#!/usr/bin/perl
package Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing global security options
sub acl_security_form
{
	my $self = shift;

local $o = $_[0];

# Root directory for file browser
print "<tr> <td><b>$self->{'text_hash'}->{'acl_root'}</b></td>\n";
printf "<td><input type=radio name=root_def value=1 %s> %s\n",
	$o->{'root'} ? '' : 'checked', $self->{'text_hash'}->{'acl_home'};
printf "<input type=radio name=root_def value=0 %s>\n",
	$o->{'root'} ? 'checked' : '';
print "<input name=root size=40 value='$o->{'root'}'> ",
      $self->file_chooser_button("root", 1),"</td> </tr>\n";

print $self->ui_table_row($self->{'text_hash'}->{'acl_otherdirs'},
	$self->ui_textarea("otherdirs", join("\n", split(/\t+/, $o->{'otherdirs'})),
		     5, 40), 3);

# Can see dot files?
print "<tr> <td><b>$self->{'text_hash'}->{'acl_nodot'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("nodot", int($o->{'nodot'})),"</td> </tr>\n";

# Browse as Unix user
print "<tr> <td><b>$self->{'text_hash'}->{'acl_fileunix'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("fileunix", $o->{'fileunix'}, 13,
			     $self->{'text_hash'}->{'acl_sameunix'})." ".
	     $self->user_chooser_button("fileunix"),"</td> </tr>\n";

print "<tr> <td colspan=2><hr></td> </tr>\n";

# Users visible in chooser
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_uedit'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=uedit_mode value=0 %s> $self->{'text_hash'}->{'acl_uedit_all'}\n",
	$o->{'uedit_mode'} == 0 ? "checked" : "";
printf "<input type=radio name=uedit_mode value=1 %s> $self->{'text_hash'}->{'acl_uedit_none'}<br>\n",
	$o->{'uedit_mode'} == 1 ? "checked" : "";
printf "<input type=radio name=uedit_mode value=2 %s> $self->{'text_hash'}->{'acl_uedit_only'}\n",
	$o->{'uedit_mode'} == 2 ? "checked" : "";
printf "<input name=uedit_can size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 2 ? $o->{'uedit'} : "",
	$self->user_chooser_button("uedit_can", 1);
printf "<input type=radio name=uedit_mode value=3 %s> $self->{'text_hash'}->{'acl_uedit_except'}\n",
	$o->{'uedit_mode'} == 3 ? "checked" : "";
printf "<input name=uedit_cannot size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 3 ? $o->{'uedit'} : "",
	$self->user_chooser_button("uedit_cannot", 1);
printf "<input type=radio name=uedit_mode value=4 %s> $self->{'text_hash'}->{'acl_uedit_uid'}\n",
	$o->{'uedit_mode'} == 4 ? "checked" : "";
printf "<input name=uedit_uid size=6 value='%s'> - \n",
	$o->{'uedit_mode'} == 4 ? $o->{'uedit'} : "";
printf "<input name=uedit_uid2 size=6 value='%s'><br>\n",
	$o->{'uedit_mode'} == 4 ? $o->{'uedit2'} : "";
printf "<input type=radio name=uedit_mode value=5 %s> $self->{'text_hash'}->{'acl_uedit_group'}\n",
	$o->{'uedit_mode'} == 5 ? "checked" : "";
printf "<input name=uedit_group size=8 value='%s'> %s</td> </tr>\n",
	$o->{'uedit_mode'} == 5 ? $self->{'dummy'}=getgrgid($o->{'uedit'}) : "",
	$self->group_chooser_button("uedit_group", 0);

# Groups visible in chooser
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_gedit'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=gedit_mode value=0 %s> $self->{'text_hash'}->{'acl_gedit_all'}\n",
	$o->{'gedit_mode'} == 0 ? "checked" : "";
printf "<input type=radio name=gedit_mode value=1 %s> $self->{'text_hash'}->{'acl_gedit_none'}<br>\n",
	$o->{'gedit_mode'} == 1 ? "checked" : "";
printf "<input type=radio name=gedit_mode value=2 %s> $self->{'text_hash'}->{'acl_gedit_only'}\n",
	$o->{'gedit_mode'} == 2 ? "checked" : "";
printf "<input name=gedit_can size=40 value='%s'> %s<br>\n",
	$o->{'gedit_mode'} == 2 ? $o->{'gedit'} : "",
	$self->group_chooser_button("gedit_can", 1);
printf "<input type=radio name=gedit_mode value=3 %s> $self->{'text_hash'}->{'acl_gedit_except'}\n",
	$o->{'gedit_mode'} == 3 ? "checked" : "";
printf "<input name=gedit_cannot size=40 value='%s'> %s<br>\n",
	$o->{'gedit_mode'} == 3 ? $o->{'gedit'} : "",
	$self->group_chooser_button("gedit_cannot", 1);
printf "<input type=radio name=gedit_mode value=4 %s> $self->{'text_hash'}->{'acl_gedit_gid'}\n",
	$o->{'gedit_mode'} == 4 ? "checked" : "";
printf "<input name=gedit_gid size=6 value='%s'> -\n",
	$o->{'gedit_mode'} == 4 ? $o->{'gedit'} : "";
printf "<input name=gedit_gid2 size=6 value='%s'></td> </tr>\n",
	$o->{'gedit_mode'} == 4 ? $o->{'gedit2'} : "";

print "<tr> <td colspan=2><hr></td> </tr>\n";

# Can submit feedback?
print "<tr> <td><b>$self->{'text_hash'}->{'acl_feedback'}</b></td> <td>\n";
printf "<input type=radio name=feedback value=2 %s> %s\n",
	$o->{'feedback'} == 2 ? "checked" : "", $self->{'text_hash'}->{'acl_feedback2'};
printf "<input type=radio name=feedback value=3 %s> %s\n",
	$o->{'feedback'} == 3 ? "checked" : "", $self->{'text_hash'}->{'acl_feedback3'};
printf "<input type=radio name=feedback value=1 %s> %s\n",
	$o->{'feedback'} == 1 ? "checked" : "", $self->{'text_hash'}->{'acl_feedback1'};
printf "<input type=radio name=feedback value=0 %s> %s</td> </tr>\n",
	$o->{'feedback'} == 0 ? "checked" : "", $self->{'text_hash'}->{'acl_feedback0'};

# Can accept RPC calls?
print "<tr> <td colspan=2><hr></td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'acl_rpc'}</b></td> <td>\n";
printf "<input type=radio name=rpc value=1 %s> %s\n",
	$o->{'rpc'} == 1 ? "checked" : "", $self->{'text_hash'}->{'acl_rpc1'};
if ($o->{'rpc'} == 2) {
	printf "<input type=radio name=rpc value=2 %s> %s\n",
		$o->{'rpc'} == 2 ? "checked" : "", $self->{'text_hash'}->{'acl_rpc2'};
	}
printf "<input type=radio name=rpc value=0 %s> %s</td> </tr>\n",
	$o->{'rpc'} == 0 ? "checked" : "", $self->{'text_hash'}->{'acl_rpc0'};

# Readonly mode
print "<tr> <td><b>$self->{'text_hash'}->{'acl_readonly'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("readonly", $o->{'readonly'}),"</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for global security options
sub acl_security_save
{
	my $self = shift;

$_[0]->{'root'} = $self->{'in_hash'}->{'root_def'} ? undef : $self->{'in_hash'}->{'root'};
$_[0]->{'otherdirs'} = join("\t", split(/\r?\n/, $self->{'in_hash'}->{'otherdirs'}));
$_[0]->{'nodot'} = $self->{'in_hash'}->{'nodot'};

$_[0]->{'uedit_mode'} = $self->{'in_hash'}->{'uedit_mode'};
$_[0]->{'uedit'} = $self->{'in_hash'}->{'uedit_mode'} == 2 ? $self->{'in_hash'}->{'uedit_can'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 3 ? $self->{'in_hash'}->{'uedit_cannot'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 4 ? $self->{'in_hash'}->{'uedit_uid'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 5 ? getgrnam($self->{'in_hash'}->{'uedit_group'}) : "";
$_[0]->{'uedit2'} = $self->{'in_hash'}->{'uedit_mode'} == 4 ? $self->{'in_hash'}->{'uedit_uid2'} : undef;

$_[0]->{'gedit_mode'} = $self->{'in_hash'}->{'gedit_mode'};
$_[0]->{'gedit'} = $self->{'in_hash'}->{'gedit_mode'} == 2 ? $self->{'in_hash'}->{'gedit_can'} :
		   $self->{'in_hash'}->{'gedit_mode'} == 3 ? $self->{'in_hash'}->{'gedit_cannot'} :
		   $self->{'in_hash'}->{'gedit_mode'} == 4 ? $self->{'in_hash'}->{'gedit_gid'} : "";
$_[0]->{'gedit2'} = $self->{'in_hash'}->{'gedit_mode'} == 4 ? $self->{'in_hash'}->{'gedit_gid2'} : undef;
$_[0]->{'feedback'} = $self->{'in_hash'}->{'feedback'};
$_[0]->{'rpc'} = $self->{'in_hash'}->{'rpc'};
$_[0]->{'readonly'} = $self->{'in_hash'}->{'readonly'};
$_[0]->{'fileunix'} = $self->{'in_hash'}->{'fileunix_def'} ? undef : $self->{'in_hash'}->{'fileunix'};
}


1;

