#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_group.cgi
# Delete a group (and maybe it's members)

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'gdelete_err'});
$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'gdelete_ecannot'});
@{$self->{'glist_array'}} = $self->list_groups();
($self->{'group'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'group'} } @{$self->{'glist_array'}};
@{$self->{'mems_array'}} = @{$self->{'group'}->{'members'}};
foreach $m (@{$self->{'mems_array'}}) {
	$self->error($self->{'text_hash'}->{'gdelete_esub'}) if ($m =~ /^\@/);
	}

if ($self->indexof($self->{'base_remote_user'}, @{$self->{'mems_array'}}) >= 0) {
	$self->error($self->{'text_hash'}->{'gdelete_euser'});
	}
elsif (@{$self->{'mems_array'}} && !$self->{'in_hash'}->{'confirm'}) {
	# Ask if the user really wants to delete the group and members
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gdelete_title'}, "");
	print "<center><form action=delete_group.cgi>\n";
	print "<input type=hidden name=group value='$self->{'in_hash'}->{'group'}'>\n";
	print $self->text('gdelete_desc', "<tt>$self->{'in_hash'}->{'group'}</tt>",
		    "<tt>".join(" ", @{$self->{'mems_array'}})."</tt>"),"<p>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'gdelete_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Delete the group (and members if any)
	$self->delete_group($self->{'in_hash'}->{'group'});
	foreach $u (@{$self->{'mems_array'}}) {
		if ($u =~ /^\@(.*)/) {
			$self->delete_group("$1");
			}
		else {
			$self->delete_user($u);
			}
		}
	$self->delete_from_groups("\@".$self->{'in_hash'}->{'group'});
	$self->reload_miniserv();
	$self->webmin_log("delete", "group", $self->{'in_hash'}->{'group'});
	$self->redirect("");
	}

1;
		
}


1;

