#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Edit a new or existing cpplus user

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->foreign_require("cpplus", "cpplus-lib.pl");

$self->ReadParse();
# Creating a new user
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'edit_ecreate'});

if(!$self->{'in_hash'}->{'old'}){
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_create_admin'}, "");
	foreach $u ($self->list_users()) {
		if ($u->{'name'} eq $self->{'in_hash'}->{'clone'}) {
			$user{'modules'} = $u->{'modules'};
			$user{'lang'} = $u->{'lang'};
			}
		if ($u->{'name'} eq $self->{'base_remote_user'}) {
			$self->{'me'} = $u;
			}
		}
}else{

    if($self->{'in_hash'}->{'old'} ne "admin" &&  $self->{'in_hash'}->{'old'}ne "root"){

	@{$self->{'ulist_array'}} = $self->list_users();
	local %user;
	foreach $u (@{$self->{'ulist_array'}}) {
    	    %user = %{$u} if ($u->{'name'} eq $self->{'in_hash'}->{'old'});#olduser
	}

# Give up if readonly
if ($user{'readonly'} && !$self->{'in_hash'}->{'readwrite'}) {
	%{$self->{'minfo_hash'}} = $self->get_module_info($user{'readonly'});
	print $self->text('edit_readonly', $self->{'minfo_hash'}->{'desc'},
		    "edit_user.cgi?user=$self->{'in_hash'}->{'user'}&readwrite=1"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# Check for temporary password lock&modify_user($user{'name'}, \%user);
	if (!$self->{'in_hash'}->{'lock'} && $user{'pass'} =~ /^\!(.*)$/) {
    	    $user{'pass'} = $1;
    	}
	elsif ($self->{'in_hash'}->{'lock'} && $user{'pass'} !~ /^\!/) {
        $user{'pass'} = "!".$user{'pass'};
        }

$self->modify_user($user{'name'}, \%user); #save user params

$self->reload_miniserv();

$self->redirect($self->{'text_hash'}->{'index_mainpage_url'});
    }else{ $self->error($self->{'text_hash'}->{'edit_euser'});}
}

print "<form action=save_user.cgi method=post>\n";
print "<input type=hidden name='max' value='99999'>";
print "<input type=hidden name='min' value='0'>";
print "<input type=hidden name='warn' value='14'>";
print "<div>".$self->{'text_hash'}->{'admin_add_desc'}."</div>";
print "<table border width=50%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'admin_detal'}</b></td> </tr>\n";

print "<tr><td $self->{'cb'}>
<table width=100%>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'admin_name'}</b></td>\n";
print "<td><input name=name size=25 value=\"$user{'name'}\"></td>\n";
	print "<td>$user{'name'}</td>\n";

print "</tr>\n";

# Show password type menu and current password
print "<tr> <td><b>$self->{'text_hash'}->{'edit_pass'}</b></td> <td colspan=3>\n";
print "<input type=hidden name=pass_def value=0 >\n";
print "<input type=password name=pass size=25>\n";
print "</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'confirm_pass'}</b></td> <td colspan=3>\n";
print "<input type=password name=re_pass size=25>\n";
print "</td> </tr>\n";

if ($self->{'access_hash'}->{'chcert'}) {
	# SSL certificate name
	printf "<input type=hidden name=cert_def value='".$user{'cert'}."'>";
	}

if ($self->{'access_hash'}->{'lang'}) {
	# Current language
	print "<input type=hidden name=lang_def value='".$user{'lang'}."'>";
	}

if ($self->{'access_hash'}->{'times'}) {  
    print "<input type=hidden name='hours_def' value='1' >
       <input type=hidden name='days_def' value='1' >";
}
if ($self->{'access_hash'}->{'logouttime'}) {
	# Show logout time
	print "<input type=hidden name=logouttime_def value=1>\n";
	}

if ($self->{'access_hash'}->{'ips'}) {
	# Allowed IP addresses
	print "<input name=ipmode type=hidden value=0> \n";
	print "<input name=ips type=hidden value=''> \n";
	}

	# Creating or editing a normal user
	@{$self->{'mcan_array'}} = $self->{'access_hash'}->{'mode'} == 1 ? @{$self->{'me'}->{'modules'}} :
		$self->{'access_hash'}->{'mode'} == 2 ? split(/\s+/, $self->{'access_hash'}->{'mods'}) :
				       $self->list_modules();
	map { $self->{'mcan_hash'}->{$_}++ } @{$self->{'mcan_array'}};
	map { $self->{'has_hash'}->{$_}++ } @{$user{'modules'}};
	map { $self->{'has_hash'}->{$_} = 0 } $self->{'group'} ? @{$self->{'group'}->{'modules'}} : ();

	# Show all modules, under categories
     @{$self->{'mlist_array'}} = grep { $self->{'access_hash'}->{'others'} || $self->{'has_hash'}->{$_->{'dir'}} || $self->{'mcan_hash'}->{$_->{'dir'}} } $self->list_module_infos();
	@{$self->{'cats_array'}} = $self->unique(map { $_->{'category'} } @{$self->{'mlist_array'}});
	$self->read_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}});

	foreach $c (sort { $b cmp $a } @{$self->{'cats_array'}}) {
		@{$self->{'cmlist_array'}} = grep { $_->{'category'} eq $c } @{$self->{'mlist_array'}};
		$self->{'sw'} = 0;
		foreach $m (@{$self->{'cmlist_array'}}) {
			local $md = $m->{'dir'};
			if ($self->{'mcan_hash'}->{$md}) {
				printf"<input type=hidden name=mod value=$md %s>\n",$self->{'has_hash'}->{$md} ? "checked" : "";
				}
			}
		}

	print "</table>\n";
	print "</td> </tr>\n";

print " </td> </tr>";
print "<tr><td ><input type=submit value=\"$self->{'text_hash'}->{'index_create_admin'}\"></td></tr>
	</form>
	</table>
	";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

