#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show RBAC status

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->{'access_hash'}->{'rbacenable'} || $self->error($self->{'text_hash'}->{'rbac_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'rbac_title'}, "");

print "$self->{'text_hash'}->{'rbac_desc'}<p>\n";
if ($self->{'gconfig_hash'}->{'os_type'} ne 'solaris') {
	print $self->text('rbac_esolaris', $self->{'gconfig_hash'}->{'real_os_type'}),"<p>\n";
	}
elsif (!$self->supports_rbac()) {
	if ($self->foreign_available("cpan")) {
		print $self->text('rbac_eperl', "<tt>Authen::SolarisRBAC</tt>",
			    "../cpan/download.cgi?source=0&local=$self->{'module_root_directory'}/Authen-SolarisRBAC-0.1.tar.gz&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"<p>\n";
		}
	else {
		print $self->text('rbac_ecpan', "<tt>Authen::SolarisRBAC</tt>"),
		      "<p>\n";
		}
	}
else {
	print "$self->{'text_hash'}->{'rbac_ok'}<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

