#!/usr/bin/perl

&MAIN();

 sub MAIN {
# hide_form.cgi
# Build up a list of modules that should be hidden due to their managed
# servers not being installed

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'user'}) {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_euser'});
	$self->{'what'} = $self->{'in_hash'}->{'user'};
	@{$self->{'whos_array'}} = $self->list_users();
	}
else {
	$self->{'access_hash'}->{'groups'} || $self->error($self->{'text_hash'}->{'gedit_ecannot'});
	$self->{'what'} = $self->{'in_hash'}->{'group'};
	@{$self->{'whos_array'}} = $self->list_groups();
	}
($self->{'who'}) = grep { $_->{'name'} eq $self->{'what'} } @{$self->{'whos_array'}};
$self->ui_print_header(undef, $self->{'text_hash'}->{'hide_title'}, "");

# Find modules to hide which the user has and which theoretically support
# this OS
%{$self->{'got_hash'}} = map { $_, 1 } @{$self->{'who'}->{'modules'}};
foreach $m (sort { $a->{'desc'} cmp $b->{'desc'} }
	    $self->get_all_module_infos()) {
	if ($self->check_os_support($m) && $self->{'got_hash'}->{$m->{'dir'}} &&
	    !$self->foreign_installed($m->{'dir'}, 0)) {
		push(@{$self->{'hide_array'}}, $m);
		}
	}

if (@{$self->{'hide_array'}}) {
	print "<form action=hide.cgi>\n";
	print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
	print "<input type=hidden name=group value='$self->{'in_hash'}->{'group'}'>\n";
	print $self->text('hide_desc', "<tt>$self->{'what'}</tt>"),"<br>\n";
	print "<ul>\n";
	foreach $h (@{$self->{'hide_array'}}) {
		print "<li>$h->{'desc'}\n";
		if ($h->{'clone'}) {
			print $self->text('hide_clone', "<tt>$h->{'dir'}</tt>"),"\n";
			}
		print "<input type=hidden name=hide value='$h->{'dir'}'>\n";
		}
	print "</ul><p>\n";
	print "$self->{'text_hash'}->{'hide_desc2'}<p>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'hide_ok'}'></form>\n";
	}
else {
	print $self->text('hide_none', "<tt>$self->{'what'}</tt>"),"<p>\n";
	}

$self->ui_print_footer(
	$self->{'in_hash'}->{'user'} ? ( "edit_user.cgi?user=$self->{'who'}", $self->{'text_hash'}->{'edit_return'} )
		    : ( "edit_group.cgi?group=$self->{'who'}", $self->{'text_hash'}->{'edit_return2'} ),
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

