#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_sessions.cgi
# Display current login sessions

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->{'access_hash'}->{'sessions'} || $self->error($self->{'text_hash'}->{'sessions_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sessions_title'}, "");

$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->open_session_db(\%{$self->{'miniserv_hash'}});
$self->{'time_now'} = time();

foreach $u ($self->list_users()) {
	$self->{'hasuser_hash'}->{$u->{'name'}}++;
	}

$self->{'haslog'} = $self->foreign_available("cppluslog");

print "<b>$self->{'text_hash'}->{'sessions_desc'}</b><p>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'sessions_id'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'sessions_user'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'sessions_host'}</b></td> ",
      $self->{'haslog'} ? "<td><b>$self->{'text_hash'}->{'sessions_login'}</b></td> " : "",
      "<td><br></td> </tr>\n";
foreach $k (sort { @a=split(/\s+/, $self->{'sessiondb_hash'}->{$a}); @b=split(/\s+/, $self->{'sessiondb_hash'}->{$b}); $b[1] <=> $a[1] } keys %{$self->{'sessiondb_hash'}}) {
	next if ($k =~ /^1111111/);
	local ($user, $ltime, $lip) = split(/\s+/, $self->{'sessiondb_hash'}->{$k});
	next if ($self->{'miniserv_hash'}->{'logouttime'} &&
		 $self->{'time_now'} - $ltime > $self->{'miniserv_hash'}->{'logouttime'}*60);
	print "<tr $self->{'cb'}>\n";
	print "<td><a href='delete_session.cgi?id=$k'>$k</a></td>\n";
	if ($self->{'hasuser_hash'}->{$user}) {
		print "<td><a href='edit_user.cgi?user=$user'>$user</a></td>\n";
		}
	elsif ($self->{'miniserv_hash'}->{'unixauth'}) {
		print "<td>$user (<a href='edit_user.cgi?user=$self->{'miniserv_hash'}->{'unixauth'}'>$self->{'miniserv_hash'}->{'unixauth'}</a>)</td>\n";
		}
	else {
		print "<td>$user</td>\n";
		}
	print "<td>",($lip || "<br>"),"</td>\n";
	local $tm = localtime($ltime);
	print "<td><tt>$tm</tt></td>\n";
	if ($self->{'haslog'}) {
		print "<td><a href='../cppluslog/search.cgi?",
		      "uall=1&mall=1&tall=1&wall=1&fall=1&sid=$k'>$self->{'text_hash'}->{'sessions_lview'}</a></td>\n";
		}
	print "</tr>\n";
	}
print "</table><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

