#!/usr/bin/perl

&MAIN();

 sub MAIN {
#quarantine listdir and edit ir drop files
# main part
&ModuleLoader::preload_module('amavis_class', "amavis::AmavisLib");
$self = new amavis::AmavisLib:: 'amavis_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();
use Time::Local;

if($self->{'in_hash'}->{'type'} eq "view"){
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_quatantinelist'}, undef, undef,);
}else{
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_quatantinelist'}, undef, undef, $self->{'module_info_hash'}->{'usermin'} ? 0 : 1, 1,);
}

# check quarantine directory
if($self->get_quarantine()){#
 $self->{'quarant_dir'}=$self->get_quarantine();
  $self->ui_print_endpage($self->text('index_eq','options.cgi?section=quarantine')) unless (-r $self->{'quarant_dir'});
}else{
   $self->ui_print_endpage($self->text('index_eq','options.cgi?section=quarantine'));
}

# view or delete quarantine files
if($self->{'in_hash'}->{'type'} eq "view"){
    print $self->ui_print_header($self->{'in_hash'}->{'file'});
    print "<pre>";
    print $self->read_file_contents($self->{'quarant_dir'}."/".$self->{'in_hash'}->{'file'});
    print "<pre>"; 
    exit;
}elsif($self->{'in_hash'}->{'f'}){
    @delete = split(/\0/, $self->{'in_hash'}->{'f'});
    foreach my $drop (@delete){
    ($self->{'rv'}, $self->{'err'})=$self->unlink_file($self->{'quarant_dir'}."/".$drop);
    if($self->{'rv'}==0){ $self->error($self->{'err'});}
    }
}

&show_quarantine($self->{'quarant_dir'});
$self->ui_print_footer("",$self->{'text_hash'}->{'index'}); 

1;
		
}

##############subs section#################
sub show_quarantine(){
#&show_quarantine(dir)
#show table files in quarantine

opendir(DIR, $_[0]) || die "can't opendir $_[0]: $!";
 @{$self->{'files_array'}}=sort{$a<=>$b} readdir(DIR);

if($#{$self->{'files_array'}}==1){
    print $self->ui_print_header($self->{'text_hash'}->{'no_quarantine_files'});
}else{

print $self->{'text_hash'}->{'qtheading'}." ".$self->{'quarant_dir'};
print $self->ui_form_start('quarantin.cgi', "post");
print $self->select_all_link("f", 0, $self->{'text_hash'}->{'sel_all'}),"&nbsp;\n";
print $self->select_invert_link("f", 0, $self->{'text_hash'}->{'sel_invert'}),"&nbsp;\n";
print "<table width='100%'>";
print "<tr><td $self->{'tb'}><b>File</b></td><td $self->{'tb'}><b>Size<b></td><td $self->{'tb'}><b>Date</b></td></tr>\n";
    foreach $_(@{$self->{'files_array'}}){#readdir(DIR)
	if(!/^\./ && -f "$_[0]/$_" ){  
	 @{$self->{'stat_array'}}=stat("$_[0]/$_");
	my $size=$self->{'stat_array'}->[7]/1024;
	 
	print "<tr>
        <td $self->{'cb'}>". $self->ui_checkbox('f',$_, "<a href=\"#\" 
	 onClick=\"window.open('/amavis/quarantin.cgi?type=view&file=$_' , '','Toolbar=0,Location=0,Directories=0,Status=0, Menubar=0,Scrollbars=1,Resizable=yes,Copyhistory=1,Left=100,Top=100,Width=700,Height=600')\"
	 title='view $_' class='menu'>$_</a>")
	."</td>
	<td $self->{'cb'}>".sprintf("%.1f", $size)." Kb</td>
	<td $self->{'cb'}>";
	($self->{'sec'},$self->{'min'},$self->{'hours'},$self->{'day'},$self->{'mon'},$self->{'year'})=localtime($self->{'stat_array'}->[9]);
	printf ("%02d:%02d %02d/%02d/%04d",$self->{'min'},$self->{'hours'},$self->{'day'},$self->{'mon'},$self->{'year'}+1900);
	print "</td></tr>\n";
	}
    }

closedir DIR;

print $self->ui_table_end();
print $self->select_all_link("f", 0, $self->{'text_hash'}->{'sel_all'}),"&nbsp;\n";
print $self->select_invert_link("f", 0, $self->{'text_hash'}->{'sel_invert'}),"&nbsp;\n <br/>\n";
print $self->ui_submit('Delete Selected');
print $self->ui_form_end();
}

}#end


1;

