#!/usr/bin/perl
package apache::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the apache module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top rowspan=4><b>$self->{'text_hash'}->{'acl_virts'}</b></td>\n";
print "<td rowspan=4 valign=top>\n";
printf "<input type=radio name=virts_def value=1 %s> %s\n",
	$_[0]->{'virts'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_vall'};
printf "<input type=radio name=virts_def value=0 %s> %s<br>\n",
	$_[0]->{'virts'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_vsel'};
print "<select name=virts multiple size=5>\n";
local $conf = $self->get_config();
local @virts = ( { 'value' => '__default__' },
		 $self->find_directive_struct("VirtualHost", $conf) );
local %vcan = map { $_, 1 } split(/\s+/, $_[0]->{'virts'});
local $v;
foreach $v (@virts) {
	local @vn = $self->virt_acl_name($v);
	local ($can) = grep { $vcan{$_} } @vn;
	local $vn = $can || $vn[0];
	printf "<option value=\"%s\" %s>%s\n",
		$vn, $can ? "selected" : "",
		$vn eq "__default__" ? $self->{'text_hash'}->{'acl_defserv'} : $vn;
	delete($vcan{$can}) if ($can);
	}
foreach $vn (keys %vcan) {
	next if ($vn eq "*");
	printf "<option value=\"%s\" %s>%s\n",
		$vn, "selected",
		$vn eq "__default__" ? $self->{'text_hash'}->{'acl_defserv'} : $vn;
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_global'}</b></td> <td><select name=global>\n";
printf "<option value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'global'} == 1 ? "selected" : "";
printf "<option value=2 %s> $self->{'text_hash'}->{'acl_htaccess'}\n",
	$_[0]->{'global'} == 2 ? "selected" : "";
printf "<option value=0 %s> $self->{'text_hash'}->{'no'}</select></td> </tr>\n",
	$_[0]->{'global'} == 0 ? "selected" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td> <td>\n";
printf "<input type=radio name=create value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'create'} ? "checked" : "";
printf "<input type=radio name=create value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'create'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_vuser'}</b></td> <td>\n";
printf "<input type=radio name=vuser value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'vuser'} ? "checked" : "";
printf "<input type=radio name=vuser value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'vuser'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_vaddr'}</b></td> <td>\n";
printf "<input type=radio name=vaddr value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'vaddr'} ? "checked" : "";
printf "<input type=radio name=vaddr value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'vaddr'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_pipe'}</b></td> <td>\n";
printf "<input type=radio name=pipe value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'pipe'} ? "checked" : "";
printf "<input type=radio name=pipe value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'pipe'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_stop'}</b></td> <td>\n";
printf "<input type=radio name=stop value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'stop'} ? "checked" : "";
printf "<input type=radio name=stop value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'stop'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_apply'}</b></td> <td>\n";
printf "<input type=radio name=apply value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'apply'} ? "checked" : "";
printf "<input type=radio name=apply value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'apply'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_names'}</b></td> <td>\n";
printf "<input type=radio name=names value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'names'} ? "checked" : "";
printf "<input type=radio name=names value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'names'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_dir'}</b></td>\n";
printf "<td colspan=3><input name=dir size=30 value='%s'> %s</td> </tr>\n",
	$_[0]->{'dir'}, $self->file_chooser_button("dir", 1);

print "<tr> <td><b>$self->{'text_hash'}->{'acl_aliasdir'}</b></td>\n";
printf "<td colspan=3><input name=aliasdir size=30 value='%s'> %s</td> </tr>\n",
	$_[0]->{'aliasdir'}, $self->file_chooser_button("aliasdir", 1);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_types'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=types_def value=1 %s> $self->{'text_hash'}->{'acl_all'}&nbsp;\n",
	$_[0]->{'types'} eq '*' ? "checked" : "";
printf "<input type=radio name=types_def value=0 %s> $self->{'text_hash'}->{'acl_sel'}<br>\n",
	$_[0]->{'types'} eq '*' ? "" : "checked";
map { $self->{'types_hash'}->{$_}++ } split(/\s+/, $_[0]->{'types'});
print "<select name=types size=5 multiple>\n";
for($i=0; $self->{'text_hash'}->{"type_$i"}; $i++) {
	printf "<option value=\"%d\" %s>%s\n",
		$i, $self->{'types_hash'}->{$i} ? "selected" : "", $self->{'text_hash'}->{"type_$i"};
	}
print "</select></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dirs'}</b></td>\n";
print "<td colspan=3>\n";
print $self->ui_radio("dirsmode", $_[0]->{'dirsmode'},
		[ [ 0, $self->{'text_hash'}->{'acl_dirs0'} ],
		  [ 1, $self->{'text_hash'}->{'acl_dirs1'} ],
		  [ 2, $self->{'text_hash'}->{'acl_dirs2'} ] ]),"<br>\n";
print $self->ui_textarea("dirs", join("\n", split(/\s+/, $_[0]->{'dirs'})), 5, 50);
print "</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the apache module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'virts_def'}) {
	$_[0]->{'virts'} = "*";
	}
else {
	$_[0]->{'virts'} = join(" ", split(/\0/, $self->{'in_hash'}->{'virts'}));
	}
$_[0]->{'global'} = $self->{'in_hash'}->{'global'};
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'vuser'} = $self->{'in_hash'}->{'vuser'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'apply'} = $self->{'in_hash'}->{'apply'};
$_[0]->{'vaddr'} = $self->{'in_hash'}->{'vaddr'};
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir'};
$_[0]->{'aliasdir'} = $self->{'in_hash'}->{'aliasdir'};
$_[0]->{'types'} = $self->{'in_hash'}->{'types_def'} ? '*'
				    : join(" ", split(/\0/, $self->{'in_hash'}->{'types'}));
$_[0]->{'pipe'} = $self->{'in_hash'}->{'pipe'};
$_[0]->{'names'} = $self->{'in_hash'}->{'names'};
$_[0]->{'dirsmode'} = $self->{'in_hash'}->{'dirsmode'};
$_[0]->{'dirs'} = join(" ", split(/\s+/, $self->{'in_hash'}->{'dirs'}));
}


1;

