#!/usr/bin/perl
package apache::Mod_cern_meta;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_cern_meta');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_cern_meta.pl
# Defines editors CERN metafile directives

1;

1;
		return $self;
}

sub mod_cern_meta_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'MetaFiles', 0, 5, 'directory', 1.3 ],
        [ 'MetaDir', 0, 5, 'server', -1.3 ],
        [ 'MetaDir', 0, 5, 'directory', 1.3 ],
        [ 'MetaSuffix', 0, 5, 'server', -1.3 ],
        [ 'MetaSuffix', 0, 5, 'directory', 1.3 ] ];
return $self->make_directives($rv, $_[0], "mod_cern_meta");
}

sub edit_MetaFiles
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cern_meta_process'}",
        $self->choice_input($_[0]->{'value'}, "MetaFiles", "off",
        "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_MetaFiles
{
	my $self = shift;

return $self->parse_choice("MetaFiles", "off");
}

sub edit_MetaDir
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cern_meta_dir'}",
        $self->opt_input($_[0]->{'value'}, "MetaDir", "$self->{'text_hash'}->{'mod_cern_meta_default'}", 8));
}

sub save_MetaDir
{
	my $self = shift;

return $self->parse_opt("MetaDir", '^\S+$', "$self->{'text_hash'}->{'mod_cern_meta_edir'}");
}

sub edit_MetaSuffix
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_cern_meta_suffix'}",
        $self->opt_input($_[0]->{'value'}, "MetaSuffix", "$self->{'text_hash'}->{'mod_cern_meta_default2'}", 15));
}

sub save_MetaSuffix
{
	my $self = shift;

return $self->parse_opt("MetaSuffix", '^\S+$', "$self->{'text_hash'}->{'mod_cern_meta_esuffix'}");
}


1;

