#!/usr/bin/perl
package apache::Mod_include;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_include');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_include.pl
# Defines editors SSI directives

1;

1;
		return $self;
}

sub mod_include_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'XBitHack', 0, 11, 'virtual directory htaccess' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_include");
}

sub mod_include_handlers
{
	my $self = shift;

return ("server-parsed");
}

sub mod_include_filters
{
	my $self = shift;

return ("INCLUDES");
}

sub edit_XBitHack
{
	my $self = shift;

return (2, "$self->{'text_hash'}->{'mod_include_incl'}",
        $self->choice_input($_[0]->{'value'}, "XBitHack", "",
        "$self->{'text_hash'}->{'no'},off", "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'mod_include_set'},full", "$self->{'text_hash'}->{'mod_include_default'},"));
}

sub save_XBitHack
{
	my $self = shift;

return $self->parse_choice("XBitHack", "");
}


1;

