#!/usr/bin/perl
package apache::Mod_log_agent;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_log_agent');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_log_agent.pl
# Defines editors for logging user agents

1;

1;
		return $self;
}

sub mod_log_agent_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'AgentLog', 0, 3, 'virtual' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_log_agent");
}

sub edit_AgentLog
{
	my $self = shift;

local($rv);
$rv = sprintf "<input type=radio name=AgentLog_mode value=0 %s> $self->{'text_hash'}->{'mod_log_agent_default'}\n",
       $_[0] ? "" : "checked";
$rv .= sprintf "<input type=radio name=AgentLog_mode value=1 %s> $self->{'text_hash'}->{'mod_log_agent_file'}",
	 $_[0] && $_[0]->{'value'} !~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input type=radio name=AgentLog_mode value=2 %s> $self->{'text_hash'}->{'mod_log_agent_program'}",
	 $_[0]->{'value'} =~ /^\|/ ? "checked" : "";
$rv .= sprintf "<input name=AgentLog size=20 value=\"%s\">\n",
        $_[0]->{'value'} =~ /^\|(.*)$/ ? $1 : $_[0]->{'value'};
return (1, "$self->{'text_hash'}->{'mod_log_agent_log'}", $rv); 
}

sub save_AgentLog
{
	my $self = shift;

if ($self->{'in_hash'}->{'AgentLog_mode'} == 0) { return ( [ ] ); }
$self->{'in_hash'}->{'AgentLog'} =~ /^\S+$/ ||
	$self->error($self->text('mod_log_agent_efile', $self->{'in_hash'}->{'AgentLog'}));
if ($self->{'in_hash'}->{'AgentLog_mode'} == 1) { return ( [ $self->{'in_hash'}->{'AgentLog'} ] ); }
else { return ( [ "|$self->{'in_hash'}->{'AgentLog'}" ] ); }
}


1;

