#!/usr/bin/perl
package apache::Mpm_winnt;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mpm_winnt');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mpm_winnt.pl
# Defines editors for the windows NT module in apache 2.0
# The actual functions for most of these are still in core.pl

1;
		return $self;
}

sub mpm_winnt_directives
{
	my $self = shift;

local $rv;
$rv = [ [ 'CoreDumpDirectory', 0, 9, 'global', 2.0 ],
	[ 'BindAddress Listen Port', 1, 1, 'global', 2.0, 10 ],
	[ 'ListenBacklog', 0, 1, 'global', 2.0 ],
	[ 'MaxRequestsPerChild', 0, 0, 'global', 2.0 ],
	[ 'PidFile', 0, 9, 'global', 2.0 ],
	[ 'SendBufferSize', 0, 1, 'global', 2.0 ],
	[ 'ThreadsPerChild', 0, 0, 'global', 2.0 ] ];
return $self->make_directives($rv, $_[0], "mpm_winnt");
}

sub edit_ThreadsPerChild
{
	my $self = shift;

return (1,
	$self->{'text_hash'}->{'worker_threads'},
	$self->opt_input($_[0]->{'value'},"ThreadsPerChild",$self->{'text_hash'}->{'default'}, 4));
}

sub save_ThreadsPerChild
{
	my $self = shift;

return $self->parse_opt("ThreadsPerChild", '^\d+$',
		  $self->{'text_hash'}->{'worker_ethreads'});
}


1;

