#!/usr/bin/perl
package apache::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns the main error log, if it exists
sub syslog_getlogs
{
	my $self = shift;

local $conf = $self->get_config();
local $errlog = $self->find_directive("ErrorLog", $conf, 1);
local @rv;
if ($errlog) {
	push(@rv, { 'file' => $self->server_root($errlog),
		    'desc' => $self->{'text_hash'}->{'syslog_desc'},
		    'active' => 1 });
	}
return @rv;
}


1;

