#!/usr/bin/perl

&MAIN();

 sub MAIN {
# allmanual_form.cgi
# Display a text box for manually editing directives from one of the files

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'types'} eq '*' && $self->{'access_hash'}->{'virts'} eq '*' ||
	$self->error($self->{'text_hash'}->{'manual_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'manual_configs'}, "");

$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = grep { -f $_ } $self->unique(map { $_->{'file'} } @{$self->{'conf'}});
$self->{'in_hash'}->{'file'} = $self->{'files_array'}->[0] if (!$self->{'in_hash'}->{'file'});
print "<form action=allmanual_form.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'manual_file'}'>\n";
print "<select name=file>\n";
foreach $f (@{$self->{'files_array'}}) {
	printf "<option %s>%s\n",
		$f eq $self->{'in_hash'}->{'file'} ? 'selected' : '', $f;
	$self->{'found'}++ if ($f eq $self->{'in_hash'}->{'file'});
	}
print "</select></form>\n";
$self->{'found'} || $self->error($self->{'text_hash'}->{'manual_efile'});

print $self->ui_form_start("allmanual_save.cgi", "form-data");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
$self->{'data'} = $self->read_file_contents($self->{'in_hash'}->{'file'});
print $self->ui_textarea("data", $self->{'data'}, 20, 80, undef, undef,
		   "style='width:100%'"),"<br>\n";
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

