#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_dir.cgi
# Modify or delete a <Directory>, <Files> or <Location> clause

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
$self->lock_file($self->{'d'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'d'}->{'file'});

if ($self->{'in_hash'}->{'delete'}) {
	# deleting a directive
	$self->{'conf'} = $self->get_config();
	$self->{'gap'} = $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1;
	splice(@{$self->{'lref'}}, $self->{'d'}->{'line'}, $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1);
	splice(@{$self->{'vconf'}}, $self->{'in_hash'}->{'idx'}, 1);
	$self->renumber($self->{'conf'}, $self->{'d'}->{'line'}, $self->{'d'}->{'file'}, -$self->{'gap'});
	}
else {
	# changing a directive
	$self->error_setup($self->{'text_hash'}->{'cdir_err2'});
	$self->{'in_hash'}->{'path'} || $self->error($self->{'text_hash'}->{'cdir_epath'});
	$self->{'in_hash'}->{'type'} eq 'Proxy' || $self->allowed_doc_dir($self->{'in_hash'}->{'path'}) ||
		$self->error($self->{'text_hash'}->{'cdir_ecannot'});
	if ($self->{'in_hash'}->{'regexp'}) {
		$self->{'in_hash'}->{'type'} eq 'Proxy' && $self->error($self->{'text_hash'}->{'cdir_eproxy'});
		if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
			$self->{'newdir'} = "<$self->{'in_hash'}->{'type'}Match \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}Match>";
			}
		else {
			$self->{'newdir'} = "<$self->{'in_hash'}->{'type'} ~ \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}>";
			}
		}
	else {
		$self->{'newdir'} = "<$self->{'in_hash'}->{'type'} \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}>";
		}
	$self->{'lref'}->[$self->{'d'}->{'line'}] = $self->{'newdir'};
	$self->{'lref'}->[$self->{'d'}->{'eline'}] = $self->{'enddir'};
	}
$self->flush_file_lines();
$self->unlock_file($self->{'d'}->{'file'});
$self->after_changing();
$self->webmin_log("dir", $self->{'in_hash'}->{'delete'} ? 'delete' : 'save',
	    $self->virtual_name($self->{'v'}, 1).":".$self->{'d'}->{'words'}->[0], \%{$self->{'in_hash'}});
$self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");

1;
		
}


1;

