#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of virtual servers

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
$self->{'access_hash'}->{'vaddr'} || $self->error($self->{'text_hash'}->{'delete_ecannot'});
$self->{'conf'} = $self->get_config();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Get them all
foreach $d (sort { $b <=> $a } @d) {
	($self->{'vmembers'}, $vconf) = $self->get_virtual_config($d);
	$self->can_edit_virt($vconf) || $self->error($self->text('delete_ecannot2',
					       $self->virtual_name($vconf)));
	push(@{$self->{'virts_array'}}, $vconf);
	}

# Take them out of their files
$self->before_changing();
foreach $vconf (@{$self->{'virts_array'}}) {
	$self->lock_file($vconf->{'file'});
	$self->{'lref'} = $self->read_file_lines($vconf->{'file'});
	if ($vconf->{'line'} && $self->{'lref'}->[$vconf->{'line'}-1] !~ /\S/) {
		# Remove one blank line before vserv
		$vconf->{'line'}--;
		}
	splice(@{$self->{'lref'}}, $vconf->{'line'},
	       $vconf->{'eline'} - $vconf->{'line'} + 1);
	$self->{'nonblank'} = 0;
	foreach $l (@{$self->{'lref'}}) {
		$self->{'nonblank'}++ if ($l =~ /\S/);
		}
	$self->flush_file_lines();
	if (!$self->{'nonblank'}) {
		# Can lose the entire file
		unlink($vconf->{'file'});

		# Delete the link too
		$self->delete_webfile_link($vconf->{'file'});
		}
	}
$self->unlock_all_files();
$self->after_changing();
$self->webmin_log("virts", "delete", scalar(@{$self->{'virts_array'}}));
$self->redirect("");

1;
		
}


1;

