#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_virt.cgi
# Display a form for editing some kind of per-directory options file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} || $self->error($self->{'text_hash'}->{'etype'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'conf'} = $self->{'d'}->{'members'};
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'directory');
$self->{'desc'} = $self->text('htfile_header', $self->dir_name($self->{'d'}), "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "");

print $self->ui_form_start("save_files.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'});
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->text('htfile_header2', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"},
                            $self->dir_name($self->{'d'})), undef, 4);
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("htaccess_index.cgi?file=$self->{'in_hash'}->{'file'}", $self->{'text_hash'}->{'htindex_return'});

1;
		
}


1;

