#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_global.cgi
# Display a form for editing some kind of global options

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'global');
$self->{'access_hash'}->{'global'}==1 || $self->error($self->{'text_hash'}->{'global_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} ||
	$self->error($self->{'text_hash'}->{'etype'});
$self->ui_print_header(undef, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "",
	undef, undef, undef, undef, $self->restart_button());

print $self->ui_form_start("save_global.cgi", "post");
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'});
print $self->ui_table_start($self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, undef, 4);
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

if ($self->{'in_hash'}->{'type'} == 6) {
	$self->{'mfile'} = $self->find_directive("TypesConfig", $self->{'conf'});
	if (!$self->{'mfile'}) { $self->{'mfile'} = $self->{'config_hash'}->{'mime_types'}; }
	if (!$self->{'mfile'}) { $self->{'mfile'} = $self->server_root("etc/mime.types", $self->{'conf'}); }
	if (!-r $self->{'mfile'}) { $self->{'mfile'} = $self->server_root("conf/mime.types", $self->{'conf'}); }
	$self->{'mfile'} = $self->server_root($self->{'mfile'}, $self->{'conf'});
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'global_mime'});
	print "$self->{'text_hash'}->{'global_mimedesc'}<p>\n";
	@{$self->{'links_array'}} = ( "<a href=\"edit_gmime_type.cgi?file=$self->{'mfile'}\">".
	           "$self->{'text_hash'}->{'global_add'}</a>" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ $self->{'text_hash'}->{'global_type'},
				  $self->{'text_hash'}->{'global_ext'} ]);
	open(MIME, $self->{'mfile'});
	$self->{'line'} = 0;
	while(<MIME>) {
		chop;
		s/#.*$//;
		if (/^\s*(\S+)\s*(.*)$/) {
			print $self->ui_columns_row([
				"<a href=\"edit_gmime_type.cgi?line=$self->{'line'}".
				"&file=$self->{'mfile'}\">$1</a>", $2 ]);
			}
		$self->{'line'}++;
		}
	close(MIME);
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

