#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_gmime_type.cgi
# Display a form for editing a MIME type from the global list

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'}==1 || $self->error($self->{'text_hash'}->{'mime_ecannot'});
if (defined($self->{'in_hash'}->{'line'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mime_edit'}, "");
	open(MIME, $self->{'in_hash'}->{'file'});
	for($i=0; $i<=$self->{'in_hash'}->{'line'}; $i++) {
		$self->{'line'} = <MIME>;
		}
	close(MIME);
	$self->{'line'} =~ s/#.*$//;
	$self->{'line'} =~ /^\s*(\S+)\s*(.*)$/;
	$self->{'type'} = $1; @{$self->{'exts_array'}} = split(/\s+/, $2);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mime_add'}, "");
	}

print $self->ui_form_start("save_gmime_type.cgi");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'});
if ($self->{'type'}) {
	print $self->ui_hidden("line", $self->{'in_hash'}->{'line'});
	}
print $self->ui_table_start($self->{'text_hash'}->{'mime_header'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'mime_type'},
	$self->ui_textbox("type", $self->{'type'}, 40));

print $self->ui_table_row($self->{'text_hash'}->{'mime_ext'},
	$self->ui_textarea("exts", join("\n", @{$self->{'exts_array'}}), 5, 15));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("edit_global.cgi?type=6", $self->{'text_hash'}->{'global_return'});

1;
		
}


1;

