#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_virt.cgi
# Display a form for editing some kind of per-server

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} || $self->error($self->{'text_hash'}->{'etype'});
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'virtual');
$self->{'desc'} = $self->text('virt_header', $self->virtual_name($self->{'v'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "",
	undef, undef, undef, undef, $self->restart_button());

if ($self->{'in_hash'}->{'type'} == 8 && !$self->{'access_hash'}->{'vuser'}) {
	print "$self->{'text_hash'}->{'virt_euser'} <p>\n";
	$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",
			 $self->{'text_hash'}->{'virt_return'});
	exit;
	}

if (!$self->{'in_hash'}->{'virt'}) {
	@{$self->{'dirs_array'}} = grep { !$_->{'virtualonly'} } @{$self->{'dirs_array'}};
	}

print $self->ui_form_start("save_virt.cgi", "post");
print $self->ui_hidden("virt", $self->{'in_hash'}->{'virt'});
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'});
print $self->ui_table_start($self->text('virt_header2', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"},
                               $self->virtual_name($self->{'v'})), undef, 4);
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'});

1;
		
}


1;

