#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_authgroups.cgi
# Displays a list of groups and their members

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

&ModuleLoader::preload_module('apache_class', "apache::AuthLib");
$self = new apache::AuthLib:: 'apache_class',%$self;


$self->{'conf'} = $self->get_config();
$self->ReadParse();
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->text('authg_ecannot', $self->{'in_hash'}->{'file'}));
$self->{'desc'} = $self->text('authg_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authg_title'}, "");
$self->{'f'} = $self->server_root($self->{'in_hash'}->{'file'}, $self->{'conf'});

@{$self->{'groups_array'}} = sort { $a->{'name'} cmp $b->{'name'} } $self->list_authgroups($self->{'in_hash'}->{'file'});
if (@{$self->{'groups_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>",$self->text('authg_header2', "<tt>$self->{'f'}</tt>"),
	      "</b></td></tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'authg_group'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'authg_mems'}</b></td> </tr>\n";
	for($i=0; $i<@{$self->{'groups_array'}}; $i++) {
		$self->{'g'} = $self->{'groups_array'}->[$i]->{'group'};
		@{$self->{'m_array'}} = @{$self->{'groups_array'}->[$i]->{'members'}};
		if (@{$self->{'m_array'}} > 15) { @{$self->{'m_array'}} = @{$self->{'m_array'}}[0..14]; }
		printf "<tr> <td><a href=\"edit_authgroup.cgi?group=$self->{'g'}&".
		  "file=%s&url=%s\">$self->{'g'}</a></td>\n",
		  $self->urlize($self->{'f'}), $self->urlize($self->this_url());
		printf "<td>%s</td> </tr>\n",
			@{$self->{'m_array'}} ? join(" , ", @{$self->{'m_array'}}) : "<i>None</i>";
		}
	print "</table></td></tr></table>\n";
	}
else {
	print "<b>",$self->text('authg_none', "<tt>$self->{'f'}</tt>"),"</b><p>\n";
	}
printf "<a href=\"edit_authgroup.cgi?file=%s&url=%s\">%s</a><p>\n",
        $self->urlize($self->{'f'}), $self->urlize($self->this_url()), $self->{'text_hash'}->{'authg_add'};

$self->ui_print_footer($self->{'in_hash'}->{'url'}, $self->{'text_hash'}->{'auth_return'});

1;
		
}


1;

