#!/usr/bin/perl

&MAIN();

 sub MAIN {
# reconfig_form.cgi
# Displays a list of supported modules, and allows the user to pick which
# ones are installed in apache

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'}==1 || $self->error($self->{'text_hash'}->{'reconfig_ecannot'});
if ($self->{'in_hash'}->{'vol'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'reconfig_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'reconfig_title'}, "", undef, 1, 1);
	}

# Is Apache installed OK?
($self->{'ver'}, $mods) = $self->httpd_info($self->{'httpd'} = $self->find_httpd());
if (!$self->{'ver'}) {
	print $self->text('reconfig_ever', "<tt>$self->{'httpd'}</tt>",
		    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Work out which modules Apache has
%{$self->{'inst_hash'}} = map { $_, 1 } $self->configurable_modules();

# Build list of modules know to Webmin
push(@{$self->{'mods_array'}}, "core");
opendir(DIR, ".");
foreach $f (readdir(DIR)) {
	if ($f =~ /^(mod_\S+|prefork|worker|perchild|mpm_\S+)\.pl$/) { push(@{$self->{'mods_array'}}, $1); }
	}
closedir(DIR);
@{$self->{'mods_array'}} = sort { $a cmp $b } @{$self->{'mods_array'}};

if (!$self->{'in_hash'}->{'vol'}) {
	print "$self->{'text_hash'}->{'reconfig_desc1'}<p>\n";
	print "$self->{'text_hash'}->{'reconfig_desc3'}<p>\n";
	}
else {
	print "$self->{'text_hash'}->{'reconfig_desc2'}<p>\n";;
	}
print $self->ui_form_start("reconfig.cgi", "post");
print $self->ui_hidden("size", $self->{'in_hash'}->{'size'});
print $self->ui_hidden("ver", $self->{'ver'});

@{$self->{'grid_array'}} = ( );
for($i=0; $i<@{$self->{'mods_array'}}; $i++) {
	push(@{$self->{'grid_array'}}, $self->ui_checkbox("mods", $self->{'mods_array'}->[$i], $self->{'mods_array'}->[$i],
				 $self->{'inst_hash'}->{$self->{'mods_array'}->[$i]}));
	}
print $self->ui_grid_table(\@{$self->{'grid_array'}}, 4, 100);
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'reconfig_ok'} ] ]);

if ($self->{'in_hash'}->{'vol'}) { $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'}); }
else { $self->ui_print_footer("/", $self->{'text_hash'}->{'index'}); }

1;
		
}


1;

