#!/usr/bin/perl

&MAIN();

 sub MAIN {
# restart.cgi
# Send a SIGHUP to apache

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'restart_err'});

$self->{'access_hash'}->{'apply'} || $self->error($self->{'text_hash'}->{'restart_ecannot'});
$self->{'conf'} = $self->get_config();

if ($self->{'config_hash'}->{'test_config'}) {
	$self->{'err'} = $self->test_config();
	$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
	}
$self->{'err'} = $self->restart_apache();
$self->error($self->{'err'}) if ($self->{'err'});

# Check if restart was successful.. some config file error may have caused it
# to silently fail
for($i=0; $i<5; $i++) {
	if ($self->is_apache_running()) {
		$self->{'running'} = 1;
		last;
		}
	sleep(1);
	}
if (!$self->{'running'}) {
	# Not running..  find out why
	$self->{'errorlogstr'} = $self->find_directive_struct("ErrorLog", $self->{'conf'});
	$self->{'errorlog'} = $self->{'errorlogstr'} ? $self->{'errorlogstr'}->{'words'}->[0]
				 : "logs/error_log";
	if ($self->{'errorlog'} eq 'syslog' || $self->{'errorlog'} =~ /^\|/) {
		$self->error($self->{'text_hash'}->{'restart_eunknown'});
		}
	else {
		$self->{'errorlog'} = $self->server_root($self->{'errorlog'}, $self->{'conf'});
		$self->{'out'} = `tail -5 $self->{'errorlog'}`;
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
$self->webmin_log("apply");
$self->redirect($self->{'in_hash'}->{'redir'});

1;
		
}


1;

