#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_virt.cgi
# Save some kind of per-server configuration

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
($self->{'conf_ssl'}, $self->{'v_ssl'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt_ssl'}) if ($self->{'in_hash'}->{'virt_ssl'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} || $self->error($self->{'text_hash'}->{'etype'});
$self->{'in_hash'}->{'type'} == 8 && !$self->{'access_hash'}->{'vuser'} &&
	$self->error($self->{'text_hash'}->{'virt_euser'});
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'virtual');
if (!$self->{'in_hash'}->{'virt'}) {
	@{$self->{'edit_array'}} = grep { !$_->{'virtualonly'} } @{$self->{'edit_array'}};
	}

$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->get_config());
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf_ssl'}, $self->get_config()) if ($self->{'in_hash'}->{'virt_ssl'});
$self->webmin_log("virt", $self->{'in_hash'}->{'type'}, $self->virtual_name($self->{'v'}, 1), \%{$self->{'in_hash'}});
$self->webmin_log("virt", $self->{'in_hash'}->{'type'}, $self->virtual_name($self->{'v_ssl'}, 1), \%{$self->{'in_hash'}}) if ($self->{'in_hash'}->{'virt_ssl'});

$self->{'in_hash'}->{'home'} ? $self->redirect("/home/index.cgi") : $self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
1;
		
}


1;

