#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete or run an at job

&ModuleLoader::preload_module('at_class', "at::AtLib");
$self = new at::AtLib:: 'at_class',%$self;

$self->ReadParse();
$self->foreign_require("proc", "proc-lib.pl");

@{$self->{'jobs_array'}} = $self->list_atjobs();
($self->{'job'}) = grep { $_->{'id'} eq $self->{'in_hash'}->{'id'} } @{$self->{'jobs_array'}};
$self->{'job'} || $self->error($self->{'text_hash'}->{'delete_egone'});

if ($self->{'in_hash'}->{'run'}) {
	# Run the command and show output
	$self->ui_print_header(undef, $self->{'text_hash'}->{'run_title'}, "");

	# Create temp script for job
	$self->{'temp'} = $self->transname();
	$self->open_tempfile(TEMP, ">$self->{'temp'}");
	$self->print_tempfile(TEMP, $self->{'job'}->{'cmd'});
	$self->close_tempfile(TEMP);
	chmod(0755, $self->{'temp'});

	print "<p>\n";
	print $self->text('run_output'),"<p>\n";
	@{$self->{'uinfo_array'}} = getpwnam($self->{'job'}->{'user'});
	print "<pre>";
	$self->{'got'} = $main::proc_object->safe_process_exec_logged($self->{'temp'}, $self->{'uinfo_array'}->[2], $self->{'uinfo_array'}->[3],
					 STDOUT, undef, 1);
	if (!$self->{'got'}) { print "<i>$self->{'text_hash'}->{'run_none'}</i>\n"; }
	unlink($self->{'temp'});
	print "</pre>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Just delete the at job
	$self->error_setup($self->{'text_hash'}->{'delete_err'});
	%{$self->{'access_hash'}} = $self->get_module_acl();
	$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->delete_atjob($self->{'in_hash'}->{'id'});
	$self->webmin_log("delete", "job", $self->{'job'}->{'user'}, $self->{'job'});
	$self->redirect("");
	}

1;
		
}


1;

