#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one scheduled backup

&ModuleLoader::preload_module('backup_config_class', "backup_config::BackupconfigLib");
$self = new backup_config::BackupconfigLib:: 'backup_config_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'backup'} = { 'emode' => 0,
		    'sched' => 1,
		    'mins' => 0,
		    'hours' => 0,
		    'days' => '*',
		    'months' => '*',
		    'weekdays' => '*' };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'backup'} = $self->get_backup($self->{'in_hash'}->{'id'});
	}

print $self->ui_form_start("save.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'});
print $self->ui_hidden("id", $self->{'in_hash'}->{'id'});
print $self->ui_table_start($self->{'text_hash'}->{'edit_header'}, "width=100%", 2);

# Show modules to backup
@{$self->{'mods_array'}} = $self->list_backup_modules();
@{$self->{'dmods_array'}} = split(/\s+/, $self->{'backup'}->{'mods'});
print $self->ui_table_row($self->{'text_hash'}->{'edit_mods'},
		    $self->ui_select("mods", \@{$self->{'dmods_array'}},
		       [ map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'mods_array'}} ],
		       5, 1));

# Show destination
print $self->ui_table_row($self->{'text_hash'}->{'edit_dest'},
		    $self->show_backup_destination("dest", $self->{'backup'}->{'dest'}, 0));

# Show files to include
print $self->ui_table_row($self->{'text_hash'}->{'edit_what'},
		    $self->show_backup_what("what", $self->{'backup'}->{'configfile'},
					      $self->{'backup'}->{'nofiles'},
					      $self->{'backup'}->{'others'}));

# Show email address
print $self->ui_table_row($self->{'text_hash'}->{'edit_email'},
		    $self->ui_textbox("email", $self->{'backup'}->{'email'}, 40));

# Show email mode
print $self->ui_table_row($self->{'text_hash'}->{'edit_emode'},
		    $self->ui_radio("emode", $self->{'backup'}->{'emode'},
			      [ [ 0, $self->{'text_hash'}->{'edit_emode0'} ],
				[ 1, $self->{'text_hash'}->{'edit_emode1'} ] ]));

# Show schedule
if ($self->{'backup'}) {
	$self->{'job'} = $self->find_cron_job($self->{'backup'});
	}
print $self->ui_table_row($self->{'text_hash'}->{'edit_sched'},
		    $self->ui_radio("sched", $self->{'job'} || $self->{'in_hash'}->{'new'} ? 1 : 0,
			      [ [ 0, $self->{'text_hash'}->{'no'} ],
				[ 1, $self->{'text_hash'}->{'edit_schedyes'} ] ]));

print "<tr> <td colspan=2><table border width=100%>\n";
$main::cron_object->show_times_input($self->{'backup'});
print "</table></td> </tr>\n";

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ 'create', $self->{'text_hash'}->{'create'} ] ], "100%");
	}
else {
	print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ],
			     [ 'run', $self->{'text_hash'}->{'edit_run'} ],
			     [ 'delete', $self->{'text_hash'}->{'delete'} ] ], "100%");
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

