#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_forwarding.cgi
# Display global forwarding and transfer options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'forwarding_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'forwarding_title'}, "");

$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'mems'} = $self->{'options'}->{'members'};

print "<form action=save_forwarding.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'forwarding_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->forwarders_input($self->{'text_hash'}->{'forwarding_fwders'}, 'forwarders', $self->{'mems'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'forwarding_fwd'}, 'forward', $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, 'first', $self->{'text_hash'}->{'no'}, 'only',
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'forwarding_max'}, "max-transfer-time-in",
		 $self->{'mems'}, $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'forwarding_minutes'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'forwarding_format'}, 'transfer-format', $self->{'mems'},
		    $self->{'text_hash'}->{'forwarding_one'}, 'one-answer',
		    $self->{'text_hash'}->{'forwarding_many'}, 'many-answers',
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'forwarding_in'}, "transfers-in",
		 $self->{'mems'}, $self->{'text_hash'}->{'default'}, 4);
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

