#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a page for manually editing named.conf
# XXX chroot!

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'manual_ecannot'});
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'manual_title'}, "");

# Work out and show the files
$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = $self->get_all_config_files($self->{'conf'});
$self->{'in_hash'}->{'file'} ||= $self->{'files_array'}->[0];
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});
print $self->ui_form_start("conf_manual.cgi");
print "<b>$self->{'text_hash'}->{'manual_file'}</b>\n";
print $self->ui_select("file", $self->{'in_hash'}->{'file'},
		 [ map { [ $_ ] } @{$self->{'files_array'}} ]),"\n";
print $self->ui_submit($self->{'text_hash'}->{'manual_ok'});
print $self->ui_form_end();

# Show the file contents
print $self->ui_form_start("save_manual.cgi", "form-data");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
$self->{'data'} = $self->read_file_contents($self->make_chroot($self->{'in_hash'}->{'file'}));
print $self->ui_textarea("data", $self->{'data'}, 20, 80),"\n";
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

