#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for setting up RNDC
# XXX should check if already working!

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'rndc_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'rndc_title'}, "");
print $self->{'text_hash'}->{'rndc_desc'},"<p>\n";

# Check for rndc-confgen program
if (!$self->has_command($self->{'config_hash'}->{'rndcconf_cmd'})) {
	$self->ui_print_endpage($self->text('rndc_ecmd', "<tt>$self->{'config_hash'}->{'rndcconf_cmd'}</tt>",
				"../config.cgi?$self->{'module_name'}"));
	}

# Check if already working
$self->execute_command("$self->{'config_hash'}->{'rndc_cmd'} status", undef, \$self->{'out'});
if (!$? && $self->{'out'} !~ /failed/) {
	print "<b>",$self->{'text_hash'}->{'rndc_desc2'},"</b><p>\n";
	}

# Show form
print $self->ui_form_start("save_rndc.cgi");
$self->{'ex'} = -s $self->{'config_hash'}->{'rndc_conf'};
print "<center>",$self->text($self->{'ex'} ? 'rndc_rusure' : 'rndc_rusure2',
		       "<tt>$self->{'config_hash'}->{'rndc_conf'}</tt>"),"<p>\n";
print $self->ui_submit($self->{'text_hash'}->{'rndc_ok'}),"</center>\n";
print $self->ui_form_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

