#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_servers.cgi
# Display options for other DNS servers

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'servers_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'servers_title'}, "");

$self->{'conf'} = $self->get_config();
@{$self->{'servers_array'}} = ( $self->find("server", $self->{'conf'}), { } );
@{$self->{'keys_array'}} = $self->find("key", $self->{'conf'});

print "<form action=save_servers.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'servers_ip'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'servers_bogus'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'servers_format'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'servers_trans'}</b></td> ",
      (@{$self->{'keys_array'}} ? "<td><b>$self->{'text_hash'}->{'servers_keys'}</b></td> " : ""), "</tr>\n";
for($i=0; $i<@{$self->{'servers_array'}}; $i++) {
	$self->{'s'} = $self->{'servers_array'}->[$i];
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=ip_$i size=15 value='%s'></td>\n",
		$self->{'s'}->{'value'};

	$self->{'bogus'} = $self->find_value("bogus", $self->{'s'}->{'members'});
	printf "<td><input type=radio name=bogus_$i value=yes %s> %s\n",
		lc($self->{'bogus'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=bogus_$i value='' %s> %s</td>\n",
		lc($self->{'bogus'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};

	$self->{'format'} = $self->find_value("transfer-format", $self->{'s'}->{'members'});
	printf "<td><input type=radio name=format_$i value=one-answer %s> %s\n",
		lc($self->{'format'}) eq 'one-answer' ? "checked" : "",
		$self->{'text_hash'}->{'servers_one'};
	printf "<input type=radio name=format_$i value=many-answers %s> %s\n",
		lc($self->{'format'}) eq 'many-answers' ? "checked" : "",
		$self->{'text_hash'}->{'servers_many'};
	printf "<input type=radio name=format_$i value='' %s> %s</td>\n",
		$self->{'format'} ? "" : "checked", $self->{'text_hash'}->{'default'};

	printf "<td><input name=trans_$i size=8 value='%s'></td>\n",
		$self->find_value("transfers", $self->{'s'}->{'members'});

	if (@{$self->{'keys_array'}}) {
		local %haskey;
		$self->{'keys'} = $self->find("keys", $self->{'s'}->{'members'});
		foreach $k (@{$self->{'keys'}->{'members'}}) {
			$haskey{$k->{'name'}}++;
			}
		print "<td>\n";
		foreach $k (@{$self->{'keys_array'}}) {
			local $v = $k->{'value'};
			printf
			"<input type=checkbox name=keys_$i value='%s' %s> %s\n",
				$v, $haskey{$v} ? "checked" : "", $v;
			}
		print "</td>\n";
		}
	print "</tr>\n";
	}
print "</table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

