#!/usr/bin/perl

&MAIN();

 sub MAIN {
# convert_slave.cgi
# Convert a slave/stub zone into a master

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}]->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->error_setup($self->{'text_hash'}->{'convert_err'});
$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'mcreate_ecannot'});

$self->{'file'} = $self->find("file", $self->{'zconf'}->{'members'});
if (!$self->{'file'}) {
	$self->error($self->{'text_hash'}->{'convert_efile'});
	}
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));

# Change the type directive
$self->save_directive($self->{'zconf'}, 'type', [ { 'name' => 'type',
				    'values' => [ 'master' ] } ], 1);

# Take out directives not allowed in masters
$self->save_directive($self->{'zconf'}, 'masters', [ ], 1);
$self->save_directive($self->{'zconf'}, 'max-transfer-time-in', [ ], 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->redirect("");

1;
		
}


1;

