#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_hint.cgi
# Create a new root zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'hcreate_err'});
$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'hcreate_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});

# Validate inputs
$self->allowed_zone_file(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'hcreate_efile'});
open(FILE, ">>".$self->make_chroot($self->{'in_hash'}->{'file'})) || $self->error($self->{'text_hash'}->{'hcreate_efile2'});
close(FILE);

# Get the root server information
if ($self->{'in_hash'}->{'real'} == 1) {
	# Download from internic
	$self->ftp_download("rs.internic.net", "/domain/named.root", 
		      $self->make_chroot($self->{'in_hash'}->{'file'}));
	}
elsif ($self->{'in_hash'}->{'real'} == 2) {
	# Use webmin's copy
	system("cp ./db.cache ".$self->make_chroot($self->{'in_hash'}->{'file'})." 2>/dev/null");
	}
else {
	# Just check the existing file
	@{$self->{'recs_array'}} = $self->read_zone_file($self->make_chroot($self->{'in_hash'}->{'file'}), ".");
	$self->error($self->{'text_hash'}->{'mcreate_erecs'}) if (@{$self->{'recs_array'}} < 2);
	}

# Create zone structure
$self->{'dir'} = { 'name' => 'zone',
	 'values' => [ '.' ],
	 'type' => 1,
	 'members' => [ { 'name' => 'type',
			  'values' => [ 'hint' ] },
			{ 'name' => 'file',
			  'values' => [ $self->{'in_hash'}->{'file'} ] }
		      ]
	};

# Add a new hint zone
$self->create_zone($self->{'dir'}, $self->{'conf'}, $self->{'in_hash'}->{'view'});
$self->webmin_log("create", "hint", ".", \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

