#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_view.cgi

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->error_setup($self->{'text_hash'}->{'vcreate_err'});
$self->ReadParse();
$self->{'add_to_file'} = $self->add_to_file();
$self->{'pconf'} = $self->get_config_parent($self->{'add_to_file'});
$self->{'conf'} = $self->{'pconf'}->{'members'};
$self->{'access_hash'}->{'views'} == 1 || $self->error($self->{'text_hash'}->{'vcreate_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'vcreate_ecannot'});

# Validate inputs
$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'vcreate_ename'});
@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
foreach $v (@{$self->{'views_array'}}) {
	$self->error($self->{'text_hash'}->{'vcreate_etaken'}) if ($v->{'value'} eq $self->{'in_hash'}->{'name'});
	}
$self->{'in_hash'}->{'class_def'} || $self->{'in_hash'}->{'class'} =~ /^[A-Za-z0-9]+$/ ||
	$self->error($self->{'text_hash'}->{'vcreate_eclass'});

# Create the view
$self->lock_file($self->make_chroot($self->{'add_to_file'}));
$self->{'dir'} = { 'name' => 'view',
	 'values' => [ $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'class_def'} ? ( ) : ( $self->{'in_hash'}->{'class'} ) ],
	 'type' => 1,
	 'members' => [ ],
	 'file' => $self->{'add_to_file'}
	};
if (!$self->{'in_hash'}->{'match_def'}) {
	push(@{$self->{'dir'}->{'members'}}, { 'name' => 'match-clients',
				     'type' => 1,
				     'members' =>
		[ map { { 'name' => $_ } } split(/\s+/, $self->{'in_hash'}->{'match'}) ] } );
	}
$self->save_directive($self->{'pconf'}, undef, [ $self->{'dir'} ], 0);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'add_to_file'}));

# Add to user's ACL
if (!$self->can_edit_view($self->{'dir'})) {
	$self->{'access_hash'}->{'vlist'} = join(" ", $self->unique(
                                split(/\s+/, $self->{'access_hash'}->{'vlist'}), $self->{'in_hash'}->{'name'}));
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
$self->webmin_log("create", "view", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

