#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_record.cgi
# Edit an existing record of some type

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannot'});
$self->{'type'} = $self->{'zone'}->{'type'};
$self->{'file'} = $self->{'zone'}->{'file'};
@{$self->{'recs_array'}} = $self->read_zone_file($self->{'file'}, $self->{'dom'});
$self->{'rec'} = $self->{'recs_array'}->[$self->{'in_hash'}->{'num'}];
$self->can_edit_type($self->{'rec'}->{'type'}, \%{$self->{'access_hash'}}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannottype'});

$self->{'desc'} = $self->text('edit_header', $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'})));
$self->ui_print_header($self->{'desc'}, $self->text('edit_title', $self->{'text_hash'}->{"edit_".$self->{'rec'}->{'type'}} || $self->{'rec'}->{'type'}), "");

$self->record_input($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'}, $self->{'in_hash'}->{'type'}, $self->{'file'},
	      $self->{'dom'}, $self->{'in_hash'}->{'num'}, $self->{'rec'}, $self->{'in_hash'}->{'dom'});
if ($self->{'in_hash'}->{'dom'})	{
        $self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'},$self->{'text_hash'}->{'index_mainpage'}, "edit_recs.cgi?type=ALL&view=&dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'recs_dnstitle'});
} else {
    $self->ui_print_footer("", $self->{'text_hash'}->{'index_return'},
    	"edit_$self->{'type'}.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'recs_return'},
	"edit_recs.cgi?index=$self->{'in_hash'}->{'index'}&type=$self->{'in_hash'}->{'type'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'edit_return'});
    }

1;
		
}


1;

