#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_text.cgi
# Display a form for manually editing a records file

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'file'} = $self->absolute_path($self->{'zone'}->{'file'});
$self->{'tv'} = $self->{'zone'}->{'type'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'access_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'text_ecannot'});
$self->ui_print_header($self->{'file'}, $self->{'text_hash'}->{'text_title'}, "");

open(FILE, $self->make_chroot($self->{'file'}));
while(<FILE>) {
	push(@{$self->{'lines_array'}}, $self->html_escape($_));
	}
close(FILE);

if (!$self->{'access_hash'}->{'ro'}) {
	print $self->text('text_desc', "<tt>$self->{'file'}</tt>"),"<p>\n";
	}

print "<form action=save_text.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'text_undo'}\">\n"
	if (!$self->{'access_hash'}->{'ro'});
print "</form>\n";

$self->ui_print_footer(($self->{'tv'} eq "master" ? "edit_master.cgi" :
	 $self->{'tv'} eq "forward" ? "edit_forward.cgi" : "edit_slave.cgi").
	"?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}", $self->{'text_hash'}->{'master_return'});
1;
		
}


1;

