#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_view.cgi
# Display options for an existing view

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->{'vconf'} = $self->{'view'}->{'members'};
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});
$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'view_title'}, "");

print "<form action=save_view.cgi>\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'view_opts'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

@{$self->{'v_array'}} = @{$self->{'view'}->{'values'}};
print "<tr> <td><b>$self->{'text_hash'}->{'view_name'}</b></td>\n";
print "<td><tt>$self->{'v_array'}->[0]</tt></td>\n";

print "<td><b>$self->{'text_hash'}->{'view_class'}</b></td>\n";
printf "<td>%s</td> </tr>\n",
	$self->{'v_array'}->[1] ? "<tt>$self->{'v_array'}->[1]</tt>" : "$self->{'text_hash'}->{'default'} (<tt>IN</tt>)";

print "<tr>\n";
print $self->addr_match_input($self->{'text_hash'}->{'view_match'}, "match-clients", $self->{'vconf'});
print $self->choice_input($self->{'text_hash'}->{'view_recursion'}, 'recursion', $self->{'vconf'},
		    $self->{'text_hash'}->{'yes'}, 'yes', $self->{'text_hash'}->{'no'}, 'no',
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "</table></td></tr> </table>\n";
if ($self->{'access_hash'}->{'ro'}) {
	print "</form>\n";
	}
else {
	print "<table width=100%><tr><td align=left>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td></form>\n";

	print "<form action=delete_view.cgi>\n";
	print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
	print "<td align=right><input type=submit ",
	      "value=\"$self->{'text_hash'}->{'delete'}\"></td></form>\n";
	print "</tr></table>\n";
	}
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

