#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find_zones.cgi
# Display zones matching some search

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();

@{$self->{'zones_array'}} = $self->list_zone_names();
foreach $z (@{$self->{'zones_array'}}) {
	$self->{'v'} = $z->{'name'};
	next if ($z->{'type'} eq 'view' ||
		 $self->{'v'} eq "." || !$self->can_edit_zone($z) ||
		 $self->arpa_to_ip($self->{'v'}) !~ /$self->{'in_hash'}->{'search'}/i);
	$self->{'t'} = $z->{'type'};
	if ($z->{'view'}) {
		push(@{$self->{'zlinks_array'}}, "edit_$self->{'t'}.cgi?index=$z->{'index'}".
			      "&view=$z->{'viewindex'}");
		push(@{$self->{'ztitles_array'}}, $self->ip6int_to_net($self->arpa_to_ip($self->{'v'}))." ".
		       $self->text('index_view', "<tt>$z->{'view'}</tt>"));
		push(@{$self->{'zdels_array'}}, $z->{'index'}." ".$z->{'view'});
		}
	else {
		push(@{$self->{'zlinks_array'}}, "edit_$self->{'t'}.cgi?index=$z->{'index'}");
		push(@{$self->{'ztitles_array'}}, $self->ip6int_to_net($self->arpa_to_ip($self->{'v'})));
		push(@{$self->{'zdels_array'}}, $z->{'index'});
		}
	push(@{$self->{'zicons_array'}}, "images/$self->{'t'}.gif");
	push(@{$self->{'ztypes_array'}}, $self->{'text_hash'}->{"index_$self->{'t'}"});
	$self->{'len'}++;
	}
if (@{$self->{'zlinks_array'}} == 1) {
	$self->redirect($self->{'zlinks_array'}->[0]);
	exit;
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'find_title'}, "");
print $self->text('find_match', "<tt>$self->{'in_hash'}->{'search'}</tt>"),"<p>\n";

if ($self->{'len'}) {
	# sort list of zones
	@{$self->{'zorder_array'}} = sort { $self->{'ztitles_array'}->[$a] cmp $self->{'ztitles_array'}->[$b] } (0 .. $self->{'len'}-1);
	@{$self->{'zlinks_array'}} = map { $self->{'zlinks_array'}->[$_] } @{$self->{'zorder_array'}};
	@{$self->{'ztitles_array'}} = map { $self->{'ztitles_array'}->[$_] } @{$self->{'zorder_array'}};
	@{$self->{'zicons_array'}} = map { $self->{'zicons_array'}->[$_] } @{$self->{'zorder_array'}};
	@{$self->{'ztypes_array'}} = map { $self->{'ztypes_array'}->[$_] } @{$self->{'zorder_array'}};
	@{$self->{'zdels_array'}} = map { $self->{'zdels_array'}->[$_] } @{$self->{'zorder_array'}};

	if ($self->{'config_hash'}->{'show_list'}) {
		# display as list
		$self->{'mid'} = int((@{$self->{'zlinks_array'}}+1)/2);
		print $self->ui_form_start("mass_delete.cgi", "post");
		@{$self->{'links_array'}} = ( $self->select_all_link("d", 0),
			   $self->select_invert_link("d", 0) );
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print "<table width=100%><tr><td width=50% valign=top>\n";
		$self->zones_table([ @{$self->{'zlinks_array'}}[0 .. $self->{'mid'}-1] ],
			     [ @{$self->{'ztitles_array'}}[0 .. $self->{'mid'}-1] ],
			     [ @{$self->{'ztypes_array'}}[0 .. $self->{'mid'}-1] ],
			     [ @{$self->{'zdels_array'}}[0 .. $self->{'mid'}-1] ] );
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'zlinks_array'}}) {
			$self->zones_table([ @{$self->{'zlinks_array'}}[$self->{'mid'} .. $#{$self->{'zlinks_array'}}] ],
				     [ @{$self->{'ztitles_array'}}[$self->{'mid'} .. $#{$self->{'ztitles_array'}}] ],
				     [ @{$self->{'ztypes_array'}}[$self->{'mid'} .. $#{$self->{'ztypes_array'}}] ],
				     [ @{$self->{'zdels_array'}}[$self->{'mid'} .. $#{$self->{'zdels_array'}}] ]);
			}
		print "</td></tr></table>\n";
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_massdelete'} ] ]);
		}
	else {
		# display as icons
		$self->icons_table(\@{$self->{'zlinks_array'}}, \@{$self->{'ztitles_array'}}, \@{$self->{'zicons_array'}});
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'find_none'}</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

