#!/usr/bin/perl

&MAIN();

 sub MAIN {
# hint_form.cgi
# Display options for creating a new root zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'hcreate_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'hcreate_title'}, "");

$self->{'conf'} = $self->get_config();
@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
foreach $v (@{$self->{'views_array'}}) {
	local @vz = $self->find("zone", $v->{'members'});
	map { $self->{'view_hash'}->{$_} = $v } @vz;
	push(@{$self->{'zones_array'}}, @vz);
	}
push(@{$self->{'zones_array'}}, $self->find("zone", $self->{'conf'}));
foreach $z (@{$self->{'zones_array'}}) {
	$self->{'tv'} = $self->find_value("type", $z->{'members'});
	if ($self->{'tv'} eq 'hint') {
		$self->{'file'} = $self->find_value("file", $z->{'members'});
		$self->{'hashint_hash'}->{$self->{'view_hash'}->{$z}}++;
		}
	}

print $self->{'text_hash'}->{'hcreate_desc'},"<p>\n";
print "<form action=\"create_hint.cgi\">\n";
print "<table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'hcreate_file'}</b></td>\n";
print "<td><input name=file size=30 value='$self->{'file'}'> ",
	$self->file_chooser_button("file"),"</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'hcreate_real'}</b></td> <td>\n";
printf "<input type=radio name=real value=1 %s> $self->{'text_hash'}->{'hcreate_down'}<br>\n",
	$self->{'file'} ? "" : "checked";
print "<input type=radio name=real value=2> $self->{'text_hash'}->{'hcreate_webmin'}<br>\n";
printf "<input type=radio name=real value=3 %s> $self->{'text_hash'}->{'hcreate_keep'}\n",
	$self->{'file'} ? "checked" : "";
print "</td> </tr>\n";

if (@{$self->{'views_array'}}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'mcreate_view'}</b></td>\n";
	print "<td colspan=3><select name=view>\n";
	foreach $v (@{$self->{'views_array'}}) {
		printf "<option value=%d>%s\n",
			$v->{'index'}, $v->{'value'} if (!$self->{'hashint_hash'}->{$v});
		}
	print "</select></td> </tr>\n";
	}

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'create'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

