#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of zones, after asking for confirmation

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();

if ($self->{'in_hash'}->{'update'}) {
	# Redirect to mass update form
	$self->redirect("mass_update_form.cgi?".
		  join("&", map { "d=".$self->urlize($_) } split(/\0/, $self->{'in_hash'}->{'d'})));
	exit;
	}

# Get the zones
foreach $d (split(/\0/, $self->{'in_hash'}->{'d'})) {
	($self->{'idx'}, $self->{'viewidx'}) = split(/\s+/, $d);
	if ($self->{'viewidx'} ne '') {
		$self->{'view'} = $self->{'conf'}->[$self->{'viewidx'}];
		$self->{'zconf'} = $self->{'view'}->{'members'}->[$self->{'idx'}];
		}
	else {
		$self->{'zconf'} = $self->{'conf'}->[$self->{'idx'}];
		}
	$self->can_edit_zone($self->{'zconf'}, $self->{'view'}) ||
		$self->error($self->{'text_hash'}->{'master_edelete'});
	push(@{$self->{'zones_array'}}, [ $self->{'zconf'}, $self->{'view'} ]);
	push(@{$self->{'znames_array'}}, $self->{'zconf'}->{'value'});
	}
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});
$self->{'access_hash'}->{'delete'} || $self->error($self->{'text_hash'}->{'master_edeletecannot'});

if (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'massdelete_title'}, "");

	print $self->ui_form_start("mass_delete.cgi", "post");
	foreach $d (split(/\0/, $self->{'in_hash'}->{'d'})) {
		print $self->ui_hidden("d", $d),"\n";
		}
	print "<center>",$self->text('massdelete_rusure', scalar(@{$self->{'zones_array'}}),
			       join(", ", @{$self->{'znames_array'}})),"<p>\n";
	print $self->ui_submit($self->{'text_hash'}->{'massdelete_ok'}, "confirm"),"<p>\n";
	@{$self->{'servers_array'}} = $self->list_slave_servers();
	if (@{$self->{'servers_array'}} && $self->{'access_hash'}->{'remote'}) {
		print $self->{'text_hash'}->{'delete_onslave'},"\n";
		print $self->ui_yesno_radio("onslave", 1),"<br>\n";
		}
	print "</center>\n";
	print $self->ui_form_end();

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	# Do it!
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'massdelete_title'}, "");

	foreach $zi (@{$self->{'zones_array'}}) {
		$self->{'zconf'} = $zi->[0];
		$self->{'view'} = $zi->[1];
		$self->{'type'} = $self->find_value("type", $self->{'zconf'}->{'members'});
		print $self->text('massdelete_zone', $self->{'zconf'}->{'value'}),"<br>\n";

		# delete the records file
		$self->{'f'} = $self->find("file", $self->{'zconf'}->{'members'});
		if ($self->{'f'} && $self->{'type'} ne 'hint') {
			$self->lock_file($self->make_chroot($self->absolute_path($self->{'f'}->{'value'})));
			unlink($self->make_chroot($self->absolute_path($self->{'f'}->{'value'})));
			}

		# remove the zone directive
		$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
		$self->save_directive($self->{'view'} || $self->get_config_parent($self->{'zconf'}->{'file'}),
				[ $self->{'zconf'} ], [ ]);
		print $self->{'text_hash'}->{'massdelete_done'},"<p>\n";

		# Also delete from slave servers
		if ($self->{'in_hash'}->{'onslave'} && $self->{'access_hash'}->{'remote'}) {
			print $self->text('massdelete_slaves',
				    $self->{'zconf'}->{'value'}),"<br>\n";
			@{$self->{'slaveerrs_array'}} = $self->delete_on_slaves($self->{'zconf'}->{'value'});
			if (@{$self->{'slaveerrs_array'}}) {
				print $self->{'text_hash'}->{'massdelete_failed'},"<br>\n";
				foreach $s (@{$self->{'slaveerrs_array'}}) {
					print "$s->[0]->{'host'} : $s->[1]<br>\n";
					}
				print "<p>\n";
				}
			else {
				print $self->{'text_hash'}->{'massdelete_done'},"<p>\n";
				}
			}
		}
	$self->flush_file_lines();
	$self->unlock_all_files();
	$self->webmin_log("delete", "zones", scalar(@{$self->{'zones_array'}}));

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

