#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move_zone.cgi
# Move a zone to a different view

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'pconf'} = $self->get_config_parent();
$self->{'conf'} = $self->{'pconf'}->{'members'};
$self->{'nconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'newview'}];
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->can_edit_zone($self->{'zconf'}, $self->{'view'}) || $self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'in_hash'}->{'view'} ne $self->{'in_hash'}->{'newview'} || $self->error($self->{'text_hash'}->{'master_emove'});
$self->can_edit_view($self->{'nconf'}) || $self->error($self->{'text_hash'}->{'master_eviewcannot'});

# Delete from the view
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->save_directive($self->{'pconf'}, [ $self->{'zconf'} ], [ ], 0);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'zconf'}->{'file'}));

# Create in new view
$self->lock_file($self->make_chroot($self->{'nconf'}->{'file'}));
$self->save_directive($self->{'nconf'}, undef, [ $self->{'zconf'} ], 1);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'nconf'}->{'file'}));
$self->webmin_log("move", undef, $self->{'zconf'}->{'value'}, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

