#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Re-download the root zone servers

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->error_setup($self->{'text_hash'}->{'refetch_err'});
$self->ReadParse();

# Work out the filename
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->can_edit_zone($self->{'zone'}, $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'hint_ecannot'});
$self->{'file'} = $self->{'zone'}->{'file'};
$self->{'file'} = $self->make_chroot($self->absolute_path($self->{'file'}));

# Try to download the root servers file from
# ftp://rs.internic.net/domain/named.root
$self->lock_file($self->{'file'});
$self->ftp_download("rs.internic.net", "/domain/named.root", $self->{'file'});
$self->unlock_file($self->{'file'});

$self->webmin_log("refetch");
$self->redirect("");

1;
		
}


1;

