#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_acls.cgi
# Update all the acl directives

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'acls_ecannot'});
$self->error_setup($self->{'text_hash'}->{'acls_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
for($i=0; defined($self->{'name'} = $self->{'in_hash'}->{"name_$i"}); $i++) {
	next if (!$self->{'name'});
	$self->{'name'} =~ /^\S+$/ || $self->error($self->text('acls_ename', $self->{'name'}));
	@{$self->{'vals_array'}} = split(/\s+/, $self->{'in_hash'}->{"values_$i"});
	push(@{$self->{'acls_array'}}, { 'name' => 'acl',
		      'values' => [ $self->{'name'} ],
		      'type' => 1,
		      'members' => [ map { { 'name' => $_ } } @{$self->{'vals_array'}} ] });
	}

$self->save_directive($self->get_config_parent(), 'acl', \@{$self->{'acls_array'}}, 0, 0, 1);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("acls", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

