#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_delegation.cgi
# Save changes to delegation zone options in named.conf

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	$self->{'indent'} = 2;
	}
else {
	$self->{'indent'} = 1;
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->error_setup($self->{'text_hash'}->{'delegation_err'});
$self->can_edit_zone($self->{'zconf'}, $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'delegation_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->webmin_log("opts", undef, $self->{'zconf'}->{'value'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

