#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_files.cgi
# Save global files options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'files_ecannot'});
$self->error_setup($self->{'text_hash'}->{'files_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->save_opt("statistics-file", \&file_check, $self->{'options'}, 1);
$self->save_opt("dump-file", \&file_check, $self->{'options'}, 1);
$self->save_opt("pid-file", \&file_check, $self->{'options'}, 1);
$self->save_opt("named-xfer", \&file_check, $self->{'options'}, 1);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("files", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub file_check
{
	shift if ($self == $_[0]);

return $_[0] =~ /\S/ ? '' : $self->{'text_hash'}->{'files_efile'};
}


1;

