#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_forwarding.cgi
# Save global forwarding options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'forwarding_ecannot'});
$self->error_setup($self->{'text_hash'}->{'forwarding_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->save_forwarders('forwarders', $self->{'options'}, 1);
$self->save_choice('forward', $self->{'options'}, 1);
$self->save_opt('max-transfer-time-in', \&check_mins, $self->{'options'}, 1);
$self->save_choice('transfer-format', $self->{'options'}, 1);
$self->save_opt('transfers-in', \&check_trans, $self->{'options'}, 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("forwarding", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_mins
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'forwarding_emins'};
}

sub check_trans
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'forwarding_etrans'};
}


1;

