#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_text.cgi
# Save a manually edit zone file

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParseMime();
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'file'} = $self->absolute_path($self->{'zone'}->{'file'});
$self->{'tv'} = $self->{'zone'}->{'type'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'access_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'text_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'master_ero'});

$self->lock_file($self->make_chroot($self->{'file'}));
$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->{'in_hash'}->{'text'} .= "\n" if ($self->{'in_hash'}->{'text'} !~ /\n$/);
$self->open_tempfile(FILE, ">".$self->make_chroot($self->{'file'}));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->unlock_file($self->make_chroot($self->{'file'}));
$self->webmin_log("text", undef, $self->{'zone'}->{'name'},
	    { 'file' => $self->{'file'} });
$self->redirect("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}");

1;
		
}


1;

