#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_view.cgi
# Update an existing view

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'view_err'});
$self->{'pconf'} = $self->get_config_parent();
$self->{'conf'} = $self->{'pconf'}->{'members'};
$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});
$self->can_edit_view($self->{'view'}) || $self->error($self->{'text_hash'}->{'view_ecannot'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'view_ecannot'});

# Save the view
$self->lock_file($self->make_chroot($self->{'view'}->{'file'}));
$self->save_addr_match("match-clients", $self->{'view'}, 1);
$self->save_choice("recursion", $self->{'view'}, 1);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'view'}->{'file'}));
$self->webmin_log("view", undef, $self->{'view'}->{'value'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

