#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a table of icons for different types of webmin configuration

&ModuleLoader::preload_module('clamav_class', "clamav::ClamavLib");
$self = new clamav::ClamavLib:: 'clamav_class',%$self;

$self->{'ver'} = $self->get_version_clamav();
$self->{'status'} =  $self->status_clamav_daemon();

# error config messeges
if (!$self->has_command($self->{'config_hash'}->{'clamav_cmd'}))
{
    $self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
    $self->ui_print_endpage($self->ui_config_link('index_ecmd',[ "<tt>$self->{'config_hash'}->{'clamav_cmd'}</tt>", undef ]));
}

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0, undef, undef, undef, $self->{'ver'});

@{$self->{'wlinks_array'}} = ( "quarantine.cgi",
	    "settings.cgi?conf=clamav",
	    "settings.cgi?conf=freshclamav",
	    "local_check.cgi",
	    "log_view.cgi",
	    "update.cgi",
	    "search_db.cgi"
	     );
@{$self->{'wtitles_array'}} = ( $self->{'text_hash'}->{'index_quarantine'},
	     $self->{'text_hash'}->{'index_clamav_settings'},
	     $self->{'text_hash'}->{'index_freshclamav_settings'},
	     $self->{'text_hash'}->{'index_local_dir'},
	     $self->{'text_hash'}->{'index_log'},
	     $self->{'text_hash'}->{'index_update'},
	     $self->{'text_hash'}->{'index_viruses'}
	      );
	     
@{$self->{'wicons_array'}} = ( "images/quarantine.gif", 
	    "images/settings.gif",
	    "images/fresh_settings.gif",
	    "images/scandir.gif",
	    "images/logs.gif",
	    "images/updates.gif",
	    "images/vdb_search.gif"
	    );
	    
$self->icons_table(\@{$self->{'wlinks_array'}}, \@{$self->{'wtitles_array'}}, \@{$self->{'wicons_array'}});

print "<hr>\n";

print $self->ui_buttons_start();
if ($self->{'status'}) {
	print $self->ui_buttons_row("restart.cgi", $self->{'text_hash'}->{'restart'}, $self->{'text_hash'}->{'index_restartmsg'});
	print $self->ui_buttons_row("stop.cgi", $self->{'text_hash'}->{'stop'}, $self->{'text_hash'}->{'index_stopmsg'});
	}
else {
	print $self->ui_buttons_row("start.cgi", $self->{'text_hash'}->{'start'}, $self->{'text_hash'}->{'index_startmsg'});
	}
print $self->ui_buttons_end();

if ($self->{'text_hash'}->{'index_mainpage_url'} && $self->{'text_hash'}->{'index_mainpage'}) {
	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
}
else {
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
}

1;
		
}


1;

