#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('clamav_class', "clamav::ClamavLib");
$self = new clamav::ClamavLib:: 'clamav_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_log'}, "", undef, 1, 1, 0, undef, undef, undef, $self->{'ver'});

print $self->ui_form_start('log_view.cgi', 'POST');
print $self->ui_table_start("$self->{'text_hash'}->{'log_table'}", 'width=100%');

$self->{'lines'} = qq(<select name="lines">);
$self->{'lines'} .= sprintf "<option value=\"0\"%s>%s</option>", !$self->{'in_hash'}->{'lines'} ? ' selected' : '', $self->{'text_hash'}->{'log_all'};
foreach $value (qw(10 20 50 100 150 200 250 300))
{
  $self->{'lines'} .= sprintf "<option value=\"%s\"%s>%s</option>", $value, ($self->{'in_hash'}->{'lines'} eq $value) ? ' selected' : '', $value;
}
$self->{'lines'} .= qq(</select>);

%{$self->{'conf_clamav_hash'}} = $self->get_config($self->{'config_hash'}->{'clamav_conf'});

$self->{'logs'} = qq(<select name="logs">);
$self->{'logs'} .= sprintf "<option value=\"$self->{'conf_clamav_hash'}->{'LogFile'}\" %s>$self->{'conf_clamav_hash'}->{'LogFile'}</option>", $self->{'in_hash'}->{'logs'} eq $self->{'conf_clamav_hash'}->{'LogFile'} ? 'selected' : '';
if (-f $self->{'config_hash'}->{'fresh_daemon_conf'}) {
    %{$self->{'conf_freshclamav_hash'}} = $self->get_config($self->{'config_hash'}->{'fresh_daemon_conf'});
    $self->{'logs'} .= sprintf "<option value=\"$self->{'conf_freshclamav_hash'}->{'LOGFILE'}\" %s>$self->{'conf_freshclamav_hash'}->{'LOGFILE'}</option>", $self->{'in_hash'}->{'logs'} eq $self->{'conf_freshclamav_hash'}->{'LOGFILE'} ? 'selected' : '';
} else {
    %{$self->{'conf_freshclamav_hash'}} = $self->get_config($self->{'config_hash'}->{'freshclamav_conf'});
    $self->{'logs'} .= sprintf "<option value=\"$self->{'conf_freshclamav_hash'}->{'UpdateLogFile'}\" %s>$self->{'conf_freshclamav_hash'}->{'UpdateLogFile'}</option>", $self->{'in_hash'}->{'logs'} eq $self->{'conf_freshclamav_hash'}->{'UpdateLogFile'} ? 'selected' : '';
    }
$self->{'logs'} .= qq(</select>);

print $self->ui_table_row("$self->{'text_hash'}->{'log_file'}", $self->{'logs'}, 2);
print $self->ui_table_row("$self->{'text_hash'}->{'log_count_lines'}", $self->{'lines'}, 2);
print $self->ui_table_end();
print $self->ui_form_end([['show', $self->{'text_hash'}->{'log_submit'}]]);

if ($self->{'in_hash'}->{'show'}) {
 	$self->show_log($self->{'in_hash'}->{'logs'}, $self->{'in_hash'}->{'lines'});
 }

if ($self->{'in_hash'}->{'clear'}) {
	`echo "" > "$self->{'in_hash'}->{logs}"`;
}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_title'});
1;
		
}


1;

