#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('clamav_class', "clamav::ClamavLib");
$self = new clamav::ClamavLib:: 'clamav_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_update'}, "", undef, 1, 1, 0, undef, undef, undef, $self->{'ver'});

local ($date1, $info1) = $self->get_last_db($self->{'config_hash'}->{'clamav_db1'});
local ($date2, $info2) = $self->get_last_db($self->{'config_hash'}->{'clamav_db2'});

#%conf_freshclamav = &get_config($self->{'config_hash'}->{'freshclamav_conf'});
local ($daemon_check, $cron_job) = $self->get_freshclamav_update_status();

#form for manually update
print $self->ui_form_start('update_manually.cgi', 'POST');
print $self->ui_table_start("$self->{'text_hash'}->{'update_table_caption'}", 'width=100%');
print $self->ui_table_row("$self->{'text_hash'}->{'update_name_db1'}", "$date1, $info1", 2, "20%");
print $self->ui_table_row("$self->{'text_hash'}->{'update_name_db2'}", "$date2, $info2", 2, "20%");
print $self->ui_table_end();
print $self->ui_form_end([['update', $self->{'text_hash'}->{'update_manually'}]]);

#form for auto update
print $self->ui_form_start('update_auto.cgi', 'POST');
$self->foreign_require('cron', 'cron-lib.pl');
print $self->ui_table_start("$self->{'text_hash'}->{'update_table1_caption'}", 'width=100%');
printf ($self->ui_table_row("<input type=radio name='update_type' value=\"1\" %s>$self->{'text_hash'}->{'update_type_1'}", "Number of daily checks &nbsp".$self->clamav_daemon_table($daemon_check), 2, "20%"), defined ($daemon_check) ? 'checked' : 'uncheked');
print $self->ui_table_hr();
printf ("<tr><td valign=top width=20%><input type=radio name='update_type' value=\"2\" %s><b>$self->{'text_hash'}->{'update_type_2'}</b></td><td><table>", defined ($cron_job) ? 'checked' : 'uncheked');
$main::cron_object->show_times_input($cron_job);
print "</table></td></tr>";
print $self->ui_table_end();
print $self->ui_form_end([['apply', $self->{'text_hash'}->{'apply'}]]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_title'});
1;
		
}


1;

