#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Shows POP3 daemon options

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();

$self->{'dmn'} = 'authlib';
$self->ui_print_header(undef, $self->{'text_hash'}->{'authlib_title'}, "");

$self->{'conf'} = $self->get_daemon_config($self->{'dmn'});

print $self->ui_form_start("save_authlib.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'authlib_header1'}, "width=100%", 2);

# Authentication Modules List
$self->{'auth'} = $self->get_real_value('authmodulelist', $self->{'conf'});
@{$self->{'auth_array'}} = split(/\s+/, $self->{'auth'});
$self->{'auth_orig'} = $self->get_value('authmodulelistorig', $self->{'conf'});
@{$self->{'auth_orig_array'}} = split(/\s+/, $self->{'auth_orig'});
print $self->ui_table_row($self->{'text_hash'}->{'authlib_mods'},
		$self->ui_select('modules', \@{$self->{'auth_array'}}, [ map { [$_] } @{$self->{'auth_orig_array'}} ], scalar(@{$self->{'auth_orig_array'}}), 1));

# Maximum number of daemon processes
$self->{'daemons'} = $self->get_value('daemons', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'authlib_procs'},
		$self->ui_textbox('daemons', $self->{'daemons'}, 5));

# The First Version of authdaemond.*
$self->{'ver'} = $self->get_value('version', $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'authlib_ver'},
		$self->ui_textbox('version', $self->{'ver'}, 30));

print $self->ui_table_end();

print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

