#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Saves AuthLib options

&ModuleLoader::preload_module('courier_imap_class', "courier_imap::CourierimapLib");
$self = new courier_imap::CourierimapLib:: 'courier_imap_class',%$self;

$self->ReadParse();

$self->{'dmn'} = 'authlib';

$self->{'cfile'} = $self->get_daemon_config_file($self->{'dmn'});
$self->{'conf'} = $self->get_daemon_config($self->{'dmn'});

$self->error_setup($self->text('save_err', $self->get_daemon_title($self->{'dmn'})));

$self->lock_file($self->{'cfile'});

# Authentication Modules List
$self->save_directive($self->{'cfile'}, $self->{'conf'}, 'authmodulelist', join(" ", split(/\0/, $self->{'in_hash'}->{'modules'})));

# Maximum number of daemon processes
$self->{'in_hash'}->{'daemons'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'authlib_edaemons'});
$self->save_directive($self->{'cfile'}, $self->{'conf'}, 'daemons', $self->{'in_hash'}->{'daemons'});

# The First Version of authdaemond.*
!$self->{'in_hash'}->{'version'} || $self->{'in_hash'}->{'version'} =~ /^authdaemond\.[a-zA-Z0-9]+$/ || $self->error($self->{'text_hash'}->{'authlib_ever'});
$self->{'ver'} = $self->{'in_hash'}->{'version'} ? "\"" . $self->{'in_hash'}->{'version'} . "\"" : "\"\"";
$self->save_directive($self->{'cfile'}, $self->{'conf'}, 'version', $self->{'ver'});

$self->flush_file_lines();
$self->unlock_file($self->{'cfile'});
$self->webmin_log("save", $self->{'dmn'});
if ($self->{'config_hash'}->{'auto_apply'} && $self->is_daemon_running($self->{'dmn'})) {
	$self->restart_daemon($self->{'dmn'});
	$self->webmin_log('apply', $self->{'dmn'});
}
$self->redirect("");

1;
		
}


1;

