#!/usr/bin/perl

&MAIN();

 sub MAIN {
# uninstall.cgi
# Uninstall a perl module group, after asking for confirmation 

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'uninstall'} || $self->error($self->{'text_hash'}->{'uninstall_ecannot'});
$self->ReadParse();
@{$self->{'mods_array'}} = $self->list_perl_modules();
$self->{'mod'} = $self->{'mods_array'}->[$self->{'in_hash'}->{'idx'}];
$self->error_setup($self->{'text_hash'}->{'uninstall_err'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Go ahead and do it
	$self->{'err'} = $self->remove_module($self->{'mod'});
	$self->error($self->{'err'}) if ($self->{'err'});
	$self->redirect("");
	}
else {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'uninstall_title'}, "");

	print "<form action=uninstall.cgi>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	local ($m, @sm) = @{$self->{'mod'}->{'mods'}};
	if (@sm) {
		print $self->text('uninstall_rusure2', "<tt>$m</tt>",
			    join(" , ", map { "<tt>$_</tt>" } @sm)),"\n";
		}
	else {
		print $self->text('uninstall_rusure', "<tt>$m</tt>"),"\n";
		}
	print "<pre>";
	foreach $f (@{$self->{'mod'}->{'packlist'}}, $self->{'mod'}->{'packfile'}) {
		print $self->html_escape($f),"\n";
		}
	print "</pre>\n";
	if ($self->{'mod'}->{'pkg'}) {
		print $self->text('uninstall_'.$self->{'mod'}->{'pkgtype'},
			    "<tt>$self->{'mod'}->{'pkg'}</tt>"),"<p>\n";
		}
	print "<center><input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'uninstall_ok'}'></center></form>\n";

	$self->ui_print_footer("edit_mod.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'edit_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

