#!/usr/bin/perl

&MAIN();

 sub MAIN {
# bootup.cgi
# Create, enable or disable CP+ startup at boot time

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->foreign_require("init", "init-lib.pl");
$self->ReadParse();

if ($self->{'in_hash'}->{'boot'}) {
	# Enable starting at boot
	$self->{'start'} = "$self->{'config_directory'}/start";
	$self->{'stop'} = "$self->{'config_directory'}/stop";
	$self->{'status'} = <<EOF;
pidfile=`grep "^pidfile=" $self->{'config_directory'}/miniserv.conf | sed -e 's/pidfile=//g'`
if [ -s \$pidfile ]; then
	pid=`cat \$pidfile`
	kill -0 \$pid >/dev/null 2>&1
	if [ "\$?" = "0" ]; then
		echo "cpplus (pid \$pid) is running"
		RETVAL=0
	else
		echo "cpplus is stopped"
		RETVAL=1
	fi
else
	echo "cpplus is stopped"
	RETVAL=1
fi
EOF
	$main::init_object->enable_at_boot("cpplus", "Start or stop CP+",
			      $self->{'start'}, $self->{'stop'}, $self->{'status'});
	}
else {
	# Disable starting at boot
	$main::init_object->disable_at_boot("cpplus");
	}
$self->redirect("");

1;
		
}


1;

