#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_lang.cgi
# Change language setting

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'lang_err'});
$self->lock_file("$self->{'config_directory'}/config");
$self->{'gconfig_hash'}->{'lang'} = $self->{'in_hash'}->{'lang'};
$self->{'gconfig_hash'}->{'acceptlang'} = $self->{'in_hash'}->{'acceptlang'};
if ($self->{'in_hash'}->{'charset_def'}) {
	delete($self->{'gconfig_hash'}->{'charset'});
	}
else {
	$self->{'in_hash'}->{'charset'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'lang_echarset'});
	$self->{'gconfig_hash'}->{'charset'} = $self->{'in_hash'}->{'charset'};
	}
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");
$self->webmin_log("lang", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

