#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save file locking settings

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'lock_err'});
if ($self->{'in_hash'}->{'lockmode'} >= 2) {
	@{$self->{'dirs_array'}} = split(/\n+/, $self->{'in_hash'}->{'lockdirs'});
	foreach $d (@{$self->{'dirs_array'}}) {
		$d =~ /^\// || $self->error($self->text('lock_edir', $d));
		}
	@{$self->{'dirs_array'}} || $self->error($self->{'text_hash'}->{'lock_edirs'});
	}

# Write out config
$self->lock_file($self->{'config_file'});
$self->{'gconfig_hash'}->{'lockmode'} = $self->{'in_hash'}->{'lockmode'};
$self->{'gconfig_hash'}->{'lockdirs'} = join("\t", @{$self->{'dirs_array'}});
$self->save_module_config(\%{$self->{'gconfig_hash'}}, "");
$self->unlock_file($self->{'config_file'});
$self->webmin_log("lock");

$self->redirect("");

1;
		
}


1;

