#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display options specific to mobile devices

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mobile_err'});

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->lock_file("$self->{'config_directory'}/config");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

# Validate and store inputs
if ($self->{'in_hash'}->{'theme'} eq '*') {
	delete($self->{'miniserv_hash'}->{'mobile_preroot'});
	delete($self->{'gconfig_hash'}->{'mobile_theme'});
	}
else {
	$self->{'miniserv_hash'}->{'mobile_preroot'} = $self->{'in_hash'}->{'theme'};
	$self->{'gconfig_hash'}->{'mobile_theme'} = $self->{'in_hash'}->{'theme'};
	}
$self->{'miniserv_hash'}->{'mobile_nosession'} = $self->{'in_hash'}->{'nosession'};
$self->{'in_hash'}->{'agents'} =~ s/\r//g;
$self->{'miniserv_hash'}->{'mobile_agents'} = join("\t", split(/\n+/, $self->{'in_hash'}->{'agents'}));
$self->{'miniserv_hash'}->{'mobile_prefixes'} = $self->{'in_hash'}->{'prefixes'};

# Write out files
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

$self->reload_miniserv();
$self->webmin_log('mobile', undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

