#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_proxy.cgi
# Change proxy settings

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->error_setup($self->{'text_hash'}->{'proxy_err'});
$self->ReadParse();

$self->lock_file("$self->{'config_directory'}/config");
if ($self->{'in_hash'}->{'http_def'}) { delete($self->{'gconfig_hash'}->{'http_proxy'}); }
elsif ($self->{'in_hash'}->{'http'} !~ /^http:\/\/(\S+):(\d+)/) {
	$self->error($self->text('proxy_ehttp2', "http://proxy.foo.com:8080/"));
	}
else { $self->{'gconfig_hash'}->{'http_proxy'} = $self->{'in_hash'}->{'http'}; }

if ($self->{'in_hash'}->{'ftp_def'}) { delete($self->{'gconfig_hash'}->{'ftp_proxy'}); }
elsif ($self->{'in_hash'}->{'ftp'} !~ /^http:\/\/(\S+):(\d+)/) {
	$self->error($self->text('proxy_eftp2', "http://proxy.foo.com:8080/"));
	}
else { $self->{'gconfig_hash'}->{'ftp_proxy'} = $self->{'in_hash'}->{'ftp'}; }

if ($self->{'in_hash'}->{'bind_def'}) {
	delete($self->{'gconfig_hash'}->{'bind_proxy'});
	}
else {
	$self->check_ipaddress($self->{'in_hash'}->{'bind'}) || $self->error($self->{'text_hash'}->{'proxy_ebind'});
	$self->{'gconfig_hash'}->{'bind_proxy'} = $self->{'in_hash'}->{'bind'};
	}

$self->{'gconfig_hash'}->{'proxy_user'} = $self->{'in_hash'}->{'puser'};
$self->{'gconfig_hash'}->{'proxy_pass'} = $self->{'in_hash'}->{'ppass'};
$self->{'gconfig_hash'}->{'noproxy'} = $self->{'in_hash'}->{'noproxy'};

# Write out the config
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");
$self->webmin_log('proxy', undef, undef, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

