#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_access.cgi
# Display IP access control form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'access_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->{'text_hash'}->{'access_desc'},"<p>\n";

print $self->ui_form_start("change_access.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'access_header'}, undef, 2);

$self->{'access'} = $self->{'miniserv_hash'}->{"allow"} ? 1 : $self->{'miniserv_hash'}->{"deny"} ? 2 : 0;
print $self->ui_table_row($self->{'text_hash'}->{'access_ip'},
	$self->ui_radio("access", $self->{'access'},
	 	  [ [ 0, $self->{'text_hash'}->{'access_all'} ],
	 	    [ 1, $self->{'text_hash'}->{'access_allow'} ],
	 	    [ 2, $self->{'text_hash'}->{'access_deny'} ] ])."<br>\n".
	$self->ui_textarea("ip",
		$self->{'access'} == 1 ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"allow"})) :
		$self->{'access'} == 2 ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"deny"})) : "",
		6, 30));

print $self->ui_table_row($self->{'text_hash'}->{'access_always'},
	$self->ui_yesno_radio("alwaysresolve", int($self->{'miniserv_hash'}->{'alwaysresolve'})));

eval "use Authen::Libwrap qw(hosts_ctl STRING_UNKNOWN)";
if (!$@) {
	print $self->ui_table_row($self->{'text_hash'}->{'access_libwrap'},
		$self->ui_yesno_radio("libwrap", int($self->{'miniserv_hash'}->{'libwrap'})));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

