#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ca.cgi
# Display the current CA or a form for creating one

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ca_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

%{$self->{'aclconfig_hash'}} = $self->foreign_config("acl");
$self->foreign_require("acl", "acl-lib.pl");
if (!$ENV{"MINISERV_CONFIG"}) {
	print "<p>$self->{'text_hash'}->{'ca_eminiserv'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
elsif (uc($ENV{'HTTPS'}) ne 'ON') {
	print "<p>$self->{'text_hash'}->{'ca_essl'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
elsif (!defined(&Net::SSLeay::X509_STORE_CTX_get_current_cert) ||
       !defined(&Net::SSLeay::CTX_load_verify_locations) ||
       !defined(&Net::SSLeay::CTX_set_verify)) {
	print "<p>$self->{'text_hash'}->{'ca_eversion'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
elsif (!$main::acl_object->get_ssleay()) {
	print "<p>",$self->text('ca_essleay',
			  "<tt>$self->{'aclconfig_hash'}->{'ssleay'}</tt>"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print -r $self->{'miniserv_hash'}->{'ca'} ? $self->{'text_hash'}->{'ca_newmsg1'} : $self->{'text_hash'}->{'ca_newmsg1'},"<p>\n";
print "<form action=setup_ca.cgi><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ca_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'ca_cn'}</b></td>\n";
print "<td><input name=commonName size=30></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ca_email'}</b></td>\n";
print "<td><input name=emailAddress size=30></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ca_ou'}</b></td>\n";
print "<td><input name=organizationalUnitName size=30></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ca_o'}</b></td>\n";
print "<td><input name=organizationName size=30></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ca_sp'}</b></td>\n";
print "<td><input name=stateOrProvinceName size=15></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ca_c'}</b></td>\n";
print "<td><input name=countryName size=2></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ssl_size'}</b></td>\n";
print "<td><input type=radio name=size_def value=1 checked> ",
      "$self->{'text_hash'}->{'default'} ($self->{'default_key_size'})\n";
print "<input type=radio name=size_def value=0> ",
      "$self->{'text_hash'}->{'ssl_custom'}\n";
print "<input name=size size=6> $self->{'text_hash'}->{'ssl_bits'}</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'ca_create'}'></form>\n";

print "<hr>\n";
print -r $self->{'miniserv_hash'}->{'ca'} ? $self->{'text_hash'}->{'ca_oldmsg1'} : $self->{'text_hash'}->{'ca_oldmsg2'},"<p>\n";
print "<form action=change_ca.cgi method=post enctype=multipart/form-data>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ca_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><textarea rows=20 cols=70 name=cert>";
if ($self->{'miniserv_hash'}->{'ca'}) {
	open(CA, $self->{'miniserv_hash'}->{'ca'});
	while(<CA>) { print; }
	close(CA);
	}
print "</textarea></td> </tr>\n";
print "</table><input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

if (-r $self->{'miniserv_hash'}->{'ca'}) {
	print "<hr>\n";
	print "<form action=stop_ca.cgi><table><tr>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'ca_stop'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'ca_stopmsg'}</td>\n";
	print "</tr></table></form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

