#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show an IP-specific SSL key

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ipkey_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ipkey_title2'}, "");
	@{$self->{'ipkeys_array'}} = $self->get_ipkeys(\%{$self->{'miniserv_hash'}});
	$self->{'ipkey'} = $self->{'ipkeys_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_ipkey.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'ipkey_header'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'ipkey_ips'},
		    $self->ui_textarea("ips", join("\n", @{$self->{'ipkey'}->{'ips'}}),
				 3, 20));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_key'},
		    $self->ui_textbox("key", $self->{'ipkey'}->{'key'}, 40)."\n".
		    $self->file_chooser_button("key"));

print $self->ui_table_row($self->{'text_hash'}->{'ssl_cert'},
		    $self->ui_opt_textbox("cert", $self->{'ipkey'}->{'cert'}, 40,
				$self->{'text_hash'}->{'ssl_cert_def'})."\n".
		    $self->file_chooser_button("cert"));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("edit_ssl.cgi", $self->{'text_hash'}->{'ssl_return'});

1;
		
}


1;

