#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ui.cgi
# Edit user interface options

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ui_title'}, "");

print $self->{'text_hash'}->{'ui_desc'},"<p>\n";

print $self->ui_form_start("change_ui.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'ui_header'}, undef, 2);

for($i=0; $i<@{$self->{'cs_names_array'}}; $i++) {
	$self->{'cd'} = $self->{'cs_codes_array'}->[$i];
	print $self->ui_table_row($self->{'cs_names_array'}->[$i],
		$self->ui_opt_textbox($self->{'cd'}, $self->{'gconfig_hash'}->{$self->{'cd'}}, 8, $self->{'text_hash'}->{'ui_default'},
				$self->{'text_hash'}->{'ui_rgb'}));
	}

print $self->ui_table_row($self->{'text_hash'}->{'ui_texttitles'},
	$self->ui_yesno_radio("texttitles", int($self->{'gconfig_hash'}->{'texttitles'})));

print $self->ui_table_row($self->{'text_hash'}->{'ui_sysinfo'},
	$self->ui_select("sysinfo", int($self->{'gconfig_hash'}->{'sysinfo'}),
		   [ map { [ $_, $self->{'text_hash'}->{'ui_sysinfo'.$_} ] } (0, 1, 4, 2, 3) ]));

print $self->ui_table_row($self->{'text_hash'}->{'ui_hostnamemode'},
	$self->ui_select("hostnamemode", int($self->{'gconfig_hash'}->{'hostnamemode'}),
		   [ map { [ $_, $self->{'text_hash'}->{'ui_hnm'.$_} ] } (0 .. 3) ]).
	" ".$self->ui_textbox("hostnamedisplay", $self->{'gconfig_hash'}->{'hostnamedisplay'}, 20));

print $self->ui_table_row($self->{'text_hash'}->{'ui_showlogin'},
	$self->ui_yesno_radio("showlogin", int($self->{'gconfig_hash'}->{'showlogin'})));

print $self->ui_table_row($self->{'text_hash'}->{'ui_feedback'},
	$self->ui_opt_textbox("feedback", $self->{'gconfig_hash'}->{'feedback_to'}, 20,
			$self->{'webmin_feedback_address'}));

print $self->ui_table_row($self->{'text_hash'}->{'ui_feedbackmode'},
	$self->ui_radio("nofeedbackcc", int($self->{'gconfig_hash'}->{'nofeedbackcc'}),
		  [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'ui_feednocc'} ],
		    [ 2, $self->{'text_hash'}->{'no'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'ui_width'},
	$self->ui_opt_textbox("width", $self->{'gconfig_hash'}->{'help_width'}, 5,
			"$self->{'text_hash'}->{'default'} (400)"));

print $self->ui_table_row($self->{'text_hash'}->{'ui_height'},
	$self->ui_opt_textbox("height", $self->{'gconfig_hash'}->{'help_height'}, 5,
			"$self->{'text_hash'}->{'default'} (400)"));

# Dialog box size options
print $self->ui_table_hr();

foreach $db ("file", "user", "users", "date", "module", "modules") {
	($self->{'w'}, $self->{'h'}) = split(/x/, $self->{'gconfig_hash'}->{'db_size'.$db});
	print $self->ui_table_row($self->{'text_hash'}->{'ui_size'.$db},
		$self->ui_radio("size".$db."_def", $self->{'w'} ? 0 : 1,
			[ [ 1, $self->{'text_hash'}->{'default'} ],
			  [ 0, $self->ui_textbox("size".$db."_w", $self->{'w'}, 4)." X ".
			       $self->ui_textbox("size".$db."_h", $self->{'h'}, 4) ] ]));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

