#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_upgrade.cgi
# Display a form for upgrading CP+

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();

# get current version
$self->{'cur_version'} = $self->get_webmin_version();

# find latest version at cpplus.psoft.net by looking at index page
$self->error_setup($self->{'text_hash'}->{'upgrade_error'});
$self->{'file'} = $self->tempname();
local $upg_info = $self->{'tconfig_hash'}->{'upgrade_info'} ? $self->{'tconfig_hash'}->{'upgrade_info'} : "/";
$self->http_download($self->{'update_host'}, $self->{'update_port'}, $upg_info, $self->{'file'}, \$self->{'error'});

open(FILE, $self->{'file'});
while(<FILE>){
	if (/cpplus-([0-9\.]+)\.tar\.gz/){
		$self->{'version'} = $1;
		last;
		}
	}
close(FILE);
unlink($self->{'file'});
$self->{'version'}=$self->{'error'} if ($self->{'error'});

# what kind of install was this?
if (open(MODE, "$self->{'root_directory'}/install-type")){
	chop($self->{'mode'} = <MODE>);
	close(MODE);
	}
else {
	$self->{'mode'} = undef;
	}

# was the install to a target directory?
if (open(DIR, "$self->{'config_directory'}/install-dir")){
	chop($self->{'dir'} = <DIR>);
	close(DIR);
	}

# print CP+ version informaition
$| = 1;
$self->{'theme_no_table'} = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'upgrade_title'}, "", undef, 0, 1);
print "<table width='100%' border cellspacing=5 cellpadding=5>\n";
print "<tr><td $self->{'tb'}><b>$self->{'text_hash'}->{'upgrade_verinfo'}</b></td></tr>\n";
print "<tr $self->{'cb'}><td><table border>\n";
print "<tr><td>$self->{'text_hash'}->{'upgrade_vercur'}</td><td>&nbsp;&nbsp;&nbsp;</td><td><b>$self->{'cur_version'}</b></td></tr>\n";
print "<tr><td>$self->{'text_hash'}->{'upgrade_verlast'}</td><td>&nbsp;&nbsp;&nbsp;</td><td><b>$self->{'version'}</b></td></tr>\n";
print "<tr><td colspan=3><br></td></tr>\n";
print "</td></tr></table></table>\n";

# print select form for upgrade
print "<form action=upgrade.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=mode value=\"$self->{'mode'}\">\n";
print "<input type=hidden name=dir value=\"$self->{'dir'}\">\n";
print "<input type=hidden name=version value=\"$self->{'version'}\">\n";
print "<table width='100%' border cellspacing=5 cellpadding=5>\n";
print "<tr><td $self->{'tb'}><b>".$self->{'text_hash'}->{'upgrade_title'}."</b></td></tr>\n";
print "<tr><td $self->{'cb'}>".$self->{'text_hash'}->{"upgrade_desc$self->{'mode'}"}."</td></tr>\n";

unless ($self->{'config_hash'}->{'deny_local_upgrade'}){
	#from http
	print "<tr $self->{'cb'}><td nowrap>\n";
	print "<input type=radio name=source value=2 checked> $self->{'text_hash'}->{'upgrade_ftp'}\n";

	# from file
	print "<tr $self->{'cb'}><td nowrap>\n";
	print "<input type=radio name=source value=0> $self->{'text_hash'}->{'upgrade_local'}\n";
	print "<input name=file size=40>\n";
	print $self->file_chooser_button("file", 0),"<br>\n";
	}
else{
	# only from http
	print "<input type=hidden name=source value=2>\n";
	}

# upgrade submit
print "<input type=submit value=\"$self->{'text_hash'}->{'upgrade_submit'}\">\n";
print "</td></tr></table>\n";
print "</form>\n";
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

