#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save, create or delete an IP-specific SSL key

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
@{$self->{'ipkeys_array'}} = $self->get_ipkeys(\%{$self->{'miniserv_hash'}});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'ipkey'} = $self->{'ipkeys_array'}->[$self->{'in_hash'}->{'idx'}];
	}
else {
	$self->{'ipkey'} = { };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just remove this entry
	splice(@{$self->{'ipkeys_array'}}, $self->{'in_hash'}->{'idx'}, 1);
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'ipkey_err'});
	@{$self->{'ips_array'}} = split(/\s+/, $self->{'in_hash'}->{'ips'});
	foreach $i (@{$self->{'ips_array'}}) {
		$self->check_ipaddress($i) ||
			$self->error($self->text('ipkey_eip', $i));
		}
	@{$self->{'ips_array'}} || $self->error($self->text('ipkey_eips'));
	$self->{'ipkey'}->{'ips'} = \@{$self->{'ips_array'}};
	$self->validate_key_cert($self->{'in_hash'}->{'key'}, $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'});
	$self->{'ipkey'}->{'key'} = $self->{'in_hash'}->{'key'};
	$self->{'ipkey'}->{'cert'} = $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'};

	# Save or add
	if ($self->{'in_hash'}->{'new'}) {
		push(@{$self->{'ipkeys_array'}}, $self->{'ipkey'});
		}
	}

$self->save_ipkeys(\%{$self->{'miniserv_hash'}}, \@{$self->{'ipkeys_array'}});
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->show_restart_page();

1;
		
}


1;

