#!/usr/bin/perl

&MAIN();

 sub MAIN {
# standard_chooser.cgi
# Display a list of standard modules for installation

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, );
$self->{'mods'} = $self->list_standard_modules();
if (!ref($self->{'mods'})) {
	print "<b>",$self->text('standard_failed', $self->{'mods'}),"</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'standard_header'}</b><br>\n";
	if ($self->{'mods'}->[0]->[1] > $self->get_webmin_version()) {
		print $self->text('standard_warn', $self->{'mods'}->[0]->[1]),"<br>\n";
		}
	print "<script>\n";
	print "function select(f)\n";
	print "{\n";
	print "opener.ifield.value = f;\n";
	print "close();\n";
	print "return false;\n";
	print "}\n";
	print "</script>\n";
	print "<table width=100%>\n";
	foreach $m (@{$self->{'mods'}}) {
		local $minfo = { 'os_support' => $m->[3] };
		next if (!$self->check_os_support($minfo));
		print "<tr>\n";
		print "<td><a href='' onClick='return select(\"$m->[0]\")'>$m->[0]</a></td>\n";
		print "<td>$m->[4]</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
$self->ui_print_footer();

1;
		
}


1;

