#!/usr/bin/perl

&MAIN();

 sub MAIN {
# stop_ca.cgi
# Remove all the CA files

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
delete($self->{'miniserv_hash'}->{'ca'});
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->{'acl'} = "$self->{'config_directory'}/acl";
$self->lock_file("$self->{'acl'}/ca.pem");
unlink("$self->{'acl'}/ca.pem");
$self->unlock_file("$self->{'acl'}/ca.pem");

$self->lock_file("$self->{'acl'}/index.txt");
unlink("$self->{'acl'}/index.txt");
$self->unlock_file("$self->{'acl'}/index.txt");

$self->lock_file("$self->{'acl'}/index.txt.old");
unlink("$self->{'acl'}/index.txt.old");
$self->unlock_file("$self->{'acl'}/index.txt.old");

$self->lock_file("$self->{'acl'}/openssl.cnf");
unlink("$self->{'acl'}/openssl.cnf");
$self->unlock_file("$self->{'acl'}/openssl.cnf");

$self->lock_file("$self->{'acl'}/serial");
unlink("$self->{'acl'}/serial");
$self->lock_file("$self->{'acl'}/serial");

$self->lock_file("$self->{'acl'}/serial.old");
unlink("$self->{'acl'}/serial.old");
$self->unlock_file("$self->{'acl'}/serial.old");
$self->system_logged("rm -rf $self->{'acl'}/newcerts");

$self->ui_print_header(undef, $self->{'text_hash'}->{'ca_title'}, "");
print "<p>$self->{'text_hash'}->{'ca_stopok'}<p>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->restart_miniserv(1);
$self->webmin_log("stopca", undef, undef);

1;
		
}


1;

