#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display logging search form

&ModuleLoader::preload_module('cppluslog_class', "cppluslog::CppluslogLib");
$self = new cppluslog::CppluslogLib:: 'cppluslog_class',%$self;

$self->foreign_require("acl", "acl-lib.pl");
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

if (!$self->{'gconfig_hash'}->{'log'}) {
	print $self->text('index_nolog', '/cpplus/edit_log.cgi'),"<p>\n";
	}
elsif (!$self->{'gconfig_hash'}->{'logfiles'}) {
	print $self->text('index_nologfiles', '/cpplus/edit_log.cgi'),"<p>\n";
	}

print "<form action=search.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>\n";

@{$self->{'ulist_array'}} = sort { $a->{'name'} cmp $b->{'name'} } $main::acl_object->list_users();
@{$self->{'canulist_array'}} = grep { $self->can_user($_->{'name'}) } @{$self->{'ulist_array'}};
if (@{$self->{'canulist_array'}} == 1) {
	# Can only show one user, so skip this field
	print $self->ui_hidden("uall", 0),"\n";
	print $self->ui_hidden("user", $self->{'canulist_array'}->[0]->{'name'}),"\n";
	}
else {
	# Show user selectors
	print $self->ui_radio("uall", 1, [ [ 1, $self->{'text_hash'}->{'index_uall'}."<br>" ],
				     [ 0, $self->{'text_hash'}->{'index_user'} ] ]),"\n";
	print "<select name=user>\n";
	foreach $u (@{$self->{'ulist_array'}}) {
		next if (!$self->can_user($u->{'name'}));
		print "<option>$u->{'name'}\n";
		}
	print "</select><br>\n";
	if ($self->{'access_users_hash'}->{'*'}) {
		print "<input name=uall type=radio value=2> $self->{'text_hash'}->{'index_nuser'}\n";
		print "<select name=nuser>\n";
		foreach $u (@{$self->{'ulist_array'}}) {
			print "<option>$u->{'name'}\n";
			}
		print "</select>\n";
		}
	print "<p>\n";
	}

print "<input name=mall type=radio value=1 checked> $self->{'text_hash'}->{'index_mall'}<br>\n";
print "<input name=mall type=radio value=0> $self->{'text_hash'}->{'index_module'}\n";
print "<select name=module>\n";
foreach $m (sort { $a->{'desc'} cmp $b->{'desc'} } $self->get_all_module_infos()) {
	next if (!$self->can_mod($m->{'dir'}));
	$self->{'mdir'} = $self->module_root_directory($m->{'dir'});
	print "<option value=$m->{'dir'}>$m->{'desc'}\n"
		if (-r "$self->{'mdir'}/log_parser.pl" &&
		    $self->check_os_support($m));
	}
print "</select><p>\n";

print "<input name=tall type=radio value=1> $self->{'text_hash'}->{'index_tall'}<br>\n";
print "<input name=tall type=radio value=2 checked> $self->{'text_hash'}->{'index_today'}<br>\n";
print "<input name=tall type=radio value=3> $self->{'text_hash'}->{'index_yesterday'}<br>\n";
print "<input name=tall type=radio value=0>\n";
print $self->text('index_time', &time_input('from'), &time_input('to')),"<p>\n";

if ($self->{'gconfig_hash'}->{'logfiles'}) {
	print "<input name=fall type=radio value=1 checked> $self->{'text_hash'}->{'index_fall'}<br>\n";
	print "<input name=fall type=radio value=0> $self->{'text_hash'}->{'index_file'}\n";
	print "<input name=file size=30><p>\n";
	}

if ($self->{'config_hash'}->{'host_search'}) {
	print "<input name=wall type=radio value=1 checked> $self->{'text_hash'}->{'index_wall'}<br>\n";
	print "<input name=wall type=radio value=0> $self->{'text_hash'}->{'index_whost'}\n";
	print "<input name=webmin size=30><p>\n";
	}

print "<div align=right>\n";
print "<input type=submit value='$self->{'text_hash'}->{'index_search'}'></div>\n";
print "</td> </tr></table>\n";
print "</form>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub time_input
{
	shift if ($self == $_[0]);

local $rv = "<input name=$_[0]_d size=2>/";
$rv .= "<select name=$_[0]_m>";
for($i=0; $i<12; $i++) {
	$rv .= "<option value=$i>".$self->{'text_hash'}->{"smonth_".($i+1)}."\n";
	}
$rv .= "</select>/<input name=$_[0]_y size=4>";
$rv .= " ".$self->date_chooser_button("$_[0]_d", "$_[0]_m", "$_[0]_y");
return $rv;
}


1;

