#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_env.cgi
# Edit an existing or new environment variable

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->ReadParse();

if (!$self->{'in_hash'}->{'new'}) {
	@{$self->{'jobs_array'}} = $self->list_cron_jobs();
	$self->{'env'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'env'}->{'user'}) ||
		$self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'env_title1'},"", undef, undef, 1);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'env_title2'},"", undef, undef, 1);
	$self->{'env'} = { 'active' => 1 };
	}

print "$self->{'text_hash'}->{'env_order'}<p>\n";

print "<form action=save_env.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'env_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'env_user'}</b></td>\n";
if ($self->{'access_hash'}->{'mode'} == 1) {
	print "<td><select name=user>\n";
	foreach $u (split(/\s+/, $self->{'access_hash'}->{'users'})) {
		printf "<option %s>$u\n",
			$self->{'env'}->{'user'} eq $u ? "selected" : "";
		}
	print "</select></td>\n";
	}
elsif ($self->{'access_hash'}->{'mode'} == 3) {
	print "<td><tt>$self->{'remote_user'}</tt></td>\n";
	print "<input type=hidden name=user value='$self->{'remote_user'}'>\n";
	}
else {
	print "<td><input name=user size=8 value=\"$self->{'env'}->{'user'}\"> ",
		$self->user_chooser_button("user", 0),"</td>\n";
	}

print "<td> <b>$self->{'text_hash'}->{'env_active'}</b></td>\n";
printf "<td><input type=radio name=active value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'env'}->{'active'} ? "checked" : "";
printf "<input type=radio name=active value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'env'}->{'active'} ? "" : "checked";

print "<td> <b>$self->{'text_hash'}->{'env_name'}</b></td>\n";
printf "<td><input name=name size=30 value='%s'></td> </tr>\n",
	$self->{'env'}->{'name'};

print "<td> <b>$self->{'text_hash'}->{'env_value'}</b></td>\n";
printf "<td><input name=value size=60 value='%s'></td> </tr>\n",
	$self->{'env'}->{'value'};

if ($self->{'in_hash'}->{'new'}) {
	# Location for new variable
	print "<td> <b>$self->{'text_hash'}->{'env_where'}</b></td> <td colspan=3>\n";
	print $self->ui_radio("where", 1, [ [ 1, $self->{'text_hash'}->{'env_top'} ],
				      [ 0, $self->{'text_hash'}->{'env_bot'} ] ]),"</td></tr>\n";
	}
elsif ($self->{'env'}->{'index'}) {
	# Location for existing
	print "<td> <b>$self->{'text_hash'}->{'env_where2'}</b></td> <td colspan=3>\n";
	print $self->ui_radio("where", 0, [ [ 1, $self->{'text_hash'}->{'env_top'} ],
				      [ 0, $self->{'text_hash'}->{'env_leave'} ]]),"</td></tr>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'env_add'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'env_edit'}'></td>\n";
	print "</form><form action=delete_env.cgi>\n";
	print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
	print "<td align=right><input type=submit name=delete ",
              "value='$self->{'text_hash'}->{'env_del'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

