#!/usr/bin/perl
package custom::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'custom::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "custom::CustomLib");
$self = new custom::CustomLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

# Configures End User commands module
local %euconfig = ();
local $euconfig_name = "$self->{'config_directory'}/enduser_cp/commands/config";
if (-r $euconfig_name) {
	$self->read_file($euconfig_name, \%euconfig);
	$self->lock_file($euconfig_name);
	$euconfig{'webmin_config'} = $self->{'module_config_directory'};
	$self->write_file($euconfig_name, \%euconfig);
	$self->unlock_file($euconfig_name);
	}
}


1;

