#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_file.cgi
# Display a file editor and its options

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'file_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fcreate_title'}, "", "fcreate");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fedit_title'}, "", "fedit");
	@{$self->{'cmds_array'}} = $self->list_commands();
	$self->{'edit'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_file.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'file_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if (!$self->{'in_hash'}->{'new'}) {
	print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'file_id'}, "fileid"),
	      "</b></td>\n";
	print "<td><tt>$self->{'edit'}->{'id'}</tt></td> </tr>\n";
	}

print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'file_desc'}, "fdesc"),
      "</b></td>\n";
print "<td><input name=desc size=50 value='",
	$self->html_escape($self->{'edit'}->{'desc'}),"'><br>\n";
print "<textarea name=html rows=2 cols=50>",$self->{'edit'}->{'html'},
      "</textarea></td> </tr>\n";

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'file_edit'}, "file"),"</b></td>\n";
print "<td><input name=edit size=50 value='$self->{'edit'}->{'edit'}'> ",
      $self->file_chooser_button("edit", 0),"</td> </tr>\n";

print "<tr> <td></td>\n";
printf "<td><input type=checkbox name=envs value=1 %s> %s</td> </tr>\n",
	$self->{'edit'}->{'envs'} ? "checked" : "", $self->{'text_hash'}->{'file_envs'};

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'file_owner'}, "owner"),"</b></td>\n";
printf "<td><input type=radio name=owner_def value=1 %s> %s\n",
	$self->{'edit'}->{'user'} ? '' : 'checked', $self->{'text_hash'}->{'file_leave'};
printf "<input type=radio name=owner_def value=0 %s> %s\n",
	$self->{'edit'}->{'user'} ? 'checked' : '', $self->{'text_hash'}->{'file_user'};
printf "<input name=user size=8 value='%s'> %s\n",
	$self->{'edit'}->{'user'}, $self->{'text_hash'}->{'file_group'};
printf "<input name=group size=8 value='%s'></td> </tr>\n",
	$self->{'edit'}->{'group'};

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'file_perms'}, "perms"),"</b></td>\n";
printf "<td><input type=radio name=perms_def value=1 %s> %s\n",
	$self->{'edit'}->{'perms'} ? '' : 'checked', $self->{'text_hash'}->{'file_leave'};
printf "<input type=radio name=perms_def value=0 %s> %s\n",
	$self->{'edit'}->{'perms'} ? 'checked' : '', $self->{'text_hash'}->{'file_set'};
printf "<input name=perms size=3 value='%s'></td> </tr>\n",
	$self->{'edit'}->{'perms'};

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'file_before'}, "before"),"</b></td>\n";
print "<td><input name=before size=60 value='",
	$self->html_escape($self->{'edit'}->{'before'}),"'></td> </tr>\n";

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'file_after'}, "after"),"</b></td>\n";
print "<td><input name=after size=60 value='",
	$self->html_escape($self->{'edit'}->{'after'}),"'></td> </tr>\n";

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_order'}, "order"),"</b></td>\n";
printf "<td><input type=radio name=order_def value=1 %s> %s\n",
	$self->{'edit'}->{'order'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=order_def value=0 %s>\n",
	$self->{'edit'}->{'order'} ? "checked" : "";
printf "<input name=order size=6 value='%s'></td> </tr>\n",
	$self->{'edit'}->{'order'} ? $self->{'edit'}->{'order'} : '';

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_usermin'},"usermin"),"</b></td>\n";
printf "<td><input type=radio name=usermin value=1 %s> %s\n",
	$self->{'edit'}->{'usermin'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=usermin value=0 %s> %s</td> </tr>\n",
	$self->{'edit'}->{'usermin'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "</table></td></tr></table><p>\n";

$self->show_params_inputs($self->{'edit'}, 1, 1);

print "<table width=100%><tr>\n";
print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<td align=right><input type=submit name=delete ",
	      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

