#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save.cgi
# Save an edited file

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParseMime();
@{$self->{'cmds_array'}} = $self->list_commands();
$self->{'edit'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
$self->error_setup($self->{'text_hash'}->{'view_err'});
$self->{'edit'}->{'edit'} && $self->can_run_command($self->{'edit'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Run the before-command
if ($self->{'edit'}->{'before'}) {
	$self->system_logged("$self->{'edit'}->{'before'} >/dev/null 2>&1 </dev/null");
	}

# Work out proper filename
$self->{'file'} = $self->{'edit'}->{'edit'};
if ($self->{'file'} !~ /^\//) {
	# File is relative to user's home directory
	@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/$self->{'file'}" if (@{$self->{'uinfo_array'}});
	}

# Set environment variables for parameters
($self->{'env'}, $self->{'export'}, $self->{'str'}, $self->{'displayfile'}) = $self->set_parameter_envs($self->{'edit'}, $self->{'file'});

if ($self->{'edit'}->{'envs'} || @{$self->{'edit'}->{'args'}}) {
	# Do environment variable substitution
	chop($self->{'file'} = `echo "$self->{'file'}"`);
	}

# Save the file
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'file'}", 1) ||
	$self->error($self->text('view_efile', $self->{'file'}, $!));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);

# Set permissions
if ($self->{'edit'}->{'user'}) {
	$self->system_logged("chown $self->{'edit'}->{'user'}:$self->{'edit'}->{'group'} ".
		       "$self->{'file'} >/dev/null 2>&1");
	}
if ($self->{'edit'}->{'perms'}) {
	$self->system_logged("chmod $self->{'edit'}->{'perms'} ".
		       "$self->{'file'} >/dev/null 2>&1");
	}

# Run the after-command
if ($self->{'edit'}->{'after'}) {
	$self->system_logged("$self->{'edit'}->{'after'} >/dev/null 2>&1 </dev/null");
	}

$self->webmin_log("save", "edit", $self->{'cmd'}->{'id'}, $self->{'edit'});
$self->redirect("");

1;
		
}


1;

