#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cmd.cgi
# Save, create or delete a custom command

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'save_ecannot'});
@{$self->{'cmds_array'}} = $self->list_commands();
if ($self->{'in_hash'}->{'delete'}) {
	$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_command($self->{'cmd'});
	$self->webmin_log("delete", "command", $self->{'cmd'}->{'id'}, $self->{'cmd'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	if (!$self->{'in_hash'}->{'new'}) {
		$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
		}
	else {
		$self->{'cmd'} = { 'id' => time() };
		}

	# parse and validate inputs
	$self->{'in_hash'}->{'cmd'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_ecmd'});
	if ($self->{'in_hash'}->{'dir_def'}) {
		$self->{'cmd'}->{'cmd'} = $self->{'in_hash'}->{'cmd'};
		}
	else {
		$self->{'in_hash'}->{'dir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'save_edir'});
		$self->{'cmd'}->{'cmd'} = "cd $self->{'in_hash'}->{'dir'} ; $self->{'in_hash'}->{'cmd'}";
		}
	$self->{'in_hash'}->{'order_def'} || $self->{'in_hash'}->{'order'} =~ /^\-?(\d+)$/ ||
		$self->error($self->{'text_hash'}->{'save_eorder'});
	$self->{'in_hash'}->{'timeout_def'} || $self->{'in_hash'}->{'timeout'} =~ /^(\d+)$/ ||
		$self->error($self->{'text_hash'}->{'save_etimeout'});
	$self->{'cmd'}->{'desc'} = $self->{'in_hash'}->{'desc'};
	$self->{'in_hash'}->{'html'} =~ s/\r//g;
	$self->{'in_hash'}->{'html'} =~ s/\n*/\n/;
	$self->{'cmd'}->{'html'} = $self->{'in_hash'}->{'html'};
	if ($self->supports_users()) {
		$self->{'in_hash'}->{'user_def'} || (@{$self->{'u_array'}} = getpwnam($self->{'in_hash'}->{'user'})) ||
			$self->error($self->{'text_hash'}->{'save_euser'});
		$self->{'cmd'}->{'user'} = $self->{'in_hash'}->{'user_def'} ? "*" : $self->{'in_hash'}->{'user'};
		$self->{'cmd'}->{'su'} = $self->{'in_hash'}->{'su'};
		}
	else {
		$self->{'cmd'}->{'user'} = 'root';
		}
	$self->{'cmd'}->{'raw'} = $self->{'in_hash'}->{'raw'};
	$self->{'cmd'}->{'order'} = $self->{'in_hash'}->{'order_def'} ? 0 : int($self->{'in_hash'}->{'order'});
	$self->{'cmd'}->{'timeout'} = $self->{'in_hash'}->{'timeout_def'} ? 0 : int($self->{'in_hash'}->{'timeout'});
	$self->{'cmd'}->{'clear'} = $self->{'in_hash'}->{'clear'};
	$self->{'cmd'}->{'noshow'} = $self->{'in_hash'}->{'noshow'};
	$self->{'cmd'}->{'usermin'} = $self->{'in_hash'}->{'usermin'};
	@{$self->{'hosts_array'}} = split(/\0/, $self->{'in_hash'}->{'hosts'});
	if (!@{$self->{'hosts_array'}} || (@{$self->{'hosts_array'}} == 1 && $self->{'hosts_array'}->[0] eq "0")) {
		delete($self->{'cmd'}->{'hosts'});
		}
	else {
		$self->{'cmd'}->{'usermin'} && $self->error($self->{'text_hash'}->{'save_eusermin'});
		$self->{'cmd'}->{'hosts'} = \@{$self->{'hosts_array'}};
		}
	$self->parse_params_inputs($self->{'cmd'});
	$self->save_command($self->{'cmd'});
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "command",
		    $self->{'cmd'}->{'id'}, $self->{'cmd'});

	if ($self->{'in_hash'}->{'new'} && $self->{'access_hash'}->{'cmds'} ne '*') {
		$self->{'access_hash'}->{'cmds'} .= " ".$self->{'cmd'}->{'id'};
		$self->save_module_acl(\%{$self->{'access_hash'}});
		}
	}
$self->redirect("");

1;
		
}


1;

