#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_file.cgi
# Save, create or delete a file editor

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'file_ecannot'});
@{$self->{'cmds_array'}} = $self->list_commands();
if ($self->{'in_hash'}->{'delete'}) {
	$self->{'edit'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_command($self->{'edit'});
	$self->webmin_log("delete", "edit", $self->{'edit'}->{'id'}, $self->{'edit'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'file_err'});
	if (!$self->{'in_hash'}->{'new'}) {
		$self->{'edit'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
		}
	else {
		$self->{'edit'} = { 'id' => time() };
		}

	# parse and validate inputs
	$self->{'in_hash'}->{'edit'} =~ /\S/ || $self->error($self->{'text_hash'}->{'file_eedit'});
	$self->{'edit'}->{'edit'} = $self->{'in_hash'}->{'edit'};
	$self->{'in_hash'}->{'desc'} =~ /\S/ || $self->error($self->{'text_hash'}->{'file_edesc'});
	$self->{'edit'}->{'desc'} = $self->{'in_hash'}->{'desc'};
	$self->{'in_hash'}->{'html'} =~ s/\r//g;
	$self->{'in_hash'}->{'html'} =~ s/\n*/\n/;
	$self->{'cmd'}->{'html'} = $self->{'in_hash'}->{'html'};
	if ($self->{'in_hash'}->{'owner_def'}) {
		$self->{'edit'}->{'user'} = $self->{'edit'}->{'group'} = undef;
		}
	else {
		(@{$self->{'u_array'}} = getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'file_euser'});
		(@{$self->{'g_array'}} = getgrnam($self->{'in_hash'}->{'group'})) || $self->error($self->{'text_hash'}->{'file_egroup'});
		$self->{'edit'}->{'user'} = $self->{'in_hash'}->{'user'};
		$self->{'edit'}->{'group'} = $self->{'in_hash'}->{'group'};
		}
	if ($self->{'in_hash'}->{'perms_def'}) {
		$self->{'edit'}->{'perms'} = undef;
		}
	else {
		$self->{'in_hash'}->{'perms'} =~ /^[0-7]{3}$/ || $self->error($self->{'text_hash'}->{'file_eperms'});
		$self->{'edit'}->{'perms'} = $self->{'in_hash'}->{'perms'};
		}
	$self->{'edit'}->{'before'} = $self->{'in_hash'}->{'before'};
	$self->{'edit'}->{'after'} = $self->{'in_hash'}->{'after'};
	$self->{'edit'}->{'order'} = $self->{'in_hash'}->{'order_def'} ? 0 : int($self->{'in_hash'}->{'order'});
	$self->{'edit'}->{'usermin'} = $self->{'in_hash'}->{'usermin'};
	$self->{'edit'}->{'envs'} = $self->{'in_hash'}->{'envs'};
	$self->parse_params_inputs($self->{'edit'});
	$self->save_command($self->{'edit'});
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "edit",
		    $self->{'cmd'}->{'id'}, $self->{'cmd'});

	if ($self->{'in_hash'}->{'new'} && $self->{'access_hash'}->{'cmds'} ne '*') {
		$self->{'access_hash'}->{'cmds'} .= " ".$self->{'edit'}->{'id'};
		$self->save_module_acl(\%{$self->{'access_hash'}});
		}
	}
$self->redirect("");

1;
		
}


1;

