#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view.cgi
# Display a file for editing

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();
@{$self->{'cmds_array'}} = $self->list_commands();
$self->{'edit'} = $self->{'cmds_array'}->[$in{'idx'}];
$self->{'edit'}->{'edit'} && $self->can_run_command($self->{'edit'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

# Work out proper filename
$self->{'file'} = $self->{'edit'}->{'edit'};
if ($self->{'file'} !~ /^\//) {
	# File is relative to user's home directory
	@{$self->{'uinfo_array'}} = getpwnam($self->{'remote_user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/$self->{'file'}" if (@{$self->{'uinfo_array'}});
	}

# Set environment variables for parameters
($self->{'env'}, $self->{'export'}, $self->{'str'}, $self->{'displayfile'}) = $self->set_parameter_envs($self->{'edit'}, $self->{'file'});

if ($self->{'edit'}->{'envs'} || @{$self->{'edit'}->{'args'}}) {
	# Do environment variable substitution
	chop($self->{'file'} = `echo "$self->{'file'}"`);
	}

# Show the editor window
$self->ui_print_header($self->{'displayfile'}, $self->{'text_hash'}->{'view_title'}, "");

$self->{'w'} = $self->{'config_hash'}->{'width'} || 80;
$self->{'h'} = $self->{'config_hash'}->{'height'} || 20;
$self->{'wrap'} = $self->{'config_hash'}->{'wrap'} ? "wrap=$self->{'config_hash'}->{'wrap'}" : "";
print "<form action=save.cgi method=post enctype=multipart/form-data>\n";
foreach my $i (keys %in) {
	print $self->ui_hidden($i, $in{$i}),"\n";
	}
print "<textarea rows=$self->{'h'} cols=$self->{'w'} $self->{'wrap'} name=data>";

open(FILE, $self->{'file'});
while(<FILE>) { print $self->html_escape($_); }
close(FILE);
print "</textarea><br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

