#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi

&ModuleLoader::preload_module('cyrus_sasl_class', "cyrus_sasl::CyrussaslLib");
$self = new cyrus_sasl::CyrussaslLib:: 'cyrus_sasl_class',%$self;


################################# BEGIN ###############################
local ($status, $string, $button, $must_edit);
local ( @wlinks, @wtitles, @wicons, @version);

$self->ReadParse();

# Start or stop daemon saslauthd
if ($self->{'in_hash'}->{'sysreq'} == 1 ) {
    $self->manage_sasld(1); 
    unless( $self->status_sasld()) { $must_edit = 1;}
    }
elsif (defined($self->{'in_hash'}->{'sysreq'}) && $self->{'in_hash'}->{'sysreq'} == 0 ){ $self->manage_sasld(0); }

# Get version number & auth method
@version = $self->get_version_sasld();
if( @version) {
 $version[0] =~ s/saslauthd//;
 $version[1] =~ /.*:(.*)$/; 
    }

# Print header
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, "intro",
$self->{'module_info_hash'}->{'usermin'} ? 0 : 1, 1,undef, 
$self->help_search_link("cyrus sasl", "man", "doc"), undef, undef, 
$version[0] ? $self->text('index_version',"$version[0] with<br>$version[1]") : 0);

# Make sure Cyrus-sasl is installed
if ( ! $self->has_command($self->{'config_hash'}->{'saslauthd_cmd'})) {
    print $self->ui_config_link('error_notconf', 
	[ "<tt>$self->{'config_hash'}->{$self->{'module_name'}}</tt>", undef]) . "<br>";
    $self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
    exit;
    }    

@wlinks = ( "daemon.cgi",
        "settings.cgi?conf=sendmail",
        "settings.cgi?conf=mta"
         );
@wtitles = ( $self->{'text_hash'}->{'index_daemon'},
          $self->{'text_hash'}->{'index_sendmail'},
          $self->{'text_hash'}->{'index_mta'}
         );
@wicons = ( "images/saslauthd.gif",
         "images/sendmail.gif",
         "images/mta.gif"
	);																											 

$self->icons_table(\@wlinks, \@wtitles, \@wicons, 3);

# Print start or stop submit daemon saslauthd
if( $self->status_sasld()) { 
    $status = 0; $string = $self->{'text_hash'}->{'index_stopmsg'};
    $button = $self->{'text_hash'}->{'index_stop'};
    }
else { $status = 1; $string = $self->{'text_hash'}->{'index_startmsg'};
    $button = $self->{'text_hash'}->{'index_start'};
    }
print "<br>". $self->ui_form_start($self->get_script_name(),"GET");
print $self->ui_hidden("sysreq", $status);
if( $must_edit) { print "$self->{'text_hash'}->{'process_erestart'}<br>";} 
print $self->ui_submit($button) . "&nbsp;$string" . $self->ui_form_end();
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

################################# END ####################################

1;
		
}


1;

