#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_share.cgi
# Display a form for editing a shared directory

&ModuleLoader::preload_module('dfsadmin_class', "dfsadmin::DfsLib");
$self = new dfsadmin::DfsLib:: 'dfsadmin_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->{'s'} = $ARGV[0];

if (defined($self->{'s'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "", "edit_share");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "", "create_share");
	}

print $self->ui_form_start("save_share.cgi", "post");
if (defined($self->{'s'})) {
	print $self->ui_hidden("idx", $self->{'s'}),"\n";
	@{$self->{'shlist_array'}} = $self->list_shares();
	$self->{'share'} = $self->{'shlist_array'}->[$self->{'s'}];
	}

# Directory and description section
print $self->ui_table_start($self->{'text_hash'}->{'edit_header1'}, "width=100%", 2);

print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_dir'}, "dir"),
		    $self->ui_textbox("directory", $self->{'share'}->{'dir'}, 60)." ".
		    $self->file_chooser_button("directory", 1));

print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_desc'}, "desc"),
		    $self->ui_textbox("desc", $self->{'share'}->{'desc'}, 60));

print $self->ui_table_end(),"<p>\n";

print "<table width=100% border>\n";
$self->parse_options($self->{'share'}->{'opts'});
print "<tr $self->{'tb'}>\n";
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_ro'}</b>","ro"),"</td>\n";
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_rw'}</b>","rw"),"</td>\n";
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'edit_root'}</b>","root"),"</td> </tr>\n";

# $fn = "<font size=-2>"; $efn = "</font>";
print "<tr $self->{'cb'}>\n";
print "<td valign=top>",
      $self->ui_radio("readonly", !defined($self->{'options_hash'}->{"ro"}) ? 0 :
			    $self->{'options_hash'}->{"ro"} ? 2 : 1,
		[ [ 0, $self->{'text_hash'}->{'edit_none'}."<br>" ],
		  [ 1, $self->{'text_hash'}->{'edit_all'}."<br>" ],
		  [ 2, $self->{'text_hash'}->{'edit_listed'}."<br>" ] ])."\n".
      $self->ui_textarea("rolist", join("\n", split(/:/, $self->{'options_hash'}->{"ro"})), 8, 25),
      "</td>\n";

print "<td valign=top>",
      $self->ui_radio("readwrite", !defined($self->{'options_hash'}->{"rw"}) ? 0 :
			    $self->{'options_hash'}->{"rw"} ? 2 : 1,
		[ [ 0, $self->{'text_hash'}->{'edit_none'}."<br>" ],
		  [ 1, $self->{'text_hash'}->{'edit_all'}."<br>" ],
		  [ 2, $self->{'text_hash'}->{'edit_listed'}."<br>" ] ])."\n".
      $self->ui_textarea("rwlist", join("\n", split(/:/, $self->{'options_hash'}->{"rw"})), 8, 25),
      "</td>\n";

print "<td valign=top>",
      $self->ui_radio("root", !defined($self->{'options_hash'}->{"root"}) ? 0 :
			$self->{'options_hash'}->{"root"} ? 2 : 1,
		[ [ 0, $self->{'text_hash'}->{'edit_none'}."<br>&nbsp;<br>" ],
		  [ 2, $self->{'text_hash'}->{'edit_listed'}."<br>" ] ])."\n".
      $self->ui_textarea("rtlist", join("\n", split(/:/, $self->{'options_hash'}->{"root"})), 8, 25),
      "</td>\n";
print "</tr></table><p>\n";

if (!$self->{'access_hash'}->{'simple'}) {
	print $self->ui_table_start($self->{'text_hash'}->{'edit_header2'}, "width=100%", 4);

	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_nosub'}, "sub"),
		    $self->ui_radio("nosub", defined($self->{'options_hash'}->{"nosub"}) ? 1 : 0,
			      [ [ 0, $self->{'text_hash'}->{'yes'} ],
				[ 1, $self->{'text_hash'}->{'no'} ] ]));

	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_nosuid'}, "suid"),
		    $self->ui_radio("nosuid", defined($self->{'options_hash'}->{"nosuid"}) ? 1 : 0,
			      [ [ 0, $self->{'text_hash'}->{'yes'} ],
				[ 1, $self->{'text_hash'}->{'no'} ] ]));

	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_des'}, "des"),
		    $self->ui_radio("secure", defined($self->{'options_hash'}->{"secure"}) ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_kerberos'}, "kerberos"),
		    $self->ui_radio("kerberos", defined($self->{'options_hash'}->{"kerberos"}) ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

	$self->{'user'} = defined($self->{'options_hash'}->{"anon"}) && $self->{'options_hash'}->{"anon"} != -1 ?
			getpwuid($self->{'options_hash'}->{'anon'}) : undef;
	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_anon'}, "anon"),
		    $self->ui_radio("anon_m", !defined($self->{'options_hash'}->{"anon"}) ? 0 :
					$self->{'options_hash'}->{"anon"} == -1 ? 1 : 2,
			      [ [ 0, $self->{'text_hash'}->{'edit_anon0'} ],
				[ 1, $self->{'text_hash'}->{'edit_anon1'} ],
				[ 2, $self->ui_user_textbox("anon", $self->{'user'}) ] ]));

	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_aclok'}, "aclok"),
		    $self->ui_radio("aclok", defined($self->{'options_hash'}->{"aclok"}) ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

	if ($self->{'gconfig_hash'}->{'os_version'} >= 7) {
		print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_public'}, "public"),
		    $self->ui_radio("public", defined($self->{'options_hash'}->{"public"}) ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ],
				[ 0, $self->{'text_hash'}->{'no'} ] ]));

		print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'edit_index'}, "index"),
		    $self->ui_opt_textbox("index", $self->{'options_hash'}->{"index"}, 15,
				    $self->{'text_hash'}->{'edit_none'}));
		}

	print $self->ui_table_end();
	}

if ($self->{'s'} ne "") {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

