#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi

&ModuleLoader::preload_module('dfsadmin_class', "dfsadmin::DfsLib");
$self = new dfsadmin::DfsLib:: 'dfsadmin_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link("dfstab share", "man"));

@{$self->{'shlist_array'}} = $self->list_shares();
if (@{$self->{'shlist_array'}} && $self->{'access_hash'}->{'icons'}) {
	# Display shares as icons
	print "<a href=\"edit_share.cgi\">$self->{'text_hash'}->{'index_add'}</a><br>\n";
	foreach $s (@{$self->{'shlist_array'}}) {
		next if ($s->{'type'} ne 'nfs');
		push(@{$self->{'icons_array'}}, "images/share.gif");
		push(@{$self->{'titles_array'}}, $s->{'dir'});
		push(@{$self->{'links_array'}}, "edit_share.cgi?$s->{'index'}");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
	if (!$self->{'access_hash'}->{'view'}) {
		print "<a href=\"edit_share.cgi\">$self->{'text_hash'}->{'index_add'}</a><br>\n";
		}
	}
elsif (@{$self->{'shlist_array'}}) {
	# Display shares as table
	if (!$self->{'access_hash'}->{'view'}) {
		print $self->ui_form_start("delete_shares.cgi", "post");
		print $self->select_all_link("d"),"\n";
		print $self->select_invert_link("d"),"\n";
		print "<a href=\"edit_share.cgi\">$self->{'text_hash'}->{'index_add'}</a><br>\n";
		@{$self->{'tds_array'}} = ( "width=5" );
		}
	print $self->ui_columns_start([
		$self->{'access_hash'}->{'view'} ? ( ) : ( "" ),
		$self->{'text_hash'}->{'index_dir'},
		$self->{'text_hash'}->{'index_clients'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $s (@{$self->{'shlist_array'}}) {
		next if ($s->{'type'} ne 'nfs');
		$self->parse_options($s->{'opts'});
		local @cols;
		if ($self->{'access_hash'}->{'view'}) {
			push(@cols, $self->html_escape($s->{'dir'}));
			}
		elsif (defined($self->{'options_hash'}->{'public'})) {
			push(@cols, "<a href=\"edit_share.cgi?$s->{'index'}\">".
				    $self->html_escape($s->{'dir'})."</a>");
			}
		else {
			push(@cols, "<a href=\"edit_share.cgi?$s->{'index'}\">".				    $self->html_escape($s->{'dir'})."</a>");
			}
		undef(%{$self->{'clients_hash'}});
		foreach (split(/:/, $self->{'options_hash'}->{"ro"})) { $self->{'clients_hash'}->{$_}++; }
		foreach (split(/:/, $self->{'options_hash'}->{"rw"})) { $self->{'clients_hash'}->{$_}++; }
		foreach (split(/:/, $self->{'options_hash'}->{"root"})) { $self->{'clients_hash'}->{$_}++; }
		if (%{$self->{'clients_hash'}}) {
			$self->{'clients'} = join(' &nbsp;|&nbsp; ' , sort { $a cmp $b }
			    map { $self->html_escape($_ =~ /^\@(.*)/ ? "$1.*" : $_) }
				     (keys %{$self->{'clients_hash'}}) );
			if (length($self->{'clients'}) > 80) {
				$self->{'clients'} = substr($self->{'clients'}, 0, 80)."...";
				}
			}
		else {
			$self->{'clients'} = $self->{'text_hash'}->{'index_everyone'};
			}
		push(@cols, $self->{'clients'});
		if ($self->{'access_hash'}->{'view'}) {
			print $self->ui_columns_row(\@cols, \@{$self->{'tds_array'}});
			}
		else {
			print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",
						      $s->{'index'});
			}
		}
	print $self->ui_columns_end();
	if (!$self->{'access_hash'}->{'view'}) {
		print $self->select_all_link("d"),"\n";
		print $self->select_invert_link("d"),"\n";
		print "<a href=\"edit_share.cgi\">$self->{'text_hash'}->{'index_add'}</a><br>\n";
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print "<a href=\"edit_share.cgi\">$self->{'text_hash'}->{'index_add'}</a><p>\n";
	}

if (!$self->{'access_hash'}->{'view'}) {
	print "<hr>\n";
	print $self->ui_buttons_start();
	print $self->ui_buttons_row("restart_sharing.cgi",
			      $self->{'text_hash'}->{'index_apply'},
			      $self->{'text_hash'}->{'index_applydesc'});
	print $self->ui_buttons_end();
	}

$self->ui_print_footer("/", "index");

1;
		
}


1;

