#!/usr/bin/perl

&MAIN();

 sub MAIN {
# download.cgi
# download and install blacklist for DansGuardian

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParseMime();

# print header
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{"index_blacklist"}, undef, undef, undef);

print "$self->{'text_hash'}->{'waiting'}\n";
print "<table width='100%'>\n";
if ($self->{'in_hash'}->{'from'} == 1)
{
 # download file
 local @url = split (/\//,$self->{'in_hash'}->{'url'});
 local $filename = $url[$#url];
 local $path = "$self->{'config_hash'}->{'dansguardian_dir'}/$filename";
 $self->error_setup($self->{'text_hash'}->{'error_download'});
 local $file = $self->download_blacklist($self->{'in_hash'}->{'url'},$path);

 # install blacklist
 $self->error_setup($self->{'text_hash'}->{'error_install'});
 $self->install_blacklist($file);
}
elsif ($self->{'in_hash'}->{'from'} == 0)
{
 # upload file
 local $path = "$self->{'config_hash'}->{'dansguardian_dir'}/$self->{'in_hash'}->{'upload_filename'}";
 $self->error_setup($self->{'text_hash'}->{'error_upload'});
 if (!$self->open_tempfile(FILE, ">$path", 1)) 
 {
  $self->error($self->text('upload_eopen', "<tt>$path</tt>", $!));
 }
 $self->print_tempfile(FILE, $self->{'in_hash'}->{'upload'});
 $self->close_tempfile(FILE);
 
 # install blacklist
 $self->error_setup($self->{'text_hash'}->{'error_install'});
 $self->install_blacklist($path);
}
print "</table>\n";

# print navigation URL
$self->ui_print_footer("blacklist.cgi",$self->{'text_hash'}->{'index_blacklist'},"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

