#!/usr/bin/perl

&MAIN();

 sub MAIN {
# filter_group.cgi
# display dansguardian filter group form

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

# get filter groups file
local $group = $self->get_filter_group($self->{'in_hash'}->{'idx'});
local $conf = $group->{'conf'};

# print header
$self->ui_print_header(undef, $self->text('index_group', $group->{'name'}),undef,undef,undef);

# print options form
print $self->ui_form_start('save_filter_group.cgi','post');
print $self->ui_hidden('idx',$self->{'in_hash'}->{'idx'});

# print filter options
print "<TABLE width=100% cellpadding=5><TR>\n";
print "<TR><TD colspan=3 $self->{'tb'}><b>".$self->{'text_hash'}->{'index_group_options'}."</b></TD></TR>\n";

# get section list for installed version
local $options = $self->get_filter_option_list();

# print options
foreach (@{$options})
{
 # get config value
 local $value = $self->get_config_value($_->[0], $conf);
 
 print "<TR $self->{'cb'}><TD width=20%><b>$self->{'text_hash'}->{$_->[0]} &nbsp;</b></TD><TD>\n";
 if ($_->[1] == 0)
 {
  # print text & edit url
  print $self->ui_hidden($_->[0].'_def',1);
  print $self->ui_textbox($_->[0], $value, 40);
  print "</TD><TD width=10%><A class=menu href=\"edit_file.cgi?idx=$self->{'in_hash'}->{'idx'}\&option=$_->[0]\">$self->{'text_hash'}->{'edit_file'}</A>\n";
 }
 elsif ($_->[1] == 1)
 {
  # print text/default radio
  local $def;
  $def = exists ($conf->{$_->[0]}) ?  1 : 0;
  print $self->ui_radio($_->[0].'_def', $def, [ [ 1, $self->ui_textbox($_->[0], $value, 7) ],[ 0, $self->{'text_hash'}->{'default'} ] ])."</TD><TD>\n";
 }
 print "</TD></TR>\n";
}
print "</TABLE>\n";
print $self->ui_submit($self->{'text_hash'}->{'save'}).$self->text('save_msg',$group->{'name'});
print $self->ui_form_end();

# print delete form
unless ($group->{'name'} == 1)
{
 print $self->ui_form_start('save_filter_group.cgi','post');
 print $self->ui_hidden('idx',$self->{'in_hash'}->{'idx'});
 print $self->ui_hidden('delete',1);
 print $self->ui_submit($self->{'text_hash'}->{'delete'}).$self->text('save_msg',$group->{'name'});
 print $self->ui_form_end();
}

# print back URL
$self->ui_print_footer("",$self->{'text_hash'}->{'index_return'});
1;
		
}


1;

