#!/usr/bin/perl

&MAIN();

 sub MAIN {
# options.cgi
# display dansguardian options form

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

# get section
local $section = $self->{'in_hash'}->{'section'};
local $index = 'index_'.$section;

# print header
$self->ui_print_header(undef, $self->{'text_hash'}->{$index}, undef);

# get dansguardian configuration
local $conf = $self->parse_config_file();

# print options form
print $self->ui_form_start('save_options.cgi','post');
print $self->ui_hidden('section',$section);

# print options table
print "<TABLE width=100% cellpadding=5><TR>\n";
print "<TR><TD colspan=3 $self->{'tb'}><b>$self->{'text_hash'}->{$index}</b></TD></TR>\n";

# get section list for installed version
local $options = $self->get_option_list();

# print options
foreach (@{$options})
{
 if ($_->[0] eq $section)
 {
  # get config value
  local $value = $self->get_config_value($_->[1], $conf);
  
  local ($chk, $def, $size);
  $def = exists ($conf->{$_->[1]}) ?  1 : 0;
  print "<TR $self->{'cb'}><TD width=20%><b>$self->{'text_hash'}->{$_->[1]} &nbsp;</b></TD><TD>\n";
  if (($_->[2] == 0) || ($_->[2] == 3))
  {
   # print text/default radio
   $size = ($_->[2] == 3) ? 40 : 7;
   print $self->ui_radio($_->[1].'_def', $def, [ [ 1, $self->ui_textbox($_->[1], $value, $size) ],[ 0, $self->{'text_hash'}->{'default'} ] ])."</TD><TD>\n";
  }
  elsif ($_->[2] == 1)
  {
   # print yes/no radio (on/off value)
	print $self->ui_hidden($_->[1].'_def',1)."\n";
   print $self->ui_radio($_->[1], $value, [ [ 'on', $self->{'text_hash'}->{'yes'}],[ 'off', $self->{'text_hash'}->{'no'} ] ])."</TD><TD>\n";
  }
  elsif ($_->[2] == 2)
  {
   # print yes/no radio (1/0 value)
   print $self->ui_hidden($_->[1].'_def',1);
   print $self->ui_radio($_->[1], $value, [ [ 1, $self->{'text_hash'}->{'yes'}],[ 0, $self->{'text_hash'}->{'no'} ] ])."</TD><TD>\n";
  }
  elsif ($_->[2] == 4)
  {
   # print text & edit url
   print $self->ui_hidden($_->[1].'_def',1);
   print $self->ui_textbox($_->[1], $value, 40);
   print "</TD><TD width=10%><A class=menu href=\"edit_file.cgi?section=$self->{'in_hash'}->{'section'}\&option=$_->[1]\"> $self->{'text_hash'}->{'edit_file'}</A>\n";
  }
  print "</TD></TR>\n";
 }
}
print "</TABLE>\n";
print $self->ui_submit($self->{'text_hash'}->{'save'});
print $self->ui_form_end();
		      
# print back URL
$self->ui_print_footer("",$self->{'text_hash'}->{'index_return'});
1;
		
}


1;

