#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_file.cgi
# save the manually edited config file

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParseMime();

local $conf;
if (exists $self->{'in_hash'}->{'idx'})
{
 # get filter file
 local $group = $self->get_filter_group($self->{'in_hash'}->{'idx'});
 $conf = $group->{'conf'};
}
elsif ($self->{'in_hash'}->{'section'})
{
 # get dansguardian configuration
 $conf = $self->parse_config_file();
}
local $file = $self->get_config_value($self->{'in_hash'}->{'option'}, $conf);
$file =~ /^'(.*?)'$/;
$file = $1;

# save data
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->{'in_hash'}->{'data'} =~ s/\n*$/\n/;
open(OUFL, ">$file") || $self->error($self->text('error_open', $file));
print OUFL $self->{'in_hash'}->{'data'};
close(OUFL);

if (exists $self->{'in_hash'}->{'idx'})
{
 # redirect to filter group
 $self->redirect("filter_group.cgi?idx=$self->{'in_hash'}->{'idx'}");
}
elsif ($self->{'in_hash'}->{'section'})
{
 # redirect to configuration section
 $self->redirect("options.cgi?section=$self->{'in_hash'}->{'section'}");
}

1;
		
}


1;

