#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_options.cgi
# save dansguardian options

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

# get section
local $section = $self->{'in_hash'}->{'section'};

# get dansguardian configuration
local $conf = $self->parse_config_file();

# get options list for installed version
local $options = $self->get_option_list();

# save options
foreach (@{$options})
{
 if ($_->[0] eq $section)
 {
  unless ($self->{'in_hash'}->{"$_->[1]_def"})
  {
   # delete option
   $self->del_config_value($_->[1],$conf); 
  }
  else
  {
   # change option value
   $self->set_config_value($_->[1],$self->{'in_hash'}->{$_->[1]},$conf); 
  }
 }
}
# save options
$self->save_new_options($conf);

if ($self->{'config_hash'}->{'save_apply'} && $self->status_dansguardian())
{
 # restart dansguardian
 $self->restart_dansguardian();
}

# redirect to index.cgi
$self->redirect("index.cgi");
1;
		
}


1;

