#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update networking options

&ModuleLoader::preload_module('dovecot_class', "dovecot::DovecotLib");
$self = new dovecot::DovecotLib:: 'dovecot_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'net_err'});
$self->lock_file($self->{'config_hash'}->{'dovecot_config'});
$self->{'conf'} = $self->get_config();

$self->save_directive($self->{'conf'}, "protocols", join(" ", split(/\0/, $self->{'in_hash'}->{'protocols'})));
$self->save_directive($self->{'conf'}, "ssl_disable", $self->{'in_hash'}->{'ssl_disable'} eq '' ? undef : $self->{'in_hash'}->{'ssl_disable'});
@{$self->{'listens_array'}} = $self->find("imap_listen", $self->{'conf'}, 2) ?
		("imap_listen", "pop3_listen", "imaps_listen", "pop3s_listen") :
		("listen", "ssl_listen");
foreach $l (@{$self->{'listens_array'}}) {
	if ($self->{'in_hash'}->{$l."_mode"} == 0) {
		$self->{'listen'} = "";
		}
	elsif ($self->{'in_hash'}->{$l."_mode"} == 1) {
		$self->{'listen'} = "[::]";
		}
	elsif ($self->{'in_hash'}->{$l."_mode"} == 2) {
		$self->{'listen'} = "*";
		}
	elsif ($self->{'in_hash'}->{$l."_mode"} == 3) {
		$self->check_ipaddress($self->{'in_hash'}->{$l}) || $self->error($self->{'text_hash'}->{'net_e'.$l});
		$self->{'listen'} = $self->{'in_hash'}->{$l};
		}
	$self->save_directive($self->{'conf'}, $l, $self->{'listen'});
	}

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'dovecot_config'});
$self->webmin_log("net");
$self->redirect("");

1;
		
}


1;

