#!/usr/bin/perl
package enduser_cf::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'enduser_cf::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the usermin module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_icons'}</b></td>\n";
print "<td colspan=3><select name=icons multiple size=10>\n";
foreach $i ($self->get_icons()) {
	printf "<option value=%s %s>%s\n",
		$i, $_[0]->{$i} ? "selected" : "", $self->{'text_hash'}->{"${i}_title"};
	}
print "</select></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_mods'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mods_def value=1 %s> %s\n",
	$_[0]->{'mods'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=mods_def value=0 %s> %s<br>\n",
	$_[0]->{'mods'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_sel'};
local %mods = map { $_, 1 } split(/\s+/, $_[0]->{'mods'});
print "<select name=mods multiple size=10>\n";
foreach $m ($self->list_modules()) {
	printf "<option value=%s %s>%s\n",
		$m->{'dir'}, $mods{$m->{'dir'}} ? "selected" : "", $m->{'desc'};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_stop'}</b></td>\n";
printf "<td><input type=radio name=stop value=1 %s> %s\n",
	$_[0]->{'stop'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=stop value=0 %s> %s</td>\n",
	$_[0]->{'stop'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_bootup'}</b></td>\n";
printf "<td><input type=radio name=bootup value=1 %s> %s\n",
	$_[0]->{'bootup'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=bootup value=0 %s> %s</td> </tr>\n",
	$_[0]->{'bootup'} ? "" : "checked", $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the usermin module
sub acl_security_save
{
	my $self = shift;

local %icons = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'icons'});
foreach $i ($self->get_icons()) {
	$_[0]->{$i} = $icons{$i};
	}
$_[0]->{'mods'} = $self->{'in_hash'}->{'mods_def'} ? "*" : join(" ", split(/\0/, $self->{'in_hash'}->{'mods'}));
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'bootup'} = $self->{'in_hash'}->{'bootup'};
}

sub get_icons
{
	my $self = shift;

return ( "access" ,"bind" ,"ui" ,"umods" ,"os" ,"lang" ,"upgrade" ,"session" ,"assignment" ,"categories" ,"themes", "referers", "anon", "ssl" ,"configs" ,"acl" ,"restrict" ,"users" ,"defacl", "sessions", "advanced" );
}


1;

