#!/usr/bin/perl
package enduser_cf::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'enduser_cf::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns the Usermin error log
sub syslog_getlogs
{
	my $self = shift;

local %miniserv;
$self->get_usermin_miniserv_config(\%miniserv);
if ($miniserv{'errorlog'} eq '-') {
	# Logging to stdout
	return ( );
	}
elsif ($miniserv{'errorlog'}) {
	# Specific file
	return ( { 'file' => $miniserv{'errorlog'},
		   'desc' => $self->{'text_hash'}->{'syslog_errorlog'},
		   'active' => 1, } );
	}
elsif ($miniserv{'logfile'} =~ /^(.*)\/[^\/]+$/) {
	# Relative to main log
	return ( { 'file' => "$1/miniserv.error",
		   'desc' => $self->{'text_hash'}->{'syslog_errorlog'},
		   'active' => 1, } );
	}
}


1;

