#!/usr/bin/perl

&MAIN();

 sub MAIN {
# bootup.cgi
# Create, enable or disable usermin startup at boot time

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'bootup_ecannot'});
$self->foreign_require("init", "init-lib.pl");
$self->ReadParse();

if ($self->{'in_hash'}->{'boot'}) {
	# Enable starting at boot
	$self->{'start'} = "$self->{'config_hash'}->{'usermin_dir'}/start";
	$self->{'stop'} = "$self->{'config_hash'}->{'usermin_dir'}/stop";
	$self->{'status'} = <<EOF;
pidfile=`grep "^pidfile=" $self->{'config_hash'}->{'usermin_dir'}/miniserv.conf | sed -e 's/pidfile=//g'`
if [ -s \$pidfile ]; then
	pid=`cat \$pidfile`
	kill -0 \$pid >/dev/null 2>&1
	if [ "\$?" = "0" ]; then
		echo "usermin (pid \$pid) is running"
		RETVAL=0
	else
		echo "usermin is stopped"
		RETVAL=1
	fi
else
	echo "usermin is stopped"
	RETVAL=1
fi
EOF
	$main::init_object->enable_at_boot("usermin", "Start or stop Usermin",
			      $self->{'start'}, $self->{'stop'}, $self->{'status'});
	}
else {
	# Disable starting at boot
	$main::init_object->disable_at_boot("usermin");
	}
$self->redirect("");

1;
		
}


1;

