#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_anon.cgi
# Update list of anonymously accessible modules

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->error_setup($main::cpplus_object->{'text_hash'}->{'anon_err'});

# Check inputs
$self->read_acl(undef, \%{$self->{'acl_hash'}});
for($i=0; defined($self->{'in_hash'}->{"url_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"url_$i"});
	$self->{'in_hash'}->{"url_$i"} =~ /^\/\S+$/ || $self->error($main::cpplus_object->text('anon_eurl', $self->{'in_hash'}->{"url_$i"}));
	getpwnam($self->{'in_hash'}->{"user_$i"}) || $self->error($self->text('anon_euser', $self->{'in_hash'}->{"url_$i"}));
	push(@{$self->{'anon_array'}}, $self->{'in_hash'}->{"url_$i"}."=".$self->{'in_hash'}->{"user_$i"});
	}

$self->lock_file($self->{'usermin_miniserv_config'});
$self->{'miniserv_hash'}->{'anonymous'} = join(" ", @{$self->{'anon_array'}});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();
$self->webmin_log("anon", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

