#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_os.cgi
# Change OS settings

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'os'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();

$self->lock_file($self->{'usermin_config'});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'osfile'} = "$self->{'miniserv_hash'}->{'root'}/os_list.txt";
if ($self->{'in_hash'}->{'update'}) {
	# Automatically detect
	%{$self->{'osinfo_hash'}} = $main::cpplus_object->detect_operating_system($self->{'osfile'});
	$self->{'uconfig_hash'}->{'real_os_type'} = $self->{'osinfo_hash'}->{'real_os_type'};
	$self->{'uconfig_hash'}->{'real_os_version'} = $self->{'osinfo_hash'}->{'real_os_version'};
	$self->{'uconfig_hash'}->{'os_type'} = $self->{'osinfo_hash'}->{'os_type'};
	$self->{'uconfig_hash'}->{'os_version'} = $self->{'osinfo_hash'}->{'os_version'};
	}
elsif ($self->{'in_hash'}->{'type'} ne $self->{'uconfig_hash'}->{'real_os_type'} ||
       $self->{'in_hash'}->{'version'} ne $self->{'uconfig_hash'}->{'real_os_version'} ||
       $self->{'in_hash'}->{'itype'} ne $self->{'uconfig_hash'}->{'os_type'} ||
       $self->{'in_hash'}->{'iversion'} ne $self->{'uconfig_hash'}->{'os_version'}) {
	# Manually change
	$self->{'uconfig_hash'}->{'real_os_type'} = $self->{'in_hash'}->{'type'};
	$self->{'in_hash'}->{'version'} || $self->error($main::cpplus_object->{'text_hash'}->{'os_eversion'});
	$self->{'uconfig_hash'}->{'real_os_version'} = $self->{'in_hash'}->{'version'};
	($self->{'os'}) = grep { $_->{'realtype'} eq $self->{'in_hash'}->{'type'} }
		     $main::cpplus_object->list_operating_systems($self->{'osfile'});
	$self->{'uconfig_hash'}->{'os_type'} = $self->{'in_hash'}->{'itype'};
	$self->{'in_hash'}->{'iversion'} || $self->error($main::cpplus_object->{'text_hash'}->{'os_eiversion'});
	$self->{'uconfig_hash'}->{'os_version'} = $self->{'in_hash'}->{'iversion'};
	}
$self->{'uconfig_hash'}->{'path'} = join(":", split(/[\r\n]+/, $self->{'in_hash'}->{'path'}));
$self->{'uconfig_hash'}->{'ld_path'} = join(":", split(/[\r\n]+/, $self->{'in_hash'}->{'ld_path'}));
$self->put_usermin_config(\%{$self->{'uconfig_hash'}});
$self->unlock_file($self->{'usermin_config'});

$self->lock_file($self->{'usermin_miniserv_config'});
foreach $e (keys %{$self->{'miniserv_hash'}}) {
	delete($self->{'miniserv_hash'}->{$e}) if ($e =~ /^env_(\S+)$/ &&
				  $1 ne "WEBMIN_CONFIG" && $1 ne "WEBMIN_VAR");
	}
for($i=0; defined($self->{'n'} = $self->{'in_hash'}->{"name_$i"}); $i++) {
	next if (!$self->{'n'});
	$self->{'miniserv_hash'}->{'env_'.$self->{'n'}} = $self->{'in_hash'}->{"value_$i"}
		if ($self->{'n'} ne "WEBMIN_CONFIG" && $self->{'n'} ne "WEBMIN_VAR");
	}
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();

$self->webmin_log("os", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

