#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_ssl.cgi
# Enable or disable SSL support

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'ssl'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();

$self->lock_file($self->{'usermin_miniserv_config'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'ssl'} = $self->{'in_hash'}->{'ssl'};
$self->{'key'} = `cat '$self->{'in_hash'}->{'key'}' 2>&1`;
$self->{'key'} =~ /BEGIN RSA PRIVATE KEY/i ||
	$self->error($main::cpplus_object->text('ssl_ekey', $self->{'in_hash'}->{'key'}));
$self->{'miniserv_hash'}->{'keyfile'} = $self->{'in_hash'}->{'key'};
if ($self->{'in_hash'}->{'cert_def'}) {
	$self->{'key'} =~ /BEGIN CERTIFICATE/ ||
		$self->error($main::cpplus_object->text('ssl_ecert', $self->{'in_hash'}->{'key'}));
	delete($self->{'miniserv_hash'}->{'certfile'});
	}
else {
	$self->{'cert'} = `cat '$self->{'in_hash'}->{'cert'}' 2>&1`;
	$self->{'cert'} =~ /BEGIN CERTIFICATE/ ||
		$self->error($main::cpplus_object->text('ssl_ecert',$self->{'in_hash'}->{'cert'}));
	$self->{'miniserv_hash'}->{'certfile'} = $self->{'in_hash'}->{'cert'};
	}
$self->{'miniserv_hash'}->{'ssl_redirect'} = $self->{'in_hash'}->{'ssl_redirect'};
if ($self->{'in_hash'}->{'version_def'}) {
	delete($self->{'miniserv_hash'}->{'ssl_version'});
	}
else {
	$self->{'in_hash'}->{'version'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ssl_eversion'});
	$self->{'miniserv_hash'}->{'ssl_version'} = $self->{'in_hash'}->{'version'};
	}
$self->{'miniserv_hash'}->{'no_ssl2'} = $self->{'in_hash'}->{'no_ssl2'};
foreach $ec (split(/[\r\n]+/, $self->{'in_hash'}->{'extracas'})) {
	-r $ec && !-d $ec || $self->error($main::cpplus_object->text('ssl_eextraca', $ec));
	push(@{$self->{'extracas_array'}}, $ec);
	}
$self->{'miniserv_hash'}->{'extracas'} = join("\t", @{$self->{'extracas_array'}});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});

$self->restart_usermin_miniserv();
$self->webmin_log("ssl", undef, undef, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

