#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_ui.cgi
# Change colour scheme

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'ui'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->error_setup($self->{'text_hash'}->{'ui_err'});
$self->ReadParse();
$self->{'in_hash'}->{'feedback_def'} || $self->{'in_hash'}->{'feedback'} =~ /\S/ || $self->error($self->{'text_hash'}->{'ui_efeedback'});
$self->{'in_hash'}->{'feedbackmail_def'} || gethostbyname($self->{'in_hash'}->{'feedbackmail'}) ||
    $self->check_ipaddress($self->{'in_hash'}->{'feedbackmail'}) || $self->error($self->{'text_hash'}->{'ui_efeedbackmail'});
$self->{'in_hash'}->{'feedbackhost_def'} || $self->{'in_hash'}->{'feedbackhost'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'ui_efeedbackhost'});

$self->lock_file($self->{'usermin_config'});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
for($i=0; $i<@{$main::cpplus_object->{'cs_names_array'}}; $i++) {
	$self->{'cd'} = $main::cpplus_object->{'cs_codes'}[$i];
	if ($self->{'in_hash'}->{"$self->{'cd'}_def"}) { delete($self->{'uconfig_hash'}->{$self->{'cd'}}); }
	elsif ($self->{'in_hash'}->{"$self->{'cd'}_rgb"} !~ /^[0-9a-fA-F]{6}$/) {
		$self->error($main::cpplus_object->text('ui_ergb', $main::cpplus_object->{'cs_names'}[$i]));
		}
	else { $self->{'uconfig_hash'}->{$self->{'cd'}} = $self->{'in_hash'}->{"$self->{'cd'}_rgb"}; }
	}
$self->{'uconfig_hash'}->{'texttitles'} = $self->{'in_hash'}->{'texttitles'};
$self->{'uconfig_hash'}->{'sysinfo'} = $self->{'in_hash'}->{'sysinfo'};
$self->{'uconfig_hash'}->{'feedback'} = $self->{'in_hash'}->{'feedback_def'} ? undef : $self->{'in_hash'}->{'feedback'};
$self->{'uconfig_hash'}->{'feedbackmail'} = $self->{'in_hash'}->{'feedbackmail_def'} ? undef :$self->{'in_hash'}->{'feedbackmail'};
$self->{'uconfig_hash'}->{'feedbackhost'} = $self->{'in_hash'}->{'feedbackhost_def'} ? undef :$self->{'in_hash'}->{'feedbackhost'};
$self->{'uconfig_hash'}->{'gotoone'} = $self->{'in_hash'}->{'gotoone'};
$self->{'uconfig_hash'}->{'gotomodule'} = $self->{'in_hash'}->{'gotomodule'};
$self->{'uconfig_hash'}->{'nohostname'} = $self->{'in_hash'}->{'nohostname'};
$self->{'uconfig_hash'}->{'showlogin'} = $self->{'in_hash'}->{'showlogin'};
$self->{'uconfig_hash'}->{'hostnamemode'} = $self->{'in_hash'}->{'hostnamemode'};
$self->{'uconfig_hash'}->{'hostnamedisplay'} = $self->{'in_hash'}->{'hostnamedisplay'};
$self->{'uconfig_hash'}->{'notabs'} = $self->{'in_hash'}->{'notabs'};
$self->write_file($self->{'usermin_config'}, \%{$self->{'uconfig_hash'}});
$self->unlock_file($self->{'usermin_config'});
$self->webmin_log('ui', undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

