#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_session.cgi
# Edit session login options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'session'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
print "Set-Cookie: sessiontest=1; path=/\n";
$self->ui_print_header(undef, $self->{'text_hash'}->{'session_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'ver'} = $self->get_usermin_version();

$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
print "$self->{'text_hash'}->{'session_desc1'}<p>\n";
print "$self->{'text_hash'}->{'session_desc2'}<p>\n";

print "<form action=change_session.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'session_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td nowrap>\n";

printf "<input type=radio name=passdelay value=0 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'passdelay'} ? '' : 'checked', $main::cpplus_object->{'text_hash'}->{'session_pdisable'};
printf "<input type=radio name=passdelay value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'passdelay'} ? 'checked' : '', $main::cpplus_object->{'text_hash'}->{'session_penable'};
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=blockhost_on value=1 %s>\n",
	$self->{'miniserv_hash'}->{'blockhost_failures'} ? "checked" : "";
print $main::cpplus_object->text('session_blockhost',
	    "<input name=blockhost_failures size=4 value='$self->{'miniserv_hash'}->{'blockhost_failures'}'>",
	    "<input name=blockhost_time size=4 value='$self->{'miniserv_hash'}->{'blockhost_time'}'>"),"<br>\n";
eval "use Sys::Syslog qw(:DEFAULT setlogsock)";
if (!$@) {
	printf "<input type=checkbox name=syslog value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'syslog'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_syslog2'};
	}
else {
	print "<input type=hidden name=syslog value='$self->{'miniserv_hash'}->{'syslog'}'>\n";
	}
print "<p>\n";

printf "<input type=radio name=session value=0 %s> %s<br>\n",
	!$self->{'miniserv_hash'}->{'session'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_disable'};
printf "<input type=radio name=session value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'session'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_enable'};
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=logouttime_on value=1 %s>\n",
	$self->{'miniserv_hash'}->{'logouttime'} ? "checked" : "";
print $main::cpplus_object->text('session_logout',
	"<input name=logouttime value='$self->{'miniserv_hash'}->{'logouttime'}' size=10>"),"<br>\n";
#printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=locking value=1 %s>\n",
#	$gconfig{'locking'} ? "checked" : "";
#print "$main::cpplus_object->{'text_hash'}->{'session_locking'}<br>\n";
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=remember value=1 %s>\n",
	$self->{'uconfig_hash'}->{'noremember'} ? "" : "checked";
print "$main::cpplus_object->{'text_hash'}->{'session_remember'}<br>\n";
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=hostname value=1 %s>\n",
	$self->{'uconfig_hash'}->{'nohostname'} ? "" : "checked";
print "$main::cpplus_object->{'text_hash'}->{'session_hostname'}<br>\n";
print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
printf "<input type=checkbox name=realname value=1 %s>\n",
	$self->{'uconfig_hash'}->{'realname'} ? "checked" : "";
print "$main::cpplus_object->{'text_hash'}->{'session_realname'}<br>\n";
if ($self->{'ver'} >= 1.153) {
	printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=utmp value=1 %s>\n",
		$self->{'miniserv_hash'}->{'utmp'} ? "checked" : "";
	print "$main::cpplus_object->{'text_hash'}->{'session_utmp'}<br>\n";
	}
printf "&nbsp;&nbsp;&nbsp;<input type=radio name=banner_def value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'loginbanner'} ? "" : "checked", $main::cpplus_object->{'text_hash'}->{'session_banner1'};
printf "<input type=radio name=banner_def value=0 %s> %s\n",
	$self->{'uconfig_hash'}->{'loginbanner'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_banner0'};
printf "<input name=banner size=30 value='%s'> %s<br>\n",
	$self->{'uconfig_hash'}->{'loginbanner'}, $self->file_chooser_button("banner");
print "<p>\n";

printf "<input type=radio name=localauth value=0 %s> %s<br>\n",
	!$self->{'miniserv_hash'}->{'localauth'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_localoff'};
printf "<input type=radio name=localauth value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'localauth'} ? "checked" : "", $main::cpplus_object->{'text_hash'}->{'session_localon'};
print "<p>\n";

@{$self->{'users_array'}} = $self->get_usermin_miniserv_users();
$self->{'authmode'} = $self->{'users_array'}->[0]->{'pass'} eq 'e' ? 2 :
	    $self->{'miniserv_hash'}->{'no_pam'} ? 1 : 0;
printf "<input type=radio name=authmode value=0 %s> %s<br>\n",
	$self->{'authmode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'session_authmode0'};
print "&nbsp;&nbsp;&nbsp;",
	$self->ui_checkbox("pam_conv", 1, $main::cpplus_object->{'text_hash'}->{'session_pamconv'},
		     $self->{'miniserv_hash'}->{'pam_conv'}),"<br>\n";
printf "<input type=radio name=authmode value=1 %s>\n",
	$self->{'authmode'} == 1 ? "checked" : "";
print $self->text('session_authmode1',
      "<input name=passwd_file size=20 value='$self->{'miniserv_hash'}->{'passwd_file'}'>",
      "<input name=passwd_uindex size=2 value='$self->{'miniserv_hash'}->{'passwd_uindex'}'>",
      "<input name=passwd_pindex size=2 value='$self->{'miniserv_hash'}->{'passwd_pindex'}'>"),
      "<br>\n";
printf "<input type=radio name=authmode value=2 %s> %s\n",
	$self->{'authmode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'session_authmode2'};
printf "<input name=extauth size=30 value='%s'><p>\n",
	$self->{'miniserv_hash'}->{'extauth'};

if ($self->{'ver'} >= 1.047 && $self->{'miniserv_hash'}->{'passwd_cindex'} ne '') {
	#print "$self->{'text_hash'}->{'session_pmodedesc'}<br>\n";
	foreach $m (0 .. 2) {
		printf "<input type=radio name=passwd_mode value=%d %s> %s\n",
			$m, $self->{'miniserv_hash'}->{'passwd_mode'} == $m ? "checked" : "",
			$main::cpplus_object->{'text_hash'}->{'session_pmode'.$m};
		print $m == 2 ? "<p>\n" : "<br>\n";
		}
	}

# Prompt to choose password at login
if ($self->{'ver'} >= 1.087) {
	printf "<input type=checkbox name=passwd_blank value=1 %s> %s<p>\n",
		$self->{'miniserv_hash'}->{'passwd_blank'} ? "checked" : "",
		$self->{'text_hash'}->{'session_blank'};
	}

if ($self->{'ver'} >= 1.003) {
	printf "<input type=checkbox name=domainuser value=1 %s> %s<br>\n",
		$self->{'miniserv_hash'}->{'domainuser'} ? "checked" : "",
		$self->{'text_hash'}->{'session_domain'};
	}
if ($self->{'ver'} >= 1.021) {
	printf "<input type=checkbox name=domainstrip value=1 %s> %s<br>\n",
		$self->{'miniserv_hash'}->{'domainstrip'} ? "checked" : "",
		$self->{'text_hash'}->{'session_strip'};
	printf "<input type=checkbox name=user_mapping_on value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'user_mapping'} ? "checked" : "",
		$self->{'text_hash'}->{'session_usermap'};
	printf "<input name=user_mapping size=30 value='%s'> %s<br>\n",
		$self->{'miniserv_hash'}->{'user_mapping'}, $self->file_chooser_button("user_mapping");
	print "&nbsp;" x 3;
	printf "$self->{'text_hash'}->{'session_userfmt'}\n";
	print $self->ui_radio("user_mapping_reverse",
			int($self->{'miniserv_hash'}->{'user_mapping_reverse'}),
			[ [ 0, $self->{'text_hash'}->{'session_userfmt0'} ],
			  [ 1, $self->{'text_hash'}->{'session_userfmt1'} ] ]),"<p>\n";
	}

# Prompt to choose password at login
if ($self->{'ver'} >= 1.142) {
	printf "<input type=checkbox name=create_homedir value=1 %s> %s<br>\n",
		$self->{'uconfig_hash'}->{'create_homedir'} ? "checked" : "",
		$self->{'text_hash'}->{'session_homedir'};
	print "&nbsp;" x 3;
	print $self->{'text_hash'}->{'session_homedir_perms'},"\n",
	      $self->ui_opt_textbox("create_homedir_perms",
		$self->{'uconfig_hash'}->{'create_homedir_perms'}, 4, $self->{'text_hash'}->{'default'}),"<br>\n";
	}

print "</td> </tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

