#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ui.cgi
# Edit user interface options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'ui'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ui_title'}, "");

$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
print $self->{'text_hash'}->{'ui_desc'},"<p>\n";
print "<form action=change_ui.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ui_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

for($i=0; $i<@{$main::cpplus_object->{'cs_names_array'}}; $i++) {
	$self->{'cd'} = $main::cpplus_object->{'cs_codes'}[$i];
	print "<tr> <td><b>$main::cpplus_object->{'cs_names'}[$i]</b></td>\n";
	printf "<td><input type=radio name=$self->{'cd'}_def value=1 %s> %s\n",
		defined($self->{'uconfig_hash'}->{$self->{'cd'}}) ? "" : "checked",
		$main::cpplus_object->{'text_hash'}->{'ui_default'};
	printf "&nbsp;&nbsp;<input type=radio name=$self->{'cd'}_def value=0 %s> %s\n",
		defined($self->{'gconfig_hash'}->{$self->{'cd'}}) ? "checked" : "",
		$main::cpplus_object->{'text_hash'}->{'ui_rgb'};
	print "<input name=$self->{'cd'}_rgb size=8 value='$self->{'uconfig_hash'}->{$self->{'cd'}}'>\n";
	print "</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'ui_texttitles'}</b></td>\n";
printf "<td><input type=radio name=texttitles value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'texttitles'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=texttitles value=0 %s> %s</td> </tr>\n",
	$self->{'uconfig_hash'}->{'texttitles'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'ui_sysinfo'}</b></td>\n";
print "<td><select name=sysinfo>\n";
foreach $m (0, 1, 4, 2, 3) {
        printf "<option value=%s %s> %s\n",
                $m, $self->{'uconfig_hash'}->{'sysinfo'} == $m ? 'selected' : '',
                $main::cpplus_object->{'text_hash'}->{'ui_sysinfo'.$m};
        }
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ui_nohost'}</b></td> <td>\n";
printf "<input name=nohostname type=radio value=0 %s> %s\n",
	$self->{'uconfig_hash'}->{'nohostname'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
printf "<input name=nohostname type=radio value=1 %s> %s</td> </tr>\n",
	$self->{'uconfig_hash'}->{'nohostname'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'ui_hostnamemode'}</b></td>\n";
print "<td><select name=hostnamemode>\n";
foreach $m (0 .. 3) {
	printf "<option value=%s %s>%s\n",
		$m, $self->{'uconfig_hash'}->{'hostnamemode'} == $m ? "selected" : "",
		$main::cpplus_object->{'text_hash'}->{'ui_hnm'.$m};
	}
print "</select>\n";
printf "<input name=hostnamedisplay size=20 value='%s'>\n",
	$self->{'uconfig_hash'}->{'hostnamedisplay'};
print "</td> </tr>\n";

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'ui_showlogin'}</b></td> <td>\n";
printf "<input name=showlogin type=radio value=1 %s> %s\n",
        $self->{'uconfig_hash'}->{'showlogin'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input name=showlogin type=radio value=0 %s> %s</td> </tr>\n",
        $self->{'uconfig_hash'}->{'showlogin'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'startpage_gotoone'}</b></td> <td>\n";
printf "<input name=gotoone type=radio value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'gotoone'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input name=gotoone type=radio value=0 %s> %s</td> </tr>\n",
	$self->{'uconfig_hash'}->{'gotoone'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$main::cpplus_object->{'text_hash'}->{'startpage_gotomodule'}</b></td>\n";
print "<td><select name=gotomodule>\n";
printf "<option value='' %s>%s\n",
	$self->{'uconfig_hash'}->{'gotomodule'} ? "" : "selected",
	$main::cpplus_object->{'text_hash'}->{'startpage_gotonone'};
foreach $m ($self->list_modules()) {
	printf "<option value=%s %s>%s\n",
		$m->{'dir'}, $self->{'uconfig_hash'}->{'gotomodule'} eq $m->{'dir'} ?
				'selected' : '', $m->{'desc'};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ui_feedbackmode'}</b></td>\n";
printf "<td><input type=radio name=feedback_def value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'feedback'} ? "" : "checked", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=feedback_def value=0 %s> %s\n",
	$self->{'uconfig_hash'}->{'feedback'} ? "checked" : "", $self->{'text_hash'}->{'ui_feedbackyes'};
printf "<input name=feedback size=30 value='%s'></td> </tr>\n",
	$self->{'uconfig_hash'}->{'feedback'};

print "<tr> <td><b>$self->{'text_hash'}->{'ui_feedbackmail'}</b></td>\n";
printf "<td nowrap><input type=radio name=feedbackmail_def value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'feedbackmail'} ? "" : "checked",
	$self->{'text_hash'}->{'ui_feedbackmail1'};
printf "<input type=radio name=feedbackmail_def value=0 %s> %s\n",
	$self->{'uconfig_hash'}->{'feedbackmail'} ? "checked" : "",
	$self->{'text_hash'}->{'ui_feedbackmail0'};
printf "<input name=feedbackmail size=30 value='%s'></td> </tr>\n",
	$self->{'uconfig_hash'}->{'feedbackmail'};

print "<tr> <td><b>$self->{'text_hash'}->{'ui_feedbackhost'}</b></td>\n";
printf "<td><input type=radio name=feedbackhost_def value=1 %s> %s\n",
	$self->{'uconfig_hash'}->{'feedbackhost'} ? "" : "checked",
	$self->{'text_hash'}->{'ui_feedbackthis'};
printf "<input type=radio name=feedbackhost_def value=0 %s>\n",
	$self->{'uconfig_hash'}->{'feedbackhost'} ? "checked" : "";
printf "<input name=feedbackhost size=30 value='%s'></td> </tr>\n",
	$self->{'uconfig_hash'}->{'feedbackhost'};

print "<tr> <td><b>$self->{'text_hash'}->{'ui_tabs'}</b></td> <td>\n";
printf "<input name=notabs type=radio value=0 %s> %s\n",
	$self->{'uconfig_hash'}->{'notabs'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
printf "<input name=notabs type=radio value=1 %s> %s</td> </tr>\n",
	$self->{'uconfig_hash'}->{'notabs'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

