#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_users.cgi
# Display user access control form

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'users_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

if ($self->get_usermin_version() < 0.76) {
	print "<p>$self->{'text_hash'}->{'users_eversion'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print $self->{'text_hash'}->{'users_desc'}," ",$self->{'text_hash'}->{'users_desc2'},"<p>\n";

print "<form action=change_users.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'users_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table><tr><td valign=top nowrap>\n";
printf "<input type=radio name=access value=0 %s>\n",
	$self->{'miniserv_hash'}->{"allowusers"} || $self->{'miniserv_hash'}->{"denyusers"} ? "" : "checked";
print "$self->{'text_hash'}->{'users_all'}<br>\n";
printf "<input type=radio name=access value=1 %s>\n",
	$self->{'miniserv_hash'}->{"allowusers"} ? "checked" : "";
print "$self->{'text_hash'}->{'users_allow'}<br>\n";
printf "<input type=radio name=access value=2 %s>\n",
	$self->{'miniserv_hash'}->{"denyusers"} ? "checked" : "";
print "$self->{'text_hash'}->{'users_deny'}<br>\n";
print "</td> <td valign=top>\n";
printf "<textarea name=user rows=6 cols=30>%s</textarea></td> </tr>\n",
 $self->{'miniserv_hash'}->{"allowusers"} ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"allowusers"})) :
 $self->{'miniserv_hash'}->{"denyusers"} ? join("\n", split(/\s+/, $self->{'miniserv_hash'}->{"denyusers"})) : "";

if ($self->get_usermin_version() > 0.95) {
	print "<tr> <td colspan=2>\n";
	printf "<input type=checkbox name=shells_deny value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'shells_deny'} ? "checked" : "",$self->{'text_hash'}->{'users_shells'};
	printf "<input name=shells size=25 value='%s'> %s</td> </tr>\n",
		$self->{'miniserv_hash'}->{'shells_deny'} || "/etc/shells",
		$self->file_chooser_button("shells");
	}

print "</table></td> </tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

