#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display usermin configuration categories

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;


if (!-r "$self->{'config_hash'}->{'usermin_dir'}/miniserv.conf") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	print "<p>",$self->text('index_econfig', "<tt>$self->{'config_hash'}->{'usermin_dir'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	if ($self->{'config_hash'}->{'usermin_dir'} eq $self->{'standard_usermin_dir'}) {
		local $mode;
		if ($self->foreign_check("software")) {
			local %sconfig = $self->foreign_config("software");
			$mode = $sconfig{'package_system'} eq 'rpm' ? 'rpm' :
				$sconfig{'package_system'} eq 'dpkg' ? 'deb' :
								       undef;
			}
		print "$self->{'text_hash'}->{'index_install'}<br>\n";
		print "<center><form action=upgrade.cgi method=post enctype=multipart/form-data>\n";
		print "<input type=hidden name=install value=1>\n";
		print "<input type=hidden name=source value=2>\n";
		print "<input type=hidden name=mode value='$mode'>\n";
		print "<input type=submit value='",
		    ($mode ? $self->{'text_hash'}->{'index_'.$mode} : $self->{'text_hash'}->{'index_tgz'}),"'>\n";
		print "</form></center>\n";
		}
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
elsif ($self->same_file($self->{'config_hash'}->{'usermin_dir'}, $self->{'config_directory'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

	print "<p>",$self->text('index_esame', "<tt>$self->{'config_hash'}->{'usermin_dir'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";

	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

$self->{'ver'} = $self->get_usermin_version();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0);

@{$self->{'links_array'}} = ( "edit_access.cgi",
	   "edit_bind.cgi",
	   "edit_ui.cgi",
	   "edit_os.cgi",
	   "edit_lang.cgi",
	   "edit_session.cgi",
	   "edit_descs.cgi",
	   "edit_anon.cgi",
	   "edit_ssl.cgi",
	   "list_configs.cgi",
	   "edit_acl.cgi",
	   $self->{'ver'} < 0.942 ? ( ) : ( "list_restrict.cgi" ),
	   $self->{'ver'} < 0.76 ? ( ) : ( "edit_users.cgi",
			         "edit_defacl.cgi" ),
	   $self->{'ver'} < 1.164 ? ( ) : ( "edit_logout.cgi" ),
	   $self->{'ver'} < 1.181 ? ( ) : ( "edit_dav.cgi" ),
	   "list_sessions.cgi",
	   "edit_advanced.cgi" );
@{$self->{'titles_array'}} = map { /_(\S+).cgi/; $self->{'text_hash'}->{"${1}_title"} } @{$self->{'links_array'}};
@{$self->{'icons_array'}} = map { /_(\S+).cgi/; "images/$1.gif" } @{$self->{'links_array'}};
for($i=0; $i<@{$self->{'links_array'}}; $i++) {
	$self->{'links_array'}->[$i] =~ /_(\S+).cgi/;
	$self->{'page'} = $1 eq "mods" ? "umods" : $1;
	if (!$self->{'access_hash'}->{$self->{'page'}}) {
		splice(@{$self->{'links_array'}}, $i, 1);
		splice(@{$self->{'titles_array'}}, $i, 1);
		splice(@{$self->{'icons_array'}}, $i, 1);
		}
	}

$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

