#!/usr/bin/perl

&MAIN();

 sub MAIN {
# lists_configs.cgi
# List all usermin modules that can be configured

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'configs'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'configs_title'}, "");

@{$self->{'mods_array'}} = $self->list_modules();
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
print "$self->{'text_hash'}->{'configs_desc'}<p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'configs_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
foreach $m (@{$self->{'mods_array'}}) {
	if ((-r "$self->{'miniserv_hash'}->{'root'}/$m->{'dir'}/config.info" ||
	    -r "$self->{'miniserv_hash'}->{'root'}/$m->{'dir'}/uconfig.info") &&
	    $self->can_use_module($m->{'dir'})) {
		print "<tr>\n" if ($self->{'i'}%3 == 0);
		print "<td><a href='edit_configs.cgi?mod=$m->{'dir'}'>",
		      "$m->{'desc'}</a></td>\n";
		print "</tr>\n" if ($self->{'i'}++%3 == 2);
		}
	}
print "</table></td></tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

