#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_restrict.cgi
# Display usermin per-user or per-group module restrictions

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'restrict'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'restrict_title'}, "");

print $self->text('restrict_desc', "edit_acl.cgi"),"<p>\n";

@{$self->{'usermods_array'}} = $self->list_usermin_usermods();
if (@{$self->{'usermods_array'}}) {
	print "<a href='edit_restrict.cgi?new=1'>$self->{'text_hash'}->{'restrict_add'}",
	      "</a><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'restrict_who'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'restrict_what'}</b></td> ",
	      "<td width=10><b>$self->{'text_hash'}->{'restrict_move'}</b></td> </tr>\n";
	$self->{'i'} = 0;
	foreach $u (@{$self->{'usermods_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td nowrap><a href='edit_restrict.cgi?idx=$self->{'i'}'>",
		  $u->[0] eq "*" ? $self->{'text_hash'}->{'restrict_all'} :
		  $u->[0] =~ /^\@(.*)/ ?
			$self->text('restrict_group', "<tt>$1</tt>") :
		  $u->[0] =~ /^\// ?
			$self->text('restrict_file', "<tt>$u->[0]</tt>") :
			"<tt>$u->[0]</tt>","</a></td>\n";
		$self->{'mods'} = join(" ", map { "<tt>$_</tt>" } @{$u->[2]});
		print "<td>",!$self->{'mods'} ? $self->{'text_hash'}->{'restrict_nomods'} :
			     $self->text($u->[1] eq "+" ? 'restrict_plus' :
				   $u->[1] eq "-" ? 'restrict_minus' :
						    'restrict_set',
				   $self->{'mods'}),"</td>\n";
		print "<td>";
		if ($u eq $self->{'usermods_array'}->[@{$self->{'usermods_array'}}-1]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$self->{'i'}&down=1'>",
			      "<img src=images/down.gif border=0></a>";
			}
		if ($u eq $self->{'usermods_array'}->[0]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$self->{'i'}&up=1'>",
			      "<img src=images/up.gif border=0></a>";
			}
		print "</td> </tr>\n";
		$self->{'i'}++;
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'restrict_none'}</b><p>\n";
	}
print "<a href='edit_restrict.cgi?new=1'>$self->{'text_hash'}->{'restrict_add'}</a><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

