#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_categories.cgi

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'categories'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->read_file("$self->{'miniserv_hash'}->{'root'}/lang/en", \%{$self->{'utext_hash'}});
$self->read_file("$self->{'miniserv_hash'}->{'root'}/ulang/en", \%{$self->{'utext_hash'}});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'categories_err'});

# Save built-in categories
foreach $t (keys %{$self->{'utext_hash'}}) {
	$t =~ s/^category_// || next;
	if (!$self->{'in_hash'}->{"def_$t"}) {
		$self->{'in_hash'}->{"desc_$t"} ||
			$self->error($self->text('categories_edesc', $t ? $t : 'other'));
		$self->{'catnames_hash'}->{$t} = $self->{'in_hash'}->{"desc_$t"};
		}
	}

# Save custom categories
for($i=0; defined($self->{'in_hash'}->{"cat_$i"}); $i++) {
	if ($self->{'in_hash'}->{"cat_$i"} && $self->{'in_hash'}->{"desc_$i"}) {
		$self->{'realcat_hash'}->{$self->{'in_hash'}->{"cat_$i"}} &&
			$self->error($self->text('categories_ecat', $self->{'in_hash'}->{"cat_$i"}));
		$self->{'catnames_hash'}->{$self->{'in_hash'}->{"cat_$i"}} = $self->{'in_hash'}->{"desc_$i"};
		}
	}

$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.catnames");
$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.catnames", \%{$self->{'catnames_hash'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/cpplus.catnames");
$self->webmin_log("categories", undef, undef, \%{$self->{'in_hash'}});
$self->flush_modules_cache();
$self->redirect("");
1;
		
}


1;

