#!/usr/bin/perl

&MAIN();

 sub MAIN {
# config_save.cgi
# Save inputs from edit_configs.cgi

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

&ModuleLoader::preload_module('enduser_cf_class', "ConfigLib");
$self = new ConfigLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'configs'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->can_use_module($self->{'in_hash'}->{'mod'}) || $self->error($self->{'text_hash'}->{'configs_ecannot'});
$self->{'m'} = $self->{'in_hash'}->{'mod'};
$self->error_setup($self->{'text_hash'}->{'config_err'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

mkdir("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}", 0700);
$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config");
$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config", \%{$self->{'mconfig_hash'}});

$self->parse_config(\%{$self->{'mconfig_hash'}}, "$self->{'miniserv_hash'}->{'root'}/$self->{'m'}/config.info");

$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config", \%{$self->{'mconfig_hash'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config");
$self->webmin_log("config", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("list_configs.cgi");

1;
		
}


1;

