#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save DAV server options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->error_setup($self->{'text_hash'}->{'dav_err'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->ReadParse();

if ($self->{'in_hash'}->{'path_def'}) {
	delete($self->{'miniserv_hash'}->{'davpaths'});
	}
else {
	$self->{'in_hash'}->{'path'} =~ /^\/\S/ || $self->error($self->{'text_hash'}->{'dav_epath'});
	$self->{'miniserv_hash'}->{'davpaths'} = $self->{'in_hash'}->{'path'};
	}

if ($self->{'in_hash'}->{'root_def'} == 0) {
	delete($self->{'miniserv_hash'}->{'dav_root'});
	}
elsif ($self->{'in_hash'}->{'root_def'} == 1) {
	$self->{'miniserv_hash'}->{'dav_root'} = '*';
	}
else {
	-d $self->{'in_hash'}->{'root'} || $self->error($self->{'text_hash'}->{'dav_eroot'});
	$self->{'miniserv_hash'}->{'dav_root'} = $self->{'in_hash'}->{'root'};
	}

if ($self->{'in_hash'}->{'users_def'}) {
	delete($self->{'miniserv_hash'}->{'dav_users'});
	}
else {
	$self->{'in_hash'}->{'users'} =~ /\S/ || $self->error($self->{'text_hash'}->{'dav_eusers'});
	$self->{'miniserv_hash'}->{'dav_users'} = join(" ", split(/\s+/, $self->{'in_hash'}->{'users'}));
	}

if (!defined($self->{'miniserv_hash'}->{'dav_remoteuser'})) {
	$self->{'miniserv_hash'}->{'dav_remoteuser'} = 1;
	}

# Update config
$self->lock_file($self->{'usermin_miniserv_config'});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();
$self->webmin_log("dav");
$self->redirect("");

1;
		
}


1;

