#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save module description overrides

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'descs_err'});

for($i=0; defined($self->{'mod'} = $self->{'in_hash'}->{"mod_$i"}); $i++) {
	$self->{'desc'} = $self->{'in_hash'}->{"desc_$i"};
	next if (!$self->{'mod'});
	%{$self->{'minfo_hash'}} = $self->get_usermin_module_info($self->{'mod'});
	$self->{'desc'} =~ /\S/ || $self->error($self->text('descs_edesc', $self->{'minfo_hash'}->{'realdesc'}));
	$self->{'descs_hash'}->{$self->{'mod'}} = $self->{'desc'};
	}
$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/webmin.descs");
$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/webmin.descs", \%{$self->{'descs_hash'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/webmin.descs");
$self->flush_modules_cache();
$self->webmin_log("descs");
$self->redirect("");

1;
		
}


1;

