#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save per-user and group logout times options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->error_setup($self->{'text_hash'}->{'logout_err'});
$self->{'access_hash'}->{'logout'} || $self->error($self->{'text_hash'}->{'logout_ecannot'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->ReadParse();

# Save to list
for($i=0; defined($self->{'type'} = $self->{'in_hash'}->{"type_$i"}); $i++) {
	next if (!$self->{'type'});
	$self->{'who'} = $self->{'in_hash'}->{"who_$i"};
	$self->{'time'} = $self->{'in_hash'}->{"time_$i"};
	if ($self->{'type'} == 1) {
		$self->{'who'} =~ /^\S+$/ || $self->error($self->text('logout_euser', $i+1));
		}
	elsif ($self->{'type'} == 2) {
		$self->{'who'} =~ /^\S+$/ || $self->error($self->text('logout_egroup', $i+1));
		$self->{'who'} = "\@$self->{'who'}";
		}
	elsif ($self->{'type'} == 3) {
		-r $self->{'who'} && $self->{'who'} =~ /^\// || $self->error($self->text('logout_efile', $i+1));
		}
	$self->{'time'} =~ /^\d+$/ || $self->error($self->text('logout_etime', $i+1));
	push(@{$self->{'logout_array'}}, [ $self->{'who'}, $self->{'time'} ]);
	}

# Update config
$self->{'miniserv_hash'}->{'logouttimes'} = join(" ", map { $_->[0]."=".$_->[1] } @{$self->{'logout_array'}});
$self->lock_file($self->{'usermin_miniserv_config'});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->reload_usermin_miniserv();
$self->webmin_log("logout");
$self->redirect("");

1;
		
}


1;

