#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_restrict.cgi
# Create, update or delete a user or group module restriction

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'restrict'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
@{$self->{'usermods_array'}} = $self->list_usermin_usermods();
$self->{'um'} = $self->{'usermods_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/usermin.mods");
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this restriction
	@{$self->{'usermods_array'}} = grep { $_ ne $self->{'um'} } @{$self->{'usermods_array'}};
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'restrict_err'});
	if ($self->{'in_hash'}->{'umode'} == 0) {
		defined(getpwnam($self->{'in_hash'}->{'user'})) ||
			$self->error($self->{'text_hash'}->{'restrict_euser'});
		$self->{'um'}->[0] = $self->{'in_hash'}->{'user'};
		}
	elsif ($self->{'in_hash'}->{'umode'} == 1) {
		defined(getgrnam($self->{'in_hash'}->{'group'})) ||
			$self->error($self->{'text_hash'}->{'restrict_egroup'});
		$self->{'um'}->[0] = "\@".$self->{'in_hash'}->{'group'};
		}
	elsif ($self->{'in_hash'}->{'umode'} == 3) {
		$self->{'in_hash'}->{'file'} =~ /^\// && -r $self->{'in_hash'}->{'file'} ||
			$self->error($self->{'text_hash'}->{'restrict_efile'});
		$self->{'um'}->[0] = $self->{'in_hash'}->{'file'};
		}
	else {
		$self->{'um'}->[0] = "*";
		}
	$self->{'um'}->[1] = $self->{'in_hash'}->{'mmode'} == 0 ? "" :
		   $self->{'in_hash'}->{'mmode'} == 1 ? "+" : "-";
	$self->{'um'}->[2] = [ split(/\0/, $self->{'in_hash'}->{'mod'}) ];

	# Save the restriction
	if ($self->{'in_hash'}->{'new'}) {
		push(@{$self->{'usermods_array'}}, $self->{'um'});
		}
	}
$self->save_usermin_usermods(\@{$self->{'usermods_array'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/usermin.mods");
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "restrict", $self->{'um'}->[0]);
$self->redirect("list_restrict.cgi");

1;
		
}


1;

