#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_job.cgi
# Create a new at job

require 'timelocal.pl';

&ModuleLoader::preload_module('at_class', "at::AtLib");
$self = new at::AtLib:: 'at_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'create_err'});
%{$self->{'access_hash'}} = $self->get_module_acl();

# Validate inputs
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'create_ecannot'});
defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'create_euser'});
$self->can_use_at($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'create_eallow'});
$self->{'in_hash'}->{'hour'} =~ /^\d+$/ && $self->{'in_hash'}->{'min'} =~ /^\d+$/ &&
	$self->{'in_hash'}->{'day'} =~ /^\d+$/ && $self->{'in_hash'}->{'year'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'create_edate'});
eval { $self->{'date'} = timelocal(0, $self->{'in_hash'}->{'min'}, $self->{'in_hash'}->{'hour'},
		         $self->{'in_hash'}->{'day'}, $self->{'in_hash'}->{'month'}, $self->{'in_hash'}->{'year'}-1900) };
$@ && $self->error($self->{'text_hash'}->{'create_edate'});
$self->{'date'} > time() || $self->error($self->{'text_hash'}->{'create_efuture'});
$self->{'in_hash'}->{'cmd'} =~ s/\r//g;
$self->{'in_hash'}->{'cmd'} =~ /\S/ || $self->error($self->{'text_hash'}->{'create_ecmd'});
-d $self->{'in_hash'}->{'dir'} || $self->error($self->{'text_hash'}->{'create_edir'});

# Create the job
$self->create_atjob($self->{'in_hash'}->{'user'}, $self->{'date'}, $self->{'in_hash'}->{'cmd'}, $self->{'in_hash'}->{'dir'});
$self->webmin_log("create", "job", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

