#!/usr/bin/perl
package chfn::LinuxLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'chfn::LinuxLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# linux-lib.pl
# Functions for changing user details on linux

1;

1;
		return $self;
}

# change_details(realname, office, ophone, hphone)
sub change_details
{
	my $self = shift;

foreach $a (@_) {
	$a =~ s/\\//g;
	$a =~ s/'//g;
	}

# What version of chfn are we running?
local @ruser = getpwnam($self->{'remote_user'});
local @uinfo = split(/,/, $ruser[6]);
local $out = `chfn -v 2>&1`;
local $cmd;
if ($out =~ /pwdutils/i || ($out =~ /-r/ && $out =~ /-w/ && $out =~ /-h/)) {
	# Change details using chfn from pwdutils syntax
	$cmd = "chfn -f ".quotemeta($_[0]);
	$cmd .= " -r ".quotemeta($_[1]) if ($_[1] || $uinfo[1]);
	$cmd .= " -w ".quotemeta($_[2]) if ($_[2] || $uinfo[2]);
	$cmd .= " -h ".quotemeta($_[3]) if ($_[3] || $uinfo[3]);
	$cmd .= " ".quotemeta($self->{'remote_user'});
	}
else {
	# Change details using chfn from util-linux syntax
	$cmd = "chfn -f ".quotemeta($_[0]);
	$cmd .= " -o ".quotemeta($_[1]) if ($_[1] || $uinfo[1]);
	$cmd .= " -p ".quotemeta($_[2]) if ($_[2] || $uinfo[2]);
	$cmd .= " -h ".quotemeta($_[3]) if ($_[3] || $uinfo[3]);
	$cmd .= " ".quotemeta($self->{'remote_user'});
	}
local $out = `$cmd 2>&1`;
return $out if ($?);

## Change shell
#if ($ruser[8] ne $_[4]) {
#	$cmd = "chsh -s ".quotemeta($_[4])." ".quotemeta($self->{'remote_user'});
#	$out = `$cmd 2>&1`;
#	return $? ? $out : undef;
#	}
return undef;
}


1;

