#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save.cgi
# Change the user's details and shell

&ModuleLoader::preload_module('chfn_class', "chfn::ChfnLib");
$self = new chfn::ChfnLib:: 'chfn_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err'});

# Force current values for those that can't be changed
@{$self->{'remote_user_info_array'}} = getpwnam($self->{'remote_user'});
@uinfo = split(/,/, $self->{'remote_user_info_array'}->[6]);
$self->{'in_hash'}->{'real'} = $uinfo[0] if (!$self->{'config_hash'}->{'change_real'});
$self->{'in_hash'}->{'office'} = $uinfo[1] if (!$self->{'config_hash'}->{'change_office'});
$self->{'in_hash'}->{'ophone'} = $uinfo[2] if (!$self->{'config_hash'}->{'change_ophone'});
$self->{'in_hash'}->{'hphone'} = $uinfo[3] if (!$self->{'config_hash'}->{'change_hphone'});

# Make sure values are set
$self->{'in_hash'}->{'real'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_ereal2'});

# Validate inputs
$self->{'in_hash'}->{'real'} =~ /[,:]/ && $self->error($self->{'text_hash'}->{'save_ereal'});
$self->{'in_hash'}->{'office'} =~ /[,:]/ && $self->error($self->{'text_hash'}->{'save_eoffice'});
$self->{'in_hash'}->{'ophone'} =~ /[,:]/ && $self->error($self->{'text_hash'}->{'save_eophone'});
$self->{'in_hash'}->{'hphone'} =~ /[,:]/ && $self->error($self->{'text_hash'}->{'save_ehphone'});

# Change the details and shell

$self->{'err'} = $self->change_details($self->{'in_hash'}->{'real'}, $self->{'in_hash'}->{'office'}, $self->{'in_hash'}->{'ophone'}, $self->{'in_hash'}->{'hphone'});

$self->{'err'} && $self->error("<tt>$self->{'err'}</tt>");

$self->ui_print_header(undef, $self->{'text_hash'}->{'save_title'}, "",undef,0,1);

print $self->text('save_desc2', "<tt>$self->{'remote_user'}</tt>"),"<p>\n";

$self->ui_print_footer("",  $self->text('index_return', $self->{'t_website'}));

1;
		
}


1;

