#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move.cgi
# Move a cron job up or down

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->error_setup($self->{'text_hash'}->{'move_err'});
$self->ReadParse();

@{$self->{'jobs_array'}} = $self->list_cron_jobs();
$self->{'job'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
if ($self->{'in_hash'}->{'up'}) {
	$self->{'swap'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}-1];
	}
else {
	$self->{'swap'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}+1];
	}
$self->{'access_hash'}->{'move'} && $self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) ||
	$self->error($self->text('save_ecannot', $self->{'job'}->{'user'}));
$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'swap'}->{'user'}) ||
	$self->error($self->text('save_ecannot', $self->{'swap'}->{'user'}));
$self->{'job'}->{'file'} eq $self->{'swap'}->{'file'} &&
  ($self->{'job'}->{'type'} == 0 || $self->{'job'}->{'type'} == 3) &&
  ($self->{'swap'}->{'type'} == 0 || $self->{'swap'}->{'type'} == 3) || $self->error($self->{'text_hash'}->{'move_etype'});
$self->lock_file($self->{'job'}->{'file'});
$self->swap_cron_jobs($self->{'job'}, $self->{'swap'});
$self->unlock_file($self->{'job'}->{'file'});
$self->webmin_log("move", "cron", $self->{'job'}->{'user'});
$self->redirect("");

1;
		
}


1;

