#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_global.cgi
# Edit options for all poll sections in a file

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title'}, "");

if ($self->{'config_hash'}->{'config_file'}) {
	$self->{'file'} = $self->{'config_hash'}->{'config_file'};
	}
else {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'poll_ecannot'});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/.fetchmailrc";
	}
@{$self->{'conf_array'}} = $self->parse_config_file($self->{'file'});
foreach $c (@{$self->{'conf_array'}}) {
	$self->{'poll'} = $c if ($c->{'defaults'});
	}

print "<form action=save_global.cgi>\n";
print "<input type=hidden name=file value='$self->{'file'}'>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";

# Show default server options
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'global_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'poll_proto'}</b></td>\n";
print "<td><select name=proto>\n";
printf "<option value='' %s> %s\n",
	$self->{'poll'}->{'proto'} ? '' : 'selected', $self->{'text_hash'}->{'default'};
foreach $p ('pop3', 'pop2', 'imap', 'imap-k4', 'imap-gss', 'apop', 'kpop') {
	printf "<option value=%s %s>%s\n",
		$p, lc($self->{'poll'}->{'proto'}) eq $p ? 'selected' : '', uc($p);
	$self->{'found'}++ if (lc($self->{'poll'}->{'proto'}) eq $p);
	}
printf "<option value=%s selected>%s\n", $self->{'poll'}->{'proto'}, uc($self->{'poll'}->{'proto'})
	if (!$self->{'found'} && $self->{'poll'}->{'proto'});
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'poll_port'}</b></td>\n";
printf "<td><input type=radio name=port_def value=1 %s> %s\n",
	$self->{'poll'}->{'port'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=port_def value=0 %s> %s\n",
	$self->{'poll'}->{'port'} ? 'checked' : '';
printf "<input name=port size=8 value='%s'></td> </tr>\n",
	$self->{'poll'}->{'port'};

@{$self->{'interface_array'}} = split(/\//, $self->{'poll'}->{'interface'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'poll_interface'}</b></td><td colspan=3>\n";
printf "<input type=radio name=interface_def value=1 %s> %s<br>\n",
	@{$self->{'interface_array'}} ? '' : 'checked', $self->{'text_hash'}->{'poll_interface_def'};
printf "<input type=radio name=interface_def value=0 %s> %s\n",
	@{$self->{'interface_array'}} ? 'checked' : '', $self->{'text_hash'}->{'poll_interface_ifc'};
print "<input name=interface size=8 value='$self->{'interface_array'}->[0]'> ",
      "$self->{'text_hash'}->{'poll_interface_ip'}\n";
print "<input name=interface_net size=15 value='$self->{'interface_array'}->[1]'> /\n";
print "<input name=interface_mask size=15 value='$self->{'interface_array'}->[2]'></td> </tr>\n";

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
print "</tr></table>\n";

if (!$self->{'fetchmail_config'} && $self->{'config_hash'}->{'view_mode'}) {
	$self->ui_print_footer("edit_user.cgi?user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'user_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

