#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several selected filters

&ModuleLoader::preload_module('filter_class', "filter::FilterLib");
$self = new filter::FilterLib:: 'filter_class',%$self;

$self->ReadParse();

# Validate selection
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Do it
$self->lock_file($main::procmail_object->{'procmailrc'});
@{$self->{'filters_array'}} = $self->list_filters();
foreach $d (sort { $b <=> $a } @d) {
	$self->{'filter'} = $self->{'filters_array'}->[$d];
	$self->delete_filter($self->{'filter'});
	}
$self->unlock_file($main::procmail_object->{'procmailrc'});

$self->redirect("");

1;
		
}


1;

