#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ffile.cgi
# Allow editing of a filter config file

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'ffile_title'}, "");
$self->{'in_hash'}->{'vfile'} = $self->make_absolute($self->{'in_hash'}->{'vfile'});
open(FILE, $self->{'in_hash'}->{'vfile'});
while(<FILE>) {
	s/\r|\n//g;
	if (/^(\S+)\s+(\S+)\s+(\S+)\s+(.*)$/) {
		push(@{$self->{'filter_array'}}, [ $1, $2, $3, $4 ]);
		}
	elsif (/^(2)\s+(\S+)$/) {
		$self->{'other'} = $2;
		}
	}
close(FILE);

print "<b>",$self->text('ffile_desc', "<tt>$self->{'in_hash'}->{'vfile'}</tt>"),"</b><p>\n";

print "<form action=save_ffile.cgi method=post enctype=multipart/form-data>\n";
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_hidden("num", $self->{'in_hash'}->{'num'}),"\n";
print $self->ui_hidden("vfile", $self->{'in_hash'}->{'vfile'}),"\n";

$self->{'i'} = 0;
foreach $f (@{$self->{'filter_array'}}, [ 1, '', '', '' ]) {
	$self->{'field'} = "<select name=field_$self->{'i'}>\n";
	foreach $ft ('', 'from', 'to', 'subject', 'cc', 'body') {
		$self->{'field'} .= sprintf "<option value='%s' %s>%s\n",
			$ft, $f->[2] eq $ft ? "selected" : "",
			$ft ? $self->{'text_hash'}->{"ffile_$ft"} : "&nbsp";
		}
	$self->{'field'} .= "</select>\n";

	$self->{'what'} = "<select name=what_$self->{'i'}>\n";
	$self->{'what'} .= sprintf "<option value=0 %s>%s\n",
		$f->[0] == 0 ? "selected" : "", $self->{'text_hash'}->{"ffile_what0"};
	$self->{'what'} .= sprintf "<option value=1 %s>%s\n",
		$f->[0] == 1 ? "selected" : "", $self->{'text_hash'}->{"ffile_what1"};
	$self->{'what'} .= "</select>\n";

	$self->{'match'} = "<input name=match_$self->{'i'} size=20 value='$f->[3]'>\n";

	$self->{'action'} = "<input name=action_$self->{'i'} size=20 value='$f->[1]'>\n";

	print $self->text('ffile_line', $self->{'field'}, $self->{'what'}, $self->{'match'}, $self->{'action'}),"<br>\n";
	$self->{'i'}++;
	}
print $self->text('ffile_other',
	    "<input name=other size=30 value='$self->{'other'}'>"),"<br>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_alias.cgi?num=$self->{'in_hash'}->{'num'}&file=$self->{'in_hash'}->{'file'}",
		 $self->{'text_hash'}->{'aform_return'});

1;
		
}


1;

