#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_rfile.cgi
# Display the contents of an autoreply file

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'rfile_title'}, "");
$self->{'in_hash'}->{'vfile'} = $self->make_absolute($self->{'in_hash'}->{'vfile'});
open(FILE, $self->{'in_hash'}->{'vfile'});
while(<FILE>) {
	if (/^Reply-Tracking:\s*(.*)/) {
		$self->{'replies'} = $1;
		}
	elsif (/^Reply-Period:\s*(.*)/) {
		$self->{'period'} = $1;
		}
	elsif (/^No-Autoreply:\s*(.*)/) {
		$self->{'no_autoreply'} = $1;
		}
	elsif (/^From:\s*(.*)/) {
		$self->{'from'} = $1;
		}
	else {
		push(@{$self->{'lines_array'}}, $_);
		}
	}
close(FILE);
if (!-r $self->{'in_hash'}->{'vfile'}) {
	($self->{'froms'}, $self->{'doms'}) = $main::mailbox_object->list_from_addresses();
	$self->{'from'} = $self->{'froms'}->[0];
	}

print $self->text('rfile_desc', "<tt>$self->{'in_hash'}->{'vfile'}</tt>"),"<p>\n";
print "$self->{'text_hash'}->{'rfile_desc2'}<p>\n";

print "<form action=save_rfile.cgi method=post enctype=multipart/form-data>\n";
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_hidden("num", $self->{'in_hash'}->{'num'}),"\n";
print $self->ui_hidden("vfile", $self->{'in_hash'}->{'vfile'}),"\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";

print "<table>\n";

# Show From: address option
print "<tr> <td>$self->{'text_hash'}->{'rfile_from'}</td>\n";
printf "<td><input type=radio name=from_def value=1 %s> %s\n",
	$self->{'from'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_auto'};
printf "<input type=radio name=from_def value=0 %s>\n",
	$self->{'from'} eq '' ? "" :"checked";
printf "<input name=from size=30 value='%s'></td> </tr>\n",
	$self->{'from'};
print "<tr> <td></td> <td><font size=-1>$self->{'text_hash'}->{'rfile_fromdesc'}</font></td> </tr>\n";

# Show reply-tracking option
printf "<tr> <td colspan=2><input type=checkbox name=replies value=1 %s> %s</td> </tr>\n",
	$self->{'replies'} ? "checked" : "", $self->{'text_hash'}->{'rfile_replies'};
print "<input type=hidden name=replies_file value='$self->{'replies'}'>\n";

# Show reply period input
print "<tr> <td>&nbsp;&nbsp;&nbsp;$self->{'text_hash'}->{'rfile_period'}</td>\n";
printf "<td><input type=radio name=period_def value=1 %s> %s\n",
	$self->{'period'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_default'};
printf "<input type=radio name=period_def value=0 %s>\n",
	$self->{'period'} eq '' ? "" :"checked";
printf "<input name=period size=5 value='%s'> %s</td> </tr>\n",
	$self->{'period'}, $self->{'text_hash'}->{'rfile_secs'};

# Show people to not autoreply to
print "<tr> <td>$self->{'text_hash'}->{'rfile_no_autoreply'}</td>\n";
printf "<td><input name=no_autoreply size=40 value='%s'></td> </tr>\n",
	$self->{'no_autoreply'};

print "</table>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'rfile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_alias.cgi?num=$self->{'in_hash'}->{'num'}&file=$self->{'in_hash'}->{'file'}",
		 $self->{'text_hash'}->{'aform_return'});

1;
		
}


1;

