#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save simple email forwarding options

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->error_setup($self->{'text_hash'}->{'simple_err'});
$self->ReadParse();

# Validate and store inputs
$self->{'simple'} = $self->get_simple();
$self->{'simple'}->{'local'} = $self->{'in_hash'}->{'local'};
if ($self->{'in_hash'}->{'forward'}) {
	$self->{'in_hash'}->{'forwardto'} || $self->error($self->{'text_hash'}->{'simple_eforward'});
	$self->{'in_hash'}->{'forwardto'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'simple_eforward2'});
	$self->{'simple'}->{'forward'} = $self->{'in_hash'}->{'forwardto'};
	}
else {
	delete($self->{'simple'}->{'forward'});
	}
$self->{'userconfig_hash'}->{'forwardto'} = $self->{'in_hash'}->{'forwardto'};
$self->{'in_hash'}->{'autotext'} =~ s/\r//g;
if ($self->{'in_hash'}->{'autotext'}) {
	$self->{'simple'}->{'autotext'} = $self->{'in_hash'}->{'autotext'};
	if (!$self->{'simple'}->{'from'}) {
		($self->{'froms'}, $self->{'doms'}) = $main::mailbox_object->list_from_addresses();
		$self->{'simple'}->{'from'} = $self->{'froms'}->[0];
		}
	if ($self->{'in_hash'}->{'period_def'}) {
		delete($self->{'simple'}->{'replies'});
		delete($self->{'simple'}->{'period'});
		}
	else {
		$self->{'in_hash'}->{'period'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'simple_eperiod'});
		$self->{'simple'}->{'period'} = $self->{'in_hash'}->{'period'}*60;
		$self->{'simple'}->{'replies'} ||=
			"$user_module_config_directory/replies";
		}
	if ($self->{'in_hash'}->{'from_def'}) {
		delete($self->{'simple'}->{'from'});
		}
	else {
		$self->{'in_hash'}->{'from'} =~ /\S/ || $self->error($self->{'text_hash'}->{'simple_efrom'});
		$self->{'simple'}->{'from'} = $self->{'in_hash'}->{'from'};
		}
	}
if ($self->{'in_hash'}->{'auto'}) {
	$self->{'in_hash'}->{'autotext'} =~ /\S/ || $self->error($self->{'text_hash'}->{'simple_eautotext'});
	}
$self->{'simple'}->{'auto'} = $self->{'in_hash'}->{'auto'};

# Save attached files
if ($self->{'config_hash'}->{'attach'}) {
	$self->{'simple'}->{'autoreply_file'} = [ ];
	for($i=0; defined($self->{'f'} = $self->{'in_hash'}->{"file_$i"}); $i++) {
		next if (!$self->{'f'});
		if ($self->{'f'} !~ /^\//) {
			$self->{'f'} = "$self->{'remote_user_info_array'}->[7]/$self->{'f'}";
			}
		-r $self->{'f'} || $self->error($self->text('simple_efile', $self->{'f'}));
		$self->{'in_hash'}->{'autotext'} || $self->error($self->{'text_hash'}->{'simple_eautotextfile'});
		push(@{$self->{'simple'}->{'autoreply_file'}}, $self->{'f'});
		}
	}

# Save settings
$self->save_simple($self->{'simple'});
$self->save_user_module_config();
$self->redirect("autoresponder.cgi");

1;
		
}


1;

