#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update a vacation alias command

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'vacation_err'});

# Validate and parse args
$self->{'args'} = "";
$self->{'in_hash'}->{'aliases'} =~ s/\r//g;
foreach $a (split(/\n+/, $self->{'in_hash'}->{'aliases'})) {
	$a =~ /^\S+$/ || $self->error($self->text('vacation_ealias', $a));
	$self->{'args'} .= " -a $a";
	}
if (!$self->{'in_hash'}->{'interval_def'}) {
	$self->{'in_hash'}->{'interval'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'vacation_einterval'});
	$self->{'args'} .= " -r $self->{'in_hash'}->{'interval'}";
	}
if (!$self->{'in_hash'}->{'msg_def'}) {
	$self->{'in_hash'}->{'msg'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'vacation_emsg'});
	$self->{'args'} .= " -m $self->{'in_hash'}->{'msg'}";
	}
foreach $u (split(/\0/, $self->{'in_hash'}->{'unknown'})) {
	$self->{'args'} .= " $u";
	}
if ($self->{'in_hash'}->{'user_def'}) {
	$self->{'args'} .= " $self->{'remote_user'}";
	}
else {
	$self->{'in_hash'}->{'user'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'vacation_euser'});
	$self->{'args'} .= " $self->{'in_hash'}->{'user'}";
	}

# Update actual alias
if ($self->{'config_hash'}->{'mail_system'} == 0) {
	@{$self->{'aliases_array'}} = $self->list_aliases();
	$a = $self->{'aliases_array'}->[$self->{'in_hash'}->{'num'}];
	}
else {
	$a = $self->get_dotqmail($self->{'in_hash'}->{'file'});
	}
$a->{'values'}->[$self->{'in_hash'}->{'idx'}] = "|$self->{'vacation_path'}$self->{'args'}";
$self->modify_alias($a, $a);
$self->redirect("edit_alias.cgi?num=$self->{'in_hash'}->{'num'}file=$self->{'in_hash'}->{'file'}");

1;
		
}


1;

