#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display main menu of GNUPG options

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 0, 1);

if (!$self->has_command($self->{'gpgpath'})) {
	print $self->text('index_egpg', "<tt>$self->{'gpgpath'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'keys_array'}} = $self->list_keys();
if (!@{$self->{'keys_array'}}) {
	# Offer to setup GNUPG
	print "$self->{'text_hash'}->{'index_setupdesc'}<br>\n";
	print "<form action=secret.cgi method=post>\n";
	print "<table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_name'}</b></td>\n";
	$self->{'remote_user_info_array'}->[6] =~ s/,.*$//;
	print "<td><input name=name size=30 value='$self->{'remote_user_info_array'}->[6]'></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_email'}</b></td>\n";
	print "<td><input name=email size=30></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_comment'}</b></td>\n";
	print "<td><input name=comment size=30></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_size'}</b></td>\n";
	print "<td><select name=size>\n";
	print "<option selected value=''>$self->{'text_hash'}->{'default'}\n";
	foreach $s (768, 1024, 2048, 4096, 8192) {
		print "<option>$s\n";
		}
	print "</select></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_pass'}</b></td>\n";
	print "<td><input name=pass type=password size=20></td> </tr>\n";
	print "</table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_setup'}'></form>\n";
	}
else {
	# Show table of options
	@{$self->{'links_array'}} = ( "list_keys.cgi", "edit_encrypt.cgi", "edit_decrypt.cgi",
		   "edit_sign.cgi", "edit_verify.cgi", "edit_secret.cgi" );
	@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'keys_title'}, $self->{'text_hash'}->{'encrypt_title'},
		    $self->{'text_hash'}->{'decrypt_title'}, $self->{'text_hash'}->{'sign_title'},
		    $self->{'text_hash'}->{'verify_title'}, $self->{'text_hash'}->{'secret_title'} );
	@{$self->{'icons_array'}} = ( "images/keys.gif", "images/encrypt.gif", "images/decrypt.gif",
		   "images/sign.gif", "images/verify.gif", "images/secret.gif" );
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, scalar(@{$self->{'links_array'}}));
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

