#!/usr/bin/perl

&MAIN();

 sub MAIN {
# recv.cgi
# Fetch a key from the keyserver

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'recv_title'}, "");

$self->{'in_hash'}->{'id'} =~ s/^0x//i;
print "<p>",$self->text('recv_desc', $self->{'in_hash'}->{'id'},
		  "<tt>$self->{'config_hash'}->{'keyserver'}</tt>"),"<p>\n";

$self->{'cmd'} = "$self->{'gpgpath'} --keyserver '$self->{'config_hash'}->{'keyserver'}' --recv-key '$self->{'in_hash'}->{'id'}'";
$self->{'out'} = `$self->{'cmd'} 2>&1`;
if ($?) {
	print "<p>",$self->text('recv_failed', "<pre>$self->{'out'}</pre>"),"<p>\n";
	}
else {
	@{$self->{'keys_array'}} = $self->list_keys();
	($self->{'key'}) = grep { lc($_->{'key'}) eq lc($self->{'in_hash'}->{'id'}) } @{$self->{'keys_array'}};
	if (!$self->{'key'}) {
		print "<p>",$self->text('recv_failed', "<pre>$self->{'out'}</pre>"),"<p>\n";
		}
	elsif ($self->{'out'} =~ /not changed/i) {
		print "<p>",$self->text('recv_same', $self->{'key'}->{'name'}->[0]),"<p>\n";
		}
	else {
		print "<p>",$self->text('recv_success', $self->{'key'}->{'name'}->[0]),"<p>\n";
		}
	}

if ($self->{'in_hash'}->{'return'}) {
	$self->ui_print_footer($self->{'in_hash'}->{'return'}, $self->{'in_hash'}->{'returnmsg'});
	}
else {
	$self->ui_print_footer("list_keys.cgi", $self->{'text_hash'}->{'keys_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

