#!/usr/bin/perl

&MAIN();

 sub MAIN {
# sign.cgi
# Sign a file and output the result

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParseMime();

if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'sign_eupload'});
	$self->{'data'} = $self->{'in_hash'}->{'upload'};
	}
else {
	$self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'sign_eupload'});
	-r $self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'sign_elocal'});
	$self->{'data'} = $self->read_entire_file($self->{'in_hash'}->{'local'});
	}

@{$self->{'keys_array'}} = $self->list_keys();
$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];
$self->{'pass'} = $self->get_passphrase($self->{'key'});
if (!defined($self->{'pass'})) {
	$self->error($self->{'text_hash'}->{'sign_epass'}.". ".
	  $self->text('gnupg_canset', "/gnupg/edit_key.cgi?idx=$self->{'in_hash'}->{'idx'}").".");
	}

$self->{'rv'} = $self->sign_data($self->{'data'}, \$self->{'signed'}, $self->{'key'}, $self->{'in_hash'}->{'sep'} ? 2 :
					$self->{'in_hash'}->{'ascii'} ? 1 : 0);

if ($self->{'rv'}) {
	$self->error($self->text('sign_egpg', "<pre>$self->{'rv'}</pre>"));
	}

if ($self->{'in_hash'}->{'ascii'}) {
	print "Content-type: text/plain\n\n";
	}
else {
	print "Content-type: application/octet-stream\n\n";
	}
print $self->{'signed'};

1;
		
}


1;

