#!/usr/bin/perl
package htaccess::Browsermatch;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Browsermatch');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
#  browsermatch.pl
# Functions used in mod_browser.pl and mod_setenvif.pl

1;

1;
		return $self;
}

sub edit_BrowserMatch_BrowserMatchNoCase
{
	my $self = shift;

local($d, @w, $i, @regex, @var, @val, @case, $rv);
foreach $d (@{$_[0]}, @{$_[1]}) {
	@w = @{$d->{'words'}};
	for($i=1; $i<@w; $i++) {
		push(@regex, $w[0]);
		if ($w[$i] =~ /^\!(\S+)$/) { push(@var, $1); push(@val, undef); }
		elsif ($w[$i] =~ /^(\S+)=(\S*)$/) { push(@var, $1); push(@val, $2); }
		else { push(@var, $w[$i]); push(@val, 1); }
		if ($d->{'name'} eq "BrowserMatch") { push(@case, 1); }
		else { push(@case, 0); }
		}
	}
push(@regex, ""); push(@var, ""); push(@val, ""); push(@case, 0);
$rv = "<table border>\n".
      "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'browsermatch_regexp'}</b></td> <td><b>$self->{'text_hash'}->{'browsermatch_case'}</b></td>\n".
      "<td><b>$self->{'text_hash'}->{'browsermatch_var'}</b></td> <td><b>$self->{'text_hash'}->{'browsermatch_value'}</b></td> </tr>\n";
for($i=0; $i<@regex; $i++) {
	$rv .= "<tr $self->{'cb'}>\n";
	$rv .= sprintf
	        "<td><input size=20 name=Browser_regex_$i value=\"%s\"></td>\n",
	        $regex[$i];
	$rv .= "<td>".$self->choice_input($case[$i], "Browser_case_$i", 1,
	       "$self->{'text_hash'}->{'yes'},1", "$self->{'text_hash'}->{'no'},0")."</td>\n";
	$rv .= sprintf
	        "<td><input size=20 name=Browser_var_$i value=\"%s\"></td>\n",
	        $var[$i];
	$rv .= "<td>".$self->opt_input($val[$i], "Browser_val_$i",
				 "$self->{'text_hash'}->{'browsermatch_clear'}", 10)."</td>\n";
	$rv .= "</tr>\n";
	}
$rv .= "</table>\n";
return (2, "$self->{'text_hash'}->{'browsermatch_txt'}", $rv);
}

sub save_BrowserMatch_BrowserMatchNoCase
{
	my $self = shift;

local($i, $regex, $case, $var, $val, $set, $lastbm, $lastbmnc, @bm, @bmnc);
for($i=0; defined($regex = $self->{'in_hash'}->{"Browser_regex_$i"}); $i++) {
	$case = $self->{'in_hash'}->{"Browser_case_$i"}; $var = $self->{'in_hash'}->{"Browser_var_$i"};
	if ($regex !~ /\S/ && $var !~ /\S/) { next; }
	$var =~ /^\S+$/ || $self->error($self->text('browsermatch_evar', $var));
	$val = $self->{'in_hash'}->{"Browser_val_$i"};
	$set = $self->{'in_hash'}->{"Browser_val_${i}_def"} ? "!$var" :
		$val eq "1" ? $var : "$var=$val";
	if ($case) {
		if ($regex eq $lastbm) { $bm[$#bm] .= " $set"; }
		else { push(@bm, "\"$regex\" $set"); }
		$lastbm = $regex;
		}
	else {
		if ($regex eq $lastbmnc) { $bmnc[$#bmnc] .= " $set"; }
		else { push(@bmnc, "\"$regex\" $set"); }
		$lastbmnc = $regex;
		}
	}
return ( \@bm, \@bmnc );
}


1;

