#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create.cgi
# Create a .htaccess file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();

if (-d $self->{'in_hash'}->{'dir'}) {
	$self->{'file'} = "$self->{'in_hash'}->{'dir'}/$self->{'config_hash'}->{'htaccess'}";
	}
else {
	$self->{'file'} = $self->{'in_hash'}->{'dir'};
	}

if (!-r $self->{'file'}) {
	open(HTACCESS, ">$self->{'file'}") || $self->error($!);
	close(HTACCESS) || $self->error($!);
	chmod(0755, $self->{'file'});
	}

@{$self->{'files_array'}} = $self->get_htaccess_files();
@{$self->{'files_array'}} = $self->unique(@{$self->{'files_array'}}, $self->{'file'});
$self->set_htaccess_files($self->{'file'});

$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'file'}));

1;
		
}


1;

