#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_files.cgi
# Create an empty <Files> clause in a .htaccess file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
$self->{'lref'} = $self->read_file_lines($self->{'in_hash'}->{'file'});
if ($self->{'in_hash'}->{'regexp'}) {
	if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
		$self->{'newdir'} = "<FilesMatch \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</FilesMatch>";
		}
	else {
		$self->{'newdir'} = "<Files ~ \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</Files>";
		}
	}
else {
	$self->{'newdir'} = "<Files \"$self->{'in_hash'}->{'path'}\">";
	$self->{'enddir'} = "</Files>";
	}
push(@{$self->{'lref'}}, $self->{'newdir'});
push(@{$self->{'lref'}}, $self->{'enddir'});
$self->flush_file_lines();
$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

