#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find.cgi
# Find .htaccess files

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();

# Search for files
open(FIND, "find '$self->{'in_hash'}->{'dir'}' -name '$self->{'config_hash'}->{'htaccess'}' -print 2>/dev/null |");
while(<FIND>) {
	s/\r|\n//g;
	push(@{$self->{'found_array'}}, $_);
	}
close(FIND);

# Save and tell the user
@{$self->{'files_array'}} = $self->get_htaccess_files();
@{$self->{'files_array'}} = $self->unique(@{$self->{'files_array'}}, @{$self->{'found_array'}});
$self->set_htaccess_files(@{$self->{'files_array'}});

$self->ui_print_header(undef, $self->{'text_hash'}->{'find_title'}, "");

if (@{$self->{'found_array'}}) {
	print "<b>",$self->text('find_list', "<tt>$self->{'in_hash'}->{'dir'}</tt>"),"</b><p>\n";
	foreach $f (@{$self->{'found_array'}}) {
		print "<tt>$f</tt><br>\n";
		}
	}
else {
	print "<b>",$self->text('find_none', "<tt>$self->{'config_hash'}->{'htaccess'}</tt>",
			     "<tt>$self->{'in_hash'}->{'dir'}</tt>"),"</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

