#!/usr/bin/perl

&MAIN();

 sub MAIN {
# htaccess_index.cgi
# Display a menu of icons for a per-directory options file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'desc'} = "<tt>".$self->html_escape($self->{'in_hash'}->{'file'})."</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'htindex_title'}, "",
	undef, undef, undef, undef, "<a href=\"delete_htaccess.cgi?file=".
	$self->urlize($self->{'in_hash'}->{'file'})."\">$self->{'text_hash'}->{'htindex_delete'}</a>");

print $self->ui_subheading($self->{'text_hash'}->{'htindex_opts'});
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'htindex_show'},
	     "link" => "show.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}) };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'htindex_edit'},
	     "link" => "manual_form.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}) };
$self->config_icons("htaccess", "edit_htaccess.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&",
	      $self->{'sw_icon'}, $self->{'ed_icon'} ? ( $self->{'ed_icon'} ) : ( ));

@{$self->{'file_array'}} = ( $self->find_directive_struct("Files", $self->{'conf'}),
          $self->find_directive_struct("FilesMatch", $self->{'conf'}) );
if (@{$self->{'file_array'}} && $self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	# Files sub-directives
	print "<hr>\n";
	print $self->ui_subheading($self->{'text_hash'}->{'htindex_file'});
	print "<table width=100% cellpadding=5>\n";
	foreach $f (@{$self->{'file_array'}}) {
		if ($self->{'i'}%3 == 0) { print "<tr>\n"; }
		$self->{'what'} = $self->dir_name($f);
		substr($self->{'what'}, 0, 1) = uc(substr($self->{'what'}, 0, 1));
		print "<td valign=top align=center width=33%>\n";
		$self->generate_icon("images/dir.gif", $self->{'what'},
		       	"files_index.cgi?idx=".$self->indexof($f, @{$self->{'conf'}}).
			"&file=".$self->urlize($self->{'in_hash'}->{'file'}));
		print "</td>\n";
		if ($self->{'i'}++%3 == 2) { print "</tr>\n"; }
		}
	while($self->{'i'}++%3) { print "<td width=33%><br></td>\n"; }
	print "</table><p>\n";
	}

if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	print "<form action=create_files.cgi>\n";
	print "<input type=hidden name=file value=$self->{'in_hash'}->{'file'}>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'htindex_create'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'htindex_regexp'}</b></td>\n";
	$self->{'regex'} = $self->{'d'}->{'words'}->[0] eq "~" || $self->{'d'}->{'name'} =~ /Match/;
	printf "<td colspan=3><input type=radio name=regexp value=0 %s> %s\n",
		$self->{'regex'} ? "" : "checked", $self->{'text_hash'}->{'htindex_exact'};
	printf "<input type=radio name=regexp value=1 %s> %s</td> </tr>\n",
		$self->{'regex'} ? "checked" : "", $self->{'text_hash'}->{'htindex_re'};
	print "<tr> <td><b>$self->{'text_hash'}->{'htindex_path'}</b></td>\n";
	printf "<td><input name=path size=40 value=\"%s\"></td>\n",
		$self->{'d'}->{'words'}->[0] eq "~" ? $self->{'d'}->{'words'}->[1]
					  : $self->{'d'}->{'words'}->[0];
	print "<td colspan=2 align=right>",
	      "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
	print "</table></td></tr></table></form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

