#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_authusers.cgi
# Displays a list of users from a text file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

&ModuleLoader::preload_module('htaccess_class', "htaccess::AuthLib");
$self = new htaccess::AuthLib:: 'htaccess_class',%$self;


$self->ReadParse();
$self->{'desc'} = $self->text('authu_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authu_title'}, "");
$self->{'f'} = $self->{'in_hash'}->{'file'};

@{$self->{'users_array'}} = sort { $a cmp $b } $self->list_authusers($self->{'f'});
if (@{$self->{'users_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>",$self->text('authu_header2', "<tt>$self->{'f'}</tt>"),
	      "</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	for($i=0; $i<@{$self->{'users_array'}}; $i++) {
		$self->{'u'} = $self->{'users_array'}->[$i];
		if ($i%4 == 0) { print "<tr>\n"; }
		printf "<td width=25%><a href=\"edit_authuser.cgi?user=$self->{'u'}&".
		  "file=%s&url=%s\">$self->{'u'}</a></td>\n",
		  $self->urlize($self->{'f'}), $self->urlize($self->this_url());
		if ($i%4 == 3) { print "</tr>\n"; }
		}
	while($i++%4) { print "<td width=25%></td>\n"; }
	print "</table></td></tr></table>\n";
	}
else {
	print "<b>",$self->text('authu_none', "<tt>$self->{'f'}</tt>"),"</b><p>\n";
	}
printf "<a href=\"edit_authuser.cgi?file=%s&url=%s\">%s</a><p>\n",
        $self->urlize($self->{'f'}), $self->urlize($self->this_url()), $self->{'text_hash'}->{'authu_add'};

$self->ui_print_footer($self->{'in_hash'}->{'url'}, $self->{'text_hash'}->{'auth_return'});

1;
		
}


1;

