#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display a form for editing or creating a htpasswd user

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->ReadParse();
@{$self->{'dirs_array'}} = $self->list_directories();
($self->{'dir'}) = grep { $_->[0] eq $self->{'in_hash'}->{'dir'} } @{$self->{'dirs_array'}};
$self->can_access_dir($self->{'dir'}->[0]) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
$self->switch_user();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'user'} = { 'enabled' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'users'} = $self->{'dir'}->[2] == 3 ? $self->list_digest_users($self->{'dir'}->[1])
				: $self->list_users($self->{'dir'}->[1]);
	$self->{'user'} = $self->{'users'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_user.cgi method=post>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=dir value='$self->{'in_hash'}->{'dir'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table cellpadding=3>\n";

# Username
print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
printf "<td><input name=htuser size=20 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'user'}->{'user'});

# User enabled?
print "<tr> <td><b>$self->{'text_hash'}->{'edit_enabled'}</b></td>\n";
printf "<td><input type=radio name=enabled value=1 %s> %s\n",
	$self->{'user'}->{'enabled'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=enabled value=0 %s> %s</td> </tr>\n",
	$self->{'user'}->{'enabled'} ? "" : "checked", $self->{'text_hash'}->{'no'};

# Password
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_pass'}</b></td> <td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<input type=radio name=htpass_def value=1 checked> ",
	      "$self->{'text_hash'}->{'edit_pass1'}<br>\n";
	print "<input type=radio name=htpass_def value=0> ",
	      "$self->{'text_hash'}->{'edit_pass0'}\n";
	}
print "<input type=password name=htpass size=20></td> </tr>\n";

if ($self->{'dir'}->[2] == 3) {
	# Digest realm
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_dom'}</b></td>\n";
	printf "<td><input name=dom size=20 value='%s'></td> </tr>\n",
		$self->html_escape($self->{'user'}->{'dom'});
	}

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

