#!/usr/bin/perl

&MAIN();

 sub MAIN {
# address_chooser.cgi
# Display a list of entries from the address book
# XXX fix up ifield problem

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

$self->popup_header($self->{'text_hash'}->{'address_choose'});
print <<EOF;
<script>
function makeaddress(a, n)
{
if (n == "") {
	// An address without a name
	return "<"+a+">";
	}
else if (n.indexOf(",") != -1) {
	// A name with a comma in it
	return "\\""+n+"\\" <"+a+">";
	}
else {
	// A name without a comma
	return n+" <"+a+">";
	}
}

// Add an address to the list
function newaddress(a, n)
{
av = makeaddress(a, n);
if (top.opener.ifield.value == "") {
	top.opener.ifield.value = av;
	}
else {
	top.opener.ifield.value += ","+av;
	}
}

// Remove an address from the list
function oldaddress(a, n)
{
av = makeaddress(a, n);
curr = top.opener.ifield.value;
idx1 = curr.indexOf(av+",");
idx2 = curr.indexOf(","+av);
if (curr == av) {
	// Address only!
	curr = "";
	}
else if (idx1 != -1) {
	// Found the address, in string
	curr = curr.substring(0, idx1)+curr.substring(idx1+av.length+1);
	}
else if (idx2 != -1) {
	// Found the ,address in string
	curr = curr.substring(0, idx2)+curr.substring(idx2+av.length+1);
	}
else {
	// Look for address only
	sp = curr.split(",");
	curr = "";
	for(j=0; j<sp.length; j++) {
		if (sp[j].indexOf(a) == -1) {
			if (curr == "") {
				curr = sp[j];
				}
			else {
				curr += ","+sp[j];
				}
			}
		}
	}
top.opener.ifield.value = curr;
}

// Called when an address has been clicked on
function clickaddress(a, n, f)
{
if (f.checked) {
	newaddress(a, n);
	}
else {
	oldaddress(a, n);
	}
}

function select(a, n)
{
if ($self->{'in_hash'}->{'mode'} == 2) {
	// Strip off domain
	at = a.indexOf("@");
	if (at > 0)
		a = a.substr(0, at);
	}
if (top.opener.rfield != null) {
	// Put real name in separate field
	top.opener.ifield.value = a;
	top.opener.rfield.value = n;
	}
else {
	// Combine to single field
	if (n == "") {
		av = "<"+a+">";
		}
	else {
		av = n+" <"+a+">";
		}
	top.opener.ifield.value = av;
	}
window.close();
}
</script>
EOF
@{$self->{'addrs_array'}} = $self->list_addresses();
if ($self->{'in_hash'}->{'mode'}) {
	@{$self->{'addrs_array'}} = grep { $_->[3] } @{$self->{'addrs_array'}};
	$self->{'addrs_count'} = scalar(@{$self->{'addrs_array'}});
	}
else {
	if (!$self->{'uconfig_hash'}->{'from_in_to'}) {
		@{$self->{'addrs_array'}} = grep { !$_->[3] } @{$self->{'addrs_array'}};
		}
	$self->{'addrs_count'} = scalar(@{$self->{'addrs_array'}});
	foreach $a ($self->list_address_groups()) {
		push(@{$self->{'addrs_array'}}, [ $a->[0] ]);
		$self->{'mems_hash'}->{$a->[0]} = [ $self->split_addresses($a->[1]) ];
		}
	}
if (@{$self->{'addrs_array'}}) {
	local @sp = $self->split_addresses($self->decode_mimewords($self->{'in_hash'}->{'addr'}));
	for($i=0; $i<@sp; $i++) {
		$self->{'infield_hash'}->{$sp[$i]->[0]} = $i;
		}
	print "<form><table width=100%>\n";
	print "<tr>\n";
	print "<td><br></td>\n" if (!$self->{'in_hash'}->{'mode'});
	print "<td><b>$self->{'text_hash'}->{'address_addr'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'address_name'}</b></td> </tr>\n";
	$i = 0;
	foreach $a (@{$self->{'addrs_array'}}) {
		if ($i == $self->{'addrs_count'} && $i) {
			print "<tr> <td><br></td>\n";
			print "<td><b>$self->{'text_hash'}->{'address_group'}</b></td>\n";
			print "<td><b>$self->{'text_hash'}->{'address_members'}</b></td></tr>\n";
			}
		print "<tr>\n";
		if ($self->{'in_hash'}->{'mode'} == 0) {
			printf "<td><input type=checkbox name=addr_$i value='%s' onClick='clickaddress(\"%s\", \"%s\", this)' %s>", $self->html_escape($a->[1]), $self->html_escape($a->[0]), $self->html_escape($a->[1]), defined($self->{'infield_hash'}->{$a->[0]}) ? "checked" : "";
			$self->{'href'} = "<a href='' onClick='cb = document.forms[0].addr_$i; cb.checked = !cb.checked; clickaddress(\"".$self->html_escape($a->[0])."\", \"".$self->html_escape($a->[1])."\", cb); return false'>";
			}
		else {
			$self->{'href'} = "<a href='' onClick='select(\"".$self->html_escape($a->[0])."\", \"".$self->html_escape($a->[1])."\"); return false'>";
			}
		if ($i >= $self->{'addrs_count'}) {
			print "<td>$self->{'href'}",$a->[0],"</a></td>\n";
			local $m = @{$self->{'mems_hash'}->{$a->[0]}};
			print "<td>$self->{'href'}",$self->text('address_m', $m),"</a></td>\n";
			}
		else {
			print "<td>$self->{'href'}$a->[0]</a></td>\n";
			print "<td>$self->{'href'}",($a->[1] ? $a->[1] : "<br>"),"</a></td>\n";
			}
		print "</tr>\n";
		$i++;
		}
	print "</table></form>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'address_none'}</b> <p>\n";
	}
$self->popup_footer();

1;
		
}


1;

