#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Copy (or move) all messages from one folder to another

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
$self->{'dest'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'dest'}];

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'copy_title'}, "");

print $self->text('copy_doing', $self->{'folder'}->{'name'}, $self->{'dest'}->{'name'}),"<p>\n";
$self->mailbox_copy_folder($self->{'folder'}, $self->{'dest'});
print $self->{'text_hash'}->{'copy_done'},"<p>\n";

if ($self->{'in_hash'}->{'move'}) {
	print $self->text('copy_deleting', $self->{'folder'}->{'name'}),"<p>\n";
	$self->mailbox_empty_folder($self->{'folder'});
	print $self->{'text_hash'}->{'copy_done'},"<p>\n";
	}

$self->ui_print_footer($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
					     : "list_folders.cgi",
		 $self->{'text_hash'}->{'folders_return'});
1;
		
}


1;

