#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for copying or moving all email to another folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];

$self->ui_print_header(undef, $self->{'text_hash'}->{'copy_title'}, "");

print $self->ui_form_start("copy.cgi");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->{'text_hash'}->{'copy_header'}, undef, 2);

# Source folder
print $self->ui_table_row($self->{'text_hash'}->{'copy_source'}, $self->{'folder'}->{'name'});

# Destination folder
@{$self->{'dfolders_array'}} = grep { !$_->{'nowrite'} && $_->{'index'} != $self->{'folder'}->{'index'} }
		 $self->list_folders_sorted();
print $self->ui_table_row($self->{'text_hash'}->{'copy_dest'},
	    $self->ui_select("dest", undef, 
		       [ map { [ $_->{'index'}, $_->{'name'} ] } @{$self->{'dfolders_array'}} ]));

# Move or copy
print $self->ui_table_row($self->{'text_hash'}->{'copy_move'},
		    $self->ui_yesno_radio("move", 0));

print $self->ui_table_end();
print $self->ui_form_end([ [ "copy", $self->{'text_hash'}->{'copy_ok'} ] ]);

$self->ui_print_footer($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
					     : "list_folders.cgi",
		 $self->{'text_hash'}->{'folders_return'});
1;
		
}


1;

