#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of folders

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'fdelete_err'});

# Get the folders
@{$self->{'folders_array'}} = $self->list_folders();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'fdelete_enone'});
foreach $d (@d) {
	push(@{$self->{'dfolders_array'}}, $self->{'folders_array'}->[$d]);
	}
$self->{'redir'} = $self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
				     : "list_folders.cgi";

if ($self->{'in_hash'}->{'confirm'}) {
	# Do the deletion
	foreach $f (@{$self->{'dfolders_array'}}) {
		$self->delete_folder($f);
		}
	$self->redirect($self->{'redir'});
	}
else {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fdelete_title'}, "");

	# Get the total folder size, where mail will actually be lost
	local $sz = 0;
	foreach $f (@{$self->{'dfolders_array'}}) {
		if ($d->{'type'} == 0) {
			$sz += $self->folder_size($f);
			}
		}

	print $self->ui_form_start("delete_folders.cgi");
	foreach $d (@d) {
		print $self->ui_hidden("d", $d),"\n";
		}
	print "<center><b>",
	      $self->text($sz ? 'fdelete_rusure' : 'fdelete_rusure2',
		    scalar(@{$self->{'dfolders_array'}}), $self->nice_size($sz)),"</b></center>\n";
	print "<center>",$self->ui_submit($self->{'text_hash'}->{'fdelete_delete'}, "confirm"),
	      "</center>\n";
	print $self->ui_form_end();

	$self->ui_print_footer($self->{'redir'}, $self->{'text_hash'}->{'folders_return'});
	}

1;
		
}


1;

