#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_mail.cgi
# Delete, mark, move or copy multiple messages

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'deleteboth_array'}} = sort { $a <=> $b } split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];

if (!$self->{'in_hash'}->{'new'} && !$self->{'in_hash'}->{'mark1'} && !$self->{'in_hash'}->{'mark2'}) {
	# Get the messages
	@{$self->{'delmail_array'}} = $self->messages_from_indexes($self->{'folder'}, \@{$self->{'deleteboth_array'}});
	}

if ($self->{'in_hash'}->{'mark1'} || $self->{'in_hash'}->{'mark2'}) {
	# Marking emails with some status
	@{$self->{'deleteboth_array'}} || $self->error($self->{'text_hash'}->{'delete_emnone'});
	$self->open_read_hash();
	local $m = $self->{'in_hash'}->{'mark1'} ? $self->{'in_hash'}->{'mode1'} : $self->{'in_hash'}->{'mode2'};
	foreach $h (@{$self->{'deleteboth_array'}}) {
		local ($hi, $hid) = split(/\//, $h);
		if ($m) {
			$self->{'read_hash'}->{$hid} = $m;
			}
		else {
			delete($self->{'read_hash'}->{$hid});
			}
		}
	dbmclose(%{$self->{'read_hash'}});
	$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $self->{'userconfig_hash'}->{'perpage'};
	#$s = int((@mail - $delete[0] - 1) / $self->{'perpage'}) * $self->{'perpage'};
	$self->redirect("index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}");
	}
elsif ($self->{'in_hash'}->{'move1'} || $self->{'in_hash'}->{'move2'}) {
	# Moving mails to some other folder
	$self->error_setup($self->{'text_hash'}->{'delete_errm'});
	@{$self->{'delmail_array'}} || $self->error($self->{'text_hash'}->{'delete_emnone'});
	$self->{'mfolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'move1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'}];
	$self->{'mfolder'}->{'noadd'} && $self->error($self->{'text_hash'}->{'delete_enoadd'});
	$self->lock_folder($self->{'folder'});
	$self->lock_folder($self->{'mfolder'});
	$self->mailbox_move_mail($self->{'folder'}, $self->{'mfolder'}, @{$self->{'delmail_array'}});
	$self->unlock_folder($self->{'mfolder'});
	$self->unlock_folder($self->{'folder'});
	$self->redirect("index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}");
	}
elsif ($self->{'in_hash'}->{'copy1'} || $self->{'in_hash'}->{'copy2'}) {
	# Copying mails to some other folder
	$self->error_setup($self->{'text_hash'}->{'delete_errc'});
	@{$self->{'delmail_array'}} || $self->error($self->{'text_hash'}->{'delete_emnone'});
	$self->{'cfolder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'copy1'} ? $self->{'in_hash'}->{'mfolder1'} : $self->{'in_hash'}->{'mfolder2'}];
	$self->{'qerr'} = $self->would_exceed_quota($self->{'cfolder'}, @{$self->{'delmail_array'}});
	$self->error($self->{'qerr'}) if ($self->{'qerr'});
	$self->lock_folder($self->{'cfolder'});
	$self->mailbox_copy_mail($self->{'folder'}, $self->{'cfolder'}, @{$self->{'delmail_array'}});
	$self->unlock_folder($self->{'cfolder'});
	$self->redirect("index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}");
	}
elsif ($self->{'in_hash'}->{'forward'}) {
	# Forwarding selected mails .. redirect
	@{$self->{'delmail_array'}} || $self->error($self->{'text_hash'}->{'delete_efnone'});
	$self->redirect("reply_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&".
		  join("&", map { "mailforward=".$self->urlize($_) } @{$self->{'deleteboth_array'}}));
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# Need to redirect to compose form
	$self->redirect("reply_mail.cgi?new=1&folder=$self->{'in_hash'}->{'folder'}");
	}
elsif ($self->{'in_hash'}->{'black'} || $self->{'in_hash'}->{'white'}) {
	# Deny or allow all senders
	$self->{'dir'} = $self->{'in_hash'}->{'black'} ? "blacklist_from" : "whitelist_from";
	@{$self->{'delmail_array'}} || $self->error($self->{'in_hash'}->{'black'} ? $self->{'text_hash'}->{'delete_ebnone'}
				       : $self->{'text_hash'}->{'delete_ewnone'});
	foreach $mail (@{$self->{'delmail_array'}}) {
		push(@{$self->{'addrs_array'}}, map { $_->[0] } $self->split_addresses($mail->{'header'}->{'from'}));
		}
	$self->foreign_require("spam", "spam-lib.pl");
	local $conf = $main::spam_object->get_config();
	local @from = map { @{$_->{'words'}} }
			  $main::spam_object->find($self->{'dir'}, $conf);
	local %already = map { $_, 1 } @from;
	@{$self->{'newaddrs_array'}} = grep { !$already{$_} } $self->unique(@{$self->{'addrs_array'}});
	push(@from, @{$self->{'newaddrs_array'}});
	$main::spam_object->save_directives($conf, $self->{'dir'}, \@from, 1);
	$self->flush_file_lines();
	$self->redirect("index.cgi?folder=$self->{'in_hash'}->{'folder'}");
	}
elsif ($self->{'in_hash'}->{'razor'} || $self->{'in_hash'}->{'ham'}) {
	# Report as ham or spam all messages
	@{$self->{'delmail_array'}} || $self->error($self->{'in_hash'}->{'razor'} ? $self->{'text_hash'}->{'delete_ebnone'}
				       : $self->{'text_hash'}->{'delete_ehnone'});

	$self->ui_print_header(undef, $self->{'in_hash'}->{'razor'} ? $self->{'text_hash'}->{'razor_title'}
					     : $self->{'text_hash'}->{'razor_title2'}, "");
	if ($self->{'in_hash'}->{'razor'}) {
		print "<b>$self->{'text_hash'}->{'razor_report2'}</b>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'razor_report3'}</b>\n";
		}
	print "<pre>";

	# Write all messages to a temp file
	$self->{'temp'} = $self->transname();
	$self->{'cmd'} = $self->{'in_hash'}->{'razor'} ? $self->spam_report_cmd() : $self->ham_report_cmd();
	foreach $mail (@{$self->{'delmail_array'}}) {
		$self->send_mail($mail, $self->{'temp'});
		}

	# Call reporting command on them
	$self->open_execute_command(*OUT, "$self->{'cmd'} <$self->{'temp'} 2>&1", 1);
	local $error;
	while(<OUT>) {
		print $self->html_escape($_);
		$error++ if (/failed/i);
		}
	close(OUT);
	unlink($self->{'temp'});
	print "</pre>\n";
	if ($? || $error) {
		print "<b>$self->{'text_hash'}->{'razor_err'}</b><p>\n";
		}
	else {
		if ($self->{'userconfig_hash'}->{'spam_del'} && $self->{'in_hash'}->{'razor'}) {
			# Delete spam too
			$self->lock_folder($self->{'folder'});
			$self->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmail_array'}});
			$self->unlock_folder($self->{'folder'});
			print "<b>$self->{'text_hash'}->{'razor_deleted'}</b><p>\n";
			}
		else {
			print "<b>$self->{'text_hash'}->{'razor_done'}</b><p>\n";
			}
		}
	$self->ui_print_footer("index.cgi?folder=$self->{'in_hash'}->{'folder'}",
			 $self->{'text_hash'}->{'mail_return'});
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Just deleting emails
	@{$self->{'delmail_array'}} || $self->{'in_hash'}->{'all'} || $self->error($self->{'text_hash'}->{'delete_enone'});
	if (!$self->{'in_hash'}->{'confirm'} && ($self->need_delete_warn($self->{'folder'}) || $self->{'in_hash'}->{'all'})) {
		# Need to ask for confirmation before deleting
		$self->ui_print_header(undef, $self->{'text_hash'}->{'confirm_title'}, "");
		print $self->check_clicks_function();

		print "<form action=delete_mail.cgi method=post>\n";
		foreach $i (keys %{$self->{'in_hash'}}) {
			foreach $v (split(/\0/, $self->{'in_hash'}->{$i})) {
				print $self->ui_hidden($i, $v),"\n";
				}
			}
		print "<center><b>\n";
		if ($self->{'in_hash'}->{'all'}) {
			print $self->text('confirm_warnall'),"<br>\n";
			}
		else {
			print $self->text('confirm_warn', scalar(@{$self->{'delmail_array'}})),"<br>\n";
			}
		if ($self->{'userconfig_hash'}->{'delete_warn'} ne 'y') {
			# Only show a warning about not touching mailbox if
			# folder is too large
			print "$self->{'text_hash'}->{'confirm_warn2'}<p>\n"
			}
		elsif ($self->{'folder'}->{'type'} == 0) {
			# For mbox format folders, show a warning about not
			# touching the mailbox
			print "$self->{'text_hash'}->{'confirm_warn4'}<p>\n"
			}
		print "</b><p><input type=submit name=confirm ",
		      "value='$self->{'text_hash'}->{'confirm_ok'}' ",
		      "onClick='return check_clicks(form)'></center></form>\n";
		
#		$self->ui_print_footer("index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'delete_return'});
		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'delete_return'});
		}
	else {
		# Go ahead and delete
		$self->{'gconfig_hash'}->{'logfiles'} = 0;
		$self->lock_folder($self->{'folder'});
		if ($self->{'in_hash'}->{'all'}) {
			# Clear the whole folder, unless the first email
			# is non-editable
			@mail = $self->mailbox_list_mails_sorted(0, 0, $self->{'folder'});
			if ($self->editable_mail($mail[0])) {
				# Trash the lot
				$self->mailbox_empty_folder($self->{'folder'});
				}
			else {
				# Delete all mail except the first
				local $fsz = $self->mailbox_folder_size($self->{'folder'});
				@mail = $self->mailbox_list_mails_sorted(1, $fsz-1, $self->{'folder'});
				@{$self->{'delmailrest_array'}} = @mail[0..$#mail];
				$self->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmailrest_array'}});
				}
			}
		else {
			# Just delete selected messages
			$self->mailbox_delete_mail($self->{'folder'}, @{$self->{'delmail_array'}});
			}
		$self->unlock_folder($self->{'folder'});
		$self->redirect("index.cgi?start=$self->{'in_hash'}->{'start'}&folder=$self->{'in_hash'}->{'folder'}");
		}
	}
else {
	$self->error("No button clicked!");
	}
$self->pop3_logout_all();

1;
		
}


1;

