#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for setting up scheduled folder clearing

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];

$self->ui_print_header(undef, $self->{'text_hash'}->{'auto_title'}, "");

print $self->ui_form_start("save_auto.cgi");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->{'text_hash'}->{'auto_header'}, undef, 2);

# Folder name
print $self->ui_table_row($self->{'text_hash'}->{'auto_name'}, $self->{'folder'}->{'name'});

# Auto-clearing enabled
$self->{'auto'} = $self->get_auto_schedule($self->{'folder'});
$self->{'auto'} ||= { 'enabled' => 0, 'mode' => 0, 'days' => 30 };
print $self->ui_table_row($self->{'text_hash'}->{'auto_enabled'},
		    $self->ui_yesno_radio("enabled", int($self->{'auto'}->{'enabled'})));

# Deletion criteria
print $self->ui_table_row($self->{'text_hash'}->{'auto_mode'},
    $self->ui_radio("mode", int($self->{'auto'}->{'mode'}),
	[ [ 0, $self->text('auto_days',
		     $self->ui_textbox("days", $self->{'auto'}->{'days'}, 5))."<br>".
	       ("&nbsp;" x 4).$self->ui_checkbox("invalid", 1, $self->{'text_hash'}->{'auto_invalid'},
			    $self->{'auto'}->{'invalid'})."<br>" ],
	  [ 1, $self->text('auto_size',
		     $self->ui_bytesbox("size", $self->{'auto'}->{'size'}, 5)) ] ]));

# Delete whole mailbox, or just infringing mails
print $self->ui_table_row($self->{'text_hash'}->{'auto_action'},
		    $self->ui_radio("all", int($self->{'auto'}->{'all'}),
			      [ [ 0, $self->{'text_hash'}->{'auto_action0'} ],
				[ 1, $self->{'text_hash'}->{'auto_action1'} ] ]));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
					     : "list_folders.cgi",
		 $self->{'text_hash'}->{'folders_return'});
1;
		
}


1;

