#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_comp.cgi
# Display a form for creating or editing a composite folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

@{$self->{'folders_array'}} = $self->list_folders();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_comp.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_mode'}</b></td>\n";
print "<td>$self->{'text_hash'}->{'edit_comp'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
print "<td>",$self->ui_textbox("name", $self->{'folder'}->{'name'}, 40),"</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_comps'}</b></td>\n";
@{$self->{'names_array'}} = split(/\t+/, $self->{'folder'}->{'subfoldernames'});
print "<td>\n";
for($i=0; $i<10; $i++) {
	print $self->ui_select("comp_$i",
		$self->{'names_array'}->[$i],
		[ [ "", "&nbsp;" ],
		  map { [ $_->{'id'} || $_->{'file'} || $_->{'name'},
			  $_->{'name'} ] }
		  grep { $_->{'type'} != 5 &&
			 !$_->{'file'} || -e $_->{'file'} } @{$self->{'folders_array'}} ]),"<br>\n";
	}
print "</td> </tr>\n";

$self->show_folder_options($self->{'folder'});

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
					     : "list_folders.cgi",
		 $self->{'text_hash'}->{'folders_return'});

1;
		
}


1;

