#!/usr/bin/perl

&MAIN();

 sub MAIN {
# inbox_login.cgi
# Save inbox POP3 login and password

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'mail_loginerr'});
$self->{'in_hash'}->{'user'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_euser'});
$self->{'folder'}->{'user'} = $self->{'pop3_hash'}->{'user'} = $self->{'in_hash'}->{'user'};
$self->{'folder'}->{'pass'} = $self->{'pop3_hash'}->{'pass'} = $self->{'in_hash'}->{'pass'};
if ($self->{'folder'}->{'type'} == 2) {
	# Try POP3 login
	@{$self->{'err_array'}} = $self->pop3_login($self->{'folder'});
	if ($self->{'err_array'}->[0] == 0) {
		$self->error($self->{'err_array'}->[1]);
		}
	elsif ($self->{'err_array'}->[0] == 2) {
		$self->error($self->text('save_elogin', $self->{'err_array'}->[1]));
		}
	else {
		$self->pop3_logout($self->{'err_array'}->[1], 1);
		}

	# Save inbox .pop3 file
	$self->write_file("$self->{'user_module_config_directory'}/inbox.pop3", \%{$self->{'pop3_hash'}});
	chmod(0700, "$self->{'user_module_config_directory'}/inbox.pop3");
	}
else {
	# Try IMAP login
	$self->{'folder'}->{'mailbox'} = $self->{'pop3_hash'}->{'mailbox'} = undef;
	@{$self->{'err_array'}} = $self->imap_login($self->{'folder'});
	if ($self->{'err_array'}->[0] == 0) {
		$self->error($self->{'err_array'}->[1]);
		}
	elsif ($self->{'err_array'}->[0] == 2) {
		$self->error($self->text('save_elogin2', $self->{'err_array'}->[1]));
		}
	elsif ($self->{'err_array'}->[0] == 3) {
		$self->error($self->text('save_emailbox', $self->{'err_array'}->[1]));
		}
	else {
		$self->imap_logout($self->{'err_array'}->[1], 1);
		}

	# Save inbox .imap file
	$self->write_file("$self->{'user_module_config_directory'}/inbox.imap", \%{$self->{'pop3_hash'}});
	chmod(0700, "$self->{'user_module_config_directory'}/inbox.imap");
	}
$self->redirect("index.cgi?folder=$self->{'in_hash'}->{'folder'}");

1;
		
}


1;

