#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_addresses.cgi
# Display contents of the user's address book

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'address_title'}, "");

@{$self->{'addrs_array'}} = $self->list_addresses();
print "$self->{'text_hash'}->{'address_desc'}<p>\n";
if (@{$self->{'addrs_array'}} || $self->{'in_hash'}->{'add'}) {
	if ($self->{'in_hash'}->{'add'} || $self->{'in_hash'}->{'edit'} ne '') {
		print "<form action=save_address.cgi>\n";
		print "<input type=hidden name=add value='$self->{'in_hash'}->{'add'}'>\n";
		print "<input type=hidden name=edit value='$self->{'in_hash'}->{'edit'}'>\n";
		}
	print "<table width=100%>\n";
	print "<tr $self->{'tb'}> <td colspan=2 width=10%></td> ",
	      "<td width=40%><b>$self->{'text_hash'}->{'address_addr'}</b></td> ",
	      "<td width=40%><b>$self->{'text_hash'}->{'address_name'}</b></td> ",
	      $self->{'config_hash'}->{'edit_from'} ? "<td colspan=2 width=10% nowrap><b>$self->{'text_hash'}->{'address_from'}</b></td> " : "",
	      "</tr>\n";
	foreach $a (@{$self->{'addrs_array'}}) {
		next if (!defined($a->[2]));
		print "<tr $self->{'cb'}> <td width=5%>\n";
		if ($self->{'in_hash'}->{'edit'} ne $a->[2]) {
			print "<a href='list_addresses.cgi?edit=$a->[2]#editing'>",
			      "$self->{'text_hash'}->{'address_edit'}</a>\n";
			}
		else {
			print "<a href=list_addresses.cgi>$self->{'text_hash'}->{'cancel'}</a>\n";
			}
		print "</td> <td width=5%>\n";
		print "<a href='save_address.cgi?delete=$a->[2]'>",
		      "$self->{'text_hash'}->{'address_delete'}</a></td>\n";

		if ($self->{'in_hash'}->{'edit'} eq $a->[2]) {
			# Editing this row
			print "<td width=40%><input name=addr size=30 value='",
				$self->html_escape($a->[0]),"'><a name=editing></td>\n";
			print "<td width=40%><input name=name size=30 value='",
				$self->html_escape($a->[1]),"'></td>\n";
			if ($self->{'config_hash'}->{'edit_from'}) {
				&from_sel($a->[3]);
				}
			else {
				print "<input type=hidden name=from value='$a->[3]'>\n";
				}
			print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
			}
		else {
			# Just showing this row
			print "<td width=40%>$a->[0]</td>\n";
			print "<td width=40%>",$a->[1] ? $a->[1] : "<br>","</td>\n";
			print "<td colspan=2>",$a->[3] == 1 ? $self->{'text_hash'}->{'yes'} :
				     $a->[3] == 2 ? $self->{'text_hash'}->{'address_yd'} :
					     	    $self->{'text_hash'}->{'no'},"</td>\n"
				if ($self->{'config_hash'}->{'edit_from'});
			}
		print "</tr>\n";
		}
	if ($self->{'in_hash'}->{'add'}) {
		print "<tr> <td width=5%><a href='list_addresses.cgi'>$self->{'text_hash'}->{'cancel'}</a></td>\n";
		print "<td width=5%><a name=adding></td>\n";
		print "<td width=40%><input name=addr size=30></td>\n";
		print "<td width=40%><input name=name size=30></td>\n";
		print &from_sel() if ($self->{'config_hash'}->{'edit_from'});
		print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	if ($self->{'in_hash'}->{'add'} || $self->{'in_hash'}->{'edit'} ne '') {
		print "</form>\n";
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'address_none'}</b> <p>\n";
	}
print "<a href='list_addresses.cgi?add=1#adding'>$self->{'text_hash'}->{'address_add'}</a> <br>\n"
	if (!$self->{'in_hash'}->{'add'});

print "<hr>\n";
print "<a name=groups></a>\n";
@{$self->{'gaddrs_array'}} = $self->list_address_groups();
print "$self->{'text_hash'}->{'address_gdesc'}<p>\n";
if (@{$self->{'gaddrs_array'}} || $self->{'in_hash'}->{'gadd'}) {
	if ($self->{'in_hash'}->{'gadd'} || $self->{'in_hash'}->{'gedit'} ne '') {
		print "<form action=save_group.cgi>\n";
		print "<input type=hidden name=gadd value='$self->{'in_hash'}->{'gadd'}'>\n";
		print "<input type=hidden name=gedit value='$self->{'in_hash'}->{'gedit'}'>\n";
		}
	print "<table width=100%>\n";
	print "<tr $self->{'tb'}> <td colspan=2 width=10%></td> ",
	      "<td width=20%><b>$self->{'text_hash'}->{'address_group'}</b></td> ",
	      "<td width=70%><b>$self->{'text_hash'}->{'address_members'}</b></td> ",
	      "</tr>\n";
	foreach $a (@{$self->{'gaddrs_array'}}) {
		next if (!defined($a->[2]));
		print "<tr $self->{'cb'}> <td width=5%>\n";
		if ($self->{'in_hash'}->{'gedit'} ne $a->[2]) {
			print "<a href='list_addresses.cgi?gedit=$a->[2]#editing'>",
			      "$self->{'text_hash'}->{'address_edit'}</a>\n";
			}
		else {
			print "<a href=list_addresses.cgi>$self->{'text_hash'}->{'cancel'}</a>\n";
			}
		print "</td> <td width=5%>\n";
		print "<a href='save_group.cgi?gdelete=$a->[2]'>",
		      "$self->{'text_hash'}->{'address_delete'}</a></td>\n";

		if ($self->{'in_hash'}->{'gedit'} eq $a->[2]) {
			print "<td width=20%><input name=group size=15 value='",
				$self->html_escape($a->[0]),"'><a name=editing></td>\n";
			print "<td width=70%><input name=members size=60 value='",
				$self->html_escape($a->[1]),"'> ",
				$self->address_button("members", 0, 0, 0, 1),"\n";
			print "<input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
			}
		else {
			print "<td width=20%>$a->[0]</td>\n";
			print "<td width=70%>",$self->html_escape($a->[1]),"</td>\n";
			}
		print "</tr>\n";
		}
	if ($self->{'in_hash'}->{'gadd'}) {
		print "<tr> <td width=5%><a href='list_addresses.cgi'>$self->{'text_hash'}->{'cancel'}</a></td>\n";
		print "<td width=5%><a name=adding></td>\n";
		print "<td width=20%><input name=group size=20></td>\n";
		print "<td width=70%><input name=members size=60> ",
		      $self->address_button("members", 0, 0, 0, 1),"\n";
		print "<input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	if ($self->{'in_hash'}->{'gadd'} || $self->{'in_hash'}->{'gedit'} ne '') {
		print "</form>\n";
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'address_gnone'}</b> <p>\n";
	}
print "<a href='list_addresses.cgi?gadd=1#adding'>$self->{'text_hash'}->{'address_gadd'}</a> <br>\n"
	if (!$self->{'in_hash'}->{'gadd'});

$self->ui_print_footer("", $self->{'text_hash'}->{'mail_return'});

1;
		
}

sub from_sel
{
	shift if ($self == $_[0]);

print "<td><select name=from>\n";
printf "<option value=0 %s> %s\n",
	$_[0] == 0 ? "selected" : "", $self->{'text_hash'}->{'no'};
printf "<option value=1 %s> %s\n",
	$_[0] == 1 ? "selected" : "", $self->{'text_hash'}->{'yes'};
printf "<option value=2 %s> %s\n",
	$_[0] == 2 ? "selected" : "", $self->{'text_hash'}->{'address_yd'};
print "</select></td>\n";
}


1;

