#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for setting up scheduled folder clearing

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];

# Validate inputs
$self->{'auto'} = $self->get_auto_schedule($self->{'folder'});
$self->{'auto'} ||= { };
$self->{'auto'}->{'enabled'} = $self->{'in_hash'}->{'enabled'};
$self->{'auto'}->{'mode'} = $self->{'in_hash'}->{'mode'};
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'days'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auto_edays'});
	$self->{'auto'}->{'days'} = $self->{'in_hash'}->{'days'};
	$self->{'auto'}->{'invalid'} = $self->{'in_hash'}->{'invalid'};
	}
else {
	$self->{'in_hash'}->{'size'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auto_esize'});
	$self->{'auto'}->{'size'} = $self->{'in_hash'}->{'size'}*$self->{'in_hash'}->{'size_units'};
	}
$self->{'auto'}->{'all'} = $self->{'in_hash'}->{'all'};

# Save schedule, and setup cron job
$self->save_auto_schedule($self->{'folder'}, $self->{'auto'});
$self->setup_auto_cron() if ($self->{'auto'}->{'enabled'});

$self->redirect($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
				      : "list_folders.cgi");
1;
		
}


1;

