#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search_form.cgi
# Display a form for searching a mailbox

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders_sorted();
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};
$self->set_module_index($self->{'in_hash'}->{'folder'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sform_title'}, "");

print "<form action=mail_search.cgi>\n";
print "<input type=radio name=and value=1 checked> $self->{'text_hash'}->{'sform_and'}\n";
print "<input type=radio name=and value=0> $self->{'text_hash'}->{'sform_or'}<p>\n";

print "<table>\n";
#print "<tr> <td><b>$self->{'text_hash'}->{'sform_field'}</b></td> ",
#      "<td><b>$self->{'text_hash'}->{'sform_mode'}</b></td> ",
#      "<td><b>$self->{'text_hash'}->{'sform_for'}</b></td> </tr>\n";
for($i=0; $i<=9; $i++) {
	print "<tr>\n";
	print "<td>$self->{'text_hash'}->{'sform_where'}</td>\n";
	print "<td><select name=field_$i>\n";
	print "<option value=''>&nbsp;\n";
	foreach $f ('from', 'subject', 'to', 'cc', 'date', 'body', 'headers', 'size') {
		print "<option value=$f>",$self->{'text_hash'}->{"sform_$f"},"\n";
		}
	print "</select></td>\n";

	print "<td><select name=neg_$i>\n";
	print "<option value=0 checked>$self->{'text_hash'}->{'sform_neg0'}\n";
	print "<option value=1>$self->{'text_hash'}->{'sform_neg1'}\n";
	print "</select></td>\n";

	print "<td>$self->{'text_hash'}->{'sform_text'}</td>\n";
	print "<td><input name=what_$i size=30></td>\n";
	print "</tr>\n";
	}
print "</table>\n";

# Status to find
print "<table>\n";
print "<tr> <td>$self->{'text_hash'}->{'search_status'}</td>\n";
print "<td>",$self->ui_radio("status_def", 1,
		[ [ 1, $self->{'text_hash'}->{'search_allstatus'} ],
		  [ 0, $self->{'text_hash'}->{'search_onestatus'} ] ]),"\n",
		$self->ui_select("status", 2,
			   [ [ 0, $self->{'text_hash'}->{'view_mark0'} ],
			     [ 1, $self->{'text_hash'}->{'view_mark1'} ],
			     [ 2, $self->{'text_hash'}->{'view_mark2'} ] ]),"</td> </tr>\n";

# Limit on number of messages to search
print "<tr> <td>$self->{'text_hash'}->{'search_latest'}</td>\n";
print "<td>",$self->ui_opt_textbox("limit", $self->{'userconfig_hash'}->{'search_latest'}, 10,
			     $self->{'text_hash'}->{'search_nolatest'}, $self->{'text_hash'}->{'search_latestnum'}),"</td> </tr>\n";

# Destination for search
print "<tr> <td>$self->{'text_hash'}->{'search_dest'}</td>\n";
print "<td>",$self->ui_opt_textbox("dest", undef, 30, $self->{'text_hash'}->{'search_dest1'}, $self->{'text_hash'}->{'search_dest0'}),"</td> </tr>\n";

print "</table>\n";

$self->{'extra'} = <<EOF;
<option value=-1>$self->{'text_hash'}->{'sform_all'}
<option value=-2>$self->{'text_hash'}->{'sform_local'}
EOF
print "<input type=submit value='$self->{'text_hash'}->{'sform_ok'}'>\n";
@{$self->{'sfolders_array'}} = grep { $_->{'id'} != $self->{'search_folder_id'} } @{$self->{'folders_array'}};
print " $self->{'text_hash'}->{'sform_folder'} ",$self->folder_select(\@{$self->{'sfolders_array'}}, $self->{'folder'}, "folder",
					       $self->{'extra'});
print "</form>\n";

$self->ui_print_footer("index.cgi?folder=$self->{'in_hash'}->{'folder'}", $self->{'text_hash'}->{'mail_return'});

1;
		
}


1;

