#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple mailcap entries

&ModuleLoader::preload_module('mailcap_class', "mailcap::MailcapLib");
$self = new mailcap::MailcapLib:: 'mailcap_class',%$self;

$self->ReadParse();
$self->{'mode'} = $self->{'in_hash'}->{'delete'} ? 'delete' :
        $self->{'in_hash'}->{'disable'} ? 'disable' : 'enable';
$self->error_setup($self->{'text_hash'}->{$self->{'mode'}.'_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});
@{$self->{'mailcap_array'}} = $self->list_mailcap();

# Do the delete
$self->lock_file($self->{'mailcap_file'});
foreach $d (@d) {
	($self->{'mailcap'}) = grep { $_->{'index'} == $d } @{$self->{'mailcap_array'}};
	$self->{'mailcap'} || $self->error($self->{'text_hash'}->{'edit_egone'});
	if ($self->{'mode'} eq 'delete') {
	        $self->delete_mailcap($self->{'mailcap'});
		}
	elsif ($self->{'mode'} eq 'disable' && $self->{'mailcap'}->{'enabled'} == 1) {
	        $self->{'mailcap'}->{'enabled'} = 0;
	        $self->modify_mailcap($self->{'mailcap'});
		}
	elsif ($self->{'mode'} eq 'enable' && $self->{'mailcap'}->{'enabled'} == 0) {
	        #($clash) = grep { $_->{'type'} eq $self->{'mailcap'}->{'type'} &&
		#		  $_->{'enabled'} == 1 } @{$self->{'mailcap_array'}};
	        #$clash && $self->error(&text('enable_eclash', $type));
	        $self->{'mailcap'}->{'enabled'} = 1;
	        $self->modify_mailcap($self->{'mailcap'});
		}
	}
$self->unlock_file($self->{'mailcap_file'});
$self->webmin_log($self->{'mode'}, "mailcaps", scalar(@d));

$self->redirect("");

1;
		
}


1;

