#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a mailcap entry

&ModuleLoader::preload_module('mailcap_class', "mailcap::MailcapLib");
$self = new mailcap::MailcapLib:: 'mailcap_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'mailcap'} = { 'enabled' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'mailcap_array'}} = $self->list_mailcap();
	($self->{'mailcap'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'index'} } @{$self->{'mailcap_array'}};
	$self->{'mailcap'} || $self->error($self->{'text_hash'}->{'edit_egone'});
	}
$self->{'args'} = $self->{'mailcap'}->{'args'};

# Form header
print $self->ui_form_start("save.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("index", $self->{'in_hash'}->{'index'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header'}, "width=100%", 4);

# MIME type, program and description fields
print $self->ui_table_row($self->{'text_hash'}->{'edit_type'},
		    $self->ui_textbox("type", $self->{'mailcap'}->{'type'}, 30));
print $self->ui_table_row($self->{'text_hash'}->{'edit_enabled'},
		    $self->ui_yesno_radio("enabled", int($self->{'mailcap'}->{'enabled'})));
print $self->ui_table_row($self->{'text_hash'}->{'edit_program'},
		    $self->ui_textbox("program", $self->{'mailcap'}->{'program'}, 70), 3);
if ($self->{'mailcap'}->{'cmt'} =~ /\n/) {
	# Multi-line comment from file comments
	print $self->ui_table_row($self->{'text_hash'}->{'edit_cmt'},
		    $self->ui_textarea("cmt", $self->{'mailcap'}->{'cmt'}, 3, 70, "off"), 3);
	}
else {
	# Single line comment from file comment
	print $self->ui_table_row($self->{'text_hash'}->{'edit_cmt'},
		    $self->ui_textbox("cmt", $self->{'mailcap'}->{'cmt'}, 70), 3);
	}

# Other options
print $self->ui_table_hr();

print $self->ui_table_row($self->{'text_hash'}->{'edit_test'},
    $self->ui_opt_textbox("test", $self->{'args'}->{'test'}, 50, $self->{'text_hash'}->{'edit_none'}), 3);

print $self->ui_table_row($self->{'text_hash'}->{'edit_term'},
	$self->ui_yesno_radio("term", defined($self->{'args'}->{'needsterminal'}) ? 1 : 0));
print $self->ui_table_row($self->{'text_hash'}->{'edit_copious'},
	$self->ui_yesno_radio("copious", defined($self->{'args'}->{'copiousoutput'}) ? 1 : 0));

print $self->ui_table_row($self->{'text_hash'}->{'edit_desc'},
    $self->ui_opt_textbox("desc", $self->{'args'}->{'description'}, 50, $self->{'text_hash'}->{'edit_none'}), 3);

# Form footer
print $self->ui_table_end();
print $self->ui_form_end([
	$self->{'in_hash'}->{'new'} ? ( [ "create", $self->{'text_hash'}->{'create'} ] )
		   : ( [ "save", $self->{'text_hash'}->{'save'} ],
		       [ "delete", $self->{'text_hash'}->{'delete'} ] ) ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

