#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the manual pages search form

&ModuleLoader::preload_module('man_class', "man::ManLib");
$self = new man::ManLib:: 'man_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", $self->{'module_info_hash'}->{'usermin'} ? 0 : 1, 1);

# build list of available search options
@{$self->{'search_array'}} = ( "man", "help" );
foreach $d (split(/\s+/, $self->{'config_hash'}->{'doc_dir'})) {
	if (-d $d) {
		push(@{$self->{'search_array'}}, "doc");
		last;
		}
	}
foreach $h (split(/\s+/, $self->{'config_hash'}->{'howto_dir'})) {
	if (-d $h) {
		push(@{$self->{'search_array'}}, "howto");
		last;
		}
	}
if (-d $self->{'config_hash'}->{'kde_dir'}) {
	push(@{$self->{'search_array'}}, "kde");
	}
if (-d $self->{'config_hash'}->{'kernel_dir'}) {
	push(@{$self->{'search_array'}}, "kernel");
	}
if ($self->{'perl_doc'}) {
	push(@{$self->{'search_array'}}, "perl");
	}
if (-d $self->{'config_hash'}->{'custom_dir'}) {
        push(@{$self->{'search_array'}}, "custom");
        }
push(@{$self->{'search_array'}}, "google");

# display the search form
print "<form action=search.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'index_for'}</b></td>\n";
print "<td><input name=for size=30></td> </tr>\n";

print "<tr> <td></td>\n";
print "<td><input type=radio name=and value=1 checked> $self->{'text_hash'}->{'index_and'}\n";
print "<input type=radio name=and value=0> $self->{'text_hash'}->{'index_or'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'index_type'}</b></td>\n";
print "<td><input type=radio name=exact value=1 checked> $self->{'text_hash'}->{'index_name'}\n";
print "<input type=radio name=exact value=0> $self->{'text_hash'}->{'index_data'}</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_where'}</b></td> <td>\n";
foreach $s (@{$self->{'search_array'}}) {
	$self->{'txt'} = $self->{'text_hash'}->{"index_${s}"};
	$self->{'txt'} = $self->{'config_hash'}->{'custom_desc'}
		if ($s eq "custom" && $self->{'config_hash'}->{'custom_desc'});
	printf "<input type=checkbox name=section value=%s %s> %s<br>\n",
		$s, $s eq 'man' ? 'checked' : '', $self->{'txt'};
	}
print "</td> </tr>\n";

print "<tr> <td colspan=2 align=right>",
      "<input type=submit value=\"$self->{'text_hash'}->{'index_search'}\">\n",
      "<input type=reset value=\"$self->{'text_hash'}->{'index_reset'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

if (!$self->{'module_info_hash'}->{'usermin'}) {
	@{$self->{'check_array'}} = $self->{'config_hash'}->{'check'} ? split(/\s+/, $self->{'config_hash'}->{'check'}) : @{$self->{'search_array'}};
	print "<hr>\n";
	print "<form action=save_check.cgi>\n";
	printf "<input type=hidden name=count value=%d>\n", scalar(@{$self->{'search_array'}});
	print "<b>$self->{'text_hash'}->{'index_others'}</b><br>\n";
	print "<table width=100%>\n";
	foreach $s (@{$self->{'search_array'}}) {
		print "<tr>\n" if ($self->{'c'} % 3 == 0);
		printf "<td><input type=checkbox name=check value=%s %s> %s</td>\n",
			$s, $self->indexof($s, @{$self->{'check_array'}}) >= 0 ? 'checked' : '', 
			$self->{'text_hash'}->{"index_other_${s}"};
		print "<tr>\n" if ($self->{'c'}++ % 3 == 2);
		}
	print "</table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

