#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_table.cgi
# Create a new table

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'table_err'});
$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'table_ename'});
if ($self->{'in_hash'}->{'copy'}) {
	local ($db, $table) = split(/\./, $self->{'in_hash'}->{'copy'});
	foreach $f ($self->table_structure($db, $table)) {
		local $copy = $self->quotestr($f->{'field'})." $f->{'type'}";
		$copy .= " not null" if (!$f->{'null'});
		if ($f->{'key'} eq 'PRI') {
			$copy .= " primary key";
			}
		$copy .= " default '$f->{'default'}'"
			if ($f->{'default'} ne '' && $f->{'default'} ne 'NULL');
		$copy .= " $f->{'extra'}" if ($f->{'extra'});
		push(@{$self->{'fields_array'}}, $copy);
		}
	}
@sql = $self->parse_table_form(\@{$self->{'fields_array'}}, $self->{'in_hash'}->{'name'});
foreach $sql (@sql) {
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $sql);
	}
$self->webmin_log("create", "table", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");

1;
		
}


1;

