#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Drop a bunch of fields

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'fdrop_err'});

# Validate inputs
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'fdrop_enone'});
@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
@d < @{$self->{'desc_array'}} || $self->error($self->{'text_hash'}->{'fdrop_eall'});

# Do the deed
foreach $d (@d) {
	$self->execute_sql_logged($self->{'in_hash'}->{'db'},
	    "alter table ".$self->quotestr($self->{'in_hash'}->{'table'})." drop ".$self->quotestr($d));
	}
$self->webmin_log("delete", "fields", scalar(@d), \%{$self->{'in_hash'}});
$self->redirect("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($self->{'in_hash'}->{'table'}));

1;
		
}


1;

