#!/usr/bin/perl

&MAIN();

 sub MAIN {
# download.cgi
# Output the contents of a blob field

if (-r 'mysql-lib.pl') {
	&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

	}
else {
	require './postgresql-lib.pl';
	}
&ModuleLoader::preload_module('mysql_class', "mysql::ViewLib");
$self = new mysql::ViewLib:: 'mysql_class',%$self;


$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});

# Get search and limiting SQL
($self->{'search'}, $self->{'searchhids'}, $self->{'searchargs'}) = $self->get_search_args(\%{$self->{'in_hash'}});
$self->{'limitsql'} = $self->get_search_limit(\%{$self->{'in_hash'}});
($self->{'sortsql'}, $self->{'sorthids'}, $self->{'sortargs'}) = $self->get_search_sort(\%{$self->{'in_hash'}});

$self->{'d'} = $self->execute_sql($self->{'in_hash'}->{'db'},
	"select * from ".$self->quotestr($self->{'in_hash'}->{'table'})." $self->{'search'} $self->{'limitsql'} $self->{'sortsql'}");

# Work out the MIME type based on the data
$self->{'data'} = $self->{'d'}->{'data'}->[$self->{'in_hash'}->{'row'}]->[$self->{'in_hash'}->{'col'}];
if ($self->{'data'} =~ /^\s*(<!doctype|<html|<head|<title)/i) {
	$self->{'type'} = "text/html";
	}
elsif ($self->{'data'} =~ /^GIF89/) {
	$self->{'type'} = "image/gif";
	}
elsif ($self->{'data'} =~ /^\377\330\377\340/) {
	$self->{'type'} = "image/jpeg";
	}
elsif ($self->{'data'} =~ /^%PDF/) {
	$self->{'type'} = "application/pdf";
	}
elsif ($self->{'data'} =~ /^[\040-\176\r\n\t]+$/) {
	$self->{'type'} = "text/plain";
	}
else {
	$self->{'type'} = "application/octet-stream";
	}
print "Content-type: $self->{'type'}\n\n";
print $self->{'data'};

1;
		
}


1;

