#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import.cgi
# Import data from a text file

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParseMime();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'import_err'});

if ($self->{'in_hash'}->{'mode'}) {
	# From uploaded file
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'import_eupload'});
	$self->{'in_hash'}->{'upload_filename'} =~ /([^\/\\\s]+)$/ ||
		$self->error($self->{'text_hash'}->{'import_eupload'});
	$self->{'file'} = $self->transname($1);
	open(TEMP, ">$self->{'file'}");
	print TEMP $self->{'in_hash'}->{'upload'};
	close(TEMP);
	$self->{'need_unlink'} = 1;
	$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");
	print "$self->{'text_hash'}->{'import_uploadout'}<p>\n";
	}
else {
	# From local file
	-r $self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'import_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");
	print $self->text('import_fileout', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
	}

# Execute the import command ..
if ($self->{'in_hash'}->{'table'}) {
	$self->{'nfile'} = $self->transname("$self->{'in_hash'}->{'table'}.txt");
	system("cp $self->{'file'} $self->{'nfile'}");
	unlink($self->{'file'}) if ($self->{'need_unlink'});
	$self->{'file'} = $self->{'nfile'};
	$self->{'need_unlink'} = 1;
	}
$self->{'delete'} = $self->{'in_hash'}->{'delete'} ? "-d" : "";
$self->{'ignore'} = $self->{'in_hash'}->{'ignore'} ? "-i" : "";
if ($self->{'in_hash'}->{'format'} == 0) {
	$self->{'format'} = "--fields-terminated-by , --fields-enclosed-by '\"'";
	}
elsif ($self->{'in_hash'}->{'format'} == 1) {
	$self->{'format'} = "--fields-terminated-by ,";
	}
print "<pre>";
$self->additional_log('exec', undef, "$self->{'config_hash'}->{'mysqlimport'} $self->{'authstr'} $self->{'delete'} $self->{'ignore'} $self->{'format'} $self->{'in_hash'}->{'db'} $self->{'file'}");
$self->open_execute_command(*SQL, "$self->{'config_hash'}->{'mysqlimport'} $self->{'authstr'} $self->{'delete'} $self->{'ignore'} $self->{'format'} ".quotemeta($self->{'in_hash'}->{'db'})." $self->{'file'} 2>&1", 1, 0);
while(<SQL>) {
	print $self->html_escape($_);
	$self->{'got'}++ if (/\S/);
	}
close(SQL);
print "</pre>\n";
$self->webmin_log("import", undef, $self->{'in_hash'}->{'db'}, { 'mode' => $self->{'in_hash'}->{'mode'},
					  'file' => $self->{'in_hash'}->{'file'} });
unlink($self->{'file'}) if ($self->{'need_unlink'});

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'});

1;
		
}


1;

