#!/usr/bin/perl

&MAIN();

 sub MAIN {
# exec_files.cgi
# Execute some SQL commands from a file and display the output

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParseMime();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'exec_err'});

if ($self->{'in_hash'}->{'mode'}) {
	# From uploaded file
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'exec_eupload'});
	$self->{'file'} = $self->transname();
	open(TEMP, ">$self->{'file'}");
	print TEMP $self->{'in_hash'}->{'upload'};
	close(TEMP);
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	print "$self->{'text_hash'}->{'exec_uploadout'}<p>\n";
	}
else {
	# From local file
	-r $self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'exec_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	print $self->text('exec_fileout', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
	}

# Call the psql program on the file
print "<pre>";
($self->{'ex'}, $self->{'out'}) = $self->execute_sql_file($self->{'in_hash'}->{'db'}, $self->{'file'});
print $self->html_escape($self->{'out'});
$self->{'got'}++ if ($self->{'out'} =~ /\S/);
print "<i>$self->{'text_hash'}->{'exec_noout'}</i>\n" if (!$self->{'got'});
print "</pre>\n";
$self->webmin_log("execfile", undef, $self->{'in_hash'}->{'db'}, { 'mode' => $self->{'in_hash'}->{'mode'},
					    'file' => $self->{'in_hash'}->{'file'} });
unlink($self->{'file'}) if ($self->{'in_hash'}->{'mode'});

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

