#!/usr/bin/perl

&MAIN();

 sub MAIN {
# kill_proc.cgi
# Send a signal to a process

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
$self->switch_acl_uid();
$self->error_setup($self->text('kill_err', $self->{'in_hash'}->{signal}, $self->{'in_hash'}->{pid}));
foreach $s ('KILL', 'TERM', 'HUP', 'STOP', 'CONT') {
	$self->{'in_hash'}->{'signal'} = $s if ($self->{'in_hash'}->{$s});
	}

%{$self->{'pinfo_hash'}} = $self->process_info($self->{'in_hash'}->{pid});
$self->can_edit_process($self->{'pinfo_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'kill_ecannot'});
if ($self->kill_logged($self->{'in_hash'}->{signal}, $self->{'in_hash'}->{pid})) {
	$self->{'in_hash'}->{'args0'} = $self->{'pinfo_hash'}->{'args'};
	$self->webmin_log("kill", undef, undef, \%{$self->{'in_hash'}});
	sleep(1);
	if ($self->process_info($self->{'in_hash'}->{pid})) {
		# still around.. return to process info
		$self->redirect("edit_proc.cgi?$self->{'in_hash'}->{pid}");
		}
	else {
		# gone case .. return to list
		$self->redirect("index.cgi");
		}
	}
else {
	# failed to send signal
	$self->error("$!");
	}

1;
		
}


1;

