#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several procmail recipes

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

$self->lock_file($self->{'procmailrc'});
@{$self->{'conf_array'}} = $self->get_procmailrc();
foreach $d (sort { $b <=> $c } @d) {
	$self->{'rec'} = $self->{'conf_array'}->[$d];
	$self->delete_recipe($self->{'rec'});
	}
$self->unlock_file($self->{'procmailrc'});
$self->webmin_log("delete", "recipes", scalar(@d));
$self->redirect("");

1;
		
}


1;

