#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_header.cgi
# Display extra header and body test

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("header");
$self->ui_print_header(undef, $self->{'text_hash'}->{'header_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'header_desc'}<p>\n";
$self->start_form("save_header.cgi", $self->{'text_hash'}->{'header_header'}."\n".
		       "(<a href=edit_simple.cgi>$self->{'text_hash'}->{'header_switch'}</a>)");

if (!$self->{'module_info_hash'}->{'usermin'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'header_allow'}</b></td> <td nowrap colspan=3>";
	$self->{'allow'} = $self->find("allow_user_rules", $self->{'conf'});
	$self->yes_no_field("allow_user_rules", $self->{'allow'}, 0);
	print "</td> </tr>\n";
	}

@{$self->{'header_array'}} = $self->find("header", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'header_test'}</b></td> <td colspan=3>\n";
$self->edit_table("header",
	    [ $self->{'text_hash'}->{'header_tname'}, $self->{'text_hash'}->{'header_name'}, $self->{'text_hash'}->{'header_op'},
	      $self->{'text_hash'}->{'header_pat'}, $self->{'text_hash'}->{'header_default'} ],
	    [ map { [ &split_header($_->{'value'}) ] } @{$self->{'header_array'}} ], [ ], \&header_conv, 2);
print "</td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

push(@{$self->{'body_array'}}, map { [ &split_body($_->{'value'}), 0 ] } $self->find("body", $self->{'conf'}));
push(@{$self->{'body_array'}}, map { [ &split_body($_->{'value'}), 1 ] } $self->find("rawbody", $self->{'conf'}));
push(@{$self->{'body_array'}}, map { [ &split_body($_->{'value'}), 2 ] } $self->find("fullbody", $self->{'conf'}));
push(@{$self->{'body_array'}}, map { [ &split_body($_->{'value'}), 3 ] } $self->find("full", $self->{'conf'}));
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'header_body'}</b></td> <td colspan=3>\n";
$self->edit_table("body",
	    [ $self->{'text_hash'}->{'header_tname'}, $self->{'text_hash'}->{'header_mode'}, $self->{'text_hash'}->{'header_op'},
	      $self->{'text_hash'}->{'header_pat'} ], \@{$self->{'body_array'}}, [ ], \&body_conv, 2);

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'uri_array'}} = $self->find("uri", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'header_uri'}</b></td> <td colspan=3>\n";
$self->edit_table("uri",
	    [ $self->{'text_hash'}->{'header_tname'}, $self->{'text_hash'}->{'header_pat'} ],
	    [ map { $_->{'words'} } @{$self->{'uri_array'}} ], [ 20, 40 ], undef, 2);
print "</td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'meta_array'}} = $self->find("meta", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'header_meta'}</b></td> <td colspan=3>\n";
$self->edit_table("meta",
	    [ $self->{'text_hash'}->{'header_tname'}, $self->{'text_hash'}->{'header_bool'} ],
	    [ map { $_->{'value'} =~ /^(\S+)\s*(.*)$/ ? [ $1, $2 ] : [ ] } @{$self->{'meta_array'}} ],
	    [ 20, 40 ], undef, 2);

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'score_array'}} = $self->find("score", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'score_score'}</b></td> <td colspan=3>\n";
$self->edit_table("score",
	    [ $self->{'text_hash'}->{'score_name'}, $self->{'text_hash'}->{'score_points'} ],
	    [ map { $_->{'words'} } @{$self->{'score_array'}} ], [ 30, 6 ]);
print "</td> </tr>\n";

@{$self->{'describe_array'}} = $self->find("describe", $self->{'conf'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'score_describe'}</b></td> <td colspan=3>\n";
$self->edit_table("describe",
	    [ $self->{'text_hash'}->{'score_name'}, $self->{'text_hash'}->{'score_descr'} ],
	    [ map { $_->{'value'} =~ /^(\S+)\s*(.*)/ ? [ $1, $2 ] : [ ] }
	      @{$self->{'describe_array'}} ], [ 30, 40 ]);
print "</td> </tr>\n";

$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# header_conv(col, name, size, value, &values)
sub header_conv
{
	shift if ($self == $_[0]);

if ($_[0] == 0) {
	return sprintf "<input name=$_[1] size=20 value='%s'>",
		$self->html_escape($_[3]);
	}
elsif ($_[0] == 1) {
	local $h = $_[3] =~ /^exists:(\S+)$/ ? $1 : $_[3] =~ /^eval:/ ? "" : $_[3];
	return sprintf "<input name=$_[1] size=15 value='%s'>",
		$self->html_escape($h);
	}
elsif ($_[0] == 2) {
	local $rv = "<select name=$_[1]>\n";
	$rv .= sprintf "<option value='=~' %s>%s\n",
		$_[3] eq '=~' ? "selected" : "", $self->{'text_hash'}->{'header_op0'};
	$rv .= sprintf "<option value='!~' %s>%s\n",
		$_[3] eq '!~' ? "selected" : "", $self->{'text_hash'}->{'header_op1'};
	$rv .= sprintf "<option value='exists' %s>%s\n",
		$_[4]->[1] =~ /^exists:/ ? "selected" : "", $self->{'text_hash'}->{'header_op2'};
	$rv .= sprintf "<option value='eval' %s>%s\n",
		$_[4]->[1] =~ /^eval:/ ? "selected" : "", $self->{'text_hash'}->{'header_op3'};
	$rv .= "</select>\n";
	return $rv;
	}
elsif ($_[0] == 3) {
	return sprintf "<input name=$_[1] size=20 value='%s'>",
		$self->html_escape($_[4]->[1] =~ /^eval:(.*)/ ? $1 : $_[3]);
	}
elsif ($_[0] == 4) {
	return sprintf "<input name=$_[1] size=15 value='%s'>",
		$self->html_escape($_[3]);
	}
}

# body_conv(col, name, size, value, &values)
sub body_conv
{
	shift if ($self == $_[0]);

if ($_[0] == 0) {
	return sprintf "<input name=$_[1] size=20 value='%s'>",
		$self->html_escape($_[4]->[0]);
	}
elsif ($_[0] == 1) {
	local $rv = "<select name=$_[1]>\n";
	local $m;
	foreach $m (0 .. 3) {
		$rv .= sprintf "<option value=%d %s>%s\n",
		   $m, $m == $_[4]->[2] ? "selected" : "", $self->{'text_hash'}->{'header_mode'.$m};
		}
	$rv .= "</select>\n";
	return $rv;
	}
elsif ($_[0] == 2) {
	local $rv = "<select name=$_[1]>\n";
	$rv .= sprintf "<option value=0 %s>%s\n",
		$_[4]->[1] =~ /^eval:/ ? "" : "selected", $self->{'text_hash'}->{'header_op0'};
	$rv .= sprintf "<option value=1 %s>%s\n",
		$_[4]->[1] =~ /^eval:/ ? "selected" : "", $self->{'text_hash'}->{'header_op3'};
	$rv .= "</select>\n";
	return $rv;
	}
elsif ($_[0] == 3) {
	return sprintf "<input name=$_[1] size=40 value='%s'>",
		$self->html_escape($_[4]->[1] =~ /^eval:(.*)$/ ? $1 : $_[4]->[1]);
	}
}

sub split_header
{
	shift if ($self == $_[0]);

if ($_[0] =~ /^(\S+)\s+(eval:\S+\(.*\))/) {
	return ($1, $2);
	}
elsif ($_[0] =~ /^(\S+)\s+(\S+)\s+(\S+)\s+(\/.*\/\S*)\s*(if-unset:\s*(.*))?/) {
	return ($1, $2, $3, $4, $6);
	}
else {
	return ( );
	}
}

sub split_body
{
	shift if ($self == $_[0]);

if ($_[0] =~ /^(\S+)\s+((\/.*\/\S*)|(eval:\S+\(.*\)))/) {
	return ($1, $2);
	}
else {
	return ( );
	}
}


1;

