#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Allow changing of the rule for delivering spam

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("procmail");
$self->ui_print_header(undef, $self->{'text_hash'}->{'procmail_title'}, "");

print $self->text('procmail_desc', "<tt>$self->{'pmrc'}</tt>"),"<p>\n";

# Find the existing recipe
$self->foreign_require("procmail", "procmail-lib.pl");
@{$self->{'pmrcs_array'}} = $self->get_procmailrc();
$self->{'pmrc'} = $self->{'pmrcs_array'}->[$#{$self->{'pmrcs_array'}}];
@{$self->{'recipes_array'}} = $main::procmail_object->parse_procmail_file($self->{'pmrc'});
$self->{'spamrec'} = $self->find_file_recipe(\@{$self->{'recipes_array'}});

if (!$self->{'spamrec'}) {
	$self->{'mode'} = 4;
	}
elsif ($self->{'spamrec'}->{'action'} eq "/dev/null") {
	$self->{'mode'} = 0;
	}
elsif ($self->{'spamrec'}->{'action'} =~ /^(.*)\/$/) {
	$self->{'mode'} = 2;
	$self->{'file'} = $1;
	}
elsif ($self->{'spamrec'}->{'action'} =~ /^(.*)\/\.$/) {
	$self->{'mode'} = 3;
	$self->{'file'} = $1;
	}
elsif ($self->{'spamrec'}->{'type'} eq '!') {
	$self->{'mode'} = 5;
	$self->{'email'} = $self->{'spamrec'}->{'action'};
	}
else {
	$self->{'mode'} = 1;
	$self->{'file'} = $self->{'spamrec'}->{'action'};
	}

print "<form action=save_procmail.cgi>\n";
print "<table>\n";

# Spam destination inputs
print "<tr> <td rowspan=6 valign=top><b>$self->{'text_hash'}->{'setup_to'}</b></td>\n";

printf "<td><input type=radio name=to value=0 %s> %s</td> </tr>\n",
	$self->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'setup_null'};

printf "<td><input type=radio name=to value=4 %s> %s</td> </tr>\n",
	$self->{'mode'} == 4 ? "checked" : "", $self->{'text_hash'}->{'setup_default'};

printf "<td><input type=radio name=to value=1 %s> %s</td>\n",
	$self->{'mode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'setup_file'};
printf "<td><input name=file size=30 value='%s'></td> </tr>\n",
	$self->{'mode'} == 1 ? $self->{'file'} : undef;

printf "<td><input type=radio name=to value=2 %s> %s</td>\n",
	$self->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'setup_maildir'};
printf "<td><input name=maildir size=30 value='%s'></td> </tr>\n",
	$self->{'mode'} == 2 ? $self->{'file'} : undef;

printf "<td><input type=radio name=to value=3 %s> %s</td>\n",
	$self->{'mode'} == 3 ? "checked" : "", $self->{'text_hash'}->{'setup_mhdir'};
printf "<td><input name=mhdir size=30 value='%s'></td> </tr>\n",
	$self->{'mode'} == 3 ? $self->{'file'} : undef;

printf "<td><input type=radio name=to value=5 %s> %s</td>\n",
	$self->{'mode'} == 5 ? "checked" : "", $self->{'text_hash'}->{'setup_email'};
printf "<td><input name=email size=30 value='%s'></td> </tr>\n",
	$self->{'mode'} == 5 ? $self->{'email'} : undef;

print "</td></tr></table><br>\n";

if ($self->{'module_info_hash'}->{'usermin'}) {
	print "$self->{'text_hash'}->{'setup_rel'}<p>\n";
	}
else {
	print "$self->{'text_hash'}->{'setup_home'}<p>\n";
	}
print "$self->{'text_hash'}->{'setup_head'}<p>\n";

print "<input type=submit value='$self->{'text_hash'}->{'procmail_ok'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

