#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display other misc user-level options

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("user");
$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'user_desc'}<p>\n";
$self->start_form("save_user.cgi", $self->{'text_hash'}->{'user_header'});

$self->{'dns'} = lc($self->find_value("dns_available", $self->{'conf'}));
$self->{'dns'} = "test" if (!$self->{'dns'} && $self->{'config_hash'}->{'defaults'});
print "<tr> <td><b>$self->{'text_hash'}->{'user_dns'}</b></td> <td nowrap>\n";
printf "<input type=radio name=dns value=1 %s> %s\n",
	$self->{'dns'} eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=dns value=0 %s> %s\n",
	$self->{'dns'} eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
if (!$self->{'config_hash'}->{'defaults'}) {
	printf "<input type=radio name=dns value=-1 %s> %s (%s)\n",
		!$self->{'dns'} ? "checked" : "", $self->{'text_hash'}->{'default'}, $self->{'text_hash'}->{'user_dnstest'};
	}
printf "<input type=radio name=dns value=2 %s> %s\n",
	$self->{'dns'} =~ /^test/ ? "checked" : "", $self->{'text_hash'}->{'user_dnslist'};
printf "<input name=dnslist size=30 value='%s'></td> </tr>\n",
	$self->{'dns'} =~ /^test:\s*(.*)/ ? $1 : "";

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_razor'}</b></td> <td nowrap>\n";
$self->{'razor'} = $self->find("razor_timeout", $self->{'conf'});
$self->opt_field("razor_timeout", $self->{'razor'}, 5, 10);
print "</td> </tr>\n";

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_dcc'}</b></td> <td>\n";
$self->{'dcc'} = $self->find("dcc_path", $self->{'conf'});
$self->opt_field("dcc_path", $self->{'dcc'}, 40, $self->{'text_hash'}->{'user_inpath'}, 1);
print $self->file_chooser_button("dcc_path", 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_bodymax'}</b></td> <td nowrap>\n";
$self->{'bodymax'} = $self->find("dcc_body_max", $self->{'conf'});
$self->opt_field("dcc_body_max", $self->{'bodymax'}, 6, 999999);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_timeout'}</b></td> <td nowrap>\n";
$self->{'timeout'} = $self->find("dcc_timeout", $self->{'conf'});
$self->opt_field("dcc_timeout", $self->{'timeout'}, 5, 10);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_fuz1max'}</b></td> <td nowrap>\n";
$self->{'fuz1max'} = $self->find("dcc_fuz1_max", $self->{'conf'});
$self->opt_field("dcc_fuz1_max", $self->{'fuz1max'}, 6, 999999);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_fuz2max'}</b></td> <td nowrap>\n";
$self->{'fuz2max'} = $self->find("dcc_fuz2_max", $self->{'conf'});
$self->opt_field("dcc_fuz2_max", $self->{'fuz2max'}, 6, 999999);
print "</td> </tr>\n";

if (!$self->version_atleast(3)) {
	print "<tr> <td><b>$self->{'text_hash'}->{'user_dheader'}</b></td> <td nowrap>\n";
	$self->{'dheader'} = $self->find("dcc_add_header", $self->{'conf'});
	$self->yes_no_field("dcc_add_header", $self->{'dheader'}, 0);
	print "</td> </tr>\n";
	}

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_pyzor'}</b></td> <td>\n";
$self->{'pyzor'} = $self->find("pyzor_path", $self->{'conf'});
$self->opt_field("pyzor_path", $self->{'pyzor'}, 40, $self->{'text_hash'}->{'user_inpath'}, 1);
print $self->file_chooser_button("pyzor_path", 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_pbodymax'}</b></td> <td nowrap>\n";
$self->{'pbodymax'} = $self->find("pyzor_body_max", $self->{'conf'});
$self->opt_field("pyzor_body_max", $self->{'pbodymax'}, 6, 999999);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_ptimeout'}</b></td> <td nowrap>\n";
$self->{'ptimeout'} = $self->find("pyzor_timeout", $self->{'conf'});
$self->opt_field("pyzor_timeout", $self->{'ptimeout'}, 5, 10);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_pheader'}</b></td> <td nowrap>\n";
$self->{'pheader'} = $self->find("pyzor_add_header", $self->{'conf'});
$self->yes_no_field("pyzor_add_header", $self->{'pheader'}, 0);
print "</td> </tr>\n";

$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

