#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Do the setup

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'razor_err'});

# Validate inputs
$self->{'in_hash'}->{'user_def'} || $self->{'in_hash'}->{'user'} =~ /\S/ || $self->error($self->{'text_hash'}->{'razor_euser'});
$self->{'in_hash'}->{'pass_def'} || $self->{'in_hash'}->{'pass'} =~ /\S/ || $self->error($self->{'text_hash'}->{'razor_epass'});

# Do it
$self->ui_print_header(undef, $self->{'text_hash'}->{'razor_title'}, "");

print "<p>$self->{'text_hash'}->{'razor_doing'}<br>\n";
$self->{'cmd'} = "$self->{'config_hash'}->{'razor_admin'} -register";
$self->{'cmd'} .= " -user ".quotemeta($self->{'in_hash'}->{'user'}) if (!$self->{'in_hash'}->{'user_def'});
$self->{'cmd'} .= " -pass ".quotemeta($self->{'in_hash'}->{'pass'}) if (!$self->{'in_hash'}->{'pass_def'});
$self->{'out'} = `cd $self->{'remote_user_info_array'}->[7] ; $self->{'cmd'} 2>&1 </dev/null`;
print "<pre>$self->{'out'}</pre>\n";
if ($? || !-r "$self->{'remote_user_info_array'}->[7]/.razor/identity") {
	print "$self->{'text_hash'}->{'razor_failed'}<p>\n";
	}
else {
	print "$self->{'text_hash'}->{'razor_done'}<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

