#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_known.cgi
# Edit or create a known host

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'known_create'}, "");
	$self->{'msg'} = $self->{'text_hash'}->{'known_desc1'};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'known_edit'}, "");
	@{$self->{'knowns_array'}} = $self->list_knowns();
	$self->{'known'} = $self->{'knowns_array'}->[$self->{'in_hash'}->{'idx'}];
	}

# Show main key details
print "$self->{'msg'}<p>\n" if ($self->{'msg'});
print "<form action=save_known.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'known_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'known_hosts'}</b></td>\n";
print "<td colspan=3><textarea name=hosts rows=3 cols=50>",
	join("\n", @{$self->{'known'}->{'hosts'}}),"</textarea></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'known_bits'}</b></td>\n";
printf "<td><input name=bits size=5 value='%s'></td>\n",
	$self->{'known'}->{'bits'};

print "<td><b>$self->{'text_hash'}->{'known_exp'}</b></td>\n";
printf "<td><input name=exp size=5 value='%s'></td> </tr>\n",
	$self->{'known'}->{'exp'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'known_key'}</b></td>\n";
print "<td colspan=3><textarea name=key rows=10 cols=50 wrap=on>$self->{'known'}->{'key'}",
      "</textarea></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'known_comment'}</b></td>\n";
printf "<td colspan=3><input name=comment size=40 value='%s'></td> </tr>\n",
	$self->{'known'}->{'comment'};

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";

if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_knowns.cgi", $self->{'text_hash'}->{'knowns_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

