#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display main menu of SSH client/login option types

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 0, 1);

if (!$self->has_command("ssh")) {
	print $self->text('index_essh', "<tt>ssh</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

if (!-d $self->{'ssh_directory'}) {
	# Offer to setup SSH
	print "<center><form action=setup.cgi method=post>\n";
	print "$self->{'text_hash'}->{'index_setup'}<p>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_sok'}'>\n";
	print "<input type=password name=pass size=25><p>\n";
	if ($self->get_ssh_version() >= 2) {
		print $self->{'text_hash'}->{'index_type'},"\n";
		print $self->ui_select("type", "",
			[ [ "rsa1", $self->{'text_hash'}->{'index_rsa1'} ],
			  [ "rsa", $self->{'text_hash'}->{'index_rsa'} ],
			  [ "dsa", $self->{'text_hash'}->{'index_dsa'} ] ]),"\n";
		}
	print "</form></center>\n";
	}
else {
	# Show table of options
	@{$self->{'links_array'}} = ( "list_auths.cgi", "list_knowns.cgi",
		   "edit_keys.cgi", "list_hosts.cgi" );
	@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'auths_title'}, $self->{'text_hash'}->{'knowns_title'},
		    $self->{'text_hash'}->{'keys_title'}, $self->{'text_hash'}->{'hosts_title'} );
	@{$self->{'icons_array'}} = ( "images/auths.gif", "images/knowns.gif",
		   "images/keys.gif", "images/hosts.gif" );
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

