#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_knowns.cgi
# List trusted remote hosts

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'knowns_title'}, "");

@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_known.cgi?new=1'>$self->{'text_hash'}->{'knowns_add'}</a>" );

print "$self->{'text_hash'}->{'knowns_desc'}<p>\n";
@{$self->{'knowns_array'}} = $self->list_knowns();
if (@{$self->{'knowns_array'}}) {
	print $self->ui_form_start("delete_knowns.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
			 	  $self->{'text_hash'}->{'knowns_hosts'},
				  $self->{'text_hash'}->{'knowns_key'} ], undef, 0, \@{$self->{'tds_array'}});
	foreach $k (@{$self->{'knowns_array'}}) {
		print $self->ui_checked_columns_row([
			"<a href='edit_known.cgi?idx=$k->{'index'}'>".
		      	  join("&nbsp;|&nbsp;", @{$k->{'hosts'}})."</a>",
			"<tt>".substr($k->{'key'}, 0, 40)." ... ".
		      	  substr($k->{'key'}, -40)."</tt>"
			], \@{$self->{'tds_array'}}, "d", $k->{'index'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'knowns_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'knowns_none'}</b> <p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

