#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_known.cgi
# Save, create or delete a known host

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
@{$self->{'knowns_array'}} = $self->list_knowns();
$self->{'known'} = $self->{'knowns_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this known host key
	$self->delete_known($self->{'known'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'known_err'});
	$self->{'in_hash'}->{'hosts'} =~ /\S/ || $self->error($self->{'text_hash'}->{'known_ehosts'});
	$self->{'known'}->{'hosts'} = [ split(/\s+/, $self->{'in_hash'}->{'hosts'}) ];
	$self->{'in_hash'}->{'bits'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_ebits'});
	$self->{'known'}->{'bits'} = $self->{'in_hash'}->{'bits'};
	$self->{'in_hash'}->{'exp'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_eexp'});
	$self->{'known'}->{'exp'} = $self->{'in_hash'}->{'exp'};
	$self->{'in_hash'}->{'key'} =~ s/\r|\n//g;
	$self->{'in_hash'}->{'key'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'auth_ekey'});
	$self->{'known'}->{'key'} = $self->{'in_hash'}->{'key'};
	$self->{'known'}->{'comment'} = $self->{'in_hash'}->{'comment'};

	# Create or save the known host
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_known($self->{'known'});
		}
	else {
		$self->modify_known($self->{'known'});
		}
	}
$self->redirect("list_knowns.cgi");

1;
		
}


1;

