#!/usr/bin/perl

&MAIN();

 sub MAIN {

# Copyright (c) 2005 Positive Software Corporation, a Comodo Group Company
# CP+ / ZTL projects
#
# Shows information panel
# 
# $Id: showinfo.cgi,v 1.6 2006/04/28 14:08:28 wr Exp $
#
&ModuleLoader::preload_module('theme_xpressia_class', "WebLib");
$self = new WebLib:: 'theme_xpressia_class',%$self;


$self->init_config();

&ModuleLoader::preload_module('theme_xpressia_class', "VirtsrvLib");
$self = new VirtsrvLib:: 'theme_xpressia_class',%$self;


$self->{'quotas_home'} = $self->{'virtsrv_config_hash'}->{'home_quotas'} ? $self->{'virtsrv_config_hash'}->{'home_quotas'} : '/';

$self->{'product'}   = $self->{'text_hash'}->{'programname'};
$self->{'hostname'}  = $self->get_system_hostname();
$self->{'ver'}       = $self->get_webmin_version();
$self->{'uptime'}    = $self->ztl_get_uptime();
$self->{'username'}  = $ENV{'REMOTE_USER'};
$self->{'ipaddress'} = $ENV{'REMOTE_ADDR'};
$self->{'time'}      = localtime();

if ( $self->{'gconfig_hash'}->{'real_os_type'} ) {
	$self->{'ostr'} = "$self->{'gconfig_hash'}->{'real_os_type'} $self->{'gconfig_hash'}->{'real_os_version'}";
}
else {
	$self->{'ostr'} = "$self->{'gconfig_hash'}->{'os_type'} $self->{'gconfig_hash'}->{'os_version'}";
}

$self->ReadParse();

$self->header();

local $img_pass = '<img width=16 height=16 border=0 src="/images/ch_pass.gif" align=middle>';
local $link_chpass = "$img_pass<a target=content href='/changepass/index.cgi'><b>$self->{'text_hash'}->{'index_chpass'}</b></a>";

local $vuser = $self->get_virtuser($self->{'username'});
foreach $u($self->list_users()){if($u->{'name'} eq $self->{'username'}){$self->{'smb'}=1;} }

($self->{'quotaused'}, $self->{'quotatotal'}) = &get_quotas();
$self->{'disk_space'} = defined($self->{'quotaused'}) ? {key => "$self->{'text_hash'}->{'index_diskspace'}:", value => $self->{'quotatotal'} ? "$self->{'quotaused'} / $self->{'quotatotal'}" : $self->{'quotaused'} } : undef;

$self->{'ftp_user'} = !$vuser ? 0 : $vuser->{'shell'} eq $self->{'virtsrv_config_hash'}->{'ftp_shell'} ? 1 : $vuser->{'shell'} eq $self->{'virtsrv_config_hash'}->{'shell'} ? 0 : -1;
$self->{'mail_user'} = $vuser && $vuser->{'email'};

if(!$vuser || $self->{'mail_user'}){ $self->{'mailbox'} = { value=>"$self->{'text_hash'}->{'st_mail'}", key=>  "<img src='/images/yes.gif' alt='ON' />"  };}
if(!$vuser || $self->{'ftp_user'} ){ $self->{'ftp_access'} = { value=>"$self->{'text_hash'}->{'st_ftp'}", key=>  "<img src='/images/yes.gif' alt='ON' />"};}
if($self->{'smb'} && $self->{'virtsrv_config_hash'}->{'samba'} ){ $self->{'smb_client'} = { value=>"$self->{'text_hash'}->{'st_smb'}", key=> "<img src='/images/yes.gif' alt='ON' />" };}

push (@{$self->{'frames_array'}},
	{
	title => $self->{'text_hash'}->{'index_title_user'},
	data => [
		{key => "$self->{'text_hash'}->{'index_user'}:", value => "$self->{'username'}" },
		$self->{'mailbox'},
		$self->{'ftp_access'},
		$self->{'smb_client'},
		$self->{'disk_space'},
		{key => "$self->{'text_hash'}->{'index_remoteip'}:", value => "$self->{'ipaddress'}" },
		{key => '', value => "$link_chpass", colspan => 2 },
		]
	}
);

push (@{$self->{'frames_array'}},
	{
	title => $self->{'text_hash'}->{'index_title_system'},
	data => [
		{key => "$self->{'text_hash'}->{'index_os'}:", value => "$self->{'ostr'}"},
		{key => "$self->{'product'} :", value => "$self->{'text_hash'}->{'index_ver'} $self->{'ver'}"},
		{key => "$self->{'text_hash'}->{'index_hostname'}:", value => "$self->{'hostname'}"},
		{key => "$self->{'text_hash'}->{'index_time'}:", value => "$self->{'time'}"},
		{key => "$self->{'text_hash'}->{'index_uptime'}:", value => "$self->{'uptime'}"},
		]
	}
);

print <<EOF;
<table align=center border=0 cellpadding=0 cellspacing=0 width=240 height='100%' class=infofr valign=top>
<tbody><tr><td valign=top>
EOF

&drawFrame(@{$self->{'frames_array'}});

print <<EOF;
</td></tr>
<tr><td>
<table class=infoframe width='100%' align=center border=0 cellspacing=0 cellpadding=2 valign=top>
<tr><td class=infotitle><img src="/images/home.gif" border=0 width=16 height=16 align=middle><a href='$self->{'text_hash'}->{'index_mainpage_url'}' target='content'>&nbsp;$self->{'text_hash'}->{'index_mainpage2'}</a></td></tr>
</table></td></tr>
<tr><td height="100%">&nbsp;</td></tr>
</tbody></table>
EOF

$self->footer();

1;
		
}

# drawFrame($title, @args);
sub drawFrame {
	shift if ($self == $_[0]);

	print "<table class=infoframe width='100%' align=center border=0 cellspacing=0 cellpadding=2>\n";
	my ($title, %data);
	foreach $m (@_) {
		($title, @{$self->{'data_array'}}) = ($m->{title}, @{$m->{data}});
		print "<tr><td colspan=2 class=infotitle><img src='/images/arr.png' border=0 align=middle width=16 height=16>&nbsp;$title</td></tr>\n";
		foreach $k (@{$self->{'data_array'}}) {
			next unless $k;
#			print "<tr><td class=left nowrap>$k->{key}</td><td class=right nowrap>$k->{value}</td></tr>\n";
			if (! $k->{colspan}) {
			   print "<tr class=smf><td nowrap align=right><b>$k->{key}</b></td><td>$k->{value}</td></tr>\n";
			   } else {
	 			print "<tr class=smf><td align=center colspan=$k->{colspan} nowrap>$k->{value}</td></tr>\n";
				}
		}
	}
	print "</table>\n";
}

sub get_mailboxes_size {
	shift if ($self == $_[0]);

	local $module = 'mailbox';
	$self->read_file_cached("$self->{'config_directory'}/$module/config", \%{$self->{'mconfig_hash'}});

	$self->foreign_require($module, "$module-lib.pl");

	my @folders = $main::mailbox_object->list_folders_sorted();
	$main::mailbox_object->folder_size(@folders);
	my $size = 0;
	map { $size += $_->{'size'} } @folders;
	return $size;
}

# returns used and total disk space info
sub get_quotas {
	shift if ($self == $_[0]);

	local $module = 'quota';
	$self->read_file_cached("$self->{'config_directory'}/$module/config", \%{$self->{'mconfig_hash'}});
	$self->foreign_require($module, "$module-lib.pl");
	local $n = $main::quota_object->user_filesystems($self->{'remote_user'});
	my $i;
	for ($i=0; $i<$n; $i++) {
		$self->{'used_quota'} = $self->{'used_quota'} + $main::quota_object->{'filesys_hash'}->{$i,'ublocks'};
		$self->{'soft_quota'} = $self->{'soft_quota'} + $main::quota_object->{'filesys_hash'}->{$i,'sblocks'};
		$self->{'hard_quota'} = $self->{'hard_quota'} + $main::quota_object->{'filesys_hash'}->{$i,'hblocks'};
	}
	$self->{'total_quota'}=$self->{'soft_quota'} + $self->{'hard_quota'};
	if ($self->{'total_quota'}) {
		$self->{'total_quota'} = $main::quota_object->quota_show($self->{'total_quota'}, $self->{'quotas_home'});
	}
	$self->{'used_quota'} = $main::quota_object->quota_show($self->{'used_quota'}, $self->{'quotas_home'});
	return ($self->{'used_quota'},$self->{'total_quota'});
}


1;

