#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display scheduled downloads, plus a form for uploading a file

&ModuleLoader::preload_module('updown_class', "updown::UpdownLib");
$self = new updown::UpdownLib:: 'updown_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

$self->{'form'} = 0;
if ($self->{'can_download'}) {
	# Show form for downloading
	print "<form action=download.cgi method=post>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header1'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_urls'}</b></td>\n";
	print "<td colspan=3><textarea name=urls rows=4 cols=70 wrap=off>",
	      "</textarea></td> </tr>\n";

	print "<input type=hidden name=dir  value='$self->{'download_dir'}'>\n";
	print "<input type=hidden name=mkdir value=0>\n";
	print "</td> </tr>\n";

	if ($self->{'can_mode'} != 3) {
		# Ask for user and group to download as
		print "<tr> <td><b>$self->{'text_hash'}->{'index_user'}</b></td>\n";
		print "<td>",$self->unix_user_input("user", $self->{'download_user'}, $self->{'form'}),
		      "</td>\n";

		print "<td><b>$self->{'text_hash'}->{'index_group'}</b></td>\n";
		printf "<td><input type=radio name=group_def value=1 %s> %s\n",
			$self->{'download_group'} ? "" : "checked", $self->{'text_hash'}->{'default'};
		printf "<input type=radio name=group_def value=0 %s>\n",
			$self->{'download_group'} ? "checked" : "";
		printf $self->unix_group_input("group", $self->{'download_group'}, $self->{'form'}),
		       "</td> </tr>\n";
		}

	if ($self->{'can_schedule'}) {
		# Download time can be selected, for scheduling with At
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_bg'}</b></td> <td colspan=3>\n";
		print "<input type=radio name=bg value=0 checked> $self->{'text_hash'}->{'index_bg0'}<br>\n";
		print "<input type=radio name=bg value=1> $self->{'text_hash'}->{'index_bg1'}\n";

		@{$self->{'now_array'}} = localtime(time());
		printf "<input name=day size=2 value='%d'>/", $self->{'now_array'}->[3];
		print "<select name=month>\n";
		for($i=0; $i<12; $i++) {
			printf "<option value=%s %s>%s\n",
				$i, $self->{'now_array'}->[4] == $i ? 'selected' : '', $self->{'text_hash'}->{"smonth_".($i+1)};
			}
		print "</select>/";
		printf "<input name=year size=4 value='%d'>\n", $self->{'now_array'}->[5] + 1900;
		print $self->date_chooser_button("day", "month", "year", $self->{'form'}),"\n";

		print "$self->{'text_hash'}->{'index_time'}\n";
		printf "<input name=hour size=2 value='%2.2d'>:<input name=min size=2 value='%2.2d'></td> </tr>\n", $self->{'now_array'}->[2], $self->{'now_array'}->[1];
		}
	elsif ($self->{'can_background'}) {
		# Download must be immediate, but can be backgrounded
		print "<input type=hidden name=bg value=0>\n";
		}
	else {
		# Download is always right now
		}

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_down'}'></form>\n";
	$self->{'form'}++;

	# Show current list of scheduled or active downloads
	@{$self->{'downs_array'}} = grep { $self->can_as_user($_->{'user'}) } $self->list_downloads();
	if (@{$self->{'downs_array'}}) {
		local ($notdone) = grep { !$_->{'complete'} } @{$self->{'downs_array'}};
		print "<form action=cancel.cgi>\n";
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> ",
		      $notdone ? "<td><br></td>" : "",
		      "<td><b>$self->{'text_hash'}->{'index_urls'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_dest'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_when'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_user'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_prog'}</b></td> </tr>\n";
		foreach $d (@{$self->{'downs_array'}}) {
			print "<tr $self->{'cb'}>\n";
			if (!$d->{'complete'}) {
				printf "<td valign=top width=5><input type=checkbox ".
				       "name=cancel value=%s></td>\n", $d->{'id'};
				}
			elsif ($notdone) {
				print "<td width=5><br></td>\n";
				}
			print "<td valign=top>\n";
			local $count = 0;
			while($self->{'url'} = $d->{"url_$count"}) {
				print "<br>\n" if ($count);
				if (length($self->{'url'}) > 70 && $self->{'url'} =~ /^([^:]+:\/\/[^\/]+\/)(.*)(\/[^\/]+)$/) {
					print "$1 .. $3";
					}
				else {
					print $self->{'url'};
					}
				$count++;
				}
			print "</td>\n";
			printf "<td valign=top>%s</td>\n", $d->{'dir'};
			print "<td valign=top nowrap>",
				$d->{'time'} ? $self->make_date($d->{'time'})
					     : $self->{'text_hash'}->{'index_imm'},"</td>\n";
			printf "<td valign=top>%s</td>\n", $d->{'user'};
			print "<td valign=top nowrap>";
			if ($d->{'error'}) {
				print "<font color=#ff0000>\n";
				if ($count > 1) {
					print $self->text('index_upto',
						$d->{'upto'}+1, $count),"\n";
					}
				print "$d->{'error'}</font>\n";
				$self->delete_download($d);
				}
			elsif (!defined($d->{'upto'})) {
				print $self->{'text_hash'}->{'index_noprog'};
				}
			elsif ($d->{'complete'}) {
				print "<font color=#00ff00>$self->{'text_hash'}->{'index_done'} (",
					$self->nice_size($d->{'total'}),")</font>\n";
				$self->delete_download($d);
				}
			else {
				if ($count > 1) {
					print $self->text('index_upto',
						$d->{'upto'}+1, $count),"\n";
					}
				local $sz = $self->nice_size($d->{'got'});
				print "$sz\n";
				if ($d->{'size'}) {
					print "(".int($d->{'got'}*100/$d->{'size'}).
					      "%)\n";
					}
				}
			print "</td>\n";
			print "</tr>\n";
			}
		print "</table>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_cancel'}'>\n"
			if ($notdone);
		print "</form>\n";
		$self->{'form'}++;
		}
	}

if ($self->{'can_upload'}) {
	# Show form for uploading
	print "<hr>\n" if ($self->{'can_download'});
	local $upid = time().$$;
	print $self->ui_form_start("upload.cgi?id=$upid", "form-data", undef,
			     $self->read_parse_mime_javascript($upid,
			       [ "upload0", "upload1", "upload2", "upload3" ]));
	print $self->ui_table_start($self->{'text_hash'}->{'index_header2'}, "width=100%", 2);

	# Upload fields
	$self->{'utable'} = "";
	for($i=0; $i<4; $i++) {
		$self->{'utable'} .= $self->ui_upload("upload$i")."\n";
		$self->{'utable'} .= "<br>\n" if ($i%2 == 1);
		}
	print $self->ui_table_row($self->{'text_hash'}->{'index_upload'}, $self->{'utable'});

	# Destination directory
	print $self->ui_table_row($self->{'text_hash'}->{'index_dir'},
		$self->ui_textbox("dir", $self->{'upload_dir'}, 50)." ".
		$self->file_chooser_button("dir", 1, $self->{'form'})." ".
		$self->ui_checkbox("mkdir", 1, $self->{'text_hash'}->{'index_mkdir'}, 0));

	if ($self->{'can_mode'} != 3) {
		# Allow selection of user to save as
		print $self->ui_table_row($self->{'text_hash'}->{'index_user'},
			$self->unix_user_input("user", $self->{'upload_user'}, $self->{'form'}));

		print $self->ui_table_row($self->{'text_hash'}->{'index_group'},
			$self->ui_radio("group_def", $self->{'upload_group'} ? 0 : 1, 
				  [ [ 1, $self->{'text_hash'}->{'default'} ],
				    [ 0, $self->unix_group_input("group",
						$self->{'upload_group'}, $self->{'form'}) ] ]));
		}

	# Unzip files
	print "<input type=hidden name=zip value=0>\n";
	print $self->ui_table_end();
	print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'index_ok'} ] ]);
	$self->{'form'}++;
	}

if ($self->{'can_fetch'}) {
	# Show form to download fetch from server to PC
	print "<hr>\n" if ($self->{'can_download'} || $self->{'can_upload'});
	print "<form action=fetch.cgi method=get>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_header3'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_fetch'}</b></td>\n";
	print "<td colspan=3>\n";
	print $self->ui_textbox("fetch", $self->{'fetch_file'}, 50),"\n",
		$self->file_chooser_button("fetch", 0, $self->{'form'});
	print "</td> </tr>\n";

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'index_show'}</b></td>\n";
	print "<td>",$self->ui_yesno_radio("show", $self->{'fetch_show'}),"</td> </tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_ok2'}'></form>\n";
	$self->{'form'}++;
	}

$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

