#!/usr/bin/perl
package usermount::UsermountLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'usermount::UsermountLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# usermount-lib.pl
# Common functions for mounting and unmounting filesystems with the 'user'
# option set.

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
$self->switch_to_remote_user();
&ModuleLoader::preload_module(ref($self), "usermount::LinuxLib");
$self = new usermount::LinuxLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# parse_options(type, options)
# Convert an options string for some filesystem into the associative
# array %{$self->{'options_hash'}}
sub parse_options
{
	my $self = shift;

local($_);
undef(%{$self->{'options_hash'}});
if ($_[1] ne "-") {
        foreach (split(/,/, $_[1])) {
                if (/^([^=]+)=(.*)$/) { $self->{'options_hash'}->{$1} = $2; }
                else { $self->{'options_hash'}->{$_} = ""; }
                }
        }
}


1;

