#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete, disable or enable all exports for some directories

&ModuleLoader::preload_module('exports_class', "exports::ExportsLib");
$self = new exports::ExportsLib:: 'exports_class',%$self;


# Validate inputs
$self->error_setup($self->{'text_hash'}->{'delete_err'});
$self->ReadParse();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Find the actual clients
$self->lock_file($self->{'config_hash'}->{'exports_file'});
@{$self->{'exps_array'}} = $self->list_exports();
foreach $e (@{$self->{'exps_array'}}) {
	if ($self->indexof($e->{'dir'}, @d) >= 0) {
		push(@{$self->{'dels_array'}}, $e);
		}
	}

# Take them out, one by one
foreach $d (reverse(@{$self->{'dels_array'}})) {
	if ($self->{'in_hash'}->{'delete'}) {
		$self->delete_export($d);
		}
	elsif ($self->{'in_hash'}->{'disable'} && $d->{'active'}) {
		$d->{'active'} = 0;
		$self->modify_export($d, $d);
		}
	elsif ($self->{'in_hash'}->{'enable'} && !$d->{'active'}) {
		$d->{'active'} = 1;
		$self->modify_export($d, $d);
		}
	}
$self->unlock_file($self->{'config_hash'}->{'exports_file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'disable'} ? "disable" : "enable",
	    "exports", scalar(@{$self->{'dels_array'}}));
$self->redirect("");

1;
		
}


1;

