#!/usr/bin/perl
package fdisk::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fdisk::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the fdisk module
sub acl_security_form
{
	my $self = shift;

local @dlist = $self->list_disks_partitions();
local ($d, %dcan);
map { $dcan{$_}++ } split(/\s+/, $_[0]->{'disks'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_disks'}</b></td> <td>\n";
printf "<input type=radio name=disks_def value=1 %s> %s\n",
	$_[0]->{'disks'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_dall'};
printf "<input type=radio name=disks_def value=0 %s> %s<br>\n",
	$_[0]->{'disks'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_dsel'};
print "<select name=disks size=4 multiple>\n";
foreach $d (@dlist) {
	printf "<option value='%s' %s>%s\n",
		$d->{'device'},
		$dcan{$d->{'device'}} ? "selected" : "",
		$self->text('select_device', uc($d->{'type'}), uc(substr($d->{'device'}, -1))).($d->{'model'} ? " ($d->{'model'})" : "");
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_view'}</b></td>\n";
printf "<td><input type=radio name=view value=1 %s> %s\n",
	$_[0]->{'view'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=view value=0 %s> %s</td> </tr>\n",
	$_[0]->{'view'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the fdisk module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'disks_def'}) {
	$_[0]->{'disks'} = "*";
	}
else {
	$_[0]->{'disks'} = join(" ", split(/\0/, $self->{'in_hash'}->{'disks'}));
	}
$_[0]->{'view'} = $self->{'in_hash'}->{'view'};
}


1;

