#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'drive'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

if( $self->{'in_hash'}->{ 'action' } eq $self->{'text_hash'}->{ 'hdparm_apply' } ) 
{
	$self->ui_print_header(undef,  $self->{'text_hash'}->{ 'hdparm_apply' }, "");

	local $command = "hdparm ";
	local $key;
	foreach $key ( 'a', 'd', 'r', 'k', 'u', 'm', 'c', 'A', 'K', 'P', 'X', 'W', 'S' )
	{
		$command .= "-".$key." ".$self->{'in_hash'}->{ $key }." " if( $self->{'in_hash'}->{ $key } ne "" );
	}
	$command .= $self->{'in_hash'}->{ 'drive' }."\n";

	local $out = "<p>". $self->{'text_hash'}->{ 'hdparm_performing' }. " : <b>". $command. "</b><i>". $self->backquote_logged($command). "</i><p>";
	$out =~ s/\n/<br>/g;
	$self->webmin_log("hdparm", undef, $self->{'in_hash'}->{'drive'}, \%{$self->{'in_hash'}});

	print( $out );
} else {
	$self->ui_print_header(undef,  $self->{'text_hash'}->{'hdparm_speed'}, "");

	local ( $_, $_, $buffered, $buffer_cache ) = split( /\n/, `hdparm -t -T $self->{'in_hash'}->{ 'drive' }` );
	( $_, $buffered ) = split( /=/, $buffered );
	( $_, $buffer_cache ) = split( /=/, $buffer_cache );

	print "<p><table border cellpadding=2>\n";
	print "<tr $self->{'tb'}> <td colspan=2>",
	      "<b>$self->{'text_hash'}->{'hdparm_speedres'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'hdparm_buf1'}</b></td> ",
	      "<td>$buffered</td> </tr>\n";
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'hdparm_buf2'}</b></td> ",
	      "<td>$buffer_cache</td> </tr>\n";
	print "</table><p>\n";
}

$self->ui_print_footer( "", $self->{'text_hash'}->{ 'index_return' } );

1;
		
}


1;

