#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_hdparm.cgi
# Edit an IDE parameters for some disk

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
@{$self->{'dlist_array'}} = $self->list_disks_partitions();
$self->{'d'} = $self->{'dlist_array'}->[$self->{'in_hash'}->{'disk'}];
$self->can_edit_disk($self->{'d'}->{'device'}) ||
	$self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'hdparm_title'}, "");
if ( ! $self->has_command( "hdparm" ) ) {
	print "<p>$self->{'text_hash'}->{ 'edit_ehdparm' }<p>\n";
	$self->ui_print_footer( "", $self->{'text_hash'}->{ 'index_return' } );
	exit;
	}

%{$self->{'hdparm_hash'}} = ( 'A', "1", 'K', "0", 'P', "0", 'X', "0", 'W', "0", 'S', "0" );
@{$self->{'yesno_array'}} = ( "1", $self->{'text_hash'}->{ 'hdparm_on' }, "0", $self->{'text_hash'}->{ 'hdparm_off' } );

foreach $argument ( 'a', 'd', 'r', 'k', 'u', 'm', 'c' )
{
    $self->{'out'} = `hdparm -$argument $self->{'d'}->{'device'}`;
    if ($self->{'out'} =~ /\s+=\s+(\S+)/) {
	$self->{'hdparm_hash'}->{ $argument } = $1;
	}
    #( $_, $line ) = split( /=/, `hdparm -$argument $self->{'d'}->{'device'}` );
    #$line =~ s/ {1,}//;
    #( $self->{'hdparm_hash'}->{ $argument } ) = split( / /, $line );
}

print(
"<form action=apply_hdparm.cgi><table border cols=1 width=\"100%\"><input type=hidden name=drive value=", $self->{'d'} -> { 'device' }, ">",
    "<tr ", $self->{'tb'}, ">",
    	"<td><b>", $self->{'text_hash'}->{ 'hdparm_label' }, "</b></td>",
    "</tr><tr ", $self->{'cb'}, "><td>",
	"<table width=\"100%\">",
	    "<tr>",
    		"<td>", $self->hlink( "<b>". $self->{'text_hash'}->{ 'hdparm_conf_X' }. "</b>", 'X' ), &p_select_wdl( "X", $self->{'hdparm_hash'}->{ 'X' }, ( "0", $self->{'text_hash'}->{ 'hdparm_conf_X_defaut' }, "1", $self->{'text_hash'}->{ 'hdparm_conf_X_disable' }, "9", "PIO mode 1", "10", "PIO mode 2", "11", "PIO mode 3", "12", "PIO mode 4", "32", "Multimode DMA 0", "33", "Multimode DMA 1", "34", "Multimode DMA 2", "64", "Ultra DMA 0", "65", "Ultra DMA 1", "66", "Ultra DMA 2" ) ), "</td>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_d' }, 'd', @{$self->{'yesno_array'}} ), "</td>",
	    "</tr><tr>",
		"<td>", $self->hlink( "<b>". $self->{'text_hash'}->{ 'hdparm_conf_a' }. "</b>", "a" ), " ", &p_entry( "a", 2, $self->{'hdparm_hash'}->{ 'a' } ), "</td>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_A' }, 'A', @{$self->{'yesno_array'}} ), "</td>",
	    "</tr><tr>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_W' }, 'W', @{$self->{'yesno_array'}} ), "</td>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_u' }, 'u', @{$self->{'yesno_array'}} ), "</td>",
	    "</tr><tr>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_k' }, 'k', @{$self->{'yesno_array'}} ), "</td>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_K' }, 'K', @{$self->{'yesno_array'}} ), "</td>",
	    "</tr><tr>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_r' }, 'r', @{$self->{'yesno_array'}} ), "</td>",
		"<td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_P' }, 'P', @{$self->{'yesno_array'}} ), "</td>",
	    "</tr><tr>",
		"<td>", $self->hlink( "<b>". $self->{'text_hash'}->{ 'hdparm_conf_S' }. "</b>", "S" ), " ", &p_entry( "S", 6, $self->{'hdparm_hash'}->{ 'S' } ), "</td>",
	    "</tr>",
	"</table><table>",
	    "<tr><td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_c' }, 'c', ( "0", $self->{'text_hash'}->{ 'hdparm_disable' }, "1", $self->{'text_hash'}->{ 'hdparm_enable' }, "3", $self->{'text_hash'}->{ 'hdparm_enable_special' } ) ), "</td></tr>",
	    "<tr><td>", &l_radio( $self->{'text_hash'}->{ 'hdparm_conf_m' }, 'm', ( "0", $self->{'text_hash'}->{ 'hdparm_disable' }, "2", "2", "4", "4", "8", "8", "16", "16", "32", "32" ) ), "<td><tr>",
	"</table></td>",
    "</tr>",
"</table><table cols=3 width=\"100%\" nosave>",
    "<tr>",
	"<td align=left><input type=submit name=action value=\"", $self->{'text_hash'}->{ 'hdparm_apply' }, "\"></td>",
	"<td align=right><input type=submit name=action value=\"", $self->{'text_hash'}->{ 'hdparm_speed' }, "\"></td>",
    "</tr>",
"</table></form>" );

$self->ui_print_footer( "", $self->{'text_hash'}->{ 'index_return' } );

1;
		
}

sub l_radio
{
	shift if ($self == $_[0]);

    my ( $label, $flag, @items ) = @_;
    return $self->hlink( "<b>".$label."</b>", $flag )."</td> <td>".
	   &p_radio( $flag, $self->{'hdparm_hash'}->{ $flag }, @items );
}

sub p_radio
{
	shift if ($self == $_[0]);

    my ( $name, $checked, @list ) = @_;
    local $out, $size = @list, $i = 0;

    do
    {
	$out .= " <input type=radio name=".$name." value=".$list[$i];
	$out .= " checked" if( $checked eq $list[$i++] );
	$out .="> ".$list[$i++];
    } while( $i < $size );

    return $out;
}

sub p_entry
{
	shift if ($self == $_[0]);

    my ( $name, $size, $value ) = @_;

    $size ? return "</td> <td><input name=". $name. " size=". $size." value=\"". $value."\">" : return "</td> <td><input name=". $name. " value=\"". $value."\">";
}

sub p_select_wdl
{
	shift if ($self == $_[0]);

    my ( $name, $selected, @list ) = @_;
    local $size = @list, $i = 0, $out = "</td> <td><select name=".$name.">";
    do
    {
	$out .= "<option name=".$name." value=".$list[$i];
	$out .= " selected" if( $selected eq $list[$i++] );
	$out .= ">".$list[$i++];
    } while( $i < $size );
    $out .= "</select>";

    return $out;
}


1;

