#!/usr/bin/perl

&MAIN();

 sub MAIN {
# fsck_form.cgi
# Ask questions before running fsck on a filesystem

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'fsck_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'fsck_title'}, "");

@{$self->{'stat_array'}} = $self->device_status($self->{'in_hash'}->{dev});
print $self->text('fsck_desc1', $self->fstype_name($self->{'stat_array'}->[1]), "<tt>$self->{'in_hash'}->{dev}</tt>",
	    "<tt>$self->{'stat_array'}->[0]</tt>"),"<p>\n";
$self->{'cmd'} = $self->fsck_command($self->{'stat_array'}->[1], $self->{'in_hash'}->{dev});
print $self->text('fsck_desc2', "<tt>$self->{'cmd'}</tt>", "<tt>fsck</tt>"),"<p>\n";

print "<form action=fsck.cgi>\n";
print "<input type=hidden name=cmd value=\"$self->{'cmd'}\">\n";
print "<input type=hidden name=dev value=\"$self->{'in_hash'}->{'dev'}\">\n";
print "<input type=hidden name=type value=\"$self->{'in_hash'}->{'type'}\">\n";
print "<center><input type=submit value=\"$self->{'text_hash'}->{'fsck_repair'}\"></center>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

