#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mkfs.cgi
# Where the new filesystem actually gets created.

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->foreign_require("proc", "proc-lib.pl");

$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'mkfs_ecannot'});
$self->error_setup($self->{'text_hash'}->{'mkfs_err'});
$self->{'cmd'} = $self->mkfs_parse($self->{'in_hash'}->{type}, $self->{'in_hash'}->{dev});
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'mkfs_title'}, "");

$self->{'label'} = $self->get_label($self->{'in_hash'}->{'dev'});

print $self->text('mkfs_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>\n";
$self->foreign_call("proc", "safe_process_exec_logged",
	      $self->{'cmd'}, 0, 0, STDOUT, undef, 1, 1);
print "</pre>\n";

if ($?) { print "<b>$self->{'text_hash'}->{'mkfs_failed'}</b> <p>\n"; }
else { print "$self->{'text_hash'}->{'mkfs_ok'} <p>\n"; }
if ($self->{'label'}) {
	$self->set_label($self->{'in_hash'}->{'dev'}, $self->{'label'}, $self->{'in_hash'}->{'type'});
	}
$self->webmin_log("mkfs", undef, $self->{'in_hash'}->{'dev'}, \%{$self->{'in_hash'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

