#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newfs_form.cgi
# Display a form asking for the parameters of a new filesystem

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'mkfs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'mkfs_title'}, "");

print "<form action=mkfs.cgi>\n";
print "<input type=hidden name=dev value=\"$self->{'in_hash'}->{dev}\">\n";
print "<input type=hidden name=type value=\"$self->{'in_hash'}->{type}\">\n";

print $self->text('mkfs_desc1', "<b>".$self->fstype_name($self->{'in_hash'}->{type})."</b>",
	    "<b><tt>$self->{'in_hash'}->{dev}</tt></b>"),"<p>\n";

if ((@{$self->{'stat_array'}} = $self->device_status($self->{'in_hash'}->{dev})) && $self->{'stat_array'}->[1] ne "swap") {
	print $self->text('mkfs_desc2', "<tt>$self->{'stat_array'}->[0]</tt>",
		    $self->fstype_name($self->{'in_hash'}->{type})),"<p>\n";
	}

print "<table border>\n";
print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'mkfs_options'}</b></td> </tr>\n";
print "<tr $self->{'cb'}><td><table cellpadding=5>\n";
$self->mkfs_options($self->{'in_hash'}->{type});
print "</table></td></tr></table>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'mkfs_create'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

