#!/usr/bin/perl

&MAIN();

 sub MAIN {
# tunefs.cgi
# Do the tuning of a filesystem

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'tunefs_ecannot'});
$self->error_setup($self->{'text_hash'}->{'tunefs_err'});
$self->{'cmd'} = $self->tunefs_parse($self->{'in_hash'}->{type}, $self->{'in_hash'}->{dev});
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'tunefs_title'}, "");

print "<b>",$self->text('tunefs_exec', "<tt>$self->{'cmd'}</tt>"),"</b>\n";
print "<pre>\n";
$self->foreign_call("proc", "safe_process_exec_logged",
	      $self->{'cmd'}, 0, 0, STDOUT, undef, 1);
print "</pre>\n";
if ($?) { print "<b>$self->{'text_hash'}->{'tunefs_failed'}</b><p>\n"; }
else { print "<b>$self->{'text_hash'}->{'tunefs_ok'}</b><p>\n"; }
$self->webmin_log("tunefs", undef, $self->{'in_hash'}->{'dev'}, \%{$self->{'in_hash'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

