#!/usr/bin/perl

&MAIN();

 sub MAIN {
# tunefs_form.cgi
# Display a form asking for filesystem tuning parameters

&ModuleLoader::preload_module('fdisk_class', "fdisk::FdiskLib");
$self = new fdisk::FdiskLib:: 'fdisk_class',%$self;

$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'tunefs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'tunefs_title'}, "");
$self->ReadParse();

print "<form action=tunefs.cgi>\n";
print "<input type=hidden name=dev value=\"$self->{'in_hash'}->{dev}\">\n";
print "<input type=hidden name=type value=\"$self->{'in_hash'}->{type}\">\n";

@{$self->{'stat_array'}} = $self->device_status($self->{'in_hash'}->{dev});
print $self->text('tunefs_desc', $self->fstype_name($self->{'in_hash'}->{type}), "<tt>$self->{'in_hash'}->{dev}</tt>",
	    "<tt>$self->{'stat_array'}->[1]</tt>"),"<p>\n";

print "<table border>\n";
print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{'tunefs_params'}</b></td> </tr>\n";
print "<tr $self->{'cb'}><td><table cellpadding=5>\n";
$self->tunefs_options($self->{'in_hash'}->{type});
print "</table></td></tr></table><br>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'tunefs_tune'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

