#!/usr/bin/perl
package fetchmail::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fetchmail::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the fetchmail module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> $self->{'text_hash'}->{'acl_all'}<br>\n",
	$_[0]->{'mode'} == 0 ? "checked" : "";
printf "<input type=radio name=mode value=3 %s> $self->{'text_hash'}->{'acl_this'}<br>\n",
	$_[0]->{'mode'} == 3 ? "checked" : "";
printf "<input type=radio name=mode value=1 %s> $self->{'text_hash'}->{'acl_only'}\n",
	$_[0]->{'mode'} == 1 ? "checked" : "";
printf "<input name=userscan size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 1 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscan", 1);
printf "<input type=radio name=mode value=2 %s> $self->{'text_hash'}->{'acl_except'}\n",
	$_[0]->{'mode'} == 2 ? "checked" : "";
printf "<input name=userscannot size=40 value='%s'> %s</td> </tr>\n",
	$_[0]->{'mode'} == 2 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscannot", 1);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_cron'}</b></td> <td>\n";
print $self->ui_radio("cron", $_[0]->{'cron'},
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the fetchmail module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'users'} = $self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 3 ? "" :
		   $self->{'in_hash'}->{'mode'} == 1 ? $self->{'in_hash'}->{'userscan'}
				    : $self->{'in_hash'}->{'userscannot'};
$_[0]->{'cron'} = $self->{'in_hash'}->{'cron'};

}


1;

