#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_poll.cgi
# Display one server polled by fetchmail

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
if ($self->{'config_hash'}->{'config_file'}) {
	$self->{'file'} = $self->{'config_hash'}->{'config_file'};
	}
else {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'poll_ecannot'});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/.fetchmailrc";
	}

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'poll_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'poll_edit'}, "");
	@{$self->{'conf_array'}} = $self->parse_config_file($self->{'file'});
	$self->{'poll'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_poll.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=file value='$self->{'file'}'>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";

# Show server options
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'poll_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'poll_poll'}</b></td>\n";
printf "<td><input name=poll size=30 value='%s'></td>\n",
	$self->{'poll'}->{'poll'};

print "<td><b>$self->{'text_hash'}->{'poll_skip'}</b></td>\n";
printf "<td><input type=radio name=skip value=0 %s> %s\n",
	$self->{'poll'}->{'skip'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=skip value=1 %s> %s</td> </tr>\n",
	$self->{'poll'}->{'skip'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'poll_via'}</b></td>\n";
printf "<td colspan=3><input type=radio name=via_def value=1 %s> %s\n",
	$self->{'poll'}->{'via'} ? '' : 'checked', $self->{'text_hash'}->{'poll_via_def'};
printf "<input type=radio name=via_def value=0 %s>\n",
	$self->{'poll'}->{'via'} ? 'checked' : '';
printf "<input name=via size=30 value='%s'></td> </tr>\n",
	$self->{'poll'}->{'via'};

print "<tr> <td><b>$self->{'text_hash'}->{'poll_proto'}</b></td>\n";
print "<td><select name=proto>\n";
printf "<option value='' %s> %s\n",
	$self->{'poll'}->{'proto'} ? '' : 'selected', $self->{'text_hash'}->{'default'};
foreach $p ('pop3', 'pop2', 'imap', 'imap-k4', 'imap-gss', 'apop', 'kpop') {
	printf "<option value=%s %s>%s\n",
		$p, lc($self->{'poll'}->{'proto'}) eq $p ? 'selected' : '', uc($p);
	$self->{'found'}++ if (lc($self->{'poll'}->{'proto'}) eq $p);
	}
printf "<option value=%s selected>%s\n", $self->{'poll'}->{'proto'}, uc($self->{'poll'}->{'proto'})
	if (!$self->{'found'} && $self->{'poll'}->{'proto'});
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'poll_port'}</b></td>\n";
printf "<td><input type=radio name=port_def value=1 %s> %s\n",
	$self->{'poll'}->{'port'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=port_def value=0 %s> %s\n",
	$self->{'poll'}->{'port'} ? 'checked' : '';
printf "<input name=port size=8 value='%s'></td> </tr>\n",
	$self->{'poll'}->{'port'};

print "<tr> <td><b>$self->{'text_hash'}->{'poll_auth'}</b></td>\n";
print "<td><select name=auth>\n";
printf "<option value='' %s> %s\n",
	$self->{'poll'}->{'auth'} ? '' : 'selected', $self->{'text_hash'}->{'default'};
foreach $p ('password', 'kerberos_v5', 'kerberos_v4', 'gssapi', 'cram-md5', 'otp', 'ntlm', 'ssh') {
        printf "<option value=%s %s>%s\n",
                $p, lc($self->{'poll'}->{'auth'}) eq $p ? 'selected' : '', uc($p);
        $self->{'found'}++ if (lc($self->{'poll'}->{'auth'}) eq $p);
        }
printf "<option value=%s selected>%s\n", $self->{'poll'}->{'auth'}, uc($self->{'poll'}->{'auth'})
        if (!$self->{'found'} && $self->{'poll'}->{'auth'});
print "</select></td> </tr>\n";

@{$self->{'interface_array'}} = split(/\//, $self->{'poll'}->{'interface'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'poll_interface'}</b></td><td colspan=3>\n";
printf "<input type=radio name=interface_def value=1 %s> %s<br>\n",
	@{$self->{'interface_array'}} ? '' : 'checked', $self->{'text_hash'}->{'poll_interface_def'};
printf "<input type=radio name=interface_def value=0 %s> %s\n",
	@{$self->{'interface_array'}} ? 'checked' : '', $self->{'text_hash'}->{'poll_interface_ifc'};
print "<input name=interface size=8 value='$self->{'interface_array'}->[0]'> ",
      "$self->{'text_hash'}->{'poll_interface_ip'}\n";
print "<input name=interface_net size=15 value='$self->{'interface_array'}->[1]'> /\n";
print "<input name=interface_mask size=15 value='$self->{'interface_array'}->[2]'></td> </tr>\n";

print "</table></td></tr></table>\n";

# Show user options
@{$self->{'users_array'}} = @{$self->{'poll'}->{'users'}};
push(@{$self->{'users_array'}}, undef) if ($self->{'in_hash'}->{'new'} || $self->{'in_hash'}->{'adduser'});
$self->{'i'} = 0;
foreach $u (@{$self->{'users_array'}}) {
	print "<br><table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'poll_uheader'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'poll_user'}</b></td>\n";
	printf "<td><input name=user_$self->{'i'} size=15 value='%s'></td>\n",
		$u->{'user'};

	print "<td><b>$self->{'text_hash'}->{'poll_pass'}</b></td>\n";
	printf "<td><input type=password name=pass_$self->{'i'} size=15 value='%s'></td> </tr>\n",
		$u->{'pass'};

	print "<tr> <td><b>$self->{'text_hash'}->{'poll_is'}</b></td> <td colspan=3>\n";
	printf "<input name=is_$self->{'i'} size=60 value='%s'></td> </tr>\n",
		join(" ", @{$u->{'is'}});

	print "<tr> <td><b>$self->{'text_hash'}->{'poll_keep'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=keep_$self->{'i'} value=1 %s> %s\n",
		$u->{'keep'} eq '1' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=keep_$self->{'i'} value=0 %s> %s\n",
		$u->{'keep'} eq '0' ? 'checked' : '', $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=keep_$self->{'i'} value='' %s> %s (%s)\n",
		$u->{'keep'} eq '' ? 'checked' : '', $self->{'text_hash'}->{'default'},
		$self->{'text_hash'}->{'poll_usually'};
	print "</td> </tr>\n";

	print "<td><b>$self->{'text_hash'}->{'poll_fetchall'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=fetchall_$self->{'i'} value=1 %s> %s\n",
		$u->{'fetchall'} eq '1' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=fetchall_$self->{'i'} value=0 %s> %s\n",
		$u->{'fetchall'} eq '0' ? 'checked' : '', $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=fetchall_$self->{'i'} value='' %s> %s (%s)\n",
		$u->{'fetchall'} eq '' ? 'checked' : '', $self->{'text_hash'}->{'default'},
		$self->{'text_hash'}->{'poll_usually'};
	print "</td> </tr>\n";

	print "<td><b>$self->{'text_hash'}->{'poll_ssl'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=ssl_$self->{'i'} value=1 %s> %s\n",
		$u->{'ssl'} eq '1' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=ssl_$self->{'i'} value=0 %s> %s\n",
		$u->{'ssl'} eq '0' ? 'checked' : '', $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=ssl_$self->{'i'} value='' %s> %s (%s)\n",
		$u->{'ssl'} eq '' ? 'checked' : '', $self->{'text_hash'}->{'default'},
		$self->{'text_hash'}->{'poll_usually'};
	print "</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'poll_preconnect'}</b></td>\n";
	$u->{'preconnect'} =~ s/'/&#39;/g;
	printf "<td colspan=3><input name=preconnect_$self->{'i'} size=50 value='%s'></td> </tr>\n", $u->{'preconnect'};

	print "<tr> <td><b>$self->{'text_hash'}->{'poll_postconnect'}</b></td>\n";
	$u->{'postconnect'} =~ s/'/&#39;/g;
	printf "<td colspan=3><input name=postconnect_$self->{'i'} size=50 value='%s'></td></tr>\n", $u->{'postconnect'};

	print "</table></td></tr></table>\n";
	$self->{'i'}++;
	}

print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	if (!$self->{'in_hash'}->{'adduser'}) {
		print "<td align=middle><input type=submit name=adduser ",
		      "value='$self->{'text_hash'}->{'poll_adduser'}'></td>\n";
		}
	print "<td align=middle><input type=submit name=check ",
	      "value='$self->{'text_hash'}->{'poll_check'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";

if (!$self->{'fetchmail_config'} && $self->{'config_hash'}->{'view_mode'}) {
	$self->ui_print_footer("edit_user.cgi?user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'user_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

