#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newchain.cgi
# Create a new user-defined chain

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->{'access_hash'}->{'newchain'} || $self->error($self->{'text_hash'}->{'new_ecannot'});
$self->ReadParse();
@{$self->{'tables_array'}} = $self->get_iptables_save();
$self->{'table'} = $self->{'tables_array'}->[$self->{'in_hash'}->{'table'}];
$self->can_edit_table($self->{'table'}->{'name'}) || $self->error($self->{'text_hash'}->{'etable'});
$self->error_setup($self->{'text_hash'}->{'new_err'});
$self->lock_file($self->{'iptables_save_file'});
$self->{'in_hash'}->{'chain'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'new_ename'});
$self->{'table'}->{'defaults'}->{$self->{'in_hash'}->{'chain'}} && $self->error($self->{'text_hash'}->{'new_etaken'});
$self->{'table'}->{'defaults'}->{$self->{'in_hash'}->{'chain'}} = '-';
$self->run_before_command();
$self->save_table($self->{'table'});
$self->run_after_command();
$self->copy_to_cluster();
$self->unlock_file($self->{'iptables_save_file'});
$self->webmin_log("create", "chain", undef, { 'chain' => $self->{'in_hash'}->{'chain'},
					'table' => $self->{'table'}->{'name'} });

$self->redirect("index.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

