#!/usr/bin/perl
package format::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'format::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "format::FormatLib");
$self = new format::FormatLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the format module
sub acl_security_form
{
	my $self = shift;

local @dlist = $self->list_disks();
local ($d, %dcan);
map { $dcan{$_}++ } split(/\s+/, $_[0]->{'disks'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_disks'}</b></td> <td>\n";
printf "<input type=radio name=disks_def value=1 %s> %s\n",
	$_[0]->{'disks'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_dall'};
printf "<input type=radio name=disks_def value=0 %s> %s<br>\n",
	$_[0]->{'disks'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_dsel'};
print "<select name=disks size=4 multiple>\n";
foreach $d (@dlist) {
	$d->{'device'} =~ s/^.*\///;
	printf "<option value='%s' %s>%s\n",
		$d->{'device'},
		$dcan{$d->{'device'}} ? "selected" : "",
		"$d->{'desc'} ($d->{'type'})";
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_view'}</b></td>\n";
print "<td>",$self->ui_radio("view", $self->{'access_hash'}->{'view'}, 
	       [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the format module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'disks_def'}) {
	$_[0]->{'disks'} = "*";
	}
else {
	$_[0]->{'disks'} = join(" ", split(/\0/, $self->{'in_hash'}->{'disks'}));
	}
$_[0]->{'view'} = $self->{'in_hash'}->{'view'};
}


1;

