#!/usr/bin/perl

&MAIN();

 sub MAIN {
# copy_part_form.cgi
# Display a form for copying the partitions map of this disk to otthers

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ui_print_header(undef, "Copy Partition Map", "");
$self->{'extwidth'} = 400;

print "This form allows you to copy the partition map from this disk\n";
print "to others of the same size. This is useful for setting up disks\n";
print "for use as parts of a RAID or mirrored MetaDisk.<p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>Partition</b></td> <td><b>Tag</b></td>\n";
print "<td><b>Extent</b></td> <td><b>Start</b></td> <td><b>End</b></td></tr>\n";
@{$self->{'dlist_array'}} = $self->list_disks();
@dinfo = split(/\s+/, $self->{'dlist_array'}->[$self->{'in_hash'}->{disk}]); $self->{'cyl'} = $dinfo[2];
@{$self->{'plist_array'}} = $self->list_partitions($self->{'in_hash'}->{disk});
for($i=0; $i<@{$self->{'plist_array'}}; $i++) {
	@p = split(/\s+/, $self->{'plist_array'}->[$i]);
	print "<tr $self->{'cb'}> <td>$i</td> <td>$p[0]</td>\n";
	if ($p[3]) {
		printf "<td><img src=images/gap.gif height=10 width=%d>",
			$self->{'extwidth'}*$p[2]/$self->{'cyl'};
		printf "<img src=images/use.gif height=10 width=%d>",
			$self->{'extwidth'}*($p[3]-$p[2])/$self->{'cyl'};
		printf "<img src=images/gap.gif height=10 width=%d></td>\n",
			$self->{'extwidth'}*($self->{'cyl'}-$p[3])/$self->{'cyl'};
		print "<td>$p[2]</td> <td>$p[3]</td> </tr>\n";
		}
	else { print "<td colspan=3><br></td>\n"; }
	print "</tr>\n";
	}
print "</table><p>\n";

# find all disks that are not in use
print "Select the disks to copy this partition map to..<br>\n";
print "<form action=copy_part.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}><td></td> <td><b>Disk Type</b></td> <td><b>Cylinders</b></td>\n";
print "     <td><b>Controller</b></td> <td><b>Target</b></td>\n";
print "     <td><b>Unit</b></td> <td><b>Device</b></td> <td><br></td> </tr>\n";
for($i=0; $i<@{$self->{'dlist_array'}}; $i++) {
	print "<tr $self->{'cb'}> <td width=20>";
	@d = split(/\s+/, $self->{'dlist_array'}->[$i]);
	undef($self->{'err'});
	if ($d[2] ne $self->{'cyl'}) { $self->{'err'} = "Different disk size"; }
	elsif ($i == $self->{'in_hash'}->{disk}) { $self->{'err'} = "Source disk"; }
	else {
		@{$self->{'plist_array'}} = split(/\s+/, $self->list_partitions($i));
		for($j=0; $j<@{$self->{'plist_array'}}; $j++) {
			$self->{'dev'} = "/dev/dsk/$d[0]s$j";
			if ($self->device_status($self->{'dev'})) {
				$self->{'err'} = "Currently in use";
				}
			}
		}

	if (!$self->{'err'}) { print "<input type=checkbox name=disk$i>\n"; }
	else { print "<br>"; }
	print "</td>\n";

	print "<td>$d[1]</td> <td>$d[2]</td>\n";
	$d[0] =~ /c(\d+)t(\d+)d(\d+)/;
	print "<td>$1</td> <td>$2</td> <td>$3</td> <td>$d[0]</td>\n";
	if ($self->{'err'}) { print "<td><font color=#ff0000>$self->{'err'}</font></td> </tr>\n"; }
	else { print "<td><font color=#00ff00>Possible target</font></td> </tr>\n"; }
	if (!$self->{'err'}) { $self->{'foundone'} = 1; }
	}
print "</table><p>\n";
if ($self->{'foundone'}) { print "<input type=submit value=Copy>\n"; }
else { print "No disks are possible targets for copying.\n"; }
print "</form>\n";

$self->ui_print_footer("", "disk list");

1;
		
}


1;

