#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of known disks and partitions

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("format", "man"));
$self->{'extwidth'} = 250;

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_disk'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'index_parts'}</b></td> </tr>\n";
@{$self->{'dlist_array'}} = $self->list_disks();
$self->{'mountcan'} = $self->foreign_available("mount");
for($i=0; $i<@{$self->{'dlist_array'}}; $i++) {
	$self->{'dl'} = $self->{'dlist_array'}->[$i];
	next if (!$self->can_edit_disk($self->{'dl'}->{'device'}));
	print "<tr $self->{'cb'}> <td valign=top><table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_location'}</b></td> ";
	print "<td>$self->{'dl'}->{'desc'}</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_cyl'}</b></td>\n";
	print "<td>$self->{'dl'}->{'cyl'}</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'index_model'}</b></td> ";
	print "<td>",$self->{'dl'}->{'type'} ? $self->{'dl'}->{'type'} : $self->{'text_hash'}->{'index_unknown'},
	      "</td> </tr>\n";
	print "</table></td> <td valign=top>\n";
	if (!$self->{'dl'}->{'device'}) {
		# Drive type unknown..
		print "<b>$self->{'text_hash'}->{'index_unknown2'}</b>\n";
		}
	elsif (@{$self->{'parts_array'}} = $self->list_partitions($self->{'dl'}->{'device'})) {
		# Known and formatted..
		print "<table width=100%>\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'index_no'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_type'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_extent'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_start'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_end'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_use'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_free'}</b></td> </tr>\n";
		for($j=0; $j<@{$self->{'parts_array'}}; $j++) {
			$self->{'p'} = $self->{'parts_array'}->[$j];
			print "<tr> <td>\n";
			if ($self->{'access_hash'}->{'view'}) {
				print $j;
				}
			else {
				print "<a href=\"edit_part.cgi?$i+$j\">$j</a>";
				}
			print "</td> <td>$self->{'p'}->{'tag'}</td> <td>\n";
			if ($self->{'p'}->{'end'} != 0) {
				printf
				  "<img src=images/gap.gif height=10 width=%d>",
				  $self->{'extwidth'}*$self->{'p'}->{'start'}/$self->{'dl'}->{'cyl'};
				printf
				  "<img src=images/use.gif height=10 width=%d>",
				  $self->{'extwidth'}*($self->{'p'}->{'end'}-$self->{'p'}->{'start'})/
				  $self->{'dl'}->{'cyl'};
				printf
				  "<img src=images/gap.gif height=10 width=%d>",
				  $self->{'extwidth'}*($self->{'dl'}->{'cyl'}-$self->{'p'}->{'end'})/
				  $self->{'dl'}->{'cyl'};
				print "</td> <td>$self->{'p'}->{'start'}</td> ",
				      "<td>$self->{'p'}->{'end'}</td> <td>\n";
				@{$self->{'stat_array'}} = $self->device_status($self->{'p'}->{'device'});
				if ($self->{'stat_array'}->[1] =~ /^meta/) {
					print "MetaDisk\n";
					}
				elsif (!$self->{'mountcan'}) {
					print "<tt>$self->{'stat_array'}->[0]</tt>\n";
					}
				elsif ($self->{'stat_array'}->[0] && $self->{'stat_array'}->[3] == -1) {
					print "<tt><a href=/mount/edit_mount.cgi?index=$self->{'stat_array'}->[4]&temp=1&return=/$self->{'module_name'}/>$self->{'stat_array'}->[0]</a></tt>\n";
					}
				elsif ($self->{'stat_array'}->[0]) {
					print "<tt><a href=/mount/edit_mount.cgi?index=$self->{'stat_array'}->[3]&return=/$self->{'module_name'}/>$self->{'stat_array'}->[0]</a></tt>\n";
					}
				print "</td> <td>\n";
				if ($self->{'stat_array'}->[0] ne 'swap' &&
				    (@{$self->{'space_array'}} = $self->disk_space($self->{'p'}->{'device'})) &&
				    $self->{'space_array'}->[0]) {
					printf "%d %%\n",
					       100 * $self->{'space_array'}->[1] / $self->{'space_array'}->[0];
					}
				print "</td> </tr>\n";
				}
			else { print "<td colspan=5></td>\n"; }
			}
		print "</table>\n";
		}
	else {
		# Disk is not formatted.. 
		print "<b>$self->{'text_hash'}->{'index_format'}</b>\n";
		}
	print "</td> </tr>\n";
	}
print "</table><p>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

