#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newfs_form.cgi
# Display a form asking for new filesystem details

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error("You are not allowed to format this disk");
$self->ui_print_header(undef, "Create Filesystem", "");

print "<form action=newfs.cgi>\n";
print "<input type=hidden name=dev value=\"$self->{'in_hash'}->{dev}\">\n";
print $self->text('newfs_desc', "<b>".$self->fstype_name("ufs")."</b>",
			  "<b><tt>$self->{'in_hash'}->{dev}</tt></b>"),"<p>\n";

if ((@{$self->{'stat_array'}} = $self->device_status($self->{'in_hash'}->{dev})) && $self->{'stat_array'}->[1] ne "swap") {
	print $self->text('newfs_warn', "<tt>$self->{'stat_array'}->[0]</tt>"),"<p>\n";
	}

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'newfs_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$self->opt_input("ufs_a", "", 1);
$self->opt_input("ufs_b", "bytes", 0);
$self->opt_input("ufs_c", "", 1);
$self->opt_input("ufs_d", "ms", 0);
$self->opt_input("ufs_f", "bytes", 1);
$self->opt_input("ufs_i", "bytes", 0);
$self->opt_input("ufs_m", "%", 1);
$self->opt_input("ufs_n", "", 0);
print "<tr> <td align=right><b>$self->{'text_hash'}->{'ufs_o'}</b></td>\n";
print "<td><select name=ufs_o>\n";
print "<option value=''> $self->{'text_hash'}->{'default'}\n";
print "<option value=space> $self->{'text_hash'}->{'newfs_space'}\n";
print "<option value=time> $self->{'text_hash'}->{'newfs_time'}\n";
print "</select></td>\n";
$self->opt_input("ufs_r", "rpm", 0);
$self->opt_input("ufs_s", "sectors", 1);
$self->opt_input("ufs_t", "", 0);
$self->opt_input("ufs_cb", "", 1);
print "</table></td></tr></table><br>\n";

print "<div align=right>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'newfs_create'}\"></form>\n";
print "</div>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

