#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_part.cgi
# Save an existing partition

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ReadParse();

# check start and end
@{$self->{'dlist_array'}} = $self->list_disks();
$self->{'dinfo'} = $self->{'dlist_array'}->[$self->{'in_hash'}->{'disk'}];
$self->can_edit_disk($self->{'dinfo'}->{'device'}) ||
	$self->error($self->{'text_hash'}->{'save_ecannot'});
if ($self->{'in_hash'}->{delete}) {
	# unassigning a partition
	$self->error_setup($self->{'text_hash'}->{'save_edelete'});
	$self->modify_partition($self->{'in_hash'}->{'disk'}, $self->{'in_hash'}->{'part'}, "unassigned", "wu", "", "");
	$self->redirect("");
	}
else {
	# changing an existing partition
	$self->error_setup($self->{'text_hash'}->{'save_esave'});
	$self->{'in_hash'}->{start} =~ /^\d+$/ ||
		$self->error($self->text('save_estart', $self->{'in_hash'}->{start}));
	$self->{'in_hash'}->{end} =~ /^\d+$/ ||
		$self->error($self->text('save_eend', $self->{'in_hash'}->{end}));
	$self->{'in_hash'}->{start} >= 0 ||
		$self->error($self->{'text_hash'}->{'save_estartmin'});
	$self->{'in_hash'}->{end} < $self->{'dinfo'}->{'cyl'} ||
		$self->error($self->text('save_eendmax', $self->{'dinfo'}->{'cyl'}));
	$self->{'in_hash'}->{start} < $self->{'in_hash'}->{end} ||
		$self->error($self->{'text_hash'}->{'save_estartend'});

	# make the change
	$self->{'flag'} = ($self->{'in_hash'}->{writable} ? "w" : "r").($self->{'in_hash'}->{mountable} ? "m" : "u");
	$self->modify_partition($self->{'in_hash'}->{disk}, $self->{'in_hash'}->{part}, $self->{'in_hash'}->{tag}, $self->{'flag'},
			  $self->{'in_hash'}->{start}, $self->{'in_hash'}->{end});
	$self->redirect("");
	}

1;
		
}


1;

