#!/usr/bin/perl

&MAIN();

 sub MAIN {
# tunefs.cgi
# You can tune a filesystem, but you can't tuna fish

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'tunefs_ecannot'});
$self->error_setup($self->{'text_hash'}->{'tunefs_err'});

$self->{'cmd'} = "tunefs";
$self->{'cmd'} .= $self->opt_check("tunefs_a", '\d+', "-a");
$self->{'cmd'} .= $self->opt_check("tunefs_d", '\d+', "-d");
$self->{'cmd'} .= $self->opt_check("tunefs_e", '\d+', "-e");
$self->{'cmd'} .= $self->opt_check("tunefs_m", '\d+', "-m");
$self->{'cmd'} .= $self->{'in_hash'}->{tunefs_o} ? " -o $self->{'in_hash'}->{tunefs_o}" : "";
$self->{'in_hash'}->{dev} =~ s/dsk/rdsk/g;
$self->{'cmd'} .= " $self->{'in_hash'}->{dev}";

$self->ui_print_header(undef, $self->{'text_hash'}->{'tunefs_title'}, "");

print $self->text('tunefs_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>\n";
open(TUNEFS, "$self->{'cmd'} 2>&1 </dev/null |");
while(<TUNEFS>) { print; }
close(TUNEFS);
print "</pre>\n";
if ($?) { print "$self->{'text_hash'}->{'tunefs_failed'}<p>\n"; }
else { print "$self->{'text_hash'}->{'tunefs_ok'}<p>\n"; }

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

