#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show FTP protocol options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ftp_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_ftp.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'ftp_header'}, "width=100%", 4);

print $self->config_yesno($self->{'conf'}, "APConv", undef, undef, "no");

print $self->config_yesno($self->{'conf'}, "PAConv", undef, undef, "no");

print $self->config_yesno($self->{'conf'}, "BounceDefend", undef, undef, "yes");

print $self->config_yesno($self->{'conf'}, "SameAddress", undef, undef, "yes");

print $self->config_yesno($self->{'conf'}, "AllowNonASCII", undef, undef, "no");

print $self->config_yesno($self->{'conf'}, "TransparentData", undef, undef, "no");

print $self->config_opt_range($self->{'conf'}, "ControlPorts", 3);

print $self->config_opt_range($self->{'conf'}, "PassivePorts", 3);

print $self->config_opt_range($self->{'conf'}, "ActivePorts", 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

