#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show general options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'general_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_general.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'general_header'}, "width=100%", 4);

print $self->config_user($self->{'conf'}, "User");

print $self->config_group($self->{'conf'}, "Group");

print $self->config_textbox($self->{'conf'}, "WorkingDir", 30, 3);

print $self->config_yesno($self->{'conf'}, "DontChroot", $self->{'text_hash'}->{'no'}, $self->{'text_hash'}->{'yes'}, "no");

print $self->config_opt_textbox($self->{'conf'}, "LogLevel", 4);

print $self->config_opt_textbox($self->{'conf'}, "PidFile", 30, 3, $self->{'text_hash'}->{'general_nowhere'});

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

