#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show networking-related options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_net.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'net_header'}, "width=100%", 4);

print $self->config_opt_textbox($self->{'conf'}, "Listen", 40, 3, $self->{'text_hash'}->{'net_all'});

print $self->config_textbox($self->{'conf'}, "Port", 6);

print $self->config_opt_textbox($self->{'conf'}, "BindToDevice", 6, 1, $self->{'text_hash'}->{'net_all'});

print $self->config_yesno($self->{'conf'}, "FromInetd", undef, undef, "no");

print $self->config_exists($self->{'conf'}, "NoDetach", $self->{'text_hash'}->{'net_fg'}, $self->{'text_hash'}->{'net_bg'});

print $self->config_opt_textbox($self->{'conf'}, "FTPProxy", 30, 3, $self->{'text_hash'}->{'net_none'});

print $self->config_opt_textbox($self->{'conf'}, "TcpOutgoingAddr", 20, 3);

print $self->config_opt_textbox($self->{'conf'}, "PASVAddress", 20, 3);

print $self->config_opt_textbox($self->{'conf'}, "ResolvLoadHack", 40, 3, $self->{'text_hash'}->{'net_none'});

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

