#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save FTP protocol options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ftp_err'});
$self->{'conf'} = $self->get_config();

$self->save_yesno($self->{'conf'}, "APConv");
$self->save_yesno($self->{'conf'}, "PAConv");
!$self->{'in_hash'}->{'APConv'} || !$self->{'in_hash'}->{'PAConv'} || $self->error($self->{'text_hash'}->{'ftp_econv'});
$self->save_yesno($self->{'conf'}, "BounceDefend");
$self->save_yesno($self->{'conf'}, "SameAddress");
$self->save_yesno($self->{'conf'}, "AllowNonASCII");
$self->save_yesno($self->{'conf'}, "TransparentData");
$self->save_opt_range($self->{'conf'}, "ControlPorts");
$self->save_opt_range($self->{'conf'}, "PassivePorts");
$self->save_opt_range($self->{'conf'}, "ActivePorts");

$self->lock_file($self->{'config_hash'}->{'frox_conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'frox_conf'});
$self->webmin_log("ftp");
$self->redirect("");

1;
		
}


1;

