#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Start the Frox proxy

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->error_setup($self->{'text_hash'}->{'start_err'});

# Fixed up file on Debian that controls startup script
if ($self->{'config_hash'}->{'daemon_file'}) {
	$self->lock_file($self->{'config_hash'}->{'daemon_file'});
	$self->read_env_file($self->{'config_hash'}->{'daemon_file'}, \%{$self->{'daemon_hash'}});
	if ($self->{'daemon_hash'}->{'RUN_DAEMON'} ne 'yes') {
		$self->{'daemon_hash'}->{'RUN_DAEMON'} = 'yes';
		$self->write_env_file($self->{'config_hash'}->{'daemon_file'}, \%{$self->{'daemon_hash'}});
		}
	$self->unlock_file($self->{'config_hash'}->{'daemon_file'});
	}

if ($self->{'config_hash'}->{'start_cmd'}) {
	$self->{'cmd'} = $self->{'config_hash'}->{'start_cmd'};
	}
else {
	$self->{'cmd'} = "$self->{'config_hash'}->{'frox'} -f $self->{'config_hash'}->{'frox_conf'}";
	}
$self->{'temp'} = $self->transname();
$self->{'ex'} = $self->system_logged("($self->{'cmd'}) >$self->{'temp'} 2>&1 </dev/null");
$self->{'out'} = `cat $self->{'temp'}`;
unlink($self->{'temp'});
if ($self->{'ex'} || (!$self->{'config_hash'}->{'start_cmd'} && $self->{'out'} =~ /\S/) || $self->{'out'} =~ /error/i) {
	$self->error("<pre>$self->{'out'}</pre>");
	}
$self->webmin_log("start");
$self->redirect("");

1;
		
}


1;

