#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of backups

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Delete each one, and its cron job
foreach $d (@d) {
	$self->{'dump'} = $self->get_dump($d);
	$self->{'access_hash'}->{'edit'} && $self->can_edit_dir($self->{'dump'}) ||
		$self->error($self->{'text_hash'}->{'dump_ecannot2'});
	@{$self->{'jobs_array'}} = $self->foreign_call("cron", "list_cron_jobs");
	($self->{'job'}) = grep { $_->{'command'} eq "$self->{'cron_cmd'} $self->{'dump'}->{'id'}" } @{$self->{'jobs_array'}};
	$self->delete_dump($self->{'dump'});
	if ($self->{'job'}) {
		$self->lock_file($self->{'job'}->{'file'});
		$self->foreign_call("cron", "delete_cron_job", $self->{'job'});
		$self->unlock_file($self->{'job'}->{'file'});
		}
	}

$self->webmin_log("delete", "dumps", scalar(@d));
$self->redirect("");

1;
		
}


1;

