#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newtape.cgi
# Indicate that a new tape is loaded for a backup job

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'newtape_err'});

$self->foreign_require("proc", "proc-lib.pl");
@{$self->{'procs_array'}} = $main::proc_object->list_processes();
@{$self->{'running_array'}} = $self->running_dumps(\@{$self->{'procs_array'}});

($self->{'job'}) = grep { $_->{'id'} == $self->{'in_hash'}->{'id'} &&
		$_->{'pid'} == $self->{'in_hash'}->{'pid'} } @{$self->{'running_array'}};
$self->{'job'} || $self->error($self->{'text_hash'}->{'newtape_egone'});
$self->can_edit_dir($self->{'job'}) || $self->error($self->{'text_hash'}->{'newtape_ecannot'});
$self->{'job'}->{'status'}->{'status'} eq 'tape' || $self->error($self->{'text_hash'}->{'newtape_estatus'});

kill('HUP', $self->{'job'}->{'status'}->{'tapepid'});
$self->redirect("");

1;
		
}


1;

