#!/usr/bin/perl

&MAIN();

 sub MAIN {
# restore_form.cgi
# Display a form with restore options

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'restore'} || $self->error($self->{'text_hash'}->{'restore_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'restore_title'}, "", "restore");

$self->{'m'} = $self->missing_restore_command($self->{'in_hash'}->{'fs'}) if ($self->{'in_hash'}->{'fs'} ne 'tar');
if ($self->{'m'}) {
	print "<p>",$self->text('restore_ecommand', "<tt>$self->{'m'}</tt>", uc($self->{'in_hash'}->{'fs'})),
	      "<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if ($self->{'in_hash'}->{'id'}) {
	# Restoring a specific dump
	$self->{'dump'} = $self->get_dump($self->{'in_hash'}->{'id'});
	}

print "<b>$self->{'text_hash'}->{'restore_desc'}</b><p>\n";

@{$self->{'tds_array'}} = ( "width=30%" );
print $self->ui_form_start("restore.cgi", "post");
print $self->ui_hidden("fs", $self->{'in_hash'}->{'fs'}),"\n";
print $self->ui_table_start($self->{'in_hash'}->{'fs'} eq 'tar' ? $self->{'text_hash'}->{'restore_theader'} :
			$self->text('restore_header', uc($self->{'in_hash'}->{'fs'})),
		      "width=100%", 4);

$self->restore_form($self->{'in_hash'}->{'fs'}, $self->{'dump'}, \@{$self->{'tds_array'}});

if ($self->{'access_hash'}->{'extra'}) {
	print $self->ui_table_row($self->hlink($self->{'text_hash'}->{'restore_extra'}, "rextra"),
			    $self->ui_textbox("extra", undef, 60), 3, \@{$self->{'tds_array'}});
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'restore_ok'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

