#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_title.cgi
# Display menu option details

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->ReadParse();
$self->{'conf'} = $self->get_menu_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'title_add'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'title_edit'}, "");
	$self->{'title'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_title.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'title_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'title_title'}</b></td>\n";
printf "<td colspan=3><input name=title size=35 value='%s'></td> </tr>\n",
	$self->{'title'}->{'value'};

$self->{'r'} = $self->{'title'}->{'root'} || $self->{'title'}->{'rootnoverify'};
if (!$self->{'r'}) {
	$self->{'mode'} = 0;
	}
elsif ($self->{'dev'} = $self->bios_to_linux($self->{'r'})) {
	$self->{'mode'} = 2;
	}
else {
	$self->{'mode'} = 1;
	}
$self->{'sel'} = $self->foreign_call("fdisk", "partition_select", "root", $self->{'dev'}, 2, \$self->{'found'});
if (!$self->{'found'} && $self->{'mode'} == 2) {
	$self->{'mode'} = 1;
	}

print "<td><b>$self->{'text_hash'}->{'title_root'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=root_mode value=0 %s> %s\n",
	$self->{'mode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=root_mode value=2 %s> %s %s\n",
	$self->{'mode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'title_sel'}, $self->{'sel'};
printf "<input type=radio name=root_mode value=1 %s> %s\n",
	$self->{'mode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'title_other'};
printf "<input name=other size=10 value='%s'><br>\n",
	$self->{'mode'} == 1 ? $self->{'title'}->{'root'} : '';

print "&nbsp;" x 3;
printf "<input type=checkbox name=noverify value=1 %s> %s</td> </tr>\n",
	$self->{'title'}->{'rootnoverify'} ? "checked" : "", $self->{'text_hash'}->{'title_noverify'};

$self->{'boot'} = $self->{'title'}->{'chainloader'} ? 1 :
	$self->{'title'}->{'kernel'} ? 2 : 0;
if ($self->{'boot'} == 2) {
	$self->{'title'}->{'kernel'} =~ /^(\S+)\s*(.*)$/;
	$self->{'kernel'} = $1; $self->{'args'} = $2;
	}
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'title_boot'}</b></td> <td colspan=3>\n";
print "<table width=100%>\n";

printf "<tr> <td valign=top><input type=radio name=boot_mode value=2 %s> %s</td>\n",
	$self->{'boot'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'title_kernel'};
printf "<td>%s <input name=kernel size=40 value='%s'> %s<br>\n",
	$self->{'text_hash'}->{'title_kfile'}, $self->{'kernel'};
printf "%s <input name=args size=40 value='%s'><br>\n",
	$self->{'text_hash'}->{'title_args'}, $self->{'args'};
printf "%s <input type=radio name=initrd_def value=1 %s> %s\n",
	$self->{'text_hash'}->{'title_initrd'}, $self->{'title'}->{'initrd'} ? "" : "checked", 
	$self->{'text_hash'}->{'global_none'};
printf "<input type=radio name=initrd_def value=0 %s>\n",
	$self->{'title'}->{'initrd'} ? "checked" : "";
printf "<input name=initrd size=30 value='%s'></td> </tr>\n",
	$self->{'title'}->{'initrd'};

$self->{'chain'} = $self->{'title'}->{'chainloader'};
printf "<tr> <td valign=top><input type=radio name=boot_mode value=1 %s> %s</td>\n",
	$self->{'boot'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'title_chain'};
printf "<td><input type=radio name=chain_def value=1 %s> %s<br>\n",
	$self->{'chain'} eq '+1' || !$self->{'chain'} ? 'checked' : '',
	$self->{'text_hash'}->{'title_chain_def'};
printf "<input type=radio name=chain_def value=0 %s> %s\n",
	$self->{'chain'} eq '+1' || !$self->{'chain'} ? '' : 'checked',
	$self->{'text_hash'}->{'title_chain_file'};
printf "<input name=chain size=40 value='%s'><br>\n",
	$self->{'chain'} eq '+1' ? '' : $self->{'chain'};
printf "<input type=checkbox name=makeactive value=1 %s> %s</td> </tr>\n",
	defined($self->{'title'}->{'makeactive'}) ? 'checked' : '',
	$self->{'text_hash'}->{'title_makeactive'};

printf "<tr> <td colspan=2><input type=radio name=boot_mode value=0 %s> %s</td> </tr>\n",
	$self->{'boot'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'title_none'};

print "</table></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'title_lock'}</b></td>\n";
printf "<td><input type=radio name=lock value=1 %s> %s\n",
	defined($self->{'title'}->{'lock'}) ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=lock value=0 %s> %s</td> </tr>\n",
	defined($self->{'title'}->{'lock'}) ? "" : "checked", $self->{'text_hash'}->{'no'};

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
print "<td align=left><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<td align=right>",
	     "<input type=submit name=delete value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

