#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display GRUB menu titles

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("grub", "man", "doc"));

# Check that GRUB is installed
if (!-r $self->{'config_hash'}->{'menu_file'}) {
	print "<p>",$self->text('index_efile', "<tt>$self->{'config_hash'}->{'menu_file'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if (!$self->has_command($self->{'config_hash'}->{'grub_path'})) {
	print "<p>",$self->text('index_epath', "<tt>$self->{'config_hash'}->{'grub_path'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# List the boot options
$self->{'conf'} = $self->get_menu_config();
$self->{'def'} = $self->find_value("default", $self->{'conf'});
foreach $t ($self->find("title", $self->{'conf'})) {
	push(@{$self->{'icons_array'}}, $t->{'chainloader'} ? "images/chain.gif"
					 : "images/kernel.gif");
	local $tt = $self->html_escape($t->{'value'});
	push(@{$self->{'titles_array'}}, $self->{'def'} == $self->{'i'} ? "<b>$tt</b>" : $tt);
	push(@{$self->{'links_array'}}, "edit_title.cgi?idx=$t->{'index'}");
	$self->{'i'}++;
	}
if (@{$self->{'links_array'}}) {
	print "<a href='edit_title.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><br>\n";
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
print "<a href='edit_title.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><p>\n";
print "<hr>\n";

print "<table width=100%>\n";
print "<form action=edit_global.cgi>\n";
print "<tr><td><input type=submit value=\"$self->{'text_hash'}->{'index_global'}\"></td>\n";
print "<td>$self->{'text_hash'}->{'index_globalmsg'}</td></tr></form>\n";

%{$self->{'flang_hash'}} = $self->load_language('fdisk');
$self->{'text_hash'}->{'select_part'} = $self->{'flang_hash'}->{'select_part'};
$self->{'text_hash'}->{'select_device'} = $self->{'flang_hash'}->{'select_device'};
$self->{'text_hash'}->{'select_fd'} = $self->{'flang_hash'}->{'select_fd'};
$self->{'r'} = $self->{'config_hash'}->{'install'};
$self->{'dev'} = $self->bios_to_linux($self->{'r'});
$self->foreign_require("mount", "mount-lib.pl");
$self->{'dev'} = $main::mount_object->device_name($self->{'dev'});
print "<form action=install.cgi>\n";
print "<input type=hidden name=dev value='$self->{'dev'}'>\n";
print "<tr><td><input type=submit value=\"$self->{'text_hash'}->{'index_install'}\"></td>\n";
print "<td>",$self->text('index_installmsg', $self->{'dev'}),"</td></tr></form>\n";

print "</table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

