#!/usr/bin/perl

&MAIN();

 sub MAIN {

#
# Copyright (c) 2005 by Positive Software Corporation, a Comodo Group Company
# CP+ / ZTL projects
#
# Used for showing simple admin and domain owner interface, 
# what depends on installed services and configured modules
#

&ModuleLoader::preload_module('home_class', "home::HomeLib");
$self = new home::HomeLib:: 'home_class',%$self;


$self->foreign_require("virtual_server", "virtual-server-lib.pl");
$self->foreign_call("virtual_server","ztl_check_quotas") if $self->{'gconfig_hash'}->{'ztl_mode'};

$self->ReadParse();

$self->foreign_require("licmanage", "licmanage-lib.pl");
$self->{'lic'} = $main::licmanage_object->get_licinfo();
if ($self->{'lic'}->{'ret'} || !$self->check_date_string($self->{'lic'}->{'d_begin2'}) || !$self->check_date_string($self->{'lic'}->{'d_expire2'})) {
	$self->ui_print_header();
	print <<EOF;
<script language="javascript">
<!--
top.location.replace("/index.cgi");
// -->
</script>
EOF
	$self->ui_print_footer();
	exit;
}

local ($ruser_level, $ruser_domain) = $self->ztl_get_access_level($self->{'remote_user'});

if (! $self->{'in_hash'}->{'noredir'} && $self->get_mode_user() && !$ruser_level) {
	$self->redirect("/showcat.cgi");
	};

if ($ruser_level == 0 && !$self->{'gconfig_hash'}->{'ztl_mode'} && $self->configured('confmaster')) {
        if ($self->{'config_hash'}->{'need_configure'}==1) {
                $self->{'config_hash'}->{'need_configure'}=0;
                $self->save_module_config();
                $self->redirect("/confmaster/configure_servers.cgi");
                exit;
        }
}

$self->header();
if ($self->foreign_call("virtual_server","master_admin") && !$self->{'gconfig_hash'}->{'ztl_mode'}) {
	$self->foreign_require('virtual_server', 'check.pl');
}
local %apps = ();
$self->ztl_get_appliances(\%apps);

if ($ruser_level == 0) {
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.webmanage");
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.samba") if $self->{'gconfig_hash'}->{'ztl_mode'};
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.networkmanage") if $self->{'gconfig_hash'}->{'ztl_mode'};
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.servermanage");
}
elsif ($ruser_level == 1) {
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.webmanage2");
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.account");
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.webadv");
	$self->print_menu(\%apps, "$self->{'module_root_directory'}/menu.serverinfo");
}
$self->ui_print_footer();
1;
		
}


1;

