#!/usr/bin/perl
package htaccess_htpasswd::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess_htpasswd::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the htaccess module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td nowrap><b>$self->{'text_hash'}->{'acl_user'}</b></td>\n";
printf "<td><input type=radio name=user_def value=1 %s> %s\n",
	$_[0]->{'user'} eq "*" ? "checked" : "", $self->{'text_hash'}->{'acl_same'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} eq "*" ? "" : "checked";
print $self->unix_user_input("user", $_[0]->{'user'} eq "*" ? "" : $_[0]->{'user'});
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dirs'}</b></td>\n";
print "<td><textarea name=dirs rows=5 cols=50>",
	join("\n", split(/\t+/, $_[0]->{'dirs'})),
	"</textarea><br>\n";
printf "<input type=checkbox name=home value=1 %s> %s</td> </tr>\n",
	$_[0]->{'home'} ? "checked" : "", $self->{'text_hash'}->{'acl_home'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_sync'}</b></td> <td>\n";
printf "<input type=radio name=sync value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'sync'} ? 'checked' : '';
printf "<input type=radio name=sync value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'sync'} ? '' : 'checked';
}

# acl_security_save(&options)
# Parse the form for security options for the cron module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'user'} = $self->{'in_hash'}->{'user_def'} ? "*" : $self->{'in_hash'}->{'user'};
$self->{'in_hash'}->{'dirs'} =~ s/\r//g;
$_[0]->{'dirs'} = join("\t", split(/\n/, $self->{'in_hash'}->{'dirs'}));
$_[0]->{'home'} = $self->{'in_hash'}->{'home'};
$_[0]->{'sync'} = $self->{'in_hash'}->{'sync'};
}


1;

