#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple .htaccess files

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->foreign_require($self->{'apachemod'}, "apache-lib.pl");
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Do the deletion of the .htaccess file and any user and group files
@{$self->{'dirs_array'}} = $self->list_directories();
foreach $d (@d) {
	($self->{'dir'}) = grep { $_->[0] eq $d } @{$self->{'dirs_array'}};
	if ($self->{'dir'}) {
		$self->{'htaccess'} = "$self->{'dir'}->[0]/$self->{'config_hash'}->{'htaccess'}";
		$self->can_access_dir($self->{'htaccess'}) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
		$self->unlink_logged($self->{'htaccess'});
		$self->unlink_logged($self->{'dir'}->[1]);
		$self->unlink_logged($self->{'dir'}->[4]) if ($self->{'dir'}->[4]);
		@{$self->{'dirs_array'}} = grep { $_ ne $self->{'dir'} } @{$self->{'dirs_array'}};
		}
	}

# Save directory list
$self->save_directories(\@{$self->{'dirs_array'}});
$self->webmin_log("delete", "dirs", scalar(@d));
$self->redirect("");

1;
		
}


1;

