#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dir.cgi
# Display information about a protected directory

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->foreign_require($self->{'apachemod'}, "apache-lib.pl");
$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'dir_title1'}, "", undef, 0, 1);
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'dir_title1'}, "", undef, 0, 1);
	@{$self->{'dirs_array'}} = $self->list_directories();
	($self->{'dir'}) = grep { $_->[0] eq $self->{'in_hash'}->{'dir'} } @{$self->{'dirs_array'}};
	$self->can_access_dir($self->{'dir'}->[0]) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
	}

print "<form action=save_dir.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'dir_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

# Directory to protect
print "<tr> <td><b>$self->{'text_hash'}->{'dir_dir'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'new'}) {
	printf "<input name=dir size=50 value='%s'> %s\n",
		$self->{'dir'}->[0], $self->file_chooser_button("dir", 1);
	}
else {
	print "<input type=hidden name=dir value='$self->{'in_hash'}->{'dir'}'>\n";
	print "<tt>$self->{'dir'}->[0]</tt>\n";
	}
print "</td> </tr>\n";

# File containing users
print "<input type=hidden name=auto value=1>\n";

# File containing groups
print "<input type=hidden name=gauto value=1>\n";

# If MD5 encryption is available, show option for it
@{$self->{'crypts_array'}} = ( 0 );
push(@{$self->{'crypts_array'}}, 1) if ($self->{'config_hash'}->{'md5'});
push(@{$self->{'crypts_array'}}, 2) if ($self->{'config_hash'}->{'sha1'});
push(@{$self->{'crypts_array'}}, 3) if ($self->{'config_hash'}->{'digest'});
if (@{$self->{'crypts_array'}} > 1) {
	print $self->ui_hidden("crypt", int($self->{'dir'}->[2]),
	[ map { [ $_, $self->{'text_hash'}->{'dir_crypt'.$_} ] } @{$self->{'crypts_array'}} ]),"\n";
	}
else {
	print "<input type=hidden name=crypt value=$self->{'crypts_array'}->[0]>\n";
	}

# Authentication realm
print "<tr> <td><b>$self->{'text_hash'}->{'dir_realm'}</b></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'conf'} = $self->foreign_call($self->{'apachemod'}, "get_htaccess_config",
			      "$self->{'dir'}->[0]/$self->{'config_hash'}->{'htaccess'}");
	$self->{'realm'} = $self->foreign_call($self->{'apachemod'}, "find_directive",
			       "AuthName", $self->{'conf'}, 1);
	}
printf "<td><input name=realm size=40 value='%s'></td> </tr>\n",
	$self->{'realm'};

# Users and groups to allow
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'require'} = $self->foreign_call($self->{'apachemod'}, "find_directive_struct",
				 "require", $self->{'conf'});
	($self->{'rmode'}, @{$self->{'rwho_array'}}) = @{$self->{'require'}->{'words'}} if ($self->{'require'});
	}
else {
	$self->{'rmode'} = "valid-user";
	}
print $self->ui_hidden("require_mode", $self->{'rmode'}),"\n";

# Webmin synchronization mode
if ($self->{'can_sync'}) {
	%{$self->{'sync_hash'}} = map { $_, 1 } split(/,/, $self->{'dir'}->[3]);
	foreach $s ('create', 'update', 'delete') {
		printf "<input type=hidden name=sync_$s value=0>\n";
		}
	}

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'dir_delete'}'>\n";
	print "<input type=hidden name=remove value=1> ";
	}
print "</form>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, "",$self->{'text_hash'}->{'return_index'});

1;
		
}


1;

