#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start.cgi
# Save config and restart rpc.idmapd

&ModuleLoader::preload_module('idmapd_class', "idmapd::IdmapdLib");
$self = new idmapd::IdmapdLib:: 'idmapd_class',%$self;


$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err', $self->{'config_hash'}->{'idmap_conf'}});

# Check directory
-d $self->{'in_hash'}->{'pipefsdir'} || $self->error($self->text('error_dir', $self->{'in_hash'}->{'pipefsdir'}));

# Write the config file
$self->lock_file($self->{'config_hash'}->{'idmapd_conf'});
open(FILE, "> $self->{'config_hash'}->{'idmapd_conf'}");
print FILE "[General]\n";
print FILE "Pipefs-Directory = $self->{'in_hash'}->{'pipefsdir'}\n";
print FILE "Domain = $self->{'in_hash'}->{'domain'}\n";
print FILE "\n[Mapping]\n";
print FILE "Nobody_User = $self->{'in_hash'}->{'nobody_user'}\n";
print FILE "Nobody_Group = $self->{'in_hash'}->{'nobody_group'}\n";
close(FILE);
$self->unlock_file($self->{'config_hash'}->{'idmapd_conf'});

# Restart rpc.idmapd
local $temp = $self->transname();
local $rv = $self->system_logged("($self->{'config_hash'}->{'restart_command'}) </dev/null >$temp 2>&1");
local $out = `cat $temp`;
unlink($temp);
if ($rv) { $self->error("$out"); }

$self->redirect("");
1;
		
}


1;

