#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_rpc.cgi
# Display a form for editing a RPC service

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'editrpc_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'editrpc_title2'}, "");
	@{$self->{'rpc_array'}} = @{($self->list_rpcs())[$self->{'in_hash'}->{'rpos'}]};
	if ($self->{'in_hash'}->{'ipos'} =~ /\d/) {
		@{$self->{'inet_array'}} = @{($self->list_inets())[$self->{'in_hash'}->{'ipos'}]};
		}
	}

print "<form action=\"save_rpc.cgi\" method=post>\n";
if (@{$self->{'rpc_array'}}) {
	print "<input type=hidden name=rpos value=$self->{'in_hash'}->{'rpos'}>\n";
	print "<input type=hidden name=ipos value=$self->{'in_hash'}->{'ipos'}>\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'editrpc_detail'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_prgname'}</b></td>\n";
print "<td><input size=10 name=name value=\"$self->{'rpc_array'}->[1]\"></td>\n";

print "<td><b>$self->{'text_hash'}->{'editrpc_prgnum'}</b></td>\n";
print "<td><input size=7 name=number value=\"$self->{'rpc_array'}->[2]\"></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'editrpc_aliase'}</b></td> <td colspan=3>\n";
print "<input size=40 name=aliases value=\"$self->{'rpc_array'}->[3]\"></td> </tr>\n";

print "</table></td></tr></table><p>\n";

if ($self->{'config_hash'}->{'rpc_inetd'}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'editrpc_server'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td colspan=4>\n";
	printf "<input type=radio name=act value=0 %s> $self->{'text_hash'}->{'editrpc_noassigned'}\n",
		@{$self->{'inet_array'}} ? "" : "checked";
	printf "<input type=radio name=act value=1 %s> $self->{'text_hash'}->{'editrpc_disable'}\n",
		@{$self->{'inet_array'}} && !$self->{'inet_array'}->[1] ? "checked" : "";
	printf "<input type=radio name=act value=2 %s> $self->{'text_hash'}->{'editrpc_enable'}\n",
		$self->{'inet_array'}->[1] ? "checked" : "";
	print "</td> </tr>\n";

	print "<td><b>$self->{'text_hash'}->{'editrpc_version'}</b></td>\n";
	if ($self->{'inet_array'}->[3] =~ /^[^\/]+\/([0-9]+)\-([0-9]+)$/) {
		$self->{'vfrom'} = $1; $self->{'vto'} = $2;
		}
	elsif ($self->{'inet_array'}->[3] =~ /^[^\/]+\/([0-9]+)$/) {
		$self->{'vfrom'} = $1; $self->{'vto'} = $1;
		}
	else { $self->{'vfrom'} = $self->{'vto'} = ""; }
	print "<td><input size=1 name=vfrom value=\"$self->{'vfrom'}\"> -\n";
	print "<input size=1 name=vto value=\"$self->{'vto'}\"></td>\n";

	print "<td><b>$self->{'text_hash'}->{'editrpc_socket'}</b></td>\n";
	print "<td><select name=type>\n";
	printf "<option value=stream %s>Stream\n",
		$self->{'inet_array'}->[4] eq "stream" || !@{$self->{'inet_array'}} ? "selected" : "";
	printf "<option value=dgram %s>Datagram\n",
		$self->{'inet_array'}->[4] eq "dgram" ? "selected" : "";
	printf "<option value=tli %s>TLI\n",
		$self->{'inet_array'}->[4] eq "tli" ? "selected" : "";
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'editrpc_protocol'}</b></td>\n";
	$self->{'inet_array'}->[5] =~ /^[^\/]+\/(.*)$/;
	if ($1 eq "*") { @{$self->{'usedpr_array'}} = split(/\s+/, $self->{'config_hash'}->{'rpc_protocols'}); }
	else { @{$self->{'usedpr_array'}} = split(/,/, $1); }
	print "<td colspan=3>\n";
	foreach $upr (split(/\s+/, $self->{'config_hash'}->{rpc_protocols})) {
		printf "<input name=protocols type=checkbox value=\"$upr\" %s>".
		       " $upr\n", $self->indexof($upr,@{$self->{'usedpr_array'}})<0?"":"checked";
		}
	print "</td> </tr>\n";

	$self->{'qm'} = ($self->{'inet_array'}->[8] =~ s/^\?//);
	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_server'}</b></td>\n";
	if (!$self->{'config_hash'}->{'no_internal'}) {
		printf "<td colspan=3><input type=radio name=internal value=1 %s> $self->{'text_hash'}->{'editrpc_internal'}\n",
			$self->{'inet_array'}->[8] eq "internal" ? "checked" : "";
		printf "<input type=radio name=internal value=0 %s>\n",
			$self->{'inet_array'}->[8] ne "internal" || !@{$self->{'inet_array'}} ? "checked" : "";
		printf "<input name=program size=40 value=\"%s\">\n",
		$self->{'inet_array'}->[8] ne "internal" || !@{$self->{'inet_array'}} ? $self->{'inet_array'}->[8] : "";
	} else {
		printf "<td colspan=3>\n";
		printf "<input name=program size=40 value=\"%s\">\n",
			@{$self->{'inet_array'}} ? $self->{'inet_array'}->[8] : "";
		}
	print $self->file_chooser_button("program", 0);
	if ($self->{'config_hash'}->{'qm_mode'}) {
		print "<br>","&nbsp;" x 5;
		printf "<input type=checkbox name=qm value=1 %s> %s\n",
			$self->{'qm'} ? "checked" : "", $self->{'text_hash'}->{'editserv_qm'};
		}
	print "</td> </tr>\n";

	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_command'}</b></td> <td colspan=3>\n";
	if (!$self->{'config_hash'}->{'no_internal'}) {
		printf "<input name=args size=40 value=\"%s\"></td> </tr>\n",
			$self->{'inet_array'}->[8] eq "internal" ? "" : $self->{'inet_array'}->[9];
	} else {
		printf "<input name=args size=40 value=\"%s\"></td> </tr>\n",
			$self->{'inet_array'}->[9];
		}
	if ($self->{'inet_array'}->[6] =~ /^(\S+)\.(\d+)$/) { $self->{'waitmode'} = $1; $self->{'permin'} = $2; }
	else { $self->{'waitmode'} = $self->{'inet_array'}->[6]; $self->{'permin'} = -1; }
	if ($self->{'inet_array'}->[7] =~ /^(\S+)\.(\S+)$/) { $self->{'user'} = $1; $self->{'group'} = $2; }
	else { $self->{'user'} = $self->{'inet_array'}->[7]; undef($self->{'group'}); }

	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_waitmode'}</b></td>\n";
	printf "<td nowrap><input type=radio name=wait value=wait %s> $self->{'text_hash'}->{'editrpc_wait'}\n",
		$self->{'waitmode'} eq "wait" || !@{$self->{'inet_array'}} ? "checked" : "";
	printf "<input type=radio name=wait value=nowait %s> $self->{'text_hash'}->{'editrpc_nowait'}</td>\n",
		$self->{'waitmode'} eq "nowait" ? "checked" : "";

	print "<td nowrap><b>$self->{'text_hash'}->{'editrpc_execasuser'}</b></td>\n";
	print "<td nowrap><input name=user size=8 value=\"$self->{'user'}\"> ",
	      $self->user_chooser_button("user", 0),"</td> </tr>\n";

	if ($self->{'config_hash'}->{extended_inetd}) {
		print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_max'}</b></td> <td nowrap>\n";
		printf "<input type=radio name=permin_def value=1 %s> $self->{'text_hash'}->{'editrpc_default'}\n",
			$self->{'permin'}<0 ? "checked" : "";
		printf "&nbsp; <input type=radio name=permin_def value=0 %s>\n",
			$self->{'permin'}<0 ? "" : "checked";
		printf "<input name=permin size=5 value=\"%s\"></td>\n",
			$self->{'permin'}<0 ? "" : $self->{'permin'};

		print "<td nowrap><b>$self->{'text_hash'}->{'editrpc_execasgrp'}</b></td>\n";
		print "<td nowrap><select name=group>\n";
		printf "<option value=\"\" %s> $self->{'text_hash'}->{'editrpc_default'}",
			$self->{'group'} ? "" : "selected";
		setgrent();
		while(@{$self->{'ginfo_array'}} = getgrent()) {
			printf "<option value=\"$self->{'ginfo_array'}->[0]\" %s>$self->{'ginfo_array'}->[0]\n",
				$self->{'ginfo_array'}->[0] eq $self->{'group'} ? "selected" : "";
			}
		print "</select></td> </tr>\n";
		endgrent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
		}

	print "</table></td></tr></table><p>\n";
	}

if (@{$self->{'rpc_array'}}) {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=$self->{'text_hash'}->{'index_save'}></td>\n";
	print "</form><form action=\"delete_rpc.cgi\">\n";
	print "<input type=hidden name=rpos value=\"$self->{'in_hash'}->{'rpos'}\">\n";
	print "<input type=hidden name=ipos value=\"$self->{'in_hash'}->{'ipos'}\">\n";
	print "<td align=right><input type=submit value=$self->{'text_hash'}->{'index_delete'}></td> </tr>\n";
	print "</form></table><p>\n";
	}
else {
	print "<input type=submit value=$self->{'text_hash'}->{'index_create'}></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_list'});

1;
		
}


1;

