#!/usr/bin/perl
package init::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'init::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "init::InitLib");
$self = new init::InitLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the init module
sub acl_security_form
{
	my $self = shift;

if ($self->{'config_hash'}->{'local_script'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'acl_script'}</b></td> <td colspan=3>\n";
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'acl_actions'}</b></td> <td colspan=3>\n";
	}
printf "<input type=radio name=bootup value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'bootup'} == 1 ? "checked" : "";
if (!$self->{'config_hash'}->{'local_script'}) {
	printf "<input type=radio name=bootup value=2 %s> $self->{'text_hash'}->{'acl_runonly'}\n",
		$_[0]->{'bootup'} == 2 ? "checked" : "";
	}
printf "<input type=radio name=bootup value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'bootup'} == 0 ? "checked" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_reboot'}</b></td> <td>\n";
printf "<input type=radio name=reboot value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'reboot'} ? "checked" : "";
printf "<input type=radio name=reboot value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'reboot'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_shutdown'}</b></td> <td>\n";
printf "<input type=radio name=shutdown value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'shutdown'} ? "checked" : "";
printf "<input type=radio name=shutdown value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'shutdown'} ? "" : "checked";
}

# acl_security_save(&options)
# Parse the form for security options for the init module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'bootup'} = $self->{'in_hash'}->{'bootup'};
$_[0]->{'reboot'} = $self->{'in_hash'}->{'reboot'};
$_[0]->{'shutdown'} = $self->{'in_hash'}->{'shutdown'};
}


1;

