#!/usr/bin/perl
package init::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'init::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "init::InitLib");
$self = new init::InitLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;
if ($self->{'config_hash'}->{'init_base'}) {
	local $a;
	foreach $a ($self->list_actions()) {
		local @ac = split(/\s+/, $a);
		push(@rv, $ac[0] =~ /^\// ? $ac[0]
					  : "$self->{'config_hash'}->{'init_dir'}/$ac[0]");
		if ($self->{'config_hash'}->{'daemons_dir'} &&
		    -r "$self->{'config_hash'}->{'daemons_dir'}/$ac[0]") {
			push(@rv, "$self->{'config_hash'}->{'daemons_dir'}/$ac[0]");
			}
		}
	}
else {
	# Just bootup and shutdown scripts
	push(@rv, $self->{'config_hash'}->{'local_script'});
	push(@rv, $self->{'config_hash'}->{'local_down'}) if ($self->{'config_hash'}->{'local_down'});
	}
return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

}


1;

