#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Start or stop a bunch of RC scripts

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();
@{$self->{'sel_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'sel_array'}} || $self->error($self->{'text_hash'}->{'mass_enone'});

$self->{'start'} = 1 if ($self->{'in_hash'}->{'start'} || $self->{'in_hash'}->{'addboot_start'});
$self->{'stop'} = 1 if ($self->{'in_hash'}->{'stop'} || $self->{'in_hash'}->{'delboot_stop'});
$self->{'enable'} = 1 if ($self->{'in_hash'}->{'addboot'} || $self->{'in_hash'}->{'addboot_start'});
$self->{'disable'} = 1 if ($self->{'in_hash'}->{'delboot'} || $self->{'in_hash'}->{'delboot_stop'});

$self->ui_print_unbuffered_header(undef, $self->{'start'} || $self->{'enable'} ? $self->{'text_hash'}->{'mass_start'}
					  : $self->{'text_hash'}->{'mass_stop'}, "");

if ($self->{'start'} || $self->{'stop'}) {
	# Starting or stopping a bunch of services
	$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'ss_ecannot'});
	foreach $s (@{$self->{'sel_array'}}) {
		if ($self->{'start'}) {
			print $self->text('mass_starting', "<tt>$s</tt>"),"<p>\n";
			($self->{'ok'}, $self->{'out'}) = $self->start_rc_script($s);
			}
		else {
			print $self->text('mass_stopping', "<tt>$s</tt>"),"<p>\n";
			($self->{'ok'}, $self->{'out'}) = $self->stop_rc_script($s);
			}
		print "<pre>$self->{'out'}</pre>";
		if (!$self->{'ok'}) {
			print $self->{'text_hash'}->{'mass_failed'},"<p>\n";
			}
		else {
			print $self->{'text_hash'}->{'mass_ok'},"<p>\n";
			}
		}
	}

if ($self->{'enable'} || $self->{'disable'}) {
	# Enable or disable at boot
	$self->{'access_hash'}->{'bootup'} == 1 || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->lock_rc_files();
	foreach $b (@{$self->{'sel_array'}}) {
		if ($self->{'enable'}) {
			print $self->text('mass_enable', "<tt>$b</tt>"),"<p>\n";
			$self->enable_rc_script($b);
			}
		else {
			print $self->text('mass_disable', "<tt>$b</tt>"),"<p>\n";
			$self->disable_rc_script($b);
			}
		}
	$self->unlock_rc_files();
	$self->webmin_log($self->{'enable'} ? 'massenable' : 'massdisable', 'action',
		    join(" ", @{$self->{'sel_array'}}));
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

