#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of run-levels and the actions that are run at boot and
# shutdown time for each level

&ModuleLoader::preload_module('inittab_class', "inittab::InittabLib");
$self = new inittab::InittabLib:: 'inittab_class',%$self;

$self->ui_print_header(undef,  $self->{'text_hash'}->{'inittab_title'}, "", "index", 1, 1, 0,
	$self->help_search_link("inittab", "man"));

print $self->ui_form_start("delete.cgi", "post");
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href=new_inittab.cgi>$self->{'text_hash'}->{'inittab_new'}</a>" );
print $self->ui_links_row(\@{$self->{'links_array'}});
@{$self->{'tds_array'}} = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->hlink( $self->{'text_hash'}->{ 'inittab_id' }, "id" ),
			  $self->hlink( $self->{'text_hash'}->{ 'inittab_active' }, "active" ),
			  $self->hlink( $self->{'text_hash'}->{ 'inittab_runlevels' }, "runlevels" ),
			  $self->hlink( $self->{'text_hash'}->{ 'inittab_action' }, "action" ),
			  $self->hlink( $self->{'text_hash'}->{ 'inittab_process' }, "process" ) ],
			100, 0, \@{$self->{'tds_array'}});
foreach $i ($self->parse_inittab()) {
	local @cols;
	push(@cols, "<a href='edit_inittab.cgi?id=$i->{'id'}'>".
		    $self->html_escape($i->{'id'})."</a>");
	push(@cols, $i->{'comment'} ? "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>"
				    : $self->{'text_hash'}->{'yes'});
	local @rls = @{$i->{'levels'}};
	push(@cols, @rls ? $self->html_escape(join(", ", @rls))
			 : $self->{'text_hash'}->{'inittab_none'});
	push(@cols, $self->{'text_hash'}->{"inittab_".$i->{'action'}} ||
		    "<tt>".$self->html_escape($i->{'action'})."</tt>");
	push(@cols, $self->html_escape($i->{'process'}));
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $i->{'id'});
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'links_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);

print "<hr>\n";
print "<table width=100%><tr>\n";
print "<form action=apply.cgi>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'inittab_apply'}'></td>\n";
print "<td>$self->{'text_hash'}->{'inittab_applymsg'}</td>\n";
print "</form></tr></table><br>\n";

$self->ui_print_footer( "/", $self->{'text_hash'}->{'index'} );

1;
		
}


1;

