#!/usr/bin/perl
package ipfw::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'ipfw::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "ipfw::IpfwLib");
$self = new ipfw::IpfwLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
if ($type eq "rule") {
	return $self->text("log_${action}_rule".($long ? "_l" : ""),
		     $self->{'text_hash'}->{'action_'.$object},
		     $self->describe_rule($p, 1));
	}
elsif ($action eq "delsel") {
	return $self->text('log_delsel', $p->{'count'});
	}
else {
	return $self->{'text_hash'}->{"log_$action"};
	}
}


1;

