#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move.cgi
# Swap two rules

&ModuleLoader::preload_module('ipfw_class', "ipfw::IpfwLib");
$self = new ipfw::IpfwLib:: 'ipfw_class',%$self;

$self->ReadParse();
$self->{'rules'} = $self->get_config();

$self->{'rule1'} = $self->{'rules'}->[$self->{'in_hash'}->{'idx'}];
$self->{'rule2'} = $self->{'rules'}->[$self->{'in_hash'}->{'up'} ? $self->{'in_hash'}->{'idx'}-1 : $self->{'in_hash'}->{'idx'}+1];
($self->{'rules'}->[$self->{'rule1'}->{'index'}], $self->{'rules'}->[$self->{'rule2'}->{'index'}]) =
	($self->{'rules'}->[$self->{'rule2'}->{'index'}], $self->{'rules'}->[$self->{'rule1'}->{'index'}]);
($self->{'rule1'}->{'num'}, $self->{'rule2'}->{'num'}) =
	($self->{'rule2'}->{'num'}, $self->{'rule1'}->{'num'});
$self->lock_file($self->{'ipfw_file'});
$self->save_config($self->{'rules'});
$self->unlock_file($self->{'ipfw_file'});
$self->copy_to_cluster();
$self->webmin_log("move", "rule", $self->{'rule1'}->{'action'}, $self->{'rule1'});
$self->redirect("");

1;
		
}


1;

