#!/usr/bin/perl

&MAIN();

 sub MAIN {
# export.cgi
# Actually do the export of a connection

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->error_setup($self->{'text_hash'}->{'export_err'});
$self->ReadParse();

# Get the config lines
@{$self->{'conf_array'}} = $self->get_config();
$self->{'conn'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
$lref = $self->read_file_lines($self->{'conn'}->{'file'});
@{$self->{'lines_array'}} = map { "$_\n" } @$lref[$self->{'conn'}->{'line'} .. $self->{'conn'}->{'eline'}];

if ($self->{'in_hash'}->{'mode'} == 0) {
	# Just show on screen
	print "Content-type: text/plain\n\n";
	print @{$self->{'lines_array'}};
	}
else {
	# Save to file
	$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'export_efile'});
	$self->open_tempfile(EXPORT, ">$self->{'in_hash'}->{'file'}", 1) ||
		$self->error($self->text('export_esave', $!));
	$self->print_tempfile(EXPORT, @{$self->{'lines_array'}});
	$self->close_tempfile(EXPORT);

	# Tell the user
	$self->ui_print_header(undef, $self->{'text_hash'}->{'export_title'}, "");

	@{$self->{'st_array'}} = stat($self->{'in_hash'}->{'file'});
	print "<p>",$self->text('export_done', "<tt>$self->{'conn'}->{'value'}</tt>",
		    	  "<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'st_array'}->[7]),"<p>\n";

	$self->ui_print_footer("edit.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'edit_return'});
	}

1;
		
}


1;

