#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newkey.cgi
# Generate a new host key

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'newkey_err'});
$self->{'in_hash'}->{'host'} =~ /^[a-z0-9\.\-]+$/i || $self->error($self->{'text_hash'}->{'newkey_ehost'});
$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'ipsec'} newhostkey --output '$self->{'config_hash'}->{'secrets'}' --hostname '$self->{'in_hash'}->{'host'}' 2>&1");
$? && $self->error("<pre>$self->{'out'}</pre>");
$self->webmin_log("newkey");
$self->redirect("");

1;
		
}


1;

