#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_policy.cgi
# Update some policy file

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'policy_err'});

if ($self->{'in_hash'}->{'mode'} == 0) {
	@{$self->{'policies_array'}} = ( );
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	@{$self->{'policies_array'}} = ( "0.0.0.0/0" );
	}
else {
	for($i=0; defined($self->{'n'} = $self->{'in_hash'}->{"net_$i"}); $i++) {
		next if ($self->{'n'} eq '');
		$self->{'m'} = $self->{'in_hash'}->{"mask_$i"};
		$self->check_ipaddress($self->{'n'}) || $self->error($self->text('policy_enet', $i+1));
		$self->{'m'} =~ /^\d+/ && $self->{'m'} <= 32 || $self->error($self->text('policy_emask', $i+1));
		push(@{$self->{'policies_array'}}, "$self->{'n'}/$self->{'m'}");
		}
	}
$self->lock_file("$self->{'config_hash'}->{'policies_dir'}/$self->{'in_hash'}->{'policy'}");
$self->write_policy($self->{'in_hash'}->{'policy'}, \@{$self->{'policies_array'}});
$self->unlock_file("$self->{'config_hash'}->{'policies_dir'}/$self->{'in_hash'}->{'policy'}");
$self->webmin_log("policy", undef, $self->{'in_hash'}->{'policy'});
$self->redirect("");

1;
		
}


1;

