#!/usr/bin/perl

&MAIN();

 sub MAIN {
# showkey.cgi
# Show this host's public key in a format suitable for inclusion in the config
# file of another host

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'showkey_title'}, "");

print "$self->{'text_hash'}->{'showkey_desc1'}<p>\n";
print "<tt>",join("<br>", $self->wrap_lines($self->get_public_key(), 80)),"</tt><p>\n";

print "$self->{'text_hash'}->{'showkey_desc2'}<p>\n";
($self->{'flags'}, $self->{'proto'}, $self->{'alg'}, $self->{'key'}) = $self->get_public_key_dns();
print "<table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'showkey_flags'}</b></td> <td>$self->{'flags'}</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'showkey_proto'}</b></td> <td>$self->{'proto'}</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'showkey_alg'}</b></td> <td>$self->{'alg'}</td> </tr>\n";
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'showkey_key'}</b></td> <td><tt>",
	join("<br>", $self->wrap_lines($self->{'key'}, 80)),"</tt></td> </tr>\n";
print "</table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

