#!/usr/bin/perl

&MAIN();

 sub MAIN {
# up.cgi
# Attempt to open a connection that was not started automatically

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
$| = 1;
$self->{'theme_no_table'}++;
$self->ui_print_header(undef, $self->{'text_hash'}->{'up_title'}, "");

# Try to connect
$self->{'cmd'} = "$self->{'config_hash'}->{'ipsec'} auto --up '$self->{'in_hash'}->{'conn'}'";
print "<b>",$self->text('up_cmd', "<tt>$self->{'cmd'}</tt>"),"</b>\n";
print "<pre>";
$self->foreign_require("proc", "proc-lib.pl");
$main::proc_object->safe_process_exec_logged($self->{'cmd'}, 0, 0, STDOUT, undef, 1);
print "</pre>\n";

# Save connection in config
$self->lock_file("$self->{'module_config_directory'}/config");
$self->{'config_hash'}->{'conn'} = $self->{'in_hash'}->{'conn'};
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");
if (!$?) {
	$self->webmin_log("up", undef, $self->{'in_hash'}->{'conn'});
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

