#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_filter.cgi
# Display allowed user filter options

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'filter_title'}, "", "filter");

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});
$self->{'filter'} = $self->find("filter", $self->{'jsm'});

print "<form action=save_filter.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'filter_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'filter_max'}</b></td>\n";
printf "<td><input name=max size=6 value='%s'></td> </tr>\n",
	$self->find_value("max_size", $self->{'filter'});

$self->{'allow'} = $self->find("allow", $self->{'filter'});

$self->{'conds'} = $self->find("conditions", $self->{'allow'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'filter_conds'}</b></td> <td>\n";
foreach $c (@{$self->{'filter_conds_array'}}) {
	$self->{'cx'} = $self->find($c, $self->{'conds'});
	printf "<input type=checkbox name=%s value=1 %s> %s\n",
		"cond_$c", $self->{'cx'} ? "checked" : "", $c;
	}
print "</td> </tr>\n";

$self->{'acts'} = $self->find("actions", $self->{'allow'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'filter_acts'}</b></td> <td>\n";
foreach $c (@{$self->{'filter_acts_array'}}) {
	$self->{'cx'} = $self->find($c, $self->{'acts'});
	printf "<input type=checkbox name=%s value=1 %s> %s\n",
		"act_$c", $self->{'cx'} ? "checked" : "", $c;
	}
print "</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

