#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ips.cgi
# Edit which addresses are allowed or denied for connection to the server

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ips_title'}, "", "ips");

$self->{'conf'} = $self->get_jabber_config();
$self->{'io'} = $self->find("io", $self->{'conf'});
@{$self->{'allow_array'}} = $self->find("allow", $self->{'io'});
@{$self->{'deny_array'}} = $self->find("deny", $self->{'io'});

print "<form action=save_ips.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ips_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ips_allow'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'ips_deny'}</b></td> </tr>\n";

printf "<tr> <td><input type=radio name=allow_def value=1 %s> %s\n",
	@{$self->{'allow_array'}} ? "" : "checked", $self->{'text_hash'}->{'ips_all'};
printf "<input type=radio name=allow_def value=0 %s> %s<br>\n",
	@{$self->{'allow_array'}} ? "checked" : "", $self->{'text_hash'}->{'ips_sel'};
print "<textarea name=allow rows=8 cols=30>\n";
foreach $a (@{$self->{'allow_array'}}) {
	local $ip = $self->find_value("ip", $a), $self->{'nm'} = $self->find_value("mask", $a);
	if ($self->{'nm'}) { print "$ip/$self->{'nm'}\n"; }
	else { print "$ip\n"; }
	}
print "</textarea></td>\n";

printf "<td><input type=radio name=deny_def value=1 %s> %s\n",
	@{$self->{'deny_array'}} ? "" : "checked", $self->{'text_hash'}->{'ips_none'};
printf "<input type=radio name=deny_def value=0 %s> %s<br>\n",
	@{$self->{'deny_array'}} ? "checked" : "", $self->{'text_hash'}->{'ips_sel'};
print "<textarea name=deny rows=8 cols=30>\n";
foreach $a (@{$self->{'deny_array'}}) {
	local $ip = $self->find_value("ip", $a), $self->{'nm'} = $self->find_value("mask", $a);
	if ($self->{'nm'}) { print "$ip/$self->{'nm'}\n"; }
	else { print "$ip\n"; }
	}
print "</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

