#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_messages.cgi
# Display welcome and other messages

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'messages_title'}, "", "messages");

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});

print "<form action=save_messages.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'messages_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'welcome'} = $self->find("welcome", $self->{'jsm'});
print "<tr> <td><b>$self->{'text_hash'}->{'messages_wsubject'}</b></td>\n";
printf "<td colspan=3><input name=wsubject size=50 value='%s'></td> </tr>\n",
	$self->find_value("subject", $self->{'welcome'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'messages_wbody'}</b></td>\n";
print "<td colspan=3><textarea name=wbody rows=4 cols=50 wrap=auto>",
	$self->find_value("body", $self->{'welcome'}),"</textarea></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

$self->{'register'} = $self->find("register", $self->{'jsm'});
print "<tr> <td><b>$self->{'text_hash'}->{'messages_rinstr'}</b></td>\n";
printf "<td colspan=3><input name=rinstr size=50 value='%s'></td> </tr>\n",
	$self->find_value("instructions", $self->{'register'});
print "<tr> <td><b>$self->{'text_hash'}->{'messages_rnotify'}</b></td>\n";
printf "<td><input type=radio name=rnotify value=1 %s> %s\n",
	$self->{'register'}->[1]->[0]->{'notify'} eq 'yes' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=rnotify value=0 %s> %s</td>\n",
	$self->{'register'}->[1]->[0]->{'notify'} eq 'yes' ? '' : 'checked', $self->{'text_hash'}->{'no'};
print "<td><b>$self->{'text_hash'}->{'messages_rfields'}</b></td> <td>\n";
foreach $f (@{$self->{'register_fields_array'}}) {
	local $rf = $self->find($f, $self->{'register'});
	printf "<input type=checkbox name=%s value=1 %s> %s\n",
		"rfield_$f", $rf ? "checked" : "", $f;
	}
print "</td></tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

$self->{'vcard'} = $self->find("vcard", $self->{'jsm'});
@{$self->{'vc_array'}} = @{$self->{'vcard'}->[1]}; shift(@{$self->{'vc_array'}});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'messages_vcard'}</b></td>\n";
print "<td colspan=3><textarea name=vcard rows=4 cols=50 wrap=auto>",
	$self->xml_string($self->{'vcard'}->[0], $self->{'vcard'}->[1]),"</textarea></td> </tr>\n";

$self->{'vcard2jud'} = $self->find("vcard2jud", $self->{'jsm'});
print "<tr> <td><b>$self->{'text_hash'}->{'messages_vcard2jud'}</b></td>\n";
printf "<td><input type=radio name=vcard2jud value=1 %s> %s\n",
	$self->{'vcard2jud'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=vcard2jud value=0 %s> %s</td> </tr>\n",
	$self->{'vcard2jud'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

