#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_admin.cgi
# Save admin users and autoreply

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'admin_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'jsm'} = $self->find("jsm", $self->{'session'});
$self->{'admin'} = $self->find("admin", $self->{'jsm'});
if (!$self->{'admin'}) {
	$self->{'admin'} = [ "admin", [ { } ] ];
	}

# Validate and save inputs
foreach $r (split(/\s+/, $self->{'in_hash'}->{'read'})) {
	push(@{$self->{'read_array'}}, [ 'read', [ { }, 0, $r ] ] );
	}
$self->save_directive($self->{'admin'}, "read", \@{$self->{'read_array'}});
foreach $w (split(/\s+/, $self->{'in_hash'}->{'write'})) {
	push(@{$self->{'write_array'}}, [ 'write', [ { }, 0, $w ] ] );
	}
$self->save_directive($self->{'admin'}, "write", \@{$self->{'write_array'}});
if ($self->{'in_hash'}->{'reply_def'}) {
	$self->save_directive($self->{'admin'}, "reply");
	}
else {
	$self->{'reply'} = $self->find("reply", $self->{'admin'});
	if (!$self->{'reply'}) {
		$self->{'reply'} = [ "reply", [ { } ] ];
		$self->save_directive($self->{'admin'}, "reply", [ $self->{'reply'} ] );
		}
	$self->save_directive($self->{'reply'}, "subject",
			[ [ 'subject', [ { }, 0, $self->{'in_hash'}->{'rsubject'} ] ] ]);
	$self->save_directive($self->{'reply'}, "body",
			[ [ 'body', [ { }, 0, $self->{'in_hash'}->{'rbody'} ] ] ]);
	}
@{$self->{'am_array'}} = @{$self->{'admin'}->[1]};
if (@{$self->{'am_array'}} > 1) {
	$self->save_directive($self->{'jsm'}, "admin", [ $self->{'admin'} ]);
	}
else {
	$self->save_directive($self->{'jsm'}, "admin");
	}

$self->save_jabber_config($self->{'conf'});
$self->redirect("");

1;
		
}


1;

