#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_modules.cgi
# Save server modules and shared libraries

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'modules_err'});

$self->{'conf'} = $self->get_jabber_config();
$self->{'session'} = $self->find_by_tag("service", "id", "sessions", $self->{'conf'});
$self->{'load'} = $self->find("load", $self->{'session'});

$self->{'newload'} = [ "load", [ $self->{'load'}->[1]->[0] ] ];
for($n=0; defined($self->{'mod'} = $self->{'in_hash'}->{"mod_$n"}); $n++) {
	next if (!$self->{'mod'});
	$self->{'so'} = $self->{'in_hash'}->{"so_$n"};
	$self->{'mod'} =~ /^\S+$/ || $self->error($self->text('modules_emod', $self->{'mod'}));
	$self->{'sopath'} = $self->{'so'} =~ /^\// ? $self->{'so'} : "$self->{'config_hash'}->{'jabber_dir'}/$self->{'so'}";
	-r $self->{'sopath'} || $self->error($self->text('modules_eso', $self->{'so'}));
	$self->save_directive($self->{'newload'}, $self->{'mod'}, [ [ $self->{'mod'}, [ { }, 0, $self->{'so'} ] ] ] );
	}
$self->save_directive($self->{'session'}, [ $self->{'load'} ], [ $self->{'newload'} ] );

$self->save_jabber_config($self->{'conf'});
$self->redirect("");
1;
		
}


1;

