#!/usr/bin/perl

&MAIN();

 sub MAIN {
#index.cgi

#main part
&ModuleLoader::preload_module('jakarta_tomcat_class', "jakarta_tomcat::JakartatomcatLib");
$self = new jakarta_tomcat::JakartatomcatLib:: 'jakarta_tomcat_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

#print header
$self->{'version'} = $self->get_version_tomcat();
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef,$self->{'module_info_hash'}->{'usermin'} ? 0 : 1, 1,undef, undef, undef,"onLoad='window.scroll(0, 10000); document.forms[0].cmd.focus()'", $self->{'version'} ? $self->text('index_version',"$self->{'version'}") : 0);

if (!-d $self->{'config_hash'}->{'java_home'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'java_home'}</tt>", undef ]));
	}
if (!-d $self->{'config_hash'}->{'tomcat_home'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'tomcat_home'}</tt>", undef ]));
	}
if (!$self->has_command($self->{'config_hash'}->{'tomcat_cmd'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);
	$self->ui_print_endpage(
		$self->ui_config_link('index_ecmd',
		        [ "<tt>$self->{'config_hash'}->{'tomcat_cmd'}</tt>", undef ]));
	}

push(@{$self->{'needs_array'}}, "XML::Parser") if (!$self->{'got_xml_parser'});
if (@{$self->{'needs_array'}}) {
	$self->{'needs'} = $self->urlize(join(" ", @{$self->{'needs_array'}}));
	print $self->text(@{$self->{'needs_array'}} == 2 ? 'index_emodules' : 'index_emodule', @{$self->{'needs_array'}},
	    "/cpan/download.cgi?source=3&cpan=$self->{'needs'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),"<p>\n";
	print "$self->{'text_hash'}->{'index_expat'}<p>\n";
	print "<hr>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
	exit;
	}

#start or stop JakartaTomcat
$self->start_tomcat() if ($self->{'in_hash'}->{'start'} eq $self->{'text_hash'}->{'start_tomcat'});
$self->stop_tomcat() if ($self->{'in_hash'}->{'start'} eq $self->{'text_hash'}->{'stop_tomcat'});

# get version number
$self->{'version'} = $self->get_version_tomcat();

#delete host
if ($self->{'in_hash'}->{'del'})
{
 $self->del_virt($self->{'in_hash'}->{'del'});
 $self->restart_tomcat();
 $self->delete_cache($self->{'in_hash'}->{'del'});
}

#create new virtual host
if ($self->{'in_hash'}->{'name'})
{
 $self->add_new_host($self->{'in_hash'}->{'name'},$self->{'in_hash'}->{'alias'},$self->{'in_hash'}->{'dir'});
 $self->restart_tomcat();
}

#save new configuration for virtual host
if ($self->{'in_hash'}->{'newname'})
{
 $self->save_conf_virt($self->{'in_hash'}->{'oldname'},$self->{'in_hash'}->{'newname'},$self->{'in_hash'}->{'port'},$self->{'in_hash'}->{'alias'},$self->{'in_hash'}->{'base'});
 $self->restart_tomcat();
 $self->delete_cache($self->{'in_hash'}->{'oldname'});
}

#get index configuration
($self->{'port'},$self->{'hosts'},$self->{'paths'},$self->{'links'},$self->{'icons'})=$self->get_index_conf();

#print form to add new virtual
print "<TABLE width=100% border=1><TR bgcolor=#00308B class='thfontcolor'>\n";
print "<TD colspan=2><b>$self->{'text_hash'}->{'virt_addhost'}</b></TD></TR>\n";
print "<FORM action=index.cgi><TR bgcolor=#eefaff>\n";
print "<TD><B>$self->{'text_hash'}->{'host_name'}</B></TD>\n";
print "<TD><INPUT type=text size=20 name=name></TD>\n";
print "<TR bgcolor=#eefaff>\n";
print "<TD width=15%><B>$self->{'text_hash'}->{'host_base'}<B></TD>\n";
print "<TD><INPUT type=text size=20 name=dir>\n";
print $self->file_chooser_button("dir", 1, 0),"</TD>\n";
print "<TR bgcolor=#eefaff><TD colspan=4>&nbsp;</TR></TABLE>\n";

#print submit to create new virtual host
print "<INPUT type=submit value='$self->{'text_hash'}->{'dir_create'}'></FORM><BR><BR>\n";

if ($self->{'config_hash'}->{show_list}==1)
{
 #print hosts configuration title
 print "<TABLE width=100% border=1><TR bgcolor=#00308B class='thfontcolor'>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'host_name'}</b></TD>\n";
 print "<TD width=20%><b>$self->{'text_hash'}->{'host_port'}</b></TD>\n";
 print "<TD width=30%><b>$self->{'text_hash'}->{'host_base'}</b></TD>\n";
 print "<TD width=10%><b>$self->{'text_hash'}->{'host_url'}</b></TD></TR>\n";

 #print hosts configuration data
 foreach (@{$self->{'hosts'}})
 {
  print "<TR bgcolor=#eefaff>\n";
  $self->{'href'}=$self->urlize(@{$_}[1]->{'name'});
  print "<TD valign=top width=20%><a href='virt.cgi?name=$self->{'href'}'>@{$_}[1]->{'name'}</a></TD>\n";
  print "<TD valign=top width=20%>$self->{'port'}</TD>\n";
  print "<TD valign=top width=30%>@{$_}[1]->{'appBase'}</TD>\n";
  print "<TD valign=top width=10%><a href=http://@{$_}[1]->{'name'}:$self->{'port'}>$self->{'text_hash'}->{'index_view'}</TD>\n";
 }
 print "</TR><TR bgcolor=#eefaff><TD colspan=5>&nbsp;</TD></TR></TABLE>\n";
}

if ($self->{'config_hash'}->{show_list}==0)
{
 #print all virtual servers
 print "<TABLE width=100% border=1><TR bgcolor=#00308B class='thfontcolor'>\n";
 print "<TD><b>$self->{'text_hash'}->{'host_name'}</b></TD></TR>\n";

 #print links to all virtual servers
 $self->icons_table(\@{$self->{'links'}},\@{$self->{'paths'}},\@{$self->{'icons'}},3);
}

#print submit start or stop JakartaTomcat
print "<TABLE width=100% border=1>";
print "<TR bgcolor=#00308B class='thfontcolor'><TD colspan=2>&nbsp;</TD></TR>\n";
print "<TR bgcolor=#eefaff>\n";

#index proces status
$self->{'status'}=$self->status_tomcat();
if ($self->{'status'} eq 'Start')
{
 print "<FORM action=index.cgi>\n";
 print "<TD width=15%><INPUT style=width:120 type=submit name=start value='$self->{'text_hash'}->{'start_tomcat'}'>\n";
 print "<TD><b>$self->{'text_hash'}->{'index_startmsg'}</b></TD>\n";
}
elsif ($self->{'status'} eq 'Stop')
{
 print "<FORM action=index.cgi>\n";
 print "<TD width=15%><INPUT style=width:120 type=submit name=start value='$self->{'text_hash'}->{'stop_tomcat'}'>\n";
 print "<TD><b>$self->{'text_hash'}->{'index_stopmsg'}</b></TD>\n";
}
print "</TR></TABLE></FORM>\n";

#print back URL
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

