#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing the LDAP PAM options

&ModuleLoader::preload_module('ldap_client_class', "ldap_client::LdapclientLib");
$self = new ldap_client::LdapclientLib:: 'ldap_client_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'pam_title'}, "", "pam");

$self->{'conf'} = $self->get_config();
print $self->ui_form_start("save_pam.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'pam_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'pam_filter'},
	$self->ui_opt_textbox("filter", $self->find_svalue("pam_filter", $self->{'conf'}),
			30, $self->{'text_hash'}->{'pam_none'}));

print $self->ui_table_row($self->{'text_hash'}->{'pam_login'},
	$self->ui_opt_textbox("login", $self->find_svalue("pam_login_attribute", $self->{'conf'}),
			20, $self->{'text_hash'}->{'default'}." (<tt>uid</tt>)"));

print $self->ui_table_row($self->{'text_hash'}->{'pam_groupdn'},
	$self->ui_opt_textbox("groupdn", $self->find_svalue("pam_groupdn", $self->{'conf'}),
			30, $self->{'text_hash'}->{'pam_ignored'})." ".
	$self->base_chooser_button("groupdn", 1));

print $self->ui_table_row($self->{'text_hash'}->{'pam_member'},
	$self->ui_opt_textbox("member", $self->find_svalue("pam_member_attribute", $self->{'conf'}),
			30, $self->{'text_hash'}->{'default'}));

print $self->ui_table_row($self->{'text_hash'}->{'pam_password'},
	$self->ui_select("password", $self->find_svalue("pam_password", $self->{'conf'}),
		   [ [ "", $self->{'text_hash'}->{'default'} ],
		     [ "clear", $self->{'text_hash'}->{'pam_clear'} ],
		     [ "crypt", $self->{'text_hash'}->{'pam_crypt'} ],
		     [ "md5", $self->{'text_hash'}->{'pam_md5'} ],
		     [ "nds", $self->{'text_hash'}->{'pam_nds'} ],
		     [ "ad", $self->{'text_hash'}->{'pam_ad'} ],
		     [ "exop", $self->{'text_hash'}->{'pam_exop'} ] ],
		    1, 0, 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

