#!/usr/bin/perl
package licmanage::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'licmanage::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "licmanage::LicmanageLib");
$self = new licmanage::LicmanageLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

	local $save_config = 0;
	if (!$self->{'config_hash'}->{'checklic'}) {
		$save_config++;
		$self->{'config_hash'}->{'checklic'} = 'checklic';
	}
	local $namefile = $self->{'config_hash'}->{'checklic'};
# 	if ( -r "$module_root_directory/$namefile") {
# 		$self->{'config_hash'}->{'md5sum'} = &get_md5sum("$module_root_directory/$namefile");
# 		$save_config++;
# 	}
	
	local $hsxp_dir = "$self->{'config_directory'}/hsxp";
	local $hsxp_config = "$hsxp_dir/config";
	if (-f "$hsxp_config") {
		local %lic;
		$self->read_file($hsxp_config,\%lic);
		if ($self->copy_source_dest("$hsxp_dir/$lic{'lic_name'}", "$self->{'lic_directory'}/$lic{'lic_name'}")) {
			$self->{'config_hash'}->{'licfile'} = $lic{'lic_name'};
			$self->rename_logged($hsxp_config, "$hsxp_config~");
			$save_config++;
		}
	}
	
	# detect valid license when 'licfile' is not defined
	unless ($self->{'config_hash'}->{'licfile'}) {
		local $f;
		local $is_found = 0;
		opendir(DIR, $self->{'lic_directory'});
		while(!$is_found && ($f = readdir(DIR))) {
			local $lic = $self->get_licinfo("$self->{'lic_directory'}/$f");
			if ($lic->{'ret'} == 0) {
				$self->{'config_hash'}->{'licfile'} = $f;
				$save_config++;
				$is_found++;
			}
		}
	}

	$self->save_module_config() if $save_config;
}


1;

