#ifndef ctlicense_licensetag_h
#define ctlicense_licensetag_h

#include <vector>
#include <string>

namespace CTLicense {

  class License;       // Forward reference

  class LicenseTag {
  public:
    std::string name;
    std::string data;
    std::vector<LicenseTag*> tags;
    
    void dump(char *ind);

    void registerLicenses(std::vector<License *>&);
    
    ~LicenseTag();
    
  };
  
}


#endif /* #ndef ctclicense_licensetag_h */
 
