#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi

&ModuleLoader::preload_module('licmanage_class', "licmanage::LicmanageLib");
$self = new licmanage::LicmanageLib:: 'licmanage_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, '');

if (!$self->{'gconfig_hash'}->{'ztl_mode'}) {
	local ($gpg_r, $gpg_msg) = $self->gnupg_setup();
	$self->error_lic("$self->{'text_hash'}->{'index_epubkey'}: $gpg_msg", undef, 1) if $gpg_r;
}

$self->{'lic'} = $self->get_licinfo();
# $self->{'nolic'} = !$self->{'lic'} || $self->{'lic'}->{'ret'};
$self->{'nolic'} = !$self->{'lic'} || $self->{'lic'}->{'ret'} || !$self->check_date_string($self->{'lic'}->{'d_begin2'}) || !$self->check_date_string($self->{'lic'}->{'d_expire2'});

if ($self->{'debug'}) {
	print "RET: $self->{'lic'}->{'ret'}<br>";
	print "MSG: $self->{'lic'}->{'msg'}<br>";
	print "BEGIN: $self->{'lic'}->{'d_begin'}<br>";
	print "EXPIRE: $self->{'lic'}->{'d_expire'}<br>";
	print "SYSRET: $self->{'lic'}->{'sys_ret'}<br>";
	print "OUTPUT:<br><pre>$self->{'lic'}->{'output'}</pre><br>";
}

# license information
print $self->ui_table_start($self->{'text_hash'}->{'index_header'}, 'width=50% align=center', 2);
print $self->ui_table_row($self->{'text_hash'}->{'index_id'}, $self->{'lic'}->{'id'}, undef, ['', 'align=right']) if $self->{'lic'}->{'id'};
print $self->ui_table_row($self->{'text_hash'}->{'index_status'}, $self->{'lic'}->{'ret'} == 0 ? $self->{'text_hash'}->{'index_valid'} : $self->{'text_hash'}->{'index_invalid'}, undef, ['', 'align=right']);
if ($self->{'nolic'}) {
	if ($self->{'config_hash'}->{'license_key'}) {
		print $self->ui_table_row($self->{'text_hash'}->{'index_msg'},  "<font color=#FF0000>$self->{'config_hash'}->{'lic_error_desc'}</font>", undef, ['', 'align=right']);
		}
	elsif ($self->{'tconfig_hash'}->{'type_lic'} == 5 ) {
		print $self->ui_table_row($self->{'text_hash'}->{'index_msg'}, "License is blocked", undef, ['', 'align=right']);
		} 
	else {
		print $self->ui_table_row($self->{'text_hash'}->{'index_msg'}, $self->{'lic'}->{'msg'}, undef, ['', 'align=right']);
		}
}
else {
	local $descr = $self->{'config_hash'}->{'lic_error_desc'} ? "<font color=#FF0000>$self->{'config_hash'}->{'lic_error_desc'}</font>" : ($self->{'lic'}->{'type'} ? $self->{'text_hash'}->{'index_type_' . $self->{'lic'}->{'type'}} : $self->{'lic'}->{'descr'});
	print $self->ui_table_row($self->{'text_hash'}->{'index_descr'}, $descr, undef, ['', 'align=right']);
	unless ($self->{'config_hash'}->{'license_key'} || ($self->{'tconfig_hash'}->{'type_lic'} == 5)){
		print $self->ui_table_row($self->{'text_hash'}->{'index_begin'}, $self->{'lic'}->{'d_begin2'}, undef, ['', 'align=right']);
		print $self->ui_table_row($self->{'text_hash'}->{'index_expire'}, $self->{'lic'}->{'d_expire2'}, undef, ['', 'align=right']);
		}
}
print $self->ui_table_end();
print "<hr>\n";

# Get a new license KEY
if (!$self->{'gconfig_hash'}->{'ztl_mode'}) {
print $self->ui_table_start($self->{'text_hash'}->{'index_license_key_header'}, 'width=50% align=center', 2);
print $self->ui_form_start('get_license.cgi', 'post');#
print "<tr><td>$self->{'text_hash'}->{'index_license_key_text'} &nbsp; ".$self->ui_textbox('new_key', $self->{'config_hash'}->{'license_key'}, 30)."</td><td align=right>" . $self->ui_submit($self->{'text_hash'}->{'index_license_key_submit'}, 'set_key') . "</td></tr>\n";
print "<tr><td>$self->{'text_hash'}->{'index_license_sub_text'}</td></tr>";
print $self->ui_form_end();
print $self->ui_table_end();
print "<hr>\n";
}

# Get a new ZTL license
if ($self->{'tconfig_hash'}->{'type_lic'} != 5) {
if (! $self->{'no_comodo_mode'}) {
	print $self->ui_table_start($self->text('index_header2', $self->{'text_hash'}->{'programname'}), 'width=50% align=center', 2);
	print $self->ui_form_start('get_license.cgi', 'post');
	print "<tr><td>$self->{'text_hash'}->{'index_desc_get'}</td><td align=right>" . $self->ui_submit($self->{'text_hash'}->{'index_get'}) . "</td></tr>\n";
	# print $self->ui_table_row($self->{'text_hash'}->{'index_desc_get'}, $self->ui_submit($self->{'text_hash'}->{'index_get'}), undef, ['', 'align=right']);
	print $self->ui_form_end();
	print $self->ui_table_end();
	print "<hr>\n";
}
}

# if ($self->{'nolic'} || (!$self->{'nolic'} && $self->{'lic'}->{'type'} == 1)) {
if ($self->{'tconfig_hash'}->{'type_lic'} != 5) {
	print $self->ui_table_start($self->{'text_hash'}->{'index_header_upload'}, 'width=50% align=center', 2);
	print $self->ui_form_start('upload.cgi', 'form-data');
	print $self->ui_table_row(undef, $self->{'text_hash'}->{'index_desc_upload'}, 2, ['']);
	print $self->ui_table_row($self->{'text_hash'}->{'index_upload'}, $self->ui_upload('file', 30) . "&nbsp;" . $self->ui_submit($self->{'text_hash'}->{'index_install'}, 'upload'), undef, ['', 'align=right']);
	print $self->ui_form_end();
	print $self->ui_table_end();
	print "<hr>\n";
	}
# }

if (!$self->{'gconfig_hash'}->{'ztl_mode'} && $self->{'tconfig_hash'}->{'type_lic'} != 5) {
	if ($self->{'nolic'}) {
		print $self->ui_table_start($self->{'text_hash'}->{'index_header_trial'}, 'width=50% align=center', 2);
		print $self->ui_form_start('get_trial.cgi', 'post');
		print $self->ui_table_row(undef, $self->{'text_hash'}->{'index_desc_trial'}, 2, ['']);
		print $self->ui_table_row($self->{'text_hash'}->{'index_username'}, $self->ui_textbox('nm', $self->{'in_hash'}->{'nm'}, 30), undef, ['', 'align=right']);
		print $self->ui_table_row($self->{'text_hash'}->{'index_company'}, $self->ui_textbox('cm', $self->{'in_hash'}->{'cm'}, 30), undef, ['', 'align=right']);
		print $self->ui_table_row($self->{'text_hash'}->{'index_email'}, $self->ui_textbox('em', $self->{'in_hash'}->{'em'}, 30), undef, ['', 'align=right']);
		print $self->ui_table_row('&nbsp;', $self->ui_submit($self->{'text_hash'}->{'index_get'}, 'trial'), undef, ['', 'align=right']);
		print $self->ui_form_end();
		print $self->ui_table_end();
		print "<hr>\n";
	}
}

if ($self->{'nolic'}) {
	$self->ui_print_footer();
}
else {
	$self->ui_print_footer("/index.cgi", $self->{'text_hash'}->{'index_mainpage'});
}
1;
		
}


1;

