#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_image.cgi
# Edit or create a boot partition

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'image_title1'}, "");
	$self->{'members'} = [ ];
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'image_title2'}, "");
	$self->{'conf'} = $self->get_lilo_conf();
	$self->{'image'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'members'} = $self->{'image'}->{'members'};
	}

print "<form action=save_image.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'image_options'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'image_name'}</b></td>\n";
printf "<td><input name=label size=15 value='%s'></td>\n",
	$self->find_value("label", $self->{'members'});

print "<td><b>$self->{'text_hash'}->{'image_kernel'}</b></td>\n";
printf "<td><input name=image size=25 value='%s'> %s</td> </tr>\n",
	$self->{'image'}->{'value'}, $self->file_chooser_button("image", 0);

print "<tr> <td><b>$self->{'text_hash'}->{'image_opts'}</b></td> <td colspan=3>\n";
$self->{'append'} = $self->find_value("append", $self->{'members'});
$self->{'literal'} = $self->find_value("literal", $self->{'members'});
$self->{'append'} =~ s/^"(.*)"$/$1/g;
$self->{'literal'} =~ s/^"(.*)"$/$1/g;
printf "<input type=radio name=opts value=0 %s> $self->{'text_hash'}->{'image_default'}\n",
	$self->{'append'} || $self->{'literal'} ? "" : "checked";
printf "<input type=radio name=opts value=1 %s> $self->{'text_hash'}->{'image_add'}\n",
	$self->{'append'} ? "checked" : "";
printf "<input type=radio name=opts value=2 %s> $self->{'text_hash'}->{'image_replace'}\n",
	$self->{'literal'} ? "checked" : "";
printf "&nbsp; <input name=append size=20 value='%s'></td> </tr>\n",
	$self->{'append'} ? $self->{'append'} : $self->{'literal'};

print "<tr> <td><b>$self->{'text_hash'}->{'image_root'}</b></td> <td colspan=3>\n";
$self->{'root'} = $self->find_value("root", $self->{'members'});
printf "<input type=radio name=rmode value=0 %s> $self->{'text_hash'}->{'image_fromkern'}\n",
	$self->{'root'} ? "" : "checked";
printf "<input type=radio name=rmode value=1 %s> $self->{'text_hash'}->{'image_rcurr'}\n",
	$self->{'root'} eq "current" ? "checked" : "";
printf "<input type=radio name=rmode value=2 %s> $self->{'text_hash'}->{'image_rdev'}\n",
	$self->{'root'} && $self->{'root'} ne "current" ? "checked" : "";
print $self->foreign_call("fdisk", "partition_select",
		    "root", $self->{'root'} eq "current" ? undef : $self->{'root'}, 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'image_initrd'}</b></td> <td colspan=3>\n";
$self->{'initrd'} = $self->find_value("initrd", $self->{'members'});
printf "<input type=radio name=initrd_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->{'initrd'} ? '' : 'checked';
printf "<input type=radio name=initrd_def value=0 %s>\n",
	$self->{'initrd'} ? 'checked' : '';
printf "<input name=initrd size=30 value='%s'> %s</td> </tr>\n",
	$self->{'initrd'}, $self->file_chooser_button("initrd");

$self->{'readonly'} = $self->find("read-only", $self->{'members'});
$self->{'readwrite'} = $self->find("read-write", $self->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'image_mode'}</b></td> <td><select name=ro>\n";
printf "<option value=0 %s>$self->{'text_hash'}->{'image_fromkern'}\n",
	$self->{'readonly'} || $self->{'readwrite'} ? "" : "selected";
printf "<option value=1 %s>$self->{'text_hash'}->{'image_ro'}\n",
	$self->{'readonly'} ? "selected" : "";
printf "<option value=2 %s>$self->{'text_hash'}->{'image_rw'}\n",
	$self->{'readwrite'} ? "selected" : "";
print "</select></td>\n";

$self->{'vga'} = lc($self->find_value("vga", $self->{'members'}));
print "<td><b>$self->{'text_hash'}->{'image_vga'}</b></td>\n";
print "<td><select name=vga>\n";
printf "<option value='' %s>$self->{'text_hash'}->{'image_fromkern'}\n",
	$self->{'vga'} ? "" : "selected";
printf "<option value=normal %s>80x25\n",
	$self->{'vga'} eq "normal" ? "selected" : "";
printf "<option value=ext %s>80x50\n",
	$self->{'vga'} eq "ext" || $self->{'vga'} eq "extended" ? "selected" : "";
printf "<option value=ask %s>$self->{'text_hash'}->{'image_ask'}\n",
	$self->{'vga'} eq "ask" ? "selected" : "";
printf "<option value=other %s>$self->{'text_hash'}->{'image_other'}\n",
	$self->{'vga'} =~ /\d/ ? "selected" : "";
printf "</select><input name=vgaother size=6 value='%s'></td> </tr>\n",
	$self->{'vga'} =~ /\d/ ? $self->{'vga'} : "";

$self->{'lock'} = $self->find("lock", $self->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'image_lock'}</b></td> <td>\n";
printf "<input type=radio name=lock value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'lock'} ? "checked" : "";
printf "<input type=radio name=lock value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'lock'} ? "" : "checked";

$self->{'optional'} = $self->find("optional", $self->{'members'});
print "<td><b>$self->{'text_hash'}->{'image_optional'}</b></td> <td>\n";
printf "<input type=radio name=optional value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'optional'} ? "checked" : "";
printf "<input type=radio name=optional value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'optional'} ? "" : "checked";

$self->{'password'} = $self->find_value("password", $self->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'image_password'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=passmode value=0 %s> $self->{'text_hash'}->{'image_none'}\n",
	$self->{'password'} ? "" : "checked";
printf "<input type=radio name=passmode value=1 %s>\n",
	$self->{'password'} ? "checked" : "";
print "<input name=password size=25 value=\"$self->{'password'}\"></td> </tr>\n";

$self->{'restricted'} = $self->find("restricted", $self->{'members'});
printf "<tr> <td><b>$self->{'text_hash'}->{'image_restricted'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=restricted value=1 %s> %s\n",
	$self->{'restricted'} ? "checked" : "", $self->{'text_hash'}->{'image_extra'};
printf "<input type=radio name=restricted value=0 %s> %s</td> </tr>\n",
	$self->{'restricted'} ? "" : "checked", $self->{'text_hash'}->{'image_any'};

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td align=left><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<td align=right>",
	      "<input type=submit name=delete value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

