#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save global options

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'lilo_conf'});
$self->{'conf'} = $self->get_lilo_conf();
$self->error_setup($self->{'text_hash'}->{'global_err'});

$self->save_directive($self->{'conf'}, "boot",
		$self->{'in_hash'}->{'bootmode'} ? { 'name' => 'boot', 'value' => $self->{'in_hash'}->{'boot'} }
				: undef);
$self->save_directive($self->{'conf'}, "default",
		$self->{'in_hash'}->{'defaultmode'} ? { 'name' => 'default',
				       'value' => $self->{'in_hash'}->{'default'} } : undef);
$self->save_directive($self->{'conf'}, "prompt",
		$self->{'in_hash'}->{'prompt'} ? { 'name' => 'prompt' } : undef);
$self->save_directive($self->{'conf'}, "timeout",
		$self->{'in_hash'}->{'timeout_def'} ? undef :
		{ 'name' => 'timeout', 'value' => $self->{'in_hash'}->{'timeout'}*10 });
$self->save_directive($self->{'conf'}, "lock",
		$self->{'in_hash'}->{'lock'} ? { 'name' => 'lock' } : undef);
$self->save_directive($self->{'conf'}, "delay",
		$self->{'in_hash'}->{'delay_def'} ? undef :
		{ 'name' => 'delay', 'value' => $self->{'in_hash'}->{'delay'}*10 });
$self->save_directive($self->{'conf'}, "compact",
		$self->{'in_hash'}->{'compact'} ? { 'name' => 'compact' } : undef);
$self->save_directive($self->{'conf'}, "optional",
		$self->{'in_hash'}->{'optional'} ? { 'name' => 'optional' } : undef);
$self->save_directive($self->{'conf'}, "password",
		$self->{'in_hash'}->{'passmode'} ? { 'name' => 'password',
				    'value' => $self->{'in_hash'}->{'password'} } : undef);
$self->save_directive($self->{'conf'}, "restricted",
		$self->{'in_hash'}->{'restricted'} ? { 'name' => 'restricted' } : undef);
if ($self->{'lilo_version'} >= 21.3) {
	$self->save_directive($self->{'conf'}, "lba32",
			$self->{'in_hash'}->{'lba'} ? { 'name' => 'lba32' } : undef);
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'lilo_conf'});
$self->webmin_log("global", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

