#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_other.cgi

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'lilo_conf'});
$self->{'conf'} = $self->get_lilo_conf();
if ($self->{'in_hash'}->{'delete'}) {
	# deleting an existing partition
	$self->{'other'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->save_directive($self->{'conf'}, $self->{'other'});
	$self->flush_file_lines();
	$self->unlock_file($self->{'config_hash'}->{'lilo_conf'});
	$self->webmin_log("delete", "other",
		    $self->find_value("label", $self->{'other'}->{'members'}), \%{$self->{'in_hash'}});
	$self->redirect("");
	exit;
	}
elsif ($self->{'in_hash'}->{'new'}) {
	# creating a new boot partition
	$self->{'other'} = { 'name' => 'other',
		   'members' => [ ] };
	}
else {
	# updating an existing image
	$self->{'oldother'} = $self->{'other'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	}

# Validate and store inputs
$self->{'in_hash'}->{'label'} =~ /\S+/ || $self->error($self->{'text_hash'}->{'other_ename'});
$self->save_subdirective($self->{'other'}, "label", $self->{'in_hash'}->{'label'});
$self->{'other'}->{'value'} = $self->{'in_hash'}->{'other'};
if ($self->{'in_hash'}->{'tablemode'} == 0) {
	$self->save_subdirective($self->{'other'}, "table");
	}
else {
	$self->save_subdirective($self->{'other'}, "table", $self->{'in_hash'}->{'table'});
	}
if ($self->{'in_hash'}->{'passmode'} == 0) {
	$self->save_subdirective($self->{'other'}, "password");
	}
else {
	$self->save_subdirective($self->{'other'}, "password", $self->{'in_hash'}->{'password'});
	}

# Save the actual partition structure
$self->save_directive($self->{'conf'}, $self->{'oldother'}, $self->{'other'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'lilo_conf'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify', "other",
	    $self->find_value("label", $self->{'other'}->{'members'}), \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

