#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_sched.cgi
# Find the logrotate cron job, or offer to create one

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'sched_title'}, "");

print "<p>",$self->text('sched_desc', "<tt>$self->{'config_hash'}->{'logrotate'}</tt>"),"<p>\n";

# Find the job, looking in daily directories too
$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
JOB: foreach $j (@{$self->{'jobs_array'}}) {
	if ($j->{'command'} =~ /logrotate/i) {
		$self->{'job'} = $j;
		last JOB;
		}
	local $rpd = $main::cron_object->is_run_parts($j->{'command'});
	if ($rpd) {
		local @exp = $main::cron_object->expand_run_parts($rpd);
		foreach $e (@exp) {
			if ($e =~ /logrotate/i && -r $e) {
				$self->{'job'} = $j;
				$self->{'runparts'} = $e;
				last JOB;
				}
			}
		}
	}

if ($self->{'runparts'}) {
	# Run from run-parts command, cannot touch
	print $self->text('sched_runparts', "<tt>$self->{'runparts'}</tt>",
		    $main::cron_object->when_text($self->{'job'})),"<p>\n";
	}
else {
	# Offer to enable/change/delete
	print "<form action=save_sched.cgi>\n";
	print "<input type=hidden name=idx value='",
		$self->{'job'} ? $self->{'job'}->{'index'} : "","'>\n";
	print "<b>$self->{'text_hash'}->{'sched_sched'}</b>\n";
	printf "<input type=radio name=sched value=0 %s> %s\n",
		$self->{'job'} ? "" : "checked", $self->{'text_hash'}->{'sched_disabled'};
	printf "<input type=radio name=sched value=1 %s> %s<br>\n",
		$self->{'job'} ? "checked" : "", $self->{'text_hash'}->{'sched_enabled'};

	$self->{'job'} ||= { 'special' => 'daily' };
	print "<table border>\n";
	$main::cron_object->show_times_input($self->{'job'});
	print "</table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'sched_save'}'></form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

