#!/usr/bin/perl
package lvm::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lvm::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "lvm::LvmLib");
$self = new lvm::LvmLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($action eq 'mkfs') {
	return $self->text('log_mkfs_lv', "<tt>".$self->html_escape($p->{'fs'})."</tt>",
		     "<tt>".$self->html_escape($object)."</tt>");
	}
else {
	return $self->text("log_${action}_${type}",
		     "<tt>".$self->html_escape($object)."</tt>",
		     "<tt>".$self->html_escape($p->{'vg'})."</tt>");
	}
}


1;

