#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_vg.cgi
# Display a form for editing or creating a volume group

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->ReadParse();

if ($self->{'in_hash'}->{'vg'}) {
	($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups();
	$self->ui_print_header(undef, $self->{'text_hash'}->{'vg_edit'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'vg_create'}, "");
	}

print "<form action=save_vg.cgi>\n";
print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'vg_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'vg_name'}</b></td>\n";
print "<td><input name=name size=20 value='$self->{'vg'}->{'name'}'></td>\n";

if ($self->{'in_hash'}->{'vg'}) {
	print "<td><b>$self->{'text_hash'}->{'vg_size'}</b></td>\n";
	print "<td>",$self->nice_size($self->{'vg'}->{'size'}*1024),"</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'vg_petotal'}</b></td>\n";
	print "<td>",$self->text('lv_petotals', $self->{'vg'}->{'pe_alloc'}, $self->{'vg'}->{'pe_total'}),
	      "</td>\n";

	print "<td><b>$self->{'text_hash'}->{'vg_pesize'}</b></td>\n";
	print "<td>$self->{'vg'}->{'pe_size'} kB</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'vg_petotal2'}</b></td>\n";
	print "<td>",$self->text('lv_petotals', $self->nice_size($self->{'vg'}->{'pe_alloc'}*$self->{'vg'}->{'pe_size'}*1024), $self->nice_size($self->{'vg'}->{'pe_total'}*$self->{'vg'}->{'pe_size'}*1024)),"</td>\n";

	print "</tr>\n";
	}
else {
	print "<td><b>$self->{'text_hash'}->{'vg_pesize'}</b></td>\n";
	print "<td><input type=radio name=pesize_def value=1 checked> ",
		$self->{'text_hash'}->{'default'},"\n";
	print "<input type=radio name=pesize_def value=0>\n";
	print "<input name=pesize size=8> kB</td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'vg_device'}</b></td> <td colspan=3>\n";
	$self->device_input();
	print "</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'vg'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      " value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

