#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_pv.cgi
# Create, modify or delete a physical volume

&ModuleLoader::preload_module('lvm_class', "lvm::LvmLib");
$self = new lvm::LvmLib:: 'lvm_class',%$self;

$self->ReadParse();

($self->{'vg'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'vg'} } $self->list_volume_groups();
($self->{'pv'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'pv'} } $self->list_physical_volumes($self->{'in_hash'}->{'vg'})
	if ($self->{'in_hash'}->{'pv'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Delete the logical volume
	$self->error_setup($self->{'text_hash'}->{'pv_err2'});
	$self->{'err'} = $self->delete_physical_volume($self->{'pv'});
	$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
	$self->webmin_log("delete", "pv", $self->{'in_hash'}->{'pv'}, $self->{'pv'});
	$self->redirect("");
	}
elsif ($self->{'in_hash'}->{'delete'}) {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'pv_delete'}, "");
	print "<center><form action=save_pv.cgi>\n";
	print "<input type=hidden name=vg value='$self->{'in_hash'}->{'vg'}'>\n";
	print "<input type=hidden name=pv value='$self->{'in_hash'}->{'pv'}'>\n";
	print "<b>",$self->text('pv_rusure',
			  "<tt>$self->{'pv'}->{'device'}</tt>"),"</b><p>\n";
	print "<input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'pv_deleteok'}'>\n";
	print "</center></form>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'pv_err'});
	if (!$self->{'in_hash'}->{'pv'}) {
		# Add the physical volume
		$self->{'pv'} = { 'vg' => $self->{'in_hash'}->{'vg'},
			'alloc' => 'y' };
		if ($self->{'in_hash'}->{'device'}) {
			$self->{'pv'}->{'device'} = $self->{'in_hash'}->{'device'};
			}
		else {
			-r $self->{'in_hash'}->{'other'} || $self->error($self->{'text_hash'}->{'pv_eother'});
			$self->{'pv'}->{'device'} = $self->{'in_hash'}->{'other'};
			}
		$self->{'err'} = $self->create_physical_volume($self->{'pv'});
		$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
		}

	# Change the volume
	if ($self->{'pv'}->{'alloc'} ne $self->{'in_hash'}->{'alloc'}) {
		$self->{'pv'}->{'alloc'} = $self->{'in_hash'}->{'alloc'};
		$self->{'err'} = $self->change_physical_volume($self->{'pv'});
		$self->error("<pre>$self->{'err'}</pre>") if ($self->{'err'});
		}

	$self->webmin_log($self->{'in_hash'}->{'pv'} ? "modify" : "create", "pv", $self->{'pv'}->{'device'},$self->{'pv'});
	$self->redirect("");
	}

1;
		
}


1;

