#!/usr/bin/perl
package mailboxes::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mailboxes::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

# Always detect the mail system if not set
	if ($self->{'config_hash'}->{'mail_system'} == 3) {
		$self->{'config_hash'}->{'mail_system'} = $self->detect_mail_system();
		$self->save_module_config() if ($self->{'config_hash'}->{'mail_system'} != 3);
	}
}


1;

