#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete all mail in some mailbox, after asking for confirmation

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
$self->is_user($self->{'in_hash'}->{'user'}) || -e $self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'mail_efile'});
@{$self->{'folders_array'}} = $self->list_user_folders_sorted($self->{'in_hash'}->{'user'});
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};

if ($self->{'in_hash'}->{'confirm'}) {
	# Do it!
	$self->{'sz'} = $self->mailbox_folder_size($self->{'folder'});
	$self->mailbox_empty_folder($self->{'folder'});
	$self->webmin_log("delmail", undef, undef, { 'from' => $self->{'folder'}->{'file'},
					       'count' => $self->{'sz'} });
	$self->redirect("list_mail.cgi?user=$self->{'in_hash'}->{'user'}&folder=$self->{'in_hash'}->{'folder'}");
	}
else {
	# Ask first
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delall_title'}, "");
	print $self->ui_form_start("delete_all.cgi");
	print $self->ui_hidden("user", $self->{'in_hash'}->{'user'}),"\n";
	print $self->ui_hidden("folder", $self->{'in_hash'}->{'folder'}),"\n";
	print "<center>\n";
	print $self->text('delall_rusure',
		    "<tt>$self->{'folder'}->{'file'}</tt>",
		    $self->mailbox_folder_size($self->{'folder'}), 
		    $self->nice_size($self->folder_size($self->{'folder'}))),"<p>\n";
	print $self->ui_submit($self->{'text_hash'}->{'delall_ok'}, "confirm"),"\n";
	print $self->ui_form_end();
	print "</center>\n";
	$self->ui_print_footer("list_mail.cgi?user=$self->{'in_hash'}->{'user'}&folder=$self->{'in_hash'}->{'folder'}",
			 $self->{'text_hash'}->{'mail_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

