#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search_form.cgi
# Display a form for searching a mailbox

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});

@{$self->{'folders_array'}} = $self->list_user_folders_sorted($self->{'in_hash'}->{'user'});
($self->{'folder'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'folder'} } @{$self->{'folders_array'}};
$self->ui_print_header(undef, $self->{'text_hash'}->{'sform_title'}, "", undef, 0, 0, undef,
	$self->folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}));

print "<form action=mail_search.cgi>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
print "<input type=hidden name=ofolder value='$self->{'in_hash'}->{'folder'}'>\n";
print "<input type=radio name=and value=1 checked> $self->{'text_hash'}->{'sform_and'}\n";
print "<input type=radio name=and value=0> $self->{'text_hash'}->{'sform_or'}<p>\n";

print "<table>\n";
#print "<tr> <td><b>$self->{'text_hash'}->{'sform_field'}</b></td> ",
#      "<td><b>$self->{'text_hash'}->{'sform_mode'}</b></td> ",
#      "<td><b>$self->{'text_hash'}->{'sform_for'}</b></td> </tr>\n";
for($i=0; $i<=9; $i++) {
	print "<tr>\n";
	print "<td>$self->{'text_hash'}->{'sform_where'}</td>\n";
	print "<td><select name=field_$i>\n";
	print "<option value=''>&nbsp;\n";
	foreach $f ('from', 'subject', 'to', 'cc', 'date', 'body', 'headers', 'size') {
		print "<option value=$f>",$self->{'text_hash'}->{"sform_$f"},"\n";
		}
	print "</select></td>\n";

	print "<td><select name=neg_$i>\n";
	print "<option value=0 checked>$self->{'text_hash'}->{'sform_neg0'}\n";
	print "<option value=1>$self->{'text_hash'}->{'sform_neg1'}\n";
	print "</select></td>\n";

	print "<td>$self->{'text_hash'}->{'sform_text'}</td>\n";
	print "<td><input name=what_$i size=30></td>\n";
	print "</tr>\n";
	}
print "</table><br>\n";

$self->{'extra'} = "<option value=-1>$self->{'text_hash'}->{'sform_all'}\n";
print "<input type=submit value='$self->{'text_hash'}->{'sform_ok'}'>\n";
print " $self->{'text_hash'}->{'sform_folder'} ",$self->folder_select(\@{$self->{'folders_array'}}, $self->{'folder'}, "folder",
					       $self->{'extra'});
print "</form>\n";

$self->ui_print_footer("list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=".
		  $self->urlize($self->{'in_hash'}->{'user'}), $self->{'text_hash'}->{'mail_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

