#!/usr/bin/perl

&MAIN();

 sub MAIN {
# add_member.cgi
# add new member into mail list

# require funcs library
&ModuleLoader::preload_module('mailman_class', "mailman::MailmanLib");
$self = new mailman::MailmanLib:: 'mailman_class',%$self;

$self->ReadParse();

# access control
%{$self->{'access_hash'}} = $self->get_module_acl();
if ($self->{'access_hash'}->{'virts'})
{
 local $ok = $self->check_dom_acl($self->{'in_hash'}->{'dom'});
 $self->error($self->text('virt_manage_ecannot', $self->{'in_hash'}->{'dom'})) unless $ok;
}

# validate inputs
$self->{'in_hash'}->{'email'} =~ /^\S+@\S+$/ || $self->error($self->{'text_hash'}->{'addmem_eemail'});

local $fullname = $self->{'in_hash'}->{'dom'} ? $self->{'in_hash'}->{'name'}.".$self->{'in_hash'}->{'dom'}" : $self->{'in_hash'}->{'name'};
local $user = { 'email' => $self->{'in_hash'}->{'email'},
				 'digest'=> $self->{'in_hash'}->{'digest'},
				 'welcome' => $self->{'in_hash'}->{'welcome'},
				 'admin' => $self->{'in_hash'}->{'admin'}
			  };

# add member
$self->error_setup($self->{'text_hash'}->{'add_mem_err'});
local $err = $self->add_member($user, $fullname);
$self->error($err) if $err;

# redirect to members list
$self->redirect("maillist.cgi?members=$self->{'in_hash'}->{'name'}&dom=$self->{'in_hash'}->{'dom'}");
1;
		
}


1;

