#!/usr/bin/perl
package majordomo::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'majordomo::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the majordomo module
sub acl_security_form
{
	my $self = shift;

local $conf = $self->get_config();
local @lists = $self->list_lists($conf);
print "<tr> <td valign=top rowspan=3><b>$self->{'text_hash'}->{'acl_lists'}</b></td>\n";
print "<td rowspan=3 valign=top>\n";
printf "<input type=radio name=lists_def value=1 %s> %s\n",
	$_[0]->{'lists'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_lall'};
printf "<input type=radio name=lists_def value=0 %s> %s<br>\n",
	$_[0]->{'lists'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_lsel'};
print "<select name=lists multiple size=3 width=150>\n";
local (%lcan, $l);
map { $lcan{$_}++ } split(/\s+/, $_[0]->{'lists'});
foreach $l (@lists) {
	printf "<option %s>%s\n",
		$lcan{$l} ? "selected" : "", $l;
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_global'}</b></td> <td>\n";
printf "<input type=radio name=global value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'global'} ? "checked" : "";
printf "<input type=radio name=global value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'global'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td> <td>\n";
printf "<input type=radio name=create value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'create'} ? "checked" : "";
printf "<input type=radio name=create value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'create'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_edit'}</b></td> <td>\n";
printf "<input type=radio name=edit value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'edit'} ? "checked" : "";
printf "<input type=radio name=edit value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'edit'} ? "" : "checked";
}

# acl_security_save(&options)
# Parse the form for security options for the majordomo module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'lists_def'}) {
	$_[0]->{'lists'} = "*";
	}
else {
	$_[0]->{'lists'} = join(" ", split(/\0/, $self->{'in_hash'}->{'lists'}));
	}
$_[0]->{'global'} = $self->{'in_hash'}->{'global'};
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'edit'} = $self->{'in_hash'}->{'edit'};
}


1;

