#!/usr/bin/perl
package majordomo::Install_check;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'majordomo::Install_check');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# install_check.pl

&ModuleLoader::preload_module(ref($self), "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: ref($self), %$self; 

1;
		return $self;
}

# is_installed(mode)
# For mode 1, returns 2 if the server is installed and configured for use by
# Webmin, 1 if installed but not configured, or 0 otherwise.
# For mode 0, returns 1 if installed, 0 if not
sub is_installed
{
	my $self = shift;

return 0 if (!-r $self->{'config_hash'}->{'majordomo_cf'} || !-d $self->{'config_hash'}->{'program_dir'} ||
	     !-r "$self->{'config_hash'}->{'program_dir'}/majordomo_version.pl");
{
    my $pkg = $self->lib_to_pkg("$self->{config_hash}->{program_dir}\/majordomo_version.pl", "majordomo");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
return 0 if ($self->{'majordomo_version'} < 1.94 || $self->{'majordomo_version'} >= 2);
if ($_[0]) {
	local $conf = $self->get_config();
	return 2 if ($self->homedir_valid($conf));
	}
return 1;
}


1;

