#!/usr/bin/perl
package majordomo::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'majordomo::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: ref($self), %$self; 
$self->{'conf'} = $self->get_config();
@{$self->{'lists_array'}} = $self->list_lists($self->{'conf'});

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Add a user to the mailing list
sub useradmin_create_user
{
	my $self = shift;

foreach $l (@{$self->{'lists_array'}}) {
	if ($self->{'config_hash'}->{"sync_$l"}) {
		local $dom = $self->{'config_hash'}->{"shost_$l"};
		$dom = $self->get_system_hostname() if (!$dom);
		local $list = $self->get_list($l, $self->{'conf'});
		local $pass = $self->find_value("admin_passwd",
			   $self->get_list_config($list->{'config'}));
		$self->lock_file($list->{'members'});
		open(WRAPPER, "|$self->{'config_hash'}->{'program_dir'}/wrapper majordomo");
		print WRAPPER "From: $_[0]->{'user'}\@$dom\n\n";
		print WRAPPER "approve $pass subscribe $l ",
			      "$_[0]->{'user'}\@$dom\n\n";
		close(WRAPPER);
		sleep(1);
		$self->unlock_file($list->{'members'});
		}
	}
}

# useradmin_delete_user(&details)
# Delete a user from the mailing list
sub useradmin_delete_user
{
	my $self = shift;

foreach $l (@{$self->{'lists_array'}}) {
	if ($self->{'config_hash'}->{"sync_$l"}) {
		local $dom = $self->{'config_hash'}->{"shost_$l"};
		$dom = $self->get_system_hostname() if (!$dom);
		local $list = $self->get_list($l, $self->{'conf'});
		local $pass = $self->find_value("admin_passwd",
			   $self->get_list_config($list->{'config'}));
		$self->lock_file($list->{'members'});
		open(WRAPPER, "|$self->{'config_hash'}->{'program_dir'}/wrapper majordomo");
		print WRAPPER "From: $_[0]->{'user'}\@$dom\n\n";
		print WRAPPER "approve $pass unsubscribe $l ",
			      "$_[0]->{'user'}\@$dom\n\n";
		close(WRAPPER);
		sleep(1);
		$self->unlock_file($list->{'members'});
		}
	}
}

# useradmin_modify_user(&details)
# Does nothing
sub useradmin_modify_user
{
	my $self = shift;

return if ($_[0]->{'user'} eq $_[0]->{'olduser'} || !$_[0]->{'olduser'});
foreach $l (@{$self->{'lists_array'}}) {
	if ($self->{'config_hash'}->{"sync_$l"}) {
		# Directly update the subscription list, if the user is on it
		local $dom = $self->{'config_hash'}->{"shost_$l"};
		$dom = $self->get_system_hostname() if (!$dom);
		local $list = $self->get_list($l, $self->{'conf'});
		$self->lock_file($list->{'members'});
		local $lref = $self->read_file_lines($list->{'members'});
		local ($i, $found);
		for($i=0; $i<@$lref; $i++) {
			if ($lref->[$i] eq "$_[0]->{'olduser'}\@$dom") {
				$lref->[$i] = "$_[0]->{'user'}\@$dom";
				$found++;
				}
			}
		$self->flush_file_lines() if ($found);
		$self->unlock_file($list->{'members'});
		}
	}

}


1;

