#!/usr/bin/perl

&MAIN();

 sub MAIN {
# alias_setup.cgi
# Create the majordomo and majordomo-owner aliases

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
$self->{'aliases_files'} = $self->get_aliases_file();
$self->{'program_dir'} = $self->{'config_hash'}->{'smrsh_program_dir'} ? $self->{'config_hash'}->{'smrsh_program_dir'}
				            : $self->{'config_hash'}->{'program_dir'};
$self->{'wrapper_path'} = $self->{'config_hash'}->{'wrapper_path'} ? $self->{'config_hash'}->{'wrapper_path'}
				        : "$self->{'program_dir'}/wrapper";
$self->error_setup($self->{'text_hash'}->{'alias_err'});
if ($self->{'in_hash'}->{'owner_a'}) {
	$self->{'in_hash'}->{'owner'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'alias_eowner'});
	$self->{'owner'} = { 'enabled' => 1,
		   'name' => $self->{'in_hash'}->{'owner_a'},
		   'values' => [ $self->{'in_hash'}->{'owner'} ] };
	$self->foreign_call($self->{'aliases_module'}, "create_alias", $self->{'owner'}, $self->{'aliases_files'});
	}
$self->{'email'} = { 'enabled' => 1,
	   'name' => $self->{'in_hash'}->{'email_a'},
	   'values' => [ "|$self->{'wrapper_path'} majordomo" ] };
$self->foreign_call("sendmail", "create_alias", $self->{'email'}, $self->{'aliases_files'});
$self->redirect("");

1;
		
}


1;

