#!/usr/bin/perl

&MAIN();

 sub MAIN {
# digest_form.cgi
# Display a form for creating a new disgest list

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'cdigest_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'cdigest_title'}, "");

$self->{'lists'} = "<select name=list>\n";
foreach $l ($self->list_lists($self->get_config())) {
	$self->{'lists'} .= "<option>$l\n";
	}
$self->{'lists'} .= "</select>\n";

$self->{'old'} = $self->text('cdigest_old', "<input name=days size=3>");
$self->{'lines'} = $self->text('cdigest_lines', "<input name=lines size=5>");

print <<EOF;
<form action=create_digest.cgi method=post>
<table border width=100%>
<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cdigest_header'}</b></td> </tr>
<tr $self->{'cb'}> <td><table width=100%>

<tr> <td><b>$self->{'text_hash'}->{'cdigest_name'}</b></td>
     <td><input name=name size=15></td> </tr>
<tr> <td><b>$self->{'text_hash'}->{'cdigest_list'}</b></td> <td>$self->{'lists'}</td> </tr>
<tr> <td><b>$self->{'text_hash'}->{'cdigest_owner'}</b></td>
     <td><input name=owner size=30></td> </tr>
<tr> <td><b>$self->{'text_hash'}->{'cdigest_password'}</b></td>
     <td><input name=password type=password size=10></td> </tr>
<tr> <td><b>$self->{'text_hash'}->{'cdigest_desc'}</b></td>
     <td><input name=desc size=50></td> </tr>
<tr> <td valign=top><b>$self->{'text_hash'}->{'cdigest_info'}</b></td>
     <td><textarea name=info rows=5 cols=60></textarea></td> </tr>
<tr> <td valign=top><b>$self->{'text_hash'}->{'cdigest_footer'}</b></td>
     <td><textarea name=footer rows=3 cols=60></textarea></td> </tr>
<tr> <td valign=top><b>$self->{'text_hash'}->{'cdigest_when'}</b></td>
     <td><input type=radio name=mode value=0 checked> $self->{'old'}<br>
	 <input type=radio name=mode value=1> $self->{'lines'}</td> </tr>

</table></td></tr></table>
<input type=submit value="$self->{'text_hash'}->{'create'}"></form>
EOF
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

