#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_access.cgi
# Edit access control options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->{'desc'} = $self->text('edit_for', "<tt>".$self->html_escape($self->{'in_hash'}->{'name'})."</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'access_title'}, "");

print "<form action=save_access.cgi>\n";
print "<input type=hidden name=name value='$self->{'in_hash'}->{'name'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'access_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr>\n";
print $self->choice_input("get_access", $self->{'text_hash'}->{'access_get'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print $self->choice_input("index_access", $self->{'text_hash'}->{'access_index'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input("info_access", $self->{'text_hash'}->{'access_info'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print $self->choice_input("intro_access", $self->{'text_hash'}->{'access_intro'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input("which_access", $self->{'text_hash'}->{'access_which'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print $self->choice_input("who_access", $self->{'text_hash'}->{'access_who'}, $self->{'conf'},
		    "open",$self->{'text_hash'}->{'access_open'}, "list",$self->{'text_hash'}->{'access_list'},
		    "closed",$self->{'text_hash'}->{'access_closed'});
print "</tr>\n";

$self->{'adv'} = $self->find_value("advertise", $self->{'conf'});
$self->{'noadv'} = $self->find_value("noadvertise", $self->{'conf'});
print "<tr>\n";
print "<td valign=top><b>$self->{'text_hash'}->{'access_adv'}</b></td> <td valign=top>\n";
printf "<input type=radio name=adv_mode value=0 %s> $self->{'text_hash'}->{'access_adv0'}<br>\n",
	$self->{'adv'} !~ /\S/ && $self->{'noadv'} !~ /\S/ ? "checked" : "";
printf "<input type=radio name=adv_mode value=1 %s> $self->{'text_hash'}->{'access_adv1'}<br>\n",
	$self->{'adv'} =~ /\S/ ? "checked" : "";
printf "<input type=radio name=adv_mode value=2 %s> $self->{'text_hash'}->{'access_adv2'}<br>\n",
	$self->{'noadv'} =~ /\S/ ? "checked" : "";
print "</td> <td valign=top colspan=2>\n";
printf "<textarea rows=4 cols=40 name=adv>%s</textarea></td> </tr>\n",
	$self->{'adv'} =~ /\S/ ? $self->{'adv'} : $self->{'noadv'} =~ /\S/ ? $self->{'noadv'} : "";

$self->{'res'} = $self->find_value("restrict_post", $self->{'conf'});
$self->{'ldir'} = $self->perl_var_replace($self->find_value("listdir", $self->get_config()),
			  $self->get_config());
$self->{'reslist'} = $self->{'res'} eq $self->{'in_hash'}->{'name'} || $self->{'res'} eq "$self->{'ldir'}/$self->{'in_hash'}->{'name'}";
print "<tr> <td><b>$self->{'text_hash'}->{'access_res'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=res_mode value=0 %s> $self->{'text_hash'}->{'access_res0'}\n",
	$self->{'res'} ? "" : "checked";
printf "<input type=radio name=res_mode value=1 %s> $self->{'text_hash'}->{'access_res1'}\n",
	$self->{'reslist'} ? "checked" : "";
printf "<input type=radio name=res_mode value=2 %s> $self->{'text_hash'}->{'access_res2'}\n",
	$self->{'res'} && !$self->{'reslist'} ? "checked" : "";
printf "<input name=res size=35 value=\"%s\">%s</td> </tr>\n",
	$self->{'res'} && !$self->{'reslist'} ? $self->{'res'} : "", $self->file_chooser_button("res", 0);

print "<tr>\n";
print $self->multi_input("taboo_body", $self->{'text_hash'}->{'access_tbody'}, $self->{'conf'});
print "</tr>\n";

print "<tr>\n";
print $self->multi_input("taboo_headers", $self->{'text_hash'}->{'access_theader'}, $self->{'conf'});
print "</tr>\n";

print "<tr> <td colspan=4>$self->{'text_hash'}->{'access_taboo'}</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("edit_list.cgi?name=$self->{'in_hash'}->{'name'}", $self->{'text_hash'}->{'edit_return'});

1;
		
}


1;

