#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_digest.cgi
# Save digest options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->lock_file($self->{'list'}->{'config'});
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});

$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "digest_name");
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "digest_maxdays", \&check_days);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "digest_maxlines", \&check_lines);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "digest_volume", \&check_volume);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "digest_issue", \&check_issue);

$self->flush_file_lines();
$self->unlock_file($self->{'list'}->{'config'});
$self->webmin_log("digest", undef, $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}

sub check_days
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'digest_edays'};
}

sub check_lines
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'digest_elines'};
}

sub check_volume
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'digest_evolume'};
}

sub check_issue
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'digest_eissue'};
}


1;

