#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_members.cgi
# Store the members of some list

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParseMime();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'members_eedit'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->{'pass'} = $self->find_value("admin_passwd", $self->{'conf'});
$self->{'wrapper_path'} = $self->{'config_hash'}->{'wrapper_path'} || "$self->{'config_hash'}->{'program_dir'}/wrapper";

# find the list owner's email address
$self->{'aliases_files'} = $self->get_aliases_file();
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	if ($a->{'name'} eq "owner-$self->{'in_hash'}->{'name'}" ||
	    $a->{'name'} eq "$self->{'in_hash'}->{'name'}-owner") {
		$self->{'owner'} = $a->{'values'}->[0];
		}
	}

$self->lock_file($self->{'list'}->{'members'});
if ($self->{'in_hash'}->{'update'}) {
	# save the new list of members
	$self->{'in_hash'}->{'members'} =~ s/\r//g;
	$self->{'in_hash'}->{'members'} =~ s/\n*$/\n/;
	$self->open_tempfile(MEMS, ">$self->{'list'}->{'members'}");
	$self->print_tempfile(MEMS, $self->{'in_hash'}->{'members'});
	$self->close_tempfile(MEMS);
	$self->unlock_file($self->{'list'}->{'members'});
	$self->webmin_log("members", undef, $self->{'in_hash'}->{'name'});
	}
elsif ($self->{'in_hash'}->{'add'}) {
	# call majordomo to subscribe an address
	$self->{'pass'} || $self->error($self->{'text_hash'}->{'members_esub'});
	$self->{'in_hash'}->{'addr_a'} =~ /^(\S+)\@(\S+)\.(\S+)$/ ||
		$self->error($self->{'text_hash'}->{'members_esubaddr'});
	open(WRAPPER, "|$self->{'wrapper_path'} majordomo");
	printf WRAPPER "From: %s\n\n",
		$self->{'owner'} ? $self->{'owner'} : $self->{'in_hash'}->{'addr_a'};
	print WRAPPER "approve $self->{'pass'} subscribe $self->{'in_hash'}->{'name'} $self->{'in_hash'}->{'addr_a'}\n\n";
	close(WRAPPER);
	sleep(1);
	$self->unlock_file($self->{'list'}->{'members'});
	$self->webmin_log("subscribe", undef, $self->{'in_hash'}->{'name'},
		    { 'addr' => $self->{'in_hash'}->{'addr_a'} });
	}
elsif ($self->{'in_hash'}->{'remove'}) {
	# call majordomo to unsubscribe an address
	$self->{'pass'} || $self->error($self->{'text_hash'}->{'members_eunsub'});
	$self->{'in_hash'}->{'addr_r'} =~ /^(\S+)\@(\S+)\.(\S+)$/ ||
		$self->error($self->{'text_hash'}->{'members_eunsubaddr'});
	open(WRAPPER, "|$self->{'wrapper_path'} majordomo");
	printf WRAPPER "From: %s\n\n",
		$self->{'owner'} ? $self->{'owner'} : $self->{'in_hash'}->{'addr_r'};
	print WRAPPER "approve $self->{'pass'} unsubscribe $self->{'in_hash'}->{'name'} $self->{'in_hash'}->{'addr_r'}\n\n";
	close(WRAPPER);
	sleep(1);
	$self->unlock_file($self->{'list'}->{'members'});
	$self->webmin_log("unsubscribe", undef, $self->{'in_hash'}->{'name'},
		    { 'addr' => $self->{'in_hash'}->{'addr_r'} });
	}
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}


1;

