#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mesg.cgi
# Save message options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->lock_file($self->{'list'}->{'config'});
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "reply_to", \&check_reply);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "sender", \&check_sender);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "resend_host", \&check_host);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "subject_prefix");
$self->save_select($self->{'conf'}, $self->{'list'}->{'config'}, "precedence");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "purge_received");
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "maxlength", \&check_maxlength);
$self->flush_file_lines();
$self->unlock_file($self->{'list'}->{'config'});
$self->webmin_log("mesg", undef, $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}

sub check_reply
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'mesg_ereply'};
}

sub check_sender
{
	shift if ($self == $_[0]);

return $_[0] =~ /\@/ ? $self->{'text_hash'}->{'mesg_esender2'} :
       $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'mesg_esender'};
}

sub check_host
{
	shift if ($self == $_[0]);

return $_[0] =~ /^[A-z0-9\-\.]+$/ ? undef : $self->{'text_hash'}->{'mesg_ehost'};
}

sub check_maxlength
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->{'text_hash'}->{'mesg_emaxlength'};
}


1;

