#!/usr/bin/perl
package mount::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mount::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "mount::MountLib");
$self = new mount::MountLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the mount module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_fs'}</b></td>\n";
print "<td colspan=3>",$self->ui_opt_textbox("fs", $_[0]->{'fs'}, 40,
		$self->{'text_hash'}->{'acl_all'}, $self->{'text_hash'}->{'acl_list'}),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_types'}</b></td>\n";
print "<td colspan=3>",$self->ui_opt_textbox("types", $_[0]->{'types'}, 30,
		$self->{'text_hash'}->{'acl_all'}, $self->{'text_hash'}->{'acl_fslist'}),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td>\n";
print "<td>",$self->ui_radio("create", $_[0]->{'create'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_only'}</b></td>\n";
print "<td>",$self->ui_radio("only", $_[0]->{'only'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_user'}</b></td>\n";
print "<td>",$self->ui_radio("user", $_[0]->{'user'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_hide'}</b></td>\n";
print "<td>",$self->ui_radio("hide", $_[0]->{'hide'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_simple'}</b></td>\n";
print "<td>",$self->ui_radio("simple", $_[0]->{'simple'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_simopts'}</b></td>\n";
print "<td>",$self->ui_radio("simopts", $_[0]->{'simopts'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_browse'}</b></td>\n";
print "<td>",$self->ui_radio("browse", $_[0]->{'browse'},
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "</tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the mount module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'fs'} = $self->{'in_hash'}->{'fs_def'} ? undef : $self->{'in_hash'}->{'fs'};
$_[0]->{'types'} = $self->{'in_hash'}->{'types_def'} ? undef : $self->{'in_hash'}->{'types'};
$_[0]->{'only'} = $self->{'in_hash'}->{'only'};
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'user'} = $self->{'in_hash'}->{'user'};
$_[0]->{'hide'} = $self->{'in_hash'}->{'hide'};
$_[0]->{'simple'} = $self->{'in_hash'}->{'simple'};
$_[0]->{'simopts'} = $self->{'in_hash'}->{'simopts'};
$_[0]->{'browse'} = $self->{'in_hash'}->{'browse'};
}


1;

