#!/usr/bin/perl

&MAIN();

 sub MAIN {
# smb_server.cgi
# Called in a pop-up javascript window to display a list of known SMB
# servers, by calling smbclient to request the browse list from some server

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

use Socket;
$self->popup_header($self->{'text_hash'}->{'smb_choose'});
print <<EOF;
<script>
function choose(f)
{
top.opener.ifield.value = f;
window.close();
}
</script>
EOF

# call smbclient
$self->{'host'} = $self->{'config_hash'}->{'browse_server'} ? $self->{'config_hash'}->{'browse_server'} : "localhost";
$self->execute_command("$self->{'config_hash'}->{'smbclient_path'} -d 0 -L $self->{'host'} -N",
		 undef, \$self->{'out'}, \$self->{'out'});
if ($?) {
	print "<b>",$self->text('smb_elist', $self->{'host'}),"</b>\n";
	exit;
	}
elsif ($self->{'out'} =~ /Unknown host/) {
	print "<b>",$self->text('smb_ehost', $self->{'host'}),"</b>\n";
	exit;
	}
elsif ($self->{'out'} =~ /error connecting|connect error/) {
	print "<b>",$self->text('smb_edown', $self->{'host'}),"</b>\n";
	exit;
	}

# parse server list
if ($self->{'out'} =~ /Server\s+Comment\n.*\n((.+\n)+)/) {
	@{$self->{'svlist_array'}} = split(/\n/, $1);
	foreach $sv (@{$self->{'svlist_array'}}) {
		if ($sv =~ /^\s+(\S+)\s*(.*)$/) {
			push(@{$self->{'names_array'}}, $1); push(@{$self->{'comms_array'}}, $2);
			}
		}
	}

if (@{$self->{'names_array'}}) {
	print "<b>$self->{'text_hash'}->{'smb_sel'}</b><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'smb_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'smb_desc'}</b></td> </tr>\n";
	for($i=0; $i<@{$self->{'names_array'}}; $i++) {
		print "<tr $self->{'cb'}>\n";
		print "<td><a href=\"\" onClick='choose(\"$self->{'names_array'}->[$i]\"); ",
		      "return false'>$self->{'names_array'}->[$i]</a></td>\n";
		print "<td>$self->{'comms_array'}->[$i]</td> </tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'smb_none'}</b>.<p>\n";
	}

$self->popup_footer();

1;
		
}


1;

