#!/usr/bin/perl
package mysql::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'mysql::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "mysql::MysqlLib");
$self = new mysql::MysqlLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the mysql module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top rowspan=3><b>$self->{'text_hash'}->{'acl_dbs'}</b></td>\n";
print "<td rowspan=3 valign=top>\n";
printf "<input type=radio name=dbs_def value=1 %s> %s\n",
	$_[0]->{'dbs'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_dall'};
printf "<input type=radio name=dbs_def value=0 %s> %s<br>\n",
	$_[0]->{'dbs'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_dsel'};
print "<select name=dbs size=3 multiple width=100>\n";
map { $self->{'dcan_hash'}->{$_}++ } split(/\s+/, $_[0]->{'dbs'});
foreach $d ($self->list_databases()) {
	printf "<option %s>%s\n",
		$self->{'dcan_hash'}->{$d} ? 'selected' : '', $d;
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_delete'}</b></td> <td>\n";
printf "<input type=radio name=delete value=1 %s> %s\n",
	$_[0]->{'delete'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=delete value=0 %s> %s</td> </tr>\n",
	$_[0]->{'delete'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_stop'}</b></td> <td>\n";
printf "<input type=radio name=stop value=1 %s> %s\n",
	$_[0]->{'stop'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=stop value=0 %s> %s</td> </tr>\n",
	$_[0]->{'stop'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_edonly'}</b></td> <td>\n";
printf "<input type=radio name=edonly value=1 %s> %s\n",
	$_[0]->{'edonly'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=edonly value=0 %s> %s</td> </tr>\n",
	$_[0]->{'edonly'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_indexes'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("indexes", $_[0]->{'indexes'}),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_views'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("views", $_[0]->{'views'}),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=create value=1 %s> %s\n",
	$_[0]->{'create'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=create value=2 %s> %s\n",
	$_[0]->{'create'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_max'};
printf "<input name=max size=5 value='%s'>\n",
	$_[0]->{'max'};
printf "<input type=radio name=create value=0 %s> %s</td> </tr>\n",
	$_[0]->{'create'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_perms'}</b></td> <td colspan=3>\n";
printf "<input name=perms type=radio value=1 %s> %s\n",
	$_[0]->{'perms'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input name=perms type=radio value=2 %s> %s\n",
	$_[0]->{'perms'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_only'};
printf "<input name=perms type=radio value=0 %s> %s\n",
	$_[0]->{'perms'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'no'};
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_login'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=user_def value=1 %s> %s<br>\n",
	$_[0]->{'user'} ? '' : 'checked', $self->{'text_hash'}->{'acl_user_def'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} ? 'checked' : '';
printf "%s <input name=user size=10 value='%s'>\n",
	$self->{'text_hash'}->{'acl_user'}, $_[0]->{'user'};
printf "%s <input name=pass type=password size=10 value='%s'></td> </tr>\n",
	$self->{'text_hash'}->{'acl_pass'}, $_[0]->{'pass'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_buser'}</b></td>\n";
printf "<td colspan=3><input type=radio name=buser_def value=1 %s> %s\n",
	$_[0]->{'buser'} ? "" : "checked", $self->{'text_hash'}->{'acl_bnone'};
printf "<input type=radio name=buser_def value=0 %s>\n",
	$_[0]->{'buser'} ? "checked" : "";
printf "<input name=buser size=8 value='%s'> %s</td> </tr>\n",
	$_[0]->{'buser'}, $self->user_chooser_button("buser");

print "<tr> <td><b>$self->{'text_hash'}->{'acl_bpath'}</b></td>\n";
printf "<td colspan=3><input name=bpath size=40 value='%s'> %s</td> </tr>\n",
	$_[0]->{'bpath'}, $self->file_chooser_button("bpath", 1);

}

# acl_security_save(&options)
# Parse the form for security options for the mysql module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'dbs_def'}) {
	$_[0]->{'dbs'} = '*';
	}
else {
	$_[0]->{'dbs'} = join(" ", split(/\0/, $self->{'in_hash'}->{'dbs'}));
	}
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'indexes'} = $self->{'in_hash'}->{'indexes'};
$_[0]->{'views'} = $self->{'in_hash'}->{'views'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'bpath'} = $self->{'in_hash'}->{'bpath'};
$_[0]->{'buser'} = $self->{'in_hash'}->{'buser_def'} ? undef : $self->{'in_hash'}->{'buser'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'perms'} = $self->{'in_hash'}->{'perms'};
$_[0]->{'edonly'} = $self->{'in_hash'}->{'edonly'};
if ($self->{'in_hash'}->{'user_def'}) {
	delete($_[0]->{'user'});
	delete($_[0]->{'pass'});
	}
else {
	$_[0]->{'user'} = $self->{'in_hash'}->{'user'};
	$_[0]->{'pass'} = $self->{'in_hash'}->{'pass'};
	}
}


1;

