#!/usr/bin/perl

&MAIN();

 sub MAIN {
# backup_form.cgi
# Display a form for backing up this database, or all databases

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'all'}) {
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'dbs_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	@{$self->{'alldbs_array'}} == @{$self->{'dbs_array'}} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
else {
	$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'buser'} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->ui_print_header(undef, $self->{'in_hash'}->{'all'} ? $self->{'text_hash'}->{'backup_title2'} : $self->{'text_hash'}->{'backup_title'}, "",
	"backup_form");

if (!-x $self->{'config_hash'}->{'mysqldump'}) {
	print $self->text('backup_edump', "<tt>$self->{'config_hash'}->{'mysqldump'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'});
	exit;
	}

$self->{'cron'} = !$self->{'module_info_hash'}->{'usermin'} && $self->{'access_hash'}->{'buser'} eq 'root' &&
	!$self->{'access_hash'}->{'user'} && $self->foreign_installed("cron");
if ($self->{'in_hash'}->{'all'}) {
	print "$self->{'text_hash'}->{'backup_desc3'}\n";
	}
else {
	print $self->text('backup_desc', "<tt>$self->{'in_hash'}->{'db'}</tt>"),"\n";
	}
if ($self->{'cron'}) {
	print "$self->{'text_hash'}->{'backup_desc2'}\n";
	}
print "<p>\n";
%{$self->{'c_hash'}} = $self->{'module_info_hash'}->{'usermin'} ? %{$self->{'userconfig_hash'}} : %{$self->{'config_hash'}};

print "<form action=backup_db.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=all value='$self->{'in_hash'}->{'all'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'backup_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

if ($self->{'in_hash'}->{'all'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_file2'}</td>\n";
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_file'}</td>\n";
	}
printf "<td><input name=file size=40 value='%s'> %s</td> </tr>\n",
	$self->{'c_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}}, $self->file_chooser_button("file");

if (!$self->{'in_hash'}->{'all'}) {
	# Show input to select tables
	$t = $self->{'c_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}};
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'backup_tables'}</b></td> <td>\n";
	printf "<input type=radio name=tables_def value=1 %s> %s\n",
		$t ? "" : "checked", $self->{'text_hash'}->{'backup_alltables'};
	printf "<input type=radio name=tables_def value=0 %s> %s<br>\n",
		$t ? "checked" : "", $self->{'text_hash'}->{'backup_seltables'};
	@{$self->{'tables_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
	%{$self->{'got_hash'}} = map { $_, 1 } split(/\s+/, $t);
	print "<select name=tables multiple size=5>\n";
	foreach $t (sort @{$self->{'tables_array'}}) {
		printf "<option %s>%s\n",
			$self->{'got_hash'}->{$t} ? "selected" : "", $t;
		}
	print "</select></td> </tr>\n";
	}

# Show input for where clause
$self->{'w'} = $self->{'c_hash'}->{'backup_where_'.$self->{'in_hash'}->{'db'}};
print "<tr> <td><b>$self->{'text_hash'}->{'backup_where'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("where", $self->{'w'}, 30, $self->{'text_hash'}->{'backup_none'}),
      "</td> </tr>\n";

# Show option to include drop statements in SQL
$self->{'d'} = $self->{'c_hash'}->{'backup_drop_'.$self->{'in_hash'}->{'db'}};
print "<tr> <td><b>$self->{'text_hash'}->{'backup_drop'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("drop", $self->{'d'} ? 1 : 0),"</td> </tr>\n";

# Show input for character set
$self->{'s'} = $self->{'c_hash'}->{'backup_charset_'.$self->{'in_hash'}->{'db'}};
print "<tr> <td><b>$self->{'text_hash'}->{'backup_charset'}</b></td>\n";
print "<td>",$self->ui_radio("charset_def", $self->{'s'} ? 0 : 1,
	       [ [ 1, $self->{'text_hash'}->{'default'} ],
		 [ 0, $self->ui_select("charset", $self->{'s'},
			[ $self->list_character_sets($self->{'in_hash'}->{'db'}) ]) ] ]),
      "</td> </tr>\n";

if ($self->{'mysql_version'} >= 5.0) {
	# Show compatability format option
	$self->{'cf'} = $self->{'c_hash'}->{'backup_compatible_'.$self->{'in_hash'}->{'db'}};
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_compatible'}</b></td>\n";
	print "<td>",$self->ui_radio("compatible_def", $self->{'cf'} ? 0 : 1,
		       [ [ 1, $self->{'text_hash'}->{'default'} ],
			 [ 0, $self->text('backup_compwith',
				$self->ui_select("compatible", $self->{'cf'},
				   [ $self->list_compatible_formats() ])) ] ]),
	      "</td> </tr>\n";

	%{$self->{'co_hash'}} = map { $_, 1 } split(/\s+/, $self->{'c_hash'}->{'backup_options_'.$self->{'in_hash'}->{'db'}});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'backup_options'}</b></td> <td>\n";
	foreach $o ($self->list_compatible_options()) {
		print $self->ui_checkbox("options", $o->[0], $o->[1] || $o->[0],
				   $self->{'co_hash'}->{$o->[0]}),"<br>\n";
		}
	print "</td> </tr>\n";
	}
else {
	print $self->ui_hidden("compatible_def", 1),"\n";
	}

# Show compression option
$self->{'cp'} = int($self->{'c_hash'}->{'backup_compress_'.$self->{'in_hash'}->{'db'}});
print "<tr> <td><b>$self->{'text_hash'}->{'backup_compress'}</b></td>\n";
print "<td>",$self->ui_radio("compress", $self->{'cp'},
		[ [ 0, $self->{'text_hash'}->{'backup_cnone'} ],
		  [ 1, $self->{'text_hash'}->{'backup_gzip'} ],
		  [ 2, $self->{'text_hash'}->{'backup_bzip2'} ] ]),"</td> </tr>\n";

if ($self->{'cron'}) {
	# Show before/after commands
	$self->{'b'} = $self->{'c_hash'}->{'backup_before_'.$self->{'in_hash'}->{'db'}};
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_before'}</b></td>\n";
	printf "<td><input name=before size=50 value='%s'></td> </tr>\n", $self->{'b'};

	$self->{'a'} = $self->{'c_hash'}->{'backup_after_'.$self->{'in_hash'}->{'db'}};
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_after'}</b></td>\n";
	printf "<td><input name=after size=50 value='%s'></td> </tr>\n", $self->{'a'};

	if ($self->{'in_hash'}->{'all'}) {
		# Command mode option
		$self->{'cmode'} = $self->{'c_hash'}->{'backup_cmode_'.$self->{'in_hash'}->{'db'}};
		print "<tr> <td><b>$self->{'text_hash'}->{'backup_cmode'}</b></td>\n";
		print "<td>",$self->ui_radio("cmode", int($self->{'cmode'}),
			[ [ 0, $self->{'text_hash'}->{'backup_cmode0'} ],
			  [ 1, $self->{'text_hash'}->{'backup_cmode1'} ] ]),"</td> </tr>\n";
		}

	# Show cron time
	$self->foreign_require("cron", "cron-lib.pl");
	@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
	$self->{'cmd'} = $self->{'in_hash'}->{'all'} ? "$self->{'cron_cmd'} --all" : "$self->{'cron_cmd'} $self->{'in_hash'}->{'db'}";
	($self->{'job'}) = grep { $_->{'command'} eq $self->{'cmd'} } @{$self->{'jobs_array'}};

	print "<tr> <td><b>$self->{'text_hash'}->{'backup_sched'}</b></td>\n";
	printf "<td><input type=radio name=sched value=0 %s> %s\n",
		$self->{'job'} ? "" : "checked", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=sched value=1 %s> %s</td> </tr>\n",
		$self->{'job'} ? "checked" : "", $self->{'text_hash'}->{'backup_sched1'};

	print "<tr> <td colspan=2><table border width=100%>\n";
	$self->{'job'} ||= { 'mins' => 0,
		   'hours' => 0,
		   'days' => '*',
		   'months' => '*',
		   'weekdays' => '*' };
	$main::cron_object->show_times_input($self->{'job'});
	print "</table></td> </tr>\n";
	}
print "</table></td></tr></table>\n";

if ($self->{'cron'}) {
	print "<input type=submit name=backup value='$self->{'text_hash'}->{'backup_ok1'}'>\n";
	print "<input type=submit name=save value='$self->{'text_hash'}->{'backup_ok2'}'>\n";
	}
else {
	print "<input type=submit name=backup value='$self->{'text_hash'}->{'backup_ok'}'>\n";
	}
print "<br>\n";
print "</form>\n";

if ($self->{'in_hash'}->{'all'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

