#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Drops multiple databases

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ddrops_err'});
@{$self->{'dbs_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'dbs_array'}} || $self->error($self->{'text_hash'}->{'ddrops_enone'});
$self->{'access_hash'}->{'delete'} || $self->error($self->{'text_hash'}->{'ddrops_ecannot'});
foreach $db (@{$self->{'dbs_array'}}) {
	$self->can_edit_db($db) || $self->error($self->text('ddrops_ecannotdb', $db));
	}
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Drop the databases
	foreach $db (@{$self->{'dbs_array'}}) {
		$self->execute_sql_logged($self->{'master_db'},"drop database ".$self->quotestr($db));
		}
	$self->webmin_log("delete", "dbs", scalar(@{$self->{'dbs_array'}}), \%{$self->{'in_hash'}});
	$self->redirect("");
	}
else {
	# Ask the user if he is sure..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ddrops_title'}, "");

	$self->{'rows'} = 0;
	$self->{'tables'} = 0;
	foreach $db (@{$self->{'dbs_array'}}) {
		@{$self->{'tables_array'}} = $self->list_tables($db);
		foreach $t (@{$self->{'tables_array'}}) {
			$self->{'d'} = $self->execute_sql($db,
				"select count(*) from ".$self->quotestr($t));
			$self->{'rows'} += $self->{'d'}->{'data'}->[0]->[0];
			$self->{'tables'}++;
			}
		}

	print "<center><b>",$self->text('ddrops_rusure', scalar(@{$self->{'dbs_array'}}),
				  $self->{'tables'}, $self->{'rows'}),"\n";
	if ($self->indexof($self->{'master_db'}, @{$self->{'dbs_array'}}) >= 0) {
		print $self->{'text_hash'}->{'ddrop_mysql'},"\n";
		}
	print "</b><p>\n";
	print "<form action=drop_dbases.cgi>\n";
	foreach $db (@{$self->{'dbs_array'}}) {
		print $self->ui_hidden("d", $db),"\n";
		}
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'ddrops_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

