#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cpriv.cgi
# Display a form for editing or creating new column permissions

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});
if ($self->{'in_hash'}->{'table'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'cpriv_title1'}, "", "create_cpriv");
	($self->{'d'}, $self->{'t'}) = split(/\./, $self->{'in_hash'}->{'table'});
	}
else {
	$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from columns_priv order by table_name,column_name");
	$self->{'u'} = $self->{'d'}->{'data'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'u'}->[1]) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->{'d'} = $self->{'u'}->[1]; $self->{'t'} = $self->{'u'}->[3];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'cpriv_title2'}, "", "edit_cpriv");
	}

print "<form action=save_cpriv.cgi>\n";
if ($self->{'in_hash'}->{'table'}) {
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	}
else {
	print "<input type=hidden name=oldhost value='$self->{'u'}->[0]'>\n";
	print "<input type=hidden name=olddb value='$self->{'u'}->[1]'>\n";
	print "<input type=hidden name=olduser value='$self->{'u'}->[2]'>\n";
	print "<input type=hidden name=oldtable value='$self->{'u'}->[3]'>\n";
	print "<input type=hidden name=oldfield value='$self->{'u'}->[4]'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'cpriv_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'cpriv_db'}</b></td>\n";
print "<td><tt>$self->{'d'}</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'cpriv_table'}</b></td>\n";
print "<td><tt>$self->{'t'}</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'cpriv_field'}</b></td>\n";
print "<td><select name=field>\n";
print "<option selected>\n" if ($self->{'in_hash'}->{'table'});
foreach $c ($self->table_structure($self->{'d'}, $self->{'t'})) {
	printf "<option %s>%s\n",
		$self->{'u'}->[4] eq $c->{'field'} ? 'selected' : '',
		$c->{'field'};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'cpriv_user'}</b></td> <td>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$self->{'u'}->[2] ? '' : 'checked', $self->{'text_hash'}->{'cpriv_anon'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$self->{'u'}->[2] ? 'checked' : '';
print "<input name=user size=10 value='$self->{'u'}->[2]'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'cpriv_host'}</b></td> <td>\n";
printf "<input type=radio name=host_def value=1 %s> %s\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? 'checked' : '', $self->{'text_hash'}->{'cpriv_any'};
printf "<input type=radio name=host_def value=0 %s>\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? '' : 'checked';
printf "<input name=host size=20 value='%s'></td> </tr>\n",
	$self->{'u'}->[0] eq '%' ? '' : $self->{'u'}->[0];

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'cpriv_perms'}</b></td>\n";
print "<td><select multiple size=4 name=perms>\n";
foreach $p ('Select','Insert','Update','References') {
	printf "<option %s>%s\n",
		$self->{'u'}->[6] =~ /$p/i ? 'selected' : '', $p;
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer('list_cprivs.cgi', $self->{'text_hash'}->{'cprivs_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

