#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_db.cgi
# Edit or create a db table record

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'db_title1'}, "", "create_db");
	}
else {
	$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from db order by db");
	$self->{'u'} = $self->{'d'}->{'data'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'u'}->[1]) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'db_title2'}, "", "edit_db");
	}

print "<form action=save_db.cgi>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=hidden name=new value=1>\n";
	}
else {
	print "<input type=hidden name=oldhost value='$self->{'u'}->[0]'>\n";
	print "<input type=hidden name=olddb value='$self->{'u'}->[1]'>\n";
	print "<input type=hidden name=olduser value='$self->{'u'}->[2]'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'db_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'db_db'}</b></td>\n";
print "<td>",$self->select_db($self->{'u'}->[1]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'db_user'}</b></td> <td>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$self->{'u'}->[2] ? '' : 'checked', $self->{'text_hash'}->{'db_anon'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$self->{'u'}->[2] ? 'checked' : '';
print "<input name=user size=10 value='$self->{'u'}->[2]'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'db_host'}</b></td> <td>\n";
printf "<input type=radio name=host_mode value=0 %s> %s\n",
	$self->{'u'}->[0] eq '' ? 'checked' : '', $self->{'text_hash'}->{'db_hosts'};
printf "<input type=radio name=host_mode value=1 %s> %s\n",
	$self->{'u'}->[0] eq '%' ? 'checked' : '', $self->{'text_hash'}->{'db_any'};
printf "<input type=radio name=host_mode value=2 %s>\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? '' : 'checked';
printf "<input name=host size=20 value='%s'></td> </tr>\n",
	$self->{'u'}->[0] eq '%' ? '' : $self->{'u'}->[0];

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'db_perms'}</b></td>\n";
print "<td><select name=perms multiple size=8>\n";
for($i=3; $i<=$self->db_priv_cols()+3-1; $i++) {
	printf "<option value=%d %s>%s\n",
		$i, $self->{'u'}->[$i] eq 'Y' ? 'selected' : '',
		$self->{'text_hash'}->{"db_priv$i"};
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer('list_dbs.cgi', $self->{'text_hash'}->{'dbs_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

