#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dbase.cgi
# Show database tables and indexes

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->read_acl(\%{$self->{'hash1_hash'}}, \%{$self->{'hash2_hash'}});

$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } $self->list_databases();
$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";

#if (@{$self->{'titles_array'}} == 1 && $self->{'module_info_hash'}->{'usermin'}) {
if ((@{$self->{'titles_array'}} == 1 && $self->{'access_hash'}->{'dbs'} ne '*' && !$self->{'access_hash'}->{'perms'} &&
	    !$self->{'access_hash'}->{'stop'} && !$self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'noconfig'}) ||  (@{$self->{'titles_array'}} == 1 && $self->{'module_info_hash'}->{'usermin'})  ){
	# Single-DB mode
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dbase_title'}, "", "edit_dbase", 1, 1);
	$self->{'single'} = 1;
	}
else {
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dbase_title'}, "", "edit_dbase");
	}
@{$self->{'titles_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
if ($self->{'access_hash'}->{'indexes'}) {
	@{$self->{'indexes_array'}} = $self->list_indexes($self->{'in_hash'}->{'db'});
	}
if ($self->{'mysql_version'} >= 5 && $self->{'access_hash'}->{'views'}) {
	@{$self->{'views_array'}} = $self->list_views($self->{'in_hash'}->{'db'});
	}

if ($self->{'in_hash'}->{'search'}) {
	# Limit to those matching search
	@{$self->{'titles_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'titles_array'}};
	@{$self->{'indexes_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'indexes_array'}};
	@{$self->{'views_array'}} = grep { /\Q$self->{'in_hash'}->{'search'}\E/i } @{$self->{'views_array'}};
	print "<table width=100%><tr>\n";
	print "<td> <b>",$self->text('dbase_showing',
		"<tt>$self->{'in_hash'}->{'search'}</tt>"),"</b></td>\n";
	print "<td align=right><a href='edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}'>",
		"$self->{'text_hash'}->{'view_searchreset'}</a></td>\n";
	print "</tr></table>\n";
	}

if (@{$self->{'titles_array'}}+@{$self->{'indexes_array'}}+@{$self->{'views_array'}} > $self->{'max_dbs'} && !$self->{'in_hash'}->{'search'}) {
	# Too many tables to show .. display search and jump forms
	print $self->ui_form_start("edit_dbase.cgi");
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
	print $self->{'text_hash'}->{'dbase_toomany'},"\n";
	print $self->ui_textbox("search", undef, 20),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_search'}),"<br>\n";
	print $self->ui_form_end();

	print $self->ui_form_start("edit_table.cgi");
	print $self->{'text_hash'}->{'dbase_jump'},"\n";
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
	print $self->ui_select("table", undef, [ map { [ $_ ] } @{$self->{'titles_array'}} ]),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'index_jumpok'}),"<br>\n";
	print $self->ui_form_end();
	}
elsif (@{$self->{'titles_array'}} || @{$self->{'indexes_array'}}) {
	@{$self->{'icons_array'}} = ( ( map { "images/table.gif" } @{$self->{'titles_array'}} ),
		   ( map { "images/index.gif" } @{$self->{'indexes_array'}} ),
		   ( map { "images/view.gif" } @{$self->{'views_array'}} ),
		 );
	@{$self->{'links_array'}} = ( ( map { "edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($_) }
		     	 @{$self->{'titles_array'}} ),
		   ( map { "edit_index.cgi?db=$self->{'in_hash'}->{'db'}&index=".$self->urlize($_) }
                         @{$self->{'indexes_array'}} ),
		   ( map { "edit_view.cgi?db=$self->{'in_hash'}->{'db'}&view=".$self->urlize($_) }
                         @{$self->{'views_array'}} ),
		 );
	#&show_buttons();
	print $self->ui_form_start("drop_tables.cgi");
	print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
	@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d", $self->{'form'}),
		      $self->select_invert_link("d", $self->{'form'}) );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	@{$self->{'checks_array'}} = ( ( @{$self->{'titles_array'}} ),
		    ( map { "!".$_ } @{$self->{'indexes_array'}} ),
		    ( map { "*".$_ } @{$self->{'views_array'}} ),
		  );
	if ($self->{'config_hash'}->{'style'}) {
		foreach $t (@{$self->{'titles_array'}}) {
			local $c = $self->execute_sql($self->{'in_hash'}->{'db'},
					"select count(*) from ".$self->quotestr($t));
			push(@{$self->{'rows_array'}}, $c->{'data'}->[0]->[0]);
			local @str = $self->table_structure($self->{'in_hash'}->{'db'}, $t);
			push(@{$self->{'fields_array'}}, scalar(@str));
			}
		foreach $t (@{$self->{'indexes_array'}}) {
			$self->{'str'} = $self->index_structure($self->{'in_hash'}->{'db'}, $t);
			push(@{$self->{'rows_array'}}, "<i>$self->{'text_hash'}->{'dbase_index'}</i>");
			push(@{$self->{'fields_array'}}, scalar(@{$self->{'str'}->{'cols'}}));
			}
		foreach $v (@{$self->{'indexes_array'}}) {
			push(@{$self->{'rows_array'}}, "<i>$self->{'text_hash'}->{'dbase_view'}</i>");
			push(@{$self->{'fields_array'}}, undef);
			}
		@{$self->{'dtitles_array'}} = map { $self->html_escape($_) }
			       ( @{$self->{'titles_array'}}, @{$self->{'indexes_array'}}, @{$self->{'views_array'}} );
		$self->split_table([ "", $self->{'text_hash'}->{'dbase_table'}, $self->{'text_hash'}->{'dbase_rows'},
			       $self->{'text_hash'}->{'dbase_cols'} ],
			     \@{$self->{'checks_array'}}, \@{$self->{'links_array'}}, \@{$self->{'dtitles_array'}},
			     \@{$self->{'rows_array'}}, \@{$self->{'fields_array'}}) if (@{$self->{'titles_array'}});
		}
	else {
		@{$self->{'checks_array'}} = map { $self->ui_checkbox("d", $_) } @{$self->{'checks_array'}};
		@{$self->{'titles_array'}} = map { $self->html_escape($_) } ( @{$self->{'titles_array'}}, @{$self->{'indexes_array'}}, @{$self->{'views_array'}});
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5, undef, undef, undef,
			     \@{$self->{'checks_array'}});
		}
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	if (!$self->{'access_hash'}->{'edonly'}) {
		print $self->ui_form_end([ [ "delete", @{$self->{'indexes_array'}} ? $self->{'text_hash'}->{'dbase_delete2'} : $self->{'text_hash'}->{'dbase_delete'} ] ]);
		}
	else {
		print $self->ui_form_end();
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'dbase_none'}</b> <p>\n";
	}
&show_buttons();

	#Check if the optional perl modules are installed
	if ( !$self->{'gconfig_hash'}->{'ztl_mode'} && $self->{'hash1_hash'}->{$self->{'remote_user'}, 'useradmin'})
		{
		if ($self->foreign_available("cpan")) {
			eval "use DBI";
			push(@{$self->{'needs_array'}}, "DBI") if ($@);
			$self->{'nodbi'}++ if ($@);
			eval "use DBD::mysql";
			push(@{$self->{'needs_array'}}, "DBD::mysql") if ($@);
			if (@{$self->{'needs_array'}}) {
				$self->{'needs'} = $self->urlize(join(" ", @{$self->{'needs_array'}}));
				print "<center><b>",$self->text(@{$self->{'needs_array'}} == 2 ? 'index_nomods' : 'index_nomod', @{$self->{'needs_array'}},
					"/cpan/download.cgi?source=3&cpan=$self->{'needs'}&mode=2&return=/$self->{'module_name'}/&returndesc=".$self->urlize($self->{'text_hash'}->{'index_return'})),
					"</b></center>\n";
				}
			}
	}

	if ($self->{'single'}) {
	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});
		#$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
		}
	else {
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		}

1;
		
}

sub show_buttons
{
	shift if ($self == $_[0]);

if (!$self->{'access_hash'}->{'edonly'}) {
	$self->{'count'} = 2;
	$self->{'count'}++ if ($self->{'access_hash'}->{'delete'});
	$self->{'count'}++ if ($self->{'access_hash'}->{'buser'});
	$self->{'count'}++ if ($self->{'mysql_version'} >= 5);
	$self->{'pct'} = int(100/$self->{'count'});

	print "<table width=100%> <tr>\n";

	# Add a new table
	print "<form action=table_form.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<td width=$self->{'pct'}% nowrap><input type=submit ",
	      "value='$self->{'text_hash'}->{'dbase_add'}'>\n";
	print $self->{'text_hash'}->{'dbase_fields'},"\n";
	print "<input name=fields size=4 value='4'></td>\n";
	print "</form>\n";
	$self->{'form'}++;

	# Add a new view
	if ($self->supports_views() && $self->{'access_hash'}->{'views'}) {
		print "<form action=edit_view.cgi>\n";
		print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
		print "<input type=hidden name=new value=1>\n";
		print "<td align=middle width=$self->{'pct'}%><input type=submit ",
		      "value='$self->{'text_hash'}->{'dbase_addview'}'></td></form>\n";
		$self->{'form'}++;
		}

	if ($self->{'access_hash'}->{'delete'}) {
		print "<form action=drop_dbase.cgi>\n";
		print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
		print "<td align=middle width=$self->{'pct'}%><input type=submit ",
		      "value='$self->{'text_hash'}->{'dbase_drop'}'></td></form>\n";
		$self->{'form'}++;
		}

	if ($self->{'access_hash'}->{'buser'}) {
		print "<form action=backup_form.cgi>\n";
		print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
		print "<td align=middle width=$self->{'pct'}%><input type=submit ",
		      "value='$self->{'text_hash'}->{'dbase_backup'}'></td></form>\n";
		$self->{'form'}++;
		}

	print "<form action=exec_form.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<td align=right width=$self->{'pct'}%><input type=submit ",
	      "value='$self->{'text_hash'}->{'dbase_exec'}'></td>\n";
	print "</form>\n";
	$self->{'form'}++;
	print "</tr> </table></form>\n";
	}
}


1;

