#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for creating or editing a view

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});

if ($self->{'in_hash'}->{'view'}) {
	# Editing a view
	$self->{'str'} = $self->view_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'view'});
	}
$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'in_hash'}->{'view'} ? $self->{'text_hash'}->{'view_title2'}
				    : $self->{'text_hash'}->{'view_title1'}, "");

print $self->ui_form_start("save_view.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'view'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'view_header1'}, undef, 2);

# View name
print $self->ui_table_row($self->{'text_hash'}->{'view_name'},
		    $self->{'in_hash'}->{'view'} ? "<tt>$self->{'str'}->{'name'}</tt>" :
		    $self->ui_textbox("name", $self->{'str'}->{'name'}, 20));

# Selection query
print $self->ui_table_row($self->{'text_hash'}->{'view_query'},
		    $self->ui_textarea("query", $self->{'str'}->{'query'}, 5, 60, "on"));

# Algorithm
print $self->ui_table_row($self->{'text_hash'}->{'view_algorithm'},
		    $self->ui_select("algorithm", $self->{'str'}->{'algorithm'},
			       [ [ "undefined", $self->{'text_hash'}->{'view_undefined'} ],
				 [ "merge", $self->{'text_hash'}->{'view_merge'} ],
				 [ "temptable", $self->{'text_hash'}->{'view_temptable'} ] ]));

# Definer
print $self->ui_table_row($self->{'text_hash'}->{'view_definer'},
	$self->{'in_hash'}->{'view'} ? $self->ui_textbox("definer", $self->{'str'}->{'definer'}, 30)
		    : $self->ui_opt_textbox("definer", undef, 20, $self->{'text_hash'}->{'default'}));

# Security level
print $self->ui_table_row($self->{'text_hash'}->{'view_security'},
		    $self->ui_radio("security", $self->{'str'}->{'security'},
			     [ $self->{'in_hash'}->{'view'} ? ( ) : ( [ "", $self->{'text_hash'}->{'default'} ] ),
			       [ "definer", $self->{'text_hash'}->{'view_sdefiner'} ],
			       [ "invoker", $self->{'text_hash'}->{'view_sinvoker'} ] ]));

# Check option
print $self->ui_table_row($self->{'text_hash'}->{'view_check'},
		    $self->ui_radio("check", $self->{'str'}->{'check'},
			     [ [ "", $self->{'text_hash'}->{'view_nocheck'} ],
			       [ "cascaded", $self->{'text_hash'}->{'view_cascaded'} ],
			       [ "local", $self->{'text_hash'}->{'view_local'} ] ]));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'view'}) {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

