#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_cprivs.cgi
# Display a list of column priviliges

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'cprivs_title'}, "", "cprivs");

$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from columns_priv order by table_name,column_name");
if (@{$self->{'d'}->{'data'}}) {
	print $self->ui_form_start("delete_cprivs.cgi", "post");
	@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d", 0),
		      $self->select_invert_link("d", 0) );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'cprivs_field'},
				  $self->{'text_hash'}->{'cprivs_table'},
				  $self->{'text_hash'}->{'cprivs_db'},
				  $self->{'text_hash'}->{'cprivs_host'},
				  $self->{'text_hash'}->{'cprivs_user'},
				  $self->{'text_hash'}->{'cprivs_privs'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'i'} = -1;
	foreach $u (@{$self->{'d'}->{'data'}}) {
		$self->{'i'}++;
		next if ($self->{'access_hash'}->{'perms'} == 2 && !$self->can_edit_db($u->[1]));
		local @cols;
		push(@cols, "<a href='edit_cpriv.cgi?idx=$self->{'i'}'>".
			    $self->html_escape($u->[4])."</a>");
		push(@cols, $self->html_escape($u->[3]));
		push(@cols, $self->html_escape($u->[1]));
		push(@cols, $u->[0] eq '' || $u->[0] eq '%' ?
		      $self->{'text_hash'}->{'cprivs_all'} : $self->html_escape($u->[0]));
		push(@cols, $u->[2] ? $self->html_escape($u->[2])
				     : $self->{'text_hash'}->{'cprivs_anon'});
		push(@cols, !$u->[6] ? $self->{'text_hash'}->{'cprivs_none'} :
		     join("&nbsp;| ",split(/[, ]+/, $u->[6])));
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, 
					      "d", join(" ", @$u[0..4]));
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'users_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'cprivs_norows'}</b><p>\n";
	}
&show_button();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub show_button
{
	shift if ($self == $_[0]);

print "<form action=edit_cpriv.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'cprivs_add'}'>\n";
print "<input type=hidden name=new value=1>\n";
print "<select name=table>\n";
foreach $d ($self->list_databases()) {
	if ($self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($d)) {
		foreach $t ($self->list_tables($d)) {
			print "<option>$d.$t\n";
			}
		}
	}
print "</select></form>\n";
}


1;

