#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show currently connected MySQL users

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'procs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'procs_title'}, "", "procs");

# Get the processes, except this one
$self->{'d'} = $self->execute_sql($self->{'master_db'}, "show full processlist");
@{$self->{'procs_array'}} = grep { $_->[7] ne "show full processlist" ||
		$_->[3] ne $self->{'master_db'} ||
		$_->[1] ne $self->{'mysql_login'} } @{$self->{'d'}->{'data'}};

if (@{$self->{'procs_array'}}) {
	print $self->ui_form_start("kill_procs.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5" );
	@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d"),
		      $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'procs_id'},
				  $self->{'text_hash'}->{'procs_user'},
				  $self->{'text_hash'}->{'procs_host'},
				  $self->{'text_hash'}->{'procs_db'},
				  $self->{'text_hash'}->{'procs_cmd'},
				  $self->{'text_hash'}->{'procs_time'},
				  $self->{'text_hash'}->{'procs_query'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $r (@{$self->{'procs_array'}}) {
		print $self->ui_checked_columns_row([
			$r->[0],
			"<a href='edit_user.cgi?user=$r->[1]'>$r->[1]</a>",
			$r->[2],
			"<a href='edit_dbase.cgi?db=$r->[3]'>$r->[3]</a>",
			$r->[4],
			&nice_time($r->[5]),
			$self->html_escape($r->[7])
			], \@{$self->{'tds_array'}}, "d", $r->[0]);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	print $self->ui_form_end([ [ "kill", $self->{'text_hash'}->{'procs_kill'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'procs_none'}</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub nice_time
{
	shift if ($self == $_[0]);

local ($s) = @_;
return sprintf "%2.2d:%2.2d:%2.2d",
	int($s / 3600), int($s / 60)%60, $s % 60;
}


1;

