#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_users.cgi
# Display a list of all database users

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'perms_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'users_title'}, "", "users");

print $self->ui_form_start("delete_users.cgi");
@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d", 0),
	      $self->select_invert_link("d", 0),
	      "<a href='edit_user.cgi?new=1'>$self->{'text_hash'}->{'users_add'}</a>" );
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
@{$self->{'tds_array'}} = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'users_user'},
			  $self->{'text_hash'}->{'users_host'},
			  $self->{'text_hash'}->{'users_pass'},
			  $self->{'text_hash'}->{'users_perms'} ], 100, 0, \@{$self->{'tds_array'}});
$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from user order by user");
$i = 0;
foreach $u (@{$self->{'d'}->{'data'}}) {
	local @cols;
	push(@cols, "<a href='edit_user.cgi?idx=$i'>".
		    ($u->[1] ? $self->html_escape($u->[1]) : $self->{'text_hash'}->{'users_anon'}).
		    "</a>");
	push(@cols, $u->[0] eq '' || $u->[0] eq '%' ?
		      $self->{'text_hash'}->{'user_any'} : $self->html_escape($u->[0]));
	push(@cols, $self->html_escape($u->[2]));
	local @priv;
	for($j=3; $j<=$self->user_priv_cols()+3-1; $j++) {
		push(@priv, $self->{'text_hash'}->{"users_priv$j"}) if ($u->[$j] eq 'Y');
		}
	push(@cols,
		scalar(@priv) == $self->user_priv_cols() ? $self->{'text_hash'}->{'users_all'} :
		!@priv ? $self->{'text_hash'}->{'users_none'} : join("&nbsp;| ", @priv));
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $u->[0]." ".$u->[1]);
	$i++;
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'users_delete'} ] ]);

print "<hr>\n";
print "<form action=save_sync.cgi>\n";
print "$self->{'text_hash'}->{'users_sync'}<p>\n";
print "<table><tr><td valign=top>\n";
printf "<input type=checkbox name=sync_create value=1 %s> %s<br>\n",
	$self->{'config_hash'}->{'sync_create'} ? "checked" : "", $self->{'text_hash'}->{'users_sync_create'};
printf "<input type=checkbox name=sync_modify value=1 %s> %s<br>\n",
	$self->{'config_hash'}->{'sync_modify'} ? "checked" : "", $self->{'text_hash'}->{'users_sync_modify'};
printf "<input type=checkbox name=sync_delete value=1 %s> %s<br>\n",
	$self->{'config_hash'}->{'sync_delete'} ? "checked" : "", $self->{'text_hash'}->{'users_sync_delete'};

map { $self->{'priv_hash'}->{$_}++ } split(/\s+/, $self->{'config_hash'}->{'sync_privs'});
print "</td><td><select name=sync_privs multiple size=5>\n";
for($i=3; $i<=$self->user_priv_cols()+3-1; $i++) {
	printf "<option value=%d %s>%s\n",
		$i, $self->{'priv_hash'}->{$i} ? 'selected' : '',
		$self->{'text_hash'}->{"user_priv$i"};
	}
print "</select></td> </tr>\n";
print "<tr> <td colspan=2>$self->{'text_hash'}->{'users_sync_host'}\n";
printf "<input type=radio name=host_def value=1 %s> %s\n",
	$self->{'config_hash'}->{'sync_host'} ? "" : "checked", $self->{'text_hash'}->{'users_sync_def'};
printf "<input type=radio name=host_def value=0 %s> %s\n",
	$self->{'config_hash'}->{'sync_host'} ? "checked" : "", $self->{'text_hash'}->{'users_sync_sel'};
printf "<input name=host size=30 value='%s'></td> </tr>\n",
	$self->{'config_hash'}->{'sync_host'};
print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

