#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of MySQL runtime variables for editing

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'vars_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'vars_title'}, "", "vars");
$self->ReadParse();
%{$self->{'d_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'d'});

# Work out which ones can be edited
%{$self->{'canedit_hash'}} = map { $_->[0], 1 } $self->list_system_variables();

$self->{'d'} = $self->execute_sql($self->{'master_db'}, "show variables");
print $self->ui_form_start("save_vars.cgi");
@{$self->{'tds_array'}} = ( "width=5" );
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'vars_name'},
			  $self->{'text_hash'}->{'vars_value'} ], 100, 0, \@{$self->{'tds_array'}});
foreach $v (@{$self->{'d'}->{'data'}}) {
	if (!$self->{'canedit_hash'}->{$v->[0]}) {
		# Cannot edit, so just show value
		print $self->ui_columns_row([ "", $v->[0], $self->html_escape($v->[1]) ],
				      \@{$self->{'tds_array'}});
		}
	elsif ($self->{'d_hash'}->{$v->[0]}) {
		# Editing now
		print $self->ui_columns_row([
			"->", "<a name=$v->[0]>$v->[0]</a>",
			$self->ui_textbox("value_".$v->[0], $v->[1], 40)
			], \@{$self->{'tds_array'}});
		}
	else {
		# Can edit
		print $self->ui_checked_columns_row([
			"<a name=$v->[0]>$v->[0]</a>",
			$self->html_escape($v->[1])
			], \@{$self->{'tds_array'}}, "d", $v->[0]);
		}
	}
print $self->ui_columns_end();
print $self->ui_form_end([ [ "edit", $self->{'text_hash'}->{'vars_edit'} ],
		     %{$self->{'d_hash'}} ? ( [ "save", $self->{'text_hash'}->{'save'} ] ) : ( ) ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

