#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newdb.cgi
# Create a new database with one optional table

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'newdb_ecannot'});
$self->error_setup($self->{'text_hash'}->{'newdb_err'});

# Make sure maximum databases limit has not been exceeded
@{$self->{'alldbs_array'}} = $self->list_databases();
@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
if ($self->{'access_hash'}->{'create'} == 2 && @{$self->{'titles_array'}} >= $self->{'access_hash'}->{'max'}) {
	$self->error($self->{'text_hash'}->{'newdb_ecannot2'});
	}

$self->{'in_hash'}->{'db'} =~ /^[A-z0-9\.\-\s]+$/ || $self->error($self->{'text_hash'}->{'newdb_edb'});
if (!$self->{'in_hash'}->{'table_def'}) {
	@sql = $self->parse_table_form([ ], $self->{'in_hash'}->{'table'});
	}
$self->execute_sql_logged($self->{'master_db'}, "create database ".$self->quotestr($self->{'in_hash'}->{'db'}).
		    ($self->{'in_hash'}->{'charset'} ? " character set $self->{'in_hash'}->{'charset'}" : ""));
$self->webmin_log("create", "db", $self->{'in_hash'}->{'db'});
if (@sql) {
	foreach $sql (@sql) {
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $sql);
		}
	$self->webmin_log("create", "table", $self->{'in_hash'}->{'table'}, \%{$self->{'in_hash'}});
	}
if ($self->{'access_hash'}->{'dbs'} ne '*') {
	$self->{'access_hash'}->{'dbs'} .= " " if ($self->{'access_hash'}->{'dbs'});
	$self->{'access_hash'}->{'dbs'} .= $self->{'in_hash'}->{'db'};
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
$self->redirect("");

1;
		
}


1;

