#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_tpriv.cgi
# Save, update or delete table permissions

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete some permissions
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->execute_sql_logged($self->{'master_db'},
		"delete from tables_priv where user = '$self->{'in_hash'}->{'olduser'}' ".
		"and host = '$self->{'in_hash'}->{'oldhost'}' and db = '$self->{'in_hash'}->{'olddb'}' ".
		"and table_name = '$self->{'in_hash'}->{'oldtable'}'");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'tpriv_err'});
	$self->{'in_hash'}->{'table'} || $self->error($self->{'text_hash'}->{'tpriv_etable'});
	$self->{'in_hash'}->{'user_def'} || $self->{'in_hash'}->{'user'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'tpriv_euser'});
	$self->{'in_hash'}->{'host_def'} || $self->{'in_hash'}->{'host'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'tpriv_ehost'});
	$self->{'in_hash'}->{'perms1'} =~ s/\0/,/g;
	$self->{'in_hash'}->{'perms2'} =~ s/\0/,/g;

	if ($self->{'in_hash'}->{'db'}) {
		# Create new table permissions
		$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'db'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->{'sql'} = sprintf "insert into tables_priv values ('%s', '%s', ".
			       "'%s', '%s', '%s', NULL, '%s', '%s')",
				$self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
				$self->{'in_hash'}->{'db'},
				$self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
				$self->{'in_hash'}->{'table'}, $self->{'config_hash'}->{'login'},
				$self->{'in_hash'}->{'perms1'}, $self->{'in_hash'}->{'perms2'};
		}
	else {
		# Update existing table permissions
		$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->{'sql'} = sprintf "update tables_priv set host = '%s', ".
			       "user = '%s', table_name = '%s', ".
			       "table_priv = '%s', column_priv = '%s' where ".
			       "host = '%s' and db = '%s' and user = '%s' ".
			       "and table_name = '%s'",
				$self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
				$self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
				$self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'perms1'}, $self->{'in_hash'}->{'perms2'},
				$self->{'in_hash'}->{'oldhost'}, $self->{'in_hash'}->{'olddb'},
				$self->{'in_hash'}->{'olduser'}, $self->{'in_hash'}->{'oldtable'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $self->{'sql'});
	}
$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "tpriv", $self->{'in_hash'}->{'oldtable'},
		    { 'user' => $self->{'in_hash'}->{'olduser'}, 'host' => $self->{'in_hash'}->{'oldhost'},
		      'db' => $self->{'in_hash'}->{'olddb'}, 'table' => $self->{'in_hash'}->{'oldtable'} } );
	}
elsif ($self->{'in_hash'}->{'db'}) {
	$self->webmin_log("create", "tpriv", $self->{'in_hash'}->{'table'},
		    { 'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
		      'db' => $self->{'in_hash'}->{'db'}, 'table' => $self->{'in_hash'}->{'table'} } );
	}
else {
	$self->webmin_log("modify", "tpriv", $self->{'in_hash'}->{'table'},
		    { 'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
		      'db' => $self->{'in_hash'}->{'db'}, 'table' => $self->{'in_hash'}->{'table'} } );
	}
$self->redirect("list_tprivs.cgi");

1;
		
}


1;

