#!/usr/bin/perl

&MAIN();

 sub MAIN {
# table_form.cgi
# Display a form for creating a table

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'table_title2'}, "", "table_form");

print $self->ui_form_start("create_table.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'table_header2'}, undef, 2);

print $self->ui_table_row($self->{'text_hash'}->{'table_name'},
		    $self->ui_textbox("name", undef, 30));

foreach $d ($self->list_databases()) {
	next if (!$self->can_edit_db($d));
	foreach $t ($self->list_tables($d, 1)) {
		push(@{$self->{'tables_array'}}, [ "$d.$t" ]);
		}
	}
print $self->ui_table_row($self->{'text_hash'}->{'table_copy'},
		    $self->ui_select("copy", undef,
			       [ [ "", $self->{'text_hash'}->{'table_copynone'} ],
				 @{$self->{'tables_array'}} ]));

print $self->ui_table_row($self->{'text_hash'}->{'table_type'},
		    $self->ui_select("type", "",
			[ [ "", $self->{'text_hash'}->{'default'} ], [ "isam" ], [ "myisam" ],
			  [ "heap" ], [ "merge" ], [ "innodb" ] ]));

print "<tr> <td colspan=2>";
$self->show_table_form($self->{'in_hash'}->{"fields"} || 4);
print "</td> </tr>\n";

print $self->ui_table_end();
print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

