#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_aifc.cgi
# Edit or create an active interface

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;


$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'aifc_create'}, "");
	$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
	}
else {
	@{$self->{'act_array'}} = $self->active_interfaces();
	$self->{'a'} = $self->{'act_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'aifc_edit'}, "");
	}

print "<form action=save_aifc.cgi>\n";
print "<input type=hidden name=new value=\"$self->{'in_hash'}->{'new'}\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",
      $self->{'in_hash'}->{'virtual'} || $self->{'a'} && $self->{'a'}->{'virtual'} ne "" ? $self->{'text_hash'}->{'aifc_desc2'}
						    : $self->{'text_hash'}->{'aifc_desc1'},
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_name'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'new'} && $self->{'in_hash'}->{'virtual'}) {
	print "<input type=hidden name=name value=$self->{'in_hash'}->{'virtual'}>\n";
	print "$self->{'in_hash'}->{'virtual'}:<input name=virtual size=3>\n";
	}
elsif ($self->{'in_hash'}->{'new'}) {
	print "<input name=name size=6>\n";
	}
else {
	print "<font size=+1><tt>$self->{'a'}->{'fullname'}</tt></font>\n";
	}
print "</td>\n";

print "<td><b>$self->{'text_hash'}->{'ifcs_ip'}</b></td>\n";
printf "<td><input name=address size=15 value=\"%s\"></td> </tr>\n",
	$self->{'a'} ? $self->{'a'}->{'address'} : "";

# Show netmask
print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_mask'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'virtual'} && $self->{'in_hash'}->{'new'} && $self->{'virtual_netmask'}) {
	# Virtual netmask cannot be edited
	print "$self->{'virtual_netmask'}\n";
	}
elsif (!$self->{'access_hash'}->{'netmask'}) {
	print $self->{'a'} ? $self->{'a'}->{'netmask'} : $self->{'config_hash'}->{'def_netmask'};
	}
else {
	print $self->ui_opt_textbox("netmask", $self->{'a'} ? $self->{'a'}->{'netmask'}
					    : $self->{'config_hash'}->{'def_netmask'}, 15,
			      $self->{'text_hash'}->{'ifcs_auto'});
	}
print "</td>\n";

# Show broadcast address
print "<td><b>$self->{'text_hash'}->{'ifcs_broad'}</b></td> <td>\n";
if (!$self->{'access_hash'}->{'broadcast'}) {
	print $self->{'a'} ? $self->{'a'}->{'broadcast'} :
	      $self->{'config_hash'}->{'def_broadcast'} ? $self->{'config_hash'}->{'def_broadcast'} :
					 $self->{'text_hash'}->{'ifcs_auto'};
	}
else {
	print $self->ui_opt_textbox("broadcast", $self->{'a'} ? $self->{'a'}->{'broadcast'}
					      : $self->{'config_hash'}->{'def_broadcast'}, 15,
			      $self->{'text_hash'}->{'ifcs_auto'});
	}
print "</td> </tr>\n";

# Show MTU
print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_mtu'}</b></td> <td>\n";
if (!$self->{'access_hash'}->{'mtu'}) {
	print $self->{'a'} ? $self->{'a'}->{'mtu'} :
	      $self->{'config_hash'}->{'def_mtu'} ? $self->{'config_hash'}->{'def_mtu'} : $self->{'text_hash'}->{'default'};
	}
else {
	print $self->ui_opt_textbox("mtu", $self->{'a'} ? $self->{'a'}->{'mtu'}
					: $self->{'config_hash'}->{'def_mtu'}, 15,
			      $self->{'text_hash'}->{'ifcs_auto'});
	}
print "</td>\n";

print "<td><b>$self->{'text_hash'}->{'ifcs_status'}</b></td> <td>\n";
if (!$self->{'access_hash'}->{'up'}) {
	print !$self->{'a'} ? $self->{'text_hash'}->{'ifcs_up'} :
		$self->{'a'}->{'up'} ? $self->{'text_hash'}->{'ifcs_up'} : $self->{'text_hash'}->{'ifcs_down'};
	}
else {
	print $self->ui_radio("up", !$self->{'a'} || $self->{'a'}->{'up'} ? 1 : 0,
			[ [ 1, $self->{'text_hash'}->{'ifcs_up'} ], [ 0, $self->{'text_hash'}->{'ifcs_down'} ] ]);
	}
print "</td> </tr>\n";

if ((!$self->{'a'} && $self->{'in_hash'}->{'virtual'} eq "") ||
    ($self->{'a'} && $self->{'a'}->{'virtual'} eq "" && $self->iface_hardware($self->{'a'}->{'name'}))) {
	print "<tr> <td><b>$self->{'text_hash'}->{'aifc_hard'}</b></td> <td>\n";
	if ($self->{'in_hash'}->{'new'}) {
		printf "<input type=radio name=ether_def value=1 %s> %s\n",
			$self->{'a'} ? "" : "checked", $self->{'text_hash'}->{'aifc_default'};
		printf "<input type=radio name=ether_def value=0 %s>\n",
			$self->{'a'} ? "checked" : "";
		}
	printf "<input name=ether size=18 value=\"%s\"></td>\n",
		$self->{'a'} ? $self->{'a'}->{'ether'} : "";
	}
else {
	print "<tr> <td colspan=2></td>\n";
	}
if ($self->{'a'} && $self->{'a'}->{'virtual'} eq "") {
	print "<td><b>$self->{'text_hash'}->{'ifcs_virts'}</b></td>\n";
	$self->{'vcount'} = 0;
	foreach $va (@{$self->{'act_array'}}) {
		if ($va->{'virtual'} ne "" && $va->{'name'} eq $self->{'a'}->{'name'}) {
			$self->{'vcount'}++;
			}
		}
	print "<td>$self->{'vcount'}\n";
	print "(<a href='edit_aifc.cgi?new=1&virtual=$self->{'a'}->{'name'}'>",
	      "$self->{'text_hash'}->{'ifcs_addvirt'}</a>)</td>\n";
	}
print "</tr>\n";
     
print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td>\n";
	}
else {
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
	if ($self->{'access_hash'}->{'delete'}) {
		print "<td align=right><input type=submit name=delete ",
		      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
		}
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_ifcs.cgi", $self->{'text_hash'}->{'ifcs_return'});

1;
		
}


1;

