#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_bifc.cgi
# Edit or create a bootup interface

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'bifc_create'}, "");
	$self->can_create_iface() || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
	}
else {
	@{$self->{'boot_array'}} = $self->boot_interfaces();
	$self->{'b'} = $self->{'boot_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'bifc_edit'}, "");
	}

print "<form action=save_bifc.cgi>\n";
print "<input type=hidden name=new value=\"$self->{'in_hash'}->{'new'}\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",
      $self->{'in_hash'}->{'virtual'} || $self->{'b'} && $self->{'b'}->{'virtual'} ne "" ? $self->{'text_hash'}->{'bifc_desc2'}
						    : $self->{'text_hash'}->{'bifc_desc1'},
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_name'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'new'} && $self->{'in_hash'}->{'virtual'}) {
	print "<input type=hidden name=name value=$self->{'in_hash'}->{'virtual'}>\n";
	print "$self->{'in_hash'}->{'virtual'}:<input name=virtual size=3>\n";
	}
elsif ($self->{'in_hash'}->{'new'}) {
	print "<input name=name size=6>\n";
	}
else {
	print "<font size=+1><tt>$self->{'b'}->{'fullname'}</tt></font>\n";
	}
print "</td>\n";

print "<td><b>$self->{'text_hash'}->{'ifcs_ip'}</b></td> <td>\n";
$self->{'virtual'} = (!$self->{'b'} && $self->{'in_hash'}->{'virtual'}) || ($self->{'b'} && $self->{'b'}->{'virtual'} ne "");
$self->{'dhcp'} = $self->can_edit("dhcp") && !$self->{'virtual'};
$self->{'bootp'} = $self->can_edit("bootp") && !$self->{'virtual'};
if ($self->{'dhcp'}) {
	printf "<input type=radio name=mode value=dhcp %s> %s\n",
		$self->{'b'} && $self->{'b'}->{'dhcp'} ? "checked" : "", $self->{'text_hash'}->{'ifcs_dhcp'};
	}
if ($self->{'bootp'}) {
	printf "<input type=radio name=mode value=bootp %s> %s\n",
		$self->{'b'} && $self->{'b'}->{'bootp'} ? "checked" : "", $self->{'text_hash'}->{'ifcs_bootp'};
	}
if ($self->{'dhcp'} || $self->{'bootp'}) {
	printf "<input type=radio name=mode value=address %s> %s\n",
		!$self->{'b'} || (!$self->{'b'}->{'bootp'} && !$self->{'b'}->{'dhcp'}) ? "checked" : "",
		$self->{'text_hash'}->{'ifcs_static'};
	}
else {
	print "<input type=hidden name=mode value=address>\n";
	}
printf "<input name=address size=15 value=\"%s\"></td> </tr>\n",
	$self->{'b'} && !$self->{'b'}->{'bootp'} && !$self->{'b'}->{'dhcp'} ? $self->{'b'}->{'address'} : "";

print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_mask'}</b></td>\n";
if ($self->{'in_hash'}->{'virtual'} && $self->{'in_hash'}->{'new'} && $self->{'virtual_netmask'}) {
	# Virtual netmask cannot be edited
	print "<td>$self->{'virtual_netmask'}</td>\n";
	}
elsif ($self->can_edit("netmask", $self->{'b'}) && $self->{'access_hash'}->{'netmask'}) {
	printf "<td><input name=netmask size=15 value='%s'></td>\n",
		$self->{'b'} ? $self->{'b'}->{'netmask'} : $self->{'config_hash'}->{'def_netmask'};
	}
else {
	printf "<td>%s</td>\n", $self->{'b'} ? $self->{'b'}->{'netmask'} : $self->{'text_hash'}->{'ifcs_auto'};
	}

print "<td><b>$self->{'text_hash'}->{'ifcs_broad'}</b></td>\n";
if ($self->can_edit("broadcast", $self->{'b'}) && $self->{'access_hash'}->{'broadcast'}) {
	printf "<td><input name=broadcast size=15 value='%s'></td>\n",
		$self->{'b'} ? $self->{'b'}->{'broadcast'} : $self->{'config_hash'}->{'def_broadcast'};
	}
else {
	printf "<td>%s</td> </tr>\n", $self->{'b'} ? $self->{'b'}->{'broadcast'}
					 : $self->{'text_hash'}->{'ifcs_auto'};
	}

print "<tr> <td><b>$self->{'text_hash'}->{'ifcs_mtu'}</b></td>\n";
if ($self->can_edit("mtu", $self->{'b'}) && $self->{'access_hash'}->{'mtu'}) {
	printf "<td><input name=mtu size=15 value='%s'></td>\n",
		$self->{'b'} ? $self->{'b'}->{'mtu'} : $self->{'config_hash'}->{'def_mtu'};
	}
else {
	printf "<td>%s</td>\n", $self->{'b'} && $self->{'b'}->{'mtu'} ? $self->{'b'}->{'mtu'}
						  : $self->{'text_hash'}->{'ifcs_auto'};
	}

print "<td><b>$self->{'text_hash'}->{'ifcs_act'}</b></td>\n";
if ($self->can_edit("up", $self->{'b'}) && $self->{'access_hash'}->{'up'}) {
	printf "<td><input type=radio name=up value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		!$self->{'b'} || $self->{'b'}->{'up'} ? "checked" : "";
	printf "<input type=radio name=up value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$self->{'b'} && !$self->{'b'}->{'up'} ? "checked" : "";
	}
else {
	printf "<td>%s</td> </tr>\n",
		!$self->{'b'} ? $self->{'text_hash'}->{'yes'} :
		$self->{'b'}->{'up'} ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'};
	}

print "<tr> <td colspan=2></td>\n";
if ($self->{'b'} && $self->{'b'}->{'virtual'} eq "") {
	print "<td><b>$self->{'text_hash'}->{'ifcs_virts'}</b></td>\n";
	$self->{'vcount'} = 0;
	foreach $vb (@{$self->{'boot_array'}}) {
		if ($vb->{'virtual'} ne "" && $vb->{'name'} eq $self->{'b'}->{'name'}) {
			$self->{'vcount'}++;
			}
		}
	print "<td>$self->{'vcount'}\n";
	if ($self->{'access_hash'}->{'virt'} && !$self->{'noos_support_add_virtifcs'}) {
		print "(<a href='edit_bifc.cgi?new=1&virtual=$self->{'b'}->{'name'}'>",
		      "$self->{'text_hash'}->{'ifcs_addvirt'}</a>)\n";
		}
	print "</td>\n";
	}
print "</tr>\n";
     
print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'access_hash'}->{'bootonly'}) {
	# Can only save both boot-time and active
	if ($self->{'in_hash'}->{'new'}) {
		print "<td><input type=submit ",
		      "name=activate value=\"$self->{'text_hash'}->{'bifc_capply'}\"></td>\n";
		}
	else {
		print "<td><input type=submit ",
		      "name=activate value=\"$self->{'text_hash'}->{'bifc_apply'}\"></td>\n";
		if ($self->{'access_hash'}->{'delete'}) {
			print "<td align=right><input type=submit ",
			      "name=unapply value=\"$self->{'text_hash'}->{'bifc_dapply'}\"></td>\n";
			}
		}
	}
else {
	# Show buttons to save both boot-time and/or active
	if ($self->{'in_hash'}->{'new'}) {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td>\n";
		print "<td align=right><input type=submit ",
		      "name=activate value=\"$self->{'text_hash'}->{'bifc_capply'}\"></td>\n";
		}
	else {
		print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n"
			unless $self->{'always_apply_ifcs'};
		if (!($self->{'b'}->{'bootp'} || $self->{'b'}->{'dhcp'}) || $self->UNIVERSAL::can('apply_interface')) {
			print "<td align=center><input type=submit ",
			      "name=activate value=\"$self->{'text_hash'}->{'bifc_apply'}\"></td>\n";
			}
		if ($self->{'access_hash'}->{'delete'}) {
			print "<td align=center><input type=submit ",
			      "name=unapply value=\"$self->{'text_hash'}->{'bifc_dapply'}\"></td>\n";
			print "<td align=right><input type=submit name=delete ",
			      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n"
				unless $self->{'noos_support_delete_ifcs'};
			}
		}
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_ifcs.cgi", $self->{'text_hash'}->{'ifcs_return'});

1;
		
}


1;

