#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a menu of various network screens

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("ifconfig hosts resolve.conf nsswitch.conf", "man"));

foreach $i ('ifcs', 'routes', 'dns', 'hosts',
	    ($self->{'config_hash'}->{'ipnodes_file'} ? ('ipnodes') : ( ))) {
	next if (!$self->{'access_hash'}->{$i});
	next if ($i eq "ifcs" && $self->running_in_zone());

	push(@{$self->{'links_array'}}, "list_${i}.cgi");
	push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{"${i}_title"});
	push(@{$self->{'icons_array'}}, "images/${i}.gif");
	}
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, @{$self->{'icons_array'}} > 4 ? scalar(@{$self->{'icons_array'}}) : 4);

if ($self->UNIVERSAL::can('apply_network') && $self->{'access_hash'}->{'apply'} && !$self->running_in_zone()) {
	# Allow the user to apply the network config
	print "<hr>\n";
	print "<form action=apply.cgi>\n";
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'index_apply'}'></td>\n";
	print "<td>$self->{'text_hash'}->{'index_applydesc'}</td>\n";
	print "</tr></table></form>\n";
	}
$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

