#!/usr/bin/perl

&MAIN();

 sub MAIN {
# interface_chooser.cgi
#
# Based on user_chooser.cgi by Jamie Cameron
# (c) Tomas Pospisek <tpo_deb@sourcepole.ch>
# Licensed under the webmin license
#
# made possible by: 
# 	Sourcepole          http://sourcepole.ch
# under contract from:
# 	AO Media Services   http://www.ao-asif.ch/aoi/media/
# Thanks!
# 
# TODO:
# replace active_interfaces by a merged list from active_* and boot_interfaces
# 
# This CGI generated the HTML for choosing an interface or a list of interfaces.

#require './../web-lib.pl';
&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->init_config();
$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();

if ($self->{'in_hash'}->{'multi'}) {
	# selecting multiple interfaces.
	if ($self->{'in_hash'}->{'frame'} == 0) {
		# base frame
		$self->PrintHeader();
		print "<script>\n";
		@{$self->{'il_array'}} = split(/\s+/, $self->{'in_hash'}->{'interface'});
		$self->{'len'} = @{$self->{'il_array'}};
		print "sel = new Array($self->{'len'});\n";
		for($i=0; $i<$self->{'len'}; $i++) {
			print "sel[$i] = \"$self->{'il_array'}->[$i]\";\n";
			}
		print "</script>\n";
		print "<title>$self->{'text_hash'}->{'interfaces_title1'}</title>\n";
		print "<frameset cols='50%,50%'>\n";
		print "<frame src=\"/net/interface_chooser.cgi?frame=1&multi=1\">\n";
		print "<frameset rows='*,50' frameborder=no>\n";
		print " <frame src=\"/net/interface_chooser.cgi?frame=2&multi=1\">\n";
		print " <frame src=\"/net/interface_chooser.cgi?frame=3&multi=1\" scrolling=no>\n";
		print "</frameset>\n";
		print "</frameset>\n";
		}
	elsif ($self->{'in_hash'}->{'frame'} == 1) {
		# list of all interfaces to choose from
		$self->ui_print_header(undef, );
		print "<script>\n";
		print "function addinterface(i)\n";
		print "{\n";
		print "top.sel[top.sel.length] = i\n";
		print "top.frames[1].location = top.frames[1].location\n";
		print "return false;\n";
		print "}\n";
		print "</script>\n";
		print "<font size=+1>$self->{'text_hash'}->{'interfaces_all'}</font>\n";
		print "<table width=100%>\n";
		foreach $if ($self->active_interfaces()) {
			if ($self->{'in_hash'}->{'interface'} eq $if->{'fullname'}) { print "<tr $self->{'cb'}>\n"; }
			else { print "<tr>\n"; }
			print "<td width=20%><a href=\"\" onClick='return addinterface(\"$if->{'fullname'}\")'>$if->{'fullname'}</a></td>\n";
			}
		print "</table>\n";
		}
	elsif ($self->{'in_hash'}->{'frame'} == 2) {
		# show chosen interfaces
		$self->ui_print_header(undef, );
		print "<font size=+1>$self->{'text_hash'}->{'interfaces_sel'}</font>\n";
		print <<'EOF';
<table width=100%>
<script>
function sub(j)
{
  sel2 = new Array();
  for(k=0,l=0; k<top.sel.length; k++) {
	if (k != j) {
		sel2[l] = top.sel[k];
		l++;
		}
	}
  top.sel = sel2;
  top.frames[1].location = top.frames[1].location;
  return false;
}
for(i=0; i<top.sel.length; i++) {
	document.write("<tr>\n");
	document.write("<td><a href=\"\" onClick='return sub("+i+")'>"+top.sel[i]+"</a></td>\n");
	}
</script>
</table>
EOF
		}
	elsif ($self->{'in_hash'}->{'frame'} == 3) {
		# output OK and Cancel buttons
		$self->ui_print_header(undef, );
		print "<form>\n";
		print "<input type=button value=\"$self->{'text_hash'}->{'interfaces_ok'}\" ",
		      "onClick='top.ifield.value = top.sel.join(\" \"); ",
		      "top.close()'>\n";
		print "<input type=button value=\"$self->{'text_hash'}->{'interfaces_cancel'}\" ",
		      "onClick='top.close()'>\n";
		print "&nbsp;&nbsp;<input type=button value=\"$self->{'text_hash'}->{'interfaces_clear'}\" onClick='top.sel = new Array(); top.selr = new Array(); top.frames[1].location = top.frames[1].location'>\n";
		print "</form>\n";
		}
	}
else {
	# selecting just one interface .. display a list of all interfaces to choose from
	$self->ui_print_header(undef, );
	print "<script>\n";
	print "function select(f)\n";
	print "{\n";
	print "ifield.value = f;\n";
	print "top.close();\n";
	print "return false;\n";
	print "}\n";
	print "</script>\n";
	print "<title>$self->{'text_hash'}->{'interfaces_title2'}</title>\n";
	print "<table width=100%>\n";
	foreach $if ($self->active_interfaces()) {
		if ($self->{'in_hash'}->{'interface'} eq $if->{'fullname'}) { print "<tr $self->{'cb'}>\n"; }
		else { print "<tr>\n"; }
		print "<td width=20%><a href=\"\" onClick='return select(\"$if->{'fullname'}\")'>$if->{'fullname'}</a></td></tr>\n";
		}
	print "</table>\n";
	}

1;
		
}


1;

