#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_host.cgi
# Create, update or delete a host address

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'hosts'} == 2 || $self->error($self->{'text_hash'}->{'hosts_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'hosts_file'});
@{$self->{'hosts_array'}} = $self->list_hosts();
if ($self->{'in_hash'}->{'delete'}) {
	# deleting a host
	$self->{'host'} = $self->{'hosts_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_host($self->{'host'});
	}
else {
	# saving or updating a host
	$self->{'whatfailed'} = "Failed to save host";
	$self->check_ipaddress($self->{'in_hash'}->{'address'}) ||
		$self->error("'$self->{'in_hash'}->{'address'}' is not a valid IP address");
	@h = split(/\s+/, $self->{'in_hash'}->{'hosts'});
	foreach $h (@h) {
		$h =~ /^[A-z0-9\-\.]+$/ ||
			$self->error("'$h' is not a valid hostname");
		}
	@h>0 || $self->error("You must enter at least one hostname");
	if ($self->{'in_hash'}->{'new'}) {
		# saving a host
		$self->{'host'} = { 'address' => $self->{'in_hash'}->{'address'},
			  'hosts' => \@h };
		$self->create_host($self->{'host'});
		}
	else {
		# updating a host
		$self->{'host'} = $self->{'hosts_array'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'host'}->{'address'} = $self->{'in_hash'}->{'address'};
		$self->{'host'}->{'hosts'} = \@h;
		$self->modify_host($self->{'host'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'hosts_file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'host', $self->{'host'}->{'address'}, $self->{'host'});
$self->redirect("list_hosts.cgi");

1;
		
}


1;

