#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ipnode.cgi
# Create, update or delete a ipnode address

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'ipnodes'} == 2 || $self->error($self->{'text_hash'}->{'ipnodes_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'ipnodes_file'});
@{$self->{'ipnodes_array'}} = $self->list_ipnodes();
if ($self->{'in_hash'}->{'delete'}) {
	# deleting a ipnode
	$self->{'ipnode'} = $self->{'ipnodes_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_ipnode($self->{'ipnode'});
	}
else {
	# saving or updating a ipnode
	$self->{'whatfailed'} = "Failed to save ipnode";
	$self->check_ipaddress($self->{'in_hash'}->{'address'}) ||
	   $self->check_ip6address($self->{'in_hash'}->{'address'}) ||
		$self->error("'$self->{'in_hash'}->{'address'}' is not a valid IPv4 or v6 address");
	@h = split(/\s+/, $self->{'in_hash'}->{'ipnodes'});
	foreach $h (@h) {
		$h =~ /^[A-z0-9\-\.]+$/ ||
			$self->error("'$h' is not a valid ipnodename");
		}
	@h>0 || $self->error("You must enter at least one ipnodename");
	if ($self->{'in_hash'}->{'new'}) {
		# saving a ipnode
		$self->{'ipnode'} = { 'address' => $self->{'in_hash'}->{'address'},
			  'ipnodes' => \@h };
		$self->create_ipnode($self->{'ipnode'});
		}
	else {
		# updating a ipnode
		$self->{'ipnode'} = $self->{'ipnodes_array'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'ipnode'}->{'address'} = $self->{'in_hash'}->{'address'};
		$self->{'ipnode'}->{'ipnodes'} = \@h;
		$self->modify_ipnode($self->{'ipnode'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'ipnodes_file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'ipnode', $self->{'ipnode'}->{'address'}, $self->{'ipnode'});
$self->redirect("list_ipnodes.cgi");

1;
		
}


1;

