#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_range.cgi
# Create, save or delete a boot-time address range

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'ifcs'} == 2 || $self->{'access_hash'}->{'ifcs'} == 3 || $self->error($self->{'text_hash'}->{'ifcs_ecannot'});
$self->ReadParse();
@{$self->{'boot_array'}} = $self->boot_interfaces();

if ($self->{'in_hash'}->{'delete'} || $self->{'in_hash'}->{'unapply'}) {
	# Delete interface
	$self->error_setup($self->{'text_hash'}->{'range_err1'});
	$self->{'b'} = $self->{'boot_array'}->[$self->{'in_hash'}->{'idx'}];
	&check_restricted_interfaces();

	if ($self->{'in_hash'}->{'unapply'}) {
		# Shut down this range
		$self->error_setup($self->{'text_hash'}->{'range_err4'});
		$self->{'err'} = $self->unapply_interface($self->{'act'});
		$self->{'err'} && $self->error("<pre>$self->{'err'}</pre>");
		}
	$self->delete_interface($self->{'b'});
	$self->webmin_log("delete", "range", $self->{'b'}->{'fullname'}, $self->{'b'});
	}
else {
	# Save or create interface
	$self->error_setup($self->{'text_hash'}->{'range_err2'});
	if (!$self->{'in_hash'}->{'new'}) {
		$self->{'b'} = $self->{'boot_array'}->[$self->{'in_hash'}->{'idx'}];
		}
	else {
		$self->{'b'} = { };
		}
	$self->parse_range($self->{'b'}, \%{$self->{'in_hash'}});
	&check_restricted_interfaces();
	$self->save_interface($self->{'b'});

	if ($self->{'in_hash'}->{'activate'}) {
		# Make this interface active (if possible)
		$self->error_setup($self->{'text_hash'}->{'range_err3'});
		$self->{'err'} = $self->apply_interface($self->{'b'});
		$self->{'err'} && $self->error("<pre>$self->{'err'}</pre>");
		}
	$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : 'modify',
		    "range", $self->{'b'}->{'fullname'}, $self->{'b'});
	}
$self->redirect("list_ifcs.cgi");

1;
		
}

sub check_restricted_interfaces() {
	shift if ($self == $_[0]);

       if ($self->{'access_hash'}->{'ifcs'} == 3) {
               map { $self->{'can_interfaces_hash'}->{$_}++ } split(/\s+/, $self->{'access_hash'}->{'interfaces'});
               if (! $self->{'can_interfaces_hash'}->{$self->{'b'}->{'name'}}) {
                       $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
               }
       }
}


1;

