#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_client.cgi
# Display NIS client options

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'client_title'}, "");

if (!($self->get_nis_support() & 1)) {
	print "<p>$self->{'text_hash'}->{'client_enis'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

$self->{'nis'} = $self->get_client_config();

print "<form action=save_client.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'client_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'client_domain'}</b></td>\n";
printf "<td valign=top><input type=radio name=domain_def value=1 %s> %s\n",
	$self->{'nis'}->{'domain'} ? '' : 'checked', $self->{'text_hash'}->{'client_none'};
printf "<input type=radio name=domain_def value=0 %s>\n",
	$self->{'nis'}->{'domain'} ? 'checked' : '';
printf "<input name=domain size=35 value='%s'></td> </tr>\n",
	$self->{'nis'}->{'domain'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'client_servers'}</b></td>\n";
printf "<td><input type=radio name=broadcast value=1 %s> %s\n",
	$self->{'nis'}->{'broadcast'} ? 'checked' : '', $self->{'text_hash'}->{'client_broadcast'};
printf "<input type=radio name=broadcast value=0 %s> %s<br>\n",
	$self->{'nis'}->{'broadcast'} ? '' : 'checked', $self->{'text_hash'}->{'client_listed'};
print "<textarea name=servers rows=3 cols=35>",
      join("\n", $self->unique(@{$self->{'nis'}->{'servers'}})),"</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'client_ok'}'></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

