#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_netgroup.cgi
# Edit a NIS netgroup table entry

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'netgroup_title'}, "");

($self->{'t'}, $self->{'lnums'}, $netgroup) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
print "<form action=save_netgroup.cgi method=post>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=line value='$self->{'in_hash'}->{'line'}'>\n";

print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'netgroup_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'netgroup_name'}</b></td>\n";
print "<td><input name=name size=15 value='$netgroup->[0]'></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'netgroup_members'}</b></td>\n";
print "<td><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'netgroup_host'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'netgroup_user'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'netgroup_domain'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $h (@$netgroup[1 .. @$netgroup-1], "(x,,)", "(x,,)") {
	$h =~ /^\((\S*),(\S*),(\S*)\)$/ || next;
	print "<tr $self->{'cb'}>\n";
	foreach $v (['host',$1],['user',$2],['dom',$3]) {
		printf "<td><input type=radio name=$v->[0]_def_$self->{'i'} value=1 %s>%s\n",
			$v->[1] ? '' : 'checked', $self->{'text_hash'}->{'netgroup_any'};
		printf "<input type=radio name=$v->[0]_def_$self->{'i'} value=2 %s>%s\n",
			$v->[1] eq 'x' ? 'checked' : '', $self->{'text_hash'}->{'netgroup_none'}
			if ($v->[0] eq 'host');
		printf "<input type=radio name=$v->[0]_def_$self->{'i'} value=0 %s>\n",
			$v->[1] && $v->[1] ne 'x' ? 'checked' : '';
		printf "<input name=$v->[0]_$self->{'i'} size=15 value='%s'></td>\n",
			$v->[1] eq "x" ? "" : $v->[1];
		}
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table>\n";
if (defined($self->{'in_hash'}->{'line'})) {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
print "</form>\n";
$self->ui_print_footer("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{'tables_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

