#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_aliases.cgi
# Create, update or delete an alias

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'alias'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '[\s:]+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the alias
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the alias
	$self->error_setup($self->{'text_hash'}->{'aliases_err'});
	$self->{'in_hash'}->{'from'} =~ /^[^:@ ]+$/ || $self->error($self->{'text_hash'}->{'aliases_efrom'});
	@{$self->{'to_array'}} = split(/\s+/, $self->{'in_hash'}->{'to'});
	@{$self->{'to_array'}} || $self->error($self->{'text_hash'}->{'aliases_eto'});
	@{$self->{'alias_array'}} = ( $self->{'in_hash'}->{'from'}, join(",", @{$self->{'to_array'}}) );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, ":", \@{$self->{'alias_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, ":", \@{$self->{'alias_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

