#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_client.cgi
# Save and apply NIS client options

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'client_err'});

# Parse and validate inputs
if (!$self->{'in_hash'}->{'domain_def'}) {
	$self->{'in_hash'}->{'domain'} =~ /^[A-Za-z0-9\.\-]+$/ ||
		$self->error($self->{'text_hash'}->{'client_edomain'});
	$self->{'nis'}->{'domain'} = $self->{'in_hash'}->{'domain'};
	}
if ($self->{'in_hash'}->{'broadcast'}) {
	$self->{'nis'}->{'broadcast'} = 1;
	}
else {
	@{$self->{'servers_array'}} = split(/\s+/, $self->{'in_hash'}->{'servers'});
	foreach $s (@{$self->{'servers_array'}}) {
		gethostbyname($s) || $self->check_ipaddress($s) ||
			$self->error($self->text('client_eserver', $s));
		}
	$self->{'nis'}->{'servers'} = \@{$self->{'servers_array'}};
	}

# Save and apply
$self->{'err'} = $self->save_client_config($self->{'nis'});
if ($self->{'err'}) { $self->error($self->{'err'}); }
$self->redirect("");

1;
		
}


1;

