#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group.cgi
# Create, update or delete a group

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'group'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the group
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the group
	$self->error_setup($self->{'text_hash'}->{'group_err'});
	$self->{'in_hash'}->{'name'} =~ /^[^:\s]+$/ || $self->error($self->{'text_hash'}->{'group_ename'});
	$self->{'in_hash'}->{'gid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'group_egid'});
	$self->{'salt'} = chr(int(rand(26))+65) . chr(int(rand(26))+65);
	@{$self->{'group_array'}} = ( $self->{'in_hash'}->{'name'},
		   $self->{'in_hash'}->{'passmode'} == 0 ? "" :
		   $self->{'in_hash'}->{'passmode'} == 1 ? $self->{'in_hash'}->{'encpass'} :
					  $self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'}),
		   $self->{'in_hash'}->{'gid'},
		   join(",", split(/\s+/, $self->{'in_hash'}->{'members'})) );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, ":", \@{$self->{'group_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, ":", \@{$self->{'group_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

