#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_hosts.cgi
# Create, update or delete a host

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'host'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the host
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the host
	$self->error_setup($self->{'text_hash'}->{'hosts_err'});
	$self->check_ipaddress($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'hosts_eip'});
	$self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'hosts_ename'});
	@{$self->{'host_array'}} = ( $self->{'in_hash'}->{'ip'}, $self->{'in_hash'}->{'name'}, split(/\s+/, $self->{'in_hash'}->{'aliases'}) );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, "\t", \@{$self->{'host_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, "\t", \@{$self->{'host_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

