#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rpc.cgi
# Create, update or delete an rpc program

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'rpc'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the host
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the host
	$self->error_setup($self->{'text_hash'}->{'rpc_err'});
	$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'rpc_ename'});
	$self->{'in_hash'}->{'number'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'rpc_enumber'});
	@{$self->{'rpc_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'number'}, split(/\s+/, $self->{'in_hash'}->{'aliases'}) );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, "\t", \@{$self->{'rpc_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, "\t", \@{$self->{'rpc_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

