#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_security.cgi
# Save NIS server security options

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'security_err'});

# Save trusted servers
if ($self->{'config_hash'}->{'securenets'}) {
	for($i=0; defined($self->{'in_hash'}->{"net_$i"}); $i++) {
		next if ($self->{'in_hash'}->{"def_$i"} == -1);
		if ($self->{'in_hash'}->{"def_$i"} == 0) {
			$self->check_ipaddress($self->{'in_hash'}->{"net_$i"}) ||
				$self->error($self->text('security_enet', $self->{'in_hash'}->{"net_$i"}));
			$self->check_ipaddress($self->{'in_hash'}->{"mask_$i"}) ||
				$self->error($self->text('security_emask', $self->{'in_hash'}->{"mask_$i"}));
			$self->{'mask'} = $self->{'in_hash'}->{"mask_$i"};
			}
		elsif ($self->{'in_hash'}->{"def_$i"} == 1) {
			$self->check_ipaddress($self->{'in_hash'}->{"net_$i"}) ||
				$self->error($self->text('security_enet', $self->{'in_hash'}->{"net_$i"}));
			$self->{'mask'} = "host";
			}
		elsif ($self->{'in_hash'}->{"def_$i"} == 2) {
			$self->{'in_hash'}->{"net_$i"} = "0.0.0.0";
			$self->{'mask'} = "0.0.0.0";
			}
		push(@{$self->{'lines_array'}}, $self->{'mask'}." ".$self->{'in_hash'}->{"net_$i"}."\n");
		}
	$self->open_tempfile(SERVERS, ">$self->{'config_hash'}->{'securenets'}");
	$self->print_tempfile(SERVERS, @{$self->{'lines_array'}});
	$self->close_tempfile(SERVERS);
	}

# Save OS-specific security options
$self->parse_server_security();

$self->redirect("");

1;
		
}


1;

