#!/usr/bin/perl
package pam::Pam_envso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_envso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_env.so

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

local $file = $_[2]->{'conffile'} ? $_[2]->{'conffile'}
				  : "/etc/security/pam_env.conf";
open(FILE, $file);
while(<FILE>) {
	s/#.*$//;
	s/\r|\n//g;
	if (/^\s*(\S+)/) {
		local $var = $1;
		local ($def, $over);
		if (/DEFAULT="([^"]+)"/i || /DEFAULT=(\S+)/i) {
			$def = $1;
			}
		if (/OVERRIDE="([^"]+)"/i || /OVERRIDE=(\S+)/i) {
			$over = $1;
			}
		push(@{$self->{'env_array'}}, [ $var, $def, $over ]);
		}
	}
close(FILE);
print "<tr> <td colspan=4><table width=100% border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'env_var'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'env_def'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'env_over'}</b></td> </tr>\n";
local $i = 0;
foreach $e (@{$self->{'env_array'}}, [ ]) {
	print "<tr> <td><input name=var_$i size=20 value='$e->[0]'></td>\n";
	print "<td><input name=def_$i size=30 value='$e->[1]'></td>\n";
	print "<td><input name=over_$i size=30 value='$e->[2]'></td> </tr>\n";
	$i++;
	}
print "</table></td> </tr>\n";
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

local $file = $_[2]->{'conffile'} ? $_[2]->{'conffile'}
				  : "/etc/security/pam_env.conf";
local ($i, @lines);
for($i=0; defined($self->{'in_hash'}->{"var_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"var_$i"});
	$self->{'in_hash'}->{"var_$i"} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'env_evar'});
	local $line = $self->{'in_hash'}->{"var_$i"};
	$line .= "\tDEFAULT=\"".$self->{'in_hash'}->{"def_$i"}."\"" if ($self->{'in_hash'}->{"def_$i"});
	$line .= "\tOVERRIDE=\"".$self->{'in_hash'}->{"over_$i"}."\"" if ($self->{'in_hash'}->{"over_$i"});
	push(@lines, $line,"\n");
	}
$self->lock_file($file);
$self->open_tempfile(FILE, ">$file");
$self->print_tempfile(FILE, @lines);
$self->close_tempfile(FILE);
$self->unlock_file($file);
}


1;

