#!/usr/bin/perl
package pam::Pam_listfileso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_listfileso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_listfile.so

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'listfile_item'}</b></td>\n";
print "<td><select name=item>\n";
foreach $i ('user', 'tty', 'rhost', 'ruser', 'group', 'shell') {
	printf "<option value='%s' %s>%s\n",
		$i, $_[2]->{'item'} eq $i ? 'selected' : '',
		$self->{'text_hash'}->{'listfile_item_'.$i};
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'listfile_sense'}</b></td>\n";
printf "<td><input type=radio name=sense value=allow %s> %s\n",
	$_[2]->{'sense'} eq 'allow' ? 'checked' : '', $self->{'text_hash'}->{'listfile_succeed'};
printf "<input type=radio name=sense value=deny %s> %s</td> </tr>\n",
	$_[2]->{'sense'} eq 'allow' ? '' : 'checked', $self->{'text_hash'}->{'listfile_fail'};

print "<tr> <td><b>$self->{'text_hash'}->{'listfile_file'}</b></td>\n";
print "<td colspan=3><input name=file size=50 value='$_[2]->{'file'}'> ",
      $self->file_chooser_button("file"),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'listfile_onerr'}</b></td>\n";
printf "<td><input type=radio name=onerr value=fail %s> %s\n",
	$_[2]->{'onerr'} eq 'fail' ? 'checked' : '', $self->{'text_hash'}->{'listfile_fail'};
printf "<input type=radio name=onerr value=succeed %s> %s</td>\n",
	$_[2]->{'onerr'} eq 'fail' ? '' : 'checked', $self->{'text_hash'}->{'listfile_succeed'};

local $mode = $_[2]->{'apply'} =~ /^\@/ ? 2 :
	      $_[2]->{'apply'} ? 1 : 0;
print "<td><b>$self->{'text_hash'}->{'listfile_apply'}</b></td>\n";
printf "<td><input type=radio name=apply_mode value=0 %s> %s\n",
	$mode == 0 ? 'checked' : '', $self->{'text_hash'}->{'listfile_all'};
printf "<input type=radio name=apply_mode value=1 %s> %s %s\n",
	$mode == 1 ? 'checked' : '', $self->{'text_hash'}->{'listfile_user'},
	$self->unix_user_input("apply_user", $mode == 1 ? $_[2]->{'apply'} : "");
printf "<input type=radio name=apply_mode value=2 %s> %s %s</td> </tr>\n",
	$mode == 2 ? 'checked' : '', $self->{'text_hash'}->{'listfile_group'},
	$self->unix_group_input("apply_group", $mode == 2 ?
		substr($_[2]->{'apply'}, 1) : "");
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

$_[2]->{'item'} = $self->{'in_hash'}->{'item'};
$_[2]->{'sense'} = $self->{'in_hash'}->{'sense'};
$_[2]->{'file'} = $self->{'in_hash'}->{'file'};
$_[2]->{'onerr'} = $self->{'in_hash'}->{'onerr'};
if ($self->{'in_hash'}->{'apply_mode'} == 0) {
	delete($_[2]->{'apply'});
	}
elsif ($self->{'in_hash'}->{'apply_mode'} == 1) {
	$_[2]->{'apply'} = $self->{'in_hash'}->{'apply_user'};
	}
else {
	$_[2]->{'apply'} = '@'.$self->{'in_hash'}->{'apply_group'};
	}
}


1;

