#!/usr/bin/perl
package pam::Pam_pwdbso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_pwdbso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_pwdb.so

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'pwdb_shadow'}</b></td>\n";
printf "<td><input type=radio name=shadow value=1 %s> %s\n",
	defined($_[2]->{'shadow'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=shadow value=0 %s> %s</td>\n",
	defined($_[2]->{'shadow'}) ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'pwdb_nullok'}</b></td>\n";
printf "<td><input type=radio name=nullok value=1 %s> %s\n",
	defined($_[2]->{'nullok'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=nullok value=0 %s> %s</td> </tr>\n",
	defined($_[2]->{'nullok'}) ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'pwdb_md5'}</b></td>\n";
printf "<td><input type=radio name=md5 value=1 %s> %s\n",
	defined($_[2]->{'md5'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=md5 value=0 %s> %s</td>\n",
	defined($_[2]->{'md5'}) ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'pwdb_nodelay'}</b></td>\n";
printf "<td><input type=radio name=nodelay value=0 %s> %s\n",
	defined($_[2]->{'nodelay'}) ? '' : 'checked', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=nodelay value=1 %s> %s</td> </tr>\n",
	defined($_[2]->{'nodelay'}) ? 'checked' : '', $self->{'text_hash'}->{'no'};
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

if ($self->{'in_hash'}->{'shadow'}) { $_[2]->{'shadow'} = ""; }
else { delete($_[2]->{'shadow'}); }

if ($self->{'in_hash'}->{'nullok'}) { $_[2]->{'nullok'} = ""; }
else { delete($_[2]->{'nullok'}); }

if ($self->{'in_hash'}->{'md5'}) { $_[2]->{'md5'} = ""; }
else { delete($_[2]->{'md5'}); }

if ($self->{'in_hash'}->{'nodelay'}) { $_[2]->{'nodelay'} = ""; }
else { delete($_[2]->{'nodelay'}); }
}


1;

