#!/usr/bin/perl
package pam::Pam_rhosts_authso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_rhosts_authso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_rhosts_auth.so

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'rhosts_equiv'}</b></td>\n";
printf "<td><input type=radio name=equiv value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($_[2]->{'no_hosts_equiv'}) ? '' : 'checked';
printf "<input type=radio name=equiv value=1 %s> $self->{'text_hash'}->{'no'}</td>\n",
	defined($_[2]->{'no_hosts_equiv'}) ? 'checked' : '';

print "<td><b>$self->{'text_hash'}->{'rhosts_rhosts'}</b></td>\n";
printf "<td><input type=radio name=rhosts value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($_[2]->{'no_rhosts'}) ? '' : 'checked';
printf "<input type=radio name=rhosts value=1 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	defined($_[2]->{'no_rhosts'}) ? 'checked' : '';

print "<tr> <td><b>$self->{'text_hash'}->{'rhosts_promiscuous'}</b></td>\n";
printf "<td><input type=radio name=promiscuous value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($_[2]->{'promiscuous'}) ? 'checked' : '';
printf "<input type=radio name=promiscuous value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	defined($_[2]->{'promiscuous'}) ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'rhosts_suppress'}</b></td>\n";
printf "<td><input type=radio name=suppress value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	defined($_[2]->{'suppress'}) ? '' : 'checked';
printf "<input type=radio name=suppress value=1 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	defined($_[2]->{'suppress'}) ? 'checked' : '';
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

if ($self->{'in_hash'}->{'equiv'}) { $_[2]->{'no_hosts_equiv'} = ''; }
else { delete($_[2]->{'no_hosts_equiv'}); }

if ($self->{'in_hash'}->{'rhosts'}) { $_[2]->{'no_rhosts'} = ''; }
else { delete($_[2]->{'no_rhosts'}); }

if ($self->{'in_hash'}->{'promiscuous'}) { $_[2]->{'promiscuous'} = ''; }
else { delete($_[2]->{'promiscuous'}); }

if ($self->{'in_hash'}->{'suppress'}) { $_[2]->{'suppress'} = ''; }
else { delete($_[2]->{'suppress'}); }
}


1;

