#!/usr/bin/perl
package pam::Pam_timeso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_timeso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_time.so

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

local $file = "/etc/security/time.conf";
local @time;
open(FILE, $file);
while(<FILE>) {
	s/#.*$//;
	s/\r|\n//g;
	if (/^\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*$/) {
		push(@time, [ $1, $2, $3, $4 ]);
		}
	}
close(FILE);
print "<tr> <td colspan=4><table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'time_services'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'time_ttys'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'time_users'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'time_times'}</b></td> </tr>\n";
local $i = 0;
foreach $t (@time, [ ]) {
	print "<tr>\n";
	print "<td><input name=services_$i size=25 value='$t->[0]'></td>\n";
	print "<td><input name=ttys_$i size=25 value='$t->[1]'></td>\n";
	print "<td><input name=users_$i size=25 value='$t->[2]'></td>\n";
	print "<td><input name=times_$i size=25 value='$t->[3]'></td>\n";
	print "</tr>\n";
	$i++;
	}
print "</table><br>$self->{'text_hash'}->{'time_info'}</td> </tr>\n";
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

local $file = "/etc/security/time.conf";
local (@lines, $i);
for($i=0; defined($self->{'in_hash'}->{"services_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"services_$i"});
	push(@lines, join(";", $self->{'in_hash'}->{"services_$i"}, $self->{'in_hash'}->{"ttys_$i"},
			       $self->{'in_hash'}->{"users_$i"}, $self->{'in_hash'}->{"times_$i"}),"\n");
	}
$self->lock_file($file);
$self->open_tempfile(FILE, ">$file");
$self->print_tempfile(FILE, @lines);
$self->close_tempfile(FILE);
$self->unlock_file($file);
}


1;

