#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mod.cgi
# Edit one PAM authentication module for some service

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ReadParse();
@{$self->{'pam_array'}} = $self->get_pam_config();
$self->{'pam'} = $self->{'pam_array'}->[$self->{'in_hash'}->{'idx'}];
if ($self->{'in_hash'}->{'midx'} ne '') {
	$self->{'mod'} = $self->{'pam'}->{'mods'}->[$self->{'in_hash'}->{'midx'}];
	$self->{'module'} = $self->{'mod'}->{'module'};
	$self->{'module'} =~ s/^.*\///;
	$self->{'type'} = $self->{'mod'}->{'type'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mod_edit'}, "");
	}
else {
	$self->{'module'} = $self->{'in_hash'}->{'module'};
	$self->{'type'} = $self->{'in_hash'}->{'type'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mod_create'}, "");
	}

print "<form action=save_mod.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=midx value='$self->{'in_hash'}->{'midx'}'>\n";
print "<input type=hidden name=_module value='$self->{'in_hash'}->{'module'}'>\n";
print "<input type=hidden name=_type value='$self->{'in_hash'}->{'type'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mod_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'mod_name'}</b></td>\n";
$self->{'t'} = $self->{'text_hash'}->{'desc_'.$self->{'pam'}->{'name'}};
print "<td><tt>",$self->html_escape($self->{'pam'}->{'name'}),"</tt> ",
		$self->{'pam'}->{'desc'} ? "($self->{'pam'}->{'desc'})" :
		$self->{'t'} ? "($self->{'t'})" : "","</td>\n";

print "<td><b>$self->{'text_hash'}->{'mod_mod'}</b></td>\n";
$self->{'t'} = $self->{'text_hash'}->{$self->{'module'}};
print "<td><tt>$self->{'module'}</tt> ",$self->{'t'} ? "($self->{'t'})" : "","</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'mod_type'}</b></td>\n";
print "<td>",$self->{'text_hash'}->{'mod_type_'.$self->{'type'}},"</td>\n";

print "<td><b>$self->{'text_hash'}->{'mod_control'}</b></td>\n";
print "<td><select name=control>\n";
foreach $c ('required', 'requisite', 'sufficient', 'optional') {
	printf "<option value=%s %s>%s (%s)\n",
		$c, $self->{'mod'}->{'control'} eq $c ? 'selected' : '',
		$self->{'text_hash'}->{'control_'.$c}, $self->{'text_hash'}->{'control_desc_'.$c};
	}
print "</select></td> </tr>\n";

if (-r "./$self->{'module'}.pl") {
	{
    my $pkg = $self->lib_to_pkg(".\/$self->{module}.pl", "pam");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	if (!$self->{'module_has_no_args'}) {
		print "<tr> <td colspan=4><hr></td> </tr>\n";
		foreach $a (split(/\s+/, $self->{'mod'}->{'args'})) {
			if ($a =~ /^([^\s=]+)=(\S*)$/) {
				$self->{'args_hash'}->{$1} = $2;
				}
			else {
				$self->{'args_hash'}->{$a} = "";
				}
			}
		$self->display_module_args($self->{'pam'}, $self->{'mod'}, \%{$self->{'args_hash'}});
		}
	}
else {
	print "<tr> <td colspan=4><hr></td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mod_args'}</b></td>\n";
	print "<td colspan=3><input name=args size=50 ",
	      "value='$self->{'mod'}->{'args'}'></td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
if ($self->{'in_hash'}->{'midx'} ne '') {
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";
print "</form>\n";

$self->ui_print_footer("edit_pam.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'edit_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

