#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pam.cgi
# Display the modules for some PAM service

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
@{$self->{'pams_array'}} = $self->get_pam_config();
$self->{'pam'} = $self->{'pams_array'}->[$self->{'in_hash'}->{'idx'}];

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td width=10%><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
$t = $self->{'text_hash'}->{'desc_'.$self->{'pam'}->{'name'}};
print "<td><tt>",$self->html_escape($self->{'pam'}->{'name'}),"</tt> ",
		$self->{'pam'}->{'desc'} ? "($self->{'pam'}->{'desc'})" :
		$t ? "($t)" : "","</td>\n";
print "</tr>\n";

foreach $t ('auth', 'account', 'session', 'password') {
	print "<tr> <td colspan=2>\n";
	print "<form action=edit_mod.cgi><table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>",$self->{'text_hash'}->{"edit_header_$t"},"</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>\n";

	local @mods = grep { $_->{'type'} eq $t } @{$self->{'pam'}->{'mods'}};
	print "<table width=100%>\n";
	if (@mods) {
		print "<tr $self->{'cb'}> <td width=20%><b>$self->{'text_hash'}->{'edit_mod'}</b></td> ",
		      "<td width=35%><b>$self->{'text_hash'}->{'edit_desc'}</b></td> ",
		      "<td width=20%><b>$self->{'text_hash'}->{'edit_control'}</b></td> ",
		      "<td width=20%><b>$self->{'text_hash'}->{'edit_args'}</b></td> ",
		      "<td width=5%><b>$self->{'text_hash'}->{'edit_move'}</b></td> </tr>\n";
		}
	else {
		print "<tr> <td colspan=5><b>$self->{'text_hash'}->{'edit_none'}",
		      "</b></td> </tr>\n";
		}
	foreach $m (@mods) {
		local $mn = $m->{'module'};
		$mn =~ s/^.*\///;
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='edit_mod.cgi?idx=$self->{'pam'}->{'index'}&",
		      "midx=$m->{'index'}'>$mn</a></td>\n";
		print "<td>",$self->{'text_hash'}->{$mn} ? $self->{'text_hash'}->{$mn} : "<br>","</td>\n";
		print "<td>",$self->{'text_hash'}->{'control_'.$m->{'control'}},"</td>\n";
		print "<td>",$m->{'args'} ? $m->{'args'} : "<br>","</td>\n";
		print "<td>";
		if ($m eq $mods[$#mods]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$self->{'pam'}->{'index'}&",
			      "midx=$m->{'index'}&down=1'><img ",
			      "src=images/down.gif border=0></a>";
			}
		if ($m eq $mods[0]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$self->{'pam'}->{'index'}&",
			      "midx=$m->{'index'}&up=1'><img ",
			      "src=images/up.gif border=0></a>";
			}
		print "</tr>\n";
		}
	print "</table>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<input type=hidden name=type value='$t'>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'edit_addmod'}'>\n";
	print "<select name=module>\n";
	foreach $m (sort { $a cmp $b } $self->list_modules()) {
		printf "<option value=%s>%s\n",
			$m, $self->{'text_hash'}->{$m} ? "$m ($self->{'text_hash'}->{$m})" : $m;
		}
	print "</select></td> </tr>\n";
	print "</table></form></td></tr>\n";
	}

print "<form action=delete_pam.cgi>\n";
print "</table></td></tr></table>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=submit value='$self->{'text_hash'}->{'edit_delete'}'>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

