#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display PAM services on the system

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, undef, undef, 1, 1, 0,
	$self->help_search_link("pam", "man", "howto", "doc"));

@{$self->{'pams_array'}} = sort { $a->{'name'} cmp $b->{'name'} } $self->get_pam_config();
if (!@{$self->{'pams_array'}}) {
	print "<p>",$self->text('index_none', "<tt>$self->{'config_hash'}->{'pam_dir'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'links_array'}} = ( "<a href='create_form.cgi'>$self->{'text_hash'}->{'index_add'}</a>" );
print $self->ui_links_row(\@{$self->{'links_array'}});
$self->{'mid'} = int((@{$self->{'pams_array'}}-1) / 2);
print "<table width=100%><tr> <td width=50% valign=top>\n";
&pam_table(@{$self->{'pams_array'}}[0 .. $self->{'mid'}]);
print "</td> <td width=50% valign=top>\n";
&pam_table(@{$self->{'pams_array'}}[$self->{'mid'}+1 .. $#{$self->{'pams_array'}}]);
print "</td> </tr></table>\n";
print $self->ui_links_row(\@{$self->{'links_array'}});

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}

sub pam_table
{
	shift if ($self == $_[0]);

print $self->ui_columns_start([ $self->{'text_hash'}->{'index_name'}, $self->{'text_hash'}->{'index_desc'} ], 100);
foreach $p (@_) {
	local $t = $self->{'text_hash'}->{'desc_'.$p->{'name'}};
	print $self->ui_columns_row([
		"<a href='edit_pam.cgi?idx=$p->{'index'}'>".
		$self->html_escape($p->{'name'})."</a>",
		$p->{'desc'} || $t
		]);
	}
print $self->ui_columns_end();
}


1;

