#!/usr/bin/perl
package pap::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pap::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pap::PapLib");
$self = new pap::PapLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the pap module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_pages'}</b></td> <td colspan=3>\n";
foreach $a ('mgetty', 'options', 'dialin', 'secrets', 'sync') {
	print "&nbsp;&nbsp;\n" if ($a eq 'sync');
	printf "<input type=checkbox name=%s value=1 %s> %s<br>\n",
		$a, $_[0]->{$a} ? "checked" : "", $self->{'text_hash'}->{$a."_title"};
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_direct'}</b></td>\n";
printf "<td><input type=radio name=direct value=1 %s> %s\n",
	$_[0]->{'direct'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=direct value=0 %s> %s</td> </tr>\n",
	$_[0]->{'direct'} ? "" : "checked", $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the squid module
sub acl_security_save
{
	my $self = shift;

foreach $a ('mgetty', 'options', 'dialin', 'secrets', 'sync') {
	$_[0]->{$a} = $self->{'in_hash'}->{$a};
	}
$_[0]->{'direct'} = $self->{'in_hash'}->{'direct'};
}


1;

