#!/usr/bin/perl
package pap::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pap::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pap::PapLib");
$self = new pap::PapLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local %iconfig = $self->foreign_config("inittab");
return ( $self->{'config_hash'}->{'pap_file'}, $self->{'config_hash'}->{'ppp_options'},
	 $self->{'config_hash'}->{'login_config'}, $self->{'config_hash'}->{'dialin_config'},
	 $iconfig{'inittab_file'},
	 grep { -r $_ } glob("$self->{'config_hash'}->{'ppp_options'}.*") );
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return $self->apply_mgetty();
}


1;

