#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_secrets.cgi
# Displays a list of all PAP secrets

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'secrets_title'}, "");

if (!-r $self->{'config_hash'}->{'pap_file'}) {
	print "<b>", $self->text('index_enopfile', $self->{'config_hash'}->{'pap_file'}), "</b>.<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index_return'});
	exit;
	}

@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	  "<a href=edit_secret.cgi>$self->{'text_hash'}->{'index_create'}</a>" );

# Show table of users
@{$self->{'sec_array'}} = $self->list_secrets();
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href=edit_secret.cgi>$self->{'text_hash'}->{'index_create'}</a>" );
if (@{$self->{'sec_array'}}) {
	print $self->ui_form_start("delete_secrets.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start(
		[ "", $self->{'text_hash'}->{'index_user'}, $self->{'text_hash'}->{'index_server'} ],
		undef, 0, \@{$self->{'tds_array'}});
	for($i=0; $i<@{$self->{'sec_array'}}; $i++) {
		$self->{'s'} = $self->{'sec_array'}->[$i];
		local @cols;
		push(@cols, "<a href=\"edit_secret.cgi?$i\">".
			($self->{'s'}->{'client'} ? $self->html_escape($self->{'s'}->{'client'})
				        : $self->{'text_hash'}->{'index_uany'})."</a>");
		push(@cols, $self->{'s'}->{'server'} eq "*" ? $self->{'text_hash'}->{'index_sany'}
					      : $self->html_escape($self->{'s'}->{'server'}));
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $i);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'secrets_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

if ($self->{'access_hash'}->{'sync'}) {
	print "<hr>\n", $self->{'text_hash'}->{'index_info'}, " <p>\n";

	print "<form action=save_sync.cgi>\n";
	printf "<input type=checkbox name=add value=1 %s>\n",
		$self->{'config_hash'}->{'sync_add'} ? "checked" : "";
	print $self->{'text_hash'}->{'index_onadd'}, "\n";
	print "<input name=server size=20 value='$self->{'config_hash'}->{'sync_server'}'><p>\n";

	printf "<input type=checkbox name=change value=1 %s>\n",
		$self->{'config_hash'}->{'sync_change'} ? "checked" : "";
	print $self->{'text_hash'}->{'index_onchange'}, "<p>\n";

	printf "<input type=checkbox name=delete value=1 %s>\n",
		$self->{'config_hash'}->{'sync_delete'} ? "checked" : "";
	print $self->{'text_hash'}->{'index_ondelete'}, "<p>\n";
	print "<input type=submit value=", $self->{'text_hash'}->{'save'}, "></form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

