#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sync.cgi
# Save unix-ppp synchronisation options

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
$self->{'access_hash'}->{'sync'} || $self->error($self->{'text_hash'}->{'sync_ecannot'});
$self->ReadParse();

$self->lock_file("$self->{'module_config_directory'}/config");
foreach $s ("add", "change", "delete") {
	if ($self->{'in_hash'}->{$s}) { $self->{'config_hash'}->{"sync_$s"} = 1; }
	else { delete($self->{'config_hash'}->{"sync_$s"}); }
	}
$self->{'config_hash'}->{'sync_server'} = $self->{'in_hash'}->{'server'};
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");
$self->webmin_log("sync", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

