#!/usr/bin/perl
package phpini::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'phpini::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the file module
sub acl_security_form
{
	my $self = shift;

local ($o) = @_;
print $self->ui_table_row($self->{'text_hash'}->{'acl_global'},
		    $self->ui_yesno_radio("global", $o->{'global'}));
print $self->ui_table_row($self->{'text_hash'}->{'acl_anyfile'},
		    $self->ui_yesno_radio("anyfile", $o->{'anyfile'}));
print $self->ui_table_row($self->{'text_hash'}->{'acl_manual'},
		    $self->ui_yesno_radio("manual", $o->{'manual'}));

print $self->ui_table_row($self->{'text_hash'}->{'acl_inis'},
	    $self->ui_textarea("inis", join("\n", split(/\t+/, $o->{'php_inis'})),
			 5, 70), 3);
}

# acl_security_save(&options)
# Parse the form for security options for the file module
sub acl_security_save
{
	my $self = shift;

local ($o) = @_;
$o->{'global'} = $self->{'in_hash'}->{'global'};
$o->{'anyfile'} = $self->{'in_hash'}->{'anyfile'};
$o->{'manual'} = $self->{'in_hash'}->{'manual'};
$o->{'php_inis'} = join("\t", split(/\n/, $self->{'in_hash'}->{'inis'}));
}


1;

