#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Write to a manually edited PHP config file

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParseMime();
$self->error_setup($self->{'text_hash'}->{'manual_err'});
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'manual_ecannot'});
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'manual_ecannot'});

# Validate input
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->{'in_hash'}->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'manual_edata'});

# Save the file
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);

$self->graceful_apache_restart();
$self->webmin_log("manual", $self->{'in_hash'}->{'file'});
$self->redirect("");

1;
		
}


1;

