#!/usr/bin/perl
package postfix::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postfix::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "postfix::PostfixLib");
$self = new postfix::PostfixLib:: ref($self), %$self; 
@{$self->{'acl_pages_array'}} = ("resource", "address_rewriting", "aliases", "general",
	      "canonical", "virtual", "transport", "relocated", "header","body",
	      "local_delivery", "smtpd", "smtp", "rate", "debug", "ldap",
	      "master", "startstop", "mailq", "postfinger", "manual");

1;
		return $self;
}

# Print the form for security options of postfix module
sub acl_security_form
{
	my $self = shift;

local $o;
foreach $o (@{$self->{'acl_pages_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'acl_'.$o},
			    $self->ui_yesno_radio($o, $_[0]->{$o} ? 1 : 0));
	}
print $self->ui_table_row($self->{'text_hash'}->{'acl_dir'},
		    $self->ui_textbox("dir", $_[0]->{'dir'}, 50));
}

# acl_security_save(&options)
# Parse the form for security options for the postfix module
sub acl_security_save
{
	my $self = shift;

local $o;
foreach $o (@{$self->{'acl_pages_array'}}) {
	$_[0]->{$o} = $self->{'in_hash'}->{$o};
	}
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir'};
}


1;

