#!/usr/bin/perl
package postfix::Install_check;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postfix::Install_check');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# install_check.pl

&ModuleLoader::preload_module(ref($self), "postfix::PostfixLib");
$self = new postfix::PostfixLib:: ref($self), %$self; 

1;
		return $self;
}

# is_installed(mode)
# For mode 1, returns 2 if the server is installed and configured for use by
# Webmin, 1 if installed but not configured, or 0 otherwise.
# For mode 0, returns 1 if installed, 0 if not
sub is_installed
{
	my $self = shift;

return 0 if (!-x $self->{'config_hash'}->{'postfix_control_command'});
if ($_[0]) {
	return 2 if (!$self->check_postfix());
	}
return 1;
}


1;

