#!/usr/bin/perl
package postfix::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postfix::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "postfix::PostfixLib");
$self = new postfix::PostfixLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

    if ($self->has_command($self->{'config_hash'}->{'postfix_config_command'}) &&
	$self->backquote_command("$self->{'config_hash'}->{'postfix_config_command'} mail_version 2>&1", 1) =~ /mail_version\s*=\s*(.*)/) {
	# Got the version
	$self->{'postfix_version'} = $1;
	# Save the version for use by other CGIs
	$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version", 0, 1);
	$self->print_tempfile(VERSION, "$self->{'postfix_version'}\n");
	$self->close_tempfile(VERSION);
	}
}


1;

