#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# A form for editing address rewriting for Postfix
#
# << Here are all options seen in Postfix sample-rewrite.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'address_rewriting'} || $self->error($self->{'text_hash'}->{'address_rewriting_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'address_rewriting_title'}, "");

$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
$self->{'none'} = $self->{'text_hash'}->{'opts_none'};
$self->{'no_'} = $self->{'text_hash'}->{'opts_no'};

print "<form action=save_opts.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'address_rewriting_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_yesno("allow_percent_hack");
$self->option_yesno("append_at_myorigin");
print "</tr>\n";

print "<tr>\n";
$self->option_yesno("append_dot_mydomain");
$self->option_yesno("swap_bangpath", 'help');
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("empty_address_recipient", 20, $self->{'text_hash'}->{'opt_empty_recip_default'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("masquerade_domains", 35, $self->{'none'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("masquerade_exceptions", 35, $self->{'none'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

