#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Manages virtuals for Postfix
#
# << Here are all options seen in Postfix sample-virtual.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'header'} || $self->error($self->{'text_hash'}->{'header_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'header_title'}, "", "header");

# alias general options

print "<form action=save_opts_header.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'header_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'none'} = $self->{'text_hash'}->{'opts_none'};

print "<tr>\n";
$self->option_radios_freefield("header_checks", 60, $self->{'none'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
print "<hr>\n";
print "<br>\n";

if ($self->get_current_value("header_checks") eq "")
{
    print ($self->{'text_hash'}->{'no_map'}."<br><br>");
}
else
{
    $self->generate_map_edit("header_checks", $self->{'text_hash'}->{'map_click'}." ".
		       "<font size=\"-1\">".$self->hlink("$self->{'text_hash'}->{'help_map_format'}", "header")."</font>\n<br>\n", 1,
		       $self->{'text_hash'}->{'header_name'}, $self->{'text_hash'}->{'header_value'});
}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

