#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a page for manually editing the Postfix config file

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'cmanual_ecannot'});
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'cmanual_title'}, "");

# Work out and show the files
@{$self->{'files_array'}} = ( $self->{'config_hash'}->{'postfix_config_file'}, $self->{'config_hash'}->{'postfix_master'} );
$self->{'in_hash'}->{'file'} ||= $self->{'files_array'}->[0];
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'cmanual_efile'});
print $self->ui_form_start("manual.cgi");
print "<b>$self->{'text_hash'}->{'cmanual_file'}</b>\n";
print $self->ui_select("file", $self->{'in_hash'}->{'file'},
		 [ map { [ $_ ] } @{$self->{'files_array'}} ]),"\n";
print $self->ui_submit($self->{'text_hash'}->{'cmanual_ok'});
print $self->ui_form_end();

# Show the file contents
print $self->ui_form_start("manual_update.cgi", "form-data");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
$self->{'data'} = $self->read_file_contents($self->{'in_hash'}->{'file'});
print $self->ui_textarea("data", $self->{'data'}, 20, 80),"\n";
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

