#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update a manually edited config file

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->error_setup($self->{'text_hash'}->{'cmanual_err'});
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'cmanual_ecannot'});
$self->ReadParseMime();

# Work out the file
@{$self->{'files_array'}} = ( $self->{'config_hash'}->{'postfix_config_file'}, $self->{'config_hash'}->{'postfix_master'} );
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'cmanual_efile'});
$self->{'in_hash'}->{'data'} =~ s/\r//g;
if ($self->{'in_hash'}->{'file'} eq $self->{'files_array'}->[0]) {
	$self->{'in_hash'}->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'cmanual_edata'});
	}

# Write to it
$self->open_lock_tempfile(DATA, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(DATA, $self->{'in_hash'}->{'data'});
$self->close_tempfile(DATA);

$self->webmin_log("manual", undef, $self->{'in_hash'}->{'file'});
$self->redirect("");

1;
		
}


1;

