#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of Postfix server processes

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'master'} || $self->error($self->{'text_hash'}->{'master_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'master_title'}, "", "master");
$self->{'master'} = $self->get_master_config();

print "<a href='edit_master.cgi?new=1'>$self->{'text_hash'}->{'master_add'}</a><br>\n";
print $self->ui_columns_start([ $self->{'text_hash'}->{'master_name'},
			  $self->{'text_hash'}->{'master_enabled'},
			  $self->{'text_hash'}->{'master_type'},
			  $self->{'text_hash'}->{'master_private'},
			  $self->{'text_hash'}->{'master_unpriv'},
			  $self->{'text_hash'}->{'master_chroot'},
			  $self->{'text_hash'}->{'master_max'} ], "100%");
foreach $m (@{$self->{'master'}}) {
	print $self->ui_columns_row([
		"<a href='edit_master.cgi?name=".$self->urlize($m->{'name'})."'>".
		 $m->{'name'}."</a>",
		$m->{'enabled'} ? $self->{'text_hash'}->{'yes'} :
			"<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>",
		$self->{'text_hash'}->{'master_'.$m->{'type'}},
		$m->{'private'} eq 'n' ? $self->{'text_hash'}->{'no'} : $self->{'text_hash'}->{'yes'},
		$m->{'unpriv'} eq 'n' ? $self->{'text_hash'}->{'no'} : $self->{'text_hash'}->{'yes'},
		$m->{'chroot'} eq 'n' ? $self->{'text_hash'}->{'no'} : $self->{'text_hash'}->{'yes'},
		$m->{'maxprocs'} eq "-" ? $self->{'text_hash'}->{'default'} :
		 $m->{'maxprocs'} eq "0" ? $self->{'text_hash'}->{'master_unlimit'} :
					  $m->{'maxprocs'},
			]);
	}
print $self->ui_columns_end();
print "<a href='edit_master.cgi?new=1'>$self->{'text_hash'}->{'master_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

