#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update a manually edited map file

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParseMime();
$self->error_setup($self->{'text_hash'}->{'manual_err'});
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'manual_ecannot'});
@{$self->{'files_array'}} = $self->get_maps_files($self->get_real_value($self->{'in_hash'}->{'map_name'}));
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});

# Save the data
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);

# Regenerate map
$self->regenerate_map_table($self->{'in_hash'}->{'map_name'});
$self->reload_postfix();

$self->webmin_log("manual", $self->{'in_hash'}->{'map_name'}.'s', $self->{'in_hash'}->{'file'});
$self->redirect_to_map_list($self->{'in_hash'}->{'map_name'});
1;
		
}


1;

