#!/usr/bin/perl
package postgresql::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postgresql::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the postgresql module
sub acl_security_form
{
	my $self = shift;

my (@listdb)=$self->list_databases();
print "<tr> <td valign=top rowspan=4><b>$self->{'text_hash'}->{'acl_dbs'}</b>\n";
print "<br>$self->{'text_hash'}->{'acl_dbscannot'}" unless @listdb;
print "</td>\n";
print "<td rowspan=4 valign=top>\n";
if (@listdb) {
	printf "<input type=radio name=dbs_def value=1 %s> %s\n",
		$_[0]->{'dbs'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_dall'};
	printf "<input type=radio name=dbs_def value=0 %s> %s<br>\n",
		$_[0]->{'dbs'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_dsel'};
	print "<select name=dbs size=5 multiple width=100>\n";
		map { $self->{'dcan_hash'}->{$_}++ } split(/\s+/, $_[0]->{'dbs'});
	foreach $d (@listdb) {
		printf "<option %s>%s\n",
			$self->{'dcan_hash'}->{$d} ? 'selected' : '', $d;
		}
	print "</select>";
	print "<input type=hidden name=dblist value=\"1\">\n";
	} 
else {
	print "<input type=hidden name=dblist value=\"0 ".$_[0]->{'dbs'}."\">\n";
	}
print "</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_create'}</b></td> <td>\n";
printf "<input type=radio name=create value=1 %s> %s\n",
	$_[0]->{'create'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=create value=2 %s> %s\n",
	$_[0]->{'create'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_max'};
printf "<input name=max size=5 value='%s'>\n",
	$_[0]->{'max'};
printf "<input type=radio name=create value=0 %s> %s</td> </tr>\n",
	$_[0]->{'create'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_delete'}</b></td> <td>\n";
printf "<input type=radio name=delete value=1 %s> %s\n",
	$_[0]->{'delete'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=delete value=0 %s> %s</td> </tr>\n",
	$_[0]->{'delete'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_stop'}</b></td> <td>\n";
printf "<input type=radio name=stop value=1 %s> %s\n",
	$_[0]->{'stop'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=stop value=0 %s> %s</td> </tr>\n",
	$_[0]->{'stop'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td>\n";
printf "<input type=radio name=users value=1 %s> %s\n",
	$_[0]->{'users'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=users value=0 %s> %s</td> </tr>\n",
	$_[0]->{'users'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_login'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=user_def value=1 %s> %s<br>\n",
	$_[0]->{'user'} ? '' : 'checked', $self->{'text_hash'}->{'acl_user_def'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} ? 'checked' : '';
printf "%s <input name=user size=10 value='%s'>\n",
	$self->{'text_hash'}->{'acl_user'}, $_[0]->{'user'};
printf "%s <input name=pass type=password size=10 value='%s'><br>\n",
	$self->{'text_hash'}->{'acl_pass'}, $_[0]->{'pass'};
print "&nbsp;&nbsp;&nbsp;\n";
printf "<input type=checkbox name=sameunix value=1 %s> %s</td> </tr>\n",
	$_[0]->{'sameunix'} ? "checked" : "", $self->{'text_hash'}->{'acl_sameunix'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_backup'}</b></td> <td>\n";
printf "<input type=radio name=backup value=1 %s> %s\n",
	$_[0]->{'backup'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=backup value=0 %s> %s</td>\n",
	$_[0]->{'backup'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_restore'}</b></td> <td>\n";
printf "<input type=radio name=restore value=1 %s> %s\n",
	$_[0]->{'restore'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=restore value=0 %s> %s</td> </tr>\n",
	$_[0]->{'restore'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_cmds'}</b></td> <td>\n";
printf "<input type=radio name=cmds value=1 %s> %s\n",
        $_[0]->{'cmds'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=cmds value=0 %s> %s</td>\n",
        $_[0]->{'cmds'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_views'}</b></td> <td>\n";
printf "<input type=radio name=views value=1 %s> %s\n",
	$_[0]->{'views'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=views value=0 %s> %s</td> </tr>\n",
	$_[0]->{'views'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_indexes'}</b></td> <td>\n";
printf "<input type=radio name=indexes value=1 %s> %s\n",
        $_[0]->{'indexes'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=indexes value=0 %s> %s</td>\n",
        $_[0]->{'indexes'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_seqs'}</b></td> <td>\n";
printf "<input type=radio name=seqs value=1 %s> %s\n",
	$_[0]->{'seqs'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=seqs value=0 %s> %s</td> </tr>\n",
	$_[0]->{'seqs'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "</tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the postgresql module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'dblist'} eq '1') {
	if ($self->{'in_hash'}->{'dbs_def'}) {
		$_[0]->{'dbs'} = '*';
		}
	else {
		$_[0]->{'dbs'} = join(" ", split(/\0/, $self->{'in_hash'}->{'dbs'}));
		}
	} 
else {
	$_[0]->{'dbs'} = $self->{'in_hash'}->{'dblist'};
	$_[0]->{'dbs'} =~ s/^0 //;
	}
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'users'} = $self->{'in_hash'}->{'users'};
$_[0]->{'backup'} = $self->{'in_hash'}->{'backup'};
$_[0]->{'restore'} = $self->{'in_hash'}->{'restore'};
$_[0]->{'cmds'} = $self->{'in_hash'}->{'cmds'};
$_[0]->{'views'} = $self->{'in_hash'}->{'views'};
$_[0]->{'indexes'} = $self->{'in_hash'}->{'indexes'};
$_[0]->{'seqs'} = $self->{'in_hash'}->{'seqs'};
if ($self->{'in_hash'}->{'user_def'}) {
	delete($_[0]->{'user'});
	delete($_[0]->{'pass'});
	}
else {
	$_[0]->{'user'} = $self->{'in_hash'}->{'user'};
	$_[0]->{'pass'} = $self->{'in_hash'}->{'pass'};
	}
$_[0]->{'sameunix'} = $self->{'in_hash'}->{'sameunix'};
}


1;

