#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_table.cgi
# Create a new table

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'table_err'});
$self->{'in_hash'}->{'name'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'table_ename'});
for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"field_$i"});
	$self->{'in_hash'}->{"field_$i"} =~ /^\S+$/ ||
		$self->error($self->text('table_efield', $self->{'in_hash'}->{"field_$i"}));
	$self->{'in_hash'}->{"type_$i"} || $self->error($self->text('table_etype', $self->{'in_hash'}->{"field_$i"}));
	if ($self->{'in_hash'}->{"size_$i"}) {
		if ($self->is_blob({ 'type' => $self->{'in_hash'}->{"type_$i"} })) {
			$self->error($self->text('table_eblob', $self->{'in_hash'}->{"field_$i"}));
			}
		$self->{'f'} = sprintf "\"%s\" %s(%s)",
		     $self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"type_$i"}, $self->{'in_hash'}->{"size_$i"};
		}
	else {
		$self->{'f'} = sprintf "\"%s\" %s", $self->{'in_hash'}->{"field_$i"}, $self->{'in_hash'}->{"type_$i"};
		}
	if ($self->{'in_hash'}->{"arr_$i"}) { $self->{'f'} .= "[]"; }
	if (!$self->{'in_hash'}->{"null_$i"}) { $self->{'f'} .= " not null"; }
	if ($self->{'in_hash'}->{"key_$i"}) { $self->{'f'} .= " primary key"; }
	if ($self->{'in_hash'}->{"uniq_$i"}) { $self->{'f'} .= " unique"; }
	push(@{$self->{'fields_array'}}, $self->{'f'});
	}
@{$self->{'fields_array'}} || $self->error($self->{'text_hash'}->{'table_enone'});
$self->{'qt'} = $self->quote_table($self->{'in_hash'}->{'name'});
$self->{'sql'} = "create table $self->{'qt'} (".join(",", @{$self->{'fields_array'}}).")";
$self->execute_sql_logged($self->{'in_hash'}->{'db'}, $self->{'sql'});
$self->webmin_log("create", "table", $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");

1;
		
}


1;

