#!/usr/bin/perl

&MAIN();

 sub MAIN {
# drop_dbase.cgi
# Drop an existing database

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ddrop_err'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
if ($self->{'in_hash'}->{'confirm'}) {
	# Drop the database
	$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "drop database \"$self->{'in_hash'}->{'db'}\"");
	$self->webmin_log("delete", "db", $self->{'in_hash'}->{'db'});
	$self->redirect("");
	}
else {
	# Ask the user if he is sure..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ddrop_title'}, "");
	@{$self->{'tables_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
	$self->{'rows'} = 0;
	foreach $t (@{$self->{'tables_array'}}) {
		$self->{'d'} = $self->execute_sql($self->{'in_hash'}->{'db'}, "select count(*) from $t");
		$self->{'rows'} += $self->{'d'}->{'data'}->[0]->[0];
		}

	print "<center><b>",$self->text('ddrop_rusure', "<tt>$self->{'in_hash'}->{'db'}</tt>",
				  scalar(@{$self->{'tables_array'}}), $self->{'rows'}),"\n";
	print $self->{'text_hash'}->{'ddrop_mysql'},"\n" if ($self->{'in_hash'}->{'db'} eq $self->{'config_hash'}->{'basedb'});
	print "</b><p>\n";
	print "<form action=drop_dbase.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'ddrop_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

