#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Drop all selected databases

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ddrops_err'});
@{$self->{'dbs_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
foreach $db (@{$self->{'dbs_array'}}) {
	$self->can_edit_db($db) || $self->error($self->text('ddrops_ecannot', $db));
	}
if ($self->{'in_hash'}->{'confirm'}) {
	# Drop the databases
	foreach $db (@{$self->{'dbs_array'}}) {
		$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, "drop database \"$db\"");
		}
	$self->webmin_log("delete", "dbs", scalar(@{$self->{'dbs_array'}}));
	$self->redirect("");
	}
else {
	# Ask the user if he is sure..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ddrop_title'}, "");
	$self->{'rows'} = 0;
	$self->{'tables'} = 0;
	foreach $db (@{$self->{'dbs_array'}}) {
		next if (!$self->accepting_connections($db));
		@{$self->{'tables_array'}} = $self->list_tables($db);
		foreach $t (@{$self->{'tables_array'}}) {
			$self->{'d'} = $self->execute_sql($db, "select count(*) from $t");
			$self->{'rows'} += $self->{'d'}->{'data'}->[0]->[0];
			$self->{'tables'}++;
			}
		}

	print "<center><b>",$self->text('ddrops_rusure', scalar(@{$self->{'dbs_array'}}),
				  $self->{'tables'}, $self->{'rows'}),"\n";
	if ($self->indexof($self->{'config_hash'}->{'basedb'}, @{$self->{'dbs_array'}}) >= 0) {
		print $self->{'text_hash'}->{'ddrops_mysql'},"\n";
		}
	print "</b><p>\n";
	print "<form action=drop_dbases.cgi>\n";
	foreach $db (@{$self->{'dbs_array'}}) {
		print $self->ui_hidden("d", $db),"\n";
		}
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'ddrops_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

