#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display a form for editing or creating a user

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'user_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_edit'}, "");
	$self->{'s'} = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select * from pg_shadow ".
					     "where usename = '$self->{'in_hash'}->{'user'}'");
	@{$self->{'user_array'}} = @{$self->{'s'}->{'data'}->[0]};
	}

print "<form action=save_user.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'user_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_name'}</b></td>\n";
if ($self->{'in_hash'}->{'new'} || $self->get_postgresql_version() >= 7.4) {
	print "<td><input name=name value='$self->{'user_array'}->[0]' size=20></td>\n";
	}
else {
	print "<td>$self->{'user_array'}->[0]</td>\n";
	}

print "<td><b>$self->{'text_hash'}->{'user_passwd'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	# For new users, can select empty or specific password
	print "<td>",$self->ui_radio("pass_def", 1,
			[ [ 1, $self->{'text_hash'}->{'user_none'} ],
			  [ 0, $self->{'text_hash'}->{'user_setto'} ] ]),"\n",
		     $self->ui_password("pass", undef, 20),"</td> </tr>\n";
	}
else {
	# For existing users, can select empty, leave unchanged or
	# specific password
	print "<td>",$self->ui_radio("pass_def", 2,
			[ [ 2, $self->{'text_hash'}->{'user_nochange'} ],
			  [ 0, $self->{'text_hash'}->{'user_setto'} ] ]),"\n",
		     $self->ui_password("pass", undef, 20),"</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'user_db'}</b></td>\n";
printf "<td><input type=radio name=db value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'user_array'}->[2] =~ /t|1/ ? 'checked' : '';
printf "<input type=radio name=db value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'user_array'}->[2] =~ /t|1/ ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'user_other'}</b></td>\n";
printf "<td><input type=radio name=other value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'user_array'}->[4] =~ /t|1/ ? 'checked' : '';
printf "<input type=radio name=other value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'user_array'}->[4] =~ /t|1/ ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'user_until'}</b></td> <td colspan=3>\n";
if (!$self->{'user_array'}->[7]) {
	printf "<input type=radio name=until_def value=1 %s> %s\n",
		$self->{'user_array'}->[7] ? '' : 'checked', $self->{'text_hash'}->{'user_forever'};
	printf "<input type=radio name=until_def value=0 %s>\n",
		$self->{'user_array'}->[7] ? 'checked' : '';
	}
print "<input name=until size=30 value='$self->{'user_array'}->[7]'></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("list_users.cgi", $self->{'text_hash'}->{'user_return'});

1;
		
}


1;

