#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for creating or editing a view

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});

if ($self->{'in_hash'}->{'view'}) {
	# Editing an index
	$self->{'str'} = $self->view_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'view'});
	}
$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'in_hash'}->{'view'} ? $self->{'text_hash'}->{'view_title2'}
				     : $self->{'text_hash'}->{'view_title1'}, "");

print $self->ui_form_start("save_view.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("old", $self->{'in_hash'}->{'view'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'view_header1'}, undef, 2);

# View name
print $self->ui_table_row($self->{'text_hash'}->{'view_name'},
		    $self->ui_textbox("name", $self->{'str'}->{'name'}, 20));

# Column names
if (!$self->{'in_hash'}->{'view'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'view_cols'},
		    $self->ui_radio("cols_set", 0, [ [ 0, $self->{'text_hash'}->{'view_auto'} ],
					       [ 1, $self->{'text_hash'}->{'view_below'} ] ]).
		    "<br>\n".
		    $self->ui_textarea("cols", undef, 3, 20));
	}

# Selection query
print $self->ui_table_row($self->{'text_hash'}->{'view_query'},
		    $self->ui_textarea("query", $self->{'str'}->{'query'}, 5, 60, "on"));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'view'}) {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

