#!/usr/bin/perl

&MAIN();

 sub MAIN {
# login.cgi
# Save PostgreSQL login and password

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'login_err'});
$self->{'access_hash'}->{'user'} || !$self->{'access_hash'}->{'noconfig'} || $self->error($self->{'text_hash'}->{'login_ecannot'});
$self->{'in_hash'}->{'login'} || $self->error($self->{'text_hash'}->{'login_elogin'});
$self->{'postgres_login'} = $self->{'config_hash'}->{'login'} = $self->{'in_hash'}->{'login'};
$self->{'postgres_pass'} = $self->{'config_hash'}->{'pass'} = $self->{'in_hash'}->{'pass'};
if (!$self->{'access_hash'}->{'user'}) {
	$self->{'postgres_sameunix'} = $self->{'config_hash'}->{'sameunix'} = $self->{'in_hash'}->{'sameunix'};
	}
if ($self->is_postgresql_running() == -1) {
	$self->error($self->{'text_hash'}->{'login_epass'});
	}
if ($self->{'access_hash'}->{'user'}) {
	# Update this user's ACL
	$self->{'access_hash'}->{'user'} = $self->{'in_hash'}->{'login'};
	$self->{'access_hash'}->{'pass'} = $self->{'in_hash'}->{'pass'};
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
else {
	# Update global login
	$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
	chmod(0700, "$self->{'module_config_directory'}/config");
	}
$self->redirect("");

1;
		
}


1;

