#!/usr/bin/perl

&MAIN();

 sub MAIN {
# restore.cgi
# Restore a database from a local file, or from an uploaded file

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParseMime();

$self->error_setup( $self->{'text_hash'}->{'restore_err'} ) ;
$self->{'access_hash'}->{'restore'} || $self->error($self->{'text_hash'}->{'restore_ecannot'});
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});

# Work out where to restore from
if ($self->{'in_hash'}->{'src'} == 0) {
	-r $self->{'in_hash'}->{'path'} || $self->error($self->text('restore_pe2', $self->{'in_hash'}->{'path'}));
	$self->{'path'} = $self->{'in_hash'}->{'path'};
	$self->{'need_unlink'} = 0;
	}
else {
	$self->{'in_hash'}->{'data'} || $self->error($self->{'text_hash'}->{'restore_edata'});
	$self->{'path'} = $self->transname();
	$self->open_tempfile(DATA, ">$self->{'path'}");
	$self->print_tempfile(DATA, $self->{'in_hash'}->{'data'});
	$self->close_tempfile(DATA);
	}

$self->{'db_find_f'} = 0 ;

if ( $self->{'in_hash'}->{'db'} ) {

    foreach ( $self->list_databases() ) {

        if ( $_ eq $self->{'in_hash'}->{'db'} ) { $self->{'db_find_f'} = 1 ; }
    }
}

if ( $self->{'db_find_f'} == 0 ) { $self->error( $self->text( 'restore_edb' ) ) ; }

$self->{'err'} = $self->restore_database($self->{'in_hash'}->{'db'}, $self->{'path'}, $self->{'in_hash'}->{'only'}, $self->{'in_hash'}->{'clean'});
if ($self->{'err'}) {
	$self->error($self->text('restore_failed', "<pre>$self->{'err'}</pre>"));
	}
else {
	$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}") ;
	}

1;
		
}


1;

