#!/usr/bin/perl

&MAIN();

 sub MAIN {
# up.cgi
# Move a hosts list entry up

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'host_ecannot'});

$self->lock_file($self->{'config_hash'}->{'hba_conf'});
@{$self->{'hosts_array'}} = $self->get_hba_config();
$self->{'host'} = $self->{'hosts_array'}->[$self->{'in_hash'}->{'idx'}];
$self->swap_hba($self->{'host'}, $self->{'hosts_array'}->[$self->{'in_hash'}->{'idx'}-1]);
$self->unlock_file($self->{'config_hash'}->{'hba_conf'});
$self->restart_postgresql();
$self->webmin_log('move', 'hba',
		   $self->{'host'}->{'type'} eq 'local' ? 'local' :
		   $self->{'host'}->{'netmask'} eq '0.0.0.0' ? 'all' :
		   $self->{'host'}->{'netmask'} eq '255.255.255.255' ? $self->{'host'}->{'address'}:
		   "$self->{'host'}->{'address'}/$self->{'host'}->{'netmask'}", $self->{'host'});
$self->redirect("list_hosts.cgi");

1;
		
}


1;

