#!/usr/bin/perl
package pptp_client::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pptp_client::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p, $long) = @_;
$object = "<tt>". $self->html_escape($object)."</tt>";
if ($type eq 'tunnel') {
	return $self->text('log_'.$action, $object);
	}
elsif ($action eq 'conn') {
	if ($p->{'address'}) {
		return $self->text($long ? 'log_conn_l' : 'log_conn',
			     $object, $p->{'address'});
		}
	else {
		return $self->text('log_failed', $object);
		}
	}
elsif ($action eq 'disc') {
	return $self->text('log_disc', $object);
	}
else {
	return $self->{'text_hash'}->{'log_'.$action};
	}
}


1;

