#!/usr/bin/perl
package pptp_server::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pptp_server::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the pptp_server module
sub acl_security_form
{
	my $self = shift;

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_conf'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=conf value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'conf'} ? "checked" : "";
printf "<input type=radio name=conf value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'conf'} ? "" : "checked";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_options'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=options value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'options'} ? "checked" : "";
printf "<input type=radio name=options value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'options'} ? "" : "checked";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_secrets'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=secrets value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'secrets'} ? "checked" : "";
printf "<input type=radio name=secrets value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'secrets'} ? "" : "checked";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_conns'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=conns value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'conns'} ? "checked" : "";
printf "<input type=radio name=conns value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'conns'} ? "" : "checked";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_stop'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=stop value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'stop'} ? "checked" : "";
printf "<input type=radio name=stop value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'stop'} ? "" : "checked";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_apply'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=apply value=1 %s> $self->{'text_hash'}->{'yes'}\n",
          $_[0]->{'apply'} ? "checked" : "";
printf "<input type=radio name=apply value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
        $_[0]->{'apply'} ? "" : "checked";
}

# acl_security_save(&options)
# Parse the form for security options for the pptp_server module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'conf'} = $self->{'in_hash'}->{'conf'};
$_[0]->{'options'} = $self->{'in_hash'}->{'options'};
$_[0]->{'secrets'} = $self->{'in_hash'}->{'secrets'};
$_[0]->{'conns'} = $self->{'in_hash'}->{'conns'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'apply'} = $self->{'in_hash'}->{'apply'};
}


1;

