#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_conf.cgi
# Display PPTP server options

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'conf'} || $self->error($self->{'text_hash'}->{'conf_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'conf_title'}, "", "conf");

# Show actual options
$self->{'conf'} = $self->get_config();
print "<form action=save_conf.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'conf_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Maximum PPP speed
$self->{'speed'} = $self->find_conf("speed", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'conf_speed'}</b></td> <td>\n";
printf "<input type=radio name=speed_def value=1 %s> %s\n",
	$self->{'speed'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=speed_def value=0 %s>\n",
	$self->{'speed'} ? "checked" : "";
printf "<input name=speed size=8 value='%s'> %s</td>\n",
	$self->{'speed'}, $self->{'text_hash'}->{'conf_baud'};

# Listen address
$self->{'listen'} = $self->find_conf("listen", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'conf_listen'}</b></td> <td>\n";
printf "<input type=radio name=listen_def value=1 %s> %s\n",
	$self->{'listen'} ? "" : "checked", $self->{'text_hash'}->{'conf_all'};
printf "<input type=radio name=listen_def value=0 %s>\n",
	$self->{'listen'} ? "checked" : "";
printf "<input name=listen size=15 value='%s'></td> </tr>\n",
	$self->{'listen'};

# PPP options file
$self->{'option'} = $self->find_conf("option", $self->{'conf'});
$self->{'mode'} = $self->{'option'} eq $self->{'options_pptp'} ? 1 : $self->{'option'} ? 2 : 0;
print "<td><b>$self->{'text_hash'}->{'conf_option'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> %s\n",
	$self->{'mode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'conf_mode0'};
printf "<input type=radio name=mode value=1 %s> %s\n",
	$self->{'mode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'conf_mode1'};
printf "<input type=radio name=mode value=2 %s> %s\n",
	$self->{'mode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'conf_mode2'};
printf "<input name=option size=25 value='%s'>&nbsp;%s</td> </tr>\n",
	$self->{'mode'} == 2 ? $self->{'option'} : "", $self->file_chooser_button("option");

# Local IP ranges
&ip_table("localip");

# Remote IP ranges
&ip_table("remoteip");

# IPX networks
$self->{'ipxnets'} = $self->find_conf("ipxnets", $self->{'conf'});
($self->{'from'}, $self->{'to'}) = split(/-/, $self->{'ipxnets'});
print "<td><b>$self->{'text_hash'}->{'conf_ipxnets'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=ipxnets_def value=1 %s> %s\n",
	$self->{'ipxnets'} ? "" : "checked", $self->{'text_hash'}->{'conf_all'};
printf "<input type=radio name=ipxnets_def value=0 %s>\n",
	$self->{'ipxnets'} ? "checked" : "";
printf "<b>%s</b> <input name=from size=8 value='%s'>\n",
	$self->{'text_hash'}->{'conf_from'}, $self->{'from'};
printf "<b>%s</b> <input name=to size=8 value='%s'>\n",
	$self->{'text_hash'}->{'conf_to'}, $self->{'from'};
print "</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub ip_table
{
	shift if ($self == $_[0]);

local @ips = split(/,/, $self->find_conf($_[0], $self->{'conf'}));
print "<tr> <td valign=top><b>",$self->{'text_hash'}->{'conf_'.$_[0]},
      "</b></td> <td colspan=2>\n";
print "<textarea name=$_[0] rows=3 cols=50>",
	join("\n", @ips),"</textarea>\n";
print "</td>\n";
if ($_[0] eq "localip") {
	print "<td rowspan=2 valign=top>$self->{'text_hash'}->{'conf_ipdesc'}</td>\n";
	}
print "</tr>\n";
}


1;

