#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_conns.cgi
# List all active connections

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'conns'} || $self->error($self->{'text_hash'}->{'conns_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'conns_title'}, "", "conns");

@{$self->{'conns_array'}} = $self->list_connections();
if (@{$self->{'conns_array'}}) {
	print "$self->{'text_hash'}->{'conns_desc'}<p>\n";
	print $self->ui_columns_start([ $self->{'text_hash'}->{'conns_iface'},
				  $self->{'text_hash'}->{'conns_client'},
				  $self->{'text_hash'}->{'conns_stime'},
				  $self->{'text_hash'}->{'conns_local'},
				  $self->{'text_hash'}->{'conns_remote'},
				  $self->{'text_hash'}->{'conns_user'} ]);
	foreach $c (@{$self->{'conns_array'}}) {
		local @cols;
		push(@cols, "<a href='disc.cgi?pid=$c->[0]'>".
			    ($c->[3] ? "<tt>$c->[3]</tt>"
				     : $self->{'text_hash'}->{'conns_unknown'})."</a>");
		push(@cols, $c->[2]);
		push(@cols, $c->[6] || $self->{'text_hash'}->{'conns_unknown'});
		push(@cols, $c->[4] ? "<tt>$c->[4]</tt>"
				     : $self->{'text_hash'}->{'conns_unknown'});
		push(@cols, $c->[5] ? "<tt>$c->[5]</tt>"
				     : $self->{'text_hash'}->{'conns_unknown'});
		push(@cols, $c->[7] ? "<tt>$c->[7]</tt>"
				     : $self->{'text_hash'}->{'conns_unknown'});
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'conns_none'}</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

