#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_secret.cgi
# Update the secrets file to add or change a secret

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_secret_esave'});

$self->lock_file($self->{'config_hash'}->{'pap_file'});
if (defined($self->{'in_hash'}->{'idx'})) {
	$self->{'host'} = $self->get_ppp_hostname();
	@{$self->{'seclist_array'}} = grep { $_->{'server'} eq $self->{'host'} } $self->list_secrets();
	%{$self->{'sec_hash'}} = %{$self->{'seclist_array'}->[$self->{'in_hash'}->{'idx'}]};
	if ($self->{'in_hash'}->{'delete'}) {
		$self->delete_secret(\%{$self->{'sec_hash'}});
		$self->unlock_file($self->{'config_hash'}->{'pap_file'});
		$self->webmin_log("delete", "secret", $self->{'sec_hash'}->{'client'}, \%{$self->{'sec_hash'}});
		$self->redirect("list_secrets.cgi");
		exit;
		}
	}

if ($self->{'in_hash'}->{'client_def'}) { $self->{'sec_hash'}->{'client'} = ""; }
else { $self->{'sec_hash'}->{'client'} = $self->{'in_hash'}->{'client'}; }

$self->{'sec_hash'}->{'server'} = $self->get_ppp_hostname();

if ($self->{'in_hash'}->{'pass_mode'} == 0) { $self->{'sec_hash'}->{'secret'} = ""; }
elsif ($self->{'in_hash'}->{'pass_mode'} == 1) { $self->{'sec_hash'}->{'secret'} = "\@$self->{'in_hash'}->{'pass_file'}"; }
elsif ($self->{'in_hash'}->{'pass_mode'} == 3) { $self->{'sec_hash'}->{'secret'} = $self->opt_crypt($self->{'in_hash'}->{'pass_text'}); }

if ($self->{'in_hash'}->{'ips_mode'} == 0) { $self->{'sec_hash'}->{'ips'} = [ "*" ]; }
elsif ($self->{'in_hash'}->{'ips_mode'} == 1) { $self->{'sec_hash'}->{'ips'} = [ "-" ]; }
elsif ($self->{'in_hash'}->{'ips_mode'} == 2) {
	@{$self->{'ips_array'}} = split(/\s+/, $self->{'in_hash'}->{'ips'});
	foreach $ip (@{$self->{'ips_array'}}) {
		if (!gethostbyname($ip)) {
			$self->error($self->text('save_secret_enoip', $ip));
			}
		}
	$self->{'sec_hash'}->{'ips'} = \@{$self->{'ips_array'}};
	}

if (defined($self->{'in_hash'}->{'idx'})) { $self->change_secret(\%{$self->{'sec_hash'}}); }
else { $self->create_secret(\%{$self->{'sec_hash'}}); }
$self->unlock_file($self->{'config_hash'}->{'pap_file'});
delete($self->{'sec_hash'}->{'secret'});
$self->webmin_log(defined($self->{'in_hash'}->{'idx'}) ? "modify" : "create",
	    "secret", $self->{'sec_hash'}->{'client'}, \%{$self->{'sec_hash'}});
$self->redirect("list_secrets.cgi");

1;
		
}


1;

