#!/usr/bin/perl
package proc::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "proc::ProcLib");
$self = new proc::ProcLib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns the kernel log, on Linux systems
sub syslog_getlogs
{
	my $self = shift;

if ($self->{'gconfig_hash'}->{'os_type'} =~ /-linux$/) {
	return ( { 'cmd' => "dmesg",
		   'desc' => $self->{'text_hash'}->{'syslog_dmesg'},
		   'active' => 1, } );
	}
else {
	return ( );
	}
}


1;

