#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index_cpu.cgi

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "cpu", !$self->{'no_module_config'}, 1);

# Show CPU load and type
$self->index_links("cpu");
if ($self->UNIVERSAL::can('get_cpu_info')) {
	print "<table>\n";
	@{$self->{'c_array'}} = $self->get_cpu_info();
	if (@{$self->{'c_array'}}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'index_loadname'}</b></td>\n";
		print "<td>",$self->text('index_loadnums',
			"<tt>$self->{'c_array'}->[0]</tt>", "<tt>$self->{'c_array'}->[1]</tt>", "<tt>$self->{'c_array'}->[2]</tt>"),
			"</td> </tr>\n";
		if (@{$self->{'c_array'}} >= 5) {
			print "<tr> <td><b>$self->{'text_hash'}->{'index_cpuname'}</b></td>\n";
			print "<td>$self->{'c_array'}->[4] ($self->{'c_array'}->[3] MHz)</td> </tr>\n";
			}
		}
	print "</table><br>\n";
	}

print $self->ui_columns_start([ $self->{'text_hash'}->{'pid'}, $self->{'text_hash'}->{'owner'},
			  $self->{'text_hash'}->{'cpu'}, $self->{'text_hash'}->{'command'} ], 100);
@{$self->{'procs_array'}} = sort { $b->{'cpu'} <=> $a->{'cpu'} } $self->list_processes();
@{$self->{'procs_array'}} = grep { $self->can_view_process($_->{'user'}) } @{$self->{'procs_array'}};
foreach $pr (@{$self->{'procs_array'}}) {
	$self->{'p'} = $pr->{'pid'};
	local @cols;
	if ($self->can_edit_process($pr->{'user'})) {
		push(@cols, "<a href=\"edit_proc.cgi?$self->{'p'}\">$self->{'p'}</a>");
		}
	else {
		push(@cols, $self->{'p'});
		}
	push(@cols, $pr->{'user'});
	push(@cols, $pr->{'cpu'});
	push(@cols, $self->html_escape($self->cut_string($pr->{'args'})));
	print $self->ui_columns_row(\@cols);
	}
print $self->ui_columns_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

