#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index_cpu.cgi

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "size", !$self->{'no_module_config'}, 1);

$self->index_links("size");
if ($self->UNIVERSAL::can('get_memory_info')) {
	@{$self->{'m_array'}} = $self->get_memory_info();
	if (@{$self->{'m_array'}}) {
		print $self->text('index_mem2', $self->nice_size($self->{'m_array'}->[0]*1024),
			    $self->nice_size($self->{'m_array'}->[1]*1024)),"\n";
		print "&nbsp;&nbsp;",
			$self->text('index_swap2', $self->nice_size($self->{'m_array'}->[2]*1024),
					     $self->nice_size($self->{'m_array'}->[3]*1024)),"<p>\n";
		}
	}
print $self->ui_columns_start([
	$self->{'text_hash'}->{'pid'},
	$self->{'text_hash'}->{'owner'},
	$self->{'text_hash'}->{'size'},
	$self->{'text_hash'}->{'command'}
	], 100);

@{$self->{'procs_array'}} = sort { $b->{'size'} <=> $a->{'size'} } $self->list_processes();
@{$self->{'procs_array'}} = grep { $self->can_view_process($_->{'user'}) } @{$self->{'procs_array'}};
foreach $pr (@{$self->{'procs_array'}}) {
	$self->{'p'} = $pr->{'pid'};
	local @cols;
	if ($self->can_edit_process($pr->{'user'})) {
		push(@cols, "<a href=\"edit_proc.cgi?$self->{'p'}\">$self->{'p'}</a>");
		}
	else {
		push(@cols, $self->{'p'});
		}
	push(@cols, $pr->{'user'});
	push(@cols, $pr->{'size'});
	push(@cols, $self->html_escape($self->cut_string($pr->{'args'})));
	print $self->ui_columns_row(\@cols);
	}
print $self->ui_columns_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

