#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'id'}) {
	$self->{'idfile'} = "$self->{'module_config_directory'}/$self->{'in_hash'}->{'id'}.tail";
	open(IDFILE, ">$self->{'idfile'}");
	print IDFILE $$,"\n";
	close(IDFILE);
	$SIG{'HUP'} = "hup_handler";
	}
$| = 1;
print "Content-type: text/plain\n\n";
$self->{'trace'} = $self->open_process_trace($self->{'in_hash'}->{'pid'},
			     $self->{'in_hash'}->{'syscalls'} ? [ split(/\s+/, $self->{'in_hash'}->{'syscalls'}) ]
					     : undef);
while($self->{'action'} = $self->read_process_trace($self->{'trace'})) {
	local $tm = $self->strftime("%H:%M:%S", localtime($self->{'action'}->{'time'}));
	print join("\t", $tm, $self->{'action'}->{'call'},
			 join(", ", @{$self->{'action'}->{'args'}}),
			 $self->{'action'}->{'rv'}),"\n";
	}
$self->close_process_trace($self->{'trace'});
unlink($self->{'idfile'}) if ($self->{'idfile'});

1;
		
}

sub hup_handler
{
	shift if ($self == $_[0]);

$self->close_process_trace($self->{'trace'});
unlink($self->{'idfile'});
exit;
}


1;

