#!/usr/bin/perl
package proftpd::Mod_pam;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_pam');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_pam.pl

1;
		return $self;
}

sub mod_pam_directives
{
	my $self = shift;

local $rv = [
	[ 'AuthPAM', 0, 6, 'virtual global', 1.20 ],
	[ 'AuthPAMConfig', 0, 6, 'virtual global', 1.20 ]
	];
return $self->make_directives($rv, $_[0], "mod_pam");
}

sub edit_AuthPAM
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_pam_pam'},
	$self->choice_input($_[0]->{'value'}, "AuthPAM", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_AuthPAM
{
	my $self = shift;

return $self->parse_choice("AuthPAM", "");
}

sub edit_AuthPAMConfig
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_pam_config'},
	$self->opt_input($_[0]->{'value'}, "AuthPAMConfig", $self->{'text_hash'}->{'default'}, 15));
}

sub save_AuthPAMConfig
{
	my $self = shift;

return $self->parse_opt("AuthPAMConfig", '^\S+$', $self->{'text_hash'}->{'mod_pam_econfig'});
}


1;

