#!/usr/bin/perl
package proftpd::Mod_site;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_site');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_site.pl

1;
		return $self;
}

sub mod_site_directives
{
	my $self = shift;

local $rv = [
#	[ 'AllowChmod', 0, 3, 'virtual directory anon limit ftpaccess global', 1.20 ]
	];
return $self->make_directives($rv, $_[0], "mod_site");
}

sub edit_AllowChmod
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_site_chmod'},
	$self->choice_input($_[0]->{'value'}, "AllowChmod", "",
		      "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off",
		      "$self->{'text_hash'}->{'default'},"));
}

sub save_AllowChmod
{
	my $self = shift;

return $self->parse_choice("AllowChmod", "");
}


1;

