#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_dir.cgi
# Add a new <Directory> section to a virtual server

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
	$self->{'conf'} = $self->{'anon'}->{'members'};
	}
$self->error_setup($self->{'text_hash'}->{'dserv_err'});

# Validate inputs
$self->{'in_hash'}->{'dir'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'dserv_edir'});
!$self->{'anon'} || $self->{'in_hash'}->{'dir'} !~ /^\// || $self->{'anon'}->{'value'} =~ /^\~/ ||
	$self->is_under_directory($self->{'anon'}->{'value'}, $self->{'in_hash'}->{'dir'}) ||
		$self->error($self->{'text_hash'}->{'dserv_eanondir'});

# Add the directory
$self->{'l'} = $self->{'conf'}->[@{$self->{'conf'}} - 1];
$self->lock_file($self->{'l'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
@{$self->{'lines_array'}} = ( "<Directory $self->{'in_hash'}->{'dir'}>", "</Directory>" );
splice(@{$self->{'lref'}}, $self->{'l'}->{'eline'}+1, 0, @{$self->{'lines_array'}});
$self->flush_file_lines();
$self->after_changing();
$self->unlock_file($self->{'l'}->{'file'});
$self->webmin_log("dir", "create", "$self->{'v'}->{'value'}:$self->{'in_hash'}->{'dir'}", \%{$self->{'in_hash'}});
$self->redirect("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}&idx=".scalar(@{$self->{'conf'}}));

1;
		
}


1;

