#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_ftpaccess.cgi
# Creates a new .ftpaccess file for some directory

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();

if (-d $self->{'in_hash'}->{'file'}) {
	# user entered a directory.. create a file in that directory
	$self->{'file'} = "$self->{'in_hash'}->{'file'}/.ftpaccess";
	}
else { $self->{'file'} = $self->{'in_hash'}->{'file'}; }

# create the file (if needed), and add to the known list
$self->lock_file($self->{'file'});
if (!(-r $self->{'file'})) {
	$self->open_lock_tempfile(FTPACCESS, ">$self->{'file'}") || $self->error($!);
	$self->close_tempfile(FTPACCESS);
	chmod(0755, $self->{'file'});
	}
$self->{'site_hash'}->{'ftpaccess'} = join(' ', $self->unique(@{$self->{'ftpaccess_files_array'}}, $self->{'file'}));
$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
$self->unlock_file($self->{'file'});
$self->webmin_log("ftpaccess", "create", $self->{'file'});

# redirect to editing index
$self->redirect("ftpaccess_index.cgi?file=".$self->urlize($self->{'file'}));

1;
		
}


1;

