#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_limit.cgi
# Create a new <Limit> section

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'file'}) {
	$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->{'conf'} = $self->get_config();
		$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
		}
	else {
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		}
	if ($self->{'in_hash'}->{'anon'}) {
		$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
		$self->{'conf'} = $self->{'anon'}->{'members'};
		}
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}]->{'members'};
		}
	}
$self->error_setup($self->{'text_hash'}->{'lserv_err'});

# Validate inputs
$self->{'in_hash'}->{'cmd'} =~ /\S/ || $self->error($self->{'text_hash'}->{'lserv_ecmd'});

# Add the limit
$self->{'l'} = $self->{'conf'}->[@{$self->{'conf'}} - 1];
$self->lock_file($self->{'l'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'l'}->{'file'});
@{$self->{'lines_array'}} = ( "<Limit $self->{'in_hash'}->{'cmd'}>", "</Limit>" );
splice(@{$self->{'lref'}}, $self->{'l'}->{'eline'}+1, 0, @{$self->{'lines_array'}});
$self->flush_file_lines();
$self->after_changing();
$self->unlock_file($self->{'l'}->{'file'});
$self->webmin_log("limit", "create", $self->{'in_hash'}->{'cmd'}, \%{$self->{'in_hash'}});
if ($self->{'in_hash'}->{'file'}) {
	$self->redirect("limit_index.cgi?file=$self->{'in_hash'}->{'file'}&limit=".scalar(@{$self->{'conf'}}));
	}
else {
	$self->redirect("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}&limit=".scalar(@{$self->{'conf'}}));
	}

1;
		
}


1;

