#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_virt.cgi
# Display a form for editing some kind of per-directory options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'vconf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
	$self->{'vconf'} = $self->{'anon'}->{'members'};
	}
$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'conf'} = $self->{'d'}->{'members'};
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'directory');
$self->{'dn'} = $self->{'d'}->{'words'}->[0];
$self->{'desc'} = $self->{'in_hash'}->{'global'} ? $self->text('dir_header5', $self->{'dn'}) :
	$self->{'in_hash'}->{'anon'} ? $self->text('dir_header4', $self->{'dn'}) :
	$self->{'in_hash'}->{'virt'} ? $self->text('dir_header1', $self->{'dn'}, $self->{'v'}->{'words'}->[0]) :
	$self->text('dir_header2', $self->{'dn'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "",
	undef, undef, undef, undef, $self->restart_button());

print "<form method=post action=save_dir.cgi method=post>\n";
print "<input type=hidden name=type value=$self->{'in_hash'}->{'type'}>\n";
print "<input type=hidden name=idx value=$self->{'in_hash'}->{'idx'}>\n";
print "<input type=hidden name=virt value=$self->{'in_hash'}->{'virt'}>\n";
print "<input type=hidden name=anon value=$self->{'in_hash'}->{'anon'}>\n";
print "<input type=hidden name=global value=$self->{'in_hash'}->{'global'}>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('dir_header3', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"},
			       $self->{'d'}->{'words'}->[0]),"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print "</table></td> </tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

if ($self->{'in_hash'}->{'global'}) {
	$self->ui_print_footer("dir_index.cgi?idx=$self->{'in_hash'}->{'idx'}&global=$self->{'in_hash'}->{'global'}",
		$self->{'text_hash'}->{'dir_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'anon'}) {
	$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{anon}",
		$self->{'text_hash'}->{'dir_return'},
		"anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'anon_return'},
		"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}",
		$self->{'text_hash'}->{'dir_return'},
		"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

