#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dserv.cgi
# Edit <Directory> section details

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
	$self->{'conf'} = $self->{'anon'}->{'members'};
	}
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'dn'} = $self->{'d'}->{'words'}->[0];
$self->{'dconf'} = $self->{'d'}->{'members'};
$self->{'desc'} = $self->{'in_hash'}->{'global'} ? $self->text('dir_header5', $self->{'dn'}) :
	$self->{'in_hash'}->{'anon'} ? $self->text('dir_header4', $self->{'dn'}) :
	$self->{'in_hash'}->{'virt'} ?  $self->text('dir_header1', $self->{'dn'}, $self->{'v'}->{'words'}->[0]) :
	$self->text('dir_header2', $self->{'dn'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dserv_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

print "<form action=save_dserv.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=anon value='$self->{'in_hash'}->{'anon'}'>\n";
print "<input type=hidden name=global value='$self->{'in_hash'}->{'global'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'dserv_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'dserv_dir'}</b></td>\n";
printf "<td><input name=dir size=40 value='%s'> %s</td> </tr>\n",
	$self->{'d'}->{'value'}, $self->file_chooser_button("dir", 1);

print "<tr> <td colspan=2 align=right>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "<input type=submit name=delete value=\"$self->{'text_hash'}->{'dserv_delete'}\">\n";
print "</td> </tr>\n";

print "</table> </td></tr></table><p>\n";
print "</form>\n";

if ($self->{'in_hash'}->{'global'}) {
	$self->ui_print_footer("dir_index.cgi?global=$self->{'in_hash'}->{'global'}&idx=$self->{'in_hash'}->{'idx'}",
		$self->{'text_hash'}->{'dir_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'anon'}) {
	$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{anon}",
		$self->{'text_hash'}->{'dir_return'},
		"anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'anon_return'},
		"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}",
		$self->{'text_hash'}->{'dir_return'},
		"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

