#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_virt.cgi
# Save some kind of per-directory configuration

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'global'}) {
	$self->{'conf'} = $self->get_config();
	$self->{'vconf'} = $self->get_or_create_global($self->{'conf'});
	}
else {
	($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
	}
if ($self->{'in_hash'}->{'anon'}) {
	$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
	$self->{'vconf'} = $self->{'anon'}->{'members'};
	}
$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'conf'} = $self->{'d'}->{'members'};
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'directory');

$self->lock_file($self->{'d'}->{'file'});
$self->{'tn'} = $self->{'type_name_array'}->[$self->{'in_hash'}->{'type'}]; $self->{'tn'} =~ tr/A-Z/a-z/;
$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->get_config());
$self->unlock_file($self->{'d'}->{'file'});
$self->webmin_log("dir", $self->{'in_hash'}->{'type'},
	    "$self->{'v'}->{'value'}:$self->{'d'}->{'words'}->[0]", \%{$self->{'in_hash'}});

$self->redirect("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}");
1;
		
}


1;

