#!/usr/bin/perl

&MAIN();

 sub MAIN {
# virt_index.cgi
# Display a menu for some specific virtual server, or the default server

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->{'desc'} = $self->{'in_hash'}->{'virt'} eq '' ? $self->{'text_hash'}->{'virt_header2'} :
	      $self->text('virt_header1', $self->{'v'}->{'value'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'virt_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

# Display header and icons
print "<h3>$self->{'text_hash'}->{'virt_opts'}</h3>\n";
$self->{'anon_icon'} = { "icon" => "images/anon.gif",
	       "name" => $self->{'text_hash'}->{'virt_anon'},
	       "link" => "anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}" };
$self->{'virt_icon'} = { "icon" => "images/virt.gif",
	       "name" => $self->{'text_hash'}->{'virt_virt'},
	       "link" => "edit_vserv.cgi?virt=$self->{'in_hash'}->{'virt'}" };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'virt_edit'},
	     "link" => "manual_form.cgi?virt=$self->{'in_hash'}->{'virt'}" };
$self->config_icons("virtual", "edit_virt.cgi?virt=$self->{'in_hash'}->{'virt'}&",
	      $self->{'anon_icon'}, $self->{'in_hash'}->{'virt'} ? ( $self->{'virt_icon'}, $self->{'ed_icon'} ) : ( ) );

# Display per-directory/limit options
@{$self->{'dir_array'}} = ( $self->find_directive_struct("Directory", $self->{'conf'}) ,
	 $self->find_directive_struct("Limit", $self->{'conf'}) );
if (@{$self->{'dir_array'}}) {
	print "<hr>\n";
	print "<h3>$self->{'text_hash'}->{'virt_header'}</h3>\n";
	foreach $d (@{$self->{'dir_array'}}) {
		if ($d->{'name'} eq 'Limit') {
			push(@{$self->{'links_array'}}, "limit_index.cgi?limit=".
				     $self->indexof($d, @{$self->{'conf'}})."&virt=$self->{'in_hash'}->{'virt'}");
			push(@{$self->{'titles_array'}}, $self->text('virt_limit', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/limit.gif");
			}
		else {
			push(@{$self->{'links_array'}}, "dir_index.cgi?idx=".
				     $self->indexof($d, @{$self->{'conf'}})."&virt=$self->{'in_hash'}->{'virt'}");
			push(@{$self->{'titles_array'}}, $self->text('virt_dir', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/dir.gif");
			}
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
	}

print "<table width=100%><tr><td>\n";

print "<form action=create_dir.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_adddir'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_path'}</b></td>\n";
print "<td><input name=dir size=30>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td><td>\n";

print "<form action=create_limit.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_addlimit'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_cmds'}</b></td>\n";
print "<td><input name=cmd size=20>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td></tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

