#!/usr/bin/perl
package pserver::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pserver::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pserver::PserverLib");
$self = new pserver::PserverLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Create a new CVS user if syncing is enabled
sub useradmin_create_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_create'}) {
	local $salt = chr(int(rand(26))+65) . chr(int(rand(26))+65);
	local $user = { 'user' => $_[0]->{'user'},
			'pass' => $_[0]->{'passmode'} == 3 ?
			    $self->unix_crypt($_[0]->{'plainpass'}, $salt) : $_[0]->{'pass'},
			'unix' => $self->{'config_hash'}->{'sync_user'} };
	$self->create_password($user);
	}
}

# useradmin_delete_user(&details)
# Delete a mysql user
sub useradmin_delete_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_delete'}) {
	local @passwd = $self->list_passwords();
	local ($user) = grep { $_->{'user'} eq $_[0]->{'user'} } @passwd;
	$self->delete_password($user) if ($user);
	}
}

# useradmin_modify_user(&details)
# Update a mysql user
sub useradmin_modify_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_modify'}) {
	local @passwd = $self->list_passwords();
	local ($user) = grep { $_->{'user'} eq $_[0]->{'olduser'} } @passwd;
	if ($user) {
		local $salt = chr(int(rand(26))+65) . chr(int(rand(26))+65);
		$user->{'user'} = $_[0]->{'user'};
		if ($_[0]->{'passmode'} == 3) {
			$user->{'pass'} = $self->unix_crypt($_[0]->{'plainpass'}, $salt);
			}
		elsif ($_[0]->{'passmode'} != 4) {
			$user->{'pass'} = $_[0]->{'pass'};
			}
		$self->modify_password($user);
		}
	}
}


1;

