#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for various things that can be configured in qmail

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;


$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("qmail", "man:$self->{'config_hash'}->{'qmail_dir'}/man", "google"));

# Check if qmail is installed
if (!-d $self->{'config_hash'}->{'qmail_dir'}) {
	print $self->text('index_edir', "<tt>$self->{'config_hash'}->{'qmail_dir'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}
if (!-d $self->{'qmail_alias_dir'} || !-d $self->{'qmail_bin_dir'}) {
	print $self->text('index_edir2', "<tt>$self->{'config_hash'}->{'qmail_dir'}</tt>",
		  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'olinks_array'}} = ( "list_opts.cgi", "list_aliases.cgi", "list_virts.cgi",
	    "list_locals.cgi", "list_rcpts.cgi", "list_bads.cgi",
	    "list_routes.cgi", "list_percents.cgi", "list_assigns.cgi",
	    "list_queue.cgi",
	    $self->foreign_available("mailboxes") ? ( "../mailboxes/" ) : ( ) );

if (!$self->{'config_hash'}->{'mailq_count'}) {
	@{$self->{'queue_array'}} = $self->list_queue();
	}
@{$self->{'otitles_array'}} = ( "$self->{'text_hash'}->{'opts_title'}<br>(control)</tt>",
	     "$self->{'text_hash'}->{'aliases_title'}<br>(alias)",
	     "$self->{'text_hash'}->{'virts_title'}<br>(virtualdomains)",
	     "$self->{'text_hash'}->{'locals_title'}<br>(locals)",
	     "$self->{'text_hash'}->{'rcpts_title'}<br>(rcpthosts)",
	     "$self->{'text_hash'}->{'bads_title'}<br>(badmailfrom)",
	     "$self->{'text_hash'}->{'routes_title'}<br>(smtproutes)",
	     "$self->{'text_hash'}->{'percents_title'}<br>(percenthack)",
	     "$self->{'text_hash'}->{'assigns_title'}<br>(assign)",
	     defined(@{$self->{'queue_array'}}) ?
	       "$self->{'text_hash'}->{'queue_title'}<br>".$self->text('queue_count', scalar(@{$self->{'queue_array'}})) :
	       "$self->{'text_hash'}->{'queue_title'}<br>(qmail-qread)",
	     $self->{'text_hash'}->{'boxes_title'} );

@{$self->{'oicons_array'}} = ( "images/opts.gif", "images/aliases.gif", "images/virts.gif",
	    "images/locals.gif", "images/rcpts.gif", "images/bads.gif",
	    "images/routes.gif", "images/percents.gif", "images/assigns.gif",
	    "images/queue.gif", "images/boxes.gif" );

$self->icons_table(\@{$self->{'olinks_array'}}, \@{$self->{'otitles_array'}}, \@{$self->{'oicons_array'}});

# Check if the qmail processes are running
print "<hr>\n";
print "<table cellpadding=5 width=100%><tr>\n";
($self->{'pid'}) = $self->find_byname("qmail-send");
if ($self->{'pid'} && kill(0, $self->{'pid'})) {
	print "<form action=stop.cgi>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_stop'}\">\n";
	print "</td> <td>$self->{'text_hash'}->{'index_stopmsg'}\n";
	}
else {
	print "<form action=start.cgi>\n";
	print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_start'}\">\n";
	print "</td> <td>",$self->text('index_startmsg',
	      "<tt>$self->{'qmail_start_cmd'}</tt>"),"</td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

