#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display the current qmail queue

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'queue_title'}, "");

@{$self->{'queue_array'}} = $self->list_queue();
if ($self->{'config_hash'}->{'mailq_sort'} == 0) {
	@{$self->{'queue_array'}} = sort { $a->{'id'} cmp $b->{'id'} } @{$self->{'queue_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 1) {
	@{$self->{'queue_array'}} = sort { lc(&address_parts($a->{'from'})) cmp lc(&address_parts($b->{'from'})) } @{$self->{'queue_array'}};
	}
elsif ($self->{'config_hash'}->{'mailq_sort'} == 2) {
	@{$self->{'queue_array'}} = sort { lc(&address_parts($a->{'to'})) cmp lc(&address_parts($b->{'to'})) } @{$self->{'queue_array'}};
	}

if (@{$self->{'queue_array'}}) {
	if (@{$self->{'queue_array'}} > $self->{'config_hash'}->{'perpage'}) {
		# Need to show arrows
		print "<center>\n";
		$self->{'s'} = int($self->{'in_hash'}->{'start'});
		$self->{'e'} = $self->{'in_hash'}->{'start'} + $self->{'config_hash'}->{'perpage'} - 1;
		$self->{'e'} = @{$self->{'queue_array'}}-1 if ($self->{'e'} >= @{$self->{'queue_array'}});
		if ($self->{'s'}) {
			printf "<a href='list_queue.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} - $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/left.gif border=0 align=middle>";
			}
		print "<font size=+1>",$self->text('mail_pos', $self->{'s'}+1, $self->{'e'}+1,
					     scalar(@{$self->{'queue_array'}})),"</font>\n";
		if ($self->{'e'} < @{$self->{'queue_array'}}-1) {
			printf "<a href='list_queue.cgi?start=%d'>%s</a>\n",
			    $self->{'s'} + $self->{'config_hash'}->{'perpage'},
			    "<img src=/images/right.gif border=0 align=middle>";
			}
		print "</center>\n";
		}
	else {
		# Can show them all
		$self->{'s'} = 0;
		$self->{'e'} = @{$self->{'queue_array'}} - 1;
		}
	print "<form action=delete_queues.cgi>\n";
	print $self->select_all_link("file", 0, $self->{'text_hash'}->{'queue_all'}),"&nbsp;\n";
	print $self->select_invert_link("file", 0, $self->{'text_hash'}->{'queue_invert'}),"<br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><br></td> <td><b>$self->{'text_hash'}->{'queue_id'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'queue_date'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'queue_from'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'queue_to'}</b></td> </tr>\n";
	for($i=$self->{'s'}; $i<=$self->{'e'}; $i++) {
		$self->{'q'} = $self->{'queue_array'}->[$i];
		print "<tr $self->{'cb'}>\n";
		print "<td><input type=checkbox name=file value=$self->{'q'}->{'file'}></td>\n";
		print "<td><a href='view_queue.cgi?file=$self->{'q'}->{'file'}'>$self->{'q'}->{'id'}</a></td>\n";
		print "<td>$self->{'q'}->{'date'}</td>\n";
		print "<td>",$self->html_escape($self->{'q'}->{'from'}),"</td>\n";
		print "<td>",$self->html_escape($self->{'q'}->{'to'}),"</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	print $self->select_all_link("file", 0, $self->{'text_hash'}->{'queue_all'}),"&nbsp;\n";
	print $self->select_invert_link("file", 0, $self->{'text_hash'}->{'queue_invert'}),"<p>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'queue_delete'}'><p>\n";
	print "</form>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'queue_none'}</b> <p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

