#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_virts.cgi
# Display a list of virtual domain mappings

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'virts_title'}, "");

@{$self->{'virts_array'}} = $self->list_virts();
print $self->text('virts_desc', "list_aliases.cgi"),"<p>\n";
$self->virt_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'virts_array'}} = grep { $_->{'from'} =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'virts_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'virts_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'virts_toomany'},"<br>\n";
	print "<form action=list_virts.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'virts_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'virts_array'}});
	}

if (@{$self->{'virts_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'virts_array'}} = sort { lc($a->{'from'}) cmp lc($b->{'from'}) }
			       @{$self->{'virts_array'}};
		}

	# render tables
        print $self->ui_form_start("delete_virts.cgi", "post");
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
	if ($self->{'config_hash'}->{'columns'} == 2) {
		$self->{'mid'} = int((@{$self->{'virts_array'}}+1)/2);
		print "<table width=100%> <tr><td width=50% valign=top>\n";
		&virts_table(@{$self->{'virts_array'}}[0..$self->{'mid'}-1]);
		print "</td><td width=50% valign=top>\n";
		if ($self->{'mid'} < @{$self->{'virts_array'}}) { &virts_table(@{$self->{'virts_array'}}[$self->{'mid'}..$#{$self->{'virts_array'}}]); }
		print "</td></tr> </table><br>\n";
		}
	else {
		&virts_table(@{$self->{'virts_array'}});
		}
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
        print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'virts_delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub virts_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td width=5><br></td> <td><b>$self->{'text_hash'}->{'virts_from'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'virts_prepend'}</b></td> </tr>\n";
foreach $v (@_) {
	print "<tr $self->{'cb'}>\n";
	print "<td width=5>",$self->ui_checkbox("d", $v->{'from'}),"</td>\n";
	print "<td valign=top><a href=\"edit_virt.cgi?idx=$v->{'idx'}\">",
	      ($v->{'from'} ? $self->html_escape($v->{'from'})
			    : "<i>$self->{'text_hash'}->{'virts_all'}</i>"),"</a></td>\n";
	print "<td>",($v->{'prepend'} ? $self->html_escape($v->{'prepend'}) :
	      "<i>$self->{'text_hash'}->{'virts_none'}</i>"),"</td> </tr>\n";
	}
print "</table>\n";
}


1;

