#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_route.cgi
# Save or delete an SMTP route

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'rsave_err'});

@{$self->{'routes_array'}} = $self->list_routes();
$self->{'r'} = $self->{'routes_array'}->[$self->{'in_hash'}->{'idx'}] if (defined($self->{'in_hash'}->{'idx'}));

if ($self->{'in_hash'}->{'delete'}) {
	# delete some route
	$self->{'logr'} = $self->{'r'};
	$self->delete_route($self->{'r'});
	}
else {
	# saving or creating .. check inputs
	$self->{'in_hash'}->{'from'} =~ /^[A-Za-z0-9\.\-]+$/ ||
		$self->error($self->text('rsave_efrom', $self->{'in_hash'}->{'from'}));
	$self->{'in_hash'}->{'to_def'} || gethostbyname($self->{'in_hash'}->{'to'}) ||
		$self->check_ipaddress($self->{'in_hash'}->{'to'}) ||
			$self->error($self->text('rsave_eto', $self->{'in_hash'}->{'to'}));
	$self->{'in_hash'}->{'port_def'} || $self->{'in_hash'}->{'port'} =~ /^\d+$/ ||
		$self->error($self->text('rsave_eport', $self->{'in_hash'}->{'port'}));
	$self->{'newr_hash'}->{'from'} = $self->{'in_hash'}->{'from'};
	$self->{'newr_hash'}->{'to'} = $self->{'in_hash'}->{'to'};
	$self->{'newr_hash'}->{'port'} = $self->{'in_hash'}->{'port'} if (!$self->{'in_hash'}->{'port_def'});

	if ($self->{'in_hash'}->{'new'}) { $self->create_route(\%{$self->{'newr_hash'}}); }
	else { $self->modify_route($self->{'r'}, \%{$self->{'newr_hash'}}); }
	$self->{'logr'} = \%{$self->{'newr_hash'}};
	}
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "route", $self->{'logr'}->{'from'}, $self->{'logr'});
$self->redirect("list_routes.cgi");

1;
		
}


1;

