#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_virt.cgi
# Save or delete a new or existing virtual mapping

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'vsave_err'});

@{$self->{'virts_array'}} = $self->list_virts();
$self->{'v'} = $self->{'virts_array'}->[$self->{'in_hash'}->{'idx'}] if ($self->{'in_hash'}->{'idx'} ne '');

if ($self->{'in_hash'}->{'delete'}) {
	# delete some virt
	$self->{'logv'} = $self->{'v'};
	$self->delete_virt($self->{'v'});
	}
else {
	# saving or creating .. check inputs
	if ($self->{'in_hash'}->{'from_mode'} == 1) {
		$self->{'in_hash'}->{'domain'} =~ /^[A-Za-z0-9\.\-]+$/ ||
			$self->error($self->text('vsave_edomain', $self->{'in_hash'}->{'domain'}));
		$self->{'newv_hash'}->{'domain'} = $self->{'in_hash'}->{'domain'};
		}
	elsif ($self->{'in_hash'}->{'from_mode'} == 2) {
		$self->{'in_hash'}->{'user'} =~ /^[^\@: ]+$/ ||
			$self->error($self->text('vsave_euser', $self->{'in_hash'}->{'user'}));
		$self->{'in_hash'}->{'domain2'} =~ /^[A-Za-z0-9\.\-]+$/ ||
			$self->error($self->text('vsave_edomain', $self->{'in_hash'}->{'domain2'}));
		$self->{'newv_hash'}->{'domain'} = $self->{'in_hash'}->{'domain2'};
		$self->{'newv_hash'}->{'user'} = $self->{'in_hash'}->{'user'};
		}
	if ($self->{'in_hash'}->{'prepend_mode'} == 1) {
		$self->{'in_hash'}->{'prepend'} =~ /^[^\@: ]+$/ ||
			$self->error($self->text('vsave_eprepend', $self->{'in_hash'}->{'prepend'}));
		$self->{'newv_hash'}->{'prepend'} = $self->{'in_hash'}->{'prepend'};
		}
	elsif ($self->{'in_hash'}->{'prepend_mode'} == 0) {
		$self->{'in_hash'}->{'from_mode'} || $self->error($self->{'text_hash'}->{'vsave_eboth'});
		}
	elsif ($self->{'in_hash'}->{'prepend_mode'} == 2) {
		if ($self->{'in_hash'}->{'from_mode'} == 1) {
			$self->{'newv_hash'}->{'prepend'} = $self->{'in_hash'}->{'domain'};
			$self->{'newv_hash'}->{'prepend'} =~ s/\.(.*)$//;
			}
		elsif ($self->{'in_hash'}->{'from_mode'} == 2) {
			$self->{'newv_hash'}->{'prepend'} = $self->{'in_hash'}->{'domain2'};
			$self->{'newv_hash'}->{'prepend'} =~ s/\.(.*)$//;
			}
		else {
			$self->{'newv_hash'}->{'prepend'} = 'catchall';
			}
		}
	if ($self->{'in_hash'}->{'new'}) { $self->create_virt(\%{$self->{'newv_hash'}}); }
	else { $self->modify_virt($self->{'v'}, \%{$self->{'newv_hash'}}); }
	$self->{'logv'} = \%{$self->{'newv_hash'}};
	}
$self->restart_qmail();
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "virt", $self->{'logv'}->{'user'} ? "$self->{'logv'}->{'user'}\@$self->{'logv'}->{'domain'}" :
		    $self->{'logv'}->{'domain'}, $self->{'logv'});
$self->redirect("list_virts.cgi");

1;
		
}


1;

