#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_queue.cgi
# Display some message from the mail queue

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();

$self->{'mail'} = $self->read_mail_file($self->{'in_hash'}->{'file'});
$self->parse_mail($self->{'mail'});

$self->{'desc'} = $self->text('qview_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'qview_title'}, "");

print "<form action=delete_queue.cgi method=post>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<table width=100% border=1>\n";
print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'qview_headers'}</b></td> </tr>\n";
print "<tr> <td $self->{'cb'}><table width=100%>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'queue_from'}</b></td> ",
      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'queue_to'}</b></td> ",
      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'queue_cc'}</b></td> ",
      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
	if ($self->{'mail'}->{'header'}->{'cc'});
print "<tr> <td><b>$self->{'text_hash'}->{'queue_date'}</b></td> ",
      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'date'}),"</td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'queue_subject'}</b></td> ",
      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'subject'}),"</td> </tr>\n";
print "</table></td></tr></table><p>\n";

# Find body attachment
@{$self->{'attach_array'}} = @{$self->{'mail'}->{'attach'}};
foreach $a (@{$self->{'attach_array'}}) {
	if ($a->{'type'} eq 'text/plain') {
		$self->{'body'} = $a;
		last;
		}
	}
if ($self->{'body'}) {
	print "<table width=100% border=1><tr><td $self->{'cb'}><pre>\n";
	foreach $l ($self->wrap_lines($self->{'body'}->{'data'}, $self->{'config_hash'}->{'wrap_width'})) {
		print $self->link_urls_and_escape($l),"\n";
		}
	print "</pre></td></tr></table><p>\n";
	}

# Display other attachments
@{$self->{'attach_array'}} = grep { $_ ne $self->{'body'} } @{$self->{'attach_array'}};
@{$self->{'attach_array'}} = grep { !$_->{'attach'} } @{$self->{'attach_array'}};
if (@{$self->{'attach_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'qview_attach'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $a (@{$self->{'attach_array'}}) {
		push(@{$self->{'titles_array'}}, $a->{'filename'} ? $a->{'filename'}
					       : $a->{'type'});
		push(@{$self->{'links_array'}}, "detach_queue.cgi?file=$self->{'in_hash'}->{'file'}&attach=$a->{'idx'}");
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

print "<input type=submit value='$self->{'text_hash'}->{'delete'}'></form>\n";

$self->ui_print_footer("list_queue.cgi", $self->{'text_hash'}->{'queue_return'});

1;
		
}


1;

