#!/usr/bin/perl

&MAIN();

 sub MAIN {
# activate.cgi
# Turn quotas on or off for some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->can_edit_filesys($self->{'in_hash'}->{'dir'}) && $self->{'access_hash'}->{'enable'} ||
	$self->error($self->{'text_hash'}->{'activate_eallow'});

if ($self->{'in_hash'}->{'active'} == 0) {
	# Turn on quotas
	$self->{'whatfailed'} = $self->{'text_hash'}->{'activate_eon'};
	if ($self->{'error'} = $self->quotaon($self->{'in_hash'}->{'dir'}, $self->{'in_hash'}->{'mode'})) {
		$self->error($self->{'error'});
		}
	$self->webmin_log("activate", undef, $self->{'in_hash'}->{'dir'}, \%{$self->{'in_hash'}});
	}
else {
	# Turn off quotas
	$self->{'whatfailed'} = $self->{'text_hash'}->{'activate_eoff'};
	if ($self->{'error'} = $self->quotaoff($self->{'in_hash'}->{'dir'}, $self->{'in_hash'}->{'mode'})) {
		$self->error($self->{'error'});
		}
	$self->webmin_log("deactivate", undef, $self->{'in_hash'}->{'dir'}, \%{$self->{'in_hash'}});
	}
$self->redirect("");

1;
		
}


1;

