#!/usr/bin/perl

&MAIN();

 sub MAIN {
# check_quotas.cgi
# Runs quotacheck to update block and file counts on some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'check_ecannot'});

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'check_title'}, "");
print $self->text('check_running', $self->{'in_hash'}->{'filesys'}), "<p>\n";

$self->quotacheck($self->{'in_hash'}->{'filesys'}, $self->{'in_hash'}->{'source'} eq 'user' ? 1 : 2);
$self->webmin_log("check", undef, $self->{'in_hash'}->{'filesys'});
print "$self->{'text_hash'}->{'check_done'}<p>\n";
if ($self->{'in_hash'}->{'source'} eq "user") {
	$self->{'retlist_name'} = $self->{'text_hash'}->{'check_ruser'};
} else {
	$self->{'retlist_name'} = $self->{'text_hash'}->{'check_rgroup'};
}
$self->ui_print_footer("list_$self->{'in_hash'}->{'source'}s.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}),
	$self->text('check_return', $self->{'retlist_name'}));

1;
		
}


1;

