#!/usr/bin/perl

&MAIN();

 sub MAIN {
# copy_group.cgi
# Copy some group's quota to a number of others

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'cgroup_efail'};
$self->{'access_hash'}->{'filesys'} eq "*" ||
	$self->error($self->{'text_hash'}->{'cgroup_ecannot'});
$self->can_edit_group($self->{'in_hash'}->{'group'}) ||
	$self->error($self->{'text_hash'}->{'cgroup_egallow'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'cgroup_egallow'});

if ($self->{'in_hash'}->{'dest'} == 0) {
	# Copy to all groups
	setgrent();
	while(@{$self->{'ginfo_array'}} = getgrent()) { push(@{$self->{'copyto_array'}}, $self->{'ginfo_array'}->[0]); }
	endgrent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
	}
elsif ($self->{'in_hash'}->{'dest'} == 1) {
	# Copy to selected groups
	@{$self->{'copyto_array'}} = split(/\s+/, $self->{'in_hash'}->{'groups'});
	}
elsif ($self->{'in_hash'}->{'dest'} == 2) {
	# Copy to groups containing users
	foreach $u (split(/\s+/, $self->{'in_hash'}->{'users'})) {
		@{$self->{'uinfo_array'}} = getpwnam($u);
		@{$self->{'ginfo_array'}} = getgrgid($self->{'uinfo_array'}->[3]);
		push(@{$self->{'copyto_array'}}, $self->{'ginfo_array'}->[0]);
		$self->{'user_hash'}->{$u}++;
		}
	setgrent();
	while(@{$self->{'ginfo_array'}} = getgrent()) {
		foreach $m (split(/\s+/, $self->{'ginfo_array'}->[3])) {
			if ($self->{'user_hash'}->{$m}) {
				push(@{$self->{'copyto_array'}}, $self->{'ginfo_array'}->[0]);
				last;
				}
			}
		}
	endgrent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
	}
@{$self->{'copyto_array'}} = $self->unique(@{$self->{'copyto_array'}});
@{$self->{'copyto_array'}} = grep { $_ ne $self->{'in_hash'}->{'group'} } @{$self->{'copyto_array'}};
if (!@{$self->{'copyto_array'}}) { $self->error($self->{'text_hash'}->{'cgroup_enogroup'}); }
foreach $c (@{$self->{'copyto_array'}}) {
	$self->can_edit_group($c) ||
		$self->error($self->text('cgroup_eallowto', $c));
	}

# Do the copy
$self->copy_group_quota($self->{'in_hash'}->{'group'}, @{$self->{'copyto_array'}});
$self->webmin_log("copy", "group", $self->{'in_hash'}->{'group'}, \%{$self->{'in_hash'}});
$self->redirect("group_filesys.cgi?group=$self->{'in_hash'}->{'group'}");

1;
		
}


1;

