#!/usr/bin/perl

&MAIN();

 sub MAIN {
# group_grace_form.cgi
# Display a form for editing group grace times for some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'ggrace'} && $self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'ggracef_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ggracef_title'}, "", "group_grace");

print "$self->{'text_hash'}->{'ggracef_info'}<p>\n";

@{$self->{'gr_array'}} = $self->get_group_grace($self->{'in_hash'}->{'filesys'});
print "<form action=group_grace_save.cgi>\n";
print "<input type=hidden name=filesys value=\"$self->{'in_hash'}->{'filesys'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td colspan=2><b>",$self->text('ggracef_graces', $self->{'in_hash'}->{'filesys'}),"</b></td></tr>\n";

print "<tr $self->{'cb'}> <td width=20%><b>$self->{'text_hash'}->{'ggracef_block'}</b></td> <td>\n";
if ($self->default_grace()) {
	printf "<input type=radio name=bdef value=1 %s> $self->{'text_hash'}->{'default'}\n",
		$self->{'gr_array'}->[0] ? "" : "checked";
	printf "<input type=radio name=bdef value=0 %s>\n",
		$self->{'gr_array'}->[0] ? "checked" : "";
	}
print "<input name=btime size=6 value=\"$self->{'gr_array'}->[0]\">";
&select_units("bunits", $self->{'gr_array'}->[1]);
print "</td> </tr>\n";

print "<tr $self->{'cb'}> <td width=20%><b>$self->{'text_hash'}->{'ggracef_file'}</b></td> <td>\n";
if ($self->default_grace()) {
	printf "<input type=radio name=fdef value=1 %s> $self->{'text_hash'}->{'default'}\n",
		$self->{'gr_array'}->[2] ? "" : "checked";
	printf "<input type=radio name=fdef value=0 %s>\n",
		$self->{'gr_array'}->[2] ? "checked" : "";
	}
print "<input name=ftime size=6 value=\"$self->{'gr_array'}->[2]\">";
&select_units("funits", $self->{'gr_array'}->[3]);
print "</td> </tr>\n";

print "</table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'ggracef_update'}></form>\n";

$self->ui_print_footer("list_groups.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}),$self->{'text_hash'}->{'ggracef_return'});

1;
		
}

sub select_units
{
	shift if ($self == $_[0]);

@{$self->{'uarr_array'}} = $self->grace_units();
print "<select name=$_[0]>\n";
for($i=0; $i<@{$self->{'uarr_array'}}; $i++) {
	printf "<option value=$i %s>$self->{'uarr_array'}->[$i]\n",
		$i == $_[1] ? "selected" : "";
	}
print "</select>\n";
}


1;

