#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_group_quota.cgi
# Update the quota for some group

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'bsize'} = $self->block_size($self->{'in_hash'}->{'filesys'});

$self->can_edit_group($self->{'in_hash'}->{'group'}) ||
	$self->error($self->{'text_hash'}->{'sgroup_egroup'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'sgroup_egroup'});
$self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'sgroup_efs'});
if ($self->{'bsize'}) {
	$self->{'in_hash'}->{'sblocks'} = $self->quota_parse("sblocks", $self->{'bsize'});
	$self->{'in_hash'}->{'hblocks'} = $self->quota_parse("hblocks", $self->{'bsize'});
	}
!$self->{'access_hash'}->{'maxblocks'} ||
	!$self->{'in_hash'}->{'sblocks_def'} && $self->{'in_hash'}->{'sblocks'} <= $self->{'access_hash'}->{'maxblocks'} &&
	!$self->{'in_hash'}->{'hblocks_def'} && $self->{'in_hash'}->{'hblocks'} <= $self->{'access_hash'}->{'maxblocks'} ||
		$self->error($self->text('suser_emaxblocks', $self->{'access_hash'}->{'maxblocks'}));
!$self->{'access_hash'}->{'maxfiles'} ||
	!$self->{'in_hash'}->{'sfiles_def'} && $self->{'in_hash'}->{'sfiles'} <= $self->{'access_hash'}->{'maxfiles'} &&
	!$self->{'in_hash'}->{'hfiles_def'} && $self->{'in_hash'}->{'hfiles'} <= $self->{'access_hash'}->{'maxfiles'} ||
		$self->error($self->text('suser_emaxfiles', $self->{'access_hash'}->{'maxfiles'}));
$self->edit_group_quota($self->{'in_hash'}->{'group'}, $self->{'in_hash'}->{'filesys'},
		  $self->{'in_hash'}->{'sblocks_def'} ? 0 : $self->{'in_hash'}->{'sblocks'},
		  $self->{'in_hash'}->{'hblocks_def'} ? 0 : $self->{'in_hash'}->{'hblocks'},
		  $self->{'in_hash'}->{'sfiles_def'} ? 0 : $self->{'in_hash'}->{'sfiles'},
		  $self->{'in_hash'}->{'hfiles_def'} ? 0 : $self->{'in_hash'}->{'hfiles'});
$self->webmin_log("save", "group", $self->{'in_hash'}->{'group'}, \%{$self->{'in_hash'}});
if ($self->{'in_hash'}->{'source'}) {
	$self->redirect("group_filesys.cgi?group=".$self->urlize($self->{'in_hash'}->{'group'}));
	}
else {
	$self->redirect("list_groups.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}));
	}

1;
		
}


1;

