#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sync.cgi
# Save default quotas for users

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'default'} && $self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'ssync_ecannot'});
$self->{'bsize'} = $self->block_size($self->{'in_hash'}->{'filesys'});
$self->lock_file("$self->{'module_config_directory'}/config");
$self->{'v'} = join(' ', $self->quota_parse("sblocks", $self->{'bsize'}),
	       $self->quota_parse("hblocks", $self->{'bsize'}),
	       ($self->{'in_hash'}->{'sfiles_def'} ? 0 : $self->{'in_hash'}->{'sfiles'}),
	       ($self->{'in_hash'}->{'hfiles_def'} ? 0 : $self->{'in_hash'}->{'hfiles'}) );
$self->{'k'} = "sync_$self->{'in_hash'}->{'filesys'}";
if ($self->{'v'} eq "0 0 0 0") { delete($self->{'config_hash'}->{$self->{'k'}}); }
else { $self->{'config_hash'}->{$self->{'k'}} = $self->{'v'}; }
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");
$self->webmin_log("sync", "user", $self->{'in_hash'}->{'filesys'}, \%{$self->{'in_hash'}});
$self->redirect("list_users.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}));

1;
		
}


1;

