#!/usr/bin/perl

&MAIN();

 sub MAIN {
# user_grace_save.cgi
# Update the grace times for users on some filesystem

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'ugraces_esave'};
$self->{'access_hash'}->{'ugrace'} && $self->can_edit_filesys($self->{'in_hash'}->{'filesys'}) ||
	$self->error($self->{'text_hash'}->{'ugraces_eedit'});

if ($self->{'in_hash'}->{'bdef'}) { push(@{$self->{'args_array'}}, 0, 0); }
elsif ($self->{'in_hash'}->{'btime'} !~ /^[0-9\.]+$/)
	{ $self->error($self->text('ugraces_enumber', $self->{'in_hash'}->{'btime'})); }
else { push(@{$self->{'args_array'}}, ($self->{'in_hash'}->{'btime'}, $self->{'in_hash'}->{'bunits'})); }

if ($self->{'in_hash'}->{'fdef'}) { push(@{$self->{'args_array'}}, 0, 0); }
elsif ($self->{'in_hash'}->{'ftime'} !~ /^[0-9\.]+$/)
	{ $self->error($self->text('ugraces_enumber', $self->{'in_hash'}->{'ftime'})); }
else { push(@{$self->{'args_array'}}, ($self->{'in_hash'}->{'ftime'}, $self->{'in_hash'}->{'funits'})); }

$self->edit_user_grace($self->{'in_hash'}->{'filesys'}, @{$self->{'args_array'}});
$self->webmin_log("grace", "user", $self->{'in_hash'}->{'filesys'}, \%{$self->{'in_hash'}});
$self->redirect("list_users.cgi?dir=".$self->urlize($self->{'in_hash'}->{'filesys'}));

1;
		
}


1;

