#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one RBAC authorization

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'auths'} || $self->error($self->{'text_hash'}->{'auths_ecannot'});
$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'auth_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'auth_title2'}, "");
	$self->{'auths'} = $self->list_auth_attrs();
	$self->{'auth'} = $self->{'auths'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_auth.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'auth_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'auth_name'},
		    $self->ui_textbox("name", $self->{'auth'}->{'name'}, 20));

print $self->ui_table_row($self->{'text_hash'}->{'auth_short'},
		    $self->ui_textbox("short", $self->{'auth'}->{'short'}, 40));

print $self->ui_table_row($self->{'text_hash'}->{'auth_desc'},
		    $self->ui_textbox("desc", $self->{'auth'}->{'desc'}, 60));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_auths.cgi", $self->{'text_hash'}->{'auths_return'});

1;
		
}


1;

