#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one RBAC execution profile

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'execs'} || $self->error($self->{'text_hash'}->{'execs_ecannot'});
$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title2'}, "");
	$self->{'execs'} = $self->list_exec_attrs();
	$self->{'exec'} = $self->{'execs'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_exec.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'exec_header'}, "width=100%", 2);

$self->{'profs'} = $self->list_prof_attrs();
print $self->ui_table_row($self->{'text_hash'}->{'exec_name'},
		    $self->ui_select("name", $self->{'exec'}->{'name'},
			[ map { [ $_->{'name'} ] } @{$self->{'profs'}} ], 0, 0,
			$self->{'in_hash'}->{'new'} ? 0 : 1));

print $self->ui_table_row($self->{'text_hash'}->{'exec_policy'},
		    $self->ui_radio("policy", $self->{'exec'}->{'policy'} || "suser",
			       [ [ "suser", $self->{'text_hash'}->{'execs_psuser'} ],
				 [ "solaris", $self->{'text_hash'}->{'execs_psolaris'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'exec_id'},
		    $self->ui_opt_textbox("id", $self->{'exec'}->{'id'} eq "*" ? undef :
				$self->{'exec'}->{'id'}, 40, $self->{'text_hash'}->{'exec_all'}));

foreach $i ("uid", "gid", "euid", "egid") {
	print $self->ui_table_row($self->{'text_hash'}->{'exec_'.$i},
			    $self->ui_opt_textbox($i, $self->{'exec'}->{'attr'}->{$i}, 15,
				    $self->{'text_hash'}->{'exec_default'},
				    $i =~ /uid/ ? $self->{'text_hash'}->{'exec_asuser'}
						: $self->{'text_hash'}->{'exec_asgroup'}));
	}

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_execs.cgi", $self->{'text_hash'}->{'execs_return'});

1;
		
}


1;

