#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one RBAC profile

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'profs'} == 1 || $self->error($self->{'text_hash'}->{'profs_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'prof_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'prof_title2'}, "");
	$self->{'profs'} = $self->list_prof_attrs();
	$self->{'prof'} = $self->{'profs'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_prof.cgi", "post");
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'prof_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'prof_name'},
		    $self->ui_textbox("name", $self->{'prof'}->{'name'}, 20));

print $self->ui_table_row($self->{'text_hash'}->{'prof_desc'},
		    $self->ui_textbox("desc", $self->{'prof'}->{'desc'}, 40));

print $self->ui_table_row($self->{'text_hash'}->{'prof_auths'},
		    $self->auths_input("auths", $self->{'prof'}->{'attr'}->{'auths'}));

print $self->ui_table_row($self->{'text_hash'}->{'prof_profiles'},
		    $self->profiles_input("profiles", $self->{'prof'}->{'attr'}->{'profs'}, 1));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_profs.cgi", $self->{'text_hash'}->{'profs_return'});

1;
		
}


1;

