#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show global policy settings

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'policy'} || $self->error($self->{'text_hash'}->{'policy_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'policy_title'}, "", "policy");
$self->{'conf'} = $self->get_policy_config();

print $self->ui_form_start("save_policy.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'policy_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'policy_auths'},
		    $self->auths_input("auths",
				 $self->find_policy_value("AUTHS_GRANTED", $self->{'conf'})));

print $self->ui_table_row($self->{'text_hash'}->{'policy_profs'},
	$self->profiles_input("profs", $self->find_policy_value("PROFS_GRANTED", $self->{'conf'}),1));

$self->{'allow'} = $self->find_policy_value("CRYPT_ALGORITHMS_ALLOW", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'policy_allow'},
	$self->ui_radio("allow_def", $self->{'allow'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'default'} ],
		    [ 0, $self->{'text_hash'}->{'policy_sel'} ] ])."<br>\n".
	$self->crypt_algorithms_input("allow", $self->{'allow'}, 1));

$self->{'default'} = $self->find_policy_value("CRYPT_DEFAULT", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'policy_default'},
	$self->ui_radio("default_def", $self->{'default'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'default'} ],
		    [ 0, " " ] ])."\n".
	$self->crypt_algorithms_input("default", $self->{'default'}, 0));

$self->{'deprecate'} = $self->find_policy_value("CRYPT_ALGORITHMS_DEPRECATE", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'policy_deprecate'},
	$self->ui_radio("deprecate_def", $self->{'deprecate'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'policy_none'} ],
		    [ 0, " " ] ])."\n".
	$self->crypt_algorithms_input("deprecate", $self->{'deprecate'}, 0));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

