#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of all user attributes

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'users_title'}, "", "users");

$self->{'users'} = $self->list_user_attrs();
@{$self->{'canusers_array'}} = grep { $self->can_edit_user($_) } @{$self->{'users'}};
if (@{$self->{'canusers_array'}}) {
	print "<a href='edit_user.cgi?new=1'>$self->{'text_hash'}->{'users_add'}</a><br>\n";
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'users_user'},
		  $self->{'text_hash'}->{'users_type'},
		  $self->{'text_hash'}->{'users_role'},
		  $self->{'text_hash'}->{'users_project'},
		  $self->{'text_hash'}->{'users_profiles'},
		  $self->{'text_hash'}->{'users_auths'} ]);
	foreach $u (sort { $a->{'user'} cmp $b->{'user'} } @{$self->{'canusers_array'}}) {
		print $self->ui_columns_row(
			[ "<a href='edit_user.cgi?idx=$u->{'index'}'>$u->{'user'}</a>",
			  $self->{'text_hash'}->{'user_t'.$u->{'attr'}->{'type'}} ||
			    $u->{'attr'}->{'type'} ||
			    $self->{'text_hash'}->{'user_tnormal'},
			  $self->nice_comma_list($u->{'attr'}->{'roles'}),
			  $u->{'attr'}->{'project'},
			  $self->nice_comma_list($u->{'attr'}->{'profiles'}),
			  $self->nice_comma_list($u->{'attr'}->{'auths'}),
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'users_none'}</b><p>\n";
	}
print "<a href='edit_user.cgi?new=1'>$self->{'text_hash'}->{'users_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});
1;
		
}


1;

