#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_bind.cgi
# Display winbind-related options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcm'}") unless $self->{'access_hash'}->{'conf_bind'};

$self->ui_print_header(undef, $self->{'text_hash'}->{'bind_title'}, "");

$self->get_share("global");
print "<form action=save_bind.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'bind_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'bind_local'}</b></td>\n";
print "<td>",$self->ui_radio("local",
		$self->istrue("winbind enable local accounts") ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'bind_trust'}</b></td>\n";
print "<td>",$self->ui_radio("trust",
		$self->istrue("winbind trusted domains only") ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'bind_users'}</b></td>\n";
print "<td>",$self->ui_radio("users",
		$self->istrue("winbind enum users") ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'bind_groups'}</b></td>\n";
print "<td>",$self->ui_radio("groups",
		$self->istrue("winbind enum groups") ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'bind_realm'}</b></td>\n";
printf "<td><input name=realm size=20 value='%s'></td>\n",
	$self->getval("realm");

print "<td><b>$self->{'text_hash'}->{'bind_cache'}</b></td>\n";
printf "<td><input name=cache size=5 value='%s'></td> </tr>\n",
	$self->getval("winbind cache time");

print "<tr> <td><b>$self->{'text_hash'}->{'bind_uid'}</b></td>\n";
printf "<td><input name=uid size=20 value='%s'></td>\n",
	$self->getval("idmap uid");

print "<td><b>$self->{'text_hash'}->{'bind_gid'}</b></td>\n";
printf "<td><input name=gid size=20 value='%s'></td> </tr>\n",
	$self->getval("idmap gid");

$self->{'backend'} = $self->getval("idmap backend");
print "<tr> <td><b>$self->{'text_hash'}->{'bind_backend'}</b></td>\n";
print "<td colspan=3>",
	$self->ui_radio("backend_def", $self->{'backend'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'default'} ],
		    [ 0, $self->ui_textbox("backend", $self->{'backend'}, 50) ] ]),
	"</td> </tr>\n";

print "</table></tr></td></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

