#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_print.cgi
# Display printing options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcprint'}") unless $self->{'access_hash'}->{'conf_print'};
 
$self->ui_print_header(undef, $self->{'text_hash'}->{'print_title'}, "");

$self->get_share("global");

print "<form action=save_print.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'print_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'print_style'}</b></td>\n";
print "<td><select name=printing>\n";
printf "<option value=\"\" %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("printing") eq "" ? "selected" : "";
foreach $s ("bsd", "sysv", "hpux", "aix", "qnx", "plp", "cups", "lprng",
	    "softq") {
	printf "<option value=$s %s> %s\n",
		$self->getval("printing") eq $s ? "selected" : "", uc($s);
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'print_show'}</b></td>\n";
printf "<td><input type=radio name=load_printers value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("load printers") ? "checked" : "";
printf "<input type=radio name=load_printers value=no %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
	$self->istrue("load printers") ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'print_printcap'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=printcap_name_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("printcap name") eq "" ? "checked" : "";
printf "&nbsp;&nbsp; <input type=radio name=printcap_name_def value=0 %s>\n",
	$self->getval("printcap name") eq "" ? "" : "checked";
printf "<input name=printcap_name size=25 value=\"%s\">\n",
	$self->getval("printcap name");
print $self->file_chooser_button("printcap_name", 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'print_cachetime'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=lpq_cache_time_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("lpq cache time") == 0 ? "checked" : "";
printf "&nbsp;&nbsp; <input type=radio name=lpq_cache_time_def value=0 %s>\n",
	$self->getval("lpq cache time") == 0 ? "" : "checked";
printf "<input name=lpq_cache_time size=5 value=\"%s\"> $self->{'text_hash'}->{'config_secs'}</td> </tr>\n",
	$self->getval("lpq cache time");

print "</table></td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
1;
		
}


1;

