#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_euser.cgi
# Edit an existing samba user

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pvusers'}")
        unless $self->{'access_hash'}->{'view_users'};
# display		
$self->ui_print_header(undef, $self->{'text_hash'}->{'euser_title'}, "");
@{$self->{'ulist_array'}} = $self->list_users();
$self->{'u'} = $self->{'ulist_array'}->[$self->{'in_hash'}->{'idx'}];

print "<form action=save_euser.cgi>\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'euser_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'euser_name'}</b></td>\n";
print "<td><font size=+1><i>$self->{'u'}->{'name'}</i></font></td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'euser_uid'}</b></td>\n";
print "<td><input name=uid size=5 value=\"$self->{'u'}->{'uid'}\"></td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'euser_passwd'}</b></td>\n";
if ($self->{'samba_version'} >= 3) {
	# In the new Samba, the password field is not really used for locking
	# accounts any more, so don't both with the no access/no password
	# options.
	print "<td colspan=3><input type=radio name=ptype value=2 checked> ",
	      "$self->{'text_hash'}->{'euser_currpw'}\n";
	}
else {
	# In the old Samba, you can set the password to deny a login to the
	# account or allow logins without a password
	$self->{'locked'} = ($self->{'u'}->{'pass1'} eq ("X" x 32));
	$self->{'nopass'} = ($self->{'u'}->{'pass1'} =~ /^NO PASSWORD/);
	printf "<td colspan=3><input type=radio name=ptype value=0 %s> $self->{'text_hash'}->{'euser_noaccess'}\n",
		$self->{'locked'} ? "checked" : "";
	printf "<input type=radio name=ptype value=1 %s> $self->{'text_hash'}->{'euser_nopw'}\n",
		$self->{'nopass'} ? "checked" : "";
	printf "<input type=radio name=ptype value=2 %s> $self->{'text_hash'}->{'euser_currpw'}\n",
		$self->{'locked'}||$self->{'nopass'} ? "" : "checked";
	}
print "<input type=radio name=ptype value=3> $self->{'text_hash'}->{'euser_newpw'}\n";
print "<input type=password name=pass size=20></td> </tr>\n";

if (!$self->{'u'}->{'opts'}) {
	# Old-style samba user
	print "<tr> <td align=right><b>$self->{'text_hash'}->{'euser_realname'}</b></td> <td colspan=3>\n";
	print "<input name=realname size=40 value='$self->{'u'}->{'real'}'></td> </tr>\n";

	print "<tr> <td align=right><b>$self->{'text_hash'}->{'euser_homedir'}</b></td>\n";
	print "<td><input name=homedir size=30 value='$self->{'u'}->{'home'}'></td>\n";

	print "<td align=right><b>$self->{'text_hash'}->{'euser_shell'}</b></td>\n";
	printf "<td><input name=shell size=15 value='%s'></td> </tr>\n",
		$self->{'u'}->{'shell'};
	}
else {
	# New-style samba user
	print "<input type=hidden name=new value=1>\n";
	map { $self->{'opt_hash'}->{uc($_)}++ } @{$self->{'u'}->{'opts'}};
	print "<tr> <td valign=top align=right><b>$self->{'text_hash'}->{'euser_option'}</b></td> <td colspan=3>\n";
	@{$self->{'ol_array'}} = ($self->{'text_hash'}->{'euser_normal'}, "U", $self->{'text_hash'}->{'euser_nopwrequired'}, "N",
	       $self->{'text_hash'}->{'euser_disable'}, "D", $self->{'text_hash'}->{'euser_trust'}, "W");
	for($i=0; $i<@{$self->{'ol_array'}}; $i+=2) {
		printf "<input type=checkbox name=opts value=%s %s> %s<br>\n",
			$self->{'ol_array'}->[$i+1], $self->{'opt_hash'}->{$self->{'ol_array'}->[$i+1]} ? "checked" : "", $self->{'ol_array'}->[$i];
		delete($self->{'opt_hash'}->{$self->{'ol_array'}->[$i+1]});
		}
	foreach $oo (keys %{$self->{'opt_hash'}}) {
		print "<input type=hidden name=opts value=$oo>\n";
		}
	print "</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<table width=100%>\n";
print "<tr> <td><input type=submit value=$self->{'text_hash'}->{'save'}></td>\n";
print "</form><form action=\"delete_euser.cgi\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<td align=right><input type=submit value=$self->{'text_hash'}->{'delete'}></td> </tr>\n";
print "</form></table><p>\n";

$self->ui_print_footer("edit_epass.cgi", $self->{'text_hash'}->{'index_userlist'},
	"", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

