#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_fmisc.cgi
# Edit misc file options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pvfmisc'}")
		unless $self->can('ro', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
# display
$self->{'s'} = $self->{'in_hash'}->{'share'};
if ($self->{'s'} eq "global") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fmisc_title'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fmisc_title'}, "");
	print "<center><font size=+1>", $self->text('fmisc_for', $self->{'s'}),"</font></center>\n";
	}
$self->get_share($self->{'s'});

print "<form action=save_fmisc.cgi>\n";
print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_lockfile'}</b></td>\n";
print "<td>",$self->yesno_input("locking"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fmisc_maxconn'}</b></td>\n";
printf "<td><input type=radio name=max_connections_def value=1 %s> $self->{'text_hash'}->{'smb_unlimited'}\n",
	$self->getval("max connections") == 0 ? "checked" : "";
printf "<input type=radio name=max_connections_def value=0 %s>\n",
	$self->getval("max connections") > 0 ? "checked" : "";
printf "<input size=6 name=max_connections value=\"%s\"></td> </tr>\n",
	$self->getval("max connections") > 0 ? $self->getval("max connections") : "";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_oplocks'}</b></td>\n";
print "<td>",$self->yesno_input("oplocks"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fmisc_level2'}</b></td>\n";
print "<td>",$self->yesno_input("level2 oplocks"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_fake'}</b></td>\n";
print "<td>",$self->yesno_input("fake oplocks"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fmisc_sharemode'}</b></td>\n";
print "<td>",$self->yesno_input("share modes"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_strict'}</b></td>\n";
print "<td>",$self->yesno_input("strict locking"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fmisc_sync'}</b></td>\n";
print "<td>",$self->yesno_input("sync always"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_volume'}</b></td>\n";
printf "<td colspan=3><input type=radio name=volume_def value=1 %s> $self->{'text_hash'}->{'fmisc_sameas'}\n",
	$self->getval("volume") eq "" ? "checked" : "";
printf "<input type=radio name=volume_def value=0 %s>\n",
	$self->getval("volume") eq "" ? "" : "checked";
printf "<input size=25 name=volume value=\"%s\"></td> </tr>\n",
	$self->getval("volume");

print "</table><table>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_unixdos'}</b></td>\n";
printf"<td><input name=mangled_map size=40 value=\"%s\"></td></tr>\n",
	$self->getval("mangled map");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_conncmd'}</b></td>\n";
printf "<td><input name=preexec size=40 value=\"%s\"></td> </tr>\n",
	$self->getval("preexec");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_disconncmd'}</b></td>\n";
printf "<td><input name=postexec size=40 value=\"%s\"></td> </tr>\n",
	$self->getval("postexec");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_rootconn'}</b></td>\n";
printf "<td><input name=root_preexec size=40 value=\"%s\"></td> </tr>\n",
	$self->getval("root preexec");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fmisc_rootdisconn'}</b></td>\n";
printf "<td><input name=root_postexec size=40 value=\"%s\"></td> </tr>\n",
	$self->getval("root postexec");

print "</table> </td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}>"
	if $self->can('wO', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
print "</form>\n";

$self->ui_print_footer("edit_fshare.cgi?share=".$self->urlize($self->{'s'}), $self->{'text_hash'}->{'index_fileshare'},
	"", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

