#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_fname.cgi
# Edit file naming options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pvfname'}")
        unless $self->can('rn', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
# display
$self->{'s'} = $self->{'in_hash'}->{'share'};
if ($self->{'s'} eq "global") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fname_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'fname_title2'}, "");
	print "<center><font size=+1>",$self->text('fmisc_for', $self->{'s'}),"</font></center>\n";
	}
$self->get_share($self->{'s'});

print "<form action=save_fname.cgi>\n";
print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'fname_option'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fname_manglecase'}</b></td>\n";
print "<td>",$self->yesno_input("mangle case"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fname_case'}</b></td>\n";
print "<td>",$self->yesno_input("case sensitive"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fname_defaultcase'}</b></td>\n";
printf "<td><input type=radio name=default_case value=lower %s> $self->{'text_hash'}->{'fname_lower'}\n",
	$self->getval("default case") =~ /lower/i ? "checked" : "";
printf "<input type=radio name=default_case value=upper %s> $self->{'text_hash'}->{'fname_upper'}</td>\n",
	$self->getval("default case") =~ /upper/i ? "checked" : "";

print "<td align=right><b>$self->{'text_hash'}->{'fname_preserve'}</b></td>\n";
print "<td>",$self->yesno_input("preserve case"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fname_shortpreserve'}</b></td>\n";
print "<td>",$self->yesno_input("short preserve case"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fname_hide'}</b></td>\n";
print "<td>",$self->yesno_input("hide dot files"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fname_archive'}</b></td>\n";
print "<td>",$self->yesno_input("map archive"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'fname_hidden'}</b></td>\n";
print "<td>",$self->yesno_input("map hidden"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'fname_system'}</b></td>\n";
print "<td>",$self->yesno_input("map system"),"</td>\n";

print "</table> </td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}>"
	if $self->can('wN', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
print "</form>\n";

$self->ui_print_footer("edit_fshare.cgi?share=".$self->urlize($self->{'s'}), $self->{'text_hash'}->{'index_fileshare'},
	"", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

