#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_group.cgi
# Show a form for editing an existing groups

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'maint_groups'} || $self->error($self->{'text_hash'}->{'groups_ecannot'});
$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title2'}, "");
	@{$self->{'groups_array'}} = $self->list_groups();
	$self->{'group'} = $self->{'groups_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_group.cgi method=post>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'gedit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'gedit_name'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input name=name size=20></td>\n";
	}
else {
	print "<td><tt>$self->{'group'}->{'name'}</b></td>\n";
	}

print "<td><b>$self->{'text_hash'}->{'gedit_type'}</b></td>\n";
print "<td><select name=type>\n";
foreach $t ('l', 'd', 'b', 'u') {
	printf "<option value=%s %s>%s\n",
		$t, $self->{'group'}->{'type'} eq $t ? "selected" : "",
		$self->{'text_hash'}->{'groups_type_'.$t};
	$self->{'found'}++ if ($self->{'group'}->{'type'} eq $t);
	}
print "<option selected>$self->{'group'}->{'type'}\n" if (!$self->{'found'} && !$self->{'in_hash'}->{'new'});
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'gedit_unix'}</b></td> <td>\n";
if ($self->{'group'}->{'unix'} == -1) {
	printf "<input type=radio name=unix_def value=1 %s> %s\n",
		$self->{'group'}->{'unix'} == -1 ? "checked" : "", $self->{'text_hash'}->{'gedit_none'};
	printf "<input type=radio name=unix_def value=0 %s> %s\n",
		$self->{'group'}->{'unix'} == -1 ? "" :"checked", $self->{'text_hash'}->{'gedit_unixgr'};
	}
print $self->unix_group_input("unix",
		       $self->{'group'}->{'unix'} == -1 ? undef : $self->{'group'}->{'unix'});
print "</td>\n";

print "<td><b>$self->{'text_hash'}->{'gedit_desc'}</b></td>\n";
print "<td><input name=desc size=30 ",
      "value='$self->{'group'}->{'desc'}'></td> </tr>\n";

if ($self->{'in_hash'}->{'new'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'gedit_priv'}</b></td> <td colspan=3>\n";
	print "<input type=radio name=priv_def value=1 checked> $self->{'text_hash'}->{'gedit_none'}\n";
	print "<input type=radio name=priv_def value=0> $self->{'text_hash'}->{'gedit_set'}\n";
	print "<input name=priv size=50></td> </tr>\n";
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'gedit_sid'}</b></td>\n";
	print "<td colspan=3><tt>$self->{'group'}->{'sid'}</tt></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'gedit_priv'}</b></td>\n";
	print "<td colspan=3>",$self->{'group'}->{'priv'} || $self->{'text_hash'}->{'gedit_none'},"</td> </tr>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right ><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_groups.cgi", $self->{'text_hash'}->{'groups_return'});

1;
		
}


1;

