#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_gsync.cgi
# Allow the user to edit auto updating of Samba groups by useradmin

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'maint_gsync'} || $self->error($self->{'text_hash'}->{'gsync_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'gsync_title'}, "");

$self->check_group_enabled($self->{'text_hash'}->{'gsync_cannot'});

print $self->{'text_hash'}->{'gsync_msg'}, "<p>\n";

print "<form action=save_gsync.cgi>\n";
printf "<input type=checkbox name=add value=1 %s>\n",
	$self->{'config_hash'}->{'gsync_add'} ? "checked" : "";
print "$self->{'text_hash'}->{'gsync_add'}\n";
print "<table>\n";
print "<tr> <td width=20></td> <td>$self->{'text_hash'}->{'gsync_type'}</td>\n";
print "<td><select name=type>\n";
foreach $t ('l', 'd', 'b', 'u') {
	printf "<option value=%s %s>%s\n",
		$t, $self->{'config_hash'}->{'gsync_type'} eq $t ? "selected" : "",
		$self->{'text_hash'}->{'groups_type_'.$t};
	}
print "</select></td> </tr>\n";
print "<tr> <td width=20></td> <td>$self->{'text_hash'}->{'gsync_priv'}</td>\n";
printf "<td><input name=priv size=40 value='%s'></td> </tr>\n",
	$self->{'config_hash'}->{'gsync_priv'};
print "</table><p>\n";

printf "<input type=checkbox name=change value=1 %s>\n",
	$self->{'config_hash'}->{'gsync_change'} ? "checked" : "";
print "$self->{'text_hash'}->{'gsync_chg'}<p>\n";

printf "<input type=checkbox name=delete value=1 %s>\n",
	$self->{'config_hash'}->{'gsync_delete'} ? "checked" : "";
print "$self->{'text_hash'}->{'gsync_del'}<p>\n";
print "<input type=submit value=\"", $self->{'text_hash'}->{'gsync_apply'}, "\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

