#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_sec.cgi
# Edit security options for some file or print share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pvsec'}")
        unless $self->can('rs', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
# display
$self->{'s'} = $self->{'in_hash'}->{'share'};
if ($self->{'s'} eq "global") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sec_index1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'sec_index2'}, "");
	print "<center><font size=+1>",$self->text('fmisc_for', $self->{'s'}), "</font></center>\n";
	}
$self->get_share($self->{'s'});

print "<form action=save_sec.cgi>\n";
print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n";
print "<input type=hidden name=printer value=\"$self->{'in_hash'}->{'printer'}\">\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'share_security'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_writable'}</b></td>\n";
print "<td>",$self->yesno_input("writeable"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'sec_guest'}</b></td>\n";
printf "<td><input type=radio name=guest value=0 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->istrue("public") ? "" : "checked";
printf "<input type=radio name=guest value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("public") && !$self->istrue("guest only") ? "checked" : "";
printf "<input type=radio name=guest value=2 %s> $self->{'text_hash'}->{'sec_guestonly'}</td> </tr>\n",
	$self->istrue("public") && $self->istrue("guest only") ? "checked" : "";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_guestaccount'}</b></td>\n";
$self->username_input("guest account", "Default");

print "<td align=right><b>$self->{'text_hash'}->{'sec_limit'}</b></td>\n";
print "<td>",$self->yesno_input("only user"),"</td> </tr>\n";

print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_allowhost'}</b></td>\n";
printf "<td colspan=3><input type=radio name=allow_hosts_all value=1 %s> $self->{'text_hash'}->{'config_all'}\n",
	$self->getval("allow hosts") eq "" ? "checked" : "";
print "&nbsp;&nbsp;\n";
printf "<input type=radio name=allow_hosts_all value=0 %s> $self->{'text_hash'}->{'sec_onlyallow'}:\n",
	$self->getval("allow hosts") eq "" ? "" : "checked";
printf "<input name=allow_hosts size=35 value=\"%s\"></td> </tr>\n",
	$self->getval("allow hosts");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_denyhost'}</b></td>\n";
printf "<td colspan=3><input type=radio name=deny_hosts_all value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("deny hosts") eq "" ? "checked" : "";
print "&nbsp;&nbsp;\n";
printf "<input type=radio name=deny_hosts_all value=0 %s> $self->{'text_hash'}->{'sec_onlydeny'}:\n",
	$self->getval("deny hosts") eq "" ? "" : "checked";
printf "<input name=deny_hosts size=35 value=\"%s\"></td> </tr>\n",
	$self->getval("deny hosts");

print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_revalidate'}</b></td>\n";
print "<td>",$self->yesno_input("revalidate"),"</td> </tr>\n";

@{$self->{'valid_users_array'}} = &split_users($self->getval("valid users"));
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_validuser'}</b></td> <td colspan=3>\n";
printf "<input name=valid_users_u size=60 value='%s'> %s</td> </tr>\n",
	join(' ', grep { !/^@/ } @{$self->{'valid_users_array'}}),
	$self->user_chooser_button("valid_users_u", 1);
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_validgroup'}</b></td> <td colspan=3>\n";
printf "<input name=valid_users_g size=60 value='%s'> %s</td> </tr>\n",
	join(' ', map { s/@//;$_ } grep { /^@/ } @{$self->{'valid_users_array'}}),
	$self->group_chooser_button("valid_users_g", 1);

@{$self->{'invalid_users_array'}} = &split_users($self->getval("invalid users"));
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_invaliduser'}</b></td> <td colspan=3>\n";
printf "<input name=invalid_users_u size=60 value='%s'> %s</td> </tr>\n",
	join(' ', grep { !/^@/ } @{$self->{'invalid_users_array'}}),
	$self->user_chooser_button("invalid_users_u", 1);
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_invalidgroup'}</b></td> <td colspan=3>\n";
printf "<input name=invalid_users_g size=60 value='%s'> %s</td> </tr>\n",
	join(' ', map { s/@//;$_ } grep { /^@/ } @{$self->{'invalid_users_array'}}),
	$self->group_chooser_button("invalid_users_g", 1);

print "<tr> <td colspan=4><hr></td> </tr>\n";

@{$self->{'user_array'}} = &split_users($self->getval("user"));
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_possibleuser'}</b></td> <td>\n";
printf "<input name=user_u size=30 value='%s'> %s</td>\n",
	join(' ', grep { !/^@/ } @{$self->{'user_array'}}),
	$self->user_chooser_button("user_u", 1);
print "<td align=right><b>$self->{'text_hash'}->{'sec_possiblegroup'}</b></td> <td colspan=3>\n";
printf "<input name=user_g size=30 value='%s'> %s</td> </tr>\n",
	join(' ', map { s/@//;$_ } grep { /^@/ } @{$self->{'user_array'}}),
	$self->group_chooser_button("user_g", 1);

@{$self->{'read_list_array'}} = &split_users($self->getval("read list"));
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_rouser'}</b></td> <td>\n";
printf "<input name=read_list_u size=30 value='%s'> %s</td>\n",
	join(' ', grep { !/^@/ } @{$self->{'read_list_array'}}),
	$self->user_chooser_button("read_list_u", 1);
print "<td align=right><b>$self->{'text_hash'}->{'sec_rogroup'}</b></td> <td colspan=3>\n";
printf "<input name=read_list_g size=30 value='%s'> %s</td> </tr>\n",
	join(' ', map { s/@//;$_ } grep { /^@/ } @{$self->{'read_list_array'}}),
	$self->group_chooser_button("read_list_g", 1);

@{$self->{'write_list_array'}} = &split_users($self->getval("write list"));
print "<tr> <td align=right><b>$self->{'text_hash'}->{'sec_rwuser'}</b></td> <td>\n";
printf "<input name=write_list_u size=30 value='%s'> %s</td>\n",
	join(' ', grep { !/^@/ } @{$self->{'write_list_array'}}),
	$self->user_chooser_button("write_list_u", 1);
print "<td align=right><b>$self->{'text_hash'}->{'sec_rwgroup'}</b></td> <td>\n";
printf "<input name=write_list_g size=30 value='%s'> %s</td> </tr>\n",
	join(' ', map { s/@//;$_ } grep { /^@/ } @{$self->{'write_list_array'}}),
	$self->group_chooser_button("write_list_g", 1);

print "</table><table border width=100%>\n";

print "</table> </td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}>" 
	if $self->can('wS', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
print "</form>\n";

if ($self->istrue("printable") || $self->{'in_hash'}->{'printer'}) {
	$self->ui_print_footer("edit_pshare.cgi?share=".$self->urlize($self->{'s'}), $self->{'text_hash'}->{'index_printershare'}, "", $self->{'text_hash'}->{'index_sharelist'});
	}
else {
	$self->ui_print_footer("edit_fshare.cgi?share=".$self->urlize($self->{'s'}), $self->{'text_hash'}->{'index_fileshare'}, "", $self->{'text_hash'}->{'index_sharelist'});
	}

1;
		
}

sub split_users
{
	shift if ($self == $_[0]);

return split(/\s*,\s*/, $_[0]);
}


1;

