#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_fname.cgi
# Save file naming options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name});

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pufname'}")
            unless $self->can('rwnN', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
# save
$self->{'whatfailed'} = $self->{'text_hash'}->{'error_savename'};
# File nameing options
$self->setval("mangle case", $self->{'in_hash'}->{mangle_case});
$self->setval("case sensitive", $self->{'in_hash'}->{case_sensitive});
$self->setval("default case", $self->{'in_hash'}->{default_case}, "lower");
$self->setval("preserve case", $self->{'in_hash'}->{preserve_case});
$self->setval("short preserve case", $self->{'in_hash'}->{short_preserve_case});
$self->setval("hide dot files", $self->{'in_hash'}->{hide_dot_files});
$self->setval("map archive", $self->{'in_hash'}->{map_archive});
$self->setval("map hidden", $self->{'in_hash'}->{map_hidden});
$self->setval("map system", $self->{'in_hash'}->{map_system});

$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'in_hash'}->{old_name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("save", "fname", $self->{'in_hash'}->{old_name}, \%{$self->{'in_hash'}});
$self->redirect("edit_fshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name}));

1;
		
}


1;

