#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_fperm.cgi
# Save file permissions options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name});

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pufperm'}")
            unless $self->can('rwpP', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
# save
$self->{'whatfailed'} = $self->{'text_hash'}->{'savefperm_fail'};
# File nameing options
$self->{'in_hash'}->{create_mode} =~ /^0?[0-7]{3}$/ ||
	$self->error($self->text('savefperm_mode', $self->{'in_hash'}->{create_mode}));
$self->setval("create mode", $self->{'in_hash'}->{create_mode});
$self->setval("directory mode", $self->{'in_hash'}->{directory_mode});
$self->setval("force create mode", $self->{'in_hash'}->{force_create_mode});
$self->setval("force directory mode", $self->{'in_hash'}->{force_directory_mode});
$self->setval("delete readonly", $self->{'in_hash'}->{delete_readonly});
$self->setval("dont descend", $self->{'in_hash'}->{dont_descend});
$self->setval("force user", $self->{'in_hash'}->{force_user});
$self->setval("force group", $self->{'in_hash'}->{force_group});
$self->setval("wide links", $self->{'in_hash'}->{wide_links});

$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'in_hash'}->{old_name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("save", "fperm", $self->{'in_hash'}->{old_name}, \%{$self->{'in_hash'}});
$self->redirect("edit_fshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name}));

1;
		
}


1;

