#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_gsync.cgi
# Save unix-samba group synchronisation options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'maint_gsync'} || $self->error($self->{'text_hash'}->{'gsync_ecannot'});
$self->ReadParse();

$self->lock_file("$self->{'module_config_directory'}/config");
foreach $s ("add", "change", "delete", "type", "priv") {
	if ($self->{'in_hash'}->{$s}) { $self->{'config_hash'}->{"gsync_$s"} = $self->{'in_hash'}->{$s}; }
	else { delete($self->{'config_hash'}->{"gsync_$s"}); }
	}
$self->write_file("$self->{'module_config_directory'}/config", \%{$self->{'config_hash'}});
$self->unlock_file("$self->{'module_config_directory'}/config");
$self->webmin_log("gsync");
$self->redirect("");

1;
		
}


1;

