#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_popts.cgi
# Save printer options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{'old_name'});

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pupopt'}")
  		unless $self->can('rwoO', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
# save
$self->{'whatfailed'} = $self->{'text_hash'}->{'savepopts_fail'};
# printer options
$self->{'in_hash'}->{min_print_space} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'savepopts_number'});
$self->setval("min print space", $self->{'in_hash'}->{min_print_space});
$self->setval("postscript", $self->{'in_hash'}->{postscript});
$self->setval("print command", $self->{'in_hash'}->{print_command_def} ? "" : $self->{'in_hash'}->{print_command});
$self->setval("lpq command", $self->{'in_hash'}->{lpq_command_def} ? "" : $self->{'in_hash'}->{lpq_command});
$self->setval("lprm command", $self->{'in_hash'}->{lprm_command_def} ? "" : $self->{'in_hash'}->{lprm_command});
$self->setval("lppause command",
	$self->{'in_hash'}->{lppause_command_def} ? "" : $self->{'in_hash'}->{lppause_command});
$self->setval("lpresume command",
	$self->{'in_hash'}->{lpresume_command_def} ? "" : $self->{'in_hash'}->{lpresume_command});
$self->setval("printer driver",
	$self->{'in_hash'}->{printer_driver_def} ? "" : $self->{'in_hash'}->{printer_driver});

# Update config file
$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'in_hash'}->{old_name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("save", "popts", $self->{'in_hash'}->{old_name}, \%{$self->{'in_hash'}});
$self->redirect("edit_pshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name}));

1;
		
}


1;

