#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_winbind.cgi
# Bind to a domain

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'winbind'} || $self->error($self->{'text_hash'}->{'winbind_ecannot'});
$self->ReadParse();

# Validate inputs and create command
$self->{'cmd'} = "$self->{'config_hash'}->{'net'} join";
$self->error_setup($self->{'text_hash'}->{'winbind_err'});
$self->{'in_hash'}->{'user'} || $self->error($self->{'text_hash'}->{'winbind_euser'});
$self->{'cmd'} .= " -U ".quotemeta($self->{'in_hash'}->{'user'});
if (!$self->{'in_hash'}->{'dom_def'}) {
	$self->{'in_hash'}->{'dom'} || $self->error($self->{'text_hash'}->{'winbind_edom'});
	$self->{'cmd'} .= " -S ".quotemeta($self->{'in_hash'}->{'dom'});
	}

# Run it
$self->ui_print_header(undef, $self->{'text_hash'}->{'winbind_title'}, undef);
print $self->text('winbind_cmd', "<tt>$self->{'cmd'}</tt>"),"\n";
$self->{'temp'} = $self->transname();
open(TEMP, ">$self->{'temp'}");
print TEMP $self->{'in_hash'}->{'pass'},"\n";
close(TEMP);
$self->{'out'} = `$self->{'cmd'} 2>&1 <$self->{'temp'}`;
unlink($self->{'temp'});
print "<pre>$self->{'out'}</pre>";
if ($? || $self->{'out'} =~ /error|failed/i) {
	print "$self->{'text_hash'}->{'winbind_failed'}<br>\n";
	}
else {
	print "$self->{'text_hash'}->{'winbind_ok'}<br>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

