#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options for report colour styling

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;


$self->{'conf'} = $self->get_config();
$self->ui_print_header(undef, $self->{'text_hash'}->{'style_title'}, "");
print $self->ui_form_start("save_style.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'style_header'}, "width=100%", 4);
$self->{'config_prefix'} = "style_";

print $self->config_language($self->{'conf'}, "language", 3,
		       "$self->{'module_root_directory'}/languages");
print $self->config_language($self->{'conf'}, "charset", 3,
		       "$self->{'module_root_directory'}/charsets");

print $self->ui_table_hr();

print $self->config_opt_textbox($self->{'conf'}, "title", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "title_color", 20, 3);
print $self->config_opt_textbox($self->{'conf'}, "font_face", 20, 3);
print $self->config_opt_textbox($self->{'conf'}, "header_color", 20, 3);
print $self->config_opt_textbox($self->{'conf'}, "header_bgcolor", 20, 3);
print $self->config_opt_textbox($self->{'conf'}, "header_font_size", 10, 3);
print $self->config_opt_textbox($self->{'conf'}, "text_color", 20, 3);
print $self->config_opt_textbox($self->{'conf'}, "text_bgcolor", 20, 3);

print $self->ui_table_hr();

print $self->config_opt_textbox($self->{'conf'}, "logo_image", 40, 3,
			  $self->{'text_hash'}->{'style_none'});
print $self->config_opt_textbox($self->{'conf'}, "image_size", 10, 3);	# XXX two numbers!
print $self->config_opt_textbox($self->{'conf'}, "logo_text", 40, 3);
print $self->config_opt_textbox($self->{'conf'}, "logo_text_color", 40, 3);

print $self->ui_table_hr();

print $self->config_opt_textbox($self->{'conf'}, "background_image", 40, 3,
			  $self->{'text_hash'}->{'style_none'});
print $self->config_opt_textbox($self->{'conf'}, "background_color", 20, 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

