#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Immediately generate the report

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'gen_err'});
if (!$self->{'in_hash'}->{'range_def'}) {
	$self->{'in_hash'}->{'rfrom'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'gen_efrom'});
	$self->{'in_hash'}->{'rto'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'gen_eto'});
	}

$self->{'theme_no_table'}++;
$| = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'gen_title'}, "");

$self->{'conf'} = $self->get_config();
$self->{'sfile'} = $self->find_value("access_log", $self->{'conf'});
print "<b>",$self->text('gen_header', "<tt>$self->{'sfile'}</tt>"),"</b><br>\n";
print "<pre>";
$self->{'rv'} = $self->generate_report(STDOUT, 1, $self->{'in_hash'}->{'clear'},
		       $self->{'in_hash'}->{'range_def'} ? ( ) : ( $self->{'in_hash'}->{'rfrom'}, $self->{'in_hash'}->{'rto'} ) );
print "</pre>\n";

$self->{'odir'} = $self->find_value("output_dir", $self->{'conf'});
$self->{'odir'} ||= $self->find_value("output_dir", $self->{'conf'}, 1);
if ($self->{'rv'} && -r "$self->{'odir'}/index.html") {
	print "<b>$self->{'text_hash'}->{'gen_done'}</b><p>\n";
	print "<a href='view.cgi/index.html'>$self->{'text_hash'}->{'gen_view'}</a><p>\n";
	}
elsif ($self->{'rv'}) {
	print "<b>$self->{'text_hash'}->{'gen_nothing'}</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'gen_failed'}</b><p>\n";
	}

$self->webmin_log("generate");
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

