#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_log.cgi
# Display the report for some log file

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->ReadParse();

$self->{'file'} = $ENV{'PATH_INFO'} || "/index.html";
$self->{'file'} =~ /\.\./ || $self->{'file'} =~ /\<|\>|\||\0/ && $self->error($self->{'text_hash'}->{'view_efile'});

$self->{'conf'} = $self->get_config();
$self->{'odir'} = $self->find_value("output_dir", $self->{'conf'});
$self->{'odir'} ||= $self->find_value("output_dir", $self->{'conf'}, 1);
$self->{'odir'} || $self->error($self->{'text_hash'}->{'view_eodir'});
$self->{'full'} = "$self->{'odir'}$self->{'file'}";
open(FILE, $self->{'full'}) || $self->error($self->{'text_hash'}->{'view_eopen'}." : $self->{'full'}");

# Display file contents
if ($self->{'full'} =~ /\.(html|htm)$/i && !$self->{'config_hash'}->{'naked'}) {
	while(read(FILE, $self->{'buf'}, 1024)) {
		$self->{'data'} .= $self->{'buf'};
		}
	close(FILE);
	if ($self->{'data'} =~ /<TITLE>(.*)<\/TITLE>/i) {
		$self->{'title'} = $1;
		}
	$self->{'data'} =~ s/^[\000-\377]*<BODY.*>//i;
	$self->{'data'} =~ s/<\/BODY>[\000-\377]*$//i;

	$self->header($self->{'title'} || $self->{'text_hash'}->{'view_title'}, "");
	print $self->{'data'};
	$self->footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	print "Content-type: ",$self->{'full'} =~ /\.png$/i ? "image/png" :
			       $self->{'full'} =~ /\.gif$/i ? "image/gif" :
			       $self->{'full'} =~ /\.(jpg|jpeg)$/i ? "image/jpeg" :
			       $self->{'full'} =~ /\.(html|htm)$/i ? "text/html" :
							   "text/plain","\n";
	print "\n";
	while(read(FILE, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close(FILE);
	}

1;
		
}


1;

