#!/usr/bin/perl
package sendmail::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sendmail::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: ref($self), %$self; 
&ModuleLoader::preload_module(ref($self), "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: ref($self), %$self; 

%{$self->{'mail_sync_hash'}} = map { $_, 1 } split(/,/, $self->{'config_hash'}->{'mail_sync'});

1;

1;
		return $self;
}

# useradmin_create_user(&details)
sub useradmin_create_user
{
	my $self = shift;

local $dir = $self->{'config_hash'}->{'mail_dir'};
if ($dir && -d $dir && $self->{'mail_sync_hash'}->{'create'}) {
	local $mf = "$dir/$_[0]->{'user'}";
	if (!-e $mf) {
		open(TOUCH, ">$mf");
		close(TOUCH);
		chown($_[0]->{'uid'}, $_[0]->{'gid'}, $mf);
		}
	}
}

# useradmin_delete_user(&details)
# Delete this user's mail file and remove from any aliases
sub useradmin_delete_user
{
	my $self = shift;

local $dir = $self->{'config_hash'}->{'mail_dir'};
if ($dir && -d $dir && $self->{'mail_sync_hash'}->{'delete'}) {
	unlink("$dir/$_[0]->{'user'}");
	unlink("$dir/.$_[0]->{'user'}.pop");
	}
local $conf = $self->get_sendmailcf();
local $afile = $self->aliases_file($conf);
local @aliases = $self->list_aliases($afile);
foreach $a (@aliases) {
	return if ($a->{'name'} eq $_[0]->{'user'});
	}
foreach $a (@aliases) {
	local @nv = grep { $_ ne $_[0]->{'user'} } @{$a->{'values'}};
	if (scalar(@nv) != scalar(@{$a->{'values'}})) {
		$a->{'values'} = \@nv;
		$self->modify_alias($a, $a);
		}
	}
}

# useradmin_modify_user(&details)
sub useradmin_modify_user
{
	my $self = shift;

local $dir = $self->{'config_hash'}->{'mail_dir'};
if ($dir && -d $dir && $self->{'mail_sync_hash'}->{'modify'}) {
	local $mfile = "$dir/$_[0]->{'olduser'}";
	local @st = stat($mfile);
	if ($st[4] != $_[0]->{'uid'}) {
		chown($_[0]->{'uid'}, $st[5], $mfile);
		}
	if ($_[0]->{'olduser'} ne $_[0]->{'user'} && -r $mfile) {
		$self->rename_logged($mfile, "$dir/$_[0]->{'user'}");
		}
	}
}


1;

