#!/usr/bin/perl

&MAIN();

 sub MAIN {
# build.cgi
# Build a new sendmail.cf, after first confirming the changes

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::FeaturesLib");
$self = new sendmail::FeaturesLib:: 'sendmail_class',%$self;

$self->{'features_access'} || $self->error($self->{'text_hash'}->{'features_ecannot'});
$self->ReadParse();
$self->{'cmd'} = "cd $self->{'config_hash'}->{'sendmail_features'}/m4 ; m4 $self->{'config_hash'}->{'sendmail_features'}/m4/cf.m4 $self->{'config_hash'}->{'sendmail_mc'}";

if ($self->{'in_hash'}->{'confirm'}) {
	# Replace sendmail.cf with new version
	$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});
	system("$self->{'cmd'} 2>/dev/null >$self->{'config_hash'}->{'sendmail_cf'} </dev/null");
	$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});
	$self->restart_sendmail();
	$self->webmin_log("build");
	$self->redirect("");
	}
else {
	# Just show user what would be done
	$self->ui_print_header(undef, $self->{'text_hash'}->{'build_title'}, "");

	if (!$self->has_command("m4")) {
		print $self->text('build_em4', "<tt>m4</tt>"),"<p>\n";
		$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});
		exit;
		}

	$self->{'temp'} = $self->transname();
	$self->{'out'} = `$self->{'cmd'} 2>&1 >$self->{'temp'}`;
	if ($?) {
		print $self->text('build_ebuild', "<pre>$self->{'out'}</pre>"),"<p>\n";
		$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});
		exit;
		}
	if ($self->has_command("diff") && -r $self->{'config_hash'}->{'sendmail_cf'}) {
		$self->{'diff'} = `diff $self->{'config_hash'}->{'sendmail_cf'} $self->{'temp'} 2>/dev/null`;
		if (!$self->{'diff'}) {
			print "$self->{'text_hash'}->{'build_nodiff'}<p>\n";
			$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});
			exit;
			}
		}
	
	print "<center><form action=build.cgi>\n";
	print "<input type=hidden name=confirm value=1>\n";
	print $self->text('build_rusure', "<tt>$self->{'config_hash'}->{'sendmail_cf'}</tt>",
		    "<tt>$self->{'config_hash'}->{'sendmail_mc'}</tt>"),"<p>\n";
	print $self->{'text_hash'}->{'build_rusure2'},"<p>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'build_ok'}'>\n";
	print "</form></center>\n";

	if ($self->{'diff'}) {
		print "<b>$self->{'text_hash'}->{'build_diff'}</b><p>\n";
		print "<table border><tr $self->{'cb'}><td><pre>",
		      $self->{'diff'},"</pre></td></tr></table><p>\n";
		}
	unlink($self->{'temp'});

	$self->ui_print_footer("list_features.cgi", $self->{'text_hash'}->{'features_return'});
	}

1;
		
}


1;

