#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_file.cgi
# Create the file for virtusers, domains, mailers or access_db

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_sendmailcf();
if ($self->{'in_hash'}->{'mode'} eq 'virtusers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: 'sendmail_class',%$self;

	$self->{'access_hash'}->{'vmode'} || $self->error($self->{'text_hash'}->{'virtusers_ecannot'});
	$self->{'file'} = $self->virtusers_file($self->{'conf'});
	($self->{'dbm'}, $self->{'dbmtype'}) = $self->virtusers_dbm($self->{'conf'});
	$self->{'log'} = "virtuser";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'mailers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;

	$self->{'access_hash'}->{'mailers'} || $self->error($self->{'text_hash'}->{'mailers_ecannot'});
	$self->{'file'} = $self->mailers_file($self->{'conf'});
	($self->{'dbm'}, $self->{'dbmtype'}) = $self->mailers_dbm($self->{'conf'});
	$self->{'log'} = "mailer";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'generics') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

	$self->{'access_hash'}->{'omode'} || $self->error($self->{'text_hash'}->{'generics_cannot'});
	$self->{'file'} = $self->generics_file($self->{'conf'});
	($self->{'dbm'}, $self->{'dbmtype'}) = $self->generics_dbm($self->{'conf'});
	$self->{'log'} = "generic";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'domains') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::DomainLib");
$self = new sendmail::DomainLib:: 'sendmail_class',%$self;

	$self->{'access_hash'}->{'domains'} || $self->error($self->{'text_hash'}->{'domains_ecannot'});
	$self->{'file'} = $self->domains_file($self->{'conf'});
	($self->{'dbm'}, $self->{'dbmtype'}) = $self->domains_dbm($self->{'conf'});
	$self->{'log'} = "domain";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'access') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

	$self->{'access_hash'}->{'access'} || $self->error($self->{'text_hash'}->{'access_ecannot'});
	$self->{'file'} = $self->access_file($self->{'conf'});
	($self->{'dbm'}, $self->{'dbmtype'}) = $self->access_dbm($self->{'conf'});
	$self->{'log'} = "access";
	}

$self->open_lock_tempfile(DFILE, ">>$self->{'file'}");
$self->close_tempfile(DFILE);
$self->system_logged("$self->{'config_hash'}->{'makemap_path'} $self->{'dbmtype'} $self->{'dbm'} <$self->{'file'}");
$self->webmin_log("manual", $self->{'log'}, $self->{'file'});
$self->redirect("list_$self->{'in_hash'}->{'mode'}.cgi");

1;
		
}


1;

