#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several generics

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'gdelete_err'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'vfile'} = $self->generics_file($self->{'conf'});
($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->generics_dbm($self->{'conf'});

# Find and validate
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'adelete_enone'});
@{$self->{'virts_array'}} = $self->list_generics($self->{'vfile'});
foreach $d (@d) {
	($virt) = grep { $_->{'from'} eq $d } @{$self->{'virts_array'}};
	if ($virt) {
		$self->can_edit_generic($virt) ||
			$self->error($self->text('gdelete_ecannot', $d));
		push(@{$self->{'delvirts_array'}}, $virt);
		}
	}

# Delete the aliases
$self->lock_file($self->{'vfile'});
foreach $virt (@{$self->{'delvirts_array'}}) {
	$self->delete_generic($virt, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'});
	}
$self->unlock_file($self->{'vfile'});

$self->webmin_log("delete", "generics", scalar(@{$self->{'delvirts_array'}}));
$self->redirect("list_generics.cgi");

1;
		
}


1;

