#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several mailers

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'mdelete_err'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'vfile'} = $self->mailers_file($self->{'conf'});
($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->mailers_dbm($self->{'conf'});

# Find and validate
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'adelete_enone'});
@{$self->{'virts_array'}} = $self->list_mailers($self->{'vfile'});
foreach $d (@d) {
	($virt) = grep { $_->{'domain'} eq $d } @{$self->{'virts_array'}};
	if ($virt) {
		push(@{$self->{'delvirts_array'}}, $virt);
		}
	}

# Delete the aliases
$self->lock_file($self->{'vfile'});
foreach $virt (@{$self->{'delvirts_array'}}) {
	$self->delete_mailer($virt, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'});
	}
$self->unlock_file($self->{'vfile'});

$self->webmin_log("delete", "mailers", scalar(@{$self->{'delvirts_array'}}));
$self->redirect("list_mailers.cgi");

1;
		
}


1;

