#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_features.cgi
# Display a list of all sendmail features from the M4 file

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::FeaturesLib");
$self = new sendmail::FeaturesLib:: 'sendmail_class',%$self;


$self->{'features_access'} || $self->error($self->{'text_hash'}->{'features_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'features_title'}, "");

@{$self->{'features_array'}} = $self->list_features() if (-r $self->{'config_hash'}->{'sendmail_mc'} &&
				 -r "$self->{'config_hash'}->{'sendmail_features'}/feature");
if (@{$self->{'features_array'}}) {
	# Show table of features
	print $self->text('features_desc', "<tt>$self->{'config_hash'}->{'sendmail_mc'}</tt>",
		    "<tt>$self->{'config_hash'}->{'sendmail_cf'}</tt>"),"<p>\n";
	print "<form action=edit_feature.cgi>\n";
	print "<input type=hidden name=new value=1>\n";
	print "<table cellpadding=0 cellspacing=0 width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'features_type'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'features_value'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'features_move'}</b></td> </tr>\n";
	local $i = 0;
	foreach $f (@{$self->{'features_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='edit_feature.cgi?idx=$f->{'index'}'>";
		print "<b>" if ($f->{'type'});
		print $self->{'text_hash'}->{"features_type".$f->{'type'}};
		print "</b>" if ($f->{'type'});
		print "</a></td>\n";
		print "<td><tt>",$f->{'text'} ? $self->html_escape($f->{'text'})
					      : "<br>","</tt></td>\n";
		print "</tt></td>\n";
		print "<td>";
		if ($i == @{$self->{'features_array'}}-1) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$i&down=1'>",
			      "<img border=0 src=images/down.gif></a>";
			}
		if ($i == 0) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$i&up=1'>",
			      "<img border=0 src=images/up.gif></a>";
			}
		print "</td>\n";
		print "</tr>\n";
		$i++;
		}
	print "</table>\n";
	print "<table width=100%><tr><td>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'features_add'}'>\n";
	print "<select name=type>\n";
	foreach $i (0, 1, 2, 4, 5) {
		print "<option value=$i>",$self->{'text_hash'}->{'features_type'.$i},"\n";
		}
	print "</select></td>\n";
	print "<td align=right><input type=submit name=manual ",
	      "value='$self->{'text_hash'}->{'features_manual'}'></td>\n";
	print "</tr></table></form>\n";

	# Show button to rebuild sendmail.cf
	print "<hr>\n";
	print "<form action=build.cgi>\n";
	print "<table width=100%><tr>\n";
	print "<td><input type=submit value='$self->{'text_hash'}->{'features_build'}'></td>\n";
	print "<td>",$self->text('features_buildmsg', "<tt>$self->{'config_hash'}->{'sendmail_cf'}</tt>"),
	      "</td>\n";
	print "</tr></table>\n";
	}
else {
	# Features file is not setup yet ..
	if (!$self->{'config_hash'}->{'sendmail_mc'} || !$self->{'config_hash'}->{'sendmail_features'}) {
		print "<p>",$self->text('features_econfig',
				  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
		}
	elsif (!-r $self->{'config_hash'}->{'sendmail_mc'}) {
		print "<p>",$self->text('features_emc', "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}",
				  "<tt>$self->{'config_hash'}->{'sendmail_mc'}</tt>"),"<p>\n";
		}
	elsif (!-r "$self->{'config_hash'}->{'sendmail_features'}/feature") {
		print "<p>",$self->text('features_efeatures', "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}",
				  "<tt>$self->{'config_hash'}->{'sendmail_features'}</tt>"),"<p>\n";
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

