#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_relay.cgi
# List domains to while relaying is allowed

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->{'access_hash'}->{'relay'} || $self->error($self->{'text_hash'}->{'relay_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'relay_title'}, "");

$self->{'conf'} = $self->get_sendmailcf();
$self->{'ver'} = $self->find_type("V", $self->{'conf'});
if ($self->{'ver'}->{'value'} !~ /^(\d+)/ || $1 < 8) {
	# Only sendmail 8.9 and above supports relay domains (I think)
	print "<b>",$self->{'text_hash'}->{'relay_eversion'},"</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

@{$self->{'dlist_array'}} = $self->get_file_or_config($self->{'conf'}, "R");

print "<form method=post action=save_relay.cgi enctype=multipart/form-data>\n";
print "<table cellpadding=5 width=100%><tr><td valign=top nowrap>\n";
print "<b>$self->{'text_hash'}->{'relay_domains'}</b><br>\n";
print "<textarea name=dlist rows=15 cols=65>",
	join("\n", @{$self->{'dlist_array'}}),"</textarea><br>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";

print "</td><td valign=top>\n";
print $self->text('relay_desc1', "list_access.cgi"),"<p>\n";
print $self->text('relay_desc2', "list_mailers.cgi"),"<br>\n";
print "</td></tr></table>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

