#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mailq_search.cgi
# Display some messages from the mail queue

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::BoxesLib");
$self = new sendmail::BoxesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'searchq_title'}, "");

# Get all of the queued messages that this user can see
$self->{'conf'} = $self->get_sendmailcf();
@{$self->{'qfiles_array'}} = $self->list_mail_queue($self->{'conf'});
@{$self->{'qmails_array'}} = grep { $self->can_view_qfile($_) }
	       map { $self->mail_from_queue($_, "auto") } @{$self->{'qfiles_array'}};

# Do the search
$self->{'fields'} = [ [ $self->{'in_hash'}->{'field'}, $self->{'in_hash'}->{'match'} ] ];
@{$self->{'qmails_array'}} = grep { $self->mail_matches($self->{'fields'}, 1, $_) } @{$self->{'qmails_array'}};
print "<p><b>",$self->text($self->{'in_hash'}->{'field'} =~ /^\!/ ? 'search_results3' :
	  'search_results2', scalar(@{$self->{'qmails_array'}}), "<tt>$self->{'in_hash'}->{'match'}</tt>"),"</b><p>\n";

if (@{$self->{'qmails_array'}}) {
	%{$self->{'qmails_hash'}} = map { $_->{'file'}, $_ } @{$self->{'qmails_array'}};
	$self->mailq_table([ map { $_->{'file'} } @{$self->{'qmails_array'}} ], \%{$self->{'qmails_hash'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'searchq_none'}</b> <p>\n";
	}

$self->ui_print_footer("list_mailq.cgi", $self->{'text_hash'}->{'mailq_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

