#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_access.cgi
# Save, create or delete an access rule

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'access'} || $self->error($self->{'text_hash'}->{'access_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'afile'} = $self->access_file($self->{'conf'});
$self->lock_file($self->{'afile'});
($self->{'adbm'}, $self->{'adbmtype'}) = $self->access_dbm($self->{'conf'});
@{$self->{'accs_array'}} = $self->list_access($self->{'afile'});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'a'} = $self->{'accs_array'}->[$self->{'in_hash'}->{'num'}];
	$self->can_edit_access($self->{'a'}) ||
		$self->error($self->{'text_hash'}->{'sform_ecannot'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# delete some rule
	$self->{'loga'} = $self->{'a'};
	$self->delete_access($self->{'a'}, $self->{'afile'}, $self->{'adbm'}, $self->{'adbmtype'});
	}
else {
	# Saving or creating.. check inputs
	$self->{'whatfailed'} = "Failed to save spam control rule";
	$self->{'from'} = $self->{'in_hash'}->{'from'};
	$self->{'in_hash'}->{'from_type'} == 0 && $self->{'from'} !~ /^[^\@ ]+\@[A-z0-9\.\-]+$/ &&
		$self->error($self->text('ssave_etype0', $self->{'from'}));
	$self->{'in_hash'}->{'from_type'} == 1 && $self->{'from'} !~ /^[0-9\.]+$/ &&
		$self->error($self->text('ssave_etype1', $self->{'from'}));
	$self->{'in_hash'}->{'from_type'} == 2 && $self->{'from'} !~ /^[^\@ ]+$/ &&
		$self->error($self->text('ssave_etype2', $self->{'from'}));
	$self->{'in_hash'}->{'from_type'} == 3 && $self->{'from'} !~ /^[A-z0-9\.\-]+$/ &&
		$self->error($self->text('ssave_etype3', $self->{'from'}));
	$self->{'from'} .= '@' if ($self->{'in_hash'}->{'from_type'} == 2);

	if ($self->{'in_hash'}->{'new'} || uc($self->{'from'}) ne uc($self->{'a'}->{'from'}) ||
	    $self->{'in_hash'}->{'tag'} ne $self->{'a'}->{'tag'}) {
		# Is this name taken?
		local ($same) = grep { uc($_->{'from'}) eq uc($self->{'from'}) &&
				       $_->{'tag'} eq $self->{'in_hash'}->{'tag'} } @{$self->{'accs_array'}};
		$same && $self->error($self->text('ssave_ealready', $self->{'from'}));
		}

	if ($self->{'in_hash'}->{'action'}) { $self->{'action'} = $self->{'in_hash'}->{'action'}; }
	else {
		$self->{'in_hash'}->{'err'} =~ /^\d\d\d$/ ||
			$self->error($self->text('ssave_ecode', $self->{'in_hash'}->{'err'}));
		$self->{'action'} = "$self->{'in_hash'}->{'err'} $self->{'in_hash'}->{'msg'}";
		}

	%{$self->{'newa_hash'}} = ( 'from', $self->{'from'},
		  'action', $self->{'action'},
		  'tag', $self->{'in_hash'}->{'tag'},
		  'cmt', $self->{'in_hash'}->{'cmt'} );
	$self->can_edit_access(\%{$self->{'newa_hash'}}) ||
		$self->error($self->{'text_hash'}->{'ssave_ecannot2'});
	if ($self->{'in_hash'}->{'new'}) { $self->create_access(\%{$self->{'newa_hash'}}, $self->{'afile'}, $self->{'adbm'}, $self->{'adbmtype'}); }
	else { $self->modify_access($self->{'a'}, \%{$self->{'newa_hash'}}, $self->{'afile'}, $self->{'adbm'}, $self->{'adbmtype'}); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->unlock_file($self->{'afile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "access", $self->{'loga'}->{'from'}, $self->{'loga'});
$self->redirect("list_access.cgi");

1;
		
}


1;

