#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_file.cgi
# Save a manually edited file

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->error_setup($self->{'text_hash'}->{'file_err'});
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'file_ecannot'});
$self->ReadParseMime();
$self->{'conf'} = $self->get_sendmailcf();
if ($self->{'in_hash'}->{'mode'} eq 'aliases') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->aliases_file($self->{'conf'})->[$self->{'in_hash'}->{'idx'}];
	$self->{'return'} = "list_aliases.cgi";
	$self->{'post'} = "newaliases";
	$self->{'access_hash'}->{'amode'} == 1 && $self->{'access_hash'}->{'aedit_1'} && $self->{'access_hash'}->{'aedit_2'} &&
	    $self->{'access_hash'}->{'aedit_3'} && $self->{'access_hash'}->{'aedit_4'} && $self->{'access_hash'}->{'aedit_5'} &&
	    $self->{'access_hash'}->{'amax'} == 0 && $self->{'access_hash'}->{'apath'} eq '/' ||
	    $self->error($self->{'text_hash'}->{'file_ealiases'});
	$self->{'log'} = "alias";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'virtusers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->virtusers_file($self->{'conf'});
	($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->virtusers_dbm($self->{'conf'});
	$self->{'return'} = "list_virtusers.cgi";
	$self->{'post'} = "$self->{'config_hash'}->{'makemap_path'} $self->{'vdbmtype'} $self->{'vdbm'} <$self->{'file'}";
	$self->{'access_hash'}->{'vmode'} == 1 && $self->{'access_hash'}->{'vedit_0'} && $self->{'access_hash'}->{'vedit_1'} &&
	    $self->{'access_hash'}->{'vedit_2'} && $self->{'access_hash'}->{'vmax'} == 0 ||
	    $self->error($self->{'text_hash'}->{'file_evirtusers'});
	$self->{'log'} = "virtuser";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'mailers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->mailers_file($self->{'conf'});
	($self->{'mdbm'}, $self->{'mdbmtype'}) = $self->mailers_dbm($self->{'conf'});
	$self->{'return'} = "list_mailers.cgi";
	$self->{'post'} = "$self->{'config_hash'}->{'makemap_path'} $self->{'mdbmtype'} $self->{'mdbm'} <$self->{'file'}";
	$self->{'access_hash'}->{'mailers'} || $self->error($self->{'text_hash'}->{'file_emailers'});
	$self->{'log'} = "mailer";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'generics') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->generics_file($self->{'conf'});
	($self->{'gdbm'}, $self->{'gdbmtype'}) = $self->generics_dbm($self->{'conf'});
	$self->{'return'} = "list_generics.cgi";
	$self->{'post'} = "$self->{'config_hash'}->{'makemap_path'} $self->{'gdbmtype'} $self->{'gdbm'} <$self->{'file'}";
	$self->{'access_hash'}->{'omode'} == 1 || $self->error($self->{'text_hash'}->{'file_egenerics'});
	$self->{'log'} = "generic";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'domains') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::DomainLib");
$self = new sendmail::DomainLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->domains_file($self->{'conf'});
	($self->{'ddbm'}, $self->{'ddbmtype'}) = $self->domains_dbm($self->{'conf'});
	$self->{'return'} = "list_domains.cgi";
	$self->{'post'} = "$self->{'config_hash'}->{'makemap_path'} $self->{'ddbmtype'} $self->{'ddbm'} <$self->{'file'}";
	$self->{'access_hash'}->{'domains'} || $self->error($self->{'text_hash'}->{'file_edomains'});
	$self->{'log'} = "domain";
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'access') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->access_file($self->{'conf'});
	($self->{'adbm'}, $self->{'adbmtype'}) = $self->access_dbm($self->{'conf'});
	$self->{'return'} = "list_access.cgi";
	$self->{'post'} = "$self->{'config_hash'}->{'makemap_path'} $self->{'adbmtype'} $self->{'adbm'} <$self->{'file'}";
	$self->{'access_hash'}->{'access'} || $self->error($self->{'text_hash'}->{'file_eaccess'});
	$self->{'log'} = "access";
	}
else { $self->error($self->{'text_hash'}->{'file_emode'}); }

$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->webmin_log("manual", $self->{'log'}, $self->{'file'});

$self->system_logged("$self->{'post'} >/dev/null 2>&1") if ($self->{'post'});
$self->redirect($self->{'return'});

1;
		
}


1;

