#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_generic.cgi
# Save, create or delete an outgoing address mapping

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'omode'} || $self->error($self->{'text_hash'}->{'gsave_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'gfile'} = $self->generics_file($self->{'conf'});
$self->lock_file($self->{'gfile'});
($self->{'gdbm'}, $self->{'gdbmtype'}) = $self->generics_dbm($self->{'conf'});
@{$self->{'gens_array'}} = $self->list_generics($self->{'gfile'});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'g'} = $self->{'gens_array'}->[$self->{'in_hash'}->{'num'}];
	$self->can_edit_generic($self->{'g'}) ||
		$self->error($self->{'text_hash'}->{'gsave_ecannot2'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# delete some mapping
	$self->{'logg'} = $self->{'g'};
	$self->delete_generic($self->{'g'}, $self->{'gfile'}, $self->{'gdbm'}, $self->{'gdbmtype'});
	}
else {
	# Saving or creating.. check inputs
	$self->error_setup($self->{'text_hash'}->{'gsave_err'});
	$self->{'in_hash'}->{'from'} =~ /^\S+$/ ||
		$self->error($self->text('gsave_efrom', $self->{'in_hash'}->{'from'}));
	$self->{'access_hash'}->{'omode'} == 1 || $self->{'in_hash'}->{'from'} =~ /$self->{'access_hash'}->{'oaddrs'}/ ||
		$self->error($self->text('gsave_ematch', $self->{'access_hash'}->{'oaddrs'}));
	$self->{'in_hash'}->{'to'} =~ /^\S+\@[a-z0-9\.\-\_]+$/i ||
		$self->error($self->text('gsave_eto', $self->{'in_hash'}->{'to'}));
	if ($self->{'in_hash'}->{'new'} || lc($self->{'in_hash'}->{'from'}) ne lc($self->{'g'}->{'from'})) {
		($self->{'same'}) = grep { lc($_->{'from'}) eq lc($self->{'in_hash'}->{'from'}) }
			       @{$self->{'gens_array'}};
		$self->{'same'} && $self->error($self->text('gsave_ealready', $self->{'in_hash'}->{'from'}));
		}
	$self->{'newg_hash'}->{'from'} = $self->{'in_hash'}->{'from'};
	$self->{'newg_hash'}->{'to'} = $self->{'in_hash'}->{'to'};
	$self->{'newg_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	$self->can_edit_generic(\%{$self->{'newg_hash'}}) ||
		$self->error($self->{'text_hash'}->{'gsave_ecannot3'});
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_generic(\%{$self->{'newg_hash'}}, $self->{'gfile'}, $self->{'gdbm'}, $self->{'gdbmtype'});
		}
	else {
		$self->modify_generic($self->{'g'}, \%{$self->{'newg_hash'}}, $self->{'gfile'}, $self->{'gdbm'}, $self->{'gdbmtype'});
		}
	$self->{'logg'} = \%{$self->{'newg_hash'}};
	}
$self->unlock_file($self->{'gfile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "generic", $self->{'logg'}->{'from'}, $self->{'logg'});
$self->redirect("list_generics.cgi");

1;
		
}


1;

