#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_mailer.cgi
# Save, create or delete a mailertable entry

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'mailers'} || $self->error($self->{'text_hash'}->{'msave_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'mfile'} = $self->mailers_file($self->{'conf'});
$self->lock_file($self->{'mfile'});
($self->{'mdbm'},$self->{'mdbmtype'}) = $self->mailers_dbm($self->{'conf'});
@{$self->{'mailers_array'}} = $self->list_mailers($self->{'mfile'});
foreach $ml (@{$self->{'mailers_array'}}) { $self->{'already_hash'}->{$ml->{'domain'}}++; }
if (!$self->{'in_hash'}->{'new'}) { $self->{'m'} = $self->{'mailers_array'}->[$self->{'in_hash'}->{'num'}]; }

if ($self->{'in_hash'}->{'delete'}) {
	# delete some mailer entry
	$self->{'logm'} = $self->{'m'};
	$self->delete_mailer($self->{'m'}, $self->{'mfile'}, $self->{'mdbm'}, $self->{'mdbmtype'});
	}
else {
	# Saving or creating.. check inputs
	$self->error_setup($self->{'text_hash'}->{'msave_err'});
	$self->{'domain'} = $self->{'in_hash'}->{'from_type'} == 1 ? ".".$self->{'in_hash'}->{'from_dom'} :
		  $self->{'in_hash'}->{'from_type'} == 2 ? $self->{'in_hash'}->{'from_all'} : $self->{'in_hash'}->{'from_host'};
	$self->{'domain'} =~ /^[A-z0-9\-\.]+$/ ||
		$self->error($self->text('msave_edomain', $self->{'domain'}));
	if ($self->{'already_hash'}->{$self->{'domain'}} && ($self->{'in_hash'}->{'new'} || $self->{'m'}->{'domain'} ne $self->{'domain'})) {
		$self->error($self->text('msave_edup', $self->{'domain'}));
		}
	if ($self->{'in_hash'}->{'new'} && $self->{'in_hash'}->{'from_type'} == 2 &&
	    $self->{'already_hash'}->{".".$self->{'in_hash'}->{'from_all'}}) {
		$self->error($self->text('msave_edup', $self->{'domain'}));
		}
	$self->{'mailer'} = $self->{'in_hash'}->{'mailer'};
	$self->{'dest'} = $self->{'in_hash'}->{'dest'};

	$self->{'newm_hash'}->{'domain'} = $self->{'domain'};
	$self->{'newm_hash'}->{'mailer'} = $self->{'mailer'};
	$self->{'newm_hash'}->{'dest'} = $self->{'in_hash'}->{'nomx'} && $self->{'mailer'} =~ /smtp|relay/ ? "[$self->{'dest'}]"
							       : $self->{'dest'};
	$self->{'newm_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_mailer(\%{$self->{'newm_hash'}}, $self->{'mfile'}, $self->{'mdbm'}, $self->{'mdbmtype'});
		if ($self->{'in_hash'}->{'from_type'} == 2) {
			# Add extra for hosts in domain
			$self->{'newm_hash'}->{'domain'} = ".".$self->{'in_hash'}->{'from_all'};
			$self->create_mailer(\%{$self->{'newm_hash'}}, $self->{'mfile'}, $self->{'mdbm'}, $self->{'mdbmtype'});
			}
		}
	else {
		$self->modify_mailer($self->{'m'}, \%{$self->{'newm_hash'}}, $self->{'mfile'}, $self->{'mdbm'}, $self->{'mdbmtype'});
		}
	$self->{'logm'} = \%{$self->{'newm_hash'}};
	}
$self->unlock_file($self->{'mfile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "mailer", $self->{'logm'}->{'domain'}, $self->{'logm'});
$self->redirect("list_mailers.cgi");

1;
		
}


1;

