#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_masq.cgi
# Save domain masquerading

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'masq'} || $self->error($self->{'text_hash'}->{'masq_ecannot'});
$self->error_setup($self->{'text_hash'}->{'masq_err'});
$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'in_hash'}->{'masq'} =~ /^[A-z0-9\-\.]*$/ ||
	$self->error($self->text('masq_edomain', $self->{'in_hash'}->{'masq'}));
@{$self->{'mlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'mlist'});
foreach $m (@{$self->{'mlist_array'}}) {
	$m =~ /^[A-z0-9\-\.]+$/ ||
		$self->error($self->text('masq_ehost', $m));
	$self->check_ipaddress($m) &&
		$self->error($self->text('masq_eip', $m));
	}
@{$self->{'mlist_array'}} = $self->unique(@{$self->{'mlist_array'}});
@{$self->{'nlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'nlist'});
foreach $n (@{$self->{'nlist_array'}}) {
	$n =~ /^[A-z0-9\-\.]+$/ ||
		$self->error($self->text('masq_ehost', $n));
	$self->check_ipaddress($n) &&
		$self->error($self->text('masq_eip', $n));
	}
@{$self->{'nlist_array'}} = $self->unique(@{$self->{'nlist_array'}});

# Update the DM directive (if there is one)
foreach $d ($self->find_type("D", $self->{'conf'})) {
	if ($d->{'value'} =~ /^M/) { push(@{$self->{'dmconf_array'}}, $d); }
	}
$self->save_directives($self->{'conf'}, \@{$self->{'dmconf_array'}},
		 [ { 'type' => 'D', 'values' => [ "M$self->{'in_hash'}->{'masq'}" ] } ]);

# Update domains to masquerade, and not to
$self->save_file_or_config($self->{'conf'}, "M", \@{$self->{'mlist_array'}});
$self->save_file_or_config($self->{'conf'}, "N", \@{$self->{'nlist_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});

$self->restart_sendmail();
$self->webmin_log("masq");
$self->redirect("");

1;
		
}


1;

