#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_relay.cgi
# Save relay domains list

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'relay'} || $self->error($self->{'text_hash'}->{'relay_ecannot'});
$self->error_setup($self->{'text_hash'}->{'relay_err'});
$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});

$self->{'conf'} = $self->get_sendmailcf();
$self->get_file_or_config($self->{'conf'}, "r", undef, \$self->{'rfile'});
$self->lock_file($self->{'rfile'}) if ($self->{'rfile'});
@{$self->{'dlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'dlist'});
foreach $d (@{$self->{'dlist_array'}}) {
	$d =~ /^[A-z0-9\-\.]+$/ ||
		$self->error($self->text('relay_edomain', $d));
	}
@{$self->{'dlist_array'}} = $self->unique(@{$self->{'dlist_array'}});

# Save relay domains
$self->save_file_or_config($self->{'conf'}, "R", \@{$self->{'dlist_array'}});

$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->unlock_file($self->{'rfile'}) if ($self->{'rfile'});
$self->restart_sendmail();
$self->webmin_log("relay");
$self->redirect("");

1;
		
}


1;

