#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_trusts.cgi
# Save trusted users list

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'trusts'} || $self->error($self->{'text_hash'}->{'trusts_ecannot'});
$self->error_setup($self->{'text_hash'}->{'trusts_err'});
$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->{'conf'} = $self->get_sendmailcf();
@{$self->{'tlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'tlist'});
foreach $u (@{$self->{'tlist_array'}}) {
	@{$self->{'uinfo_array'}} = getpwnam($u);
	@{$self->{'uinfo_array'}} || $self->error($self->text('trusts_euser', $u));
	}
@{$self->{'tlist_array'}} = $self->unique(@{$self->{'tlist_array'}});

# Update trusted users
$self->save_file_or_config($self->{'conf'}, "t", \@{$self->{'tlist_array'}}, "T");

$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->restart_sendmail();
$self->webmin_log("trusts");
$self->redirect("");

1;
		
}


1;

