#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_virtuser.cgi
# Save, create or delete an address mapping

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'vmode'} > 0 || $self->error($self->{'text_hash'}->{'vsave_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'vfile'} = $self->virtusers_file($self->{'conf'});
$self->lock_file($self->{'vfile'});
($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->virtusers_dbm($self->{'conf'});
@{$self->{'virts_array'}} = $self->list_virtusers($self->{'vfile'});
foreach $vu (@{$self->{'virts_array'}}) { $self->{'already_hash'}->{$vu->{'from'}}++; }
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'v'} = $self->{'virts_array'}->[$self->{'in_hash'}->{'num'}];
	$self->can_edit_virtuser($self->{'v'}) || $self->error($self->{'text_hash'}->{'vsave_ecannot2'});
	}
elsif ($self->{'access_hash'}->{'vmax'}) {
	local @cvirts =
		grep { $self->{'access_hash'}->{"vedit_".$self->virt_type($_->{'to'})} } @{$self->{'virts_array'}};
	if ($self->{'access_hash'}->{'vmode'} == 2) {
		@cvirts = grep { $_->{'from'} =~ /$self->{'access_hash'}->{'vaddrs'}/ } @cvirts;
		}
	elsif ($self->{'access_hash'}->{'vmode'} == 3) {
		@cvirts = grep { $_->{'from'} =~ /^$self->{'remote_user'}\@/ } @cvirts;
		}
	$self->error($self->text('vsave_emax', $self->{'access_hash'}->{'vmax'}))
		if (@cvirts >= $self->{'access_hash'}->{'vmax'});
	}

if ($self->{'in_hash'}->{'delete'}) {
	# delete some mapping
	$self->{'logv'} = $self->{'v'};
	$self->delete_virtuser($self->{'v'}, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'});
	}
else {
	# Saving or creating.. check inputs
	$self->error_setup($self->{'text_hash'}->{'vsave_err'});
	if ($self->{'in_hash'}->{'from_type'} == 0) {
		$self->{'in_hash'}->{'from_addr'} =~ /^(\S+)\@(\S+)$/ ||
			$self->error($self->text('vsave_efrom', $self->{'in_hash'}->{'from_addr'}));
		$self->{'from'} = $self->{'in_hash'}->{'from_addr'};
		if ($self->{'already_hash'}->{$self->{'from'}} && ($self->{'in_hash'}->{'new'} || $self->{'v'}->{'from'} ne $self->{'from'})) {
			$self->error($self->text('vsave_efromdup', $self->{'in_hash'}->{'from_addr'}));
			}
		}
	else {
		$self->{'in_hash'}->{'from_dom'} =~ /^([^\@ ]+)$/ ||
			$self->error($self->text('vsave_edom', $self->{'in_hash'}->{'from_dom'}));
		$self->{'from'} = "\@$self->{'in_hash'}->{'from_dom'}";
		if ($self->{'already_hash'}->{$self->{'from'}} && ($self->{'in_hash'}->{'new'} || $self->{'v'}->{'from'} ne $self->{'from'})) {
			$self->error($self->text('vsave_edomdup', $self->{'in_hash'}->{'from_dom'}));
			}
		}
	if ($self->{'access_hash'}->{'vmode'} == 2) {
		$self->{'from'} =~ /$self->{'access_hash'}->{'vaddrs'}/ ||
			$self->error($self->text('vsave_ematch', $self->{'access_hash'}->{'vaddrs'}));
		}
	elsif ($self->{'access_hash'}->{'vmode'} == 3) {
		$self->{'from'} =~ /^$self->{'remote_user'}\@/ || $self->error($self->{'text_hash'}->{'vsave_esame'});
		}
	if ($self->{'in_hash'}->{'to_type'} == 2) {
		$self->{'access_hash'}->{"vedit_2"} ||
			$self->error($self->{'text_hash'}->{'vsave_ecannot3'});
		$self->{'in_hash'}->{'to_addr'} =~ /^([^\s,]+)$/ ||
			$self->error($self->text('vsave_eaddr', $self->{'in_hash'}->{'to_addr'}));
		$self->{'to'} = $self->{'in_hash'}->{'to_addr'};
		}
	elsif ($self->{'in_hash'}->{'to_type'} == 1) {
		$self->{'access_hash'}->{"vedit_1"} ||
			$self->error($self->{'text_hash'}->{'vsave_ecannot4'});
		$self->{'in_hash'}->{'to_dom'} =~ /^([^\@ ]+)$/ ||
			$self->error($self->text('vsave_edom', $self->{'in_hash'}->{'to_dom'}));
		$self->{'in_hash'}->{'from_type'} == 1 ||
			$self->error($self->{'text_hash'}->{'vsave_edomdom'});
		$self->{'to'} = "\%1\@$self->{'in_hash'}->{'to_dom'}";
		}
	else {
		$self->{'access_hash'}->{"vedit_0"} ||
			$self->error($self->{'text_hash'}->{'vsave_ecannot5'});
		$self->{'to'} = "error:$self->{'in_hash'}->{'to_code'} $self->{'in_hash'}->{'to_error'}";
		}

	$self->{'newv_hash'}->{'from'} = $self->{'from'};
	$self->{'newv_hash'}->{'to'} = $self->{'to'};
	$self->{'newv_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	if ($self->{'in_hash'}->{'new'}) { $self->create_virtuser(\%{$self->{'newv_hash'}}, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'}); }
	else { $self->modify_virtuser($self->{'v'}, \%{$self->{'newv_hash'}}, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'}); }
	$self->{'logv'} = \%{$self->{'newv_hash'}};
	}
$self->unlock_file($self->{'vfile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "virtuser", $self->{'logv'}->{'from'}, $self->{'logv'});
$self->redirect("list_virtusers.cgi");

1;
		
}


1;

