#!/usr/bin/perl
package shell::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'shell::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "shell::ShellLib");
$self = new shell::ShellLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the shell module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_user'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$_[0]->{'user'} ? '' : 'checked', $self->{'text_hash'}->{'acl_user_def'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} ? 'checked' : '';
print "<input name=user size=8 value='$_[0]->{'user'}'> ",
      $self->user_chooser_button("user"),"</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the shell module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'user'} = $self->{'in_hash'}->{'user_def'} ? undef : $self->{'in_hash'}->{'user'};
}


1;

