#!/usr/bin/perl
package shorewall::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'shorewall::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the acl module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_nochange'}</b></td> <td>\n";
printf "<input type=radio name=nochange value=0 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'nochange'} ? '' : 'checked';
printf "<input type=radio name=nochange value=1 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'nochange'} ? 'checked' : '';

print "</tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_files'}</b></td> <td>\n";
print $self->ui_radio("files_def", $_[0]->{'files'} eq '*' ? 1 : 0,
		[ [ 1, $self->{'text_hash'}->{'acl_all'} ], [ 0, $self->{'text_hash'}->{'acl_sel'} ] ]),"<br>\n";
print $self->ui_select("files", [ split(/\s+/, $_[0]->{'files'}) ],
		 [ map { [ $_, $self->{'text_hash'}->{$_."_title"}." ($_)" ] }
		       @{$self->{'shorewall_files_array'}} ], 5, 1);
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'nochange'} = $self->{'in_hash'}->{'nochange'};
$_[0]->{'files'} = $self->{'in_hash'}->{'files_def'} ? "*"
				    : join(" ", split(/\0/, $self->{'in_hash'}->{'files'}));
}


1;

