#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of table rows

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
scalar(@{$self->{'d_array'}}) || $self->error($self->{'text_hash'}->{'delete_enone'});

$self->lock_table($self->{'in_hash'}->{'table'});
foreach $idx (sort { $b <=> $a } @{$self->{'d_array'}}) {
	$self->delete_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $idx);
	}
$self->unlock_table($self->{'in_hash'}->{'table'});
$self->webmin_log('deletes', 'table', $self->{'in_hash'}->{'table'});
$self->redirect("list.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

