#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display the contents of a table file

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_title"}, "");

$self->{'file'} = "$self->{'config_hash'}->{'config_dir'}/$self->{'in_hash'}->{'table'}";
$self->{'in_hash'}->{'table'} =~ /\.\./ && $self->error($self->{'text_hash'}->{'manual_efile'});
print $self->text('manual_desc', "<tt>$self->{'file'}</tt>"),"<p>\n";

print "<form action=manual_save.cgi method=post enctype=multipart/form-data>\n";
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'});
print "<textarea name=data rows=20 cols=80>";
open(FILE, $self->{'file'});
while(<FILE>) {
	print $self->html_escape($_);
	}
close(FILE);
print "</textarea><br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
print "<input type=reset value='$self->{'text_hash'}->{'manual_reset'}'>\n";
print "</form>\n";

$self->ui_print_footer("list.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_return"});
1;
		
}


1;

