#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save the contents of a table file

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParseMime();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->error_setup($self->{'text_hash'}->{'manual_err'});
$self->{'file'} = "$self->{'config_hash'}->{'config_dir'}/$self->{'in_hash'}->{'table'}";
$self->{'in_hash'}->{'table'} =~ /\.\./ && $self->error($self->{'text_hash'}->{'manual_efile'});
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->{'in_hash'}->{'data'} || $self->error($self->{'text_hash'}->{'manual_edata'});

$self->open_lock_tempfile(FILE, ">$self->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);
$self->webmin_log('manual', 'table', $self->{'in_hash'}->{'table'});
$self->redirect("list.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

