#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Updated, modify or delete a comment

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
$self->error_setup($self->{'text_hash'}->{"comment_err"});

$self->lock_table($self->{'in_hash'}->{'table'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete one row
	$self->delete_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'in_hash'}->{'idx'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'msg'} =~ /\S/ || $self->error($self->{'text_hash'}->{'comment_enone'});
	$self->{'line'} = "COMMENT $self->{'in_hash'}->{'msg'}";

	# Update or add
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'line'});
		}
	else {
		# Updating 
		$self->modify_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'in_hash'}->{'idx'}, $self->{'line'});
		}
	}
$self->unlock_table($self->{'in_hash'}->{'table'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "comment", $self->{'in_hash'}->{'table'});
$self->redirect("list.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

