#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Perform some action

&ModuleLoader::preload_module('smart_status_class', "smart_status::SmartstatusLib");
$self = new smart_status::SmartstatusLib:: 'smart_status_class',%$self;

$self->ReadParse();
$self->{'mode'} = $self->{'in_hash'}->{'short'} ? "short" :
	$self->{'in_hash'}->{'ext'} ? "ext" : "data";
$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'mode'}.'_title'}, "");

@{$self->{'drives_array'}} = $main::fdisk_object->list_disks_partitions();
($self->{'d'}) = grep { $_->{'device'} eq $self->{'in_hash'}->{'drive'} } @{$self->{'drives_array'}};
print $self->text($self->{'mode'}."_doing", $self->{'d'}->{'desc'}),"\n";
if ($self->{'mode'} eq "short") {
	($self->{'ok'}, $self->{'out'}) = $self->short_test($self->{'in_hash'}->{'drive'});
	}
elsif ($self->{'mode'} eq "ext") {
	($self->{'ok'}, $self->{'out'}) = $self->ext_test($self->{'in_hash'}->{'drive'});
	}
elsif ($self->{'mode'} eq "data") {
	($self->{'ok'}, $self->{'out'}) = $self->data_test($self->{'in_hash'}->{'drive'});
	}
print "<pre>$self->{'out'}</pre>\n";
if ($self->{'ok'}) {
	print $self->{'text_hash'}->{$self->{'mode'}."_ok"},"<p>\n";
	}
else {
	print $self->{'text_hash'}->{$self->{'mode'}."_failed"},"<p>\n";
	}

$self->ui_print_footer("index.cgi?drive=$self->{'in_hash'}->{'drive'}", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

