#!/usr/bin/perl

&MAIN();

 sub MAIN {
# log_viewer.cgi
# Display logfile

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'log_viewer_title'}, "");

# get logfile path
if (defined($self->{'in_hash'}->{'logfile'})) {
	$self->{'logfile'} = $self->{'in_hash'}->{'logfile'};
	# remove quotes
	$self->{'logfile'} =~ /\'([^\']*)\'/;
	$self->{'logfile'} = $1;
} else {
	$self->error("No logfile name supplied to logfile viewer!");
	}
$self->{'numlines'} = 40;
if (defined($self->{'in_hash'}->{'numlines'})) {
	$self->{'numlines'} = $self->{'in_hash'}->{'numlines'};
}

if ($self->{'numlines'} eq "all") {
	$self->{'newnumlines'} = $self->backquote_logged("/usr/bin/wc -l $self->{'logfile'}");
	if ($self->{'newnumlines'} =~ /([0-9]+)\s+$self->{'logfile'}/) {
		$self->{'numlines'} = $1;
		}
	}
$self->{'data'} = $self->backquote_logged("/usr/bin/tail -$self->{'numlines'} $self->{'logfile'}");
print "<h2>";
$self->text_and_whats_this("log_viewer_detail");
print " : $self->{'logfile'}</h2>\n";

print "<form method=\"POST\" action=\"log_viewer.cgi?logfile='$self->{'logfile'}'\">\n";

# show selection for number of logfile lines to display
print "<p>$self->{'text_hash'}->{'log_viewer_show_last'}&nbsp;:&nbsp;\n";
$self->print_selection("numlines", $self->{'numlines'}, \@{$self->{'logfile_numlines_values_array'}});
print "$self->{'text_hash'}->{'log_viewer_num_lines'}&nbsp;:&nbsp;$self->{'logfile'}&nbsp;";
print
 "<input type=submit name=\"submit\" value=\"$self->{'text_hash'}->{'log_viewer_submit'}\">";
print "</p></form>\n";

print "<hr>\n";

print "<p><pre>";
print "$self->{'data'}";
print "</pre></p>\n";

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});

1;
		
}


1;

