#!/usr/bin/perl

&MAIN();

 sub MAIN {
# chooser.cgi
# Outputs HTML for a frame-based path chooser 

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;


$self->init_config();
$self->ReadParse();

if (defined($self->{'in_hash'}->{'path'})) {
	$self->{'path'} = $self->{'in_hash'}->{'path'};
	# +'s get converted to spaces, convert back
	$self->{'path'} =~ s/\s/+/g;
	if ($self->{'path'} =~ /^(\/.*)$/) {
		# path entered is valid
		$self->{'path'}=$1;
		}
} else {
	$self->{'path'}="/";
	}
$self->{'add'} = int($self->{'in_hash'}->{'add'});

$self->{'frame'} = $self->{'in_hash'}->{'frame'};
if ($self->{'frame'} eq "" ) {
	$self->{'frame'} = 0;
}

if ($self->{'in_hash'}->{'frame'} == 0) {
	# base frame
	$self->PrintHeader();
	print "<title>$self->{'text_hash'}->{'path_chooser_title'}</title>\n";
	print "<frameset rows='*,50'>\n";
	print "<frame marginwidth=10 marginheight=10 name=topframe ",
	    "src=\"path_chooser.cgi?frame=1&path=$self->{'path'}&add=$self->{'add'}\">\n";
	print "<frame marginwidth=10 marginheight=10 name=bottomframe ",
	    "src=\"path_chooser.cgi?frame=2&add=$self->{'add'}&path=$self->{'path'}\"",
	    "scrolling=no>\n";
	print "</frameset>\n";
	}
elsif ($self->{'in_hash'}->{'frame'} == 1) {
	# List of svcs
	$self->header();
	print <<EOF;
<script>
function pathclick(path, expand)
{
top.bottomframe.document.forms[0].path.value = path;
if (expand == 1) {
	location ="path_chooser.cgi?frame=1&add=$self->{'add'}&path="+path;
	}
}

</script>
EOF
	print "<b>", $self->text('path_chooser_path', $self->{'path'}),"</b>\n";
	print "<table>\n";
	# get file/dir list
	if (opendir(CURRDIR, $self->{'path'})) {
		# remove extra trailing "/" if there.
		$self->{'fixed_filepath'} = $self->{'path'};
		$self->{'fixed_filepath'} =~ s/(.*)\/$/$1/;
		foreach $f (readdir(CURRDIR)) {
			if ($f eq ".") {
				# skip
			} elsif ($f eq "..") {
				$self->{'uplevel'} = "$self->{'fixed_filepath'}";
				if ($self->{'uplevel'} =~ /^((\/[^\/]*)*)\/[^\/]*$/) {
					$self->{'uplevel'} = $1;
					}
				if ($self->{'uplevel'} eq "") {
					$self->{'uplevel'} = "/";
					}
				$self->{'uplevel'} = $self->urlize($self->{'uplevel'});
				push(@{$self->{'pathlist_array'}},
"<td><a href='javascript:pathclick(\"$self->{'uplevel'}\",1)'><img border=0 width=30 height=30 src=\"images/uplevel.gif\"></a></td><td><a href='javascript:pathclick(\"$self->{'uplevel'}\",1)'>..</a></td>");
			} else {
				$self->{'expand'} = 0;
				$self->{'img'} = "images/file.gif";
				# is this a file or a dir?
				if (opendir(DISCARD, "$self->{'fixed_filepath'}/$f")) {
					close(DISCARD);
					$self->{'expand'} = 1;
					$self->{'img'} = "images/dir.gif";
					}
				$self->{'newpath'} = $self->urlize("$self->{'fixed_filepath'}/$f");
				push(@{$self->{'pathlist_array'}},
"<td><a href='javascript:pathclick(\"$self->{'newpath'}\",$self->{'expand'})'><img border=0 width=30 height=30 src=$self->{'img'}></a></td><td><a href='javascript:pathclick(\"$self->{'newpath'}\",$self->{'expand'})'>$f</a></td>");
				}
			}
		closedir(CURRDIR);
		}
	foreach $p (@{$self->{'pathlist_array'}}) {
		print "<tr>\n";
		print "$p";
		print "</tr>\n";
		}
	print "</table>\n";
	$self->footer();
	}
elsif ($self->{'in_hash'}->{'frame'} == 2) {
	# Current path and OK/cancel buttons
	$self->header();
	print <<EOF;
<script>
function pathchosen()
{
if ($self->{'add'} == 0) {
	top.opener.ifield.value =
	 "file://localhost"+document.forms[0].path.value;
	}
else {
	if (top.opener.ifield.value != "") {
		top.opener.ifield.value += " ";
		}
	top.opener.ifield.value +=
	 "file://localhost"+document.forms[0].path.value;
	}
top.close();
}
</script>
EOF
	print "<table width=100%><tr><td>\n";
	print "<form onSubmit='pathchosen(); return false'>\n";
	print
	 "<input name=path size=45 value=\"\">\n";
	print
	 "<input type=\"submit\" value=\"$self->{'text_hash'}->{'path_chooser_ok'}\">\n";
	print "</form>\n";
	print "</td><td>\n";
	print "<form>";
	print
"<input type=\"button\" onClick='top.close()' value=\"$self->{'text_hash'}->{'path_chooser_cancel'}\">";
	print "</form>";
	print "</td></tr></table></form>\n";
	$self->footer();
	}
1;
		
}


1;

