#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here
$self->wizard_header($self->{'wizard'}, "smfwizard_dependent.cgi",
	"$self->{'text_hash'}->{'smfwizard_dependent_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_dependent_description'}"),
	"images/smf.gif");

@{$self->{'sinst_list_array'}} = ("service");
# add existing instances to list...
@{$self->{'existing_insts_array'}} = $self->wizard_get_data_values("smfwizard_instance.cgi",
	"instance_name");
@{$self->{'sinst_list_array'}} = (@{$self->{'sinst_list_array'}}, @{$self->{'existing_insts_array'}});

$self->wizard_select("smfwizard_dependent.cgi", "$self->{'text_hash'}->{'smfwizard_sinst_name'}",
	"sinst", \@{$self->{'sinst_list_array'}}, ".+", "$self->{'text_hash'}->{'smfwizard_sinst_error'}");
$self->wizard_input("smfwizard_dependent.cgi", "$self->{'text_hash'}->{'smfwizard_dependent_name'}",
	"dependent_name", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_dependent_name_error'}");
$self->wizard_select("smfwizard_dependent.cgi", "$self->{'text_hash'}->{'smfwizard_dependent_type'}",
	"dependent_type", \@{$self->{'dep_types_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_dependent_type_error'}");
$self->wizard_select("smfwizard_dependent.cgi",
	"$self->{'text_hash'}->{'smfwizard_dependent_grouping'}", "dependent_grouping",
	\@{$self->{'grouping_values_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_dependent_grouping_error'}");
$self->wizard_select("smfwizard_dependent.cgi",
	"$self->{'text_hash'}->{'smfwizard_dependent_restart_on'}", "dependent_restart_on",
	\@{$self->{'restart_on_values_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_dependent_restart_on_error'}");
$self->wizard_input("smfwizard_dependent.cgi",
	"$self->{'text_hash'}->{'smfwizard_dependent_fmri'}", "dependent_fmri",
	60, ".+", "$self->{'text_hash'}->{'smfwizard_dependent_fmri_error'}");
print "<tr $self->{'cb'}><td>";
$self->print_svc_chooser("dependent_fmri", 0, "$self->{'text_hash'}->{'svc_chooser_titleboth'}",
	"both", "0");
$self->print_path_chooser("dependent_fmri", 0, "$self->{'text_hash'}->{'path_chooser_title'}",
	"0");
print "</td></tr>";
$self->wizard_select("smfwizard_dependent.cgi",
	"$self->{'text_hash'}->{'smfwizard_dependent_stability'}", "dependent_stability",
	\@{$self->{'stability_values_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_dependent_stability_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_dependent.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});
1;
		
}


1;

