#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here
$self->wizard_header($self->{'wizard'}, "smfwizard_manpage.cgi",
	"$self->{'text_hash'}->{'smfwizard_manpage_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_manpage_description'}"),
	"images/smf.gif");

$self->wizard_input("smfwizard_manpage.cgi",
	"$self->{'text_hash'}->{'smfwizard_manpage_title'}",
	"manpage_title", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_manpage_title_error'}");
$self->wizard_input("smfwizard_manpage.cgi",
	"$self->{'text_hash'}->{'smfwizard_manpage_section'}",
	"manpage_section", 10, ".+",
	"$self->{'text_hash'}->{'smfwizard_manpage_section_error'}");
$self->wizard_input("smfwizard_manpage.cgi",
	"$self->{'text_hash'}->{'smfwizard_manpage_manpath'}",
	"manpage_manpath", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_manpage_manpath_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_manpage.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});
1;
		
}


1;

