#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here
$self->wizard_header($self->{'wizard'}, "smfwizard_property_group.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_group_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_property_group_description'}"),
	"images/smf.gif");

$self->wizard_input("smfwizard_property_group.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_group_name'}",
	"property_group_name", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_property_group_name_error'}");
$self->wizard_input("smfwizard_property_group.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_group_type'}", "property_group_type",
	60, ".+", "$self->{'text_hash'}->{'smfwizard_property_group_type_error'}");
$self->wizard_select("smfwizard_property_group.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_group_stability'}",
	"property_group_stability",
	\@{$self->{'stability_values_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_property_group_stability_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_property_group.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});
1;
		
}


1;

