#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_pack.cgi
# Ask if the user wants to delete a package, and if so do it

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->{'p'} = $self->{'in_hash'}->{'package'};
$self->{'v'} = $self->{'in_hash'}->{'version'};
$self->error_setup($self->text('delete_err', $self->{'p'}));
(@{$self->{'pinfo_array'}} = $self->package_info($self->{'p'}, $self->{'v'})) ||
	$self->error($self->text('delete_epack', $self->{'p'}));

if ($self->{'in_hash'}->{'sure'}) {
	# do the deletion
	$self->list_packages($self->{'p'});
	if ($self->{'error'} = $self->delete_package($self->{'p'}, \%{$self->{'in_hash'}}, $self->{'v'})) {
		$self->error($self->{'error'});
		}
	$self->webmin_log("delete", "package", $self->{'p'}, { 'desc' => $self->{'packages_hash'}->{0,'desc'} });
	if ($self->{'in_hash'}->{'search'}) {
		$self->redirect("search.cgi?search=$self->{'in_hash'}->{'search'}");
		}
	else {
		$self->redirect("");
		}
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "", "delete");

	# Sum up files
	$self->{'n'} = $self->check_files($self->{'p'}, $self->{'v'});
	$self->{'sz'} = 0;
	for($i=0; $i<$self->{'n'}; $i++) {
		if ($self->{'files_hash'}->{$i,'type'} == 0) { $self->{'sz'} += $self->{'files_hash'}->{$i,'size'}; }
		}
	print "<center>\n";
	if ($self->{'n'}) {
		print $self->text('delete_rusure', "<tt>$self->{'p'}</tt>", $self->{'n'}, $self->{'sz'}),"<br>\n";
		}
	else {
		print $self->text('delete_rusure2', "<tt>$self->{'p'}</tt>"),"<br>\n";
		}

	# Ask if the user is sure..
	print "<form action=delete_pack.cgi>\n";
	print "<input type=hidden name=package value=\"$self->{'p'}\">\n";
	print "<input type=hidden name=version value=\"$self->{'v'}\">\n";
	print "<input type=hidden name=sure value=1>\n";
	print "<input type=hidden name=search value=\"$self->{'in_hash'}->{'search'}\">\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'delete_ok'}\"><p>\n";
	if ($self->UNIVERSAL::can('delete_options')) {
		$self->delete_options($self->{'p'});
		}
	print "</center></form>\n";

	$self->ui_print_footer("edit_pack.cgi?search=$self->{'in_hash'}->{'search'}&package=".$self->urlize($self->{'p'}).
	 	"&version=".$self->urlize($self->{'v'}), $self->{'text_hash'}->{'edit_return'});
	}

1;
		
}


1;

