#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pack.cgi
# Displays the details of an existing package, with links to uninstall and
# other options

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
@{$self->{'pinfo_array'}} = $self->package_info($self->{'in_hash'}->{'package'}, $self->{'in_hash'}->{'version'});
$self->{'pinfo_array'}->[0] || $self->error($self->{'text_hash'}->{'edit_egone'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "", "edit_pack");

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'pinfo_array'}->[2]) {
	print "<tr> <td valign=top width=20%><b>$self->{'text_hash'}->{'edit_desc'}</b></td>\n";
	print "<td colspan=3 align=left><pre>",
	      $self->html_escape($self->entities_to_ascii($self->{'pinfo_array'}->[2])),
	      "</pre></td> </tr>\n";
	}

print "<tr> <td width=20%><b>$self->{'text_hash'}->{'edit_pack'}</b></td> <td>",
	$self->html_escape($self->{'pinfo_array'}->[0]),"</td>\n";
print "<td width=20%><b>$self->{'text_hash'}->{'edit_class'}</b></td> <td>",
      $self->{'pinfo_array'}->[1] ? $self->html_escape($self->{'pinfo_array'}->[1]) : $self->{'text_hash'}->{'edit_none'},"</td> </tr>\n";

print "<tr> <td width=20%><b>$self->{'text_hash'}->{'edit_ver'}</b></td> <td>",
	$self->html_escape($self->{'pinfo_array'}->[4]),"</td>\n";
print "<td width=20%><b>$self->{'text_hash'}->{'edit_vend'}</b></td> <td>",
	$self->html_escape($self->{'pinfo_array'}->[5]),"</td> </tr>\n";

print "<tr> <td width=20%><b>$self->{'text_hash'}->{'edit_arch'}</b></td> <td>",
	$self->html_escape($self->{'pinfo_array'}->[3]),"</td>\n";
print "<td width=20%><b>$self->{'text_hash'}->{'edit_inst'}</b></td> <td>",
	$self->html_escape($self->{'pinfo_array'}->[6]),"</td> </tr>\n";
print "</table></td></tr></table><p>\n";

print "<table width=100%> <tr>\n";

# Show button to list files, if supported
if (!$self->{'pinfo_array'}->[8]) {
	print "<form action=list_pack.cgi>\n";
	print "<input type=hidden name=package value=\"$self->{'pinfo_array'}->[0]\">\n";
	print "<input type=hidden name=version value=\"$self->{'pinfo_array'}->[4]\">\n";
	print "<input type=hidden name=search value=\"$self->{'in_hash'}->{'search'}\">\n";
	print "<td align=left><input type=submit value=\"$self->{'text_hash'}->{'edit_list'}\"></td>\n";
	print "</form>\n";
	}

# Show button to un-install (if possible)
if (!$self->{'pinfo_array'}->[7]) {
	print "<form action=delete_pack.cgi>\n";
	print "<input type=hidden name=package value=\"$self->{'pinfo_array'}->[0]\">\n";
	print "<input type=hidden name=version value=\"$self->{'pinfo_array'}->[4]\">\n";
	print "<input type=hidden name=search value=\"$self->{'in_hash'}->{'search'}\">\n";
	print "<td align=right>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_uninst'}\"></td>\n";
	print "</form>\n";
	}

print "</tr> </table><p>\n";

if ($self->{'in_hash'}->{'search'}) {
	$self->ui_print_footer("search.cgi?search=$self->{'in_hash'}->{'search'}", $self->{'text_hash'}->{'search_return'});
	}
else {
	$self->ui_print_footer("tree.cgi#$self->{'pinfo_array'}->[1]", $self->{'text_hash'}->{'index_treturn'});
	}

1;
		
}


1;

