#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Upgrade all packages, or update the database of URPMI packages

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

# Work out what we are doing
if ($self->{'in_hash'}->{'upgrade'}) {
	$self->{'cmd'} = "urpmi --force --auto-select";
	$self->{'mode'} = "upgrade";
	}
else {
	$self->{'cmd'} = "urpmi.update main updates contrib";
	$self->{'mode'} = "update";
	}
	
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'urpmi_title_'.$self->{'mode'}}, "");

print "<b>",$self->text('urpmi_updatedesc', "<tt>$self->{'cmd'}</tt>"),"</b><p>\n";
print "<pre>";
$self->additional_log("exec", undef, $self->{'cmd'});
$self->clean_environment();
open(CMD, "$self->{'cmd'} 2>&1 </dev/null |");
while(<CMD>) {
	print $self->html_escape($_);
	}
close(CMD);
$self->reset_environment();
print "</pre>\n";
if ($?) {
	print "<b>$self->{'text_hash'}->{'uprmi_upgradefailed'}</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'urpmi_upgradeok'}</b><p>\n";
	$self->webmin_log("urpmi", $self->{'mode'})
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

