#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view.cgi
# Output the contents of a file

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->{'p'} = $ENV{'PATH_INFO'};

# Try to guess type from filename
if ($self->{'p'} =~ /\.([^\.\/]+)$/) {
	$self->{'ext'} = lc($1);
	$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
	open(MIME, $self->{'miniserv_hash'}->{'mimetypes'});
	while(<MIME>) {
		s/#.*//g;
		if (/(\S+)\s+(.*)/) {
			foreach $e (split(/\s+/, $2)) {
				if ($self->{'ext'} eq $e) {
					$self->{'type'} = $1;
					last;
					}
				}
			}
		}
	close(MIME);
	}
if (!$self->{'type'}) {
	# No idea .. use the 'file' command
	if (`file "$self->{'p'}"` =~ /text|script/) {
		$self->{'type'} = "text/plain";
		}
	else {
		$self->{'type'} = "application/octet-stream";
		}
	}

# Dump the file
if (!open(FILE, "<$self->{'p'}")) {
	print "Content-type: text/plain\n\n";
	print $self->text('list_eview', $self->{'p'}, $!),"\n";
	}
else {
	@{$self->{'st_array'}} = stat($self->{'p'});
	print "Content-length: $self->{'st_array'}->[7]\n";
	print "Content-type: $self->{'type'}\n\n";
	while(read(FILE, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close(FILE);
	}

1;
		
}


1;

