#!/usr/bin/perl

&MAIN();

 sub MAIN {
# yum_upgrade.cgi
# Upgrade all packages

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'yum_upgrade'}, "");

$self->clean_environment();
$self->{'cmd'} = "yum -y update";
print "<b>",$self->text('yum_upgradedesc', "<tt>$self->{'cmd'}</tt>"),"</b><p>\n";
print "<pre>";
$self->additional_log("exec", undef, $self->{'cmd'});
open(CMD, "$self->{'cmd'} 2>&1 </dev/null |");
while(<CMD>) {
	if (/^\[(update|install):\s+(\S+)\s+/) {
		push(@{$self->{'packs_array'}}, $2);
		}
	if (!/ETA/ && !/\%\s+done\s+\d+\/\d+\s*$/) {
		print $self->html_escape($_);
		}
	}
close(CMD);
$self->reset_environment();
print "</pre>\n";
if ($?) {
	print "<b>$self->{'text_hash'}->{'yum_upgradefailed'}</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'yum_upgradeok'}</b><p>\n";
	foreach $p (@{$self->{'packs_array'}}) {
		local @pinfo = $self->show_package_info($p);
		}
	$self->webmin_log("yum", "upgrade", undef, { 'packages' => \@{$self->{'packs_array'}} })
		if (@{$self->{'packs_array'}});
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

