#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_priv.cgi
# Display various privileged settings

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("priv");
$self->ui_print_header(undef, $self->{'text_hash'}->{'priv_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'priv_desc'}<p>\n";
$self->start_form("save_priv.cgi", $self->{'text_hash'}->{'priv_header'});

print "<tr> <td><b>$self->{'text_hash'}->{'priv_white'}</b></td> <td colspan=3 nowrap>";
$self->opt_field("auto_whitelist_path", $self->{'x'}=$self->find("auto_whitelist_path", $self->{'conf'}), 40,
	   "~/.spamassassin/auto-whitelist");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'priv_mode'}</b></td> <td nowrap>";
$self->opt_field("auto_whitelist_file_mode", $self->{'x'}=$self->find("auto_whitelist_file_mode", $self->{'conf'}), 4,
	   "0700");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'priv_dcc'}</b></td> <td nowrap>";
$self->opt_field("dcc_options", $self->{'x'}=$self->find("dcc_options", $self->{'conf'}), 10, "-R");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'priv_log'}</b></td> <td colspan=3 nowrap>";
$self->opt_field("timelog_path", $self->{'x'}=$self->find("timelog_path", $self->{'conf'}), 40, "NULL");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'priv_razor'}</b></td> <td colspan=3 nowrap>";
$self->opt_field("razor_config", $self->{'x'}=$self->find("razor_config", $self->{'conf'}), 40, "~/razor.conf");
print "</td> </tr>\n";

$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

