#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_setup.cgi
# Display a form for setting up SpamAssassin, either locally or globally

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("setup");
$self->ui_print_header(undef, $self->{'text_hash'}->{'setup_title'}, "");

$self->foreign_require("procmail", "procmail-lib.pl");
@{$self->{'pmrcs_array'}} = $self->get_procmailrc();
$self->{'pmrc'} = $self->{'pmrcs_array'}->[$#{$self->{'pmrcs_array'}}];
if ($self->{'module_info_hash'}->{'usermin'}) {
	print $self->text('setup_desc_usermin', "<tt>$self->{'pmrc'}</tt>"),"<p>\n";
	}
else {
	print $self->text('setup_desc_webmin', "<tt>$self->{'pmrc'}</tt>"),"<p>\n";
	}

print "<form action=setup.cgi>\n";
print "<table>\n";

# Spam destination inputs
print "<tr> <td rowspan=6 valign=top><b>$self->{'text_hash'}->{'setup_to'}</b></td>\n";

print "<td><input type=radio name=to value=0> $self->{'text_hash'}->{'setup_null'}</td> </tr>\n";

print "<td><input type=radio name=to value=4> $self->{'text_hash'}->{'setup_default'}</td> </tr>\n";

print "<td><input type=radio name=to value=1 checked> $self->{'text_hash'}->{'setup_file'}</td>\n";
printf "<td><input name=file size=30 value='%s'></td> </tr>\n",
	$self->{'module_info_hash'}->{'usermin'} ? "mail/spam" : "\$HOME/spam";

print "<td><input type=radio name=to value=2> $self->{'text_hash'}->{'setup_maildir'}</td>\n";
print "<td><input name=maildir size=30></td> </tr>\n";

print "<td><input type=radio name=to value=3> $self->{'text_hash'}->{'setup_mhdir'}</td>\n";
print "<td><input name=mhdir size=30></td> </tr>\n";

print "<td><input type=radio name=to value=5> $self->{'text_hash'}->{'setup_email'}</td>\n";
print "<td><input name=email size=30></td> </tr>\n";

# Run mode input
if (!$self->{'module_info_hash'}->{'usermin'}) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'setup_drop'}</b></td> <td>\n";
	print "<input type=radio name=drop value=1 checked> ",
	      "$self->{'text_hash'}->{'setup_drop1'}\n";
	print "<input type=radio name=drop value=0> ",
	      "$self->{'text_hash'}->{'setup_drop0'}</td> </tr>\n";
	}

print "</td></tr></table><br>\n";

if ($self->{'module_info_hash'}->{'usermin'}) {
	print "$self->{'text_hash'}->{'setup_rel'}<p>\n";
	}
else {
	print "$self->{'text_hash'}->{'setup_home'}<p>\n";
	}
print "$self->{'text_hash'}->{'setup_head'}<p>\n";

print "<input type=submit value='$self->{'text_hash'}->{'setup_ok'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

