#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_white.cgi
# Display white and black lists of to and from addresses

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("white");
$self->ui_print_header(undef, $self->{'text_hash'}->{'white_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'white_desc'}<p>\n";
$self->start_form("save_white.cgi", $self->{'text_hash'}->{'white_header'});

print "<tr> <td width=50%><b>$self->{'text_hash'}->{'white_from'}</b></td> ",
      "<td width=50%><b>$self->{'text_hash'}->{'white_unfrom'}</b></td> </tr>\n";
print "<tr> <td width=50%>\n";
@{$self->{'from_array'}} = $self->find("whitelist_from", $self->{'conf'});
$self->edit_textbox("whitelist_from", [ map { @{$_->{'words'}} } @{$self->{'from_array'}} ], 40, 5);
print "</td> <td width=50%>\n";
@{$self->{'un_array'}} = $self->find("unwhitelist_from", $self->{'conf'});
$self->edit_textbox("unwhitelist_from", [ map { @{$_->{'words'}} } @{$self->{'un_array'}} ], 40, 5);
print "</td> </tr>\n";

if ($self->{'config_hash'}->{'show_global'}) {
	print "<tr> <td width=50%><b>$self->{'text_hash'}->{'white_gfrom'}</b></td> ",
	      "<td width=50%><b>$self->{'text_hash'}->{'white_gunfrom'}</b></td> </tr>\n";
	$self->{'gconf'} = $self->get_config($self->{'config_hash'}->{'global_cf'});
	print "<tr> <td width=50%>\n";
	@{$self->{'gfrom_array'}} = $self->find("whitelist_from", $self->{'gconf'});
	$self->edit_textbox("gwhitelist_from", [ map { @{$_->{'words'}} } @{$self->{'gfrom_array'}} ], 40, 5);
	print "</td> <td width=50%>\n";
	@{$self->{'gun_array'}} = $self->find("unwhitelist_from", $self->{'gconf'});
	$self->edit_textbox("gunwhitelist_from", [ map { @{$_->{'words'}} } @{$self->{'gun_array'}} ], 40, 5);
	print "</td> </tr>\n";
	print "<script>\n";
	print "document.forms[0].gwhitelist_from.disabled = true;\n";
	print "document.forms[0].gunwhitelist_from.disabled = true;\n";
	print "</script>\n";
	}
else {
	print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'white_rcvd'}</b></td> </tr>\n";
	print "<tr> <td colspan=2>\n";
	@{$self->{'rcvd_array'}} = $self->find("whitelist_from_rcvd", $self->{'conf'});
	$self->edit_table("whitelist_from_rcvd",
		    [ $self->{'text_hash'}->{'white_addr'}, $self->{'text_hash'}->{'white_rcvdhost'} ],
		    [ map { $_->{'words'} } @{$self->{'rcvd_array'}} ], [ 40, 30 ], undef, 3);
	print "</td> </tr>\n";
	}

print "<tr> <td colspan=2><hr></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'white_black'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'white_unblack'}</b></td> </tr>\n";
print "<tr> <td>\n";
@{$self->{'from_array'}} = $self->find("blacklist_from", $self->{'conf'});
$self->edit_textbox("blacklist_from", [ map { @{$_->{'words'}} } @{$self->{'from_array'}} ], 40, 5);
print "</td> <td>\n";
@{$self->{'un_array'}} = $self->find("unblacklist_from", $self->{'conf'});
$self->edit_textbox("unblacklist_from", [ map { @{$_->{'words'}} } @{$self->{'un_array'}} ], 40, 5);
print "</td> </tr>\n";

if ($self->{'config_hash'}->{'show_global'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'white_gblack'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'white_gunblack'}</b></td> </tr>\n";
	print "<tr> <td>\n";
	@{$self->{'gfrom_array'}} = $self->find("blacklist_from", $self->{'gconf'});
	$self->edit_textbox("gblacklist_from", [ map { @{$_->{'words'}} } @{$self->{'gfrom_array'}} ], 40, 5);
	print "</td> <td>\n";
	@{$self->{'gun_array'}} = $self->find("gunblacklist_from", $self->{'gconf'});
	$self->edit_textbox("gunblacklist_from", [ map { @{$_->{'words'}} } @{$self->{'gun_array'}} ], 40, 5);
	print "</td> </tr>\n";
	print "<script>\n";
	print "document.forms[0].gblacklist_from.disabled = true;\n";
	print "document.forms[0].gunblacklist_from.disabled = true;\n";
	print "</script>\n";
	}
else {
	print "<tr> <td colspan=2><hr></td> </tr>\n";

	push(@{$self->{'to_array'}}, map { [ $_, 0 ] } map { @{$_->{'words'}} } $self->find("whitelist_to", $self->{'conf'}));
	push(@{$self->{'to_array'}}, map { [ $_, 1 ] } map { @{$_->{'words'}} } $self->find("more_spam_to", $self->{'conf'}));
	push(@{$self->{'to_array'}}, map { [ $_, 2 ] } map { @{$_->{'words'}} } $self->find("all_spam_to", $self->{'conf'}));
	print "<tr> <td colspan=2><b>$self->{'text_hash'}->{'white_to'}</b></td> </tr>\n";
	print "<tr> <td colspan=2>\n";
	$self->edit_table("whitelist_to", [ $self->{'text_hash'}->{'white_addr'}, $self->{'text_hash'}->{'white_level'} ],
		    \@{$self->{'to_array'}}, [ 40, 0 ], \&whitelist_to_conv, 3);
	print "</td> </tr>\n";
	}

$self->end_form(undef, $self->{'text_hash'}->{'save'});

# Show whitelist import form
print "<hr>\n";
print "$self->{'text_hash'}->{'white_importdesc'}<p>\n";
print "<form action=import.cgi method=post enctype=multipart/form-data>\n";
print "<table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'white_import'}</b></td>\n";
print "<td><input type=file name=import></td> </tr>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'white_sort'}</b></td>\n";
print "<td><input type=radio name=sort value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=sort value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";
print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'white_importok'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# whitelist_to_conv(col, name, size, value)
sub whitelist_to_conv
{
	shift if ($self == $_[0]);

if ($_[0] == 0) {
	return $self->default_convfunc(@_);
	}
else {
	local $rv = "<select name=$_[1]>\n";
	foreach $l (0 .. 2) {
		$rv .= sprintf "<option value=%d %s>%s\n",
			$l, $l == $_[3] ? "selected" : "", $self->{'text_hash'}->{"white_level$l"};
		}
	$rv .= "</select>\n";
	return $rv;
	}
}


1;

