#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import.cgi
# Add email addresses to the allowed list

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->ReadParseMime();
$self->{'in_hash'}->{'import'} || $self->error($self->{'text_hash'}->{'import_efile'});

# Parse the file
while($self->{'in_hash'}->{'import'} =~ s/((([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+([a-zA-Z]{2,})+)))//) {
	push(@{$self->{'addrs_array'}}, $1);
	}
@{$self->{'addrs_array'}} || $self->error($self->{'text_hash'}->{'import_enone'});
@{$self->{'addrs_array'}} = $self->unique(@{$self->{'addrs_array'}});

$self->lock_spam_files();
$self->{'conf'} = $self->get_config();
@{$self->{'from_array'}} = map { @{$_->{'words'}} } $self->find("whitelist_from", $self->{'conf'});
%{$self->{'already_hash'}} = map { $_, 1 } @{$self->{'from_array'}};
@{$self->{'newaddrs_array'}} = grep { !$self->{'already_hash'}->{$_} } @{$self->{'addrs_array'}};

$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");

if (@{$self->{'newaddrs_array'}}) {
	print "<p>",$self->text('import_ok1', scalar(@{$self->{'newaddrs_array'}}),
					scalar(@{$self->{'addrs_array'}})),"<p>\n";
	push(@{$self->{'from_array'}}, @{$self->{'newaddrs_array'}});
	if ($self->{'in_hash'}->{'sort'}) {
		@{$self->{'from_array'}} = sort { ($ua, $da) = split(/\@/, $a);
			       ($ub, $db) = split(/\@/, $b);
			       lc($da) cmp lc($db) || lc($ua) cmp lc($ub) }
			     @{$self->{'from_array'}};
		}
	$self->save_directives($self->{'conf'}, 'whitelist_from', \@{$self->{'from_array'}}, 1);
	$self->flush_file_lines();
	}
else {
	print "<p>",$self->text('import_ok2', scalar(@{$self->{'addrs_array'}})),"<p>\n";
	}
$self->webmin_log("import", scalar(@{$self->{'newaddrs_array'}}));
$self->unlock_spam_files();

$self->ui_print_footer("edit_white.cgi", $self->{'text_hash'}->{'white_return'});

1;
		
}


1;

