#!/usr/bin/perl
package squid::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "squid::SquidLib");
$self = new squid::SquidLib:: ref($self), %$self; 
@{$self->{'accopts_array'}} = ('portsnets', 'othercaches', 'musage', 'logging', 'copts',
	    'hprogs', 'actrl', 'admopts', 'proxyauth', 'miscopt', 'cms',
	    'rebuild', 'calamaris', 'delay', 'headeracc', 'refresh',
	    'authparam', 'iptables');

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the squid module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_sections'}</b></td>\n";
print "<td colspan=3><select name=sections multiple size=6>\n";
foreach $s (@{$self->{'accopts_array'}}) {
	printf "<option value=%s %s>%s\n",
		$s, $_[0]->{$s} ? 'selected' : '', $self->{'text_hash'}->{"index_${s}"};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_root'}</b></td>\n";
printf "<td colspan=3><input name=root size=40 value='%s'> %s</td> </tr>\n",
	$_[0]->{'root'}, $self->file_chooser_button("root", 1);

print "<tr> <td><b>$self->{'text_hash'}->{'acl_start'}</b></td>\n";
printf "<td><input type=radio name=start value=1 %s> %s\n",
	$_[0]->{'start'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=start value=0 %s> %s</td> </tr>\n",
	$_[0]->{'start'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_restart'}</b></td>\n";
printf "<td><input type=radio name=restart value=1 %s> %s\n",
	$_[0]->{'restart'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=restart value=0 %s> %s</td> </tr>\n",
	$_[0]->{'restart'} ? '' : 'checked', $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the squid module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'root'} = $self->{'in_hash'}->{'root'};
map { $self->{'sections_hash'}->{$_} = 1 } split(/\0/, $self->{'in_hash'}->{'sections'});
foreach $s (@{$self->{'accopts_array'}}) {
	$_[0]->{$s} = $self->{'sections_hash'}->{$s};
	}
$_[0]->{'start'} = $self->{'in_hash'}->{'start'};
$_[0]->{'restart'} = $self->{'in_hash'}->{'restart'};
}


1;

