#!/usr/bin/perl

&MAIN();

 sub MAIN {
# always_save.cgi
# Save or delete an always_direct directive

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();

@{$self->{'always_array'}} = $self->find_config("always_direct", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'always'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this restriction
	splice(@{$self->{'always_array'}}, $self->indexof($self->{'always'}, @{$self->{'always_array'}}), 1);
	}
else {
	# update or create
	@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'action'} );
	foreach $y (split(/\0/, $self->{'in_hash'}->{'yes'})) { push(@{$self->{'vals_array'}}, $y); }
	foreach $n (split(/\0/, $self->{'in_hash'}->{'no'})) { push(@{$self->{'vals_array'}}, "!$n"); }
	$self->{'newalways'} = { 'name' => 'always_direct', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'always'}) { splice(@{$self->{'always_array'}}, $self->indexof($self->{'always'}, @{$self->{'always_array'}}),
			      1, $self->{'newalways'}); }
	else { push(@{$self->{'always_array'}}, $self->{'newalways'}); }
	}
$self->save_directive($self->{'conf'}, "always_direct", \@{$self->{'always_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'always'} ? 'modify' : 'create', "always");
$self->redirect("edit_icp.cgi");

1;
		
}


1;

