#!/usr/bin/perl

&MAIN();

 sub MAIN {
# chown.cgi
# Change permissions on cache/log/pid files after a user change

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'admopts'} || $self->error($self->{'text_hash'}->{'eadm_ecannot'});
$| = 1;
$self->ui_print_header(undef, $self->{'text_hash'}->{'chown_header'}, "");
$self->{'conf'} = $self->get_config();

# Stop squid
if ($self->{'pidstruct'} = $self->find_config("pid_filename", $self->{'conf'})) {
	$self->{'pidfile'} = $self->{'pidstruct'}->{'values'}->[0];
	}
else { $self->{'pidfile'} = $self->{'config_hash'}->{'pid_file'}; }
if (open(PID, $self->{'pidfile'})) {
	<PID> =~ /(\d+)/; $self->{'pid'} = $1;
	close(PID);
	}
if ($self->{'pid'} && kill(0, $self->{'pid'})) {
	print "<p>$self->{'text_hash'}->{'chown_stop'}<br>\n";
	system("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} ".
	       "-k shutdown >/dev/null 2>&1");
	for($i=0; $i<40; $i++) {
		if (!kill(0, $self->{'pid'})) { last; }
		sleep(1);
		}
	print "$self->{'text_hash'}->{'chown_done'}<br>\n";
	$self->{'stopped'}++;
	}

# Change ownership
print "<p>$self->{'text_hash'}->{'chown_chown'}<br>\n";
($self->{'user'}, $self->{'group'}) = $self->get_squid_user($self->{'conf'});
$self->chown_files($self->{'user'}, $self->{'group'}, $self->{'conf'});
print "$self->{'text_hash'}->{'chown_done'}<br>\n";

# Re-start Squid
if ($self->{'stopped'}) {
	print "<p>$self->{'text_hash'}->{'chown_restart'}<br>\n";
	$self->{'temp'} = $self->transname();
	system("$self->{'config_hash'}->{'squid_path'} -sY -f $self->{'config_hash'}->{'squid_conf'} >$self->{'temp'} 2>&1 </dev/null &");
	sleep(3);
	$self->{'errs'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	if ($self->{'errs'}) {
		system("$self->{'config_hash'}->{'squid_path'} -k shutdown -f $self->{'config_hash'}->{'squid_conf'} >/dev/null 2>&1");
		print "$self->{'text_hash'}->{'chown_failrestart'}<br>\n";
		print "<pre>$self->{'errs'}</pre>\n";
		}
	print "$self->{'text_hash'}->{'chown_done'}<br>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'chown_return'});

1;
		
}


1;

