#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several refresh rules at once

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'drefresh_err'});
$self->{'access_hash'}->{'refresh'} || $self->error($self->{'text_hash'}->{'refresh_ecannot'});
$self->ReadParse();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'drefesh_enone'});

# Do the delete
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
@{$self->{'refresh_array'}} = $self->find_config("refresh_pattern", $self->{'conf'});
foreach $d (sort { $b <=> $a } @d) {
	$self->{'h'} = $self->{'conf'}->[$d];
	splice(@{$self->{'refresh_array'}}, $self->indexof($self->{'h'}, @{$self->{'refresh_array'}}), 1);
	}

# Write it out
$self->save_directive($self->{'conf'}, "refresh_pattern", \@{$self->{'refresh_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("delete", "refreshes", scalar(@d));
$self->redirect("list_refresh.cgi");

1;
		
}


1;

