#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_admin.cgi
# A form for editing admin options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'admopts'} || $self->error($self->{'text_hash'}->{'eadm_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eadm_header'}, "", "edit_admin", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_admin.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eadm_aao'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	$self->{'v'} = $self->find_config("cache_effective_user", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'eadm_runasuu'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=effective_def value=1 %s> $self->{'text_hash'}->{'eadm_nochange'}\n",
		$self->{'v'} ? "" : "checked";
	printf "&nbsp;<input type=radio name=effective_def value=0 %s>\n",
		$self->{'v'} ? "checked" : "";
	print $self->{'text_hash'}->{'eadm_user'} ,$self->unix_user_input("effective_u",
				       $self->{'v'}->{'values'}->[0]),"\n";
	print $self->{'text_hash'}->{'eadm_group'} ,$self->unix_group_input("effective_g",
					 $self->{'v'}->{'values'}->[1]),"\n";
	print "</td> </tr>\n";
	}
else {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_runasuu'}, "cache_effective_user", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_nochange'}, 8,
			 $self->user_chooser_button("cache_effective_user", 0));
	print $self->opt_input($self->{'text_hash'}->{'eadm_runasug'}, "cache_effective_group", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_nochange'}, 8,
			 $self->group_chooser_button("cache_effective_group", 0));
	print "</tr>\n";
	}

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eadm_cmemail'}, "cache_mgr",
		 $self->{'conf'}, $self->{'text_hash'}->{'eadm_default'}, 35);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eadm_vhost'}, "visible_hostname",
		 $self->{'conf'}, $self->{'text_hash'}->{'eadm_auto'}, 35);
print "</tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_annto'}, "announce_to",
			 $self->{'conf'}, $self->{'text_hash'}->{'eadm_default'}, 40);
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_every'}, "cache_announce", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_never'}, 6, "hours");
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_uniq'}, "unique_hostname",
			 $self->{'conf'}, $self->{'text_hash'}->{'eadm_auto'}, 35);
	print "</tr>\n";

	if ($self->{'squid_version'} >= 2.4) {
		print "<tr>\n";
		print $self->opt_input($self->{'text_hash'}->{'eadm_haliases'}, "hostname_aliases",
				 $self->{'conf'}, $self->{'text_hash'}->{'eadm_none'}, 35);
		print "</tr>\n";
		}

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_cah'}, "announce_host", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_default'}, 20);
	print $self->opt_input($self->{'text_hash'}->{'eadm_cap'}, "announce_port", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_default'}, 6);
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eadm_caf'}, "announce_file", $self->{'conf'},
			 $self->{'text_hash'}->{'eadm_none'}, 35, $self->file_chooser_button("announce_file"));
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_time_input($self->{'text_hash'}->{'eadm_annp'}, "announce_period", $self->{'conf'},
			      $self->{'text_hash'}->{'eadm_default'}, 4);
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'eadm_buttsave'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eadm_return'});

1;
		
}


1;

