#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_auth.cgi
# Display authentication options and list of proxy users

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'proxyauth'} || $self->error($self->{'text_hash'}->{'eauth_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eauth_header'}, "", undef, 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_auth.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eauth_aopt'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

$self->{'v'} = $self->find_config("proxy_auth", $self->{'conf'});
$self->{'authfile'} = $self->{'v'}->{'values'}->[0];
$self->{'authdom'} = $self->{'v'}->{'values'}->[1];
print "<tr> <td><b>$self->{'text_hash'}->{'eauth_puf'}</b></td> <td>\n";
printf "<input type=radio name=authfile_def value=1 %s> $self->{'text_hash'}->{'eauth_none'}&nbsp;\n",
	$self->{'authfile'} ? "" : "checked";
printf "<input type=radio name=authfile_def value=0 %s>\n",
	$self->{'authfile'} ? "checked" : "";
printf "<input name=authfile size=30 value=\"%s\">\n",
	$self->{'authfile'} ? $self->{'authfile'} : "";
print $self->file_chooser_button("authfile"),"</td> </tr>\n";

print "<tr>\n";
print "<td><b>$self->{'text_hash'}->{'eauth_nologin'}</b></td> <td>\n";
printf "<input type=radio name=authdom_def value=1 %s> $self->{'text_hash'}->{'eauth_none'}&nbsp;\n",
	$self->{'authdom'} ? "" : "checked";
printf "<input type=radio name=authdom_def value=0 %s>\n",
	$self->{'authdom'} ? "checked" : "";
printf "<input name=authdom size=20 value=\"%s\"></td>\n",
	$self->{'authdom'} ? $self->{'authdom'} : "";
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'eauth_buttsave'}></form>\n";

if ($self->{'authfile'}) {
	print "<hr>\n";
	print $self->{'text_hash'}->{'eauth_msgaccess'};
	print "\n<p>\n";
	@{$self->{'users_array'}} = $self->list_auth_users($self->{'authfile'});
	if (@{$self->{'users_array'}}) {
		print "<a href=\"edit_user.cgi?new=1\">$self->{'text_hash'}->{'eauth_addpuser'}</a><br>\n";
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eauth_pusers'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table width=100%>\n";
		for($i=0; $i<@{$self->{'users_array'}}; $i++) {
			print "<tr>\n" if ($i%4 == 0);
			print "<td width=25%><a href=\"edit_user.cgi?",
			      "index=$i\">$self->{'users_array'}->[$i]->{'user'}</a></td>\n";
			print "</tr>\n" if ($i%4 == 3);
			}
		while($i++%4) { print "<td width=25%></td>\n"; }
		print "</table></td></tr></table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'eauth_nopusers'}</b> <p>\n";
		}
	print "<a href=\"edit_user.cgi?new=1\">$self->{'text_hash'}->{'eauth_addpuser'}</a><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'eauth_return'});

1;
		
}


1;

