#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_ext.cgi
# Display a form for creating or editing an external ACL type

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ext_title1'}, "", undef, 0, 0, 0, $self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ext_title2'}, "", undef, 0, 0, 0, $self->restart_button());
	$self->{'ext'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	$self->{'ea'} = $self->parse_external($self->{'ext'});
	}

print "<form action=save_ext.cgi method=post>\n";
print "<input type=hidden name=index value='$self->{'in_hash'}->{'index'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";

print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ext_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ext_name'}</b></td>\n";
printf "<td><input name=name size=20 value='%s'></td> </tr>\n",
	$self->{'ea'}->{'name'};

print "<tr> <td><b>$self->{'text_hash'}->{'ext_format'}</b></td>\n";
printf "<td><input name=format size=60 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'ea'}->{'format'});

$self->{'o'} = $self->{'ea'}->{'opts'};
foreach $on ('ttl', 'negative_ttl', 'concurrency', 'cache') {
	print "<tr> <td><b>",$self->{'text_hash'}->{'ext_'.$on},"</b></td>\n";
	printf "<td><input type=radio name=%s_def value=1 %s> %s\n",
		$on, defined($self->{'o'}->{$on}) ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=%s_def value=0 %s>\n",
		$on, defined($self->{'o'}->{$on}) ? "checked" : "";
	printf "<input name=%s size=6 value='%s'> %s</td> </tr>\n",
		$on, $self->{'o'}->{$on}, $self->{'text_hash'}->{'ext_'.$on.'_u'};
	}

print "<tr> <td><b>$self->{'text_hash'}->{'ext_program'}</b></td>\n";
printf "<td><input name=program size=60 value='%s'></td> </tr>\n",
	$self->html_escape(join(" ", $self->{'ea'}->{'program'}, @{$self->{'ea'}->{'args'}}));

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n"
	if (!$self->{'in_hash'}->{'new'});
print "</form>\n";

$self->ui_print_footer("edit_acl.cgi", $self->{'text_hash'}->{'acl_return'});

1;
		
}


1;

