#!/usr/bin/perl

&MAIN();

 sub MAIN {
# A form for editing or creating a header access control rule

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'headeracc'} || $self->error($self->{'text_hash'}->{'header_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();

if (!defined($self->{'in_hash'}->{'index'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'header_create'}, "",
		undef, 0, 0, 0, $self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'header_edit'}, "",
		undef, 0, 0, 0, $self->restart_button());
	@{$self->{'v_array'}} = @{$self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'values'}};
	}

print "<form action=save_headeracc.cgi>\n";
if (@{$self->{'v_array'}}) {
	print "<input type=hidden name=index value='$self->{'in_hash'}->{'index'}'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'header_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'header_name'}</b></td> <td colspan=3>\n";
printf "<input name=name size=30 value='%s'></td> </tr>\n", $self->{'v_array'}->[0];

print "<tr> <td><b>$self->{'text_hash'}->{'ahttp_a'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=action value=allow %s> $self->{'text_hash'}->{'ahttp_a1'}\n",
	$self->{'v_array'}->[1] eq "allow" ? "checked" : "";
printf "<input type=radio name=action value=deny %s> $self->{'text_hash'}->{'ahttp_d'}</td> </tr>\n",
	$self->{'v_array'}->[1] eq "allow" ? "" : "checked";

for($i=2; $i<@{$self->{'v_array'}}; $i++) { $self->{'match_hash'}->{$self->{'v_array'}->[$i]}++; }
@{$self->{'acls_array'}} = grep { !$self->{'done_hash'}->{$_->{'values'}->[0]}++ } $self->find_config("acl", $self->{'conf'});
$self->{'r'} = @{$self->{'acls_array'}}; $self->{'r'} = 10 if ($self->{'r'} > 10);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'ahttp_ma'}</b></td>\n";
print "<td valign=top><select name=yes multiple size=$self->{'r'} width=100>\n";
foreach $a (@{$self->{'acls_array'}}) {
	printf "<option %s>%s\n",
		$self->{'match_hash'}->{$a->{'values'}->[0]} ? "selected" : "",
		$a->{'values'}->[0];
	}
print "</select></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'ahttp_dma'}</b></td>\n";
print "<td valign=top><select name=no multiple size=$self->{'r'} width=100>\n";
foreach $a (@{$self->{'acls_array'}}) {
	printf "<option %s>%s\n",
		$self->{'match_hash'}->{"!$a->{'values'}->[0]"} ? "selected" : "",
		$a->{'values'}->[0];
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'>\n";
if (@{$self->{'v_array'}}) {
	print "<input type=submit value='$self->{'text_hash'}->{'buttdel'}' name=delete>\n";
	}
print "</form>\n";

$self->ui_print_footer("list_headeracc.cgi", $self->{'text_hash'}->{'header_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

