#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mem.cgi
# A form for editing memory usage options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'musage'} || $self->error($self->{'text_hash'}->{'emem_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'emem_header'}, "", "edit_mem", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_mem.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'emem_maduo'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'emem_mul'}, "cache_mem", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_mb'});
	print $self->opt_input($self->{'text_hash'}->{'emem_dul'}, "cache_swap",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_mb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'emem_mul'}, "cache_mem", $self->{'conf'},
			       $self->{'text_hash'}->{'default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'emem_fcs'}, "fqdncache_size", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 8);
	}
print "</tr>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2.5) {
	print $self->opt_input($self->{'text_hash'}->{'emem_mhwm'}, "cache_mem_high", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, "%");
	print $self->opt_input($self->{'text_hash'}->{'emem_mlwm'}, "cache_mem_low", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, "%");
	}
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emem_dhwm'}, "cache_swap_high", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 4, "%");
print $self->opt_input($self->{'text_hash'}->{'emem_dlwm'}, "cache_swap_low", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 4, "%");
print "</tr>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'emem_mcos'}, "maximum_object_size",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 8, $self->{'text_hash'}->{'emem_kb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'emem_mcos'},
			       "maximum_object_size", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	}
print $self->opt_input($self->{'text_hash'}->{'emem_iacs'}, "ipcache_size", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_e'});
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emem_ichwm'}, "ipcache_high", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 4, "%");
print $self->opt_input($self->{'text_hash'}->{'emem_iclwm'}, "ipcache_low", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 4, "%");
print "</tr>\n";

if ($self->{'squid_version'} >= 2.4) {
	print "<tr>\n";
	print $self->select_input($self->{'text_hash'}->{'emem_crp'}, "cache_replacement_policy", $self->{'conf'}, '',
			    $self->{'text_hash'}->{'default'}, '', $self->{'text_hash'}->{'emem_lru'}, 'lru',
			    $self->{'text_hash'}->{'emem_gdsf'}, 'heap GDSF', $self->{'text_hash'}->{'emem_lfuda'}, 'heap LFUDA',
			    $self->{'text_hash'}->{'emem_hlru'}, 'heap LRU');
	print $self->select_input($self->{'text_hash'}->{'emem_mrp'}, "memory_replacement_policy", $self->{'conf'}, '',
			    $self->{'text_hash'}->{'default'}, '', $self->{'text_hash'}->{'emem_lru'}, 'lru',
			    $self->{'text_hash'}->{'emem_gdsf'}, 'heap GDSF', $self->{'text_hash'}->{'emem_lfuda'}, 'heap LFUDA',
			    $self->{'text_hash'}->{'emem_hlru'}, 'heap LRU');
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'emem_return'});

1;
		
}


1;

