#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_misc.cgi
# A form for edit misc options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'miscopt'} || $self->error($self->{'text_hash'}->{'emisc_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'emisc_header'}, "", "edit_misc", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_misc.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'emisc_mo'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_sdta'}, "dns_testnames", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 40);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_slr'}, "logfile_rotate", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 6);
print $self->opt_input($self->{'text_hash'}->{'emisc_dd'}, "append_domain", $self->{'conf'}, $self->{'text_hash'}->{'none'}, 10);
print "</tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'emisc_sp'}, "ssl_proxy", $self->{'conf'}, $self->{'text_hash'}->{'none'}, 15);
	print $self->opt_input($self->{'text_hash'}->{'emisc_nghp'}, "passthrough_proxy",
			 $self->{'conf'}, $self->{'text_hash'}->{'none'}, 15);
	print "</tr>\n";
	}

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_emt'}, "err_html_text", $self->{'conf'}, $self->{'text_hash'}->{'none'}, 40);
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'emisc_pcs'}, "client_db", $self->{'conf'},
		    "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print $self->choice_input($self->{'text_hash'}->{'emisc_xffh'}, "forwarded_for", $self->{'conf'},
		    "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'emisc_liq'}, "log_icp_queries", $self->{'conf'},
		    "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print $self->opt_input($self->{'text_hash'}->{'emisc_mdh'}, "minimum_direct_hops", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 6);
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'emisc_kmffu'}, "memory_pools", $self->{'conf'},
		    "on", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
if ($self->{'squid_version'} >= 2) {
	print $self->opt_bytes_input($self->{'text_hash'}->{'emisc_aomtk'}, "memory_pools_limit",
			       $self->{'conf'}, $self->{'text_hash'}->{'emisc_u'}, 6);
	}
print "</tr>\n";

print "<tr>\n";
if ($self->{'squid_version'} >= 2.2 && $self->{'squid_version'} < 2.5) {
	foreach $a ($self->find_config("anonymize_headers", $self->{'conf'})) {
		@{$self->{'ap_array'}} = @{$a->{'values'}};
		$self->{'anon'} = shift(@{$self->{'ap_array'}});
		push(@{$self->{'anon_array'}}, @{$self->{'ap_array'}});
		}
	print "<td valign=top><b>$self->{'text_hash'}->{'emisc_htpt'}</b></td> ",
	      "<td colspan=3>\n";
	printf "<input type=radio name=anon_mode value=0 %s> $self->{'text_hash'}->{'emisc_ah'}<br>\n",
		$self->{'anon'} ? "" : "checked";
	printf "<input type=radio name=anon_mode value=1 %s> $self->{'text_hash'}->{'emisc_oh'}\n",
		$self->{'anon'} eq "allow" ? "checked" : "";
	printf "<input name=anon_allow size=50 value='%s'><br>\n",
		$self->{'anon'} eq "allow" ? join(" ", @{$self->{'anon_array'}}) : "";
	printf "<input type=radio name=anon_mode value=2 %s> $self->{'text_hash'}->{'emisc_ae'}\n",
		$self->{'anon'} eq "deny" ? "checked" : "";
	printf "<input name=anon_deny size=50 value='%s'>\n",
		$self->{'anon'} eq "deny" ? join(" ", @{$self->{'anon_array'}}) : "";
	print "</td> </tr> <tr>\n";
	}
elsif ($self->{'squid_version'} < 2.2) {
	print $self->choice_input($self->{'text_hash'}->{'emisc_a'}, "http_anonymizer", $self->{'conf'},
			    "off", $self->{'text_hash'}->{'emisc_off'}, "off", 
				$self->{'text_hash'}->{'emisc_std'}, "standard",
			    $self->{'text_hash'}->{'emisc_par'}, "paranoid");
	}
print $self->opt_input($self->{'text_hash'}->{'emisc_fua'}, "fake_user_agent", $self->{'conf'}, $self->{'text_hash'}->{'none'}, 15);

print "</tr><tr>\n";
if ($self->{'squid_version'} < 3.0) {
	$self->{'host'} = $self->find_value("httpd_accel_host", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'emisc_hah'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=accel value=0 %s> %s\n",
		$self->{'host'} ? "" : "checked", $self->{'text_hash'}->{'emisc_none'};
	printf "<input type=radio name=accel value=1 %s> %s\n",
		$self->{'host'} eq "virtual" ? "checked" : "", $self->{'text_hash'}->{'emisc_virtual'};
	printf "<input type=radio name=accel value=2 %s>\n",
		$self->{'host'} eq "virtual" || !$self->{'host'} ? "" : "checked";
	printf "<input name=httpd_accel_host size=50 value='%s'></td>\n",
		$self->{'host'} eq "virtual" ? "" : $self->{'host'};
	print "</tr><tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'emisc_hap'}, "httpd_accel_port", $self->{'conf'},
			 $self->{'text_hash'}->{'emisc_none'}, 10);
	if ($self->{'squid_version'} >= 2.5) {
		print $self->choice_input($self->{'text_hash'}->{'emisc_hash'}, "httpd_accel_single_host", 
				  $self->{'conf'}, "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
		}
	print "</tr><tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'emisc_hawp'}, "httpd_accel_with_proxy",
			  $self->{'conf'}, "off", $self->{'text_hash'}->{'on'}, "on", $self->{'text_hash'}->{'off'}, "off");
	print $self->choice_input($self->{'text_hash'}->{'emisc_hauhh'}, "httpd_accel_uses_host_header", 
			  $self->{'conf'}, "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
	print "</tr><tr>\n";
	}

if ( $self->{'squid_version'} >= 2.3) {
        print $self->opt_input($self->{'text_hash'}->{'emisc_wccprtr'}, "wccp_router", $self->{'conf'},
                         $self->{'text_hash'}->{'default'}, 35);
        print "</tr><tr>\n";
        print $self->opt_input($self->{'text_hash'}->{'emisc_wccpin'}, "wccp_incoming_address",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 35);
        print "</tr><tr>\n";
        print $self->opt_input($self->{'text_hash'}->{'emisc_wccpout'}, "wccp_outgoing_address",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 35);
        print "</tr><tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'emisc_return'});

1;
		
}


1;

