#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_nauth.cgi
# Display a list of proxy users

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

if ($self->{'config_hash'}->{'crypt_conf'} == 1) {
	eval "use MD5";
	if ($@) {
        	$self->error($self->text('eauth_nomd5', $self->{'module_name'}));
		}
	}

$self->{'access_hash'}->{'proxyauth'} || $self->error($self->{'text_hash'}->{'eauth_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eauth_header'}, "", undef, 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();
$self->{'authfile'} = $self->get_auth_file($self->{'conf'});

print $self->text('eauth_nmsgaccess', "<tt>$self->{'authfile'}</tt>"),"<p>\n";
@{$self->{'users_array'}} = $self->list_auth_users($self->{'authfile'});
if (@{$self->{'users_array'}}) {
	print "<a href=\"edit_nuser.cgi?new=1\">$self->{'text_hash'}->{'eauth_addpuser'}</a><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eauth_pusers'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	for($self->{'i'}=0; $self->{'i'}<@{$self->{'users_array'}}; $self->{'i'}++) {
		local ($it, $unit) = $self->{'users_array'}->[$self->{'i'}]->{'enabled'} ? ('', '') :
					('<i>', '</i>');
		print "<tr>\n" if ($self->{'i'}%4 == 0);
		print "<td width=25%><a href=\"edit_nuser.cgi?",
		      "index=$self->{'i'}\">$it$self->{'users_array'}->[$self->{'i'}]->{'user'}$unit</a></td>\n";
		print "</tr>\n" if ($self->{'i'}%4 == 3);
		}
	while($self->{'i'}++%4) { print "<td width=25%></td>\n"; }
	print "</table></td></tr></table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'eauth_nopusers'}</b> <p>\n";
	}
print "<a href=\"edit_nuser.cgi?new=1\">$self->{'text_hash'}->{'eauth_addpuser'}</a><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eauth_return'});

1;
		
}


1;

