#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pool.cgi
# A form for editing or creating a delay pool

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'pool_title1'}, "", "edit_pool", 0, 0, 0,
		$self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'pool_title2'}, "", "edit_pool", 0, 0, 0,
		$self->restart_button());
	@{$self->{'pools_array'}} = $self->find_config("delay_class", $self->{'conf'});
	($self->{'pool'}) = grep { $_->{'values'}->[0] == $self->{'in_hash'}->{'idx'} } @{$self->{'pools_array'}};
	@{$self->{'params_array'}} = $self->find_config("delay_parameters", $self->{'conf'});
	($self->{'param'}) = grep { $_->{'values'}->[0] == $self->{'in_hash'}->{'idx'} } @{$self->{'params_array'}};
	@{$self->{'access_array'}} = $self->find_config("delay_access", $self->{'conf'});
	@{$self->{'access_array'}} = grep { $_->{'values'}->[0] == $self->{'in_hash'}->{'idx'} } @{$self->{'access_array'}};
	}

print "<form action=save_pool.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'pool_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pool_num'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	$self->{'pools'} = $self->find_value("delay_pools", $self->{'conf'});
	print "<td>",$self->{'pools'}+1,"</td>\n";
	}
else {
	print "<td>$self->{'in_hash'}->{'idx'}</td>\n";
	}
print "</tr>\n";

$self->{'cls'} = $self->{'pool'}->{'values'}->[1] || 1;
print "<tr> <td><b>$self->{'text_hash'}->{'pool_class'}</b></td>\n";
print "<td><select name=class>\n";
foreach $c (1 .. ($self->{'squid_version'} >= 3 ? 5 : 3)) {
	printf "<option value=%s %s>%s - %s\n",
		$c, $self->{'cls'} == $c ? "selected" : "",
		$c, $self->{'text_hash'}->{"delay_class_$c"};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pool_agg'}</b></td>\n";
print "<td colspan=3>",&limit_field("agg",
	$self->{'cls'} == 5 ? undef : $self->{'param'}->{'values'}->[1]),"</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pool_ind'}</b></td>\n";
print "<td colspan=3>",&limit_field("ind",
	$self->{'param'}->{'values'}->[$self->{'cls'} == 2 ? 2 : 3]),"</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'pool_net'}</b></td>\n";
print "<td colspan=3>",&limit_field("net",
	$self->{'cls'} == 3 || $self->{'cls'} == 4 ? $self->{'param'}->{'values'}->[2] : undef),"</td>\n";

if ($self->{'squid_version'} >= 3) {
	print "<tr> <td><b>$self->{'text_hash'}->{'pool_user'}</b></td>\n";
	print "<td colspan=3>",&limit_field("user",
		$self->{'cls'} == 4 ? $self->{'param'}->{'values'}->[4] : undef),"</td>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'pool_tag'}</b></td>\n";
	print "<td colspan=3>",&limit_field("tag",
		$self->{'cls'} == 5 ? $self->{'param'}->{'values'}->[1] : undef),"</td>\n";

	}

print "</table></td></tr></table>\n";

if (!$self->{'in_hash'}->{'new'}) {
	print "<p><table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'pool_aclheader'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td>\n";

	if (@{$self->{'access_array'}}) {
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}><td width=10%><b>$self->{'text_hash'}->{'eacl_act'}</b></td>\n";
		print "<td><b>$self->{'text_hash'}->{'eacl_acls1'}</b></td>\n";
		print "<td width=5%><b>$self->{'text_hash'}->{'eacl_move'}</b></td> </tr>\n";
		$self->{'hc'} = 0;
		foreach $h (@{$self->{'access_array'}}) {
			@{$self->{'v_array'}} = @{$h->{'values'}};
			if ($self->{'v_array'}->[1] eq "allow") {
				$self->{'v_array'}->[1] = $self->{'text_hash'}->{'eacl_allow'};
			} else {
				$self->{'v_array'}->[1] = $self->{'text_hash'}->{'eacl_deny'};
			}
			print "<tr $self->{'cb'}>\n";
			print "<td><a href=\"pool_access.cgi?index=",
			      "$h->{'index'}&idx=$self->{'in_hash'}->{'idx'}\">$self->{'v_array'}->[1]</a></td>\n";
			print "<td>",$self->html_escape(join(' ', @{$self->{'v_array'}}[2..$#{$self->{'v_array'}}])),
			      "</td>\n";
			print "<td>\n";
			if ($self->{'hc'} != @{$self->{'access_array'}}-1) {
				print "<a href=\"move_pool.cgi?$self->{'hc'}+1+",
				      "$self->{'in_hash'}->{'idx'}\"><img src=images/down.gif ",
				      "border=0></a>";
				}
			else { print "<img src=images/gap.gif>"; }
			if ($self->{'hc'} != 0) {
				print "<a href=\"move_pool.cgi?$self->{'hc'}+-1+",
				      "$self->{'in_hash'}->{'idx'}\"><img src=images/up.gif ",
				      "border=0></a>";
				}
			print "</td></tr>\n";
			$self->{'hc'}++;
			}
		print "</table>\n";
		}
	else {
		print "<b>$self->{'text_hash'}->{'pool_noacl'}</b><p>\n";
		}
	print "<a href='pool_access.cgi?new=1&idx=$self->{'in_hash'}->{'idx'}'>",
	      "$self->{'text_hash'}->{'pool_add'}</a>\n";

	print "</td></tr></table>\n";
	}
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("edit_delay.cgi", $self->{'text_hash'}->{'delay_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}

# limit_field(name, value)
sub limit_field
{
	shift if ($self == $_[0]);

local ($v1, $v2) = $_[1] =~ /^([0-9\-]+)\/([0-9\-]+)$/ ? ($1, $2) : ( -1, -1 );
local $unl = $v1 == -1 && $v2 == -1;
local $rv;
$rv .= sprintf "<input type=radio name=%s_def value=1 %s> %s\n",
		$_[0], $unl ? "checked" : "", $self->{'text_hash'}->{'delay_unlimited'};
$rv .= sprintf "<input type=radio name=%s_def value=0 %s>\n",
		$_[0], $unl ? "" : "checked";
$rv .= &unit_field("$_[0]_1", $unl ? "" : $v1).
	$self->{'text_hash'}->{'pool_limit1'}."&nbsp;&nbsp;";
$rv .= &unit_field("$_[0]_2", $unl ? "" : $v2).$self->{'text_hash'}->{'pool_limit2'};
return $rv;
}

# unit_field(name, value)
sub unit_field
{
	shift if ($self == $_[0]);

local ($rv, $i, $u);
local @ud = ( .125, 1, 125, 1000, 125000, 1000000 );
if ($_[1] > 0) {
	for($u=@ud-1; $u>=1; $u--) {
		last if (!($_[1]%$ud[$u]));
		}
	}
else {
	$u = 1;
	}
$rv .= sprintf "<input name=%s_n size=8 value='%s'>\n",
		$_[0], $_[1] > 0 ? $_[1]/$ud[$u] : $_[1];
$rv .= "<select name=$_[0]_u>\n";
for($i=0; $i<@ud; $i++) {
	$rv .= sprintf "<option value=%s %s>%s\n",
		$i, $i == $u ? "selected" : "", $self->{'text_hash'}->{'pool_unit'.$i};
	}
$rv .= "</select>\n";
return $rv;
}


1;

