#!/usr/bin/perl

&MAIN();

 sub MAIN {
# A form for editing or creating a refresh pattern rule

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'refresh'} || $self->error($self->{'text_hash'}->{'refresh_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();

if (!defined($self->{'in_hash'}->{'index'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'refresh_create'}, "",
		undef, 0, 0, 0, $self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'refresh_edit'}, "",
		undef, 0, 0, 0, $self->restart_button());
	@{$self->{'v_array'}} = @{$self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'values'}};
	}

print "<form action=save_refresh.cgi>\n";
if (@{$self->{'v_array'}}) {
	print "<input type=hidden name=index value='$self->{'in_hash'}->{'index'}'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'refresh_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

# Show regular expression inputs
if ($self->{'v_array'}->[0] eq "-i") {
	$self->{'caseless'} = shift(@{$self->{'v_array'}});
	}
print "<tr> <td><b>$self->{'text_hash'}->{'refresh_re'}</b></td> <td colspan=3>\n";
printf "<input name=re size=30 value='%s'></td> </tr>\n", $self->{'v_array'}->[0];

print "<tr> <td></td> <td colspan=3>\n";
printf "<input type=checkbox name=caseless value=1 %s> %s</td> </tr>\n",
	$self->{'caseless'} ? "checked" : "", $self->{'text_hash'}->{'refresh_caseless'};

# Show min, max and percentage
print "<tr> <td><b>$self->{'text_hash'}->{'refresh_min'}</b></td>\n";
printf "<td><input name=min size=6 value='%s'> %s</td>\n",
	$self->{'v_array'}->[1], $self->{'text_hash'}->{'ec_mins'};

print "<td><b>$self->{'text_hash'}->{'refresh_max'}</b></td>\n";
printf "<td><input name=max size=6 value='%s'> %s</td> </tr>\n",
	$self->{'v_array'}->[3], $self->{'text_hash'}->{'ec_mins'};

$self->{'v_array'}->[2] =~ s/\%$//;
print "<tr> <td><b>$self->{'text_hash'}->{'refresh_pc'}</b></td>\n";
printf "<td><input name=pc size=6 value='%s'> %%</td> </tr>\n",
	$self->{'v_array'}->[2];

# Show options
%{$self->{'opts_hash'}} = map { $_, 1 } @{$self->{'v_array'}}[4..$#{$self->{'v_array'}}];
@{$self->{'known_array'}} = ( "override-expire", "override-lastmod",
	   "reload-into-ims", "ignore-reload" );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'refresh_options'}</b></td> <td colspan=3>\n";
foreach $k (@{$self->{'known_array'}}) {
	printf "<input type=checkbox name=options value=%s %s> %s<br>\n",
		$k, $self->{'opts_hash'}->{$k} ? "checked" : "", $self->{'text_hash'}->{'refresh_'.$k};
	delete($self->{'opts_hash'}->{$k});
	}
foreach $u (keys %{$self->{'opts_hash'}}) {
	print "<input type=hidden name=options value=$k>\n";
	}
print "</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'>\n";
if (@{$self->{'v_array'}}) {
	print "<input type=submit value='$self->{'text_hash'}->{'buttdel'}' name=delete>\n";
	}
print "</form>\n";

$self->ui_print_footer("list_refresh.cgi", $self->{'text_hash'}->{'refresh_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

