#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_sports.cgi
# A form for editing simple networking options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'portsnets'} || $self->error($self->{'text_hash'}->{'eports_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eports_header'}, "", "", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_sports.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eports_pano'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
if ($self->{'squid_version'} >= 2.3) {
	print "<td valign=top><b>$self->{'text_hash'}->{'eports_paap'}</b></td>\n";
	print "<td colspan=3><table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eports_p'}</b></td>\n",
	      "<td><b>$self->{'text_hash'}->{'eports_hia'}</b></td> </tr>\n";
	foreach $p ($self->find_config('http_port', $self->{'conf'})) {
		push(@{$self->{'ports_array'}}, @{$p->{'values'}});
		}
	$self->{'i'} = 0;
	foreach $p (@{$self->{'ports_array'}}, '') {
		print "<tr $self->{'cb'}>\n";
		printf "<td><input name=port_$self->{'i'} size=6 value='%s'></td> <td>\n",
			$p =~ /(\d+)$/ ? $1 : '';
		printf "<input type=radio name=addr_def_$self->{'i'} value=1 %s> All\n",
			$p =~ /:/ ? '' : 'checked';
		printf "<input type=radio name=addr_def_$self->{'i'} value=0 %s>\n",
			$p =~ /:/ ? 'checked' : '';
		printf "<input name=addr_$self->{'i'} size=20 value='%s'></td>\n",
			$p =~ /^(\S+):/ ? $1 : '';
		print "</tr>\n";
		$self->{'i'}++;
		}

	print "</table></td></tr>\n";
	}
else {
	print $self->opt_input($self->{'text_hash'}->{'eports_pp'}, "http_port", 
				$self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'eports_ita'}, "tcp_incoming_address",
			 $self->{'conf'}, $self->{'text_hash'}->{'eports_a'}, 15);
	print "</tr>\n";
	}

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_sdta'}, "dns_testnames", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 40);
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "</tr><tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_hah'}, "httpd_accel_host", $self->{'conf'},
                 $self->{'text_hash'}->{'default'}, 50);
print "</tr><tr>\n";
print $self->opt_input($self->{'text_hash'}->{'emisc_hap'}, "httpd_accel_port", $self->{'conf'},
                 $self->{'text_hash'}->{'default'}, 10);
print "</tr><tr>\n";
print $self->choice_input($self->{'text_hash'}->{'emisc_hawp'}, "httpd_accel_with_proxy",
                  $self->{'conf'}, "off", $self->{'text_hash'}->{'on'}, "on", $self->{'text_hash'}->{'off'}, "off");
print $self->choice_input($self->{'text_hash'}->{'emisc_hauhh'}, "httpd_accel_uses_host_header", 
                  $self->{'conf'}, "off", $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print "</tr><tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eports_return'});

1;
		
}


1;

