#!/usr/bin/perl

&MAIN();

 sub MAIN {
# icp_access.cgi
# A form for editing or creating an ICP access restriction

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();

if (!defined($self->{'in_hash'}->{'index'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'aicp_header'}, "",
		undef, 0, 0, 0, $self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'aicp_header1'}, "",
		undef, 0, 0, 0, $self->restart_button());
	@{$self->{'icp_array'}} = @{$self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'values'}};
	}

print "<form action=icp_access_save.cgi>\n";
if (@{$self->{'icp_array'}}) {
	print "<input type=hidden name=index value=$self->{'in_hash'}->{'index'}>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aicp_ir'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'aicp_a'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=action value=allow %s> $self->{'text_hash'}->{'aicp_a1'}\n",
	$self->{'icp_array'}->[0] eq "allow" ? "checked" : "";
printf "<input type=radio name=action value=deny %s> $self->{'text_hash'}->{'aicp_d'}</td> </tr>\n",
	$self->{'icp_array'}->[0] eq "allow" ? "" : "checked";

for($i=1; $i<@{$self->{'icp_array'}}; $i++) { $self->{'match_hash'}->{$self->{'icp_array'}->[$i]}++; }
@{$self->{'acls_array'}} = grep { !$self->{'done_hash'}->{$_->{'values'}->[0]}++ } $self->find_config("acl", $self->{'conf'});
$self->{'r'} = @{$self->{'acls_array'}}; $self->{'r'} = 10 if ($self->{'r'} > 10);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'aicp_ma'}</b></td>\n";
print "<td><select name=yes multiple rows=$self->{'r'} width=100>\n";
foreach $a (@{$self->{'acls_array'}}) {
	printf "<option %s>%s\n",
		$self->{'match_hash'}->{$a->{'values'}->[0]} ? "selected" : "",
		$a->{'values'}->[0];
	}
print "</select></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'aicp_dma'}</b></td>\n";
print "<td><select name=no multiple rows=$self->{'r'} width=100>\n";
foreach $a (@{$self->{'acls_array'}}) {
	printf "<option %s>%s\n",
		$self->{'match_hash'}->{"!$a->{'values'}->[0]"} ? "selected" : "",
		$a->{'values'}->[0];
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'>\n";
if (@{$self->{'icp_array'}}) {
	print "<input type=submit value='$self->{'text_hash'}->{'buttdel'}' name=delete>\n";
	}
print "</form>\n";

$self->ui_print_footer("edit_acl.cgi", $self->{'text_hash'}->{'aicp_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

