#!/usr/bin/perl

&MAIN();

 sub MAIN {
# icp_access_save.cgi
# Save or delete a proxy restriction

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'saicp_ftsir'};

@{$self->{'icps_array'}} = $self->find_config("icp_access", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'icp'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this restriction
	splice(@{$self->{'icps_array'}}, $self->indexof($self->{'icp'}, @{$self->{'icps_array'}}), 1);
	}
else {
	# update or create
	@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'action'} );
	foreach $y (split(/\0/, $self->{'in_hash'}->{'yes'})) { push(@{$self->{'vals_array'}}, $y); }
	foreach $n (split(/\0/, $self->{'in_hash'}->{'no'})) { push(@{$self->{'vals_array'}}, "!$n"); }
	$self->{'newicp'} = { 'name' => 'icp_access', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'icp'}) { splice(@{$self->{'icps_array'}}, $self->indexof($self->{'icp'}, @{$self->{'icps_array'}}), 1, $self->{'newicp'}); }
	else { push(@{$self->{'icps_array'}}, $self->{'newicp'}); }
	}
$self->save_directive($self->{'conf'}, "icp_access", \@{$self->{'icps_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'icp'} ? 'modify' : 'create', "icp");
$self->redirect("edit_acl.cgi");

1;
		
}


1;

