#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_refresh.cgi
# Display all refresh patterns

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'refresh'} || $self->error($self->{'text_hash'}->{'refresh_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'refresh_title'}, "", "list_refresh", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

@{$self->{'refresh_array'}} = $self->find_config("refresh_pattern", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_refresh.cgi?new=1'>$self->{'text_hash'}->{'refresh_add'}</a>" );
if (@{$self->{'refresh_array'}}) {
	print $self->ui_form_start("delete_refreshes.cgi", "post");
	@{$self->{'tds_array'}} = ( "width=5", undef, undef, undef, undef, "width=32" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'refresh_re'},
				  $self->{'text_hash'}->{'refresh_min'},
				  $self->{'text_hash'}->{'refresh_pc'},
				  $self->{'text_hash'}->{'refresh_max'},
				  $self->{'text_hash'}->{'eacl_move'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'hc'} = 0;
	foreach $h (@{$self->{'refresh_array'}}) {
		@{$self->{'v_array'}} = @{$h->{'values'}};
		if ($self->{'v_array'}->[0] eq "-i") {
			shift(@{$self->{'v_array'}});
			}
		local @cols;
		push(@cols, "<a href='edit_refresh.cgi?index=$h->{'index'}'>$self->{'v_array'}->[0]</a>");
		push(@cols, @{$self->{'v_array'}}[1..3]);
		local $mover;
		if ($self->{'hc'} != @{$self->{'refresh_array'}}-1) {
			$mover .= "<a href=\"move_refresh.cgi?$self->{'hc'}+1\">".
			          "<img src=images/down.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		if ($self->{'hc'} != 0) {
			$mover .= "<a href=\"move_refresh.cgi?$self->{'hc'}+-1\">".
			          "<img src=images/up.gif border=0></a>";
			}
		else {
			$mover .= "<img src=images/gap.gif>";
			}
		push(@cols, $mover);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$h->{'index'});
		$self->{'hc'}++;
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'refresh_delete'} ] ]);
	}
else {
	print "<p>$self->{'text_hash'}->{'refresh_none'}<p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

