#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move_refresh.cgi
# Move a refresh_pattern directive up or down

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'refresh'} || $self->error($self->{'text_hash'}->{'header_ecannot'});
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
($self->{'pos'}, $self->{'move'}) = @ARGV;

@{$self->{'refresh_array'}} = $self->find_config("refresh_pattern", $self->{'conf'});
$self->{'newpos'} = $self->{'pos'} + $self->{'move'};
$self->{'oldv'} = $self->{'refresh_array'}->[$self->{'pos'}]->{'values'};
$self->{'refresh_array'}->[$self->{'pos'}]->{'values'} = $self->{'refresh_array'}->[$self->{'newpos'}]->{'values'};
$self->{'refresh_array'}->[$self->{'newpos'}]->{'values'} = $self->{'oldv'};
$self->save_directive($self->{'conf'}, "refresh_pattern", \@{$self->{'refresh_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("move", "refresh", $self->{'oldv'}->[0] eq "-i" ? $self->{'oldv'}->[1] : $self->{'oldv'}->[0]);
$self->redirect("list_refresh.cgi");
1;
		
}


1;

