#!/usr/bin/perl

&MAIN();

 sub MAIN {
# pool_access_save.cgi
# Save or delete a delay pool ACL

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();

@{$self->{'delays_array'}} = $self->find_config("delay_access", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'delay'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this ACL
	splice(@{$self->{'delays_array'}}, $self->indexof($self->{'delay'}, @{$self->{'delays_array'}}), 1);
	}
else {
	# update or create
	@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'action'} );
	foreach $y (split(/\0/, $self->{'in_hash'}->{'yes'})) { push(@{$self->{'vals_array'}}, $y); }
	foreach $n (split(/\0/, $self->{'in_hash'}->{'no'})) { push(@{$self->{'vals_array'}}, "!$n"); }
	$self->{'newdelay'} = { 'name' => 'delay_access', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'delay'}) { splice(@{$self->{'delays_array'}}, $self->indexof($self->{'delay'}, @{$self->{'delays_array'}}), 1, $self->{'newdelay'});}
	else { push(@{$self->{'delays_array'}}, $self->{'newdelay'}); }
	}
$self->save_directive($self->{'conf'}, "delay_access", \@{$self->{'delays_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'delay'} ? 'modify' : 'create', "delay",
	    $self->{'in_hash'}->{'idx'});
$self->redirect("edit_pool.cgi?idx=$self->{'in_hash'}->{'idx'}");

1;
		
}


1;

