#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Call squidclient to remove just one URL

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'purge_err'});
$self->{'access_hash'}->{'rebuild'} || $self->error($self->{'text_hash'}->{'clear_ecannot'});
$self->ReadParse();
$self->{'in_hash'}->{'url'} || $self->error($self->{'text_hash'}->{'purge_eurl'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'purge_title'}, "");

# Get the port number
$self->{'conf'} = $self->get_config();
if ($self->{'squid_version'} >= 2.3) {
	@{$self->{'ports_array'}} = $self->find_config("http_port", $self->{'conf'});
	foreach $p (@{$self->{'ports_array'}}) {
		if ($p->{'values'}->[0] =~ /(\d+)$/) {
			$self->{'port'} = $1;
			last;
			}
		}
	}
else {
	$self->{'port'} = $self->find_value("http_port", $self->{'conf'});
	$self->{'port'} ||= 3128;
	}

# Run it
print $self->text('purge_doing', "<tt>$self->{'in_hash'}->{'url'}</tt>"),"\n";
$self->{'cmd'} = "$self->{'config_hash'}->{'squidclient'} -p $self->{'port'} -m PURGE ".quotemeta($self->{'in_hash'}->{'url'});
$self->{'out'} = $self->backquote_logged("$self->{'cmd'} 2>&1");
print "<pre>$self->{'out'}</pre>\n";
if ($?) {
	print $self->{'text_hash'}->{'purge_failed'},"<br>\n";
	}
else {
	print $self->{'text_hash'}->{'purge_done'},"<br>\n";
	}
$self->webmin_log("purge", undef, $self->{'in_hash'}->{'url'});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

