#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save or delete an HTTP header access control rule

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'headeracc'} || $self->error($self->{'text_hash'}->{'headeracc_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'headeracc_err'});

@{$self->{'headeracc_array'}} = $self->find_config("header_access", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'h'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this restriction
	splice(@{$self->{'headeracc_array'}}, $self->indexof($self->{'h'}, @{$self->{'headeracc_array'}}), 1);
	}
else {
	# update or create
	$self->{'in_hash'}->{'name'} =~ /^[a-z0-9\.\-\_]+$/i || $self->error($self->{'text_hash'}->{'header_ename'});
	@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'action'} );
	foreach $y (split(/\0/, $self->{'in_hash'}->{'yes'})) { push(@{$self->{'vals_array'}}, $y); }
	foreach $n (split(/\0/, $self->{'in_hash'}->{'no'})) { push(@{$self->{'vals_array'}}, "!$n"); }
	$self->{'newh'} = { 'name' => 'header_access', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'h'}) { splice(@{$self->{'headeracc_array'}}, $self->indexof($self->{'h'}, @{$self->{'headeracc_array'}}), 1, $self->{'newh'}); }
	else { push(@{$self->{'headeracc_array'}}, $self->{'newh'}); }
	}
$self->save_directive($self->{'conf'}, "header_access", \@{$self->{'headeracc_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'h'} ? 'modify' : 'create',
	    "headeracc", $self->{'in_hash'}->{'name'});
$self->redirect("list_headeracc.cgi");

1;
		
}


1;

