#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_nuser.cgi
# Save, create or delete a proxy user

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

if ($self->{'config_hash'}->{'crypt_conf'} == 1) {
	eval "use MD5";
	if ($@) {
        	$self->error($self->text('eauth_nomd5', $self->{'module_name'}));
		}
	}

$self->{'access_hash'}->{'proxyauth'} || $self->error($self->{'text_hash'}->{'eauth_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'file'} = $self->get_auth_file($self->{'conf'});
$self->lock_file($self->{'file'});
@{$self->{'users_array'}} = $self->list_auth_users($self->{'file'});

$self->{'user'} = $self->{'users_array'}->[$self->{'in_hash'}->{'index'}];
if ($self->{'in_hash'}->{'delete'}) {
	$self->replace_file_line($self->{'file'}, $self->{'user'}->{'line'});
	}
else {
	$self->{'whatfailed'} = $self->{'text_hash'}->{'suser_ftsu'};
	$self->{'in_hash'}->{'user'} =~ /^[^:\s]+$/ || $self->error($self->{'text_hash'}->{'suser_emsg1'});
	local ($same) = grep { $_->{'user'} eq $self->{'in_hash'}->{'user'} } @{$self->{'users_array'}};
	local $cmt = $self->{'in_hash'}->{'enabled'} ? "" : "#";
	if ($self->{'in_hash'}->{'new'}) {
		!$same || $self->error($self->{'text_hash'}->{'suser_etaken'});
		$self->{'pass'} = &encryptpwd($self->{'in_hash'}->{'pass'}, $self->{'salt'});
		$self->open_tempfile(FILE,">>$self->{'file'}");
		$self->print_tempfile(FILE, "$cmt$self->{'in_hash'}->{'user'}:$self->{'pass'}\n");
		$self->close_tempfile(FILE);
		}
	else {
		!$same || $same->{'user'} eq $self->{'user'}->{'user'} ||
			 $self->error($self->{'text_hash'}->{'suser_etaken'});
		$self->{'pass'} = $self->{'in_hash'}->{'pass_def'} ? $self->{'user'}->{'pass'}
					: &encryptpwd($self->{'in_hash'}->{'pass'}, $self->{'salt'});
		$self->replace_file_line($self->{'file'}, $self->{'user'}->{'line'},
				   "$cmt$self->{'in_hash'}->{'user'}:$self->{'pass'}\n");
		}
	}
$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'user', $self->{'in_hash'}->{'user'} ? $self->{'in_hash'}->{'user'} : $self->{'user'}->{'user'});
$self->redirect("edit_nauth.cgi");

sub encryptpwd {
  if ($self->{'config_hash'}->{'crypt_conf'}) {
    local $pwd = $_[0];
    local $encryptpwd = new MD5;
    $encryptpwd->add($pwd);
    $pwd = encode_base64($encryptpwd->hexdigest());
    chomp($pwd);
    $pwd = "\$$pwd\$";
    return $pwd;
    }
    else {
      $self->{'salt'} = substr(time(), -2);
      local $pwd = &unix_crypt($_[0], $_[1]);
      return $pwd;
      }
  }
1;
		
}



1;

