#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start.cgi
# Start squid

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'start'} || $self->error($self->{'text_hash'}->{'start_ecannot'});
use POSIX;
$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'start_ftsq'};
$self->{'temp'} = $self->transname();
$self->clean_environment();
if ($self->{'config_hash'}->{'squid_start'}) {
	# Use a start script
	$self->{'rv'} = $self->system_logged("$self->{'config_hash'}->{'squid_start'} >$self->{'temp'} 2>&1 </dev/null");
	sleep(5);
	$self->{'errs'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	$self->reset_environment();
	if ($self->{'errs'} && $self->{'errs'} =~ /\d+\/\d+\/\d+/) {
		$self->system_logged("$self->{'config_hash'}->{'squid_stop'} >/dev/null 2>&1 </dev/null");
		$self->error("<pre>$self->{'errs'}</pre>");
		}
	}
else {
	# Run the squid executable directly
	$self->system_logged("cd / ; $self->{'config_hash'}->{'squid_path'} -sY -f $self->{'config_hash'}->{'squid_conf'} >$self->{'temp'} 2>&1 </dev/null &");
	sleep(5);
	$self->{'errs'} = `cat $self->{'temp'}`;
	unlink($self->{'temp'});
	$self->reset_environment();
	if ($self->{'errs'}) {
		$self->backquote_logged("$self->{'config_hash'}->{'squid_path'} -k shutdown -f $self->{'config_hash'}->{'squid_conf'} 2>&1 </dev/null");
		$self->error("<pre>$self->{'errs'}</pre>");
		}
	}
$self->webmin_log("start");
$self->redirect($self->{'in_hash'}->{'redir'});

1;
		
}


1;

