#!/usr/bin/perl

&MAIN();

 sub MAIN {
# stop.cgi
# Stop the running squid process

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'start'} || $self->error($self->{'text_hash'}->{'stop_ecannot'});
$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'stop_ftsq'};
if ($self->{'config_hash'}->{'squid_stop'}) {
	# Use a stop script
	$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'squid_stop'} 2>&1");
	if ($self->{'out'} && $self->{'out'} =~ /\d+\/\d+\/\d+/) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
else {
	# Run the squid executable directly
	$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'squid_path'} -f $self->{'config_hash'}->{'squid_conf'} -k shutdown 2>&1");
	if ($self->{'out'}) { $self->error("<pre>$self->{'out'}</pre>"); }
	}
for($i=0; $i<40; $i++) {
	if (!kill(0, $self->{'in_hash'}->{'pid'})) { last; }
	sleep(1);
	}
$self->webmin_log("stop");
$self->redirect($self->{'in_hash'}->{'redir'});

1;
		
}


1;

