#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_access.cgi
# Display access control SSHd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'access_title'}, "", "access");
$self->{'conf'} = $self->get_sshd_config();

print "<form action=save_access.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'access_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	$self->scmd(1);
	@{$self->{'allowh_array'}} = $self->find_value("AllowHosts", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'access_allowh'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=allowh_def value=1 %s> %s\n",
		@{$self->{'allowh_array'}} ? "" : "checked", $self->{'text_hash'}->{'access_all'};
	printf "<input type=radio name=allowh_def value=0 %s>\n",
		@{$self->{'allowh_array'}} ? "checked" : "";
	printf "<input name=allowh size=50 value='%s'></td>\n",
		join(" ", @{$self->{'allowh_array'}});
	$self->ecmd();

	$self->scmd(1);
	@{$self->{'denyh_array'}} = $self->find_value("DenyHosts", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'access_denyh'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=denyh_def value=1 %s> %s\n",
		@{$self->{'denyh_array'}} ? "" : "checked", $self->{'text_hash'}->{'access_none'};
	printf "<input type=radio name=denyh_def value=0 %s>\n",
		@{$self->{'denyh_array'}} ? "checked" : "";
	printf "<input name=denyh size=50 value='%s'></td>\n",
		join(" ", @{$self->{'denyh_array'}});
	$self->ecmd();

	$self->scmd(1);
	print "<td colspan=4><hr></td>\n";
	$self->ecmd();
	}

$self->{'commas'} = $self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} >= 3.2;

$self->scmd(1);
@{$self->{'allowu_array'}} = $self->find_value("AllowUsers", $self->{'conf'});
$self->{'allowu'} = $self->{'commas'} ? join(" ", split(/,/, $self->{'allowu_array'}->[0]))
		  : join(" ", @{$self->{'allowu_array'}});
print "<td><b>$self->{'text_hash'}->{'access_allowu'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=allowu_def value=1 %s> %s\n",
	$self->{'allowu'} ? "" : "checked", $self->{'text_hash'}->{'access_all'};
printf "<input type=radio name=allowu_def value=0 %s>\n",
	$self->{'allowu'} ? "checked" : "";
printf "<input name=allowu size=50 value='%s'> %s</td>\n",
	$self->{'allowu'}, $self->user_chooser_button("allowu", 1);
$self->ecmd();

$self->scmd(1);
@{$self->{'allowg_array'}} = $self->find_value("AllowGroups", $self->{'conf'});
$self->{'allowg'} = $self->{'commas'} ? join(" ", split(/,/, $self->{'allowg_array'}->[0]))
		  : join(" ", @{$self->{'allowg_array'}});
print "<td><b>$self->{'text_hash'}->{'access_allowg'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=allowg_def value=1 %s> %s\n",
	$self->{'allowg'} ? "" : "checked", $self->{'text_hash'}->{'access_all'};
printf "<input type=radio name=allowg_def value=0 %s>\n",
	$self->{'allowg'} ? "checked" : "";
printf "<input name=allowg size=50 value='%s'> %s</td>\n",
	$self->{'allowg'}, $self->group_chooser_button("allowg", 1);
$self->ecmd();

$self->scmd(1);
@{$self->{'denyu_array'}} = $self->find_value("DenyUsers", $self->{'conf'});
$self->{'denyu'} = $self->{'commas'} ? join(" ", split(/,/, $self->{'denyu_array'}->[0]))
		 : join(" ", @{$self->{'denyu_array'}});
print "<td><b>$self->{'text_hash'}->{'access_denyu'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=denyu_def value=1 %s> %s\n",
	$self->{'denyu'} ? "" : "checked", $self->{'text_hash'}->{'access_none'};
printf "<input type=radio name=denyu_def value=0 %s>\n",
	$self->{'denyu'} ? "checked" : "";
printf "<input name=denyu size=50 value='%s'> %s</td>\n",
	$self->{'denyu'}, $self->user_chooser_button("denyu", 1);
$self->ecmd();

$self->scmd(1);
@{$self->{'denyg_array'}} = $self->find_value("DenyGroups", $self->{'conf'});
$self->{'denyg'} = $self->{'commas'} ? join(" ", split(/,/, $self->{'denyg_array'}->[0]))
		 : join(" ", @{$self->{'denyg_array'}});
print "<td><b>$self->{'text_hash'}->{'access_denyg'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=denyg_def value=1 %s> %s\n",
	$self->{'denyg'} ? "" : "checked", $self->{'text_hash'}->{'access_none'};
printf "<input type=radio name=denyg_def value=0 %s>\n",
	$self->{'denyg'} ? "checked" : "";
printf "<input name=denyg size=50 value='%s'> %s</td>\n",
	$self->{'denyg'}, $self->group_chooser_button("denyg", 1);
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd(1);
	print "<td colspan=4><hr></td>\n";
	$self->ecmd();

	$self->scmd();
	$self->{'silent'} = $self->find_value("SilentDeny", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'access_silent'}</b></td> <td>\n";
	printf "<input type=radio name=silent value=1 %s> %s\n",
		lc($self->{'silent'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=silent value=0 %s> %s</td>\n",
		lc($self->{'silent'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

