#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a page for manually editing an SSHd config file

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'manual_title'}, "");

# Work out and show the files
@{$self->{'files_array'}} = ( $self->{'config_hash'}->{'sshd_config'}, $self->{'config_hash'}->{'client_config'} );
$self->{'in_hash'}->{'file'} ||= $self->{'files_array'}->[0];
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});
print $self->ui_form_start("edit_manual.cgi");
print "<b>$self->{'text_hash'}->{'manual_file'}</b>\n";
print $self->ui_select("file", $self->{'in_hash'}->{'file'},
		 [ map { [ $_ ] } @{$self->{'files_array'}} ]),"\n";
print $self->ui_submit($self->{'text_hash'}->{'manual_ok'});
print $self->ui_form_end();

# Show the file contents
print $self->ui_form_start("save_manual.cgi", "form-data");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
$self->{'data'} = $self->read_file_contents($self->{'in_hash'}->{'file'});
print $self->ui_textarea("data", $self->{'data'}, 20, 80),"\n";
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

