#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update a manually edited config file

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'manual_err'});
$self->ReadParseMime();

# Work out the file
@{$self->{'files_array'}} = ( $self->{'config_hash'}->{'sshd_config'}, $self->{'config_hash'}->{'client_config'} );
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->{'in_hash'}->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'manual_edata'});

# Write to it
$self->open_lock_tempfile(DATA, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(DATA, $self->{'in_hash'}->{'data'});
$self->close_tempfile(DATA);

$self->webmin_log("manual", undef, $self->{'in_hash'}->{'file'});
$self->redirect("");

1;
		
}


1;

