#!/usr/bin/perl
package status::Apachemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Apachemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# apache-monitor.pl
# Monitor the apache server on this host

1;

1;
		return $self;
}

# Check the PID file to see if apache is running
sub get_apache_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "apache-lib.pl");
return { 'up' => -1 } if (!$self->foreign_check($_[1]));
local %aconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-x $aconfig{'httpd_path'});

if ($self->foreign_call($_[1], "is_apache_running")) {
	local $pidfile = $self->foreign_call($_[1], "get_pid_file");
	local @st = stat($pidfile);
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_apache_dialog
{
	my $self = shift;

$self->depends_check($_[0], "apache");
}


1;

