#!/usr/bin/perl
package status::Bind8monitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Bind8monitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# bind8-monitor.pl
# Monitor the BIND DNS server on this host

1;

1;
		return $self;
}

# Check the PID file to see if apache is running
sub get_bind8_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "bind8-lib.pl");
local %bconfig = $self->foreign_config($_[1]);
return { 'up' => -1 }
	if (!-r $self->foreign_call($_[1], "make_chroot", $bconfig{'named_conf'}));
local $file = $self->foreign_call($_[1], "get_pid_file");
$file = $self->foreign_call($_[1], "make_chroot", $file, 1);

if ($self->check_pid_file($file)) {
	local @st = stat($file);
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_bind8_dialog
{
	my $self = shift;

$self->depends_check($_[0], "bind8");
}


1;

