#!/usr/bin/perl
package status::Cfenginemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Cfenginemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# cfengine-monitor.pl
# Monitor the cfengine daemon on this host

1;

1;
		return $self;
}

# Check the PID file to see if cfd is running
sub get_cfengine_status
{
	my $self = shift;

local %cconfig = $self->foreign_config($_[1]);
$self->has_command($cconfig{'cfd'}) || return { 'up' => -1 };
local @pids = $self->find_byname("cfd");
if (@pids) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_cfengine_dialog
{
	my $self = shift;

$self->depends_check($_[0], "cfengine");
}


1;

