#!/usr/bin/perl
package status::Changemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Changemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# change-monitor.pl
# Check if some file or directory has changed

1;
		return $self;
}

sub get_change_status
{
	my $self = shift;

local %change;
$self->read_file("$self->{'module_config_directory'}/change", \%change);
local $t = $change{$_[0]->{'file'}};
local @st = stat($_[0]->{'file'});
local $rv;
if ($t && $st[9] != $t) {
	$rv = { 'up' => 0 };
	}
elsif (!$t) {
	$rv = { 'up' => -1 };
	}
else {
	$rv = { 'up' => 1 };
	}
$change{$_[0]->{'file'}} = $st[9];
$self->write_file("$self->{'module_config_directory'}/change", \%change);
return $rv;
}

sub show_change_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'change_file'},
	$self->ui_textbox("file", $_[0]->{'file'}, 30)." ".
	$self->file_chooser_button("file", 0), 3);
}

sub parse_change_dialog
{
	my $self = shift;

$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
}


1;

