#!/usr/bin/perl
package status::Dhcpdmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Dhcpdmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# dhcpd-monitor.pl
# Monitor the DHCP server on this host

1;

1;
		return $self;
}

# Check the PID file to see if DHCPd is running
sub get_dhcpd_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "dhcpd-lib.pl");
local %dconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $dconfig{'dhcpd_conf'});
if ($self->foreign_call($_[1], "is_dhcpd_running")) {
	local @st = stat($dconfig{'pid_file'});
	return { 'up' => 1,
		 'desc' => @st ? $self->text('up_since', scalar(localtime($st[9])))
			       : undef };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_dhcpd_dialog
{
	my $self = shift;

$self->depends_check($_[0], "dhcpd");
}


1;

