#!/usr/bin/perl
package status::Hostsentrymonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Hostsentrymonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# hostsentry-monitor.pl
# Monitor the hostsentry daemon

1;

1;
		return $self;
}

# Check the PID file to see if hostsentry is running
sub get_hostsentry_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("sentry"));
local %sconfig = $self->foreign_config("sentry");
-r $sconfig{'hostsentry'} || return { 'up' => -1 };
$self->foreign_require("sentry", "sentry-lib.pl");
local $pid = $main::sentry_object->get_hostsentry_pid();
if ($pid) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_hostsentry_dialog
{
	my $self = shift;

$self->depends_check($_[0], "sentry");
}


1;

