#!/usr/bin/perl
package status::Jabbermonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Jabbermonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# jabber-monitor.pl
# Monitor the jabber server on this host

1;

1;
		return $self;
}

# Check the PID file to see if mon is running
sub get_jabber_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
local %jconfig = $self->foreign_config($_[1]);
-r $jconfig{'jabber_config'} || return { 'up' => -1 };
$self->foreign_require($_[1], "jabber-lib.pl");
local $pidfile = $self->foreign_call($_[1], "jabber_pid_file");
if (open(PID, $pidfile) && ($self->{'pid'} = int(<PID>)) && kill(0, $self->{'pid'})) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_jabber_dialog
{
	my $self = shift;

$self->depends_check($_[0], "jabber");
eval "use XML::Parser";
$self->error($self->text('jabber_eparser', "<tt>XML::Parser</tt>")) if ($@);
}


1;

