#!/usr/bin/perl
package status::Mysqlmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Mysqlmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mysql-monitor.pl
# Monitor the MySQL server on this host

1;

1;
		return $self;
}

# Check if mysql is running
sub get_mysql_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "mysql-lib.pl");
local %mconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-x $mconfig{'mysqladmin'});
local $r = $self->foreign_call($_[1], "is_mysql_running");
return { 'up' => $r ? 1 : 0 };
}

sub parse_mysql_dialog
{
	my $self = shift;

$self->depends_check($_[0], "mysql");
}


1;

