#!/usr/bin/perl
package status::Nfsmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Nfsmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# nfs-monitor.pl
# Monitor the NFS server process

1;
		return $self;
}

sub get_nfs_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("proc"));
$self->foreign_require("proc", "proc-lib.pl");
if ($self->foreign_check("exports") || $self->foreign_check("dfsadmin") ||
    $self->foreign_check("bsdexports") || $self->foreign_check("hpuxexports")) {
	return { 'up' => $self->find_named_process('nfsd') ? 1 : 0 };
	}
else {
	return { 'up' => -1 };
	}
}


1;

