#!/usr/bin/perl
package status::Portsentrymonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Portsentrymonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# portsentry-monitor.pl
# Monitor the portsentry daemon

1;

1;
		return $self;
}

# Check the PID file to see if portsentry is running
sub get_portsentry_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("sentry"));
local %sconfig = $self->foreign_config("sentry");
$self->has_command($sconfig{'portsentry'}) || return { 'up' => -1 };
$self->foreign_require("sentry", "sentry-lib.pl");
local @pids = $main::sentry_object->get_portsentry_pids();
if (@pids) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_portsentry_dialog
{
	my $self = shift;

$self->depends_check($_[0], "sentry");
}


1;

