#!/usr/bin/perl
package status::Postfixmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Postfixmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# postfix-monitor.pl
# Monitor the postfix server on this host

1;

1;
		return $self;
}

# Check to see if postfix is running
sub get_postfix_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "postfix-lib.pl");
local %pconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $pconfig{'postfix_control_command'});
if ($self->foreign_call($_[1], "is_postfix_running")) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_postfix_dialog
{
	my $self = shift;

$self->depends_check($_[0], "postfix");
}


1;

