#!/usr/bin/perl
package status::Qmailadminmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Qmailadminmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# qmailadmin-monitor.pl
# Monitor the qmail server on this host

1;

1;
		return $self;
}

# Check the PID file to see if qmail is running
sub get_qmailadmin_status
{
	my $self = shift;

local %qconfig = $self->foreign_config($_[1]);
-d $qconfig{'qmail_dir'} || return { 'up' => -1 };
local ($pid) = $self->find_byname("qmail-send");
if ($pid) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_qmailadmin_dialog
{
	my $self = shift;

$self->depends_check($_[0], "qmailadmin");
}


1;

