#!/usr/bin/perl
package status::Sendmailmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Sendmailmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# sendmail-monitor.pl
# Monitor the sendmail server on this host

1;

1;
		return $self;
}

# Check the PID file to see if sendmail is running
sub get_sendmail_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "sendmail-lib.pl");
local %sconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $sconfig{'sendmail_cf'});
if ($main::sendmail_object->is_sendmail_running()) {
	local @pidfiles = split(/\t+/, $sconfig{'sendmail_pid'});
	local @st = stat($pidfiles[0]);
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_sendmail_dialog
{
	my $self = shift;

$self->depends_check($_[0], "sendmail");
}


1;

