#!/usr/bin/perl
package swup::Install_check;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'swup::Install_check');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# install_check.pl

&ModuleLoader::preload_module(ref($self), "swup::SwupLib");
$self = new swup::SwupLib:: ref($self), %$self; 

1;
		return $self;
}

# is_installed(mode)
# For mode 1, returns 2 if SWUP is installed and configured for use by
# CP+, 1 if installed but not configured, or 0 otherwise.
# For mode 0, returns 1 if installed, 0 if not
sub is_installed
{
	my $self = shift;

return 0 if (!-x $self->{'config_hash'}->{'swup_path'} || !-r $self->{'config_hash'}->{'swup_conf'});
return $_[0] ? 2 : 1;
}


1;

