#!/usr/bin/perl

&MAIN();

 sub MAIN {
###########################################################################
# showcat.cgi
###########################################################################
&ModuleLoader::preload_module('theme_xpressia_class', "WebLib");
$self = new WebLib:: 'theme_xpressia_class',%$self;

$self->init_config();

$self->foreign_require("licmanage", "licmanage-lib.pl");
$self->{'lic'} = $main::licmanage_object->get_licinfo();
if ($self->{'lic'}->{'ret'}) {
	$self->ui_print_header();
	print <<EOF;
<script language="javascript">
window.onload=top.location.replace("/index.cgi");
</script>
EOF
	$self->ui_print_footer();
	exit;
}

# Work out what categories exist, and which is current
$self->ReadParse();

# read current user categories
$self->read_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}}, \@{$self->{'catnames_array'}});

@{$self->{'modules_array'}} = $self->get_available_module_infos(1);
foreach $m (@{$self->{'modules_array'}}) {
	#$m->{'category'} = 'one' if ($one_tab);
	$c = $m->{'category'};
	next if ($self->{'cats_hash'}->{$c});
	if ($self->{'catnames_hash'}->{$c}) {
		$self->{'cats_hash'}->{$c} = $self->{'catnames_hash'}->{$c};
	}
	elsif ($self->{'text_hash'}->{"category_$c"}) {
		$self->{'cats_hash'}->{$c} = $self->{'text_hash'}->{"category_$c"};
	}
	else {
		# try to get category name from module ..
		local %mtext = $self->load_language($m->{'dir'});
		if ($mtext{"category_$c"}) {
			$self->{'cats_hash'}->{$c} = $mtext{"category_$c"};
		}
#		else {
#			$c = $m->{'category'} = "";
#			$self->{'cats_hash'}->{$c} = $self->{'text_hash'}->{"category_$c"};
#		}
	}
}

# get list of uniq. used categories
%{$self->{'seen_hash'}} = ();
@{$self->{'uniq_used_cats_array'}} = grep { ! $self->{'seen_hash'}->{$_}++ } map { $_->{'category'} } @{$self->{'modules_array'}};
@{$self->{'cats_array'}} = grep { $self->{'seen_hash'}->{$_} } @{$self->{'catnames_array'}};

for ($i=0; $i<= int (@{$self->{'cats_array'}})-1; $i++ )   {
	if ($self->{'cats_array'}->[$i] eq "other")
	{local $tmp= $self->{'cats_array'}->[int (@{$self->{'cats_array'}})-1];
 	$self->{'cats_array'}->[int (@{$self->{'cats_array'}})-1]= $self->{'cats_array'}->[$i];
 	$self->{'cats_array'}->[$i]= $tmp;
	}
}

$self->{'category'} = $self->{'in_hash'}->{'cat'};
$self->{'show_hidden'} = $self->{'in_hash'}->{'show_hidden'};

$self->header();

$self->{'modi'} = 0;
$self->{'cati'} = 0;

$self->{'icon_size'} = 24;
$self->{'cols'} = 3;

$self->{'conf'} = '24';

#$pers = int(100 / $self->{'cols'});
$self->{'show_hidden'} = &get_showhidden_user();
if (exists ($self->{'in_hash'}->{show_hidden})) {
   if ($self->{'in_hash'}->{show_hidden} != $self->{'show_hidden'}) {
       $self->{'gconfig_hash'}->{'showhidden_'.$self->{'remote_user'}}=$self->{'in_hash'}->{show_hidden};
       $self->lock_file("$self->{'config_directory'}/config");
       $self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
       $self->unlock_file("$self->{'config_directory'}/config");
       $self->{'show_hidden'} = $self->{'in_hash'}->{show_hidden};
       }
}

print "<table align=center border=0 cellspacing=0 cellpadding=2 width='100%' class=infoframe>\n";
foreach $c (@{$self->{'cats_array'}}) {
	@{$self->{'visible_array'}} = ();
	$self->{'v_count'} = 0;
	@{$self->{'invisible_array'}} = ();
	$self->{'inv_count'} = 0;

	if ($self->{'category'} eq $c || !$self->{'category'}) {
		$self->{'cati'}++;

		foreach $m (@{$self->{'modules_array'}}) {
			next if $m->{'category'} ne $c;
			#ok print modules count
			$self->{'module_dir'} = $m->{'dir'};
			if ( $self->configured($self->{'module_dir'}) ){
				push(@{$self->{'visible_array'}},$m);
				$self->{'v_count'}++;
			} else {
				push(@{$self->{'invisible_array'}},$m);
				$self->{'inv_count'}++;
			}
		}

		# draw category header
		print "<tr class=infotitle><td colspan=$self->{'cols'}>";
#  		if ($self->{'inv_count'}) {
# #  			if ($self->{'show_hidden'}) {
# #  				print "<a href='menu.cgi?cat=$self->{'in_hash'}->{cat}&show_hidden=0' target=nav title='Hide misconfigured modules'><img align=right src=images/d_up.gif border=0 width=16 height=16></a>\n";
# #  			}
# #  			else {
# #  				print "<a href='menu.cgi?cat=$self->{'in_hash'}->{cat}&show_hidden=1' target=nav title='Show misconfigured modules'><img align=right src=images/d_down.gif border=0 width=16 height=16></a>\n";
# #  			}
#  			if ($self->{'show_hidden'}) {
#  				print "<a class=ilnk href='showcat.cgi?show_hidden=0' target=content title='Hide misconfigured modules'><img align=right src=images/d_up.gif border=0 width=16 height=16></a>\n";
#  			}
#  			else {
#  				print "<a class=ilnk href='showcat.cgi?show_hidden=1' target=content title='Show misconfigured modules'><img align=right src=images/d_down.gif border=0 width=16 height=16></a>\n";
#  			}
#  		}
# 		print "<b>$self->{'catnames_hash'}->{$c}</b>";
		printf "<table width=100%><tr class=infotitle><td><b>$self->{'catnames_hash'}->{$c}</b></td>";
		printf "<td>%s</td></tr></table>", $self->{'inv_count'} ? $self->{'show_hidden'} ? "<a class=ilnk href='showcat.cgi?show_hidden=0' target=content title='Hide misconfigured modules'><img align=right src=images/d_up.gif border=0 width=16 height=16></a>"
			: "<a class=ilnk href='showcat.cgi?show_hidden=1' target=content title='Show misconfigured modules'><img align=right src=images/d_down.gif border=0 width=16 height=16></a>" : " &nbsp; ";
		print "</td></tr>\n";

#		$pos = 0;
#		$self->{'cols'} = 3;
#		$done = 0;
		# draw configured modules list
		$self->{'modi'} = 0;
		foreach $m (@{$self->{'visible_array'}}) {
			if($self->{'modi'} == 0) {
				print "<tr>\n";
			}
			$self->{'href'} = $m->{'full_url'} ? $m->{'dir'} : "/$m->{'dir'}/";
			$self->{'href_url'} = $self->urlize($self->{'href'});
			$self->{'icon'} = $m->{'icon'} ? $m->{'icon'} : "/$m->{'dir'}/images/icon$self->{'conf'}.gif";
			$self->{'link'} = "<a target=content class=none href='$self->{'href'}'>";
			$self->{'ilink'} = "<a target=content class=ilnk href='$self->{'href'}'>";
			#$self->{'link'} = "<a target=content class=none href='menu.cgi?lnk=$self->{'href_url'}'>";
			#$self->{'ilink'} = "<a target=content class=ilnk href='menu.cgi?lnk=$self->{'href_url'}'>";
			print "<td align=left>$self->{'ilink'}<img src=$self->{'icon'} border=0 width=$self->{'icon_size'} height=$self->{'icon_size'}></a>$self->{'link'}$m->{'desc'}</a></td>\n";
			$self->{'modi'}++;
			if($self->{'modi'} == $self->{'cols'}) {
				print "</tr>\n";
				$self->{'modi'} = 0;
			}
		}
		if ($self->{'modi'} != 0) {
			foreach ($self->{'modi'} .. $self->{'cols'} - 1) { print "<td>&nbsp</td>\n"; }
			print "</tr>";
		}
		# draw not configured modules list
		$self->{'modi'} = 0;
		if ($self->{'show_hidden'} && $self->{'inv_count'}) {
			#print "<tr><td class=divider colspan=$self->{'cols'} align=right>&nbsp;<a href='menu.cgi?cat=$self->{'in_hash'}->{cat}&show_hidden=0' target=nav title='Hide misconfigured modules'><img src=images/d_up.gif border=0 width=16 height=16></a></td></tr>";
			print "<tr><td class=divider colspan=$self->{'cols'} align=right>&nbsp;</td></tr>";
			foreach $m (@{$self->{'invisible_array'}}) {
				if($self->{'modi'} == 0) {
					print "<tr>\n";
				}
				$self->{'href'} = $m->{'full_url'} ? $m->{'dir'} : "/$m->{'dir'}/";
				$self->{'icon'} = $m->{'icon'} ? $m->{'icon'} : "/$m->{'dir'}/images/icon$self->{'conf'}\_off.gif";
				$self->{'link'} = "<a target=content class=none href='$self->{'href'}'>";
				$self->{'ilink'} = "<a target=content class=ilnk href='$self->{'href'}'>";
				print "<td align=left>$self->{'ilink'}<img src=$self->{'icon'} border=0 width=$self->{'icon_size'} height=$self->{'icon_size'}></a>$self->{'link'}$m->{'desc'}</a></td>\n";
				$self->{'modi'}++;
				if($self->{'modi'} == $self->{'cols'}) {
					print "</tr>\n";
					$self->{'modi'} = 0;
				}
			}
			if ($self->{'modi'} != 0) {
				foreach ($self->{'modi'} .. $self->{'cols'} - 1) { print "<td>&nbsp</td>\n"; }
				print "</tr>";
			}
		}
		else {
			#print "<tr><td colspan=$self->{'cols'} align=right>&nbsp;<a href='menu.cgi?cat=$self->{'in_hash'}->{cat}&show_hidden=1' target=nav title='Show misconfigured modules'><img src=images/d_down.gif border=0 width=16 height=16></a></td></tr>";
		}
		print "<tr><td colspan=$self->{'cols'}>&nbsp;</td></tr>\n";
	}
}

print "</table>\n</body>\n</html>\n";

1;
		
}

# ---------
sub get_showhidden_user {
	shift if ($self == $_[0]);

	local $key = 'showhidden_'.$self->{'remote_user'};
	return ($self->{'gconfig_hash'}->{$key} ? $self->{'gconfig_hash'}->{$key} : 0);
}


1;

