#!/usr/bin/perl
package updown::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'updown::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "updown::UpdownLib");
$self = new updown::UpdownLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the updown module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_upload'}</b></td>\n";
printf "<td colspan=3><input type=radio name=upload value=1 %s> %s\n",
	$_[0]->{'upload'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=upload value=0 %s> %s</td> </tr>\n",
	$_[0]->{'upload'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td nowrap><b>$self->{'text_hash'}->{'acl_max'}</b></td>\n";
printf "<td colspan=3><input type=radio name=max_def value=1 %s> %s\n",
	$_[0]->{'max'} ? "" : "checked", $self->{'text_hash'}->{'acl_unlim'};
printf "<input type=radio name=max_def value=0 %s>\n",
	$_[0]->{'max'} ? "checked" : "";
printf "<input name=max size=8 value='%s'> %s</td> </tr>\n",
	$_[0]->{'max'}, $self->{'text_hash'}->{'acl_b'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_download'}</b></td>\n";
printf "<td colspan=3><input type=radio name=download value=1 %s> %s\n",
	$_[0]->{'download'} == 1 ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=download value=2 %s> %s\n",
	$_[0]->{'download'} == 2 ? "checked" : "", $self->{'text_hash'}->{'acl_nosched'};
printf "<input type=radio name=download value=0 %s> %s</td> </tr>\n",
	$_[0]->{'download'} == 0 ? "checked" : "", $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> $self->{'text_hash'}->{'acl_all'}<br>\n",
	$_[0]->{'mode'} == 0 ? "checked" : "";
printf "<input type=radio name=mode value=3 %s> $self->{'text_hash'}->{'acl_this'}<br>\n",
	$_[0]->{'mode'} == 3 ? "checked" : "";
printf "<input type=radio name=mode value=1 %s> $self->{'text_hash'}->{'acl_only'}\n",
	$_[0]->{'mode'} == 1 ? "checked" : "";
printf "<input name=userscan size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 1 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscan", 1);
printf "<input type=radio name=mode value=2 %s> $self->{'text_hash'}->{'acl_except'}\n",
	$_[0]->{'mode'} == 2 ? "checked" : "";
printf "<input name=userscannot size=40 value='%s'> %s</td> </tr>\n",
	$_[0]->{'mode'} == 2 ? $_[0]->{'users'} : "",
	$self->user_chooser_button("userscannot", 1);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dirs'}</b></td> <td colspan=3>\n";
print "<textarea name=dirs rows=3 cols=50>",
	join("\n", split(/\s+/, $_[0]->{'dirs'})),"</textarea><br>\n";
printf "<input type=checkbox name=home value=1 %s> %s</td> </tr>\n",
	$_[0]->{'home'} ? 'checked' : '', $self->{'text_hash'}->{'acl_home'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_fetch'}</b></td>\n";
printf "<td colspan=3><input type=radio name=fetch value=1 %s> %s\n",
	$_[0]->{'fetch'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=fetch value=0 %s> %s</td> </tr>\n",
	$_[0]->{'fetch'} ? "" : "checked", $self->{'text_hash'}->{'no'};
}

# acl_security_save(&options)
# Parse the form for security options for the cron module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'upload'} = $self->{'in_hash'}->{'upload'};
$_[0]->{'max'} = $self->{'in_hash'}->{'max_def'} ? undef : $self->{'in_hash'}->{'max'};
$_[0]->{'download'} = $self->{'in_hash'}->{'download'};
$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'users'} = $self->{'in_hash'}->{'mode'} == 0 || $self->{'in_hash'}->{'mode'} == 3 ? "" :
		   $self->{'in_hash'}->{'mode'} == 1 ? $self->{'in_hash'}->{'userscan'}
				    : $self->{'in_hash'}->{'userscannot'};
local @dirs = split(/\s+/, $self->{'in_hash'}->{'dirs'});
map { s/\/+/\//g } @dirs;
map { s/([^\/])\/+$/$1/ } @dirs;
$_[0]->{'dirs'} = join(" ", @dirs);
$_[0]->{'home'} = $self->{'in_hash'}->{'home'};
$_[0]->{'fetch'} = $self->{'in_hash'}->{'fetch'};
}


1;

