#!/usr/bin/perl

&MAIN();

 sub MAIN {
# export_exec.cgi
# Actually output a user creation batch file

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'export'} || $self->error($self->{'text_hash'}->{'export_ecannot'});
$self->ReadParse();

# Validate inputs
if ($self->{'in_hash'}->{'to'}) {
	$self->{'access_hash'}->{'export'} == 2 || $self->error($self->{'text_hash'}->{'export_ecannot'});
	$self->{'in_hash'}->{'file'} =~ /^\/.+$/ || $self->error($self->{'text_hash'}->{'export_efile'});
	$self->is_under_directory($self->{'access_hash'}->{'home'}, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->{'text_hash'}->{'export_efile2'});
	}

# Open the output file
if ($self->{'in_hash'}->{'to'}) {
	$self->open_tempfile(OUT, ">$self->{'in_hash'}->{'file'}", 1) ||
		$self->error($self->text('export_eopen', $!));
	$self->{'fh'} = "OUT";
	$self->ui_print_header(undef, $self->{'text_hash'}->{'export_title'}, "");
	}
else {
	print "Content-type: text/plain\n\n";
	$self->{'fh'} = "STDOUT";
	}

# Work out which users are allowed and selected
@{$self->{'ulist_array'}} = $self->list_users();
@{$self->{'ulist_array'}} = $self->list_allowed_users(\%{$self->{'access_hash'}}, \@{$self->{'ulist_array'}});
$self->{'faccess_hash'}->{'uedit_mode'} = $self->{'in_hash'}->{'mode'};
$self->{'faccess_hash'}->{'uedit'} = $self->{'in_hash'}->{'mode'} == 2 ? $self->{'in_hash'}->{'can'} :
		   $self->{'in_hash'}->{'mode'} == 3 ? $self->{'in_hash'}->{'cannot'} :
		   $self->{'in_hash'}->{'mode'} == 4 ? $self->{'in_hash'}->{'uid'} :
		   $self->{'in_hash'}->{'mode'} == 8 ? $self->{'in_hash'}->{'gid'} :
		   $self->{'in_hash'}->{'mode'} == 5 ?
			join(" ", map { "".$self->my_getgrnam($_) }
			     split(/\s+/, $self->{'in_hash'}->{'group'})) : "";
$self->{'faccess_hash'}->{'uedit2'} = $self->{'in_hash'}->{'mode'} == 4 ? $self->{'in_hash'}->{'uid2'} :
		     $self->{'in_hash'}->{'mode'} == 8 ? $self->{'in_hash'}->{'gid2'} : undef;
$self->{'faccess_hash'}->{'uedit_sec'} = $self->{'in_hash'}->{'mode'} == 5 ? $self->{'in_hash'}->{'sec'} : undef;
@{$self->{'ulist_array'}} = $self->list_allowed_users(\%{$self->{'faccess_hash'}}, \@{$self->{'ulist_array'}});

# Go through all allowed users
$self->{'count'} = 0;
$self->{'pft'} = $self->{'in_hash'}->{'pft'};
foreach $u (@{$self->{'ulist_array'}}) {
	@{$self->{'line_array'}} = ( $u->{'user'}, $u->{'pass'}, $u->{'uid'}, $u->{'gid'},
		  $u->{'real'}, $u->{'home'}, $u->{'shell'} );
	if ($self->{'pft'} == 1 || $self->{'pft'} == 6) {
		push(@{$self->{'line_array'}}, $u->{'class'});
		}
	elsif ($self->{'pft'} == 2) {
		push(@{$self->{'line_array'}}, $u->{'min'}, $u->{'max'}, $u->{'warn'},
			    $u->{'inactive'}, $u->{'expire'});
		}
	elsif ($self->{'pft'} == 4) {
		local @flags;
		push(@flags, 'ADMIN') if ($u->{'admin'});
                push(@flags, 'ADMCHG') if ($u->{'admchg'});
                push(@flags, 'NOCHECK') if ($u->{'nocheck'});
		push(@{$self->{'line_array'}}, $u->{'min'}, $u->{'max'},
			    $u->{'expire'}, join(" ", @flags));
		}
	elsif ($self->{'pft'} == 5) {
		push(@{$self->{'line_array'}}, $u->{'min'}, $u->{'max'});
		}
	if ($self->{'fh'} eq "STDOUT") {
		local $tmp_mas = join(":", "create", @{$self->{'line_array'}},"\n");
		{ my $t=$self->{'fh'}; print $t $tmp_mas;}
		}
	else {
		$self->print_tempfile($self->{'fh'}, join(":", "create", @{$self->{'line_array'}}),"\n");
		}
	$self->{'count'}++;
	}

if ($self->{'in_hash'}->{'to'}) {
	# All done
	$self->close_tempfile($self->{'fh'});
	@{$self->{'st_array'}} = stat($self->{'in_hash'}->{'file'});
	print "<p>",$self->text('export_done',
		  $self->{'count'}, "<tt>$self->{'in_hash'}->{'file'}</tt>", $self->nice_size($self->{'st_array'}->[7])),"<p>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

