#!/usr/bin/perl

&MAIN();

 sub MAIN {
# export_form.cgi
# Display a form for exporting a batch file

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'export'} || $self->error($self->{'text_hash'}->{'export_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'export_title'}, "", "export");

print "$self->{'text_hash'}->{'export_desc'}<p>\n";
print "<form action=export_exec.cgi>\n";
print "<table>\n";
print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'export_title'}</b> </td></tr>";
print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'export_to'}</b></td> <td valign=top>\n";
if ($self->{'access_hash'}->{'export'} == 2) {
	print "<input type=radio name=to value=0 checked> $self->{'text_hash'}->{'export_show'}<br>\n";
	print "<input type=radio name=to value=1> $self->{'text_hash'}->{'export_file'}\n";
	print "<input name=file size=30> ",$self->file_chooser_button("file"),"</td> </tr>\n";
	}
else {
	print "$self->{'text_hash'}->{'export_show'}</td> </tr>\n";
	}

$self->{'pft'} = $self->passfiles_type();
print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'export_pft'}</b></td> <td valign=top>\n";
print "<select name=pft width=50 >\n";
foreach $k (sort { $a cmp $b } keys %{$self->{'text_hash'}}) {
	next if ($k !~ /^pft_(\d+)$/ || $self->{'done_hash'}->{$self->{'text_hash'}->{$k}}++);
	printf "<option value=%d %s> %s<br>\n",
		$1, $1 == $self->{'pft'} ? "selected" : "", $self->{'text_hash'}->{$k};
	}
print "</select></td> </tr>\n";

print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'export_who'}</b></td> <td valign=top>\n";
print "<input type=radio name=mode value=0 checked> $self->{'text_hash'}->{'acl_uedit_all'}<br>\n";
print "<input type=radio name=mode value=2> $self->{'text_hash'}->{'acl_uedit_only'}\n";
printf "<input name=can size=40> %s<br>\n",
	$self->user_chooser_button("can", 1);
print "<input type=radio name=mode value=3> $self->{'text_hash'}->{'acl_uedit_except'}\n";
printf "<input name=cannot size=40> %s<br>\n",
	$self->user_chooser_button("cannot", 1);

print "<input type=radio name=mode value=4> $self->{'text_hash'}->{'acl_uedit_uid'}\n";
print "<input name=uid size=6> - \n";
print "<input name=uid2 size=6><br>\n";

print "<input type=radio name=mode value=5> $self->{'text_hash'}->{'acl_uedit_group'}\n";
printf "<input name=group size=40> %s<br>\n",
	$self->group_chooser_button("group", 1);
printf "%s <input type=checkbox name=sec value=1> %s<br>\n",
	"&nbsp;" x 5, $self->{'text_hash'}->{'acl_uedit_sec'};

print "<input type=radio name=mode value=8> $self->{'text_hash'}->{'acl_uedit_gid'}\n";
print "<input name=gid size=6> - \n";
print "<input name=gid2 size=6><br>\n";
print "</td> </tr>\n",

print "</table>\n";
print "<tr $self->{'cb'}> <td><input type=submit value=\"$self->{'text_hash'}->{'export_ok'}\"></td> </tr>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

