#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_logins.cgi
# Display the last login locations, tty, login time and duration

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
$self->{'u'} = $self->{'in_hash'}->{'username'};
%{$self->{'access_hash'}} = $self->get_module_acl();
if (!$self->{'access_hash'}->{'logins'}) {
	$self->error($self->{'text_hash'}->{'logins_elist'});
	}
elsif ($self->{'access_hash'}->{'logins'} ne "*") {
	$self->{'u'} || $self->error($self->{'text_hash'}->{'logins_elist'});
	local @ul = split(/\s+/, $self->{'access_hash'}->{'logins'});
	$self->indexof($self->{'u'},@ul) >= 0 ||
		$self->error($self->text('logins_elistu', $self->{'u'}));
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'logins_title'}, "", "list_logins");

if ($self->{'u'}) {
	print $self->ui_subheading($self->text('logins_head', $self->{'u'}));
	}
print "<table border width=100%> <tr $self->{'tb'}>\n";
if (!$self->{'u'}) {
	print "<td><b>$self->{'text_hash'}->{'user'}</b></td>\n";
	}
print "<td><b>$self->{'text_hash'}->{'logins_from'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'logins_tty'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'logins_in'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'logins_out'}</b></td>\n";
print "<td><b>$self->{'text_hash'}->{'logins_for'}</b></td> </tr>\n";
foreach $l ($self->list_last_logins($self->{'u'}, $self->{'config_hash'}->{'last_count'})) {
	@{$self->{'last_array'}} = @$l;
	print "<tr $self->{'cb'}>", $self->{'u'} ? ""
			     : "<td><tt>".$self->html_escape($self->{'last_array'}->[0])."</tt></td>";
	print "<td><tt>", $self->{'last_array'}->[2] ? $self->html_escape($self->{'last_array'}->[2])
				   : $self->{'text_hash'}->{'logins_local'},
	      "</tt></td> <td><tt>",$self->html_escape($self->{'last_array'}->[1]),"</tt></td> ",
	      "<td><tt>",$self->html_escape($self->{'last_array'}->[3]),"</tt></td>\n";
	if ($self->{'last_array'}->[4]) {
		print "<td><tt>",$self->html_escape($self->{'last_array'}->[4]),"</tt></td> ",
		      "<td><tt>",$self->html_escape($self->{'last_array'}->[5]),"</tt></td> </tr>\n";
		}
	else {
		print "<td colspan=2><tt>$self->{'text_hash'}->{'logins_still'}",
		      "</tt></td> </tr>\n";
		}
	$self->{'foundany'}++;
	}
if (!$self->{'foundany'}) {
	printf "<tr $self->{'cb'}> <td colspan=%d>$self->{'text_hash'}->{'logins_none'}</td> </tr>\n",
		$self->{'u'} ? 5 : 6;
	}
print "</table><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

