#!/usr/bin/perl

&MAIN();

 sub MAIN {
# my_group_chooser.cgi
# A modified version of group_chooser.cgi that uses the my_ functions

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->init_config();
$self->ReadParse(undef, undef, 1);
%{$self->{'access_hash'}} = $self->get_module_acl(undef, "");

# Build list of primary groups
$self->my_setpwent();
while(@{$self->{'uinfo_array'}} = $self->my_getpwent()) {
	push(@{$self->{'members_hash'}->{$self->{'uinfo_array'}->[3]}}, $self->{'uinfo_array'}->[0]);
	}
$self->my_endpwent();

if ($self->{'in_hash'}->{'multi'}) {
	# selecting multiple groups.
	if ($self->{'in_hash'}->{'frame'} == 0) {
		# base frame
		$self->PrintHeader();
		print "<script>\n";
		@{$self->{'ul_array'}} = split(/\s+/, $self->{'in_hash'}->{'group'});
		$self->{'len'} = @{$self->{'ul_array'}};
		print "sel = new Array($self->{'len'});\n";
		print "selr = new Array($self->{'len'});\n";
		for($i=0; $i<$self->{'len'}; $i++) {
			print "sel[$i] = \"$self->{'ul_array'}->[$i]\";\n";
			@{$self->{'ginfo_array'}} = $self->my_getgrnam($self->{'ul_array'}->[$i]);
			if (@{$self->{'ginfo_array'}}) {
				@{$self->{'mems_array'}} = $self->unique( split(/ /, $self->{'ginfo_array'}->[3]),
						 @{$self->{'members_hash'}->{$self->{'ginfo_array'}->[2]}} );
				if (@{$self->{'mems_array'}} > 3) { @{$self->{'mems_array'}} = (@{$self->{'mems_array'}}[0..1], "..."); }
				print "selr[$i] = \"",join(' ', @{$self->{'mems_array'}}),"\";\n";
				}
			else { print "selr[$i] = \"???\";\n"; }
			}
		print "</script>\n";
		print "<title>$self->{'text_hash'}->{'groups_title1'}</title>\n";
		print "<frameset cols='50%,50%'>\n";
		print "<frame src=\"my_group_chooser.cgi?frame=1&multi=1\">\n";
		print "<frameset rows='*,50' frameborder=no>\n";
		print " <frame src=\"my_group_chooser.cgi?frame=2&multi=1\">\n";
		print " <frame src=\"my_group_chooser.cgi?frame=3&multi=1\" scrolling=no>\n";
		print "</frameset>\n";
		print "</frameset>\n";
		}
	elsif ($self->{'in_hash'}->{'frame'} == 1) {
		# list of all groups to choose from
		$self->popup_header();
		print "<script>\n";
		print "function addgroup(u, r)\n";
		print "{\n";
		print "top.sel[top.sel.length] = u\n";
		print "top.selr[top.selr.length] = r\n";
		print "top.frames[1].location = top.frames[1].location\n";
		print "return false;\n";
		print "}\n";
		print "</script>\n";
		print "<font size=+1>$self->{'text_hash'}->{'groups_all'}</font>\n";
		print "<table width=100%>\n";
		foreach $u (&get_groups_list()) {
			if ($self->{'in_hash'}->{'group'} eq $u->[0]) { print "<tr $self->{'cb'}>\n"; }
			else { print "<tr>\n"; }
			print "<td width=20%><a href=\"\" onClick='return addgroup(\"$u->[0]\", \"$u->[3]\")'>$u->[0]</a></td>\n";
			print "<td>$u->[3]</td> </tr>\n";
			}
		print "</table>\n";
		$self->popup_footer();
		}
	elsif ($self->{'in_hash'}->{'frame'} == 2) {
		# show chosen groups
		$self->popup_header();
		print "<font size=+1>$self->{'text_hash'}->{'groups_sel'}</font>\n";
		print <<'EOF';
<table width=100%>
<script>
function sub(j)
{
sel2 = new Array(); selr2 = new Array();
for(k=0,l=0; k<top.sel.length; k++) {
	if (k != j) {
		sel2[l] = top.sel[k];
		selr2[l] = top.selr[k];
		l++;
		}
	}
top.sel = sel2; top.selr = selr2;
location = location;
return false;
}
for(i=0; i<top.sel.length; i++) {
	document.write("<tr>\n");
	document.write("<td><a href=\"\" onClick='return sub("+i+")'>"+top.sel[i]+"</a></td>\n");
	document.write("<td>"+top.selr[i]+"</td>\n");
	}
</script>
</table>
EOF
		$self->popup_footer();
		}
	elsif ($self->{'in_hash'}->{'frame'} == 3) {
		# output OK and Cancel buttons
		$self->popup_header();
		print "<script>\n";
		print "function qjoin(l)\n";
		print "{\n";
		print "rv = \"\";\n";
		print "for(i=0; i<l.length; i++) {\n";
		print "    if (rv != '') rv += ' ';\n";
		print "    if (l[i].indexOf(' ') < 0) rv += l[i];\n";
		print "    else rv += '\"'+l[i]+'\"'\n";
		print "    }\n";
		print "return rv;\n";
		print "}\n";
		print "</script>\n";
		print "<form>\n";
		print "<input type=button value=\"$self->{'text_hash'}->{'groups_ok'}\" ",
		      " onClick='top.opener.ifield.value = qjoin(top.sel); ",
		      "top.close()'>\n";
		print "<input type=button value=\"$self->{'text_hash'}->{'groups_cancel'}\" ",
		      "onClick='top.close()'>\n";
		print "&nbsp;&nbsp;<input type=button value=\"$self->{'text_hash'}->{'groups_clear'}\" onClick='top.sel = new Array(); top.selr = new Array(); top.frames[1].location = top.frames[1].location'>\n";
		print "</form>\n";
		$self->popup_footer();
		}
	}
else {
	# selecting just one group .. display a list of all groups to choose from
	$self->popup_header($self->{'text_hash'}->{'groups_title2'});
	print "<script>\n";
	print "function select(f)\n";
	print "{\n";
	print "top.opener.ifield.value = f;\n";
	print "top.close();\n";
	print "return false;\n";
	print "}\n";
	print "</script>\n";
	print "<table width=100%>\n";
	foreach $u (&get_groups_list()) {
		if ($self->{'in_hash'}->{'group'} eq $u->[0]) { print "<tr $self->{'cb'}>\n"; }
		else { print "<tr>\n"; }
		print "<td width=20%><a href=\"\" onClick='return select(\"$u->[0]\")'>$u->[0]</a></td>\n";
		print "<td>$u->[3]</td> </tr>\n";
		}
	print "</table>\n";
	$self->popup_footer();
	}

1;
		
}

sub get_groups_list
{
	shift if ($self == $_[0]);

local(@ginfo, @groups, %gcan);
if ($self->{'access_hash'}->{'gedit_mode'} == 2 || $self->{'access_hash'}->{'gedit_mode'} == 3) {
	map { $gcan{$_}++ } split(/\s+/, $self->{'access_hash'}->{'gedit'});
	}
$self->my_setgrent();
while(@ginfo = $self->my_getgrent()) {
	@{$self->{'mems_array'}} = $self->unique( split(/ /, $ginfo[3]), @{$self->{'members_hash'}->{$ginfo[2]}} );
	if (@{$self->{'mems_array'}} > 3) { @{$self->{'mems_array'}} = (@{$self->{'mems_array'}}[0..1], "..."); }
	$ginfo[3] = join(' ', @{$self->{'mems_array'}});
	if ($self->{'access_hash'}->{'gedit_mode'} == 0 ||
	    $self->{'access_hash'}->{'gedit_mode'} == 2 && $gcan{$ginfo[0]} ||
	    $self->{'access_hash'}->{'gedit_mode'} == 3 && !$gcan{$ginfo[0]} ||
	    $self->{'access_hash'}->{'gedit_mode'} == 4 &&
		(!$self->{'access_hash'}->{'gedit'} || $ginfo[2] >= $self->{'access_hash'}->{'gedit'}) &&
		(!$self->{'access_hash'}->{'gedit2'} || $ginfo[2] <= $self->{'access_hash'}->{'gedit2'})) {
		push(@groups, [ @ginfo ]);
		}
	}
$self->my_endgrent();
return sort { $a->[0] cmp $b->[0] } @groups;
}


1;

