#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_afile.cgi
# Display the contents of an address file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'afile_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'afile_title'}, "");

$self->switch_to_domain_user($self->{'d'});
if (-e $self->{'in_hash'}->{'file'}) {
	open(FILE, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->text('afile_eread', $self->{'in_hash'}->{'file'}, $self->{'d'}->{'user'}, $!));
	@{$self->{'lines_array'}} = <FILE>;
	close(FILE);
	}

print "<b>",$self->text('afile_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"</b><p>\n";

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
print "<form action=save_afile.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=$self->{'what'} value=\"",$self->{'in_hash'}->{$self->{'what'}},"\">\n";
print "<input type=hidden name=dom value=\"$self->{'in_hash'}->{'dom'}\">\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'afile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_$self->{'what'}.cgi?dom=$self->{'in_hash'}->{'dom'}&$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}",
	$self->{'text_hash'}->{$self->{'what'}.'_return'});

1;
		
}


1;

