#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display all custom fields for domains

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newfields_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'newfields_title'}, "");

print "$self->{'text_hash'}->{'newfields_descr'}<p>\n";

@{$self->{'fields_array'}} = $self->list_custom_fields();
print $self->ui_form_start("save_newfields.cgi", "post");
print $self->ui_columns_start([ $self->{'text_hash'}->{'newfields_name'},
			  $self->{'text_hash'}->{'newfields_desc'},
			  $self->{'text_hash'}->{'newfields_type'} ]);
$self->{'i'} = 0;
foreach $f (@{$self->{'fields_array'}}, { }, { }) {
	print $self->ui_columns_row([
		$self->ui_textbox("name_$self->{'i'}", $f->{'name'}, 15),
		$self->ui_textbox("desc_$self->{'i'}", $f->{'desc'}, 45),
		$self->ui_select("type_$self->{'i'}", $f->{'type'},
			   [ map { [ $_, $self->{'text_hash'}->{'newfields_type'.$_} ] } (0 .. 10) ]).
		$self->ui_textbox("opts_$self->{'i'}", $f->{'opts'}, 25)
			]);
	$self->{'i'}++;	
	}
close(FIELDS);
print $self->ui_columns_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

