#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display currently enabled plugin modules

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newplugin_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'newplugin_title'}, "");

print "<form action=save_newplugin.cgi method=post>\n";
print "$self->{'text_hash'}->{'newplugin_desc'}<p>\n";
print "<table>\n";

# Show active plugins
%{$self->{'plugins_hash'}} = map { $_, 1 } @{$self->{'plugins_array'}};
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newplugin_mods'}</b></td>\n";
print "<td><select name=mods size=10 multiple width=400>\n";
foreach $m (sort { $a->{'desc'} cmp $b->{'desc'} } $self->get_all_module_infos()) {
	$self->{'mdir'} = $self->UNIVERSAL::can('module_root_directory') ?
			$self->module_root_directory($m->{'dir'}) :
			"$self->{'root_directory'}/$m->{'dir'}";
	if (-r "$self->{'mdir'}/virtual_feature.pl") {
		$self->foreign_require($m->{'dir'}, "virtual_feature.pl");
		printf "<option value=%s %s>%s (%s)\n",
			$m->{'dir'}, $self->{'plugins_hash'}->{$m->{'dir'}} ? "selected" : "",
			$self->plugin_call($m->{'dir'}, "feature_name"),
			$m->{'desc'};
		push(@{$self->{'allplugins_array'}}, $m->{'dir'});
		if (-r "$self->{'mdir'}/config.info") {
			push(@{$self->{'confplugins_array'}}, $m);
			}
		}
	}
print "</select></td> </tr>\n";

print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

# Show links to configure plugins
if (@{$self->{'confplugins_array'}}) {
	print "<hr>\n";
	print "<form action=edit_plugconfig.cgi>\n";
	print "$self->{'text_hash'}->{'newplugin_configdesc'}<p>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'newplugin_config'}'>\n";
	print "<select name=mod>\n";
	foreach $m (@{$self->{'confplugins_array'}}) {
		printf "<option value=%s>%s (%s)\n",
			$m->{'dir'}, 
			$self->plugin_call($m->{'dir'}, "feature_name"),
			$m->{'desc'};
		}
	print "</select>\n";
	print "</form>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

