#!/usr/bin/perl

&MAIN();

 sub MAIN {
# enable_domain.cgi
# Undo the disabling of a domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'d'}->{'disabled'} || $self->error($self->{'text_hash'}->{'enable_ealready'});
$self->{'subh'} = $self->domain_in($self->{'d'});
if ($self->{'in_hash'}->{'confirm'}) {
	$self->ui_print_unbuffered_header($self->{'subh'}, $self->text('enable_title1', $self->{'t_website'}), "" ,undef,0,1);
	#$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'enable_title'}, "");
	}
else {
	#$self->ui_print_header(undef, $self->{'text_hash'}->{'enable_title'}, "");
	$self->ui_print_header($self->{'subh'}, $self->text('enable_title', $self->{'t_website'}), "" ,undef,0,1);
	}

# Work out what can be enabled
@{$self->{'disabled_array'}} = split(/,/, $self->{'d'}->{'disabled'});
%{$self->{'disabled_hash'}} = map { $_, 1 } @{$self->{'disabled_array'}};
@{$self->{'enable_array'}} = grep { $self->{'d'}->{$_} && ($self->{'config_hash'}->{$_} || $_ eq 'unix') } @{$self->{'disabled_array'}};
push(@{$self->{'enable_array'}}, "ssl") if ($self->indexof("web", @{$self->{'enable_array'}}) >= 0 && $self->{'d'}->{'ssl'});
@{$self->{'enable_array'}} = grep { $_ ne "unix" } @{$self->{'enable_array'}} if ($self->{'d'}->{'parent'});
push(@{$self->{'enable_array'}}, grep { $self->{'d'}->{$_} && $self->{'disabled_hash'}->{$_} &&
		     $self->plugin_defined($_, "feature_enable") } @{$self->{'feature_plugins_array'}});

if (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure
	@{$self->{'distext_array'}} = map { $self->{'text_hash'}->{"disable_f".$_} ||
			 $self->plugin_call($_, "feature_disname") } @{$self->{'enable_array'}};
	if (@{$self->{'distext_array'}} == 1) {
		$self->{'distext'} = $self->{'distext_array'}->[0];
		}
	elsif (@{$self->{'distext_array'}} == 2) {
		$self->{'distext'} = $self->text('disable_and', $self->{'distext_array'}->[0], $self->{'distext_array'}->[1]);
		}
	else {
		$self->{'dislast'} = pop(@{$self->{'distext_array'}});
		$self->{'distext'} = $self->text('disable_and', join(", ", @{$self->{'distext_array'}}), $self->{'dislast'});
		}

	print $self->check_clicks_function();
	print "<p>",$self->text('enable_rusure2', "<tt>$self->{'d'}->{'dom'}</tt>",
			  $self->{'distext'}),"<p>\n";
	print "<center><form action=enable_domain.cgi>\n";
	print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$self->{'text_hash'}->{'enable_ok'}' onClick='check_clicks(form)'>\n";
	print "</form></center>\n";
	}
else {
	# Go ahead and do it
	%{$self->{'enable_hash'}} = map { $_, 1 } @{$self->{'enable_array'}};

	# Run the before command
	$self->set_domain_envs($self->{'d'}, "ENABLE_DOMAIN");
	$self->{'merr'} = $self->making_changes();
	$self->error($self->text('enable_emaking', "<tt>$self->{'merr'}</tt>")) if (defined($self->{'merr'}));

	# Enable all disabled features
	local $f;
	foreach $f (@{$self->{'features_array'}}) {
		if ($self->{'d'}->{$f} && $self->{'enable_hash'}->{$f}) {
			local $efunc = "enable_$f";
			$self->try_function($f, $efunc, $self->{'d'});
			}
		}
	foreach $f (@{$self->{'feature_plugins_array'}}) {
		if ($self->{'d'}->{$f} && $self->{'enable_hash'}->{$f}) {
			$self->plugin_call($f, "feature_enable", $self->{'d'});
			}
		}

	# Save new domain details
	print $self->{'text_hash'}->{'save_domain'},"<br>\n";
	delete($self->{'d'}->{'disabled'});
	delete($self->{'d'}->{'disabled_reason'});
	$self->save_domain($self->{'d'});
	print $self->{'text_hash'}->{'setup_done'},"<p>\n";

	# Run the after command
	$self->run_post_actions();
	$self->set_domain_envs($self->{'d'}, "ENABLE_DOMAIN");
	$self->made_changes();
	$self->webmin_log("enable", "domain", $self->{'d'}->{'dom'}, $self->{'d'});
	}

#$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
#	"", $self->{'text_hash'}->{'index_return'});

		$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );
1;
		
}


1;

