#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a table of icons for different types of webmin configuration

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;


$self->ui_print_header(undef, $self->{'text_hash'}->{'config_title'}, "", undef, undef, 1, 0);

%{$self->{'access_hash'}} = $self->get_module_acl();

local (@s_wlinks, @s_wtitles, @s_wicons);
foreach my $s ('1', '2', '4.6', '6') {
	push(@s_wlinks, "/config.cgi?virtual_server&conf_file=config_websites.info&ln=$s&title=config_s_$s");
	push(@s_wtitles, $self->{'text_hash'}->{"config_s_$s"});
	push(@s_wicons, "images/config_s_$s.gif");
}

print $self->ui_subheading($self->{'text_hash'}->{'subheader_1'});
$self->icons_table(\@s_wlinks, \@s_wtitles, \@s_wicons);

# Advanced configuration
local (@adv_wlinks, @adv_wtitles, @adv_wicons);
# Website template details
push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=1");
push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_1'});
push(@adv_wicons, "images/tmpl_title_1.gif");
# Networking
push(@adv_wlinks, "/config.cgi?virtual_server&conf_file=config_websites.info&ln=1.5&title=config_s_1.5&mode=2");
push(@adv_wtitles, $self->{'text_hash'}->{"config_s_1.5"});
push(@adv_wicons, "images/config_s_1.5.gif");
# Templates
push(@adv_wlinks, "/config.cgi?virtual_server&conf_file=config_websites.info&ln=4&title=config_s_4&mode=2");
push(@adv_wtitles, $self->{'text_hash'}->{"config_s_4"});
push(@adv_wicons, "images/config_s_4.gif");
# Settings for new websites
if ($self->{'config_hash'}->{'web'}) {
	push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=3");
	push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_3'});
	push(@adv_wicons, "images/tmpl_title_3.gif");
}
# DNS records
if ($self->{'config_hash'}->{'dns'}) {
	push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=4");
	push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_4'});
	push(@adv_wicons, "images/tmpl_title_4.gif");
}
# FTP virtual host
if ($self->{'config_hash'}->{'ftp'}) {
	local $num = $self->{'config_hash'}->{'ftp_system'} == 2 ? 9 : 5;
	push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=$num");
	push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_' . $num});
	push(@adv_wicons, "images/tmpl_title_5.gif");
}
# 
push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=7");
push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_7'});
push(@adv_wicons, "images/tmpl_title_7.gif");
# 
if ($self->{'config_hash'}->{'mysql'} || $self->{'config_hash'}->{'postgres'}) {
    push(@adv_wlinks, "edit_tmpl.cgi?tmpl_mode=8");
    push(@adv_wtitles, $self->{'text_hash'}->{'tmpl_title_8'});
    push(@adv_wicons, "images/tmpl_title_8.gif");
    }

print $self->ui_subheading($self->{'text_hash'}->{'subheader_2'});
$self->icons_table(\@adv_wlinks, \@adv_wtitles, \@adv_wicons);
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

