#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_users.cgi
# List mailbox users in some domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'users_ecannot'});
#@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'}, 0, 1);
@{$self->{'users_array'}} = $self->list_domain_users($self->{'d'});
$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'users_title'}, "", undef, undef, 1);

($self->{'mcount'}, $self->{'mmax'}, $self->{'mdoms'}) = $self->count_mailboxes($self->{'d'});
$self->{'show_users_add'} = (!defined($self->{'mmax'}) || $self->{'mcount'} <= $self->{'mmax'});
$self->{'pfx'} = "2" if ($self->{'mdoms'} > 1);

if (defined($self->{'mmax'})) {
	print "<p><b>",$self->text(
		$self->{'show_users_add'} ? 'users_limit2'.$self->{'pfx'}
				: 'users_nomore'.$self->{'pfx'},
		$self->{'mmax'}, $self->{'mmax'} - $self->{'mcount'} + 1),"</b><p>\n";
	}
if ($self->{'show_users_add'}) {
	print "<a href=edit_user.cgi?new=1&type=mail&dom=$self->{'in_hash'}->{'dom'}><img width=24 height=24 src=images/addmail.gif border=0>&nbsp;$self->{'text_hash'}->{'label_add_mail_user'}</a><br>\n" if ($self->{'config_hash'}->{'mail'} && $self->{'d'}->{'mail'});
	print "<a href=edit_user.cgi?new=1&type=ftp&dom=$self->{'in_hash'}->{'dom'}><img width=24 height=24 src=images/addftp.gif border=0>&nbsp;$self->{'text_hash'}->{'label_add_ftp_user'}</a><br>\n" if ($self->{'config_hash'}->{'ftp'} || $self->{'d'}->{'web'});
	print "<a href=edit_user.cgi?new=1&type=samba&dom=$self->{'in_hash'}->{'dom'}><img width=24 height=24 src=images/addsamba.gif border=0>&nbsp;$self->{'text_hash'}->{'label_add_samba_user'}</a><br>\n" if ($self->{'config_hash'}->{'samba'} && $self->{'d'}->{'samba'});
	}

if (@{$self->{'users_array'}}) {
	$self->users_table(\@{$self->{'users_array'}}, $self->{'d'});
	}
else {
	print "<b>$self->{'text_hash'}->{'users_none'}</b><p>\n";
	}

if ($self->{'single_domain_mode'}) {
	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->text('index_return2', $self->{'t_website'}));
	}
else {
	$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );
	}

1;
		
}


1;

