#!/usr/bin/perl

&MAIN();

 sub MAIN {
# rename_form.cgi
# Display server rename form

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'norename'} && $self->error($self->{'text_hash'}->{'rename_ecannot'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
local ($ruser_level, $ruser_domain) = $self->ztl_get_access_level($self->{'remote_user'});
$self->error($self->{'text_hash'}->{'edit_ecannotsub'}) if ($ruser_level == 1 && !$self->{'d'}->{'parent'});
$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'rename_title'}, "");

#local $website = &ztl_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');
print ($self->text('rename_desc', $self->{'t_website'}, $self->{'t_website'}), "<p>\n");

#print "$self->{'text_hash'}->{'rename_desc'}<p>\n";

print "<form action=rename.cgi method=post>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'rename_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Old and new domain name
print "<tr> <td><b>$self->{'text_hash'}->{'rename_domain'}</b></td>\n";
print "<td><tt>$self->{'d'}->{'dom'}</tt></td> </tr>\n";

local ($new_name, $parent_name) = $self->{'d'}->{'dom'};
if ($ruser_level == 1 && $self->{'d'}->{'parent'}) {
    $self->{'dparent'} = $self->get_domain($self->{'d'}->{'parent'});
    $parent_name = $self->{'dparent'}->{'dom'};
    $new_name =~ s/\.$parent_name$//;
    print "<input type=hidden name=parent value='.$parent_name'>\n";
}

print "<tr> <td><b>$self->{'text_hash'}->{'rename_new'}</b></td>\n";
printf "<td><input name=new size=30 value='%s'>%s</td> </tr>\n", $new_name, $parent_name ? ".$parent_name" : "";

if ($self->{'d'}->{'unix'} && $self->master_admin()) {
	# Rename user option
	print "<tr> <td><b>$self->{'text_hash'}->{'rename_user'}</b></td> <td>\n";
	print "<input type=radio name=user_mode value=0 checked> ",
	      $self->text('rename_user0', "<tt><b>$self->{'d'}->{'user'}</b></tt>"),"\n";
# 	print "<input type=radio name=user_mode value=1 checked> ",
# 	      "$self->{'text_hash'}->{'rename_user1'}\n";
	print "<input type=radio name=user_mode value=2> ",
	      "$self->{'text_hash'}->{'rename_user2'}\n";
	print $self->unix_user_input("user"),"</td> </tr>\n";
	}

# if ($self->{'d'}->{'dir'}) {
# 	# Change home dir option
# 	print "<tr> <td><b>$self->{'text_hash'}->{'rename_home'}</b></td> <td>\n";
# 	print "<input type=radio name=home_mode value=0> ",
# 	      $self->text('rename_home0', "<tt>$self->{'d'}->{'home'}</tt>"),"\n";
# 	print "<input type=radio name=home_mode value=1 checked> ",
# 	      "$self->{'text_hash'}->{'rename_home1'}\n";
# 	print "</td> </tr>\n";
# 	}
# else {
# 	# Always change home, since there is none!
# 	print "<input type=hidden name=home_mode value=1>\n";
# 	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'rename_ok'}'></form>\n";

#$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'});

	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",  $self->text('index_return', $self->{'t_website'}),"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->text('edit_return', $self->{'t_website'}) );
1;
		
}


1;

