#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for restoring a single virtual server, or a bunch

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'restore_ecannot'});
#$self->ui_print_header(undef, $self->{'text_hash'}->{'restore_title'}, "");
$self->ui_print_header(undef, $self->text('restore_title' ,$self->{'t_websites_mail'}), "",undef, 0, 1);
$self->ReadParse();

print "<form action=restore.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'restore_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

#foreach (keys (%{$self->{'config_hash'}}))
#{print ("$_ = ", $self->{'config_hash'}->{$_},"<BR>") };

# Get source
$self->{'dest'} = $self->{'config_hash'}->{'backup_dest'};
if (defined($self->{'in_hash'}->{'dom'})) {
	$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
	if ($self->{'d'}->{'backup_dest'}) {
		$self->{'dest'} = $self->{'d'}->{'backup_dest'};
		}
	elsif ($self->{'config_hash'}->{'backup_fmt'} == 0 && $self->{'dest'}) {
		$self->{'dest'} .= "/$self->{'d'}->{'dom'}.tar.gz";
		}
	}

# Show source file field
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'restore_src'}</td>\n";
print "<td>",$self->show_backup_destination("src", $self->{'dest'}),"</td> </tr>\n";

# Show feature selection boxes
#print "<tr> <td valign=top><b>$self->{'text_hash'}->{'restore_features'}</td> <td>\n";
foreach $f (@{$self->{'backup_features_array'}}) {
	$self->{'bfunc'} = "restore_$f";
	if ($self->UNIVERSAL::can($self->{'bfunc'}) &&
	    ($self->{'config_hash'}->{$f} || $f eq "unix" || $f eq "virtualmin")) {
		#printf "<input type=checkbox name=feature value=%s %s> %s\n",
		#	$f, $self->{'config_hash'}->{'backup_feature_'.$f} ? "checked" : "",
		#	$self->{'text_hash'}->{'backup_feature_'.$f} || $self->{'text_hash'}->{'feature_'.$f};

	        printf "<input type=hidden name=feature value=%s>\n", $self->{'config_hash'}->{'backup_feature_'.$f} ? $f : '';
		$self->{'ofunc'} = "show_restore_$f";

		if ($self->UNIVERSAL::can($self->{'ofunc'})) { #print ("AAA=", &show_restore_web()," \n");
			local %opts = map { split(/=/, $_) }
					split(/,/, $self->{'config_hash'}->{'backup_opts_'.$f});

			if ($f eq 'web') {
				print "<input type=hidden name=web_fixip value=1>\n" #if $opts{'fixip'};
				#$opts{'fixip'}
			}
			elsif ($f eq 'mail') {
				print "<input type=hidden name=mail_mailfiles value=1>\n" #if $opts{'mailfiles'};
			}
			elsif ($f eq 'dns') {
				print "<input type=hidden name=dns_fixip value=1>\n" #if $opts{'fixip'};
			}
			elsif ($f eq 'ssl') {
				print "<input type=hidden name=ssl_fixip value=1>\n" #if $opts{'fixip'};
			}
			elsif ($f eq 'dir') {
				print "<input type=hidden name=dir_chown value=1>\n"# if $opts{'chown'};
			}
			else {
				print "DEVELOPMENT ERROR: you should see sub $self->{'ofunc'} for website feature $f<br>\n";
			}

			#local $ohtml = &$self->{'ofunc'}(\%opts);
		#	print $ohtml;
			}
		#print "<br>\n";
		}
 	}
#print "</td> </tr>\n";

# Creation options
#print "<tr> <td valign=top><b>$self->{'text_hash'}->{'restore_reuid'}</td>\n";
#print "<td>",&ui_radio("reuid", 1, [ [ 1, $self->{'text_hash'}->{'yes'} ],
#				     [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "</table></td></tr></table>\n";
#print "<input type=submit value='$self->{'text_hash'}->{'restore_now'}'></form>\n";
print ("<input type=submit value='",$self->html_escape($self->text('restore_now' ,$self->{'t_websites_mail'})),"'></form>\n");

#$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'},"",$self->text('index_return', $self->{'t_website'}));
1;
		
}


1;

