#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_afile.cgi
# Save an addresses file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParseMime();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'afile_ecannot'});

$self->switch_to_domain_user($self->{'d'});
$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->{'in_hash'}->{'text'} =~ s/\n*$/\n/;
$self->lock_file($self->{'in_hash'}->{'file'});
open(FILE, ">$self->{'in_hash'}->{'file'}") ||
	$self->error($self->text('afile_ewrite', $self->{'in_hash'}->{'file'}, $self->{'dom'}->{'user'}, $!));
print FILE $self->{'in_hash'}->{'text'};
close(FILE);
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->webmin_log("save", "afile", $self->{'in_hash'}->{'file'});

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
$self->redirect("edit_$self->{'what'}.cgi?$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}&dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

