#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search.cgi
# Display domains matching some search

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();

# If search is by parent, look it up
$self->{'oldwhat'} = $self->{'in_hash'}->{'what'};
if (($self->{'in_hash'}->{'field'} eq "parent" || $self->{'in_hash'}->{'field'} eq "alias") &&
    $self->{'in_hash'}->{'what'} !~ /^\d+$/) {
	$self->{'pd'} = $self->get_domain_by("dom", $self->{'in_hash'}->{'what'});
	$self->{'in_hash'}->{'what'} = $self->{'pd'}->{'id'} if ($self->{'pd'});
	}

# Do the search
foreach $d ($self->list_domains()) {
	next if (!$self->can_edit_domain($d));
	if ($d->{$self->{'in_hash'}->{'field'}} =~ /\Q$self->{'in_hash'}->{'what'}\E/i) {
		push(@{$self->{'doms_array'}}, $d);
		}
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'search_title'}, "");

if (!@{$self->{'doms_array'}}) {
	print "<b>",$self->text('search_none', "<tt>$self->{'oldwhat'}</tt>"),"</b><p>\n";
	}
else {
	print "<b>",$self->text('search_results', "<tt>$self->{'oldwhat'}</tt>",
			  scalar(@{$self->{'doms_array'}})),"</b><p>\n";
	$self->domains_table(\@{$self->{'doms_array'}});
	print "<p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

