#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start_bind.cgi
# Start bind 8

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'stop'} || $self->error($self->{'text_hash'}->{'start_ecannot'});
$self->require_bind();
if ($self->{'bconfig_hash'}->{'named_user'}) {
	$self->{'user'} = "-u $self->{'bconfig_hash'}->{'named_user'}";
	if ($self->{'config_hash'}->{'named_group'}) {
		$self->{'user'} .= " -g $self->{'bconfig_hash'}->{'named_group'}";
		}
	else {
		local @u = getpwnam($self->{'bconfig_hash'}->{'named_user'});
		local @g = getgrgid($u[3]);
		$self->{'user'} .= " -g $g[0]";
		}
	}
if ($self->{'bconfig_hash'}->{'start_cmd'}) {
	$self->{'cmd'} = $self->{'bconfig_hash'}->{'start_cmd'};
	}
elsif (!$self->{'bconfig_hash'}->{'chroot'}) {
	$self->{'cmd'} = "$self->{'bconfig_hash'}->{'named_path'} -c $self->{'bconfig_hash'}->{'named_conf'} $self->{'user'} </dev/null 2>&1";
	}
elsif (`$self->{'bconfig_hash'}->{'named_path'} -help 2>&1` =~ /\[-t/) {
	# use named's chroot option
	$self->{'cmd'} = "$self->{'bconfig_hash'}->{'named_path'} -c $self->{'bconfig_hash'}->{'named_conf'} -t $self->{'bconfig_hash'}->{'chroot'} $self->{'user'} </dev/null 2>&1";
	}
else {
	# use the chroot command
	$self->{'cmd'} = "chroot $self->{'bconfig_hash'}->{'chroot'} $self->{'bconfig_hash'}->{'named_path'} -c $self->{'bconfig_hash'}->{'named_conf'} $self->{'user'} </dev/null 2>&1";
	}

$self->{'temp'} = $self->tempname();
$self->{'rv'} = $self->system_logged("$self->{'cmd'} </dev/null >$self->{'temp'} 2>&1");
$self->{'out'} = `cat $self->{'temp'}`;
unlink($self->{'temp'});
if ($self->{'rv'} || $self->{'out'} =~ /chroot.*not available/i) {
	$self->error($main::bind8_object->text('start_error', "<tt>$self->{'out'}</tt>"));
	}
$self->webmin_log("start", "dns");
$self->redirect("");

1;
		
}


1;

