#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display the webalizer report for some domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->require_webalizer();
$self->ReadParse();

$ENV{'PATH_INFO'} =~ /^\/([^\/]+)(\/.*)$/ ||
	$self->error($main::webalizer_object->{'text_hash'}->{'view_epath'});
$self->{'did'} = $1;
$self->{'file'} = $2;
$self->{'d'} = $self->get_domain($self->{'did'});
$self->{'log'} = $self->get_apache_log($self->{'d'}->{'dom'}, $self->{'d'}->{'web_port'});
$self->{'file'} =~ /\.\./ || $self->{'file'} =~ /\<|\>|\||\0/ &&
	$self->error($main::webalizer_object->{'text_hash'}->{'view_efile'});

$self->{'lconf'} = $main::webalizer_object->get_log_config($self->{'log'}) ||
	$self->error($main::webalizer_object->{'text_hash'}->{'view_elog'}." : $self->{'log'}");
$self->{'full'} = "$self->{'lconf'}->{'dir'}$self->{'file'}";
open(FILE, $self->{'full'}) || $self->error($main::webalizer_object->{'text_hash'}->{'view_eopen'}." : $self->{'full'}");

# Display file contents
if ($self->{'full'} =~ /\.(html|htm)$/i) {
	while(read(FILE, $self->{'buf'}, 1024)) {
		$self->{'data'} .= $self->{'buf'};
		}
	close(FILE);
	$self->{'data'} =~ /<TITLE>(.*)<\/TITLE>/i;
	$self->{'title'} = $1;
	$self->{'data'} =~ s/^[\000-\377]*<BODY.*>//i;
	$self->{'data'} =~ s/<\/BODY>[\000-\377]*$//i;

	$self->ui_print_header(undef, $self->{'title'} || $self->{'text_hash'}->{'view_title'}, "");
	print $self->{'data'};
	$self->ui_print_footer("/$self->{'module_name'}/edit_domain.cgi?dom=$self->{'d'}->{'id'}",
			 $self->{'text_hash'}->{'edit_return'},
			 "/$self->{'module_name'}/", $self->{'text_hash'}->{'index_return'});
	}
else {
	print "Content-type: ",$self->{'full'} =~ /\.png$/i ? "image/png" :
			       $self->{'full'} =~ /\.gif$/i ? "image/gif" :
			       $self->{'full'} =~ /\.(jpg|jpeg)$/i ? "image/jpeg" :
			       $self->{'full'} =~ /\.(html|htm)$/i ? "text/html" :
							   "text/plain","\n";
	print "\n";
	while(read(FILE, $self->{'buf'}, 1024)) {
		print $self->{'buf'};
		}
	close(FILE);
	}

1;
		
}


1;

