#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete.cgi
# delete VsFTPd virtual server

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

$self->ReadParse();

# ACL error
$self->error($self->{'text_hash'}->{'virt_edelete'}) unless ($self->{'access_hash'}->{'daemon'});

# get virtual server file
local ($file) = $self->get_server_conf($self->{'in_hash'}->{'idx'});
$file = "$self->{'config_hash'}->{'vsftpd_dir'}/$file";
if (-e $file) 
{
 # delete the vsftpd virtual server config
 $self->unlink_logged($file);
	
 # restart daemon vsftpd
 $self->restart_vsftpd() if $self->status_vsftpd();
}

# redirect to index.cgi
$self->redirect("index.cgi");
1;
		
}


1;

