#!/usr/bin/perl

&MAIN();

 sub MAIN {
# options.cgi
# display vsftpd options form

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

# get section & idx
local $section = $self->{'in_hash'}->{'section'};
local $idx = $self->{'in_hash'}->{'idx'};

# ACL error
$self->error($self->{'text_hash'}->{'section_ecannot'}) if ($self->{'access_hash'}->{$section.'_dis'});

# get virtual server configuration
local ($file,$name,$conf) = $self->get_server_conf($self->{'in_hash'}->{'idx'});
$self->error($self->text('virt_ecannot',$self->{'in_hash'}->{'idx'})) unless ($file);

# print header
$self->ui_print_header($self->text('index_defdesc',"$name"), $self->{'text_hash'}->{"index_$section"}, undef, undef, 1, 1);

# print options form
print "<FORM method=post action=save_options.cgi>\n";
print "<INPUT type=hidden name=idx value=$idx>\n";
print "<INPUT type=hidden name=section value=$section>\n";
print "<TABLE width=100% cellpadding=5><TR>\n";
print "<TR bgcolor=#00308B class='thfontcolor'>\n";
local $index = 'index_'.$section;
print "<TD colspan=2><b>$self->{'text_hash'}->{$index}</b></TD></TR>\n";

# get options list for section & installed version
local $options = $self->get_option_list($section);

# print options
foreach (@{$options})
{
 unless ($self->{'access_hash'}->{$_->[0].'_dis'})
 {
  print "<TR><TD $self->{'cb'} width=20% nowrap>",$self->hlink("<b>$self->{'text_hash'}->{$_->[1]} &nbsp;</b>","opt_".$_->[1]),"</TD><TD $self->{'cb'} 80%>\n";
  local ($value,$check);
  if (exists ($conf->{$_->[0]}))
  {
   $value = $self->get_config_value($_->[0],$conf);
   $check = 1;  
  }
  if ($_->[2])
  {
   print $self->choice_input($_->[0],$value);
  }
  else
  {
   print $self->text_input($_->[0],$value,$check);
  }
  print "</TD></TR>\n";
 }
}
print "</TABLE>\n";
print "<INPUT type=submit value=\"$self->{'text_hash'}->{'save'}\"></FORM>\n";
		      
# print back URL
$self->ui_print_footer("virt.cgi?idx=$idx", $self->{'text_hash'}->{'index_return'}, "", $self->{'text_hash'}->{'index_main'});
1;
		
}


1;

