#!/usr/bin/perl

&MAIN();

 sub MAIN {
# virt.cgi
# display the icons or list for various types of vsftpd config options

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

$self->ReadParse();

local ($file,$name,$conf,$mode) = $self->get_server_conf($self->{'in_hash'}->{'idx'});

# ACL error
$self->error($self->text('virt_ecannot',$self->{'in_hash'}->{'idx'})) unless ($file);

# print header
$self->ui_print_header($self->text('index_defdesc',"$name"),$self->{'text_hash'}->{'index_virtual'}, undef, undef,1, 1);

# get section list for installed version
local $section = $self->get_section_list();

# print section icons
print "<TABLE width=100% cellpadding=5><TR>\n";
local $i;
foreach (@{$section})
{
 unless ($self->{'access_hash'}->{$_->[0].'_dis'})
 {
  print "<TD width=20% valign=top align=center nowrap>\n";
  $self->generate_icon("images/$_->[1]",$self->{'text_hash'}->{"index_$_->[0]"},"options.cgi?idx=$self->{'in_hash'}->{'idx'}&section=$_->[0]",undef, undef, undef,undef);
  print "</TD>\n";
  $i++;
  if ($i == 5)
  {
   print "</TR><TR>\n";
   $i = 0;
  }
 }
}
print "</TABLE>\n";
 
if ($self->{'access_hash'}->{'daemon'} && ($name ne 'default'))
{
 # print delete virtual server submit
 print $self->ui_table_start();
 print $self->ui_form_start('delete.cgi','post')."\n";
 print "<TR><TD>".$self->ui_hidden('idx', $self->{'in_hash'}->{'idx'})."\n";
 print $self->ui_submit($self->{'text_hash'}->{'index_delete'})."</TD></TR>\n";
 print $self->ui_form_end();
 print $self->ui_table_end();
}

if ($mode)
{
 # print main page url
 $self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
}
else
{
 # print back URL
 $self->ui_print_footer("", $self->{'text_hash'}->{'index_main'});
}
1;
		
}


1;

