#!/usr/bin/perl
package webalizer::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'webalizer::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the webalizer module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_view'}</b></td>\n";
printf "<td nowrap><input type=radio name=view value=1 %s> %s\n",
	$_[0]->{'view'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=view value=0 %s> %s</td>\n",
	$_[0]->{'view'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'acl_global'}</b></td>\n";
printf "<td nowrap><input type=radio name=global value=1 %s> %s\n",
	$_[0]->{'global'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=global value=0 %s> %s</td> </tr>\n",
	$_[0]->{'global'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_add'}</b></td>\n";
printf "<td nowrap><input type=radio name=add value=1 %s> %s\n",
	$_[0]->{'add'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=add value=0 %s> %s</td> </tr>\n",
	$_[0]->{'add'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_user'}</b></td>\n";
printf "<td colspan=3><input type=radio name=user_def value=1 %s> %s\n",
	$_[0]->{'user'} eq "" ? "checked" : "", $self->{'text_hash'}->{'acl_this'};
printf "<input type=radio name=user_def value=2 %s> %s\n",
	$_[0]->{'user'} eq "*" ? "checked" : "", $self->{'text_hash'}->{'acl_any'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} eq "*" || $_[0]->{'user'} eq "" ? "" : "checked";
printf "<input name=user size=8 value='%s'> %s</td> </tr>\n",
	$_[0]->{'user'} eq "*" ? "" : $_[0]->{'user'},
	$self->user_chooser_button("user");

print "<tr> <td><b>$self->{'text_hash'}->{'acl_dir'}</b></td>\n";
print "<td colspan=3><input name=dir size=50 value='$_[0]->{'dir'}'></td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the shell module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'view'} = $self->{'in_hash'}->{'view'};
$_[0]->{'global'} = $self->{'in_hash'}->{'global'};
$_[0]->{'add'} = $self->{'in_hash'}->{'add'};
$_[0]->{'dir'} = $self->{'in_hash'}->{'dir'};
$_[0]->{'user'} = $self->{'in_hash'}->{'user_def'} == 2 ? "*" :
		  $self->{'in_hash'}->{'user_def'} == 1 ? "" : $self->{'in_hash'}->{'user'};
}


1;

