#!/usr/bin/perl
package webalizer::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'webalizer::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq "log") {
	return $self->text("log_${action}_log", "<tt>".$self->html_escape($object)."</tt>");
	}
elsif ($type eq "logs") {
	return $self->text("log_${action}_logs", $object);
	}
elsif ($type eq "global") {
	return $object eq "-" ? $self->{'text_hash'}->{"log_global"} :
		$self->text("log_global2", "<tt>".$self->html_escape($object)."</tt>");
	}
}


1;

