#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_message.cgi
# Display messages and readmes

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'message_title'}, "", "message");

$self->{'conf'} = $self->get_ftpaccess();

print "<form action=save_message.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'message_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

@{$self->{'message_array'}} = ( $self->find_value("message", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'message_message'}</b></td>\n";
print "<td><table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'message_path'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'message_when'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'message_classes'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $m (@{$self->{'message_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=mpath_$self->{'i'} size=15 value='$m->[0]'></td>\n";
	printf "<td nowrap><input name=mwhen_$self->{'i'} type=radio value=0 %s> %s\n",
		$m->[1] =~ /^login$/i ? 'checked' : '',
		$self->{'text_hash'}->{'message_login'};
	printf "<input name=mwhen_$self->{'i'} type=radio value=1 %s> %s\n",
		$m->[1] =~ /^cwd=\*$/ ? 'checked' : '',
		$self->{'text_hash'}->{'message_alldir'};
	printf "<input name=mwhen_$self->{'i'} type=radio value=2 %s> %s\n",
		$m->[1] =~ /^cwd=([^\*].*)$/ ? 'checked' : '',
		$self->{'text_hash'}->{'message_dir'};
	printf "<input name=mcwd_$self->{'i'} size=20 value='%s'></td>\n",
		$m->[1] =~ /^cwd=([^\*].*)$/ ? $1 : '';
	printf "<td><input name=mclasses_$self->{'i'} size=15 value='%s'></td>\n",
		join(" ", @$m[2..@$m-1]);
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=2><hr></td> </tr>\n";

@{$self->{'readme_array'}} = ( $self->find_value("readme", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'message_readme'}</b></td>\n";
print "<td><table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'message_path'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'message_update'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'message_classes'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $m (@{$self->{'readme_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=rpath_$self->{'i'} size=15 value='$m->[0]'></td>\n";
	printf "<td nowrap><input name=rwhen_$self->{'i'} type=radio value=0 %s> %s\n",
		$m->[1] =~ /^login$/i ? 'checked' : '',
		$self->{'text_hash'}->{'message_login'};
	printf "<input name=rwhen_$self->{'i'} type=radio value=1 %s> %s\n",
		$m->[1] =~ /^cwd=\*$/ ? 'checked' : '',
		$self->{'text_hash'}->{'message_alldir'};
	printf "<input name=rwhen_$self->{'i'} type=radio value=2 %s> %s\n",
		$m->[1] =~ /^cwd=([^\*].*)$/ ? 'checked' : '',
		$self->{'text_hash'}->{'message_dir'};
	printf "<input name=rcwd_$self->{'i'} size=20 value='%s'></td>\n",
		$m->[1] =~ /^cwd=([^\*].*)$/ ? $1 : '';
	printf "<td><input name=rclasses_$self->{'i'} size=15 value='%s'></td>\n",
		join(" ", @$m[2..@$m-1]);
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=2><hr></td> </tr>\n";

$self->{'g'} = $self->find_value('greeting', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'message_greeting'}</b></td>\n";
printf "<td><input type=radio name=greeting value=full %s> %s\n",
	$self->{'g'}->[0] eq 'full' || !$self->{'g'}->[0] ? 'checked' : '', $self->{'text_hash'}->{'message_full'};
printf "<input type=radio name=greeting value=brief %s> %s\n",
	$self->{'g'}->[0] eq 'brief' ? 'checked' : '', $self->{'text_hash'}->{'message_brief'};
printf "<input type=radio name=greeting value=terse %s> %s</td> </tr>\n",
	$self->{'g'}->[0] eq 'terse' ? 'checked' : '', $self->{'text_hash'}->{'message_terse'};

$self->{'b'} = $self->find_value('banner', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'message_banner'}</b></td>\n";
printf "<td><input type=radio name=banner_def value=1 %s> %s\n",
	$self->{'b'} ? '' : 'checked', $self->{'text_hash'}->{'message_none'};
printf "<input type=radio name=banner_def value=0 %s> %s\n",
	$self->{'b'} ? 'checked' : '', $self->{'text_hash'}->{'message_file'};
printf "<input name=banner size=30 value='%s'> %s</td> </tr>\n",
	$self->{'b'}->[0], $self->file_chooser_button('banner', 0);

$self->{'h'} = $self->find_value('hostname', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'message_hostname'}</b></td>\n";
printf "<td><input type=radio name=hostname_def value=1 %s> %s\n",
	$self->{'h'} ? '' : 'checked', $self->{'text_hash'}->{'message_hostdef'};
printf "<input type=radio name=hostname_def value=0 %s>\n",
	$self->{'h'} ? 'checked' : '';
printf "<input name=hostname size=30 value='%s'> %s</td> </tr>\n",
	$self->{'h'}->[0];

$self->{'e'} = $self->find_value('email', $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'message_email'}</b></td>\n";
printf "<td><input type=radio name=email_def value=1 %s> %s\n",
	$self->{'e'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=email_def value=0 %s>\n",
	$self->{'e'} ? 'checked' : '';
printf "<input name=email size=30 value='%s'> %s</td> </tr>\n",
	$self->{'e'}->[0];

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

