#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_net.cgi
# Display network-related options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "", "net");

$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

print "<form action=save_net.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display TCP window options
@{$self->{'tcp_array'}} = ( $self->find_value('tcpwindow', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_tcp'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_tsize'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'net_tclass'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $t (@{$self->{'tcp_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=tsize_$self->{'i'} size=5 value='$t->[0]'></td>\n";
	print "<td><select name=tclass_$self->{'i'}>\n";
	printf "<option value='' %s>%s\n",
		$t->[1] ? '' : 'checked', $self->{'text_hash'}->{'net_tall'};
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$t->[1] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# passive address options
@{$self->{'pasv_array'}} = ( ( grep { $_->[0] eq 'address' } $self->find_value('passive', $self->{'conf'}) ), [ ]);
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_pasvaddr'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_pip'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'net_pcidr'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $p (@{$self->{'pasv_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=aip_$self->{'i'} size=15 value='$p->[1]'></td>\n";
	local @ci = split(/\//, $p->[2]);
	print "<td><input name=anet_$self->{'i'} size=15 value='$ci[0]'> /\n";
	print "<input name=acidr_$self->{'i'} size=2 value='$ci[1]'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td></tr>\n";

# passive port options
@{$self->{'pasv_array'}} = ( ( grep { $_->[0] eq 'ports' } $self->find_value('passive', $self->{'conf'}) ), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_pasvport'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_prange'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'net_pcidr'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $p (@{$self->{'pasv_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=pmin_$self->{'i'} size=5 value='$p->[2]'> -\n";
	print "<input name=pmax_$self->{'i'} size=5 value='$p->[3]'></td>\n";
	local @ci = split(/\//, $p->[1]);
	print "<td><input name=pnet_$self->{'i'} size=15 value='$ci[0]'> /\n";
	print "<input name=pcidr_$self->{'i'} size=2 value='$ci[1]'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td></tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

