#!/usr/bin/perl
package acl::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'acl::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "acl::AclLib");
$self = new acl::AclLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the acl module
sub acl_security_form
{
	my $self = shift;

local $o = $_[0];
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td>\n";
print "<td valign=top>\n";
printf "<input type=radio name=users_def value=1 %s> %s\n",
	$o->{'users'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_uall'};
printf "<input type=radio name=users_def value=2 %s> %s<br>\n",
	$o->{'users'} eq '~' ? 'checked' : '', $self->{'text_hash'}->{'acl_uthis'};
printf "<input type=radio name=users_def value=0 %s> %s<br>\n",
	$o->{'users'} eq '*' || $o->{'users'} eq '~' ? '' : 'checked',
	$self->{'text_hash'}->{'acl_usel'};
print "<select name=users multiple size=6 width=150>\n";
map { $self->{'ucan_hash'}->{$_}++ } split(/\s+/, $o->{'users'});
foreach $u ($self->list_users()) {
	printf "<option %s>%s\n",
		$self->{'ucan_hash'}->{$u->{'name'}} ? 'selected' : '',
		$u->{'name'};
	}
foreach $g ($self->list_groups()) {
	printf "<option %s value=%s>%s\n",
		$self->{'ucan_hash'}->{'_'.$g->{'name'}} ? 'selected' : '',
		'_'.$g->{'name'}, $self->text('acl_gr', $g->{'name'});
	}
print "</select></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'acl_mods'}</b></td> ",
      "<td valign=top>\n";
printf "<input type=radio name=mode value=0 %s> %s&nbsp;\n",
	$o->{'mode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=mode value=1 %s> %s<br>\n",
	$o->{'mode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'acl_own'};
printf "<input type=radio name=mode value=2 %s> %s<br>\n",
	$o->{'mode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_sel'};
print "&nbsp;&nbsp;&nbsp;<select name=mods multiple size=6>\n";
map { $self->{'mcan_hash'}->{$_}++ } split(/\s+/, $o->{'mods'});
foreach $m ($self->list_module_infos()) {
	printf "<option value=%s %s>%s\n",
		$m->{'dir'}, $self->{'mcan_hash'}->{$m->{'dir'}} ? 'selected' :'',
		$m->{'desc'};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_create'}</b></td> <td>\n";
printf "<input type=radio name=create value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'create'} ? 'checked' : '';
printf "<input type=radio name=create value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'create'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_delete'}</b></td> <td>\n";
printf "<input type=radio name=delete value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'delete'} ? 'checked' : '';
printf "<input type=radio name=delete value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'delete'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_rename'}</b></td> <td>\n";
printf "<input type=radio name=rename value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'rename'} ? 'checked' : '';
printf "<input type=radio name=rename value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'rename'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_acl'}</b></td> <td>\n";
printf "<input type=radio name=acl value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'acl'} ? 'checked' : '';
printf "<input type=radio name=acl value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'acl'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_cert'}</b></td> <td>\n";
printf "<input type=radio name=cert value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'cert'} ? 'checked' : '';
printf "<input type=radio name=cert value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'cert'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_others'}</b></td> <td>\n";
printf "<input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'others'} ? 'checked' : '';
printf "<input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'others'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_chcert'}</b></td> <td>\n";
printf "<input type=radio name=chcert value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'chcert'} ? 'checked' : '';
printf "<input type=radio name=chcert value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'chcert'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_lang'}</b></td> <td>\n";
printf "<input type=radio name=lang value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'lang'} ? 'checked' : '';
printf "<input type=radio name=lang value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'lang'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_cats'}</b></td> <td>\n";
printf "<input type=radio name=cats value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'cats'} ? 'checked' : '';
printf "<input type=radio name=cats value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'cats'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_theme'}</b></td> <td>\n";
printf "<input type=radio name=theme value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'theme'} ? 'checked' : '';
printf "<input type=radio name=theme value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'theme'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ips'}</b></td> <td>\n";
printf "<input type=radio name=ips value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'ips'} ? 'checked' : '';
printf "<input type=radio name=ips value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'ips'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_perms'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=perms value=1 %s> $self->{'text_hash'}->{'acl_perms_1'}\n",
	$o->{'perms'} ? 'checked' : '';
printf "<input type=radio name=perms value=0 %s> $self->{'text_hash'}->{'acl_perms_0'}</td>\n",
	$o->{'perms'} ? '' : 'checked';
print "</tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_sync'}</b></td> <td>\n";
printf "<input type=radio name=sync value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'sync'} ? 'checked' : '';
printf "<input type=radio name=sync value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'sync'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_unix'}</b></td> <td>\n";
printf "<input type=radio name=unix value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'unix'} ? 'checked' : '';
printf "<input type=radio name=unix value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'unix'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_sessions'}</b></td> <td>\n";
printf "<input type=radio name=sessions value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'sessions'} ? 'checked' : '';
printf "<input type=radio name=sessions value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'sessions'} ? '' : 'checked';

print "<td><b>$self->{'text_hash'}->{'acl_switch'}</b></td> <td>\n";
printf "<input type=radio name=switch value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'switch'} ? 'checked' : '';
printf "<input type=radio name=switch value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'switch'} ? '' : 'checked';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_times'}</b></td> <td>\n";
printf "<input type=radio name=times value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'times'} ? 'checked' : '';
printf "<input type=radio name=times value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'times'} ? '' : 'checked';

print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_groups'}</b></td> <td valign=top>\n";
printf "<input type=radio name=groups value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'groups'} == 1 ? 'checked' : '';
printf "<input type=radio name=groups value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$o->{'groups'} == 0 ? 'checked' : '';

print "<td valign=top><b>$self->{'text_hash'}->{'acl_gassign'}</b></td> <td>\n";
printf "<input type=radio name=gassign_def value=1 %s> %s\n",
	$o->{'gassign'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_gall'};
printf "<input type=radio name=gassign_def value=0 %s> %s<br>\n",
	$o->{'gassign'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_gsel'};
print "<select name=gassign multiple size=3 width=150>\n";
map { $self->{'gcan_hash'}->{$_}++ } split(/\s+/, $o->{'gassign'});
printf "<option value=_none %s>&lt;%s&gt;\n",
	$self->{'gcan_hash'}->{'_none'} ? 'selected' : '', $self->{'text_hash'}->{'acl_gnone'};
foreach $g ($self->list_groups()) {
	printf "<option %s>%s\n",
		$self->{'gcan_hash'}->{$g->{'name'}} ? 'selected' : '', $g->{'name'};
	}
print "</select></td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'users_def'} == 1) {
	$_[0]->{'users'} = '*';
	}
elsif ($self->{'in_hash'}->{'users_def'} == 2) {
	$_[0]->{'users'} = '~';
	}
else {
	$_[0]->{'users'} = join(" ", split(/\0/, $self->{'in_hash'}->{'users'}));
	}
$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'mods'} = $self->{'in_hash'}->{'mode'} == 2 ? join(" ", split(/\0/, $self->{'in_hash'}->{'mods'}))
				   : undef;
$_[0]->{'create'} = $self->{'in_hash'}->{'create'};
$_[0]->{'groups'} = $self->{'in_hash'}->{'groups'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'rename'} = $self->{'in_hash'}->{'rename'};
$_[0]->{'acl'} = $self->{'in_hash'}->{'acl'};
$_[0]->{'others'} = $self->{'in_hash'}->{'others'};
$_[0]->{'cert'} = $self->{'in_hash'}->{'cert'};
$_[0]->{'chcert'} = $self->{'in_hash'}->{'chcert'};
$_[0]->{'lang'} = $self->{'in_hash'}->{'lang'};
$_[0]->{'perms'} = $self->{'in_hash'}->{'perms'};
$_[0]->{'gassign'} = $self->{'in_hash'}->{'gassign_def'} ? '*' :
		     join(" ", split(/\0/, $self->{'in_hash'}->{'gassign'}));
$_[0]->{'sync'} = $self->{'in_hash'}->{'sync'};
$_[0]->{'unix'} = $self->{'in_hash'}->{'unix'};
$_[0]->{'switch'} = $self->{'in_hash'}->{'switch'};
$_[0]->{'sessions'} = $self->{'in_hash'}->{'sessions'};
$_[0]->{'cats'} = $self->{'in_hash'}->{'cats'};
$_[0]->{'theme'} = $self->{'in_hash'}->{'theme'};
$_[0]->{'ips'} = $self->{'in_hash'}->{'ips'};
$_[0]->{'times'} = $self->{'in_hash'}->{'times'};
}


1;

