#!/usr/bin/perl

&MAIN();

 sub MAIN {
# convert_form.cgi
# Display a form for converting unix users to webmin users

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->{'access_hash'}->{'sync'} && $self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'convert_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'convert_title'}, "");

@{$self->{'glist_array'}} = $self->list_groups();
if ($self->{'access_hash'}->{'gassign'} ne '*') {
	@{$self->{'gcan_array'}} = split(/\s+/, $self->{'access_hash'}->{'gassign'});
	@{$self->{'glist_array'}} = grep { $self->indexof($_->{'name'}, @{$self->{'gcan_array'}}) >= 0 } @{$self->{'glist_array'}};
	}
if (!@{$self->{'glist_array'}}) {
	print "$self->{'text_hash'}->{'convert_nogroups'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<form action=convert.cgi>\n";
print "$self->{'text_hash'}->{'convert_desc'}<p>\n";
print "<input type=radio name=conv value=0 checked> $self->{'text_hash'}->{'convert_0'}<br>\n";
print "<input type=radio name=conv value=1> $self->{'text_hash'}->{'convert_1'} ",
      "<input name=users size=40> ",$self->user_chooser_button("users",1),"<br>\n";
print "<input type=radio name=conv value=2> $self->{'text_hash'}->{'convert_2'} ",
      "<input name=nusers size=40> ",$self->user_chooser_button("nusers",1),"<br>\n";
print "<input type=radio name=conv value=3> $self->{'text_hash'}->{'convert_3'} ",
      $self->unix_group_input("group"),"<br>\n";
print "<input type=radio name=conv value=4> $self->{'text_hash'}->{'convert_4'} ",
      "<input name=min size=6> - <input name=max size=6><p>\n";

print "$self->{'text_hash'}->{'convert_group'} <select name=wgroup>\n";
foreach $g (@{$self->{'glist_array'}}) {
	print "<option>$g->{'name'}\n";
	}
print "</select><br>\n";
print "<input type=checkbox name=sync value=1> $self->{'text_hash'}->{'convert_sync'}<br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'convert_ok'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

