#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of Webmin users

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'udeletes_err'});
$self->{'access_hash'}->{'delete'} || $self->error($self->{'text_hash'}->{'delete_ecannot'});

# Validate inputs
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'d_array'}} || $self->error($self->{'text_hash'}->{'udeletes_enone'});
foreach $user (@{$self->{'d_array'}}) {
	$self->can_edit_user($user) || $self->error($self->{'text_hash'}->{'delete_euser'});
	if ($self->{'base_remote_user'} eq $user) {
		$self->error($self->{'text_hash'}->{'delete_eself'});
		}
	$user->{'readonly'} && $self->error($self->{'text_hash'}->{'udeletes_ereadonly'});
	}

if ($self->{'in_hash'}->{'confirm'}) {
	# Do it
	foreach $user (@{$self->{'d_array'}}) {
		$self->delete_user($user);
		$self->delete_from_groups($user);
		}

	$self->reload_miniserv();
	$self->webmin_log("delete", "users", scalar(@{$self->{'d_array'}}));
	$self->redirect("");
	}
else {
	# Ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'udeletes_title'}, "");

	print "<center>\n";
	print $self->ui_form_start("delete_users.cgi", "post");
	foreach $user (@{$self->{'d_array'}}) {
		print $self->ui_hidden("d", $user),"\n";
		}
	print $self->text('udeletes_rusure', scalar(@{$self->{'d_array'}})),"<p>\n";

	print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'udeletes_ok'} ] ]);

	print $self->text('udeletes_users', join(" ", map { "<tt>$_</tt>" } @{$self->{'d_array'}})),
	      "<p>\n";
	print "</center>\n";

	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

