#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_sync.cgi
# Display unix/webmin user synchronization

&ModuleLoader::preload_module('acl_class', "acl::AclLib");
$self = new acl::AclLib:: 'acl_class',%$self;

$self->{'access_hash'}->{'sync'} && $self->{'access_hash'}->{'create'} && $self->{'access_hash'}->{'delete'} ||
	$self->error($self->{'text_hash'}->{'sync_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sync_title'}, "");

@{$self->{'glist_array'}} = $self->list_groups();
if (!@{$self->{'glist_array'}}) {
	print "<p>$self->{'text_hash'}->{'sync_nogroups'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<form action=save_sync.cgi>\n";
print "<b>$self->{'text_hash'}->{'sync_desc'}</b><p>\n";
printf "<input type=checkbox name=create value=1 %s> %s<p>\n",
	$self->{'config_hash'}->{'sync_create'} ? "checked" : "", $self->{'text_hash'}->{'sync_create'};
printf "<input type=checkbox name=delete value=1 %s> %s<p>\n",
	$self->{'config_hash'}->{'sync_delete'} ? "checked" : "", $self->{'text_hash'}->{'sync_delete'};
printf "<input type=checkbox name=unix value=1 %s> %s<p>\n",
	$self->{'config_hash'}->{'sync_unix'} ? "checked" : "", $self->{'text_hash'}->{'sync_unix'};

print "$self->{'text_hash'}->{'sync_group'} <select name=group>\n";
foreach $g (@{$self->{'glist_array'}}) {
	printf "<option %s>%s\n",
		$g->{'name'} eq $self->{'config_hash'}->{'sync_group'} ? "selected" : "",
		$g->{'name'};
	}
print "</select><p>\n";

print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

