#!/usr/bin/perl

&MAIN();

 sub MAIN {
# options.cgi
# display amavisd logs

# main part
&ModuleLoader::preload_module('amavis_class', "amavis::AmavisLib");
$self = new amavis::AmavisLib:: 'amavis_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->ReadParse();

# get log file name
local $log_file = $self->get_log_file();

# print header
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_log'}, undef, undef, 1, 1, undef, undef, undef, undef, $log_file);

unless ($log_file && -r $log_file)
{
 # print unlog message
 $self->ui_print_endpage($self->text('index_elog','options.cgi?section=logging'));
}
else
{
 # print logs
 print $self->ui_form_start('log_view.cgi', 'POST');
 print $self->ui_table_start("$self->{'text_hash'}->{'log_table'}", 'width=100%');

 # check lines
 local $lines = qq(<select name="lines">);
 $lines .= sprintf "<option value=\"0\"%s>%s</option>", !$self->{'in_hash'}->{'lines'} ? ' selected' : '', $self->{'text_hash'}->{'log_all'};
 foreach $value (qw(10 20 50 100 150 200 250 300))
 {
  $lines .= sprintf "<option value=\"%s\"%s>%s</option>", $value, ($self->{'in_hash'}->{'lines'} eq $value) ? ' selected' : '', $value;
 }
 $lines .= qq(</select>);

 # print lines form
 print $self->ui_table_row("$self->{'text_hash'}->{'log_count_lines'}",$lines,1,['width=15%']);
 print $self->ui_table_end();
 print $self->ui_hidden('logs',$log_file);
 print $self->ui_form_end([['show', $self->{'text_hash'}->{'log_submit'}]]);
}
# print logs
if ($self->{'in_hash'}->{'show'}) 
{
 $self->show_log($self->{'in_hash'}->{'logs'}, $self->{'in_hash'}->{'lines'});
}
# print clear log submit
if ($self->{'in_hash'}->{'clear'}) 
{
 $self->backquote_logged("echo \"\" > $self->{'in_hash'}->{logs}");
}

# print back URL
$self->ui_print_footer("",$self->{'text_hash'}->{'index'});
1;
		
}


1;

