#!/usr/bin/perl
package apache::Install_check;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Install_check');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# install_check.pl

&ModuleLoader::preload_module(ref($self), "apache::ApacheLib");
$self = new apache::ApacheLib:: ref($self), %$self; 

1;
		return $self;
}

# is_installed(mode)
# For mode 1, returns 2 if Apache is installed and configured for use by
# Webmin, 1 if installed but not configured, or 0 otherwise.
# For mode 0, returns 1 if installed, 0 if not
sub is_installed
{
	my $self = shift;

return 0 if (!-d $self->{'config_hash'}->{'httpd_dir'} || !$self->find_httpd());
local ($htconf) = $self->find_httpd_conf();
return 0 if (!$htconf);
if ($_[0]) {
	return 2 if ($self->{'httpd_modules_hash'}->{'core'});
	}
return 1;
}


1;

