#!/usr/bin/perl
package apache::Mod_authn_file;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_authn_file');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_authn_file.pl
# Defines editors for user text-file authentication directives

1;
		return $self;
}

sub mod_authn_file_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'AuthUserFile', 0, 4, 'directory htaccess' ] ];
return $self->make_directives($rv, $_[0], "mod_authn_file");
}

sub edit_AuthUserFile
{
	my $self = shift;

local $uf = $_[0] && -r "list_authusers.cgi" ? 1 : 0;
return (2, $self->{'text_hash'}->{'mod_auth_ufile'},
       $self->opt_input($_[0]->{'value'}, "AuthUserFile", $self->{'text_hash'}->{'default'}, 45).
       $self->file_chooser_button("AuthUserFile", 0).
       ($uf ? "&nbsp;<a href=\"list_authusers.cgi?file=".$_[0]->{'value'}.
       "&url=".$self->urlize($self->this_url())."\">$self->{'text_hash'}->{'mod_auth_uedit'}</a>" : ""));
}

sub save_AuthUserFile
{
	my $self = shift;

$self->{'in_hash'}->{'AuthUserFile_def'} || $self->allowed_auth_file($self->{'in_hash'}->{'AuthUserFile'}) ||
        $self->error($self->{'text_hash'}->{'mod_auth_eudir'});
return $self->parse_opt("AuthUserFile", '^\S+$', $self->{'text_hash'}->{'mod_auth_eufile'});
}


1;

