#!/usr/bin/perl
package apache::Mod_authz_host;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_authz_host');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_authz_host.pl
# Just calls mod_access.pl , to handle the move of these directives to a
# new module in Apache 2.2.0

&ModuleLoader::preload_module(ref($self), "apache::Mod_access");
$self = new apache::Mod_access:: ref($self), %$self; 

1;
		return $self;
}

sub mod_authz_host_directives
{
	my $self = shift;

local($rv);
$rv = [ [ 'allow deny order', 1, 4, 'directory htaccess' ] ];
return $self->make_directives($rv, $_[0], "mod_authz_host");
}


1;

