#!/usr/bin/perl
package apache::Mod_status;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'apache::Mod_status');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_status.pl
# This module defines the one directive and handle for mod_status

1;

1;
		return $self;
}

sub mod_status_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'ExtendedStatus', 0, 0, 'global', 1.302 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_status");
}

sub mod_status_handlers
{
	my $self = shift;

return ("server-status");
}

sub edit_ExtendedStatus
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_status_msg'}",
        $self->choice_input($_[0]->{'value'}, "ExtendedStatus",
	               "off", "$self->{'text_hash'}->{'yes'},on", "$self->{'text_hash'}->{'no'},off"));
}

sub save_ExtendedStatus
{
	my $self = shift;

return $self->parse_choice("ExtendedStatus", "off");
}


1;

