#!/usr/bin/perl

&MAIN();

 sub MAIN {
# allmanual_save.cgi
# Save an entire config file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'types'} eq '*' && $self->{'access_hash'}->{'virts'} eq '*' ||
	$self->error($self->{'text_hash'}->{'manual_ecannot'});

$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = $self->unique(map { $_->{'file'} } @{$self->{'conf'}});
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});

$self->{'temp'} = $self->transname();
$self->execute_command("cp ".quotemeta($self->{'in_hash'}->{'file'})." $self->{'temp'}");
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->lock_file($self->{'in_hash'}->{'file'});
$self->open_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);
$self->unlock_file($self->{'in_hash'}->{'file'});
if ($self->{'config_hash'}->{'test_manual'}) {
	$self->{'err'} = $self->test_config();
	if ($self->{'err'}) {
		$self->execute_command("mv $self->{'temp'} '$self->{'in_hash'}->{'file'}'");
		$self->error($self->text('manual_etest', "<pre>$self->{'err'}</pre>"));
		}
	}
unlink($self->{'temp'});
$self->webmin_log("manual", undef, undef, { 'file' => $self->{'in_hash'}->{'file'} });
$self->redirect("");

1;
		
}


1;

