#!/usr/bin/perl

&MAIN();

 sub MAIN {
# apache_directives.cgi
# Display a form for editing some kind of per-server

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->foreign_require('virtual_server', 'virtual-server-lib.pl');
$self->{'d'} = $main::virtual_server_object->get_domain($self->{'in_hash'}->{'dom'});
$main::virtual_server_object->{'access_hash'}->{'edit'} && $main::virtual_server_object->can_edit_domain($self->{'d'}) || $self->error($main::virtual_server_object->{'text_hash'}->{'edit_ecannot'});
if ($self->{'d'}->{'parent'}) {
	$self->{'parentdom'} = $main::virtual_server_object->get_domain($self->{'d'}->{'parent'});
}
local ($v, $conf) = $main::virtual_server_object->get_apache_virtual($self->{'d'}->{'dom'}, $self->{'d'}->{'web_port'} || undef);
local ($vssl, $confssl) = $main::virtual_server_object->get_apache_virtual($self->{'d'}->{'dom'}, $self->{'d'}->{'web_sslport'} || undef) if $self->{'d'}->{'web_sslport'};
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'virtual');
$self->{'desc'} = $self->text('virt_header', $self->virtual_name($v));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "", undef, undef, 1);
$conf_ap = $self->get_config();
local $i=0;
local $virt=0;
local $virt_ssl;
foreach (@$conf_ap){
	$virt=$i if $$conf_ap[$i]->{'eline'} == $v->{'eline'};
	$virt_ssl=$i if ($$conf_ap[$i]->{'eline'} == $vssl->{'eline'} && $self->{'d'}->{'web_sslport'});
	$i++;
}

print $self->ui_form_start("save_virt.cgi", "post");
print $self->ui_hidden("virt", $virt);
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'});
print $self->ui_hidden("virt_ssl", $virt_ssl) if $virt_ssl;
print $self->ui_hidden("home", $self->{'in_hash'}->{'home'});
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('virt_header2', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, $self->virtual_name($v)),"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>";
print "<table>\n";
$self->generate_inputs_home(\@{$self->{'dirs_array'}}, $conf);
print "</table>";
print "</td></tr>\n";
print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

if ($self->{'in_hash'}->{'type'} == 101) {
	print "<hr>\n";
	print "<h3>$self->{'text_hash'}->{'global_mime'}</h3>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td width=25%><b>$self->{'text_hash'}->{'global_type'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'global_ext'}</b></td>\n";
	print "<td width=25%><b>$self->{'text_hash'}->{'global_type'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'global_ext'}</b></td></tr>\n";
	$self->{'mfile'} = $self->find_directive("TypesConfig", $conf);
	if (!$self->{'mfile'}) { $self->{'mfile'} = $self->{'config_hash'}->{'mime_types'}; }
	if (!$self->{'mfile'}) { $self->{'mfile'} = $self->server_root("etc/mime.types", $conf); }
	if (!-r $self->{'mfile'}) { $self->{'mfile'} = $self->server_root("conf/mime.types", $conf); }
	$self->{'mfile'} = $self->server_root($self->{'mfile'}, $conf);
	open(MIME, $self->{'mfile'});
	$self->{'line'} = 0;
	while(<MIME>) {
		chop;
		s/#.*$//;
		if (/^\s*(\S+)\s*(.*)$/) {
			if (!$self->{'sw'}) { print "<tr $self->{'cb'}>\n"; }
			print "<td>$1</td> <td>$2<br></td>\n";
			if ($self->{'sw'}) { print "</tr>\n"; }
			$self->{'sw'} = !$self->{'sw'};
			}
		$self->{'line'}++;
		}
	if ($self->{'sw'}) { print "<td colspan=2>&nbsp;</td></tr>\n"; }
	close(MIME);
	print "</table>\n";
	}
if ($self->{'in_hash'}->{'type'} == 104) {
	print "<hr>\n";
	($self->{'ap_conf'}, $self->{'ap_v'}) = $self->get_virtual_config();
	@{$self->{'dirs_array'}} = $self->{'gconfig_hash'}->{'ztl_mode'} ? $self->mod_ztl_directives($self->{'in_hash'}->{'type'}, 'virtual') : $self->mod_cpplus_directives($self->{'in_hash'}->{'type'}, 'virtual') ;
	$self->{'desc'} = $self->text('virt_header', $self->virtual_name($self->{'ap_v'}));
	$self->generate_outputs_hand(\@{$self->{'dirs_array'}}, $self->{'ap_conf'});
	}
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});
1;
		
}


1;

