#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_dir.cgi
# Create an empty <Directory>, <Files> or <Location> clause

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'cdir_err'});
($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'f'} = $self->{'vconf'}->[0]->{'file'};
for($j=0; $self->{'vconf'}->[$j]->{'file'} eq $self->{'f'}; $j++) { }
$self->{'l'} = $self->{'vconf'}->[$j-1]->{'eline'}+1;
$self->lock_file($self->{'f'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'f'});
$self->{'in_hash'}->{'path'} || $self->error($self->{'text_hash'}->{'cdir_epath'});

$self->{'in_hash'}->{'type'} eq 'Proxy' || $self->allowed_doc_dir($self->{'in_hash'}->{'path'}) ||
	$self->error($self->{'text_hash'}->{'cdir_ecannot'});
if ($self->{'in_hash'}->{'regexp'}) {
	$self->{'in_hash'}->{'type'} eq 'Proxy' && $self->error($self->{'text_hash'}->{'cdir_eproxy'});
	if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
		$self->{'newdir'} = "<$self->{'in_hash'}->{'type'}Match \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}Match>";
		}
	else {
		$self->{'newdir'} = "<$self->{'in_hash'}->{'type'} ~ \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}>";
		}
	}
else {
	$self->{'newdir'} = "<$self->{'in_hash'}->{'type'} \"$self->{'in_hash'}->{'path'}\">";
	$self->{'enddir'} = "</$self->{'in_hash'}->{'type'}>";
	}
splice(@{$self->{'lref'}}, $self->{'l'}, 0, ($self->{'newdir'}, $self->{'enddir'}));
$self->flush_file_lines();
$self->unlock_file($self->{'f'});
$self->after_changing();
$self->webmin_log("dir", "create", $self->virtual_name($self->{'v'}, 1).":$self->{'in_hash'}->{'path'}", \%{$self->{'in_hash'}});
$self->redirect("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}");

1;
		
}


1;

