#!/usr/bin/perl

&MAIN();

 sub MAIN {
# create_files.cgi
# Create an empty <Files> clause in a .htaccess file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'in_hash'}->{'file'});
$self->before_changing();
$self->{'lref'} = $self->read_file_lines($self->{'in_hash'}->{'file'});
if ($self->{'in_hash'}->{'regexp'}) {
	if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
		$self->{'newdir'} = "<FilesMatch \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</FilesMatch>";
		}
	else {
		$self->{'newdir'} = "<Files ~ \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</Files>";
		}
	}
else {
	$self->{'newdir'} = "<Files \"$self->{'in_hash'}->{'path'}\">";
	$self->{'enddir'} = "</Files>";
	}
push(@{$self->{'lref'}}, $self->{'newdir'});
push(@{$self->{'lref'}}, $self->{'enddir'});
$self->flush_file_lines();
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->after_changing();
$self->webmin_log("files", "create", "$self->{'in_hash'}->{'file'}:$self->{'in_hash'}->{'path'}", \%{$self->{'in_hash'}});
$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

