#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_htaccess.cgi
# Delete some .htaccess or similar file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htaccess_edelete'});
$self->lock_file($self->{'in_hash'}->{'file'});
unlink($self->{'in_hash'}->{'file'});
$self->unlock_file($self->{'in_hash'}->{'file'});

$self->read_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
@{$self->{'ht_array'}} = split(/\s+/, $self->{'site_hash'}->{'htaccess'});
$self->{'site_hash'}->{'htaccess'} = join(' ', (grep { $_ ne $self->{'in_hash'}->{'file'} } @{$self->{'ht_array'}}));
$self->write_file("$self->{'module_config_directory'}/site", \%{$self->{'site_hash'}});
$self->webmin_log("htaccess", "delete", $self->{'in_hash'}->{'file'});
$self->redirect("htaccess.cgi");

1;
		
}


1;

