#!/usr/bin/perl

&MAIN();

 sub MAIN {
# dir_index.cgi
# Display a menu of icons for per-directory options

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'desc'} = $self->text('dir_header', $self->dir_name($self->{'d'}), $self->virtual_name($self->{'v'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'dir_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

print $self->ui_subheading($self->{'text_hash'}->{'dir_title'});
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'dir_show'},
	     "link" => "show.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}" };
if ($self->{'access_hash'}->{'types'} eq '*') {
	$self->{'ed_icon'} = { "icon" => "images/edit.gif",
		     "name" => $self->{'text_hash'}->{'dir_edit'},
		     "link" =>
			"manual_form.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}" };
	}
$self->config_icons("directory", "edit_dir.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&",
	      $self->{'sw_icon'}, $self->{'ed_icon'} ? ( $self->{'ed_icon'}) : ( ));

print "<hr>\n";
print $self->ui_form_start("change_dir.cgi", "post");
print $self->ui_hidden("virt", $self->{'in_hash'}->{'virt'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->{'text_hash'}->{'dir_opts'}, undef, 2);

$self->{'dname'} = $self->{'d'}->{'name'};
$self->{'dname'} =~ s/Match$//;
print $self->ui_table_row($self->{'text_hash'}->{'dir_type'},
	$self->ui_select("type", $self->{'dname'},
	  [ map { [ $_, $self->{'text_hash'}->{'virt_'.$_} ] }
		  $self->{'httpd_modules_hash'}->{'core'} >= 2.0 ?
			( "Directory", "Files", "Location", "Proxy" ) :
		  $self->{'httpd_modules_hash'}->{'core'} >= 1.2 ?
			( "Directory", "Files", "Location" ) :
			( "Directory", "Location" ) ]));

if ($self->{'httpd_modules_hash'}->{'core'} >= 1.2) {
	$self->{'re'} = $self->{'d'}->{'words'}->[0] eq "~" || $self->{'d'}->{'name'} =~ /Match/i ? 1 : 0;
	print $self->ui_table_row($self->{'text_hash'}->{'dir_regexp'},
		$self->ui_radio("regexp", $self->{'re'}, [ [ 0, $self->{'text_hash'}->{'virt_exact'} ],
					   [ 1, $self->{'text_hash'}->{'virt_re'} ] ]));
	}

print $self->ui_table_row($self->{'text_hash'}->{'dir_path'},
	$self->ui_textbox("path", $self->{'d'}->{'words'}->[0] eq "~" ? $self->{'d'}->{'words'}->[1]
						  : $self->{'d'}->{'words'}->[0], 50));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ],
		     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);

$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'});

1;
		
}


1;

