#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_authgroup.cgi
# Display a form for editing a new or existing group

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

&ModuleLoader::preload_module('apache_class', "apache::AuthLib");
$self = new apache::AuthLib:: 'apache_class',%$self;


$self->ReadParse();
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->text('authg_ecannot', $self->{'in_hash'}->{'file'}));
$self->{'desc'} = $self->text('authg_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
if (defined($self->{'in_hash'}->{'group'})) {
	# editing existing group
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authg_edit'}, "");
	$self->{'g'} = $self->get_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'group'});
	$self->{'group'} = $self->{'g'}->{'group'};
	@{$self->{'members_array'}} = @{$self->{'g'}->{'members'}};
	$self->{'new'} = 0;
	}
else {
	# creating a new group
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authg_create'}, "");
	$self->{'new'} = 1;
	}

print "<form method=post action=save_authgroup.cgi>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=url value=\"$self->{'in_hash'}->{'url'}\">\n";
if (!$self->{'new'}) { print "<input type=hidden name=oldgroup value=$self->{'in_hash'}->{'group'}>\n"; }
print "<table border> <tr $self->{'tb'}><td colspan=2><b>",
      ($self->{'new'} ? $self->{'text_hash'}->{'authg_create'} : $self->{'text_hash'}->{'authg_edit'}),
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'authg_group'}</b></td>\n";
print "<td><input name=group size=20 value=\"$self->{'group'}\"></td> </tr>\n";
print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'authg_mems'}</b></td>\n";
print "<td><textarea name=members rows=5 cols=60 wrap=on>",
	join(' ', @{$self->{'members_array'}}),"</textarea></td> </tr>\n";

print "</table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "&nbsp; <input type=submit value=\"$self->{'text_hash'}->{'delete'}\" name=delete>\n"
	if (!$self->{'new'});
print "</form>\n";

$self->ui_print_footer($self->{'in_hash'}->{'url'}, $self->{'text_hash'}->{'auth_return'});

1;
		
}


1;

