#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_authuser.cgi
# Display a form for editing a user from a text file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

&ModuleLoader::preload_module('apache_class', "apache::AuthLib");
$self = new apache::AuthLib:: 'apache_class',%$self;


$self->ReadParse();
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->text('authu_ecannot', $self->{'in_hash'}->{'file'}));
$self->{'desc'} = $self->text('authu_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
if (defined($self->{'in_hash'}->{'user'})) {
	# editing an existing user
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authu_edit'}, "");
	$self->{'u'} = $self->get_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'user'});
	$self->{'user'} = $self->{'u'}->{'user'};
	$self->{'pass'} = $self->{'u'}->{'pass'};
	$self->{'new'} = 0;
	}
else {
	# creating a new user
	$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authu_create'}, "");
	$self->{'new'} = 1;
	}

print "<form method=post action=save_authuser.cgi>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=url value=\"$self->{'in_hash'}->{'url'}\">\n";
if (!$self->{'new'}) { print "<input type=hidden name=olduser value=$self->{'in_hash'}->{'user'}>\n"; }

print "<table border>\n";
printf "<tr $self->{'tb'}> <td><b>%s</b></td> </tr>\n",
	$self->{'new'} ? $self->{'text_hash'}->{'authu_create'} : $self->{'text_hash'}->{'authu_edit'};
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'authu_user'}</b></td>\n";
print "<td><input name=user size=20 value=\"$self->{'user'}\"></td> </tr>\n";
print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'authu_pass'}</b></td>\n";
printf "<td><input name=mode type=radio value=1 %s> $self->{'text_hash'}->{'authu_enc'}\n",
	$self->{'new'} ? '' : 'checked';
print "<input name=enc size=15 value='$self->{'pass'}'>\n";
printf "<input name=mode type=radio value=0 %s> $self->{'text_hash'}->{'authu_plain'}\n",
	$self->{'new'} ? 'checked' : '';
print "<input name=pass size=15></td> </tr>\n";

print "<tr> <td colspan=2 align=right>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'delete'}\" name=delete>\n"
	if (!$self->{'new'});
print "</td> </tr></table></td></tr></table>\n";
print "</form>\n";

$self->ui_print_footer($self->{'in_hash'}->{'url'}, $self->{'text_hash'}->{'authu_return'});

1;
		
}


1;

