#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dir.cgi
# Display a form for editing some kind of per-directory options

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->can_edit_virt($self->{'v'}) || $self->error($self->{'text_hash'}->{'virt_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} || $self->error($self->{'text_hash'}->{'etype'});
$self->{'d'} = $self->{'vconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'conf'} = $self->{'d'}->{'members'};
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'directory');
$self->{'desc'} = $self->text('dir_header', $self->dir_name($self->{'d'}), $self->virtual_name($self->{'v'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "",
	undef, undef, undef, undef, $self->restart_button());

print $self->ui_form_start("save_dir.cgi", "post");
print $self->ui_hidden("virt", $self->{'in_hash'}->{'virt'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_hidden("type", $self->{'in_hash'}->{'type'});
print $self->ui_table_start($self->text('dir_header2', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"},
                               $self->dir_name($self->{'d'})), undef, 4);
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'dir_return'});

1;
		
}


1;

