#!/usr/bin/perl

&MAIN();

 sub MAIN {
# files_index.cgi
# Display a menu of icons for per-files options

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'desc'} = $self->text('htfile_header', $self->dir_name($self->{'d'}), "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'htfile_title'}, "");

print "<h3>$self->{'text_hash'}->{'htfile_title'}</h3>\n";
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'htfile_show'},
	     "link" => "show.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}" };
if ($self->{'access_hash'}->{'types'} eq '*') {
	$self->{'ed_icon'} = { "icon" => "images/edit.gif",
		     "name" => $self->{'text_hash'}->{'htfile_edit'},
		     "link" =>
			"manual_form.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}" };
	}
$self->config_icons("directory", "edit_files.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}&",
	      $self->{'sw_icon'}, $self->{'ed_icon'} ? ( $self->{'ed_icon'} ) : ( ));

print "<hr>\n";
print $self->ui_form_start("change_files.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'});
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'});
print $self->ui_table_start($self->{'text_hash'}->{'htfile_apply'}, undef, 2);

$self->{'regexp'} = $self->{'d'}->{'words'}->[0] eq "~" || $self->{'d'}->{'name'} =~ /Match/;
print $self->ui_table_row($self->{'text_hash'}->{'htindex_regexp'},
	$self->ui_radio("regexp", $self->{'regexp'} ? 1 : 0,
		  [ [ 0, $self->{'text_hash'}->{'htindex_exact'} ],
		    [ 1, $self->{'text_hash'}->{'htindex_re'} ] ]));

print $self->ui_table_row($self->{'text_hash'}->{'htindex_path'},
	$self->ui_textbox("path", 
		$self->{'d'}->{'words'}->[0] eq "~" ? $self->{'d'}->{'words'}->[1]
					  : $self->{'d'}->{'words'}->[0], 50));

print $self->ui_table_end();
print $self->ui_form_end([ [ undef, $self->{'text_hash'}->{'save'} ],
		     [ 'delete', $self->{'text_hash'}->{'delete'} ] ]);

$self->ui_print_footer("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}), $self->{'text_hash'}->{'htindex_return'});

1;
		
}


1;

