#!/usr/bin/perl

&MAIN();

 sub MAIN {
# htaccess.cgi
# Display a list of per-directory config files

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'htaccess_title'}, "");

print "$self->{'text_hash'}->{'htaccess_desc'} <p>\n";

# List of existing files
@{$self->{'htaccess_files_array'}} = grep { $self->allowed_auth_file($_) } @{$self->{'htaccess_files_array'}};
if (@{$self->{'htaccess_files_array'}}) {
	print $self->ui_columns_start([ $self->{'text_hash'}->{'htaccess_file'} ]);
	foreach $f (@{$self->{'htaccess_files_array'}}) {
		print $self->ui_columns_row([
			"<a href=\"htaccess_index.cgi?file=".$self->urlize($self->{'htaccess_files_array'}->[$self->{'i'}])."\">".$self->{'htaccess_files_array'}->[$self->{'i'}]."</a>"
			]);
		}
	print $self->ui_columns_end();
	}

# Form to create
print $self->ui_form_start("create_htaccess.cgi");
print $self->ui_submit($self->{'text_hash'}->{'htaccess_create'}),"\n";
print $self->ui_textbox("file", undef, 30)." ".
	$self->file_chooser_button("file", 0, 0);
print $self->ui_form_end();

# Form to find
print $self->ui_form_start("find_htaccess.cgi");
print $self->ui_submit($self->{'text_hash'}->{'htaccess_find'}),"\n";

if ($self->{'access_hash'}->{'dir'} eq '/') {
	print $self->ui_radio("from", 0, [ [ 0, $self->{'text_hash'}->{'htaccess_auto'} ],
				     [ 1, $self->{'text_hash'}->{'htaccess_from'} ] ]);
	}
else {
	print "$self->{'text_hash'}->{'htaccess_from'}\n";
	}
print $self->ui_textbox("dir", $self->{'access_hash'}->{'dir'}, 30)." ".
	$self->file_chooser_button("dir", 1, 1);
print $self->ui_form_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

