#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_authusers.cgi
# Displays a list of users from a text file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

&ModuleLoader::preload_module('apache_class', "apache::AuthLib");
$self = new apache::AuthLib:: 'apache_class',%$self;


$self->{'conf'} = $self->get_config();
$self->ReadParse();
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->text('authu_ecannot', $self->{'in_hash'}->{'file'}));
$self->{'desc'} = $self->text('authu_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'authu_title'}, "");
$self->{'f'} = $self->server_root($self->{'in_hash'}->{'file'}, $self->{'conf'});

@{$self->{'users_array'}} = sort { $a cmp $b } $self->list_authusers($self->{'f'});
if (@{$self->{'users_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>",$self->text('authu_header2', "<tt>$self->{'f'}</tt>"),
	      "</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	for($i=0; $i<@{$self->{'users_array'}}; $i++) {
		$self->{'u'} = $self->{'users_array'}->[$i];
		if ($i%4 == 0) { print "<tr>\n"; }
		printf "<td width=25%%><a href=\"edit_authuser.cgi?user=$self->{'u'}&".
		  "file=%s&url=%s\">$self->{'u'}</a></td>\n",
		  $self->urlize($self->{'f'}), $self->urlize($self->this_url());
		if ($i%4 == 3) { print "</tr>\n"; }
		}
	while($i++%4) { print "<td width=25%></td>\n"; }
	print "</table></td></tr></table>\n";
	}
else {
	print "<b>",$self->text('authu_none', "<tt>$self->{'f'}</tt>"),"</b><p>\n";
	}
printf "<a href=\"edit_authuser.cgi?file=%s&url=%s\">%s</a><p>\n",
        $self->urlize($self->{'f'}), $self->urlize($self->this_url()), $self->{'text_hash'}->{'authu_add'};

print "<hr>\n";
$self->{'s'} = $self->{'config_hash'}->{"sync_$self->{'f'}"};
print "<form action=save_sync.cgi>\n";
print "$self->{'text_hash'}->{'authu_sync'} <p>\n";
print "<input type=hidden name=file value='$self->{'f'}'>\n";
print "<input type=hidden name=url value='$self->{'in_hash'}->{'url'}'>\n";
printf "<input type=checkbox name=sync value=create %s> %s<br>\n",
	$self->{'s'} =~ /create/ ? 'checked' : '', $self->{'text_hash'}->{'authu_screate'};
printf "<input type=checkbox name=sync value=modify %s> %s<br>\n",
	$self->{'s'} =~ /modify/ ? 'checked' : '', $self->{'text_hash'}->{'authu_smodify'};
printf "<input type=checkbox name=sync value=delete %s> %s<br>\n",
	$self->{'s'} =~ /delete/ ? 'checked' : '', $self->{'text_hash'}->{'authu_sdelete'};
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer($self->{'in_hash'}->{'url'}, $self->{'text_hash'}->{'auth_return'});

1;
		
}


1;

