#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_gmime_type.cgi
# Add or change a MIME type

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'}==1 || $self->error($self->{'text_hash'}->{'mime_ecannot'});

$self->error_setup($self->{'text_hash'}->{'mime_err'});
if ($self->{'in_hash'}->{'type'} !~ /^(\S+)\/(\S+)$/) {
	$self->error($self->text('mime_etype', $self->{'in_hash'}->{'type'}));
	}

$self->lock_file($self->{'in_hash'}->{'file'});
open(MIME, $self->{'in_hash'}->{'file'});
@{$self->{'mime_array'}} = <MIME>;
close(MIME);
$self->{'line'} = "$self->{'in_hash'}->{'type'} ".join(" ", split(/\s+/, $self->{'in_hash'}->{'exts'}))."\n";
if ($self->{'in_hash'}->{'line'}) {
	$self->{'mime_array'}->[$self->{'in_hash'}->{'line'}] = $self->{'line'};
	}
else {
	push(@{$self->{'mime_array'}}, $self->{'line'});
	}
$self->open_tempfile(MIME, "> $self->{'in_hash'}->{'file'}");
$self->print_tempfile(MIME, @{$self->{'mime_array'}});
$self->close_tempfile(MIME);
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->webmin_log("mime", $self->{'in_hash'}->{'line'} ? 'modify' : 'create', $self->{'in_hash'}->{'type'}, \%{$self->{'in_hash'}});
$self->redirect("edit_global.cgi?type=6");

1;
		
}


1;

