#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_htaccess.cgi
# Save some kind of per-directory options file

&ModuleLoader::preload_module('apache_class', "apache::ApacheLib");
$self = new apache::ApacheLib:: 'apache_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'htaccess_ecannot'});
$self->{'access_types_hash'}->{$self->{'in_hash'}->{'type'}} ||
	$self->error($self->{'text_hash'}->{'etype'});
$self->allowed_auth_file($self->{'in_hash'}->{'file'}) ||
	$self->error($self->{'text_hash'}->{'htindex_ecannot'});
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'htaccess');

$self->lock_file($self->{'in_hash'}->{'file'});
$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->{'conf'});
$self->unlock_file($self->{'in_hash'}->{'file'});
$self->webmin_log("htaccess", $self->{'in_hash'}->{'type'}, $self->{'in_hash'}->{'file'}, \%{$self->{'in_hash'}});

$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));
1;
		
}


1;

