#!/usr/bin/perl
package at::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'at::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "at::AtLib");
$self = new at::AtLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'config_hash'}->{'at_dir'});
while($self->{'f'} = readdir(DIR)) {
	next if ($self->{'f'} eq "." || $self->{'f'} eq ".." || $self->{'f'} eq ".SEQ");
	if (!-d "$self->{'config_hash'}->{'at_dir'}/$self->{'f'}") {
		push(@rv, "$self->{'config_hash'}->{'at_dir'}/$self->{'f'}");
		}
	}
return @rv;
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return undef;
}


1;

