#!/usr/bin/perl
package at::MacosLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'at::MacosLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# macos-lib.pl

1;
		return $self;
}

sub list_atjobs
{
	my $self = shift;

local @rv;
opendir(DIR, $self->{'config_hash'}->{'at_dir'});
while($self->{'f'} = readdir(DIR)) {
	local $p = "$self->{'config_hash'}->{'at_dir'}/$self->{'f'}";
	if ($self->{'f'} =~ /^a(\S+)\.(\d+)$/) {
		local @st = stat($p);
		local $job = { 'id' => $self->{'f'},
			       'date' => hex($1)*60,
			       'user' => scalar(getpwuid($st[4])),
			       'created' => $st[9] };
		open(FILE, $p);
		while(<FILE>) {
			$job->{'cmd'} .= $_;
			}
		close(FILE);
		$job->{'realcmd'} = $job->{'cmd'};
		$job->{'realcmd'} =~ s/^[\000-\177]+cd\s+(\S+)\n//;
		push(@rv, $job);
		}
	}
closedir(DIR);
return @rv;
}

# create_atjob(user, time, commands, directory)
sub create_atjob
{
	my $self = shift;

local @tm = localtime($_[1]);
local $date = sprintf "%2.2d:%2.2d %d.%d.%d",
		$tm[2], $tm[1], $tm[3], $tm[4]+1, $tm[5]+1900;
$self->open_execute_command(*AT, "su \"$_[0]\" -c \"cd $_[3] ; at $date\" >/dev/null 2>&1", 0); 
print AT $_[2];
close(AT);
$self->additional_log('exec', undef, "su \"$_[0]\" -c \"cd $_[3] ; at $date\"");
}

# delete_atjob(id)
sub delete_atjob
{
	my $self = shift;

$self->system_logged("atrm \"$_[0]\" >/dev/null 2>&1");
}


1;

