#!/usr/bin/perl
package bind8::Feedback_files;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bind8::Feedback_files');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: ref($self), %$self; 

1;

1;
		return $self;
}

sub feedback_files
{
	my $self = shift;

local @rv = ( $self->make_chroot($self->{'config_hash'}->{'named_conf'}) );
local $conf = $self->get_config();
local @views = $self->find("view", $conf);
local @zones;
foreach $v (@views) {
	push(@zones, $self->find("zone", $v->{'members'}));
	}
push(@zones, $self->find("zone", $conf));
foreach $z (@zones) {
	local $tv = $self->find("type", $z->{'members'});
	if ($tv->{'value'} eq 'primary') {
		local $fv = $self->find("file", $z->{'members'});
		if ($fv) {
			push(@rv, $fv->{'value'});
			}
		}
	}
return @rv;
}


1;

