#!/usr/bin/perl
package bind8::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'bind8::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns a list of structures containing extra log files known to this module
sub syslog_getlogs
{
	my $self = shift;

local $conf = $self->get_config();
local $logging = $self->find("logging", $conf);
return ( ) if (!$logging);
local @chans = $self->find("channel", $logging->{'members'});
local @rv;
foreach my $c (@chans) {
	local $file = $self->find("file", $c->{'members'});
	if ($file) {
		push(@rv, { 'file' => $file->{'values'}->[0],
			    'active' => 1,
			    'desc' => $self->{'text_hash'}->{'syslog_desc'} });
		}
	}
return @rv;
}


1;

