#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_acls.cgi
# Display global ACLs

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'acls_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'acls_title'}, "");

$self->{'conf'} = $self->get_config();
@{$self->{'acls_array'}} = ( $self->find("acl", $self->{'conf'}), { } );

print "<form action=save_acls.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'acls_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'acls_values'}</b></td> </tr>\n";
for($i=0; $i<@{$self->{'acls_array'}}; $i++) {
	print "<tr $self->{'cb'}>\n";
	printf "<td valign=top><input name=name_$i size=15 value='%s'></td>\n",
		$self->{'acls_array'}->[$i]->{'value'};
	@{$self->{'vals_array'}} = map { $_->{'name'} } @{$self->{'acls_array'}->[$i]->{'members'}};
	print "<td><textarea rows=2 cols=60 name=values_$i wrap=auto>",
		join(" ", @{$self->{'vals_array'}}),"</textarea></td> </tr>\n";
	}
print "</table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

