#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_keys.cgi
# Display options for other DNS servers

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'keys_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'keys_title'}, "");

$self->{'conf'} = $self->get_config();
@{$self->{'keys_array'}} = ( $self->find("key", $self->{'conf'}), { } );

print "<form action=save_keys.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'keys_id'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'keys_alg'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'keys_secret'}</b></td> </tr>\n";
for($i=0; $i<@{$self->{'keys_array'}}; $i++) {
	$self->{'k'} = $self->{'keys_array'}->[$i];
	print "<tr $self->{'cb'}>\n";
	printf "<td><input name=id_$i size=15 value='%s'></td>\n",
		$self->{'k'}->{'value'};

	@{$self->{'algs_array'}} = ( "hmac-md5" );
	$self->{'alg'} = $self->find_value("algorithm", $self->{'k'}->{'members'});
	print "<td><select name=alg_$i>\n";
	local $found;
	foreach $a (@{$self->{'algs_array'}}) {
		printf "<option %s>%s\n", $self->{'alg'} eq $a ? "selected" : "", $a;
		$found++ if ($self->{'alg'} eq $a);
		}
	print "<option selected>$self->{'alg'}\n" if (!$found && $self->{'alg'});
	print "</select></td>\n";

	printf "<td><input name=secret_$i size=64 value='%s'></td> </tr>\n",
		$self->find_value("secret", $self->{'k'}->{'members'});
	}
print "</table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

