#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_misc.cgi
# Display miscellaneous options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'misc_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'misc_title'}, "");

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'mems'} = $self->{'options'}->{'members'};

print "<form action=save_misc.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'misc_core'}, 'coresize', $self->{'mems'}, $self->{'text_hash'}->{'default'}, 8);
print $self->opt_input($self->{'text_hash'}->{'misc_data'}, 'datasize', $self->{'mems'}, $self->{'text_hash'}->{'default'}, 8);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'misc_files'}, 'files', $self->{'mems'}, $self->{'text_hash'}->{'default'}, 8);
print $self->opt_input($self->{'text_hash'}->{'misc_stack'}, 'stacksize', $self->{'mems'}, $self->{'text_hash'}->{'default'}, 8);
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'misc_clean'}, 'cleaning-interval', $self->{'mems'},
		 $self->{'text_hash'}->{'default'}, 8, "$self->{'text_hash'}->{'misc_mins'}");
print $self->opt_input($self->{'text_hash'}->{'misc_iface'}, 'interface-interval', $self->{'mems'},
		 $self->{'text_hash'}->{'default'}, 8, "$self->{'text_hash'}->{'misc_mins'}");
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'misc_stats'}, 'statistics-interval', $self->{'mems'},
		 $self->{'text_hash'}->{'default'}, 8, "$self->{'text_hash'}->{'misc_mins'}");
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'misc_recursion'}, 'recursion', $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, 'yes', $self->{'text_hash'}->{'no'}, 'no',
		    $self->{'text_hash'}->{'default'}, undef);
print $self->choice_input($self->{'text_hash'}->{'misc_cnames'}, 'multiple-cnames', $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, 'yes', $self->{'text_hash'}->{'no'}, 'no',
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'misc_glue'}, 'fetch-glue', $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, 'yes', $self->{'text_hash'}->{'no'}, 'no',
		    $self->{'text_hash'}->{'default'}, undef);
print $self->choice_input($self->{'text_hash'}->{'misc_nx'}, 'auth-nxdomain', $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, 'yes', $self->{'text_hash'}->{'no'}, 'no',
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

