#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_files.cgi
# Display global files options

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'net_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "");

$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'mems'} = $self->{'options'}->{'members'};

print "<form action=save_net.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_listen'}</b></td> <td colspan=3>\n";
@{$self->{'listen_array'}} = $self->find("listen-on", $self->{'mems'});
printf "<input type=radio name=listen_def value=1 %s> %s\n",
	@{$self->{'listen_array'}} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=listen_def value=0 %s> %s<br>\n",
	@{$self->{'listen_array'}} ? "checked" : "", $self->{'text_hash'}->{'net_below'};

print "<table width=100% border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_port'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'net_addrs'}</b></td> </tr>\n";
push(@{$self->{'listen_array'}}, { });
for($i=0; $i<@{$self->{'listen_array'}}; $i++) {
	printf "<tr $self->{'cb'}> <td><input type=radio name=pdef_$i value=1 %s> %s\n",
		$self->{'listen_array'}->[$i]->{'value'} eq 'port' ? "" : "checked",
		$self->{'text_hash'}->{'default'};
	printf "<input type=radio name=pdef_$i value=0 %s>\n",
		$self->{'listen_array'}->[$i]->{'value'} eq 'port' ? "checked" : "";
	printf "<input name=port_$i size=5 value='%s'></td>\n",
		$self->{'listen_array'}->[$i]->{'value'} eq 'port' ?
			$self->{'listen_array'}->[$i]->{'values'}->[1] : "";

	@{$self->{'vals_array'}} = map { $_->{'name'} } @{$self->{'listen_array'}->[$i]->{'members'}};
	printf "<td><input name=addrs_$i size=50 value='%s'></td> </tr>\n",
		join(" ", @{$self->{'vals_array'}});
	}
print "</table></td></tr>\n";

$self->{'src'} = $self->find("query-source", $self->{'mems'});
$self->{'srcstr'} = join(" ", @{$self->{'src'}->{'values'}});
$self->{'sport'} = $1 if ($self->{'srcstr'} =~ /port\s+(\d+)/i);
$self->{'saddr'} = $1 if ($self->{'srcstr'} =~ /address\s+([0-9\.]+)/i);
print "<tr> <td><b>$self->{'text_hash'}->{'net_saddr'}</b></td> <td>\n";
printf "<input type=radio name=saddr_def value=1 %s> %s\n",
	$self->{'saddr'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=saddr_def value=0 %s>\n",
	$self->{'saddr'} ? "checked" : "";
printf "<input name=saddr size=15 value='%s'></td>\n", $self->{'saddr'};
print "<td><b>$self->{'text_hash'}->{'net_sport'}</b></td> <td>\n";
printf "<input type=radio name=sport_def value=1 %s> %s\n",
	$self->{'sport'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=sport_def value=0 %s>\n",
	$self->{'sport'} ? "checked" : "";
printf "<input name=sport size=5 value='%s'></td> </tr>\n", $self->{'sport'};

print "<tr>\n";
print $self->addr_match_input($self->{'text_hash'}->{'net_topol'}, 'topology', $self->{'mems'}, 1);
print $self->addr_match_input($self->{'text_hash'}->{'net_recur'}, 'allow-recursion', $self->{'mems'}, 1);
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

