#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_zonedef.cgi
# Display defaults for master zones

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'zonedef_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'zonedef_title'}, "");

print "<form action=save_zonedef.cgi>\n";

$self->get_zone_defaults(\%{$self->{'zd_hash'}});
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'zonedef_msg'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table cellpadding=5>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'master_refresh'}</b></td>\n";
print "<td><input name=refresh size=10 value='$self->{'zd_hash'}->{'refresh'}'>\n";
print $self->time_unit_choice("refunit", $self->{'zd_hash'}->{'refunit'});
print "</td>\n";
print "<td><b>$self->{'text_hash'}->{'master_retry'}</b></td>\n";
print "<td><input name=retry size=10 value='$self->{'zd_hash'}->{'retry'}'>\n";
print $self->time_unit_choice("retunit", $self->{'zd_hash'}->{'retunit'});
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'master_expiry'}</b></td>\n";
print "<td><input name=expiry size=10 value='$self->{'zd_hash'}->{'expiry'}'>\n";
print $self->time_unit_choice("expunit", $self->{'zd_hash'}->{'expunit'});
print "</td>\n";
print "<td><b>$self->{'text_hash'}->{'master_minimum'}</b></td>\n";
print "<td><input name=minimum size=10 value='$self->{'zd_hash'}->{'minimum'}'>\n";
print $self->time_unit_choice("minunit", $self->{'zd_hash'}->{'minunit'});
print "</td>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'master_tmplrecs'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'master_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'master_type'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'master_value'}</b></td> </tr>\n";
for($i=0; $i<2 || $self->{'config_hash'}->{"tmpl_".($i-1)}; $i++) {
	@c = split(/\s+/, $self->{'config_hash'}->{"tmpl_$i"}, 3);
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=name_$i size=15 value='$c[0]'></td>\n";
	print "<td><select name=type_$i>\n";
	foreach $t ('A', 'CNAME', 'MX', 'NS', 'TXT', 'HINFO') {
		printf "<option value=%s %s>%s\n",
			$t, $c[1] eq $t ? 'selected' : '', $self->{'text_hash'}->{"type_$t"};
		}
	print "</select></td>\n";
	printf "<td><input type=radio name=def_$i value=1 %s> %s\n",
		$c[2] ? '' : 'checked', $self->{'text_hash'}->{'master_user'};
	printf "<input type=radio name=def_$i value=0 %s>\n",
		$c[2] ? 'checked' : '';
	print "<input name=value_$i size=15 value='$c[2]'></td> </tr>\n";
	}
print "</table>\n";

print "<b>$self->{'text_hash'}->{'master_include'}</b>\n";
printf "<input name=include size=40 value='%s'> %s\n",
	$self->{'config_hash'}->{'tmpl_include'}, $self->file_chooser_button("include");
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'zonedef_email'}</b></td>\n";
print "<td colspan=3>",$self->ui_textbox("email", $self->{'config_hash'}->{'tmpl_email'}, 40),
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'zonedef_prins'}</b></td>\n";
print "<td colspan=3>",$self->ui_opt_textbox("prins", $self->{'config_hash'}->{'default_prins'}, 30,
		$self->text('zonedef_this', "<tt>".$self->get_system_hostname()."</tt>")),
		"</td> </tr>\n";

print "</tr> </table></td></tr></table><br>\n";

$self->{'conf'} = $self->get_config();
$self->{'options'} = $self->find("options", $self->{'conf'});
$self->{'mems'} = $self->{'options'}->{'members'};
foreach $c ($self->find("check-names", $self->{'mems'})) {
	$self->{'check_hash'}->{$c->{'values'}->[0]} = $c->{'values'}->[1];
	}

print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'zonedef_msg2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr>\n";
print $self->addr_match_input($self->{'text_hash'}->{'zonedef_transfer'}, "allow-transfer", $self->{'mems'});
print $self->addr_match_input($self->{'text_hash'}->{'zonedef_query'}, "allow-query", $self->{'mems'});
print "</tr>\n";

print "<tr>\n";
&ignore_warn_fail($self->{'text_hash'}->{'zonedef_cmaster'}, 'master', $self->{'check_hash'}->{'master'});
&ignore_warn_fail($self->{'text_hash'}->{'zonedef_cslave'}, 'slave', $self->{'check_hash'}->{'slave'});
print "</tr>\n";

print "<tr>\n";
&ignore_warn_fail($self->{'text_hash'}->{'zonedef_cresponse'}, 'response', $self->{'check_hash'}->{'response'});
print $self->choice_input($self->{'text_hash'}->{'zonedef_notify'}, "notify", $self->{'mems'},
		    $self->{'text_hash'}->{'yes'}, "yes", $self->{'text_hash'}->{'no'}, "no",
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "</tr> </table></td></tr></table><br>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# ignore_warn_fail(text, name, value)
sub ignore_warn_fail
{
	shift if ($self == $_[0]);

print "<td><b>$_[0]</b></td> <td>\n";
printf "<input type=radio name=$_[1] value=ignore %s> $self->{'text_hash'}->{'ignore'}\n",
	$_[2] eq 'ignore' ? 'checked' : '';
printf "<input type=radio name=$_[1] value=warn %s> $self->{'text_hash'}->{'warn'}\n",
	$_[2] eq 'warn' ? 'checked' : '';
printf "<input type=radio name=$_[1] value=fail %s> $self->{'text_hash'}->{'fail'}\n",
	$_[2] eq 'fail' ? 'checked' : '';
printf "<input type=radio name=$_[1] value='' %s> $self->{'text_hash'}->{'default'}</td>\n",
	!$_[2] ? 'checked' : '';
}


1;

