#!/usr/bin/perl

&MAIN();

 sub MAIN {
# convert_master.cgi
# Convert a master zone into a slave

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}]->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->error_setup($self->{'text_hash'}->{'convert_err'});
$self->lock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->{'access_hash'}->{'slave'} || $self->error($self->{'text_hash'}->{'screate_ecannot1'});

# Change the type directive
$self->save_directive($self->{'zconf'}, 'type', [ { 'name' => 'type',
				    'values' => [ 'slave' ] } ], 1);

# Add a masters section
if ($self->{'config_hash'}->{'default_master'}) {
	@{$self->{'mdirs_array'}} = map { { 'name' => $_ } } split(/\s+/, $self->{'config_hash'}->{'default_master'});
	$self->save_directive($self->{'zconf'}, 'masters', [ { 'name' => 'masters',
					       'type' => 1,
					       'members' => \@{$self->{'mdirs_array'}} } ], 1);
	}

# Take out directives not allowed in slaves
$self->save_directive($self->{'zconf'}, 'allow-update', [ ], 1);

$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'zconf'}->{'file'}));
$self->redirect("");

1;
		
}


1;

