#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_zone.cgi
# Delete an existing view and all its zones

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'pconf'} = $self->get_config_parent();
$self->{'conf'} = $self->{'pconf'}->{'members'};
$self->{'vconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
$self->{'access_hash'}->{'views'} || $self->error($self->{'text_hash'}->{'view_ecannot'});

if (!$self->{'in_hash'}->{'confirm'}) {
	# Ask the user if he is sure ..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'vdelete_title'}, "");

	@{$self->{'zones_array'}} = $self->find("zone", $self->{'vconf'}->{'members'});
	print "<center><p>",$self->text(@{$self->{'zones_array'}} ? 'vdelete_mesg' : 'vdelete_mesg2',
				  "<tt>$self->{'vconf'}->{'value'}</tt>"),"<p>\n";
	print "<form action=delete_view.cgi>\n";
	print "<input type=hidden name=index value=$self->{'in_hash'}->{'index'}>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'delete'}'><br>\n";
	if (@{$self->{'zones_array'}}) {
		print "<b>$self->{'text_hash'}->{'vdelete_newview'}</b>\n";
		print "<input type=radio name=mode value=0> ",
		      "$self->{'text_hash'}->{'vdelete_delete'}\n";
		print "<input type=radio name=mode value=1 checked> ",
		      "$self->{'text_hash'}->{'vdelete_root'}\n";
		@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
		if (@{$self->{'views_array'}} > 1) {
			print "<input type=radio name=mode value=2> ",
			      "$self->{'text_hash'}->{'vdelete_move'}\n";
			print "<select name=newview>\n";
			foreach $v (@{$self->{'views_array'}}) {
				if ($v->{'index'} != $self->{'in_hash'}->{'index'}) {
					printf "<option value=%d>%s\n",
						$v->{'index'}, $v->{'value'};
					}
				}
			print "</select>\n";
			}
		print "<br>\n";
		}
	print "</form></center>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

# deal with the zones in this view
@{$self->{'zones_array'}} = $self->find("zone", $self->{'vconf'}->{'members'});
if ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'dest'} = $self->{'pconf'};
	}
else {
	$self->{'dest'} = $self->{'conf'}->[$self->{'in_hash'}->{'newview'}];
	}
$self->lock_file($self->make_chroot($self->{'dest'}->{'file'}));
foreach $z (@{$self->{'zones_array'}}) {
	local $type = $self->find_value("type", $z->{'members'});
	next if (!$type || $type eq 'hint');
	if ($self->{'in_hash'}->{'mode'} == 0) {
		# Delete the records file
		local $file = $self->find_value("file", $z->{'members'});
		if ($file) {
			$self->lock_file($self->make_chroot($self->absolute_path($file)));
			unlink($self->make_chroot($self->absolute_path($file)));
			}
		}
	else {
		# Move to another view or the top level
		$self->save_directive($self->{'dest'}, undef, [ $z ], $self->{'in_hash'}->{'mode'} == 2 ? 1 : 0);
		}
	}
$self->flush_file_lines();

# remove the view directive
$self->lock_file($self->make_chroot($self->{'vconf'}->{'file'}));
$self->{'lref'} = $self->read_file_lines($self->make_chroot($self->{'vconf'}->{'file'}));
splice(@{$self->{'lref'}}, $self->{'vconf'}->{'line'}, $self->{'vconf'}->{'eline'} - $self->{'vconf'}->{'line'} + 1);
$self->flush_file_lines();
$self->unlock_all_files();
$self->webmin_log("delete", "view", $self->{'vconf'}->{'value'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

