#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_forward.cgi
# Display options for an existing forward zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'bconf'} = $self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'members'};
$self->{'dom'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'value'};
$self->can_edit_zone($self->{'conf'}->[$self->{'in_hash'}->{'index'}], $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'fwd_ecannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'fwd_title'}, "");

print "<form action=save_forward.cgi>\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'fwd_opts'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->forwarders_input($self->{'text_hash'}->{'fwd_masters'}, "forwarders", $self->{'zconf'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'fwd_forward'}, "forward", $self->{'zconf'},
		    $self->{'text_hash'}->{'yes'}, "first", $self->{'text_hash'}->{'no'}, "only",
		    $self->{'text_hash'}->{'default'}, undef);
print $self->choice_input($self->{'text_hash'}->{'fwd_check'}, "check-names", $self->{'zconf'},
		    $self->{'text_hash'}->{'warn'}, "warn", $self->{'text_hash'}->{'fail'}, "fail",
		    $self->{'text_hash'}->{'ignore'}, "ignore", $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "</table></td></tr> </table>\n";

if ($self->{'access_hash'}->{'ro'}) {
	print "</form>\n";
	}
else {
	print "<table width=100%><tr><td align=left>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td></form>\n";

	@{$self->{'views_array'}} = $self->find("view", $self->{'bconf'});
	if ($self->{'in_hash'}->{'view'} eq '' && @{$self->{'views_array'}} || $self->{'in_hash'}->{'view'} ne '' && @{$self->{'views_array'}} > 1) {
		print "<form action=move_zone.cgi>\n";
		print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
		print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
		print "<td width=33% align=middle>\n";
		print "<input type=submit value=\"$self->{'text_hash'}->{'master_move'}\">\n";
		print "<select name=newview>\n";
		foreach $v (@{$self->{'views_array'}}) {
			printf "<option value=%d>%s\n",
			    $v->{'index'}, $v->{'value'}
				if ($v->{'index'} ne $self->{'in_hash'}->{'view'});
			}
		print "</select></td></form>\n";
		}
	else {
		print "<td></td>\n";
		}

	print "<form action=delete_zone.cgi>\n";
	print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
	print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
	print "<td align=right><input type=submit ",
	      "value=\"$self->{'text_hash'}->{'delete'}\"></td></form>\n";
	print "</tr></table>\n";
	}
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

