#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_options.cgi
# Display options for an existing master zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'bconf'} = $self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'members'};
$self->{'dom'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'value'};
$self->can_edit_zone($self->{'conf'}->[$self->{'in_hash'}->{'index'}], $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'master_ecannot'});
$self->{'access_hash'}->{'opts'} || $self->error($self->{'text_hash'}->{'master_eoptscannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'master_opts'}, "");

# Form for editing zone options
print "<a name=options>\n";
print "<form action=save_master.cgi>\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'master_opts'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'master_check'}, "check-names", $self->{'zconf'},
		    $self->{'text_hash'}->{'warn'}, "warn", $self->{'text_hash'}->{'fail'}, "fail",
		    $self->{'text_hash'}->{'ignore'}, "ignore", $self->{'text_hash'}->{'default'}, undef);
print $self->choice_input($self->{'text_hash'}->{'master_notify'}, "notify", $self->{'zconf'},
		    $self->{'text_hash'}->{'yes'}, "yes", $self->{'text_hash'}->{'no'}, "no",
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "<tr>\n";
print $self->address_input($self->{'text_hash'}->{'master_update'}, "allow-update", $self->{'zconf'});
print $self->address_input($self->{'text_hash'}->{'master_transfer'}, "allow-transfer", $self->{'zconf'});
print "</tr>\n";

print "<tr>\n";
print $self->address_input($self->{'text_hash'}->{'master_query'}, "allow-query", $self->{'zconf'});
print $self->address_input($self->{'text_hash'}->{'master_notify2'}, "also-notify", $self->{'zconf'});
print "</tr>\n";

print "</table></td></tr> </table>\n";
print "<table width=100%><tr>\n";
print "<td width=33%><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td></form>\n";

@{$self->{'views_array'}} = grep { $self->can_edit_view($_) } $self->find("view", $self->{'bconf'});
if ($self->{'in_hash'}->{'view'} eq '' && @{$self->{'views_array'}} || $self->{'in_hash'}->{'view'} ne '' && @{$self->{'views_array'}} > 1) {
	print "<form action=move_zone.cgi>\n";
	print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
	print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
	print "<td width=33% align=middle>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'master_move'}\">\n";
	print "<select name=newview>\n";
	foreach $v (@{$self->{'views_array'}}) {
		printf "<option value=%d>%s\n", $v->{'index'}, $v->{'value'}
			if ($v->{'index'} ne $self->{'in_hash'}->{'view'});
		}
	print "</select></td></form>\n";
	}
else {
	print "<td width=33%></td>\n";
	}

if ($self->{'access_hash'}->{'slave'}) {
	print "<form action=convert_master.cgi>\n";
	print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
	print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
	print "<td width=33% align=right>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'master_convert'}\">\n";
	print "</td></form>\n";
	}
else {
	print "<td width=33%></td>\n";
	}
print "</tr></table>\n";

$self->ui_print_footer("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'master_return'});

1;
		
}


1;

