#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_soptions.cgi
# Display options for an existing slave or stub zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'bconf'} = $self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'view'} ne '') {
	$self->{'view'} = $self->{'conf'}->[$self->{'in_hash'}->{'view'}];
	$self->{'conf'} = $self->{'view'}->{'members'};
	}
$self->{'zconf'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'members'};
$self->{'file'} = $self->find_value("file", $self->{'zconf'});
$self->{'dom'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}]->{'value'};
$self->can_edit_zone($self->{'conf'}->[$self->{'in_hash'}->{'index'}], $self->{'view'}) ||
	$self->error($self->{'text_hash'}->{'slave_ecannot'});
$self->{'access_hash'}->{'opts'} || $self->error($self->{'text_hash'}->{'slave_ecannot'});
$self->{'desc'} = $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'}));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'master_opts'}, "");

print "<form action=save_slave.cgi>\n";
print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
print "<input type=hidden name=slave_stub value=\"$self->{'scriptname'}\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'slave_opts'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
print $self->address_port_input($self->{'text_hash'}->{'slave_masters'},
			  $self->{'text_hash'}->{'slave_masterport'},
			  $self->{'text_hash'}->{'slave_master_port'}, 
			  $self->{'text_hash'}->{'default'}, 
			  "masters",
			  "port",
			  $self->{'zconf'},
			  5);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'slave_max'}, "max-transfer-time-in",
		 $self->{'zconf'}, $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'slave_mins'});
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'slave_file'}, "file", $self->{'zconf'}, $self->{'text_hash'}->{'slave_none'}, 40);
print "</tr>\n";

print "<tr>\n";
print $self->choice_input($self->{'text_hash'}->{'slave_check'}, "check-names", $self->{'zconf'},
		    $self->{'text_hash'}->{'warn'}, "warn", $self->{'text_hash'}->{'fail'}, "fail",
		    $self->{'text_hash'}->{'ignore'}, "ignore", $self->{'text_hash'}->{'default'}, undef);
print $self->choice_input($self->{'text_hash'}->{'slave_notify'}, "notify", $self->{'zconf'},
		    $self->{'text_hash'}->{'yes'}, "yes", $self->{'text_hash'}->{'no'}, "no",
		    $self->{'text_hash'}->{'default'}, undef);
print "</tr>\n";

print "<tr>\n";
print $self->addr_match_input($self->{'text_hash'}->{'slave_update'}, "allow-update", $self->{'zconf'});
print $self->addr_match_input($self->{'text_hash'}->{'slave_transfer'}, "allow-transfer", $self->{'zconf'});
print "</tr>\n";

print "<tr>\n";
print $self->addr_match_input($self->{'text_hash'}->{'slave_query'}, "allow-query", $self->{'zconf'});
print $self->address_input($self->{'text_hash'}->{'slave_notify2'}, "also-notify", $self->{'zconf'});
print "</tr>\n";

print "</table></td></tr> </table>\n";

print "<table width=100%><tr><td width=25% align=left>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></td></form>\n";

@{$self->{'views_array'}} = $self->find("view", $self->{'bconf'});
if ($self->{'in_hash'}->{'view'} eq '' && @{$self->{'views_array'}} || $self->{'in_hash'}->{'view'} ne '' && @{$self->{'views_array'}} > 1) {
	print "<form action=move_zone.cgi>\n";
	print "<input type=hidden name=index value=\"$self->{'in_hash'}->{'index'}\">\n";
	print "<input type=hidden name=view value=\"$self->{'in_hash'}->{'view'}\">\n";
	print "<td align=center>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'master_move'}\">\n";
	print "<select name=newview>\n";
	foreach $v (@{$self->{'views_array'}}) {
		printf "<option value=%d>%s\n",
		    $v->{'index'}, $v->{'value'}
			if ($v->{'index'} ne $self->{'in_hash'}->{'view'});
		}
	print "</select></td></form>\n";
	}

if ($self->{'access_hash'}->{'master'} && -s $self->make_chroot($self->{'file'})) {
	print "<form action=convert_slave.cgi>\n";
	print "<input type=hidden name=index value='$self->{'in_hash'}->{'index'}'>\n";
	print "<input type=hidden name=view value='$self->{'in_hash'}->{'view'}'>\n";
	print "<td align=right><input type=submit ",
	      "value=\"$self->{'text_hash'}->{'slave_convert'}\"></td></form>\n";
	}
print "</table>\n";

$self->ui_print_footer("edit_slave.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}", $self->{'text_hash'}->{'master_return'});

1;
		
}


1;

