#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_gen.cgi
# Display $generate entries

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'gen'} || $self->error($self->{'text_hash'}->{'gen_ecannot'});
$self->{'zone'} = $self->get_zone_name($self->{'in_hash'}->{'index'}, $self->{'in_hash'}->{'view'});
$self->{'dom'} = $self->{'zone'}->{'name'};
$self->can_edit_zone($self->{'zone'}) ||
	$self->error($self->{'text_hash'}->{'recs_ecannot'});
$self->{'desc'} = $self->text('recs_header', $self->ip6int_to_net($self->arpa_to_ip($self->{'dom'})));
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'gen_title'}, "");

@{$self->{'gens_array'}} = grep { $_->{'generate'} } $self->read_zone_file($self->{'zone'}->{'file'}, $self->{'dom'});
print "$self->{'text_hash'}->{'gen_desc'}<p>\n";
print "<form action=save_gen.cgi method=post>\n";
print "<input type=hidden name=index value='$self->{'in_hash'}->{'index'}'>\n";
print "<input type=hidden name=view value='$self->{'in_hash'}->{'view'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'gen_type'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'gen_range'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'gen_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'gen_value'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'gen_cmt'}</b></td> </tr>\n";
$self->{'i'} = 0;
if ($self->{'bind_version'} >= 9) {
	@{$self->{'types_array'}} = ( 'PTR', 'CNAME', 'NS', 'A', 'AAAA', 'DNAME' );
	}
else {
	@{$self->{'types_array'}} = ( 'PTR', 'CNAME', 'NS' );
	}
foreach $g (@{$self->{'gens_array'}}, { }) {
	@{$self->{'gv_array'}} = @{$g->{'generate'}};
	local @r = $self->{'gv_array'}->[0] =~ /^(\d+)-(\d+)(\/(\d+))?$/ ? ( $1, $2, $4 ) : ( );
	print "<tr $self->{'cb'}>\n";
	print "<td><select name=type_$self->{'i'}>\n";
	foreach $t ('', @{$self->{'types_array'}}) {
		printf "<option value='%s' %s>%s\n",
			$t, lc($self->{'gv_array'}->[2]) eq lc($t) ? "selected" : "",
			$t ? $t : "&nbsp";
		}
	print "</select></td>\n";
	print "<td><input name=start_$self->{'i'} size=3 value='$r[0]'> -";
	print "<input name=stop_$self->{'i'} size=3 value='$r[1]'> $self->{'text_hash'}->{'gen_skip'}\n";
	print "<input name=skip_$self->{'i'} size=3 value='$r[2]'></td>\n";
	print "<td><input name=name_$self->{'i'} size=15 value='$self->{'gv_array'}->[1]'></td>\n";
	print "<td><input name=value_$self->{'i'} size=15 value='$self->{'gv_array'}->[3]'></td>\n";
	$self->{'cmt'} = join(" ", @{$self->{'gv_array'}}[4..$#{$self->{'gv_array'}}]);
	print "<td><input name=cmt_$self->{'i'} size=15 value='$g->{'comment'}'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
print "<td align=right><input type=submit name=show ",
      "value='$self->{'text_hash'}->{'gen_show'}'></td>\n" if (@{$self->{'gens_array'}});
print "</tr></table></form>\n";

$self->ui_print_footer("edit_master.cgi?index=$self->{'in_hash'}->{'index'}&view=$self->{'in_hash'}->{'view'}",
	$self->{'text_hash'}->{'master_return'});

1;
		
}


1;

