#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Form for creating multiple zones from an uploaded file, local file or text

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'mass_title'}, "");

print "$self->{'text_hash'}->{'mass_desc'}<p>\n";

print $self->ui_form_start("mass_create.cgi", "form-data");
print $self->ui_table_start($self->{'text_hash'}->{'mass_header'}, "100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'mass_local'},
		    $self->ui_textbox("local", undef, 40)."\n".
		    $self->file_chooser_button("local"));

print $self->ui_table_row($self->{'text_hash'}->{'mass_upload'},
		    $self->ui_upload("upload", 40));

print $self->ui_table_row($self->{'text_hash'}->{'mass_text'},
		    $self->ui_textarea("text", undef, 5, 40));

print $self->ui_table_row($self->{'text_hash'}->{'mass_tmpl'},
		    $self->ui_yesno_radio("tmpl", 1));

@{$self->{'servers_array'}} = $self->list_slave_servers();
if (@{$self->{'servers_array'}} && $self->{'access_hash'}->{'remote'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'mass_onslave'},
	    $self->ui_radio("onslave", 1,
		[ [ 0, $self->{'text_hash'}->{'no'} ], [ 1, $self->{'text_hash'}->{'master_onslaveyes'} ] ])." ".
	    $self->ui_textbox("mip", $self->{'config_hash'}->{'this_ip'} ||
		 $self->to_ipaddress($self->get_system_hostname()), 30));
	}

@{$self->{'views_array'}} = grep { $_->{'type'} eq 'view' && $self->can_edit_view($_) }
	      $self->list_zone_names();
if (@{$self->{'views_array'}}) {
	print $self->ui_table_row($self->{'text_hash'}->{'mass_view'},
		    $self->ui_select("view", undef,
			[ map { [ $_->{'index'}, $_->{'name'} ] } @{$self->{'views_array'}} ]));
	}

print $self->ui_table_end();
print $self->ui_form_end([ [ "ok", $self->{'text_hash'}->{'mass_ok'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

