#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for changing the IPs in multiple zones

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'umass_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'umass_enone'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'umass_title'}, "");

print $self->ui_form_start("mass_update.cgi", "post");
foreach $d (@d) {
	print $self->ui_hidden("d", $d),"\n";
	$self->{'dc'}++;
	}
print $self->ui_table_start($self->{'text_hash'}->{'umass_header'}, undef, 2);

# Number of domains selected
print $self->ui_table_row($self->{'text_hash'}->{'umass_sel'}, $self->{'dc'});

# Type to change
@{$self->{'rtypes_array'}} = ( 'A', 'CNAME', 'NS', 'MX', 'PTR', 'TXT',
	    $self->{'config_hash'}->{'support_aaaa'} ? ( "AAAA" ) : ( ) );
print $self->ui_table_row($self->{'text_hash'}->{'umass_type'},
	$self->ui_select("type", "A",
		   [ map { [ $_, $self->{'text_hash'}->{'recs_'.$_} ] } @{$self->{'rtypes_array'}} ]));

# Value to change
print $self->ui_table_row($self->{'text_hash'}->{'umass_old'},
		    $self->ui_textbox("old", undef, 15));

# New value
print $self->ui_table_row($self->{'text_hash'}->{'umass_new'},
		    $self->ui_textbox("new", undef, 15));

print $self->ui_table_end();
print $self->ui_form_end([ [ "update", $self->{'text_hash'}->{'umass_ok'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

