#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_keys.cgi
# Update all the key directives

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'keys_ecannot'});
$self->error_setup($self->{'text_hash'}->{'keys_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
@{$self->{'old_array'}} = $self->find("key", $self->{'conf'});
for($i=0; defined($self->{'id'} = $self->{'in_hash'}->{"id_$i"}); $i++) {
	next if (!$self->{'id'});
	$self->{'id'} =~ /^\S+$/ || $self->error($self->text('keys_ekey', $self->{'id'}));
	$self->{'in_hash'}->{"secret_$i"} =~ /^\S+$/ || $self->error($self->text('keys_esecret', $self->{'id'}));
	local $k = { 'name' => 'key',
		     'type' => 1 };
	$k->{'members'} = $self->{'old_array'}->[$i] ? $self->{'old_array'}->[$i]->{'members'} : [ ];
	$k->{'values'} = [ $self->{'id'} ];
	$self->save_directive($k, "algorithm", [ { 'name' => 'algorithm',
				'values' => [ $self->{'in_hash'}->{"alg_$i"} ] } ], 1, 1);
	$self->save_directive($k, "secret", [ { 'name' => 'secret',
				'values' => [ $self->{'in_hash'}->{"secret_$i"} ] } ], 1, 1);
	push(@{$self->{'keys_array'}}, $k);
	}
$self->save_directive($self->get_config_parent(), 'key', \@{$self->{'keys_array'}}, 0);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("keys", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

