#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update a manually edited config file

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->error_setup($self->{'text_hash'}->{'manual_err'});
$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'manual_ecannot'});
$self->ReadParseMime();

# Work out the file
$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = $self->get_all_config_files($self->{'conf'});
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});
$self->{'in_hash'}->{'data'} =~ s/\r//g;
if ($self->{'in_hash'}->{'file'} eq $self->{'files_array'}->[0]) {
	$self->{'in_hash'}->{'data'} =~ /\S/ || $self->error($self->{'text_hash'}->{'manual_edata'});
	}

# Write to it
$self->open_lock_tempfile(DATA, ">".$self->make_chroot($self->{'in_hash'}->{'file'}));
$self->print_tempfile(DATA, $self->{'in_hash'}->{'data'});
$self->close_tempfile(DATA);

$self->webmin_log("manual", undef, $self->{'in_hash'}->{'file'});
$self->redirect("");

1;
		
}


1;

