#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_servers.cgi
# Update all the server directives

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'access_hash'}->{'defaults'} || $self->error($self->{'text_hash'}->{'servers_ecannot'});
$self->error_setup($self->{'text_hash'}->{'servers_err'});
$self->ReadParse();

$self->lock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->{'conf'} = $self->get_config();
@{$self->{'old_array'}} = $self->find("server", $self->{'conf'});
for($i=0; defined($self->{'ip'} = $self->{'in_hash'}->{"ip_$i"}); $i++) {
	next if (!$self->{'ip'});
	$self->check_ipaddress($self->{'ip'}) || $self->error($self->text('servers_eip', $self->{'ip'}));
	$self->{'in_hash'}->{"trans_$i"} =~ /^\d*$/ ||
		$self->error($self->text('servers_etrans', $self->{'in_hash'}->{"trans_$i"}));
	local $s = { 'name' => 'server',
		     'type' => 1 };
	$s->{'members'} = $self->{'old_array'}->[$i] ? $self->{'old_array'}->[$i]->{'members'} : [ ];
	$s->{'values'} = [ $self->{'ip'} ];
	$self->save_directive($s, 'bogus',
		$self->{'in_hash'}->{"bogus_$i"} ? [ { 'name' => 'bogus',
				      'values' => [ 'yes' ] } ] : [ ], 1, 1);
	$self->save_directive($s, 'transfer-format',
		$self->{'in_hash'}->{"format_$i"} ? [ { 'name' => 'transfer-format',
				       'values' => [ $self->{'in_hash'}->{"format_$i"} ] } ]
				 : [ ], 1, 1);
	$self->save_directive($s, 'transfers',
		$self->{'in_hash'}->{"trans_$i"} ne '' ? [ { 'name' => 'transfers',
				            'values' => [ $self->{'in_hash'}->{"trans_$i"} ] } ]
				      : [ ], 1, 1);

	@{$self->{'keys_array'}} = split(/\0/, $self->{'in_hash'}->{"keys_$i"});
	if (@{$self->{'keys_array'}}) {
		local @mems = map { { 'name' => $_ } } @{$self->{'keys_array'}};
		$self->save_directive($s, 'keys',
			[ { 'name' => 'keys',
			    'type' => 1,
			    'members' => \@mems } ], 1, 1);
		}
	else {
		$self->save_directive($s, 'keys', [ ], 1, 1);
		}
		
	push(@{$self->{'servers_array'}}, $s);
	}
$self->save_directive($self->get_config_parent(), 'server', \@{$self->{'servers_array'}}, 0);
$self->flush_file_lines();
$self->unlock_file($self->make_chroot($self->{'config_hash'}->{'named_conf'}));
$self->webmin_log("servers", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

