#!/usr/bin/perl

&MAIN();

 sub MAIN {
# slave_form.cgi
# A form for creating a new slave or stub zone

&ModuleLoader::preload_module('bind8_class', "bind8::Bind8Lib");
$self = new bind8::Bind8Lib:: 'bind8_class',%$self;

$self->{'type'} = ($0 =~ /slave_form/);
$self->{'access_hash'}->{'slave'} || $self->error($self->{'type'} ? $self->{'text_hash'}->{'screate_ecannot1'}
				 : $self->{'text_hash'}->{'screate_ecannot2'});
$self->ui_print_header(undef, $self->{'type'} ? $self->{'text_hash'}->{'screate_title1'} : $self->{'text_hash'}->{'screate_title2'}, "");

print "<form action=create_slave.cgi>\n";
print "<input type=hidden name=type value=\"$self->{'type'}\">\n";
print "<table border width=100%>\n";
print "<tr> <td $self->{'tb'}><b>",$self->{'type'} ? $self->{'text_hash'}->{'screate_header1'}
			       : $self->{'text_hash'}->{'screate_header2'},"</b></td> </tr>\n";
print "<tr> <td $self->{'cb'}><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'screate_type'}</b></td>\n";
print "<td colspan=3><input type=radio name=rev value=0 checked>\n";
print "$self->{'text_hash'}->{'screate_fwd'}\n";
print "&nbsp;&nbsp;<input type=radio name=rev value=1>\n";
print "$self->{'text_hash'}->{'screate_rev'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'screate_dom'}</b></td>\n";
print "<td colspan=3><input name=zone size=40></td> </tr>\n";

$self->{'conf'} = $self->get_config();
@{$self->{'views_array'}} = $self->find("view", $self->{'conf'});
if (@{$self->{'views_array'}}) {
        print "<tr> <td><b>$self->{'text_hash'}->{'mcreate_view'}</b></td><td>\n";
	print $self->ui_select("view", undef,
	        [ map ({ [ $_->{'index'}, $_->{'value'} ] }
		     grep { $self->can_edit_view($_) } @{$self->{'views_array'}}) ,
		 ['', 'in the included file'] ]);
        print "</td></tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'slave_file'}</b></td> <td colspan=3>\n";
print "<input type=radio name=file_def value=1> $self->{'text_hash'}->{'slave_none'}\n";
print "<input type=radio name=file_def value=2 checked> $self->{'text_hash'}->{'slave_auto'}\n";
print "<input type=radio name=file_def value=0>\n";
print "<input name=file size=30>",$self->file_chooser_button("file"),"</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'slave_masters'}</b></td> <td>\n";
print "<textarea name=masters rows=4 cols=30>",
	join("\n", split(/\s+/, $self->{'config_hash'}->{'default_master'})),"</textarea></td>";
print "<td valign=top><b>$self->{'text_hash'}->{'slave_masterport'}</b></td> <td valign=top>\n";
print "<input type=radio name=port_def value=1 checked> $self->{'text_hash'}->{'default'}\n";
print "<input type=radio name=port_def value=0> $self->{'text_hash'}->{'slave_master_port'}\n";
print "<input name=port size=5> </td> </tr>\n";

# Create on slave servers?
@{$self->{'servers_array'}} = grep { $_->{'sec'} } $self->list_slave_servers();
if (@{$self->{'servers_array'}} && $self->{'access_hash'}->{'remote'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'master_onslave'}</b></td>\n";
	print "<td colspan=3>",$self->ui_yesno_radio("onslave", 1),"</td> </tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

