#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_export.cgi
# Display a form for editing or creating an export

&ModuleLoader::preload_module('bsdexports_class', "bsdexports::BsdexportsLib");
$self = new bsdexports::BsdexportsLib:: 'bsdexports_class',%$self;

$self->ReadParse();

if (defined($self->{'in_hash'}->{'index'})) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	@{$self->{'exp_array'}} = $self->list_exports();
	%{$self->{'exp_hash'}} = %{$self->{'exp_array'}->[$self->{'in_hash'}->{'index'}]};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	}

print $self->ui_form_start("save_export.cgi", "post");
if (%{$self->{'exp_hash'}}) {
	print $self->ui_hidden("index", $self->{'in_hash'}->{'index'}),"\n";
	}
print $self->ui_table_start($self->{'text_hash'}->{'edit_header1'}, "width=100%", 4);

print "<tr> <td valign=top rowspan=3><b>$self->{'text_hash'}->{'edit_dirs'}</b></td>\n";
print "<td rowspan=3>",
      $self->ui_textarea("dirs", join("\n", @{$self->{'exp_hash'}->{'dirs'}}), 4, 30),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'edit_alldirs'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("alldirs", $self->{'exp_hash'}->{'alldirs'} ? 1 : 0),
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_ro'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("ro", $self->{'exp_hash'}->{'ro'} ? 1 : 0),
      "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_kerb'}</b></td>\n";
print "<td>",$self->ui_yesno_radio("kerb", $self->{'exp_hash'}->{'kerb'} ? 1 : 0),
      "</td> </tr>\n";

print $self->ui_table_end(),"<p>\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header2'}, "width=100%", 2);

$self->{'user'} = $self->{'exp_hash'}->{'maproot'} =~ /^([^:]+)/ ? $1 : "";
$self->{'groups'} = $self->{'exp_hash'}->{'maproot'} =~ /:(.*)$/ ? join(' ', split(/:/, $1)) : "";
print $self->ui_table_row($self->{'text_hash'}->{'edit_maproot'},
		    $self->ui_radio("maproot_def", $self->{'exp_hash'}->{'maproot'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'edit_unpriv'}."<br>" ],
				[ 0, $self->{'text_hash'}->{'edit_uid'} ] ])."\n".
		    $self->ui_textbox("maproot", $self->{'user'}, 8)."\n".
		    $self->ui_checkbox("maprootg_def", 1, $self->{'text_hash'}->{'edit_gids'},
				 $self->{'exp_hash'}->{'maproot'} =~ /:/)."\n".
		    $self->ui_textbox("maprootg", $self->{'groups'}, 30));

$self->{'user'} = $self->{'exp_hash'}->{'mapall'} =~ /^([^:]+)/ ? $1 : "";
$self->{'groups'} = $self->{'exp_hash'}->{'mapall'} =~ /:(.*)$/ ? join(' ', split(/:/, $1)) : "";
print $self->ui_table_row($self->{'text_hash'}->{'edit_mapall'},
		    $self->ui_radio("mapall_def", $self->{'exp_hash'}->{'mapall'} ? 0 : 1,
			      [ [ 1, $self->{'text_hash'}->{'edit_unpriv'}."<br>" ],
				[ 0, $self->{'text_hash'}->{'edit_uid'} ] ])."\n".
		    $self->ui_textbox("mapall", $self->{'user'}, 8)."\n".
		    $self->ui_checkbox("mapallg_def", 1, $self->{'text_hash'}->{'edit_gids'},
				 $self->{'exp_hash'}->{'mapall'} =~ /:/)."\n".
		    $self->ui_textbox("mapallg", $self->{'groups'}, 30));

print $self->ui_table_end(),"<p>\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header3'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'edit_clients'},
    $self->ui_radio("cmode", $self->{'exp_hash'}->{'mask'} ? 1 : 0,
	      [ [ 0, $self->{'text_hash'}->{'edit_hosts'}." ".
		     $self->ui_textbox("hosts", join(' ', @{$self->{'exp_hash'}->{'hosts'}}), 40).
		     "<br>" ],
		[ 1, $self->{'text_hash'}->{'edit_network'}." ".
		     $self->ui_textbox("network", $self->{'exp_hash'}->{'network'}, 20)." ".
		     $self->{'text_hash'}->{'edit_mask'}." ".
		     $self->ui_textbox("mask", $self->{'exp_hash'}->{'mask'}, 20) ] ]));

print $self->ui_table_end(),"<p>\n";

if (%{$self->{'exp_hash'}}) {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

