#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of exports

&ModuleLoader::preload_module('bsdexports_class', "bsdexports::BsdexportsLib");
$self = new bsdexports::BsdexportsLib:: 'bsdexports_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

@{$self->{'exp_array'}} = $self->list_exports();
if (@{$self->{'exp_array'}}) {
	print $self->ui_form_start("delete_exports.cgi", "post");
	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"\n";
	print "<a href=edit_export.cgi>$self->{'text_hash'}->{'index_add'}</a> <br>\n";

	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'index_dirs'},
				  $self->{'text_hash'}->{'index_clients'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $e (@{$self->{'exp_array'}}) {
		local @cols;
		push(@cols, "<a href=\"edit_export.cgi?index=$e->{'index'}\">".
			    join(" ", @{$e->{'dirs'}})."</a>");
		if ($e->{'network'}) {
			push(@cols, "$e->{'network'} / $e->{'mask'}");
			}
		elsif (!$e->{'hosts'}) {
			push(@cols, $self->{'text_hash'}->{'index_everyone'});
			}
		else {
			push(@cols, join("&nbsp;|&nbsp;", @{$e->{'hosts'}}));
			}
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",
					      $e->{'index'});
		}
	print $self->ui_columns_end();

	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"\n";
	print "<a href=edit_export.cgi>$self->{'text_hash'}->{'index_add'}</a> <br>\n";
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	print "<a href=edit_export.cgi>$self->{'text_hash'}->{'index_add'}</a> <p>\n";
	}

print "<hr>\n";

print $self->ui_buttons_start();
print $self->ui_buttons_row("restart_mountd.cgi",
		      $self->{'text_hash'}->{'index_apply'},
		      $self->{'text_hash'}->{'index_applydesc'});
print $self->ui_buttons_end();

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

