#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('clamav_class', "clamav::ClamavLib");
$self = new clamav::ClamavLib:: 'clamav_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_viruses'}, "", undef, 1, 1, 0, undef, undef, undef, $self->{'ver'});

$self->{'count'} = $self->clamav_viruses_count();
print "<pre>".$self->text('search_count', $self->{'count'})."</pre>";
print $self->ui_form_start('search_db.cgi', 'POST');
print $self->ui_table_start("$self->{'text_hash'}->{'search_table'}", 'width=100%');
print $self->ui_table_row("$self->{'text_hash'}->{'search_name'}", qq(<input type=text name=\"name\" value=\"$self->{'in_hash'}->{name}\">), 2);
printf ($self->ui_table_row("", qq(<input type=checkbox name=\"ext\" %s> $self->{'text_hash'}->{'search_ext'}), 2), $self->{'in_hash'}->{ext} ? 'checked' : 'unchecked');
printf ($self->ui_table_row("", qq(<input type=checkbox name=\"case\" %s> $self->{'text_hash'}->{'search_case'}), 2), $self->{'in_hash'}->{case} ? 'checked' : 'unchecked');
printf ($self->ui_table_row("", qq(<input type=checkbox name=\"sort\" %s> $self->{'text_hash'}->{'search_sort'}), 2), $self->{'in_hash'}->{sort} ? 'checked' : 'unchecked');
print $self->ui_table_end();
print $self->ui_form_end([['submit', $self->{'text_hash'}->{'search_submit'}], ['show_all', $self->{'text_hash'}->{'search_show_all'}]]);

$self->clamav_vdb_search($self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'ext'}, $self->{'in_hash'}->{'case'}, $self->{'in_hash'}->{'sort'},$self->{'in_hash'}->{'page'},$self->{'in_hash'}->{'bl'}) if ($self->{'in_hash'}->{'submit'});
$self->clamav_vdb_search() if ($self->{'in_hash'}->{'show_all'});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_title'});
1;
		
}


1;

