#!/usr/bin/perl

$no_acl_check++;
require './confmaster-lib.pl';

sub appl_install
{
 my ($appl, $type) = @_;
 
 # change confmaster config
 $config{"configured_$_[0]"} = 1;
 if (($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  # ZTL for CentOS
  if (($appl eq 'mail') && ($type eq 'postfix'))
  {
   # set postfix based system
   $config{'mail_system'} = 4;
  }
  elsif (($appl eq 'mail') && ($type eq 'sendmail'))
  {
   # set sendmail based system
   $config{'mail_system'} = 3;
  } 
 }
 &save_module_config();

 # configure appliance 
 if ($remote_user && ($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  # redirect OUTPUT & ERRORS
  open (STDOUT, ">$module_config_directory\/install.log");
  open (STDERR, ">>$module_config_directory\/install.log");
 }
 &run_modules_postinstall($appl);
 &configure_server($appl);
 &websites_configure($appl);
 if ($remote_user && ($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  close (STDOUT);
  close (STDERR);
 }
 
 # change global config
 $gconfig{"$_[0]_app_on"} = 1;
 &save_module_config(\%gconfig,'/');
 
 # add confmaster log
 &write_postinstall_log($_[0],'complete',1);
}

1;
