#!/usr/bin/perl

$no_acl_check++;
require './confmaster-lib.pl';

sub appl_uninstall
{
 my ($appl, $type) = @_;
 
 if (($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  # ZTL for CentOS
  # change confmaster config
  if (($appl eq 'mail') && ($type eq 'postfix'))
  {
   # set postfix based system 
	$config{'mail_system'} = 4;
	&save_module_config();
  }
  elsif (($appl eq 'mail') && ($type eq 'sendmail'))
  {
   # set sendmail based system
	$config{'mail_system'} = 3;
	&save_module_config();
  }
 }
  
 # uninstall appliance
 if ($remote_user && ($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  # redirect OUTPUT & ERRORS
  open (STDOUT, ">$module_config_directory\/uninstall.log");
  open (STDERR, ">>$module_config_directory\/uninstall.log");
 }
 &del_configured_flag($appl);
 &uninstall_websites_configure($appl);
 &uninstall_server($appl);
 if ($remote_user && ($gconfig{'os_type'} eq 'redhat-linux') && ($gconfig{'os_version'} => 11))
 {
  close (STDOUT);
  close (STDERR);
 }
}

1;
