#!/usr/bin/perl
# confmaster: index.cgi

require './confmaster-lib.pl';
&ReadParse();

my ($srv_name, $type, $conf);
if ($config{'ztl_mode'})
{
 # for ztl
 $srv_name = $text{"server_appl_$in{'srv'}"};
 $type = $text{"appliance"};
 $types = $text{"appliances"};
}
else
{
 # for cpplus
 $type = $text{"server"};
 $types = $text{"servers"};
}

if ($in{'srv'} eq 'database' || $in{'srv'} eq 'file' || $in{'srv'} eq 'lan')
{
 # only for ztl submenu
 my $srv = $text{"server_appl_$in{'srv'}"};
 
 #print header
 &ui_print_header(undef, $srv, undef, undef, undef);

 # submenu for database & file appliance
 &print_servers_table($in{'srv'});
 
 # print return footer
 &ui_print_footer("", &text('index_return', $types));
}
else
{
 # print header
 &ui_print_header(undef, &text('index_title', $types), undef, undef, 1);

 # main menu
 &print_servers_table();

 # print return url
 &ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'});
}
