#!/usr/bin/perl
# upgrade_cpplus.cgi
# Display a form for upgrading CP+

# disable acl check
$no_acl_check++;
require './confmaster-lib.pl';
&foreign_require("swup", "swup-lib.pl");

&ReadParse();
if ($in{'upgrade'})
{
 # upgrade cpplus.rpm
 # Save this CGI from being killed by the upgrade
 $SIG{'TERM'} = 'IGNORE';

 # unbuffered
 $| = 1;

 # upgrade cp+
 &ui_print_header(undef, $text{'upgrade_title'}, "");
 print "<table width='100%'>\n";
 &swup::upgrade_package('cpplus');
 print "<tr><td colspan=2>$text{'setup_ok_sys'}</td></tr>";
 print "</table>\n";
}
else
{
 # what kind of install was this?
 if (open(MODE, "$root_directory/install-type"))
 {
  chop($mode = <MODE>);
  close(MODE);
 }
 else
 {
  $mode = undef;
 }
 #type of installation
 if (($mode eq 'rpm') && &configured('swup'))
 {
  #upgrade from rpm
  #get current version
  my $cur_version = &get_webmin_version();

  #search new version cp+ for upgrade
  my $version;
  #get upgrade package list
  #my @upgrade=&swup::get_upgrade_pkgs_list();
  my @upgrade=&swup::get_remote_package_desc('cpplus');
  foreach (@upgrade)
  {
   if ($_=~/^Version:\s+([0-9\.]+)/)
   {
    $version = $1;
   }
  }

  # print CP+ version informaition
  &ui_print_header(undef, $text{'upgrade_title'}, "", undef, 0, 1);
  print "<table width='100%' border cellspacing=5 cellpadding=5>\n";
  print "<tr><td $tb><b>$text{'upgrade_verinfo'}</b></td></tr>\n";
  print "<tr><td>$text{'upgrade_vercur'}&nbsp;&nbsp;&nbsp;<b>$cur_version</b></td></tr>\n";
  print "<tr><td>$text{'upgrade_verlast'}&nbsp;&nbsp;&nbsp;<b>$version</b></td></tr>\n" if  ($version);
  if  (!$version || (&base_version($version) eq &base_version($cur_version)))
  {
   # last version
   print "<tr><td><b>$text{'upgrade_elatest'}</b><p></td></tr></table>\n";
  }
  elsif  (&base_version($version) lt &base_version($cur_version))
  {
   # last version
   print "<tr><td><b>$text{'upgrade_eversion'}</b><p></td></tr></table>\n";
  }
  else
  {
   # print select form for upgrade
   print "<form action=upgrade_cpplus.cgi>\n";
   print "<input type=hidden name=upgrade value=1>\n";
   print "<tr><td $tb><b>".$text{'upgrade_title'}."</b></td></tr>\n";
   print "<tr><td $cb>".$text{"upgrade_desc"}."</td></tr>\n";
   print "<tr><td><input type=submit value=\"$text{'upgrade_submit'}\">\n";
   print "</td></tr></table></form>\n";
  }
 }
 else
 {
  # upgrade from tar
  &redirect("/cpplus/edit_upgrade.cgi");
 }
}
&ui_print_footer($text{'index_mainpage_url'}, $text{'index_mainpage'});

# base_version()
# Rounds a version number down to the nearest .01
sub base_version
{
my $r = $_[0];
if ($r =~ /^(\d+)\.(\d+)$/) { # decoding old-format ztl version number
    my ($hi, $lo) = ($1, $2);
    $lo = sprintf("0.%d", $1) if $lo =~ /^0(\d+)$/;
    $r = "$hi.$lo";
}
my $ver;
while ($r =~ /(\d+)/g) {
    $ver .= ($ver ? '.' : '') . sprintf("%02d", $1);
}
return $ver;
}
