#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mod.cgi
# Display the details and documentation of a perl module

&ModuleLoader::preload_module('cpan_class', "cpan::CpanLib");
$self = new cpan::CpanLib:: 'cpan_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
#&read_acl(\%hash1, \%hash2);
if ($self->{'in_hash'}->{'name'}) {
	@{$self->{'mods_array'}} = $self->list_perl_modules($self->{'in_hash'}->{'name'});
	$self->{'mod'} = $self->{'mods_array'}->[0];
	}
else {
	@{$self->{'mods_array'}} = $self->list_perl_modules($self->{'in_hash'}->{'name'});
	$self->{'mod'} = $self->{'mods_array'}->[$self->{'in_hash'}->{'idx'}];
	}
$self->{'midx'} = $self->{'in_hash'}->{'midx'} ? $self->{'in_hash'}->{'midx'} : 0;

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "",undef, 0, 1);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> \n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

@{$self->{'m_array'}} = @{$self->{'mod'}->{'mods'}};
($self->{'desc'}, $self->{'ver'}) = $self->module_desc($self->{'mod'}, $self->{'midx'});
print "<tr> <td><b>$self->{'text_hash'}->{'edit_mod'}</b></td> \n";
print "<td>$self->{'m_array'}->[$self->{'midx'}] </td></tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_ver'}</b></td> \n";
print "<td> $self->{'ver'}</td></tr>\n";
print "<td><b>$self->{'text_hash'}->{'edit_desc'}</b></td>\n";
print "<td>",$self->{'desc'} ? $self->html_escape($self->{'desc'}) : $self->{'text_hash'}->{'edit_none'},"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_date'}</b></td> \n";
print "<td nowrap>$self->{'mod'}->{'date'}</td></tr>\n";

#print "<td><b>$self->{'text_hash'}->{'edit_file'}</b></td>\n";
#print "<td>$self->{'mod'}->{'files'}->[$self->{'midx'}]</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_method'}</b></td>\n";
print "<td>",$self->{'mod'}->{'pkg'} ?
		$self->text('edit_'.$self->{'mod'}->{'pkgtype'}, "<tt>$self->{'mod'}->{'pkg'}</tt>") :
		$self->{'text_hash'}->{'edit_manual'},"</td>\n";
print "</tr>\n";

if ($self->{'midx'} == $self->{'mod'}->{'master'} && @{$self->{'m_array'}} > 1) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_subs'}</b></td>\n";
	print "<td colspan=3>";
	for($i=0; $i<@{$self->{'m_array'}}; $i++) {
		print "<a href='edit_mod.cgi?idx=$self->{'in_hash'}->{'idx'}&midx=$i&name=$self->{'in_hash'}->{'name'}'>$self->{'m_array'}->[$i]</a>&nbsp;&nbsp;\n" if ($i != $self->{'mod'}->{'master'});
		}
	print "</td> </tr>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%> <tr>\n";
if ($self->{'midx'} == $self->{'mod'}->{'master'} && !$self->{'mod'}->{'noremove'} && $self->{'access_hash'}->{'uninstall'}) {  #&& $hash1{$remote_user, 'useradmin'}) {
	print "<form action=uninstall.cgi><td>\n";
	print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'edit_uninstall'}'>\n";
	print "</td></form>\n";
	}

if ($self->{'midx'} == $self->{'mod'}->{'master'} && !$self->{'mod'}->{'noupgrade'} && $self->{'access_hash'}->{'download'}) {  # && $hash1{$remote_user, 'useradmin'}) {
	print "<form action=download.cgi><td align=right>\n";
	print "<input type=hidden name=cpan value='$self->{'mod'}->{'mods'}->[0]'>\n";
	print "<input type=hidden name=source value=3>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'edit_upgrade'}'>\n";
	print "</td></form>\n";
	}
print "</table>\n";
print "<br>\n";

#open(DOC, "$perl_doc -t '$self->{'m_array'}->[$self->{'midx'}]' 2>/dev/null |");
#while(<DOC>) { $doc .= $_; }
#close(DOC);
#if ($doc =~ /\S/) {
#	print "<table border width=100%>\n";
#	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header2'}</b></td> </tr>\n";
#	print "<tr $self->{'cb'}> <td><pre>";
#	print $self->html_escape($doc);
#	print "</pre></td></tr></table><br>\n";
#	}

$self->ui_print_footer($self->{'midx'} != $self->{'mod'}->{'master'} ?
	 ( "edit_mod.cgi?idx=$self->{'in_hash'}->{'idx'}&midx=$self->{'mod'}->{'master'}&name=$self->{'in_hash'}->{'name'}",
	   $self->{'text_hash'}->{'edit_return'} ) : ( ),
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

