#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for finding cached URLs, with the ability to flush

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'cache_title'}, "");
$self->ReadParse();

# Search form
print $self->ui_form_start("cache.cgi");
print "<b>$self->{'text_hash'}->{'cache_search'}</b>\n",
      $self->ui_textbox("search", $self->{'in_hash'}->{'search'}, 40),"\n",
      $self->ui_submit($self->{'text_hash'}->{'cache_ok'}),"\n";
print $self->ui_form_end();

if ($self->{'in_hash'}->{'search'}) {
	# Find results
	$self->{'surl'} = $self->{'in_hash'}->{'search'};
	$self->{'surl'} =~ s/\//_/g;
	foreach $c ($self->list_cached_files()) {
		if ($c->[0] =~ /\Q$self->{'surl'}\E/i) {
			local @st = stat($c->[1]);
			push(@{$self->{'urls_array'}}, [ $c->[0], $c->[2], $st[7], $st[9] ]);
			}
		}

	if (@{$self->{'urls_array'}}) {
		# Show the results
		print $self->text('cache_matches', scalar(@{$self->{'urls_array'}})),"<br>\n";
		@{$self->{'tds_array'}} = ( "width=5" );
		print $self->ui_form_start("delete_cache.cgi", "post");
		print $self->ui_hidden("search", $self->{'in_hash'}->{'search'}),"\n";
		@{$self->{'links_array'}} = ( $self->select_all_link("d", 1),
			   $self->select_invert_link("d", 1) );
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_columns_start([ "", $self->{'text_hash'}->{'cache_url'},
					  $self->{'text_hash'}->{'cache_size'}, $self->{'text_hash'}->{'cache_date'} ],
					100, 0, \@{$self->{'tds_array'}});
		foreach $url (@{$self->{'urls_array'}}) {
			print $self->ui_checked_columns_row(
			  [ $url->[1], $self->nice_size($url->[2]), $self->make_date($url->[3], 1) ],
			  \@{$self->{'tds_array'}}, "d", $url->[0]);
			}
		print $self->ui_columns_end();
		print $self->ui_links_row(\@{$self->{'links_array'}});
		print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'cache_delete'} ] ]);
		}
	else {
		print "<b>$self->{'text_hash'}->{'cache_none'}</b><p>\n";
		}
	}

$self->ui_print_footer("edit_proxy.cgi", $self->{'text_hash'}->{'proxy_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

