#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_access.cgi
# Update IP allow and deny parameters

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

#use Socket;
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'access_err'});

$self->{'raddr'} = $ENV{'REMOTE_ADDR'};
if ($self->{'in_hash'}->{"access"}) {
	@{$self->{'hosts_array'}} = split(/\s+/, $self->{'in_hash'}->{"ip"});
	if (!@{$self->{'hosts_array'}}) { $self->error($self->{'text_hash'}->{'access_enone'}); }
	foreach $h (@{$self->{'hosts_array'}}) {
		$self->{'err'} = $self->valid_allow($h);
		$self->error($self->{'err'}) if ($self->{'err'});
		push(@{$self->{'ip_array'}}, $h);
		}
	if ($self->{'in_hash'}->{"access"} == 1 && !$self->ip_match($self->{'raddr'}, @{$self->{'ip_array'}}) ||
	    $self->{'in_hash'}->{"access"} == 2 && $self->ip_match($self->{'raddr'}, @{$self->{'ip_array'}})) {
		$self->error($self->text('access_eself', $self->{'raddr'}));
		}
	}

eval "use Authen::Libwrap qw(hosts_ctl STRING_UNKNOWN)";
if (!$@ && $self->{'in_hash'}->{'libwrap'}) {
	# Check if the current address would be denied
	if (!$self->hosts_ctl("webmin", STRING_UNKNOWN, $self->{'raddr'}, STRING_UNKNOWN)) {
		$self->error($self->text('access_eself', $self->{'raddr'}));
		}
	}

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
delete($self->{'miniserv_hash'}->{"allow"});
delete($self->{'miniserv_hash'}->{"deny"});
if ($self->{'in_hash'}->{"access"} == 1) { $self->{'miniserv_hash'}->{"allow"} = join(' ', @{$self->{'hosts_array'}}); }
elsif ($self->{'in_hash'}->{"access"} == 2) { $self->{'miniserv_hash'}->{"deny"} = join(' ', @{$self->{'hosts_array'}}); }
$self->{'miniserv_hash'}->{'libwrap'} = $self->{'in_hash'}->{'libwrap'};
$self->{'miniserv_hash'}->{'alwaysresolve'} = $self->{'in_hash'}->{'alwaysresolve'};
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
$self->show_restart_page();
$self->webmin_log("access", undef, undef, \%{$self->{'in_hash'}});

1;
		
}


1;

