#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_anon.cgi
# Update list of anonymously accessible modules

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->error_setup($self->{'text_hash'}->{'anon_err'});

# Check inputs
$self->read_acl(undef, \%{$self->{'acl_hash'}});
for($i=0; defined($self->{'in_hash'}->{"url_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"url_$i"});
	$self->{'in_hash'}->{"url_$i"} =~ /^\/\S+$/ || $self->error($self->text('anon_eurl', $self->{'in_hash'}->{"url_$i"}));
	$self->{'acl_hash'}->{$self->{'in_hash'}->{"user_$i"}} || $self->error($self->text('anon_euser', $self->{'in_hash'}->{"url_$i"}));
	push(@{$self->{'anon_array'}}, $self->{'in_hash'}->{"url_$i"}."=".$self->{'in_hash'}->{"user_$i"});
	}

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->{'miniserv_hash'}->{'anonymous'} = join(" ", @{$self->{'anon_array'}});
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
$self->show_restart_page();
$self->webmin_log("anon", undef, undef, \%{$self->{'in_hash'}});
1;
		
}


1;

