#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_ca.cgi
# Update the CA cert manually

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParseMime();
$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->setup_ca() if (!$self->{'miniserv_hash'}->{'ca'});

$self->lock_file($self->{'miniserv_hash'}->{'ca'});
$self->open_tempfile(CA, ">$self->{'miniserv_hash'}->{'ca'}");
$self->{'in_hash'}->{'cert'} =~ s/\r//g;
$self->{'in_hash'}->{'cert'} =~ s/\n*$/\n/;
$self->print_tempfile(CA, $self->{'in_hash'}->{'cert'});
$self->close_tempfile(CA);
chmod(0700, $self->{'miniserv_hash'}->{'ca'});
$self->unlock_file($self->{'miniserv_hash'}->{'ca'});

unlink("$self->{'config_directory'}/acl/crl.pem");
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});
$self->redirect("");
sleep(1);
$self->show_restart_page();
$self->webmin_log("changeca", undef, undef, \%{$self->{'in_hash'}});
1;
		
}


1;

