#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_log.cgi
# Enable or disable logging

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'log_err'});

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'log'} = $self->{'in_hash'}->{'log'};
$self->{'miniserv_hash'}->{'loghost'} = $self->{'in_hash'}->{'loghost'};
$self->{'miniserv_hash'}->{'logclf'} = $self->{'in_hash'}->{'logclf'};
$self->{'miniserv_hash'}->{'logclear'} = $self->{'in_hash'}->{'logclear'};
!$self->{'in_hash'}->{'logclear'} || $self->{'in_hash'}->{'logtime'} =~ /^[1-9][0-9]*$/ ||
	$self->error($self->text('log_ehours', $self->{'in_hash'}->{'logtime'}));
$self->{'miniserv_hash'}->{'logtime'} = $self->{'in_hash'}->{'logtime'};
if ($self->{'in_hash'}->{'perms_def'}) {
	delete($self->{'miniserv_hash'}->{'logperms'});
	}
else {
	$self->{'in_hash'}->{'perms'} =~ /^[0-7]{3,4}$/ || $self->error($self->{'text_hash'}->{'log_eperms'});
	$self->{'miniserv_hash'}->{'logperms'} = $self->{'in_hash'}->{'perms'};
	}
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->{'gconfig_hash'}->{'log'} = $self->{'in_hash'}->{'log'};
$self->{'gconfig_hash'}->{'logtime'} = $self->{'in_hash'}->{'logtime'};
$self->{'gconfig_hash'}->{'logclear'} = $self->{'in_hash'}->{'logclear'};
$self->{'gconfig_hash'}->{'logusers'} =
	$self->{'in_hash'}->{'uall'} ? '' : join(" ", split(/\0/, $self->{'in_hash'}->{'users'}));
$self->{'gconfig_hash'}->{'logmodules'} =
	$self->{'in_hash'}->{'mall'} ? '' : join(" ", split(/\0/, $self->{'in_hash'}->{'modules'}));
$self->{'gconfig_hash'}->{'logfiles'} = $self->{'in_hash'}->{'logfiles'};
$self->{'gconfig_hash'}->{'logfullfiles'} = $self->{'in_hash'}->{'logfullfiles'};
$self->{'gconfig_hash'}->{'logperms'} = $self->{'miniserv_hash'}->{'logperms'};
!$self->{'in_hash'}->{'logfiles'} || $self->has_command("diff") ||
	$self->error($self->text('log_ediff', "diff"));
$self->{'gconfig_hash'}->{'logsyslog'} = $self->{'in_hash'}->{'logsyslog'} if (defined($self->{'in_hash'}->{'logsyslog'}));
$self->lock_file("$self->{'config_directory'}/config");
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

$self->show_restart_page();
$self->webmin_log("log", undef, undef, \%{$self->{'in_hash'}});

1;
		
}


1;

