#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_os.cgi
# Change OS settings

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();

$self->lock_file("$self->{'config_directory'}/config");
if ($self->{'in_hash'}->{'update'}) {
	# Automatically detect
	%{$self->{'osinfo_hash'}} = $self->detect_operating_system();
	$self->{'gconfig_hash'}->{'real_os_type'} = $self->{'osinfo_hash'}->{'real_os_type'};
	$self->{'gconfig_hash'}->{'real_os_version'} = $self->{'osinfo_hash'}->{'real_os_version'};
	$self->{'gconfig_hash'}->{'os_type'} = $self->{'osinfo_hash'}->{'os_type'};
	$self->{'gconfig_hash'}->{'os_version'} = $self->{'osinfo_hash'}->{'os_version'};
	}
elsif ($self->{'in_hash'}->{'type'} ne $self->{'gconfig_hash'}->{'real_os_type'} ||
       $self->{'in_hash'}->{'version'} ne $self->{'gconfig_hash'}->{'real_os_version'} ||
       $self->{'in_hash'}->{'itype'} ne $self->{'gconfig_hash'}->{'os_type'} ||
       $self->{'in_hash'}->{'iversion'} ne $self->{'gconfig_hash'}->{'os_version'}) {
	# Manually change
	$self->{'gconfig_hash'}->{'real_os_type'} = $self->{'in_hash'}->{'type'};
	$self->{'in_hash'}->{'version'} || $self->error($self->{'text_hash'}->{'os_eversion'});
	$self->{'gconfig_hash'}->{'real_os_version'} = $self->{'in_hash'}->{'version'};
	($self->{'os'}) = grep { $_->{'realtype'} eq $self->{'in_hash'}->{'type'} }
		     $self->list_operating_systems();
	$self->{'gconfig_hash'}->{'os_type'} = $self->{'in_hash'}->{'itype'};
	$self->{'in_hash'}->{'iversion'} || $self->error($self->{'text_hash'}->{'os_eiversion'});
	$self->{'gconfig_hash'}->{'os_version'} = $self->{'in_hash'}->{'iversion'};
	}
$self->{'gconfig_hash'}->{'path'} = join($self->{'path_separator'}, split(/[\r\n]+/, $self->{'in_hash'}->{'path'}));
if ($self->{'gconfig_hash'}->{'ld_env'}) {
	$self->{'gconfig_hash'}->{'ld_path'} = join($self->{'path_separator'},
				   split(/[\r\n]+/, $self->{'in_hash'}->{'ld_path'}));
	}
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
foreach $e (keys %{$self->{'miniserv_hash'}}) {
	delete($self->{'miniserv_hash'}->{$e}) if ($e =~ /^env_(\S+)$/ &&
				  $1 ne "WEBMIN_CONFIG" && $1 ne "WEBMIN_VAR");
	}
for($i=0; defined($self->{'n'} = $self->{'in_hash'}->{"name_$i"}); $i++) {
	next if (!$self->{'n'});
	$self->{'miniserv_hash'}->{'env_'.$self->{'n'}} = $self->{'in_hash'}->{"value_$i"}
		if ($self->{'n'} ne "WEBMIN_CONFIG" && $self->{'n'} ne "WEBMIN_VAR");
	}
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->show_restart_page();
$self->webmin_log("os", undef, undef, \%{$self->{'in_hash'}});
1;
		
}


1;

