#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_ssl.cgi
# Enable or disable SSL support

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ssl_err'});

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->{'miniserv_hash'}->{'ssl'} = $self->{'in_hash'}->{'ssl'};
$self->validate_key_cert($self->{'in_hash'}->{'key'}, $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'});
$self->{'miniserv_hash'}->{'keyfile'} = $self->{'in_hash'}->{'key'};
$self->{'miniserv_hash'}->{'certfile'} = $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'};
$self->{'miniserv_hash'}->{'ssl_redirect'} = $self->{'in_hash'}->{'ssl_redirect'};
if ($self->{'in_hash'}->{'version_def'}) {
	delete($self->{'miniserv_hash'}->{'ssl_version'});
	}
else {
	$self->{'in_hash'}->{'version'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ssl_eversion'});
	$self->{'miniserv_hash'}->{'ssl_version'} = $self->{'in_hash'}->{'version'};
	}
foreach $ec (split(/[\r\n]+/, $self->{'in_hash'}->{'extracas'})) {
	-r $ec && !-d $ec || $self->error($self->text('ssl_eextraca', $ec));
	push(@{$self->{'extracas_array'}}, $ec);
	}
$self->{'miniserv_hash'}->{'extracas'} = join("\t", @{$self->{'extracas_array'}});
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$SIG{'TERM'} = 'IGNORE';	# stop process from being killed by restart
$self->restart_miniserv();
$self->webmin_log("ssl", undef, undef, \%{$self->{'in_hash'}});

$self->{'url'} = "$ENV{'SERVER_NAME'}:$self->{'miniserv_hash'}->{'port'}/cpplus/";
if ($self->{'in_hash'}->{'ssl'}) { $self->redirect("https://$self->{'url'}"); }
else { $self->redirect("http://$self->{'url'}"); }

1;
		
}


1;

