#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_syslet.cgi
# Save syslet auto-download options

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'syslet_err'});

$self->lock_file("$self->{'config_directory'}/config");
@{$self->{'base_array'}} = split(/\s+/, $self->{'in_hash'}->{'syslet_base'});
foreach $b (@{$self->{'base_array'}}) {
	$b =~ /^http:\/\/([A-Za-z0-9\.\-]+)(:\d+)?\/(\S*)/ ||
		$self->error($self->{'text_hash'}->{'syslet_ebase'});
	}
$self->{'gconfig_hash'}->{'syslet_base'} = join(" ", @{$self->{'base_array'}});
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

$self->lock_file($ENV{'MINISERV_CONFIG'});
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});
if ($self->{'in_hash'}->{'auto'}) {
	$self->{'miniserv_hash'}->{'error_handler_404'} = '/eazel_download_module.cgi';
	}
elsif ($self->{'miniserv_hash'}->{'error_handler_404'} eq '/eazel_download_module.cgi') {
	$self->{'miniserv_hash'}->{'error_handler_404'} = '';
	}
$self->put_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($ENV{'MINISERV_CONFIG'});

$self->webmin_log("syslet", undef, undef, \%{$self->{'in_hash'}});
$self->show_restart_page();

1;
		
}


1;

