#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_ui.cgi
# Change colour scheme

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->error_setup($self->{'text_hash'}->{'ui_err'});
$self->ReadParse();

$self->lock_file("$self->{'config_directory'}/config");
for($i=0; $i<@{$self->{'cs_names_array'}}; $i++) {
	$self->{'cd'} = $self->{'cs_codes_array'}->[$i];
	if ($self->{'in_hash'}->{"$self->{'cd'}_def"}) { delete($self->{'gconfig_hash'}->{$self->{'cd'}}); }
	elsif ($self->{'in_hash'}->{"$self->{'cd'}_rgb"} !~ /^[0-9a-fA-F]{6}$/) {
		$self->error($self->text('ui_ergb', $self->{'cs_names_array'}->[$i]));
		}
	else { $self->{'gconfig_hash'}->{$self->{'cd'}} = $self->{'in_hash'}->{"$self->{'cd'}_rgb"}; }
	}

$self->{'gconfig_hash'}->{'texttitles'} = $self->{'in_hash'}->{'texttitles'};
$self->{'gconfig_hash'}->{'sysinfo'} = $self->{'in_hash'}->{'sysinfo'};
$self->{'gconfig_hash'}->{'showlogin'} = $self->{'in_hash'}->{'showlogin'};
$self->{'gconfig_hash'}->{'hostnamemode'} = $self->{'in_hash'}->{'hostnamemode'};
$self->{'gconfig_hash'}->{'hostnamedisplay'} = $self->{'in_hash'}->{'hostnamedisplay'};
$self->{'gconfig_hash'}->{'feedback_to'} = $self->{'in_hash'}->{'feedback_def'} ? undef : $self->{'in_hash'}->{'feedback'};
$self->{'gconfig_hash'}->{'nofeedbackcc'} = $self->{'in_hash'}->{'nofeedbackcc'};

$self->{'in_hash'}->{'width_def'} || $self->{'in_hash'}->{'width'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ui_ewidth'});
$self->{'gconfig_hash'}->{'help_width'} = $self->{'in_hash'}->{'width'};
$self->{'in_hash'}->{'height_def'} || $self->{'in_hash'}->{'height'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ui_eheight'});
$self->{'gconfig_hash'}->{'help_height'} = $self->{'in_hash'}->{'height'};

# Save dialog box sizes
foreach $db ("file", "user", "users", "date", "module", "modules") {
	if ($self->{'in_hash'}->{"size".$db."_def"}) {
		delete($self->{'gconfig_hash'}->{"db_size".$db});
		}
	else {
		$self->{'in_hash'}->{"size".$db."_w"} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'ui_edbwidth'});
		$self->{'in_hash'}->{"size".$db."_h"} =~ /^\d+$/ ||
			$self->error($self->{'text_hash'}->{'ui_edbheight'});
		$self->{'gconfig_hash'}->{"db_size".$db} = $self->{'in_hash'}->{"size".$db."_w"}."x".
					  $self->{'in_hash'}->{"size".$db."_h"};
		}
	}

$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");
$self->webmin_log('ui', undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

