#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_bind.cgi
# Display port / address form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'bind_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->{'text_hash'}->{'bind_desc'},"<p>\n";

print $self->ui_form_start("change_bind.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'bind_header'}, undef, 2);

# Build list of sockets
@{$self->{'sockets_array'}} = $self->get_miniserv_sockets(\%{$self->{'miniserv_hash'}});

# Show table of all bound IPs and ports
$self->{'stable'} = $self->ui_columns_start([ $self->{'text_hash'}->{'bind_sip'}, $self->{'text_hash'}->{'bind_sport'} ]);
$self->{'i'} = 0;
foreach $s (@{$self->{'sockets_array'}}, [ undef, "*" ]) {
	# IP address
	local @cols;
	push(@cols, $self->ui_select("ip_def_$self->{'i'}", $s->[0] eq "" ? 0 :
					    $s->[0] eq "*" ? 1 : 2,
			       [ [ 0, "&nbsp;" ],
				 [ 1, $self->{'text_hash'}->{'bind_sip1'} ],
				 [ 2, $self->{'text_hash'}->{'bind_sip2'} ] ])." ".
		    $self->ui_textbox("ip_$self->{'i'}", $s->[0] eq "*" ? undef : $s->[0], 20));

	# Port
	push(@cols, $self->ui_select("port_def_$self->{'i'}", $s->[1] eq "*" ? 0 : 1,
			       [ $self->{'i'} ? ( [ 0, $self->{'text_hash'}->{'bind_sport0'} ] ) : ( ),
				 [ 1, $self->{'text_hash'}->{'bind_sport1'} ] ])." ".
		    $self->ui_textbox("port_$self->{'i'}", $s->[1] eq "*" ? undef : $s->[1],5));
	$self->{'stable'} .= $self->ui_columns_row(\@cols, [ "nowrap", "nowrap" ]);
	$self->{'i'}++;
	}
$self->{'stable'} .= $self->ui_columns_end();
print $self->ui_table_row($self->{'text_hash'}->{'bind_sockets'}, $self->{'stable'});

# Show listen address
print $self->ui_table_row($self->{'text_hash'}->{'bind_listen'},
    $self->ui_radio("listen_def", $self->{'miniserv_hash'}->{"listen"} ? 0 : 1,
	[ [ 1, $self->{'text_hash'}->{'bind_none'} ],
	  [ 0, $self->ui_textbox("listen", $self->{'miniserv_hash'}->{"listen"}, 6) ] ]));

# Show web server hostname
print $self->ui_table_row($self->{'text_hash'}->{'bind_hostname'},
    $self->ui_radio("hostname_def", $self->{'miniserv_hash'}->{"host"} ? 0 : 1,
	[ [ 1, $self->{'text_hash'}->{'bind_auto'} ],
	  [ 0, $self->ui_textbox("hostname", $self->{'miniserv_hash'}->{"host"}, 25) ] ]));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

