#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_lang.cgi
# Language config form

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'lang_title'}, "");

print $self->{'text_hash'}->{'lang_intro'},"<p>\n";

print $self->ui_form_start("change_lang.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'lang_title2'}, undef, 2);

# Language
$self->{'clang'} = $self->{'gconfig_hash'}->{'lang'} ? $self->{'gconfig_hash'}->{'lang'} : $self->{'default_lang'};
print $self->ui_table_row($self->{'text_hash'}->{'lang_lang'},
	$self->ui_select("lang", $self->{'clang'},
	   [ map { [ $_->{'lang'}, "$_->{'desc'} (".uc($_->{'lang'}).")" ] }
		 $self->list_languages() ]));

# Character set
print $self->ui_table_row($self->{'text_hash'}->{'lang_charset'},
	$self->ui_opt_textbox("charset", $self->{'gconfig_hash'}->{'charset'}, 15,
			$self->{'text_hash'}->{'lang_chardef'}));

# Use language from browser?
print $self->ui_table_row($self->{'text_hash'}->{'lang_accept'},
	$self->ui_yesno_radio("acceptlang", int($self->{'gconfig_hash'}->{'acceptlang'})));

print $self->ui_table_end();
print $self->ui_form_end([ [ "", $self->{'text_hash'}->{'lang_ok'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

