#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display options specific to mobile devices

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'mobile_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->ui_form_start("change_mobile.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'mobile_header'}, undef, 2);

# Custom theme for mobile devices
@{$self->{'themes_array'}} = $self->list_themes();
$self->{'m'} = $self->{'miniserv_hash'}->{'mobile_preroot'};
print $self->ui_table_row($self->{'text_hash'}->{'mobile_theme'},
	    $self->ui_select("theme", defined($self->{'m'}) ? $self->{'m'} : "*",
		       [ [ "*", $self->{'text_hash'}->{'mobile_themeglob'} ],
			 [ "", $self->{'text_hash'}->{'themes_default'} ],
			 map { [ $_->{'dir'}, $_->{'desc'} ] } @{$self->{'themes_array'}} ]));

# Skip session login for mobile devices
print $self->ui_table_row($self->{'text_hash'}->{'mobile_nosession'},
	    $self->ui_yesno_radio("nosession", int($self->{'miniserv_hash'}->{'mobile_nosession'})));

# Extra user agents
print $self->ui_table_row($self->{'text_hash'}->{'mobile_agents'},
	    $self->ui_textarea("agents",
		join("\n", split(/\t+/, $self->{'miniserv_hash'}->{'mobile_agents'})), 5, 50));

# Hostname prefixes for mobile
print $self->ui_table_row($self->{'text_hash'}->{'mobile_prefixes'},
	    $self->ui_textbox("prefixes", $self->{'miniserv_hash'}->{'mobile_prefixes'}, 50));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

