#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_session.cgi
# Edit session login options

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

print "Set-Cookie: sessiontest=1; path=/\n";
$self->ui_print_header(undef, $self->{'text_hash'}->{'session_title'}, "");
$self->get_miniserv_config(\%{$self->{'miniserv_hash'}});

print "$self->{'text_hash'}->{'session_desc1'}<p>\n";
print "$self->{'text_hash'}->{'session_desc2'}<p>\n";

print "<form action=change_session.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'session_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td nowrap>\n";

printf "<input type=radio name=passdelay value=0 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'passdelay'} ? '' : 'checked', $self->{'text_hash'}->{'session_pdisable'};
printf "<input type=radio name=passdelay value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'passdelay'} ? 'checked' : '', $self->{'text_hash'}->{'session_penable'};
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=blockhost_on value=1 %s>\n",
	$self->{'miniserv_hash'}->{'blockhost_failures'} ? "checked" : "";
print $self->text('session_blockhost',
	    "<input name=blockhost_failures size=4 value='$self->{'miniserv_hash'}->{'blockhost_failures'}'>",
	    "<input name=blockhost_time size=4 value='$self->{'miniserv_hash'}->{'blockhost_time'}'>"),"<br>\n";
eval "use Sys::Syslog qw(:DEFAULT setlogsock)";
if (!$@) {
	printf "<input type=checkbox name=syslog value=1 %s> %s\n",
		$self->{'miniserv_hash'}->{'syslog'} ? "checked" : "", $self->{'text_hash'}->{'session_syslog2'};
	}
else {
	print "<input type=hidden name=syslog value='$self->{'miniserv_hash'}->{'syslog'}'>\n";
	}
print "<p>\n";

printf "<input type=radio name=session value=0 %s> %s<br>\n",
	!$self->{'miniserv_hash'}->{'session'} ? "checked" : "", $self->{'text_hash'}->{'session_disable'};
printf "<input type=radio name=session value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'session'} ? "checked" : "", $self->{'text_hash'}->{'session_enable'};
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=logouttime_on value=1 %s>\n",
	$self->{'miniserv_hash'}->{'logouttime'} ? "checked" : "";
print $self->text('session_logout',
	"<input name=logouttime value='$self->{'miniserv_hash'}->{'logouttime'}' size=10>"),"<br>\n";
#printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=locking value=1 %s>\n",
#	$self->{'gconfig_hash'}->{'locking'} ? "checked" : "";
#print "$self->{'text_hash'}->{'session_locking'}<br>\n";
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=remember value=1 %s>\n",
	$self->{'gconfig_hash'}->{'noremember'} ? "" : "checked";
print "$self->{'text_hash'}->{'session_remember'}<br>\n";
printf "&nbsp;&nbsp;&nbsp;<input type=checkbox name=hostname value=1 %s>\n",
	$self->{'gconfig_hash'}->{'nohostname'} ? "" : "checked";
print "$self->{'text_hash'}->{'session_hostname'}<br>\n";
print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
printf "<input type=checkbox name=realname value=1 %s>\n",
	$self->{'gconfig_hash'}->{'realname'} ? "checked" : "";
print "$self->{'text_hash'}->{'session_realname'}<br>\n";
printf "&nbsp;&nbsp;&nbsp;<input type=radio name=banner_def value=1 %s> %s\n",
	$self->{'gconfig_hash'}->{'loginbanner'} ? "" : "checked", $self->{'text_hash'}->{'session_banner1'};
printf "<input type=radio name=banner_def value=0 %s> %s\n",
	$self->{'gconfig_hash'}->{'loginbanner'} ? "checked" : "", $self->{'text_hash'}->{'session_banner0'};
printf "<input name=banner size=30 value='%s'> %s<br>\n",
	$self->{'gconfig_hash'}->{'loginbanner'}, $self->file_chooser_button("banner");
print "<p>\n";

printf "<input type=radio name=localauth value=0 %s> %s<br>\n",
	!$self->{'miniserv_hash'}->{'localauth'} ? "checked" : "", $self->{'text_hash'}->{'session_localoff'};
printf "<input type=radio name=localauth value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'localauth'} ? "checked" : "", $self->{'text_hash'}->{'session_localon'};
print "<p>\n";

printf "<input type=radio name=no_pam value=0 %s> %s<br>\n",
	!$self->{'miniserv_hash'}->{'no_pam'} ? "disabled" : "disabled", $self->{'text_hash'}->{'session_pamon'};
printf "<input type=radio name=no_pam value=1 %s> %s<br>\n",
	$self->{'miniserv_hash'}->{'no_pam'} ? "checked" : "", $self->{'text_hash'}->{'session_pamoff'};
print "&nbsp;&nbsp;&nbsp;",$self->text('session_pfile',
	"<input name=passwd_file size=20 value='$self->{'miniserv_hash'}->{'passwd_file'}'>",
	"<input name=passwd_uindex size=2 value='$self->{'miniserv_hash'}->{'passwd_uindex'}'>",
	"<input name=passwd_pindex size=2 value='$self->{'miniserv_hash'}->{'passwd_pindex'}'>"),
	"<br>\n";
print "&nbsp;&nbsp;&nbsp;",
	$self->ui_checkbox("pam_conv", 1, $self->{'text_hash'}->{'session_pamconv'},
		     $self->{'miniserv_hash'}->{'pam_conv'}),"<p>\n";

print "$self->{'text_hash'}->{'session_pmodedesc2'}<br>\n";
foreach $m (0 .. 2) {
	printf "<input type=radio name=passwd_mode value=%d %s> %s\n",
		$m, $self->{'miniserv_hash'}->{'passwd_mode'} == $m ? "checked" : "",
		$self->{'text_hash'}->{'session_pmode'.$m};
	print $m == 2 ? "<p>\n" : "<br>\n";
	}

# Squid-style authentication program
print "$self->{'text_hash'}->{'session_extauth'} ",
      "<input name=extauth size=40 value='$self->{'miniserv_hash'}->{'extauth'}'><p>\n";

# Password encryption format
printf "<input type=radio name=md5pass value=0 %s> %s<br>\n",
	!$self->{'gconfig_hash'}->{'md5pass'} ? "checked" : "", $self->{'text_hash'}->{'session_md5off'};
printf "<input type=radio name=md5pass value=1 %s> %s<br>\n",
	$self->{'gconfig_hash'}->{'md5pass'} ? "checked" : "", $self->{'text_hash'}->{'session_md5on'};

print "</td> </tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

