#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Set OS to automatically detected version

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();

# Do Webmin
$self->lock_file("$self->{'config_directory'}/config");
%{$self->{'osinfo_hash'}} = $self->detect_operating_system();
$self->{'gconfig_hash'}->{'real_os_type'} = $self->{'osinfo_hash'}->{'real_os_type'};
$self->{'gconfig_hash'}->{'real_os_version'} = $self->{'osinfo_hash'}->{'real_os_version'};
$self->{'gconfig_hash'}->{'os_type'} = $self->{'osinfo_hash'}->{'os_type'};
$self->{'gconfig_hash'}->{'os_version'} = $self->{'osinfo_hash'}->{'os_version'};
$self->write_file("$self->{'config_directory'}/config", \%{$self->{'gconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/config");

# Do Usermin too, if installed and running an equivalent version
if ($self->foreign_installed("usermin")) {
	$self->foreign_require("usermin", "usermin-lib.pl");
	local %miniserv;
	&usermin::get_usermin_miniserv_config(\%miniserv);
	@{$self->{'ust_array'}} = stat("$miniserv{'root'}/os_list.txt");
	@{$self->{'wst_array'}} = stat("$self->{'root_directory'}/os_list.txt");
	if ($self->{'ust_array'}->[7] == $self->{'wst_array'}->[7]) {
		# os_list.txt is the same, so we can assume the same OS codes
		# are supported
		$self->lock_file($usermin::usermin_config);
		&usermin::get_usermin_config(\%{$self->{'uconfig_hash'}});
		$self->{'uconfig_hash'}->{'real_os_type'} = $self->{'osinfo_hash'}->{'real_os_type'};
		$self->{'uconfig_hash'}->{'real_os_version'} = $self->{'osinfo_hash'}->{'real_os_version'};
		$self->{'uconfig_hash'}->{'os_type'} = $self->{'osinfo_hash'}->{'os_type'};
		$self->{'uconfig_hash'}->{'os_version'} = $self->{'osinfo_hash'}->{'os_version'};
		&usermin::put_usermin_config(\%{$self->{'uconfig_hash'}});
		$self->unlock_file($usermin::usermin_config);
		}
	}

$self->webmin_log("os");
$self->redirect($ENV{'HTTP_REFERER'});
1;
		
}


1;

