#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_categories.cgi

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'categories_err'});

# Save built-in categories
foreach $t (keys %{$self->{'text_hash'}}) {
	$t =~ s/^category_// || next;
	if (!$self->{'in_hash'}->{"def_$t"}) {
		$self->{'in_hash'}->{"desc_$t"} ||
			$self->error($self->text('categories_edesc', $t ? $t : 'other'));
		$self->{'catnames_hash'}->{$t} = $self->{'in_hash'}->{"desc_$t"};
		}
	}

# Save custom categories
for($i=0; defined($self->{'in_hash'}->{"cat_$i"}); $i++) {
	if ($self->{'in_hash'}->{"cat_$i"} && $self->{'in_hash'}->{"desc_$i"}) {
		$self->{'realcat_hash'}->{$self->{'in_hash'}->{"cat_$i"}} &&
			$self->error($self->text('categories_ecat', $self->{'in_hash'}->{"cat_$i"}));
		$self->{'catnames_hash'}->{$self->{'in_hash'}->{"cat_$i"}} = $self->{'in_hash'}->{"desc_$i"};
		}
	}

# Write out the file
$self->{'file'} = "$self->{'config_directory'}/cpplus.catnames";
$self->{'file'} .= ".".$self->{'in_hash'}->{'lang'} if ($self->{'in_hash'}->{'lang'});
$self->lock_file("$self->{'config_directory'}/cpplus.catnames");
$self->write_file("$self->{'config_directory'}/cpplus.catnames", \%{$self->{'catnames_hash'}});
$self->unlock_file("$self->{'config_directory'}/cpplus.catnames");
$self->webmin_log("categories", undef, $self->{'in_hash'}->{'lang'}, \%{$self->{'in_hash'}});
$self->flush_webmin_caches();
$self->redirect("");
1;
		
}


1;

