#!/usr/bin/perl

&MAIN();

 sub MAIN {
# third_chooser.cgi
# Display a list of third-party modules for installation

&ModuleLoader::preload_module('cpplus_class', "cpplus::CpplusLib");
$self = new cpplus::CpplusLib:: 'cpplus_class',%$self;

$self->ui_print_header(undef, );
$self->{'mods'} = $self->list_third_modules();
if (!ref($self->{'mods'})) {
	print "<b>",$self->text('third_failed', $self->{'mods'}),"</b><p>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'third_header'}</b><br>\n";
	print "<script>\n";
	print "function select(f)\n";
	print "{\n";
	print "opener.ifield.value = f;\n";
	print "close();\n";
	print "return false;\n";
	print "}\n";
	print "</script>\n";
	print "<table width=100%>\n";
	foreach $m (@{$self->{'mods'}}) {
		print "<tr>\n";
		print "<td><a href='' onClick='return select(\"$m->[2]\")'>$m->[0]</a></td>\n";
		print "<td>",$m->[1] eq "NONE" ? "" : $m->[1],"</td>\n";
		print "<td>$m->[3]</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
$self->ui_print_footer();

1;
		
}


1;

