# uninstall.pl
# Called when webmin is uninstalled

require 'cpplus-lib.pl';

sub module_uninstall
{
if ($config{'update'}) {
	&foreign_require("cron", "cron-lib.pl");
	$cron_cmd = "$module_config_directory/update.pl";
	foreach $j (&cron::list_cron_jobs()) {
		if ($j->{'user'} eq 'root' &&
		    $j->{'command'} eq $cron_cmd) {
			&cron::delete_cron_job($j);
			}
		}
	}
# Delete public key with known fingerprint
$key_fingerprint = $webmin_key_fingerprint;
$key_fingerprint =~ s/ //g;
$gpg = "gpg";
$r = `$gpg --batch --delete-key $key_fingerprint 2>/dev/null`;
}

1;

