#!/usr/bin/perl
package cppluslog::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cppluslog::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "cppluslog::CppluslogLib");
$self = new cppluslog::CppluslogLib:: ref($self), %$self; 
$self->foreign_require("acl", "acl-lib.pl");

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the acl module
sub acl_security_form
{
	my $self = shift;

# Allowed modules
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_mods'}</b></td> <td>\n";
printf "<input type=radio name=mods_def value=1 %s> %s\n",
	$_[0]->{'mods'} eq "*" ? "checked" : "", $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=mods_def value=0 %s> %s<br>\n",
	$_[0]->{'mods'} eq "*" ? "" : "checked", $self->{'text_hash'}->{'acl_sel'};
local %gotmod = map { $_, 1 } split(/\s+/, $_[0]->{'mods'});
print "<select name=mods multiple size=10 width=400>\n";
local $m;
foreach $m (sort { $a->{'desc'} cmp $b->{'desc'} } $self->get_all_module_infos()) {
	printf "<option value=%s %s>%s\n",
		$m->{'dir'}, $gotmod{$m->{'dir'}} ? "selected" : "",
		$m->{'desc'};
	}
print "</select></td> </tr>\n";

# Allowed users
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td>\n";
printf "<input type=radio name=users_def value=1 %s> %s\n",
	$_[0]->{'users'} eq "*" ? "checked" : "", $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=users_def value=0 %s> %s<br>\n",
	$_[0]->{'users'} eq "*" ? "" : "checked", $self->{'text_hash'}->{'acl_sel'};
local %gotuser = map { $_, 1 } split(/\s+/, $_[0]->{'users'});
print "<select name=users multiple size=10 width=400>\n";
local $u;
foreach $u (sort { $a->{'name'} cmp $b->{'name'} } $main::acl_object->list_users()) {
	printf "<option value=%s %s>%s\n",
		$u->{'name'}, $gotuser{$u->{'name'}} ? "selected" : "",
		$u->{'name'};
	}
print "</select></td> </tr>\n";

# Rollback
print "<tr> <td><b>$self->{'text_hash'}->{'acl_rollback'}</b></td>\n";
print "<td>",$self->ui_radio("rollback", $_[0]->{'rollback'},
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'mods'} = $self->{'in_hash'}->{'mods_def'} ? "*" : join(" ", split(/\0/, $self->{'in_hash'}->{'mods'}));
$_[0]->{'users'} = $self->{'in_hash'}->{'users_def'} ? "*" : join(" ", split(/\0/,$self->{'in_hash'}->{'users'}));
$_[0]->{'rollback'} = $self->{'in_hash'}->{'rollback'};
}


1;

