#!/usr/bin/perl
package cron::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "cron::CronLib");
$self = new cron::CronLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

	@list_cron=$self->list_cron_jobs();
	@modules = $self->get_all_module_infos(2);

	foreach my $mod (@modules){
		push @{$self->{'array_array'}},$mod->{'dir'};
	}
	
	foreach my $task (@list_cron){
		my $tmp_conf_dir = $self->{'config_directory'};
		if ($task->{'command'} =~ /$tmp_conf_dir[\/]*([A-Za-z]+(-|_)[A-Za-z]+)\//) {
			my $mod=$1;
			my $def=$2;
			local ($value) = grep { $_ eq $mod} @{$self->{'array_array'}};
			if ($def eq "-" && !$value){
				$task->{'command'} =~ s/-/_/;
			}
			elsif ($def eq "_" && !$value) {
				$task->{'command'} =~ s/_/-/;
			}
			$self->change_cron_job($task);
		}
	}
}


1;

