#!/usr/bin/perl
package cron::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cron::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "cron::CronLib");
$self = new cron::CronLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
sub useradmin_create_user
{
	my $self = shift;

}

# useradmin_delete_user(&details)
# Delete this user's cron file
sub useradmin_delete_user
{
	my $self = shift;

$self->lock_file("$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'user'}");
unlink("$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'user'}");
$self->unlock_file("$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'user'}");
}

# useradmin_modify_user(&details, &old)
sub useradmin_modify_user
{
	my $self = shift;

# If a user's login name has changed, update all his Cron jobs
if ($_[0]->{'user'} ne $_[0]->{'olduser'}) {
	if (-r "$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'olduser'}") {
		$self->rename_logged("$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'olduser'}",
			       "$self->{'config_hash'}->{'cron_dir'}/$_[0]->{'user'}");
		}
	foreach $j ($self->list_cron_jobs()) {
		if ($j->{'user'} eq $_[0]->{'olduser'}) {
			$self->lock_file($j->{'file'});
			$j->{'user'} = $_[0]->{'user'};
			$self->change_cron_job($j);
			$self->unlock_file($j->{'file'});
			}
		}
	}

# If the user's home has changed, update all Cron job paths
if ($_[1] && $_[1]->{'home'} ne '/' && $_[0]->{'home'} ne $_[1]->{'home'}) {
	foreach $j ($self->list_cron_jobs()) {
		if ($j->{'user'} eq $_[0]->{'user'}) {
			if ($j->{'command'} =~
			    s/$_[1]->{'home'}/$_[0]->{'home'}/g) {
				$self->lock_file($j->{'file'});
				$self->change_cron_job($j);
				$self->unlock_file($j->{'file'});
				}
			}
		}
	}
}


1;

