#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple Cron jobs at once

&ModuleLoader::preload_module('cron_class', "cron::CronLib");
$self = new cron::CronLib:: 'cron_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@{$self->{'jobs_array'}} = $self->list_cron_jobs();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete selected jobs
	foreach $d (sort { $b <=> $c } @d) {
		$self->{'job'} = $self->{'jobs_array'}->[$d];
		$self->lock_file($self->{'job'}->{'file'});
		$self->{'access_hash'}->{'delete'} && $self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) ||
			$self->error($self->{'text_hash'}->{'edit_ecannot'});
		$self->delete_cron_job($self->{'job'});
		}
	$self->unlock_all_files();
	$self->webmin_log("delete", "crons", scalar(@d));
	}
elsif ($self->{'in_hash'}->{'disable'} || $self->{'in_hash'}->{'enable'}) {
	# Disable selected
	foreach $d (@d) {
		$self->{'job'} = $self->{'jobs_array'}->[$d];
		$self->lock_file($self->{'job'}->{'file'});
		$self->can_edit_user(\%{$self->{'access_hash'}}, $self->{'job'}->{'user'}) ||
                        $self->error($self->{'text_hash'}->{'edit_ecannot'});
		$self->{'job'}->{'active'} = $self->{'in_hash'}->{'disable'} ? 0 : 1;
		$self->change_cron_job($self->{'job'});
		}
	$self->unlock_all_files();
	$self->webmin_log($self->{'in_hash'}->{'disable'} ? "disable" : "enable", "crons", scalar(@d));
	}
$self->redirect("");

1;
		
}


1;

