#!/usr/bin/perl

$no_acl_check++;
require './cron-lib.pl';

sub module_install {
	@list_cron=&list_cron_jobs();
	@modules = &get_all_module_infos(2);

	foreach my $mod (@modules){
		push @array,$mod->{'dir'};
	}
	
	foreach my $task (@list_cron){
		my $tmp_conf_dir = $config_directory;
		if ($task->{'command'} =~ /$tmp_conf_dir[\/]*([A-Za-z]+(-|_)[A-Za-z]+)\//) {
			my $mod=$1;
			my $def=$2;
			local ($value) = grep { $_ eq $mod} @array;
			if ($def eq "-" && !$value){
				$task->{'command'} =~ s/-/_/;
			}
			elsif ($def eq "_" && !$value) {
				$task->{'command'} =~ s/_/-/;
			}
			&change_cron_job($task);
		}
	}
}

1;
