#!/usr/bin/perl
package custom::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'custom::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "custom::CustomLib");
$self = new custom::CustomLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the custom module
sub acl_security_form
{
	my $self = shift;

local $mode = $_[0]->{'cmds'} eq '*' ? 1 :
	      $_[0]->{'cmds'} =~ /^\!/ ? 2 : 0;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_cmds'}</b></td> <td>\n";
printf "<input type=radio name=cmds_def value=1 %s> %s\n",
	$mode == 1 ? 'checked' : '', $self->{'text_hash'}->{'acl_call'};
printf "<input type=radio name=cmds_def value=0 %s> %s\n",
	$mode == 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_csel'};
printf "<input type=radio name=cmds_def value=2 %s> %s<br>\n",
	$mode == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_cexcept'};
print "<select name=cmds size=5 multiple width=200>\n";
local @cmds = $self->list_commands();
local ($c, %ccan);
map { $ccan{$_}++ } split(/\s+/, $_[0]->{'cmds'});
foreach $c (@cmds) {
	printf "<option value=%s %s> %s\n",
		$c->{'id'},
		$ccan{$c->{'id'}} ? "selected" : "",
		$c->{'desc'};
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_edit'}</b></td> <td>\n";
printf "<input type=radio name=edit value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'edit'} ? "checked" : "";
printf "<input type=radio name=edit value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'edit'} ? "" : "checked";
}

# acl_security_save(&options)
# Parse the form for security options for the custom module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'cmds_def'} == 1) {
	$_[0]->{'cmds'} = "*";
	}
elsif ($self->{'in_hash'}->{'cmds_def'} == 0) {
	$_[0]->{'cmds'} = join(" ", split(/\0/, $self->{'in_hash'}->{'cmds'}));
	}
else {
	$_[0]->{'cmds'} = join(" ", "!", split(/\0/, $self->{'in_hash'}->{'cmds'}));
	}
$_[0]->{'edit'} = $self->{'in_hash'}->{'edit'};
}


1;

