#!/usr/bin/perl
package custom::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'custom::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "custom::CustomLib");
$self = new custom::CustomLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
if ($type eq 'command') {
	return $self->text("log_${action}",
		     "<tt>".$self->html_escape($p->{'desc'})."</tt>");
	}
elsif ($type eq 'edit') {
	return $self->text("log_${action}_edit",
		     "<tt>".$self->html_escape($p->{'desc'})."</tt>");
	}
else {
	return undef;
	}
}


1;

