#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cmd.cgi
# Display a custom command and its parameters

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "", "create");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "", "edit");
	@{$self->{'cmds_array'}} = $self->list_commands();
	$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_cmd.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if (!$self->{'in_hash'}->{'new'}) {
	print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'edit_id'}, "id"),
	      "</b></td>\n";
	print "<td><tt>$self->{'cmd'}->{'id'}</tt></td> </tr>\n";
	}

print "<tr> <td valign=top><b>",$self->hlink($self->{'text_hash'}->{'edit_desc'}, "desc"),
      "</b></td>\n";
print "<td colspan=3><input name=desc size=50 value='",
	$self->html_escape($self->{'cmd'}->{'desc'}),"'><br>\n";
print "<textarea name=html rows=2 cols=50>",$self->{'cmd'}->{'html'},
      "</textarea></td> </tr>\n";

if ($self->{'cmd'}->{'cmd'} =~ s/^\s*cd\s+(\S+)\s*;\s*//) {
	$self->{'dir'} = $1;
	}
print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_cmd'},"command"),"</b></td>\n";
print "<td colspan=3><input name=cmd size=50 value=\"".
	$self->html_escape($self->{'cmd'}->{'cmd'})."\"></td> </tr>\n";

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_dir'},"dir"),"</b></td>\n";
$self->{'dir'} =~ s/"/&quot;/g;
printf "<td colspan=3><input type=radio name=dir_def value=1 %s> %s\n",
	$self->{'dir'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=dir_def value=0 %s>\n",
	$self->{'dir'} ? "checked" : "";
printf "<input name=dir size=40 value=\"%s\"> %s</td> </tr>\n",
	$self->{'dir'}, $self->file_chooser_button("dir", 1);

if ($self->supports_users()) {
	print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_user'},"user"),"</b></td>\n";
	print "<td colspan=3>\n";
	printf "<input type=radio name=user_def value=1 %s> %s\n",
		$self->{'cmd'}->{'user'} eq '*' && !$self->{'in_hash'}->{'new'} ? "checked" : "",
		$self->{'text_hash'}->{'edit_user_def'};
	printf "<input type=radio name=user_def value=0 %s>\n",
		$self->{'cmd'}->{'user'} eq '*' && !$self->{'in_hash'}->{'new'} ? "" : "checked";
	printf "<input name=user size=8 value='%s'> %s\n",
		$self->{'cmd'}->{'user'} eq '*' ? '' : $self->{'cmd'}->{'user'},
		$self->user_chooser_button("user", 0);
	printf "<input type=checkbox name=su value=1 %s> %s</td> </tr>\n",
		$self->{'cmd'}->{'su'} ? 'checked' : '', $self->{'text_hash'}->{'edit_su'};
	}

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_raw'},"raw"),"</b></td>\n";
printf "<td><input type=radio name=raw value=1 %s> %s\n",
	$self->{'cmd'}->{'raw'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=raw value=0 %s> %s</td>\n",
	$self->{'cmd'}->{'raw'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>",$self->hlink($self->{'text_hash'}->{'edit_order'},"order"),"</b></td>\n";
printf "<td><input type=radio name=order_def value=1 %s> %s\n",
	$self->{'cmd'}->{'order'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=order_def value=0 %s>\n",
	$self->{'cmd'}->{'order'} ? "checked" : "";
printf "<input name=order size=6 value='%s'></td> </tr>\n",
	$self->{'cmd'}->{'order'} ? $self->{'cmd'}->{'order'} : '';

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_noshow'},"noshow"),"</b></td>\n";
printf "<td><input type=radio name=noshow value=1 %s> %s\n",
	$self->{'cmd'}->{'noshow'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=noshow value=0 %s> %s</td>\n",
	$self->{'cmd'}->{'noshow'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td><b>",$self->hlink($self->{'text_hash'}->{'edit_usermin'},"usermin"),"</b></td>\n";
printf "<td><input type=radio name=usermin value=1 %s> %s\n",
	$self->{'cmd'}->{'usermin'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=usermin value=0 %s> %s</td> </tr>\n",
	$self->{'cmd'}->{'usermin'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td><b>",$self->hlink($self->{'text_hash'}->{'edit_timeout'},"timeout"),"</b></td>\n";
printf "<td><input type=radio name=timeout_def value=1 %s> %s\n",
	$self->{'cmd'}->{'timeout'} ? "" : "checked", $self->{'text_hash'}->{'edit_timeoutdef'};
printf "<input type=radio name=timeout_def value=0 %s>\n",
	$self->{'cmd'}->{'timeout'} ? "checked" : "";
printf "<input name=timeout size=6 value='%s'> %s</td>\n",
	$self->{'cmd'}->{'timeout'} ? $self->{'cmd'}->{'timeout'} : '', $self->{'text_hash'}->{'edit_secs'};

print "<td><b>",$self->hlink($self->{'text_hash'}->{'edit_clear'},"clear"),"</b></td>\n";
printf "<td><input type=radio name=clear value=1 %s> %s\n",
	$self->{'cmd'}->{'clear'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=clear value=0 %s> %s</td> </tr>\n",
	$self->{'cmd'}->{'clear'} ? "" : "checked", $self->{'text_hash'}->{'no'};

# Show Webmin servers to run on
@{$self->{'servers_array'}} = $self->list_servers();
if (@{$self->{'servers_array'}} > 1) {
	print "<tr> <td valign=top><b>",
		$self->hlink($self->{'text_hash'}->{'edit_servers'}, "servers"),"</b></td>\n";
	print "<td colspan=3>";
	@{$self->{'hosts_array'}} = @{$self->{'cmd'}->{'hosts'}};
	@{$self->{'hosts_array'}} = ( 0 ) if (!@{$self->{'hosts_array'}});
	print $self->ui_select("hosts", \@{$self->{'hosts_array'}},
	 [ map { [ $_->{'id'}, ($_->{'desc'} || $_->{'host'}) ] } @{$self->{'servers_array'}} ],
	 5, 1);
	print "</td> </tr>\n";
	}

print "</table></td></tr></table><p>\n";

# Show parameters
$self->show_params_inputs($self->{'cmd'});

print "<table width=100%><tr>\n";
print "<td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<td align=right><input type=submit name=delete ",
	      "value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

