#!/usr/bin/perl

&MAIN();

 sub MAIN {
# form.cgi
# Display the form for one custom command on a page

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();
@{$self->{'cmds_array'}} = $self->list_commands();
$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
$self->can_run_command($self->{'cmd'}) || $self->error($self->{'text_hash'}->{'form_ecannot'});

# Display form for command parameters
$self->ui_print_header(undef, $self->{'text_hash'}->{'form_title'}, "");
@a = @{$self->{'cmd'}->{'args'}};
($self->{'up'}) = grep { $_->{'type'} == 10 } @a;
if ($self->{'cmd'}->{'edit'}) {
	print "<form action=view.cgi>\n";
	}
elsif ($self->{'up'}) {
	print "<form action=run.cgi method=post enctype=multipart/form-data>\n";
	}
elsif (@a) {
	print "<form action=run.cgi method=post>\n";
	}
else {
	print "<form action=run.cgi method=get>\n";
	}
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->html_escape($self->{'cmd'}->{'desc'}),"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>",$self->{'cmd'}->{'html'},"<table width=100%>\n";

foreach $a (@{$self->{'cmd'}->{'args'}}) {
	print "<tr>\n" if (!$self->{'col'});
	print "<td width=25%><b>",$self->html_escape($a->{'desc'}),
	      "</b></td> <td width=25% nowrap>\n";
	$self->{'n'} = $a->{'name'};
	if ($a->{'type'} == 0) {
		print "<input name=$self->{'n'} size=30>\n";
		}
	elsif ($a->{'type'} == 1 || $a->{'type'} == 2) {
		print "<input name=$self->{'n'} size=8> ",
			$self->user_chooser_button($self->{'n'}, 0);
		}
	elsif ($a->{'type'} == 3 || $a->{'type'} == 4) {
		print "<input name=$self->{'n'} size=8> ",
			$self->group_chooser_button($self->{'n'}, 0);
		}
	elsif ($a->{'type'} == 5 || $a->{'type'} == 6) {
		print "<input name=$self->{'n'} size=30 value='$a->{'opts'}'> ",
			$self->file_chooser_button($self->{'n'}, $a->{'type'}-5);
		}
	elsif ($a->{'type'} == 7) {
		print "<input type=radio name=$self->{'n'} value=1> $self->{'text_hash'}->{'yes'}\n";
		print "<input type=radio name=$self->{'n'} value=0 checked> $self->{'text_hash'}->{'no'}\n";
		}
	elsif ($a->{'type'} == 8) {
		print "<input name=$self->{'n'} type=password size=30>\n";
		}
	elsif ($a->{'type'} == 9) {
		print "<select name=$self->{'n'}>\n";
		foreach $l ($self->read_opts_file($a->{'opts'})) {
			print "<option value='$l->[0]'>",
			      "$l->[1]\n";
			}
		print "</select>\n";
		}
	elsif ($a->{'type'} == 10) {
		print "<input name=$self->{'n'} type=file size=20>\n";
		}
	elsif ($a->{'type'} == 11) {
		print "<textarea name=$self->{'n'} rows=4 cols=30>".
		      "</textarea>\n";
		}
	print "</td>\n";
	print "</tr>\n" if ($self->{'col'});
	$self->{'col'} = !$self->{'col'};
	}
print "<td colspan=2 width=50%></td> </tr>\n" if ($self->{'col'});

$self->{'txt'} = $self->{'cmd'}->{'edit'} ? $self->{'text_hash'}->{'form_edit'} : $self->{'text_hash'}->{'form_exec'};
print "<tr> <td colspan=4><input type=submit value='$self->{'txt'}'>",
      "</td> </tr>\n";
print "</table></td></tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

