#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save, create or delete an SQL command

&ModuleLoader::preload_module('custom_class', "custom::CustomLib");
$self = new custom::CustomLib:: 'custom_class',%$self;

$self->ReadParse();

$self->{'access_hash'}->{'edit'} || $self->error($self->{'text_hash'}->{'save_ecannot'});
@{$self->{'cmds_array'}} = $self->list_commands();
if ($self->{'in_hash'}->{'delete'}) {
	$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_command($self->{'cmd'});
	$self->webmin_log("delete", "command", $self->{'cmd'}->{'id'}, $self->{'cmd'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'sql_err'});
	if (!$self->{'in_hash'}->{'new'}) {
		$self->{'cmd'} = $self->{'cmds_array'}->[$self->{'in_hash'}->{'idx'}];
		}
	else {
		$self->{'cmd'} = { 'id' => time() };
		}

	# parse and validate inputs
	$self->{'cmd'}->{'desc'} = $self->{'in_hash'}->{'desc'};
	$self->{'in_hash'}->{'html'} =~ s/\r//g;
        $self->{'in_hash'}->{'html'} =~ s/\n*/\n/;
	$self->{'cmd'}->{'html'} = $self->{'in_hash'}->{'html'};
	$self->{'cmd'}->{'type'} = $self->{'in_hash'}->{'type'};
	$self->{'in_hash'}->{'db'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'sql_edb'});
	$self->{'cmd'}->{'db'} = $self->{'in_hash'}->{'db'};
	$self->{'in_hash'}->{'sql'} =~ /\S/ || $self->error($self->{'text_hash'}->{'sql_esql'});
	$self->{'in_hash'}->{'sql'} =~ s/\r//g;
	$self->{'cmd'}->{'sql'} = $self->{'in_hash'}->{'sql'};
	$self->{'cmd'}->{'user'} = $self->{'in_hash'}->{'dbuser'};
	$self->{'cmd'}->{'pass'} = $self->{'in_hash'}->{'dbpass'};
	if ($self->{'in_hash'}->{'host_def'}) {
		delete($self->{'cmd'}->{'host'});
		}
	else {
		gethostbyname($self->{'in_hash'}->{'host'}) || $self->error($self->{'text_hash'}->{'sql_ehost'});
		$self->{'cmd'}->{'host'} = $self->{'in_hash'}->{'host'};
		}
	$self->parse_params_inputs($self->{'cmd'});
	$self->save_command($self->{'cmd'});
	$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : "modify", "command",
		    $self->{'cmd'}->{'id'}, $self->{'cmd'});

	if ($self->{'in_hash'}->{'new'} && $self->{'access_hash'}->{'cmds'} ne '*') {
		$self->{'access_hash'}->{'cmds'} .= " ".$self->{'cmd'}->{'id'};
		$self->save_module_acl(\%{$self->{'access_hash'}});
		}
	}
$self->redirect("");

1;
		
}


1;

