#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_file.cgi
# displays a form for editing file

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

local ($conf,$group);
if (exists $self->{'in_hash'}->{'idx'})
{
 # edit filter group file
 # get filter group file
 $group = $self->get_filter_group($self->{'in_hash'}->{'idx'});
 $conf = $group->{'conf'};
}
elsif ($self->{'in_hash'}->{'section'})
{
 # edit config file
 # get dansguardian configuration
 $conf = $self->parse_config_file();
}
local $file = $self->get_config_value($self->{'in_hash'}->{'option'}, $conf);
$file =~ /^'(.*?)'$/;
$file = $1;

# print header
$self->ui_print_header(undef, $self->text('index_edit',$file), undef, undef, undef);

# print file form
print $self->ui_form_start('save_file.cgi','form-data');
print $self->ui_hidden('option',$self->{'in_hash'}->{'option'});
if (exists $self->{'in_hash'}->{'idx'})
{
 # for filter group file
 print $self->text('edit_file_msg',"<B>$file</B>")."</BR>\n";
 print $self->ui_hidden('idx',$self->{'in_hash'}->{'idx'});
}
elsif ($self->{'in_hash'}->{'section'})
{
 # for config file
 print $self->ui_hidden('section',$self->{'in_hash'}->{'section'});
 print $self->text('edit_conf_file_msg',"<B>$file</B>")."</BR>\n";
}
print "<TEXTAREA name=data rows=30 cols=85>";
$self->print_filter_file($file);
print "</TEXTAREA><BR>\n";
print $self->ui_submit($self->{'text_hash'}->{'save'});
print $self->ui_form_end();

# print navigation URL
if (exists $self->{'in_hash'}->{'idx'})
{
 # back to filter group
 $self->ui_print_footer("filter_group.cgi?idx=$self->{'in_hash'}->{'idx'}",$self->text('index_group',$group->{'name'}),"", $self->{'text_hash'}->{'index_return'});
}
elsif ($self->{'in_hash'}->{'section'})
{
 # back to configuration section
 $self->ui_print_footer("options.cgi?section=$self->{'in_hash'}->{'section'}",$self->{'text_hash'}->{"index_$self->{'in_hash'}->{'section'}"},"", $self->{'text_hash'}->{'index_return'});
}

1;
		
}


1;

