#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_filter_group.cgi
# save dansguardian filter group options

# main part
&ModuleLoader::preload_module('dg_class', "dg::DgLib");
$self = new dg::DgLib:: 'dg_class',%$self;

$self->ReadParse();

# get filter groups file
local $group = $self->get_filter_group($self->{'in_hash'}->{'idx'});

if ($self->{'in_hash'}->{'delete'})
{
 # delete group
 $self->delete_filter_group($group->{'file'}, $group->{'name'});
}
else
{
 # modify group
 local $conf = $group->{'conf'};
 
 # get section list for installed version
 local $options = $self->get_filter_option_list();

 # print options
 foreach (@{$options})
 {
  unless ($self->{'in_hash'}->{"$_->[0]_def"})
  {
   # delete option
   $self->del_config_value($_->[0],$conf); 
  }
  else
  {
   # change option value
   $self->set_config_value($_->[0],$self->{'in_hash'}->{$_->[0]},$conf); 
  }
 }
 # save options
 $self->save_new_options($conf, $group->{'file'});
}

if ($self->{'config_hash'}->{'save_apply'} && $self->status_dansguardian())
{
 # restart dansguardian
 $self->restart_dansguardian();
}

# redirect to index.cgi
$self->redirect("index.cgi");
1;
		
}


1;

