#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_theme.cgi
# Change the current webmin theme

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'themes'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();

$self->lock_file($self->{'usermin_config'});
$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
$self->{'uconfig_hash'}->{'theme'} = $self->{'in_hash'}->{'theme'};
$self->put_usermin_config(\%{$self->{'uconfig_hash'}});
$self->unlock_file($self->{'usermin_config'});

$self->lock_file($self->{'usermin_miniserv_config'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
if ($self->{'in_hash'}->{'theme'}) {
	$self->{'miniserv_hash'}->{'preroot'} = $self->{'in_hash'}->{'theme'};
	}
else {
	delete($self->{'miniserv_hash'}->{'preroot'});
	}
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();
$self->webmin_log('theme', undef, undef, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

