#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_users.cgi
# Update user allow and deny parameters

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
use Socket;
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'users_err'});

@{$self->{'users_array'}} = split(/\s+/, $self->{'in_hash'}->{"user"});
if ($self->{'in_hash'}->{"access"}) {
	foreach $u (@{$self->{'users_array'}}) {
		if ($u =~ /^\@(\S+)$/) {
			defined(getgrnam($1)) ||
				$self->error($self->text('users_egroup', "$1"));
			}
		elsif ($u =~ /^(\d*)-(\d*)$/ && ($1 || $2)) {
			# Assume UIDs are ok
			}
		else {
			defined(getpwnam($u)) ||
				$self->error($self->text('users_euser', $u));
			}
		}
	}
if ($self->{'in_hash'}->{'shells_deny'}) {
	-r $self->{'in_hash'}->{'shells'} || $self->error($self->{'text_hash'}->{'users_eshell'});
	}

$self->lock_file($self->{'usermin_miniserv_config'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
delete($self->{'miniserv_hash'}->{"allowusers"});
delete($self->{'miniserv_hash'}->{"denyusers"});
if ($self->{'in_hash'}->{"access"} == 1) { $self->{'miniserv_hash'}->{"allowusers"} = join(' ', @{$self->{'users_array'}}); }
elsif ($self->{'in_hash'}->{"access"} == 2) { $self->{'miniserv_hash'}->{"denyusers"} = join(' ', @{$self->{'users_array'}}); }
if ($self->{'in_hash'}->{'shells_deny'}) {
	$self->{'miniserv_hash'}->{'shells_deny'} = $self->{'in_hash'}->{'shells'};
	}
else {
	delete($self->{'miniserv_hash'}->{'shells_deny'});
	}
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();
$self->webmin_log("users", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

