#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_bind.cgi
# Display port / address form

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'bind'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'bind_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->{'text_hash'}->{'bind_desc2'},"<p>\n";

print "<form action=change_bind.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'bind_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Build list of sockets
@{$self->{'sockets_array'}} = $main::cpplus_object->get_miniserv_sockets(\%{$self->{'miniserv_hash'}});

# Show table of all bound IPs and ports
print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'bind_sockets'}</b></td>\n";
print "<td><table border>\n";
print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'bind_sip'}</b></td> ",
      "<td><b>$main::cpplus_object->{'text_hash'}->{'bind_sport'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $s (@{$self->{'sockets_array'}}, [ undef, "*" ]) {
	print "<tr $self->{'cb'}>\n";
	print "<td><select name=ip_def_$self->{'i'}>\n";
	printf "<option value=0 %s>&nbsp;\n",
		$s->[0] ? "" : "selected";
	printf "<option value=1 %s>%s\n",
		$s->[0] eq "*" ? "selected" : "", $main::cpplus_object->{'text_hash'}->{'bind_sip1'};
	printf "<option value=2 %s>%s\n",
		$s->[0] eq "*" || !$s->[0] ? "" : "selected",$main::cpplus_object->{'text_hash'}->{'bind_sip2'};
	print "</select>\n";
	printf "<input name=ip_$self->{'i'} size=20 value='%s'></td>\n",
		$s->[0] eq "*" ? undef : $s->[0];

	print "<td>\n";
	print "<select name=port_def_$self->{'i'}>\n";
	if ($self->{'i'}) {
		printf "<option value=0 %s>%s\n",
			$s->[1] eq "*" ? "selected" : "", $main::cpplus_object->{'text_hash'}->{'bind_sport0'};
		}
	printf "<option value=1 %s>%s\n",
		$s->[1] eq "*" ? "" : "selected", $main::cpplus_object->{'text_hash'}->{'bind_sport1'};
	print "</select>\n";
	printf "<input name=port_$self->{'i'} size=5 value='%s'></td>\n",
		$s->[1] eq "*" ? undef : $s->[1];
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

# Show web server hostname
print "<tr> <td nowrap><b>$main::cpplus_object->{'text_hash'}->{'bind_hostname'}</b></td>\n";
print "<td>",$self->ui_radio("hostname_def", $self->{'miniserv_hash'}->{"hostname"} ? 0 : 1,
	[ [ 1, $main::cpplus_object->{'text_hash'}->{'bind_auto'} ],
	  [ 0, $self->ui_textbox("hostname", $self->{'miniserv_hash'}->{"hostname"}, 25) ] ]),
	"</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

