#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show module description overrides

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'descs_title'}, undef);
print "$self->{'text_hash'}->{'descs_info'}<p>\n";

$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/webmin.descs", \%{$self->{'descs_hash'}});
print $self->ui_form_start("save_descs.cgi");
print $self->ui_columns_start([ $main::cpplus_object->{'text_hash'}->{'descs_mod'},
			  $main::cpplus_object->{'text_hash'}->{'descs_desc'} ]);
$self->{'i'} = 0;
@{$self->{'mods_array'}} = sort { $a->{'realdesc'} cmp $b->{'realdesc'} } $self->list_modules();
foreach $d ((sort { $a cmp $b } (keys %{$self->{'descs_hash'}})), undef, undef, undef) {
	next if ($d =~ /^(\S+)\s+(\S+)$/);
	print $self->ui_columns_row([
		$self->ui_select("mod_$self->{'i'}", $d,
		   [ [ "", "&nbsp;" ],
		     map { [ $_->{'dir'}, $_->{'realdesc'} ] } @{$self->{'mods_array'}} ]),
		$self->ui_textbox("desc_$self->{'i'}", $self->{'descs_hash'}->{$d}, 40) ]);
	$self->{'i'}++;
	}
print $self->ui_columns_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

