#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display per-user and group logout times options

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'logout'} || $self->error($self->{'text_hash'}->{'logout_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'logout_title'}, "");
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

print $self->{'text_hash'}->{'logout_desc'},"<p>\n";
foreach $a (split(/\s+/, $self->{'miniserv_hash'}->{'logouttimes'})) {
	if ($a =~ /^([^=]+)=(\S+)$/) {
		push(@{$self->{'logout_array'}}, [ $1, $2 ]);
		}
	}

print $self->ui_form_start("save_logout.cgi", "post");
print $self->ui_columns_start([ $self->{'text_hash'}->{'logout_type'},
			  $self->{'text_hash'}->{'logout_who'},
			  $self->{'text_hash'}->{'logout_time'} ]);
$self->{'i'} = 0;
foreach $l (@{$self->{'logout_array'}}, [ ], [ ], [ ]) {
	local ($type, $who) = (0, $l->[0]);
	if ($l->[0] =~ /^\@(.*)$/) {
		$type = 2;
		$who = $1;
		}
	elsif ($l->[0] =~ /^(\/.*)$/) {
		$type = 3;
		}
	elsif ($l->[0]) {
		$type = 1;
		}
	print $self->ui_columns_row([
		$self->ui_select("type_$self->{'i'}", $type,
			   [ [ 0, "&nbsp;" ],
			     [ 1, $self->{'text_hash'}->{'logout_user'} ],
			     [ 2, $self->{'text_hash'}->{'logout_group'} ],
			     [ 3, $self->{'text_hash'}->{'logout_file'} ] ]),
		$self->ui_textbox("who_$self->{'i'}", $who, 30),
		$self->ui_textbox("time_$self->{'i'}", $l->[1], 6) ]);
	$self->{'i'}++;
	}
print $self->ui_columns_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

