#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_os.cgi
# Operating system config form

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'os'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'os_title'}, "");

print $self->{'text_hash'}->{'os_desc3'},"<br>\n";
print $self->{'text_hash'}->{'os_desc2'},"<br>\n";

$self->get_usermin_config(\%{$self->{'uconfig_hash'}});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

print "<form action=change_os.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'os_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

# OS according to Usermin
$self->{'osfile'} = "$self->{'miniserv_hash'}->{'root'}/os_list.txt";
print "<tr> <td><b>$self->{'text_hash'}->{'os_usermin'}</b></td>\n";
print "<td>",$self->ui_select("type", $self->{'uconfig_hash'}->{'real_os_type'},
	[ map { [ $_ ] } sort { $a cmp $b } $self->unique(map { $_->{'realtype'} }
			 $main::cpplus_object->list_operating_systems($self->{'osfile'})) ]),"\n";
print $self->ui_textbox("version", $self->{'uconfig_hash'}->{'real_os_version'}, 10),"</td> </tr>\n";

# Internal OS code
print "<tr> <td><b>$self->{'text_hash'}->{'os_iusermin'}</b></td>\n";
print "<td>",$self->ui_select("itype", $self->{'uconfig_hash'}->{'os_type'},
	[ map { [ $_ ] } sort { $a cmp $b } $self->unique(map { $_->{'type'} }
			 $main::cpplus_object->list_operating_systems($self->{'osfile'})) ]),"\n";
print $self->ui_textbox("iversion", $self->{'uconfig_hash'}->{'os_version'}, 10),"</td> </tr>\n";

# Detected OS
%{$self->{'osinfo_hash'}} = $main::cpplus_object->detect_operating_system($self->{'osfile'});
print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'os_detect'}</b></td> <td>\n";
if ($self->{'osinfo_hash'}->{'real_os_type'}) {
	print "$self->{'osinfo_hash'}->{'real_os_type'} $self->{'osinfo_hash'}->{'real_os_version'}\n";
	if ($self->{'osinfo_hash'}->{'os_type'} ne $self->{'uconfig_hash'}->{'os_type'} ||
	    $self->{'osinfo_hash'}->{'os_version'} ne $self->{'uconfig_hash'}->{'os_version'}) {
		print "<br>",$self->ui_checkbox("update", 1, $self->{'text_hash'}->{'os_update'});
		}
	}
else {
	print "<i>$main::cpplus_object->{'text_hash'}->{'os_cannot'}</i>\n";
	}
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'os_path'}</b></td>\n";
print "<td><textarea name=path rows=5 cols=30>",
	join("\n", split(/:/, $self->{'uconfig_hash'}->{'path'})),
	"</textarea></td> </tr>\n";

print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'os_ld_path'}</b></td>\n";
print "<td><textarea name=ld_path rows=3 cols=30>",
	join("\n", split(/:/, $self->{'uconfig_hash'}->{'ld_path'})),
	"</textarea></td> </tr>\n";

print "<tr> <td valign=top><b>$main::cpplus_object->{'text_hash'}->{'os_envs'}</b></td>\n";
print "<td><table border>\n";
print "<tr $self->{'tb'}> <td><b>$main::cpplus_object->{'text_hash'}->{'os_name'}</b></td> ",
      "<td><b>$main::cpplus_object->{'text_hash'}->{'os_value'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $e (keys %{$self->{'miniserv_hash'}}) {
	if ($e =~ /^env_(\S+)$/ &&
	    $1 ne "WEBMIN_CONFIG" && $1 ne "WEBMIN_VAR") {
		print "<tr $self->{'cb'}>\n";
		print "<td><input name=name_$self->{'i'} size=20 value='$1'></td>\n";
		print "<td><input name=value_$self->{'i'} size=30 ",
		      "value='$self->{'miniserv_hash'}->{$e}'></td>\n";
		print "</tr>\n";
		$self->{'i'}++;
		}
	}
print "<td><input name=name_$self->{'i'} size=20></td>\n";
print "<td><input name=value_$self->{'i'} size=30></td>\n";
print "</table></td></tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

