#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_restrict.cgi
# Edit a user or group module restriction

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'restrict'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'restrict_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'restrict_edit'}, "");
	@{$self->{'usermods_array'}} = $self->list_usermin_usermods();
	$self->{'um'} = $self->{'usermods_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_restrict.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=all value='$self->{'in_hash'}->{'all'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'restrict_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'restrict_who2'}</b></td>\n";
$self->{'umode'} = $self->{'um'}->[0] eq "*" ? 2 :
	 $self->{'um'}->[0] =~ /^\@/ ? 1 :
	 $self->{'um'}->[0] =~ /^\// ? 3 :
			     0;

printf "<td><input type=radio name=umode value=2 %s> %s<br>\n",
	$self->{'umode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'restrict_umode2'};

printf "<input type=radio name=umode value=0 %s> %s\n",
	$self->{'umode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'restrict_umode0'};
printf "<input name=user size=13 value='%s'> %s<br>\n",
	$self->{'umode'} == 0 ? $self->{'um'}->[0] : "", $self->user_chooser_button("user");

printf "<input type=radio name=umode value=1 %s> %s\n",
	$self->{'umode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'restrict_umode1'};
printf "<input name=group size=13 value='%s'> %s<br>\n",
	$self->{'umode'} == 1 ? substr($self->{'um'}->[0], 1) : "", $self->group_chooser_button("group");

if ($self->get_usermin_version() >= 1.031) {
	printf "<input type=radio name=umode value=3 %s> %s\n",
		$self->{'umode'} == 3 ? "checked" : "", $self->{'text_hash'}->{'restrict_umode3'};
	printf "<input name=file size=40 value='%s'> %s</td> </tr>\n",
		$self->{'umode'} == 3 ? $self->{'um'}->[0] : "", $self->file_chooser_button("file");
	}

$self->read_usermin_acl(\%{$self->{'acl_hash'}});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'restrict_mods'}</b><br>",
      $self->text('restrict_modsdesc', "edit_acl.cgi"),"</td> <td>\n";
printf "<input type=radio name=mmode value=0 %s> %s\n",
	$self->{'um'}->[1] eq "" ? "checked" : "", $self->{'text_hash'}->{'restrict_mmode0'};
printf "<input type=radio name=mmode value=1 %s> %s\n",
	$self->{'um'}->[1] eq "+" ? "checked" : "", $self->{'text_hash'}->{'restrict_mmode1'};
printf "<input type=radio name=mmode value=2 %s> %s<br>\n",
	$self->{'um'}->[1] eq "-" ? "checked" : "", $self->{'text_hash'}->{'restrict_mmode2'};
@{$self->{'mods_array'}} = $self->list_modules();
print "<table>\n";
foreach $m (@{$self->{'mods_array'}}) {
	print "<tr>\n" if ($self->{'i'} % 3 == 0);
	printf "<td width=33%%><input type=checkbox name=mod value=%s %s> %s</td>\n",
		$m->{'dir'}, $self->indexof($m->{'dir'}, @{$self->{'um'}->[2]}) >= 0 ?
				'checked' : '',
		$self->{'acl_hash'}->{"user",$m->{'dir'}} ? $m->{'desc'} : "<font color=#ff0000>$m->{'desc'}</font>";
	print "</tr>\n" if ($self->{'i'} % 3 == 2);
	$self->{'i'}++;
	}
print "</table>\n";
print $self->select_all_link("mod", 0),"\n";
print $self->select_invert_link("mod", 0),"\n";
print "</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_restrict.cgi", $self->{'text_hash'}->{'restrict_return'});

1;
		
}


1;

