#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_sessions.cgi
# Display current login sessions

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'sessions'} || $self->error($self->{'text_hash'}->{'sessions_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sessions_title'}, "");

$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$main::acl_object->open_session_db(\%{$self->{'miniserv_hash'}});
$self->{'time_now'} = time();

if ($self->foreign_available("useradmin")) {
	$self->foreign_require("useradmin", "user-lib.pl");
	@{$self->{'users_array'}} = $main::useradmin_object->list_users();
	%{$self->{'umap_hash'}} = map { $_->{'user'}, $_ } @{$self->{'users_array'}};
	}

print "<b>$self->{'text_hash'}->{'sessions_desc'}</b><p>\n";
@{$self->{'keys_array'}} = keys %{$main::acl_object->{'sessiondb_hash'}};
if (@{$self->{'keys_array'}}) {
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'sessions_id'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'sessions_user'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'sessions_host'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'sessions_login'}</b></td> </tr>\n";
	foreach $k (sort { @a=split(/\s+/, $main::acl_object->{'sessiondb_hash'}->{$a}); @b=split(/\s+/, $main::acl_object->{'sessiondb_hash'}->{$b}); $b[1] <=> $a[1] } @{$self->{'keys_array'}}) {
		next if ($k =~ /^1111111/);
		local ($user, $ltime, $lip) = split(/\s+/, $main::acl_object->{'sessiondb_hash'}->{$k});
		next if ($self->{'miniserv_hash'}->{'logouttime'} &&
			 $self->{'time_now'} - $ltime > $self->{'miniserv_hash'}->{'logouttime'}*60);
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='delete_session.cgi?id=$k'>$k</a></td>\n";
		if ($self->{'uinfo'} = $self->{'umap_hash'}->{$user}) {
			print "<td><a href='../useradmin/edit_user.cgi?num=$self->{'uinfo'}->{'num'}'>$user</a></td>\n";
			}
		else {
			print "<td>$user</td>\n";
			}
		print "<td>",($lip || "<br>"),"</td>\n";
		local $tm = localtime($ltime);
		print "<td><tt>$tm</tt></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'sessions_none'}</b><p>\n";
	}

# Show quick switch form
print "<hr>\n";
print $self->ui_form_start("switch.cgi", "get", "_new");
print $self->{'text_hash'}->{'sessions_switch'},"\n";
print $self->ui_user_textbox("user");
print $self->ui_submit($self->{'text_hash'}->{'sessions_ok'});
print $self->ui_form_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

