#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save, create or delete an IP-specific SSL key

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
@{$self->{'ipkeys_array'}} = $main::cpplus_object->get_ipkeys(\%{$self->{'miniserv_hash'}});
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'ipkey'} = $self->{'ipkeys_array'}->[$self->{'in_hash'}->{'idx'}];
	}
else {
	$self->{'ipkey'} = { };
	}

if ($self->{'in_hash'}->{'delete'}) {
	# Just remove this entry
	splice(@{$self->{'ipkeys_array'}}, $self->{'in_hash'}->{'idx'}, 1);
	}
else {
	# Validate inputs
	$self->error_setup($main::cpplus_object->{'text_hash'}->{'ipkey_err'});
	@{$self->{'ips_array'}} = split(/\s+/, $self->{'in_hash'}->{'ips'});
	foreach $i (@{$self->{'ips_array'}}) {
		$self->check_ipaddress($i) ||
			$self->error($main::cpplus_object->text('ipkey_eip', $i));
		}
	@{$self->{'ips_array'}} || $self->error($main::cpplus_object->text('ipkey_eips'));
	$self->{'ipkey'}->{'ips'} = \@{$self->{'ips_array'}};
	$main::cpplus_object->validate_key_cert($self->{'in_hash'}->{'key'}, $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'});
	$self->{'ipkey'}->{'key'} = $self->{'in_hash'}->{'key'};
	$self->{'ipkey'}->{'cert'} = $self->{'in_hash'}->{'cert_def'} ? undef : $self->{'in_hash'}->{'cert'};

	# Save or add
	if ($self->{'in_hash'}->{'new'}) {
		push(@{$self->{'ipkeys_array'}}, $self->{'ipkey'});
		}
	}

$main::cpplus_object->save_ipkeys(\%{$self->{'miniserv_hash'}}, \@{$self->{'ipkeys_array'}});
$self->lock_file($self->{'usermin_miniserv_config'});
$self->put_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
$self->unlock_file($self->{'usermin_miniserv_config'});
$self->restart_usermin_miniserv();
$self->webmin_log("ipkey");
$self->redirect("edit_ssl.cgi");

1;
		
}


1;

