#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_uconfigs.cgi
# Save default user inputs from edit_configs.cgi

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

&ModuleLoader::preload_module('enduser_cf_class', "ConfigLib");
$self = new ConfigLib:: 'enduser_cf_class',%$self;

$self->{'access_hash'}->{'configs'} || $self->error($self->{'text_hash'}->{'acl_ecannot'});
$self->ReadParse();
$self->can_use_module($self->{'in_hash'}->{'mod'}) || $self->error($self->{'text_hash'}->{'configs_ecannot'});
$self->{'m'} = $self->{'in_hash'}->{'mod'};
$self->error_setup($self->{'text_hash'}->{'config_err'});
$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});

mkdir("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}", 0700);
$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/uconfig");
$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/uconfig", \%{$self->{'uconfig_hash'}});

$self->parse_config(\%{$self->{'uconfig_hash'}}, "$self->{'miniserv_hash'}->{'root'}/$self->{'m'}/uconfig.info");

$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/uconfig", \%{$self->{'uconfig_hash'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/uconfig");

# Save the preferences config as well
mkdir("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}", 0700);
$self->lock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config");
$self->read_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config", \%{$self->{'mconfig_hash'}});
$self->{'mconfig_hash'}->{'noprefs'} = $self->{'in_hash'}->{'noprefs'} == 1 ? 1 : 0;
$self->write_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config", \%{$self->{'mconfig_hash'}});
$self->unlock_file("$self->{'config_hash'}->{'usermin_dir'}/$self->{'m'}/config");

# Save allowed options
%{$self->{'canconfig_hash'}} = map { $_, 1 } split(/\0/, $self->{'in_hash'}->{'_can'});
$self->{'canfile'} = "$self->{'config_hash'}->{'usermin_dir'}/$self->{'in_hash'}->{'mod'}/canconfig";
if ($self->{'in_hash'}->{'noprefs'} == 2) {
	# Save allowed list
	$self->write_file($self->{'canfile'}, \%{$self->{'canconfig_hash'}});
	}
else {
	# All are allowed (or denied)
	$self->unlink_file($self->{'canfile'});
	}

$self->webmin_log("uconfig", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("list_configs.cgi");

1;
		
}


1;

