#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Set the Usermin session cookie to be some other user

&ModuleLoader::preload_module('enduser_cf_class', "enduser_cf::Enduser_cfLib");
$self = new enduser_cf::Enduser_cfLib:: 'enduser_cf_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'sessions'} || $self->error($self->{'text_hash'}->{'switch_euser'});

$self->get_usermin_miniserv_config(\%{$self->{'miniserv_hash'}});
if ($self->check_pid_file($self->{'miniserv_hash'}->{'pidfile'})) {
	# Stop Usermin first, so that the DBM can be safely written
	$self->stop_usermin();
	$self->{'stopped'} = 1;
	}
$main::acl_object->open_session_db(\%{$self->{'miniserv_hash'}});
$self->seed_random();
$self->{'now'} = time();
$self->{'sid'} = int(rand()*$self->{'now'});
$main::acl_object->{'sessiondb_hash'}->{$self->{'sid'}} = "$self->{'in_hash'}->{'user'} $self->{'now'} $ENV{'REMOTE_ADDR'}";
dbmclose(%{$main::acl_object->{'sessiondb_hash'}});
if ($self->{'stopped'}) {
	$self->start_usermin();
	}
$self->reload_usermin_miniserv();
$self->webmin_log("switch", undef, $self->{'in_hash'}->{'user'});
eval "use Net::SSLeay";
if ($@) {
	$self->{'miniserv_hash'}->{'ssl'} = 0;
	}
$self->{'ssl'} = $self->{'miniserv_hash'}->{'ssl'} || $self->{'miniserv_hash'}->{'inetd_ssl'};
$self->{'sec'} = $self->{'ssl'} ? "; secure" : "";
$self->{'sidname'} = $self->{'miniserv_hash'}->{'sidname'} || 'sid';
print "Set-Cookie: $self->{'sidname'}=$self->{'sid'}; path=/$self->{'sec'}\n";

# Work out redirect host
@{$self->{'sockets_array'}} = $main::cpplus_object->get_miniserv_sockets(\%{$self->{'miniserv_hash'}});
if ($self->{'config_hash'}->{'host'}) {
	# Specific hostname set
	$self->{'host'} = $self->{'config_hash'}->{'host'};
	}
else {
	if ($self->{'sockets_array'}->[0]->[0] ne "*") {
		# Listening on special IP
		$self->{'host'} = $self->{'sockets_array'}->[0]->[0];
		$self->{'port'} = $self->{'sockets_array'}->[0]->[1] if ($self->{'sockets_array'}->[0]->[1] ne '*');
		}
	else {
		# Use same hostname as this server
		$self->{'host'} = $ENV{'HTTP_HOST'};
		$self->{'host'} =~ s/:.*//;
		}
	}
$self->{'port'} ||= $self->{'config_hash'}->{'port'} || $self->{'miniserv_hash'}->{'port'};

$self->redirect(($self->{'ssl'} ? "https://" : "http://").
	  $self->{'host'}.":".$self->{'port'}."/");

1;
		
}


1;

