#!/usr/bin/perl
package chfn::Editor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'chfn::Editor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# editor.pl
# Called by chfn to edit freebsd user details

sleep(1);
open(FILE, $ARGV[0]);
@{$self->{'lines_array'}} = <FILE>;
close(FILE);
open(FILE, ">$ARGV[0]");
foreach $l (@{$self->{'lines_array'}}) {
	if ($l =~ /^(Shell):/i) {
		$l = "$1: $ENV{'EDITOR_SHELL'}\n";
		}
	elsif ($l =~ /^(Full Name):/i) {
		$l = "$1: $ENV{'EDITOR_REAL'}\n";
		}
	elsif ($l =~ /^(Office Location):/i) {
		$l = "$1: $ENV{'EDITOR_OFFICE'}\n";
		}
	elsif ($l =~ /^(Office Phone):/i) {
		$l = "$1: $ENV{'EDITOR_OPHONE'}\n";
		}
	elsif ($l =~ /^(Home Phone):/i) {
		$l = "$1: $ENV{'EDITOR_HPHONE'}\n";
		}
	print FILE $l;
	}
close(FILE);

1;
		return $self;
}


1;

