#!/usr/bin/perl
package cshrc::CshrcLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'cshrc::CshrcLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# cshrc-lib.pl

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
$self->switch_to_remote_user();
$self->create_user_config_dirs();

if ($self->{'remote_user_info_array'}->[8] =~ /\/(csh|tcsh)$/) {
	@{$self->{'cshrc_files_array'}} = ( "$self->{'remote_user_info_array'}->[7]/.cshrc",
			 "$self->{'remote_user_info_array'}->[7]/.login" );
	@{$self->{'cshrc_types_array'}} = ( 0, 1 );
	}
elsif ($self->{'remote_user_info_array'}->[8] =~ /\/bash$/ ||
       $self->resolve_links($self->{'remote_user_info_array'}->[8]) =~ /\/bash$/) {
	@{$self->{'cshrc_files_array'}} = ( "$self->{'remote_user_info_array'}->[7]/.bashrc",
			 "$self->{'remote_user_info_array'}->[7]/.profile" );
	@{$self->{'cshrc_types_array'}} = ( 0, 1 );
	}
else {
	@{$self->{'cshrc_files_array'}} = ( "$self->{'remote_user_info_array'}->[7]/.profile" );
	@{$self->{'cshrc_types_array'}} = ( 1 );
	}

1;

1;
		return $self;
}


1;

