#!/usr/bin/perl

&MAIN();

 sub MAIN {
# check.cgi
# Run a fetchmail config file

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'check_title'}, "");

if ($self->{'config_hash'}->{'config_file'}) {
	$self->{'file'} = $self->{'config_hash'}->{'config_file'};
	}
else {
	$self->can_edit_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'poll_ecannot'});
	@{$self->{'uinfo_array'}} = getpwnam($self->{'in_hash'}->{'user'});
	$self->{'file'} = "$self->{'uinfo_array'}->[7]/.fetchmailrc";
	}

$self->{'cmd'} = "$self->{'config_hash'}->{'fetchmail_path'} -v -f '$self->{'file'}'";
if ($self->{'config_hash'}->{'mda_command'}) {
	$self->{'cmd'} .= " -m '$self->{'config_hash'}->{'mda_command'}'";
	}
if (defined($self->{'in_hash'}->{'idx'})) {
	@{$self->{'conf_array'}} = $self->parse_config_file($self->{'file'});
	$self->{'poll'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'cmd'} .= " $self->{'poll'}->{'poll'}";
	}

print $self->text('check_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>";
if ($< == 0) {
	# For webmin, switch to the user
	if ($self->{'in_hash'}->{'user'} ne 'root') {
		$self->{'cmd'} = $self->command_as_user($self->{'in_hash'}->{'user'}, 0, $self->{'cmd'})
		}
	open(CMD, "$self->{'cmd'} 2>&1 |");
	$self->additional_log("exec", undef, "su '$self->{'in_hash'}->{'user'}' -c '$self->{'cmd'}'");
	}
else {
	# For usermin, which has already switched
	open(CMD, "$self->{'cmd'} 2>&1 |");
	}
while(<CMD>) {
	print $self->html_escape($_);
	}
close(CMD);
print "</pre>\n";

if ($? > 256) { print "<b>$self->{'text_hash'}->{'check_failed'}</b> <p>\n"; }
else { print "$self->{'text_hash'}->{'check_ok'} <p>\n"; }

$self->webmin_log("check", defined($self->{'in_hash'}->{'idx'}) ? "server" : "file",
	    $self->{'config_hash'}->{'config_file'} ? $self->{'file'} : $self->{'in_hash'}->{'user'}, $self->{'poll'});

if (!$self->{'fetchmail_config'} && $self->{'config_hash'}->{'view_mode'}) {
	$self->ui_print_footer("edit_user.cgi?user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'user_return'},
			 "", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

