#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Show fetchmail configurations

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

# Check if fetchmail is installed
if (!$self->has_command($self->{'config_hash'}->{'fetchmail_path'})) {
	print $self->text('index_efetchmail',
			  "<tt>$self->{'config_hash'}->{'fetchmail_path'}</tt>"),"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'conf_array'}} = $self->parse_config_file($self->{'fetchmail_config'});
@{$self->{'conf_array'}} = grep { $_->{'poll'} } @{$self->{'conf_array'}};
$self->show_polls(\@{$self->{'conf_array'}}, $self->{'fetchmail_config'}, $self->{'remote_user_info_array'}->[0]);

if (@{$self->{'conf_array'}}) {
	# Show the fetchmail daemon form
	print "<hr>\n";
	print "<table width=100%>\n";

	if ($self->foreign_check("cron")) {
		# Show button to manage cron job
		print "<form action=edit_cron.cgi>\n";
		print "<tr> <td><input type=submit ",
		      "value='$self->{'text_hash'}->{'index_cron'}'></td>\n";
		print "<td>$self->{'text_hash'}->{'index_crondesc'}</td> </tr></form>\n";
		}

	print "<tr><td>\n";
	foreach $pf ("$self->{'remote_user_info_array'}->[7]/.fetchmail.pid",
		     "$self->{'remote_user_info_array'}->[7]/.fetchmail") {
		if (open(PID, $pf) && ($self->{'line'}=<PID>) &&
		    (($self->{'pid'},$self->{'interval'}) = split(/\s+/, $self->{'line'})) && $self->{'pid'} &&
		    kill(0, $self->{'pid'})) {
			$self->{'running'} = $pf;
			last;
			}
		}
	if ($self->{'running'}) {
		# daemon is running - offer to stop it
		print "<form action=stop.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_stop'}'></td>\n";
		print "<td>",$self->text('index_stopmsg', $self->{'interval'}),"</td>\n";
		}
	else {
		# daemon isn't running - offer to start it
		print "<form action=start.cgi>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'index_start'}'></td>\n";
		print "<td>",$self->text('index_startmsg',
			   "<input name=interval size=5 value='60'>"),"</td>\n";
		}
	print "</td></tr></table></form>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

