#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_vfile.cgi
# Display the contents of a vacation autoreply file

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'vfile_title'}, "");

$self->{'in_hash'}->{'vfile'} = $self->make_absolute($self->{'in_hash'}->{'vfile'});
open(FILE, $self->{'in_hash'}->{'vfile'});
while(<FILE>) {
	if (/^Subject:\s*(.*)/) {
		$self->{'subject'} = $1;
		}
	elsif (/^From:\s*(.*)/) {
		$self->{'from'} = $1;
		}
	else {
		push(@{$self->{'lines_array'}}, $_);
		}
	}
close(FILE);
if (!-r $self->{'in_hash'}->{'vfile'}) {
	($self->{'froms'}, $self->{'doms'}) = $main::mailbox_object->list_from_addresses();
	$self->{'from'} = $self->{'froms'}->[0];
	}

print $self->text('vfile_desc', "<tt>$self->{'in_hash'}->{'vfile'}</tt>"),"<p>\n";

print "<form action=save_vfile.cgi method=post enctype=multipart/form-data>\n";
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_hidden("num", $self->{'in_hash'}->{'num'}),"\n";
print $self->ui_hidden("vfile", $self->{'in_hash'}->{'vfile'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";

print "<table>\n";

# Show From: address option
print "<tr> <td>$self->{'text_hash'}->{'rfile_from'}</td>\n";
print "<td>",$self->ui_radio("from_def", $self->{'from'} ? 0 : 1,
		       [ [ 1, $self->{'text_hash'}->{'default'} ],
			 [ 0, " " ] ]),"\n",
	     $self->ui_textbox("from", $self->{'from'}, 50),"</td> </tr>\n";

# Show Subject: line option
print "<tr> <td>$self->{'text_hash'}->{'vfile_subject'}</td>\n";
print "<td>",$self->ui_radio("subject_def", $self->{'subject'} ? 0 : 1,
		       [ [ 1, $self->{'text_hash'}->{'default'} ],
			 [ 0, " " ] ]),"\n",
	     $self->ui_textbox("subject", $self->{'subject'}, 50),"</td> </tr>\n";

print "</table>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'rfile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer(defined($self->{'in_hash'}->{'idx'}) ?
		 ( "edit_vacation.cgi?num=$self->{'in_hash'}->{'num'}&file=$self->{'in_hash'}->{'file'}&idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'vacation_return'} ) : ( ),
		 "edit_alias.cgi?num=$self->{'in_hash'}->{'num'}&file=$self->{'in_hash'}->{'file'}",
		 $self->{'text_hash'}->{'aform_return'});

1;
		
}


1;

