#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rfile.cgi
# Save an autoreply file

&ModuleLoader::preload_module('forward_class', "forward::ForwardLib");
$self = new forward::ForwardLib:: 'forward_class',%$self;

$self->ReadParseMime();
$self->error_setup($self->{'text_hash'}->{'rfile_err'});

$self->{'in_hash'}->{'period_def'} || $self->{'in_hash'}->{'period'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'rfile_eperiod'});
$self->{'in_hash'}->{'from_def'} || $self->{'in_hash'}->{'from'} =~ /\S/ ||
	$self->error($self->{'text_hash'}->{'rfile_efrom'});

$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->open_tempfile(FILE, ">$self->{'in_hash'}->{'vfile'}", 1) || $self->error($self->text('rfile_ewrite', $!));
if ($self->{'in_hash'}->{'replies'}) {
	$self->{'rfile'} = "$self->{'user_module_config_directory'}/replies";
	$self->{'rfile'} = $self->{'in_hash'}->{'replies_file'} if ($self->{'in_hash'}->{'replies_file'} &&
					 $self->{'in_hash'}->{'replies_file'} ne $self->{'rfile'});
	$self->print_tempfile(FILE, "Reply-Tracking: $self->{'rfile'}\n");
	}
if (!$self->{'in_hash'}->{'period_def'}) {
	$self->print_tempfile(FILE, "Reply-Period: $self->{'in_hash'}->{'period'}\n");
	}
if ($self->{'in_hash'}->{'no_autoreply'}) {
	$self->print_tempfile(FILE, "No-Autoreply: $self->{'in_hash'}->{'no_autoreply'}\n");
	}
if (!$self->{'in_hash'}->{'from_def'}) {
	$self->print_tempfile(FILE, "From: $self->{'in_hash'}->{'from'}\n");
	}
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->redirect("edit_alias.cgi?num=$self->{'in_hash'}->{'num'}&file=$self->{'in_hash'}->{'file'}");
1;
		
}


1;

