#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_trust.cgi
# Change the trust level for a key

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();
$self->{'in_hash'}->{'trust'} || $self->error($self->{'text_hash'}->{'trust_echoice'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'trust_title'}, "");

@{$self->{'keys_array'}} = $self->list_keys();
$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];

$self->{'cmd'} = "$self->{'gpgpath'} --edit-key \"$self->{'key'}->{'name'}->[0]\"";
($fh, $self->{'fpid'}) = $self->foreign_call("proc", "pty_process_exec", $self->{'cmd'});
$self->wait_for($fh, "command>");
syswrite($fh, "trust\n");
$self->wait_for($fh, "decision");
syswrite($fh, $self->{'in_hash'}->{'trust'}."\n");
syswrite($fh, "quit\n");
sleep(1);
close($fh);

print $self->text('trust_done', "<tt>$self->{'key'}->{'name'}->[0]</tt>"),"<p>\n";

$self->ui_print_footer("list_keys.cgi", $self->{'text_hash'}->{'keys_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

