#!/usr/bin/perl

&MAIN();

 sub MAIN {
# decrypt.cgi
# Decrypt and output a file

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParseMime();

if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'decrypt_eupload'});
	$self->{'data'} = $self->{'in_hash'}->{'upload'};
	}
else {
	$self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'decrypt_eupload'});
	-r $self->{'in_hash'}->{'local'} || $self->error($self->{'text_hash'}->{'decrypt_elocal'});
	$self->{'data'} = $self->read_entire_file($self->{'in_hash'}->{'local'});
	}

$self->{'rv'} = $self->decrypt_data($self->{'data'}, \$self->{'plain'});
if ($self->{'rv'}) {
	$self->error($self->text('decrypt_egpg', $self->{'rv'}));
	}

local $temp = $self->transname();
$self->write_entire_file($temp, $self->{'plain'});
$self->{'type'} = `file $temp`;
unlink($temp);
if ($self->{'type'} =~ /text$/) {
	print "Content-type: text/plain\n\n";
	}
else {
	print "Content-type: application/octet-stream\n\n";
	}
print $self->{'plain'};

1;
		
}


1;

