#!/usr/bin/perl

&MAIN();

 sub MAIN {
# export.cgi
# Output a key as binary or ascii

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();
@{$self->{'keys_array'}} = $self->list_keys();
$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];

# Work out command-line args
$self->{'args'} = "--armor" if (!$self->{'in_hash'}->{'format'});
$self->{'cmd'} = "$self->{'gpgpath'} $self->{'args'} $self->{'args'} --export \"$self->{'key'}->{'name'}->[0]\"";
if ($self->{'in_hash'}->{'smode'}) {
	$self->{'cmd'} .= "; $self->{'gpgpath'} $self->{'args'} --export-secret-keys \"$self->{'key'}->{'name'}->[0]\"";
	}

if ($self->{'in_hash'}->{'mode'}) {
	# Saving to file
	$self->error_setup($self->{'text_hash'}->{'export_err'});
	if ($self->{'in_hash'}->{'to'} !~ /^\//) {
		$self->{'in_hash'}->{'to'} = $self->{'remote_user_info_array'}->[7]."/".$self->{'in_hash'}->{'to'};
		}
	$self->{'in_hash'}->{'to'} || $self->error($self->{'text_hash'}->{'export_efile'});
	if (-d $self->{'in_hash'}->{'to'}) {
		$self->{'in_hash'}->{'to'} .= "/".($self->{'in_hash'}->{'format'} ? "key.gpg" : "key.asc");
		}
	open(OUT, ">$self->{'in_hash'}->{'to'}") || $self->error($self->text('efilewrite', $self->{'in_hash'}->{'to'}, $!));
	$self->{'fh'} = "OUT";
	}
else {
	# Showing in browser
	if ($self->{'in_hash'}->{'format'}) {
		print "Content-type: application/octet-stream\n\n";
		}
	else {
		print "Content-type: text/plain\n\n";
		}
	$self->{'fh'} = "STDOUT";
	}

# Do it
open(GPG, "($self->{'cmd'}) |");
while(<GPG>) {
	{ my $t=$self->{'fh'}; print $t $_;}
	}
close(GPG);

if ($self->{'in_hash'}->{'mode'}) {
	# Tell the user
	close($self->{'fh'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'export_title'}, "");
	print $self->text('export_done', "<tt>$self->{'in_hash'}->{'to'}</tt>"),"<p>\n";
	$self->ui_print_footer("list_keys.cgi", $self->{'text_hash'}->{'keys_return'});
	}

1;
		
}


1;

