#!/usr/bin/perl

&MAIN();

 sub MAIN {
# owner.cgi
# Add or delete an owner from a key

&ModuleLoader::preload_module('gnupg_class', "gnupg::GnupgLib");
$self = new gnupg::GnupgLib:: 'gnupg_class',%$self;

$self->ReadParse();

@{$self->{'keys_array'}} = $self->list_keys();
$self->{'key'} = $self->{'keys_array'}->[$self->{'in_hash'}->{'idx'}];

if ($self->{'in_hash'}->{'add'}) {
	# Adding details
	$self->error_setup($self->{'text_hash'}->{'owner_err1'});
	$self->{'in_hash'}->{'name'} =~ /\S/ || $self->error($self->{'text_hash'}->{'owner_ename'});
	if ($self->{'in_hash'}->{'name'} =~ s/\((.*)\)\s*$//) {
		$self->{'cmt'} = $1;
		$self->{'in_hash'}->{'name'} =~ s/\s+$//;
		}

	$self->{'cmd'} = "$self->{'gpgpath'} --edit-key \"$self->{'key'}->{'name'}->[0]\"";
	($fh, $self->{'fpid'}) = $self->foreign_call("proc", "pty_process_exec", $self->{'cmd'});
	$self->wait_for($fh, "command>");
	syswrite($fh, "adduid\n");
	$self->wait_for($fh, "name:");
	syswrite($fh, "$self->{'in_hash'}->{'name'}\n");
	$self->wait_for($fh, "address:");
	syswrite($fh, "$self->{'in_hash'}->{'email'}\n");
	$self->wait_for($fh, "comment:");
	syswrite($fh, "$self->{'cmt'}\n");
	$self->wait_for($fh, "\\?");
	syswrite($fh, "o\n");
	$self->wait_for($fh, "command>");
	syswrite($fh, "quit\n");
	if ($self->wait_for($fh, "save changes") == 0) {
		syswrite($fh, "y\n");
		}
	sleep(1);
	close($fh);
	}
else {
	# Deleting details
	foreach $k (keys %{$self->{'in_hash'}}) {
		$self->{'delidx'} = $k if ($k =~ /^\d+$/);
		}
	$self->error_setup($self->{'text_hash'}->{'owner_err2'});
	if (@{$self->{'key'}->{'name'}} == 1) {
		$self->error($self->{'text_hash'}->{'owner_elast'});
		}
	$self->{'cmd'} = "$self->{'gpgpath'} --edit-key \"$self->{'key'}->{'name'}->[0]\"";
	($fh, $self->{'fpid'}) = $self->foreign_call("proc", "pty_process_exec", $self->{'cmd'});
	local %keymap;
	while(1) {
		local $rv = $self->wait_for($fh, "command>", '\\((\d+)\\)[\\. ]+(.*)\\n');
		last if ($rv == 0);
		$matches[2] =~ s/<.*$//;
		$matches[2] =~ s/\s+$//;
		$keymap{$matches[2]} = $matches[1];
		}
	local $idx = $keymap{$self->{'key'}->{'name'}->[$self->{'delidx'}]};
	syswrite($fh, "uid $idx\n");
	$self->wait_for($fh, "command>");
	syswrite($fh, "deluid\n");
	$self->wait_for($fh, "\\?");
	syswrite($fh, "y\n");
	$self->wait_for($fh, "command>");
	syswrite($fh, "quit\n");
	if ($self->wait_for($fh, "save changes") == 0) {
		syswrite($fh, "y\n");
		}
	sleep(1);
	close($fh);
	}

$self->redirect("edit_key.cgi?idx=$self->{'in_hash'}->{'idx'}");

1;
		
}


1;

