#!/usr/bin/perl
package htaccess::Mod_mime_magic;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_mime_magic');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_mime_magic.pl
# Defines MIME type guessing directives

1;

1;
		return $self;
}

sub mod_mime_magic_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'MimeMagicFile', 0, 6, 'virtual' ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_mime_magic");
}

sub edit_MimeMagicFile
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_mime_magic_file'}",
        $self->opt_input($_[0]->{'value'}, "MimeMagicFile", "$self->{'text_hash'}->{'mod_mime_magic_none'}", 20).
        $self->file_chooser_button("MimeMagicFile", 1));
}

sub save_MimeMagicFile
{
	my $self = shift;

return $self->parse_opt("MimeMagicFile", '^\S+$', "$self->{'text_hash'}->{'mod_mime_magic_efile'}");
}


1;

