#!/usr/bin/perl
package htaccess::Mod_speling;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'htaccess::Mod_speling');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_speling.pl
# Defines editors spelling correction directives

1;

1;
		return $self;
}

sub mod_speling_directives
{
	my $self = shift;

$self->{'rv'} = [ [ 'CheckSpelling', 0, 5, 'virtual', '1.3-1.302' ],
	[ 'CheckSpelling', 0, 5, 'virtual directory htaccess', 1.302 ] ];
return $self->make_directives($self->{'rv'}, $_[0], "mod_speling");
}

sub edit_CheckSpelling
{
	my $self = shift;

return (1, "$self->{'text_hash'}->{'mod_speling_autocorr'}",
        $self->choice_input($_[0]->{'value'}, "CheckSpelling",
        "", "$self->{'text_hash'}->{'no'},Off", "$self->{'text_hash'}->{'yes'},On", "$self->{'text_hash'}->{'mod_speling_default'},"));
}

sub save_CheckSpelling
{
	my $self = shift;

return $self->parse_choice("CheckSpelling", "");
}


1;

