#!/usr/bin/perl

&MAIN();

 sub MAIN {
# change_files.cgi
# Modify or delete a <Files> clause in a .htaccess file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'lref'} = $self->read_file_lines($self->{'d'}->{'file'});

if ($self->{'in_hash'}->{'delete'}) {
	# deleting a directive
	$self->{'gap'} = $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1;
	splice(@{$self->{'lref'}}, $self->{'d'}->{'line'}, $self->{'d'}->{'eline'} - $self->{'d'}->{'line'} + 1);
	splice(@{$self->{'hconf'}}, $self->{'in_hash'}->{'idx'}, 1);
	$self->renumber($self->{'hconf'}, $self->{'d'}->{'line'}, $self->{'d'}->{'file'}, -$self->{'gap'});
	}
else {
	# changing a directive
	if ($self->{'in_hash'}->{'regexp'}) {
		if ($self->{'httpd_modules_hash'}->{'core'} >= 1.3) {
			$self->{'newdir'} = "<FilesMatch \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</FilesMatch>";
			}
		else {
			$self->{'newdir'} = "<Files ~ \"$self->{'in_hash'}->{'path'}\">";
			$self->{'enddir'} = "</Files>";
			}
		}
	else {
		$self->{'newdir'} = "<Files \"$self->{'in_hash'}->{'path'}\">";
		$self->{'enddir'} = "</Files>";
		}
	$self->{'lref'}->[$self->{'d'}->{'line'}] = $self->{'newdir'};
	$self->{'lref'}->[$self->{'d'}->{'eline'}] = $self->{'enddir'};
	}
$self->flush_file_lines();
$self->redirect("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}));

1;
		
}


1;

