#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_htaccess.cgi
# Display a form for editing some kind of per-directory options file

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
@{$self->{'dirs_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'htaccess');
$self->{'desc'} = $self->text('htindex_header', "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}, "");

print "<form method=post action=save_htaccess.cgi>\n";
print "<input type=hidden name=type value=$self->{'in_hash'}->{'type'}>\n";
print "<input type=hidden name=file value=$self->{'in_hash'}->{'file'}>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('htindex_header2', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"},
			       "<tt>$self->{'in_hash'}->{'file'}</tt>"),"</td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
$self->generate_inputs(\@{$self->{'dirs_array'}}, $self->{'conf'});
print "</table></td> </tr></table><br>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("htaccess_index.cgi?file=$self->{'in_hash'}->{'file'}", "options file index");

1;
		
}


1;

