#!/usr/bin/perl

&MAIN();

 sub MAIN {
# files_index.cgi
# Display a menu of icons for per-files options

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
$self->{'d'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
$self->{'desc'} = $self->text('htfile_header', $self->dir_name($self->{'d'}), "<tt>$self->{'in_hash'}->{'file'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'htfile_title'}, "");

print $self->ui_subheading($self->{'text_hash'}->{'htfile_title'});
$self->{'sw_icon'} = { "icon" => "images/show.gif",
	     "name" => $self->{'text_hash'}->{'htfile_show'},
	     "link" => "show.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}" };
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'htfile_edit'},
	     "link" =>
		"manual_form.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}" };
$self->config_icons("directory", "edit_files.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'})."&idx=$self->{'in_hash'}->{'idx'}&",
	      $self->{'sw_icon'}, $self->{'ed_icon'} ? ( $self->{'ed_icon'} ) : ( ));

print "<hr>\n";
print "<form action=change_files.cgi>\n";
print "<input type=hidden name=file value=$self->{'in_hash'}->{'file'}>\n";
print "<input type=hidden name=idx value=$self->{'in_hash'}->{'idx'}>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'htfile_apply'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'htindex_regexp'}</b></td>\n";
$self->{'regex'} = $self->{'d'}->{'words'}->[0] eq "~" || $self->{'d'}->{'name'} =~ /Match/i;
printf "<td colspan=3><input type=radio name=regexp value=0 %s> %s\n",
	$self->{'regex'} ? "" : "checked", $self->{'text_hash'}->{'htindex_exact'};
printf "<input type=radio name=regexp value=1 %s> %s</td> </tr>\n",
	$self->{'regex'} ? "checked" : "", $self->{'text_hash'}->{'htindex_re'};
print "<tr> <td><b>$self->{'text_hash'}->{'htindex_path'}</b></td>\n";
printf "<td><input name=path size=40 value=\"%s\"></td>\n",
	$self->{'d'}->{'words'}->[0] eq "~" ? $self->{'d'}->{'words'}->[1] : $self->{'d'}->{'words'}->[0];
print "<td colspan=2 align=right>",
      "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">&nbsp;",
      "<input type=submit value=\"$self->{'text_hash'}->{'delete'}\" name=delete></td> </tr>\n";
print "</table></td></tr></table></form>\n";

$self->ui_print_footer("htaccess_index.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}), $self->{'text_hash'}->{'htindex_return'});

1;
		
}


1;

