#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of all .htaccess files

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

# Check if version info can be gotten from webmin
if (!$self->{'httpd_modules_hash'}->{'core'}) {
	print "<b>",$self->text('index_apache', "<tt>$self->{'config_hash'}->{'webmin_apache'}</tt>"),
	      "</b><p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

# Show known config files
print $self->text('index_desc', "<tt>$self->{'config_hash'}->{'htaccess'}</tt>"),"<p>\n";
@{$self->{'files_array'}} = $self->get_htaccess_files();
if (@{$self->{'files_array'}}) {
	print $self->ui_subheading($self->{'text_hash'}->{'index_header'});
	@{$self->{'icons_array'}} = map { "images/dir.gif" } @{$self->{'files_array'}};
	@{$self->{'links_array'}} = map { "htaccess_index.cgi?file=".$self->urlize($_) } @{$self->{'files_array'}};
	@{$self->{'titles_array'}} = map { /^(.*)\//; $1 } @{$self->{'files_array'}};
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
print "<form action=create.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'index_create'}'>\n";
print "<input name=dir size=50> ",$self->file_chooser_button("dir", 1),"<br>\n";
print "</form>\n";

print "<hr>\n";
print $self->text('index_finddesc', "<tt>$self->{'config_hash'}->{'htaccess'}</tt>"),"<br>\n";
print "<form action=find.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'index_find'}'>\n";
print "<input name=dir size=50 value='$self->{'www_root'}'> ",
	$self->file_chooser_button("dir", 1),"<br>\n";
print "</form>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

