#!/usr/bin/perl

&MAIN();

 sub MAIN {
# manual_save.cgi
# Save manually entered directives

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

$self->ReadParseMime();
if (defined($self->{'in_hash'}->{'idx'})) {
	# files within .htaccess file
	$self->{'hconf'} = $self->get_htaccess_config($self->{'in_hash'}->{'file'});
	$self->{'d'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->{'return'} = "files_index.cgi";
	$self->{'start'} = $self->{'d'}->{'line'}+1; $self->{'end'} = $self->{'d'}->{'eline'}-1;
	$self->{'logtype'} = 'files';
	$self->{'logname'} = "$self->{'in_hash'}->{'file'}:$self->{'d'}->{'words'}->[0]";
	}
else {
	# .htaccess file
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->{'return'} = "htaccess_index.cgi";
	$self->{'logtype'} = 'htaccess'; $self->{'logname'} = $self->{'in_hash'}->{'file'};
	}

$self->{'in_hash'}->{'directives'} =~ s/\r//g;
$self->{'in_hash'}->{'directives'} =~ s/\s+$//;
@{$self->{'dirs_array'}} = split(/\n/, $self->{'in_hash'}->{'directives'});
$self->{'lref'} = $self->read_file_lines($self->{'file'});
if (!defined($self->{'start'})) {
	$self->{'start'} = 0;
	$self->{'end'} = @{$self->{'lref'}} - 1;
	}
splice(@{$self->{'lref'}}, $self->{'start'}, $self->{'end'}-$self->{'start'}+1, @{$self->{'dirs_array'}});
$self->flush_file_lines();

foreach $h ('virt', 'idx', 'file') {
	push(@{$self->{'args_array'}}, "$h=$self->{'in_hash'}->{$h}") if (defined($self->{'in_hash'}->{$h}));
	}
$self->redirect("$self->{'return'}?".join("&", @{$self->{'args_array'}}));

1;
		
}


1;

