#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_authgroup.cgi
# Save, create or delete a group

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

&ModuleLoader::preload_module('htaccess_class', "htaccess::AuthLib");
$self = new htaccess::AuthLib:: 'htaccess_class',%$self;


$self->ReadParse();
if ($self->{'in_hash'}->{'delete'}) {
	# Deleting a group
	$self->delete_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'oldgroup'});
	}
else {
	# Creating or updating
	$self->error_setup($self->{'text_hash'}->{'authg_err'});
	$self->{'in_hash'}->{'group'} =~ /\S/ || $self->error($self->{'text_hash'}->{'authg_euser'});
	$self->{'in_hash'}->{'group'} !~ /:/ || $self->error($self->{'text_hash'}->{'authg_euser2'});

	$self->{'oldg'} = $self->get_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'oldgroup'});
	$self->{'ginfo_hash'}->{'group'} = $self->{'in_hash'}->{'group'};
	@{$self->{'mems_array'}} = split(/\s+/, $self->{'in_hash'}->{'members'});
	$self->{'ginfo_hash'}->{'members'} = \@{$self->{'mems_array'}};

	if (defined($self->{'in_hash'}->{'oldgroup'})) {
		# updating an old group
		if ($self->{'in_hash'}->{'oldgroup'} ne $self->{'in_hash'}->{'group'} &&
		    $self->get_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'group'})) {
			$self->error($self->text('authg_edup', $self->{'in_hash'}->{'group'}));
			}
		$self->save_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'oldgroup'}, \%{$self->{'ginfo_hash'}});
		}
	else {
		# creating a new one
		if ($self->get_authgroup($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'group'})) {
			$self->error($self->text('authg_edup', $self->{'in_hash'}->{'group'}));
			}
		$self->create_authgroup($self->{'in_hash'}->{'file'}, \%{$self->{'ginfo_hash'}});
		}
	}
$self->redirect($self->{'in_hash'}->{'url'});

1;
		
}


1;

