#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_authuser.cgi
# Save, create or delete a user

&ModuleLoader::preload_module('htaccess_class', "htaccess::HtaccessLib");
$self = new htaccess::HtaccessLib:: 'htaccess_class',%$self;

&ModuleLoader::preload_module('htaccess_class', "htaccess::AuthLib");
$self = new htaccess::AuthLib:: 'htaccess_class',%$self;


$self->ReadParse();
if ($self->{'in_hash'}->{'delete'}) {
	# Deleting a user
	$self->delete_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'olduser'});
	}
else {
	# Creating or updating
	$self->error_setup($self->{'text_hash'}->{'authu_err'});
	$self->{'in_hash'}->{'user'} =~ /\S/ || $self->error($self->{'text_hash'}->{'authu_euser'});
	$self->{'in_hash'}->{'user'} !~ /:/ || $self->error($self->{'text_hash'}->{'authu_euser2'});

	$self->{'oldu'} = $self->get_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'olduser'});
	$self->{'uinfo_hash'}->{'user'} = $self->{'in_hash'}->{'user'};
	if ($self->{'in_hash'}->{'mode'}) {
		$self->{'uinfo_hash'}->{'pass'} = $self->{'in_hash'}->{'enc'};
		}
	else {
		$self->{'salt'} = chr(int(rand(26))+65).chr(int(rand(26))+65);
		$self->{'uinfo_hash'}->{'pass'} = $self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'});
		}

	if (defined($self->{'in_hash'}->{'olduser'})) {
		# updating an old user
		if ($self->{'in_hash'}->{'olduser'} ne $self->{'in_hash'}->{'user'} &&
		    $self->get_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'user'})) {
			$self->error($self->text('authu_edup', $self->{'in_hash'}->{'user'}));
			}
		$self->save_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'olduser'}, \%{$self->{'uinfo_hash'}});
		}
	else {
		# creating a new one
		if ($self->get_authuser($self->{'in_hash'}->{'file'}, $self->{'in_hash'}->{'user'})) {
			$self->error($self->text('authu_edup', $self->{'in_hash'}->{'user'}));
			}
		$self->create_authuser($self->{'in_hash'}->{'file'}, \%{$self->{'uinfo_hash'}});
		}
	}
$self->redirect($self->{'in_hash'}->{'url'});

1;
		
}


1;

