#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing or creating a htgroup entry

&ModuleLoader::preload_module('htaccess_htpasswd_class', "htaccess_htpasswd::HtaccessLib");
$self = new htaccess_htpasswd::HtaccessLib:: 'htaccess_htpasswd_class',%$self;

$self->ReadParse();
@{$self->{'dirs_array'}} = $self->list_directories();
($self->{'dir'}) = grep { $_->[0] eq $self->{'in_hash'}->{'dir'} } @{$self->{'dirs_array'}};
$self->can_access_dir($self->{'dir'}->[0]) || $self->error($self->{'text_hash'}->{'dir_ecannot'});
$self->switch_user();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title1'}, "");
	$self->{'group'} = { 'enabled' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title2'}, "");
	$self->{'groups'} = $self->list_groups($self->{'dir'}->[4]);
	$self->{'group'} = $self->{'groups'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save_group.cgi method=post>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=dir value='$self->{'in_hash'}->{'dir'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'gedit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table cellpadding=3>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'gedit_group'}</b></td>\n";
printf "<td><input name=group size=20 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'group'}->{'group'});

print "<tr> <td><b>$self->{'text_hash'}->{'edit_enabled'}</b></td>\n";
printf "<td><input type=radio name=enabled value=1 %s> %s\n",
	$self->{'group'}->{'enabled'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=enabled value=0 %s> %s</td> </tr>\n",
	$self->{'group'}->{'enabled'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'gedit_members'}</b></td>\n";
print "<td><textarea name=members rows=5 cols=40 wrap=on>",
	join("\n", @{$self->{'group'}->{'members'}}),"</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

