#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_folder.cgi
# Display a form for creating or editing a folder of some kind

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'mode'} = $self->{'in_hash'}->{'mode'};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'folders_array'}} = $self->list_folders();
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'mode'} = $self->{'folder'}->{'mode'};
	}

print "<form action=save_folder.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=mode value='$self->{'mode'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_mode'}</b></td>\n";
print "<td>",$self->text("edit_mode$self->{'mode'}", "<tt>$self->{'folders_dir'}</tt>"),"</td> </tr>\n";

if ($self->{'mode'} == 0) {
	# Adding/editing a new file or directory to ~/mail
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
	printf "<td><input name=name size=40 value='%s'></td> </tr>\n",
		$self->{'folder'}->{'name'};

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td>\n";
	if ($self->{'in_hash'}->{'new'} && $self->{'folders_dir'} eq "$self->{'remote_user_info_array'}->[7]/Maildir") {
		# A new folder, but under a Maildir .. so it must be maildir too
		print "<td>",$self->{'text_hash'}->{'edit_type1'},"</td> </tr>\n";
		print $self->ui_hidden("type", 1),"\n";
		}
	elsif ($self->{'in_hash'}->{'new'}) {
		# Can choose the type of a new folder
		print "<td><input type=radio name=type value=0 checked> ",
		      "$self->{'text_hash'}->{'edit_type0'}\n"; 
		print "<input type=radio name=type value=1> ",
		      "$self->{'text_hash'}->{'edit_type1'}\n";
		print "<input type=radio name=type value=3> ",
		      "$self->{'text_hash'}->{'edit_type3'}\n" if ($self->{'userconfig_hash'}->{'mailbox_recur'});
		print "</td> </tr>\n";
		}
	else {
		# Show type of existing folder
		print "<td>",$self->{'text_hash'}->{'edit_type'.$self->{'folder'}->{'type'}},
		      "</td> </tr>\n";
		}
	}
elsif ($self->{'mode'} == 1) {
	# Adding/editing an external file or directory
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
	printf "<td><input name=name size=40 value='%s'></td> </tr>\n",
		$self->{'folder'}->{'name'};

	print "<tr> <td><b>$self->{'text_hash'}->{'edit_file'}</b></td>\n";
	printf "<td><input name=file size=40 value='%s'> %s</td> </tr>\n",
		$self->{'folder'}->{'file'}, $self->file_chooser_button("file");
	}
elsif ($self->{'mode'} == 2) {
	# Selecting the sent mail folder
	local $sf = "$self->{'folders_dir'}/sentmail";
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_sent'}</b></td> <td>\n";
	printf "<input type=radio name=sent_def value=1 %s> %s<br>\n",
		$self->{'folder'}->{'file'} eq $sf ? "checked" : "", $self->{'text_hash'}->{'edit_sent1'};
	printf "<input type=radio name=sent_def value=0 %s> %s\n",
		$self->{'folder'}->{'file'} eq $sf ? "" : "checked", $self->{'text_hash'}->{'edit_sent0'};
	printf "<input name=sent size=40 value='%s'> %s</td> </tr>\n",
		$self->{'folder'}->{'file'} eq $sf ? "" : $self->{'folder'}->{'file'},
		$self->file_chooser_button("sent");
	}

$self->show_folder_options($self->{'folder'}, $self->{'mode'});

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n"
		if ($self->{'mode'} != 2);
	}
print "</form>\n";

$self->ui_print_footer("list_folders.cgi", $self->{'text_hash'}->{'folders_return'});

1;
		
}


1;

