#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for creating or editing an IMAP folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'mode'} = $self->{'in_hash'}->{'mode'};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'folders_array'}} = $self->list_folders();
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("save_ifolder.cgi");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'edit_header'});

# IMAP folder name
print $self->ui_table_row($self->{'text_hash'}->{'edit_name'},
		    $self->ui_textbox("name", $self->{'folder'}->{'name'}, 40));

$self->show_folder_options($self->{'folder'}, $self->{'folder'}->{'mode'});

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list_ifolders.cgi", $self->{'text_hash'}->{'folders_return'});
1;
		
}


1;

