#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pop3.cgi
# Display a form for creating or editing a POP3 folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	$self->{'mode'} = $self->{'in_hash'}->{'mode'};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'folders_array'}} = $self->list_folders();
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'mode'} = $self->{'folder'}->{'mode'};
	}

print "<form action=save_pop3.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=mode value='$self->{'mode'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_mode'}</b></td>\n";
print "<td>$self->{'text_hash'}->{'edit_pop3'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
printf "<td><input name=name size=40 value='%s'></td> </tr>\n",
	$self->{'folder'}->{'name'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_server'}</b></td>\n";
printf "<td><input name=server size=30 value='%s'></td> </tr>\n",
	$self->{'folder'}->{'server'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_port'}</b></td> <td>\n";
printf "<input type=radio name=port_def value=1 %s> %s (%d)\n",
	$self->{'folder'}->{'port'} ? "" : "checked", $self->{'text_hash'}->{'default'}, $self->{'pop3_port'};
printf "<input type=radio name=port_def value=0 %s>\n",
	$self->{'folder'}->{'port'} ? "checked" : "";
printf "<input name=port size=6 value='%s'></td> </tr>\n",
	$self->{'folder'}->{'port'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
printf "<td><input name=user size=20 value='%s'></td> </tr>\n",
	$self->{'folder'}->{'user'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_pass'}</b></td>\n";
printf "<td><input type=password name=pass size=20 value='%s'></td> </tr>\n",
	$self->{'folder'}->{'pass'};

$self->show_folder_options($self->{'folder'});

print "</table></td></tr></table>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value='$self->{'text_hash'}->{'create'}'>\n";
	}
else {
	print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer("list_folders.cgi", $self->{'text_hash'}->{'folders_return'});

1;
		
}


1;

