#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_address.cgi
# Save, add or delete an address book entry

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'delete'} ne '') {
	$self->delete_address($self->{'in_hash'}->{'delete'});
	}
else {
	$self->error_setup($self->{'text_hash'}->{'address_err'});
	$self->{'in_hash'}->{'addr'} =~ /^\S+\@\S+$/ || $self->error($self->{'text_hash'}->{'address_eaddr'});
	$self->{'in_hash'}->{'addr'} =~ /[,<>"'\(\)]/ && $self->error($self->{'text_hash'}->{'address_eaddr'});
	if ($self->{'in_hash'}->{'from'} == 2) {
		# Turn off default for all others
		foreach $a ($self->list_addresses()) {
			if ($a->[3] == 2 && $a->[2] != $self->{'in_hash'}->{'edit'}) {
				$self->modify_address($a->[2], $a->[0],
						$a->[1], 1);
				}
			}
		}
	if ($self->{'in_hash'}->{'add'}) {
		$self->create_address($self->{'in_hash'}->{'addr'}, $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'from'});
		}
	else {
		$self->modify_address($self->{'in_hash'}->{'edit'}, $self->{'in_hash'}->{'addr'}, $self->{'in_hash'}->{'name'}, $self->{'in_hash'}->{'from'});
		}
	}
$self->redirect("list_addresses.cgi");

1;
		
}


1;

