#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_comp.cgi
# Create, modify or delete a composite folder

&ModuleLoader::preload_module('mailbox_class', "mailbox::MailboxLib");
$self = new mailbox::MailboxLib:: 'mailbox_class',%$self;

$self->ReadParse();
@{$self->{'folders_array'}} = $self->list_folders();
if (!$self->{'in_hash'}->{'new'}) {
	$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'old'} = { %{$self->{'folder'}} };
	}
$self->error_setup($self->{'text_hash'}->{'save_err'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this folder file
	$self->delete_folder($self->{'old'});
	}
else {
	# Validate inputs
	$self->{'in_hash'}->{'name'} =~ /\S/ || $self->error($self->{'text_hash'}->{'save_ename'});
	for($i=0; defined($self->{'n'} = $self->{'in_hash'}->{"comp_$i"}); $i++) {
		push(@{$self->{'subfolders_array'}}, $self->find_named_folder($self->{'n'}, \@{$self->{'folders_array'}})) if ($self->{'n'});
		}
	$self->parse_folder_options($self->{'folder'}, 0, \%{$self->{'in_hash'}});

	# Save the folder
	$self->{'folder'}->{'type'} = 5;
	$self->{'folder'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'folder'}->{'subfolders'} = \@{$self->{'subfolders_array'}};
	$self->{'folder'}->{'perpage'} = $self->{'in_hash'}->{'perpage_def'} ? undef : $self->{'in_hash'}->{'perpage'};
	$self->{'folder'}->{'fromaddr'} = $self->{'in_hash'}->{'fromaddr_def'} ? undef : $self->{'in_hash'}->{'fromaddr'};
	$self->{'folder'}->{'sent'} = $self->{'in_hash'}->{'sent'};
	$self->save_folder($self->{'folder'}, $self->{'old'});
	}
$self->redirect($self->{'config_hash'}->{'mail_system'} == 4 ? "list_ifolders.cgi"
				      : "list_folders.cgi");

1;
		
}


1;

