#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show current mailcap entries

&ModuleLoader::preload_module('mailcap_class', "mailcap::MailcapLib");
$self = new mailcap::MailcapLib:: 'mailcap_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1);

@{$self->{'mailcap_array'}} = $self->list_mailcap();
if (@{$self->{'mailcap_array'}}) {
	print $self->ui_form_start("delete.cgi", "post");
	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"\n";
	print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><br>\n";

	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'index_type'},
		$self->{'text_hash'}->{'index_program'},
		$self->{'text_hash'}->{'index_cmt'},
		$self->{'text_hash'}->{'index_enabled'},
		], "width=100%", 0, \@{$self->{'tds_array'}});
	foreach $m (@{$self->{'mailcap_array'}}) {
		print $self->ui_checked_columns_row([
			"<a href='edit.cgi?index=$m->{'index'}'>$m->{'type'}</a>",
			$m->{'program'},
			$m->{'cmt'} || $m->{'args'}->{'description'},
			$m->{'enabled'} ? $self->{'text_hash'}->{'yes'} :
			    "<font color=#ff0000>$self->{'text_hash'}->{'no'}</font>",
			], \@{$self->{'tds_array'}}, "d", $m->{'index'});
		}
	print $self->ui_columns_end();

	print $self->select_all_link("d"),"\n";
	print $self->select_invert_link("d"),"\n";
	print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><br>\n";
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'index_delete'} ],
			     undef,
			     [ "disable", $self->{'text_hash'}->{'index_disable'} ],
			     [ "enable", $self->{'text_hash'}->{'index_enable'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	print "<a href='edit.cgi?new=1'>$self->{'text_hash'}->{'index_add'}</a><p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

