#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_kernel.cgi
# View some kernel doc file

&ModuleLoader::preload_module('man_class', "man::ManLib");
$self = new man::ManLib:: 'man_class',%$self;

$self->ReadParse();

$self->{'in_hash'}->{'file'} !~ /\.\./ ||
	$self->error($self->{'text_hash'}->{'kernel_epath'});
$self->{'in_hash'}->{'file'} !~ /[\\\&\;\`\'\"\|\*\?\<\>\^\(\)\[\]\{\}\$\n\r]/ ||
	$self->error($self->{'text_hash'}->{'kernel_epath'});
foreach $h (split(/\s+/, $self->{'config_hash'}->{'kernel_dir'})) {
	$self->{'ok'}++ if (substr($self->{'in_hash'}->{'file'}, 0, length($h)) eq $h);
	}
$self->{'ok'} || $self->error($self->{'text_hash'}->{'kernel_epath'});
-r $self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'kernel_epath'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'kernel_title'}, "");

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('kernel_header', $self->{'in_hash'}->{'file'}),
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td>";
open(FILE, $self->{'in_hash'}->{'file'});
read(FILE, $self->{'two'}, 2);
$self->{'qm'} = quotemeta($self->{'in_hash'}->{'file'});
if ($self->{'two'} eq "\037\213") {
	close(FILE);
	$self->open_execute_command(*FILE, "gunzip -c $self->{'qm'}", 1, 1);
	}
elsif ($self->{'two'} eq "BZ") {
	close(FILE);
	$self->open_execute_command(*FILE, "bunzip2 -c $self->{'qm'}", 1, 1);
	}
seek(FILE, 0, 0);
if ($self->{'in_hash'}->{'file'} =~ /\.htm/i) {
	# Display HTML documentation
	($self->{'dir'} = $self->{'in_hash'}->{'file'}) =~ s/\/[^\/]+$//;
	while($self->{'line'} = <FILE>) {
		$self->{'line'} =~ s/href="([^"]+)"/href="view_doc.cgi?file=$self->{'dir'}\/$1"/ig;
		$self->{'line'} =~ s/href='([^']+)'/href='view_doc.cgi?file=$self->{'dir'}\/$1'/ig;
		$self->{'line'} =~ s/href=([^'"\s>]+)/href='view_doc.cgi?file=$self->{'dir'}\/$1'/ig;
		print $self->{'line'};
		}
	}
else {
	# Display text file
	print "<pre>";
	@{$self->{'for_array'}} = split(/\s+/, $self->{'in_hash'}->{'for'});
	while($self->{'line'} = <FILE>) {
		$self->{'line'} = $self->html_escape($self->{'line'});
		foreach $f (@{$self->{'for_array'}}) {
			$self->{'line'} =~ s/($f)/<b>$1<\/b>/ig;
			}
		print $self->{'line'};
		}
	print "</pre>";
	}
close(FILE);
print "</td></tr></table><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

