#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_table.cgi
# Display the structure of some table

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
if ($self->{'access_hash'}->{'edonly'}) {
	$self->redirect("view_table.cgi?db=$self->{'in_hash'}->{'db'}&table=".$self->urlize($self->{'in_hash'}->{'table'}));
	exit;
	}
$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'table_title'}, "", "edit_table");

print $self->ui_form_start("delete_fields.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'}),"\n";
@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
@{$self->{'tds_array'}} = ( "width=5" );
@{$self->{'rowlinks_array'}} = ( $self->select_all_link("d"),
	      $self->select_invert_link("d") );
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_columns_start([ "",
			  $self->{'text_hash'}->{'table_field'},
			  $self->{'text_hash'}->{'table_type'},
			  $self->{'text_hash'}->{'table_null'},
			  $self->{'text_hash'}->{'table_key'},
		 	  $self->{'text_hash'}->{'table_default'},
			  $self->{'text_hash'}->{'table_extra'} ], 100, 0, \@{$self->{'tds_array'}});
$self->{'i'} = 0;
foreach $r (@{$self->{'desc_array'}}) {
	local @cols;
	push(@cols, "<a href='edit_field.cgi?db=$self->{'in_hash'}->{'db'}&table=".
		    $self->urlize($self->{'in_hash'}->{'table'})."&".
		    "idx=$self->{'i'}'>".$self->html_escape($r->{'field'})."</a>");
	push(@cols, $self->html_escape($r->{'type'}));
	push(@cols, $r->{'null'} eq 'YES' ? $self->{'text_hash'}->{'yes'} : $self->{'text_hash'}->{'no'});
	push(@cols,
		$r->{'key'} eq 'PRI' ? $self->{'text_hash'}->{'table_pri'} :
		$r->{'key'} eq 'MUL' ? $self->{'text_hash'}->{'table_mul'} :
				       $self->{'text_hash'}->{'table_none'});
	push(@cols, $self->html_escape($r->{'default'}));
	push(@cols, $self->html_escape($r->{'extra'}));
	print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $r->{'field'});
	$self->{'i'}++;
	}
print $self->ui_columns_end();
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'table_delete'} ] ]);

print "<form action=edit_field.cgi>\n";
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'}),"\n";
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'}),"\n";
print "<table width=100%><tr>\n";

# Add field button
print "<td width=25% nowrap><input type=submit value='$self->{'text_hash'}->{'table_add'}'>\n";
print "<select name=type>\n";
foreach $t (@{$self->{'type_list_array'}}) {
	print "<option>$t\n";
	}
print "</select></td></form>\n";

# View and edit data button
print "<form action=view_table.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=center width=25%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_data'}'></td>\n";
print "</form>\n";

# CSV export button
print "<form action=csv_form.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=center width=25%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_csv'}'></td>\n";
print "</form>\n";

if ($self->{'access_hash'}->{'indexes'}) {
	# Create index button
	print "<form action=edit_index.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<td align=center width=25%>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'table_index'}'></td>\n";
	print "</form>\n";
	}

# Drop table button
print "<form action=drop_table.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=right width=25%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_drop'}'></td>\n";
print "</form>\n";

print "</tr></table>\n";

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

