#!/usr/bin/perl

&MAIN();

 sub MAIN {
# backup_form.cgi
# Display a form for backup the database

require './postgresql-lib.pl' ;
$self->ReadParse();
$self->error_setup( $self->{'text_hash'}->{'backup_err'} ) ;
if ($self->{'in_hash'}->{'all'}) {
	@{$self->{'alldbs_array'}} = $self->list_databases();
	@{$self->{'dbs_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
	@{$self->{'alldbs_array'}} == @{$self->{'dbs_array'}} || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
else {
	$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
	}
$self->{'access_hash'}->{'backup'} || $self->error($self->{'text_hash'}->{'backup_ecannot'});

$self->has_command($self->{'config_hash'}->{'dump_cmd'}) ||
	$self->error($self->text('backup_ecmd', "<tt>$self->{'config_hash'}->{'dump_cmd'}</tt>"));

$self->{'desc'} = "<tt>$self->{'in_hash'}->{'db'}</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'in_hash'}->{'all'} ? $self->{'text_hash'}->{'backup_title2'}
		   : $self->{'text_hash'}->{'backup_title'}, "", "backup_form" ) ;

$self->{'cron'} = !$self->{'module_info_hash'}->{'usermin'} &&
        !$self->{'access_hash'}->{'user'} && $self->foreign_installed("cron");
if ($self->{'in_hash'}->{'all'}) {
	print "$self->{'text_hash'}->{'backup_desc3'}\n";
	}
else {
	print $self->text('backup_desc', "<tt>$self->{'in_hash'}->{'db'}</tt>"),"\n";
	}
if ($self->{'cron'}) {
        print "$self->{'text_hash'}->{'backup_desc2'}\n";
        }
print "<p>\n";
%{$self->{'c_hash'}} = $self->{'module_info_hash'}->{'usermin'} ? %{$self->{'userconfig_hash'}} : %{$self->{'config_hash'}};

print "<form action=backup.cgi method=post>\n" ;
print "<input type=hidden name=db value=\"$self->{'in_hash'}->{'db'}\">\n" ;
print "<input type=hidden name=all value=\"$self->{'in_hash'}->{'all'}\">\n" ;
print "<table border>\n" ;
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'backup_header'}</b></td> </tr>\n" ;
print "<tr $self->{'cb'}> <td><table>\n" ;

$self->{'p'} = $self->{'c_hash'}->{'backup_'.$self->{'in_hash'}->{'db'}} || "$self->{'config_hash'}->{'repository'}/";
if ($self->{'in_hash'}->{'all'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_path2'}</b></td>\n" ;
	}
else {
	print "<tr> <td><b>$self->{'text_hash'}->{'backup_path'}</b></td>\n" ;
	}
print "<td><input type=text name=path value='$self->{'p'}' size=64></td></tr>\n" ;

# Show backup format input
$self->{'f'} = $self->{'c_hash'}->{'backup_format_'.$self->{'in_hash'}->{'db'}};
print "<tr> <td><b>$self->{'text_hash'}->{'backup_format'}</b></td>\n";
print "<td><select name=format>\n";
foreach $t ('p', 't', 'c') {
	printf "<option value=%s %s>%s\n",
		$t, $self->{'f'} eq $t ? "selected" : "", $self->{'text_hash'}->{'backup_format_'.$t};
	}
print "</select></td> </tr>\n";

if (!$self->{'in_hash'}->{'all'}) {
	# Show input to select tables
	$t = $self->{'c_hash'}->{'backup_tables_'.$self->{'in_hash'}->{'db'}};
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'backup_tables'}</b></td> <td>\n";
	printf "<input type=radio name=tables_def value=1 %s> %s\n",
		$t ? "" : "checked", $self->{'text_hash'}->{'backup_alltables'};
	printf "<input type=radio name=tables_def value=0 %s> %s\n",
		$t ? "checked" : "", $self->{'text_hash'}->{'backup_seltables'};
	@{$self->{'tables_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
	%{$self->{'got_hash'}} = map { $_, 1 } split(/\s+/, $t);
	print "<select name=tables>\n";
	foreach $t (sort @{$self->{'tables_array'}}) {
		printf "<option %s>%s\n",
			$self->{'got_hash'}->{$t} ? "selected" : "", $t;
		}
	print "</select></td> </tr>\n";
	}

if ($self->{'cron'}) {
	if ($self->{'access_hash'}->{'cmds'}) {
		$self->{'b'} = $self->{'c_hash'}->{'backup_before_'.$self->{'in_hash'}->{'db'}};
		print "<tr> <td><b>$self->{'text_hash'}->{'backup_before'}</b></td>\n";
		print "<td>",$self->ui_textbox("before", $self->{'b'}, 50),"</td> </tr>\n";

		$self->{'a'} = $self->{'c_hash'}->{'backup_after_'.$self->{'in_hash'}->{'db'}};
		print "<tr> <td><b>$self->{'text_hash'}->{'backup_after'}</b></td>\n";
		print "<td>",$self->ui_textbox("after", $self->{'a'}, 50),"</td> </tr>\n";

		if ($self->{'in_hash'}->{'all'}) {
			# Command mode option
			$self->{'a'} = $self->{'c_hash'}->{'backup_cmode_'.$self->{'in_hash'}->{'db'}};
			print "<tr> <td><b>$self->{'text_hash'}->{'backup_cmode'}</b></td>\n";
			print "<td>",$self->ui_radio("cmode", int($self->{'cmode'}),
				[ [ 0, $self->{'text_hash'}->{'backup_cmode0'} ],
				  [ 1, $self->{'text_hash'}->{'backup_cmode1'} ] ]),
			      "</td> </tr>\n";
			}
                }

	$self->foreign_require("cron", "cron-lib.pl");
	@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
	$self->{'cmd'} = $self->{'in_hash'}->{'all'} ? "$self->{'cron_cmd'} --all" : "$self->{'cron_cmd'} $self->{'in_hash'}->{'db'}";
	($self->{'job'}) = grep { $_->{'command'} eq $self->{'cmd'} } @{$self->{'jobs_array'}};

	print "<tr> <td><b>$self->{'text_hash'}->{'backup_sched'}</b></td>\n";
	printf "<td><input type=radio name=sched value=0 %s> %s\n",
		$self->{'job'} ? "" : "checked", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=sched value=1 %s> %s</td> </tr>\n",
		$self->{'job'} ? "checked" : "", $self->{'text_hash'}->{'backup_sched1'};

	if (!$self->{'config_hash'}->{'simple_sched'} || ($self->{'dump'} && !$self->{'dump'}->{'special'})) {
		# Complex Cron time input
		print "<tr> <td colspan=2><table border width=100%>\n";
		$self->{'job'} ||= { 'mins' => 0,
			   'hours' => 0,
			   'days' => '*',
			   'months' => '*',
			   'weekdays' => '*' };
		$main::cron_object->show_times_input($self->{'job'});
		print "</table></td> </tr>\n";
		}
	else {
		# Simple Cron time input
		$self->{'job'} ||= { 'special' => 'daily' };
		print $self->ui_hidden("special_def", 1),"\n";
		print "<tr> <td><b>$self->{'text_hash'}->{'backup_special'}</b></td>\n";
		print "<td>",$self->ui_select("special", $self->{'job'}->{'special'},
			[ map { [ $_, $main::cron_object->{'text_hash'}->{'edit_special_'.$_} ] }
		          ('hourly', 'daily', 'weekly', 'monthly', 'yearly') ]),
		      "</td> </tr>\n";
		}
	}
print "</table></td></tr></table>\n" ;

if ($self->{'cron'}) {
	print "<input type=submit name=backup value='$self->{'text_hash'}->{'backup_ok1'}'>\n";
	print "<input type=submit name=save value='$self->{'text_hash'}->{'backup_ok2'}'>\n";
	}
else {
	print "<input type=submit name=backup value='$self->{'text_hash'}->{'backup_ok'}'>\n";
	}
print "<br>\n";
print "</form>\n";

if ($self->{'in_hash'}->{'all'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

