#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_table.cgi
# Display the structure of some table

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'table_title'}, "", "edit_table");

@{$self->{'desc_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});
print "<form action=edit_field.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";

$self->{'mid'} = int((@{$self->{'desc_array'}} / 2)+0.5);
print "<table border=0 width=100%> <tr><td valign=top width=50%>\n";
&type_table(0, $self->{'mid'});
print "</td><td valign=top width=50%>\n";
&type_table($self->{'mid'}, scalar(@{$self->{'desc_array'}})) if (@{$self->{'desc_array'}} > 1);
print "</td></tr> </table>\n";

print "<table width=100%><tr>\n";
print "<td width=33% nowrap><input type=submit value='$self->{'text_hash'}->{'table_add'}'>\n";
print "<select name=type>\n";
foreach $t ($self->list_types()) {
	print "<option>$t\n";
	}
print "</select></td></form>\n";

print "<form action=view_table.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=middle width=22%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_data'}'></td>\n";
print "</form>\n";

print "<form action=csv_form.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=middle width=22%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_csv'}'></td>\n";
print "</form>\n";

if (!$self->can_drop_fields()) {
	print "<form action=drop_field.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<td align=right width=22%>\n";
	print "<input type=submit name=drop_a_fld value='$self->{'text_hash'}->{'table_fielddrop'}'></td>\n";
	print "</form>\n";
	}

# Create index button
if ($self->supports_indexes() && $self->{'access_hash'}->{'indexes'}) {
	print "<form action=edit_index.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<td align=center width=25%>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'table_index'}'></td>\n";
	print "</form>\n";
	}

print "<form action=drop_table.cgi>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<td align=right width=22%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'table_drop'}'></td>\n";
print "</form>\n";

print "</tr></table>\n";

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub type_table
{
	shift if ($self == $_[0]);

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'table_field'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'table_type'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'table_arr'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'table_null'}</b></td> </tr>\n";
local $i;
for($i=$_[0]; $i<$_[1]; $i++) {
	local $r = $self->{'desc_array'}->[$i];
	print "<tr $self->{'cb'}>\n";
	print "<td><a href='edit_field.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}&",
	      "idx=$i'>",$self->html_escape($r->{'field'}),"</a></td>\n";
	print "<td>",$self->html_escape($r->{'type'}),"</td>\n";
	print "<td>",$r->{'arr'} eq 'YES' ? $self->{'text_hash'}->{'yes'}
					  : $self->{'text_hash'}->{'no'},"</td>\n";
	print "<td>",$r->{'null'} eq 'YES' ? $self->{'text_hash'}->{'yes'}
					   : $self->{'text_hash'}->{'no'},"</td>\n";
	print "</tr>\n";
	}
print "</table>\n";
}


1;

