#!/usr/bin/perl

&MAIN();

 sub MAIN {
# kill_proc_list.cgi
# Send a signal to a list of process

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
$self->switch_acl_uid();
foreach $s ('KILL', 'TERM', 'HUP', 'STOP', 'CONT') {
	$self->{'in_hash'}->{'signal'} = $s if ($self->{'in_hash'}->{$s});
	}

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'kill_title'}, "");
@{$self->{'pidlist_array'}} = split(/\s+/, $self->{'in_hash'}->{pidlist});
@{$self->{'pinfo_array'}} = $self->list_processes(@{$self->{'pidlist_array'}});
for($i=0; $i<@{$self->{'pidlist_array'}}; $i++) {
	$self->{'in_hash'}->{"args$i"} = $self->{'pinfo_array'}->[$i]->{'args'};
	print "$self->{'text_hash'}->{'pid'} <tt>$self->{'pidlist_array'}->[$i]</tt> ... \n";
	if ($self->can_edit_process($self->{'pinfo_array'}->[$i]->{'user'})) {
		if ($self->kill_logged($self->{'in_hash'}->{signal}, $self->{'pidlist_array'}->[$i])) {
			print "SIG$self->{'in_hash'}->{signal} $self->{'text_hash'}->{'kill_sent'}<br>\n";
			}
		else {
			print "$!<br>\n";
			}
		}
	else {
		print "$self->{'text_hash'}->{'kill_ecannot'}<br>\n";
		}
	}
$self->webmin_log("kill", undef, undef, \%{$self->{'in_hash'}});
print "<p>\n";
$self->ui_print_footer("index_search.cgi?$self->{'in_hash'}->{'args'}", $self->{'text_hash'}->{'search_return'});

1;
		
}


1;

