#!/usr/bin/perl

&MAIN();

 sub MAIN {
# open_files.cgi
# Display files and network connections that a process has open

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'open_title'}, "", "open_proc");
%{$self->{'pinfo_hash'}} = $self->process_info($self->{'in_hash'}->{'pid'});
$self->can_edit_process($self->{'pinfo_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
if (!%{$self->{'pinfo_hash'}}) {
	print "<b>$self->{'text_hash'}->{'edit_gone'}</b> <p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<b>",$self->text('open_proc', "<tt>$self->{'pinfo_hash'}->{'args'}</tt>", $self->{'in_hash'}->{'pid'}),
      "</b><p>\n";

# Show open files
@{$self->{'files_array'}} = $self->find_process_files($self->{'in_hash'}->{'pid'});
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'open_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'open_fd'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'open_type'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'open_size'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'open_inode'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'open_file'}</b></td> </tr>\n";
foreach $f (@{$self->{'files_array'}}) {
	print "<tr>\n";
	print "<td>",$f->{'fd'} eq 'cwd' ? $self->{'text_hash'}->{'open_cwd'} :
		     $f->{'fd'} eq 'rtd' ? $self->{'text_hash'}->{'open_rtd'} :
		     $f->{'fd'} eq 'txt' ? $self->{'text_hash'}->{'open_txt'} :
		     $f->{'fd'} eq 'mem' ? $self->{'text_hash'}->{'open_mem'} :
					   $f->{'fd'},"</td>\n";
	print "<td>",$f->{'type'} =~ /^v?dir$/ ? $self->{'text_hash'}->{'open_dir'} :
		     $f->{'type'} =~ /^v?reg$/ ? $self->{'text_hash'}->{'open_reg'} :
		     $f->{'type'} =~ /^v?chr$/ ? $self->{'text_hash'}->{'open_chr'} :
		     $f->{'type'} =~ /^v?blk$/ ? $self->{'text_hash'}->{'open_blk'} :
					     $f->{'type'},"</td>\n";
	print "<td>",$f->{'size'} || "<br>","</td>\n";
	print "<td>$f->{'inode'}</td>\n";
	print "<td>$f->{'file'}</td>\n";
	print "</tr>\n";
	}
print "</table></td></tr></table><p>\n";

# Show network connections
@{$self->{'nets_array'}} = $self->find_process_sockets($self->{'in_hash'}->{'pid'});
if (@{$self->{'nets_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'open_header2'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'open_type'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'open_proto'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'open_fd'}</b></td> ",
	      "<td colspan=4><b>$self->{'text_hash'}->{'open_desc'}</b></td> </tr>\n";
	foreach $n (@{$self->{'nets_array'}}) {
		print "<tr>\n";
		print "<td>",uc($n->{'type'}),"</td>\n";
		print "<td>",uc($n->{'proto'}),"</td>\n";
		print "<td>",$n->{'fd'},"</td>\n";
		if ($n->{'listen'} && $n->{'lhost'} eq '*') {
			print "<td colspan=4>",
				$self->text('open_listen1', "<tt>$n->{'lport'}</tt>"),
				"</td>\n";
			}
		elsif ($n->{'listen'}) {
			print "<td colspan=4>",
				$self->text('open_listen2', "<tt>$n->{'lhost'}</tt>",
				      "<tt>$n->{'lport'}</tt>"),"</td>\n";
			}
		elsif ($n->{'rhost'}) {
			print "<td><tt>$n->{'lhost'}:$n->{'lport'}</tt></td>\n";
			print "<td><tt>-&gt;</tt></td>\n";
			print "<td><tt>$n->{'rhost'}:$n->{'rport'}</tt></td>\n";
			print "<td><tt>$n->{'state'}</tt></td>\n";
			}
		else {
			print "<td colspan=4>",
				$self->text('open_recv', "<tt>$n->{'lhost'}</tt>",
				      "<tt>$n->{'lport'}</tt>"),"</td>\n";
			}
		print "</tr>\n";
		}
	print "</table></td></tr></table>\n";
	}

$self->ui_print_footer("edit_proc.cgi?$self->{'in_hash'}->{'pid'}", $self->{'text_hash'}->{'edit_return'},
		 "", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

