#!/usr/bin/perl

&MAIN();

 sub MAIN {
# run.cgi
# Run a command, and maybe display it's output

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'run'} || $self->error($self->{'text_hash'}->{'run_ecannot'});
$self->switch_acl_uid();

$self->{'in_hash'}->{'input'} =~ s/\r//g;
$self->{'cmd'} = $self->{'in_hash'}->{'cmd'};
if ($self->supports_users()) {
	defined(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'run_euser'});
	$self->can_edit_process($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'run_euser2'});
	if ($self->{'in_hash'}->{'user'} ne getpwuid($<)) {
		$self->{'cmd'} = $self->command_as_user($self->{'in_hash'}->{'user'}, 0, $self->{'cmd'});
		}
	}

if ($self->{'in_hash'}->{'mode'}) {
	# fork and run..
	if (!($self->{'pid'} = fork())) {
		close(STDIN); close(STDOUT); close(STDERR);
		$self->open_execute_command(*PROC, "($self->{'cmd'})", 0);
		print PROC $self->{'in_hash'}->{'input'};
		close(PROC);
		exit;
		}
	$self->redirect("index_tree.cgi");
	}
else {
	# run and display output..
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'run_title'}, "");
	print "<p>\n";
	print $self->text('run_output', "<tt>$self->{'in_hash'}->{'cmd'}</tt>"),"<p>\n";
	print "<pre>";
	$self->{'got'} = $self->safe_process_exec_logged($self->{'cmd'}, 0, 0,
					 STDOUT, $self->{'in_hash'}->{'input'}, 1);
	if (!$self->{'got'}) { print "<i>$self->{'text_hash'}->{'run_none'}</i>\n"; }
	print "</pre>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index'});
	}
$self->webmin_log("run", undef, undef, \%{$self->{'in_hash'}});

1;
		
}


1;

