#!/usr/bin/perl
package quota::OldquotaLib;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'quota::OldquotaLib');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# quota-lib.pl
# Functions for getting user quotas

&ModuleLoader::preload_module(ref($self), "WebLib");
$self = new WebLib:: ref($self), %$self; 
$self->init_config();
$self->switch_to_remote_user();
&ModuleLoader::preload_module(ref($self), "UiLib");
$self = new UiLib:: ref($self), %$self; 
if ($self->{'gconfig_hash'}->{'os_type'} =~ /^\S+\-linux$/) {
	&ModuleLoader::preload_module(ref($self), "quota::LinuxLib");
$self = new quota::LinuxLib:: ref($self), %$self; 
	}
else {
	{
    my $pkg = $self->lib_to_pkg("$self->{gconfig_hash}->{os_type}-lib.pl", "quota");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
	}

1;

1;
		return $self;
}

# print_limit(amount, no-blocks)
sub print_limit
{
	my $self = shift;

if ($_[0] == 0) { print "<td>$self->{'text_hash'}->{'quota_unlimited'}</td>\n"; }
elsif ($self->{'bsize'} && !$_[1]) { print "<td>",$self->nice_size($_[0]*$self->{'bsize'}),"</td>"; }
else { print "<td>$_[0]</td>\n"; }
}

sub print_grace
{
	my $self = shift;

print "<td>",($_[0] || "<br>"),"</td>\n";
}


1;

