#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of schedules

&ModuleLoader::preload_module('schedule_class', "schedule::ScheduleLib");
$self = new schedule::ScheduleLib:: 'schedule_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

foreach $d (@d) {
	$self->{'sched'} = $self->get_schedule($d);
	$self->{'cron'} = $self->find_cron_job($self->{'sched'});
	if ($self->{'in_hash'}->{'delete'}) {
		# Delete email and cron job
		$self->delete_schedule($self->{'sched'});
		$main::cron_object->delete_cron_job($self->{'cron'}) if ($self->{'cron'});
		}
	elsif ($self->{'in_hash'}->{'disable'}) {
		# Clear enabled flag
		$self->{'sched'}->{'enabled'} = 0;
		$self->save_schedule($self->{'sched'});
		}
	elsif ($self->{'in_hash'}->{'enable'}) {
		# Set enabled flag
		$self->{'sched'}->{'enabled'} = 1;
		$self->save_schedule($self->{'sched'});
		}
	}

$self->redirect("");

1;
		
}


1;

