#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mail.cgi
# Display messages that have been categorized as spam

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->foreign_require("mailbox", "mailbox-lib.pl");
$self->ReadParse();
$self->{'folder'} = $self->spam_file_folder();
$self->disable_indexing($self->{'folder'});
dbmopen(%{$self->{'read_hash'}}, "$self->{'user_config_directory'}/mailbox/read", 0600);

$self->{'ref'} = $self->{'userconfig_hash'}->{'refresh'} || $main::mailbox_object->{'userconfig_hash'}->{'refresh'};
if ($self->{'ref'}) {
	print "Refresh: $self->{'ref'}\r\n";
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mail_title'}, "", undef, 0, 0, 0,
		$self->{'ref'} > 60 ? $self->text('mail_will', int($self->{'ref'}/60)) :
			    $self->text('mail_wills', $self->{'ref'}));
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mail_title'}, "");
	}
print $self->check_clicks_function() if ($self->UNIVERSAL::can('check_clicks_function'));

#print "$self->{'text_hash'}->{'mail_desc'}<p>\n";

# View mail from the most recent
$self->{'perpage'} = $self->{'folder'}->{'perpage'} || $main::mailbox_object->{'userconfig_hash'}->{'perpage'};
@{$self->{'mail_array'}} = $main::mailbox_object->mailbox_list_mails_sorted($self->{'in_hash'}->{'start'},
				    $self->{'in_hash'}->{'start'}+$self->{'perpage'}-1,
				    $self->{'folder'}, 1, \@{$self->{'error_array'}});
print "<form action=mail.cgi><center>\n";
if ($self->{'in_hash'}->{'start'}+$self->{'perpage'} < @{$self->{'mail_array'}}) {
	printf "<a href='mail.cgi?start=%d'>%s</a>\n",
		$self->{'in_hash'}->{'start'}+$self->{'perpage'},
		'<img src=/images/left.gif border=0 align=middle>';
	}

local $s = @{$self->{'mail_array'}}-$self->{'in_hash'}->{'start'};
local $e = @{$self->{'mail_array'}}-$self->{'in_hash'}->{'start'}-$self->{'perpage'}+1;
print "<font size=+1>\n";
if (@{$self->{'mail_array'}}) {
	print $self->text('mail_pos', $s, $e < 1 ? 1 : $e, scalar(@{$self->{'mail_array'}}));
	}
else {
	print $self->text('mail_none');
	}
print "</font> <input type=submit value='$self->{'text_hash'}->{'mail_refresh'}'>\n";

if ($self->{'in_hash'}->{'start'}) {
	printf "<a href='mail.cgi?start=%d'>%s</a>\n",
		$self->{'in_hash'}->{'start'}-$self->{'perpage'},
		'<img src=/images/right.gif border=0 align=middle>';
	}
print "</center></form>\n";

print "<form action=process.cgi method=post>\n";
if ($main::mailbox_object->{'userconfig_hash'}->{'top_buttons'} && @{$self->{'mail_array'}}) {
	$self->show_buttons(1);
	print $self->select_all_link("d", 1, $main::mailbox_object->{'text_hash'}->{'mail_all'}),"&nbsp;\n";
	print $self->select_invert_link("d", 1, $main::mailbox_object->{'text_hash'}->{'mail_invert'}),"&nbsp;\n";
	}

if (@{$self->{'mail_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td>&nbsp;</td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_size'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'mail_level'}</b></td> ",
	      "<td><b>$main::mailbox_object->{'text_hash'}->{'mail_subject'}</b></td> </tr>\n";
	}

for($self->{'i'}=int($self->{'in_hash'}->{'start'}); $self->{'i'}<@{$self->{'mail_array'}} && $self->{'i'}<$self->{'in_hash'}->{'start'}+$self->{'perpage'}; $self->{'i'}++) {
	local $idx = $self->{'mail_array'}->[$self->{'i'}]->{'idx'};
	print "<tr $self->{'cb'}>\n";
	print "<td><input type=checkbox name=d value=$self->{'i'}></td>\n";
	if ($self->{'userconfig_hash'}->{'full_from'}) {
		print "<td nowrap><a href='view_mail.cgi?idx=$self->{'i'}'>",
		      $self->html_escape($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'from'}),
		      "</td>\n";
		}
	else {
		print "<td nowrap><a href='view_mail.cgi?idx=$self->{'i'}'>",
		      $main::mailbox_object->simplify_from($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'from'}),
		      "</td>\n";
		}
	print "<td nowrap>",$main::mailbox_object->simplify_date($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'date'}),
	      "</td>\n";
	print "<td nowrap>",int($self->{'mail_array'}->[$self->{'i'}]->{'size'}/1000)+1," kB","</td>\n";
	print "<td nowrap>",length($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'x-spam-level'}),"</td>\n";
	print "<td><table border=0 cellpadding=0 cellspacing=0 width=100%>",
	      "<tr><td>",$main::mailbox_object->simplify_subject($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'subject'}),
	      "</td> <td align=right>";
	if ($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'content-type'} =~ /multipart\/\S+/i) {
		print "<img src=/mailbox/images/attach.gif>";
		}
	local $p = int($self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'x-priority'});
	if ($p == 1) {
		print "&nbsp;<img src=/mailbox/images/p1.gif>";
		}
	elsif ($p == 2) {
		print "&nbsp;<img src=/mailbox/images/p2.gif>";
		}
	if (!$self->{'showto'}) {
		if ($self->{'read_hash'}->{$self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'message-id'}} == 2) {
			print "&nbsp;<img src=/mailbox/images/special.gif>";
			}
		elsif ($self->{'read_hash'}->{$self->{'mail_array'}->[$self->{'i'}]->{'header'}->{'message-id'}} == 1) {
			print "&nbsp;<img src=/mailbox/images/read.gif>";
			}
		}
	print "</td></tr></table></td> </tr>\n";
	}
if (@{$self->{'mail_array'}}) {
	print "</table>\n";
	print $self->select_all_link("d", 1, $main::mailbox_object->{'text_hash'}->{'mail_all'}),"&nbsp;\n";
	print $self->select_invert_link("d", 1, $main::mailbox_object->{'text_hash'}->{'mail_invert'}),"&nbsp;\n";
	$self->show_buttons(2);
	}

print "</form>\n";

# Show search field
print "<table width=100%><tr>\n";
print "<form action=mail_search.cgi><td width=33%>\n";
print "<input type=hidden name=simple value=1>\n";
print "<input type=submit value='$main::mailbox_object->{'text_hash'}->{'mail_search2'}'>\n";
print "<input name=search size=20></td></form>\n";

# Show score search field
print "<form action=mail_search.cgi><td align=center width=33%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'mail_search3'}'>\n";
print "<input name=score size=5></td></form>\n";

# Show delete all button
print "<form action=delete_all.cgi><td align=right width=33%>\n";
print "<input type=submit value='$self->{'text_hash'}->{'mail_delall'}'></td>\n";
print "</form>\n";

print "</tr></table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

