#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_host.cgi
# Display options for a new or existing host config

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'host_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'host_edit'}, "");
	$self->{'hconf'} = $self->get_client_config();
	$self->{'host'} = $self->{'hconf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'conf'} = $self->{'host'}->{'members'};
	}

print "<form action=save_host.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'host_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->scmd(1);
print "<td><b>$self->{'text_hash'}->{'host_name'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=name_def value=1 %s> %s\n",
	$self->{'host'}->{'values'}->[0] eq '*' ? 'checked' : '', $self->{'text_hash'}->{'hosts_all'};
printf "<input type=radio name=name_def value=0 %s>\n",
	$self->{'host'}->{'values'}->[0] eq '*' ? '' : 'checked'; 
printf "<input name=name size=40 value='%s'></td>\n",
	$self->{'host'}->{'values'}->[0] eq '*' ? '' : $self->{'host'}->{'values'}->[0];
$self->ecmd();

$self->scmd();
$self->{'user'} = $self->find_value("User", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_user'}</b></td> <td nowrap>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$self->{'user'} ? "" : "checked", $self->{'text_hash'}->{'host_user_def'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$self->{'user'} ? "checked" : "";
print "<input name=user size=13 value='$self->{'user'}'></td>\n";
$self->ecmd();

$self->scmd();
$self->{'keep'} = $self->find_value("KeepAlive", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_keep'}</b></td> <td>\n";
printf "<input type=radio name=keep value=1 %s> %s\n",
	lc($self->{'keep'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=keep value=0 %s> %s\n",
	lc($self->{'keep'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=keep value=2 %s> %s</td>\n",
	!$self->{'keep'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'hostname'} = $self->find_value("HostName", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_hostname'}</b></td> <td nowrap>\n";
printf "<input type=radio name=hostname_def value=1 %s> %s\n",
	$self->{'hostname'} ? "" : "checked", $self->{'text_hash'}->{'host_hostname_def'};
printf "<input type=radio name=hostname_def value=0 %s>\n",
	$self->{'hostname'} ? "checked" : "";
print "<input name=hostname size=20 value='$self->{'hostname'}'></td>\n";
$self->ecmd();

$self->scmd();
$self->{'batch'} = $self->find_value("BatchMode", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_batch'}</b></td> <td>\n";
printf "<input type=radio name=batch value=0 %s> %s\n",
	lc($self->{'batch'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=batch value=1 %s> %s\n",
	lc($self->{'batch'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=batch value=2 %s> %s</td>\n",
	!$self->{'batch'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'port'} = $self->find_value("Port", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_port'}</b></td> <td nowrap>\n";
printf "<input type=radio name=port_def value=1 %s> %s\n",
	$self->{'port'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=port_def value=0 %s>\n",
	$self->{'port'} ? "checked" : "";
print "<input name=port size=6 value='$self->{'port'}'></td>\n";
$self->ecmd();

$self->scmd();
$self->{'comp'} = $self->find_value("Compression", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_comp'}</b></td> <td>\n";
printf "<input type=radio name=comp value=1 %s> %s\n",
	lc($self->{'comp'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=comp value=0 %s> %s\n",
	lc($self->{'comp'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=comp value=2 %s> %s</td>\n",
	!$self->{'comp'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'escape'} = $self->find_value("EscapeChar", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_escape'}</b></td> <td nowrap>\n";
printf "<input type=radio name=escape_def value=1 %s> %s\n",
	$self->{'escape'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=escape_def value=2 %s> %s\n",
	$self->{'escape'} eq "none" ? "checked" : "", $self->{'text_hash'}->{'host_escape_none'};
printf "<input type=radio name=escape_def value=0 %s>\n",
	$self->{'escape'} eq "" || $self->{'escape'} eq "none" ? "" : "checked";
printf "<input name=escape size=2 value='%s'></td>\n",
	$self->{'escape'} eq "" || $self->{'escape'} eq "none" ? "" : $self->{'escape'};
$self->ecmd();

$self->scmd();
$self->{'clevel'} = $self->find_value("CompressionLevel", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_clevel'}</b></td> <td nowrap>\n";
printf "<input type=radio name=clevel_def value=1 %s> %s\n",
	$self->{'clevel'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=clevel_def value=0 %s>\n",
	$self->{'clevel'} ? "checked" : "";
print "<select name=clevel>\n";
foreach $l (1 .. 9) {
	printf "<option %s value=%s>%s %s\n", $self->{'clevel'} == $l ? 'selected' : '',
		$l, $l, $self->{'text_hash'}->{"host_clevel_$l"};
	}
print "</select></td>\n";
$self->ecmd();

$self->scmd();
$self->{'attempts'} = $self->find_value("ConnectionAttempts", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_attempts'}</b></td> <td nowrap>\n";
printf "<input type=radio name=attempts_def value=1 %s> %s\n",
	$self->{'attempts'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=attempts_def value=0 %s>\n",
	$self->{'attempts'} ? "checked" : "";
print "<input name=attempts size=2 value='$self->{'attempts'}'></td>\n";
$self->ecmd();

$self->scmd();
$self->{'priv'} = $self->find_value("UsePrivilegedPort", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_priv'}</b></td> <td>\n";
printf "<input type=radio name=priv value=1 %s> %s\n",
	lc($self->{'priv'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=priv value=0 %s> %s\n",
	lc($self->{'priv'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=priv value=2 %s> %s</td>\n",
	!$self->{'priv'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'rsh'} = $self->find_value("FallBackToRsh", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_rsh'}</b></td> <td>\n";
printf "<input type=radio name=rsh value=1 %s> %s\n",
	lc($self->{'rsh'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=rsh value=0 %s> %s\n",
	lc($self->{'rsh'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=rsh value=2 %s> %s</td>\n",
	!$self->{'rsh'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'usersh'} = $self->find_value("UseRsh", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_usersh'}</b></td> <td>\n";
printf "<input type=radio name=usersh value=1 %s> %s\n",
	lc($self->{'usersh'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=usersh value=0 %s> %s\n",
	lc($self->{'usersh'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=usersh value=2 %s> %s</td>\n",
	!$self->{'usersh'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'agent'} = $self->find_value("ForwardAgent", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_agent'}</b></td> <td>\n";
printf "<input type=radio name=agent value=1 %s> %s\n",
	lc($self->{'agent'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=agent value=0 %s> %s\n",
	lc($self->{'agent'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=agent value=2 %s> %s</td>\n",
	!$self->{'agent'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'x11'} = $self->find_value("ForwardX11", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_x11'}</b></td> <td>\n";
printf "<input type=radio name=x11 value=1 %s> %s\n",
	lc($self->{'x11'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=x11 value=0 %s> %s\n",
	lc($self->{'x11'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=x11 value=2 %s> %s</td>\n",
	!$self->{'x11'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd();
$self->{'strict'} = $self->find_value("StrictHostKeyChecking", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'host_strict'}</b></td> <td>\n";
printf "<input type=radio name=strict value=0 %s> %s\n",
	lc($self->{'strict'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=strict value=1 %s> %s\n",
	lc($self->{'strict'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'no'};
printf "<input type=radio name=strict value=3 %s> %s\n",
	lc($self->{'strict'}) eq 'ask' ? "checked" : "", $self->{'text_hash'}->{'host_ask'};
printf "<input type=radio name=strict value=2 %s> %s</td>\n",
	!$self->{'strict'} ? "checked" : "", $self->{'text_hash'}->{'default'};
$self->ecmd();

$self->scmd(1);
$self->{'proxy'} = join(" ", $self->find_value("ProxyCommand", $self->{'conf'}));
print "<td><b>$self->{'text_hash'}->{'host_proxy'}</b></td> <td nowrap colspan=3>\n";
printf "<input type=radio name=proxy_def value=1 %s> %s\n",
	$self->{'proxy'} ? "" : "checked", $self->{'text_hash'}->{'host_proxy_def'};
printf "<input type=radio name=proxy_def value=0 %s>\n",
	$self->{'proxy'} ? "checked" : "";
print "<input name=proxy size=60 value='$self->{'proxy'}'></td>\n";
$self->ecmd();

if ($self->get_ssh_type() eq 'openssh') {
	$self->scmd();
	$self->{'checkip'} = $self->find_value("CheckHostIP", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'host_checkip'}</b></td> <td>\n";
	printf "<input type=radio name=checkip value=1 %s> %s\n",
		lc($self->{'checkip'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=checkip value=0 %s> %s\n",
		lc($self->{'checkip'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=checkip value=2 %s> %s</td>\n",
		!$self->{'checkip'} ? "checked" : "", $self->{'text_hash'}->{'default'};
	$self->ecmd();

	$self->scmd(1);
	$self->{'prots'} = $self->find_value("Protocol", $self->{'conf'});
	@{$self->{'prots_array'}} = split(/,/, $self->{'prots'});
	print "<td><b>$self->{'text_hash'}->{'host_prots'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=prots_def value=1 %s> %s\n",
		$self->{'prots'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=prots_def value=0 %s> %s\n",
		$self->{'prots'} ? 'checked' : '', $self->{'text_hash'}->{'host_prots_sel'};
	foreach $p (1, 2) {
		printf "<input type=checkbox name=prots value=%s %s> %s\n",
			$p, $self->indexof($p, @{$self->{'prots_array'}}) >= 0 ? "checked" : "",
			$self->{'text_hash'}->{"net_prots_$p"};
		}
	print "</td>\n";
	$self->ecmd();
	}

$self->scmd(1);
print "<td colspan=4><hr></td>\n";
$self->ecmd();

$self->scmd(1);
print "<td valign=top><b>$self->{'text_hash'}->{'host_lforward'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'host_llport'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'host_lrhost'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'host_lrport'}</b></td> </tr>\n";
@{$self->{'lforward_array'}} = $self->find("LocalForward", $self->{'conf'});
$self->{'i'} = 0;
foreach $l (@{$self->{'lforward_array'}}, { }) {
	local ($lp, $rh, $rp) = ( $l->{'values'}->[0],
				  split(/:/, $l->{'values'}->[1]) );
	print "<tr>\n";
	print "<td><input name=llport_$self->{'i'} size=8 value='$lp'></td>\n";
	print "<td><input name=lrhost_$self->{'i'} size=40 value='$rh'></td>\n";
	print "<td><input name=lrport_$self->{'i'} size=8 value='$rp'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td>\n";
$self->ecmd();

$self->scmd(1);
print "<td colspan=4><hr></td>\n";
$self->ecmd();

$self->scmd(1);
print "<td valign=top><b>$self->{'text_hash'}->{'host_rforward'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'host_rrport'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'host_rlhost'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'host_rlport'}</b></td> </tr>\n";
@{$self->{'rforward_array'}} = $self->find("RemoteForward", $self->{'conf'});
$self->{'i'} = 0;
foreach $r (@{$self->{'rforward_array'}}, { }) {
	local ($rp, $lh, $lp) = ( $r->{'values'}->[0],
				  split(/:/, $r->{'values'}->[1]) );
	print "<tr>\n";
	print "<td><input name=rrport_$self->{'i'} size=8 value='$rp'></td>\n";
	print "<td><input name=rlhost_$self->{'i'} size=40 value='$lh'></td>\n";
	print "<td><input name=rlport_$self->{'i'} size=8 value='$lp'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td>\n";
$self->ecmd();

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
print "<td align=right><input type=submit name=delete ",
      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
print "</tr></table>\n";

$self->ui_print_footer("list_hosts.cgi", $self->{'text_hash'}->{'hosts_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

