#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_auths.cgi
# List public keys that are allowed to login to this account

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'auths_title'}, "");

@{$self->{'links_array'}} = ( "<a href='edit_auth.cgi?new=1&type=1'>$self->{'text_hash'}->{'auths_add1'}</a>",
	   "<a href='edit_auth.cgi?new=1&type=2'>$self->{'text_hash'}->{'auths_add2'}</a>" );

print "$self->{'text_hash'}->{'auths_desc'}<p>\n";
@{$self->{'auths_array'}} = $self->list_auths();
if (@{$self->{'auths_array'}}) {
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ $self->{'text_hash'}->{'auths_name'},
				  $self->{'text_hash'}->{'auths_key'} ]);
	foreach $a (@{$self->{'auths_array'}}) {
		print $self->ui_columns_row([ 
			"<a href='edit_auth.cgi?idx=$a->{'index'}'>".
			  "$a->{'name'}</a>",
			"<tt>".substr($a->{'key'}, 0, 40)." ... ".
			      substr($a->{'key'}, -40)."</tt>",
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'auths_none'}</b> <p>\n";
	}
print $self->ui_links_row(\@{$self->{'links_array'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

