#!/usr/bin/perl

&MAIN();

 sub MAIN {
# setup.cgi
# Calls ssh-keygen for the user

&ModuleLoader::preload_module('ssh_class', "ssh::SshLib");
$self = new ssh::SshLib:: 'ssh_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'setup_err'});

# Check for openssh version 3.4 or above
$self->{'type'} = $self->{'in_hash'}->{'type'} ? "-t $self->{'in_hash'}->{'type'}" : "";

$self->{'out'} = `echo '' | ssh-keygen $self->{'type'} -P \"$self->{'in_hash'}->{'pass'}\" 2>&1`;
if ($?) {
	$self->error("<pre>$self->{'out'}</pre>");
	}
if (-r "$self->{'ssh_directory'}/identity.pub") {
	system("cp $self->{'ssh_directory'}/identity.pub $self->{'ssh_directory'}/authorized_keys");
	}
else {
	system("cp $self->{'ssh_directory'}/id_dsa.pub $self->{'ssh_directory'}/authorized_keys");
	}
$self->redirect("");

1;
		
}


1;

