#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display the telnet applet

&ModuleLoader::preload_module('telnet_class', "WebLib");
$self = new WebLib:: 'telnet_class',%$self;

use Socket;
$self->init_config();
&ModuleLoader::preload_module('telnet_class', "UiLib");
$self = new UiLib:: 'telnet_class',%$self;

$self->switch_to_remote_user();
$self->create_user_config_dirs();
$self->{'theme_no_table'} = 1 if ($self->{'userconfig_hash'}->{'sizemode'} == 1);
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 0, 1);

# Are we running SSH or telnet
$self->{'telnet_port'} = $self->{'config_hash'}->{'telnet_port'} || 23;
$self->{'ssh_port'} = $self->{'config_hash'}->{'ssh_port'} || 22;
$self->{'port'} = $self->{'ssh_port'};
$self->{'mode'} = 1;
socket(STEST, PF_INET, SOCK_STREAM, getprotobyname("tcp"));
$self->{'rv'} = connect(STEST, pack_sockaddr_in($self->{'ssh_port'}, inet_aton("127.0.0.1")));
close(STEST);
if (!$self->{'rv'}) {
	$self->{'port'} = $self->{'telnet_port'};
	$self->{'mode'} = 0;
	$self->{'rv'} = connect(STEST, pack_sockaddr_in($self->{'telnet_port'}, inet_aton("127.0.0.1")));
	close(STEST);
	}
if (!$self->{'rv'}) {
	if ($self->{'gconfig_hash'}->{'ztl_mode'}) {print "<p>$self->{'text_hash'}->{'index_econnect2'}<\p>\n";}
	else {print "<p>$self->{'text_hash'}->{'index_econnect3'}<p>\n";}
	}
else {
	print "<center>\n";
	if ($self->{'userconfig_hash'}->{'detach'}) {
		$self->{'w'} = 100; $self->{'h'} = 50;
		}
	elsif ($self->{'userconfig_hash'}->{'sizemode'} == 2 &&
	       $self->{'userconfig_hash'}->{'size'} =~ /^(\d+)\s*x\s*(\d+)$/) {
		$self->{'w'} = $1; $self->{'h'} = $2;
		}
	elsif ($self->{'userconfig_hash'}->{'sizemode'} == 1) {
		$self->{'w'} = "100%"; $self->{'h'} = "80%";
		}
	else {
		$self->{'w'} = 590; $self->{'h'} = 360;
		}
	$self->{'jar'} = $self->{'userconfig_hash'}->{'applet'} ? "jta25.jar" : "jta20.jar";
	print "<applet archive=\"$self->{'jar'}\" code=de.mud.jta.Applet ",
	      "width=$self->{'w'} height=$self->{'h'}>\n";
	printf "<param name=config value=%s>\n",
		$self->{'mode'} ? "ssh.conf" : "telnet.conf";
	print "$self->{'text_hash'}->{'index_nojava'} <p>\n";
	if ($self->{'userconfig_hash'}->{'sizemode'}) {
		print "<param name=Terminal.resize value='screen'>\n";
		}
	if ($self->{'userconfig_hash'}->{'fontsize'}) {
		print "<param name=Terminal.fontSize value='$self->{'userconfig_hash'}->{'fontsize'}'>\n";
		}
	if ($self->{'userconfig_hash'}->{'detach'}) {
		print "<param name=Applet.detach value='true'>\n";
		print "<param name=Applet.detach.stopText value='Disconnect'>\n";
		}
	if ($self->{'config_hash'}->{'port'}) {
		print "<param name=Socket.port value=$self->{'port'}>\n";
		}
        if ($self->{'config_hash'}->{'applet'}) {
                print "<param name=Socket.host value=$ENV{'SERVER_NAME'}>\n";
                }
	print "</applet><br>\n";

	print "</center>\n";
	}

%{$self->{'hometext_hash'}} = $self->load_language('/home');
#$self->ui_print_footer("/home/", $self->{'hometext_hash'}->{'index_return'});
	$self->ui_print_footer("$self->{'text_hash'}->{'index_mainpage_url'}", $self->{'text_hash'}->{'index_mainpage'} );
1;
		
}


1;

