#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mount.cgi
# Mount or unmount a directory

&ModuleLoader::preload_module('usermount_class', "usermount::UsermountLib");
$self = new usermount::UsermountLib:: 'usermount_class',%$self;

$self->ReadParse();
($self->{'d'}) = grep { /^(mount|umount)/ } (keys %{$self->{'in_hash'}});
$self->{'d'} =~ /^(\S+)_(\S+)$/;
$self->{'fs'} = $2;
$self->{'cmd'} = $1 eq "mount" ? "mount ".quotemeta($self->{'fs'}) : "umount ".quotemeta($self->{'fs'});
$self->error_setup($1 eq "mount" ? $self->{'text_hash'}->{'mount_err1'} : $self->{'text_hash'}->{'mount_err2'});
if ($self->{'in_hash'}->{'pass_'.$self->{'fs'}}) {
	$self->{'temp'} = $self->transname();
	open(TEMP, ">$self->{'temp'}");
	print TEMP $self->{'in_hash'}->{'pass_'.$self->{'fs'}},"\n";
	close(TEMP);
	$self->{'out'} = `$self->{'cmd'} -p - <$self->{'temp'} 2>&1`;
	}
else {
	$self->{'out'} = `$self->{'cmd'} </dev/null 2>&1`;
	}
unlink($self->{'temp'});
if ($?) {
	$self->error("<pre>$self->{'out'}</pre>");
	}
$self->redirect("");

1;
		
}


1;

