#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cron.cgi
# Show fetchmail cron configuration

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->{'access_hash'}->{'cron'} || $self->error($self->{'text_hash'}->{'cron_ecannot2'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'cron_title'}, "");

print "$self->{'text_hash'}->{'cron_desc'}<p>\n";

# Get the cron job
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
($self->{'job'}) = grep { $_->{'user'} eq $self->{'cron_user'} &&
		$_->{'command'} =~ /^$self->{'cron_cmd'}/ } @{$self->{'jobs_array'}};

print $self->ui_form_start("save_cron.cgi");
print $self->ui_table_start($self->{'text_hash'}->{'cron_header'}, "width=100%", 2);

if ($self->{'job'}) {
	if ($self->{'job'}->{'command'} =~ /--mail\s+(\S+)/) {
		$self->{'mail'} = `echo $1`;
		}
	elsif ($self->{'job'}->{'command'} =~ /--file\s+(\S+)/) {
		$self->{'file'} = `echo $1`;
		}
	elsif ($self->{'job'}->{'command'} =~ /--output/) {
		$self->{'output'} = 1;
		}
	elsif ($self->{'job'}->{'command'} =~ /--owner/) {
		$self->{'owner'} = 1;
		}
	if ($self->{'job'}->{'command'} =~ /--user\s+(\S+)/) {
		$self->{'user'} = $1;
		}
	if ($self->{'job'}->{'command'} =~ /--errors/) {
		$self->{'errors'} = 1;
		}
	}

print $self->ui_table_row($self->{'text_hash'}->{'cron_output'},
		   $self->ui_radio("output", $self->{'owner'} ? 4 : $self->{'output'} ? 3 : $self->{'mail'} ? 2 : $self->{'file'} ? 1 : 0,
			     [ [ 0, $self->{'text_hash'}->{'cron_throw'}."<br>" ],
			       [ 3, $self->{'text_hash'}->{'cron_cron'}."<br>" ],
			       [ 1, $self->text('cron_file',
				$self->ui_textbox("file", $self->{'file'}, 30))."<br>" ],
			       [ 2, $self->text('cron_mail',
				$self->ui_textbox("mail", $self->{'mail'}, 30))."<br>" ],
			       $self->{'fetchmail_config'} ? ( ) :
				 ( [ 4, $self->{'text_hash'}->{'cron_owner'}."<br>" ] ) ]));

print $self->ui_table_row($self->{'text_hash'}->{'cron_errors'},
		    $self->ui_radio("errors", $self->{'errors'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

if ($self->{'cron_user'} eq "root" && $self->{'fetchmail_config'}) {
	print $self->ui_table_row($self->{'text_hash'}->{'cron_user'},
			    $self->ui_user_textbox("user", $self->{'user'} || "root"));
	}

print $self->ui_table_row($self->{'text_hash'}->{'cron_enabled'},
		    $self->ui_radio("enabled", $self->{'job'} ? 1 : 0,
			      [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]));

print "<tr> <td colspan=2><table border width=100%>\n";
$self->{'job'} ||= { 'special' => 'hourly' };
$main::cron_object->show_times_input($self->{'job'});
print "</table></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

