#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start.cgi
# Start the fetchmail daemon

&ModuleLoader::preload_module('fetchmail_class', "fetchmail::FetchmailLib");
$self = new fetchmail::FetchmailLib:: 'fetchmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'start_err'});
$self->{'config_hash'}->{'config_file'} || $< || $self->error($self->{'text_hash'}->{'start_ecannot'});

if ($self->{'config_hash'}->{'start_cmd'}) {
	$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'start_cmd'} 2>&1");
	}
else {
	$self->{'in_hash'}->{'interval'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'start_einterval'});
	$self->{'mda'} = " -m '$self->{'config_hash'}->{'mda_command'}'" if ($self->{'config_hash'}->{'mda_command'});
	if ($< == 0) {
		if ($self->{'config_hash'}->{'daemon_user'} eq 'root') {
			$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'fetchmail_path'} -d $self->{'in_hash'}->{'interval'} -f $self->{'config_hash'}->{'config_file'} $self->{'mda'} 2>&1");
			}
		else {
			$self->{'out'} = $self->backquote_logged("su - '$self->{'config_hash'}->{'daemon_user'}' -c '$self->{'config_hash'}->{'fetchmail_path'} -d $self->{'in_hash'}->{'interval'} -f $self->{'config_hash'}->{'config_file'} $self->{'mda'}' 2>&1");
			}
		}
	else {
		$self->{'out'} = $self->backquote_logged("$self->{'config_hash'}->{'fetchmail_path'} -d $self->{'in_hash'}->{'interval'} $self->{'mda'} 2>&1");
		}
	}
if ($?) {
	$self->error("<tt>$self->{'out'}</tt>");
	}
$self->webmin_log("start", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

