#!/usr/bin/perl

&MAIN();

 sub MAIN {
# convert.cgi
# Convert in-kernel firewall rules to the save file, and setup a bootup script

&ModuleLoader::preload_module('firewall_class', "firewall::FirewallLib");
$self = new firewall::FirewallLib:: 'firewall_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'setup'} || $self->error($self->{'text_hash'}->{'setup_ecannot'});
$self->error_setup($self->{'text_hash'}->{'convert_err'});
$self->lock_file($self->{'iptables_save_file'});
if ($self->UNIVERSAL::can('unapply_iptables')) {
	# Call distro's unapply command
	$self->{'err'} = $self->unapply_iptables();
	}
else {
	# Manually run iptables-save
	$self->{'out'} = $self->backquote_logged("iptables-save >$self->{'iptables_save_file'} 2>&1");
	$self->{'err'} = "<pre>$self->{'out'}</pre>" if ($?);
	}
$self->error($self->{'err'}) if ($self->{'err'});

if ($self->{'in_hash'}->{'atboot'}) {
	$self->create_firewall_init();
	}
$self->unlock_file($self->{'iptables_save_file'});

$self->webmin_log("convert");
$self->redirect("");

1;
		
}


1;

