#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_disk.cgi
# Display information about a disk, with links to low-level format,
# repair and other dangerous options

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ui_print_header(undef, "Edit Disk", "");
print "<table width=100%><tr> <td valign=top>\n";
$self->{'d'} = $ARGV[0];

@{$self->{'dlist_array'}} = $self->list_disks();
@dinfo = split(/\s+/, $self->{'dlist_array'}->[$self->{'d'}]);
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>Disk Details</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>Disk Type:</b></td> <td>$dinfo[1]</td> </tr>\n";
print "<tr> <td><b>Device:</b></td> <td><tt>/dev/dsk/$dinfo[0]</tt></td> </tr>\n";

print "<tr> <td valign=top><b>SCSI:</b></td>\n";
$dinfo[0] =~ /c(\d+)t(\d+)d(\d+)/;
print "<td><table>\n";
print "<tr> <td>Controller</td> <td>$1</td> </tr>\n";
print "<tr> <td>Target</td> <td>$2</td> </tr>\n";
print "<tr> <td>Unit</td> <td>$3</td> </tr></table></td> </tr>\n";

print "<tr> <td valign=top><b>Vendor:</b></td>\n";
@{$self->{'inq_array'}} = $self->disk_info($self->{'d'});
print "<td><table>\n";
print "<tr> <td>Name</td> <td>$self->{'inq_array'}->[0]</td> </tr>\n";
print "<tr> <td>Product</td> <td>$self->{'inq_array'}->[1]</td> </tr>\n";
print "<tr> <td>Revision</td> <td>$self->{'inq_array'}->[2]</td> </tr></table></td> </tr>\n";
print "</table></td></tr></table>\n";

print "</td> <td valign=top>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td colspan=2><b>Disk Tasks</b></td> </tr>\n";
@{$self->{'plist_array'}} = $self->list_partitions($self->{'d'});
for($i=0; $i<@{$self->{'plist_array'}}; $i++) {
	@{$self->{'stat_array'}} = $self->device_status("/dev/dsk/$dinfo[0]s$i");
	if (@{$self->{'stat_array'}}) { $self->{'inuse'} = 1; }
	if ($self->{'stat_array'}->[2]) { $self->{'mounted'} = 1; }
	}

print "<tr $self->{'cb'}> <form action=format_form.cgi>\n";
print "<td valign=top><b>Format Disk</b><br>\n";
if (!$self->{'inuse'}) {
	print "<input type=hidden name=disk value=$self->{'d'}>\n";
	print "<input type=submit value=\"Format\"></td>\n";
	print "<td>Does a low level format of the disk, permanently erasing\n";
	print "all data. This is only necessary if the disk has not been\n";
	print "formatted by the vendor.</td> </tr>\n";
	}
else {
	print "</td> <td>You cannot format this disk because it contains\n";
	print "filesystems that are in the system mount list.</td> </tr>\n";
	}
print "</form> </tr>\n";

print "<tr $self->{'cb'}> <form action=copy_part_form.cgi>\n";
print "<td valign=top><b>Copy Partitions</b><br>\n";
print "<input type=hidden name=disk value=$self->{'d'}>\n";
print "<input type=submit value=\"Copy\"></td>\n";
print "<td>Copy the partition map from this disk to other disks. This\n";
print "is useful if you have a large number of disks that need the same\n";
print "partition layout, such as for a MetaDisk array.</td> </tr>\n";
print "</form> </tr>\n";

print "</table>\n";

print "</td> </tr></table><p>\n";
$self->ui_print_footer("", "disk list");

1;
		
}


1;

