#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_part.cgi
# Edit an existing partition

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->{'d'} = $ARGV[0]; $self->{'p'} = $ARGV[1];
@{$self->{'dlist_array'}} = $self->list_disks();
$self->{'dinfo'} = $self->{'dlist_array'}->[$self->{'d'}];
$self->can_edit_disk($self->{'dinfo'}->{'device'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
print "<table width=100%><tr> <td valign=top>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<form action=save_part.cgi><tr $self->{'cb'}><td><table>\n";
print "<input type=hidden name=disk value=$self->{'d'}>\n";
print "<input type=hidden name=part value=$self->{'p'}>\n";
@{$self->{'plist_array'}} = $self->list_partitions($self->{'dinfo'}->{'device'});
$self->{'pinfo'} = $self->{'plist_array'}->[$self->{'p'}];
$self->{'new'} = !$self->{'pinfo'}->{'end'};

$self->{'dinfo'}->{'device'} =~ /c(\d+)t(\d+)d(\d+)/;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_location'}</b></td>\n";
print "<td>$self->{'pinfo'}->{'desc'}</td> </tr>\n";

$self->{'dev'} = $self->{'pinfo'}->{'device'};
print "<tr> <td><b>$self->{'text_hash'}->{'edit_dev'}</b></td> <td><tt>$self->{'dev'}</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td> <td><select name=tag>\n";
foreach $t ($self->list_tags()) {
	printf "<option %s>$t\n", $t eq $self->{'pinfo'}->{'tag'} ? "selected" : "";
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_flags'}</b></td>\n";
printf "<td nowrap><input type=checkbox name=writable value=1 %s> %s\n",
	$self->{'pinfo'}->{'flag'} =~ /^w.$/ ? "checked" : "", $self->{'text_hash'}->{'edit_w'};
printf "<input type=checkbox name=mountable value=1 %s> %s</td> </tr>\n",
	$self->{'pinfo'}->{'flag'} =~ /^.m$/ ? "checked" : "", $self->{'text_hash'}->{'edit_m'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_extent'}</b></td>\n";
printf "<td nowrap><input name=start size=6 value=\"%s\"> - \n",
	$self->{'pinfo'}->{'end'} ? $self->{'pinfo'}->{'start'} : "";
printf "<input name=end size=6 value=\"%s\">\n",
	$self->{'pinfo'}->{'end'} ? $self->{'pinfo'}->{'end'} : "";
print "of $self->{'dinfo'}->{'cyl'}</td> </tr>\n";

if ($self->{'pinfo'}->{'end'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_stat'}</b></td>\n";
	@{$self->{'stat_array'}} = $self->device_status($self->{'dev'});
	if ($self->{'stat_array'}->[1] eq "meta") {
		print "<td>$self->{'text_hash'}->{'edit_meta'}</td> </tr>\n";
		}
	elsif ($self->{'stat_array'}->[1] eq "metadb") {
		print "<td>$self->{'text_hash'}->{'edit_metadb'}</td> </tr>\n";
		}
	elsif (@{$self->{'stat_array'}}) {
		local $msg = $self->{'stat_array'}->[2] ? 'edit_mount' : 'edit_umount';
		$msg .= 'vm' if ($self->{'stat_array'}->[1] eq 'swap');
		print "<td>",$self->text($msg, "<tt>$self->{'stat_array'}->[0]</tt>",
				   "<tt>$self->{'stat_array'}->[1]</tt>"),"</td> </tr>\n";
		}
	else { print "<td>$self->{'text_hash'}->{'edit_nouse'}</td> </tr>\n"; }

	if ($self->{'stat_array'}->[1] !~ /^meta/) {
		print "<tr> <td><b>$self->{'text_hash'}->{'edit_fs'}</b></td>\n";
		$self->{'fs'} = $self->filesystem_type($self->{'dev'});
		printf "<td>%s</td> </tr>\n", $self->{'fs'} ? $self->fstype_name($self->{'fs'}) : "None";
		}
	}

print "</table></td></tr></table><p>\n";
if (@{$self->{'stat_array'}}) { print "<b>$self->{'text_hash'}->{'edit_inuse'}</b>.\n"; }
elsif ($self->{'new'}) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_setup'}\">\n";
	}
else {
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_change'}\">\n";
	print "<input type=submit name=delete value=\"$self->{'text_hash'}->{'delete'}\">\n";
	}
print "</form>\n";

print "</td> <td valign=top>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td colspan=2><b>$self->{'text_hash'}->{'edit_tasks'}</b></td> </tr>\n";

print "<tr $self->{'cb'}> <form action=newfs_form.cgi>\n";
print "<td valign=top nowrap><b>$self->{'text_hash'}->{'edit_newfs'}</b><br>\n";
if (!$self->{'new'} && (!@{$self->{'stat_array'}} || $self->{'stat_array'}->[2] == 0)) {
	print "<input type=hidden name=dev value=$self->{'dev'}>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'edit_newdesc1'}</td>\n";
	}
elsif ($self->{'new'}) {
	print "</td> <td>$self->{'text_hash'}->{'edit_newdesc2'}</td>\n";
	}
else {
	print "</td> <td>$self->{'text_hash'}->{'edit_newdesc3'}</td>\n";
	}
print "</form> </tr>\n";

print "<tr $self->{'cb'}> <form action=fsck_form.cgi>\n";
print "<td valign=top><b>$self->{'text_hash'}->{'edit_fsckfs'}</b><br>\n";
if (!$self->{'new'} && (!@{$self->{'stat_array'}} || $self->{'stat_array'}->[2] == 0) && $self->{'fs'} eq "ufs") {
	print "<input type=hidden name=dev value=$self->{'dev'}>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_fsck'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'edit_fsckdesc1'}</td>\n";
	}
elsif ($self->{'new'}) {
	print "</td> <td>$self->{'text_hash'}->{'edit_fsckdesc2'}</td>\n";
	}
elsif (@{$self->{'stat_array'}} && $self->{'stat_array'}->[2]) {
	print "</td> <td>$self->{'text_hash'}->{'edit_fsckdesc3'}</td>\n";
	}
elsif (!$self->{'fs'}) {
	print "</td> <td>$self->{'text_hash'}->{'edit_fsckdesc4'}</td>\n";
	}
else {
	print "</td> <td>$self->{'text_hash'}->{'edit_fsckdesc5'}</td>\n";
	}
print "</form> </tr>\n";

print "<tr $self->{'cb'}> <form action=tunefs_form.cgi>\n";
print "<td valign=top><b>$self->{'text_hash'}->{'edit_tunefs'}</b><br>\n";
if (!$self->{'new'} && (!@{$self->{'stat_array'}} || $self->{'stat_array'}->[2] == 0) && $self->{'fs'} eq "ufs") {
	print "<input type=hidden name=dev value=$self->{'dev'}>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'edit_tune'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'edit_tunedesc1'}</td>\n";
	}
elsif ($self->{'new'}) {
	print "</td> <td>$self->{'text_hash'}->{'edit_tunedesc2'}</td>\n";
	}
elsif (@{$self->{'stat_array'}} && $self->{'stat_array'}->[2]) {
	print "</td> <td>$self->{'text_hash'}->{'edit_tunedesc3'}</td>\n";
	}
elsif (!$self->{'fs'}) {
	print "</td> <td>$self->{'text_hash'}->{'edit_tunedesc4'}</td>\n";
	}
elsif ($self->{'fs'} ne "ufs") {
	print "</td> <td>$self->{'text_hash'}->{'edit_tunedesc5'}</td>\n";
	}
print "</form> </tr>\n";

print "</table>\n";
print "</td></tr></table>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

