#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newfs.cgi
# Create a new filesystem 

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'newfs_ecannot'});
$self->error_setup($self->{'text_hash'}->{'newfs_err'});
$self->{'cmd'} = "newfs";
$self->{'cmd'} .= $self->opt_check("ufs_a", '\d+', "-a");
$self->{'cmd'} .= $self->opt_check("ufs_b", '\d+', "-b");
$self->{'cmd'} .= $self->opt_check("ufs_c", '\d+', "-c");
$self->{'cmd'} .= $self->opt_check("ufs_d", '\d+', "-d");
$self->{'cmd'} .= $self->opt_check("ufs_f", '\d+', "-f");
$self->{'cmd'} .= $self->opt_check("ufs_i", '\d+', "-i");
$self->{'cmd'} .= $self->opt_check("ufs_m", '\d+', "-m");
$self->{'cmd'} .= $self->opt_check("ufs_n", '\d+', "-n");
$self->{'cmd'} .= $self->{'in_hash'}->{ufs_o} ? " -o $self->{'in_hash'}->{ufs_o}" : "";
$self->{'cmd'} .= $self->opt_check("ufs_r", '\d+', "-r");
$self->{'cmd'} .= $self->opt_check("ufs_s", '\d+', "-s");
$self->{'cmd'} .= $self->opt_check("ufs_t", '\d+', "-t");
$self->{'cmd'} .= $self->opt_check("ufs_cb", '\d+', "-C");
$self->{'in_hash'}->{dev} =~ s/dsk/rdsk/g;
$self->{'cmd'} .= " $self->{'in_hash'}->{dev}";

$self->ui_print_header(undef, $self->{'text_hash'}->{'newfs_title'}, "");

print $self->text('newfs_exec', "<tt>$self->{'cmd'}</tt>"),"<p>\n";
print "<pre>\n";
open(MKFS, "$self->{'cmd'} 2>&1 </dev/null |");
while(<MKFS>) { print; }
close(MKFS);
print "</pre>\n";
if ($?) { print "$self->{'text_hash'}->{'newfs_failed'} <p>\n"; }
else { print "$self->{'text_hash'}->{'newfs_ok'} <p>\n"; }

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

