#!/usr/bin/perl

&MAIN();

 sub MAIN {
# tunefs_form.cgi
# Display a form for entering filesystem tuning options

&ModuleLoader::preload_module('format_class', "format::FormatLib");
$self = new format::FormatLib:: 'format_class',%$self;

$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'ecannot'});
$self->ReadParse();
$self->can_edit_disk($self->{'in_hash'}->{'dev'}) || $self->error($self->{'text_hash'}->{'tunefs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'tunefs_title'}, "");

@{$self->{'stat_array'}} = $self->device_status($self->{'in_hash'}->{dev});
$self->{'fs'} = $self->filesystem_type($self->{'in_hash'}->{dev});
print "<form action=tunefs.cgi>\n";
print "<input type=hidden name=dev value=\"$self->{'in_hash'}->{dev}\">\n";
print $self->text('tunefs_desc', $self->fstype_name($self->{'fs'}), "<tt>$self->{'in_hash'}->{'dev'}</tt>"),"<p>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'tunefs_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$self->opt_input("tunefs_a", "", 1);
$self->opt_input("tunefs_d", "ms", 0);
$self->opt_input("tunefs_e", "", 1);
$self->opt_input("tunefs_m", "%", 0);
print "<tr> <td align=right><b>$self->{'text_hash'}->{'tunefs_opt'}</b></td>\n";
print "<td><select name=tunefs_o>\n";
print "<option value=''> $self->{'text_hash'}->{'default'}\n";
print "<option value=space> $self->{'text_hash'}->{'tunefs_space'}\n";
print "<option value=time> $self->{'text_hash'}->{'tunefs_time'}\n";
print "</select></td>\n";
print "</table></td></tr></table><br>\n";

print "<div align=right>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'tunefs_tune'}\"></form>\n";
print "</div>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

