#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show access control options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'acl_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_acl.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'acl_header'}, "width=100%", 4);

print $self->config_opt_textbox($self->{'conf'}, "Timeout", 5);

print $self->config_opt_textbox($self->{'conf'}, "MaxForks", 5);

print $self->config_opt_textbox($self->{'conf'}, "MaxForksPerHost", 5);

print $self->config_opt_textbox($self->{'conf'}, "MaxTransferRate", 5, 1, $self->{'text_hash'}->{'acl_bps'});

print $self->config_yesno($self->{'conf'}, "DoNTP", undef, undef, "no");

print $self->ui_table_row("", "");

print $self->config_opt_textbox($self->{'conf'}, "NTPAddress", 30, 3, $self->{'text_hash'}->{'acl_same'});

print $self->ui_table_hr();

@{$self->{'acl_array'}} = $self->find("ACL", $self->{'conf'});
$self->{'table'} = "<table border width=100%>\n".
	 "<tr $self->{'tb'}> ".
	 "<td><b>$self->{'text_hash'}->{'acl_action'}</b></td> ".
	 "<td><b>$self->{'text_hash'}->{'acl_src'}</b></td> ".
	 "<td><b>$self->{'text_hash'}->{'acl_dest'}</b></td> ".
	 "<td><b>$self->{'text_hash'}->{'acl_ports'}</b></td> ".
         "</tr>\n";
$self->{'i'} = 0;
foreach $a (@{$self->{'acl_array'}}, { }, { }, { }) {
	$self->{'table'} .= "<tr $self->{'cb'}>\n";
	$self->{'table'} .= "<td>".$self->ui_select("action_$self->{'i'}",
				    $a->{'words'}->[0],
				    [ [ "", " " ],
				      [ "Allow", $self->{'text_hash'}->{'acl_allow'} ],
				      [ "Deny", $self->{'text_hash'}->{'acl_deny'} ] ]).
	          "</td>\n";
	$self->{'table'} .= "<td>".$self->ui_opt_textbox("src_$self->{'i'}",
					 $a->{'words'}->[1] eq "*" ? "" :
						$a->{'words'}->[1],
					 20, $self->{'text_hash'}->{'acl_any'})."</td>\n";
	$self->{'table'} .= "<td>".$self->ui_opt_textbox("dest_$self->{'i'}",
					 $a->{'words'}->[3] eq "*" ? "" :
						$a->{'words'}->[3],
					 20, $self->{'text_hash'}->{'acl_any'})."</td>\n";
	$self->{'table'} .= "<td>".$self->ui_opt_textbox("ports_$self->{'i'}",
					 $a->{'words'}->[4] eq "*" ? "" :
						$a->{'words'}->[4],
					 10, $self->{'text_hash'}->{'acl_any'})."</td>\n";
	$self->{'table'} .= "</tr>\n";
	$self->{'i'}++;
	}
$self->{'table'} .= "</table>\n";
print $self->ui_table_row(undef, $self->{'table'}, 4);

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

