#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show caching options

&ModuleLoader::preload_module('frox_class', "frox::FroxLib");
$self = new frox::FroxLib:: 'frox_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'cache_title'}, "");
$self->{'conf'} = $self->get_config();

print $self->ui_form_start("save_cache.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'cache_header'}, "width=100%", 4);

$self->{'module'} = $self->find_value("CacheModule", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'cache_module'},
		    $self->ui_radio("CacheModule", $self->{'module'},
			      [ [ "", $self->{'text_hash'}->{'cache_none'} ],
				[ "local", $self->{'text_hash'}->{'cache_local'} ],
				[ "http", $self->{'text_hash'}->{'cache_http'} ] ]), 3, \@{$self->{'ui_td_array'}});

print $self->config_textbox($self->{'conf'}, "CacheSize", 6, undef, "MB");

print $self->config_textbox($self->{'conf'}, "HTTPProxy", 30);

print $self->ui_table_row("", "");

print $self->config_textbox($self->{'conf'}, "MinCacheSize", 6, undef, "bytes");

print $self->config_yesno($self->{'conf'}, "StrictCaching", undef, undef, "no");

print $self->config_yesno($self->{'conf'}, "CacheOnFQDN", undef, undef, "yes");

print $self->config_yesno($self->{'conf'}, "CacheAll", undef, undef, "no");

print $self->ui_table_hr();

print $self->config_opt_textbox($self->{'conf'}, "VirusScanner", 40, 3, $self->{'text_hash'}->{'cache_vnone'});

print $self->config_opt_textbox($self->{'conf'}, "VSOK", 4, 3);

print $self->config_opt_textbox($self->{'conf'}, "VSProgressMsgs", 4, 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

