#!/usr/bin/perl
package fsdump::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'fsdump::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the acl module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_edit'}</b></td> <td valign=top>\n";
printf "<input type=radio name=edit value=1 %s> %s\n",
	$_[0]->{'edit'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=edit value=0 %s> %s</td>\n",
	$_[0]->{'edit'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td valign=top><b>$self->{'text_hash'}->{'acl_restore'}</b></td> <td valign=top>\n";
printf "<input type=radio name=restore value=1 %s> %s\n",
	$_[0]->{'restore'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=restore value=0 %s> %s</td> </tr>\n",
	$_[0]->{'restore'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_cmds'}</b></td> <td valign=top>\n";
printf "<input type=radio name=cmds value=1 %s> %s\n",
	$_[0]->{'cmds'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=cmds value=0 %s> %s</td>\n",
	$_[0]->{'cmds'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<td valign=top><b>$self->{'text_hash'}->{'acl_extra'}</b></td> <td valign=top>\n";
printf "<input type=radio name=extra value=1 %s> %s\n",
	$_[0]->{'extra'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=extra value=0 %s> %s</td> </tr>\n",
	$_[0]->{'extra'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_dirs'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=dirs_def value=1 %s> %s\n",
	$_[0]->{'dirs'} eq "*" ? "checked" : "", $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=dirs_def value=0 %s> %s<br>\n",
	$_[0]->{'dirs'} eq "*" ? "" : "checked", $self->{'text_hash'}->{'acl_list'};
print "<textarea name=dirs rows=5 cols=30>",
	$_[0]->{'dirs'} eq "*" ? "" :
	join("\n", split(/\t/, $_[0]->{'dirs'})),"</textarea></td> </tr>\n";


}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'edit'} = $self->{'in_hash'}->{'edit'};
$_[0]->{'restore'} = $self->{'in_hash'}->{'restore'};
$_[0]->{'cmds'} = $self->{'in_hash'}->{'cmds'};
$_[0]->{'extra'} = $self->{'in_hash'}->{'extra'};
$self->{'in_hash'}->{'dirs'} =~ s/\r//g;
$_[0]->{'dirs'} = $self->{'in_hash'}->{'dirs_def'} ? "*" :
			join("\t", split(/\n/, $self->{'in_hash'}->{'dirs'}));
}


1;

