#!/usr/bin/perl

&MAIN();

 sub MAIN {
# restore.cgi
# Restore a backup dump

&ModuleLoader::preload_module('fsdump_class', "fsdump::FsdumpLib");
$self = new fsdump::FsdumpLib:: 'fsdump_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'restore_err'});
$self->{'access_hash'}->{'restore'} || $self->error($self->{'text_hash'}->{'restore_ecannot'});

$self->{'cmd'} = $self->parse_restore($self->{'in_hash'}->{'fs'});

$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'restore_title'}, "");

$self->create_wrappers();

print "<b>",$self->text('restore_now', "<tt>$self->{'cmd'}</tt>"),"</b> <p>\n";
print "<pre>";
$self->{'rv'} = $self->restore_backup($self->{'in_hash'}->{'fs'}, $self->{'cmd'});
print "</pre>\n";
if ($self->{'rv'}) {
	if ($self->{'rv'} =~ /^\d+$/) {
		# Bad exit status
		print "<b>$self->{'text_hash'}->{'restore_failed2'}</b><p>\n";
		}
	else {
		# Some error message
		print "<b>",$self->text('restore_failed', $self->{'rv'}),"</b><p>\n";
		}
	}
elsif (!$self->{'in_hash'}->{'test'}) {
	print "<b>$self->{'text_hash'}->{'restore_complete'}</b><p>\n";
	}
$self->webmin_log("restore", undef, $self->{'in_hash'}->{'mode'} == 0 ? $self->{'in_hash'}->{'file'} :
		      $self->{'in_hash'}->{'huser'} ? "$self->{'in_hash'}->{'huser'}@$self->{'in_hash'}->{'host'}:$self->{'in_hash'}->{'hfile'}" :
				     "$self->{'in_hash'}->{'huser'}:$self->{'in_hash'}->{'hfile'}");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

