#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_global.cgi
# Edit global GRUB options

&ModuleLoader::preload_module('grub_class', "grub::GrubLib");
$self = new grub::GrubLib:: 'grub_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");
$self->{'conf'} = $self->get_menu_config();
$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title'}, "");

print "<form action=save_global.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'global_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'default'} = $self->find_value("default", $self->{'conf'});
@{$self->{'titles_array'}} = $self->find_value("title", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_default'}</b></td>\n";
print "<td><select name=default>\n";
printf "<option value='' %s>%s\n",
	$self->{'default'} eq '' ? 'selected' : '', $self->{'text_hash'}->{'global_first'};
for($i=0; $i<@{$self->{'titles_array'}}; $i++) {
	printf "<option value=%s %s>%s\n",
		$i, $self->{'default'} eq $i ? 'selected' : '', $self->{'titles_array'}->[$i];
	}
print "</select></td>\n";

$self->{'fallback'} = $self->find_value("fallback", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_fallback'}</b></td>\n";
print "<td><select name=fallback>\n";
printf "<option value='' %s>%s\n",
	$self->{'fallback'} eq '' ? 'selected' : '', $self->{'text_hash'}->{'global_first'};
for($i=0; $i<@{$self->{'titles_array'}}; $i++) {
	printf "<option value=%s %s>%s\n",
		$i, $self->{'fallback'} eq $i ? 'selected' : '', $self->{'titles_array'}->[$i];
	}
print "</select></td> </tr>\n";

$self->{'timeout'} = $self->find_value("timeout", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_timeout'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=timeout_def value=1 %s> %s\n",
	$self->{'timeout'} eq '' ? 'checked' : '', $self->{'text_hash'}->{'global_forever'};
printf "<input type=radio name=timeout_def value=0 %s>\n",
	$self->{'timeout'} eq '' ? '' : 'checked';
printf "<input name=timeout size=5 value='%s'> %s</td> </tr>\n",
	$self->{'timeout'}, $self->{'text_hash'}->{'global_secs'};

$self->{'password'} = $self->find("password", $self->{'conf'});
@{$self->{'pv_array'}} = split(/\s+/, $self->{'password'}->{'value'}) if ($self->{'password'});
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'global_password'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=password_def value=1 %s> %s\n",
	$self->{'password'} eq '' ? 'checked' : '', $self->{'text_hash'}->{'global_none'};
printf "<input type=radio name=password_def value=0 %s>\n",
	$self->{'password'} eq '' ? '' : 'checked';
printf "<input name=password size=20 value='%s'><br>\n", $self->{'pv_array'}->[0];
printf "<input type=checkbox name=password_file %s> %s\n",
	$self->{'pv_array'}->[1] ? "checked" : "", $self->{'text_hash'}->{'global_password_file'}; 
printf "<input name=password_filename size=30 value='%s'></td> </tr>\n", $self->{'pv_array'}->[1];

$self->{'r'} = $self->{'config_hash'}->{'install'};
$self->{'dev'} = $self->bios_to_linux($self->{'r'});
$self->{'sel'} = $self->foreign_call("fdisk", "partition_select", "install", $self->{'dev'}, 2, \$self->{'found'});
print "<td><b>$self->{'text_hash'}->{'global_install'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=install_mode value=1 %s> %s %s\n",
	$self->{'found'} ? 'checked' : '', $self->{'text_hash'}->{'global_sel'}, $self->{'sel'};
printf "<input type=radio name=install_mode value=0 %s> %s\n",
	$self->{'found'} ? '' : 'checked', $self->{'text_hash'}->{'global_other'};
printf "<input name=other size=10 value='%s'></td> </tr>\n",
	$self->{'found'} ? '' : $self->{'r'};

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

