#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of directories and their client(s)

$| = 1;
&ModuleLoader::preload_module('hpuxexports_class', "hpuxexports::ExportsLib");
$self = new hpuxexports::ExportsLib:: 'hpuxexports_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);

if (!$self->has_nfs_commands()) {
	print "<p>",$self->{'text_hash'}->{'index_eprog'},"<p>\n";
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	exit;
	}

@{$self->{'exps_array'}} = $self->list_exports();
if (@{$self->{'exps_array'}}) {
	@{$self->{'dirs_array'}} = $self->unique(map { $_->{'dir'} } @{$self->{'exps_array'}});
	if ($self->{'access_hash'}->{'icons'}) {
		# Display icons for exports
		foreach $d (@{$self->{'dirs_array'}}) {
			@{$self->{'cl_array'}} = grep { $_->{'dir'} eq $d } @{$self->{'exps_array'}};
			foreach $c (@{$self->{'cl_array'}}) {
				push(@{$self->{'icons_array'}}, "images/export.gif");
				local $desc = $self->describe_host($c->{'host'});
				if ($c->{'active'}) {
					push(@{$self->{'titles_array'}}, $d.'<br>'.$desc);
					}
				else {
					push(@{$self->{'titles_array'}}, '<font color=#ff0000>'.
					     $d.'<br>'.$desc.'</font>');
					}
				push(@{$self->{'links_array'}},
				     "edit_export.cgi?idx=$c->{'index'}");
				}
			}
		$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
		}
	else {
		# Display table of exports and clients
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_dir'}</b></td> ",
		      "<td><b>$self->{'text_hash'}->{'index_to'}</b></td> </tr>\n";
		foreach $d (@{$self->{'dirs_array'}}) {
			print "<tr $self->{'cb'}> <td valign=top>$d</td>\n";
			print "<td>\n";
			@{$self->{'cl_array'}} = grep { $_->{'dir'} eq $d } @{$self->{'exps_array'}};
			$self->{'ccount'} = 0;
			foreach $c (@{$self->{'cl_array'}}) {
				print "&nbsp;|&nbsp; " if ($self->{'ccount'}++);
				print "<a href=\"edit_export.cgi?idx=$c->{'index'}\">",$self->describe_host($c->{'host'}),"</a>\n";
				print "<font color=#ff0000>($self->{'text_hash'}->{'index_inactive'})","</font>\n" if (!$c->{'active'});
				}
			print "</td> </tr>\n";
			}
		print "</table>\n";
		}
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b> <p>\n";
	}
print "<a href=\"edit_export.cgi?new=1\">$self->{'text_hash'}->{'index_add'}</a> <p>\n";

print "<hr>\n";
print "<table width=100%> <tr>\n";
print "<td><form action=restart_mountd.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\">\n";
print "</form></td>\n";
print "<td valign=top>$self->{'text_hash'}->{'index_applymsg'}</td>\n";
print "</tr> <tr> </table>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

