#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_export.cgi
# Save, create or delete an export

&ModuleLoader::preload_module('hpuxexports_class', "hpuxexports::ExportsLib");
$self = new hpuxexports::ExportsLib:: 'hpuxexports_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'exports_file'});
@{$self->{'exps_array'}} = $self->list_exports();

if ($self->{'in_hash'}->{'delete'}) {
	# Deleting some export
	$self->{'exp'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->delete_export($self->{'exp'});
	}
else {
	if (!$self->{'in_hash'}->{'new'}) {
		# Get old export
		$self->{'oldexp'} = $self->{'exps_array'}->[$self->{'in_hash'}->{'idx'}];
		%{$self->{'opts_hash'}} = %{$self->{'oldexp'}->{'options'}};
		}

	# check dir and active
	$self->error_setup($self->{'text_hash'}->{'save_err'});
	-d $self->{'in_hash'}->{'dir'} || $self->error($self->text('save_edir', $self->{'in_hash'}->{'dir'}));
	$self->{'exp_hash'}->{'dir'} = $self->{'in_hash'}->{'dir'};
	$self->{'exp_hash'}->{'active'} = $self->{'in_hash'}->{'active'};

	# check inputs
	$self->check_inputs();

	# validate and parse options
	$self->set_options();

	$self->{'exp_hash'}->{'options'} = \%{$self->{'opts_hash'}};
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_export(\%{$self->{'exp_hash'}});
		}
	else {
		$self->modify_export(\%{$self->{'exp_hash'}}, $self->{'oldexp'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'exports_file'});
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "export", $self->{'exp'}->{'dir'}, $self->{'exp'});
	}
elsif ($self->{'in_hash'}->{'new'}) {
	$self->webmin_log("create", "export", $self->{'exp_hash'}->{'dir'}, \%{$self->{'exp_hash'}});
	}
else {
	$self->webmin_log("modify", "export", $self->{'exp_hash'}->{'dir'}, \%{$self->{'exp_hash'}});
	}
$self->redirect("");

1;
		
}


1;

