#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_rpc.cgi
# Delete an RPC program

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->ReadParse();

$self->lock_inetd_files();
@{$self->{'rpcs_array'}} = $self->list_rpcs();
@{$self->{'rpc_array'}} = @{$self->{'rpcs_array'}->[$self->{'in_hash'}->{'rpos'}]};
$self->delete_rpc($self->{'rpc_array'}->[0]);
if ($self->{'in_hash'}->{'ipos'} =~ /\d/) {
	@{$self->{'inets_array'}} = $self->list_inets();
	@{$self->{'inet_array'}} = @{$self->{'inets_array'}->[$self->{'in_hash'}->{'ipos'}]};
	$self->delete_inet($self->{'inet_array'}->[0], $self->{'inet_array'}->[10]);
	}
$self->unlock_inetd_files();
$self->webmin_log("delete", "rpc", $self->{'rpc_array'}->[1],
	    { 'name' => $self->{'rpc_array'}->[1], 'number' => $self->{'rpc_array'}->[2],
	      'active' => $self->{'inet_array'}->[1],
	      'user' => $self->{'inet_array'}->[7], 'wait' => $self->{'inet_array'}->[6],
	      'prog' => join(" ", @{$self->{'inet_array'}}[8..@{$self->{'inet_array'}}-1]) } );
$self->redirect("");
1;
		
}


1;

