#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_inet.cgi
# Display a form for editing or creating an internet service

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'editserv_title1'}, "");
	}
else {
	local @servs = $self->list_services();
	local @inets = $self->list_inets();
	$self->ui_print_header(undef, $self->{'text_hash'}->{'editserv_title2'}, "");
	if (defined($self->{'in_hash'}->{'name'})) {
		local $i;
		for($i=0; $i<@servs; $i++) {
			$self->{'in_hash'}->{'spos'} = $i if ($servs[$i]->[1] eq $self->{'in_hash'}->{'name'} &&
					     $servs[$i]->[3] eq $self->{'in_hash'}->{'proto'});
			}
		defined($self->{'in_hash'}->{'spos'}) || $self->error($self->{'text_hash'}->{'editserv_ename'});
		for($i=0; $i<@inets; $i++) {
			$self->{'in_hash'}->{'ipos'} = $i if ($inets[$i]->[3] eq $self->{'in_hash'}->{'name'} &&
					     $inets[$i]->[5] eq $self->{'in_hash'}->{'proto'});
			}
		}
	@{$self->{'serv_array'}} = @{$servs[$self->{'in_hash'}->{'spos'}]};
	if ($self->{'in_hash'}->{'ipos'} =~ /\d/) {
		@{$self->{'inet_array'}} = @{$inets[$self->{'in_hash'}->{'ipos'}]};
		}
	}

print "<form action=\"save_serv.cgi\" method=post>\n";
if (@{$self->{'serv_array'}}) {
	print "<input type=hidden name=spos value=$self->{'in_hash'}->{'spos'}>\n";
	print "<input type=hidden name=ipos value=$self->{'in_hash'}->{'ipos'}>\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'editserv_detail'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editserv_name'}</b></td>\n";
print "<td><input size=20 name=name value=\"$self->{'serv_array'}->[1]\"></td>\n";

print "<td nowrap><b>$self->{'text_hash'}->{'editserv_port'}</b></td>\n";
print "<td nowrap><input size=10 name=port value=\"$self->{'serv_array'}->[2]\"></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'editrpc_protocol'}</b></td>\n";
print "<td valign=top><select name=protocol>\n";
foreach $p ($self->list_protocols()) {
	printf "<option value=$p %s>%s %s\n",
		$self->{'serv_array'}->[3] eq $p || (!@{$self->{'serv_array'}} && $p eq "tcp") ? "selected" : "",
		uc($p), $self->{'prot_name_hash'}->{$p} ? "($self->{'prot_name_hash'}->{$p})" : "";
	}
print "</select></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'editrpc_aliase'}</b></td>\n";
printf "<td valign=top><textarea name=aliases ".
       "rows=3 cols=20>%s</textarea></td> </tr>\n",
	join("\n", split(/\s+/, $self->{'serv_array'}->[4]));

print "</table></td> </tr></table><p>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'editrpc_server'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td colspan=4>\n";
printf "<input type=radio name=act value=0 %s> $self->{'text_hash'}->{'editrpc_noassigned'}\n",
	@{$self->{'inet_array'}} ? "" : "checked";
printf "<input type=radio name=act value=1 %s> $self->{'text_hash'}->{'editrpc_disable'}\n",
	@{$self->{'inet_array'}} && !$self->{'inet_array'}->[1] ? "checked" : "";
printf "<input type=radio name=act value=2 %s> $self->{'text_hash'}->{'editrpc_enable'}\n",
	$self->{'inet_array'}->[1] ? "checked" : "";
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'editserv_program'}</b></td>\n";
print "<td colspan=3>";
if (!$self->{'config_hash'}->{'no_internal'}) {
	printf "<input type=radio name=serv value=1 %s>\n",
		$self->{'inet_array'}->[8] eq "internal" ? "checked" : "";
	print "$self->{'text_hash'}->{'editserv_inetd'}</td> </tr>\n";
	}

$self->{'qm'} = ($self->{'inet_array'}->[8] =~ s/^\?//);
$self->{'tcpd'} = (-x $self->{'config_hash'}->{'tcpd_path'} && $self->{'inet_array'}->[8] eq $self->{'config_hash'}->{'tcpd_path'});
print "<tr> <td></td>\n";
print "<td colspan=3>";
if (!$self->{'config_hash'}->{'no_internal'}) {
	printf "<input type=radio name=serv value=2 %s> $self->{'text_hash'}->{'editrpc_command'}\n",
		$self->{'inet_array'}->[8] ne "internal" && !$self->{'tcpd'} ? "checked" : "";
	printf "<input name=program size=30 value=\"%s\">\n",
		$self->{'inet_array'}->[8] ne "internal" && !$self->{'tcpd'} ? $self->{'inet_array'}->[8] : "";
	print $self->file_chooser_button("program", 0);
	printf "$self->{'text_hash'}->{'editserv_args'} <input name=args size=30 value=\"%s\">\n",
 	       $self->{'inet_array'}->[5] ne "internal" && !$self->{'tcpd'} ? $self->{'inet_array'}->[9] : "";

} else {
	printf "<input type=radio name=serv value=2 %s> $self->{'text_hash'}->{'editrpc_command'}\n",
		!$self->{'tcpd'} ? "checked" : "";
	printf "<input name=program size=30 value=\"%s\">\n",
		!$self->{'tcpd'} ? $self->{'inet_array'}->[8] : "";
	print $self->file_chooser_button("program", 0);
	printf "$self->{'text_hash'}->{'editserv_args'} <input name=args size=30 value=\"%s\">\n",
        	!$self->{'tcpd'} ? $self->{'inet_array'}->[9] : "";
	}
if ($self->{'config_hash'}->{'qm_mode'}) {
	print "<br>","&nbsp;" x 5;
	printf "<input type=checkbox name=qm value=1 %s> %s\n",
		$self->{'qm'} ? "checked" : "", $self->{'text_hash'}->{'editserv_qm'};
	}
print "</td> </tr>\n";

if (-x $self->{'config_hash'}->{'tcpd_path'}) {
	print "<tr> <td></td>\n";
	printf "<td colspan=3><input type=radio name=serv value=3 %s>\n",
		$self->{'tcpd'} ? "checked" : "";
 	print "$self->{'text_hash'}->{'editserv_wrapper'}\n";
	$self->{'inet_array'}->[9] =~ /^(\S+)\s*(.*)$/;
	printf "<input name=tcpd size=15 value=\"%s\">\n", $self->{'tcpd'} ? $1 : "";
	printf "$self->{'text_hash'}->{'editserv_args'} <input name=args2 size=30 value=\"%s\"></td> </tr>\n",
		$self->{'tcpd'} ? $2 : "";
	}

@{$self->{'op1_array'}} = split(/[:\.\/]/, $self->{'inet_array'}->[6]);
@{$self->{'op2_array'}} = split(/[:\.\/]/, $self->{'inet_array'}->[7]);
if ($self->{'inet_array'}->[7] =~ /\// && $self->{'inet_array'}->[7] !~ /:/) {
	# class but no group!
	splice(@{$self->{'op2_array'}}, 1, 0, undef);
	}
print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_waitmode'}</b></td> <td nowrap>\n";
printf "<input type=radio name=wait value=wait %s> $self->{'text_hash'}->{'editrpc_wait'}\n",
	$self->{'op1_array'}->[0] eq "wait" ? "checked" : "";
printf "<input type=radio name=wait value=nowait %s> $self->{'text_hash'}->{'editrpc_nowait'}</td>\n",
	$self->{'op1_array'}->[0] ne "wait" ? "checked" : "";

print "<td nowrap><b>$self->{'text_hash'}->{'editrpc_execasuser'}</b></td>\n";
print "<td nowrap><input name=user size=8 value=\"$self->{'op2_array'}->[0]\"> ",
      $self->user_chooser_button("user", 0),"</td> </tr>\n";

if ($self->{'config_hash'}->{'extended_inetd'} == 1) {
	# Display max per minute and group options
	# This is for systems like Linux
	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_max'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=permin_def value=1 %s> $self->{'text_hash'}->{'editrpc_default'}\n",
		@{$self->{'op1_array'}} < 2 ? "checked" : "";
	printf "&nbsp; <input type=radio name=permin_def value=0 %s>\n",
		@{$self->{'op1_array'}} < 2 ? "" : "checked";
	printf "<input name=permin size=5 value=\"%s\"></td>\n",
		@{$self->{'op1_array'}} < 2 ? "" : $self->{'op1_array'}->[1];

	print "<td nowrap><b>$self->{'text_hash'}->{'editrpc_execasgrp'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=group_def value=1 %s> %s\n",
		$self->{'op2_array'}->[1] ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=group_def value=0 %s>\n",
		$self->{'op2_array'}->[1] ? "checked" : "";
	print $self->unix_group_input("group", $self->{'op2_array'}->[1]),"</td> </tr>\n";
	}
elsif ($self->{'config_hash'}->{'extended_inetd'} == 2) {
	# Display max child, max per minute, group and login class options
	# This is for systems like FreeBSD
	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editrpc_max'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=permin_def value=1 %s> $self->{'text_hash'}->{'editrpc_default'}\n",
		@{$self->{'op1_array'}} < 3 ? "checked" : "";
	printf "&nbsp; <input type=radio name=permin_def value=0 %s>\n",
		@{$self->{'op1_array'}} < 3 ? "" : "checked";
	printf "<input name=permin size=5 value=\"%s\"></td>\n",
		@{$self->{'op1_array'}} < 3 ? "" : $self->{'op1_array'}->[2];

	print "<td nowrap><b>$self->{'text_hash'}->{'editrpc_execasgrp'}</b></td>\n";
	print "<td nowrap><select name=group>\n";
	printf "<option value=\"\" %s> $self->{'text_hash'}->{'editrpc_default'}",
		$self->{'op2_array'}->[1] ? "" : "selected";
	setgrent();
	while(@{$self->{'ginfo_array'}} = getgrent()) {
		printf "<option value=\"$self->{'ginfo_array'}->[0]\" %s>$self->{'ginfo_array'}->[0]\n",
			$self->{'ginfo_array'}->[0] eq $self->{'op2_array'}->[1] ? "selected" : "";
		}
	print "</select></td> </tr>\n";
	endgrent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');

	print "<tr> <td nowrap><b>$self->{'text_hash'}->{'editserv_maxchild'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=child_def value=1 %s> $self->{'text_hash'}->{'editrpc_default'}\n",
		@{$self->{'op1_array'}} < 2 ? "checked" : "";
	printf "&nbsp; <input type=radio name=child_def value=0 %s>\n",
		@{$self->{'op1_array'}} < 2 ? "" : "checked";
	printf "<input name=child size=5 value=\"%s\"></td>\n",
		@{$self->{'op1_array'}} < 2 ? "" : $self->{'op1_array'}->[1];

	print "<td nowrap><b>$self->{'text_hash'}->{'editserv_execlogin'}</b></td>\n";
	print "<td><input name=class size=10 value=\"$self->{'op2_array'}->[2]\"></td> </tr>\n";
	}

print "</table></td></tr></table>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=$self->{'text_hash'}->{'index_save'}></td>\n";
	print "</form><form action=\"delete_serv.cgi\">\n";
	print "<input type=hidden name=spos value=\"$self->{'in_hash'}->{'spos'}\">\n";
	print "<input type=hidden name=ipos value=\"$self->{'in_hash'}->{'ipos'}\">\n";
	print "<td align=right><input type=submit value=$self->{'text_hash'}->{'index_delete'}></td> </tr>\n";
	print "</form></table><p>\n";
	}
else {
	print "<input type=submit value=$self->{'text_hash'}->{'index_create'}></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_list'});
1;
		
}


1;

