#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of known services, built from those handled by inetd and
# from the services file

&ModuleLoader::preload_module('inetd_class', "inetd::InetdLib");
$self = new inetd::InetdLib:: 'inetd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("inetd", "man", "doc", "howto"));

# break down into rpc and internet services
$self->{'j'} = 0;
foreach $i ($self->list_inets()) {
	if ($i->[2]) {
		# rpc service
		$i->[3] =~ /^(\S+)\//;
		if ($i->[1]) { $self->{'rpc_active_hash'}->{$1} = $self->{'j'}; }
		else { $self->{'rpc_disabled_hash'}->{$1} = $self->{'j'}; }
		}
	else {
		# internet service
		if ($i->[1]) { $self->{'int_active_hash'}->{$i->[3],$i->[5]} = $self->{'j'}; }
		else { $self->{'int_disabled_hash'}->{$i->[3],$i->[5]} = $self->{'j'}; }
		}
	$self->{'j'}++;
	}

print "<form action=edit_serv.cgi>\n";
print "<a href=\"edit_serv.cgi?new=1\">$self->{'text_hash'}->{'index_newservice'}</a>.<br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_service'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$i = 0;
@{$self->{'slist_array'}} = $self->list_services();
if ($self->{'config_hash'}->{'sort_mode'} == 1) {
	@{$self->{'slist_array'}} = sort { uc($a->[1]) cmp uc($b->[1]) } @{$self->{'slist_array'}};
	}
elsif ($self->{'config_hash'}->{'sort_mode'} == 2) {
	@{$self->{'slist_array'}} = sort { (defined($self->{'int_active_hash'}->{$b->[1],$b->[3]}) ? 2 :
			 defined($self->{'int_disabled_hash'}->{$b->[1],$b->[3]}) ? 1 : 0) <=>
			(defined($self->{'int_active_hash'}->{$a->[1],$a->[3]}) ? 2 :
			 defined($self->{'int_disabled_hash'}->{$a->[1],$a->[3]}) ? 1 : 0) }
		      @{$self->{'slist_array'}};
	}
foreach $s (@{$self->{'slist_array'}}) {
	$self->{'ia'} = $self->{'int_active_hash'}->{$s->[1],$s->[3]};
	$self->{'id'} = $self->{'int_disabled_hash'}->{$s->[1],$s->[3]};
	if ($self->{'ia'} =~ /\d/) { $self->{'op'} = "<b>"; $self->{'cl'} = "</b>"; $self->{'ip'} = $self->{'ia'}; }
	elsif ($self->{'id'} =~ /\d/) { $self->{'op'} = "<i><b>"; $self->{'cl'} = "</b></i>"; $self->{'ip'} = $self->{'id'}; }
	elsif (!$self->{'config_hash'}->{'show_empty'}) { next; }
	else { $self->{'op'} = $self->{'cl'} = $self->{'ip'} = ""; }
	if ($i%4 == 0) { print "<tr>\n"; }
	print "<td>$self->{'op'}";
	print "<a href=\"edit_serv.cgi?spos=$s->[5]&ipos=$self->{'ip'}\">",
	      $self->html_escape($s->[1]),"</a>(",$self->html_escape($s->[3]),")";
	print "$self->{'cl'}</td>\n";
	if ($i++%4 == 3) { print "</tr>\n"; }
	}
print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td><a href='edit_serv.cgi?new=1'>$self->{'text_hash'}->{'index_newservice'}</a></td>\n";
if (!$self->{'config_hash'}->{'show_empty'}) {
	print "<td align=right>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'index_edit'}'>\n";
	print "<input name=name size=12>\n";
	print "<select name=proto>\n";
	foreach $p ($self->list_protocols()) {
		printf "<option value=%s %s>%s\n",
			$p, $p eq "tcp" ? "selected" : "", $p;
		}
	print "</select></td>\n";
	}
print "</tr></table></form>\n";

print "<hr>\n";
print "<a href=\"edit_rpc.cgi?new=1\">$self->{'text_hash'}->{'index_newrpc'}</a>. <br>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'index_rpc'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$i = 0;
@{$self->{'rlist_array'}} = $self->list_rpcs();
if ($self->{'config_hash'}->{'sort_mode'} == 1) {
	@{$self->{'rlist_array'}} = sort { uc($a->[1]) cmp uc($b->[1]) } @{$self->{'rlist_array'}};
	}
elsif ($self->{'config_hash'}->{'sort_mode'} == 2) {
	@{$self->{'rlist_array'}} = sort { ($self->{'rpc_active_hash'}->{$b->[1]} ? 2 :
			 $self->{'rpc_disabled_hash'}->{$b->[1]} ? 1 : 0) <=>
			($self->{'rpc_active_hash'}->{$a->[1]} ? 2 :
			 $self->{'rpc_disabled_hash'}->{$a->[1]} ? 1 : 0) } @{$self->{'rlist_array'}};
	}
foreach $r (@{$self->{'rlist_array'}}) {
	if ($i%4 == 0) { print "<tr $self->{'cb'}>\n"; }
	$self->{'ra'} = $self->{'rpc_active_hash'}->{$r->[1]};
	$self->{'rd'} = $self->{'rpc_disabled_hash'}->{$r->[1]};
	$self->{'ranum'} = $self->{'rpc_active_hash'}->{$r->[2]};
	$self->{'rdnum'} = $self->{'rpc_disabled_hash'}->{$r->[2]};
	if ($self->{'ra'} =~ /\d/) { $self->{'op'} = "<b>"; $self->{'cl'} = "</b>"; $self->{'rp'} = $self->{'ra'}; }
	elsif ($self->{'ranum'} =~ /\d/) { $self->{'op'} = "<b>"; $self->{'cl'} = "</b>"; $self->{'rp'} = $self->{'ranum'}; }
	elsif ($self->{'rd'} =~ /\d/) { $self->{'op'} = "<i>"; $self->{'cl'} = "</i>"; $self->{'rp'} = $self->{'rd'}; }
	elsif ($self->{'rdnum'} =~ /\d/) { $self->{'op'} = "<i>"; $self->{'cl'} = "</i>"; $self->{'rp'} = $self->{'rdnum'}; }
	else { $self->{'op'} = $self->{'cl'} = $self->{'rp'} = ""; }
	print "<td>$self->{'op'}";
	print "<a href=\"edit_rpc.cgi?rpos=$r->[4]&ipos=$self->{'rp'}\">",
	      $self->html_escape($r->[1]),"</a>$self->{'cl'}</td>\n";
	if ($i++%4 == 3) { print "</tr>\n"; }
	}
print "</table></td></tr></table>\n";
print "<a href=\"edit_rpc.cgi?new=1\">$self->{'text_hash'}->{'index_newrpc'}</a>. <p>\n";

print "<hr>\n";
print "<form action=restart_inetd.cgi>\n";
print "<table width=100%> <tr>\n";
print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_apply'}\"></td>\n";
print "<td valign=top> $self->{'text_hash'}->{'index_applymsg'}</td>\n";
print "</tr> </table> </form>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

