#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a BSD rc script

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	$self->{'rc'} = { 'enabled' => 1 };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	@{$self->{'rcs_array'}} = $self->list_rc_scripts();
	($self->{'rc'}) = grep { $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'rcs_array'}};
	$self->{'rc'} || $self->error($self->{'text_hash'}->{'edit_egone'});
	}

print $self->ui_form_start("save_rc.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'});
print $self->ui_table_start($self->{'text_hash'}->{'edit_details'}, "width=100%", 2);

if ($self->{'in_hash'}->{'new'}) {
	# When creating, show start/stop/status input fields
	print $self->ui_table_row($self->{'text_hash'}->{'edit_name'},
		$self->ui_textbox("name", undef, 20));

	print $self->ui_table_row($self->{'text_hash'}->{'edit_startcmd'},
		$self->ui_textbox("start_cmd", undef, 70));

	print $self->ui_table_row($self->{'text_hash'}->{'edit_stopcmd'},
		$self->ui_textbox("stop_cmd", undef, 70));

	print $self->ui_table_row($self->{'text_hash'}->{'edit_statuscmd'},
		$self->ui_textbox("status_cmd", undef, 70));
	}
else {
	# Just show fill action file contents
	print $self->ui_table_row($self->{'text_hash'}->{'edit_name'}, "<tt>$self->{'in_hash'}->{'name'}</tt>");
	print $self->ui_hidden("name", $self->{'in_hash'}->{'name'});

	$self->{'script'} = $self->read_file_contents($self->{'rc'}->{'file'});
	print $self->ui_table_row($self->{'text_hash'}->{'edit_script'},
		$self->ui_textarea("script", $self->{'script'}, 20, 70));
	}

# Enabled at boot option
if ($self->{'rc'}->{'enabled'} != 2) {
	print $self->ui_table_row($self->{'text_hash'}->{'edit_boot'},
		$self->ui_yesno_radio("enabled", int($self->{'rc'}->{'enabled'})));
	}

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     undef,
			     [ "start", $self->{'text_hash'}->{'edit_startnow'} ],
			     $self->{'rc'}->{'startstop'} ? 
			        ( [ "stop", $self->{'text_hash'}->{'edit_stopnow'} ] ) : ( ),
			     undef,
			     $self->{'rc'}->{'standard'} ?
				( ) : ( [ "delete", $self->{'text_hash'}->{'delete'} ] ) ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

