#!/usr/bin/perl

&MAIN();

 sub MAIN {
# fix_action.cgi
# Convert an action from a run-level file to a proper action in init.d

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error("You are not allowed to edit bootup actions");
$self->{'rl'} = $ARGV[0];
$self->{'ss'} = $ARGV[1];
$self->{'num'} = $ARGV[2];
$self->{'ac'} = $ARGV[3];

$self->{'oldfile'} = $self->runlevel_filename($self->{'rl'}, $self->{'ss'}, $self->{'num'}, $self->{'ac'});
$self->{'newfile'} = $self->action_filename($self->{'ac'});
while(-r $self->{'newfile'}) {
	if ($self->{'ac'} =~ /^(.*)_([0-9]+)$/) { $self->{'ac'} = "$1_".($2+1); }
	else { $self->{'ac'} = $self->{'ac'}."_1"; }
	$self->{'newfile'} = $self->action_filename($self->{'ac'});
	}
`mv $self->{'oldfile'} $self->{'newfile'}`;
$self->add_rl_action($self->{'ac'}, $self->{'rl'}, $self->{'ss'}, $self->{'num'});
$self->redirect("edit_action.cgi?0+$self->{'ac'}");

1;
		
}


1;

