#!/usr/bin/perl

&MAIN();

 sub MAIN {
# modifyhostconfig.cgi
# Rewrites the hostconfig file

# Written by Michael A. Peters <mpeters@mac.com>
# for OSX/Darwin

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error("You are not allowed to edit the bootup script");
$self->ReadParse();

if ( $self->{'in_hash'}->{'choice'} eq "custom" ) {
	$self->{'setting'} = $self->{'in_hash'}->{'custom'};
	}
else {
	$self->{'setting'} = $self->{'in_hash'}->{'choice'};
	}
	
if ( $self->{'setting'} =~ /^\%22(.*)\%22$/ ) {
	$self->{'setting'} = $1;
	}
	
$self->{'setting'} =~ s/\+/ /g;
if ( $self->{'setting'} =~ /[ ]/ ) {
	$self->{'setting'} = "\"$self->{'setting'}\"";
	}

# not all possibile blunders are fixed, but at least intelligently
# made ones...

$self->{'setting'} = "$self->{'in_hash'}->{'action'}=$self->{'setting'}";

$self->{'hostc'} = $self->{'config_hash'}->{'hostconfig'};
# modify and write the hostconfig file
@{$self->{'new_array'}} = ();
$self->lock_file($self->{'config_hash'}->{'hostconfig'});
open(LOCAL, "$self->{'hostc'}");
@{$self->{'old_array'}} = <LOCAL>;
close(LOCAL);
foreach $line (@{$self->{'old_array'}}) {
	$line =~ s/^$self->{'in_hash'}->{'action'}=(.*)$/$self->{'setting'}/;
	push @{$self->{'new_array'}}, $line;
	}

$self->open_tempfile(LOCAL, "> $self->{'config_hash'}->{'hostconfig'}");
$self->print_tempfile(LOCAL, @{$self->{'new_array'}});
$self->close_tempfile(LOCAL);
$self->unlock_file($self->{'config_hash'}->{'hostconfig'});
$self->webmin_log("hostconfig", undef, undef, "\%{$self->{'in_hash'}}");
$self->redirect("");
1;
		
}


1;

