#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_startscript.cgi
# saves modifications to the StartupItems/script/script or
# the StartupItems/script/StartupItems.plist

# Even though it would be MUCH faster to pass the file to be edited
# in the form, forms are filled out by the browser, not the server.
#
# A malicious user could manipulate the form to write to
# any file they darned well please. While a user who has webmin access 
# to the bootup scripts could do a fair amount of damage anyway, I still
# would rather limit the possible files the cgi will write to to the
# actual bootup scripts.

# Written by Michael A. Peters <mpeters@mac.com> for
# webmin init module, based on save_local.cgi of same
# module. Written for Darwin/OS X.

&ModuleLoader::preload_module('init_class', "init::InitLib");
$self = new init::InitLib:: 'init_class',%$self;

&ModuleLoader::preload_module('init_class', "init::HostconfigLib");
$self = new init::HostconfigLib:: 'init_class',%$self;

use File::Basename;
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'bootup'} == 1 || $self->error("You are not allowed to edit the bootup script");
$self->ReadParse();

$self->{'action'}=$self->{'in_hash'}->{'action'};

if ( $self->{'in_hash'}->{'plist'} ne "" ) {
	$self->{'in_hash'}->{'plist'} =~ s/\r//g;
	$self->{'towrite'} = $self->{'in_hash'}->{'plist'};
	%{$self->{'temphash_hash'}} = $self->hostconfig_gather(startscript);
	$self->{'tempfile'} = $self->{'temphash_hash'}->{"$self->{'action'}"};
	$self->{'dir'} = dirname("$self->{'tempfile'}");
	$self->{'file'} = "$self->{'dir'}/$self->{'config_hash'}->{'plist'}";
	$self->{'redirect'} = "edit_hostconfig.cgi?0+$self->{'action'}";
	-e $self->{'file'} || $self->error("$self->{'file'} doesn't seem to exist");
	}
elsif ( $self->{'in_hash'}->{'startup'} ne "" ) {
	$self->{'in_hash'}->{'startup'} =~ s/\r//g;
	$self->{'towrite'} = $self->{'in_hash'}->{'startup'};
	%{$self->{'temphash_hash'}} = $self->hostconfig_gather(startscript);
	$self->{'file'} = $self->{'temphash_hash'}->{"$self->{'action'}"};
	$self->{'redirect'} = "edit_hostconfig.cgi?0+$self->{'action'}";
	-e $self->{'file'} || $self->error("$self->{'file'} doesn't seem to exist");
	}
elsif ( $self->{'in_hash'}->{'hostconfig'} ne "" ) {
	$self->{'in_hash'}->{'hostconfig'} =~ s/\r//g;
	$self->{'towrite'} = $self->{'in_hash'}->{'hostconfig'};
	$self->{'file'} = $self->{'config_hash'}->{'hostconfig'};
	$self->{'redirect'} = "edit_hostconfig.cgi?2";
	}
else {
	$self->error("I do not know what you want me to do");
	}

$self->lock_file($self->{'file'});
$self->open_tempfile(LOCAL, "> $self->{'file'}");
$self->print_tempfile(LOCAL, $self->{'towrite'});
$self->close_tempfile(LOCAL);
$self->unlock_file($self->{'file'});
$self->webmin_log("startup", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("$self->{'redirect'}");
1;
		
}


1;

