#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('inittab_class', "inittab::InittabLib");
$self = new inittab::InittabLib:: 'inittab_class',%$self;

$self->ReadParse();
@{$self->{'inittab_array'}} = $self->parse_inittab();
($self->{'init'}) = grep { $_->{'id'} eq $self->{'in_hash'}->{'oldid'} } @{$self->{'inittab_array'}}
	if ($self->{'in_hash'}->{'oldid'} ne '');

$self->lock_file($self->{'config_hash'}->{ 'inittab_file' });
if ($self->{'in_hash'}->{ 'button' } eq $self->{'text_hash'}->{ 'edit_inittab_del' } ) {
	# Just delete the entry
	$self->delete_inittab($self->{'init'});
	}
else {
	# Validate and store inputs
	$self->error($self->{'text_hash'}->{'save_inittab_noid'}) if(!$self->{'in_hash'}->{'id'});
	if ($self->{'in_hash'}->{'id'} ne $self->{'in_hash'}->{'oldid'}) {
		($self->{'clash'}) = grep { $_->{'id'} eq $self->{'in_hash'}->{'id'} } @{$self->{'inittab_array'}};
		$self->error($self->{'text_hash'}->{'save_inittab_already'}) if ($self->{'clash'});
		}
	$self->{'init'}->{'id'} = $self->{'in_hash'}->{'id'};
	$self->{'init'}->{'comment'} = $self->{'in_hash'}->{'comment'};
	foreach $l ( 0..6, "a", "b", "c" ) {
		push(@{$self->{'levels_array'}}, $l) if ($self->{'in_hash'}->{$l});
		}
	$self->{'init'}->{'levels'} = \@{$self->{'levels_array'}};
	$self->{'init'}->{'action'} = $self->{'in_hash'}->{'action'};
	$self->{'init'}->{'process'} = $self->{'in_hash'}->{'process'};

	if ($self->{'in_hash'}->{'oldid'} ne '') {
		# Update the entry
		$self->modify_inittab($self->{'init'});
		}
	else {
		# Add a new entry
		$self->create_inittab($self->{'init'});
		}
	}
$self->unlock_file($self->{'config_hash'}->{ 'inittab_file' });

if ( $self->{'in_hash'}->{ 'button' } eq $self->{'text_hash'}->{ 'edit_inittab_del' }) {
	$self->webmin_log("delete", "inittab", $self->{'in_hash'}->{ 'oldid' }, \%{$self->{'in_hash'}});
	}
elsif ( $self->{'number'} == -1 ) {
	$self->webmin_log("create", "inittab", $self->{'in_hash'}->{ 'id' }, \%{$self->{'in_hash'}});
	}
else {
	$self->webmin_log("modify", "inittab", $self->{'in_hash'}->{ 'id' }, \%{$self->{'in_hash'}});
	}

$self->redirect("");

1;
		
}


1;

