#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit.cgi
# Show a form for editing or creating a connection

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "", "edit");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "", "edit");
	@{$self->{'conf_array'}} = $self->get_config();
	$self->{'conn'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Connection name
print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
if ($self->{'conn'}->{'value'} eq '%default' || $self->{'in_hash'}->{'new'} == 2) {
	print "<td><i>$self->{'text_hash'}->{'edit_default'}</i></td>\n";
	}
else {
	printf "<td><input name=name size=20 value='%s'></td>\n",
		$self->{'conn'}->{'value'};
	}

# ipsec startup option
$self->{'a'} = $self->{'conn'}->{'values'}->{'auto'};
print "<td><b>$self->{'text_hash'}->{'edit_auto'}</b></td>\n";
print "<td>",$self->ui_select("auto", $self->{'a'},
		[ [ "", $self->{'text_hash'}->{'edit_amode'} ],
		  [ "ignore", $self->{'text_hash'}->{'edit_amodeignore'} ],
		  [ "add", $self->{'text_hash'}->{'edit_amodeadd'} ],
		  [ "start", $self->{'text_hash'}->{'edit_amodestart'} ] ]),"</td> </tr>\n";

# compression option
$self->{'c'} = $self->{'conn'}->{'values'}->{'compress'};
print "<tr> <td><b>$self->{'text_hash'}->{'edit_comp'}</b></td> <td>\n";
print $self->ui_radio("comp", $self->{'c'},
		[ [ "", $self->{'text_hash'}->{'edit_cmode'} ],
		  [ "yes", $self->{'text_hash'}->{'edit_cmodeyes'} ],
		  [ "no", $self->{'text_hash'}->{'edit_cmodeno'} ] ]),"</td>\n";

# connection type option
$self->{'t'} = $self->{'conn'}->{'values'}->{'type'};
print "<td><b>$self->{'text_hash'}->{'edit_type'}</b></td>\n";
print "<td>",$self->ui_select("type", $self->{'t'},
		[ [ "", $self->{'text_hash'}->{'edit_tmode'} ],
		  [ "tunnel", $self->{'text_hash'}->{'edit_tmodetunnel'} ],
		  [ "transport", $self->{'text_hash'}->{'edit_tmodetransport'} ],
		  [ "passthrough", $self->{'text_hash'}->{'edit_tmodepassthrough'} ] ]),
       "</td> </tr>\n";

# authentication type option
$self->{'b'} = $self->{'conn'}->{'values'}->{'authby'};
print "<td><b>$self->{'text_hash'}->{'edit_authby'}</b></td>\n";
print "<td>",$self->ui_select("authby", $self->{'b'},
			[ [ "", $self->{'text_hash'}->{'edit_authbydef'} ],
			  [ "rsasig", $self->{'text_hash'}->{'edit_rsasig'} ],
			  [ "secret", $self->{'text_hash'}->{'edit_secret'} ],
			  [ "rsasig|secret", $self->{'text_hash'}->{'edit_rsasigsecret'} ],
			  [ "never", $self->{'text_hash'}->{'edit_never'} ] ], 0,0, 1),"</td>\n";

# pfs option
$self->{'c'} = $self->{'conn'}->{'values'}->{'pfs'};
print "<td><b>$self->{'text_hash'}->{'edit_pfs'}</b></td> <td>\n";
print $self->ui_radio("pfs", $self->{'c'}, [ [ "yes", $self->{'text_hash'}->{'edit_pmodeyes'} ],
			     [ "no", $self->{'text_hash'}->{'edit_pmodeno'} ],
			     [ "", $self->{'text_hash'}->{'edit_pmode'} ] ]);
print "</td> </tr>\n";

# auth type option
$self->{'a'} = $self->{'conn'}->{'values'}->{'auth'};
print "<tr> <td><b>$self->{'text_hash'}->{'edit_auth'}</b></td>\n";
print "<td>",$self->ui_select("auth", $self->{'a'},
		[ [ "", $self->{'text_hash'}->{'edit_authdef'} ],
		  [ "esp", $self->{'text_hash'}->{'edit_authesp'} ],
		  [ "ah", $self->{'text_hash'}->{'edit_authah'} ] ], 0, 0, 1),
      "</td>\n";

# keying tries option
$self->{'k'} = $self->{'conn'}->{'values'}->{'keyingtries'};
print "<td><b>$self->{'text_hash'}->{'edit_keying'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("keying", $self->{'k'}, 10, $self->{'text_hash'}->{'default'}),
      "</td> </tr>\n";

# esp type option
$self->{'e'} = $self->{'conn'}->{'values'}->{'esp'};
$self->{'eonly'} = ($self->{'e'} =~ s/\!//g ? "!" : "");
print "<tr> <td><b>$self->{'text_hash'}->{'edit_esp'}</b></td>\n";
print "<td>",$self->ui_select("esp", $self->{'e'},
		[ [ "", $self->{'text_hash'}->{'edit_espdef'} ],
		  [ "3des-md5", $self->{'text_hash'}->{'edit_espmd5'} ],
		  [ "3des-sha", $self->{'text_hash'}->{'edit_espsha'} ],
		  [ "aes-128-md5", $self->{'text_hash'}->{'edit_esp128'} ] ], 0, 0, 1),
      "</td>\n";

print "<td><b>$self->{'text_hash'}->{'edit_esponly'}</b></td>\n";
print "<td>",$self->ui_radio("esp_only", $self->{'eonly'},
	[ [ "!", $self->{'text_hash'}->{'yes'} ], [ "", $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

# key lifetime option
$self->{'l'} = $self->{'conn'}->{'values'}->{'keylife'};
$self->{'lu'} = $self->{'l'} =~ s/([^0-9])$// ? $1 : "s";
print "<tr> <td><b>$self->{'text_hash'}->{'edit_keylife'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("keylife", $self->{'l'}, 5, $self->{'text_hash'}->{'default'})," ",
	     $self->ui_select("keylife_units", $self->{'lu'},
			[ [ "s", $self->{'text_hash'}->{'edit_unit_s'} ],
			  [ "m", $self->{'text_hash'}->{'edit_unit_m'} ],
			  [ "h", $self->{'text_hash'}->{'edit_unit_h'} ],
			  [ "d", $self->{'text_hash'}->{'edit_unit_d'} ] ]),"</td>\n";

# keying channel lifetime option
$self->{'l'} = $self->{'conn'}->{'values'}->{'ikelifetime'};
$self->{'lu'} = $self->{'l'} =~ s/([^0-9])$// ? $1 : "s";
print "<td><b>$self->{'text_hash'}->{'edit_ikelifetime'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("ikelifetime", $self->{'l'}, 5, $self->{'text_hash'}->{'default'})," ",
	     $self->ui_select("ikelifetime_units", $self->{'lu'},
			[ [ "s", $self->{'text_hash'}->{'edit_unit_s'} ],
			  [ "m", $self->{'text_hash'}->{'edit_unit_m'} ],
			  [ "h", $self->{'text_hash'}->{'edit_unit_h'} ],
			  [ "d", $self->{'text_hash'}->{'edit_unit_d'} ] ]),"</td>\n";

foreach $d ('left', 'right') {
	print "</table></td></tr></table><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>",$self->{'text_hash'}->{'edit_'.$d},"</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	# left/right
	$self->{'a'} = $self->{'conn'}->{'values'}->{$d};
	$self->{'amode'} = $self->{'a'} eq '%defaultroute' ? 0 :
		 $self->{'a'} eq '%any' ? 1 : 
		 $self->{'a'} eq '%opportunistic' ? 2 : 3;
	if ($self->{'a'} eq '' && $self->{'conn'}->{'value'} eq '%default' || $self->{'in_hash'}->{'new'} == 2) {
		$self->{'amode'} = -1;
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_addr'}</b></td> <td colspan=3>\n";
	foreach $m ($self->{'amode'} == -1 ? (-1 .. 3) : (0 .. 3)) {
		printf "<input type=radio name=${d}_mode value=%s %s>%s\n",
		     $m, $m == $self->{'amode'} ? "checked" : "", $self->{'text_hash'}->{'edit_addr'.$m};
		}
	printf "<input name=$d size=15 value='%s'></td> </tr>\n",
		$self->{'amode'} == 3 ? $self->{'a'} : undef;

	# leftid/rightid
	$self->{'i'} = $self->{'conn'}->{'values'}->{$d."id"};
	$self->{'imode'} = $self->{'i'} =~ /^\@/ ? 2 : $self->{'i'} eq '' ? 0 : 1;
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_id'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=${d}_id_mode value=0 %s> %s\n",
		$self->{'imode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=${d}_id_mode value=1 %s> %s\n",
		$self->{'imode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_id1'};
	printf "<input type=radio name=${d}_id_mode value=2 %s> %s\n",
		$self->{'imode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_id2'};
	printf "<input name=${d}_id size=20 value='%s'>\n",
		$self->{'imode'} == 2 ? substr($self->{'i'}, 1) : $self->{'i'};

	# leftsubnet/rightsubnet
	$self->{'s'} = $self->{'conn'}->{'values'}->{$d.'subnet'};
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_subnet'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=${d}_subnet_def value=1 %s> %s\n",
		$self->{'s'} ? "" : "checked", $self->{'text_hash'}->{'edit_none'};
	printf "<input type=radio name=${d}_subnet_def value=0 %s> %s\n",
		$self->{'s'} ? "checked" : "";
	print "<input name=${d}_subnet size=20 value='$self->{'s'}'></td> </tr>\n";

	# leftrsasigkey/rightrsasigkey
	$self->{'k'} = $self->{'conn'}->{'values'}->{$d.'rsasigkey'};
	if ($self->{'in_hash'}->{'new'} == 1 && $d eq 'left') {
		$self->{'k'} = $self->get_public_key();
		}
	$self->{'kmode'} = $self->{'k'} eq '%dns' ? 1 : $self->{'k'} ? 2 : 0;
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_key'}</b></td> ",
	      "<td colspan=3>\n";
	foreach $m (0 .. 2) {
		printf "<input type=radio name=${d}_key_mode value=%s %s> %s\n",
			$m, $self->{'kmode'} == $m ? "checked" : "", $self->{'text_hash'}->{'edit_key'.$m};
		}
	print "<textarea name=${d}_key rows=4 cols=81 wrap=hard>",
		$self->{'kmode'} == 2 ? join("\n", $self->wrap_lines($self->{'k'}, 80)) : "",
		"</textarea></td> </tr>\n";

	# leftnexthop/rightnexthop
	$self->{'h'} = $self->{'conn'}->{'values'}->{$d.'nexthop'};
	$self->{'hmode'} = $self->{'h'} eq '%direct' ? 1 :
		 $self->{'h'} eq '%defaultroute' ? 3 :
		 $self->{'h'} ? 2 : 0;
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_hop'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=${d}_hop_mode value=0 %s> %s\n",
		$self->{'hmode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=${d}_hop_mode value=1 %s> %s\n",
		$self->{'hmode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_hopdir'};
	printf "<input type=radio name=${d}_hop_mode value=3 %s> %s\n",
		$self->{'hmode'} == 3 ? "checked" : "", $self->{'text_hash'}->{'edit_hoproute'};
	printf "<input type=radio name=${d}_hop_mode value=2 %s> %s\n",
		$self->{'hmode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_hopip'};
	printf "<input name=${d}_hop size=15 value='%s'></td> </tr>\n",
		$self->{'hmode'} == 2 ? $self->{'h'} : undef;

	# leftcert/rightcert
	$self->{'s'} = $self->{'conn'}->{'values'}->{$d.'cert'};
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_cert'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=${d}_cert_def value=1 %s> %s\n",
		$self->{'s'} ? "" : "checked", $self->{'text_hash'}->{'edit_none'};
	printf "<input type=radio name=${d}_cert_def value=0 %s> %s\n",
		$self->{'s'} ? "checked" : "";
	print "<input name=${d}_cert size=40 value='$self->{'s'}'></td> </tr>\n";
	}

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	if ($self->{'conn'}->{'value'} ne '%default') {
		print "<td align=center><input type=submit name=export ",
		      "value='$self->{'text_hash'}->{'edit_export'}'></td>\n";
		}
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

