#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_policy.cgi
# Display entries from a policy file for editing

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'policy_desc_'.$self->{'in_hash'}->{'policy'}} ||
        $self->text('policy_desc', $self->{'in_hash'}->{'policy'}), "");

# Show explanation of this policy
print $self->{'text_hash'}->{'policy_longdesc_'.$self->{'in_hash'}->{'policy'}} ||
      $self->text('policy_longdesc', $self->{'in_hash'}->{'policy'}),"<p>\n";
print "<form action=save_policy.cgi method=post>\n";
print "<input type=hidden name=policy value='$self->{'in_hash'}->{'policy'}'>\n";

@{$self->{'policies_array'}} = $self->read_policy($self->{'in_hash'}->{'policy'});
$self->{'mode'} = !@{$self->{'policies_array'}} ? 0 :
	@{$self->{'policies_array'}} == 1 && $self->{'policies_array'}->[0] eq "0.0.0.0/0" ? 1 : 2;
foreach $m (0 .. 2) {
	printf "<input type=radio name=mode value=%s %s> %s\n",
		$m, $self->{'mode'} == $m ? "checked" : "", $self->{'text_hash'}->{'policy_mode'.$m};
	}
print "<br>\n";

# Show a table of networks
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'policy_net'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'policy_mask'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $p ($self->{'mode'} == 2 ? @{$self->{'policies_array'}} : ( ), "", "") {
	local ($n, $m) = split(/\//, $p);
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=net_$self->{'i'} size=20 value='$n'></td>\n";
	print "<td><input name=mask_$self->{'i'} size=5 value='$m'></td>\n";
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

