#!/usr/bin/perl

&MAIN();

 sub MAIN {
# import.cgi
# Add an imported connection to the config file

&ModuleLoader::preload_module('ipsec_class', "ipsec::IpsecLib");
$self = new ipsec::IpsecLib:: 'ipsec_class',%$self;

$self->ReadParseMime();
$self->error_setup($self->{'text_hash'}->{'import_err'});

# Get the file
if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'import_eupload'});
	$self->{'in_hash'}->{'upload'} =~ s/\r//g;
	@{$self->{'data_array'}} = split(/\n/, $self->{'in_hash'}->{'upload'});
	}
else {
	$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'import_efile'});
	open(FILE, $self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'import_eopen'});
	while(<FILE>) {
		s/\r|\n//g;
		push(@{$self->{'data_array'}}, $_);
		}
	close(FILE);
	}

# Read and validate it
$self->{'temp'} = $self->transname();
open(TEMP, ">$self->{'temp'}");
print TEMP map { "$_\n" } @{$self->{'data_array'}};
close(TEMP);
@{$self->{'iconf_array'}} = $self->get_config($self->{'temp'});
unlink($self->{'temp'});
if (@{$self->{'iconf_array'}} != 1 || $self->{'iconf_array'}->[0]->{'name'} ne 'conn') {
	$self->error($self->{'text_hash'}->{'import_eformat'});
	}
@{$self->{'conf_array'}} = $self->get_config();
foreach $c (@{$self->{'conf_array'}}) {
	if (lc($c->{'value'}) eq lc($self->{'iconf_array'}->[0]->{'value'})) {
		$self->{'clash'} = $c;
		if (!$self->{'in_hash'}->{'over'}) {
			$self->error($self->text('import_eclash',
				     "<tt>$self->{'iconf_array'}->[0]->{'value'}</tt>"));
			}
		}
	}

# Add to the real config file
if ($self->{'clash'}) {
	$self->lock_file($self->{'clash'}->{'file'});
	$self->{'lref'} = $self->read_file_lines($self->{'clash'}->{'file'});
	splice(@{$self->{'lref'}}, $self->{'clash'}->{'line'},
	       $self->{'clash'}->{'eline'} - $self->{'clash'}->{'line'} + 1, @{$self->{'data_array'}});
	}
else {
	$self->lock_file($self->{'config_hash'}->{'file'});
	$self->{'lref'} = $self->read_file_lines($self->{'config_hash'}->{'file'});
	push(@{$self->{'lref'}}, @{$self->{'data_array'}});
	}
$self->flush_file_lines();
$self->unlock_all_files();

# Tell the user
$self->ui_print_header(undef, $self->{'text_hash'}->{'import_title'}, "");

print "<p>",$self->text($self->{'clash'} ? 'import_done2' : 'import_done1',
		  "<tt>$self->{'iconf_array'}->[0]->{'value'}</tt>"),"<p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

# All done
$self->webmin_log("import", "conn", $self->{'iconf_array'}->[0]->{'value'}, $self->{'iconf_array'}->[0]->{'values'});

1;
		
}


1;

