#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_karma.cgi
# Edit karma traffic limitation options

&ModuleLoader::preload_module('jabber_class', "jabber::JabberLib");
$self = new jabber::JabberLib:: 'jabber_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'karma_title'}, "", "karma");

$self->{'conf'} = $self->get_jabber_config();
$self->{'io'} = $self->find("io", $self->{'conf'});
$self->{'karma'} = $self->find("karma", $self->{'io'});

print "<form action=save_karma.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'karma_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'rate'} = $self->find("rate", $self->{'io'});
print "<tr> <td><b>$self->{'text_hash'}->{'karma_rate'}</b></td>\n";
printf "<td><input type=radio name=rate_def value=1 %s> %s\n",
	$self->{'rate'} ? "" : "checked", $self->{'text_hash'}->{'karma_rate_def'};
printf "<input type=radio name=rate_def value=0 %s>\n",
	$self->{'rate'} ? "checked" : "";
print $self->text('karma_rate_sel',
	    "<input name=points size=5 value='$self->{'rate'}->[1]->[0]->{'points'}'>",
	    "<input name=time size=5 value='$self->{'rate'}->[1]->[0]->{'time'}'>"),
	   "</td> </tr>\n";

$self->{'mode'} = $self->{'karma'} ? 3 : -1;
for($self->{'i'}=0; $self->{'i'}<@{$self->{'karma_presets_array'}}; $self->{'i'}++) {
	local $kp = $self->{'karma_presets_array'}->[$self->{'i'}];
	local $different = 0;
	foreach $k (keys %$kp) {
		local $v = $self->find_value($k, $self->{'karma'});
		if ($v != $kp->{$k}) {
			$different++;
			last;
			}
		}
	if (!$different) {
		$self->{'mode'} = $self->{'i'};
		last;
		}
	}

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'karma_mode'}</b></td>\n";
print "<td><select name=mode>\n";
printf "<option value=-1 %s> %s\n",
	$self->{'mode'} == -1 ? "selected" : "", $self->{'text_hash'}->{'karma_none'};
printf "<option value=0 %s> %s\n",
	$self->{'mode'} == 0 ? "selected" : "", $self->{'text_hash'}->{'karma_low'};
printf "<option value=1 %s> %s\n",
	$self->{'mode'} == 1 ? "selected" : "", $self->{'text_hash'}->{'karma_medium'};
printf "<option value=2 %s> %s\n",
	$self->{'mode'} == 2 ? "selected" : "", $self->{'text_hash'}->{'karma_high'};
printf "<option value=3 %s> %s\n",
	$self->{'mode'} == 3 ? "selected" : "", $self->{'text_hash'}->{'karma_sel'};
print "</select><br><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'karma_heartbeat'}</b></td>\n";
printf "<td><input name=heartbeat size=6 value='%s'></td>\n",
	$self->find_value("heartbeat", $self->{'karma'});

print "<td><b>$self->{'text_hash'}->{'karma_init'}</b></td>\n";
printf "<td><input name=init size=6 value='%s'></td> </tr>\n",
	$self->find_value("init", $self->{'karma'});

print "<tr> <td><b>$self->{'text_hash'}->{'karma_max'}</b></td>\n";
printf "<td><input name=max size=6 value='%s'></td>\n",
	$self->find_value("max", $self->{'karma'});

print "<td><b>$self->{'text_hash'}->{'karma_dec'}</b></td>\n";
printf "<td><input name=dec size=6 value='%s'></td> </tr>\n",
	$self->find_value("dec", $self->{'karma'});

$self->{'p'} = $self->find_value("penalty", $self->{'karma'});
print "<tr> <td><b>$self->{'text_hash'}->{'karma_penalty'}</b></td>\n";
printf "<td><input name=penalty size=6 value='%s'></td>\n",
	defined($self->{'p'}) ? $self->{'p'} * -1 : undef;

print "<td><b>$self->{'text_hash'}->{'karma_restore'}</b></td>\n";
printf "<td><input name=restore size=6 value='%s'></td> </tr>\n",
	$self->find_value("restore", $self->{'karma'});

print "</table></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

