#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi

&ModuleLoader::preload_module('krb5_class', "krb5::Krb5Lib");
$self = new krb5::Krb5Lib:: 'krb5_class',%$self;


$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
		 $self->help_search_link("krb5", "man"));

if (!-r $self->{'config_hash'}->{'krb5_conf'}) {
	$self->ui_print_endpage(
		$self->ui_config_link('index_econf',
			[ "<tt>$self->{'config_hash'}->{'krb5_conf'}</tt>", undef ]));
	}

%{$self->{'conf_hash'}} = $self->get_config();

print "<form action=\"save.cgi\">\n";
print "<table border width=100%>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<tr $self->{'tb'}> <td colspan=4><b>$self->{'text_hash'}->{'logging'}</b></td> </tr>\n";

print "<tr $self->{'cb'}> <td>",$self->hlink("<b>$self->{'text_hash'}->{'default_log'}</b>","default_log"),"</td>\n";
print "<td><input name=default_log size=40 value=\"$self->{'conf_hash'}->{'default_log'}\">",
    $self->file_chooser_button("default_log", 1), "</td></tr>\n";

print "<tr $self->{'cb'}> <td>",$self->hlink("<b>$self->{'text_hash'}->{'kdc_log'}</b>","kdc_log"),"</td>\n";
print "<td><input name=kdc_log size=40 value=\"$self->{'conf_hash'}->{'kdc_log'}\">",
    $self->file_chooser_button("kdc_log", 1), "</td></tr>\n";

print "<tr $self->{'cb'}> <td>",$self->hlink("<b>$self->{'text_hash'}->{'admin_log'}</b>","admin_log"),"</td>\n";
print "<td><input name=admin_log size=40 value=\"$self->{'conf_hash'}->{'admin_server_log'}\">",
    $self->file_chooser_button("admin_log", 1), "</td></tr>\n";

print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'libdefaults'}</b></td> </tr>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'default_realm'}</b>","default_realm"),"</td>\n";
print "<td><input name=default_realm size=40 value=\"$self->{'conf_hash'}->{'realm'}\"> </td></tr>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'domain'}</b>","domain"),"</td>\n";
print "<td><input name=domain size=40 value=\"$self->{'conf_hash'}->{'domain'}\"> </td></tr>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'default_domain'}</b>","default_domain"),"</td>\n";
print "<td><input name=default_domain size=40 value=\"$self->{'conf_hash'}->{'default_domain'}\"> </td></tr>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'dns_kdc'}</b>","dns_kdc"),"</td>\n";
printf "<td><input type=radio name=dns_kdc value=1 %s> $self->{'text_hash'}->{'yes'}\n",
    ($self->{'conf_hash'}->{'dns_lookup_kdc'} eq "false") ? "" : "checked";
printf "<input type=radio name=dns_kdc value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
    ($self->{'conf_hash'}->{'dns_lookup_kdc'} eq "false") ? "checked" : "";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'default_kdc'}</b>","default_kdc"),"</td>\n";
print "<td><input name=default_kdc size=40 value=\"$self->{'conf_hash'}->{'kdc'}\"> : ";
print "<input name=default_kdc_port size=5 value=\"$self->{'conf_hash'}->{'kdc_port'}\"> </td></tr>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'default_admin'}</b>","default_admin"),"</td>\n";
print "<td><input name=default_admin size=40 value=\"$self->{'conf_hash'}->{'admin_server'}\"> : ";
print "<input name=default_admin_port size=5 value=\"$self->{'conf_hash'}->{'admin_port'}\"> </td></tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
1;
		
}


1;

