#!/usr/bin/perl

&MAIN();

 sub MAIN {
# start.cgi
# Save config

&ModuleLoader::preload_module('krb5_class', "krb5::Krb5Lib");
$self = new krb5::Krb5Lib:: 'krb5_class',%$self;


$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'save_err', $self->{'config_hash'}->{'krb5_conf'}});

# Write the config file
$self->lock_file($self->{'config_hash'}->{'krb5_conf'});
open(FILE, "> $self->{'config_hash'}->{'krb5_conf'}");
print FILE "[logging]\n";
print FILE "default = FILE:$self->{'in_hash'}->{'default_log'}\n";
print FILE "kdc = FILE:$self->{'in_hash'}->{'kdc_log'}\n";
print FILE "admin_server = FILE:$self->{'in_hash'}->{'admin_log'}\n";
print FILE "\n";
print FILE "[libdefaults]\n";
print FILE "default_realm = $self->{'in_hash'}->{'default_realm'}\n";
if (!$self->{'in_hash'}->{'dns_kdc'}) {
    print FILE "dns_lookup_kdc = false\n";
}
print FILE "\n";
print FILE "[realms]\n";
print FILE "$self->{'in_hash'}->{'default_realm'} = {\n";
print FILE "   default_domain = $self->{'in_hash'}->{'default_domain'}\n";
print FILE "   kdc = $self->{'in_hash'}->{'default_kdc'}:$self->{'in_hash'}->{'default_kdc_port'}\n";
print FILE "   admin_server = $self->{'in_hash'}->{'default_admin'}:$self->{'in_hash'}->{'default_admin_port'}\n";
print FILE "}\n";
print FILE "\n";
print FILE "[domain_realm]\n";
print FILE "$self->{'in_hash'}->{'domain'} = $self->{'in_hash'}->{'default_realm'}\n";
print FILE "\n";
close(FILE);
$self->unlock_file($self->{'config_hash'}->{'krb5_conf'});

$self->redirect("");
1;
		
}


1;

