#include "ctlicense.hpp"
#include <iostream.h>
#define MODULE "http://licences.comodogroup.com/trustix/cpplus"
int main(int argc, char** argv) {
  if (argc < 2) {
    printf("Usage:\n");
    printf("<program> <license directory | license file>\n");
    exit(1);
  }
  printf("Checking license ... ");
  CTLicense::reloadLicenses(argv[1]);
  bool ok = CTLicense::checkModuleLicense(MODULE);
  printf("%s\n", (ok ? "OK" : "FAILED"));
  if (ok) {
    printf("Begin Date: %s", CTLicense::getModuleBeginDateString(MODULE).c_str());
    printf("Expire Date: %s", CTLicense::getModuleExpireDateString(MODULE).c_str());
    printf("Description: %s\n", CTLicense::getModuleLicenseDescription(MODULE).c_str());
// 	 CTLicense::dumpLicense(0);
//     printf("Description: %s", CTLicense::getModuleStringTerm(MODULE, "ProductID").c_str());
//     printf("Servers Number: %d\n", CTLicense::getModuleNumericTerm(MODULE, "Servers"));
  }
  exit(!ok);
}
