#!/usr/bin/perl

&MAIN();

 sub MAIN {
# get_license.cgi
# gets license using activation code
#
# interface for entering activation code and getting a license in the ZTL

&ModuleLoader::preload_module('licmanage_class', "licmanage::LicmanageLib");
$self = new licmanage::LicmanageLib:: 'licmanage_class',%$self;


$self->{'no_comodo_mode'} && $self->error($self->{'text_hash'}->{'getlic_enoztlmode'});

$self->ReadParse();

if ($self->{'debug'}) {
	$self->{'lic'} = $self->get_licinfo();
	print "RET: $self->{'lic'}->{'ret'}<br>";
	print "MSG: $self->{'lic'}->{'msg'}<br>";
	print "BEGIN: $self->{'lic'}->{'d_begin'}<br>";
	print "EXPIRE: $self->{'lic'}->{'d_expire'}<br>";
	print "SYSRET: $self->{'lic'}->{'sys_ret'}<br>";
	print "OUTPUT:<br><pre>$self->{'lic'}->{'output'}</pre><br>";
}

if ($self->{'in_hash'}->{'getlic'} && $self->{'in_hash'}->{'collectionCode'} && $self->{'in_hash'}->{'queryType'}) {
	$self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'getlic_title2'}, '');
	local $rv = $self->license_download($self->{'in_hash'}->{'collectionCode'});
	$self->print_debug("<pre>RESULT\nOK: $rv->{'ok'}\nSTATUS: $rv->{'status'}\nMSG: $rv->{'msg'}\n$rv->{'license'}</pre>");
	$self->error($self->text('err_getting', $rv->{'status'}, $rv->{'msg'})) unless $rv->{'ok'};
	local $fname = $self->{'in_hash'}->{'collectionCode'};
	local $file = "$self->{'lic_directory'}/$fname";
	print $self->{'text_hash'}->{'getlic_log_save'} if $self->{'lic_logging'};
	$self->save_to_file($file, $rv->{'license'}) || $self->error($self->{'text_hash'}->{'err_save'});
	print $self->{'text_hash'}->{'getlic_log_ok'} if $self->{'lic_logging'};
	$self->{'config_hash'}->{'licfile'} = $fname;
	$self->{'lic'} = $self->get_licinfo();
	if ($self->{'lic'}->{'ret'}) {
		print "$self->{'text_hash'}->{'getlic_failed'}<br>";
	}
	else {
		$self->save_module_config();
		print "$self->{'text_hash'}->{'getlic_success'}<br>";
	}
	$self->ui_print_footer("/index.cgi", $self->{'text_hash'}->{'index_mainpage'});
} elsif ($self->{'in_hash'}->{'set_key'}) {
        $self->ui_print_unbuffered_header(undef, $self->{'text_hash'}->{'getlic_title2'}, '');
        $self->print_debug("<pre>NEW KEY\nOK: $self->{'in_hash'}->{'new_key'}<br>");
        $self->{'config_hash'}->{'license_key'} = $self->{'in_hash'}->{'new_key'};
	$self->{'config_hash'}->{'lic_time_check'} = $self->{'config_hash'}->{'lic_time_check'} - $self->{'tconfig_hash'}->{'billing_check_period'} - 10;
        $self->save_module_config();
        $self->{'lic'} = $self->get_licinfo();

        if ($self->{'lic'}->{'ret'}) {
                print "$self->{'text_hash'}->{'getlic_failed'}<br>";
        } else {
                print "$self->{'text_hash'}->{'getlic_success'}<br>";
    		}
        $self->ui_print_footer("/index.cgi", $self->{'text_hash'}->{'index_mainpage'});
} else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'getlic_title'}, '');
	if (!$self->{'no_comodo_mode'} && $self->check_Net_SSLeay()) {
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
		exit;
	}
	print $self->ui_form_start('get_license.cgi', 'post'),
	$self->ui_hidden('queryType', '1');
	print "<table align=center border=1>\n";
	print "<tr><td colspan=3>", $self->text('getlic_desc', $self->{'lic_order_url'}), "</td></tr>\n";
	print "<tr $self->{'tb'}><td colspan=3><b>$self->{'text_hash'}->{'getlic_header'}</b></td></tr>\n";
	print "<tr $self->{'cb'}><td>$self->{'text_hash'}->{'getlic_code'}</td><td align=right>", $self->ui_textbox('collectionCode', $self->{'lic_collectionCode'}, 20), 
	"</td><td align=right>", $self->ui_submit($self->{'text_hash'}->{'getlic_get'}, 'getlic'), "</td></tr>\n";
	print "</table>\n";
	print $self->ui_form_end();
	$self->{'lic'} = $self->get_licinfo();
	if ($self->{'lic'}->{'ret'}) {
		$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}
	else {
		$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, "", $self->{'text_hash'}->{'index_return'});
	}
}
1;
		
}


1;

