#!/usr/bin/perl

$no_acl_check++;
require 'licmanage-lib.pl';

sub module_install {
	local $save_config = 0;
	if (!$config{'checklic'}) {
		$save_config++;
		$config{'checklic'} = 'checklic';
	}
	local $namefile = $config{'checklic'};
# 	if ( -r "$module_root_directory/$namefile") {
# 		$config{'md5sum'} = &get_md5sum("$module_root_directory/$namefile");
# 		$save_config++;
# 	}
	
	local $hsxp_dir = "$config_directory/hsxp";
	local $hsxp_config = "$hsxp_dir/config";
	if (-f "$hsxp_config") {
		local %lic;
		&read_file($hsxp_config,\%lic);
		if (&copy_source_dest("$hsxp_dir/$lic{'lic_name'}", "$lic_directory/$lic{'lic_name'}")) {
			$config{'licfile'} = $lic{'lic_name'};
			&rename_logged($hsxp_config, "$hsxp_config~");
			$save_config++;
		}
	}
	
	# detect valid license when 'licfile' is not defined
	unless ($config{'licfile'}) {
		local $f;
		local $is_found = 0;
		opendir(DIR, $lic_directory);
		while(!$is_found && ($f = readdir(DIR))) {
			local $lic = &get_licinfo("$lic_directory/$f");
			if ($lic->{'ret'} == 0) {
				$config{'licfile'} = $f;
				$save_config++;
				$is_found++;
			}
		}
	}

	&save_module_config() if $save_config;
}

1;
