#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_global.cgi
# Display options that apply to all sections

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");

$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title'}, "");
$self->{'conf'} = $self->get_lilo_conf();

print "<form action=save_global.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'global_desc'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'boot'} = $self->find_value("boot", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_boot'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=bootmode value=0 %s> $self->{'text_hash'}->{'global_root'}\n",
	$self->{'boot'} ? "" : "checked";
printf "<input type=radio name=bootmode value=1 %s>\n",
	$self->{'boot'} ? "checked" : "";
print $self->foreign_call("fdisk", "partition_select", "boot", $self->{'boot'}, 2);
print "</td> </tr>\n";

$self->{'default'} = $self->find_value("default", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_default'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=defaultmode value=0 %s> $self->{'text_hash'}->{'global_first'}\n",
	$self->{'default'} ? "" : "checked";
printf "<input type=radio name=defaultmode value=1 %s>\n",
	$self->{'default'} ? "checked" : "";
print "<select name=default>\n";
@{$self->{'images_array'}} = sort { $a->{'index'} <=> $b->{'index'} }
	       ( $self->find("image", $self->{'conf'}), $self->find("other", $self->{'conf'}) );
foreach $i (@{$self->{'images_array'}}) {
	$self->{'l'} = $self->find_value("label", $i->{'members'});
	if ($self->{'l'}) {
		printf "<option %s>$self->{'l'}\n",
			$self->{'default'} eq $self->{'l'} ? "selected" : "";
		}
	}
print "</select></td> </tr>\n";

$self->{'prompt'} = $self->find("prompt", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_prompt'}</b></td> <td>\n";
printf "<input type=radio name=prompt value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'prompt'} ? "checked" : "";
printf "<input type=radio name=prompt value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'prompt'} ? "" : "checked";

$self->{'timeout'} = $self->find_value("timeout", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_timeout'}</b></td> <td>\n";
printf "<input type=radio name=timeout_def value=1 %s> %s\n",
	$self->{'timeout'} ? "" : "checked", $self->{'text_hash'}->{'global_forever'};
printf "<input type=radio name=timeout_def value=0 %s>\n",
	$self->{'timeout'} ? "checked" : "";
printf "<input name=timeout size=5 value='%s'> $self->{'text_hash'}->{'global_secs'}</td> </tr>\n",
	$self->{'timeout'} ? $self->{'timeout'} / 10.0 : "";

$self->{'lock'} = $self->find("lock", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_lock'}</b></td> <td>\n";
printf "<input type=radio name=lock value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'lock'} ? "checked" : "";
printf "<input type=radio name=lock value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'lock'} ? "" : "checked";

$self->{'delay'} = $self->find_value("delay", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_delay'}</b></td> <td>\n";
printf "<input type=radio name=delay_def value=1 %s> $self->{'text_hash'}->{'global_imm'}\n",
	$self->{'delay'} ? "" : "checked";
printf "<input type=radio name=delay_def value=0 %s>\n",
	$self->{'delay'} ? "checked" : "";
printf "<input name=delay size=5 value='%s'> $self->{'text_hash'}->{'global_secs'}</td> </tr>\n",
	$self->{'delay'} ? $self->{'delay'} / 10.0 : "";

$self->{'compact'} = $self->find("compact", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_compact'}</b></td> <td>\n";
printf "<input type=radio name=compact value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'compact'} ? "checked" : "";
printf "<input type=radio name=compact value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->{'compact'} ? "" : "checked";

$self->{'optional'} = $self->find("optional", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_optional'}</b></td> <td>\n";
printf "<input type=radio name=optional value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'optional'} ? "checked" : "";
printf "<input type=radio name=optional value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->{'optional'} ? "" : "checked";

$self->{'password'} = $self->find_value("password", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_password'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=passmode value=0 %s> $self->{'text_hash'}->{'global_none'}\n",
	$self->{'password'} ? "" : "checked";
printf "<input type=radio name=passmode value=1 %s>\n",
	$self->{'password'} ? "checked" : "";
print "<input name=password size=25 value=\"$self->{'password'}\"></td> </tr>\n";

$self->{'restricted'} = $self->find("restricted", $self->{'conf'});
printf "<tr> <td><b>$self->{'text_hash'}->{'global_restricted'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=restricted value=1 %s> %s\n",
	$self->{'restricted'} ? "checked" : "", $self->{'text_hash'}->{'global_extra'};
printf "<input type=radio name=restricted value=0 %s> %s</td> </tr>\n",
	$self->{'restricted'} ? "" : "checked", $self->{'text_hash'}->{'global_any'};

if ($self->{'lilo_version'} >= 21.3) {
	$self->{'lba'} = $self->find("lba32", $self->{'conf'});
	print "<tr> <td><b>$self->{'text_hash'}->{'global_lba'}</b></td> <td>\n";
	printf "<input type=radio name=lba value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$self->{'lba'} ? "checked" : "";
	printf "<input type=radio name=lba value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
		$self->{'lba'} ? "" : "checked";
	}

print "</table></td></tr></table><br>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

