#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_other.cgi
# Edit or create a boot partition

&ModuleLoader::preload_module('lilo_class', "lilo::LiloLib");
$self = new lilo::LiloLib:: 'lilo_class',%$self;

$self->foreign_require("fdisk", "fdisk-lib.pl");

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'other_title1'}, "");
	$self->{'members'} = [ ];
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'other_title2'}, "");
	$self->{'conf'} = $self->get_lilo_conf();
	$self->{'other'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'members'} = $self->{'other'}->{'members'};
	}

print "<form action=save_other.cgi>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'other_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'other_name'}</b></td>\n";
printf "<td valign=top><input name=label size=15 value='%s'></td>\n",
	$self->find_value("label", $self->{'members'});

print "<td><b>$self->{'text_hash'}->{'other_part'}</b></td> <td>\n";
print $self->foreign_call("fdisk", "partition_select", "other", $self->{'other'}->{'value'}, 0);
print "</td> </tr>\n";

$self->{'table'} = $self->find_value("table", $self->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'other_pass'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=tablemode value=0 %s> $self->{'text_hash'}->{'no'}\n",
	$self->{'table'} ? "" : "checked";
printf "<input type=radio name=tablemode value=1 %s> $self->{'text_hash'}->{'other_yes'}\n",
	$self->{'table'} ? "checked" : "";
print $self->foreign_call("fdisk", "partition_select", "table", $self->{'table'}, 1);
print "</td> </tr>\n";

$self->{'password'} = $self->find_value("password", $self->{'members'});
print "<tr> <td><b>$self->{'text_hash'}->{'other_password'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=passmode value=0 %s> $self->{'text_hash'}->{'other_none'}\n",
	$self->{'password'} ? "" : "checked";
printf "<input type=radio name=passmode value=1 %s>\n",
	$self->{'password'} ? "checked" : "";
print "<input name=password size=25 value=\"$self->{'password'}\"></td> </tr>\n";

print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td align=left><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<td align=right>",
	      "<input type=submit name=delete value=\"$self->{'text_hash'}->{'delete'}\"></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

