#!/usr/bin/perl
package logrotate::Install_check;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'logrotate::Install_check');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: ref($self), %$self; 

1;
		return $self;
}

# is_installed(mode)
# For mode 1, returns 2 if Logrotate is installed, or 0 otherwise.
# For mode 0, returns 1 if installed, 0 if not.
sub is_installed
{
	my $self = shift;

return 0 if (!-r $self->{'config_hash'}->{'logrotate_conf'} && !-r $self->{'config_hash'}->{'sample_conf'});
return 0 if (!$self->has_command($self->{'config_hash'}->{'logrotate'}));
return $_[0] ? 2 : 1;
}


1;

