#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of logrotate sections

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;

$self->ReadParse();

# Validate inputs
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Delete the sections
$self->{'parent'} = $self->get_config_parent();
$self->{'conf'} = $self->{'parent'}->{'members'};
foreach $d (@d) {
	$self->{'log'} = $self->{'conf'}->[$d];
	$self->lock_file($self->{'log'}->{'file'});
	$self->save_directive($self->{'parent'}, $self->{'log'}, undef);
	push(@{$self->{'files_array'}}, $self->{'log'}->{'file'});
	}
$self->flush_file_lines();

# Write out config
foreach $f ($self->unique(@{$self->{'files_array'}})) {
	$self->delete_if_empty($f);
	$self->unlock_file($f);
	}

$self->webmin_log("delete", "logs", scalar(@d));
$self->redirect("");

1;
		
}


1;

