#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sched.cgi
# Create, update or delete the rotation cron job

&ModuleLoader::preload_module('logrotate_class', "logrotate::LogrotateLib");
$self = new logrotate::LogrotateLib:: 'logrotate_class',%$self;

$self->ReadParse();

$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
if ($self->{'in_hash'}->{'idx'} ne "") {
	$self->{'oldjob'} = $self->{'job'} = $self->{'jobs_array'}->[$self->{'in_hash'}->{'idx'}];
	}
else {
	$self->{'job'} = { 'user' => 'root',
		 'command' => $self->has_command($self->{'config_hash'}->{'logrotate'})." ".
			      $self->{'config_hash'}->{'logrotate_conf'},
		 'active' => 1 };
	}
$self->lock_file($main::cron_object->cron_file($self->{'job'}));

$self->error_setup($self->{'text_hash'}->{'sched_err'});
$main::cron_object->parse_times_input($self->{'job'}, \%{$self->{'in_hash'}}) if ($self->{'in_hash'}->{'sched'});

if ($self->{'oldjob'} && $self->{'in_hash'}->{'sched'}) {
	# Just update
	$main::cron_object->change_cron_job($self->{'job'});
	$self->{'action'} = "modify";
	}
elsif ($self->{'oldjob'} && !$self->{'in_hash'}->{'sched'}) {
	# Delete
	$main::cron_object->delete_cron_job($self->{'job'});
	$self->{'action'} = "delete";
	}
elsif (!$self->{'oldjob'} && $self->{'in_hash'}->{'sched'}) {
	# Create new
	$main::cron_object->create_cron_job($self->{'job'});
	$self->{'action'} = "create";
	}

$self->unlock_file($main::cron_object->cron_file($self->{'job'}));
$self->webmin_log($self->{'action'}, "sched");

$self->redirect("");

1;
		
}


1;

