#!/usr/bin/perl
package lpadmin::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the lpadmin module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_printers'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input name=printers_def type=radio value=1 %s> %s\n",
	$_[0]->{'printers'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_pall'};
printf "<input name=printers_def type=radio value=0 %s> %s<br>\n",
	$_[0]->{'printers'} eq '*' ? '' : 'checked', $self->{'text_hash'}->{'acl_psel'};
print "<select name=printers multiple size=4 width=15>\n";
local @plist = $self->list_printers();
local ($p, %pcan);
map { $pcan{$_}++ } split(/\s+/, $_[0]->{'printers'});
foreach $p (@plist) {
	local $prn = $self->get_printer($p);
	printf "<option value=%s %s>%s (%s)\n",
		$p, $pcan{$p} ? 'selected' : '',
		$prn->{'desc'}, $p;
	}
print "</select></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_cancel'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=cancel value=0 %s> $self->{'text_hash'}->{'no'}\n",
	$_[0]->{'cancel'} == 0 ? "checked" : "";
printf "<input type=radio name=cancel value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'cancel'} == 1 ? "checked" : "";
printf "<input type=radio name=cancel value=2 %s> $self->{'text_hash'}->{'acl_listed'}<br>\n",
	$_[0]->{'cancel'} == 2 ? "checked" : "";
print "<select name=jobs multiple size=4 width=15>\n";
map { $self->{'jcan_hash'}->{$_}++ } split(/\s+/, $_[0]->{'jobs'});
foreach $p (@plist) {
	local $prn = $self->get_printer($p);
	printf "<option value=%s %s>%s (%s)\n",
		$p, $self->{'jcan_hash'}->{$p} ? 'selected' : '',
		$prn->{'desc'}, $p;
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_user'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$_[0]->{'user'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'acl_user_all'};
printf "<input type=radio name=user_def value=2 %s> %s\n",
	$_[0]->{'user'} ? '' : 'checked', $self->{'text_hash'}->{'acl_user_this'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$_[0]->{'user'} eq '*' || !$_[0]->{'user'} ? '' : 'checked';
printf "<input name=user size=13 value='%s'></td> </tr>\n",
	$_[0]->{'user'} eq '*' || !$_[0]->{'user'} ? '' : $_[0]->{'user'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_add'}</b></td>\n";
printf "<td><input type=radio name=add value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'add'} ? "checked" : "";
printf "<input type=radio name=add value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'add'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_stop'}</b></td>\n";
printf "<td><input type=radio name=stop value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'stop'} == 1 ? "checked" : "";
printf "<input type=radio name=stop value=2 %s> $self->{'text_hash'}->{'acl_restart'}\n",
	$_[0]->{'stop'} == 2 ? "checked" : "";
printf "<input type=radio name=stop value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'stop'} == 0 ? "checked" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_view'}</b></td>\n";
printf "<td><input type=radio name=view value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'view'} ? "checked" : "";
printf "<input type=radio name=view value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'view'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_test'}</b></td>\n";
printf "<td><input type=radio name=test value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'test'} ? "checked" : "";
printf "<input type=radio name=test value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'test'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_delete'}</b></td>\n";
printf "<td><input type=radio name=delete value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'delete'} ? "checked" : "";
printf "<input type=radio name=delete value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'delete'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_cluster'}</b></td>\n";
printf "<td><input type=radio name=cluster value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'cluster'} ? "checked" : "";
printf "<input type=radio name=cluster value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'cluster'} ? "" : "checked";

print "</tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the lpadmin module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'printers_def'}) {
	$_[0]->{'printers'} = '*';
	}
else {
	$_[0]->{'printers'} = join(" ", split(/\0/, $self->{'in_hash'}->{'printers'}));
	}
$_[0]->{'cancel'} = $self->{'in_hash'}->{'cancel'};
$_[0]->{'jobs'} = $self->{'in_hash'}->{'cancel'} == 2 ? join(" ", split(/\0/, $self->{'in_hash'}->{'jobs'})) : "";
$_[0]->{'add'} = $self->{'in_hash'}->{'add'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'view'} = $self->{'in_hash'}->{'view'};
$_[0]->{'user'} = $self->{'in_hash'}->{'user_def'} == 1 ? '*' :
		  $self->{'in_hash'}->{'user_def'} == 2 ? undef : $self->{'in_hash'}->{'user'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'test'} = $self->{'in_hash'}->{'test'};
$_[0]->{'cluster'} = $self->{'in_hash'}->{'cluster'};
}


1;

