#!/usr/bin/perl
package lpadmin::Webmindriver;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'lpadmin::Webmindriver');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# webmin-driver.pl
# Functions for webmin print and smb drivers.
# These are all just calls to the standard driver functions.

$self->{'webmin_windows_driver'} = 1;
$self->{'webmin_print_driver'} = 1;

1;

1;
		return $self;
}

# is_windows_driver(path)
# Returns a driver structure if some path is a windows driver
sub is_windows_driver
{
	my $self = shift;

return $self->is_webmin_windows_driver(@_);
}

# is_driver(path)
# Returns a structure containing the details of a driver
sub is_driver
{
	my $self = shift;

return $self->is_webmin_driver(@_);
}

# create_windows_driver(&printer, &driver)
# Creates a new windows printer driver
sub create_windows_driver
{
	my $self = shift;

return $self->create_webmin_windows_driver(@_);
}

# create_driver(&printer, &driver)
# Creates a new local printer driver and returns the path
sub create_driver
{
	my $self = shift;

return $self->create_webmin_driver(@_);
}

# delete_driver(name)
sub delete_driver
{
	my $self = shift;

$self->delete_webmin_driver(@_);
}

# driver_input(&printer, &driver)
sub driver_input
{
	my $self = shift;

return $self->webmin_driver_input(@_);
}

# parse_driver()
# Parse driver selection from %in and return a driver structure
sub parse_driver
{
	my $self = shift;

return $self->parse_webmin_driver(@_);
}


1;

