#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show hosts in printer cluster

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->{'access_hash'}->{'cluster'} || $self->error($self->{'text_hash'}->{'cluster_ecannot'});
$self->foreign_require("servers", "servers-lib.pl");
$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'cluster_title'}, undef, "cluster");

# Show existing servers
@{$self->{'servers_array'}} = $self->list_cluster_servers();
if (@{$self->{'servers_array'}}) {
	print "<form action=cluster_delete.cgi>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td width=10><br></td> ",
	      "<td><b>$self->{'text_hash'}->{'cluster_host'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'cluster_desc'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'cluster_os'}</b></td> </tr>\n";
	foreach $s (@{$self->{'servers_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td width=10><input type=checkbox name=d value=$s->{'id'}></td>\n";
		print "<td>",$s->{'host'},"</td>\n";
		print "<td>",$s->{'desc'} || "<br>","</td>\n";
		foreach $t (@{$main::servers_object->{'server_types_array'}}) {
			if ($t->[0] eq $s->{'type'}) {
				print "<td>$t->[1]</td>\n";
				}
			}
		print "</tr>\n";
		}
	print "</table>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'cluster_delete'}'></form>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'cluster_none'}</b><p>\n";
	}

# Show buttons to add
print "<form action=cluster_add.cgi>\n";
print "<table width=100%><tr>\n";
@{$self->{'allservers_array'}} = grep { $_->{'user'} } $main::servers_object->list_servers();
%{$self->{'gothost_hash'}} = map { $_->{'id'}, 1 } @{$self->{'servers_array'}};
@{$self->{'addservers_array'}} = grep { !$self->{'gothost_hash'}->{$_->{'id'}} } @{$self->{'allservers_array'}};
if (@{$self->{'addservers_array'}}) {
	print "<td><input type=submit name=add value='$self->{'text_hash'}->{'cluster_add'}'>\n";
	print "<select name=server>\n";
	foreach $s (@{$self->{'addservers_array'}}) {
		print "<option value=$s->{'id'}>",
			$s->{'desc'} ? $s->{'desc'} : $s->{'host'},"\n";
		}
	print "</select></td>\n";
	}
@{$self->{'groups_array'}} = $main::servers_object->list_all_groups(\@{$self->{'allservers_array'}});
if (@{$self->{'groups_array'}}) {
	print "<td align=right><input type=submit name=gadd ",
	      "value='$self->{'text_hash'}->{'cluster_gadd'}'>\n";
	print "<select name=group>\n";
	foreach $g (@{$self->{'groups_array'}}) {
		print "<option>$g->{'name'}\n";
		}
	print "</select></td>\n";
	}
print "</tr></table></form>\n";
if (!@{$self->{'allservers_array'}}) {
	print "<b>$self->{'text_hash'}->{'cluster_need'}</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

