#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of printers at once

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Delete the printers, locally, from ACLs and from the cluster
foreach $d (@d) {
	$self->{'access_hash'}->{'delete'} && $self->can_edit_printer($d) ||
		$self->error($self->{'text_hash'}->{'save_eedit'});
	$self->{'prn'} = $self->get_printer($d);
	$self->{'info'} = $self->log_info($self->{'prn'});
	$self->delete_printer_and_driver($self->{'prn'});
	$self->delete_from_acls($d);

	# delete from cluster
	@{$self->{'slaveerrs_array'}} = $self->delete_on_cluster($self->{'prn'});
	if (@{$self->{'slaveerrs_array'}}) {
		$self->error($self->text('save_errdelslave',
		     "<p>".join("<br>", map { "$_->[0]->{'host'} : $_->[1]" }
					    @{$self->{'slaveerrs_array'}})));
		}
	}
$self->system_logged("$self->{'config_hash'}->{'apply_cmd'} >/dev/null 2>&1 </dev/null")
	if ($self->{'config_hash'}->{'apply_cmd'});
$self->webmin_log("delete", "printers", scalar(@d));

$self->redirect("");

1;
		
}


1;

