#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_printer.cgi
# Edit or create a printer

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->ReadParse();

if ($self->{'in_hash'}->{'new'}) {
	$self->{'access_hash'}->{'add'} || $self->error($self->{'text_hash'}->{'edit_eadd'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_add'}, "");
	$self->{'prn_hash'}->{'accepting'}++;
	$self->{'prn_hash'}->{'enabled'}++;
	$self->{'prn_hash'}->{'allow_all'}++;
	$self->{'prn_hash'}->{'dev'} = $self->{'device_files_array'}->[0];
	$self->{'prn_hash'}->{'ctype'} = [ "postscript" ];
	}
else {
	$self->can_edit_printer($self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_eedit'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_edit'}, "");
	local $prn = $self->get_printer($self->{'in_hash'}->{'name'});
	$prn || $self->error($self->text('save_egone', $self->{'in_hash'}->{'name'}));
	%{$self->{'prn_hash'}} = %$prn;
	}

print "<form action=save_printer.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_conf'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_name'}</b></td>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input name=name size=15></td>\n";
	print "<input type=hidden name=new value=1>\n";
	}
else {
	print "<td>$self->{'prn_hash'}->{'name'}</td>\n";
	print "<input type=hidden name=name value=\"$self->{'prn_hash'}->{'name'}\">\n";
	}

print "<td align=right><b>$self->{'text_hash'}->{'edit_acc'}</b></td>\n";
printf "<td><input type=radio name=accepting value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'prn_hash'}->{'accepting'} ? "checked" : "";
if ($self->printer_support('why')) {
	printf "<input type=radio name=accepting value=0 %s> %s\n",
		$self->{'prn_hash'}->{'accepting'} ? "" : "checked", $self->{'text_hash'}->{'edit_why'};
	printf "<input name=accepting_why size=15 value=\"%s\"></td> </tr>\n",
		$self->{'prn_hash'}->{'accepting_why'};
	}
else {
	printf "<input type=radio name=accepting value=0 %s> $self->{'text_hash'}->{'no'}\n",
		$self->{'prn_hash'}->{'accepting'} ? "" : "checked";
	}

if ($self->printer_support('desc')) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_desc'}</b></td>\n";
	print "<td><input name=desc size=20 value=\"",
		$self->html_escape($self->{'prn_hash'}->{'desc'}),"\"></td>\n";
	}
else { print "<tr> <td colspan=2></td>\n"; }

print "<td align=right><b>$self->{'text_hash'}->{'edit_ena'}</b></td>\n";
printf "<td><input type=radio name=enabled value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$self->{'prn_hash'}->{'enabled'} ? "checked" : "";
if ($self->printer_support('why')) {
	printf "<input type=radio name=enabled value=0 %s> %s\n",
		$self->{'prn_hash'}->{'enabled'} ? "" : "checked", $self->{'text_hash'}->{'edit_why'};
	printf "<input name=enabled_why size=15 value=\"%s\"></td> </tr>\n",
		$self->{'prn_hash'}->{'enabled_why'};
	}
else {
	printf "<input type=radio name=enabled value=0 %s> $self->{'text_hash'}->{'no'}\n",
		$self->{'prn_hash'}->{'enabled'} ? "" : "checked";
	}

if ($self->printer_support('allow')) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_acl'}</b></td>\n";
	print "<td colspan=3><table><tr><td valign=top>\n";
	printf "<input type=radio name=access value=0 %s> %s<br>\n",
		$self->{'prn_hash'}->{'allow_all'} ? "checked" : "", $self->{'text_hash'}->{'edit_allow'};
	printf "<input type=radio name=access value=1 %s> %s<br>\n",
		$self->{'prn_hash'}->{'deny_all'} ? "checked" : "", $self->{'text_hash'}->{'edit_deny'};
	printf "<input type=radio name=access value=2 %s> %s<br>\n",
		$self->{'prn_hash'}->{'allow'} ? "checked" : "", $self->{'text_hash'}->{'edit_allowu'};
	printf "<input type=radio name=access value=3 %s> %s\n",
		$self->{'prn_hash'}->{'deny'} ? "checked" : "", $self->{'text_hash'}->{'edit_denyu'};
	print "</td> <td valign=top>\n";
	print "<textarea wrap=auto name=users rows=5 cols=30>",
	      join(" ", (@{$self->{'prn_hash'}->{'allow'}}, @{$self->{'prn_hash'}->{'deny'}})),
	      "</textarea></td>\n";
	print "<td valign=top>",$self->user_chooser_button("users",1),"</td>\n";
	print "</tr></table></td> </tr>\n";
	}

if ($self->printer_support('banner')) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_banner'}</b></td> ",
	      "<td valign=top>\n";
	printf "<input type=radio name=prbanner value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$self->{'prn_hash'}->{'banner'} ? "checked" : "";
	printf "<input type=radio name=prbanner value=0 %s> %s</td>\n",
		$self->{'prn_hash'}->{'banner'} ? "" : "checked", $self->{'text_hash'}->{'edit_opt'};
	}
else { print "<tr>\n"; }

if ($self->printer_support('default')) {
	print "<td align=right><b>$self->{'text_hash'}->{'edit_default'}</b></td> <td>\n";
	if (!$self->{'prn_hash'}->{'default'}) {
		printf "<input type=radio name=default value=1 %s> $self->{'text_hash'}->{'yes'}\n", $self->{'prn_hash'}->{'default'} ? "checked" : "";
		printf "<input type=radio name=default value=0 %s> $self->{'text_hash'}->{'no'}</td></tr>\n", $self->{'prn_hash'}->{'default'} ? "" : "checked";
		}
	else {
		print "<i>$self->{'text_hash'}->{'edit_already'}</i> </td> </tr>\n";
		}
	}
elsif ($self->printer_support('msize')) {
	print "<td align=right><b>$self->{'text_hash'}->{'edit_max'}</b></td> <td>\n";
	printf "<input type=radio name=msize_def value=1 %s> %s\n",
		defined($self->{'prn_hash'}->{'msize'}) ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=msize_def value=2 %s> %s\n",
		$self->{'prn_hash'}->{'msize'} eq '0' ? "checked" : "", $self->{'text_hash'}->{'edit_unlimited'};
	printf "<input type=radio name=msize_def value=0 %s>\n",
		$self->{'prn_hash'}->{'msize'} ? "checked" : "";
	printf "<input name=msize size=6 value=\"%s\"> %s</td> </tr>\n",
		$self->{'prn_hash'}->{'msize'} ? $self->{'prn_hash'}->{'msize'} : "", $self->{'text_hash'}->{'blocks'};
	}
else { print "<td colspan=2></tr>\n"; }

if ($self->printer_support('ctype')) {
	@{$self->{'ctype_array'}} = @{$self->{'prn_hash'}->{'ctype'}};
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_dacc'}</b></td> <td colspan=3>\n";
	printf "<input type=checkbox name=ctype_simple %s> %s &nbsp;\n",
		$self->indexof("simple", @{$self->{'ctype_array'}}) < 0 ? "" : "checked",
		$self->{'text_hash'}->{'edit_dtext'};
	printf "<input type=checkbox name=ctype_postscript %s> %s &nbsp;\n",
		$self->indexof("postscript", @{$self->{'ctype_array'}}) < 0 ? "" : "checked",
		$self->{'text_hash'}->{'edit_dpost'};
	@{$self->{'ctypeo_array'}} = grep { !/^(simple|postscript)$/ } @{$self->{'ctype_array'}};
	printf "<input type=checkbox name=ctype_other %s> %s\n",
		@{$self->{'ctypeo_array'}} ? "checked" : "", $self->{'text_hash'}->{'edit_dother'};
	printf "<input name=ctype_olist size=20 value=\"%s\">\n",
		join(' ', @{$self->{'ctypeo_array'}});
	print "</td> </tr>\n";
	}

if ($self->printer_support('alias')) {
	@{$self->{'alias_array'}} = @{$self->{'prn_hash'}->{'alias'}};
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_alt'}</b></td> <td colspan=3>\n";
	printf "<input name=alias size=40 value=\"%s\"></td> </tr>\n",
		join(' ', @{$self->{'alias_array'}});
	}

print "</table></td></tr></table><p>\n";

if ($self->{'in_hash'}->{'new'} || $self->printer_support('editdest')) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_dest'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table>\n";

	$self->{'isdev'} = $self->indexof($self->{'prn_hash'}->{'dev'}, @{$self->{'device_files_array'}}) >= 0;
	if (!$self->{'webmin_windows_driver'}) {
		$self->{'wdrv'} = $self->is_webmin_windows_driver($self->{'prn_hash'}->{'iface'}, \%{$self->{'prn_hash'}});
		$self->{'webmin'}++ if ($self->{'wdrv'});
		}
	$self->{'wdrv'} = $self->is_windows_driver($self->{'prn_hash'}->{'iface'}, \%{$self->{'prn_hash'}}) if (!$self->{'wdrv'});
	$self->{'hdrv'} = $self->is_hpnp_driver($self->{'prn_hash'}->{'iface'}, \%{$self->{'prn_hash'}});
	if ($self->{'wdrv'}) { $self->{'prn_hash'}->{'iface'} = $self->{'wdrv'}->{'program'}; }
	elsif ($self->{'hdrv'}) { $self->{'prn_hash'}->{'iface'} = $self->{'hdrv'}->{'program'}; }

	printf "<tr> <td><input type=radio name=dest value=0 %s> %s</td>\n",
		$self->{'prn_hash'}->{'dev'} && $self->{'isdev'} && !$self->{'wdrv'} && !$self->{'hdrv'} ? "checked" : "",
		$self->{'text_hash'}->{'edit_dev'};
	print "<td><select name=dev>\n";
	for($i=0; $i<@{$self->{'device_files_array'}}; $i++) {
		$self->{'d'} = $self->{'device_files_array'}->[$i];
		printf "<option value=\"$self->{'d'}\" %s>$self->{'device_names_array'}->[$i]\n",
			$self->{'d'} eq $self->{'prn_hash'}->{'dev'} ? "selected" : "";
		}
	print "</select></td> </tr>\n";

	printf "<tr> <td><input type=radio name=dest value=1 %s> %s</td>\n",
		$self->{'prn_hash'}->{'dev'} && !$self->{'isdev'} && !$self->{'wdrv'} && !$self->{'hdrv'} ? "checked" : "",
		$self->{'text_hash'}->{'edit_file'};
	printf "<td><input name=file size=25 value=\"%s\"></td> </tr>\n",
		$self->{'isdev'} || $self->{'wdrv'} || $self->{'hdrv'} ? "" : $self->{'prn_hash'}->{'dev'};

	printf "<tr> <td><input type=radio name=dest value=2 %s>\n",
		$self->{'prn_hash'}->{'rhost'} ? "checked" : "";
	print "$self->{'text_hash'}->{'edit_remote'}</td>\n";
	print "<td><input name=rhost size=25 value=\"$self->{'prn_hash'}->{'rhost'}\"></td>\n";
	print "<td>$self->{'text_hash'}->{'edit_rqueue'} ",
	      "<input name=rqueue size=15 value=\"$self->{'prn_hash'}->{'rqueue'}\">\n";
	if ($self->UNIVERSAL::can('remote_printer_types')) {
		@{$self->{'rtypes_array'}} = $self->remote_printer_types();
		}
	elsif ($self->printer_support('sysv')) {
		@{$self->{'rtypes_array'}} = ( [ 'bsd', 'BSD' ], [ 's5', 'SysV' ] );
		}
	elsif ($self->printer_support('ipp')) {
		@{$self->{'rtypes_array'}} = ( [ 'bsd', 'BSD' ], [ 'ipp', 'IPP' ] );
		}
	if (@{$self->{'rtypes_array'}}) {
		print "$self->{'text_hash'}->{'edit_type'} <select name=rtype>\n";
		foreach $t (@{$self->{'rtypes_array'}}) {
			printf "<option value=%s %s>%s\n",
				$t->[0],
				$self->{'prn_hash'}->{'rtype'} eq $t->[0] ? "selected" : "",
				$t->[1];
			}
		print "</select>\n";
		}
	print "</td> </tr>\n";

	if ($self->printer_support("direct")) {
		printf "<tr> <td><input type=radio name=dest value=5 %s>\n",
			$self->{'prn_hash'}->{'dhost'} ? "checked" : "";
		print "$self->{'text_hash'}->{'edit_direct'}</td>\n";
		print "<td><input name=dhost size=25 ",
		      "value=\"$self->{'prn_hash'}->{'dhost'}\"></td>\n";
		print "<td>$self->{'text_hash'}->{'edit_dport'} ",
		      "<input name=dport size=5 value=\"$self->{'prn_hash'}->{'dport'}\">\n";
		print "</td> </tr>\n";
		}

	if ($self->has_smbclient()) {
		printf "<tr> <td><input type=radio name=dest value=3 %s>\n",
			$self->{'wdrv'} ? "checked" : "";
		printf "$self->{'text_hash'}->{'edit_smb'}</td> ".
		      "<td><input name=server size=25 value=\"%s\"></td>\n",
			$self->{'wdrv'}->{'server'};
		printf "<td>$self->{'text_hash'}->{'edit_share'} ".
		       "<input name=share size=15 value=\"%s\"></td>\n",
			$self->{'wdrv'}->{'share'};
		print "</tr><tr> <td align=right>$self->{'text_hash'}->{'edit_user'}</td>\n";
		printf "<td colspan=2><input name=suser size=10 value='%s'>\n",
			$self->{'wdrv'}->{'user'};
		printf "$self->{'text_hash'}->{'edit_pass'} ".
		       "<input type=password name=spass size=10 value='%s'>\n",
			$self->{'wdrv'}->{'pass'};
		printf "$self->{'text_hash'}->{'edit_wgroup'} ".
		       "<input name=wgroup size=10 value=\"%s\">\n",
			$self->{'wdrv'}->{'workgroup'};
		print "</td> </tr>\n";
		}

	if ($self->has_hpnp()) {
		printf "<tr> <td><input type=radio name=dest value=4 %s>\n",
			$self->{'hdrv'} ? "checked" : "";
		print "$self->{'text_hash'}->{'edit_hpnp'}</td>\n";
		printf "<td><input name=hpnp size=25 value=\"%s\"></td>\n",
			$self->{'hdrv'}->{'server'};
		printf "<td>$self->{'text_hash'}->{'edit_port'} ".
		       "<input name=port size=15 value=\"%s\"></td> </tr>\n",
			$self->{'hdrv'}->{'port'};
		}

	print "<tr> <td>&nbsp;&nbsp;&nbsp;&nbsp;",
	      "<input type=checkbox name=check value=1> ",
	      "$self->{'text_hash'}->{'edit_check'}</td> </tr>\n";

	print "</table></td></tr></table><p>\n";

	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_driver'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	if (!$self->{'webmin_print_driver'}) {
		$self->{'drv'} = $self->is_webmin_driver($self->{'prn_hash'}->{'iface'}, \%{$self->{'prn_hash'}});
		}
	if ($self->{'drv'}->{'mode'} != 0 && $self->{'drv'}->{'mode'} != 2 || $self->{'webmin'}) {
		$self->{'webmin'}++;
		$self->{'after'} = $self->webmin_driver_input(\%{$self->{'prn_hash'}}, $self->{'drv'});
		}
	else {
		$self->{'drv'} = $self->is_driver($self->{'prn_hash'}->{'iface'}, \%{$self->{'prn_hash'}});
		$self->{'after'} = $self->driver_input(\%{$self->{'prn_hash'}}, $self->{'drv'});
		}
	print "</table></td></tr></table><p>\n";
	}
print "<input type=hidden name=webmin value=\"$self->{'webmin'}\">\n";

if ($self->{'in_hash'}->{'new'}) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form><p>\n";
	}
else {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";
	if ($self->{'access_hash'}->{'delete'}) {
		print "</form><form action=\"delete_printer.cgi\">\n";
		print "<input type=hidden name=name value=\"$self->{'in_hash'}->{'name'}\">\n";
		print "<td align=right><input type=submit ",
		      "value=\"$self->{'text_hash'}->{'delete'}\"></td> </tr>\n";
		}
	print "</form></table>\n";
	}
print $self->{'after'};

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

