#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_jobs.cgi
# List all print jobs on some printer

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->ReadParse();
print "Refresh: $self->{'config_hash'}->{'queue_refresh'}\r\n"
	if ($self->{'config_hash'}->{'queue_refresh'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'jobs_title'}, "");

@{$self->{'jobs_array'}} = $self->get_jobs($self->{'in_hash'}->{'name'});
if (@{$self->{'jobs_array'}}) {
	print $self->ui_subheading($self->text('jobs_header', "<tt>$self->{'in_hash'}->{'name'}</tt>"));
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'jobs_id'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'jobs_size'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'jobs_by'}</b></td>\n";
	if ($self->{'jobs_array'}->[0]->{'when'}) {
		print "<td><b>$self->{'text_hash'}->{'jobs_when'}</b></td>\n";
		}
	if ($self->{'jobs_array'}->[0]->{'file'}) {
		print "<td><b>$self->{'text_hash'}->{'jobs_file'}</b></td>\n";
		}
	foreach $j (@{$self->{'jobs_array'}}) {
		local $ju = $j->{'user'};
		$ju =~ s/\!.*$//;
		print "<tr $self->{'cb'}>\n";
		if ($self->can_edit_jobs($self->{'in_hash'}->{'name'}, $ju)) {
			print "<td><a href=\"cancel_job.cgi?name=$self->{'in_hash'}->{'name'}&",
			      "id=$j->{'id'}\">",$self->html_escape($j->{'id'}),
			      "</a></td>\n";
			}
		else {
			print "<td>",$self->html_escape($j->{'id'}),"</td>\n";
			}
		if ($j->{'printfile'} && $self->can_edit_jobs($self->{'in_hash'}->{'name'}, $ju)) {
			print "<td><a href='view_job.cgi?name=$self->{'in_hash'}->{'name'}",
			      "&id=$j->{'id'}'>",$self->html_escape($j->{'size'}),
			      " $self->{'text_hash'}->{'jobs_bytes'}</a></td>\n";
			$self->{'printfile'}++;
			}
		else {
			print "<td>",$self->html_escape($j->{'size'}),
			      " $self->{'text_hash'}->{'jobs_bytes'}</td>\n";
			}
		if ($j->{'user'} =~ /^(\S+)\!(\S+)$/) {
			print "<td>",$self->html_escape("$2\@$1"),"</td>\n";
			}
		else { print "<td>",$self->html_escape($j->{'user'}),"</td>\n"; }
		if ($j->{'when'}) { print "<td>$j->{'when'}</td>\n"; }
		if ($j->{'file'}) { print "<td>$j->{'file'}</td>\n"; }
		print "</tr>\n";
		}
	print "</table>\n";
	if ($self->{'access_hash'}->{'cancel'}) {
		print "<table width=100%><tr><td>\n";
		print $self->{'printfile'} ? $self->{'text_hash'}->{'jobs_cancelview'}
				 : $self->{'text_hash'}->{'jobs_cancel'},"<br>\n";
		print "</td> <td align=right>",
		      "<a href='cancel_all.cgi?name=$self->{'in_hash'}->{'name'}'>",
		      "$self->{'text_hash'}->{'jobs_all'}</a></td> </tr></table>\n";
		}
	}
else {
	print "<b>",$self->text('jobs_none', "<tt>$self->{'in_hash'}->{'name'}</tt>"),"</b><p>\n";
	}

print "<form action=test_form.cgi>\n";
print "<input type=hidden name=name value='$self->{'in_hash'}->{'name'}'>\n";
print "<input type=submit value='$self->{'text_hash'}->{'jobs_test'}'></form><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

