#!/usr/bin/perl

&MAIN();

 sub MAIN {
# test_print.cgi
# Print one of the test pages

&ModuleLoader::preload_module('lpadmin_class', "lpadmin::LpadminLib");
$self = new lpadmin::LpadminLib:: 'lpadmin_class',%$self;

$self->foreign_require("proc", "proc-lib.pl");
$self->ReadParseMime();
$self->{'access_hash'}->{'test'} || $self->error($self->{'text_hash'}->{'test_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'test_title'}, "");

if ($self->{'in_hash'}->{'mode'} == 0) {
	$self->{'file'} = "bw.ps";
	}
elsif ($self->{'in_hash'}->{'mode'} == 1) {
	$self->{'file'} = "colour.ps";
	}
elsif ($self->{'in_hash'}->{'mode'} == 2) {
	$self->{'file'} = "ascii.txt";
	}
else {
	$self->{'file'} = $self->transname();
	open(FILE, ">$self->{'file'}");
	print FILE $self->{'in_hash'}->{'file'};
	close(FILE);
	}

$self->{'cmd'} = $self->print_command($self->{'in_hash'}->{'name'}, $self->{'file'});
print $self->text('test_exec', "<tt>$self->{'cmd'}</tt>"),"<br>\n";
print "<pre>";
if ($self->{'access_hash'}->{'user'} eq '*') {
	open(CMD, "$self->{'cmd'} 2>&1 |");
	}
elsif ($self->{'access_hash'}->{'user'}) {
	open(CMD, "su '$self->{'access_hash'}->{'user'}' -c '$self->{'cmd'}' 2>&1 |");
	}
else {
	open(CMD, "su '$self->{'remote_user'}' -c '$self->{'cmd'}' 2>&1 |");
	}
while(<CMD>) {
	print;
	}
close(CMD);
print "</pre>\n";

if ($?) { print "<b>$self->{'text_hash'}->{'test_failed'}</b> <p>\n"; }
else { print "$self->{'text_hash'}->{'test_ok'} <p>\n"; }

unlink($self->{'file'}) if ($self->{'in_hash'}->{'mode'} == 3);
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

