#!/usr/bin/perl

&MAIN();

 sub MAIN {
# find.cgi
# Display users matching some criteria

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->ReadParse();

# Build a list of all matching users
foreach $uinfo ($self->list_mail_users()) {
	if ($self->can_user(@$uinfo)) {
		if ($self->{'in_hash'}->{'match'} == 0 && lc($self->{'in_hash'}->{'user'}) eq $uinfo->[0] ||
		    $self->{'in_hash'}->{'match'} == 1 && $uinfo->[0] =~ /\Q$self->{'in_hash'}->{'user'}\E/i) {
			push(@{$self->{'users_array'}}, $uinfo);
			}
		}
	}

if (@{$self->{'users_array'}} == 1) {
	# Can go direct to user
	$self->redirect("list_mail.cgi?user=$self->{'users_array'}->[0]->[0]");
	}
elsif (@{$self->{'users_array'}} == 0) {
	# No matches
	$self->error($self->{'text_hash'}->{'find_enone'});
	}
else {
	# Show table of matches
	$self->ui_print_header(undef, $self->{'text_hash'}->{'find_title'}, "");
	print $self->text('find_results', $self->{'in_hash'}->{'user'}),"<p>\n";
	$self->show_users_table(\@{$self->{'users_array'}});
	$self->ui_print_footer();
	}

1;
		
}


1;

