#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_mail.cgi
# View a single email message 

&ModuleLoader::preload_module('mailboxes_class', "mailboxes::MailboxesLib");
$self = new mailboxes::MailboxesLib:: 'mailboxes_class',%$self;

$self->{'force_charset'} = '';
$self->ReadParse();
$self->can_user($self->{'in_hash'}->{'user'}) || $self->error($self->{'text_hash'}->{'mail_ecannot'});
if ($self->is_user($self->{'in_hash'}->{'user'})) {
	@{$self->{'uinfo_array'}} = $self->get_mail_user($self->{'in_hash'}->{'user'});
	@{$self->{'uinfo_array'}} || $self->error($self->{'text_hash'}->{'view_eugone'});
	}

$self->{'uuser'} = $self->urlize($self->{'in_hash'}->{'user'});
@{$self->{'folders_array'}} = $self->list_user_folders($self->{'in_hash'}->{'user'});
$self->{'folder'} = $self->{'folders_array'}->[$self->{'in_hash'}->{'folder'}];
@{$self->{'mail_array'}} = $self->mailbox_list_mails($self->{'in_hash'}->{'idx'}, $self->{'in_hash'}->{'idx'}, $self->{'folder'});
$self->{'mail'} = $self->{'mail_array'}->[$self->{'in_hash'}->{'idx'}];
$self->parse_mail($self->{'mail'}, undef, $self->{'in_hash'}->{'raw'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
        # We are looking at a mail within a mail ..
        local $amail = $self->extract_mail($self->{'mail'}->{'attach'}->[$s]->{'data'});
        $self->parse_mail($amail, undef, $self->{'in_hash'}->{'raw'});
        $self->{'mail'} = $amail;
        }

dbmopen(%{$self->{'read_hash'}}, "$self->{'module_config_directory'}/$self->{'in_hash'}->{'user'}.read", 0600);
eval { $self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}} = 1 }
	if (!$self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}});

if ($self->{'in_hash'}->{'raw'}) {
	# Special mode - viewing whole raw message
	print "Content-type: text/plain\n\n";
	if ($self->{'mail'}->{'fromline'}) {
		print $self->{'mail'}->{'fromline'},"\n";
		}
	if (defined($self->{'mail'}->{'rawheaders'})) {
		#$self->{'mail'}->{'rawheaders'} =~ s/(\S)\t/$1\n\t/g;
		print $self->{'mail'}->{'rawheaders'};
		}
	else {
		foreach $h (@{$self->{'mail'}->{'headers'}}) {
			#$h->[1] =~ s/(\S)\t/$1\n\t/g;
			print "$h->[0]: $h->[1]\n";
			}
		}
	print "\n";
	print $self->{'mail'}->{'body'};
	exit;
	}

# Find body attachment and type
($self->{'textbody'}, $self->{'htmlbody'}, $self->{'body'}) = $self->find_body($self->{'mail'}, $self->{'config_hash'}->{'view_html'});
$self->{'body'} = $self->{'htmlbody'} if ($self->{'in_hash'}->{'body'} == 2);
$self->{'body'} = $self->{'textbody'} if ($self->{'in_hash'}->{'body'} == 1);
@{$self->{'attach_array'}} = @{$self->{'mail'}->{'attach'}};

# Show pre-body HTML
if ($self->{'body'} && $self->{'body'} eq $self->{'htmlbody'}) {
	$self->{'headstuff'} = $self->head_html($self->{'body'}->{'data'});
	}

#&mail_page_header($self->{'text_hash'}->{'view_title'}, $self->{'headstuff'}, undef,
#		  &folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}));
#$self->ui_print_header(undef, $self->{'text_hash'}->{'view_title'}, "", undef, 0, 0, undef,&folder_link($self->{'in_hash'}->{'user'}, $self->{'folder'}), $self->{'headstuff'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'view_title'}, "", undef, undef, 1);
print $self->check_clicks_function();
&show_arrows();

print "<form action=reply_mail.cgi>\n";
print "<input type=hidden name=user value='$self->{'in_hash'}->{'user'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=folder value='$self->{'in_hash'}->{'folder'}'>\n";
print "<input type=hidden name=mod value=",$self->modification_time($self->{'folder'}),">\n";
foreach $s (@{$self->{'sub_array'}}) {
	print "<input type=hidden name=sub value='$s'>\n";
	}

# Find any delivery status attachment
($self->{'dstatus'}) = grep { $_->{'type'} eq 'message/delivery-status' } @{$self->{'attach_array'}};

# Strip out attachments not to display as icons
@{$self->{'attach_array'}} = grep { $_ ne $self->{'body'} && $_ ne $self->{'dstatus'} } @{$self->{'attach_array'}};
@{$self->{'attach_array'}} = grep { !$_->{'attach'} } @{$self->{'attach_array'}};

#if ($self->{'config_hash'}->{'top_buttons'} == 2 && $self->editable_mail($self->{'mail'})) {
#	&show_mail_buttons(1, scalar(@{$self->{'sub_array'}}));
#	print "<p>\n";
#	}

print "<table width=100% border=1>\n";
print "<tr> <td $self->{'tb'}><table width=100% cellpadding=0 cellspacing=0><tr>",
      "<td><b>$self->{'text_hash'}->{'view_headers'}</b></td> <td align=right>\n";
if ($self->{'in_hash'}->{'headers'}) {
	print "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&body=$self->{'in_hash'}->{'body'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&headers=0$self->{'subs'}'>$self->{'text_hash'}->{'view_noheaders'}</a>\n";
	}
else {
	print "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&body=$self->{'in_hash'}->{'body'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&headers=1$self->{'subs'}'>$self->{'text_hash'}->{'view_allheaders'}</a>\n";
	}
print "&nbsp;&nbsp;<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&raw=1$self->{'subs'}'>$self->{'text_hash'}->{'view_raw'}</a></td>\n";
print "</tr></table></td> </tr>\n";

print "<tr> <td $cb><table width=100%>\n";
if ($self->{'in_hash'}->{'headers'}) {
	# Show all the headers
	if ($self->{'mail'}->{'fromline'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_rfc'}</b></td>",
		      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'fromline'}),
		      "</td> </tr>\n";
		}
	foreach $h (@{$self->{'mail'}->{'headers'}}) {
		print "<tr> <td><b>$h->[0]:</b></td> ",
		      "<td>",$self->eucconv_and_escape($self->decode_mimewords($h->[1])),
		      "</td> </tr>\n";
		}
	}
else {
	# Just show the most useful headers
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
	      "<td>",&address_link($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
		if ($self->{'mail'}->{'header'}->{'cc'});
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td>",$self->eucconv_and_escape($self->{'mail'}->{'header'}->{'date'}),
	      "</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
	      "<td>",$self->eucconv_and_escape($self->decode_mimewords(
			$self->{'mail'}->{'header'}->{'subject'})),"</td> </tr>\n";
	}
print "</table></td></tr></table><p>\n";

# Show body attachment, with properly linked URLs
if ($self->{'body'} && $self->{'body'}->{'data'} =~ /\S/) {
	if ($self->{'body'} eq $self->{'textbody'}) {
		# Show plain text
		$self->{'bodycontents'} = "<pre>";
		foreach $l ($self->wrap_lines($self->eucconv($self->{'body'}->{'data'}),
					$self->{'config_hash'}->{'wrap_width'})) {
			$self->{'bodycontents'} .= $self->link_urls_and_escape($l,
						$self->{'config_hash'}->{'link_mode'})."\n";
			}
		$self->{'bodycontents'} .= "</pre>";
		if ($self->{'htmlbody'}) {
			$self->{'bodyright'} = "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&headers=$self->{'in_hash'}->{'headers'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&body=2$self->{'subs'}'>$self->{'text_hash'}->{'view_ashtml'}</a>";
			}
		}
	elsif ($self->{'body'} eq $self->{'htmlbody'}) {
		# Attempt to show HTML
		$self->{'bodycontents'} = $self->safe_html($self->{'body'}->{'data'});
		$self->{'bodycontents'} = $self->fix_cids($self->{'bodycontents'}, \@{$self->{'attach_array'}},
			"detach.cgi?user=$self->{'uuser'}&idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}$self->{'subs'}");
		if ($self->{'textbody'}) {
			$self->{'bodyright'} = "<a href='view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&headers=$self->{'in_hash'}->{'headers'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&body=1$self->{'subs'}'>$self->{'text_hash'}->{'view_astext'}</a>";
			}
		}
	}
if ($self->{'bodycontents'}) {
	print "<table width=100% border=1>\n";
	print "<tr $self->{'tb'}> <td><table width=100% cellpadding=0 cellspacing=0><tr>",
	      "<td><b>$self->{'text_hash'}->{'view_body'}</b></td> ",
	      "<td align=right>$self->{'bodyright'}</td> </tr></table></td> </tr>\n";
	print "<tr $cb> <td>\n";
	print $self->{'bodycontents'};
	print "</pre></td></tr></table><p>\n";
	}

# Show delivery status
if ($self->{'dstatus'}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'view_dstatus'}</b></td> </tr>\n";
	print "<tr> <td $cb><table>\n";

	local $ds = $self->parse_delivery_status($self->{'dstatus'}->{'data'});
	foreach $dsh ('final-recipient', 'diagnostic-code',
		      'remote-mta', 'reporting-mta') {
		if ($ds->{$dsh}) {
			$ds->{$dsh} =~ s/^\S+;//;
			print "<tr> <td nowrap valign=top><b>",
			      $self->{'text_hash'}->{'view_'.$dsh},"</b></td>\n";
			print "<td>",$self->html_escape($ds->{$dsh}),"</td> </tr>\n";
			}
		}

	print "</table></td></tr></table><p>\n";
	}

# Display other attachments
if (@{$self->{'attach_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'view_attach'}</b></td> </tr>\n";
	print "<tr> <td $cb>\n";
	foreach $a (@{$self->{'attach_array'}}) {
		local $fn;
		$self->{'size'} = (int(length($a->{'data'})/1000)+1)." Kb";
		local $cb;
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'titles_array'}}, "$self->{'text_hash'}->{'view_sub'}<br>$self->{'size'}");
			}
		elsif ($a->{'filename'}) {
			push(@{$self->{'titles_array'}}, $self->decode_mimewords($a->{'filename'}).
				      "<br>$self->{'size'}");
			$fn = $self->decode_mimewords($a->{'filename'});
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		else {
			push(@{$self->{'titles_array'}}, "$a->{'type'}<br>$self->{'size'}");
			$a->{'type'} =~ /\/(\S+)$/;
			$fn = "file.$1";
			push(@{$self->{'detach_array'}}, [ $a->{'idx'}, $fn ]);
			}
		if ($a->{'error'}) {
			$self->{'titles_array'}->[$#{$self->{'titles_array'}}] .= "<br><font size=-1>($a->{'error'})</font>";
			}
		$fn =~ s/ /_/g;
		$fn =~ s/\#/_/g;
		$fn = $self->html_escape($fn);
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'links_array'}}, "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}$self->{'subs'}&sub=$a->{'idx'}");
			}
		else {
			push(@{$self->{'links_array'}}, "detach.cgi/$fn?idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}&attach=$a->{'idx'}$self->{'subs'}");
			}
		if ($self->{'config_hash'}->{'thumbnails'} &&
		    ($a->{'type'} =~ /image\/gif/i && $self->has_command("giftopnm")&&
		     $self->has_command("pnmscale") && $self->has_command("cjpeg") ||
		     $a->{'type'} =~ /image\/jpeg/i && $self->has_command("djpeg") &&
		     $self->has_command("pnmscale") && $self->has_command("cjpeg"))) {
			# Can show an image icon
			push(@{$self->{'icons_array'}}, "detach.cgi?scale=1&idx=$self->{'in_hash'}->{'idx'}&folder=$self->{'in_hash'}->{'folder'}&attach=$a->{'idx'}$self->{'subs'}");
			$self->{'imgicons'}++;
			}
		else {
			push(@{$self->{'icons_array'}}, "images/boxes.gif");
			}
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 6, undef,
		     $self->{'imgicons'} ? ( 0, 0 ) : ( ));
	if ($self->{'access_hash'}->{'candetach'} && @{$self->{'detach_array'}} && defined($self->{'uinfo_array'}->[2])) {
		print "<input type=submit name=detach value='$self->{'text_hash'}->{'view_detach'}'>\n";
		print "<input type=hidden name=bindex value='$self->{'body'}->{'idx'}'>\n" if ($self->{'body'});
		print "<select name=attach>\n";
		print "<option value=*>$self->{'text_hash'}->{'view_dall'}\n";
		foreach $a (@{$self->{'detach_array'}}) {
			printf "<option value=%s>%s\n",
				$a->[0], $a->[1];
			}
		print "</select>\n";
		print "<b>$self->{'text_hash'}->{'view_dir'}</b>\n";
		print "<input name=dir size=40> ",
			$self->file_chooser_button("dir", 1),"\n";
		}
	print "</td></tr></table><p>\n";
	}

&show_mail_buttons(2, scalar(@{$self->{'sub_array'}})) if ($self->editable_mail($self->{'mail'}));
if ($self->{'config_hash'}->{'arrows'} == 2 && !@{$self->{'sub_array'}}) {
        &show_arrows();
        }
print "</form>\n";

dbmclose(%{$self->{'read_hash'}});

local @sr = !@{$self->{'sub_array'}} ? ( ) :
    ( "view_mail.cgi?idx=$self->{'in_hash'}->{'idx'}", $self->{'text_hash'}->{'view_return'} ),
$s = int((@{$self->{'mail_array'}} - $self->{'in_hash'}->{'idx'} - 1) / $self->{'config_hash'}->{'perpage'}) *
	$self->{'config_hash'}->{'perpage'};
$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'},"", $self->{'text_hash'}->{'index_return'},
	"list_mail.cgi?folder=$self->{'in_hash'}->{'folder'}&user=$self->{'in_hash'}->{'user'}", $self->{'text_hash'}->{'mail_return'});

1;
		
}

# show_mail_buttons(pos, submode)
sub show_mail_buttons
{
	shift if ($self == $_[0]);

local $spacer = "&nbsp;\n";
if (!$_[1]) {
	if (!$self->{'folder'}->{'sent'} && !$self->{'folder'}->{'drafts'}) {
		$self->{'m'} = $self->{'read_hash'}->{$self->{'mail'}->{'header'}->{'message-id'}};
		print "<input name=mark$_[0] type=submit value=\"$self->{'text_hash'}->{'view_mark'}\">";
		print "<select name=mode$_[0]>\n";
		foreach $i (0 .. 2) {
			printf "<option value=%d %s>%s\n",
				$i, $self->{'m'} == $i ? 'selected' : '', $self->{'text_hash'}->{"view_mark$i"};
			}
		print "</select>";
		print $spacer;
		}
	}
if ($self->is_user($self->{'in_hash'}->{'user'})) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'view_reply'}\" name=reply>";
#	print "<input type=submit value=\"$self->{'text_hash'}->{'view_reply2'}\" name=rall>";
	print $spacer;
	}


if ($self->is_user($self->{'in_hash'}->{'user'})) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'view_forward'}\" name=forward>";
	print $spacer;
	}

print "<input type=submit value=\"$self->{'text_hash'}->{'view_print'}\" name=print>";
print $spacer;


print "<input type=submit value=\"$self->{'text_hash'}->{'view_strip'}\" name=strip>";
print $spacer;

print "<input type=submit value=\"$self->{'text_hash'}->{'view_delete'}\" name=delete ","onClick='return check_clicks(form)'>";
print $spacer;


# Show spam report buttons
@{$self->{'modules_array'}} = $self->get_available_module_infos(1);
($self->{'hasspam'}) = grep { $_->{'dir'} eq "spam" } @{$self->{'modules_array'}};
if ($self->foreign_installed("spam") &&
    $self->{'config_hash'}->{'spam_buttons'} =~ /mail/ &&
    $self->spam_report_cmd($self->{'in_hash'}->{'user'})) {
    	print "<br><hr>";
	if ($self->{'hasspam'}) {
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_black'}\" name=black>";
		}
	if ($self->{'config_hash'}->{'spam_del'}) {
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_razordel'}\" name=razor>\n";
		}
	else {
		print "<input type=submit value=\"$self->{'text_hash'}->{'view_razor'}\" name=razor>\n";
		}
	}
print "<br>\n";
}

sub show_arrows
{
	shift if ($self == $_[0]);

print "<center>\n";
if (!@{$self->{'sub_array'}}) {
	if ($self->{'in_hash'}->{'idx'}) {
		print "<a href='view_mail.cgi?idx=",
		      $self->{'in_hash'}->{'idx'}-1,"&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}'>",
		      "<img src=/images/left.gif border=0 ",
		      "align=middle></a>\n";
		}
	print "<font size=+1>",$self->text('view_desc', $self->{'in_hash'}->{'idx'}+1,
			$self->{'folder'}->{'name'}),"</font>\n";
	if ($self->{'in_hash'}->{'idx'} < @{$self->{'mail_array'}}-1) {
		print "<a href='view_mail.cgi?idx=",
		      $self->{'in_hash'}->{'idx'}+1,"&folder=$self->{'in_hash'}->{'folder'}&user=$self->{'uuser'}'>",
		      "<img src=/images/right.gif border=0 ",
		      "align=middle></a>\n";
		}
	}
else {
	print "<font size=+1>$self->{'text_hash'}->{'view_sub'}</font>\n";
	}
print "</center><br>\n";
}

# address_link(address)
sub address_link
{
	shift if ($self == $_[0]);

local @addrs = $self->split_addresses($self->decode_mimewords($_[0]));
local @rv;
foreach $a (@addrs) {
	push(@rv, $self->eucconv_and_escape($a->[2]));
	}
return join(" , ", @rv);
}


1;

