#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_list.cgi
# Delete a mailing list, after asking the user if he is sure

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
$self->{'name'} = $self->{'in_hash'}->{'name'};
($self->{'namere'} = $self->{'name'}) =~ s/\./\\./g;
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'name'}) || $self->error($self->{'text_hash'}->{'delete_ecannot'});

# find aliases and files
$self->{'conf'} = $self->get_config();
$self->{'aliases_files'} = $self->get_aliases_file();
$self->foreign_call($self->{'aliases_module'}, "lock_alias_files", $self->{'aliases_files'})
	if ($self->{'in_hash'}->{'confirm'});
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	if ($a->{'name'} eq $self->{'name'} && $a->{'value'} =~ /-digestify/i) {
		$self->error($self->{'text_hash'}->{'delete_edigest'});
		}
	if ($a->{'name'} =~ /-digestify$/i && $a->{'value'} =~ /\s$self->{'namere'}\s/i) {
		$self->{'digestify'} = $a;
		}
	if ($a->{'name'} eq $self->{'name'}) {
		foreach $v (@{$a->{'values'}}) {
			$self->{'real_list'} = $1
				if ($v =~ /^\|\S*wrapper\s+resend.*\s(\S+)$/);
			}
		}
	}
@{$self->{'daliases_array'}} = grep { $_->{'name'} =~ /^$self->{'namere'}$/i ||
		  $_->{'name'} eq $self->{'real_list'} ||
		  $_->{'name'} =~ /^$self->{'namere'}-(list|owner|approval|outgoing|request|archive)$/i ||
		  $_->{'name'} =~ /owner-$self->{'namere'}-outgoing$/i ||
		  $_->{'name'} =~ /$self->{'namere'}-outgoing-(list|owner|approval)$/i ||
		  $_ eq $self->{'digestify'} ||
		  $_->{'name'} =~ /^owner-$self->{'namere'}$/i } @{$self->{'aliases_array'}};
$self->{'ldir'} = $self->perl_var_replace($self->find_value("listdir", $self->{'conf'}), $self->{'conf'});
opendir(LDIR, $self->{'ldir'});
while($f = readdir(LDIR)) {
	if ($f eq $self->{'name'} || $f =~ /^$self->{'namere'}\./) {
		push(@{$self->{'files_array'}}, "$self->{'ldir'}/$f");
		}
	}
closedir(LDIR);

if ($self->{'in_hash'}->{'confirm'}) {
	# do the deletion
	foreach $f (@{$self->{'files_array'}}) { $self->lock_file($f); }
	foreach $f (@{$self->{'files_array'}}) {
		system("rm -rf \"$f\"");
		}
	foreach $f (@{$self->{'files_array'}}) { $self->unlock_file($f); }
	@{$self->{'daliases_array'}} = sort { $b->{'line'} <=> $a->{'line'} } @{$self->{'daliases_array'}};
	foreach $a (@{$self->{'daliases_array'}}) {
		$self->foreign_call($self->{'aliases_module'}, "delete_alias", $a,
			      $self->{'aliases_file'}, $a ne $self->{'daliases_array'}->[$#{$self->{'daliases_array'}}]);
		}

	if ($self->{'digestify'}) {
		# delete the digestify alias from the 'parent' list
		foreach $a (@{$self->{'aliases_array'}}) {
			$self->{'idx'} = $self->indexof($self->{'digestify'}->{'name'},@{$a->{'values'}});
			if ($self->{'idx'} >= 0) {
				splice(@{$a->{'values'}}, $self->{'idx'}, 1);
				$self->foreign_call($self->{'aliases_module'},
					      "modify_alias", $a, $a);
				}
			}
		}
	$self->foreign_call($self->{'aliases_module'}, "unlock_alias_files", $self->{'aliases_files'});

	# remove from ACLs
	$self->read_acl(undef, \%{$self->{'wusers_hash'}});
	foreach $u (keys %{$self->{'wusers_hash'}}) {
		%{$self->{'uaccess_hash'}} = $self->get_module_acl($u);
		$self->{'uaccess_hash'}->{'lists'} = join(' ', grep { $_ ne $self->{'name'} }
					      split(/\s+/, $self->{'uaccess_hash'}->{'lists'}));
		$self->save_module_acl(\%{$self->{'uaccess_hash'}}, $u) if ($self->{'uaccess_hash'}->{'lists'} ne '*');
		}
	$self->webmin_log("delete", "list", $self->{'name'});
	$self->redirect("");
	}
else {
	# ask the user if he is sure
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delete_title'}, "");
	print "<form action=delete_list.cgi>\n";
	print "<input type=hidden name=name value=\"$self->{'name'}\">\n";
	print "<input type=hidden name=confirm value=1>\n";
	print "<b>",$self->text('delete_rusure', "<tt>".$self->html_escape($self->{'name'})."</tt>"),
	      "</b><br>\n";
	print "<ul>\n";
	foreach $f (@{$self->{'files_array'}}) {
		print "<tt>",$self->html_escape($f),"</tt><br>\n";
		}
	print "</ul>\n";
	print "<b>$self->{'text_hash'}->{'delete_aliases'}</b><br>\n";
	print "<ul>\n";
	foreach $a (@{$self->{'daliases_array'}}) {
		print "<tt>",$self->html_escape("$a->{'name'}: $a->{'value'}"),
		      "</tt><br>\n";
		}
	print "</ul>\n";
	print "<center><input type=submit ",
	      "value='$self->{'text_hash'}->{'delete_ok'}'></center>\n";
	print "</form>\n";
	$self->ui_print_footer("edit_list.cgi?name=$self->{'name'}", $self->{'text_hash'}->{'edit_return'});
	}

1;
		
}


1;

