#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_list.cgi
# Edit an existing mailing list

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) ||
	$self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'desc'} = $self->text('edit_for', "<tt>".$self->html_escape($self->{'in_hash'}->{'name'})."</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'edit_title'}, "");

@{$self->{'links_array'}} = ( "edit_members.cgi", "edit_info.cgi", "edit_subs.cgi",
	   "edit_mesg.cgi", "edit_access.cgi", "edit_head.cgi",
	   "edit_misc.cgi" );
foreach $a ($self->foreign_call($self->{'aliases_module'}, "list_aliases",
			  $self->get_aliases_file())) {
	if ($a->{'name'} =~ /-digestify$/i &&
	    $a->{'value'} =~ /\s$self->{'in_hash'}->{'name'}\s/i) {
		$self->{'isdigest'}++;
		}
	}
if ($self->{'isdigest'}) {
	push(@{$self->{'links_array'}}, "edit_digest.cgi");
	}
map { s/edit_(\S+).cgi/images\/$1.gif/ } (@{$self->{'icons_array'}} = @{$self->{'links_array'}});
map { s/edit_(\S+).cgi/$self->{'text_hash'}->{"$1_title"}/ } (@{$self->{'titles_array'}} = @{$self->{'links_array'}});
@{$self->{'links_array'}} = map { $_."?name=".$self->urlize($self->{'in_hash'}->{'name'}) } @{$self->{'links_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});

print "<hr>\n";
print "<table>\n";
print "<form action=delete_list.cgi>\n";
print "<input type=hidden name=name value=\"$self->{'in_hash'}->{'name'}\">\n";
print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'edit_delete'}\"></td>\n";
print "<td>$self->{'text_hash'}->{'edit_deletemsg'}</td> </tr>\n";
print "</form>\n";
print "</table>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

