#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_members.cgi
# Display a form for editing the members of some list

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->{'desc'} = $self->text('edit_for', "<tt>".$self->html_escape($self->{'in_hash'}->{'name'})."</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'members_title'}, "");

if ($self->{'access_hash'}->{'edit'}) {
	print "$self->{'text_hash'}->{'members_desc'}<br>\n";
	}
else {
	print "$self->{'text_hash'}->{'members_rodesc'}<br>\n";
	}
print "<form action=save_members.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=name value='$self->{'in_hash'}->{'name'}'>\n";
print "<textarea rows=15 cols=60 name=members>\n";
open(MEMS, $self->{'list'}->{'members'});
while(<MEMS>) {
	print $self->html_escape($_);
	}
close(MEMS);
print "</textarea>\n";
if (!$self->{'access_hash'}->{'edit'}) {
	print "<p>\n";
	}
else {
	print "<br><input type=submit value=\"$self->{'text_hash'}->{'save'}\" name=update>\n";
	print "<hr>\n";

	print "<table>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'members_sub'}</b></td>\n";
	print "<td><input name=addr_a size=40> ",
	      "<input type=submit name=add ",
	      "value=\"$self->{'text_hash'}->{'members_add'}\"></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'members_unsub'}</b></td>\n";
	print "<td><input name=addr_r size=40> ",
	      "<input type=submit name=remove ",
	      "value=\"$self->{'text_hash'}->{'members_rem'}\"></td> </tr>\n";
	print "</table></form>\n";

	print "<hr>\n";
	print "<form action=save_auto.cgi>\n";
	print "<input type=hidden name=name value='$self->{'in_hash'}->{'name'}'>\n";
	print "<table>\n";
	$self->{'sync'} = $self->{'config_hash'}->{"sync_$self->{'in_hash'}->{'name'}"};
	print "<tr> <td><b>$self->{'text_hash'}->{'members_sync'}</b></td> <td>\n";
	printf "<input type=radio name=sync value=1 %s> %s\n",
		$self->{'sync'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=sync value=0 %s> %s</td> </tr>\n",
		$self->{'sync'} ? "" : "checked", $self->{'text_hash'}->{'no'};

	$self->{'shost'} = $self->{'config_hash'}->{"shost_$self->{'in_hash'}->{'name'}"};
	print "<tr><td><b>$self->{'text_hash'}->{'members_dom'}</b></td>\n";
	print "<td><input name=shost size=40 value='$self->{'shost'}'>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td> </tr>\n";

	print "</table></form>\n";
	}

$self->ui_print_footer("edit_list.cgi?name=$self->{'in_hash'}->{'name'}", $self->{'text_hash'}->{'edit_return'});

1;
		
}


1;

