#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_subs.cgi
# Edit subscription options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->{'desc'} = $self->text('edit_for', "<tt>".$self->html_escape($self->{'in_hash'}->{'name'})."</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'subs_title'}, "");

print "<form action=save_subs.cgi>\n";
print "<input type=hidden name=name value='$self->{'in_hash'}->{'name'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'subs_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

$self->{'pol'} = $self->find_value("subscribe_policy", $self->{'conf'});
if ($self->{'pol'} =~ /(\S+)\+confirm/) { $self->{'pol'} = $1; $self->{'confirm'} = 1; }
print "<tr> <td><b>$self->{'text_hash'}->{'subs_sub'}</b></td> <td colspan=3 nowrap>\n";
printf "<input name=subscribe_policy type=radio value=open %s> %s\n",
	$self->{'pol'} eq "open" ? "checked" : "", $self->{'text_hash'}->{'subs_sopen'};
printf "<input name=subscribe_policy type=radio value=auto %s> %s\n",
	$self->{'pol'} eq "auto" ? "checked" : "", $self->{'text_hash'}->{'subs_sauto'};
printf "<input name=subscribe_policy type=radio value=closed %s> %s\n",
	$self->{'pol'} eq "closed" ? "checked" : "", $self->{'text_hash'}->{'subs_closed'};
print "</td> </tr>\n";

$self->{'upol'} = $self->find_value("unsubscribe_policy", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'subs_unsub'}</b></td> <td colspan=3 nowrap>\n";
printf "<input name=unsubscribe_policy type=radio value=open %s> %s\n",
	$self->{'upol'} eq "open" ? "checked" : "", $self->{'text_hash'}->{'subs_uopen'};
printf "<input name=unsubscribe_policy type=radio value=auto %s> %s\n",
	$self->{'upol'} eq "auto" ? "checked" : "", $self->{'text_hash'}->{'subs_uauto'};
printf "<input name=unsubscribe_policy type=radio value=closed %s> %s\n",
	$self->{'upol'} eq "closed" ? "checked" : "", $self->{'text_hash'}->{'subs_closed'};
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'subs_confirm'}</b></td> <td>\n";
printf "<input name=subscribe_policy_c type=radio value='+confirm' %s> %s\n",
	$self->{'confirm'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input name=subscribe_policy_c type=radio value='' %s> %s</td>\n",
	$self->{'confirm'} ? "" : "checked", $self->{'text_hash'}->{'no'};
print $self->choice_input("welcome", $self->{'text_hash'}->{'subs_welcome'}, $self->{'conf'},
		    "yes", $self->{'text_hash'}->{'yes'}, "no", $self->{'text_hash'}->{'no'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input("strip", $self->{'text_hash'}->{'subs_strip'}, $self->{'conf'},
		    "yes", $self->{'text_hash'}->{'yes'}, "no", $self->{'text_hash'}->{'no'});
print $self->choice_input("announcements", $self->{'text_hash'}->{'subs_announcements'},
		    $self->{'conf'}, "yes", $self->{'text_hash'}->{'yes'}, "no", $self->{'text_hash'}->{'no'});
print "</tr>\n";

print "<tr>\n";
print $self->choice_input("administrivia", $self->{'text_hash'}->{'subs_administrivia'},
		    $self->{'conf'}, "yes", $self->{'text_hash'}->{'yes'}, "no", $self->{'text_hash'}->{'no'});
print $self->opt_input("admin_passwd", $self->{'text_hash'}->{'subs_passwd'}, $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 10);
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";
print "<tr>\n";
print $self->choice_input("moderate", $self->{'text_hash'}->{'subs_moderate'}, $self->{'conf'},
		    "yes", $self->{'text_hash'}->{'yes'}, "no", $self->{'text_hash'}->{'no'});
print $self->opt_input("moderator", $self->{'text_hash'}->{'subs_moderator'}, $self->{'conf'},
		 $self->{'text_hash'}->{'subs_maint'}, 20);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input("approve_passwd", $self->{'text_hash'}->{'subs_mpasswd'}, $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 10);
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";
$self->{'aliases_files'} = $self->get_aliases_file();
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	$self->{'owner'} = $a->{'value'}
		if (lc($a->{'name'}) eq lc("$self->{'in_hash'}->{'name'}-owner") ||
		    lc($a->{'name'}) eq lc("owner-$self->{'in_hash'}->{'name'}"));
	$self->{'approval'} = $a->{'value'}
		if (lc($a->{'name'}) eq lc("$self->{'in_hash'}->{'name'}-approval"));
	}
print "<tr> <td><b>$self->{'text_hash'}->{'subs_owner'}</b></td>\n";
print "<td><input name=owner size=20 value='$self->{'owner'}'></td>\n";

print "<td><b>$self->{'text_hash'}->{'subs_approval'}</b></td>\n";
print "<td><input name=approval size=20 value='$self->{'approval'}'></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("edit_list.cgi?name=$self->{'in_hash'}->{'name'}", $self->{'text_hash'}->{'edit_return'});

1;
		
}


1;

