#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_access.cgi
# Save access control options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->lock_file($self->{'list'}->{'config'});
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "get_access");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "index_access");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "info_access");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "intro_access");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "which_access");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "who_access");
$self->{'in_hash'}->{'adv'} =~ s/\r//g;
if ($self->{'in_hash'}->{'adv_mode'} == 0) {
	$self->{'adv'} = $self->{'noadv'} = "";
	}
elsif ($self->{'in_hash'}->{'adv_mode'} == 1) {
	$self->{'adv'} = $self->{'in_hash'}->{'adv'};
	$self->{'noadv'} = "";
	}
else {
	$self->{'adv'} = "";
	$self->{'noadv'} = $self->{'in_hash'}->{'adv'};
	}
$self->save_list_directive($self->{'conf'}, $self->{'list'}->{'config'}, "advertise", $self->{'adv'}, 1);
$self->save_list_directive($self->{'conf'}, $self->{'list'}->{'config'}, "noadvertise", $self->{'noadv'}, 1);
$self->save_list_directive($self->{'conf'}, $self->{'list'}->{'config'}, "restrict_post",
		     $self->{'in_hash'}->{'res_mode'} == 0 ? "" :
		     $self->{'in_hash'}->{'res_mode'} == 1 ? $self->{'in_hash'}->{'name'} :
					    $self->{'in_hash'}->{'res'});
$self->save_multi($self->{'conf'}, $self->{'list'}->{'config'}, "taboo_body");
$self->save_multi($self->{'conf'}, $self->{'list'}->{'config'}, "taboo_headers");
$self->flush_file_lines();
$self->unlock_file($self->{'list'}->{'config'});
$self->webmin_log("access", undef, $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}


1;

