#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save global majordomo options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'global_ecannot'});
$self->lock_file($self->{'config_hash'}->{'majordomo_cf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'global_err'});

# Check inputs
$self->{'in_hash'}->{'whereami'} =~ /^[A-z0-9\-\.]+$/ ||
	$self->error($self->{'text_hash'}->{'global_ewhereami'});
$self->{'in_hash'}->{'whoami'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'global_ewhoami'});
$self->{'in_hash'}->{'whoami_owner'} =~ /^\S+$/ ||
	$self->error($self->{'text_hash'}->{'global_eowner'});
-x $self->{'in_hash'}->{'sendmail_command'} ||
	$self->error($self->text('global_esendmail', "<tt>$self->{'in_hash'}->{'sendmail_command'}</tt>"));

# Save inputs
$self->save_directive($self->{'conf'}, "whereami", $self->{'in_hash'}->{'whereami'});
$self->save_directive($self->{'conf'}, "whoami", $self->{'in_hash'}->{'whoami'});
$self->save_directive($self->{'conf'}, "whoami_owner", $self->{'in_hash'}->{'whoami_owner'});
$self->save_directive($self->{'conf'}, "sendmail_command", $self->{'in_hash'}->{'sendmail_command'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'majordomo_cf'});
$self->webmin_log("global", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

