#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_subs.cgi
# Save subscription options

&ModuleLoader::preload_module('majordomo_class', "majordomo::MajordomoLib");
$self = new majordomo::MajordomoLib:: 'majordomo_class',%$self;

$self->ReadParse();
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->can_edit_list(\%{$self->{'access_hash'}}, $self->{'in_hash'}->{'name'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'list'} = $self->get_list($self->{'in_hash'}->{'name'}, $self->get_config());
$self->lock_file($self->{'list'}->{'config'});
$self->{'conf'} = $self->get_list_config($self->{'list'}->{'config'});
$self->save_list_directive($self->{'conf'}, $self->{'list'}->{'config'}, "subscribe_policy",
		     $self->{'in_hash'}->{'subscribe_policy'}.$self->{'in_hash'}->{'subscribe_policy_c'});
$self->save_list_directive($self->{'conf'}, $self->{'list'}->{'config'}, "unsubscribe_policy",
		     $self->{'in_hash'}->{'unsubscribe_policy'});
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "welcome");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "strip");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "announcements");
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "administrivia");
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "admin_passwd", \&check_pass);
$self->save_choice($self->{'conf'}, $self->{'list'}->{'config'}, "moderate");
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "moderator", \&check_email);
$self->save_opt($self->{'conf'}, $self->{'list'}->{'config'}, "approve_passwd", \&check_pass);

$self->{'in_hash'}->{'owner'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'subs_eowner'});
$self->{'in_hash'}->{'approval'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'subs_eapproval'});
$self->{'aliases_files'} = $self->get_aliases_file();
$self->foreign_call($self->{'aliases_module'}, "lock_alias_files", $self->{'aliases_files'});
@{$self->{'aliases_array'}} = $self->foreign_call($self->{'aliases_module'}, "list_aliases", $self->{'aliases_files'});
foreach $a (@{$self->{'aliases_array'}}) {
	$self->{'listowner'} = $a if (lc($a->{'name'}) eq lc("$self->{'in_hash'}->{'name'}-owner"));
	$self->{'ownerlist'} = $a if (lc($a->{'name'}) eq lc("owner-$self->{'in_hash'}->{'name'}"));
	$self->{'approval'} = $a if (lc($a->{'name'}) eq lc("$self->{'in_hash'}->{'name'}-approval"));
	}
$self->foreign_call('sendmail', 'modify_alias', $self->{'listowner'},
	      { 'name' => "$self->{'in_hash'}->{'name'}-owner",
		'values' => [ $self->{'in_hash'}->{'owner'} ],
		'enabled' => 1 }) if ($self->{'listowner'});
$self->foreign_call('sendmail', 'modify_alias', $self->{'ownerlist'},
	      { 'name' => "owner-$self->{'in_hash'}->{'name'}",
		'values' => [ $self->{'in_hash'}->{'owner'} ],
		'enabled' => 1 }) if ($self->{'ownerlist'});
$self->foreign_call('sendmail', 'modify_alias', $self->{'approval'},
	      { 'name' => "$self->{'in_hash'}->{'name'}-approval",
		'values' => [ $self->{'in_hash'}->{'approval'} ],
		'enabled' => 1 }) if ($self->{'approval'});
$self->foreign_call($self->{'aliases_module'}, "unlock_alias_files", $self->{'aliases_files'});

$self->flush_file_lines();
$self->unlock_file($self->{'list'}->{'config'});
$self->webmin_log("subs", undef, $self->{'in_hash'}->{'name'});
$self->redirect("edit_list.cgi?name=$self->{'in_hash'}->{'name'}");

1;
		
}

sub check_email
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'subs_emoderator'};
}

sub check_pass
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\S+$/ ? undef : $self->{'text_hash'}->{'subs_epasswd'};
}


1;

