#!/usr/bin/perl

&MAIN();

 sub MAIN {
# nfs_export.cgi
# Display a list of NFS exports on some host for the user to choose from

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->ReadParse();
$self->popup_header($self->text('nfs_choose', $self->{'in_hash'}->{'server'}));
print <<EOF;
<script>
function choose(f)
{
top.opener.ifield.value = f;
window.close();
}
</script>
EOF

if ($self->{'error'} = $self->exports_list($self->{'in_hash'}->{'server'}, \@{$self->{'dirs_array'}}, \@{$self->{'clients_array'}})) {
	print "<b>",$self->text('nfs_failed', $self->{'in_hash'}->{'server'},
			  "<p><tt>$self->{'error'}</tt><p>"),"</b>\n";
	exit;
	}
print "<b>$self->{'text_hash'}->{'nfs_seldir'}</b>\n";
if ($self->UNIVERSAL::can('nfs_max_version') && $self->nfs_max_version($self->{'in_hash'}->{'server'}) >= 4) {
	print "<br>$self->{'text_hash'}->{'nfs_seldirv4'}\n";
	}

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'nfs_dir'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'nfs_clients'}</b></td> </tr>\n";
for($i=0; $i<@{$self->{'dirs_array'}}; $i++) {
	print "<tr $self->{'cb'}>\n";
	print "<td><a href=\"\" onClick='choose(\"$self->{'dirs_array'}->[$i]\"); return false'>",
	      "$self->{'dirs_array'}->[$i]</a></td>\n";
	printf "<td>%s</td>\n",
		length($self->{'clients_array'}->[$i]) > 45 ?
			$self->html_escape(substr($self->{'clients_array'}->[$i], 0, 45))." ..." :
			$self->html_escape($self->{'clients_array'}->[$i]);
	print "</tr>\n";
	}
print "</table>\n";
$self->popup_footer();
1;
		
}


1;

