#!/usr/bin/perl

&MAIN();

 sub MAIN {
# smb_share.cgi
# Displays a list of shares available on some host

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->ReadParse();
$self->header($self->text('smb_choose2', $self->{'in_hash'}->{'server'}));
print <<EOF;
<script>
function choose(f)
{
top.opener.ifield.value = f;
window.close();
}
</script>
EOF

$self->execute_command("$self->{'config_hash'}->{'smbclient_path'} -d 0 -L $self->{'in_hash'}->{'server'} -N",
		 undef, \$self->{'out'}, \$self->{'out'});
if ($?) {
	print "<b>",$self->text('smb_elist2', $self->{'in_hash'}->{'server'}),"</b>\n";
	exit;
	}
elsif ($self->{'out'} =~ /Unknown host/) {
	print "<b>",$self->text('smb_ehost', $self->{'in_hash'}->{'server'}),"</b>\n";
	exit;
	}
elsif ($self->{'out'} =~ /error connecting|connect error/) {
	print "<b>",$self->text('smb_edown', $self->{'in_hash'}->{'server'}),"</b>\n";
	exit;
	}

if ($self->{'out'} =~ /Sharename\s+Type\s+Comment\n((.+\n)+)/) {
	@{$self->{'shlist_array'}} = split(/\n/, $1);
	foreach $sh (@{$self->{'shlist_array'}}) {
		if ($sh =~ /^\s+(.{1,7}\S+)\s+Disk\s*(.*)$/) {
			push(@{$self->{'names_array'}}, $1); push(@{$self->{'comms_array'}}, $2);
			}
		}
	}
if (@{$self->{'names_array'}}) {
	print "<b>$self->{'text_hash'}->{'smb_sel2'}</b><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'smb_share'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'smb_comment'}</b></td> </tr>\n";
	for($i=0; $i<@{$self->{'names_array'}}; $i++) {
		print "<tr $self->{'cb'}> <td><a href=\"\" ",
		      "onClick='choose(\"$self->{'names_array'}->[$i]\"); ".
		      "return false'>$self->{'names_array'}->[$i]</a></td>\n";
		printf "<td>%s</td> </tr>\n",
			$self->{'comms_array'}->[$i] =~ /\S/ ? $self->{'comms_array'}->[$i] : "<br>";
		}
	print "</table>\n";
	}
else {
	print "<b>",$self->text('smb_noshares', $self->{'in_hash'}->{'server'}),"</b>\n";
	}

$self->popup_footer();

1;
		
}


1;

