#!/usr/bin/perl

&MAIN();

 sub MAIN {
# unmount.cgi
# Unmount a currently mounted filesystem

&ModuleLoader::preload_module('mount_class', "mount::MountLib");
$self = new mount::MountLib:: 'mount_class',%$self;

$self->ReadParse();

@{$self->{'mounts_array'}} = $self->list_mounted();
$self->{'mount'} = $self->{'mounts_array'}->[$self->{'in_hash'}->{'index'}];
$self->error_setup($self->text('unmount_err', $self->{'mount'}->[0]));
$self->can_edit_fs(@{$self->{'mount'}}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'err'} = $self->unmount_dir(@{$self->{'mount'}});
$self->error($self->{'err'}) if ($self->{'err'});
$self->delete_unmounted(@{$self->{'mount'}});
$self->webmin_log("umount", undef, undef, { 'dev' => $self->{'mount'}->[0],
				      'type' => $self->{'mount'}->[2],
				      'dir' => $self->{'mount'}->[1] });
$self->redirect("");

1;
		
}


1;

