#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_tpriv.cgi
# Display a form for editing or creating new table permissions

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});
if ($self->{'in_hash'}->{'db'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'tpriv_title1'}, "", "create_tpriv");
	}
else {
	$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from tables_priv order by table_name");
	$self->{'u'} = $self->{'d'}->{'data'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'u'}->[1]) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'tpriv_title2'}, "", "edit_tpriv");
	}

print "<form action=save_tpriv.cgi>\n";
if ($self->{'in_hash'}->{'db'}) {
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	}
else {
	print "<input type=hidden name=oldhost value='$self->{'u'}->[0]'>\n";
	print "<input type=hidden name=olddb value='$self->{'u'}->[1]'>\n";
	print "<input type=hidden name=olduser value='$self->{'u'}->[2]'>\n";
	print "<input type=hidden name=oldtable value='$self->{'u'}->[3]'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'tpriv_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'tpriv_db'}</b></td>\n";
print "<td><tt>",$self->{'in_hash'}->{'db'} ? $self->{'in_hash'}->{'db'} : $self->{'u'}->[1],"</tt></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'tpriv_table'}</b></td>\n";
print "<td><select name=table>\n";
print "<option selected>\n" if ($self->{'in_hash'}->{'db'});
foreach $t ($self->list_tables($self->{'in_hash'}->{'db'} ? $self->{'in_hash'}->{'db'} : $self->{'u'}->[1])) {
	printf "<option %s>%s\n",
		$self->{'u'}->[3] eq $t ? 'selected' : '', $t;
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'tpriv_user'}</b></td> <td>\n";
printf "<input type=radio name=user_def value=1 %s> %s\n",
	$self->{'u'}->[2] ? '' : 'checked', $self->{'text_hash'}->{'tpriv_anon'};
printf "<input type=radio name=user_def value=0 %s>\n",
	$self->{'u'}->[2] ? 'checked' : '';
print "<input name=user size=10 value='$self->{'u'}->[2]'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'tpriv_host'}</b></td> <td>\n";
printf "<input type=radio name=host_def value=1 %s> %s\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? 'checked' : '', $self->{'text_hash'}->{'tpriv_any'};
printf "<input type=radio name=host_def value=0 %s>\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? '' : 'checked';
printf "<input name=host size=20 value='%s'></td> </tr>\n",
	$self->{'u'}->[0] eq '%' ? '' : $self->{'u'}->[0];

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tpriv_perms1'}</b></td>\n";
print "<td><select multiple size=4 name=perms1>\n";
foreach $p ('Select','Insert','Update','Delete','Create',
	    'Drop','Grant','References','Index','Alter',
	    ($self->{'mysql_version'} >= 5 ? ('Create View','Show view') : ( ))) {
	printf "<option %s>%s\n",
		$self->{'u'}->[6] =~ /$p/i ? 'selected' : '', $p;
	}
print "</select></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tpriv_perms2'}</b></td>\n";
print "<td><select multiple size=4 name=perms2>\n";
foreach $p ('Select','Insert','Update','References') {
	printf "<option %s>%s\n",
		$self->{'u'}->[7] =~ /$p/i ? 'selected' : '', $p;
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
if (!$self->{'in_hash'}->{'db'}) {
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer('list_tprivs.cgi', $self->{'text_hash'}->{'tprivs_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

