#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display a form for editing or creating a MySQL user

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} == 1 || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title1'}, "", "create_user");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'user_title2'}, "", "edit_user");
	if ($self->{'in_hash'}->{'user'}) {
		$self->{'d'} = $self->execute_sql_safe($self->{'master_db'},
				       "select * from user where user = ?",
				       $self->{'in_hash'}->{'user'});
		$self->{'u'} = $self->{'d'}->{'data'}->[0];
		}
	else {
		$self->{'d'} = $self->execute_sql_safe($self->{'master_db'},
				       "select * from user order by user");
		$self->{'u'} = $self->{'d'}->{'data'}->[$self->{'in_hash'}->{'idx'}];
		}
	}

print "<form action=save_user.cgi>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input type=hidden name=new value=1>\n";
	}
else {
	print "<input type=hidden name=olduser value='$self->{'u'}->[1]'>\n";
	print "<input type=hidden name=oldhost value='$self->{'u'}->[0]'>\n";
	}
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'user_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_user'}</b></td> <td>\n";
printf "<input type=radio name=mysqluser_def value=1 %s> %s\n",
	$self->{'u'}->[1] ? '' : 'checked', $self->{'text_hash'}->{'user_all'};
printf "<input type=radio name=mysqluser_def value=0 %s>\n",
	$self->{'u'}->[1] ? 'checked' : '';
print "<input name=mysqluser size=10 value='$self->{'u'}->[1]'></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_pass'}</b></td> <td>\n";
printf "<input type=radio name=mysqlpass_mode value=2 %s> %s\n",
	!$self->{'in_hash'}->{'new'} && !$self->{'u'}->[2] ? 'checked' : '', $self->{'text_hash'}->{'user_none'};
if (!$self->{'in_hash'}->{'new'}) {
	printf "<input type=radio name=mysqlpass_mode value=1 %s> %s\n",
		$self->{'u'}->[2] ? 'checked' : '', $self->{'text_hash'}->{'user_leave'};
	}
printf "<input type=radio name=mysqlpass_mode value=0 %s> %s\n",
	$self->{'in_hash'}->{'new'} ? 'checked' : '', $self->{'text_hash'}->{'user_set'};
print "<input name=mysqlpass type=password size=10></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'user_host'}</b></td> <td>\n";
printf "<input type=radio name=host_def value=1 %s> %s\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? 'checked' : '', $self->{'text_hash'}->{'user_any'};
printf "<input type=radio name=host_def value=0 %s>\n",
	$self->{'u'}->[0] eq '%' || $self->{'u'}->[0] eq '' ? '' : 'checked';
printf "<input name=host size=20 value='%s'></td> </tr>\n",
	$self->{'u'}->[0] eq '%' ? '' : $self->{'u'}->[0];

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'user_perms'}</b></td>\n";
print "<td><select name=perms multiple size=10>\n";
for($i=3; $i<=$self->user_priv_cols()+3-1; $i++) {
	printf "<option value=%d %s>%s\n",
		$i, $self->{'u'}->[$i] eq 'Y' ? 'selected' : '',
		$self->{'text_hash'}->{"user_priv$i"};
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";
if (!$self->{'in_hash'}->{'new'}) {
	print "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>\n";
	}
print "</form>\n";

$self->ui_print_footer('list_users.cgi', $self->{'text_hash'}->{'users_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

