#!/usr/bin/perl

&MAIN();

 sub MAIN {
# exec_file.cgi
# Execute some SQL commands from a file and display the output

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParseMime();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'access_hash'}->{'edonly'} && $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->error_setup($self->{'text_hash'}->{'exec_err'});

if ($self->{'in_hash'}->{'mode'}) {
	# From uploaded file
	$self->{'in_hash'}->{'upload'} || $self->error($self->{'text_hash'}->{'exec_eupload'});
	$self->{'file'} = $self->transname();
	open(TEMP, ">$self->{'file'}");
	print TEMP $self->{'in_hash'}->{'upload'};
	close(TEMP);
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	print "$self->{'text_hash'}->{'exec_uploadout'}<p>\n";
	$self->{'need_unlink'} = 1;
	}
else {
	# From local file
	-r $self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'exec_efile'});
	$self->{'file'} = $self->{'in_hash'}->{'file'};
	$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "");
	print $self->text('exec_fileout', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
	$self->{'need_unlink'} = 0;
	}

# Un-compress file if needed
$self->{'cf'} = $self->compression_format($self->{'file'});
$self->{'cmd'} = $self->{'cf'} == 1 ? "gunzip -c" :
       $self->{'cf'} == 2 ? "uncompress -C" :
       $self->{'cf'} == 3 ? "bunzip2 -c" : undef;
if ($self->{'cmd'}) {
	($self->{'prog'}, @{$self->{'args_array'}}) = split(/\s+/, $self->{'cmd'});
	$self->has_command($self->{'prog'}) ||
		$self->error($self->text('exec_ecompress', "<tt>$self->{'prog'}</tt>"));
	$self->{'tempfile'} = $self->transname();
	$self->{'out'} = $self->backquote_command("$self->{'cmd'} <$self->{'file'} 2>&1 >$self->{'tempfile'}");
	if ($?) {
		$self->error($self->text('exec_ecompress2', "<pre>$self->{'out'}</pre>"));
		}
	unlink($self->{'file'}) if ($self->{'need_unlink'});
	$self->{'file'} = $self->{'tempfile'};
	$self->{'need_unlink'} = 1;
	}

print "<pre>";
($self->{'ex'}, $self->{'out'}) = $self->execute_sql_file($self->{'in_hash'}->{'db'}, $self->{'file'});
print $self->html_escape($self->{'out'});
$self->{'got'}++ if ($self->{'out'} =~ /\S/);
print "<i>$self->{'text_hash'}->{'exec_noout'}</i>\n" if (!$self->{'got'});
print "</pre>\n";
$self->webmin_log("execfile", undef, $self->{'in_hash'}->{'db'}, { 'mode' => $self->{'in_hash'}->{'mode'},
					    'file' => $self->{'in_hash'}->{'file'} });
unlink($self->{'file'}) if ($self->{'need_unlink'});

$self->ui_print_footer("exec_form.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'exec_return'},
	"edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

