#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_dbs.cgi
# Display database-level permissions

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'dbs_title'}, "", "dbs");

@{$self->{'rowlinks_array'}} = ( "<a href='edit_db.cgi?new=1'>$self->{'text_hash'}->{'dbs_add'}</a>" );
$self->{'d'} = $self->execute_sql_safe($self->{'master_db'}, "select * from db order by db");
if (@{$self->{'d'}->{'data'}}) {
	print $self->ui_form_start("delete_dbs.cgi");
	unshift(@{$self->{'rowlinks_array'}}, $self->select_all_link("d", 0),
			   $self->select_invert_link("d", 0) );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'dbs_db'},
				  $self->{'text_hash'}->{'dbs_user'},
				  $self->{'text_hash'}->{'dbs_host'},
				  $self->{'text_hash'}->{'dbs_perms'} ], 100, 0, \@{$self->{'tds_array'}});
	$self->{'i'} = -1;
	foreach $u (@{$self->{'d'}->{'data'}}) {
		$self->{'i'}++;
		next if ($self->{'access_hash'}->{'perms'} == 2 && !$self->can_edit_db($u->[1]));
		local @cols;
		push(@cols, "<a href='edit_db.cgi?idx=$self->{'i'}'>".
			($u->[1] eq '%' || $u->[1] eq '' ? $self->{'text_hash'}->{'dbs_any'}
					: $self->html_escape($u->[1]))."</a>");
		push(@cols, $u->[2] eq '' ? $self->{'text_hash'}->{'dbs_anon'}
					    : $self->html_escape($u->[2]));
		push(@cols, $u->[0] eq '%' ? $self->{'text_hash'}->{'dbs_any'} :
			    $u->[0] eq '' ? $self->{'text_hash'}->{'dbs_hosts'}
					  : $self->html_escape($u->[0]));
		local @priv;
		for($j=3; $j<=$self->db_priv_cols()+3-1; $j++) {
			push(@priv, $self->{'text_hash'}->{"dbs_priv$j"}) if ($u->[$j] eq 'Y');
			}
		push(@cols, 
			scalar(@priv) == $self->db_priv_cols() ? $self->{'text_hash'}->{'dbs_all'} :
			!@priv ? $self->{'text_hash'}->{'dbs_none'} : join("&nbsp;| ", @priv));
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}},
				"d", join(" ", $u->[0], $u->[1], $u->[2]));
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'dbs_empty'}</b> <p>\n";
	}
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'users_delete'} ]]) if (@{$self->{'d'}->{'data'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

