#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cpriv.cgi
# Save, update or delete field permissions

&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'perms'} || $self->error($self->{'text_hash'}->{'perms_ecannot'});

if ($self->{'in_hash'}->{'delete'}) {
	# Delete some permissions
	$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
		$self->error($self->{'text_hash'}->{'perms_edb'});
	$self->execute_sql_logged($self->{'master_db'},
		"delete from columns_priv where user = '$self->{'in_hash'}->{'olduser'}' ".
		"and host = '$self->{'in_hash'}->{'oldhost'}' and db = '$self->{'in_hash'}->{'olddb'}' ".
		"and table_name = '$self->{'in_hash'}->{'oldtable'}' ".
		"and column_name = '$self->{'in_hash'}->{'oldfield'}'");
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'cpriv_err'});
	$self->{'in_hash'}->{'field'} || $self->error($self->{'text_hash'}->{'cpriv_efield'});
	$self->{'in_hash'}->{'user_def'} || $self->{'in_hash'}->{'user'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'cpriv_euser'});
	$self->{'in_hash'}->{'host_def'} || $self->{'in_hash'}->{'host'} =~ /^\S+$/ ||
		$self->error($self->{'text_hash'}->{'cpriv_ehost'});
	$self->{'in_hash'}->{'perms'} =~ s/\0/,/g;

	if ($self->{'in_hash'}->{'table'}) {
		# Create new column permissions
		($self->{'d'}, $self->{'t'}) = split(/\./, $self->{'in_hash'}->{'table'});
		$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'d'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->{'sql'} = sprintf "insert into columns_priv values ('%s', '%s', ".
			       "'%s', '%s', '%s', NULL, '%s')",
				$self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'}, $self->{'d'},
				$self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
				$self->{'t'}, $self->{'in_hash'}->{'field'}, $self->{'in_hash'}->{'perms'};
		}
	else {
		# Update existing column permissions
		$self->{'access_hash'}->{'perms'} == 1 || $self->can_edit_db($self->{'in_hash'}->{'olddb'}) ||
			$self->error($self->{'text_hash'}->{'perms_edb'});
		$self->{'sql'} = sprintf "update columns_priv set host = '%s', ".
			       "user = '%s', column_name = '%s', ".
			       "column_priv = '%s' where host = '%s' ".
			       "and db = '%s' and user = '%s' ".
			       "and table_name = '%s' and column_name = '%s'",
				$self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
				$self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
				$self->{'in_hash'}->{'field'}, $self->{'in_hash'}->{'perms'},
				$self->{'in_hash'}->{'oldhost'}, $self->{'in_hash'}->{'olddb'},
				$self->{'in_hash'}->{'olduser'}, $self->{'in_hash'}->{'oldtable'},
				$self->{'in_hash'}->{'oldfield'};
		}
	$self->execute_sql_logged($self->{'master_db'}, $self->{'sql'});
	}
$self->execute_sql_logged($self->{'master_db'}, 'flush privileges');
if ($self->{'in_hash'}->{'delete'}) {
	$self->webmin_log("delete", "cpriv", $self->{'in_hash'}->{'oldtable'},
		    { 'user' => $self->{'in_hash'}->{'olduser'}, 'host' => $self->{'in_hash'}->{'oldhost'},
		      'db' => $self->{'in_hash'}->{'olddb'}, 'table' => $self->{'in_hash'}->{'oldtable'},
		      'field' => $self->{'in_hash'}->{'oldfield'} } );
	}
elsif ($self->{'in_hash'}->{'table'}) {
	$self->webmin_log("create", "cpriv", $self->{'in_hash'}->{'table'},
		    { 'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
		      'db' => $self->{'d'}, 'table' => $self->{'t'}, 'field' => $self->{'in_hash'}->{'field'} } );
	}
else {
	$self->webmin_log("modify", "cpriv", $self->{'in_hash'}->{'table'},
		    { 'user' => $self->{'in_hash'}->{'user_def'} ? '' : $self->{'in_hash'}->{'user'},
		      'host' => $self->{'in_hash'}->{'host_def'} ? '%' : $self->{'in_hash'}->{'host'},
		      'db' => $self->{'in_hash'}->{'olddb'}, 'table' => $self->{'in_hash'}->{'oldtable'},
		      'field' => $self->{'in_hash'}->{'field'} } );
	}
$self->redirect("list_cprivs.cgi");

1;
		
}


1;

