#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show form for searching a table, using multiple fields

if (-r 'mysql-lib.pl') {
	&ModuleLoader::preload_module('mysql_class', "mysql::MysqlLib");
$self = new mysql::MysqlLib:: 'mysql_class',%$self;

	}
else {
	require './postgresql-lib.pl';
	}
&ModuleLoader::preload_module('mysql_class', "mysql::ViewLib");
$self = new mysql::ViewLib:: 'mysql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'str_array'}} = $self->table_structure($self->{'in_hash'}->{'db'}, $self->{'in_hash'}->{'table'});

$self->{'desc'} = $self->text('table_header', "<tt>$self->{'in_hash'}->{'table'}</tt>", "<tt>$self->{'in_hash'}->{'db'}</tt>");
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'adv_title'}, "");

print $self->ui_form_start("view_table.cgi", "post");
print $self->ui_hidden("db", $self->{'in_hash'}->{'db'});
print $self->ui_hidden("table", $self->{'in_hash'}->{'table'});

print $self->ui_radio("and", 1, [ [ 0, $self->{'text_hash'}->{'adv_or'} ],
			    [ 1, $self->{'text_hash'}->{'adv_and'} ] ]),"<p>\n";
print "<table>\n";
for($i=0; $i<10; $i++) {
	print "<tr>\n";
	print "<td>",$self->ui_select("field_$i", "",
		[ [ "", "&nbsp;" ],
		  map { [ $_->{'field'}, $_->{'field'} ] } @{$self->{'str_array'}} ]),"</td>\n";
	print "<td>",$self->ui_select("match_$i", 0,
		[ map { [ $_, $self->{'text_hash'}->{'view_match'.$_} ] } (0.. 3) ]),"</td>\n";
	print "<td>",$self->ui_textbox("for_$i", undef, 30),"</td>\n";
	print "</tr>\n";
	}
print "</table>\n";
print $self->ui_form_end([ [ "advanced", $self->{'text_hash'}->{'adv_ok'} ] ]);

if ($self->{'access_hash'}->{'edonly'}) {
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}",$self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
else {
	$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}",
		$self->{'text_hash'}->{'table_return'},
		"edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

