#!/usr/bin/perl
package net::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'net::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "net::NetLib");
$self = new net::NetLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the net module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_ifcs'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=ifcs value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'ifcs'} == 2 ? "checked" : "";
printf "<input type=radio name=ifcs value=1 %s> $self->{'text_hash'}->{'acl_view'}\n",
	$_[0]->{'ifcs'} == 1 ? "checked" : "";
printf "<input type=radio name=ifcs value=0 %s> $self->{'text_hash'}->{'no'}<br>\n",
	$_[0]->{'ifcs'} ? "" : "checked";
printf "<input type=radio name=ifcs value=3 %s> $self->{'text_hash'}->{'acl_ifcs_only'}\n",
	$_[0]->{'ifcs'} == 3 ? "checked" : "";
print "<input name=interfaces3 size=30 value='".$_[0]->{'interfaces'}."'> ",
	$self->interfaces_chooser_button("interfaces", 1),"<br>\n";
printf "<input type=radio name=ifcs value=4 %s> $self->{'text_hash'}->{'acl_ifcs_ex'}\n",
	$_[0]->{'ifcs'} == 4 ? "checked" : "";
print "<input name=interfaces4 size=30 value='".$_[0]->{'interfaces'}."'> ",
	$self->interfaces_chooser_button("interfaces", 1),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_bootonly'}</b></td>\n";
print "<td>",$self->ui_radio("bootonly", $_[0]->{'bootonly'},
		 [ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_netmask'}</b></td>\n";
print "<td>",$self->ui_radio("netmask", $_[0]->{'netmask'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_broadcast'}</b></td>\n";
print "<td>",$self->ui_radio("broadcast", $_[0]->{'broadcast'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_mtu'}</b></td>\n";
print "<td>",$self->ui_radio("mtu", $_[0]->{'mtu'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_up'}</b></td>\n";
print "<td>",$self->ui_radio("up", $_[0]->{'up'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_virt'}</b></td>\n";
print "<td>",$self->ui_radio("virt", $_[0]->{'virt'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_delete'}</b></td>\n";
print "<td>",$self->ui_radio("delete", $_[0]->{'delete'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'acl_hide'}</b></td>\n";
print "<td>",$self->ui_radio("hide", $_[0]->{'hide'},
		 [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_routes'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=routes value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'routes'} == 2 ? "checked" : "";
printf "<input type=radio name=routes value=1 %s> $self->{'text_hash'}->{'acl_view'}\n",
	$_[0]->{'routes'} == 1 ? "checked" : "";
printf "<input type=radio name=routes value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'routes'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_dns'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=dns value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'dns'} == 2 ? "checked" : "";
printf "<input type=radio name=dns value=1 %s> $self->{'text_hash'}->{'acl_view'}\n",
	$_[0]->{'dns'} == 1 ? "checked" : "";
printf "<input type=radio name=dns value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'dns'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_hosts'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=hosts value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'hosts'} == 2 ? "checked" : "";
printf "<input type=radio name=hosts value=1 %s> $self->{'text_hash'}->{'acl_view'}\n",
	$_[0]->{'hosts'} == 1 ? "checked" : "";
printf "<input type=radio name=hosts value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'hosts'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_apply'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=apply value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'apply'} == 1 ? "checked" : "";
printf "<input type=radio name=apply value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'apply'} ? "" : "checked";
}

# acl_security_save(&options)
# Parse the form for security options for the file module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'ifcs'} = $self->{'in_hash'}->{'ifcs'};
$_[0]->{'routes'} = $self->{'in_hash'}->{'routes'};
$_[0]->{'dns'} = $self->{'in_hash'}->{'dns'};
$_[0]->{'hosts'} = $self->{'in_hash'}->{'hosts'};
$_[0]->{'interfaces'} = $self->{'in_hash'}->{'ifcs'} == 3 ? $self->{'in_hash'}->{'interfaces3'} :
			$self->{'in_hash'}->{'ifcs'} == 4 ? $self->{'in_hash'}->{'interfaces4'} : undef;
$_[0]->{'apply'} = $self->{'in_hash'}->{'apply'};
$_[0]->{'bootonly'} = $self->{'in_hash'}->{'bootonly'};
$_[0]->{'netmask'} = $self->{'in_hash'}->{'netmask'};
$_[0]->{'broadcast'} = $self->{'in_hash'}->{'broadcast'};
$_[0]->{'mtu'} = $self->{'in_hash'}->{'mtu'};
$_[0]->{'up'} = $self->{'in_hash'}->{'up'};
$_[0]->{'virt'} = $self->{'in_hash'}->{'virt'};
$_[0]->{'delete'} = $self->{'in_hash'}->{'delete'};
$_[0]->{'hide'} = $self->{'in_hash'}->{'hide'};
}


1;

