#!/usr/bin/perl

&MAIN();

 sub MAIN {
# De-activate a bunch of active interfaces

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'daifcs_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'daifcs_enone'});

# Do the deletion, one by one
@{$self->{'acts_array'}} = $self->active_interfaces();
foreach $d (@d) {
	($self->{'a'}) = grep { $_->{'fullname'} eq $d } @{$self->{'acts_array'}};
	$self->{'a'} || $self->error($self->{'text_hash'}->{'daifcs_egone'});
	$self->can_iface($self->{'a'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
	$self->deactivate_interface($self->{'a'});
	}

$self->webmin_log("delete", "aifcs", scalar(@d));
$self->redirect("list_ifcs.cgi");

1;
		
}


1;

