#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete some boot-time interfaces, and perhaps de-activate them too

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'in_hash'}->{'apply'} ? $self->{'text_hash'}->{'dbifcs_err2'} : $self->{'text_hash'}->{'dbifcs_err'});
@d = split(/\0/, $self->{'in_hash'}->{'b'});
@d || $self->error($self->{'text_hash'}->{'daifcs_enone'});

# Do the deletes
@{$self->{'boot_array'}} = $self->boot_interfaces();
@{$self->{'active_array'}} = $self->active_interfaces();
foreach $d (reverse(@d)) {
	($self->{'b'}) = grep { $_->{'fullname'} eq $d } @{$self->{'boot_array'}};
	$self->{'b'} || $self->error($self->{'text_hash'}->{'daifcs_egone'});
	$self->can_iface($self->{'b'}) || $self->error($self->{'text_hash'}->{'ifcs_ecannot_this'});
	if ($self->{'in_hash'}->{'apply'}) {
		# Make this interface active
		$self->activate_interface($self->{'b'});
		}
	else {
		# Deleting
		if ($self->{'in_hash'}->{'deleteapply'}) {
			# De-activate first
			($self->{'act'}) = grep { $_->{'fullname'} eq $self->{'b'}->{'fullname'} }
				      @{$self->{'active_array'}};
			if ($self->{'act'}) {
				if ($self->UNIVERSAL::can('unapply_interface')) {
					$self->{'err'} = $self->unapply_interface($self->{'act'});
					$self->{'err'} && $self->error("<pre>$self->{'err'}</pre>");
					}
				else {
					$self->deactivate_interface($self->{'act'});
					}
				}
			}

		# Delete config
		$self->delete_interface($self->{'b'});
		}
	}

$self->webmin_log($self->{'in_hash'}->{'apply'} ? "apply" : "delete", "bifcs", scalar(@d));
$self->redirect("list_ifcs.cgi");

1;
		
}


1;

