#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_dns.cgi
# Display the DNS client configuration

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'dns'} || $self->error($self->{'text_hash'}->{'dns_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'dns_title'}, "");

$self->{'dns'} = $self->get_dns_config();
print "<form action=save_dns.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'dns_options'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'dns_hostname'}</b></td>\n";
printf "<td><input name=hostname size=20 value=\"%s\"></td>\n",
	$self->get_hostname();

$self->{'order'} = $self->order_input($self->{'dns'});
if ($self->{'order'}) {
	print "<td><b>$self->{'text_hash'}->{'dns_order'}</b></td>\n";
	print "<td>$self->{'order'}</td> </tr>\n";
	}

# Find hostname in /etc/hosts
@{$self->{'hosts_array'}} = $self->list_hosts();
foreach $h (@{$self->{'hosts_array'}}) {
	foreach $n (@{$h->{'hosts'}}) {
		$self->{'found'}++ if ($n eq $self->get_hostname());
		}
	}
if ($self->{'found'}) {
	print "<tr> <td></td>\n";
	print "<td colspan=3><input type=checkbox name=hosts value=1 checked> ",
	      "$self->{'text_hash'}->{'dns_hoststoo'}</td> </tr>\n";
	}

# Check if hostname is set from DHCP
# XXX not done yet
#$dhost = defined(&get_dhcp_hostname) ? &get_dhcp_hostname() : -1;
#if ($dhost != -1) {
#	print "<tr> <td></td>\n";
#	print "<td>",&ui_checkbox("dhcp", 1, $self->{'text_hash'}->{'dns_dhcp'}, $dhost),
#	      "</td> </tr>\n";
#	}

print "<tr> <td valign=top><b>";
print "$self->{'dns'}->{'name'}[0] " if $self->{'dns'}->{'name'};
print "$self->{'text_hash'}->{'dns_servers'}</b></td> <td valign=top>\n";
print "<input type=hidden name=name0 value=\"$self->{'dns'}->{'name'}[0]\">\n"
    if $self->{'dns'}->{'name'};
for($i=0; $i<$self->{'max_dns_servers'}; $i++) {
	printf "<input name=nameserver_$i size=15 value=\"%s\"><br>\n",
		$self->{'dns'}->{'nameserver'}->[$i];
	}
print "</td>\n";

if (@{$self->{'dns'}->{'name'}} > 1) {
    for ($j=1; $j<@{$self->{'dns'}->{'name'}}; $j++) {
	print "<td valign=top><b>";
	print "$self->{'dns'}->{'name'}[$j] ";
	print "$self->{'text_hash'}->{'dns_servers'}</b></td> <td valign=top>\n";
	print "<input type=hidden name=name$j value=\"$self->{'dns'}->{'name'}[$j]\">\n";
	for ($i=0; $i<$self->{'max_dns_servers'}; $i++) {
	    printf "<input name=nameserver${j}_$i size=15 value=\"%s\"><br>\n",
		$self->{'dns'}->{"nameserver$j"}->[$i];
	}
	print "</td>\n";
    }
}

print "<td valign=top><b>$self->{'text_hash'}->{'dns_search'}</b></td> <td valign=top>\n";
printf "<input type=radio name=domain_def value=1 %s> $self->{'text_hash'}->{'dns_none'}\n",
	$self->{'dns'}->{'domain'} ? "" : "checked";
printf "<input type=radio name=domain_def value=0 %s> $self->{'text_hash'}->{'dns_listed'}\n",
	$self->{'dns'}->{'domain'} ? "checked" : "";
print "<br><textarea name=domain rows=3 cols=30>",
	join("\n", @{$self->{'dns'}->{'domain'}}),"</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n"
	if ($self->{'access_hash'}->{'dns'} == 2);
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

