#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_hosts.cgi
# List hosts from /etc/hosts

&ModuleLoader::preload_module('net_class', "net::NetLib");
$self = new net::NetLib:: 'net_class',%$self;

$self->{'access_hash'}->{'hosts'} || $self->error($self->{'text_hash'}->{'hosts_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'hosts_title'}, "");

if ($self->{'access_hash'}->{'hosts'} == 2) {
	print $self->ui_form_start("delete_hosts.cgi", "post");
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d"),
		   "<a href=\"edit_host.cgi?new=1\">$self->{'text_hash'}->{'hosts_add'}</a>" );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	@{$self->{'tds_array'}} = ( "width=5" );
	}
print $self->ui_columns_start([ $self->{'access_hash'}->{'hosts'} == 2 ? ( "" ) : ( ),
			  $self->{'text_hash'}->{'hosts_ip'},
			  $self->{'text_hash'}->{'hosts_host'} ], undef, 0, \@{$self->{'tds_array'}});
foreach $h ($self->list_hosts()) {
	local @cols;
	if ($self->{'access_hash'}->{'hosts'} == 2) {
		push(@cols, "<a href=\"edit_host.cgi?idx=$h->{'index'}\">".
			    $self->html_escape($h->{'address'})."</a>");
		}
	else {
		push(@cols, $self->html_escape($h->{'address'}));
		}
	push(@cols, join(" , ", map { $self->html_escape($_) }
				    @{$h->{'hosts'}}));
	if ($self->{'access_hash'}->{'hosts'} == 2) {
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d",$h->{'index'});
		}
	else {
		print $self->ui_columns_row(\@cols);
		}
	}
print $self->ui_columns_end();
if ($self->{'access_hash'}->{'hosts'} == 2) {
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'hosts_delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

