#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_security.cgi
# Show NIS server security options

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'security_title'}, "");

if ($self->get_server_mode() == 0 || !($self->get_nis_support() & 2)) {
	print "<p>$self->{'text_hash'}->{'security_enis'}<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}

print "<form action=save_security.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'security_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'config_hash'}->{'securenets'}) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'security_nets'}</b></td>\n";
	print "<td><table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'security_mask'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'security_net'}</b></td> </tr>\n";
	open(NETS, $self->{'config_hash'}->{'securenets'});
	while(<NETS>) {
		s/#.*$//;
		if (/(\S+)\s+(\S+)/) {
			push(@{$self->{'nets_array'}}, [ $1 eq '255.255.255.255' ? 1 :
				      $1 eq 'host' ? 1 :
				      $1 eq '0.0.0.0' ? 2 : 0, $1, $2 ]);
			}
		}
	close(NETS);
	local $i = 0;
	foreach $n (@{$self->{'nets_array'}}, [ -1, "", "" ]) {
		print "<tr $self->{'cb'}>\n";
		printf "<td><input type=radio name=def_$i value=-1 %s> %s\n",
			$n->[0] == -1 ? 'checked' : '', $self->{'text_hash'}->{'security_none'};
		printf "<input type=radio name=def_$i value=2 %s> %s\n",
			$n->[0] == 2 ? 'checked' : '', $self->{'text_hash'}->{'security_any'};
		printf "<input type=radio name=def_$i value=1 %s> %s\n",
			$n->[0] == 1 ? 'checked' : '', $self->{'text_hash'}->{'security_single'};
		printf "<input type=radio name=def_$i value=0 %s> %s\n",
			$n->[0] == 0 ? 'checked' : '', $self->{'text_hash'}->{'security_mask'};
		printf "<input name=mask_$i size=15 value='%s'></td>\n",
			$n->[0] == 0 ? $n->[1] : '';
		printf "<td><input name=net_$i size=15 value='%s'></td>\n",
			$n->[0] == 2 ? "" : $n->[2];
		print "</tr>\n";
		$i++;
		}
	print "</table></td></tr>\n";
	}

$self->show_server_security();

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'security_ok'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

