#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for NIS functions

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", undef, 1, 1, 0,
	$self->help_search_link("NIS", "man", "howto"));

if (!$self->get_nis_support()) {
	print "<p><b>$self->{'text_hash'}->{'index_enis'} $self->{'text_hash'}->{'index_enis2'}</b><p>\n";
	}

@{$self->{'icons_array'}} =  ( "images/client.gif", "images/switch.gif",
	    "images/server.gif", "images/tables.gif",
	    "images/security.gif" );
@{$self->{'titles_array'}} = ( $self->{'text_hash'}->{'client_title'}, $self->{'text_hash'}->{'switch_title'},
	    $self->{'text_hash'}->{'server_title'}, $self->{'text_hash'}->{'tables_title'},
	    $self->{'text_hash'}->{'security_title'} );
@{$self->{'links_array'}} =  ( "edit_client.cgi", "list_switches.cgi",
	    "edit_server.cgi", "edit_tables.cgi",
	    "edit_security.cgi" );
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 5);

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

