#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show services in nsswitch.conf, with links to edit them

if (-r 'ldap-client-lib.pl') {
	require './ldap-client-lib.pl';
	}
else {
	&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

	}
&ModuleLoader::preload_module('nis_class', "nis::SwitchLib");
$self = new nis::SwitchLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'switch_title'}, "",
		 $self->{'module_name'} eq "nis" ? undef : "switch");

print $self->ui_columns_start([ $self->{'text_hash'}->{'switch_service'},
			  $self->{'text_hash'}->{'switch_srcs'} ], undef, 0,
			[ "nowrap", "nowrap" ]);
$self->{'conf'} = $self->get_nsswitch_config();
foreach $s (@{$self->{'conf'}}) {
	$self->{'srcs'} = join(", ", map { $self->{'text_hash'}->{'order_'.$_->{'src'}} } @{$s->{'srcs'}});
	$self->{'name'} = $self->{'text_hash'}->{'desc_'.$s->{'name'}} || $s->{'name'};
	print $self->ui_columns_row([
		"<a href='edit_switch.cgi?name=$s->{'name'}'>$self->{'name'}</a>",
		$self->{'srcs'},
		]);
	}
print $self->ui_columns_end();

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

