#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_switch.cgi
# Display client service switches

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'switch_title'}, "");
@{$self->{'switch_array'}} = $self->get_nsswitch_conf();

print "<form action=save_switch.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'switch_service'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'switch_order'}</b></td> </tr>\n";

foreach $s (@{$self->{'switch_array'}}) {
	local @o = split(/\s+/, $s->{'order'});
	$self->{'max'} = @o if (@o > $self->{'max'});
	}

foreach $s (@{$self->{'switch_array'}}) {
	local $sv = $s->{'service'};
	print "<tr $self->{'cb'}>\n";
	print "<td><b>",$self->{'text_hash'}->{"desc_$sv"} ? $self->{'text_hash'}->{"desc_$sv"} :
			$s->{'service'},"</b></td> <td>\n";
	if ($s->{'order'} =~ /\[/) {
		print "<input name=order_$sv size=60 value='$s->{'order'}'>\n";
		}
	else {
		local @o = split(/\s+/, $s->{'order'});
		local @sources = ("");
		if ($self->UNIVERSAL::can('switch_sources')) {
			push(@sources, $self->switch_sources());
			}
		else {
			push(@sources, split(/\s+/, $self->{'config_hash'}->{'sources'}));
			}
		print "<table width=100% cellpadding=0 cellspacing=0><tr>\n";
		for($i=1; $i<=$self->{'max'}+1; $i++) {
			print "<td><select name=order_${sv}_${i}>\n";
			foreach $sc (@sources) {
				if ($sc =~ /(\S+)=(\S+)/ && $1 eq $sv) {
					printf "<option value='%s' %s>%s\n",
					    $2,
					    $o[$i-1] eq $2 ? 'selected' : '',
					    $self->{'text_hash'}->{"order_$2"};
					}
				elsif ($sc !~ /=/) {
					printf "<option value='%s' %s>%s\n",
					    $sc,
					    $o[$i-1] eq $sc ? 'selected' : '',
					    $self->{'text_hash'}->{"order_$sc"};
					}
				}
			print "</select></td>";
			}
		print "</tr></table>\n";
		}
	push(@{$self->{'list_array'}}, $sv);
	print "</td> </tr>\n";
	}
print "</table>\n";
printf "<input type=hidden name=list value='%s'>\n",
	join(" ", @{$self->{'list_array'}});
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

