#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ethers.cgi
# Create, update or delete an ethernet address

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'ether'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the ether
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the host
	$self->error_setup($self->{'text_hash'}->{'ethers_err'});
	lc($self->{'in_hash'}->{'mac'}) =~ /^([0-9a-f]{2}:){5}[0-9a-f]{2}$/ ||
		$self->error($self->{'text_hash'}->{'ethers_emac'});
	gethostbyname($self->{'in_hash'}->{'ip'}) || $self->error($self->{'text_hash'}->{'ethers_eip'});
	@{$self->{'ether_array'}} = ( $self->{'in_hash'}->{'mac'}, $self->{'in_hash'}->{'ip'} );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, "\t", \@{$self->{'ether_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, "\t", \@{$self->{'ether_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

