#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_netgroup.cgi
# Create, update or delete a netgroup

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'netgroup'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the netgroup
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the netgroup
	$self->error_setup($self->{'text_hash'}->{'netgroup_err'});
	$self->{'in_hash'}->{'name'} =~ /^[A-Za-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'netgroup_ename'});
	@{$self->{'netgroup_array'}} = ( $self->{'in_hash'}->{'name'} );
	HOST: for($i=0; defined($self->{'in_hash'}->{"host_$i"}); $i++) {
		local @h;
		foreach $v ('host', 'user', 'dom') {
			if ($self->{'in_hash'}->{"${v}_def_$i"} == 1) { push(@h, ""); }
			elsif ($self->{'in_hash'}->{"${v}_def_$i"} == 2) { next HOST; }
			elsif ($self->{'in_hash'}->{"${v}_$i"} !~ /^\S+$/) {
				$self->error($self->text("netgroup_e$v", $i+1));
				}
			else { push(@h, $self->{'in_hash'}->{"${v}_$i"}); }
			}
		push(@{$self->{'netgroup_array'}}, "($h[0],$h[1],$h[2])");
		}
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, "\t", \@{$self->{'netgroup_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, "\t", \@{$self->{'netgroup_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

