#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_netmasks.cgi
# Create, update or delete a netmask

&ModuleLoader::preload_module('nis_class', "nis::NisLib");
$self = new nis::NisLib:: 'nis_class',%$self;

$self->ReadParse();

($self->{'t'}, $self->{'lnums'}, $self->{'netmask'}) = $self->table_edit_setup($self->{'in_hash'}->{'table'}, $self->{'in_hash'}->{'line'}, '\s+');
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the ether
	$self->table_delete($self->{'t'}, $self->{'lnums'});
	}
else {
	# Validate inputs and save the host
	$self->error_setup($self->{'text_hash'}->{'netmasks_err'});
	$self->check_ipaddress($self->{'in_hash'}->{'net'}) || $self->error($self->{'text_hash'}->{'netmasks_enet'});
	$self->check_ipaddress($self->{'in_hash'}->{'mask'}) || $self->error($self->{'text_hash'}->{'netmasks_emask'});
	@{$self->{'netmask_array'}} = ( $self->{'in_hash'}->{'net'}, $self->{'in_hash'}->{'mask'} );
	if ($self->{'in_hash'}->{'line'} eq '') {
		$self->table_add($self->{'t'}, "\t", \@{$self->{'netmask_array'}});
		}
	else {
		$self->table_update($self->{'t'}, $self->{'lnums'}, "\t", \@{$self->{'netmask_array'}});
		}
	}
$self->apply_table_changes() if (!$self->{'config_hash'}->{'manual_build'});
$self->redirect("edit_tables.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

