#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# An OpenSLP webmin module
# by Monty Charlton <monty@caldera.com>,
#
# Copyright (c) 2000 Caldera Systems
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#

&ModuleLoader::preload_module('openslp_class', "openslp::SlpLib");
$self = new openslp::SlpLib:: 'openslp_class',%$self;

$self->ReadParse();

local @scopes, @daaddr;
local $val = "";

# Process List Items
for($i=0; $i<3; $i++) {
	if (!$self->{'in_hash'}->{'useScopes'}) {
		push(@scopes, $val) if ($val=$self->{'in_hash'}->{"useScopesValue_$i"});
		}
	if (!$self->{'in_hash'}->{'DAAddresses'}) {
		push(@daaddr, $val) if ($val=$self->{'in_hash'}->{"DAAddressesValue_$i"});
		}
}
if (!$self->{'in_hash'}->{'useScopes'}) {
	$self->enable_list_line(@scopes,'useScopes');
	}
else {
	$self->disable_line('useScopes');
	}

if (!$self->{'in_hash'}->{'DAAddresses'}) {
	$self->enable_list_line(@daaddr,'DAAddresses');
	}
else {
	$self->disable_line('DAAddresses');
	}

$self->restart();
$self->redirect("");

1;
		
}


1;

