#!/usr/bin/perl
package pam::Pam_tallyso;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pam::Pam_tallyso');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# display args for pam_tally.so.pl

1;
		return $self;
}

# display_args(&service, &module, &args)
sub display_module_args
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'tally_deny'}</b></td>\n";
printf "<td nowrap><input type=radio name=deny_def value=1 %s> %s\n",
	$_[2]->{'deny'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=deny_def value=0 %s>\n",
	$_[2]->{'deny'} ? 'checked' : '';
print "<input name=deny size=5 value='$_[2]->{'deny'}'></td>\n";

print "<td><b>$self->{'text_hash'}->{'tally_reset'}</b></td>\n";
printf "<td><input type=radio name=reset value=0 %s> %s\n",
	defined($_[2]->{'reset'}) || defined($_[2]->{'no_reset'}) ?
	'' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=reset value=1 %s> %s\n",
	defined($_[2]->{'reset'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=reset value=2 %s> %s</td> </tr>\n",
	defined($_[2]->{'no_reset'}) ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'tally_magic'}</b></td>\n";
printf "<td><input type=radio name=magic value=1 %s> %s\n",
	defined($_[2]->{'no_magic_root'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=magic value=0 %s> %s</td>\n",
	defined($_[2]->{'no_magic_root'}) ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'tally_root'}</b></td>\n";
printf "<td><input type=radio name=root value=1 %s> %s\n",
      defined($_[2]->{'even_deny_root_account'}) ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=root value=0 %s> %s</td> </tr>\n",
      defined($_[2]->{'even_deny_root_account'}) ? '' : 'checked', $self->{'text_hash'}->{'no'};
}

# parse_module_args(&service, &module, &args)
sub parse_module_args
{
	my $self = shift;

if ($self->{'in_hash'}->{'deny_def'}) { delete($_[2]->{'deny'}); }
else {
	$self->{'in_hash'}->{'deny'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'tally_edeny'});
	$_[2]->{'deny'} = $self->{'in_hash'}->{'deny'};
	}

delete($_[2]->{'reset'});
delete($_[2]->{'no_reset'});
if ($self->{'in_hash'}->{'reset'} == 1) { $_[2]->{'reset'} = ''; }
elsif ($self->{'in_hash'}->{'reset'} == 2) { $_[2]->{'no_reset'} = ''; }

if ($self->{'in_hash'}->{'magic'}) { $_[2]->{'no_magic_root'} = ''; }
else { delete($_[2]->{'no_magic_root'}); }

if ($self->{'in_hash'}->{'root'}) { $_[2]->{'even_deny_root_account'} = ''; }
else { delete($_[2]->{'even_deny_root_account'}); }
}


1;

