#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move.cgi
# Move a PAM module line up or down

&ModuleLoader::preload_module('pam_class', "pam::PamLib");
$self = new pam::PamLib:: 'pam_class',%$self;

$self->ReadParse();
@{$self->{'pams_array'}} = $self->get_pam_config();
$self->{'pam'} = $self->{'pams_array'}->[$self->{'in_hash'}->{'idx'}];

$self->lock_file($self->{'pam'}->{'file'});
$self->{'swap1'} = $self->{'pam'}->{'mods'}->[$self->{'in_hash'}->{'midx'}];
$self->{'i'} = $self->{'in_hash'}->{'midx'};
do {
	$self->{'i'} += $self->{'in_hash'}->{'up'} ? -1 : 1;
	$self->{'swap2'} = $self->{'pam'}->{'mods'}->[$self->{'i'}];
	} while($self->{'swap2'}->{'type'} ne $self->{'swap1'}->{'type'});
$self->swap_modules($self->{'pam'}->{'name'}, $self->{'swap1'}, $self->{'swap2'});
$self->unlock_file($self->{'pam'}->{'file'});
$self->webmin_log("move", "mod", $self->{'pam'}->{'name'}, { '1' => $self->{'swap1'}->{'module'},
					     '2' => $self->{'swap2'}->{'module'} });
$self->redirect("edit_pam.cgi?idx=$self->{'in_hash'}->{'idx'}");

1;
		
}


1;

