#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several secrets

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->error_setup($self->{'text_hash'}->{'delete_err'});
$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
$self->ReadParse();
@{$self->{'d_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'d_array'}} || $self->error($self->{'text_hash'}->{'delete_enone'});

# Do the deletion
$self->lock_file($self->{'config_hash'}->{'pap_file'});
@{$self->{'seclist_array'}} = $self->list_secrets();
foreach my $d (sort { $b <=> $a } @{$self->{'d_array'}}) {
	$self->{'sec'} = $self->{'seclist_array'}->[$d];
	$self->delete_secret($self->{'sec'});
	}
$self->unlock_file($self->{'config_hash'}->{'pap_file'});
$self->webmin_log("deletes", undef, scalar(@{$self->{'d_array'}}));
$self->redirect("list_secrets.cgi");

1;
		
}


1;

