#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_mgetty.cgi
# Display the mgetty configuration for some serial port

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'mgetty'} || $self->error($self->{'text_hash'}->{'mgetty_ecannot'});
$self->ReadParse();
$self->foreign_require("inittab", "inittab-lib.pl");

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mgetty_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'mgetty_edit'}, "");
	@{$self->{'mgi_array'}} = $self->mgetty_inittabs();
	($self->{'init'}) = grep { $_->{'id'} eq $self->{'in_hash'}->{'id'} } @{$self->{'mgi_array'}};
	}

print "<form action=save_mgetty.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=id value='$self->{'in_hash'}->{'id'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'mgetty_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'mgetty_tty'}</b></td>\n";
print "<td><select name=tty>\n";
$self->{'found'}++ if ($self->{'in_hash'}->{'new'});
foreach $t (sort { "$a$b" =~ /^\/dev\/ttyS(\d+)\/dev\/ttyS(\d+)$/ ? $1 <=> $2 : 0 }
		 glob($self->{'config_hash'}->{'serials'})) {
	$t =~ s/^\/dev\///;
	local $f = $self->{'init'}->{'tty'} eq $t || $self->{'init'}->{'tty'} eq "/dev/$t";
	printf "<option value=%s %s>%s\n",
		$t, $f ? "selected" : "",
		$t =~ /^ttyS(\d+)$/ ? $self->text('mgetty_ts', $1+1) :
		$t =~ /^term\/(\S+)$/ ? $self->text('mgetty_ts', uc($1)) : "/dev/$t";
	$self->{'found'}++ if ($f);
	}
printf "<option value='' %s>%s\n",
	$self->{'found'} ? "" : "selected", $self->{'text_hash'}->{'mgetty_other'};
print "</select>\n";
printf "<input name=other size=20 value='%s'> %s</td>\n",
	$self->{'found'} ? "" : $self->{'init'}->{'tty'}, $self->file_chooser_button("other");

print "<td><b>$self->{'text_hash'}->{'mgetty_type'}</b></td>\n";
printf "<td><input name=direct type=radio value=1 %s> %s\n",
	$self->{'init'}->{'direct'} ? "checked" : "", $self->{'text_hash'}->{'mgetty_direct'};
printf "<input name=direct type=radio value=0 %s> %s</td> </tr>\n",
	$self->{'init'}->{'direct'} ? "" : "checked", $self->{'text_hash'}->{'mgetty_modem'};

print "<tr> <td><b>$self->{'text_hash'}->{'mgetty_speed'}</b></td>\n";
printf "<td><input type=radio name=speed_def value=1 %s> %s\n",
	$self->{'init'}->{'speed'} ? "" : "checked", $self->{'text_hash'}->{'mgetty_auto'};
printf "<input type=radio name=speed_def value=0 %s>\n",
	$self->{'init'}->{'speed'} ? "checked" : "";
printf "<input name=speed size=8 value='%s'> %s</td>\n",
	$self->{'init'}->{'speed'}, $self->{'text_hash'}->{'mgetty_baud'};

print "<td><b>$self->{'text_hash'}->{'mgetty_answer'}</b></td>\n";
printf "<td><input name=rings size=4 value='%s'> %s</td> </tr>\n",
	defined($self->{'init'}->{'rings'}) ? $self->{'init'}->{'rings'} : 1, $self->{'text_hash'}->{'mgetty_rings'};

print "<tr> <td><b>$self->{'text_hash'}->{'mgetty_mode'}</b></td>\n";
printf "<td><input type=radio name=mode value=0 %s> %s\n",
	$self->{'init'}->{'data'} || $self->{'init'}->{'fax'} ? "" : "checked", $self->{'text_hash'}->{'mgetty_df'};
printf "<input type=radio name=mode value=1 %s> %s\n",
	$self->{'init'}->{'data'} ? "checked" : "", $self->{'text_hash'}->{'mgetty_d'};
printf "<input type=radio name=mode value=2 %s> %s</td>\n",
	$self->{'init'}->{'fax'} ? "checked" : "", $self->{'text_hash'}->{'mgetty_f'};

print "<td><b>$self->{'text_hash'}->{'mgetty_back'}</b></td>\n";
printf "<td><input type=radio name=back_def value=1 %s> %s\n",
	$self->{'init'}->{'back'} ? "" : "checked", $self->{'text_hash'}->{'mgetty_back_def'};
printf "<input type=radio name=back_def value=0 %s>\n",
	$self->{'init'}->{'back'} ? "checked" : "";
printf "<input name=back size=4 value='%s'> %s</td> </tr>\n",
	$self->{'init'}->{'back'}, $self->{'text_hash'}->{'mgetty_secs'};

print "<tr> <td><b>$self->{'text_hash'}->{'mgetty_prompt'}</b></td>\n";
printf "<td colspan=3><input type=radio name=prompt_def value=1 %s> %s\n",
	$self->{'init'}->{'prompt'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=prompt_def value=0 %s>\n",
	$self->{'init'}->{'prompt'} ? "checked" : "";
printf "<input name=prompt size=50 value='%s'></td> </tr>\n",
	$self->{'init'}->{'prompt'};

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</table></form>\n";

$self->ui_print_footer("list_mgetty.cgi", $self->{'text_hash'}->{'mgetty_return'});

1;
		
}


1;

