#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Displays a menu of PPP server related icons

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;


# Show icons for various option categories
@{$self->{'links_array'}} = ( "list_mgetty.cgi", "edit_options.cgi", "list_dialin.cgi",
	   "list_secrets.cgi" );
@{$self->{'links_array'}} = grep { /_(.*).cgi/; $self->{'access_hash'}->{$1} } @{$self->{'links_array'}};
@{$self->{'titles_array'}} = map { /_(.*).cgi/; $self->{'text_hash'}->{$1."_title"} } @{$self->{'links_array'}};
@{$self->{'icons_array'}} = map { /_(.*).cgi/; "images/$1.gif" } @{$self->{'links_array'}};

if (@{$self->{'links_array'}} == 1 && $self->{'access_hash'}->{'direct'}) {
	$self->redirect($self->{'links_array'}->[0]);
	exit;
	}
$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);

if (@{$self->{'links_array'}}) {
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

