#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dialin.cgi
# Display a list of allowed and denied caller-ID numbers

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'dialin'} || $self->error($self->{'text_hash'}->{'dialin_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'dialin_title'}, "");

# Check for the mgetty login config file
if (!-r $self->{'config_hash'}->{'login_config'}) {
	print "<p>",$self->text('dialin_efile', "<tt>$self->{'config_hash'}->{'dialin_config'}</tt>",
	    "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	exit;
	}
@{$self->{'dialin_array'}} = $self->parse_dialin_config();

print "$self->{'text_hash'}->{'dialin_desc'}<p>\n";

if (@{$self->{'dialin_array'}}) {
	print "<a href='edit_dialin.cgi?new=1'>$self->{'text_hash'}->{'dialin_add'}</a><br>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'dialin_number'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'dialin_ad'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'dialin_move'}</b></td> </tr>\n";
	foreach $d (@{$self->{'dialin_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='edit_dialin.cgi?idx=$d->{'index'}'>",
			$d->{'number'} eq 'all' ? $self->{'text_hash'}->{'dialin_all'} :
			$d->{'number'} eq 'none' ? $self->{'text_hash'}->{'dialin_none'} :
			$d->{'number'},"</a></td>\n";
		print "<td>",$d->{'not'} ? $self->{'text_hash'}->{'dialin_deny'}
					 : $self->{'text_hash'}->{'dialin_allow'},"</td>\n";
		print "<td>";
		if ($d eq $self->{'dialin_array'}->[@{$self->{'dialin_array'}}-1]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$d->{'index'}&down=1'>",
			      "<img src=images/down.gif border=0></a>";
			}
		if ($d eq $self->{'dialin_array'}->[0]) {
			print "<img src=images/gap.gif>";
			}
		else {
			print "<a href='move.cgi?idx=$d->{'index'}&up=1'>",
			      "<img src=images/up.gif border=0></a>";
			}
		print "</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'dialin_nonumbers'}</b> <p>\n";
	}
print "<a href='edit_dialin.cgi?new=1'>$self->{'text_hash'}->{'dialin_add'}</a><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

