#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_dialin.cgi
# Create, update or delete a caller ID number

&ModuleLoader::preload_module('pap_class', "pap::PapLib");
$self = new pap::PapLib:: 'pap_class',%$self;

$self->{'access_hash'}->{'dialin'} || $self->error($self->{'text_hash'}->{'dialin_ecannot'});
$self->ReadParse();
@{$self->{'dialin_array'}} = $self->parse_dialin_config();
$self->{'dialin'} = $self->{'dialin_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

$self->lock_file($self->{'config_hash'}->{'dialin_config'});
if ($self->{'in_hash'}->{'delete'}) {
	# Delete the number
	$self->delete_dialin($self->{'dialin'}, \@{$self->{'dialin_array'}});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'dialin_err'});
	$self->{'in_hash'}->{'mode'} != 2 || $self->{'in_hash'}->{'number'} =~ /^\d+$/ ||
		$self->error($self->{'text_hash'}->{'dialin_enumber'});

	$self->{'dialin'}->{'number'} = $self->{'in_hash'}->{'mode'} == 0 ? 'all' :
			      $self->{'in_hash'}->{'mode'} == 1 ? 'none' : $self->{'in_hash'}->{'number'};
	$self->{'dialin'}->{'not'} = !$self->{'in_hash'}->{'allow'};
	if ($self->{'in_hash'}->{'new'}) {
		# Add a new number
		$self->create_dialin($self->{'dialin'}, \@{$self->{'dialin_array'}});
		}
	else {
		# Update an existing number
		$self->modify_dialin($self->{'dialin'}, \@{$self->{'dialin_array'}});
		}
	}
$self->unlock_file($self->{'config_hash'}->{'dialin_config'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "dialin", $self->{'dialin'}->{'number'}, $self->{'dialin'});
$self->redirect("list_dialin.cgi");

1;
		
}


1;

