#!/usr/bin/perl
package passwd::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'passwd::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "passwd::PasswdLib");
$self = new passwd::PasswdLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the passwd module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_users'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=mode value=0 %s> %s\n",
	$_[0]->{'mode'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode0'};

printf "<input type=radio name=mode value=3 %s> %s<br>\n",
	$_[0]->{'mode'} == 3 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode3'};

printf "<input type=radio name=mode value=1 %s> %s\n",
	$_[0]->{'mode'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode1'};
printf "<input name=users1 size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 1 ? $_[0]->{'users'} : '',
	$self->user_chooser_button("users1", 1);

printf "<input type=radio name=mode value=2 %s> %s\n",
	$_[0]->{'mode'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode2'};
printf "<input name=users2 size=40 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 2 ? $_[0]->{'users'} : '',
	$self->user_chooser_button("users2", 1);

printf "<input type=radio name=mode value=4 %s> %s\n",
	$_[0]->{'mode'} == 4 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode4'};
printf "<input name=low size=8 value='%s'> -\n",
	$_[0]->{'mode'} == 4 ? $_[0]->{'low'} : '';
printf "<input name=high size=8 value='%s'><br>\n",
	$_[0]->{'mode'} == 4 ? $_[0]->{'high'} : '';

printf "<input type=radio name=mode value=5 %s> %s\n",
	$_[0]->{'mode'} == 5 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode5'};
printf "<input name=groups size=20 value='%s'> %s<br>\n",
	$_[0]->{'mode'} == 5 ? $_[0]->{'users'} : '',
	$self->group_chooser_button("groups", 1);
printf "%s <input type=checkbox name=sec value=1 %s> %s<br>\n",
        "&nbsp;" x 5, $_[0]->{'sec'} ? 'checked' : '',$self->{'text_hash'}->{'acl_sec'};
printf "%s %s <input name=notusers size=20 value='%s'> %s<br>\n",
	"&nbsp;" x 5, $self->{'text_hash'}->{'acl_notusers'},
	$_[0]->{'mode'} == 5 ? $_[0]->{'notusers'} : '',
	$self->user_chooser_button("notusers", 1);

printf "<input type=radio name=mode value=6 %s> %s\n",
	$_[0]->{'mode'} == 6 ? 'checked' : '', $self->{'text_hash'}->{'acl_mode6'};
printf "<input name=match size=15 value='%s'></td> </tr>\n",
	$_[0]->{'mode'} == 6 ? $_[0]->{'users'} : '';

print "<tr> <td><b>$self->{'text_hash'}->{'acl_repeat'}</b></td> <td>\n";
printf "<input type=radio name=repeat value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'repeat'} ? "checked" : "";
printf "<input type=radio name=repeat value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'repeat'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_expire'}</b></td> <td>\n";
printf "<input type=radio name=expire value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'expire'} ? "checked" : "";
printf "<input type=radio name=expire value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'expire'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_others'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'others'} == 1 ? "checked" : "";
printf "<input type=radio name=others value=2 %s> $self->{'text_hash'}->{'acl_opt'}\n",
	$_[0]->{'others'} == 2 ? "checked" : "";
printf "<input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'others'} == 0 ? "checked" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_old'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=old value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'old'} == 1 ? "checked" : "";
printf "<input type=radio name=old value=2 %s> $self->{'text_hash'}->{'acl_old_this'}\n",
	$_[0]->{'old'} == 2 ? "checked" : "";
printf "<input type=radio name=old value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'old'} == 0 ? "checked" : "";
}

# acl_security_save(&options)
# Parse the form for security options for the bind8 module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'mode'} = $self->{'in_hash'}->{'mode'};
$_[0]->{'users'} = $self->{'in_hash'}->{'mode'} == 1 ? $self->{'in_hash'}->{'users1'} :
		   $self->{'in_hash'}->{'mode'} == 2 ? $self->{'in_hash'}->{'users2'} :
		   $self->{'in_hash'}->{'mode'} == 5 ? $self->{'in_hash'}->{'groups'} :
		   $self->{'in_hash'}->{'mode'} == 6 ? $self->{'in_hash'}->{'match'} : undef;
$_[0]->{'notusers'} = $self->{'in_hash'}->{'mode'} == 5 ? $self->{'in_hash'}->{'notusers'} : undef;
$_[0]->{'low'} = $self->{'in_hash'}->{'low'};
$_[0]->{'high'} = $self->{'in_hash'}->{'high'};
$_[0]->{'repeat'} = $self->{'in_hash'}->{'repeat'};
$_[0]->{'old'} = $self->{'in_hash'}->{'old'};
$_[0]->{'others'} = $self->{'in_hash'}->{'others'};
$_[0]->{'expire'} = $self->{'in_hash'}->{'expire'};
$_[0]->{'sec'} = $self->{'in_hash'}->{'sec'};
}


1;

