#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_passwd.cgi

&ModuleLoader::preload_module('passwd_class', "passwd::PasswdLib");
$self = new passwd::PasswdLib:: 'passwd_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'passwd_err'});

@{$self->{'user_array'}} = getpwnam($self->{'in_hash'}->{'user'});
@{$self->{'user_array'}} || $self->error($self->{'text_hash'}->{'passwd_euser'});
$self->can_edit_passwd(\@{$self->{'user_array'}}) || $self->error($self->{'text_hash'}->{'passwd_ecannot'});

# Show password change form
$self->ui_print_header(undef, $self->{'text_hash'}->{'passwd_title'}, "");
print "<form action=save_passwd.cgi method=post>\n";
print "<input type=hidden name=user value='$self->{'user_array'}->[0]'>\n";
print "<input type=hidden name=one value='$self->{'in_hash'}->{'one'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'passwd_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

%{$self->{'uconfig_hash'}} = $self->foreign_config("useradmin");
print "<tr> <td><b>$self->{'text_hash'}->{'passwd_for'}</b></td>\n";
$self->{'user_array'}->[6] =~ s/,.*$// if ($self->{'uconfig_hash'}->{'extra_real'});
print "<td>$self->{'user_array'}->[0]",( $self->{'user_array'}->[6] ? " ($self->{'user_array'}->[6])" : "" ),
      "</td> </tr>\n";

if ($self->{'access_hash'}->{'old'} == 1 ||
    $self->{'access_hash'}->{'old'} == 2 && $self->{'user_array'}->[0] ne $self->{'remote_user'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'passwd_old'}</b></td>\n";
	print "<td><input name=old size=25 type=password></td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_new'}</b></td>\n";
print "<td><input name=new size=25 type=password></td> </tr>\n";

if ($self->{'access_hash'}->{'repeat'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'passwd_repeat'}</b></td>\n";
	print "<td><input name=repeat size=25 type=password></td> </tr>\n";
	}

if (!$self->{'config_hash'}->{'passwd_cmd'} && $self->{'access_hash'}->{'expire'}) {
	$self->foreign_require("useradmin", "user-lib.pl");
	$self->{'pft'} = $main::useradmin_object->passfiles_type();
	($self->{'uuser'}) = grep { $_->{'user'} eq $self->{'in_hash'}->{'user'} }
			$main::useradmin_object->list_users();
	if ($self->{'uuser'}->{'max'} && ($self->{'pft'} == 2 || $self->{'pft'} == 5)) {
		print "<tr> <td colspan=2>\n";
		print "<input type=checkbox name=expire value=1> ",
		      "$self->{'text_hash'}->{'passwd_expire'}</td> </tr>\n";
		}
	}

if ($self->{'access_hash'}->{'others'} == 2) {
	print "<tr> <td colspan=2>\n";
	print "<input type=checkbox name=others value=1 checked> ",
	      "$self->{'text_hash'}->{'passwd_others'}</td> </tr>\n";
	}

print "<tr> <td colspan=2>\n";
print "<input type=submit value='$self->{'text_hash'}->{'passwd_change'}'>\n";
print "<input type=reset value='$self->{'text_hash'}->{'passwd_reset'}'></td> </tr>\n";

print "</table></td></tr></table></form>\n";
$self->ui_print_footer($self->{'in_hash'}->{'one'} ? ( "/", $self->{'text_hash'}->{'index'} ) :
			      ( "", $self->{'text_hash'}->{'index_return'} ));

1;
		
}


1;

