#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options for program directories and directory limits

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'dirs_title'}, "");

print $self->ui_form_start("save_dirs.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'dirs_header'}, "width=100%", 2);

# Include files directories
$self->{'include'} = $self->find_value("include_path", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'dirs_include'},
	$self->ui_radio("include_def", $self->{'include'} ? 0 : 1,
		  [ [ 1, $self->{'text_hash'}->{'default'} ], [ 0, $self->{'text_hash'}->{'dirs_below'} ] ]).
	"<br>\n".
	$self->ui_textarea("include", join("\n", split(/:/, $self->{'include'})), 3, 60)." ".
	$self->file_chooser_button("include", 1, undef, undef, 1));

# Extensions directory
print $self->ui_table_row($self->{'text_hash'}->{'dirs_ext'},
	$self->ui_opt_textbox("ext", $self->find_value("extension_dir", $self->{'conf'}),
			60, $self->{'text_hash'}->{'default'})." ".
	$self->file_chooser_button("ext", 1));

# Can accept uploads?
print $self->ui_table_row($self->{'text_hash'}->{'dirs_upload'},
	$self->onoff_radio("file_uploads"));

# Upload temp files directory
print $self->ui_table_row($self->{'text_hash'}->{'dirs_utmp'},
	$self->ui_opt_textbox("utmp", $self->find_value("upload_tmp_dir", $self->{'conf'}),
			60, $self->{'text_hash'}->{'default'})." ".
	$self->file_chooser_button("utmp", 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

