#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to memory / disk limits

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'limits_title'}, "");

print $self->ui_form_start("save_limits.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'limits_header'}, "width=100%", 4);

# Memory limit
print $self->ui_table_row($self->{'text_hash'}->{'limits_mem'},
	$self->ui_opt_textbox("memory_limit",
			$self->find_value("memory_limit", $self->{'conf'}),
			8, $self->{'text_hash'}->{'default'}));

# POST limit
print $self->ui_table_row($self->{'text_hash'}->{'limits_post'},
	$self->ui_opt_textbox("post_max_size",
			$self->find_value("post_max_size", $self->{'conf'}),
			8, $self->{'text_hash'}->{'default'}));

# Upload limit
print $self->ui_table_row($self->{'text_hash'}->{'limits_upload'},
	$self->ui_opt_textbox("upload_max_filesize",
			$self->find_value("upload_max_filesize", $self->{'conf'}),
			8, $self->{'text_hash'}->{'default'}));

# Max run time
print $self->ui_table_row($self->{'text_hash'}->{'limits_exec'},
	$self->ui_opt_textbox("max_execution_time",
			$self->find_value("max_execution_time", $self->{'conf'}),
			8, $self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'db_s'});

# Max parsing time
print $self->ui_table_row($self->{'text_hash'}->{'limits_input'},
	$self->ui_opt_textbox("max_input_time",
			$self->find_value("max_input_time", $self->{'conf'}),
			8, $self->{'text_hash'}->{'default'})." ".$self->{'text_hash'}->{'db_s'});

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

