#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to other options

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'misc_title'}, "");

print $self->ui_form_start("save_misc.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'misc_header'}, "width=100%", 4);

# Tag styles
print $self->ui_table_row($self->{'text_hash'}->{'misc_short'},
		    $self->onoff_radio("short_open_tag"));
print $self->ui_table_row($self->{'text_hash'}->{'misc_asp'},
		    $self->onoff_radio("asp_tags"));

# Output options
print $self->ui_table_row($self->{'text_hash'}->{'misc_zlib'},
		    $self->onoff_radio("zlib.output_compression"));
print $self->ui_table_row($self->{'text_hash'}->{'misc_flush'},
		    $self->onoff_radio("implicit_flush"));

# URL open options
print $self->ui_table_row($self->{'text_hash'}->{'misc_fopen'},
		    $self->onoff_radio("allow_url_fopen"));

print $self->ui_table_hr();

# Email sending options
$self->{'smtp'} = $self->find_value("SMTP", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'misc_smtp'},
		    $self->ui_opt_textbox("smtp", $self->{'smtp'}, 20, $self->{'text_hash'}->{'misc_none'}));
$self->{'port'} = $self->find_value("smtp_port", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'misc_port'},
		    $self->ui_opt_textbox("smtp_port", $self->{'port'}, 5, $self->{'text_hash'}->{'default'}));

$self->{'sendmail'} = $self->find_value("sendmail_path", $self->{'conf'});
print $self->ui_table_row($self->{'text_hash'}->{'misc_sendmail'},
		    $self->ui_opt_textbox("sendmail_path", $self->{'sendmail'}, 60,
				    $self->{'text_hash'}->{'misc_none'}), 3);

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

