#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related for PHP safe mode

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'safe_title'}, "");

print $self->ui_form_start("save_safe.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'safe_header'}, "width=100%", 2);

# Enable safe mode
print $self->ui_table_row($self->{'text_hash'}->{'safe_on'},
	$self->onoff_radio("safe_mode"));

print $self->ui_table_row($self->{'text_hash'}->{'safe_gid'},
	$self->onoff_radio("safe_mode_gid"));

# Safe directory for includes
print $self->ui_table_row($self->{'text_hash'}->{'safe_include'},
	$self->ui_opt_textbox("safe_mode_include_dir",
			$self->find_value("safe_mode_include_dir", $self->{'conf'}),
			60, $self->{'text_hash'}->{'safe_none'})." ".
	$self->file_chooser_button("safe_mode_include_dir", 1));

# Safe directory for execs
print $self->ui_table_row($self->{'text_hash'}->{'safe_exec'},
	$self->ui_opt_textbox("safe_mode_exec_dir",
			$self->find_value("safe_mode_exec_dir", $self->{'conf'}),
			60, $self->{'text_hash'}->{'safe_none'})." ".
	$self->file_chooser_button("safe_mode_exec_dir", 1));

# Allowed directory for opens
print $self->ui_table_row($self->{'text_hash'}->{'safe_basedir'},
	$self->ui_opt_textbox("open_basedir",
			$self->find_value("open_basedir", $self->{'conf'}),
			60, $self->{'text_hash'}->{'safe_none'})." ".
	$self->file_chooser_button("open_basedir", 1));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

