#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show options related to PHP variables

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'vars_title'}, "");

print $self->ui_form_start("save_vars.cgi", "post");
print $self->ui_hidden("file", $self->{'in_hash'}->{'file'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'vars_header'}, "width=100%", 4);

print $self->ui_table_row($self->{'text_hash'}->{'vars_magic'},
		    $self->onoff_radio("magic_quotes_gpc"));

print $self->ui_table_row($self->{'text_hash'}->{'vars_runtime'},
		    $self->onoff_radio("magic_quotes_runtime"));

print $self->ui_table_row($self->{'text_hash'}->{'vars_register'},
		    $self->onoff_radio("register_globals"));

print $self->ui_table_row($self->{'text_hash'}->{'vars_long'},
		    $self->onoff_radio("register_long_arrays"));

print $self->ui_table_row($self->{'text_hash'}->{'vars_args'},
		    $self->onoff_radio("register_argc_argv"));

print $self->ui_table_end();
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ]);

$self->ui_print_footer("list_ini.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}),
		 $self->{'text_hash'}->{'list_return'});
1;
		
}


1;

