#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a page of icons for various PHP config sections

&ModuleLoader::preload_module('phpini_class', "phpini::PhpiniLib");
$self = new phpini::PhpiniLib:: 'phpini_class',%$self;

$self->ReadParse();
$self->can_php_config($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});

# Work out if we can just see one file
@{$self->{'files_array'}} = $self->list_php_configs();
if (@{$self->{'files_array'}} == 1 && !$self->{'access_hash'}->{'anyfile'} && $self->{'access_hash'}->{'noconfig'}) {
	$self->{'onefile'} = 1;
	}

$self->ui_print_header("<tt>$self->{'in_hash'}->{'file'}</tt>", $self->{'text_hash'}->{'list_title'}, "", undef, 0,
		 $self->{'onefile'});

@{$self->{'pages_array'}} = ( "vars", "dirs", "db", "session", "safe", "limits",
	   "errors", "misc" );
@{$self->{'links_array'}} = map { "edit_${_}.cgi?file=".$self->urlize($self->{'in_hash'}->{'file'}) } @{$self->{'pages_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{$_."_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/$_.gif" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);

if ($self->{'onefile'}) {
	$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});
	}
else {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

