#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Manages canonicals for Postfix
#
# << Here are all options seen in Postfix sample-canonical.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'canonical'} || $self->error($self->{'text_hash'}->{'canonical_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'canonical_title'}, "", "canonical");

# alias general options

print "<form action=save_opts_canonical.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'canonical_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'none'} = $self->{'text_hash'}->{'opts_none'};

print "<tr>\n";
$self->option_radios_freefield("canonical_maps", 60, $self->{'none'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("recipient_canonical_maps", 60, $self->{'none'});
print "</tr>\n";

print "<tr>\n";
$self->option_radios_freefield("sender_canonical_maps", 60, $self->{'none'});
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
print "<hr>\n";

print "<br>\n";

print "<table cellpadding=5 width=100%><tr><td>\n";
print "<form action=canonical_edit.cgi>\n";
print "$self->{'text_hash'}->{'edit_canonical_maps_general'}:</td></tr><tr><td>\n";
print "<input type=submit name=which1 value=\"$self->{'text_hash'}->{'edit_canonical_maps'}\">\n";
print "<input type=submit name=which2 value=\"$self->{'text_hash'}->{'edit_recipient_canonical_maps'}\">\n";
print "<input type=submit name=which3 value=\"$self->{'text_hash'}->{'edit_sender_canonical_maps'}\">\n";
print "</td></tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

