#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit one category of canonical maps

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'canonical_edit_title'}, "", "canonical");

local $first_line = $self->{'text_hash'}->{'map_click'}." ".
                 "<font size=\"-1\">".$self->hlink("$self->{'text_hash'}->{'help_map_format'}", "canonical")."</font>\n<br>\n";

if ($self->{'in_hash'}->{'which1'})
{ 
    $self->generate_map_edit("canonical_maps", $first_line);
}
elsif ($self->{'in_hash'}->{'which2'})
{ 
    $self->generate_map_edit("recipient_canonical_maps", $first_line);
}
elsif ($self->{'in_hash'}->{'which3'})
{ 
    $self->generate_map_edit("sender_canonical_maps", $first_line);
}
else 
{ 
    $self->error($self->{'text_hash'}->{'internal_error'}); 
}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

