#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several mail aliases

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

&ModuleLoader::preload_module('postfix_class', "postfix::AliasesLib");
$self = new postfix::AliasesLib:: 'postfix_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'adelete_err'});
$self->{'access_hash'}->{'aliases'} || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
@{$self->{'afiles_array'}} = $self->get_aliases_files($self->get_current_value("alias_maps"));
$self->lock_alias_files(\@{$self->{'afiles_array'}});

# Find and validate
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'adelete_enone'});
@{$self->{'aliases_array'}} = $self->list_aliases(\@{$self->{'afiles_array'}});
foreach $d (@d) {
	($alias) = grep { $_->{'name'} eq $d } @{$self->{'aliases_array'}};
	if ($alias) {
		push(@{$self->{'delaliases_array'}}, $alias);
		}
	}

# Delete the aliases
foreach $alias (@{$self->{'delaliases_array'}}) {
	$self->delete_alias($alias, 1);
	}
$self->unlock_alias_files(\@{$self->{'afiles_array'}});

$self->regenerate_aliases();
$self->reload_postfix();

$self->webmin_log("delete", "aliases", scalar(@{$self->{'delaliases_array'}}));
$self->redirect("aliases.cgi");

1;
		
}


1;

