#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple mappings

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});

@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

$self->{'maps'} = $self->get_maps($self->{'in_hash'}->{'map_name'});
foreach $d (@d) {
	($self->{'map'}) = grep { $_->{'name'} eq $d } @{$self->{'maps'}};
	if ($self->{'map'}) {
		$self->lock_file($self->{'map'}->{'file'});
	        $self->delete_mapping($self->{'in_hash'}->{'map_name'}, $self->{'map'});
		}
	}
$self->unlock_all_files();

$self->regenerate_map_table($self->{'in_hash'}->{'map_name'});
$self->reload_postfix();

$self->webmin_log("delete", $self->{'in_hash'}->{'map_name'}.'s', scalar(@d));
$self->redirect_to_map_list($self->{'in_hash'}->{'map_name'});
1;
		
}


1;

