#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit an email alias

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_alias_title'}, "");

local @afiles = $self->get_aliases_files($self->get_current_value("alias_maps"));
local @aliases = $self->list_aliases(\@afiles);
$self->{'a'} = $aliases[$self->{'in_hash'}->{'num'}] if (!$self->{'in_hash'}->{'new'});

$self->alias_form($self->{'a'});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

