#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit a mapping

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_mapping_title'}, "");

local $num;

if (!exists($self->{'in_hash'}->{'num'}))
{
    $num = $self->init_new_mapping($self->get_current_value("sender_canonical_maps"));
}
else
{
    $num = $self->{'in_hash'}->{'num'};
}

local $mappingsaliases = $self->get_aliases();
local %alias;

foreach $trans (@{$self->{'aliases'}})
{
    if ($trans->{'number'} == $num) { %alias = %{$trans}; }
}    

print "<form action=save_alias.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_alias_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr>\n";
print "<td><b>$self->{'text_hash'}->{'aliases_name'}</b></td> <td nowrap>\n";
print "<input type=hidden name=\"num\" value=\"$num\">";
print "<input name=\"name\" size=40 value=\"$alias{'name'}\"> </td>\n";
print "</tr>\n";

print "<tr>\n";
print "<td><b>$self->{'text_hash'}->{'aliases_value'}</b></td> <td nowrap>\n";
print "<input name=\"value\" size=40 value=\"$alias{'value'}\"> </td>\n";
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'alias_save'}\">\n";
print "<input type=submit name=delete value=\"$self->{'text_hash'}->{'delete_alias'}\"></form>\n";

print "<hr>\n";
print "<br>\n";

1;
		
}


1;

