#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing a mapping file

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'manual_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'manual_title'}, "");

# Find the maps files
@{$self->{'files_array'}} = $self->get_maps_files($self->get_real_value($self->{'in_hash'}->{'map_name'}));
$self->{'file'} = $self->{'in_hash'}->{'file'} || $self->{'files_array'}->[0];
if (@{$self->{'files_array'}} > 1) {
	# Show form to select
	print $self->ui_form_start("edit_manual.cgi");
	print $self->ui_hidden("map_name", $self->{'in_hash'}->{'map_name'});
	print $self->{'text_hash'}->{'manual_file'},"\n";
	print $self->ui_select("file", $self->{'file'}, [ map { [ $_ ] } @{$self->{'files_array'}} ]),"\n";
	print $self->ui_submit($self->{'text_hash'}->{'manual_change'});
	print $self->ui_form_end();
	}

# Show the file contents
$self->open_readfile(*FILE, $self->{'file'});
while(<FILE>) {
	$self->{'data'} .= $_;
	}
close(FILE);
print $self->ui_form_start("save_manual.cgi", "form-data");
print $self->ui_hidden("map_name", $self->{'in_hash'}->{'map_name'});
print $self->ui_hidden("file", $self->{'file'});
print $self->text('manual_editing', "<tt>$self->{'file'}</tt>"),"<br>\n";
print $self->ui_textarea("data", $self->{'data'}, 20, 80);
print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ] ] );

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

