#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_rfile.cgi
# Display the contents of an autoreply file

my $rec_uire = (-r 'sendmail-lib.pl' ? './sendmail-lib.pl' :
	 -r 'qmail-lib.pl' ? './qmail-lib.pl' :
			     './postfix-lib.pl');
 &ModuleLoader::preload_module('postfix_class', "WebLib");
$self = new WebLib:: 'postfix_class',%$self;

 {
    my $pkg = $self->lib_to_pkg($rec_uire, "postfix");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
$self->ReadParse();
if (substr($self->{'in_hash'}->{'file'}, 0, length($self->{'access_hash'}->{'apath'})) ne $self->{'access_hash'}->{'apath'}) {
	$self->error($self->text('rfile_efile', $self->{'in_hash'}->{'file'}));
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'rfile_title'}, "");
$self->open_readfile(*FILE, $self->{'in_hash'}->{'file'});
while(<FILE>) {
	if (/^Reply-Tracking:\s*(.*)/) {
		$self->{'replies'} = $1;
		}
	elsif (/^Reply-Period:\s*(.*)/) {
		$self->{'period'} = $1;
		}
	elsif (/^No-Autoreply:\s*(.*)/) {
		$self->{'no_autoreply'} = $1;
		}
	elsif (/^No-Autoreply-Regexp:\s*(.*)/) {
		push(@{$self->{'no_regexp_array'}}, $1);
		}
	elsif (/^From:\s*(.*)/) {
		$self->{'from'} = $1;
		}
	else {
		push(@{$self->{'lines_array'}}, $_);
		}
	}
close(FILE);

print $self->text('rfile_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
print "$self->{'text_hash'}->{'rfile_desc2'}<p>\n";

print "<form action=save_rfile.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=num value=\"$self->{'in_hash'}->{'num'}\">\n";
print "<input type=hidden name=name value=\"$self->{'in_hash'}->{'name'}\">\n";
print "<textarea name=text rows=20 cols=80 $self->{'config_hash'}->{'wrap_mode'}>",
	join("", @{$self->{'lines_array'}}),"</textarea>\n";

print "<table>\n";

# Show From: address
print "<tr> <td>$self->{'text_hash'}->{'rfile_from'}</td>\n";
printf "<td><input type=radio name=from_def value=1 %s> %s\n",
	$self->{'from'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_auto'};
printf "<input type=radio name=from_def value=0 %s>\n",
	$self->{'from'} eq '' ? "" :"checked";
printf "<input name=from size=30 value='%s'></td> </tr>\n",
	$self->{'from'};
print "<tr> <td></td> <td><font size=-1>$self->{'text_hash'}->{'rfile_fromdesc'}</font></td> </tr>\n";

# Show reply-tracking file
print "<tr> <td>$self->{'text_hash'}->{'rfile_replies'}</td>\n";
printf "<td><input type=radio name=replies_def value=1 %s> %s\n",
	$self->{'replies'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_none'};
printf "<input type=radio name=replies_def value=0 %s> %s\n",
	$self->{'replies'} eq '' ? "" :"checked", $self->{'text_hash'}->{'rfile_file'};
printf "<input name=replies size=30 value='%s'> %s</td> </tr>\n",
	$self->{'replies'}, $self->file_chooser_button("replies");
print "&nbsp;" x 3;

# Show reply-tracking period
print "<tr> <td>&nbsp;&nbsp;&nbsp;$self->{'text_hash'}->{'rfile_period'}</td>\n";
printf "<td><input type=radio name=period_def value=1 %s> %s\n",
	$self->{'period'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_default'};
printf "<input type=radio name=period_def value=0 %s>\n",
	$self->{'period'} eq '' ? "" :"checked";
printf "<input name=period size=5 value='%s'> %s</td> </tr>\n",
	$self->{'period'}, $self->{'text_hash'}->{'rfile_secs'};

# Show people to not autoreply to
print "<tr> <td>$self->{'text_hash'}->{'rfile_no_autoreply'}</td>\n";
printf "<td><input name=no_autoreply size=40 value='%s'></td> </tr>\n";
	$self->{'no_autoreply'};

# Show regexps to not autoreply to
print "<tr> <td>$self->{'text_hash'}->{'rfile_no_regexp'}</td>\n";
print "<td>",$self->ui_textarea("no_regexp", join("\n", @{$self->{'no_regexp_array'}}), 3, 40),"</td> </tr>\n";

print "</table>\n";

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'rfile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_alias.cgi?name=$self->{'in_hash'}->{'name'}&num=$self->{'in_hash'}->{'num'}", $self->{'text_hash'}->{'aform_return'});

1;
		
}


1;

