#!/usr/bin/perl

&MAIN();

 sub MAIN {
# mailq_search.cgi
# Display some messages from the mail queue

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

&ModuleLoader::preload_module('postfix_class', "postfix::BoxesLib");
$self = new postfix::BoxesLib:: 'postfix_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'searchq_title'}, "");

# Get all of the queued messages that this user can see
@{$self->{'qfiles_array'}} = $self->list_queue();

# Do the search
$self->{'neg'} = ($self->{'in_hash'}->{'field'} =~ s/^!//);
@{$self->{'qfiles_array'}} = grep { local $r = &compare_field($_);
		 $self->{'neg'} ? !$r : $r } @{$self->{'qfiles_array'}};

print "<p><b>",$self->text($self->{'in_hash'}->{'field'} =~ /^\!/ ? 'search_results3' :
	  'search_results2', scalar(@{$self->{'qfiles_array'}}), "<tt>$self->{'in_hash'}->{'match'}</tt>"),"</b><p>\n";
if (@{$self->{'qfiles_array'}}) {
	# Show matching messages
	$self->mailq_table(\@{$self->{'qfiles_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'searchq_none'}</b> <p>\n";
	}

$self->ui_print_footer("mailq.cgi", $self->{'text_hash'}->{'mailq_return'},
		 "", $self->{'text_hash'}->{'index_return'});

1;
		
}

sub compare_field
{
	shift if ($self == $_[0]);

if ($self->{'in_hash'}->{'field'} eq 'size') {
	return $_[0]->{$self->{'in_hash'}->{'field'}} > $self->{'in_hash'}->{'match'};
	}
else {
	return $_[0]->{$self->{'in_hash'}->{'field'}} =~ /\Q$self->{'in_hash'}->{'match'}\E/i;
	}
}


1;

