#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# 
# Edit maps

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

$self->ReadParse();

$self->ui_print_header(undef, $self->{'text_hash'}->{'canonical_edit_title'}, "");

local $which;

if ($self->{'in_hash'}->{'which'} eq $self->{'text_hash'}->{'edit_canonical_maps'}) { $which = 1; }
elsif ($self->{'in_hash'}->{'which'} eq $self->{'text_hash'}->{'edit_recipient_canonical_maps'}) { $which = 2; }
elsif ($self->{'in_hash'}->{'which'} eq $self->{'text_hash'}->{'edit_sender_canonical_maps'}) { $which = 3; }
else { $self->error($self->{'text_hash'}->{'internal_error'}); }

# double-table displaying all mappings

local $mappingsaliases = $self->get_aliases();

print "Click on any alias to edit its properties:\n<br>\n";
print "<table width=100%> <tr><td width=50% valign=top>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliases_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'aliases_value'}</b></td> </tr>\n";

local $split_index = int(($#{$self->{'aliases'}})/2);
local $i = -1;

foreach $alias (@{$self->{'aliases'}})
{
    print "<tr $self->{'cb'}>\n";
    print "<td><a href=\"edit_alias.cgi?num=$alias->{'number'}\">$alias->{'name'}</a></td>\n";
    print "<td>$alias->{'value'}</td>\n</tr>\n";
    $i++;
    if ($i == $split_index)
    {
	print "</table></td><td width=50% valign=top>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliases_name'}</b></td> ",
	"<td><b>$self->{'text_hash'}->{'aliases_value'}</b></td> </tr>\n";
    }
}

print "</tr></td></table>\n";
print "</table>\n";

# new alias form

print "<table cellpadding=5 width=100%><tr><td>\n";
print "<form action=edit_alias.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'new_alias'}\">\n";
print "</td> <td width=\"99%\">$self->{'text_hash'}->{'new_aliasmsg'}\n";
print "</td></tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

print "$which <hr>\n";
print "<br>\n";

1;
		
}


1;

