#!/usr/bin/perl

&MAIN();

 sub MAIN {
# postfinger.cgi
# check postfix configuration

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->ReadParse();

$self->{'System'}=$self->{'in_hash'}->{'system'}||1;
$self->{'Package'}=$self->{'in_hash'}->{'package'}||1;
$self->{'Locking'}=$self->{'in_hash'}->{'locking'}||0;
$self->{'Tables'}=$self->{'in_hash'}->{'tables'}||0;
$self->{'Main'}=$self->{'in_hash'}->{'main'}||1;
$self->{'Master'}=$self->{'in_hash'}->{'master'}||1;
$self->{'Permissions'}=$self->{'in_hash'}->{'permissions'}||0;
$self->{'Libraries'}=$self->{'in_hash'}->{'libraries'}||0;
$self->{'Warn'}=$self->{'in_hash'}->{'warn'}||1;
$self->{'Defaultsinmain'}=$self->{'in_hash'}->{'defaultsinmain'}||1;

$self->{'access_hash'}->{'postfinger'} || $self->error($self->{'text_hash'}->{'postfinger_ecannot'});
$self->header($self->{'text_hash'}->{'postfinger_title'}, "");
if ( !$self->{'in_hash'}->{'go'} ) {
	print "<br><form action=postfinger.cgi>\n";
	print "<input type=hidden name=go value=go>\n";
	print "<table width=100% border>\n";
	print "<tr> <td><table width=50%>\n";
	print "<tr $self->{'tb'}> <td colspan=3><b>Display Options:</b></td></tr>\n";
	print "<tr $self->{'cb'}> <td><b>System</b></td> <td colspan=3>\n";
	printf "<input type=radio name=system value=1 %s> %s\n",
	$self->{'System'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=system value=no %s> %s\n",
	$self->{'System'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'System'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Package</b></td> <td colspan=3>\n";
	printf "<input type=radio name=package value=1 %s> %s\n",
	$self->{'Package'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=package value=no %s> %s\n",
	$self->{'Package'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Package'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Main</b></td> <td colspan=3>\n";
	printf "<input type=radio name=main value=1 %s> %s\n",
	$self->{'Main'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=main value=no %s> %s\n",
	$self->{'Main'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Main'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Defaults in Main</b></td> <td colspan=3>\n";
	printf "<input type=radio name=defaultsinmain value=1 %s> %s\n",
	$self->{'Defaultsinmain'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=defaultsinmain value=no %s> %s\n",
	$self->{'Defaultsinmain'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Defaultsinmain'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Master</b></td> <td colspan=3>\n";
	printf "<input type=radio name=master value=1 %s> %s\n",
	$self->{'Master'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=master value=no %s> %s\n",
	$self->{'Master'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Master'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Locking</b></td> <td colspan=3>\n";
	printf "<input type=radio name=locking value=1 %s> %s\n",
	$self->{'Locking'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=locking value=no %s> %s\n",
	$self->{'Locking'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Locking'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Tables</b></td> <td colspan=3>\n";
	printf "<input type=radio name=tables value=1 %s> %s\n",
	$self->{'Tables'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=tables value=no %s> %s\n",
	$self->{'Tables'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Tables'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Permissions</b></td> <td colspan=3>\n";
	printf "<input type=radio name=permissions value=1 %s> %s\n",
	$self->{'Permissions'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=permissions value=no %s> %s\n",
	$self->{'Permissions'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Permissions'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Libraries</b></td> <td colspan=3>\n";
	printf "<input type=radio name=libraries value=1 %s> %s\n",
	$self->{'Libraries'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=libraries value=no %s> %s\n",
	$self->{'Libraries'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Libraries'}),"</td> </tr>\n";

	print "<tr $self->{'cb'}> <td><b>Warn</b></td> <td colspan=3>\n";
	printf "<input type=radio name=warn value=1 %s> %s\n",
	$self->{'Warn'} eq 1 ? 'checked' : '', $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=warn value=no %s> %s\n",
	$self->{'Warn'} eq 1 ? '' : 'checked', $self->{'text_hash'}->{'no'},
	join(" ", $self->{'Warn'}),"</td> </tr>\n";
	print "<tr><td> </td></tr><tr><td><input type=submit value=\"$self->{'text_hash'}->{'postfinger_show'}\"></td></tr></form>\n";

	print "</table></td> </tr></table>";
	$self->footer("index.cgi", $self->{'text_hash'}->{'index_title'});
} else {
	print "<table border='0' cellpadding='3' width='600' align='center'>";
	print "<tr $self->{'tb'}><td>";

	if (! -x $self->{'config_hash'}->{'postfix_config_command'} && ! -r $self->{'config_hash'}->{'postfix_config_file'} ) {
		print "Can not find postconf";
		exit;
	}
# Verify that current configuration is valid
	if ($self->{'config_hash'}->{'index_check'} && ($self->{'err'} = $self->check_postfix())) {
		print "<p>",$self->text('check_error'),"<p>\n";
		print "<pre>$self->{'err'}</pre>\n";
		$self->footer("/", $self->{'text_hash'}->{'index'});
		exit;
	}
	if ($self->{'System'} eq 1 ) {
#		print '<center><b>--System Parameters--</b></center>';
		if ($self->has_command($self->{'config_hash'}->{'postfix_config_command'})) {
			print "<b>Postfix Version: $self->{'postfix_version'}</b>";
			print "</td></tr>";
			print "</table>";
			print "<table border='0' cellpadding='3' width='600' align='center'>";
			open(MAILQ, "/bin/hostname 2>/dev/null |");
			while (local $hostname = <MAILQ>) { print "<tr $self->{'cb'}><td><b>Hostname </b></td><td>$hostname</td></tr>"; }
			close(MAILQ);
			open(MAILQ, "/bin/uname -a 2>/dev/null |");
			while (local $uname = <MAILQ>) { print "<tr $self->{'cb'}><td><b>System</b></td><td>$uname</td></tr>"; }
			close(MAILQ);
		}
		print "</table><br />";
	}

	if ($self->{'Locking'} eq 1 ) {
		print "<table align='center' width='600'>";
		print "<tr $self->{'tb'}><td><b>Mailbox locking methods</b></td></tr>";
		open(MAILQ, "$self->{'config_hash'}->{'postfix_config_command'} -l 2>/dev/null |");
		while (local $locking_methods = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$locking_methods</td></tr>"; }
		close(MAILQ);
		print "</table><br />";
	}

	if ($self->{'Tables'} eq 1 ) {
		print "<table width='600' align='center'>";
		print "<tr $self->{'tb'}><td><b>Supported Lookup Tables</b></td></tr>";
#		print '<center><b>--Supported Lookup tables--</b></center><br>';
		open(MAILQ, "$self->{'config_hash'}->{'postfix_config_command'} -m 2>/dev/null |");
		while (local $lookup_tables = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$lookup_tables</td></tr>"; }
		close(MAILQ);
		print "</table><br />";
	}

	if (($self->{'Main'} eq 1 || $self->{'Defaultsinmain'} eq 1 ) && ("x`find . -prune  \( -perm 020 -o -perm 002 \) -print`" != "x")){
		print "<center><b>Do not run this in a public- or group-writable directory</b></center><br>";
		exit;
	} else {
	local ($pf_d, $pf_n) = ($self->tempname("postfinger.$$.d"), $self->tempname("postfinger.$$.n"));
	#system ("rm postfinger.*.d postfinger.*.n");
#	unlink  "postfinger.*.d, postfinger.*.n";
	`$self->{'config_hash'}->{'postfix_config_command'} -d | tr -s [:blank:] | sort > $pf_d`;
	`$self->{'config_hash'}->{'postfix_config_command'} -n | tr -s [:blank:] | sort > $pf_n`;

	if ($self->{'Main'} eq 1 ) {
		print "<table width='600' align='center'>";
		print "<tr><td colspan=2><h1>main.cf</h1></td></tr>";
		print "<tr $self->{'tb'}><td colspan=2><b>non-default parameters</b></td></tr>";
#		print '<center><b>--main.cf non-default parameters--</b></center><br>';
		open(MAILQ, "/usr/bin/comm -13 $pf_d $pf_n 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			($self->{'postf1'},$self->{'postf2'})=split(/=/,$postfinger,2);
			print "<tr><td $self->{'cb'}><b>$self->{'postf1'}</b></td>";
			print "<td $self->{'cb'}>$self->{'postf2'}</td></tr>"; }
		close(MAILQ);
		print "</table><br />";
	}

	if ($self->{'Defaultsinmain'} eq 1 ) {
		print "<table width='600' align='center'>";
		print "<tr><td colspan=2><h1>main.cf</h1></td></tr>";
		print "<tr $self->{'tb'}><td colspan=2><b>parameters defined as per defaults</b></td></tr>";
#		print '<center><b>--main.cf parameters defined as per defaults--</b></center><br>';
		open(MAILQ, "/usr/bin/comm -12 $pf_d $pf_n 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			($self->{'postf1'},$self->{'postf2'})=split(/=/,$postfinger,2);
			print "<tr><td $self->{'cb'}><b>$self->{'postf1'}</b></td>";
			print "<td $self->{'cb'}>$self->{'postf2'}</td></tr>"; }
		close(MAILQ);
		print "</table><br />";
	}
	unlink  "$pf_d, $pf_n";
	#unlink  "postfinger.*.d, postfinger.*.n";
	}

	if ($self->{'Master'} eq 1 ) {
		print "<table width='600' cellpadding='8' align='center'>";
		print "<tr><td colspan=8><h1>master.cf</h1></td></tr>";
		print "<tr $self->{'tb'}><td><b>service </b></td><td><b>type</b></td>",
			"<td><b>private</b></td><td><b>unpriv</b></td>",
			"<td><b>chroot</b></td><td><b>wakeup</b></td>",
			"<td><b>maxproc</b></td><td><b>command + args</b></td></tr>";
		open(MAILQ, "/bin/cat `$self->{'config_hash'}->{'postfix_config_command'} -h config_directory`/master.cf 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			($self->{'postf1'},$self->{'postf2'},$self->{'postf3'},$self->{'postf4'},$self->{'postf5'},$self->{'postf6'},$self->{'postf7'},$self->{'postf8'})=split(/\s+/,$postfinger,8);
			if ( grep(/\-\o/,$postfinger)){
				print "<tr><td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}>$self->{'postf2'}</td></tr>"
				if ( !grep(/^#|^\[ 	\]*$/,$postfinger));
			} elsif  ( grep(/user=/,$postfinger)){
				print "<tr><td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}> </td>",
					"<td $self->{'cb'}> </td><td $self->{'cb'}>$self->{'postf1'}</td></tr>"
				if ( !grep(/^#|^\[ 	\]*$/,$postfinger));
			} else {
				print "<tr><td $self->{'cb'}><b>$self->{'postf1'}</b></td><td $self->{'cb'}><center>$self->{'postf2'}</center></td>",
					"<td $self->{'cb'}><center>$self->{'postf3'}</center></td><td $self->{'cb'}><center>$self->{'postf4'}</center></td>",
					"<td $self->{'cb'}><center>$self->{'postf5'}</center></td><td $self->{'cb'}><center>$self->{'postf6'}</center></td>",
					"<td $self->{'cb'}><center>$self->{'postf7'}</center></td><td $self->{'cb'}>$self->{'postf8'}</td></tr>"
				if ( !grep(/^#|^\[ 	\]*$/,$postfinger));
			}
		}
		close(MAILQ);
		print "</table><br>";
	}

	if ($self->{'Permissions'} eq 1 ) {
		print "<table width='600' align='center' cellpadding='0'>";
		print "<tr $self->{'tb'}><td><b>Specific file and directory permissions</b></td></tr>";
		print "<tr><td $self->{'cb'}><b>Permission</b><b> Deep </b><b>Owner</b> <b>Group</b><b> Size </b><b>  Date  </b><b>Directory/File</b> </td></tr>";
		open(MAILQ, "/bin/ls -ld `$self->{'config_hash'}->{'postfix_config_command'} -h queue_directory`/maildrop 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
			if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
		} 
		close(MAILQ);
		print "<tr><td> </td></tr>";
		open(MAILQ, "/bin/ls -ld `$self->{'config_hash'}->{'postfix_config_command'} -h queue_directory`/public 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
			if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
		} 
		close(MAILQ);
		print "<tr><td> </td></tr>";
		if (! open(MAILQ, "/bin/ls -l `$self->{'config_hash'}->{'postfix_config_command'} -h queue_directory`/public 2>/dev/null |")) {
		        print '<center><b>WARNING: No access to $queue_directory/public<br>Try running postfinger as user root or postfix</b></center><br>';
		} else {
			while (local $postfinger = <MAILQ>) {
				print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
				if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
			}
			close(MAILQ);
			print "<tr><td> </td></tr>";
		}
		open(MAILQ, "/bin/ls -ld `$self->{'config_hash'}->{'postfix_config_command'} -h queue_directory`/private 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
			if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
		} 
		close(MAILQ);
		print "<tr><td> </td></tr>";
		if (! open(MAILQ, "/bin/ls -l `$self->{'config_hash'}->{'postfix_config_command'} -h queue_directory`/private 2>/dev/null |")) {
		        print '<center><b>WARNING: No access to $queue_directory/private<br>Try running postfinger as user root or postfix</b></center><br>';
		} else {
			while (local $postfinger = <MAILQ>) {
				print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
				if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
			} 
			close(MAILQ);
			print "<tr><td> </td></tr>";
		}
		open(MAILQ, "/bin/ls -l `$self->{'config_hash'}->{'postfix_config_command'} -h command_directory`/postdrop 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
			print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
			if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
		} 
		close(MAILQ);
		print "<tr><td> </td></tr>";
		open(MAILQ, "/bin/ls -l `$self->{'config_hash'}->{'postfix_config_command'} -h command_directory`/postqueue 2>/dev/null |");
		while (local $postfinger = <MAILQ>) {
				print "<tr><td $self->{'cb'}>$postfinger</td></tr>"
				if ( !grep(/total|^#|^\[ 	\]*$/,$postfinger));
		} 
		close(MAILQ);
		print "</table><br>";
	}
	if ($self->{'Libraries'} eq 1 ) {
		print "<table width='600' align='center'>";
		print "<tr $self->{'tb'}><td colspan=2><b>Library dependencies</b></td></tr>";
		if (! open(MAILQ, "/usr/bin/ldd `$self->{'config_hash'}->{'postfix_config_command'} -h daemon_directory`/smtpd 2>/dev/null |")) {
		        print '<center><b>WARNING: Can not find ldd.  Check you have it installed and in your path</b></center><br>';
		} else {
			while (local $postfinger = <MAILQ>) {
				($self->{'postf1'},$self->{'postf2'})=split(/=/,$postfinger,2);
				print "<tr><td $self->{'cb'}><b>$self->{'postf1'}</b></td>";
				print "<td $self->{'cb'}>=$self->{'postf2'}</td></tr>";
			}
			close(MAILQ);
			print "</table><br>";
		}
	}
print "</td> </tr></table></td> </tr></table>";
$self->footer("index.cgi", $self->{'text_hash'}->{'index_title'});
}

1;
		
}


1;

