#!/usr/bin/perl

$no_acl_check++;
require 'postfix-lib.pl';

sub module_install {
    if (&has_command($config{'postfix_config_command'}) &&
	&backquote_command("$config{'postfix_config_command'} mail_version 2>&1", 1) =~ /mail_version\s*=\s*(.*)/) {
	# Got the version
	$postfix_version = $1;
	# Save the version for use by other CGIs
	&open_tempfile(VERSION, ">$module_config_directory/version", 0, 1);
	&print_tempfile(VERSION, "$postfix_version\n");
	&close_tempfile(VERSION);
	}
}

1;
