#!/usr/bin/perl

&MAIN();

 sub MAIN {
#
# postfix-module by Guillaume Cottenceau <gc@mandrakesoft.com>,
# for webmin by Jamie Cameron
#
# Copyright (c) 2000 by Mandrakesoft
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby 
# granted. No representations are made about the suitability of this software 
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
#
# A form for controlling resource control.
#
# << Here are all options seen in Postfix sample-resource.cf >>

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;


$self->{'access_hash'}->{'resource'} || $self->error($self->{'text_hash'}->{'resource_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'resource_title'}, "");

$self->{'default'} = $self->{'text_hash'}->{'opts_default'};
$self->{'none'} = $self->{'text_hash'}->{'opts_none'};
$self->{'no_'} = $self->{'text_hash'}->{'opts_no'};

print "<form action=save_opts.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'resource_title'}</b></td></tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
$self->option_freefield("bounce_size_limit", 15);
$self->option_freefield("command_time_limit", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("default_process_limit", 15);
$self->option_freefield("duplicate_filter_limit", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("deliver_lock_attempts", 15);
$self->option_freefield("deliver_lock_delay", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("fork_attempts", 15);
$self->option_freefield("fork_delay", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("header_size_limit", 15);
$self->option_freefield("line_length_limit", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("message_size_limit", 15);
$self->option_freefield("qmgr_message_active_limit", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("qmgr_message_recipient_limit", 15);
$self->option_freefield("queue_minfree", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("stale_lock_time", 15);
$self->option_freefield("transport_retry_time", 15);
print "</tr>\n";

print "<tr>\n";
$self->option_freefield("mailbox_size_limit", 15);
print "</tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'opts_save'}\"></form>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

