#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_mailq.cgi
# Display some message from the mail queue

&ModuleLoader::preload_module('postfix_class', "postfix::PostfixLib");
$self = new postfix::PostfixLib:: 'postfix_class',%$self;

&ModuleLoader::preload_module('postfix_class', "postfix::BoxesLib");
$self = new postfix::BoxesLib:: 'postfix_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'mailq'} || $self->error($self->{'text_hash'}->{'mailq_ecannot'});

$self->{'mail'} = $self->parse_queue_file($self->{'in_hash'}->{'id'});
$self->{'mail'} || $self->error($self->{'text_hash'}->{'mailq_egone'});
$self->parse_mail($self->{'mail'});
@{$self->{'sub_array'}} = split(/\0/, $self->{'in_hash'}->{'sub'});
$self->{'subs'} = join("", map { "&sub=$_" } @{$self->{'sub_array'}});
foreach $s (@{$self->{'sub_array'}}) {
        # We are looking at a mail within a mail ..
        local $amail = $self->extract_mail($self->{'mail'}->{'attach'}->[$s]->{'data'});
        $self->parse_mail($amail);
        $self->{'mail'} = $amail;
        }

if (!@{$self->{'sub_array'}}) {
	$self->{'desc'} = $self->text('view_qdesc',"<tt>$self->{'in_hash'}->{'id'}</tt>");
	}
else {
	$self->{'desc'} = $self->{'text_hash'}->{'view_sub'};
	}
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'view_title'}, "");

print "<form action=delete_queues.cgi>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'id'}'>\n";
print "<table width=100% border=1>\n";
print "<tr> <td $self->{'tb'}><table width=100% cellpadding=0 cellspacing=0><tr>",
      "<td><b>$self->{'text_hash'}->{'view_headers'}</b></td>\n";
if ($self->{'in_hash'}->{'headers'}) {
	print "<td align=right><a href='view_mailq.cgi?id=$self->{'in_hash'}->{'id'}&headers=0$self->{'subs'}'>$self->{'text_hash'}->{'view_noheaders'}</a></td>\n";
	}
else {
	print "<td align=right><a href='view_mailq.cgi?id=$self->{'in_hash'}->{'id'}&headers=1$self->{'subs'}'>$self->{'text_hash'}->{'view_allheaders'}</a></td>\n";
	}
print "</tr></table></td> </tr>\n";

print "<tr> <td $self->{'cb'}><table width=100%>\n";
if ($self->{'in_hash'}->{'headers'}) {
	# Show all the headers
	if ($self->{'mail'}->{'fromline'}) {
		print "<tr> <td><b>$self->{'text_hash'}->{'mail_rfc'}</b></td>",
		      "<td>",$self->html_escape($self->{'mail'}->{'fromline'}),"</td> </tr>\n";
		}
	foreach $h (@{$self->{'mail'}->{'headers'}}) {
		print "<tr> <td><b>$h->[0]:</b></td> ",
		      "<td>",$self->html_escape($self->decode_mimewords($h->[1])),
		      "</td> </tr>\n";
		}
	}
else {
	# Just show the most useful headers
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_from'}</b></td> ",
	      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'from'}),"</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_to'}</b></td> ",
	      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'to'}),"</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_cc'}</b></td> ",
	      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'cc'}),"</td> </tr>\n"
		if ($self->{'mail'}->{'header'}->{'cc'});
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_date'}</b></td> ",
	      "<td>",$self->html_escape($self->{'mail'}->{'header'}->{'date'}),"</td> </tr>\n";
	print "<tr> <td><b>$self->{'text_hash'}->{'mail_subject'}</b></td> ",
	      "<td>",$self->html_escape(
			$self->{'mail'}->{'header'}->{'subject'}),"</td> </tr>\n";
	}
print "</table></td></tr></table><p>\n";

# Find body attachment
@{$self->{'attach_array'}} = @{$self->{'mail'}->{'attach'}};
foreach $a (@{$self->{'attach_array'}}) {
	if ($a->{'type'} eq 'text/plain') {
		$self->{'body'} = $a;
		last;
		}
	}
if ($self->{'body'}) {
	print "<table width=100% border=1><tr><td $self->{'cb'}><pre>\n";
	foreach $l ($self->wrap_lines($self->{'body'}->{'data'}, $self->{'config_hash'}->{'wrap_width'})) {
		print $self->link_urls_and_escape($l),"\n";
		}
	print "</pre></td></tr></table><p>\n";
	}

# Display other attachments
@{$self->{'attach_array'}} = grep { $_ ne $self->{'body'} } @{$self->{'attach_array'}};
@{$self->{'attach_array'}} = grep { !$_->{'attach'} } @{$self->{'attach_array'}};
if (@{$self->{'attach_array'}}) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $self->{'tb'}><b>$self->{'text_hash'}->{'view_attach'}</b></td> </tr>\n";
	print "<tr> <td $self->{'cb'}>\n";
	foreach $a (@{$self->{'attach_array'}}) {
		if ($a->{'type'} eq 'message/rfc822') {
			push(@{$self->{'titles_array'}}, $self->{'text_hash'}->{'view_sub'});
			push(@{$self->{'links_array'}}, "view_mailq.cgi?id=$self->{'in_hash'}->{'id'}$self->{'subs'}&sub=$a->{'idx'}");
			}
		else {
			push(@{$self->{'titles_array'}}, $a->{'filename'} ?
			    $self->decode_mimewords($a->{'filename'}) : $a->{'type'});
			push(@{$self->{'links_array'}}, "detach_queue.cgi?id=$self->{'in_hash'}->{'id'}&attach=$a->{'idx'}$self->{'subs'}");
			}
		push(@{$self->{'icons_array'}}, "images/boxes.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 8);
	print "</td></tr></table><p>\n";
	}

# Display buttons
if (!@{$self->{'sub_array'}}) {
	print "<input type=submit value=\"$self->{'text_hash'}->{'view_delete'}\" name=delete>\n";
	print "<p>\n";
	}
print "</form>\n";

$self->ui_print_footer(!@{$self->{'sub_array'}} ? ( ) : ( "view_mailq.cgi?id=$self->{'in_hash'}->{'id'}", $self->{'text_hash'}->{'view_return'} ),
	"mailq.cgi", $self->{'text_hash'}->{'mailq_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

