#!/usr/bin/perl
package postgresql::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'postgresql::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

	# Check for PostgreSQL program
	return if (!-x $self->{'config_hash'}->{'psql'} || -d $self->{'config_hash'}->{'psql'});
	# Check for the config file
	if (!-r $self->{'config_hash'}->{'hba_conf'} && $self->{'config_hash'}->{'setup_cmd'}) {
		$self->{'temp'} = $self->transname();
		$self->{'rv'} = $self->system_logged("($self->{'config_hash'}->{'setup_cmd'}) >$self->{'temp'} 2>&1");
		$self->{'out'} = `cat $self->{'temp'}`;
		unlink($self->{'temp'});
		#if ($self->{'rv'}) {
		#	&error("<pre>$self->{'out'}</pre>");
		#}
		sleep(3);
		#&webmin_log("setup");
	}
}


1;

