#!/usr/bin/perl

&MAIN();

 sub MAIN {
# drop_table.cgi
# Delete an existing table

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->{'qt'} = $self->quote_table($self->{'in_hash'}->{'table'});
if ($self->{'in_hash'}->{'confirm'}) {
	# Drop the table
	$self->error_setup($self->{'text_hash'}->{'tdrop_err'});
	$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "drop table $self->{'qt'}");
	$self->webmin_log("delete", "table", $self->{'in_hash'}->{'table'}, \%{$self->{'in_hash'}});
	$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");
	}
else {
	# Ask the user if he is sure..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'tdrop_title'}, "");
	@{$self->{'tables_array'}} = $self->list_tables($self->{'in_hash'}->{'db'});
	$self->{'d'} = $self->execute_sql_safe($self->{'in_hash'}->{'db'}, "select count(*) from $self->{'qt'}");
	$self->{'rows'} = $self->{'d'}->{'data'}->[0]->[0];

	print "<center><b>", $self->text('tdrop_rusure', "<tt>$self->{'in_hash'}->{'table'}</tt>",
				   "<tt>$self->{'in_hash'}->{'db'}</tt>", $self->{'rows'}),"</b><p>\n";
	print "<form action=drop_table.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'tdrop_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("edit_table.cgi?db=$self->{'in_hash'}->{'db'}&table=$self->{'in_hash'}->{'table'}",
		$self->{'text_hash'}->{'table_return'});
	}

1;
		
}


1;

