#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple tables

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
@{$self->{'tables_array'}} = split(/\0/, $self->{'in_hash'}->{'d'});
@{$self->{'tables_array'}} || $self->error($self->{'text_hash'}->{'tdrops_enone'});

if ($self->{'in_hash'}->{'confirm'}) {
	# Drop the tables, views, sequences and indexes (tables last)
	$self->error_setup($self->{'text_hash'}->{'tdrops_err'});
	foreach $t (@{$self->{'tables_array'}}) {
		if ($t =~ /^\!(.*)$/) {
			$self->{'qt'} = $self->quote_table($1);
			$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "drop index $self->{'qt'}");
			}
		elsif ($t =~ /^\*(.*)$/) {
			$self->{'qt'} = $self->quote_table($1);
			$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "drop view $self->{'qt'}");
			}
		elsif ($t =~ /^\/(.*)$/) {
			$self->{'qt'} = $self->quote_table($1);
			$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "drop sequence $self->{'qt'}");
			}
		else {
			push(@{$self->{'rest_array'}}, $t);
			}
		}
	foreach $t (@{$self->{'rest_array'}}) {
		$self->{'qt'} = $self->quote_table($t);
		$self->execute_sql_logged($self->{'in_hash'}->{'db'}, "drop table $self->{'qt'}");
		}
	$self->webmin_log("delete", "tables", scalar(@{$self->{'tables_array'}}), \%{$self->{'in_hash'}});
	$self->redirect("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}");
	}
else {
	# Ask the user if he is sure..
	$self->ui_print_header(undef, $self->{'text_hash'}->{'tdrops_title'}, "");
	foreach $t (@{$self->{'tables_array'}}) {
		if ($t !~ /^\!/ && $t !~ /^\*/ && $t !~ /^\//) {
			$self->{'qt'} = $self->quote_table($t);
			$self->{'d'} = $self->execute_sql_safe($self->{'in_hash'}->{'db'}, "select count(*) from $self->{'qt'}");
			$self->{'rows'} += $self->{'d'}->{'data'}->[0]->[0];
			}
		}

	$self->{'msg'} = defined($self->{'rows'}) ? 'tdrops_rusure' : 'tdrops_rusure2';
	print "<center><b>", $self->text($self->{'msg'}, scalar(@{$self->{'tables_array'}}),
				   "<tt>$self->{'in_hash'}->{'db'}</tt>", $self->{'rows'}),"</b><p>\n";
	print "<form action=drop_tables.cgi>\n";
	print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
	foreach $t (@{$self->{'tables_array'}}) {
		print $self->ui_hidden("d", $t),"\n";
		}
	print "<input type=submit name=confirm value='$self->{'text_hash'}->{'tdrops_ok'}'>\n";
	print "</form></center>\n";
	$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}",
			$self->{'text_hash'}->{'dbase_return'});
	}

1;
		
}


1;

