#!/usr/bin/perl

&MAIN();

 sub MAIN {
# exec_form.cgi
# Display a form for executing SQL in some database

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->can_edit_db($self->{'in_hash'}->{'db'}) || $self->error($self->{'text_hash'}->{'dbase_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'exec_title'}, "", "exec_form");

# Form for executing an SQL command
print "<p>",$self->text('exec_header', "<tt>$self->{'in_hash'}->{'db'}</tt>"),"<p>\n";
print "<form action=exec.cgi method=post>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'>\n";
print "<textarea name=cmd rows=10 cols=70></textarea><br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'exec_exec'}'></form>\n";

# Form for executing commands from a file
print "<hr>\n";
print "<p>",$self->text('exec_header2', "<tt>$self->{'in_hash'}->{'db'}</tt>"),"<p>\n";
print "<form action=exec_file.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'> <table>\n";
print "<tr> <td><input type=radio name=mode value=0 checked> ",
      "$self->{'text_hash'}->{'exec_file'}</td> <td><input name=file size=40> ",
      $self->file_chooser_button("file", 0, 1),"</td> </tr>\n";
print "<tr> <td><input type=radio name=mode value=1> ",
      "$self->{'text_hash'}->{'exec_upload'}</td> ",
      "<td><input name=upload type=file></td> </tr>\n";
print "</table> <input type=submit value='$self->{'text_hash'}->{'exec_exec'}'></form>\n";

# Form for loading a CSV or tab-separated file
print "<hr>\n";
print "<p>",$self->text('exec_header3', "<tt>$self->{'in_hash'}->{'db'}</tt>"),"<br>",
      $self->{'text_hash'}->{'exec_header4'},"<p>\n";
print "<form action=import.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=db value='$self->{'in_hash'}->{'db'}'> <table>\n";

print "<tr> <td><input type=radio name=mode value=0 checked> ",
      "$self->{'text_hash'}->{'exec_file'}</td> <td><input name=file size=40> ",
      $self->file_chooser_button("file", 0, 2),"</td> </tr>\n";

print "<tr> <td><input type=radio name=mode value=1> ",
      "$self->{'text_hash'}->{'exec_upload'}</td> ",
      "<td><input name=upload type=file></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'exec_import'}</b></td>\n";
print "<td><select name=table>\n";
foreach $t ($self->list_tables($self->{'in_hash'}->{'db'})) {
	print "<option>$t\n";
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'exec_delete'}</b></td>\n";
print "<td><input type=radio name=delete value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=delete value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'exec_ignore'}</b></td>\n";
print "<td><input type=radio name=ignore value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input type=radio name=ignore value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'exec_format'}</b></td>\n";
print "<td>",$self->ui_radio("format", 2, [ [ 0, $self->{'text_hash'}->{'csv_format0'} ],
				      [ 1, $self->{'text_hash'}->{'csv_format1'} ],
				      [ 2, $self->{'text_hash'}->{'csv_format2'} ] ]),
      "</td> </tr>\n";

print "</table> <input type=submit value='$self->{'text_hash'}->{'exec_exec'}'></form>\n";

$self->ui_print_footer("edit_dbase.cgi?db=$self->{'in_hash'}->{'db'}", $self->{'text_hash'}->{'dbase_return'},
	"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

