#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_groups.cgi
# Display all groups in the database

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->{'access_hash'}->{'users'} || $self->error($self->{'text_hash'}->{'group_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'group_title'}, "", "list_groups");

$self->{'s'} = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select * from pg_user");
foreach $u (@{$self->{'s'}->{'data'}}) {
	$self->{'uid_hash'}->{$u->[1]} = $u->[0];
	}

$self->{'s'} = $self->execute_sql_safe($self->{'config_hash'}->{'basedb'}, "select * from pg_group");
@{$self->{'rowlinks_array'}} = ( "<a href='edit_group.cgi?new=1'>$self->{'text_hash'}->{'group_add'}</a>" );
if (@{$self->{'s'}->{'data'}}) {
	print $self->ui_form_start("delete_groups.cgi", "post");
	unshift(@{$self->{'rowlinks_array'}}, $self->select_all_link("d", 0),
			   $self->select_invert_link("d", 0) );
	print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
	local @tds = ( "width=5" );
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'group_name'},
				  $self->{'text_hash'}->{'group_name'},
				  $self->{'text_hash'}->{'group_mems'} ], 100, 0, \@tds);
	foreach $g (@{$self->{'s'}->{'data'}}) {
		local @cols;
		push(@cols, "<a href='edit_group.cgi?gid=$g->[1]'>".
			    $self->html_escape($g->[0])."</a>");
		push(@cols, $g->[1]);
		push(@cols, join("&nbsp;|&nbsp;",
		     map { $self->html_escape($self->{'uid_hash'}->{$_}) } $self->split_array($g->[2])));
		print $self->ui_checked_columns_row(\@cols, \@tds, "d", $g->[1]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'group_none'}</b><p>\n";
	}
print $self->ui_links_row(\@{$self->{'rowlinks_array'}});
print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'user_delete'} ] ]) if (@{$self->{'s'}->{'data'}});

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

