#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newdb.cgi
# Create a new database with one optional table

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'newdb_ecannot'});
$self->error_setup($self->{'text_hash'}->{'newdb_err'});

# Make sure maximum databases limit has not been exceeded
@{$self->{'alldbs_array'}} = $self->list_databases();
@{$self->{'titles_array'}} = grep { $self->can_edit_db($_) } @{$self->{'alldbs_array'}};
if ($self->{'access_hash'}->{'create'} == 2 && @{$self->{'titles_array'}} >= $self->{'access_hash'}->{'max'}) {
	$self->error($self->{'text_hash'}->{'newdb_ecannot2'});
	}

$self->{'in_hash'}->{'db'} =~ /^[A-z0-9\.\-]+$/ || $self->error($self->{'text_hash'}->{'newdb_edb'});
$self->{'cmd'} = "create database $self->{'in_hash'}->{'db'}";
if (!$self->{'in_hash'}->{'path_def'}) {
	$self->{'in_hash'}->{'path'} =~ /\S/ || $self->error($self->{'text_hash'}->{'newdb_epath'});
	$self->{'cmd'} .= " with location = '$self->{'in_hash'}->{'path'}'";
	}
if (!$self->{'in_hash'}->{'user_def'}) {
	$self->{'cmd'} .= " with owner=\"$self->{'in_hash'}->{'user'}\"";
	}
if (!$self->{'in_hash'}->{'encoding_def'} && $self->get_postgresql_version() >= 8) {
	$self->{'in_hash'}->{'encoding'} =~ /\S/ || $self->error($self->{'text_hash'}->{'newdb_eencoding'});
	$self->{'cmd'} .= " encoding = '$self->{'in_hash'}->{'encoding'}'";
	}
$self->execute_sql_logged($self->{'config_hash'}->{'basedb'}, $self->{'cmd'});
$self->webmin_log("create", "db", $self->{'in_hash'}->{'db'});
if ($self->{'access_hash'}->{'dbs'} ne '*') {
	$self->{'access_hash'}->{'dbs'} .= " " if ($self->{'access_hash'}->{'dbs'});
	$self->{'access_hash'}->{'dbs'} .= $self->{'in_hash'}->{'db'};
	$self->save_module_acl(\%{$self->{'access_hash'}});
	}
$self->redirect("");

1;
		
}


1;

