#!/usr/bin/perl

&MAIN();

 sub MAIN {
# newdb_form.cgi
# Display a form for creating a new database

&ModuleLoader::preload_module('postgresql_class', "postgresql::PostgresqlLib");
$self = new postgresql::PostgresqlLib:: 'postgresql_class',%$self;

$self->{'access_hash'}->{'create'} || $self->error($self->{'text_hash'}->{'newdb_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'newdb_title'}, "", "newdb_form");

print "<form action=newdb.cgi method=post>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'newdb_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

# Database name
print "<tr> <td><b>$self->{'text_hash'}->{'newdb_db'}</b></td>\n";
print "<td><input name=db size=15></td> </tr>\n";

if ($self->get_postgresql_version() >= 7) {
	# Owner option
	print "<tr> <td><b>$self->{'text_hash'}->{'newdb_user'}</b></td>\n";
	print "<td><input type=radio name=user_def value=1 checked> $self->{'text_hash'}->{'default'}\n";
	print "<input type=radio name=user_def value=0>\n";
	print "<select name=user>\n";
	$u = $self->execute_sql($self->{'config_hash'}->{'basedb'}, "select usename from pg_shadow");
	@{$self->{'users_array'}} = map { $_->[0] } @{$u->{'data'}};
	foreach $u (@{$self->{'users_array'}}) {
		print "<option>$u\n";
		}
	print "</select></td> </tr>\n";
	}

if ($self->get_postgresql_version() >= 8) {
	# Encoding option
	print "<tr> <td><b>$self->{'text_hash'}->{'newdb_encoding'}</b></td>\n";
	print "<td>",$self->ui_opt_textbox("encoding", undef, 20, $self->{'text_hash'}->{'default'}),
	      "</td> </tr>\n";
	}

# Path to database file
print "<tr> <td><b>$self->{'text_hash'}->{'newdb_path'}</b></td>\n";
print "<td>",$self->ui_opt_textbox("path", undef, 30, $self->{'text_hash'}->{'default'}),
      "</td> </tr>\n";

print "<tr> <td colspan=2 align=right><input type=submit ",
      "value='$self->{'text_hash'}->{'create'}'></td> </tr>\n";

print "</table></td></tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

