#!/usr/bin/perl

&MAIN();

 sub MAIN {
# bootup.cgi
# Create, enable or disable PPTP startup at boot time

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;

$self->foreign_require("init", "init-lib.pl");
$self->ReadParse();

$self->{'start_cmd'} = "$self->{'module_config_directory'}/start.pl";
$self->{'stop_cmd'} = "$self->{'module_config_directory'}/stop.pl";

if ($self->{'in_hash'}->{'tunnel'}) {
	# Create start and stop wrapper scripts
	$self->foreign_require("cron", "cron-lib.pl");
	$main::cron_object->create_wrapper($self->{'start_cmd'}, $self->{'module_name'}, "start.pl");
	$main::cron_object->create_wrapper($self->{'stop_cmd'}, $self->{'module_name'}, "stop.pl");

	# Enable starting at boot
	$main::init_object->enable_at_boot($self->{'module_name'},
			      "Startup or shutdown PPTP connection",
			      $self->{'start_cmd'}, $self->{'stop_cmd'});
	$self->{'config_hash'}->{'boot'} = $self->{'in_hash'}->{'tunnel'};
	}
else {
	# Disable starting at boot
	$main::init_object->disable_at_boot($self->{'module_name'});
	delete($self->{'config_hash'}->{'boot'});
	}

# Save setting
$self->save_module_config();

$self->redirect("");

1;
		
}


1;

