#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_opts.cgi
# Display PPP options for all connections

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'opts_title'}, "");

print $self->text('opts_desc', "<tt>$self->{'config_hash'}->{'pptp_options'}</tt>"),"<br>\n";
@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'config_hash'}->{'pptp_options'});

print "<form action=save_opts.cgi method=post>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'opts_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'mtu'} = $self->find("mtu", \@{$self->{'opts_array'}});
printf "<tr> <td><b>$self->{'text_hash'}->{'opts_mtu'}</b></td> <td>\n";
printf "<input type=radio name=mtu_def value=1 %s> %s\n",
	$self->{'mtu'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=mtu_def value=0 %s>\n",
	$self->{'mtu'} ? "checked" : "";
print "<input name=mtu size=6 value='$self->{'mtu'}->{'value'}'> bytes</td>\n";

$self->{'mru'} = $self->find("mru", \@{$self->{'opts_array'}});
printf "<td><b>$self->{'text_hash'}->{'opts_mru'}</b></td> <td>\n";
printf "<input type=radio name=mru_def value=1 %s> %s\n",
	$self->{'mru'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=mru_def value=0 %s>\n",
	$self->{'mru'} ? "checked" : "";
print "<input name=mru size=6 value='$self->{'mru'}->{'value'}'> bytes</td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";
print "<tr> <td colspan=4 align=center>$self->{'text_hash'}->{'opts_msdesc'}</td> </tr>\n";

# Show MPPE options
$self->mppe_options_form(\@{$self->{'opts_array'}});

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

