#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_opts.cgi
# Save global PPTP PPP options

&ModuleLoader::preload_module('pptp_client_class', "pptp_client::PptpclientLib");
$self = new pptp_client::PptpclientLib:: 'pptp_client_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'opts_err'});

$self->lock_file($self->{'config_hash'}->{'pptp_options'});
@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'config_hash'}->{'pptp_options'});
if ($self->{'in_hash'}->{'mtu_def'}) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'config_hash'}->{'pptp_options'}, "mtu", undef);
	}
else {
	$self->{'in_hash'}->{'mtu'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'opts_emtu'});
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'config_hash'}->{'pptp_options'}, "mtu",
			 { 'name' => 'mtu', 'value' => $self->{'in_hash'}->{'mtu'} });
	}
if ($self->{'in_hash'}->{'mru_def'}) {
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'config_hash'}->{'pptp_options'}, "mru", undef);
	}
else {
	$self->{'in_hash'}->{'mru'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'opts_emru'});
	$self->save_ppp_option(\@{$self->{'opts_array'}}, $self->{'config_hash'}->{'pptp_options'}, "mru",
			 { 'name' => 'mru', 'value' => $self->{'in_hash'}->{'mru'} });
	}
$self->parse_mppe_options(\@{$self->{'opts_array'}}, $self->{'config_hash'}->{'pptp_options'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'pptp_options'});
$self->webmin_log("opts");

$self->redirect("");

1;
		
}


1;

