#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_options.cgi
# XXX +chap options?

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'options'} || $self->error($self->{'text_hash'}->{'options_ecannot'});
$self->{'out'} = `pppd --help 2>&1`;
if ($self->{'out'} =~ /version\s+(\S+)/i) {
        $self->{'vers'} = $1;
        }
$self->ui_print_header(undef, $self->{'text_hash'}->{'options_title'}, "", "options", 0, 0, 0, undef, undef, undef,
	$self->text('options_version', $self->{'vers'}));

$self->{'conf'} = $self->get_config();
$self->{'option'} = $self->find_conf("option", $self->{'conf'});
$self->{'option'} ||= $self->{'config_hash'}->{'ppp_options'};
@{$self->{'opts_array'}} = $self->parse_ppp_options($self->{'option'});

if ($self->{'option'} eq $self->{'config_hash'}->{'ppp_options'}) {
	print $self->text('options_desc0', "<tt>$self->{'option'}</tt>"),"\n";
	}
else {
	print $self->text('options_desc1', "<tt>$self->{'option'}</tt>"),"\n";
	}
print "$self->{'text_hash'}->{'options_desc2'}<p>\n";

print "<form action=save_options.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'options_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'lock'} = $self->find("lock", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_lock'}</b></td>\n";
printf "<td><input type=radio name=lock value=1 %s> %s\n",
	$self->{'lock'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=lock value=0 %s> %s</td>\n",
	$self->{'lock'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'proxy'} = $self->find("proxyarp", \@{$self->{'opts_array'}});
print "<td><b>$self->{'text_hash'}->{'options_proxyarp'}</b></td>\n";
printf "<td><input type=radio name=proxyarp value=1 %s> %s\n",
	$self->{'proxy'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=proxyarp value=0 %s> %s</td> </tr>\n",
	$self->{'proxy'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'mtu'} = $self->find("mtu", \@{$self->{'opts_array'}});
printf "<tr> <td><b>$self->{'text_hash'}->{'options_mtu'}</b></td> <td>\n";
printf "<input type=radio name=mtu_def value=1 %s> %s\n",
	$self->{'mtu'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=mtu_def value=0 %s>\n",
	$self->{'mtu'} ? "checked" : "";
print "<input name=mtu size=6 value='$self->{'mtu'}->{'value'}'> bytes</td>\n";

$self->{'mru'} = $self->find("mru", \@{$self->{'opts_array'}});
printf "<td><b>$self->{'text_hash'}->{'options_mru'}</b></td> <td>\n";
printf "<input type=radio name=mru_def value=1 %s> %s\n",
	$self->{'mru'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=mru_def value=0 %s>\n",
	$self->{'mru'} ? "checked" : "";
print "<input name=mru size=6 value='$self->{'mru'}->{'value'}'> bytes</td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

$self->{'auth'} = $self->find("auth", \@{$self->{'opts_array'}});
$self->{'noauth'} = $self->find("noauth", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_auth'}</b></td>\n";
printf "<td colspan=3><input type=radio name=auth value=0 %s> %s\n",
	$self->{'noauth'} || $self->{'auth'} ? "" : "checked", $self->{'text_hash'}->{'options_auth0'};
printf "<input type=radio name=auth value=1 %s> %s\n",
	$self->{'noauth'} ? "checked" : "", $self->{'text_hash'}->{'options_auth1'};
printf "<input type=radio name=auth value=2 %s> %s</td> </tr>\n",
	$self->{'auth'} ? "checked" : "", $self->{'text_hash'}->{'options_auth2'};

&auth_input("pap");
&auth_input("chap");

$self->{'login'} = $self->find("login", \@{$self->{'opts_array'}});
print "<tr> <td><b>$self->{'text_hash'}->{'options_login'}</b></td>\n";
printf "<td><input type=radio name=login value=1 %s> %s\n",
	$self->{'login'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=login value=0 %s> %s</td>\n",
	$self->{'login'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'name'} = $self->find("name", \@{$self->{'opts_array'}});
printf "<tr> <td><b>$self->{'text_hash'}->{'options_name'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=name_def value=1 %s> %s (%s)\n",
	$self->{'name'} ? "" : "checked", $self->{'text_hash'}->{'options_hn'}, $self->get_system_hostname();
printf "<input type=radio name=name_def value=0 %s>\n",
	$self->{'name'} ? "checked" : "";
print "<input name=name size=30 value='$self->{'name'}->{'value'}'></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td colspan=4 align=center>$self->{'text_hash'}->{'options_msdesc'}</td> </tr>\n";

$self->foreign_require("pptp_client", "pptp-client-lib.pl");
if ($main::pptp_client_object->mppe_support() == 1) {
	# Show new-style MS-CHAP options
	&auth_input("mschap");
	&auth_input("mschap-v2");
	}
else {
	# Show old-style MS-CHAP option
	&auth_input("chapms");
	&auth_input("chapms-v2");
	}

# Show general MPPE options
$main::pptp_client_object->mppe_options_form(\@{$self->{'opts_array'}});

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# auth_input(name)
sub auth_input
{
	shift if ($self == $_[0]);

local $a = $_[0];
local $req = $self->find("require-$a", \@{$self->{'opts_array'}});
local $ref = $self->find("refuse-$a", \@{$self->{'opts_array'}});
print "<tr> <td><b>",$self->{'text_hash'}->{'options_'.$a},"</b></td> <td colspan=3>\n";
printf "<input type=radio name=$a value=2 %s> %s\n",
	$req ? "checked" : "", $self->{'text_hash'}->{"options_req"};
printf "<input type=radio name=$a value=1 %s> %s\n",
	$req || $ref ? "" : "checked", $self->{'text_hash'}->{"options_all"};
printf "<input type=radio name=$a value=0 %s> %s</td> </tr>\n",
	$ref ? "checked" : "", $self->{'text_hash'}->{"options_ref"};
}


1;

