#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_secret.cgi
# Displays a form for editing or creating a pap secret

&ModuleLoader::preload_module('pptp_server_class', "pptp_server::PptpserverLib");
$self = new pptp_server::PptpserverLib:: 'pptp_server_class',%$self;

$self->{'access_hash'}->{'secrets'} || $self->error($self->{'text_hash'}->{'secrets_ecannot'});
if (@ARGV) {
	$self->{'idx'} = $ARGV[0];
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_secret_etitle'}, "");
	$self->{'host'} = $self->get_ppp_hostname();
	@{$self->{'seclist_array'}} = grep { $_->{'server'} eq $self->{'host'} } $self->list_secrets();
	%{$self->{'sec_hash'}} = %{$self->{'seclist_array'}->[$self->{'idx'}]};
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_secret_ctitle'}, "");
	}

print "<form action=save_secret.cgi>\n";
if (%{$self->{'sec_hash'}}) { print "<input type=hidden name=idx value=$self->{'idx'}>\n"; }
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->{'text_hash'}->{'edit_secret_acc'},"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr $self->{'cb'}> <td><b>", $self->{'text_hash'}->{'edit_secret_user'}, "</b></td>\n";
printf "<td colspan=3><input type=radio name=client_def value=1 %s> ",
	%{$self->{'sec_hash'}} && !$self->{'sec_hash'}->{'client'} ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_uany'}, "\n";
printf "<input type=radio name=client_def value=0 %s> ",
	%{$self->{'sec_hash'}} && !$self->{'sec_hash'}->{'client'} ? "" : "checked";
print "<input name=client size=40 value=\"$self->{'sec_hash'}->{'client'}\"></td>\n";

print "<tr $self->{'cb'}> <td valign=top><b>", $self->{'text_hash'}->{'edit_secret_pass'}, "</b></td>\n";
printf "<td valign=top><input type=radio name=pass_mode value=0 %s> ",
	%{$self->{'sec_hash'}} && $self->{'sec_hash'}->{'secret'} eq "" ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_none'}, "<br>\n";
printf "<input type=radio name=pass_mode value=1 %s> ",
	$self->{'sec_hash'}->{'secret'} =~ /^@(.*)$/ ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_ffile'};
printf "<input name=pass_file size=20 value=\"%s\">\n",
	$self->{'sec_hash'}->{'secret'} =~ /^@(.*)$/ ? $1 : "";
print $self->file_chooser_button("pass_file", 0);
print "<br>\n";
if (%{$self->{'sec_hash'}}) {
	printf "<input type=radio name=pass_mode value=2 %s> ",
		$self->{'sec_hash'}->{'secret'} !~ /^(@.*|)$/ ? "checked" : "";
	print $self->{'text_hash'}->{'edit_secret_leave'}, "<br>\n";
	}
printf "<input type=radio name=pass_mode value=3 %s> ",
	%{$self->{'sec_hash'}} ? "" : "checked";
print $self->{'text_hash'}->{'edit_secret_setto'}, "\n";
print "<input type=password name=pass_text size=15></td>\n";

@{$self->{'ips_array'}} = @{$self->{'sec_hash'}->{'ips'}};
print "<td valign=top><b>", $self->{'text_hash'}->{'edit_secret_vaddr'}, "</b></td>\n";
printf "<td><input type=radio name=ips_mode value=0 %s> ",
	$self->{'ips_array'}->[0] eq "*" || !@{$self->{'ips_array'}} ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_aany'}, "<br>\n";
printf "<input type=radio name=ips_mode value=1 %s> ",
	$self->{'ips_array'}->[0] eq "-" ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_anone'}, "<br>\n";
printf "<input type=radio name=ips_mode value=2 %s> ",
	@{$self->{'ips_array'}} && $self->{'ips_array'}->[0] ne "-" && $self->{'ips_array'}->[0] ne "*" ? "checked" : "";
print $self->{'text_hash'}->{'edit_secret_alist'}, "<br>\n";
printf "<textarea name=ips rows=5 cols=20>%s</textarea></td> </tr>\n",
	@{$self->{'ips_array'}} && $self->{'ips_array'}->[0] ne "-" && $self->{'ips_array'}->[0] ne "*" ? join("\n", @{$self->{'ips_array'}}) : "";

print "</table></td></tr></table>\n";
print "<table width=100%><tr><td align=left>\n";
print "<input type=submit value=", $self->{'text_hash'}->{'edit_secret_save'}, "></td>\n";
if (%{$self->{'sec_hash'}}) {
	print "<td align=right>\n";
	print "<input type=submit name=delete value=", $self->{'text_hash'}->{'edit_secret_del'},
	      "></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("list_secrets.cgi", $self->{'text_hash'}->{'edit_secret_return'});

1;
		
}


1;

