#!/usr/bin/perl
package proc::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proc::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "proc::ProcLib");
$self = new proc::ProcLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the proc module
sub acl_security_form
{
	my $self = shift;

# Run as user
print "<tr> <td><b>$self->{'text_hash'}->{'acl_manage'}</b></td> <td colspan=3>\n";
local $u = $_[0]->{'uid'} < 0 ? undef : getpwuid($_[0]->{'uid'});
printf "<input type=radio name=uid_def value=1 %s> %s\n",
	$_[0]->{'uid'} < 0 ? 'checked' : '', $self->{'text_hash'}->{'acl_manage_def'};
printf "<input type=radio name=uid_def value=0 %s>\n",
	$_[0]->{'uid'} < 0 ? '' : 'checked';
print "<input name=uid size=8 value='$u'> ",
	$self->user_chooser_button("uid", 0),"</td> </tr>\n";

# Who can be managed
if (!defined($_[0]->{'users'})) {
	$_[0]->{'users'} = $_[0]->{'uid'} < 0 ? "x" :
			   $_[0]->{'uid'} == 0 ? "*" : getpwuid($_[0]->{'uid'});
	}
local $who = $_[0]->{'users'} eq "x" ? 1 :
	     $_[0]->{'users'} eq "*" ? 0 : 2;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_who'}</b></td> <td colspan=3>\n";
print $self->ui_radio("who", $who,
		[ [ 0, $self->{'text_hash'}->{'acl_who0'}."<br>\n" ],
		  [ 1, $self->{'text_hash'}->{'acl_who1'}."<br>\n" ],
		  [ 2, $self->{'text_hash'}->{'acl_who2'} ] ])." ".
		       $self->ui_textbox("users", $who == 2 ? $_[0]->{'users'} : "",
				   40),"</td> </tr>\n";

# Can do stuff to processes?
print "<tr> <td><b>$self->{'text_hash'}->{'acl_edit'}</b></td>\n";
printf "<td><input type=radio name=edit value=1 %s> %s\n",
	$_[0]->{'edit'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=edit value=0 %s> %s</td>\n",
	$_[0]->{'edit'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

# Can run commands?
print "<td><b>$self->{'text_hash'}->{'acl_run'}</b></td>\n";
printf "<td><input type=radio name=run value=1 %s> %s\n",
	$_[0]->{'run'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=run value=0 %s> %s</td> </tr>\n",
	$_[0]->{'run'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

# Can see other processes?
print "<tr> <td><b>$self->{'text_hash'}->{'acl_only'}</b></td>\n";
printf "<td><input type=radio name=only value=1 %s> %s\n",
	$_[0]->{'only'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=only value=0 %s> %s</td>\n",
	$_[0]->{'only'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

print "</tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the proc module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'uid'} = $self->{'in_hash'}->{'uid_def'} ? -1 : getpwnam($self->{'in_hash'}->{'uid'});
$_[0]->{'edit'} = $self->{'in_hash'}->{'edit'};
$_[0]->{'run'} = $self->{'in_hash'}->{'run'};
$_[0]->{'only'} = $self->{'in_hash'}->{'only'};
$_[0]->{'users'} = $self->{'in_hash'}->{'who'} == 0 ? "*" :
		   $self->{'in_hash'}->{'who'} == 1 ? "x" : $self->{'in_hash'}->{'users'};
}


1;

