#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index_user.cgi

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "user", !$self->{'no_module_config'}, 1);

$self->index_links("user");
@{$self->{'procs_array'}} = sort { $b->{'cpu'} <=> $a->{'cpu'} } $self->list_processes();
@{$self->{'procs_array'}} = grep { $self->can_view_process($_->{'user'}) } @{$self->{'procs_array'}};
@{$self->{'users_array'}} = $self->unique(map { $_->{'user'} } @{$self->{'procs_array'}});
foreach $u (@{$self->{'users_array'}}) {
	if ($self->supports_users()) {
		@{$self->{'uinfo_array'}} = getpwnam($u);
		$self->{'uinfo_array'}->[6] =~ s/,.*$//;
		}
	print $self->ui_subheading("$u ".($self->{'uinfo_array'}->[6] ? "($self->{'uinfo_array'}->[6])" : "")),"\n";
	print $self->ui_columns_start([
			  $self->{'text_hash'}->{'pid'},
			  $self->{'text_hash'}->{'cpu'},
			  $self->{'info_arg_map_hash'}->{'_stime'} ? ( $self->{'text_hash'}->{'stime'} ) : ( ),
			  $self->{'text_hash'}->{'command'} ], 100);
	foreach $pr (grep { $_->{'user'} eq $u } @{$self->{'procs_array'}}) {
		$self->{'p'} = $pr->{'pid'};
		local @cols;
		if ($self->can_edit_process($pr->{'user'})) {
			push(@cols, "<a href=\"edit_proc.cgi?$self->{'p'}\">$self->{'p'}</a>");
			}
		else {
			push(@cols, $self->{'p'});
			}
		push(@cols, $pr->{'cpu'});
		if ($self->{'info_arg_map_hash'}->{'_stime'}) {
			push(@cols, $pr->{'_stime'});
			}
		push(@cols, $self->html_escape($self->cut_string($pr->{'args'})));
		print $self->ui_columns_row(\@cols);
		}
	print $self->ui_columns_end();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

