#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index_user.cgi

&ModuleLoader::preload_module('proc_class', "proc::ProcLib");
$self = new proc::ProcLib:: 'proc_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "zone", !$self->{'no_module_config'}, 1);

$self->index_links("zone");
@{$self->{'procs_array'}} = sort { $b->{'cpu'} <=> $a->{'cpu'} } $self->list_processes();
@{$self->{'procs_array'}} = grep { $self->can_view_process($_->{'user'}) } @{$self->{'procs_array'}};
@{$self->{'zones_array'}} = $self->unique(map { $_->{'_zone'} } @{$self->{'procs_array'}});
foreach $z (@{$self->{'zones_array'}}) {
	print "<dt><font size=+1>",$self->text('index_inzone', "<tt>$z</tt>"),"</font><br>\n";
	print "<dd><table border width=90%>\n";
	print "<tr $self->{'tb'}> <td width=1% nowrap><b>$self->{'text_hash'}->{'pid'}</b></td>\n";
	print "         <td width=1%><b>$self->{'text_hash'}->{'cpu'}</b></td>\n";
	if ($self->{'info_arg_map_hash'}->{'_stime'}) {
		print "         <td width=1%><b>$self->{'text_hash'}->{'stime'}</b></td>\n";
		}
	print "         <td width=98%><b>$self->{'text_hash'}->{'command'}</b></td> </tr>\n";
	foreach $pr (grep { $_->{'_zone'} eq $z } @{$self->{'procs_array'}}) {
		$self->{'p'} = $pr->{'pid'};
		print "<tr $self->{'cb'}>\n";
		if ($self->can_edit_process($pr->{'user'})) {
			print "<td><a href=\"edit_proc.cgi?$self->{'p'}\">$self->{'p'}</a></td>\n";
			}
		else {
			print "<td>$self->{'p'}</td>\n";
			}
		print "<td nowrap>$pr->{'cpu'}</td>\n";
		if ($self->{'info_arg_map_hash'}->{'_stime'}) {
			print "<td nowrap>",$pr->{'_stime'} || "<br>","</td>\n";
			}
		print "<td>",$self->html_escape($self->cut_string($pr->{'args'})),
		      "</td>\n";
		print "</tr>\n";
		}
	print "</table><p>\n";
	}
print "</dl>\n";

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

