#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_env.cgi
# Create, update or delete an environment setting

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'procmailrc'});
@{$self->{'conf_array'}} = $self->get_procmailrc();
$self->{'env'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the variable
	$self->delete_recipe($self->{'env'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'env_err'});
	$self->{'in_hash'}->{'name'} =~ /^[^\s=]+$/ || $self->error($self->{'text_hash'}->{'env_ename'});
	$self->{'env'}->{'name'} = $self->{'in_hash'}->{'name'};
	$self->{'in_hash'}->{'value'} =~ s/\r//g;
	$self->{'env'}->{'value'} = $self->{'in_hash'}->{'value'};

	# Save the receipe
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_recipe($self->{'env'});
		}
	else {
		$self->modify_recipe($self->{'env'});
		}
	}
$self->unlock_file($self->{'procmailrc'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "env", undef, $self->{'env'});
$self->redirect("");

1;
		
}


1;

