#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_inc.cgi
# Create, update or delete an include file

&ModuleLoader::preload_module('procmail_class', "procmail::ProcmailLib");
$self = new procmail::ProcmailLib:: 'procmail_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'procmailrc'});
@{$self->{'conf_array'}} = $self->get_procmailrc();
$self->{'inc'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}] if (!$self->{'in_hash'}->{'new'});

if ($self->{'in_hash'}->{'delete'}) {
	# Just delete the variable
	$self->delete_recipe($self->{'inc'});
	}
else {
	# Validate inputs
	$self->error_setup($self->{'text_hash'}->{'env_err'});
	$self->{'in_hash'}->{'inc'} =~ /\S/ || $self->error($self->{'text_hash'}->{'inc_einc'});
	$self->{'inc'}->{'include'} = $self->{'in_hash'}->{'inc'};

	# Save the receipe
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_recipe($self->{'inc'});
		}
	else {
		$self->modify_recipe($self->{'inc'});
		}
	}
$self->unlock_file($self->{'procmailrc'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? "delete" : $self->{'in_hash'}->{'new'} ? "create" : "modify",
	    "inc", undef, $self->{'inc'});
$self->redirect("");

1;
		
}


1;

