#!/usr/bin/perl
package proftpd::Mod_readme;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'proftpd::Mod_readme');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mod_readme.pl

1;
		return $self;
}

sub mod_readme_directives
{
	my $self = shift;

local $rv = [
	[ 'DisplayReadme', 0, 2, 'virtual anon global', 1.20 ]
	];
return $self->make_directives($rv, $_[0], "mod_readme");
}

sub edit_DisplayReadme
{
	my $self = shift;

return (1, $self->{'text_hash'}->{'mod_readme_display'},
	$self->opt_input($_[0]->{'value'}, "DisplayReadme", $self->{'text_hash'}->{'mod_readme_none'},
		   15));
}

sub save_DisplayReadme
{
	my $self = shift;

return $self->parse_opt("DisplayReadme", '^\S+$', $self->{'text_hash'}->{'mod_readme_edisplay'});
}


1;

