#!/usr/bin/perl

&MAIN();

 sub MAIN {
# allmanual_form.cgi
# Display a text box for manually editing directives from one of the files

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'manual_configs'}, "",
	undef, undef, undef, undef, $self->restart_button());

$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = $self->unique(map { $_->{'file'} } @{$self->{'conf'}});
$self->{'in_hash'}->{'file'} = $self->{'files_array'}->[0] if (!$self->{'in_hash'}->{'file'});
print "<form action=allmanual_form.cgi>\n";
print "<input type=submit value='$self->{'text_hash'}->{'manual_file'}'>\n";
print "<select name=file>\n";
foreach $f (@{$self->{'files_array'}}) {
	printf "<option %s>%s\n",
		$f eq $self->{'in_hash'}->{'file'} ? 'selected' : '', $f;
	$self->{'found'}++ if ($f eq $self->{'in_hash'}->{'file'});
	}
print "</select></form>\n";
$self->{'found'} || $self->error($self->{'text_hash'}->{'manual_efile'});

print "<form action=allmanual_save.cgi method=post ",
      "enctype=multipart/form-data>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<textarea name=data rows=20 cols=80>";
open(FILE, $self->{'in_hash'}->{'file'});
while(<FILE>) { print $self->html_escape($_); }
close(FILE);
print "</textarea><br>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

