#!/usr/bin/perl

&MAIN();

 sub MAIN {
# allmanual_save.cgi
# Save an entire config file

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParseMime();

$self->{'conf'} = $self->get_config();
@{$self->{'files_array'}} = $self->unique(map { $_->{'file'} } @{$self->{'conf'}});
$self->indexof($self->{'in_hash'}->{'file'}, @{$self->{'files_array'}}) >= 0 || $self->error($self->{'text_hash'}->{'manual_efile'});

$self->{'temp'} = $self->transname();
system("cp ".quotemeta($self->{'in_hash'}->{'file'})." $self->{'temp'}");
$self->{'in_hash'}->{'data'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
$self->print_tempfile(FILE, $self->{'in_hash'}->{'data'});
$self->close_tempfile(FILE);
if ($self->{'config_hash'}->{'test_manual'}) {
	$self->{'err'} = $self->test_config();
	if ($self->{'err'}) {
		system("mv $self->{'temp'} ".quotemeta($self->{'in_hash'}->{'file'}));
		$self->error($self->text('manual_etest', "<pre>$self->{'err'}</pre>"));
		}
	}
unlink($self->{'temp'});
$self->redirect("");

1;
		
}


1;

