#!/usr/bin/perl

&MAIN();

 sub MAIN {
# anon_index.cgi
# Display a menu for anonymous section options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->{'anonstr'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
if (!$self->{'anonstr'}) {
	# Go to the anon options page
	$self->redirect("edit_aserv.cgi?virt=$self->{'in_hash'}->{'virt'}&init=1");
	exit;
	}
$self->{'anon'} = $self->{'anonstr'}->{'members'};

# Display header and config icons
$self->{'desc'} = $self->{'in_hash'}->{'virt'} eq '' ? $self->{'text_hash'}->{'anon_header2'} :
	      $self->text('anon_header1', $self->{'v'}->{'value'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'anon_title'}, "", undef, undef, undef, undef, $self->restart_button());

print "<h3>$self->{'text_hash'}->{'anon_opts'}</h3>\n";
$self->{'anon_icon'} = { "icon" => "images/anon.gif",
	       "name" => $self->{'text_hash'}->{'anon_anon'},
	       "link" => "edit_aserv.cgi?virt=$self->{'in_hash'}->{'virt'}" };
$self->config_icons("anon", "edit_anon.cgi?virt=$self->{'in_hash'}->{'virt'}&", $self->{'anon_icon'});

# Display per-directory/limit options
@{$self->{'dir_array'}} = ( $self->find_directive_struct("Directory", $self->{'anon'}) ,
	 $self->find_directive_struct("Limit", $self->{'anon'}) );
if (@{$self->{'dir_array'}}) {
	print "<hr>\n";
	print "<h3>$self->{'text_hash'}->{'virt_header'}</h3>\n";
	foreach $d (@{$self->{'dir_array'}}) {
		if ($d->{'name'} eq 'Limit') {
			push(@{$self->{'links_array'}}, "limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&".
				     "anon=1&limit=".$self->indexof($d, @{$self->{'anon'}}));
			push(@{$self->{'titles_array'}}, $self->text('virt_limit', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/limit.gif");
			}
		else {
			push(@{$self->{'links_array'}}, "dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&".
				     "anon=1&idx=".$self->indexof($d, @{$self->{'anon'}}));
			push(@{$self->{'titles_array'}}, $self->text('virt_dir', $d->{'value'}));
			push(@{$self->{'icons_array'}}, "images/dir.gif");
			}
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
	}

print "<table width=100%><tr><td>\n";

print "<form action=create_dir.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<input type=hidden name=anon value=1>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_adddir'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_path'}</b></td>\n";
print "<td><input name=dir size=30>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td><td>\n";

print "<form action=create_limit.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<input type=hidden name=anon value=1>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'virt_addlimit'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'virt_cmds'}</b></td>\n";
print "<td><input name=cmd size=20>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

print "</td></tr></table>\n";

$self->ui_print_footer("virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}", $self->{'text_hash'}->{'virt_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

