#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_dserv.cgi
# Edit <Limit> section details

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'file'}) {
	$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->{'conf'} = $self->get_config();
		$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
		}
	else {
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		}
	if ($self->{'in_hash'}->{'anon'}) {
		$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
		$self->{'conf'} = $self->{'anon'}->{'members'};
		}
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->{'dir'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
		$self->{'conf'} = $self->{'dir'}->{'members'};
		}
	}
$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
$self->{'ln'} = $self->{'l'}->{'value'};
$self->{'desc'} = $self->{'in_hash'}->{'file'} ? $self->text('limit_header6', $self->{'ln'}, $self->html_escape($self->{'in_hash'}->{'file'})) :
	$self->{'dir'} ? $self->text('limit_header4', $self->{'ln'}, $self->{'dir'}->{'words'}->[0]) :
	$self->{'in_hash'}->{'global'} ? $self->text('limit_header7', $self->{'ln'}) :
	$self->{'in_hash'}->{'anon'} ? $self->text('limit_header5', $self->{'ln'}) :
	$self->{'in_hash'}->{'virt'} ? $self->text('limit_header1', $self->{'ln'}, $self->{'v'}->{'words'}->[0]) :
	$self->text('limit_header2', $self->{'ln'});
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'lserv_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

print "<form action=save_lserv.cgi>\n";
print "<input type=hidden name=virt value='$self->{'in_hash'}->{'virt'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=limit value='$self->{'in_hash'}->{'limit'}'>\n";
print "<input type=hidden name=anon value='$self->{'in_hash'}->{'anon'}'>\n";
print "<input type=hidden name=global value='$self->{'in_hash'}->{'global'}'>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'lserv_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

map { $self->{'cmd_hash'}->{lc($_)}++ } @{$self->{'l'}->{'words'}};
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'lserv_cmd'}</b></td>\n";
print "<td><select name=cmd multiple size=7 width=120>\n";
foreach $c ('cwd', 'mkd', 'rnfr', 'dele', 'rmd', 'retr', 'stor') {
	printf "<option value=%s %s>%s\n",
		uc($c), $self->{'cmd_hash'}->{$c} ? "selected" : "", uc($c);
	}
print "</select><select name=cmd multiple size=7 width=120>\n";
foreach $c ('site_chmod', 'read', 'write', 'dirs', 'login', 'all') {
	printf "<option value=%s %s>%s\n",
		uc($c), $self->{'cmd_hash'}->{$c} ? "selected" : "", uc($c);
	}
print "</select></td> </tr>\n";

print "<tr> <td colspan=2 align=right>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";
print "<input type=submit name=delete value=\"$self->{'text_hash'}->{'lserv_delete'}\">\n";
print "</td> </tr>\n";

print "</table> </td></tr></table><p>\n";
print "</form>\n";

if ($self->{'in_hash'}->{'file'}) {
	$self->ui_print_footer("limit_index.cgi?file=$self->{'in_hash'}->{'file'}&limit=$self->{'in_hash'}->{'limit'}",
		$self->{'text_hash'}->{'limit_return'},
		"ftpaccess_index.cgi?file=$self->{'in_hash'}->{'file'}",$self->{'text_hash'}->{'ftpindex_return'},
		"ftpaccess.cgi", $self->{'text_hash'}->{'ftpaccess_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}
elsif ($self->{'in_hash'}->{'idx'} eq '') {
	if ($self->{'in_hash'}->{'global'}) {
		$self->ui_print_footer("limit_index.cgi?limit=$self->{'in_hash'}->{'limit'}&global=$self->{'in_hash'}->{'global'}",
			$self->{'text_hash'}->{'limit_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	elsif ($self->{'in_hash'}->{'anon'}) {
		$self->ui_print_footer("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}",
			$self->{'text_hash'}->{'limit_return'},
			"anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'anon_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	else {
		$self->ui_print_footer("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&limit=$self->{'in_hash'}->{'limit'}",
			$self->{'text_hash'}->{'limit_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->ui_print_footer("limit_index.cgi?limit=$self->{'in_hash'}->{'limit'}&idx=$self->{'in_hash'}->{'idx'}&global=$self->{'in_hash'}->{'global'}",
			$self->{'text_hash'}->{'limit_return'},
			"dir_index.cgi?idx=$self->{'in_hash'}->{'idx'}&global=$self->{'in_hash'}->{'global'}",
			$self->{'text_hash'}->{'dir_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	elsif ($self->{'in_hash'}->{'anon'}) {
		$self->ui_print_footer("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&limit=$self->{'in_hash'}->{'limit'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}",
			$self->{'text_hash'}->{'limit_return'},
			"dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}", $self->{'text_hash'}->{'dir_return'},
			"anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'anon_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	else {
		$self->ui_print_footer("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&limit=$self->{'in_hash'}->{'limit'}&idx=$self->{'in_hash'}->{'idx'}",
			$self->{'text_hash'}->{'limit_return'},
			"dir_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&anon=$self->{'in_hash'}->{'anon'}", $self->{'text_hash'}->{'dir_return'},
			"virt_index.cgi?virt=$self->{'in_hash'}->{'virt'}",$self->{'text_hash'}->{'virt_return'},
			"", $self->{'text_hash'}->{'index_return'});
		}
	}
1;
		
}


1;

