#!/usr/bin/perl

&MAIN();

 sub MAIN {
# ftpaccess.cgi
# Display a list of per-directory config files

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'ftpaccess_title'}, "",
	undef, undef, undef, undef, $self->restart_button());

print "$self->{'text_hash'}->{'ftpaccess_desc'} <p>\n";
if (@{$self->{'ftpaccess_files_array'}}) {
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ftpaccess_title'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}><td><table width=100%>\n";
	for($i=0; $i<@{$self->{'ftpaccess_files_array'}}; $i++) {
		if ($i%2 == 0) { print "<tr>\n"; }
		print "<td width=50%><a href=\"ftpaccess_index.cgi?file=",
		      $self->urlize($self->{'ftpaccess_files_array'}->[$i]),"\">",
		      $self->html_escape($self->{'ftpaccess_files_array'}->[$i]),"</a></td>\n";
		if ($i%2 == 1) { print "</tr>\n"; }
		}
	print "</table></td></tr></table><p>\n";
	}
print "<form action=create_ftpaccess.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'ftpaccess_create'}\">\n";
print "<input name=file size=30>\n",
	$self->file_chooser_button("file", 0, 0);
print "</form>\n";

print "<form action=find_ftpaccess.cgi>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'ftpaccess_find'}\">\n";
print "<input type=radio name=from value=0 checked> ",
      "$self->{'text_hash'}->{'ftpaccess_auto'}&nbsp;&nbsp;\n";
print "<input type=radio name=from value=1>\n";
print "$self->{'text_hash'}->{'ftpaccess_from'}\n";
print "<input name=dir size=30 value=/>\n",
	$self->file_chooser_button("dir", 1, 1);
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

