#!/usr/bin/perl

&MAIN();

 sub MAIN {
# ftpaccess_index.cgi
# Display a menu of icons for a per-directory options file

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
$self->{'desc'} = "<tt>".$self->html_escape($self->{'in_hash'}->{'file'})."</tt>";
$self->ui_print_header($self->{'desc'}, $self->{'text_hash'}->{'ftpindex_title'}, "",
	undef, undef, undef, undef, "<a href=\"delete_ftpaccess.cgi?file=".
	$self->urlize($self->{'in_hash'}->{'file'})."\">$self->{'text_hash'}->{'ftpindex_delete'}</a>".
	"<br>".$self->restart_button());

print "<h3>$self->{'text_hash'}->{'ftpindex_opts'}</h3>\n";
# Add user permissions icon/link
$self->{'userperms_icon'} = { "icon" => "images/type_icon_3.gif",
	     "name" => "User Permissions",
	     "link" => "userpermissions_form.cgi?file=$self->{'in_hash'}->{'file'}" };
# Add 'edit as text' icon/link
$self->{'ed_icon'} = { "icon" => "images/edit.gif",
	     "name" => $self->{'text_hash'}->{'ftpindex_edit'},
	     "link" => "manual_form.cgi?file=$self->{'in_hash'}->{'file'}" };
$self->config_icons("ftpaccess", "edit_ftpaccess.cgi?file=$self->{'in_hash'}->{'file'}&", $self->{'ed_icon'}, $self->{'userperms_icon'});

@{$self->{'limit_array'}} = ( $self->find_directive_struct("Limit", $self->{'conf'}) );
if (@{$self->{'limit_array'}}) {
	# Limit sub-directives
	print "<hr>\n";
	print "<h3>$self->{'text_hash'}->{'ftpindex_limit'}</h3>\n";
	foreach $l (@{$self->{'limit_array'}}) {
		push(@{$self->{'links_array'}}, "limit_index.cgi?limit=".$self->indexof($l, @{$self->{'conf'}}).
			     "&file=$self->{'in_hash'}->{'file'}");
		push(@{$self->{'titles_array'}}, $l->{'value'});
		push(@{$self->{'icons_array'}}, "images/limit.gif");
		}
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 3);
	}

print "<form action=create_limit.cgi>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ftpindex_addlimit'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'ftpindex_cmds'}</b></td>\n";
print "<td><input name=cmd size=20>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></td> </tr>\n";
print "</table></td></tr></table></form>\n";

$self->ui_print_footer("ftpaccess.cgi", $self->{'text_hash'}->{'ftpaccess_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

