#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_anon.cgi
# Save some kind of anonymous section configuration

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
($self->{'vconf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'vconf'});
$self->{'conf'} = $self->{'anon'}->{'members'};
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'anon');

$self->lock_file($self->{'anon'}->{'file'});
$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->get_config());
$self->unlock_file($self->{'anon'}->{'file'});
$self->webmin_log("anon", $self->{'in_hash'}->{'type'}, $self->{'in_hash'}->{'virt'} ? $self->{'v'}->{'value'} : "", \%{$self->{'in_hash'}});

$self->redirect("anon_index.cgi?virt=$self->{'in_hash'}->{'virt'}");
1;
		
}


1;

