#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_global.cgi
# Save some type of global options

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
$self->lock_proftpd_files();
$self->{'conf'} = $self->get_config();
$self->{'gconf'} = $self->get_or_create_global($self->{'conf'});
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'root');
@{$self->{'gedit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'global');

$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->{'conf'});
$self->parse_inputs(\@{$self->{'gedit_array'}}, $self->{'gconf'}, $self->{'conf'});
$self->unlock_proftpd_files();
$self->webmin_log("global", $self->{'in_hash'}->{'type'}, undef, \%{$self->{'in_hash'}});

$self->redirect("");

1;
		
}


1;

