#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_limit.cgi
# Save some kind of per-command configuration

&ModuleLoader::preload_module('proftpd_class', "proftpd::ProftpdLib");
$self = new proftpd::ProftpdLib:: 'proftpd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'file'}) {
	$self->{'conf'} = $self->get_ftpaccess_config($self->{'in_hash'}->{'file'});
	}
else {
	if ($self->{'in_hash'}->{'global'}) {
		$self->{'conf'} = $self->get_config();
		$self->{'conf'} = $self->get_or_create_global($self->{'conf'});
		}
	else {
		($self->{'conf'}, $self->{'v'}) = $self->get_virtual_config($self->{'in_hash'}->{'virt'});
		}
	if ($self->{'in_hash'}->{'anon'}) {
		$self->{'anon'} = $self->find_directive_struct("Anonymous", $self->{'conf'});
		$self->{'conf'} = $self->{'anon'}->{'members'};
		}
	if ($self->{'in_hash'}->{'idx'} ne '') {
		$self->{'conf'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}]->{'members'};
		}
	}
$self->{'l'} = $self->{'conf'}->[$self->{'in_hash'}->{'limit'}];
$self->{'conf'} = $self->{'l'}->{'members'};
@{$self->{'edit_array'}} = $self->editable_directives($self->{'in_hash'}->{'type'}, 'limit');

$self->lock_file($self->{'l'}->{'file'});
$self->{'tn'} = $self->{'type_name_array'}->[$self->{'in_hash'}->{'type'}]; $self->{'tn'} =~ tr/A-Z/a-z/;
$self->error_setup($self->text('efailed', $self->{'text_hash'}->{"type_$self->{'in_hash'}->{'type'}"}));
$self->parse_inputs(\@{$self->{'edit_array'}}, $self->{'conf'}, $self->get_config());
$self->unlock_file($self->{'l'}->{'file'});
$self->webmin_log("limit", $self->{'in_hash'}->{'type'}, $self->{'l'}->{'value'}, \%{$self->{'in_hash'}});

$self->redirect("limit_index.cgi?virt=$self->{'in_hash'}->{'virt'}&idx=$self->{'in_hash'}->{'idx'}&limit=$self->{'in_hash'}->{'limit'}&anon=$self->{'in_hash'}->{'anon'}&global=$self->{'in_hash'}->{'global'}&file=$self->{'in_hash'}->{'file'}");
1;
		
}


1;

