#!/usr/bin/perl
package pserver::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'pserver::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "pserver::PserverLib");
$self = new pserver::PserverLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the pserver module
sub acl_security_form
{
	my $self = shift;

local $i = 0;
foreach $f (@{$self->{'features_array'}}, 'setup', 'init') {
	print "<tr>\n" if ($i%2 == 0);
	print "<td><b>",$self->{'text_hash'}->{'acl_'.$f},"</b></td> <td>\n";
	printf "<input type=radio name=%s value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$f, $_[0]->{$f} ? 'checked' : '';
	printf "<input type=radio name=%s value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$f, $_[0]->{$f} ? '' : 'checked';
	print "</tr>\n" if ($i++%2 == 1);
	}
print "</tr>\n" if ($i%2 == 1);
}

# acl_security_save(&options)
# Parse the form for security options for the acl module
sub acl_security_save
{
	my $self = shift;

foreach $f (@{$self->{'features_array'}}, 'setup', 'init') {
	$_[0]->{$f} = $self->{'in_hash'}->{$f};
	}
}


1;

