#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_queue.cgi
# Delete multiple mail messsages from the queue

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();

@{$self->{'files_array'}} = split(/\0/, $self->{'in_hash'}->{'file'});
if ($self->{'in_hash'}->{'confirm'}) {
	# Delete messages
	($self->{'pid'}) = $self->find_byname("qmail-send");
	if ($self->{'pid'}) {
		$self->stop_qmail();
		}

	foreach $f (@{$self->{'files_array'}}) {
		$f =~ /(\d+)\/(\d+)$/;
		$self->{'id'} = "$1/$2";
		unlink("$self->{'qmail_mess_dir'}/$self->{'id'}");
		unlink("$self->{'qmail_info_dir'}/$self->{'id'}");
		unlink("$self->{'qmail_remote_dir'}/$self->{'id'}");
		unlink("$self->{'qmail_local_dir'}/$self->{'id'}");
		}

	($self->{'newpid'}) = $self->find_byname("qmail-send");
	if ($self->{'pid'} && !$self->{'newpid'}) {
		# Need to re-start qmail
		$self->start_qmail();
		}

	$self->redirect("list_queue.cgi");
	}
else {
	# Ask for confirmation first
	$self->ui_print_header(undef, $self->{'text_hash'}->{'delq_titles'}, "");
	print "<center>\n";
	print $self->ui_form_start("delete_queues.cgi", "post");
	print $self->text('delq_rusure', scalar(@{$self->{'files_array'}})),"<p>\n";
	foreach $f (@{$self->{'files_array'}}) {
		print $self->ui_hidden("file", $f),"\n";
		}
	print $self->ui_form_end([ [ "confirm", $self->{'text_hash'}->{'delq_confirm'} ] ]);
	print "</center>\n";
	$self->ui_print_footer("list_queue.cgi", $self->{'text_hash'}->{'queue_return'});
	}

1;
		
}


1;

