#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_assigns.cgi
# Displays a list of all user assignments

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'assigns_title'}, "");
print "$self->{'text_hash'}->{'assigns_desc'}<p>\n";

@{$self->{'assigns_array'}} = $self->list_assigns();
$self->assign_form();

if ($self->{'in_hash'}->{'search'}) {
	# Restrict to search results
	@{$self->{'assigns_array'}} = grep { $_->{'address'} =~ /$self->{'in_hash'}->{'search'}/ } @{$self->{'assigns_array'}};
	}
elsif ($self->{'config_hash'}->{'max_records'} && @{$self->{'assigns_array'}} > $self->{'config_hash'}->{'max_records'}) {
	# Show search form
	print $self->{'text_hash'}->{'assigns_toomany'},"<br>\n";
	print "<form action=list_assigns.cgi>\n";
	print "<input type=submit value='$self->{'text_hash'}->{'assigns_go'}'>\n";
	print "<input name=search size=20></form>\n";
	undef(@{$self->{'assigns_array'}});
	}

if (@{$self->{'assigns_array'}}) {
	# sort if needed
	if ($self->{'config_hash'}->{'sort_mode'} == 1) {
		@{$self->{'assigns_array'}} = sort { lc($a->{'address'}) cmp lc($b->{'address'}) }
				@{$self->{'assigns_array'}};
		}

	# output table of assigns
        print $self->ui_form_start("delete_assigns.cgi", "post");
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td width=5><br></td> ",
	      "<td><b>$self->{'text_hash'}->{'assigns_address'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'assigns_user'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'assigns_uid'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'assigns_gid'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'assigns_home'}</b></td> </tr>\n";
	foreach $a (@{$self->{'assigns_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td width=5>",$self->ui_checkbox("d", $a->{'address'}),"</td>\n";
		print "<td><a href='edit_assign.cgi?idx=$a->{'idx'}'>",
		      ($a->{'mode'} eq '+' ? "$a->{'address'}*"
					   : $self->html_escape($a->{'address'})),
		      "</a></td>\n";
		print "<td>",$self->html_escape($a->{'user'}),"</td>\n";
		print "<td>",$self->html_escape($a->{'uid'}),"</td>\n";
		print "<td>",$self->html_escape($a->{'gid'}),"</td>\n";
		print "<td>",$self->html_escape($a->{'home'}),"</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
        print $self->select_all_link("d", 1),"\n";
        print $self->select_invert_link("d", 1),"<br>\n";
        print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'assigns_delete'} ] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

