#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_assign.cgi
# Save or delete a mail user assignment

&ModuleLoader::preload_module('qmailadmin_class', "qmailadmin::QmailLib");
$self = new qmailadmin::QmailLib:: 'qmailadmin_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ssave_err'});

@{$self->{'assigns_array'}} = $self->list_assigns();
$self->{'a'} = $self->{'assigns_array'}->[$self->{'in_hash'}->{'idx'}] if (defined($self->{'in_hash'}->{'idx'}));

if ($self->{'in_hash'}->{'delete'}) {
	# delete some assign
	$self->{'loga'} = $self->{'a'};
	$self->delete_assign($self->{'a'});
	}
else {
	# saving or creating .. check inputs
	if ($self->{'in_hash'}->{'mode'} eq '=') {
		$self->{'in_hash'}->{'address0'} =~ /^[^:\s]+$/ || $self->error($self->{'text_hash'}->{'ssave_eaddress'});
		}
	else {
		$self->{'in_hash'}->{'address1'} =~ /^[^:\s]*$/ || $self->error($self->{'text_hash'}->{'ssave_eaddress'});
		}
	scalar(getpwnam($self->{'in_hash'}->{'user'})) || $self->error($self->{'text_hash'}->{'ssave_euser'});
	$self->{'in_hash'}->{'uid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ssave_euid'});
	$self->{'in_hash'}->{'gid'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'ssave_egid'});
	-d $self->{'in_hash'}->{'home'} || $self->error($self->{'text_hash'}->{'ssave_ehome'});
	$self->{'newa_hash'}->{'mode'} = $self->{'in_hash'}->{'mode'};
	$self->{'newa_hash'}->{'address'} = $self->{'in_hash'}->{'mode'} eq '=' ? $self->{'in_hash'}->{'address0'} : $self->{'in_hash'}->{'address1'};
	$self->{'newa_hash'}->{'user'} = $self->{'in_hash'}->{'user'};
	$self->{'newa_hash'}->{'uid'} = $self->{'in_hash'}->{'uid'};
	$self->{'newa_hash'}->{'gid'} = $self->{'in_hash'}->{'gid'};
	$self->{'newa_hash'}->{'home'} = $self->{'in_hash'}->{'home'};
	if ($self->{'a'}) {
		# Just keep these as before
		$self->{'newa_hash'}->{'dash'} = $self->{'a'}->{'dash'};
		$self->{'newa_hash'}->{'preext'} = $self->{'a'}->{'preext'};
		}

	if ($self->{'in_hash'}->{'new'}) { $self->create_assign(\%{$self->{'newa_hash'}}); }
	else { $self->modify_assign($self->{'a'}, \%{$self->{'newa_hash'}}); }
	$self->{'loga'} = \%{$self->{'newa_hash'}};
	}
$self->system_logged("$self->{'qmail_bin_dir'}/qmail-newu");
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "assign", $self->{'loga'}->{'mode'}.$self->{'loga'}->{'address'}, $self->{'loga'});
$self->redirect("list_assigns.cgi");

1;
		
}


1;

