#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rfile.cgi
# Save an autoreply file

my $rec_uire = (-r 'sendmail-lib.pl' ? './sendmail-lib.pl' :
	 -r 'qmail-lib.pl' ? './qmail-lib.pl' :
			     './postfix-lib.pl');
 &ModuleLoader::preload_module('qmailadmin_class', "WebLib");
$self = new WebLib:: 'qmailadmin_class',%$self;

 {
    my $pkg = $self->lib_to_pkg($rec_uire, "qmailadmin");
    &ModuleLoader::preload_module(ref($self), "$pkg");
    $pkg .= '::';
    eval "\$self = new $pkg ref(\$self),\%\$self;"; 
}
$self->ReadParseMime();
if (substr($self->{'in_hash'}->{'file'}, 0, length($self->{'access_hash'}->{'apath'})) ne $self->{'access_hash'}->{'apath'}) {
	$self->error($self->text('rfile_efile', $self->{'in_hash'}->{'file'}));
	}
$self->{'in_hash'}->{'replies_def'} || $self->{'in_hash'}->{'replies'} =~ /^\/\S+/ ||
	$self->error($self->{'text_hash'}->{'rfile_ereplies'});
$self->{'in_hash'}->{'period_def'} || $self->{'in_hash'}->{'period'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'rfile_eperiod'});
$self->{'in_hash'}->{'from_def'} || $self->{'in_hash'}->{'from'} =~ /\S/ ||
	$self->error($self->{'text_hash'}->{'rfile_efrom'});

$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}");
if (!$self->{'in_hash'}->{'replies_def'}) {
	$self->print_tempfile(FILE, "Reply-Tracking: $self->{'in_hash'}->{'replies'}\n");
	}
if (!$self->{'in_hash'}->{'period_def'}) {
	$self->print_tempfile(FILE, "Reply-Period: $self->{'in_hash'}->{'period'}\n");
	}
if ($self->{'in_hash'}->{'no_autoreply'}) {
	$self->print_tempfile(FILE, "No-Autoreply: $self->{'in_hash'}->{'no_autoreply'}\n");
	}
foreach $r (split(/\r?\n/, $self->{'in_hash'}->{'no_regexp'})) {
	$self->print_tempfile(FILE, "No-Autoreply-Regexp: $r\n") if ($r =~ /\S/);
	}
if (!$self->{'in_hash'}->{'from_def'}) {
	$self->print_tempfile(FILE, "From: $self->{'in_hash'}->{'from'}\n");
	}
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->system_logged("cp autoreply.pl $self->{'module_config_directory'}");
$self->redirect("edit_alias.cgi?name=$self->{'in_hash'}->{'name'}&num=$self->{'in_hash'}->{'num'}");

1;
		
}


1;

