#!/usr/bin/perl

&MAIN();

 sub MAIN {
# copy_user.cgi
# Copy some user's quota to a number of others

&ModuleLoader::preload_module('quota_class', "quota::QuotaLib");
$self = new quota::QuotaLib:: 'quota_class',%$self;

$self->ReadParse();
$self->{'whatfailed'} = $self->{'text_hash'}->{'cuser_efail'};
$self->{'access_hash'}->{'filesys'} eq "*" ||
	$self->error($self->{'text_hash'}->{'cuser_ecannot'});
$self->can_edit_user($self->{'in_hash'}->{'user'}) ||
	$self->error($self->{'text_hash'}->{'cuser_euallow'});
$self->{'access_hash'}->{'ro'} && $self->error($self->{'text_hash'}->{'cuser_euallow'});

if ($self->{'in_hash'}->{'dest'} == 0) {
	# Copy to all users
	setpwent();
	while(@{$self->{'uinfo_array'}} = getpwent()) {
		push(@{$self->{'copyto_array'}}, $self->{'uinfo_array'}->[0]);
		}
	endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
	}
elsif ($self->{'in_hash'}->{'dest'} == 1) {
	# Copy to selected users
	@{$self->{'copyto_array'}} = split(/\s+/, $self->{'in_hash'}->{'users'});
	}
elsif ($self->{'in_hash'}->{'dest'} == 2) {
	# Copy to members of groups
	setpwent();
	while(@{$self->{'uinfo_array'}} = getpwent()) { $self->{'ingroup_hash'}->{$self->{'uinfo_array'}->[3]} .= "$self->{'uinfo_array'}->[0] "; }
	endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');
	foreach $g (split(/\s+/, $self->{'in_hash'}->{'groups'})) {
		@{$self->{'ginfo_array'}} = getgrnam($g);
		push(@{$self->{'copyto_array'}}, split(/\s+/, $self->{'ingroup_hash'}->{$self->{'ginfo_array'}->[2]}));
		push(@{$self->{'copyto_array'}}, split(/\s+/, $self->{'ginfo_array'}->[3]));
		}
	}
@{$self->{'copyto_array'}} = $self->unique(@{$self->{'copyto_array'}});
@{$self->{'copyto_array'}} = grep { $_ ne $self->{'in_hash'}->{'user'} } @{$self->{'copyto_array'}};
if (!@{$self->{'copyto_array'}}) { $self->error($self->{'text_hash'}->{'cuser_enouser'}); }
foreach $c (@{$self->{'copyto_array'}}) {
	$self->can_edit_user($c) ||
		$self->error($self->text('cuser_eallowto', $c));
	}

# Do the copy
$self->copy_user_quota($self->{'in_hash'}->{'user'}, @{$self->{'copyto_array'}});
$self->webmin_log("copy", "user", $self->{'in_hash'}->{'user'}, \%{$self->{'in_hash'}});
$self->redirect("user_filesys.cgi?user=$self->{'in_hash'}->{'user'}");

1;
		
}


1;

