#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show icons for users, profiles and so on

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->ui_print_header(undef, $self->{'module_info_hash'}->{'desc'}, "", undef, 1, 1, 0,
		 $self->help_search_link("rbac", "man"));

# Make sure RBAC is installed
$self->{'missing'} = $self->missing_rbac_config_file();
if ($self->{'missing'}) {
	$self->ui_print_endpage(
		$self->ui_config_link('index_euser',
			[ "<tt>$self->{'missing'}</tt>", undef ]));
	}

# Show icons
@{$self->{'allpages_array'}} = ( "users", "auths", "profs", "execs", "policy",
	      "projects", "prctl" );
@{$self->{'pages_array'}} = grep { $_ eq "users" ? $self->{'access_hash'}->{'users'} || $self->{'access_hash'}->{'roles'}
			      : $self->{'access_hash'}->{$_} } @{$self->{'allpages_array'}};
@{$self->{'links_array'}} = map { "list_${_}.cgi" } @{$self->{'pages_array'}};
@{$self->{'titles_array'}} = map { $self->{'text_hash'}->{"${_}_title"} } @{$self->{'pages_array'}};
@{$self->{'icons_array'}} = map { "images/${_}.gif" } @{$self->{'pages_array'}};
$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}}, 4);

$self->ui_print_footer("/", $self->{'text_hash'}->{"index"});
1;
		
}


1;

