#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of all authiles

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'auths'} || $self->error($self->{'text_hash'}->{'auths_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'auths_title'}, "", "auths");

$self->{'auths'} = $self->list_auth_attrs();
if (@{$self->{'auths'}}) {
	print "<a href='edit_auth.cgi?new=1'>$self->{'text_hash'}->{'auths_add'}</a><br>\n";
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'auths_name'},
		  $self->{'text_hash'}->{'auths_desc'} ]);
	foreach $a (sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'auths'}}) {
		print $self->ui_columns_row(
			[ "<a href='edit_auth.cgi?idx=$a->{'index'}'>$a->{'name'}</a>",
			  $self->rbac_help_link($a, $a->{'short'} || $a->{'desc'}),
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'auths_none'}</b><p>\n";
	}
print "<a href='edit_auth.cgi?new=1'>$self->{'text_hash'}->{'auths_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});

1;
		
}


1;

