#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of all execiles

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'execs'} || $self->error($self->{'text_hash'}->{'execs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'execs_title'}, "", "execs");

$self->{'execs'} = $self->list_exec_attrs();
if (@{$self->{'execs'}}) {
	print "<a href='edit_exec.cgi?new=1'>$self->{'text_hash'}->{'execs_add'}</a><br>\n";
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'execs_name'},
		  $self->{'text_hash'}->{'execs_policy'},
		  $self->{'text_hash'}->{'execs_id'} ]);
	foreach $e (sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'execs'}}) {
		print $self->ui_columns_row(
			[ "<a href='edit_exec.cgi?idx=$e->{'index'}'>$e->{'name'}</a>",
			  $self->{'text_hash'}->{'execs_p'.$e->{'policy'}},
			  $e->{'id'} eq '*' ? $self->{'text_hash'}->{'execs_all'} : $e->{'id'},
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'execs_none'}</b><p>\n";
	}
print "<a href='edit_exec.cgi?new=1'>$self->{'text_hash'}->{'execs_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});

1;
		
}


1;

