#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a table of all profiles

&ModuleLoader::preload_module('rbac_class', "rbac::RbacLib");
$self = new rbac::RbacLib:: 'rbac_class',%$self;

$self->{'access_hash'}->{'profs'} || $self->error($self->{'text_hash'}->{'profs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'profs_title'}, "", "profs");

$self->{'profs'} = $self->list_prof_attrs();
if (@{$self->{'profs'}}) {
	print "<a href='edit_prof.cgi?new=1'>$self->{'text_hash'}->{'profs_add'}</a><br>\n"
		if ($self->{'access_hash'}->{'profs'} == 1);
	print $self->ui_columns_start(
		[ $self->{'text_hash'}->{'profs_name'},
		  $self->{'text_hash'}->{'profs_desc'},
		  $self->{'text_hash'}->{'profs_auths'} ]);
	foreach $p (sort { $a->{'name'} cmp $b->{'name'} } @{$self->{'profs'}}) {
		print $self->ui_columns_row(
			[ $self->{'access_hash'}->{'profs'} == 1 ?
			    "<a href='edit_prof.cgi?idx=$p->{'index'}'>$p->{'name'}</a>" :
			    $p->{'name'},
			  $self->rbac_help_link($p, $p->{'desc'}),
			  $self->nice_comma_list($p->{'attr'}->{'auths'}),
			]);
		}
	print $self->ui_columns_end();
	}
else {
	print "<b>$self->{'text_hash'}->{'profs_none'}</b><p>\n";
	}
print "<a href='edit_prof.cgi?new=1'>$self->{'text_hash'}->{'profs_add'}</a><br>\n"
	if ($self->{'access_hash'}->{'profs'} == 1);

$self->ui_print_footer("", $self->{'text_hash'}->{"index_return"});
1;
		
}


1;

