#!/usr/bin/perl
package samba::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'samba::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "samba::SambaLib");
$self = new samba::SambaLib:: ref($self), %$self; 

1;
1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the samba module
sub acl_security_form
{
	my $self = shift;

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_apply'}</b></td> <td>\n";
printf "<input type=radio name=apply value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'apply'} ? "checked" : "";
printf "<input type=radio name=apply value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'apply'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_view_all_con'}</b></td> <td>\n";
printf "<input type=radio name=view_all_con value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'view_all_con'} ? "checked" : "";
printf "<input type=radio name=view_all_con value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'view_all_con'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_kill_con'}</b></td> <td>\n";
printf "<input type=radio name=kill_con value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'kill_con'} ? "checked" : "";
printf "<input type=radio name=kill_con value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'kill_con'} ? "" : "checked";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_conf_net'}</b></td> <td>\n";
printf "<input type=radio name=conf_net value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'conf_net'} ? "checked" : "";
printf "<input type=radio name=conf_net value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'conf_net'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_conf_smb'}</b></td> <td>\n";
printf "<input type=radio name=conf_smb value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'conf_smb'} ? "checked" : "";
printf "<input type=radio name=conf_smb value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'conf_smb'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_conf_pass'}</b></td> <td>\n";
printf "<input type=radio name=conf_pass value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'conf_pass'} ? "checked" : "";
printf "<input type=radio name=conf_pass value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'conf_pass'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_conf_print'}</b></td> <td>\n";
printf "<input type=radio name=conf_print value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'conf_print'} ? "checked" : "";
printf "<input type=radio name=conf_print value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'conf_print'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_conf_misc'}</b></td> <td>\n";
printf "<input type=radio name=conf_misc value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'conf_misc'} ? "checked" : "";
printf "<input type=radio name=conf_misc value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'conf_misc'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_swat'}</b></td> <td>\n";
printf "<input type=radio name=swat value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'swat'} ? "checked" : "";
printf "<input type=radio name=swat value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'swat'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_manual'}</b></td> <td>\n";
printf "<input type=radio name=manual value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'manual'} ? "checked" : "";
printf "<input type=radio name=manual value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'manual'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_winbind'}</b></td> <td>\n";
printf "<input type=radio name=winbind value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'winbind'} ? "checked" : "";
printf "<input type=radio name=winbind value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'winbind'} ? "" : "checked";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# encripted passwords
print "<tr>\n<td $self->{'tb'}><b>$self->{'text_hash'}->{'acl_enc_passwd_opts'}</b></td></tr> \n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_view_users'}</b></td> <td>\n";
printf "<input type=radio name=view_users value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'view_users'} ? "checked" : "";
printf "<input type=radio name=view_users value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'view_users'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_maint_users'}</b></td> <td>\n";
printf "<input type=radio name=maint_users value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'maint_users'} ? "checked" : "";
printf "<input type=radio name=maint_users value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'maint_users'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_maint_makepass'}</b></td> <td>\n";
printf "<input type=radio name=maint_makepass value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'maint_makepass'} ? "checked" : "";
printf "<input type=radio name=maint_makepass value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'maint_makepass'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_maint_sync'}</b></td> <td>\n";
printf "<input type=radio name=maint_sync value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'maint_sync'} ? "checked" : "";
printf "<input type=radio name=maint_sync value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'maint_sync'} ? "" : "checked";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# encripted passwords
print "<tr>\n<td $self->{'tb'}><b>$self->{'text_hash'}->{'acl_group_opts'}</b></td></tr> \n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_maint_groups'}</b></td> <td>\n";
printf "<input type=radio name=maint_groups value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'maint_groups'} ? "checked" : "";
printf "<input type=radio name=maint_groups value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'maint_groups'} ? "" : "checked";
print "</tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_maint_gsync'}</b></td> <td>\n";
printf "<input type=radio name=maint_gsync value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'maint_gsync'} ? "checked" : "";
printf "<input type=radio name=maint_gsync value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'maint_gsync'} ? "" : "checked";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# hide
print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_hide'}</b></td> <td>\n";
printf "<input type=radio name=hide value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'hide'} == 1 ? "checked" : "";
printf "<input type=radio name=hide value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'hide'} == 0 ? "checked" : "";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# global acls
print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_afs'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=checkbox name=c_fs value=1 %s> %s\n",
		$_[0]->{'c_fs'} ? "checked" : "", $self->{'text_hash'}->{"acl_c"};
printf "<input type=checkbox name=r_fs value=1 %s> %s\n",
		$_[0]->{'r_fs'} ? "checked" : "", $self->{'text_hash'}->{"acl_r"};
printf "<input type=checkbox name=w_fs value=1 %s> %s\n",
		$_[0]->{'w_fs'} ? "checked" : "", $self->{'text_hash'}->{"acl_w"};
print "</td> </tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_aps'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=checkbox name=c_ps value=1 %s> %s\n",
		$_[0]->{'c_ps'} ? "checked" : "", $self->{'text_hash'}->{"acl_c"};
printf "<input type=checkbox name=r_ps value=1 %s> %s\n",
		$_[0]->{'r_ps'} ? "checked" : "", $self->{'text_hash'}->{"acl_r"};
printf "<input type=checkbox name=w_ps value=1 %s> %s\n",
		$_[0]->{'w_ps'} ? "checked" : "", $self->{'text_hash'}->{"acl_w"};
print "</td> </tr>\n";

print "<tr>\n<td><b>$self->{'text_hash'}->{'acl_copy'}</b></td> <td>\n";
printf "<input type=radio name=copy value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'copy'} ? "checked" : "";
printf "<input type=radio name=copy value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
		$_[0]->{'copy'} ? "" : "checked";
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# per-share acls
print "<tr><td><b>$self->{'text_hash'}->{'acl_per_fs_acls'}</b></td> <td>\n";
printf "<input type=radio name=per_fs_acls value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'per_fs_acls'} ? "checked" : "";
printf "<input type=radio name=per_fs_acls value=0 %s> $self->{'text_hash'}->{'no'}\n",
		$_[0]->{'per_fs_acls'} ? "" : "checked";
print "</td></tr>\n";

print "<tr><td><b>$self->{'text_hash'}->{'acl_per_ps_acls'}</b></td> <td>\n";
printf "<input type=radio name=per_ps_acls value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$_[0]->{'per_ps_acls'} ? "checked" : "";
printf "<input type=radio name=per_ps_acls value=0 %s> $self->{'text_hash'}->{'no'}\n",
		$_[0]->{'per_ps_acls'} ? "" : "checked";
print "</td></tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

# table
print "<tr> <td colspan=4>\n<table border width=100%>\n";
printf "<th $self->{'tb'} colspan=7><b>%s</b></th>\n", $self->{'text_hash'}->{'acl_per_share_acls'};
print "<tr $self->{'tb'}>\n";
printf "<td rowspan=2><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_sname'};
printf "<td rowspan=2><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_saccess'};
printf "<td rowspan=2><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_sconn'};
printf "<th colspan=4><b>%s</b></th>\n", $self->{'text_hash'}->{'acl_sopthdr'};
print "</tr>\n<tr $self->{'tb'}>\n";
printf "<td><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_ssec'};
printf "<td><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_sperm'};
printf "<td><b>%s</b></td>\n", $self->{'text_hash'}->{'acl_snaming'};
printf "<td><b>%s<br>%s</b></td>\n", $self->{'text_hash'}->{'acl_smisc'}, $self->{'text_hash'}->{'acl_sprn'};
print "</tr>\n";

foreach ($self->list_shares()) {
	$self->display_acl_row($_[0], $_);
	}
print "</table> </td> </tr>\n";
}

# acl_security_save(&options)
# Parse the form for security options for the samba module
sub acl_security_save
{
	my $self = shift;

if ($self->{'in_hash'}->{'r_fs'} < $self->{'in_hash'}->{'w_fs'} || $self->{'in_hash'}->{'r_ps'} < $self->{'in_hash'}->{'w_ps'}) {
	$self->{'whatfailed'} = $self->{'text_hash'}->{'acl_err'};
	$self->error($self->{'text_hash'}->{'acl_ernow'});
	}
$_[0]->{'apply'}=$self->{'in_hash'}->{'apply'};
$_[0]->{'view_all_con'}=$self->{'in_hash'}->{'view_all_con'};
$_[0]->{'kill_con'}=$self->{'in_hash'}->{'kill_con'};
$_[0]->{'conf_net'}=$self->{'in_hash'}->{'conf_net'};
$_[0]->{'conf_smb'}=$self->{'in_hash'}->{'conf_smb'};
$_[0]->{'conf_pass'}=$self->{'in_hash'}->{'conf_pass'};
$_[0]->{'conf_print'}=$self->{'in_hash'}->{'conf_print'};
$_[0]->{'conf_misc'}=$self->{'in_hash'}->{'conf_misc'};
$_[0]->{'swat'}=$self->{'in_hash'}->{'swat'};
$_[0]->{'manual'}=$self->{'in_hash'}->{'manual'};
$_[0]->{'hide'}=$self->{'in_hash'}->{'hide'};
$_[0]->{'per_fs_acls'}=$self->{'in_hash'}->{'per_fs_acls'};
$_[0]->{'per_ps_acls'}=$self->{'in_hash'}->{'per_ps_acls'};
$_[0]->{'c_fs'}=$self->{'in_hash'}->{'c_fs'};
$_[0]->{'r_fs'}=$self->{'in_hash'}->{'r_fs'};
$_[0]->{'w_fs'}=$self->{'in_hash'}->{'w_fs'};
$_[0]->{'c_ps'}=$self->{'in_hash'}->{'c_ps'};
$_[0]->{'r_ps'}=$self->{'in_hash'}->{'r_ps'};
$_[0]->{'w_ps'}=$self->{'in_hash'}->{'w_ps'};
$_[0]->{'copy'}=$self->{'in_hash'}->{'copy'};
$_[0]->{'view_users'}=$self->{'in_hash'}->{'view_users'};
$_[0]->{'maint_users'}=$self->{'in_hash'}->{'maint_users'};
$_[0]->{'maint_makepass'}=$self->{'in_hash'}->{'maint_makepass'};
$_[0]->{'maint_sync'}=$self->{'in_hash'}->{'maint_sync'};
$_[0]->{'maint_groups'}=$self->{'in_hash'}->{'maint_groups'};
$_[0]->{'maint_gsync'}=$self->{'in_hash'}->{'maint_gsync'};
$_[0]->{'winbind'}=$self->{'in_hash'}->{'winbind'};

foreach (keys %{$self->{'in_hash'}}) {
	  $_[0]->{$1} .= $self->{'in_hash'}->{$_} if /^\w\w_(ACL\w\w_\w+)$/;
	  }
}

# display_acl_row(\%access, $share_name)									
sub display_acl_row
{
	my $self = shift;

local($acc,$name)=@_;
local %share;
$self->get_share($name);
local $stype=$self->istrue('printable') ? 'ps' : 'fs';
local $aclname='ACL' . $stype . '_' . $name;

#display row
print "<tr>\n";
printf $stype eq 'fs' ? "<td><b>%s</b></td>\n" : 
						"<td><b><i>%s</i></td>\n", $name;
$self->display_acl_cell($acc, $name, 'r', 'w', $aclname, 
				  $self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_r1'}, $self->{'text_hash'}->{'acl_rw'});
$self->display_acl_cell($acc, $name, 'v', 'V', $aclname, 
				  $self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_view'}, $self->{'text_hash'}->{'acl_kill'});
$self->display_acl_cell($acc, $name, 's', 'S', $aclname, 
				  $self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_view'}, $self->{'text_hash'}->{'acl_edit'});
$stype eq 'fs' ? $self->display_acl_cell($acc, $name, 'p', 'P', $aclname, 
				  $self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_view'}, $self->{'text_hash'}->{'acl_edit'}) : 
				  print "<td> </td>\n";
$stype eq 'fs' ? $self->display_acl_cell($acc, $name, 'n', 'N', $aclname, 
				$self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_view'}, $self->{'text_hash'}->{'acl_edit'}) :
				print "<td> </td>\n";
$self->display_acl_cell($acc, $name, 'o', 'O', $aclname, 
				  $self->{'text_hash'}->{'acl_na'}, $self->{'text_hash'}->{'acl_view'}, $self->{'text_hash'}->{'acl_edit'});
print "</tr>\n";		
}

#display_acl_cell(\%access, $name, 
#				  $rperm, $wperm, $aclname, 
#				  $text1, $text2, $text3)
sub display_acl_cell
{
	my $self = shift;

local ($acc, $name, $rp, $wp, $aclname, $text1, $text2, $text3) = @_;
local $rn = $rp . $wp . '_' . $aclname;

print "<td>\n";
if($acc->{$aclname}) { 
	printf "<input type=radio name=$rn value='' %s> %s<br>\n",
			!$self->perm_to($rp, $acc, $aclname) ? 
				"checked" : "", $text1;
	printf "<input type=radio name=$rn value='$rp' %s> %s<br>\n",
			$self->perm_to($rp, $acc, $aclname) && 
			!$self->perm_to($rp.$wp, $acc, $aclname) ? 
				"checked" : "",$text2;
	printf "<input type=radio name=$rn value='$rp$wp' %s> %s\n",
			$self->perm_to($rp.$wp, $acc, $aclname) ? 
				"checked" : "", $text3;
	}
else {
	printf "<input type=radio name=$rn value='' checked> %s<br>\n",
			$text1;
	printf "<input type=radio name=$rn value='$rp'> %s<br>\n", 
			$text2;
	printf "<input type=radio name=$rn value='$rp$wp'> %s\n",
			$text3;
	}
print "</td>\n";
}

# perm_to($permissions_string,\%access,$ACLname)
# check only per-share permissions
sub perm_to
{
	my $self = shift;

local $acl=$_[1]->{$_[2]};
foreach (split //,$_[0]) {
	return 0 if index($acl,$_) == -1;
	}
return 1;
}


1;

