#!/usr/bin/perl
package samba::Postinstall;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'samba::Postinstall');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

$self->{'no_acl_check'}++;
&ModuleLoader::preload_module(ref($self), "samba::SambaLib");
$self = new samba::SambaLib:: ref($self), %$self; 

1;
		return $self;
}

sub module_install {
	my $self = shift;

# Check the samba version
local $out;
if ($self->{'samba_version'} = $self->get_samba_version(\$out)) {
	# Save version number
	$self->open_tempfile(VERSION, ">$self->{'module_config_directory'}/version");
	$self->print_tempfile(VERSION, $self->{'samba_version'},"\n");
	$self->close_tempfile(VERSION);
	}
}


1;

