#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_misc.cgi
# Display other options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcm'}") unless $self->{'access_hash'}->{'conf_misc'};

$self->ui_print_header(undef, $self->{'text_hash'}->{'misc_title'}, "");

$self->get_share("global");
print "<form action=save_misc.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_debug'}</b></td>\n";
print "<td><select name=debug_level>\n";
foreach $d ("", 0 .. 10) {
	printf "<option value=\"$d\" %s> %s\n",
		$self->getval("debug level") eq $d ? "selected" : "",
		$d eq "" ? $self->{'text_hash'}->{'default'} : $d;
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'misc_cachecall'}</b></td>\n";
printf "<td nowrap><input type=radio name=getwd_cache value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("getwd cache") ? "checked" : "";
printf "<input type=radio name=getwd_cache value=no %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->istrue("getwd cache") ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_lockdir'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=lock_directory_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("lock directory") eq "" ? "checked" : "";
printf "&nbsp; <input type=radio name=lock_directory_def value=0 %s>\n",
	$self->getval("lock directory") eq "" ? "" : "checked";
printf "<input name=lock_directory size=30 value=\"%s\">\n",
	$self->getval("lock directory");
print $self->file_chooser_button("lock_directory", 1);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_log'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=log_file_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("log file") eq "" ? "checked" : "";
printf "&nbsp; <input type=radio name=log_file_def value=0 %s>\n",
	$self->getval("log file") eq "" ? "" : "checked";
printf "<input name=log_file size=30 value=\"%s\">\n",
	$self->getval("log file");
print $self->file_chooser_button("log_file", 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_maxlog'}</b></td>\n";
printf "<td nowrap><input type=radio name=max_log_size_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("max log size") eq "" ? "checked" : "";
printf "<input type=radio name=max_log_size_def value=0 %s>\n",
	$self->getval("max log size") eq "" ? "" : "checked";
printf "<input name=max_log_size size=5 value=\"%s\">kB</td>\n",
	$self->getval("max log size");

print "<tr> <td><b>$self->{'text_hash'}->{'misc_rawread'}</b></td>\n";
printf "<td nowrap><input type=radio name=read_raw value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->isfalse("read raw") ? "" : "checked";
printf "<input type=radio name=read_raw value=no %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->isfalse("read raw") ? "checked" : "";

print "<td><b>$self->{'text_hash'}->{'misc_rawwrite'}</b></td>\n";
printf "<td nowrap><input type=radio name=write_raw value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->isfalse("write raw") ? "" : "checked";
printf "<input type=radio name=write_raw value=no %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->isfalse("write raw") ? "checked" : "";

print "<td><b>$self->{'text_hash'}->{'misc_overlapread'}</b></td>\n";
printf "<td nowrap><input type=radio name=read_size_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("read size") eq "" ? "checked" : "";
printf "<input type=radio name=read_size_def value=0 %s>\n",
	$self->getval("read size") eq "" ? "" : "checked";
printf "<input name=read_size size=5 value=\"%s\">$self->{'text_hash'}->{'config_bytes'}</td> </tr>\n",
	$self->getval("read size");

print "<tr> <td><b>$self->{'text_hash'}->{'misc_chroot'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=root_directory_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("root directory") eq "" ? "checked" : "";
printf "&nbsp; <input type=radio name=root_directory_def value=0 %s>\n",
	$self->getval("root directory") eq "" ? "" : "checked";
printf "<input name=root_directory size=30 value=\"%s\">\n",
	$self->getval("root directory");
print $self->file_chooser_button("root_directory", 1);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_smbrun'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=smbrun_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("smbrun") eq "" ? "checked" : "";
printf "&nbsp; <input type=radio name=smbrun_def value=0 %s>\n",
	$self->getval("smbrun") eq "" ? "" : "checked";
printf "<input name=smbrun size=30 value=\"%s\">\n",
	$self->getval("smbrun");
print $self->file_chooser_button("smbrun", 0);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'misc_clienttime'}</b></td>\n";
printf "<td><input name=time_offset size=4 value=\"%d\">$self->{'text_hash'}->{'config_mins'}</td>\n",
	$self->getval("time offset");

print "<td><b>$self->{'text_hash'}->{'misc_readprediction'}</b></td>\n";
printf "<td nowrap><input type=radio name=read_prediction value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("read prediction") ? "checked" : "";
printf "<input type=radio name=read_prediction value=no %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->istrue("read prediction") ? "" : "checked";

print "</table></tr></td></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

