#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_net.cgi
# Display Unix networking options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcn'}") unless $self->{'access_hash'}->{'conf_net'};

$self->ui_print_header(undef, $self->{'text_hash'}->{'net_title'}, "");

$self->get_share("global");

print "<form action=save_net.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'net_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'net_idle'}</b></td>\n";
printf "<td><input type=radio name=dead_time_def value=1 %s> $self->{'text_hash'}->{'config_never'}\n",
	$self->getval("deadtime") eq "" ? "checked" : "";
printf "<input type=radio name=dead_time_def value=0 %s>\n",
	$self->getval("deadtime") eq "" ? "" : "checked";
printf "<input name=dead_time size=5 value=\"%s\"> $self->{'text_hash'}->{'config_mins'}</td> </tr>\n",
	$self->getval("deadtime");

print "<tr> <td><b>$self->{'text_hash'}->{'net_trustlist'}</b></td>\n";
printf "<td><input type=radio name=hosts_equiv_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("hosts equiv") eq "" ? "checked" : "";
printf "<input type=radio name=hosts_equiv_def value=0 %s>",
	$self->getval("hosts equiv") eq "" ? "" : "checked";
printf "<input name=hosts_equiv size=20 value=\"%s\">\n",
	$self->getval("hosts equiv");
print $self->file_chooser_button("hosts_equiv", 0);
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_netinterface'}</b></td>\n";
print "<td>\n";
printf "<input type=radio name=interfaces_def value=1 %s> $self->{'text_hash'}->{'net_auto'}&nbsp;\n",
	$self->getval("interfaces") ? "" : "checked";
printf "<input type=radio name=interfaces_def value=0 %s> $self->{'text_hash'}->{'net_uselist'}<br>\n",
	$self->getval("interfaces") ? "checked" : "";
print "<table border>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'net_interface'}</b></td> <td><b>$self->{'text_hash'}->{'net_netmask'}</b></td> </tr>\n";
@{$self->{'iflist_array'}} = split(/\s+/, $self->getval("interfaces"));
$self->{'len'} = @{$self->{'iflist_array'}} ? @{$self->{'iflist_array'}}+1 : 2;
for($i=0; $i<$self->{'len'}; $i++) {
	print "<tr>\n";
	if ($self->{'iflist_array'}->[$i] =~ /^([0-9\.]+)\/([0-9]+)$/) {
		for($j=0; $j<$2; $j++) { $self->{'pw'} += 2**(31-$j); }
		$self->{'n'} = sprintf "%u.%u.%u.%u",
				($self->{'pw'}>>24)&0xff, ($self->{'pw'}>>16)&0xff,
				($self->{'pw'}>>8)&0xff, ($self->{'pw'})&0xff;
		print "<td><input name=interface_ip$i value=$1 size=15></td>\n";
		print "<td><input name=interface_nm$i value=$self->{'n'} size=15></td>\n";
		}
	elsif ($self->{'iflist_array'}->[$i] =~ /^([0-9\.]+)\/([0-9\.]+)$/) {
		print "<td><input name=interface_ip$i value=$1 size=15></td>\n";
		print "<td><input name=interface_nm$i value=$2 size=15></td>\n";
		}
	elsif ($self->{'iflist_array'}->[$i] =~ /^(\S+)$/) {
		print "<td><input name=interface_ip$i value=$1 size=15></td>\n";
		print "<td><input name=interface_nm$i size=15></td>\n";
		}
	else {
		print "<td><input name=interface_ip$i size=15></td>\n";
		print "<td><input name=interface_nm$i size=15></td>\n";
		}
	print "</tr>\n";
	}
print "</table></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'net_keepalive'}</b></td>\n";
printf "<td><input type=radio name=keepalive_def value=1 %s> $self->{'text_hash'}->{'net_notsend'}\n",
	$self->getval("keepalive") eq "" ? "checked" : "";
printf "<input type=radio name=keepalive_def value=0 %s>\n",
	$self->getval("keepalive") eq "" ? "" : "checked";
print "$self->{'text_hash'}->{'net_every'}\n";
printf "<input name=keepalive size=5 value=\"%s\">$self->{'text_hash'}->{'config_secs'}</td> </tr>\n",
	$self->getval("keepalive");

print "<tr> <td><b>$self->{'text_hash'}->{'net_maxpacket'}</b></td>\n";
printf "<td><input type=radio name=max_xmit_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("max xmit") eq "" ? "checked" : "";
printf "<input type=radio name=max_xmit_def value=0 %s>\n",
	$self->getval("max xmit") eq "" ? "" : "checked";
printf "<input name=max_xmit size=5 value=\"%s\"> $self->{'text_hash'}->{'config_bytes'}</td> </tr>\n",
	$self->getval("max xmit");

print "<tr> <td><b>$self->{'text_hash'}->{'net_listen'}</b></td>\n";
printf "<td><input type=radio name=socket_address_def value=1 %s> $self->{'text_hash'}->{'config_all'}\n",
	$self->getval("socket address") eq "" ? "checked" : "";
printf "<input type=radio name=socket_address_def value=0 %s>\n",
	$self->getval("socket address") eq "" ? "" : "checked";
printf "<input name=socket_address size=15 value=\"%s\"></td> </tr>\n",
	$self->getval("socket address");

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'net_socket'}</b></td>\n";
print "<td><table>\n";
foreach (split(/\s+/, $self->getval("socket options"))) {
	if (/^([A-Z\_]+)=(.*)/) { $self->{'sopts_hash'}->{$1} = $2; }
	else { $self->{'sopts_hash'}->{$_} = ""; }
	}
for($i=0; $i<@{$self->{'sock_opts_array'}}; $i++) {
	$self->{'sock_opts_array'}->[$i] =~ /^([A-Z\_]+)(.*)$/;
	if ($i%2 == 0) { print "<tr>\n"; }
	printf "<td><input type=checkbox name=$1 value=1 %s> $1\n",
		defined($self->{'sopts_hash'}->{$1}) ? "checked" : "";
	if ($2 eq "*") {
		printf "<input size=5 name=\"$1_val\" value=\"%s\">\n",
			$self->{'sopts_hash'}->{$1};
		}
	print "</td>\n";
	if ($i%2 == 1) { print "<tr>\n"; }
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

