#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_pass.cgi
# Display password options options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcp'}") unless $self->{'access_hash'}->{'conf_pass'};

$self->ui_print_header(undef, $self->{'text_hash'}->{'passwd_title'}, "");

$self->get_share("global");

print "<form action=save_pass.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'passwd_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<tr> <td><b>$self->{'text_hash'}->{'passwd_encrypt'}</b></td>\n";
printf "<td><input type=radio name=encrypt_passwords value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("encrypt passwords") ? "checked" : "";
printf "&nbsp; <input type=radio name=encrypt_passwords value=no %s> $self->{'text_hash'}->{'no'}</td>\n",
	$self->istrue("encrypt passwords") ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'passwd_allownull'}</b></td>\n";
printf "<td><input type=radio name=null_passwords value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("null passwords") ? "checked" : "";
printf "$self->{'gap'} <input type=radio name=null_passwords value=no %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
	$self->istrue("null passwords") ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'passwd_program'}</b></td>\n";
printf "<td><input type=radio name=passwd_program_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("passwd program") eq "" ? "checked" : "";
printf "<input type=radio name=passwd_program_def value=0 %s>\n",
	$self->getval("passwd program") eq "" ? "" : "checked";
printf "<input size=15 name=passwd_program value=\"%s\"></td>\n",
	$self->getval("passwd program");

print "<td><b>$self->{'text_hash'}->{'passwd_sync'}</b></td>\n";
printf "<td><input type=radio name=unix_password_sync value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->istrue("unix password sync") ? "checked" : "";
printf "$self->{'gap'} <input type=radio name=unix_password_sync value=no %s> $self->{'text_hash'}->{'no'}</td></tr>\n",
	$self->istrue("unix password sync") ? "" : "checked";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'passwd_chat'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=passwd_chat_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("passwd chat") eq "" ? "checked" : "";
printf "<input type=radio name=passwd_chat_def value=0 %s> $self->{'text_hash'}->{'passwd_below'}<br>\n",
	$self->getval("passwd chat") eq "" ? "" : "checked";
print "<table border> <tr><td><b>$self->{'text_hash'}->{'passwd_waitfor'}</b></td> <td><b>$self->{'text_hash'}->{'passwd_send'}</b></td></tr>\n";
$self->{'pc'} = $self->getval("passwd chat");
while($self->{'pc'} =~ /^"([^"]*)"\s*(.*)/ || $self->{'pc'} =~ /^(\S+)\s*(.*)/) {
	if ($send) { push(@{$self->{'send_array'}}, $1); $send = 0; }
	else { push(@{$self->{'recv_array'}}, $1); $send = 1; }
	$self->{'pc'} = $2;
	}
for($i=0; $i<(@{$self->{'recv_array'}} < 5 ? 5 : @{$self->{'recv_array'}}+1); $i++) {
	printf "<tr><td><input name=chat_recv_$i value=\"%s\" size=20></td>\n",
		$self->{'recv_array'}->[$i] eq "." ? "" : $self->{'recv_array'}->[$i];
	printf "<td><input name=chat_send_$i value=\"%s\" size=20></td></tr>\n",
		$self->{'send_array'}->[$i];
	}
print "</table></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'passwd_map'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=username_map_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("username map") eq "" ? "checked" : "";
printf"<input type=radio name=username_map_def value=0 %s> $self->{'text_hash'}->{'passwd_below'}<br>\n",
	$self->getval("username map") eq "" ? "" : "checked";
print "<table border> <tr><td><b>$self->{'text_hash'}->{'passwd_unixuser'}</b></td>\n";
print "                   <td><b>$self->{'text_hash'}->{'passwd_winuser'}</b></td></tr>\n";
open(UMAP, $self->getval("username map"));
while(<UMAP>) {
	s/\r|\n//g;
	s/[#;].*$//g;
	if (/^\s*(\S+)\s*=\s*(.*)$/) {
		local $uunix = $1;
		local $rest = $2;
		while($rest =~ /^\s*"([^"]*)"(.*)$/ ||
		      $rest =~ /^\s*(\S+)(.*)$/) {
			push(@{$self->{'uunix_array'}}, $uunix);
			push(@{$self->{'uwin_array'}}, $1);
			$rest = $2;
			}
		}
	}
close(UMAP);
for($i=0; $i<@{$self->{'uunix_array'}}+1; $i++) {
	printf "<tr> <td><input name=umap_unix_$i size=8 value=\"%s\"></td>\n",
		$self->{'uunix_array'}->[$i];
	printf "<td><input name=umap_win_$i size=30 value=\"%s\"></td> </tr>\n",
		$self->{'uwin_array'}->[$i];
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
1;
		
}


1;

