#!/usr/bin/perl

&MAIN();

 sub MAIN {
# conf_smb.cgi
# Display Windows networking options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;


# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcs'}") unless $self->{'access_hash'}->{'conf_smb'};

$self->ui_print_header(undef, $self->{'text_hash'}->{'smb_title'}, "");

$self->get_share("global");

print "<form action=save_smb.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'smb_title'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$self->{'gap'} = "&nbsp;" x 3;

print "<tr> <td><b>$self->{'text_hash'}->{'smb_workgroup'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=workgroup_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("workgroup") eq "" ? "checked" : "";
printf "$self->{'gap'} <input type=radio name=workgroup_def value=0 %s>\n",
	$self->getval("workgroup") eq "" ? "" : "checked";
printf "<input name=workgroup size=15 value=\"%s\"></td> </tr>\n",
	$self->getval("workgroup");

print "<tr> <td><b>$self->{'text_hash'}->{'smb_wins'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=wins value=0 %s> $self->{'text_hash'}->{'smb_winsserver'}\n",
	$self->isfalse("wins support") ? "" : "checked";
printf "$self->{'gap'} <input type=radio name=wins value=1 %s> $self->{'text_hash'}->{'smb_useserver'}\n",
	$self->getval("wins server") eq "" ? "" : "checked";
printf "<input name=wins_server size=10 value=\"%s\">\n",
	$self->getval("wins server");
printf "$self->{'gap'} <input type=radio name=wins value=2 %s> $self->{'text_hash'}->{'config_neither'}\n",
      $self->isfalse("wins support") && $self->getval("wins server") eq "" ? "checked" : "";
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'smb_description'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=server_string_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("server string") eq "" ? "checked" : "";
printf "$self->{'gap'} <input type=radio name=server_string_def value=0 %s>\n",
	$self->getval("server string") eq "" ? "" : "checked";
printf "<input name=server_string size=20 value=\"%s\"></td> </tr>\n",
	$self->getval("server string");

print "<tr> <td><b>$self->{'text_hash'}->{'smb_name'}</b></td>\n";
printf "<td><input name=netbios_name size=15 value=\"%s\"></td>\n",
	$self->getval("netbios name");

print "<td><b>$self->{'text_hash'}->{'smb_aliase'}</b></td>\n";
printf "<td><input name=netbios_aliases size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("netbios aliases");

print "<tr> <td><b>$self->{'text_hash'}->{'smb_default'}</b></td>\n";
print "<td><select name=default>\n";
printf "<option value=\"\" %s> $self->{'text_hash'}->{'config_none'}\n", $self->getval("default") eq "";
foreach $s ($self->list_shares()) {
	next unless $self->can('r', \%{$self->{'access_hash'}}, $s) || !$self->{'access_hash'}->{'hide'};
	printf "<option value=\"$s\" %s> $s\n",
		$self->getval("default") eq $s ? "selected" : "";
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'smb_show'}</b></td>\n";
print "<td rowspan=2><select name=auto_services multiple size=3>\n";
foreach $s (split(/s\+/, $self->getval("auto services"))) { $self->{'autos_hash'}->{$s}++; }
foreach $s ($self->list_shares()) {
	next unless $self->can('r', \%{$self->{'access_hash'}}, $s) || !$self->{'access_hash'}->{'hide'};
	printf "<option value=\"$s\" %s> $s\n",
		$self->{'autos_hash'}->{$s} ? "checked" : "";
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'smb_disksize'}</b></td>\n";
print "<td colspan=2>\n";
printf "<input type=radio name=max_disk_size_def value=1 %s> $self->{'text_hash'}->{'smb_unlimited'}\n",
	$self->getval("max disk size") eq "" ? "checked" : "";
printf "$self->{'gap'} <input type=radio name=max_disk_size_def value=0 %s>\n",
	$self->getval("max disk size") eq "" ? "" : "checked";
printf "<input name=max_disk_size size=5 value=\"%s\"> kB</td>\n",
	$self->getval("max disk size");

print "<tr> <td><b>$self->{'text_hash'}->{'smb_winpopup'}</b></td>\n";
printf "<td><input name=message_command size=15 value=\"%s\"></td>\n",
	$self->getval("message command");

print "<td><b>$self->{'text_hash'}->{'smb_priority'}</b></td>\n";
printf "<td><input name=os_level size=5 value=\"%d\"></td> </tr>\n",
	$self->getval("os level");

print "<tr> <td><b>$self->{'text_hash'}->{'smb_protocol'}</b></td>\n";
print "<td><select name=protocol>\n";
printf "<option value=\"\" %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("protocol") eq "" ? "selected" : "";
foreach $p (@{$self->{'protocols_array'}}) {
	printf "<option value=\"$p\" %s> $p\n",
		$self->getval("protocol") eq $p ? "selected" : "";
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'smb_master'}</b></td>\n";
printf "<td><input type=radio name=preferred_master value=yes %s> $self->{'text_hash'}->{'yes'}\n",
	$self->isfalse("preferred master") ? "" : "checked";
printf "$self->{'gap'} <input type=radio name=preferred_master value=no %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$self->isfalse("preferred master") ? "checked" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'smb_security'}</b></td>\n";
print "<td><select name=security>\n";
printf "<option value='' %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("security") ? "" : "selected";
printf "<option value=share %s> $self->{'text_hash'}->{'smb_sharelevel'}\n",
	$self->getval("security") =~ /^share$/i ? "selected" : "";
printf "<option value=user %s> $self->{'text_hash'}->{'smb_userlevel'}\n",
	$self->getval("security") =~ /^user$/i ? "selected" : "";
printf "<option value=server %s> $self->{'text_hash'}->{'smb_passwdserver'}\n",
	$self->getval("security") =~ /^server$/i ? "selected" : "";
printf "<option value=domain %s> $self->{'text_hash'}->{'smb_domain'}\n",
	$self->getval("security") =~ /^domain$/i ? "selected" : "";
printf "<option value=ads %s> $self->{'text_hash'}->{'smb_ads'}\n",
	$self->getval("security") =~ /^ads$/i ? "selected" : "";
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'smb_passwdserver'}</b></td>\n";
printf "<td><input name=password_server size=10 value=\"%s\"></td> </tr>\n",
	$self->getval("password server");

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'smb_announce'}</b></td>\n";
print "<td colspan=3>\n";
printf "<input type=radio name=remote_def value=1 %s> $self->{'text_hash'}->{'smb_nowhere'}\n",
	$self->getval("remote announce") ? "" : "checked";
printf "$self->{'gap'} <input type=radio name=remote_def value=0 %s> $self->{'text_hash'}->{'smb_fromlist'}<br>\n",
	$self->getval("remote announce") ? "checked" : "";
print "<table border> <tr> <td><b>$self->{'text_hash'}->{'smb_ip'}</b></td> ",
      "<td>$self->{'text_hash'}->{'smb_asworkgroup'}</td> </tr>\n";
@{$self->{'rem_array'}} = split(/\s+/, $self->getval("remote announce")); $self->{'len'} = @{$self->{'rem_array'}} ? @{$self->{'rem_array'}}+1 : 2;
for($i=0; $i<$self->{'len'}; $i++) {
	print "<tr>\n";
	if ($self->{'rem_array'}->[$i] =~ /^([\d\.]+)\/(.+)$/) { $self->{'ip'} = $1; $self->{'wg'} = $2; }
	elsif ($self->{'rem_array'}->[$i] =~ /^([\d\.]+)$/) { $self->{'ip'} = $1; $self->{'wg'} = ""; }
	else { $self->{'ip'} = $self->{'wg'} = ""; }
	print "<td><input name=remote_ip$i size=15 value=\"$self->{'ip'}\"></td>\n";
	print "<td><input name=remote_wg$i size=15 value=\"$self->{'wg'}\"></td>\n";
	print "</tr>\n";
	}
print "</table></td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

