#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of shares at once

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
%{$self->{'access_hash'}} = $self->get_module_acl();

@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

$self->lock_file($self->{'config_hash'}->{'smb_conf'});
foreach $d (@d) {
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pds'}") 
		unless $self->can('rw', \%{$self->{'access_hash'}}, $d);
	foreach $s ($self->list_shares()) {
		$self->get_share($s);
		if ($self->getval("copy") eq $d) {
			$self->error($self->text('error_delcopy', $s));
			}
		}
	$self->delete_share($d);
	$self->drop_samba_acl(\%{$self->{'access_hash'}}, $d);
	}
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("delete", "shares", scalar(@d));
$self->redirect("");

1;
		
}


1;

