#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_fshare.cgi
# Display a form for editing or creating a new directory share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->{'s'} = $self->{'in_hash'}->{'share'};
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
if(!$self->{'s'}) {
    $self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcfs'}")
	    unless $self->{'access_hash'}->{'c_fs'};
	}
else {
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pafs'}")
        unless $self->can('r', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
    }
# display
if ($self->{'s'}) {
	$self->ui_print_header(undef, $self->{'s'} eq 'global' ? $self->{'text_hash'}->{'share_title1'} : $self->{'text_hash'}->{'share_title2'}, "");
	$self->get_share($self->{'s'});
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'share_title3'}, "");
	}

print "<form action=save_fshare.cgi>\n";
if ($self->{'s'}) { print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n"; }

# Vital share options..
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'share_info'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table cellpadding=2>\n";
if ($self->{'s'} ne "global") {
	if ($self->{'copy'} = $self->getval("copy")) {
		print "<tr> <td colspan=4><b>",$self->text('share_copy', $self->{'copy'}),
		      "</b></td> </tr>\n";
		}
	print "<tr> <td align=right><b>$self->{'text_hash'}->{'share_name'}</b></td>\n";
	printf "<td colspan=3><input type=radio name=homes value=0 %s>\n",
		$self->{'s'} eq "homes" ? "" : "checked";
	printf "<input size=10 name=share value=\"%s\">&nbsp;&nbsp;&nbsp;\n",
		$self->{'s'} eq "homes" ? "" : $self->{'s'};
	printf "<input type=radio name=homes value=1 %s> $self->{'text_hash'}->{'share_home'}\n",
		$self->{'s'} eq "homes" ? "checked" : "";
	print "</td> </tr>\n";
	}

print "<tr> <td align=right><b>$self->{'text_hash'}->{'share_dir'}</b></td>\n";
printf "<td colspan=3><input name=path size=40 value=\"%s\">\n",
	$self->getval("path");
print $self->file_chooser_button("path", 1);
print "</td> </tr>\n";

if (!$self->{'s'}) {
	print "<tr> <td align=right><b>$self->{'text_hash'}->{'share_create'}</b></td>\n";
	print "<td>",$self->yesno_input("create"),"</td>\n";

	print "<td align=right><b>$self->{'text_hash'}->{'share_owner'}</b></td>\n";
	print "<td>",$self->ui_user_textbox("createowner", "root"),"</td> </tr>\n";
}

print "<tr> <td align=right><b>$self->{'text_hash'}->{'share_available'}</b></td>\n";
print "<td>",$self->yesno_input("available"),"</td>\n";

print "<td align=right><b>$self->{'text_hash'}->{'share_browseable'}</b></td>\n";
print "<td>",$self->yesno_input("browseable"),"</td> </tr>\n";

print "<td align=right><b>$self->{'text_hash'}->{'share_comment'}</b></td>\n";
printf "<td colspan=3><input size=40 name=comment value=\"%s\"></td> </tr>\n",
	$self->getval("comment");

print "<tr> <td colspan=4 align=center>$self->{'text_hash'}->{'share_samedesc2'}</td> </tr>\n"
	if ($self->{'s'} eq "global");

print "</table> </td></tr></table><p>\n";
if ($self->{'s'} eq "global") {
	print "<input type=submit value=$self->{'text_hash'}->{'save'}> </form>\n";
	}
elsif ($self->{'s'}) {
	print "<table width=100%> <tr>\n";
	print "<td align=left><input type=submit value=$self->{'text_hash'}->{'save'}></td>\n"
		if $self->can('rw', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form><form action=view_users.cgi>\n";
	print "<input type=hidden name=share value=\"$self->{'s'}\">\n";
	print "<td align=center><input type=submit value=\"$self->{'text_hash'}->{'share_view'}\"></td>\n"
		if $self->can('rv', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form><form action=delete_share.cgi>\n";
	print "<input type=hidden name=share value=\"$self->{'s'}\">\n";
	print "<input type=hidden name=type value=fshare>\n";
	print "<td align=right><input type=submit value=$self->{'text_hash'}->{'delete'}></td>\n"
		if $self->can('rw', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form> </tr> </table>\n";
	}
else {
	print "<input type=submit value=$self->{'text_hash'}->{'create'}> </form>\n";
	}

if ($self->{'s'}) {
	# Icons for other share options
	$self->{'us'} = "share=".$self->urlize($self->{'s'});
	local (@url, @text, @icon, $disp);
	if ($self->can('rs',\%{$self->{'access_hash'}}, $self->{'s'})) {
		push(@url,  "edit_sec.cgi?$self->{'us'}");
		push(@text, $self->{'text_hash'}->{'share_security'});
		push(@icon, "images/icon_2.gif");
		$disp++;
		}
	if ($self->can('rp',\%{$self->{'access_hash'}}, $self->{'s'})) {
		push(@url,  "edit_fperm.cgi?$self->{'us'}");
		push(@text, $self->{'text_hash'}->{'share_permission'});
		push(@icon, "images/icon_7.gif");
		$disp++;
		}
	if ($self->can('rn',\%{$self->{'access_hash'}}, $self->{'s'})) {
		push(@url,  "edit_fname.cgi?$self->{'us'}");
		push(@text, $self->{'text_hash'}->{'share_naming'});
		push(@icon, "images/icon_8.gif");
		$disp++;
		}
	if ($self->can('ro',\%{$self->{'access_hash'}}, $self->{'s'})) {
		push(@url,  "edit_fmisc.cgi?$self->{'us'}");
		push(@text, $self->{'text_hash'}->{'share_misc'});
		push(@icon, "images/icon_4.gif");
		$disp++;
		}
	if ($disp) {
		print "<hr>\n";
		print $self->ui_subheading($self->{'text_hash'}->{'share_option'});
		$self->icons_table(\@url, \@text, \@icon);
		}
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

