#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_popts.cgi
# Edit print-share specific options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pvpopt'}")
        unless $self->can('ro', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
# display
$self->{'s'} = $self->{'in_hash'}->{'share'};
if ($self->{'s'} eq "global") {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'print_title1'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'print_title2'}, "");
	}
$self->get_share($self->{'s'});

print "<form action=save_popts.cgi>\n";
print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n";

# Printer options
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'print_option'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'print_minspace'}</b></td>\n";
printf "<td><input name=min_print_space size=5 value=\"%d\"></td>\n",
	$self->getval("min print space");

print "<td><b>$self->{'text_hash'}->{'print_postscript'}</b></td>\n";
print "<td>",$self->yesno_input("postscript"),"</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'print_command'}</b></td>\n";
printf "<td colspan=3>\n";
printf "<input type=radio name=print_command_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("print command") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=print_command_def value=0 %s>\n",
	$self->getval("print command") ne "" ? "checked" : "";
printf "<input name=print_command size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("print command");

print "<tr> <td><b>$self->{'text_hash'}->{'print_queue'}</b></td>\n";
printf "<td colspan=3>\n";
printf "<input type=radio name=lpq_command_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("lpq command") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=lpq_command_def value=0 %s>\n",
	$self->getval("lpq command") ne "" ? "checked" : "";
printf "<input name=lpq_command size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("lpq command");

print "<tr> <td><b>$self->{'text_hash'}->{'print_delete'}</b></td>\n";
printf "<td colspan=3>\n";
printf "<input type=radio name=lprm_command_def value=1 %s> $self->{'text_hash'}->{'default'}\n",
	$self->getval("lprm command") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=lprm_command_def value=0 %s>\n",
	$self->getval("lprm command") ne "" ? "checked" : "";
printf "<input name=lprm_command size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("lprm command");

print "<tr> <td><b>$self->{'text_hash'}->{'print_pause'}</b></td>\n";
printf "<td colspan=3>\n";
printf "<input type=radio name=lppause_command_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("lppause command") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=lppause_command_def value=0 %s>\n",
	$self->getval("lppause command") ne "" ? "checked" : "";
printf "<input name=lppause_command size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("lppause command");

print "<tr> <td><b>$self->{'text_hash'}->{'print_unresume'}</b></td>\n";
printf "<td colspan=3>\n";
printf "<input type=radio name=lpresume_command_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("lpresume command") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=lpresume_command_def value=0 %s>\n",
	$self->getval("lpresume command") ne "" ? "checked" : "";
printf "<input name=lpresume_command size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("lpresume command");

print "<tr> <td><b>$self->{'text_hash'}->{'print_driver'}</b></td>\n"; 
print "<td colspan=3>\n";
printf "<input type=radio name=printer_driver_def value=1 %s> $self->{'text_hash'}->{'config_none'}\n",
	$self->getval("printer driver") eq "" ? "checked" : "";
printf "&nbsp;&nbsp;<input type=radio name=printer_driver_def value=0 %s>\n",
	$self->getval("printer driver") ne "" ? "checked" : "";
printf "<input name=printer_driver size=30 value=\"%s\"></td> </tr>\n",
	$self->getval("printer driver");

print "</table> </td></tr></table><p>\n";
print "<input type=submit value=$self->{'text_hash'}->{'save'}>"
	if $self->can('wO', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'}); 
print "</form><p>\n";

$self->ui_print_footer("edit_pshare.cgi?share=".$self->urlize($self->{'s'}), $self->{'text_hash'}->{'index_printershare'},
	"", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

