#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_pshare.cgi
# Display a form for editing or creating a new printer share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->{'s'} = $self->{'in_hash'}->{'share'};
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
if(!$self->{'s'}) {
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcps'}")
        unless $self->{'access_hash'}->{'c_ps'};
	}
else {
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_paps'}")
        unless $self->can('r', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{'share'});
	}
# display
if ($self->{'s'}) {
	$self->ui_print_header(undef, $self->{'s'} eq 'global' ? $self->{'text_hash'}->{'pshare_title1'} : $self->{'text_hash'}->{'pshare_title2'}, "");
	$self->get_share($self->{'s'});
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'pshare_title3'}, "");
	}

print "<form action=save_pshare.cgi>\n";
if ($self->{'s'}) { print "<input type=hidden name=old_name value=\"$self->{'s'}\">\n"; }

# Vital share options..
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'pshare_info'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";
if ($self->{'s'} ne "global") {
	if ($self->{'copy'} = $self->getval("copy")) {
		print "<tr> <td colspan=4><b>", $self->text('share_copy',$self->{'copy'}),"</b></td> </tr>\n";
		}
	print "<tr> <td><b>$self->{'text_hash'}->{'pshare_name'}</b></td>\n";
	printf "<td colspan=3><input type=radio name=printers value=0 %s>\n",
		$self->{'s'} eq "printers" ? "" : "checked";
	printf "<input size=10 name=share value=\"%s\">&nbsp;&nbsp;&nbsp;\n",
		$self->{'s'} eq "printers" ? "" : $self->{'s'};
	printf "<input type=radio name=printers value=1 %s> $self->{'text_hash'}->{'pshare_all'}\n",
		$self->{'s'} eq "printers" ? "checked" : "";
	print "</td> </tr>\n";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'pshare_unixprn'}</b></td>\n";
if ($self->foreign_check("lpadmin")) {
	$self->foreign_require("lpadmin", "lpadmin-lib.pl");
	@{$self->{'plist_array'}} = $self->foreign_call("lpadmin", "list_printers");
	}
elsif ($self->{'config_hash'}->{'list_printers_command'}) {
	@{$self->{'plist_array'}} = split(/\s+/ , `$self->{'config_hash'}->{'list_printers_command'}`);
	}
if (@{$self->{'plist_array'}}) {
	local $printer = $self->getval("printer");
	push(@{$self->{'plist_array'}}, $printer)
		if ($printer && $self->indexof($printer, @{$self->{'plist_array'}}) == -1);
	print "<td><select name=printer>\n";
	printf "<option value=\"\" %s> %s\n",
		$printer eq "" ? "selected" : "",
		$self->{'s'} eq "global" ? $self->{'text_hash'}->{'config_none'} : $self->{'text_hash'}->{'default'};
	foreach $p (@{$self->{'plist_array'}}) {
		printf "<option value=\"$p\" %s> $p\n",
			$p eq $printer ? "selected" : "";
		}
	print "</select></td>\n";
	}
else {
	print "<td><input name=printer size=8></td>\n";
	}

print "<td><b>$self->{'text_hash'}->{'pshare_spool'}</b></td>\n";
printf "<td><input name=path size=35 value=\"%s\">\n",
	$self->getval("path");
print $self->file_chooser_button("path", 1);
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'share_available'}</b></td>\n";
print "<td>",$self->yesno_input("available"),"</td>\n";

print "<td><b>$self->{'text_hash'}->{'share_browseable'}</b></td>\n";
print "<td>",$self->yesno_input("browseable"),"</td> </tr>\n";

print "<td align=right><b>$self->{'text_hash'}->{'share_comment'}</b></td>\n";
printf "<td colspan=3 align=left>\n";
printf "<input size=40 name=comment value=\"%s\"></td> </tr>\n",
	$self->getval("comment");

print "<tr> <td colspan=4 align=center>$self->{'text_hash'}->{'share_samedesc1'}</td> </tr>\n"
	if ($self->{'s'} eq "global");

print "</table> </td></tr></table><p>\n";

if ($self->{'s'} eq "global") {
	print "<input type=submit value=$self->{'text_hash'}->{'save'}> </form><p>\n";
	}
elsif ($self->{'s'}) {
	print "<table width=100%> <tr>\n";
	print "<td align=left><input type=submit value=$self->{'text_hash'}->{'save'}></td>\n"
		if $self->can('rw', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form><form action=view_users.cgi>\n";
	print "<input type=hidden name=share value=\"$self->{'s'}\">\n";
	print "<input type=hidden name=printer value=1>\n";
	print "<td align=center><input type=submit value=\"$self->{'text_hash'}->{'index_view'}\"></td>\n"
		if $self->can('rv', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form><form action=delete_share.cgi>\n";
	print "<input type=hidden name=share value=\"$self->{'s'}\">\n";
	print "<input type=hidden name=type value=pshare>\n";
	print "<td align=right><input type=submit value=$self->{'text_hash'}->{'delete'}></td>\n"
		if $self->can('rw', \%{$self->{'access_hash'}}, $self->{'s'});
	print "</form> </tr> </table> <p>\n";
	}
else {
	print "<input type=submit value=$self->{'text_hash'}->{'create'}> </form><p>\n";
	}

if ($self->{'s'}) {
	# Icons for other share options
    $self->{'us'} = "share=".$self->urlize($self->{'s'})."&printer=1";
    local (@url, @text, @icon, $disp);
    if ($self->can('rs',\%{$self->{'access_hash'}}, $self->{'s'})) {
        push(@url,  "edit_sec.cgi?$self->{'us'}");
        push(@text, $self->{'text_hash'}->{'share_security'});
        push(@icon, "images/icon_2.gif");
        $disp++;
        }
    if ($self->can('ro',\%{$self->{'access_hash'}}, $self->{'s'})) {
        push(@url,  "edit_popts.cgi?$self->{'us'}");
        push(@text, $self->{'text_hash'}->{'print_option'});
        push(@icon, "images/icon_3.gif");
        $disp++;
        }
    if ($disp) {
        print "<hr>\n";
        print $self->ui_subheading($self->{'text_hash'}->{'share_option'});
        $self->icons_table(\@url, \@text, \@icon);
        }
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
1;
		
}


1;

