#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_winbind.cgi
# Show form for binding to a domain

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'winbind'} || $self->error($self->{'text_hash'}->{'winbind_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'winbind_title'}, "");

print $self->{'text_hash'}->{'winbind_msg'}, "<p>\n";

print $self->ui_form_start("save_winbind.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'winbind_header'}, "width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'winbind_user'},
		    $self->ui_user_textbox("user", "Administrator"));

print $self->ui_table_row($self->{'text_hash'}->{'winbind_pass'},
		    $self->ui_password("pass", undef, 20));

print $self->ui_table_row($self->{'text_hash'}->{'winbind_dom'},
		    $self->ui_opt_textbox("dom", undef, 20,
				    $self->{'text_hash'}->{'winbind_default'}));

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'winbind_save'} ] ], "100%");

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

