#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_group.cgi
# List all existing Samba groups

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'maint_groups'} || $self->error($self->{'text_hash'}->{'groups_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'groups_title'}, "");

$self->check_group_enabled($self->{'text_hash'}->{'groups_cannot'});

@{$self->{'groups_array'}} = $self->list_groups();
if (@{$self->{'groups_array'}}) {
	@{$self->{'groups_array'}} = sort { lc($a->{'name'}) cmp lc($b->{'name'}) } @{$self->{'groups_array'}}
		if ($self->{'config_hash'}->{'sort_mode'});
	print "<a href='edit_group.cgi?new=1'>$self->{'text_hash'}->{'groups_add'}</a><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'groups_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'groups_unix'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'groups_type'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'groups_sid'}</b></td> </tr>\n";
	foreach $g (@{$self->{'groups_array'}}) {
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='edit_group.cgi?idx=$g->{'index'}'>",
		      "$g->{'name'}</a></td>\n";
		print "<td>",$g->{'unix'} == -1 ? $self->{'text_hash'}->{'groups_nounix'} :
			     "<tt>$g->{'unix'}</tt>","</td>\n";
		print "<td>",$self->{'text_hash'}->{'groups_type_'.$g->{'type'}} ||
			     $g->{'type'},"</td>\n";
		print "<td><tt>$g->{'sid'}</tt></td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'groups_none'}</b><p>\n";
	}
print "<a href='edit_group.cgi?new=1'>$self->{'text_hash'}->{'groups_add'}</a><p>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

