#!/usr/bin/perl

&MAIN();

 sub MAIN {
# make_epass.cgi
# Create or update the samba password file from the list of Unix users

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pmpass'}")
		unless $self->{'access_hash'}->{'maint_makepass'};
# make
$self->ui_print_header(undef, $self->{'text_hash'}->{'mkpass_title'}, "");
$self->error_setup($self->{'text_hash'}->{'mkpass_convfail'});
$| = 1;

if ($self->{'config_hash'}->{'smb_passwd'} =~ /^(.*)\/([^\/]+)$/) {
	mkdir($1, 0700);
	}
$self->lock_file($self->{'config_hash'}->{'smb_passwd'});
@{$self->{'ulist_array'}} = $self->list_users();
map { $self->{'suser_hash'}->{$_->{'name'}} = $_ } @{$self->{'ulist_array'}};

print "$self->{'text_hash'}->{'mkpass_msg'}<p>\n";
@{$self->{'skip_array'}} = split(/[ \t,]/ , $self->{'in_hash'}->{"skip_list"});
print "<table border width=100%><tr><td bgcolor=#c0c0c0><pre>\n";
setpwent();
while(@{$self->{'uinfo_array'}} = getpwent()) {
	# Get new and existing user details
	local ($c1, $c2, $m);
	local $huinfo = $self->html_escape($self->{'uinfo_array'}->[0]);
	$self->{'uexists_hash'}->{$self->{'uinfo_array'}->[0]}++;
	local $su = $self->{'suser_hash'}->{$self->{'uinfo_array'}->[0]};

	# Check if this user would be skipped
	local $skipme;
	foreach $s (@{$self->{'skip_array'}}) {
		if ($s eq $self->{'uinfo_array'}->[0]) { $skipme++; }
		elsif ($s =~ /^(\d+)$/ && $s == $self->{'uinfo_array'}->[2]) { $skipme++; }
		elsif ($s =~ /^(\d+)\-(\d+)$/ &&
		       $self->{'uinfo_array'}->[2] >= $1 && $self->{'uinfo_array'}->[2] <= $2) { $skipme++; }
		elsif ($s =~ /^(\d+)\-$/ && $self->{'uinfo_array'}->[2] >= $1) { $skipme++; }
		elsif ($s =~ /^\-(\d+)$/ && $self->{'uinfo_array'}->[2] <= $1) { $skipme++; }
		elsif ($s =~ /^\@(.*)$/) {
			local @ginfo = getgrnam($1);
			local @mems = split(/\s+/, $ginfo[3]);
			$skipme++ if ($self->{'uinfo_array'}->[3] == $ginfo[2] ||
				      $self->indexof($self->{'uinfo_array'}->[0], @mems) >= 0);
			}
		}
	if ($skipme) {
		$m = "$huinfo $self->{'text_hash'}->{'mkpass_skip'}";
		}

	elsif ($su && $self->{'in_hash'}->{"update"}) {
		if ($su->{'opts'}) {
			# new-style user
			if ($self->{'uinfo_array'}->[2] == $su->{'uid'}) {
				$m = "$huinfo $self->{'text_hash'}->{'mkpass_same'}";
				}
			else {
				$su->{'uid'} = $self->{'uinfo_array'}->[2];
				$su->{'real'} = $self->{'uinfo_array'}->[6];
				$self->modify_user($su);
				$m = "$huinfo $self->{'text_hash'}->{'mkpass_update'}";
				$c1 = "<i>"; $c2 = "</i>";
				$self->{'modified'}++;
				}
			}
		else {
			# old-style user
			if ($self->{'uinfo_array'}->[2] == $su->{'uid'} &&
			    $self->{'uinfo_array'}->[6] eq $su->{'real'} &&
			    $self->{'uinfo_array'}->[7] eq $su->{'home'} &&
			    $self->{'uinfo_array'}->[8] eq $su->{'shell'}) {
				$m = "$huinfo $self->{'text_hash'}->{'mkpass_same'}";
				}
			else {
				$su->{'uid'} = $self->{'uinfo_array'}->[2];
				$su->{'real'} = $self->{'uinfo_array'}->[6];
				$su->{'home'} = $self->{'uinfo_array'}->[7];
				$su->{'shell'} = $self->{'uinfo_array'}->[8];
				$self->modify_user($su);
				$m = "$huinfo $self->{'text_hash'}->{'mkpass_update'}";
				$c1 = "<i>"; $c2 = "</i>";
				$self->{'modified'}++;
				}
			}
		}
	elsif ($self->{'in_hash'}->{"add"} && !$su) {
		local $nu = { 'name' => $self->{'uinfo_array'}->[0],
			      'uid' => $self->{'uinfo_array'}->[2] };
		local @flags = ("U");
		$c1 = "<b>"; $c2 = "</b>";
		$m = "$huinfo being added";
		if ($self->{'in_hash'}->{'newmode'} == 0) {
			$nu->{'pass1'} = "NO PASSWORDXXXXXXXXXXXXXXXXXXXXX";
			$nu->{'pass2'} = $nu->{'pass1'};
			push(@flags, "N");
			}
		else {
			$nu->{'pass1'} = $nu->{'pass2'} = ("X" x 32);
			if ($self->{'in_hash'}->{'newmode'} == 2) {
				$self->{'setpass_hash'}->{$self->{'uinfo_array'}->[0]} = $self->{'in_hash'}->{'newpass'};
				}
			else { push(@flags, "D"); }
			}
		if ($self->{'samba_version'} < 2) {
			$nu->{'real'} = $self->{'uinfo_array'}->[6];
			$nu->{'home'} = $self->{'uinfo_array'}->[7];
			$nu->{'shell'} = $self->{'uinfo_array'}->[8];
			}
		else {
			$nu->{'opts'} = \@flags;
			}
		$self->create_user($nu);
		$self->{'created'}++;
		}
	if ($m) { printf "$c1%-40.40s$c2%s", $m, ++$self->{'c'}%2 ? "" : "\n"; }
	}
endpwent() if ($self->{'gconfig_hash'}->{'os_type'} ne 'hpux');

# Delete missing users, if needed
if ($self->{'in_hash'}->{"delete"}) {
	foreach $u (@{$self->{'ulist_array'}}) {
		if (!$self->{'uexists_hash'}->{$u->{'name'}}) {
			# delete this samba user..
			$m = $self->html_escape($u->{'name'})." $self->{'text_hash'}->{'mkpass_del'}";
			$self->delete_user($u);
			printf "<b><font color=#ff0000>%-40.40s</font></b>%s",
				$m, ++$self->{'c'}%2 ? "" : "\n";
			$self->{'deleted'}++;
			}
		}
	}

# Update the passwords of new users
foreach $u (keys %{$self->{'setpass_hash'}}) {
	$self->set_password($u, $self->{'setpass_hash'}->{$u}) ||
		$self->error($self->{'text_hash'}->{'mkpass_passfail'});
	}
$self->unlock_file($self->{'config_hash'}->{'smb_passwd'});
$self->webmin_log("epass", undef, undef, { 'modified' => $self->{'modified'},
				     'created' => $self->{'created'},
				     'deleted' => $self->{'deleted'} } );

print "</pre></td></tr></table>\n";
$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});

1;
		
}


1;

