#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_copy.cgi
# Create a new, empty share that is a copy of an existing one

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcopy'}") unless $self->{'access_hash'}->{'copy'};
 
$self->error_setup($self->{'text_hash'}->{'savecopy_fail'});
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'in_hash'}->{'name'} || $self->error($self->{'text_hash'}->{'savecopy_ename'});
if ($self->{'in_hash'}->{"name"} eq "global") {
	$self->error($self->{'text_hash'}->{'savecopy_global'});
	}
if ($self->indexof($self->{'in_hash'}->{"name"}, $self->list_shares()) >= 0) {
	$self->error($self->text('savecopy_exist', $self->{'in_hash'}->{name}));
	}
$self->setval("copy", $self->{'in_hash'}->{copy});
$self->create_share($self->{'in_hash'}->{name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("copy", undef, $self->{'in_hash'}->{'name'}, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}


1;

