#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_euser.cgi
# Save an existing samba user

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pmusers'}")
        unless $self->{'access_hash'}->{'maint_users'} && $self->{'access_hash'}->{'view_users'};
# save		
$self->{'whatfailed'} = $self->{'text_hash'}->{'saveuser_fail'};
$self->lock_file($self->{'config_hash'}->{'smb_passwd'});
@{$self->{'list_array'}} = $self->list_users();
$self->{'u'} = $self->{'list_array'}->[$self->{'in_hash'}->{'idx'}];

# check inputs
$self->{'in_hash'}->{'uid'} =~ /^\d+$/ || $self->error($self->text('saveuser_uid', $self->{'in_hash'}->{'uid'}));
$self->{'u'}->{'uid'} = $self->{'in_hash'}->{'uid'};
if ($self->{'in_hash'}->{'new'}) {
	$self->{'u'}->{'opts'} = [ split(/\0/, $self->{'in_hash'}->{'opts'}) ];
	}
else {
	$self->{'in_hash'}->{'realname'} !~ /:/ ||
		$self->error($self->{'text_hash'}->{'saveuser_colon'});
	(-d $self->{'in_hash'}->{'homedir'}) ||
		$self->error($self->text('saveuser_home', $self->{'in_hash'}->{'homedir'}));
	(-x $self->{'in_hash'}->{'shell'}) || $self->error($self->text('saveuser_shell', $self->{'in_hash'}->{'shell'}));
	$self->{'u'}->{'home'} = $self->{'in_hash'}->{'homedir'};
	$self->{'u'}->{'shell'} = $self->{'in_hash'}->{'shell'};
	$self->{'u'}->{'real'} = $self->{'in_hash'}->{'realname'};
	}

# apply changes
if ($self->{'in_hash'}->{ptype} == 0) {
	$self->{'u'}->{'pass1'} = $self->{'u'}->{'$pass2'} = ("X" x 32);
	}
elsif ($self->{'in_hash'}->{ptype} == 1) {
	$self->{'u'}->{'pass1'} = "NO PASSWORDXXXXXXXXXXXXXXXXXXXXX";
	$self->{'u'}->{'pass2'} = $self->{'u'}->{'pass1'};
	}
elsif ($self->{'in_hash'}->{ptype} == 3) {
	# changing password.. need to set later with smbpasswd
	$self->{'u'}->{'pass1'} = $self->{'u'}->{'$pass2'} = ("X" x 32);
	$self->{'set_passwd'} = 1;
	}
$self->modify_user($self->{'u'});

# Call password change program if necessary
if ($self->{'set_passwd'}) {
	$self->set_password($self->{'u'}->{'name'}, $self->{'in_hash'}->{'pass'}) ||
		$self->error($self->text('saveuser_pass', $self->{'error'}));
	}
$self->unlock_file($self->{'config_hash'}->{'smb_passwd'});
$self->webmin_log("save", "euser", $self->{'u'}->{'name'}, $self->{'u'});

$self->redirect("edit_epass.cgi");

1;
		
}


1;

