#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_fmisc.cgi
# Save a misc options for a file share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name});

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pufmisc'}")
            unless $self->can('rwoO', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
# save
$self->{'whatfailed'} = $self->{'text_hash'}->{'savefmisc_fail'};
# Random options
$self->setval("mangled map", $self->{'in_hash'}->{mangled_map});
$self->setval("locking", $self->{'in_hash'}->{locking});
if ($self->{'in_hash'}->{max_connections_def}) { $self->setval("max connections", 0); }
else {
	($self->{'in_hash'}->{max_connections} =~ /^\d+$/ && $self->{'in_hash'}->{max_connections} > 0) ||
		$self->error($self->text('savefmisc_number', $self->{'in_hash'}->{max_connections}));
	$self->setval("max connections", $self->{'in_hash'}->{max_connections});
	}
$self->setval("oplocks", $self->{'in_hash'}->{oplocks});
$self->setval("level2 oplocks", $self->{'in_hash'}->{level2_oplocks});
$self->setval("fake oplocks", $self->{'in_hash'}->{fake_oplocks});
$self->setval("share modes", $self->{'in_hash'}->{share_modes});
$self->setval("strict locking", $self->{'in_hash'}->{strict_locking});
$self->setval("sync always", $self->{'in_hash'}->{sync_always});
$self->setval("volume", $self->{'in_hash'}->{volume_def} ? "" : $self->{'in_hash'}->{volume});
$self->setval("preexec", $self->{'in_hash'}->{preexec});
$self->setval("postexec", $self->{'in_hash'}->{postexec});
$self->setval("root preexec", $self->{'in_hash'}->{root_preexec});
$self->setval("root postexec", $self->{'in_hash'}->{root_postexec});

$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'in_hash'}->{old_name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("save", "fmisc", $self->{'in_hash'}->{old_name}, \%{$self->{'in_hash'}});
$self->redirect("edit_fshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name}));

1;
		
}


1;

