#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_print.cgi
# Save inputs from conf_print.cgi

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->{'global'} = $self->get_share("global");

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pcprint'}") unless $self->{'access_hash'}->{'conf_print'};
 
$self->{'whatfailed'} = $self->{'text_hash'}->{'saveprint_fail'};
$self->setval("printing", $self->{'in_hash'}->{printing}, "");

$self->setval("load printers", $self->{'in_hash'}->{load_printers}, "");

$self->setval("printcap name", $self->{'in_hash'}->{printcap_name_def} ? "" : $self->{'in_hash'}->{printcap_name}, "");

if (!$self->{'in_hash'}->{lpq_cache_time_def} && $self->{'in_hash'}->{lpq_cache_time} !~ /^\d+$/) {
	$self->error($self->text('saveprint_cache', $self->{'in_hash'}->{lpq_cache_time}));
	}
$self->setval("lpq cache time", $self->{'in_hash'}->{lpq_cache_time_def} ? 0 : $self->{'in_hash'}->{lpq_cache_time}, 0);

if ($self->{'global'}) { $self->modify_share("global", "global"); }
else { $self->create_share("global"); }
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("print", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

