#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sec.cgi
# Save secuirty options for a share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'smb_conf'});
$self->get_share($self->{'in_hash'}->{old_name});

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pusec'}")
	        unless $self->can('rwsS', \%{$self->{'access_hash'}}, $self->{'in_hash'}->{old_name});
# save				
$self->{'whatfailed'} = $self->{'text_hash'}->{'savesec_fail'};
$self->delval("read only");
$self->setval("writeable", $self->{'in_hash'}->{writeable});
if ($self->{'in_hash'}->{guest} == 0) {
	$self->delval("public"); $self->delval("guest only");
	}
elsif ($self->{'in_hash'}->{guest} == 1) {
	$self->setval("public", "yes"); $self->delval("guest only");
	}
else {
	$self->setval("public", "yes"); $self->setval("guest only", "yes");
	}
$self->setval("valid users",
	join(',', &split_input($self->{'in_hash'}->{'valid_users_u'}),
		  &split_input($self->{'in_hash'}->{'valid_users_g'}, '@')));
$self->setval("invalid users",
	join(',', &split_input($self->{'in_hash'}->{'invalid_users_u'}),
		  &split_input($self->{'in_hash'}->{'invalid_users_g'}, '@')));
$self->setval("user",
	join(',', &split_input($self->{'in_hash'}->{'user_u'}),
		  &split_input($self->{'in_hash'}->{'user_g'}, '@')));
$self->setval("read list",
	join(',', &split_input($self->{'in_hash'}->{'read_list_u'}),
		  &split_input($self->{'in_hash'}->{'read_list_g'}, '@')));
$self->setval("write list",
	join(',', &split_input($self->{'in_hash'}->{'write_list_u'}),
		  &split_input($self->{'in_hash'}->{'write_list_g'}, '@')));
if (!$self->{'in_hash'}->{allow_hosts_all} && $self->{'in_hash'}->{allow_hosts} =~ /\S/) {
	$self->setval("allow hosts", $self->{'in_hash'}->{allow_hosts});
	}
else { $self->delval("allow hosts"); }
if (!$self->{'in_hash'}->{deny_hosts_all} && $self->{'in_hash'}->{deny_hosts} =~ /\S/) {
	$self->setval("deny hosts", $self->{'in_hash'}->{deny_hosts});
	}
else { $self->delval("deny hosts"); }
$self->setval("guest account", $self->{'in_hash'}->{guest_account});
$self->setval("only user", $self->{'in_hash'}->{only_user});
$self->setval("revalidate", $self->{'in_hash'}->{revalidate});

$self->modify_share($self->{'in_hash'}->{old_name}, $self->{'in_hash'}->{old_name});
$self->unlock_file($self->{'config_hash'}->{'smb_conf'});
$self->webmin_log("save", "sec", $self->{'in_hash'}->{old_name}, \%{$self->{'in_hash'}});
if ($self->istrue("printable") || $self->{'in_hash'}->{'printer'})
	{ $self->redirect("edit_pshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name})); }
else
	{ $self->redirect("edit_fshare.cgi?share=".$self->urlize($self->{'in_hash'}->{old_name})); }

1;
		
}

# split_input(string, [prepend])
sub split_input
{
	shift if ($self == $_[0]);

local @rv;
local $str = $_[0];
while($str =~ /^\s*(\S*"[^"]+"\S*)(.*)$/ || $str =~ /^\s*(\S+)(.*)$/) {
	push(@rv, $_[1].$1);
	$str = $2;
	}
return @rv;
}


1;

