#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_sync.cgi
# Save unix-samba synchronisation options

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();
# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pmsync'}")
        unless $self->{'access_hash'}->{'maint_sync'};
# save
$self->{'in_hash'}->{'gid_def'} || $self->{'in_hash'}->{'gid'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'esync_egid'});
$self->lock_file($self->{'module_config_file'});
foreach $s ("add", "change", "delete", "delete_profile", "change_profile") {
	if ($self->{'in_hash'}->{$s}) { $self->{'config_hash'}->{"sync_$s"} = 1; }
	else { delete($self->{'config_hash'}->{"sync_$s"}); }
	}
$self->{'config_hash'}->{'sync_gid'} = $self->{'in_hash'}->{'gid_def'} ? undef : $self->{'in_hash'}->{'gid'};
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});
$self->webmin_log("sync");
$self->redirect("");

1;
		
}


1;

