#!/usr/bin/perl

&MAIN();

 sub MAIN {
# view_users.cgi
# Display users connected to a share

&ModuleLoader::preload_module('samba_class', "samba::SambaLib");
$self = new samba::SambaLib:: 'samba_class',%$self;

$self->ReadParse();

# check acls
%{$self->{'access_hash'}} = $self->get_module_acl();
$self->error_setup("<blink><font color=red>$self->{'text_hash'}->{'eacl_aviol'}</font></blink>");
if ($self->{'in_hash'}->{share}) { # this may be cracked very easy, don't know how to do better :    # per-share acls ...
    # per-share acls ...
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pconn'}") 
		unless $self->can('rv',\%{$self->{'access_hash'}}, $self->{'in_hash'}->{share});
	}
else {
	$self->error("$self->{'text_hash'}->{'eacl_np'} $self->{'text_hash'}->{'eacl_pconn_all'}") 
		unless $self->{'access_hash'}->{'view_all_con'};
	} 
$self->ui_print_header(undef, $self->{'text_hash'}->{'viewu_index'}, "");

if (!$self->has_command($self->{'config_hash'}->{samba_status_program})) {
	print $self->text('viewu_ecmd', $self->{'config_hash'}->{'samba_status_program'}, "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}");
	print "<p>\n";
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'});
	exit;
	}

if ($self->{'in_hash'}->{share}) {
	print $self->ui_subheading($self->text('viewu_list',"<tt>$self->{'in_hash'}->{share}</tt>"));
	@{$self->{'cons_array'}} = $self->list_connections($self->{'in_hash'}->{'share'});
	}
else {
	@{$self->{'cons_array'}} = $self->list_connections();
	}
@{$self->{'locks_array'}} = $self->list_locks();

if (@{$self->{'cons_array'}}) {
	print $self->ui_form_start("kill_users.cgi");
	print $self->ui_hidden("share", $self->{'in_hash'}->{'share'});
	@{$self->{'links_array'}} = ( $self->select_all_link("d"),
		   $self->select_invert_link("d") );
	print $self->ui_links_row(\@{$self->{'links_array'}});

	# Show table header
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_columns_start([
		"",
		$self->{'text_hash'}->{'viewu_pid'},
		$self->{'in_hash'}->{'share'} ? ( ) : ( $self->{'text_hash'}->{'viewu_share'} ),
		$self->{'text_hash'}->{'viewu_user'},
		$self->{'text_hash'}->{'viewu_group'},
		$self->{'text_hash'}->{'viewu_from'},
		$self->{'text_hash'}->{'viewu_time'},
		$self->{'text_hash'}->{'viewu_locks'} ], 100, 0, \@{$self->{'tds_array'}});

	# Show each connected user
	foreach $c (@{$self->{'cons_array'}}) {
		local @cols;
		push(@cols, "<a href=\"kill_user.cgi?share=$self->{'in_hash'}->{'share'}&pid=$c->[3]\">".$self->html_escape($c->[3])."</a>");
		if (!$self->{'in_hash'}->{'share'}) {
			push(@cols, $self->html_escape($c->[0]));
			}
		push(@cols, $self->html_escape($c->[1]));
		push(@cols, $self->html_escape($c->[2]));
		push(@cols, $self->html_escape($c->[4]));
		push(@cols, $self->html_escape($c->[5]));
		local $ulocks;
		@{$self->{'ulocks_array'}} = grep { $_->[0] == $c->[3] } @{$self->{'locks_array'}};
		foreach $l (@{$self->{'ulocks_array'}}) {
			$ulocks .= $self->html_escape($l->[4])." (".
			      	   $self->html_escape($l->[1]).")<br>\n";
			}
		$ulocks ||= $self->{'text_hash'}->{'viewu_none'};
		push(@cols, $ulocks);
		print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "d", $c->[3]);
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "kill", $self->{'text_hash'}->{'viewu_kill'} ] ]);

	print $self->{'text_hash'}->{'viewu_msg1'}, "<br>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'viewu_msg2'}</b>.\n";
	}
print "<p>\n";

if ($self->{'in_hash'}->{share}) {
	$self->ui_print_footer($self->{'in_hash'}->{printer} ? "edit_pshare.cgi?share=$self->{'in_hash'}->{share}"
			     : "edit_fshare.cgi?share=$self->{'in_hash'}->{share}",
		$self->{'text_hash'}->{'index_shareconf'},
		"", $self->{'text_hash'}->{'index_sharelist'});
	}
else { $self->ui_print_footer("", $self->{'text_hash'}->{'index_sharelist'}); }

1;
		
}


1;

