#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show schedule form

&ModuleLoader::preload_module('sarg_class', "sarg::SargLib");
$self = new sarg::SargLib:: 'sarg_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
@{$self->{'jobs_array'}} = $main::cron_object->list_cron_jobs();
($self->{'job'}) = grep { $_->{'user'} eq 'root' &&
		$_->{'command'} eq $self->{'cron_cmd'} } @{$self->{'jobs_array'}};

$self->{'conf'} = $self->get_config();
$self->{'odir'} = $self->find_value("output_dir", $self->{'conf'});
$self->{'sfile'} = $self->find_value("access_log", $self->{'conf'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'sched_title'}, "");

if (!$self->{'odir'}) {
	$self->ui_print_endpage($self->text('sched_edir', "edit_log.cgi"));
	}
elsif (!$self->{'sfile'}) {
	$self->ui_print_endpage($self->text('sched_esfile', "edit_log.cgi"));
	}

print $self->ui_form_start("save_sched.cgi", "post");
print $self->ui_table_start($self->{'text_hash'}->{'sched_header'}, "width=100%", 4);

print $self->ui_table_row($self->{'text_hash'}->{'sched_sched'},
		    $self->ui_radio("sched", $self->{'job'} ? 1 : 0,
			      [ [ 0, $self->{'text_hash'}->{'no'} ],
				[ 1, $self->{'text_hash'}->{'sched_yes'} ] ]), 3);

print $self->ui_table_row($self->{'text_hash'}->{'sched_dir'},
		    "<tt>$self->{'odir'}</tt>", 3);

print $self->ui_table_row($self->{'text_hash'}->{'sched_clear'}, $self->gen_clear_input(), 3);

print $self->ui_table_row($self->{'text_hash'}->{'sched_range'}, $self->gen_range_input(), 3);

print "<tr> <td colspan=4><table border width=100%>\n";
$main::cron_object->show_times_input($self->{'job'} || { 'special' => 'daily' });
print "</table></td></tr>\n";

print $self->ui_table_end();
print $self->ui_form_end([ [ 'save', $self->{'text_hash'}->{'save'} ] ], "100%");
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

