#!/usr/bin/perl
package sendmail::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sendmail::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the sendmail module
sub acl_security_form
{
	my $self = shift;

print "<tr> <td><b>$self->{'text_hash'}->{'acl_opts'}</b></td> <td>\n";
printf "<input type=radio name=opts value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'opts'} ? "checked" : "";
printf "<input type=radio name=opts value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'opts'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_cws'}</b></td> <td>\n";
printf "<input type=radio name=cws value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'cws'} ? "checked" : "";
printf "<input type=radio name=cws value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'cws'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_masq'}</b></td> <td>\n";
printf "<input type=radio name=masq value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'masq'} ? "checked" : "";
printf "<input type=radio name=masq value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'masq'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_trusts'}</b></td> <td>\n";
printf "<input type=radio name=trusts value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'trusts'} ? "checked" : "";
printf "<input type=radio name=trusts value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'trusts'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_cgs'}</b></td> <td>\n";
printf "<input type=radio name=cgs value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'cgs'} ? "checked" : "";
printf "<input type=radio name=cgs value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'cgs'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_relay'}</b></td> <td>\n";
printf "<input type=radio name=relay value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'relay'} ? "checked" : "";
printf "<input type=radio name=relay value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'relay'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_mailers'}</b></td> <td>\n";
printf "<input type=radio name=mailers value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'mailers'} ? "checked" : "";
printf "<input type=radio name=mailers value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'mailers'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_access'}</b></td> <td>\n";
printf "<input type=radio name=access value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'access'} ? "checked" : "";
printf "<input type=radio name=access value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'access'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_domains'}</b></td> <td>\n";
printf "<input type=radio name=domains value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'domains'} ? "checked" : "";
printf "<input type=radio name=domains value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'domains'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_stop'}</b></td> <td>\n";
printf "<input type=radio name=stop value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'stop'} ? "checked" : "";
printf "<input type=radio name=stop value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'stop'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_manual'}</b></td> <td>\n";
printf "<input type=radio name=manual value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'manual'} ? "checked" : "";
printf "<input type=radio name=manual value=0 %s> $self->{'text_hash'}->{'no'}</td>\n",
	$_[0]->{'manual'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'acl_mailq'}</b></td> <td><select name=mailq>\n";
printf "<option value=2 %s> $self->{'text_hash'}->{'acl_viewdel'}\n",
	$_[0]->{'mailq'} == 2 ? "selected" : "";
printf "<option value=1 %s> $self->{'text_hash'}->{'acl_view'}\n",
	$_[0]->{'mailq'} == 1 ? "selected" : "";
printf "<option value=0 %s> $self->{'text_hash'}->{'no'}\n",
	$_[0]->{'mailq'} == 0 ? "selected" : "";
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_qdoms'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=qdoms_def value=1 %s> %s\n",
	$_[0]->{'qdoms'} ? "" : "checked", $self->{'text_hash'}->{'acl_all'};
printf "<input type=radio name=qdoms_def value=0 %s> %s\n",
	$_[0]->{'qdoms'} ? "checked" : "", $self->{'text_hash'}->{'acl_matching'};
printf "<input name=qdoms size=40 value='%s'></td> </tr>\n",
	$_[0]->{'qdoms'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_qdomsmode'}</b></td> <td colspan=3>\n";
foreach $m (0 .. 2) {
	printf "<input type=radio name=qdomsmode value=%s %s> %s\n",
		$m, $_[0]->{'qdomsmode'} == $m ? "checked" : "",
		$self->{'text_hash'}->{'acl_qdomsmode'.$m};
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_flushq'}</b></td> <td>\n";
printf "<input type=radio name=flushq value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$_[0]->{'flushq'} ? "checked" : "";
printf "<input type=radio name=flushq value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$_[0]->{'flushq'} ? "" : "checked";

# Virtusers
print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_virtusers'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=vmode value=0 %s> $self->{'text_hash'}->{'acl_none'}\n",
	$_[0]->{'vmode'} == 0 ? "checked" : "";
printf "<input type=radio name=vmode value=1 %s> $self->{'text_hash'}->{'acl_all'}\n",
	$_[0]->{'vmode'} == 1 ? "checked" : "";
printf "<input type=radio name=vmode value=3 %s> $self->{'text_hash'}->{'acl_vsame'}<br>\n",
	$_[0]->{'vmode'} == 3 ? "checked" : "";
printf "<input type=radio name=vmode value=2 %s> $self->{'text_hash'}->{'acl_matching'}\n",
	$_[0]->{'vmode'} == 2 ? "checked" : "";
printf "<input name=vaddrs size=40 value='%s'></td> </tr>\n",
	$_[0]->{'vaddrs'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_vtypes'}</b></td>\n";
print "<td colspan=3>\n";
for($n=0; $n<3; $n++) {
	printf "<input type=checkbox name=vedit_%s value=1 %s> %s\n",
		$n, $_[0]->{"vedit_$n"} ? "checked" : "", $self->{'text_hash'}->{"acl_vtype$n"};
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_vmax'}</b></td>\n";
printf "<td colspan=3><input type=radio name=vmax_def value=1 %s> %s\n",
	$_[0]->{'vmax'} ? "" : "checked", $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=vmax_def value=0 %s>\n",
	$_[0]->{'vmax'} ? "checked" : "";
printf "<input name=vmax size=5 value='%s'></td> </tr>\n",
	$_[0]->{'vmax'};

# Aliases
print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_aliases'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=amode value=0 %s> $self->{'text_hash'}->{'acl_none'}\n",
	$_[0]->{'amode'} == 0 ? "checked" : "";
printf "<input type=radio name=amode value=1 %s> $self->{'text_hash'}->{'acl_all'}\n",
	$_[0]->{'amode'} == 1 ? "checked" : "";
printf "<input type=radio name=amode value=3 %s> $self->{'text_hash'}->{'acl_asame'}<br>\n",
	$_[0]->{'amode'} == 3 ? "checked" : "";
printf "<input type=radio name=amode value=2 %s> $self->{'text_hash'}->{'acl_matching'}\n",
	$_[0]->{'amode'} == 2 ? "checked" : "";
printf "<input name=aliases size=40 value='%s'></td> </tr>\n",
	$_[0]->{'aliases'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_atypes'}</b></td> <td colspan=3>\n";
for($n=1; $n<=6; $n++) {
	printf "<input type=checkbox name=aedit_%s value=1 %s> %s\n",
		$n, $_[0]->{"aedit_$n"} ? "checked" : "",
		$self->{'text_hash'}->{"acl_atype$n"};
	}
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_amax'}</b></td>\n";
printf "<td colspan=3><input type=radio name=amax_def value=1 %s> %s\n",
	$_[0]->{'amax'} ? "" : "checked", $self->{'text_hash'}->{'acl_unlimited'};
printf "<input type=radio name=amax_def value=0 %s>\n",
	$_[0]->{'amax'} ? "checked" : "";
printf "<input name=amax size=5 value='%s'></td> </tr>\n",
	$_[0]->{'amax'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_apath'}</b></td>\n";
printf "<td colspan=3><input name=apath size=40 value='%s'> %s</td> </tr>\n",
	$_[0]->{'apath'}, $self->file_chooser_button("apath", 1);

# Outgoing address mappings
print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_outgoing'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=omode value=0 %s> $self->{'text_hash'}->{'acl_none'}\n",
	$_[0]->{'omode'} == 0 ? "checked" : "";
printf "<input type=radio name=omode value=1 %s> $self->{'text_hash'}->{'acl_all'}<br>\n",
	$_[0]->{'omode'} == 1 ? "checked" : "";
printf "<input type=radio name=omode value=2 %s> $self->{'text_hash'}->{'acl_matching'}\n",
	$_[0]->{'omode'} == 2 ? "checked" : "";
printf "<input name=oaddrs size=40 value='%s'></td> </tr>\n",
	$_[0]->{'oaddrs'};

# Spam control rules
print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_spam'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=smode value=1 %s> $self->{'text_hash'}->{'acl_all'}\n",
	$_[0]->{'smode'} == 1 ? "checked" : "";
printf "<input type=radio name=smode value=2 %s> $self->{'text_hash'}->{'acl_matching'}\n",
	$_[0]->{'smode'} == 2 ? "checked" : "";
printf "<input name=saddrs size=40 value='%s'></td> </tr>\n",
	$_[0]->{'saddrs'};
}

# acl_security_save(&options)
# Parse the form for security options for the sendmail module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'opts'} = $self->{'in_hash'}->{'opts'};
$_[0]->{'cws'} = $self->{'in_hash'}->{'cws'};
$_[0]->{'masq'} = $self->{'in_hash'}->{'masq'};
$_[0]->{'trusts'} = $self->{'in_hash'}->{'trusts'};
$_[0]->{'cgs'} = $self->{'in_hash'}->{'cgs'};
$_[0]->{'relay'} = $self->{'in_hash'}->{'relay'};
$_[0]->{'manual'} = $self->{'in_hash'}->{'manual'};
$_[0]->{'mailq'} = $self->{'in_hash'}->{'mailq'};
$_[0]->{'qdoms'} = $self->{'in_hash'}->{'qdoms_def'} ? undef : $self->{'in_hash'}->{'qdoms'};
$_[0]->{'qdomsmode'} = $self->{'in_hash'}->{'qdomsmode'};
$_[0]->{'mailers'} = $self->{'in_hash'}->{'mailers'};
$_[0]->{'access'} = $self->{'in_hash'}->{'access'};
$_[0]->{'domains'} = $self->{'in_hash'}->{'domains'};
$_[0]->{'stop'} = $self->{'in_hash'}->{'stop'};
$_[0]->{'vmode'} = $self->{'in_hash'}->{'vmode'};
$_[0]->{'vaddrs'} = $self->{'in_hash'}->{'vmode'} == 2 ? $self->{'in_hash'}->{'vaddrs'} : "";
$_[0]->{'vmax'} = $self->{'in_hash'}->{'vmax_def'} ? undef : $self->{'in_hash'}->{'vmax'};
foreach $i (0..2) {
	$_[0]->{"vedit_$i"} = $self->{'in_hash'}->{"vedit_$i"};
	}
$_[0]->{'amode'} = $self->{'in_hash'}->{'amode'};
$_[0]->{'aliases'} = $self->{'in_hash'}->{'amode'} == 2 ? $self->{'in_hash'}->{'aliases'} : "";
$_[0]->{'amax'} = $self->{'in_hash'}->{'amax_def'} ? undef : $self->{'in_hash'}->{'amax'};
$_[0]->{'apath'} = $self->{'in_hash'}->{'apath'};
foreach $i (1..6) {
	$_[0]->{"aedit_$i"} = $self->{'in_hash'}->{"aedit_$i"};
	}
$_[0]->{'omode'} = $self->{'in_hash'}->{'omode'};
$_[0]->{'oaddrs'} = $self->{'in_hash'}->{'omode'} == 2 ? $self->{'in_hash'}->{'oaddrs'} : "";
$_[0]->{'flushq'} = $self->{'in_hash'}->{'flushq'};
$_[0]->{'smode'} = $self->{'in_hash'}->{'smode'};
$_[0]->{'saddrs'} = $self->{'in_hash'}->{'smode'} == 2 ? $self->{'in_hash'}->{'saddrs'} : "";
}


1;

