#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several spam control rules

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'sdelete_err'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'vfile'} = $self->access_file($self->{'conf'});
($self->{'vdbm'}, $self->{'vdbmtype'}) = $self->access_dbm($self->{'conf'});

# Find and validate
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'adelete_enone'});
@{$self->{'virts_array'}} = $self->list_access($self->{'vfile'});
foreach $d (@d) {
	($virt) = grep { $_->{'from'} eq $d } @{$self->{'virts_array'}};
	$self->can_edit_access($virt) || $self->error($self->text('sdelete_ecannot', $d));
	if ($virt) {
		push(@{$self->{'delvirts_array'}}, $virt);
		}
	}

# Delete the rules
$self->lock_file($self->{'vfile'});
foreach $virt (@{$self->{'delvirts_array'}}) {
	$self->delete_access($virt, $self->{'vfile'}, $self->{'vdbm'}, $self->{'vdbmtype'});
	}
$self->unlock_file($self->{'vfile'});

$self->webmin_log("delete", "accesses", scalar(@{$self->{'delvirts_array'}}));
$self->redirect("list_access.cgi");

1;
		
}


1;

