#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several mail aliases

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'adelete_err'});
$self->{'access_hash'}->{'amode'} > 0 || $self->error($self->{'text_hash'}->{'asave_ecannot2'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'afile'} = $self->aliases_file($self->{'conf'});

# Find and validate
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'adelete_enone'});
@{$self->{'aliases_array'}} = $self->list_aliases($self->{'afile'});
foreach $d (@d) {
	($alias) = grep { $_->{'name'} eq $d } @{$self->{'aliases_array'}};
	if ($alias) {
		$self->can_edit_alias($alias) || $self->error($self->text('adelete_ecannot', $d));
		push(@{$self->{'delaliases_array'}}, $alias);
		}
	}

# Delete the aliases
$self->lock_alias_files($self->{'afile'});
foreach $alias (@{$self->{'delaliases_array'}}) {
	$self->delete_alias($alias);
	}
$self->unlock_alias_files($self->{'afile'});

$self->webmin_log("delete", "aliases", scalar(@{$self->{'delaliases_array'}}));
$self->redirect("list_aliases.cgi");

1;
		
}


1;

