#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_file.cgi
# Display the contents of a file for editing

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->error_setup($self->{'text_hash'}->{'file_err'});
$self->{'access_hash'}->{'manual'} || $self->error($self->{'text_hash'}->{'file_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_sendmailcf();
if ($self->{'in_hash'}->{'mode'} eq 'aliases') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::AliasesLib");
$self = new sendmail::AliasesLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->aliases_file($self->{'conf'})->[$self->{'in_hash'}->{'idx'}];
	$self->{'return'} = "list_aliases.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'aliases_return'};
	$self->{'access_hash'}->{'amode'} == 1 && $self->{'access_hash'}->{'aedit_1'} && $self->{'access_hash'}->{'aedit_2'} &&
	    $self->{'access_hash'}->{'aedit_3'} && $self->{'access_hash'}->{'aedit_4'} && $self->{'access_hash'}->{'aedit_5'} &&
	    $self->{'access_hash'}->{'amax'} == 0 && $self->{'access_hash'}->{'apath'} eq '/' ||
	    $self->error($self->{'text_hash'}->{'file_ealiases'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'virtusers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::VirtusersLib");
$self = new sendmail::VirtusersLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->virtusers_file($self->{'conf'});
	$self->{'return'} = "list_virtusers.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'virtusers_return'};
	$self->{'access_hash'}->{'vmode'} == 1 && $self->{'access_hash'}->{'vedit_0'} && $self->{'access_hash'}->{'vedit_1'} &&
	    $self->{'access_hash'}->{'vedit_2'} && $self->{'access_hash'}->{'vmax'} == 0 ||
	    $self->error($self->{'text_hash'}->{'file_evirtusers'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'mailers') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::MailersLib");
$self = new sendmail::MailersLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->mailers_file($self->{'conf'});
	$self->{'return'} = "list_mailers.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'mailers_return'};
	$self->{'access_hash'}->{'mailers'} || $self->error($self->{'text_hash'}->{'file_emailers'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'generics') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::GenericsLib");
$self = new sendmail::GenericsLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->generics_file($self->{'conf'});
	$self->{'return'} = "list_generics.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'generics_return'};
	$self->{'access_hash'}->{'omode'} == 1 || $self->error($self->{'text_hash'}->{'file_egenerics'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'domains') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::DomainLib");
$self = new sendmail::DomainLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->domains_file($self->{'conf'});
	$self->{'return'} = "list_domains.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'domains_return'};
	$self->{'access_hash'}->{'domains'} || $self->error($self->{'text_hash'}->{'file_edomains'});
	}
elsif ($self->{'in_hash'}->{'mode'} eq 'access') {
	&ModuleLoader::preload_module('sendmail_class', "sendmail::AccessLib");
$self = new sendmail::AccessLib:: 'sendmail_class',%$self;

	$self->{'file'} = $self->access_file($self->{'conf'});
	$self->{'return'} = "list_access.cgi";
	$self->{'rmsg'} = $self->{'text_hash'}->{'access_return'};
	$self->{'access_hash'}->{'access'} || $self->error($self->{'text_hash'}->{'file_eaccess'});
	}
else { $self->error($self->{'text_hash'}->{'file_emode'}); }

$self->ui_print_header(undef, $self->{'text_hash'}->{'file_title'}, "");
open(FILE, $self->{'file'});
@{$self->{'lines_array'}} = <FILE>;
close(FILE);

print "<b>",$self->text('file_desc', "<tt>$self->{'file'}</tt>"),"</b><p>\n";

print "<form action=save_file.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=mode value=\"$self->{'in_hash'}->{'mode'}\">\n";
print "<input type=hidden name=idx value=\"$self->{'in_hash'}->{'idx'}\">\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'file_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer($self->{'return'}, $self->{'rmsg'});

1;
		
}


1;

