#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_masq.cgi
# List domains for which masquerading is done

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->{'access_hash'}->{'masq'} || $self->error($self->{'text_hash'}->{'masq_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'masq_title'}, "");
$self->{'conf'} = $self->get_sendmailcf();

# Get the domain we masquerade as
foreach $d ($self->find_type("D", $self->{'conf'})) {
	if ($d->{'value'} =~ /^M\s*(\S*)/) { $self->{'masq'} = $1; }
	}

# Get masquerading domains
@{$self->{'mlist_array'}} = $self->get_file_or_config($self->{'conf'}, "M");

# Get non-masqueraded domains
@{$self->{'nlist_array'}} = $self->get_file_or_config($self->{'conf'}, "N");

print "<form method=post action=save_masq.cgi enctype=multipart/form-data>\n";
print "<b>$self->{'text_hash'}->{'masq_domain'}</b>\n";
print "<input name=masq size=30 value=\"$self->{'masq'}\"><br>\n";

print "<table cellpadding=5 width=100%><tr><td valign=top nowrap>\n";
print "<b>$self->{'text_hash'}->{'masq_domains'}</b><br>\n";
print "<textarea name=mlist rows=8 cols=65>",
	join("\n", @{$self->{'mlist_array'}}),"</textarea><br>\n";
print "<b>$self->{'text_hash'}->{'masq_ndomains'}</b><br>\n";
print "<textarea name=nlist rows=7 cols=65>",
	join("\n", @{$self->{'nlist_array'}}),"</textarea><br>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\">\n";

print "</td><td valign=top>\n";
print $self->text('masq_desc1', 'list_generics.cgi'),"<p>\n";
print $self->{'text_hash'}->{'masq_desc2'},"\n";
print "</td></tr></table>\n";
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

