#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_cws.cgi
# Save sendmail.cw list

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

$self->ReadParseMime();
$self->{'access_hash'}->{'cws'} || $self->error($self->{'text_hash'}->{'cws_ecannot'});
$self->error_setup($self->{'text_hash'}->{'cws_err'});

$self->lock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->{'conf'} = $self->get_sendmailcf();
$self->get_file_or_config($self->{'conf'}, "w", undef, \$self->{'cwfile'});
$self->lock_file($self->{'cwfile'}) if ($self->{'cwfile'});
@{$self->{'dlist_array'}} = split(/\s+/, $self->{'in_hash'}->{'dlist'});
foreach $d (@{$self->{'dlist_array'}}) {
	$d =~ /^[A-z0-9\-\.]+$/ ||
		$self->error($self->text('cws_ehost', $d));
	}
@{$self->{'dlist_array'}} = $self->unique(@{$self->{'dlist_array'}});

$self->save_file_or_config($self->{'conf'}, "w", \@{$self->{'dlist_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'cwfile'}) if ($self->{'cwfile'});
$self->unlock_file($self->{'config_hash'}->{'sendmail_cf'});
$self->restart_sendmail();

$self->webmin_log("cws");
$self->redirect("");

1;
		
}


1;

