#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_domain.cgi
# Save, create or delete an address mapping

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::DomainLib");
$self = new sendmail::DomainLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'domains'} || $self->error($self->{'text_hash'}->{'dsave_ecannot'});
$self->{'conf'} = $self->get_sendmailcf();
$self->{'dfile'} = $self->domains_file($self->{'conf'});
$self->lock_file($self->{'dfile'});
($self->{'ddbm'}, $self->{'ddbmtype'}) = $self->domains_dbm($self->{'conf'});
@{$self->{'doms_array'}} = $self->list_domains($self->{'dfile'});
if (!$self->{'in_hash'}->{'new'}) { $self->{'d'} = $self->{'doms_array'}->[$self->{'in_hash'}->{'num'}]; }
foreach $du (@{$self->{'doms_array'}}) { $self->{'already_hash'}->{$du->{'from'}}++; }

if ($self->{'in_hash'}->{'delete'}) {
	# delete some mapping
	$self->{'logd'} = $self->{'d'};
	$self->delete_domain($self->{'d'}, $self->{'dfile'}, $self->{'ddbm'}, $self->{'ddbmtype'});
	}
else {
	# Saving or creating.. check inputs
	$self->error_setup($self->{'text_hash'}->{'dsave_err'});
	$self->{'in_hash'}->{'from'} =~ /^[A-z0-9\.\-]+$/ ||
		$self->error($self->text('dsave_edomain', $self->{'in_hash'}->{'from'}));
	$self->{'in_hash'}->{'to'} =~ /^[A-z0-9\.\-]+$/ ||
		$self->error($self->text('dsave_edomain', $self->{'in_hash'}->{'to'}));
	if ($self->{'in_hash'}->{'new'} || lc($self->{'in_hash'}->{'from'}) ne lc($self->{'d'}->{'from'})) {
		($self->{'same'}) = grep { lc($_->{'from'}) eq lc($self->{'in_hash'}->{'from'}) }
			       @{$self->{'doms_array'}};
		$self->{'same'} && $self->error($self->text('dsave_ealready', $self->{'in_hash'}->{'from'}));
		}
	$self->{'newd_hash'}->{'from'} = $self->{'in_hash'}->{'from'};
	$self->{'newd_hash'}->{'to'} = $self->{'in_hash'}->{'to'};
	$self->{'newd_hash'}->{'cmt'} = $self->{'in_hash'}->{'cmt'};
	if ($self->{'in_hash'}->{'new'}) { $self->create_domain(\%{$self->{'newd_hash'}}, $self->{'dfile'}, $self->{'ddbm'}, $self->{'ddbmtype'}); }
	else { $self->modify_domain($self->{'d'}, \%{$self->{'newd_hash'}}, $self->{'dfile'}, $self->{'ddbm'}, $self->{'ddbmtype'}); }
	$self->{'logd'} = \%{$self->{'newd_hash'}};
	}
$self->unlock_file($self->{'dfile'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    "domain", $self->{'logd'}->{'from'}, $self->{'logd'});
$self->redirect("list_domains.cgi");

1;
		
}


1;

