#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_feature.cgi
# Add a new line to the M4 file

&ModuleLoader::preload_module('sendmail_class', "sendmail::SendmailLib");
$self = new sendmail::SendmailLib:: 'sendmail_class',%$self;

&ModuleLoader::preload_module('sendmail_class', "sendmail::FeaturesLib");
$self = new sendmail::FeaturesLib:: 'sendmail_class',%$self;

$self->ReadParse();
$self->{'features_access'} || $self->error($self->{'text_hash'}->{'features_ecannot'});
$self->error_setup($self->{'text_hash'}->{'feature_err'});

@{$self->{'features_array'}} = $self->list_features();
if ($self->{'in_hash'}->{'new'}) {
	$self->{'feature'} = { 'type' => $self->{'in_hash'}->{'type'} };
	}
else {
	$self->{'feature'} = $self->{'features_array'}->[$self->{'in_hash'}->{'idx'}];
	}

$self->lock_file($self->{'config_hash'}->{'sendmail_mc'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete this entry
	$self->delete_feature($self->{'feature'});
	}
else {
	# Validate and store inputs
	if ($self->{'feature'}->{'type'} == 0) {
		$self->{'feature'}->{'text'} = $self->{'in_hash'}->{'text'};
		}
	elsif ($self->{'feature'}->{'type'} == 1) {
		#local ($same) = grep { $_->{'type'} == 1 &&
		#		       $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'features_array'}};
		#$same && ($self->{'in_hash'}->{'new'} || $self->{'feature'}->{'name'} ne $self->{'in_hash'}->{'name'}) &&
		#	$self->error($self->text('feature_efeat', "<tt>$self->{'in_hash'}->{'name'}</tt>"));
		$self->{'feature'}->{'name'} = $self->{'in_hash'}->{'name'};
		local @v;
		for($i=0; defined($self->{'in_hash'}->{"value_$i"}); $i++) {
			push(@v, $self->{'in_hash'}->{"value_$i"});
			}
		while($v[$#v] eq '' && @v) { pop(@v); }
		$self->{'feature'}->{'values'} = \@v;
		}
	elsif ($self->{'feature'}->{'type'} == 2 || $self->{'feature'}->{'type'} == 3) {
		local ($same) = grep { ($_->{'type'} == 2 || $_->{'type'} == 3) &&
				       $_->{'name'} eq $self->{'in_hash'}->{'name'} } @{$self->{'features_array'}};
		$same && ($self->{'in_hash'}->{'new'} || $self->{'feature'}->{'name'} ne $self->{'in_hash'}->{'name'}) &&
			$self->error($self->text('feature_edef', "<tt>$self->{'in_hash'}->{'name'}</tt>"));
		$self->{'feature'}->{'name'} = $self->{'in_hash'}->{'name'};
		if ($self->{'in_hash'}->{'undef'}) {
			$self->{'feature'}->{'type'} = 3;
			}
		else {
			$self->{'feature'}->{'type'} = 2;
			$self->{'feature'}->{'value'} = $self->{'in_hash'}->{'value'};
			}
		}
	elsif ($self->{'feature'}->{'type'} == 4) {
		local ($same) = grep { $_->{'type'} == 4 &&
				       $_->{'mailer'} eq $self->{'in_hash'}->{'mailer'} } @{$self->{'features_array'}};
		$same && ($self->{'in_hash'}->{'new'} || $self->{'feature'}->{'mailer'} ne $self->{'in_hash'}->{'mailer'}) &&
			$self->error($self->text('feature_emailer', "<tt>$self->{'in_hash'}->{'mailer'}</tt>"));
		$self->{'feature'}->{'mailer'} = $self->{'in_hash'}->{'mailer'};
		}
	elsif ($self->{'feature'}->{'type'} == 5) {
		local ($same) = grep { $_->{'type'} == 5 } @{$self->{'features_array'}};
		$same && $self->{'in_hash'}->{'new'} &&
			$self->error($self->text('feature_eostype', "<tt>$self->{'in_hash'}->{'ostype'}</tt>"));
		$self->{'feature'}->{'ostype'} = $self->{'in_hash'}->{'ostype'};
		}

	# Save or create the entry
	if ($self->{'in_hash'}->{'new'}) {
		$self->create_feature($self->{'feature'});
		}
	else {
		$self->modify_feature($self->{'feature'});
		}
	}

$self->unlock_file($self->{'config_hash'}->{'sendmail_mc'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? 'create' : $self->{'in_hash'}->{'delete'} ? 'delete' : 'modify',
	    "feature", undef, $self->{'feature'});
$self->redirect("list_features.cgi");

1;
		
}


1;

