#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display icons for portsentry, hostsentry and logcheck options

&ModuleLoader::preload_module('sentry_class', "sentry::SentryLib");
$self = new sentry::SentryLib:: 'sentry_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1);

# Find out which programs are installed
if (!$self->has_command($self->{'config_hash'}->{'portsentry'}) &&
    !-r $self->{'config_hash'}->{'hostsentry'} &&
    !$self->has_command($self->{'config_hash'}->{'logcheck'})) {
	# None are ..
	print "<p>",$self->text('index_ecommands',
			  "<tt>$self->{'config_hash'}->{'portsentry'}</tt>",
			  "<tt>$self->{'config_hash'}->{'hostsentry'}</tt>",
			  "<tt>$self->{'config_hash'}->{'logcheck'}</tt>",
			  "$self->{'gconfig_hash'}->{'webprefix'}/config.cgi?$self->{'module_name'}"),"<p>\n";
	}
else {
	# Show icons
	@{$self->{'links_array'}} = ( "edit_portsentry.cgi", "edit_hostsentry.cgi",
		   "edit_logcheck.cgi" );
	@{$self->{'titles_array'}} = ( "$self->{'text_hash'}->{'portsentry_title'}<br>$self->{'text_hash'}->{'portsentry_below'}",
		    "$self->{'text_hash'}->{'hostsentry_title'}<br>$self->{'text_hash'}->{'hostsentry_below'}",
		    "$self->{'text_hash'}->{'logcheck_title'}<br>$self->{'text_hash'}->{'logcheck_below'}" );
	@{$self->{'icons_array'}} = ( "images/portsentry.gif", "images/hostsentry.gif",
		   "images/logcheck.gif" );
	$self->icons_table(\@{$self->{'links_array'}}, \@{$self->{'titles_array'}}, \@{$self->{'icons_array'}});
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

