#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_export.cgi
# Display a form for editing or creating an export

&ModuleLoader::preload_module('sgiexports_class', "sgiexports::SgiexportsLib");
$self = new sgiexports::SgiexportsLib:: 'sgiexports_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->header($self->{'text_hash'}->{'edit_title1'}, "");
	}
else {
	$self->header($self->{'text_hash'}->{'edit_title2'}, "");
	@{$self->{'exports_array'}} = $self->get_exports();
	$self->{'export'} = $self->{'exports_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'opts'} = $self->{'export'}->{'opts'};
	}
print "<hr>\n";

print "<form action=save_export.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_dir'}</b></td>\n";
printf "<td colspan=3><input name=dir size=40 value='%s'> %s</td> </tr>\n",
	$self->{'export'}->{'dir'}, $self->file_chooser_button("dir", 1);

print "<tr> <td><b>$self->{'text_hash'}->{'edit_hosts'}</b></td>\n";
printf "<td colspan=3><input name=hosts size=50 value='%s'></td> </tr>\n",
	join(" ", @{$self->{'export'}->{'hosts'}});

print "<tr> <td><b>$self->{'text_hash'}->{'edit_ro'}</b></td>\n";
printf "<td><input type=radio name=ro value=1 %s> %s\n",
	defined($self->{'opts'}->{'ro'}) ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=ro value=0 %s> %s</td> </tr>\n",
	defined($self->{'opts'}->{'ro'}) ? "" : "checked", $self->{'text_hash'}->{'no'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_wsync'}</b></td>\n";
printf "<td><input type=radio name=wsync value=1 %s> %s\n",
	defined($self->{'opts'}->{'wsync'}) ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=wsync value=0 %s> %s</td> </tr>\n",
	defined($self->{'opts'}->{'wsync'}) ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'am'} = $self->{'opts'}->{'anon'} eq "-1" ? 2 : defined($self->{'opts'}->{'anon'}) ? 0 : 1;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_anon'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=anon_def value=1 %s> %s",
	$self->{'am'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_anon1'};
printf "<input type=radio name=anon_def value=2 %s> %s",
	$self->{'am'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_anon2'};
printf "<input type=radio name=anon_def value=0 %s> %s\n",
	$self->{'am'} == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_anon0'};
print $self->unix_user_input("anon", $self->{'am'} == 0 ? $self->{'opts'}->{'anon'} : ""),"</td> </tr>\n";

print "</table></td></tr></table><p>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_rw'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_root'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_access'}</b></td> </tr>\n";
print "<tr $self->{'cb'}>\n";

printf "<td><input type=radio name=rw_def value=1 %s> %s<br>\n",
	defined($self->{'opts'}->{'rw'}) ? "" : "checked", $self->{'text_hash'}->{'edit_all'};
printf "<input type=radio name=rw_def value=0 %s> %s<br>\n",
	defined($self->{'opts'}->{'rw'}) ? "checked" : "", $self->{'text_hash'}->{'edit_sel'};
print "<textarea name=rw rows=5 cols=20>",
	join("\n", split(/:/, $self->{'opts'}->{'rw'})),"</textarea></td>\n";

printf "<td><input type=radio name=root_def value=1 %s> %s<br>\n",
	defined($self->{'opts'}->{'root'}) ? "" : "checked", $self->{'text_hash'}->{'edit_none'};
printf "<input type=radio name=root_def value=0 %s> %s<br>\n",
	defined($self->{'opts'}->{'root'}) ? "checked" : "", $self->{'text_hash'}->{'edit_sel'};
print "<textarea name=root rows=5 cols=20>",
	join("\n", split(/:/, $self->{'opts'}->{'root'})),"</textarea></td>\n";

printf "<td><input type=radio name=access_def value=1 %s> %s<br>\n",
	defined($self->{'opts'}->{'access'}) ? "" : "checked", $self->{'text_hash'}->{'edit_none'};
printf "<input type=radio name=access_def value=0 %s> %s<br>\n",
	defined($self->{'opts'}->{'access'}) ? "checked" : "", $self->{'text_hash'}->{'edit_sel'};
print "<textarea name=access rows=5 cols=20>",
	join("\n", split(/:/, $self->{'opts'}->{'access'})),"</textarea></td>\n";

print "</tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

print "<hr>\n";
$self->footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

