#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit.cgi
# Display a form for editing or creating a table entry

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_create"}, "");
	if ($self->{'in_hash'}->{'before'} ne '') {
		$self->{'msg'} = $self->text('edit_before', $self->{'in_hash'}->{'before'}+1);
		}
	elsif ($self->{'in_hash'}->{'after'} ne '') {
		$self->{'msg'} = $self->text('edit_after', $self->{'in_hash'}->{'after'}+1);
		}
	print "<center><font size=+1>$self->{'msg'}</font></center>\n" if ($self->{'msg'});
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_edit"}, "");
	$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
	$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
	@{$self->{'table_array'}} = $self->read_table_file($self->{'in_hash'}->{'table'}, $self->{'pfunc'});
	$self->{'row'} = $self->{'table_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print "<form action=save.cgi>\n";
print "<input type=hidden name=table value='$self->{'in_hash'}->{'table'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=before value='$self->{'in_hash'}->{'before'}'>\n";
print "<input type=hidden name=after value='$self->{'in_hash'}->{'after'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>",$self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_header"},"</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'ffunc'} = $self->{'in_hash'}->{'table'}."_form";
do { my $fn = $self->{'ffunc'}; $self->$fn(@{$self->{'row'}})};

print "</table></td></tr></table>\n";
print "<table width=100%>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</table>\n";

print "</form>\n";

$self->ui_print_footer("list.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_return"});

1;
		
}


1;

