#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing or creating a comment

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{"comment_create"}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{"comment_edit"}, "");
	$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
	$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
	@{$self->{'table_array'}} = $self->read_table_file($self->{'in_hash'}->{'table'}, $self->{'pfunc'});
	$row = $self->{'table_array'}->[$self->{'in_hash'}->{'idx'}];
	}

print $self->ui_form_start("savecmt.cgi", "post");
foreach $f ("table", "new", "idx") {
	print $self->ui_hidden($f, $self->{'in_hash'}->{$f});
	}
print $self->ui_table_start($self->{'text_hash'}->{'comment_header'}, 2);

print $self->ui_table_row($self->{'text_hash'}->{'comment_msg'},
		    $self->ui_textbox("msg", join(" ", @$row[1..@$row-1]), 60));

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}

$self->ui_print_footer("list.cgi?table=$self->{'in_hash'}->{'table'}", $self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_return"});

1;
		
}


1;

