#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save.cgi
# Updated, modify or delete a table entry

&ModuleLoader::preload_module('shorewall_class', "shorewall::ShorewallLib");
$self = new shorewall::ShorewallLib:: 'shorewall_class',%$self;

$self->ReadParse();
$self->can_access($self->{'in_hash'}->{'table'}) || $self->error($self->{'text_hash'}->{'list_ecannot'});
$self->{'pfunc'} = $self->{'in_hash'}->{'table'}."_parser";
$self->{'pfunc'} = "standard_parser" if (!$self->UNIVERSAL::can($self->{'pfunc'}));
$self->error_setup($self->{'text_hash'}->{$self->{'in_hash'}->{'table'}."_err"});

$self->lock_table($self->{'in_hash'}->{'table'});
if ($self->{'in_hash'}->{'delete'}) {
	# Just delete one row
	$self->delete_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'in_hash'}->{'idx'});
	}
else {
	# Validate inputs
	$self->{'vfunc'} = $self->{'in_hash'}->{'table'}."_validate";
	@{$self->{'row_array'}} = do { my $fn = $self->{'vfunc'}; $self->$fn()};
	$self->{'jfunc'} = $self->{'in_hash'}->{'table'}."_join";
	if ($self->UNIVERSAL::can($self->{'jfunc'})) {
		$self->{'line'} = do { my $fn = $self->{'jfunc'}; $self->$fn(@{$self->{'row_array'}})};
		}
	else {
		$self->{'line'} = join("\t", @{$self->{'row_array'}});
		}

	# Update or add
	if ($self->{'in_hash'}->{'new'}) {
		local $where = $self->{'in_hash'}->{'before'} ne '' ? $self->{'in_hash'}->{'before'} :
			       $self->{'in_hash'}->{'after'} ne '' ? $self->{'in_hash'}->{'after'}+1 : undef;
		$self->create_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'line'}, $where);
		}
	else {
		# Updating 
		$self->modify_table_row($self->{'in_hash'}->{'table'}, $self->{'pfunc'}, $self->{'in_hash'}->{'idx'}, $self->{'line'});
		}
	}
$self->unlock_table($self->{'in_hash'}->{'table'});
$self->webmin_log($self->{'in_hash'}->{'new'} ? "create" : $self->{'in_hash'}->{'delete'} ? "delete" : "modify",
	    "table", $self->{'in_hash'}->{'table'});
$self->redirect("list.cgi?table=$self->{'in_hash'}->{'table'}");

1;
		
}


1;

