#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search instance 
# Display a form for searching for a service using keywords/browse

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();

$self->{'got_results'} = -1;
$self->{'original_searchstring'} = "";
$self->{'searchstring'} = "";
# get search term
if (defined($self->{'in_hash'}->{'searchstring'})) {
	$self->{'original_searchstring'} = $self->{'in_hash'}->{'searchstring'};
	$self->{'searchstring'} = $self->{'in_hash'}->{'searchstring'};
	if ($self->{'searchstring'} =~ /svc:\/.*/) {
		$self->{'searchstring'} = "$self->{'searchstring'}";
	} elsif ($self->{'searchstring'} =~ /.+/) {
		$self->{'searchstring'} = "\*$self->{'searchstring'}";
		}
	@{$self->{'svcs_info_array'}} = $self->svcs_listing("$self->{'searchstring'}");
	if (@{$self->{'svcs_info_array'}} > 0) {
		$self->{'got_results'} = 1;
	} else {
		$self->{'got_results'} = 0;
		}
		
}

$self->ui_print_header(undef, $self->{'text_hash'}->{'search_instance_title'}, "", undef);

print "<h2>";
$self->text_and_whats_this("search_instance_detail");
print "</h2>";

print "<form  method=\"POST\" action=\"search_instance.cgi\">\n";
print
    "<input size=60 name=\"searchstring\" value=\"$self->{'original_searchstring'}\">\n";
$self->print_svc_chooser("searchstring", 0, "$self->{'text_hash'}->{'search_instance_browse'}",
	"both", "0");
print "&nbsp;<input type=submit value=\"$self->{'text_hash'}->{'search_instance_go'}\">\n";
print "</form>\n";
if ($self->{'got_results'} == 1) {
	print "<hr>\n";
	for $svc_info (@{$self->{'svcs_info_array'}}) {
		$self->{'fmri'} = $svc_info->{'FMRI'};
		print "<p>\n";
		print "<a href=\"instance_viewer.cgi?fmri='$self->{'fmri'}'\">$self->{'fmri'}</a>";
		print "</p>\n";
		}
} elsif ($self->{'got_results'} == 0) {
	print "<hr>\n";
	print "<p>$self->{'text_hash'}->{'search_instance_noresults'}</p>\n";
	}

$self->print_cmds_run();

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});

1;
		
}


1;

