#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here
$self->wizard_header($self->{'wizard'}, "smfwizard_exec.cgi",
	"$self->{'text_hash'}->{'smfwizard_exec_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_exec_description'}"),
	"images/smf.gif");

@{$self->{'sinst_list_array'}} = ("service");
# add existing instances to list...
@{$self->{'existing_insts_array'}} = $self->wizard_get_data_values("smfwizard_instance.cgi",
	"instance_name");
@{$self->{'sinst_list_array'}}= (@{$self->{'sinst_list_array'}}, @{$self->{'existing_insts_array'}});

$self->wizard_select("smfwizard_exec.cgi", "$self->{'text_hash'}->{'smfwizard_sinst_name'}",
	"sinst", \@{$self->{'sinst_list_array'}}, ".+", "$self->{'text_hash'}->{'smfwizard_sinst_error'}");
$self->wizard_input("smfwizard_exec.cgi", "$self->{'text_hash'}->{'smfwizard_exec_name'}",
	"exec_name", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_exec_name_error'}");
$self->wizard_input("smfwizard_exec.cgi", "$self->{'text_hash'}->{'smfwizard_exec_timeout'}",
	"exec_timeout", 20, "[0-9]+",
	"$self->{'text_hash'}->{'smfwizard_exec_timeout_error'}");
$self->wizard_input("smfwizard_exec.cgi",
	"$self->{'text_hash'}->{'smfwizard_exec_exec'}", "exec_exec",
	60, ".+", "$self->{'text_hash'}->{'smfwizard_exec_exec_error'}");
$self->wizard_input("smfwizard_exec.cgi",
	"$self->{'text_hash'}->{'smfwizard_exec_user'}", "exec_user",
	60, ".*", "$self->{'text_hash'}->{'smfwizard_exec_user_error'}");
$self->wizard_input("smfwizard_exec.cgi",
	"$self->{'text_hash'}->{'smfwizard_exec_group'}", "exec_group",
	60, ".*", "$self->{'text_hash'}->{'smfwizard_exec_group_error'}");
$self->wizard_input("smfwizard_exec.cgi",
	"$self->{'text_hash'}->{'smfwizard_exec_privileges'}", "exec_privileges",
	60, ".*", "$self->{'text_hash'}->{'smfwizard_exec_privileges_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_exec.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});
1;
		
}


1;

