#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here
$self->wizard_header($self->{'wizard'}, "smfwizard_property.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_property_description'}"),
	"images/smf.gif");

@{$self->{'sinst_list_array'}} = ("service");
# add existing instances to list...
@{$self->{'existing_insts_array'}} = $self->wizard_get_data_values("smfwizard_instance.cgi",
	"instance_name");
@{$self->{'sinst_list_array'}}= (@{$self->{'sinst_list_array'}}, @{$self->{'existing_insts_array'}});
@{$self->{'pgroup_list_array'}} = $self->wizard_get_data_values("smfwizard_property_group.cgi",
	"property_group_name");
$self->wizard_select("smfwizard_property.cgi", "$self->{'text_hash'}->{'smfwizard_sinst_name'}",
	"sinst", \@{$self->{'sinst_list_array'}}, ".+", "$self->{'text_hash'}->{'smfwizard_sinst_error'}");
$self->wizard_select("smfwizard_property.cgi", "$self->{'text_hash'}->{'smfwizard_pgroup_name'}",
	"pgroup", \@{$self->{'pgroup_list_array'}}, ".+", "$self->{'text_hash'}->{'smfwizard_pgroup_name_error'}");

$self->wizard_input("smfwizard_property.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_name'}",
	"property_name", 60, ".+",
	"$self->{'text_hash'}->{'smfwizard_property_name_error'}");
$self->wizard_select("smfwizard_property.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_type'}",
	"property_type", \@{$self->{'propval_type_values_array'}}, ".+",
	"$self->{'text_hash'}->{'smfwizard_property_type_error'}");
$self->wizard_input("smfwizard_property.cgi",
	"$self->{'text_hash'}->{'smfwizard_property_value'}", "property_value",
	60, ".*", "$self->{'text_hash'}->{'smfwizard_property_value_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_property.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});
1;
		
}


1;

