#!/usr/bin/perl

&MAIN();

 sub MAIN {

&ModuleLoader::preload_module('smf_class', "smf::SmfLib");
$self = new smf::SmfLib:: 'smf_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'smfwizard_title'}, "");

# wizard-specific info here!

if (defined($self->{'in_hash'}->{'clearout'})) {
	if ($self->{'in_hash'}->{'clearout'} == 1) {
		$self->wizard_clear_all_data($self->{'wizard'});
		}
	}
$self->wizard_header($self->{'wizard'}, "smfwizard_service.cgi",
	"$self->{'text_hash'}->{'smfwizard_service_heading'}",
	$self->convert_links_in_text("$self->{'text_hash'}->{'smfwizard_service_description'}"),
	"images/smf.gif");
$self->wizard_input("smfwizard_service.cgi", "$self->{'text_hash'}->{'smfwizard_service_name'}",
	"service_name", 60, ".+", "$self->{'text_hash'}->{'smfwizard_service_name_error'}");
$self->wizard_input("smfwizard_service.cgi", "$self->{'text_hash'}->{'smfwizard_service_version'}",
	"service_version", 60, "\s*[0-9]+\s*",
	"$self->{'text_hash'}->{'smfwizard_service_version_error'}");

$self->wizard_footer($self->{'wizard'}, "smfwizard_service.cgi");
# end wizard-specific info

$self->ui_print_footer("index.cgi", $self->{'text_hash'}->{'index'});

1;
		
}


1;

