#!/usr/bin/perl

&MAIN();

 sub MAIN {
# delete_packs.cgi
# Ask if the user wants to delete multiple packages, and if so do it
# XXX logging

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'deletes_err'});
foreach $d (split(/\0/, $self->{'in_hash'}->{'del'})) {
	local ($p, $v) = split(/\s/, $d);
	local @pinfo;
	(@pinfo = $self->package_info($p, $v)) ||
		$self->error($self->text('delete_epack', $p));
	push(@{$self->{'packs_array'}}, $p);
	push(@{$self->{'vers_array'}}, $v);
	push(@{$self->{'infos_array'}}, \@pinfo);
	}
@{$self->{'packs_array'}} || $self->error($self->{'text_hash'}->{'deletes_enone'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'deletes_title'}, "", "delete");

if ($self->{'in_hash'}->{'sure'}) {
	# do the deletion
	print "<p>\n";
	if ($self->UNIVERSAL::can('delete_packages')) {
		# Can just use one function
		print $self->text('deletes_desc', "<tt>".join(" ", @{$self->{'packs_array'}})."</tt>"),
		      "<p>\n";
		$self->{'error'} = $self->delete_packages(\@{$self->{'packs_array'}}, \%{$self->{'in_hash'}}, \@{$self->{'vers_array'}});
		if ($self->{'error'}) {
			print "<b>",$self->text('deletes_failed2', $self->{'error'}),"</b><p>\n";
			}
		else {
			print "$self->{'text_hash'}->{'deletes_success2'}<p>\n";
			}
		}
	else {
		# Need to use a loop
		for($i=0; $i<@{$self->{'packs_array'}}; $i++) {
			$self->{'error'} = $self->delete_package($self->{'packs_array'}->[$i], \%{$self->{'in_hash'}}, $self->{'vers_array'}->[$i]);
			if ($self->{'error'}) {
				print "<b>",$self->text('deletes_failed1', "<tt>$self->{'packs_array'}->[$i]</tt>", $self->{'error'}),"</b><br>\n";
				}
			else {
				print $self->text('deletes_success1', "<tt>$self->{'packs_array'}->[$i]</tt>"),"<br>\n";
				}
			}
		}
	$self->webmin_log("deletes", "package", undef, { 'packs' => \@{$self->{'packs_array'}} });
	}
else {
	# Ask if the user is sure..
	print "<center>\n";
	print $self->text('deletes_rusure', "<tt>".join(" ", @{$self->{'packs_array'}})."</tt>"),
	      "<p>\n";
	print "<form action=delete_packs.cgi method=post>\n";
	foreach $d (split(/\0/, $self->{'in_hash'}->{'del'})) {
		print "<input type=hidden name=del value='$d'>\n";
		}
	print "<input type=hidden name=sure value=1>\n";
	print "<input type=hidden name=search value=\"$self->{'in_hash'}->{'search'}\">\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'deletes_ok'}\"><p>\n";
	if ($self->UNIVERSAL::can('delete_options')) {
		$self->delete_options($self->{'packs_array'}->[0]);
		}
	print "</center></form>\n";

	}

$self->ui_print_footer("search.cgi?search=$self->{'in_hash'}->{'search'}", $self->{'text_hash'}->{'search_return'});

1;
		
}


1;

