#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form in a popup window for selecting a package from the update system

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

$self->popup_header($self->{'text_hash'}->{'find_title'});
print <<EOF;
<script>
function sel(m)
{
window.opener.ifield.value = m;
window.close();
return false;
}
</script>
EOF

# Show form for searching
print $self->ui_form_start("find.cgi");
print $self->ui_submit($self->{'text_hash'}->{'find_search'}),"\n";
print $self->ui_textbox("search", $self->{'in_hash'}->{'search'}, 20),"\n";
print $self->ui_form_end();

# Show results, if any
$self->{'search'} = $self->{'in_hash'}->{'search'};
if ($self->{'search'}) {
	if ($self->UNIVERSAL::can('update_system_search')) {
		# Call the search function
		@{$self->{'avail_array'}} = $self->update_system_search($self->{'search'});
		}
	else {
		# Scan through list manually
		@{$self->{'avail_array'}} = $self->update_system_available();
		@{$self->{'avail_array'}} = grep { $_->{'name'} =~ /\Q$self->{'search'}\E/i ||
				$_->{'desc'} =~ /\Q$self->{'search'}\E/i } @{$self->{'avail_array'}};
		}
	@{$self->{'avail_array'}} = sort { lc($a->{'name'}) cmp lc($b->{'name'}) } @{$self->{'avail_array'}};

	if (@{$self->{'avail_array'}}) {
		$self->{'hasdesc'} = $self->{'avail_array'}->[0]->{'desc'};
		$self->{'hasver'} = $self->{'avail_array'}->[0]->{'version'};
		print $self->ui_columns_start(
			[ $self->{'text_hash'}->{'find_name'},
			  $self->{'hasver'} ? ($self->{'text_hash'}->{'find_version'}) : ( ),
			  $self->{'hasdesc'} ? ($self->{'text_hash'}->{'find_desc'}) : ( ) ], "100%");
		foreach $a (@{$self->{'avail_array'}}) {
			$self->{'sel'} = $a->{'select'} || $a->{'name'};
			$self->{'epoch'} = $a->{'epoch'} ? "$a->{'epoch'}:" : "";
			print $self->ui_columns_row(
				[ "<a href='' onClick='sel(\"$self->{'sel'}\")'>$a->{'name'}</a>",
				  $self->{'hasver'} ? ($self->{'epoch'}.$a->{'version'}) : ( ),
				  $self->{'hasdesc'} ? ($a->{'desc'}) : ( ) ]);
			}
		print $self->ui_columns_end();
		}
	else {
		print "<b>$self->{'text_hash'}->{'find_none'}</b><p>\n";
		}
	}

$self->popup_footer();

1;
		
}


1;

