#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Lists all installed packages

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'index_title'}, "", "intro", 1, 1, 0,
	$self->help_search_link($self->UNIVERSAL::can('package_help') ? ( $self->package_help() ) : ( ),
			  "man", "doc"));

# Show package search and list forms
print "<table $self->{'cb'} width=100%>\n<tr $self->{'tb'}><td colspan=\"2\">";
print "<b>".$self->{'text_hash'}->{'index_installed'},"</b>";
print "</td></tr>\n<tr>";
print "<form action=search.cgi>\n";
print "<td><input type=submit value=\"$self->{'text_hash'}->{'index_search'}\">\n";
print "<input name=search size=30><input type=hidden name=goto value=1></td>\n";
print "</form>\n";

print "<form action=tree.cgi>\n";
print "<td align=right><input type=submit value='$self->{'text_hash'}->{'index_tree'}'></td>\n";
print "</form></tr></table>\n";

# Show form to install a new package
print "<hr>\n";
print "<table $self->{'cb'} width=100%>\n<tr $self->{'tb'}><td>";
print "<b>".$self->{'text_hash'}->{'index_install'},"</b>";
print "</td></tr>\n<tr><td>";
print $self->text('index_installmsg', $self->package_system()),"<p>";
print "</td></tr>\n<tr><td>";

$self->{'upid'} = time().$$;
print $self->ui_form_start("install_pack.cgi?id=$self->{'upid'}", "form-data", undef,
		     $self->read_parse_mime_javascript($self->{'upid'}, [ "upload" ])),"\n";
print $self->ui_oneradio("source", 0, $self->{'text_hash'}->{'index_local'}, 1),"\n",
      $self->ui_textbox("local", undef, 50),"\n",
      $self->file_chooser_button("local", 0, 2); 
print "</td></tr>\n<tr><td>";

print $self->ui_oneradio("source", 1, $self->{'text_hash'}->{'index_uploaded'}, 0),"\n",
      $self->ui_upload("upload", 20),"<br>\n";
print "</td></tr>\n<tr><td>";
print $self->ui_oneradio("source", 2, $self->{'text_hash'}->{'index_ftp'}, 0),"\n",
      $self->ui_textbox("url", undef, 50),"\n";
print $self->search_system_input() if ($self->{'has_search_system'});
print "<tr><td>";

if ($self->{'has_update_system'}) {
	print $self->ui_oneradio("source", 3, $self->{'text_hash'}->{$self->{'update_system'}.'_input'}, 0),"\n",
	      $self->ui_textbox("update", undef, 30),"\n",
	      $self->update_system_button("update", $self->{'text_hash'}->{$self->{'update_system'}.'_find'});
	if ($self->UNIVERSAL::can('show_update_system_opts') &&
	    ($self->{'opts'} = $self->show_update_system_opts())) {
		print "<br>",("&nbsp;" x 5),$self->{'opts'},"\n";
		}
	print "<br>\n";
	}
print $self->ui_submit($self->{'text_hash'}->{'index_installok'}),"\n";
print $self->ui_form_end();
print "</td></tr></table>";

# Show search form by file, if supported by package system
if (!$self->{'no_package_filesearch'}) {
	print "<hr>\n";
	print "<table $self->{'cb'} width=100%>\n<tr $self->{'tb'}><td>";
	print "<b>".$self->{'text_hash'}->{'index_ident'},"</b>";
	print "</td></tr><tr><td>";
	print $self->text('index_identmsg', $self->package_system());
	print "</td></tr>\n<tr><td>";
	print "<form action=file_info.cgi>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'index_identok'}\">\n";
	print "<input name=file size=30>\n";
	print $self->file_chooser_button("file", 0, 3);
	print "</form>\n</td></tr></table>";
	}

if ($self->{'has_update_system'} && $self->UNIVERSAL::can('update_system_form')) {
	print "<hr>\n";
	$self->update_system_form();
	}

$self->ui_print_footer("/", $self->{'text_hash'}->{'index'});

1;
		
}


1;

