#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_pack.cgi
# List all the files in some package

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();
$self->ui_print_header(undef, $self->{'text_hash'}->{'list_title'}, "", "list_pack");

print $self->ui_subheading($self->text('list_files', "<tt>$self->{'in_hash'}->{'package'}</tt>"));
print $self->ui_columns_start([
	$self->{'text_hash'}->{'list_path'},
	$self->{'text_hash'}->{'list_owner'},
	$self->{'text_hash'}->{'list_group'},
	$self->{'text_hash'}->{'list_type'},
	$self->{'text_hash'}->{'list_size'},
	$self->{'text_hash'}->{'list_status'} ], 100);
$self->{'n'} = $self->check_files($self->{'in_hash'}->{'package'}, $self->{'in_hash'}->{'version'});
@{$self->{'tds_array'}} = ( "valign=top", "valign=top", "valign=top",
	 "valign=top", "valign=top", "valign=top" );
for($i=0; $i<$self->{'n'}; $i++) {
	$self->{'sz'} = $self->{'files_hash'}->{$i,'size'};
	$self->{'ty'} = $self->{'files_hash'}->{$i,'type'};
	local @cols;
	$self->{'ls'} = "<a href=\"file_info.cgi?file=".$self->urlize($self->{'files_hash'}->{$i,'path'})."\">";
	$self->{'le'} = "</a>";
	if ($self->{'ty'} == 3 || $self->{'ty'} == 4) {
		# Hard or soft link
		push(@cols, $self->{'ls'}.$self->html_escape($self->{'files_hash'}->{$i,'path'}).
		      " -> ".$self->html_escape($self->{'files_hash'}->{$i,'link'}).$self->{'le'});
		push(@cols, "", "");
		}
	else {
		$self->{'table'} = "<table width=100% cellpadding=0 ".
		      "cellspacing=0><tr><td>$self->{'ls'}".
		      $self->html_escape($self->{'files_hash'}->{$i,'path'}).
		      "$self->{'le'}</td> <td align=right>\n";
		if ($self->{'ty'} == 0 || $self->{'ty'} == 5) {
			$self->{'table'} .= "<a href='view.cgi".
				$self->html_escape($self->{'files_hash'}->{$i,'path'}).
				"'>$self->{'text_hash'}->{'list_view'}</a>";
			}
		$self->{'table'} .= "</td></tr></table>";
		push(@cols, $self->{'table'});
		push(@cols, $self->html_escape($self->{'files_hash'}->{$i,'user'}));
		push(@cols, $self->html_escape($self->{'files_hash'}->{$i,'group'}));
		}
	push(@cols, $self->{'type_map_array'}->[$self->{'ty'}]);
	push(@cols, $self->{'ty'} != 0 ? "" : $self->nice_size($self->{'sz'}));
	$self->{'err'} = $self->{'files_hash'}->{$i,'error'};
	if ($self->{'err'}) {
		$self->{'err'} =~ s/</&lt;/g;
		$self->{'err'} =~ s/>/&gt;/g;
		$self->{'err'} =~ s/\n/<br>/g;
		push(@cols, "<font color=#ff0000>$self->{'err'}</font>");
		}
	else {
		push(@cols, $self->{'text_hash'}->{'list_ok'});
		}
	print $self->ui_columns_row(\@cols, \@{$self->{'tds_array'}});
	}
print $self->ui_columns_end();

$self->ui_print_footer("edit_pack.cgi?package=".$self->urlize($self->{'in_hash'}->{'package'}).
	"&version=".$self->urlize($self->{'in_hash'}->{'version'}), $self->{'text_hash'}->{'edit_return'},
	"tree.cgi", $self->{'text_hash'}->{'index_treturn'});

1;
		
}


1;

