#!/usr/bin/perl

&MAIN();

 sub MAIN {
# search.cgi
# Display a list of packages where the name or description matches some string

&ModuleLoader::preload_module('software_class', "software::SoftwareLib");
$self = new software::SoftwareLib:: 'software_class',%$self;

$self->ReadParse();

$self->{'in_hash'}->{'search'} || $self->error($self->{'text_hash'}->{'search_esearch'});
if ($self->UNIVERSAL::can('package_search')) {
	# Use system-specific search function
	$self->{'n'} = $self->package_search($self->{'in_hash'}->{'search'});
	@{$self->{'match_array'}} = ( 0 .. $self->{'n'}-1 ) if ($self->{'n'});
	}
else {
	# Search manually through entire list
	$self->{'n'} = $self->list_packages();
	$self->{'s'} = $self->{'in_hash'}->{'search'};
	for($i=0; $i<$self->{'n'}; $i++) {
		if ($self->{'packages_hash'}->{$i,'name'} =~ /\Q$self->{'s'}\E/i ||
		    $self->{'packages_hash'}->{$i,'desc'} =~ /\Q$self->{'s'}\E/i) {
			push(@{$self->{'match_array'}}, $i);
			}
		}
	}
if (@{$self->{'match_array'}} == 1 && $self->{'in_hash'}->{'goto'}) {
	$self->{'p'} = $self->{'packages_hash'}->{$self->{'match_array'}->[0],'name'};
	$self->{'v'} = $self->{'packages_hash'}->{$self->{'match_array'}->[0],'version'};
	$self->redirect("edit_pack.cgi?package=".$self->urlize($self->{'p'})."&version=".$self->urlize($self->{'v'}));
	exit;
	}

$self->ui_print_header(undef, $self->{'text_hash'}->{'search_title'}, "", "search");

if (@{$self->{'match_array'}}) {
	@{$self->{'match_array'}} = sort { lc($self->{'packages_hash'}->{$a,'name'}) cmp lc($self->{'packages_hash'}->{$b,'name'}) }
		      @{$self->{'match_array'}};
	print "<b>",$self->text('search_match', "<tt>$self->{'s'}</tt>"),"</b><p>\n";
	print "<form action=delete_packs.cgi method=post>\n";
	print "<input type=hidden name=search value='$self->{'in_hash'}->{'search'}'>\n";
	@{$self->{'tds_array'}} = ( "width=5" );
	@{$self->{'links_array'}} = ( $self->select_all_link("del", 0),
		   $self->select_invert_link("del", 0) );
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'search_pack'},
				  $self->{'text_hash'}->{'search_class'},
				  $self->{'text_hash'}->{'search_desc'} ], 100, 0, \@{$self->{'tds_array'}});
	foreach $i (@{$self->{'match_array'}}) {
		local @cols;
		push(@cols, "<a href=\"edit_pack.cgi?search=$self->{'s'}&package=".
		      $self->urlize($self->{'packages_hash'}->{$i,'name'})."&version=".
		      $self->urlize($self->{'packages_hash'}->{$i,'version'})."\">".$self->html_escape(
			$self->{'packages_hash'}->{$i,'name'}.($self->{'packages_hash'}->{$i,'version'} ?
			   " $self->{'packages_hash'}->{$i,'version'}" : ""))."</a>");
		$self->{'c'} = $self->{'packages_hash'}->{$i,'class'};
		push(@cols, $self->{'c'} ? $self->html_escape($self->{'c'})
				: $self->{'text_hash'}->{'search_none'});
		push(@cols, $self->html_escape($self->{'packages_hash'}->{$i,'desc'}));
		if ($self->{'packages_hash'}->{$i,'nouninstall'}) {
			print $self->ui_columns_row([ "", @cols ], \@{$self->{'tds_array'}});
			}
		else {
			print $self->ui_checked_columns_row(\@cols, \@{$self->{'tds_array'}}, "del",
			      $self->{'packages_hash'}->{$i,'name'}." ".$self->{'packages_hash'}->{$i,'version'});
			}
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print "<input type=submit value='$self->{'text_hash'}->{'search_delete'}'></form>\n";
	}
else {
	print "<b>",$self->text('search_nomatch', "<tt>$self->{'s'}</tt>"),"</b><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

