#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show simple body tests

&ModuleLoader::preload_module('spam_class', "spam::SpamLib");
$self = new spam::SpamLib:: 'spam_class',%$self;

$self->can_use_check("header");
$self->ui_print_header(undef, $self->{'text_hash'}->{'simple_title'}, "");
$self->{'conf'} = $self->get_config();

print "$self->{'text_hash'}->{'simple_desc'}<p>\n";
$self->start_form("save_simple.cgi", $self->{'text_hash'}->{'simple_header'}."\n".
		       "(<a href=edit_header.cgi>$self->{'text_hash'}->{'simple_switch'}</a>)");
print "<tr> <td>\n";

# Find the tests we can handle
@{$self->{'simples_array'}} = $self->get_simple_tests($self->{'conf'});

print $self->ui_columns_start([ $self->{'text_hash'}->{'simple_name'},
			  $self->{'text_hash'}->{'simple_for'},
			  $self->{'text_hash'}->{'simple_regexp'},
			  $self->{'text_hash'}->{'simple_score'},
			  $self->{'text_hash'}->{'simple_describe'} ], "100");
$self->{'i'} = 0;
foreach $s (@{$self->{'simples_array'}}, { }, { }, { }) {
	print $self->ui_columns_row([
		$self->ui_textbox("name_$self->{'i'}", $s->{'name'}, 20),
		$self->ui_select("header_$self->{'i'}", $s->{'header'},
			[ [ "subject", "Subject: header" ],
			  [ "from", "From: header" ],
			  [ "to", "To: header" ],
			  [ "cc", "Cc: header" ],
			  [ "received", "Received: header" ],
			  [ "uri", "URL in message" ],
			  [ "body", "Message body" ],
			  [ "full", "Un-decoded body" ] ],
			0, 0, $s->{'header'} ? 1 : 0),
		"/".$self->ui_textbox("regexp_$self->{'i'}", $s->{'regexp'}, 25)."/".
		    $self->ui_textbox("flags_$self->{'i'}", $s->{'flags'}, 2),
		$self->ui_textbox("score_$self->{'i'}", $s->{'score'}, 5),
		$self->ui_textbox("describe_$self->{'i'}", $s->{'describe'}, 30)
		]);
	$self->{'i'}++;
	}
print $self->ui_columns_end();

print "</td> </tr>\n";
$self->end_form(undef, $self->{'text_hash'}->{'save'});
$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

