#!/usr/bin/perl
package squid::Syslog_logs;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'squid::Syslog_logs');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# Contains a function to supply the syslog module with extra logs

&ModuleLoader::preload_module(ref($self), "squid::SquidLib");
$self = new squid::SquidLib:: ref($self), %$self; 

1;
		return $self;
}

# syslog_getlogs()
# Returns the Squid cache and store logs
sub syslog_getlogs
{
	my $self = shift;

local @rv;
if (-d $self->{'config_hash'}->{'log_dir'}) {
	push(@rv, { 'file' => "$self->{'config_hash'}->{'log_dir'}/cache.log",
		    'desc' => $self->{'text_hash'}->{'syslog_cache'},
		    'active' => 1 });
	push(@rv, { 'file' => "$self->{'config_hash'}->{'log_dir'}/store.log",
		    'desc' => $self->{'text_hash'}->{'syslog_store'},
		    'active' => 1 });
	}
return @rv;
}


1;

