#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple proxy restrictions

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'dhttp_err'});
$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->ReadParse();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'dhttp_enone'});

# Get the existing restrictions
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
@{$self->{'https_array'}} = $self->find_config("http_access", $self->{'conf'});

# Delete them
foreach $d (sort { $b <=> $c } @d) {
	$self->{'http'} = $self->{'conf'}->[$d];
	splice(@{$self->{'https_array'}}, $self->indexof($self->{'http'}, @{$self->{'https_array'}}), 1);
	}

# Write out
$self->save_directive($self->{'conf'}, "http_access", \@{$self->{'https_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("delete", "https", scalar(@d));
$self->redirect("edit_acl.cgi");

1;
		
}


1;

