#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete a bunch of other caches

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->error_setup($self->{'text_hash'}->{'deicp_err'});
$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'deicp_enone'});

# Get the existing entries
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'cache_host'} = $self->{'squid_version'} >= 2 ? "cache_peer" : "cache_host";
@{$self->{'ch_array'}} = $self->find_config($self->{'cache_host'}, $self->{'conf'});
@{$self->{'chd_array'}} = $self->find_config($self->{'cache_host'}."_domain", $self->{'conf'});

# Delete them
foreach $d (sort { $b <=> $a } @d) {
	$self->{'dom'} = $self->{'ch_array'}->[$d]->{'values'}->[0];
	$self->{'dir'} = $self->{'ch_array'}->[$d];
	splice(@{$self->{'ch_array'}}, $d, 1);

	# delete any cache_host directives as well
	for($i=0; $i<@{$self->{'chd_array'}}; $i++) {
		if ($self->{'chd_array'}->[$i]->{'values'}->[0] eq $self->{'dom'}) {
			splice(@{$self->{'chd_array'}}, $i--, 1);
			}
		}
	}

# Write them out
$self->save_directive($self->{'conf'}, $self->{'cache_host'}, \@{$self->{'ch_array'}});
$self->save_directive($self->{'conf'}, $self->{'cache_host'}."_domain", \@{$self->{'chd_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("delete", "hosts", scalar(@d));
$self->redirect("edit_icp.cgi");

1;
		
}


1;

