#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cache.cgi
# A form for editing cache options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'copts'} || $self->error($self->{'text_hash'}->{'ec_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'ec_header'}, "", "edit_cache", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_cache.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ec_cro'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
@{$self->{'dirs_array'}} = $self->find_config("cache_dir", $self->{'conf'});
print "<td valign=top><b>$self->{'text_hash'}->{'ec_cdirs'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=cache_dir_def value=1 %s> $self->{'text_hash'}->{'ec_default'} ($self->{'config_hash'}->{'cache_dir'})\n",
	@{$self->{'dirs_array'}} ? "" : "checked";
printf "<input type=radio name=cache_dir_def value=0 %s> $self->{'text_hash'}->{'ec_listed'}<br>\n",
	@{$self->{'dirs_array'}} ? "checked" : "";
print "<table border>\n";
if ($self->{'squid_version'} >= 2) {
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ec_directory'}</b></td>\n";
	if ($self->{'squid_version'} >= 2.3) {
		print "<td><b>$self->{'text_hash'}->{'ec_type'}</b></td>\n";
		}
	print "<td><b>$self->{'text_hash'}->{'ec_size'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'ec_1dirs'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'ec_2dirs'}</b></td>\n";
	if ($self->{'squid_version'} >= 2.4) {
		print "<td><b>$self->{'text_hash'}->{'ec_opts'}</b></td>\n";
		}
	print "</tr>\n";
	}
for($i=0; $i<=@{$self->{'dirs_array'}}; $i++) {
	@{$self->{'dv_array'}} = $i<@{$self->{'dirs_array'}} ? @{$self->{'dirs_array'}->[$i]->{'values'}} : ();
	print "<tr $self->{'cb'}>\n";
	if ($self->{'squid_version'} >= 2.4) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><select name=cache_type_$i>\n";
		printf "<option value=ufs %s>$self->{'text_hash'}->{'ec_u'}\n",
			$self->{'dv_array'}->[0] eq 'ufs' ? 'selected' : '';
		printf "<option value=diskd %s>$self->{'text_hash'}->{'ec_diskd'}\n",
			$self->{'dv_array'}->[0] eq 'diskd' ? 'selected' : '';
		printf "<option value=aufs %s>$self->{'text_hash'}->{'ec_ua'}\n",
			$self->{'dv_array'}->[0] eq 'aufs' ? 'selected' : '';
		print "</select></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[4]\"></td>\n";
		print "<td><input name=cache_opts_$i size=10 ",
		      "value=\"",join(" ",@{$self->{'dv_array'}}[5..$#{$self->{'dv_array'}}]),"\"></td>\n";
		}
	elsif ($self->{'squid_version'} >= 2.3) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><select name=cache_type_$i>\n";
		printf "<option value=ufs %s>$self->{'text_hash'}->{'ec_u'}\n",
			$self->{'dv_array'}->[0] eq 'ufs' ? 'selected' : '';
		printf "<option value=asyncufs %s>$self->{'text_hash'}->{'ec_ua'}\n",
			$self->{'dv_array'}->[0] eq 'asyncufs' ? 'selected' : '';
		print "</select></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[4]\"></td>\n";
		}
	elsif ($self->{'squid_version'} >= 2) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[0]\"></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		}
	else {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[0]\"></td>\n";
		}
	print "</tr>\n";
	}
print "</table></td> </tr>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'ec_1dirs1'}, "swap_level1_dirs", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'ec_2dirs2'}, "swap_level2_dirs", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6);
	print "</tr>\n";
	}

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'ec_aos'}, "store_avg_object_size", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6, $self->{'text_hash'}->{'ec_kb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'ec_aos'}, "store_avg_object_size",
			       $self->{'conf'}, $self->{'text_hash'}->{'ec_default'}, 6);
	}
print $self->opt_input($self->{'text_hash'}->{'ec_opb'}, "store_objects_per_bucket", $self->{'conf'},
		 $self->{'text_hash'}->{'ec_default'}, 6);
print "</tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->list_input($self->{'text_hash'}->{'ec_ncuc'}, "cache_stoplist",
			  $self->{'conf'}, 1, $self->{'text_hash'}->{'ec_default'});
	print "</tr>\n";

	print "<tr>\n";
	print $self->list_input($self->{'text_hash'}->{'ec_ncum'}, "cache_stoplist_pattern",
			  $self->{'conf'}, 1, $self->{'text_hash'}->{'ec_default'});
	print "</tr>\n";
	}

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'ec_ncua'}</b></td> <td>\n";
print "<table>\n";
@{$self->{'acls_array'}} = grep { !$self->{'acldone_hash'}->{$_->{'values'}->[0]}++ } $self->find_config("acl", $self->{'conf'});
@v = $self->find_config("no_cache", $self->{'conf'});
foreach $v (@v) {
	foreach $ncv (@{$v->{'values'}}) {
		$self->{'noca_hash'}->{$ncv}++;
		}
	}
$i = 0;
foreach $acl (@{$self->{'acls_array'}}) {
	print "<tr>\n" if ($i%3 == 0);
	$self->{'aclv'} = $acl->{'values'}->[0];
	printf "<td nowrap><input type=checkbox name=no_cache value=$self->{'aclv'} %s>$self->{'aclv'}</td>\n",
		$self->{'noca_hash'}->{$self->{'aclv'}} ? "checked" : "";
	print "</tr>\n" if ($i++%3 == 2);
	}
print "</table></td>\n";

print $self->opt_time_input($self->{'text_hash'}->{'ec_mct'}, "reference_age", $self->{'conf'},
		      $self->{'text_hash'}->{'default'}, 6);
print "</tr>\n";

print "<tr>\n";
if ($self->{'squid_version'} >= 2) {
	if ($self->{'squid_version'} >= 2.3) {
		print $self->opt_bytes_input($self->{'text_hash'}->{'ec_mrbs'},
			"request_body_max_size", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
		print $self->opt_bytes_input($self->{'text_hash'}->{'ec_mrhs'},
			"request_header_max_size", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
		print "</tr>\n";

		print "<tr>\n";
		if ($self->{'squid_version'} < 2.5) {
			print $self->opt_bytes_input($self->{'text_hash'}->{'ec_mrbs1'},
			   "reply_body_max_size", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
			}
		else {
			print $self->opt_bytes_input($self->{'text_hash'}->{'ec_gap'},
			   "read_ahead_gap", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
			}
		}
	else {
		print $self->opt_bytes_input($self->{'text_hash'}->{'ec_mrs'}, "request_size",
				       $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
		}
	print $self->opt_time_input($self->{'text_hash'}->{'ec_frct'},
			      "negative_ttl", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	}
else {
	print $self->opt_input($self->{'text_hash'}->{'ec_mrs'}, "request_size", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 8, $self->{'text_hash'}->{'ec_kb'});
	print $self->opt_input($self->{'text_hash'}->{'ec_frct'}, "negative_ttl", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_mins'});
	}
print "</tr>\n";

if ($self->{'squid_version'} >= 2.5) {
	# Max reply size can be limited by ACL
	print "<tr>\n";
	print "<td valign=top><b>$self->{'text_hash'}->{'ec_maxreplies'}</b></td>\n";
	print "<td colspan=3><table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ec_maxrn'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'ec_maxracls'}</b></td> </tr>\n";
	@{$self->{'maxrs_array'}} = $self->find_config("reply_body_max_size", $self->{'conf'});
	$i = 0;
	foreach $m (@{$self->{'maxrs_array'}}, { }) {
		local ($s, @a) = @{$m->{'values'}};
		print "<tr $self->{'cb'}>\n";
		printf "<td><input name=reply_body_max_size_%d size=8 value='%s'></td>\n",
			$i, $s;
		printf "<td><input name=reply_body_max_acls_%d size=50 value='%s'></td>\n",
			$i, join(" ", @a);
		print "</tr>\n";
		$i++;
		}
	print "</table></tr>\n";
	}

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'ec_dlct'}, "positive_dns_ttl", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_mins'});
	print $self->opt_input($self->{'text_hash'}->{'ec_fdct'}, "negative_dns_ttl", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_mins'});
	}
else {
	print $self->opt_time_input($self->{'text_hash'}->{'ec_dlct'}, "positive_dns_ttl",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print $self->opt_time_input($self->{'text_hash'}->{'ec_fdct'}, "negative_dns_ttl",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	}
print "</tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'ec_ct'}, "connect_timeout", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_secs'});
	print $self->opt_input($self->{'text_hash'}->{'ec_rt'}, "read_timeout", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_secs'});
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'ec_mcct'}, "client_lifetime", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_mins'});
	print $self->opt_input($self->{'text_hash'}->{'ec_mst'}, "shutdown_lifetime", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 4, $self->{'text_hash'}->{'ec_mins'});
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print $self->opt_time_input($self->{'text_hash'}->{'ec_ct'}, "connect_timeout", $self->{'conf'},
			      $self->{'text_hash'}->{'default'}, 4);
	print $self->opt_time_input($self->{'text_hash'}->{'ec_rt'}, "read_timeout", $self->{'conf'},
			      $self->{'text_hash'}->{'default'}, 4);
	print "<tr>\n";

	print "</tr>\n";
	print $self->opt_time_input($self->{'text_hash'}->{'ec_sst'}, "siteselect_timeout",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print $self->opt_time_input($self->{'text_hash'}->{'ec_crt'}, "request_timeout",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_time_input($self->{'text_hash'}->{'ec_mcct'}, "client_lifetime",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print $self->opt_time_input($self->{'text_hash'}->{'ec_mst'}, "shutdown_lifetime",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print "</tr>\n";

	print "<tr>\n";
	print $self->choice_input($self->{'text_hash'}->{'ec_hcc'}, "half_closed_clients",
			    $self->{'conf'}, "on", $self->{'text_hash'}->{'on'},"on", $self->{'text_hash'}->{'off'},"off");
	print $self->opt_time_input($self->{'text_hash'}->{'ec_pt'}, "pconn_timeout",
			      $self->{'conf'}, $self->{'text_hash'}->{'default'}, 4);
	print "</tr>\n";
	}

if ($self->{'squid_version'} < 2) {
	print "<tr> <td><b>$self->{'text_hash'}->{'ec_wr'}</b></td> <td colspan=3>\n";
	$v = $self->find_config("wais_relay", $self->{'conf'});
	printf "<input type=radio name=wais_relay_def value=1 %s> $self->{'text_hash'}->{'none'}\n",
		$v ? "" : "checked";
	printf "<input type=radio name=wais_relay_def value=0 %s> $self->{'text_hash'}->{'ec_host'}\n",
		$v ? "checked" : "";
	@{$self->{'wrv_array'}} = $v ? @{$v->{'values'}} : ();
	print "<input size=20 name=wais_relay1 value=\"$self->{'wrv_array'}->[0]\">&nbsp;$self->{'text_hash'}->{'ec_port'}\n";
	print "<input size=6 name=wais_relay2 value=\"$self->{'wrv_array'}->[1]\"></td>\n";
	print "</tr>\n";
	}
else {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'ec_wrh'}, "wais_relay_host",
			 $self->{'conf'}, $self->{'text_hash'}->{'none'}, 20);
	print $self->opt_input($self->{'text_hash'}->{'ec_wrp'}, "wais_relay_port",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	print "</tr>\n";
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=$self->{'text_hash'}->{'buttsave'}></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'ec_return'});

1;
		
}


1;

