#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_cache_host.cgi
# Display a form for editing or creating a cache_host line

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'cache_host'} = $self->{'squid_version'} >= 2 ? "cache_peer" : "cache_host";
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ech_header'}, "", undef, 0, 0, 0, $self->restart_button());
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'ech_header1'}, "", undef, 0, 0, 0, $self->restart_button());
	@{$self->{'chl_array'}} = $self->find_config($self->{'cache_host'}, $self->{'conf'});
	@{$self->{'ch_array'}} = @{$self->{'chl_array'}->[$self->{'in_hash'}->{'num'}]->{'values'}};
	for($i=4; $i<@{$self->{'ch_array'}}; $i++) {
		if ($self->{'ch_array'}->[$i] =~ /^(\S+)=(\S+)$/) { $self->{'opts_hash'}->{$1} = $2; }
		else { $self->{'opts_hash'}->{$self->{'ch_array'}->[$i]} = 1; }
		}
	}

print "<form action=save_cache_host.cgi>\n";
if ($self->{'in_hash'}->{'new'}) { print "<input type=hidden name=new value=1>\n"; }
else { print "<input type=hidden name=num value=$self->{'in_hash'}->{'num'}>\n"; }
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ech_cho'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ech_h'}</b></td>\n";
print "<td><input name=host size=20 value=\"$self->{'ch_array'}->[0]\"></td>\n";

%{$self->{'ts_hash'}} = (	"parent"=> $self->{'text_hash'}->{"ech_parent"},
	"sibling"=>$self->{'text_hash'}->{"ech_sibling"},
	"multicast"=>$self->{'text_hash'}->{"ech_multicast"} );
print "<td><b>$self->{'text_hash'}->{'ech_t'}</b></td>\n";
print "<td><select name=type>\n";
foreach $t (keys %{$self->{'ts_hash'}}) {
	printf "<option value=$t %s>$self->{'ts_hash'}->{$t}\n", $t eq $self->{'ch_array'}->[1] ? "selected" : "";
	}
print "</select></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ech_pp'}</b></td>\n";
print "<td><input name=proxy size=6 value=\"$self->{'ch_array'}->[2]\"></td>\n";

print "<td><b>$self->{'text_hash'}->{'ech_ip'}</b></td>\n";
print "<td><input name=icp size=6 value=\"$self->{'ch_array'}->[3]\"></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'ech_po'}</b></td>\n";
printf "<td><input type=radio name=proxy-only value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
	$self->{'opts_hash'}->{'proxy-only'} ? "checked" : "";
printf "<input type=radio name=proxy-only value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
	$self->{'opts_hash'}->{'proxy-only'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'ech_siq'}</b></td>\n";
printf "<td><input type=radio name=no-query value=0 %s> $self->{'text_hash'}->{'ech_y'}\n",
	$self->{'opts_hash'}->{'no-query'} ? "" : "checked";
printf "<input type=radio name=no-query value=1 %s> $self->{'text_hash'}->{'ech_n'}</td> </tr>\n",
	$self->{'opts_hash'}->{'no-query'} ? "checked" : "";

print "<tr> <td><b>$self->{'text_hash'}->{'ech_dc'}</b></td>\n";
printf "<td><input type=radio name=default value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
	$self->{'opts_hash'}->{'default'} ? "checked" : "";
printf "<input type=radio name=default value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
	$self->{'opts_hash'}->{'default'} ? "" : "checked";

print "<td><b>$self->{'text_hash'}->{'ech_rrc'}</b></td>\n";
printf "<td><input type=radio name=round-robin value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
	$self->{'opts_hash'}->{'round-robin'} ? "checked" : "";
printf "<input type=radio name=round-robin value=0 %s> $self->{'text_hash'}->{'ech_n'}</td> </tr>\n",
	$self->{'opts_hash'}->{'round-robin'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'ech_ittl'}</b></td>\n";
printf "<td><input type=radio name=ttl_def value=1 %s> $self->{'text_hash'}->{'ech_d'}\n",
	$self->{'opts_hash'}->{'ttl'} ? "" : "checked";
printf "<input type=radio name=ttl_def value=0 %s>\n",
	$self->{'opts_hash'}->{'ttl'} ? "checked" : "";
print "<input name=ttl size=6 value=\"$self->{'opts_hash'}->{'ttl'}\"></td>\n";

print "<td><b>$self->{'text_hash'}->{'ech_cw'}</b></td>\n";
printf "<td><input type=radio name=weight_def value=1 %s> $self->{'text_hash'}->{'ech_d'}\n",
	$self->{'opts_hash'}->{'weight'} ? "" : "checked";
printf "<input type=radio name=weight_def value=0 %s>\n",
	$self->{'opts_hash'}->{'weight'} ? "checked" : "";
print "<input name=weight size=6 value=\"$self->{'opts_hash'}->{'weight'}\"></td> </tr>\n";

if ($self->{'squid_version'} >= 2) {
	print "<tr> <td><b>$self->{'text_hash'}->{'ech_co'}</b></td>\n";
	printf "<td><input type=radio name=closest-only value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'closest-only'} ? "checked" : "";
	printf "<input type=radio name=closest-only value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
		$self->{'opts_hash'}->{'closest-only'} ? "" : "checked";

	print "<td><b>$self->{'text_hash'}->{'ech_nd'}</b></td>\n";
	printf "<td><input type=radio name=no-digest value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'no-digest'} ? "checked" : "";
	printf "<input type=radio name=no-digest value=0 %s> $self->{'text_hash'}->{'ech_n'}</td> </tr>\n",
		$self->{'opts_hash'}->{'no-digest'} ? "" : "checked";

	print "<tr> <td><b>$self->{'text_hash'}->{'ech_nne'}</b></td>\n";
	printf "<td><input type=radio name=no-netdb-exchange value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'no-netdb-exchange'} ? "checked" : "";
	printf "<input type=radio name=no-netdb-exchange value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
		$self->{'opts_hash'}->{'no-netdb-exchange'} ? "" : "checked";

	print "<td><b>$self->{'text_hash'}->{'ech_nd1'}</b></td>\n";
	printf "<td><input type=radio name=no-delay value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'no-delay'} ? "checked" : "";
	printf "<input type=radio name=no-delay value=0 %s> $self->{'text_hash'}->{'ech_n'}</td> </tr>\n",
		$self->{'opts_hash'}->{'no-delay'} ? "" : "checked";
	}

if ($self->{'squid_version'} >= 2.1) {
	local $mode = $self->{'opts_hash'}->{'login'} eq 'PASS' ? 2 :
		      $self->{'opts_hash'}->{'login'} =~ /^\*:\S+$/ ? 3 :
		      $self->{'opts_hash'}->{'login'} ? 1 : 0;
	local @up = split(/:/, $self->{'opts_hash'}->{'login'});
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'ech_ltp'}</b></td>\n";
	print "<td colspan=3>\n";
	printf "<input type=radio name=login value=0 %s> $self->{'text_hash'}->{'ech_nl'}<br>\n",
		$mode == 0 ? "checked" : "";
	printf "<input type=radio name=login value=1 %s>\n",
		$mode == 1 ? "checked" : "";
	printf "$self->{'text_hash'}->{'ech_u'} <input name=login_user size=15 value=\"%s\">\n", $mode == 1 ? $up[0] : "";
		
	printf "$self->{'text_hash'}->{'ech_p'} <input name=login_pass size=15 value=\"%s\"><br>\n", $mode == 1 ? $up[1] : "";
	if ($self->{'squid_version'} >= 2.5 || $mode > 1) {
		printf "<input type=radio name=login value=2 %s> %s<br>\n",
			$mode == 2 ? "checked" : "",
			$self->{'text_hash'}->{'ech_pass'};
		printf "<input type=radio name=login value=3 %s> %s\n",
			$mode == 3 ? "checked" : "",
			$self->{'text_hash'}->{'ech_upass'};
		printf "<input name=login_pass2 size=15 value=\"%s\">\n",
			$mode == 3 ? $up[1] : "";
		}
	print "</td> </tr>\n";
	}

if ($self->{'squid_version'} >= 3.0) {
	print "<tr> <td><b>$self->{'text_hash'}->{'ech_timeo'}</b></td>\n";
	printf "<td><input type=radio name=connect-timeout_def value=1 %s> $self->{'text_hash'}->{'ech_d'}\n",
		$self->{'opts_hash'}->{'connect-timeout'} ? "" : "checked";
	printf "<input type=radio name=connect-timeout_def value=0 %s>\n",
		$self->{'opts_hash'}->{'connect-timeout'} ? "checked" : "";
	print "<input name=connect-timeout size=6 value=\"$self->{'opts_hash'}->{'connect-timeout'}\"></td>\n";

	print "<td><b>$self->{'text_hash'}->{'ech_digest'}</b></td>\n";
	printf "<td><input type=radio name=digest-url_def value=1 %s> $self->{'text_hash'}->{'ech_d'}\n",
		$self->{'opts_hash'}->{'digest-url'} ? "" : "checked";
	printf "<input type=radio name=digest-url_def value=0 %s>\n",
		$self->{'opts_hash'}->{'digest-url'} ? "checked" : "";
	print "<input name=digest-url size=20 value=\"$self->{'opts_hash'}->{'digest-url'}\"></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'ech_miss'}</b></td>\n";
	printf "<td><input type=radio name=allow-miss value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'allow-miss'} ? "checked" : "";
	printf "<input type=radio name=allow-miss value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
		$self->{'opts_hash'}->{'allow-miss'} ? "" : "checked";

	print "<td><b>$self->{'text_hash'}->{'ech_maxconn'}</b></td>\n";
	printf "<td><input type=radio name=max-conn_def value=1 %s> $self->{'text_hash'}->{'ech_d'}\n",
		$self->{'opts_hash'}->{'max-conn'} ? "" : "checked";
	printf "<input type=radio name=max-conn_def value=0 %s>\n",
		$self->{'opts_hash'}->{'max-conn'} ? "checked" : "";
	print "<input name=max-conn size=6 value=\"$self->{'opts_hash'}->{'max-conn'}\"></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'ech_htcp'}</b></td>\n";
	printf "<td><input type=radio name=htcp value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'htcp'} ? "checked" : "";
	printf "<input type=radio name=htcp value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
		$self->{'opts_hash'}->{'htcp'} ? "" : "checked";

	print "<td><b>$self->{'text_hash'}->{'ech_force'}</b></td>\n";
	printf "<td><input type=radio name=forceddomain_def value=1 %s> %s\n",
		$self->{'opts_hash'}->{'forceddomain'} ? "" : "checked", $self->{'text_hash'}->{'ech_same'};
	printf "<input type=radio name=forceddomain_def value=0 %s>\n",
		$self->{'opts_hash'}->{'forceddomain'} ? "checked" : "";
	print "<input name=forceddomain size=20 value=\"$self->{'opts_hash'}->{'forceddomain'}\"></td> </tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'ech_origin'}</b></td>\n";
	printf "<td><input type=radio name=originserver value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'originserver'} ? "checked" : "";
	printf "<input type=radio name=originserver value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
		$self->{'opts_hash'}->{'originserver'} ? "" : "checked";

	print "<td><b>$self->{'text_hash'}->{'ech_ssl'}</b></td>\n";
	printf "<td><input type=radio name=ssl value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
		$self->{'opts_hash'}->{'ssl'} ? "checked" : "";
	printf "<input type=radio name=ssl value=0 %s> $self->{'text_hash'}->{'ech_n'}</td> </tr>\n",
		$self->{'opts_hash'}->{'ssl'} ? "" : "checked";
	}

print "<tr> <td><b>$self->{'text_hash'}->{'ech_mr'}</b></td>\n";
printf "<td><input type=radio name=multicast-responder value=1 %s> $self->{'text_hash'}->{'ech_y'}\n",
	$self->{'opts_hash'}->{'multicast-responder'} ? "checked" : "";
printf "<input type=radio name=multicast-responder value=0 %s> $self->{'text_hash'}->{'ech_n'}</td>\n",
	$self->{'opts_hash'}->{'multicast-responder'} ? "" : "checked";
print "</tr>\n";

if (!$self->{'in_hash'}->{'new'}) {
	@chd = $self->find_config($self->{'cache_host'}."_domain", $self->{'conf'});
	foreach $chd (@chd) {
		@{$self->{'chdv_array'}} = @{$chd->{'values'}};
		if ($self->{'chdv_array'}->[0] eq $self->{'ch_array'}->[0]) {
			# found a record for this host..
			for($i=1; $i<@{$self->{'chdv_array'}}; $i++) {
				if ($self->{'chdv_array'}->[$i] =~ /^\!(\S+)$/) {
					push(@{$self->{'dontq_array'}}, $1);
					}
				else { push(@{$self->{'doq_array'}}, $self->{'chdv_array'}->[$i]); }
				}
			}
		}
	}
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'ech_qhfd'}</b></td>\n";
print "<td><textarea name=doq rows=6 cols=25>",join("\n", @{$self->{'doq_array'}}),
      "</textarea></td>\n";
print "<td valign=top><b>$self->{'text_hash'}->{'ech_dqfd'}</b></td>\n";
print "<td><textarea name=dontq rows=6 cols=25>",join("\n", @{$self->{'dontq_array'}}),
      "</textarea></td> </tr>\n";

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
print "<td><input type=submit value=$self->{'text_hash'}->{'ech_buttsave'}></td> <td align=right>\n";
if (!$self->{'in_hash'}->{'new'}) { print "<input type=submit value=$self->{'text_hash'}->{'ech_buttdel'} name=delete>\n"; }
print "</td></tr></table>\n";
print "</form>\n";

$self->ui_print_footer("edit_icp.cgi", $self->{'text_hash'}->{'ech_return'},
	"", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

