#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_progs.cgi
# A form for editing helper program options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'hprogs'} || $self->error($self->{'text_hash'}->{'eprogs_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'eprogs_header'}, "", "edit_progs", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_progs.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'eprogs_chpo'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'eprogs_sfp'}, "ftpget_program", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 40, $self->file_chooser_button("ftpget_program"));
	print "</tr>\n";

	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eprogs_fo'}, "ftpget_options", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 15);
	}
else {
	print $self->opt_input($self->{'text_hash'}->{'eprogs_fcv'}, "ftp_list_width", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'eprogs_c'});
	}
print $self->opt_input($self->{'text_hash'}->{'eprogs_afl'}, "ftp_user", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 15);
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_sdp'}, "cache_dns_program", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 40,
		 $self->file_chooser_button("cache_dns_program"));
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_nodp'}, "dns_children", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 5);
print $self->choice_input($self->{'text_hash'}->{'eprogs_adtr'}, "dns_defnames", $self->{'conf'}, "off",
		    $self->{'text_hash'}->{'yes'}, "on", $self->{'text_hash'}->{'no'}, "off");
print "</tr>\n";

if ($self->{'squid_version'} >= 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'eprogs_dsa'}, "dns_nameservers", $self->{'conf'},
			 $self->{'text_hash'}->{'eprogs_fr'}, 35);
	print "</tr>\n";
	}

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_ccp'}, "unlinkd_program", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 40, $self->file_chooser_button("unlinkd_program"));
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_spp'}, "pinger_program", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 40, $self->file_chooser_button("pinger_program"));
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_crp'}, "redirect_program", $self->{'conf'},
		 $self->{'text_hash'}->{'none'}, 40, $self->file_chooser_button("redirect_program"));
print "</tr>\n";

print "<tr>\n";
print $self->opt_input($self->{'text_hash'}->{'eprogs_norp'}, "redirect_children", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 6);
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'eprogs_return'});

1;
		
}


1;

