#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_smem.cgi
# A form for editing simple memory and disk usage options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'musage'} || $self->error($self->{'text_hash'}->{'emem_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'emem_dheader'}, "", "", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

print "<form action=save_smem.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'emem_maduo'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'emem_mul'}, "cache_mem", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_mb'});
	print $self->opt_input($self->{'text_hash'}->{'emem_dul'}, "cache_swap",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_mb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'emem_mul'}, "cache_mem", $self->{'conf'},
			       $self->{'text_hash'}->{'default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'emem_fcs'}, "fqdncache_size", $self->{'conf'},
			 $self->{'text_hash'}->{'default'}, 8);
	}
print "</tr>\n";

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'emem_mcos'}, "maximum_object_size",
			 $self->{'conf'}, $self->{'text_hash'}->{'default'}, 8, $self->{'text_hash'}->{'emem_kb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'emem_mcos'},
			       "maximum_object_size", $self->{'conf'}, $self->{'text_hash'}->{'default'}, 6);
	}
print $self->opt_input($self->{'text_hash'}->{'emem_iacs'}, "ipcache_size", $self->{'conf'},
		 $self->{'text_hash'}->{'default'}, 6, $self->{'text_hash'}->{'emem_e'});
print "</tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr>\n";
@{$self->{'dirs_array'}} = $self->find_config("cache_dir", $self->{'conf'});
print "<td valign=top><b>$self->{'text_hash'}->{'ec_cdirs'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=cache_dir_def value=1 %s>$self->{'text_hash'}->{'ec_default'}\n",
	@{$self->{'dirs_array'}} ? "" : "checked";
printf "<input type=radio name=cache_dir_def value=0 %s>$self->{'text_hash'}->{'ec_listed'}<br>\n",
	@{$self->{'dirs_array'}} ? "checked" : "";
print "<table border>\n";
if ($self->{'squid_version'} >= 2) {
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'ec_directory'}</b></td>\n";
	if ($self->{'squid_version'} >= 2.3) {
		print "<td><b>$self->{'text_hash'}->{'ec_type'}</b></td>\n";
		}
	print "<td><b>$self->{'text_hash'}->{'ec_size'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'ec_1dirs'}</b></td>\n";
	print "<td><b>$self->{'text_hash'}->{'ec_2dirs'}</b></td>\n";
	if ($self->{'squid_version'} >= 2.4) {
		print "<td><b>$self->{'text_hash'}->{'ec_opts'}</b></td>\n";
		}
	print "</tr>\n";
	}
for($i=0; $i<=@{$self->{'dirs_array'}}; $i++) {
	@{$self->{'dv_array'}} = $i<@{$self->{'dirs_array'}} ? @{$self->{'dirs_array'}->[$i]->{'values'}} : ();
	print "<tr $self->{'cb'}>\n";
	if ($self->{'squid_version'} >= 2.4) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><select name=cache_type_$i>\n";
		printf "<option value=ufs %s>$self->{'text_hash'}->{'ec_u'}\n",
			$self->{'dv_array'}->[0] eq 'ufs' ? 'selected' : '';
		printf "<option value=diskd %s>$self->{'text_hash'}->{'ec_diskd'}\n",
			$self->{'dv_array'}->[0] eq 'diskd' ? 'selected' : '';
		printf "<option value=aufs %s>$self->{'text_hash'}->{'ec_ua'}\n",
			$self->{'dv_array'}->[0] eq 'aufs' ? 'selected' : '';
		print "</select></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[4]\"></td>\n";
		print "<td><input name=cache_opts_$i size=10 ",
		      "value=\"",join(" ",@{$self->{'dv_array'}}[5..$#{$self->{'dv_array'}}]),"\"></td>\n";
		}
	elsif ($self->{'squid_version'} >= 2.3) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><select name=cache_type_$i>\n";
		printf "<option value=ufs %s>$self->{'text_hash'}->{'ec_u'}\n",
			$self->{'dv_array'}->[0] eq 'ufs' ? 'selected' : '';
		printf "<option value=asyncufs %s>$self->{'text_hash'}->{'ec_ua'}\n",
			$self->{'dv_array'}->[0] eq 'asyncufs' ? 'selected' : '';
		print "</select></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[4]\"></td>\n";
		}
	elsif ($self->{'squid_version'} >= 2) {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[0]\"></td>\n";
		print "<td><input name=cache_size_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[1]\"></td>\n";
		print "<td><input name=cache_lv1_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[2]\"></td>\n";
		print "<td><input name=cache_lv2_$i size=8 ",
		      "value=\"$self->{'dv_array'}->[3]\"></td>\n";
		}
	else {
		print "<td><input name=cache_dir_$i size=30 ",
		      "value=\"$self->{'dv_array'}->[0]\"></td>\n";
		}
	print "</tr>\n";
	}
print "</table></td> </tr>\n";

if ($self->{'squid_version'} < 2) {
	print "<tr>\n";
	print $self->opt_input($self->{'text_hash'}->{'ec_1dirs1'}, "swap_level1_dirs", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6);
	print $self->opt_input($self->{'text_hash'}->{'ec_2dirs2'}, "swap_level2_dirs", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6);
	print "</tr>\n";
	}

print "<tr>\n";
if ($self->{'squid_version'} < 2) {
	print $self->opt_input($self->{'text_hash'}->{'ec_aos'}, "store_avg_object_size", $self->{'conf'},
			 $self->{'text_hash'}->{'ec_default'}, 6, $self->{'text_hash'}->{'ec_kb'});
	}
else {
	print $self->opt_bytes_input($self->{'text_hash'}->{'ec_aos'}, "store_avg_object_size",
			       $self->{'conf'}, $self->{'text_hash'}->{'ec_default'}, 6);
	}
print $self->opt_input($self->{'text_hash'}->{'ec_opb'}, "store_objects_per_bucket", $self->{'conf'},
		 $self->{'text_hash'}->{'ec_default'}, 6);
print "</tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'buttsave'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'emem_return'});

1;
		
}


1;

