#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_headeracc.cgi
# Display all header access control restrictions

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'headeracc'} || $self->error($self->{'text_hash'}->{'header_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'header_title'}, "", "list_headeracc", 0, 0, 0, $self->restart_button());
$self->{'conf'} = $self->get_config();

@{$self->{'headeracc_array'}} = $self->find_config("header_access", $self->{'conf'});
if (@{$self->{'headeracc_array'}}) {
	print "<a href='edit_headeracc.cgi?new=1'>$self->{'text_hash'}->{'header_add'}</a>\n";
	print "<table border>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'header_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'header_act'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'header_acls'}</b></td> ",
	      "<td width=10%><b>$self->{'text_hash'}->{'eacl_move'}</b></td> </tr>\n";
	$self->{'hc'} = 0;
	foreach $h (@{$self->{'headeracc_array'}}) {
		@{$self->{'v_array'}} = @{$h->{'values'}};
		print "<tr $self->{'cb'}>\n";
		print "<td><a href='edit_headeracc.cgi?index=$h->{'index'}'>",
		      "$self->{'v_array'}->[0]</a></td>\n";
		print "<td>",$self->{'v_array'}->[1] eq 'allow' ?  $self->{'text_hash'}->{'eacl_allow'} :
				$self->{'text_hash'}->{'eacl_deny'},"</td>\n";
		print "<td>",join(" ", @{$self->{'v_array'}}[2..$#{$self->{'v_array'}}]),"</td>\n";
		print "<td>\n";
		if ($self->{'hc'} != @{$self->{'headeracc_array'}}-1) {
			print "<a href=\"move_headeracc.cgi?$self->{'hc'}+1\">",
			      "<img src=images/down.gif border=0></a>";
			}
		else { print "<img src=images/gap.gif>"; }
		if ($self->{'hc'} != 0) {
			print "<a href=\"move_headeracc.cgi?$self->{'hc'}+-1\">",
			      "<img src=images/up.gif border=0></a>";
			}
		print "</td></tr>\n";
		print "</tr>\n";
		$self->{'hc'}++;
		}
	print "</table>\n";
	}
else {
	print "<p>$self->{'text_hash'}->{'header_none'}<p>\n";
	}
print "<a href='edit_headeracc.cgi?new=1'>$self->{'text_hash'}->{'header_add'}</a><br>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

