#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move_headeracc.cgi
# Move a header_access directive up or down

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'headeracc'} || $self->error($self->{'text_hash'}->{'header_ecannot'});
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
($self->{'pos'}, $self->{'move'}) = @ARGV;

@{$self->{'headeracc_array'}} = $self->find_config("header_access", $self->{'conf'});
$self->{'newpos'} = $self->{'pos'} + $self->{'move'};
$self->{'oldv'} = $self->{'headeracc_array'}->[$self->{'pos'}]->{'values'};
$self->{'headeracc_array'}->[$self->{'pos'}]->{'values'} = $self->{'headeracc_array'}->[$self->{'newpos'}]->{'values'};
$self->{'headeracc_array'}->[$self->{'newpos'}]->{'values'} = $self->{'oldv'};
$self->save_directive($self->{'conf'}, "header_access", \@{$self->{'headeracc_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("move", "headeracc");
$self->redirect("list_headeracc.cgi");
1;
		
}


1;

