#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move_icp.cgi
# Move a icp_access directive up or down

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'actrl'} || $self->error($self->{'text_hash'}->{'eacl_ecannot'});
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
($self->{'pos'}, $self->{'move'}) = @ARGV;

@{$self->{'icps_array'}} = $self->find_config("icp_access", $self->{'conf'});
$self->{'newpos'} = $self->{'pos'} + $self->{'move'};
$self->{'oldv'} = $self->{'icps_array'}->[$self->{'pos'}]->{'values'};
$self->{'icps_array'}->[$self->{'pos'}]->{'values'} = $self->{'icps_array'}->[$self->{'newpos'}]->{'values'};
$self->{'icps_array'}->[$self->{'newpos'}]->{'values'} = $self->{'oldv'};
$self->save_directive($self->{'conf'}, "icp_access", \@{$self->{'icps_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("move", "icp");
$self->redirect("edit_acl.cgi");
1;
		
}


1;

