#!/usr/bin/perl

&MAIN();

 sub MAIN {
# move_delay.cgi
# Move a delay_access directive up or down

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
($self->{'pos'}, $self->{'move'}, $self->{'idx'}) = @ARGV;

@{$self->{'delays_array'}} = $self->find_config("delay_access", $self->{'conf'});
@{$self->{'access_array'}} = grep { $_->{'values'}->[0] == $self->{'idx'} } @{$self->{'delays_array'}};
$self->{'newpos'} = $self->{'pos'} + $self->{'move'};
$self->{'oldv'} = $self->{'access_array'}->[$self->{'pos'}]->{'values'};
$self->{'access_array'}->[$self->{'pos'}]->{'values'} = $self->{'access_array'}->[$self->{'newpos'}]->{'values'};
$self->{'access_array'}->[$self->{'newpos'}]->{'values'} = $self->{'oldv'};
$self->save_directive($self->{'conf'}, "delay_access", \@{$self->{'delays_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("move", "delay", $self->{'idx'});
$self->redirect("edit_pool.cgi?idx=$self->{'idx'}");
1;
		
}


1;

