#!/usr/bin/perl

&MAIN();

 sub MAIN {
# never_save.cgi
# Save or delete an never_direct directive

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();

@{$self->{'never_array'}} = $self->find_config("never_direct", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'never'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this restriction
	splice(@{$self->{'never_array'}}, $self->indexof($self->{'never'}, @{$self->{'never_array'}}), 1);
	}
else {
	# update or create
	@{$self->{'vals_array'}} = ( $self->{'in_hash'}->{'action'} );
	foreach $y (split(/\0/, $self->{'in_hash'}->{'yes'})) { push(@{$self->{'vals_array'}}, $y); }
	foreach $n (split(/\0/, $self->{'in_hash'}->{'no'})) { push(@{$self->{'vals_array'}}, "!$n"); }
	$self->{'newnever'} = { 'name' => 'never_direct', 'values' => \@{$self->{'vals_array'}} };
	if ($self->{'never'}) { splice(@{$self->{'never_array'}}, $self->indexof($self->{'never'}, @{$self->{'never_array'}}),
			      1, $self->{'newnever'}); }
	else { push(@{$self->{'never_array'}}, $self->{'newnever'}); }
	}
$self->save_directive($self->{'conf'}, "never_direct", \@{$self->{'never_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'never'} ? 'modify' : 'create', "never");
$self->redirect("edit_icp.cgi");

1;
		
}


1;

