#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_delay.cgi
# Save global delay pool options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'delay'} || $self->error($self->{'text_hash'}->{'delay_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'delay_err'});

$self->save_opt("delay_initial_bucket_level", \&check_initial, $self->{'conf'});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("delay", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_initial
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('delay_epercent', $_[0]);
}


1;

