#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_icp.cgi
# Save cache options

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'othercaches'} || $self->error($self->{'text_hash'}->{'eicp_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->{'whatfailed'} = $self->{'text_hash'}->{'sicp_ftsco'};

if ($self->{'squid_version'} < 2) {
	$self->save_list("local_domain", undef, $self->{'conf'});
	$self->save_address("local_ip", $self->{'conf'});
	$self->save_list("inside_firewall", undef, $self->{'conf'});
	$self->save_address("firewall_ip", $self->{'conf'});
	}
$self->save_list("hierarchy_stoplist", undef, $self->{'conf'});
if ($self->{'squid_version'} < 2) {
	$self->save_choice("single_parent_bypass", "off", $self->{'conf'});
	$self->save_choice("source_ping", "off", $self->{'conf'});
	$self->save_opt("neighbor_timeout", \&check_timeout, $self->{'conf'});
	}
else {
	$self->save_opt("icp_query_timeout", \&check_timeout, $self->{'conf'});
	$self->save_opt("mcast_icp_query_timeout", \&check_timeout, $self->{'conf'});
	$self->save_opt("dead_peer_timeout", \&check_timeout, $self->{'conf'});
	}
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log("icp", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");

1;
		
}

sub check_timeout
{
	shift if ($self == $_[0]);

return $_[0] =~ /^\d+$/ ? undef : $self->text('sicp_emsg1',$_[0]);
}


1;

