#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save or delete a refresh pattern

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'refresh'} || $self->error($self->{'text_hash'}->{'refresh_ecannot'});
$self->ReadParse();
$self->lock_file($self->{'config_hash'}->{'squid_conf'});
$self->{'conf'} = $self->get_config();
$self->error_setup($self->{'text_hash'}->{'refresh_err'});

@{$self->{'refresh_array'}} = $self->find_config("refresh_pattern", $self->{'conf'});
if (defined($self->{'in_hash'}->{'index'})) {
	$self->{'h'} = $self->{'conf'}->[$self->{'in_hash'}->{'index'}];
	}
if ($self->{'in_hash'}->{'delete'}) {
	# delete this restriction
	splice(@{$self->{'refresh_array'}}, $self->indexof($self->{'h'}, @{$self->{'refresh_array'}}), 1);
	}
else {
	# update or create
	$self->{'in_hash'}->{'re'} =~ /^\S+$/ || $self->error($self->{'text_hash'}->{'refresh_ere'});
	$self->{'in_hash'}->{'min'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'refresh_emin'});
	$self->{'in_hash'}->{'max'} =~ /^\d+$/ || $self->error($self->{'text_hash'}->{'refresh_emax'});
	$self->{'in_hash'}->{'pc'} =~ /^\d+$/ && $self->{'in_hash'}->{'pc'} >= 0 && $self->{'in_hash'}->{'pc'} <= 100 ||
		$self->error($self->{'text_hash'}->{'refresh_epc'});
	push(@{$self->{'vals_array'}}, "-i") if ($self->{'in_hash'}->{'caseless'});
	push(@{$self->{'vals_array'}}, $self->{'in_hash'}->{'re'}, $self->{'in_hash'}->{'min'}, $self->{'in_hash'}->{'pc'}.'%', $self->{'in_hash'}->{'max'});
	push(@{$self->{'vals_array'}}, split(/\0/, $self->{'in_hash'}->{'options'}));
	$self->{'newr'} = { 'name' => 'refresh_pattern',
		  'values' => \@{$self->{'vals_array'}} };
	$self->{'idx'} = $self->indexof($self->{'h'}, @{$self->{'refresh_array'}});
	if ($self->{'h'}) { splice(@{$self->{'refresh_array'}}, $self->indexof($self->{'h'}, @{$self->{'refresh_array'}}), 1, $self->{'newr'}); }
	else { push(@{$self->{'refresh_array'}}, $self->{'newr'}); }
	}
$self->save_directive($self->{'conf'}, "refresh_pattern", \@{$self->{'refresh_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'squid_conf'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'h'} ? 'modify' : 'create',
	    "refresh", $self->{'in_hash'}->{'re'});
$self->redirect("list_refresh.cgi");

1;
		
}


1;

