#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_user.cgi
# Save, create or delete a proxy user

&ModuleLoader::preload_module('squid_class', "squid::SquidLib");
$self = new squid::SquidLib:: 'squid_class',%$self;

$self->{'access_hash'}->{'proxyauth'} || $self->error($self->{'text_hash'}->{'eauth_ecannot'});
$self->ReadParse();
$self->{'conf'} = $self->get_config();
$self->{'file'} = $self->find_config("proxy_auth", $self->{'conf'})->{'values'}->[0];
$self->lock_file($self->{'file'});
@{$self->{'users_array'}} = $self->list_auth_users($self->{'file'});

$self->{'user'} = $self->{'users_array'}->[$self->{'in_hash'}->{'index'}];
if ($self->{'in_hash'}->{'delete'}) {
	$self->replace_file_line($self->{'file'}, $self->{'user'}->{'line'});
	}
else {
	$self->{'whatfailed'} = $self->{'text_hash'}->{'suser_ftsu'};
	$self->{'in_hash'}->{'user'} =~ /^[^:\s]+$/ || $self->error($self->{'text_hash'}->{'suser_emsg1'});
	$self->{'salt'} = substr(time(), -2);
	local ($same) = grep { $_->{'user'} eq $self->{'in_hash'}->{'user'} } @{$self->{'users_array'}};
	if ($self->{'in_hash'}->{'new'}) {
		!$same || $self->error($self->{'text_hash'}->{'suser_etaken'});
		$self->open_tempfile(FILE, ">>$self->{'file'}");
		$self->print_tempfile(FILE, $self->{'in_hash'}->{'user'},":",$self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'}),"\n");
		$self->close_tempfile(FILE);
		}
	else {
		!$same || $same->{'user'} eq $self->{'user'}->{'user'} ||
			 $self->error($self->{'text_hash'}->{'suser_etaken'});
		$self->{'pass'} = $self->{'in_hash'}->{'pass_def'} ? $self->{'user'}->{'pass'}
					: $self->unix_crypt($self->{'in_hash'}->{'pass'}, $self->{'salt'});
		$self->replace_file_line($self->{'file'}, $self->{'user'}->{'line'},
				   "$self->{'in_hash'}->{'user'}:$self->{'pass'}\n");
		}
	}
$self->unlock_file($self->{'file'});
$self->webmin_log($self->{'in_hash'}->{'delete'} ? 'delete' : $self->{'in_hash'}->{'new'} ? 'create' : 'modify',
	    'user', $self->{'in_hash'}->{'user'} ? $self->{'in_hash'}->{'user'} : $self->{'user'}->{'user'});
$self->redirect("edit_auth.cgi");

1;
		
}


1;

