#!/usr/bin/perl
package sshd::Backup_config;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sshd::Backup_config');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sshd::SshdLib");
$self = new sshd::SshdLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# backup_config_files()
# Returns files and directories that can be backed up
sub backup_config_files
{
	my $self = shift;

local @rv = ( $self->{'config_hash'}->{'sshd_config'}, $self->{'config_hash'}->{'client_config'} );
if ($self->{'config_hash'}->{'sshd_config'} =~ /^(.*)\//) {
	local $sshd_dir = $1;
	opendir(DIR, $sshd_dir);
	local $f;
	foreach $f (readdir(DIR)) {
		next if ($f eq "." || $f eq ".." || $f =~ /\.rpmsave$/i);
		push(@rv, "$sshd_dir/$f");
		}
	closedir(DIR);
	}
return $self->unique(@rv);
}

# pre_backup(&files)
# Called before the files are actually read
sub pre_backup
{
	my $self = shift;

return undef;
}

# post_backup(&files)
# Called after the files are actually read
sub post_backup
{
	my $self = shift;

return undef;
}

# pre_restore(&files)
# Called before the files are restored from a backup
sub pre_restore
{
	my $self = shift;

return undef;
}

# post_restore(&files)
# Called after the files are restored from a backup
sub post_restore
{
	my $self = shift;

return $self->restart_sshd();
}


1;

