#!/usr/bin/perl
package sshd::Useradmin_update;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'sshd::Useradmin_update');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "sshd::SshdLib");
$self = new sshd::SshdLib:: ref($self), %$self; 

1;

1;
		return $self;
}

# useradmin_create_user(&details)
# Setup SSH and GNUPG for new users
sub useradmin_create_user
{
	my $self = shift;

if ($self->{'config_hash'}->{'sync_create'} && $self->has_command($self->{'config_hash'}->{'keygen_path'}) &&
    -d $_[0]->{'home'} && !-d "$_[0]->{'home'}/.ssh") {
	local $cmd;
	local $type = $self->{'config_hash'}->{'sync_type'} ? "-t $self->{'config_hash'}->{'sync_type'}" :
		      $self->{'version_hash'}->{'type'} eq 'openssh' &&
		       $self->{'version_hash'}->{'number'} >= 3.2 ? "-t rsa1" : "";
	if ($self->{'config_hash'}->{'sync_pass'} && $_[0]->{'passmode'} == 3) {
		$cmd = "$self->{'config_hash'}->{'keygen_path'} $type -P \"$_[0]->{'plainpass'}\"";
		}
	else {
		$cmd = "$self->{'config_hash'}->{'keygen_path'} $type -P \"\"";
		}
	$self->system_logged("echo '' | su $_[0]->{'user'} -c '$cmd' >/dev/null 2>&1");
	if ($self->{'config_hash'}->{'sync_auth'}) {
		if (-r "$_[0]->{'home'}/.ssh/identity.pub") {
			$self->system_logged("cp $_[0]->{'home'}/.ssh/identity.pub $_[0]->{'home'}/.ssh/authorized_keys");
			}
		else {
			$self->system_logged("cp $_[0]->{'home'}/.ssh/id_dsa.pub $_[0]->{'home'}/.ssh/authorized_keys");
			}
		$self->system_logged("chown $_[0]->{'uid'}:$_[0]->{'gid'} $_[0]->{'home'}/.ssh/authorized_keys");
		}
	}
}

# useradmin_delete_user(&details)
sub useradmin_delete_user
{
	my $self = shift;

}

# useradmin_modify_user(&details)
sub useradmin_modify_user
{
	my $self = shift;

}


1;

