#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_users.cgi
# Display user and group related SSHd options

&ModuleLoader::preload_module('sshd_class', "sshd::SshdLib");
$self = new sshd::SshdLib:: 'sshd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'users_title'}, "", "users");
$self->{'conf'} = $self->get_sshd_config();

print "<form action=save_users.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'users_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'expire'} = $self->find_value("AccountExpireWarningDays", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_expire'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=expire_def value=1 %s> %s\n",
		$self->{'expire'} ? "" : "checked", $self->{'text_hash'}->{'users_expire_def'};
	printf "<input type=radio name=expire_def value=0 %s>\n",
		$self->{'expire'} ? "checked" : "";
	print "<input name=expire size=3 value='$self->{'expire'}'></td>\n";
	$self->ecmd();
	}

$self->{'mail'} = $self->find_value("CheckMail", $self->{'conf'});
if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	$self->scmd();
	print "<td><b>$self->{'text_hash'}->{'users_mail'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=mail value=1 %s> %s\n",
		lc($self->{'mail'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=mail value=0 %s> %s</td>\n",
		lc($self->{'mail'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}
elsif ($self->{'version_hash'}->{'number'} < 3.1) {
	$self->scmd();
	print "<td><b>$self->{'text_hash'}->{'users_mail'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=mail value=1 %s> %s\n",
		lc($self->{'mail'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=mail value=0 %s> %s</td>\n",
		lc($self->{'mail'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

# XXX are these supported?
#$empty = $self->find_value("ForcedEmptyPasswdChange", $self->{'conf'});
#print "<tr> <td><b>$self->{'text_hash'}->{'users_empty'}</b></td> <td>\n";
#printf "<input type=radio name=empty value=1 %s> %s\n",
#	lc($empty) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
#printf "<input type=radio name=empty value=0 %s> %s</td>\n",
#	lc($empty) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};

#$passwd = $self->find_value("ForcedPasswdChange", $self->{'conf'});
#print "<td><b>$self->{'text_hash'}->{'users_passwd'}</b></td> <td>\n";
#printf "<input type=radio name=passwd value=1 %s> %s\n",
#	lc($passwd) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
#printf "<input type=radio name=passwd value=0 %s> %s</td> </tr>\n",
#	lc($passwd) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};

if ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'pexpire'} = $self->find_value("PasswordExpireWarningDays", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_pexpire'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=pexpire_def value=1 %s> %s\n",
		$self->{'pexpire'} ? "" : "checked", $self->{'text_hash'}->{'users_pexpire_def'};
	printf "<input type=radio name=pexpire_def value=0 %s>\n",
		$self->{'pexpire'} ? "checked" : "";
	print "<input name=pexpire size=3 value='$self->{'pexpire'}'></td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 3) {
	$self->scmd();
	$self->{'auth'} = $self->find_value("PasswordAuthentication", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_auth'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=auth value=1 %s> %s\n",
		lc($self->{'auth'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=auth value=0 %s> %s</td>\n",
		lc($self->{'auth'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

$self->scmd();
$self->{'pempty'} = $self->find_value("PermitEmptyPasswords", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'users_pempty'}</b></td> <td nowrap>\n";
if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	printf "<input type=radio name=pempty value=1 %s> %s\n",
		lc($self->{'pempty'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=pempty value=0 %s> %s</td>\n",
		lc($self->{'pempty'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	}
else {
	printf "<input type=radio name=pempty value=1 %s> %s\n",
		lc($self->{'pempty'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=pempty value=0 %s> %s</td>\n",
		lc($self->{'pempty'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	}
$self->ecmd();

$self->scmd();
$self->{'root'} = $self->find_value("PermitRootLogin", $self->{'conf'});
if (!$self->{'root'}) {
	# Default ways seems to be 'yes'
	$self->{'root'} = "yes";
	}
print "<td><b>$self->{'text_hash'}->{'users_root'}</b></td> <td nowrap><select name=root>\n";
printf "<option value=yes %s> %s\n",
	lc($self->{'root'}) eq 'yes' || !$self->{'root'} ? "selected" : "", $self->{'text_hash'}->{'yes'};
printf "<option value=no %s> %s\n",
	lc($self->{'root'}) eq 'no' ? "selected" : "", $self->{'text_hash'}->{'no'};
if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	printf "<option value=nopwd %s> %s\n",
		lc($self->{'root'}) eq 'nopwd' ? "selected" : "", $self->{'text_hash'}->{'users_nopwd'};
	}
else {
	printf "<option value=without-password %s> %s\n",
		lc($self->{'root'}) eq 'without-password' ? "selected" : "",
		$self->{'text_hash'}->{'users_nopwd'};
	if ($self->{'version_hash'}->{'number'} >= 2) {
		printf "<option value=forced-commands-only %s> %s\n",
			lc($self->{'root'}) eq 'forced-commands-only' ? "selected" : "",
			$self->{'text_hash'}->{'users_fcmd'};
		}
	}
print "</select></td>\n";
$self->ecmd();

if ($self->{'version_hash'}->{'type'} ne 'ssh' || $self->{'version_hash'}->{'number'} < 3) {
	$self->scmd();
	$self->{'rsa'} = $self->find_value("RSAAuthentication", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_rsa'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=rsa value=1 %s> %s\n",
		lc($self->{'rsa'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=rsa value=0 %s> %s</td>\n",
		lc($self->{'rsa'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	$self->ecmd();
	}

$self->scmd();
$self->{'strict'} = $self->find_value("StrictModes", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'users_strict'}</b></td> <td nowrap>\n";
printf "<input type=radio name=strict value=1 %s> %s\n",
	lc($self->{'strict'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=strict value=0 %s> %s</td>\n",
	lc($self->{'strict'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
$self->ecmd();

$self->scmd();
$self->{'motd'} = $self->find_value("PrintMotd", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'users_motd'}</b></td> <td nowrap>\n";
printf "<input type=radio name=motd value=1 %s> %s\n",
	lc($self->{'motd'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=motd value=0 %s> %s</td>\n",
	lc($self->{'motd'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'openssh') {
	$self->scmd();
	$self->{'known'} = $self->find_value("IgnoreUserKnownHosts", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_known'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=known value=1 %s> %s\n",
		lc($self->{'known'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=known value=0 %s> %s</td>\n",
		lc($self->{'known'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();

	if ($self->{'version_hash'}->{'number'} > 2.3) {
		$self->scmd(1);
		$self->{'banner'} = $self->find_value("Banner", $self->{'conf'});
		print "<td><b>$self->{'text_hash'}->{'users_banner'}</b></td> <td colspan=3>\n";
		printf "<input type=radio name=banner_def value=1 %s> %s\n",
			$self->{'banner'} ? "" : "checked", $self->{'text_hash'}->{'users_banner_def'};
		printf "<input type=radio name=banner_def value=0 %s>\n",
			$self->{'banner'} ? "checked" : "";
		print "<input name=banner size=40 value='$self->{'banner'}'>\n",
		      $self->file_chooser_button("banner"),"</td>\n";
		$self->ecmd();
		}
	}
elsif ($self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} >= 2) {
	$self->scmd(1);
	$self->{'banner'} = $self->find_value("BannerMessageFile", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_banner'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=banner_def value=1 %s> %s\n",
		$self->{'banner'} ? "" : "checked", $self->{'text_hash'}->{'users_banner_def'};
	printf "<input type=radio name=banner_def value=0 %s>\n",
		$self->{'banner'} ? "checked" : "";
	print "<input name=banner size=40 value='$self->{'banner'}'>\n",
	      $self->file_chooser_button("banner"),"</td>\n";
	$self->ecmd();
	}

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} >= 3) {
	$self->scmd(1);
	$self->{'authkeys'} = $self->find_value("AuthorizedKeysFile", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_authkeys'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=authkeys_def value=1 %s> %s\n",
		$self->{'authkeys'} ? "" : "checked", $self->{'text_hash'}->{'users_authkeys_def'};
	printf "<input type=radio name=authkeys_def value=0 %s>\n",
		$self->{'authkeys'} ? "checked" : "";
	print "<input name=authkeys size=40 value='$self->{'authkeys'}'></td>\n";
	$self->ecmd();
	}

$self->scmd(1);
print "<td colspan=4><hr></td>\n";
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'openssh' && $self->{'version_hash'}->{'number'} < 3.7 ||
    $self->{'version_hash'}->{'type'} eq 'ssh' && $self->{'version_hash'}->{'number'} < 2) {
	$self->scmd();
	$self->{'rhostsauth'} = $self->find_value("RhostsAuthentication", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_rhostsauth'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=rhostsauth value=1 %s> %s\n",
		lc($self->{'rhostsauth'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=rhostsauth value=0 %s> %s</td>\n",
		lc($self->{'rhostsauth'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	$self->ecmd();

	$self->scmd();
	$self->{'rhostsrsa'} = $self->find_value("RhostsRSAAuthentication", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_rhostsrsa'}</b></td> <td nowrap>\n";
	if ($self->{'version_hash'}->{'type'} eq 'ssh') {
		printf "<input type=radio name=rhostsrsa value=1 %s> %s\n",
			lc($self->{'rhostsrsa'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
		printf "<input type=radio name=rhostsrsa value=0 %s> %s</td>\n",
			lc($self->{'rhostsrsa'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
		}
	else {
		printf "<input type=radio name=rhostsrsa value=1 %s> %s\n",
			lc($self->{'rhostsrsa'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
		printf "<input type=radio name=rhostsrsa value=0 %s> %s</td>\n",
			lc($self->{'rhostsrsa'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
		}
	$self->ecmd();
	}

$self->scmd();
$self->{'rhosts'} = $self->find_value("IgnoreRhosts", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'users_rhosts'}</b></td> <td nowrap>\n";
if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	printf "<input type=radio name=rhosts value=1 %s> %s\n",
		lc($self->{'rhosts'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=rhosts value=0 %s> %s</td>\n",
		lc($self->{'rhosts'}) eq 'yes' ? "" : "checked", $self->{'text_hash'}->{'no'};
	}
else {
	printf "<input type=radio name=rhosts value=1 %s> %s\n",
		lc($self->{'rhosts'}) eq 'no' ? "" : "checked", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=rhosts value=0 %s> %s</td>\n",
		lc($self->{'rhosts'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	}
$self->ecmd();

if ($self->{'version_hash'}->{'type'} eq 'ssh') {
	$self->scmd(1);
	$self->{'rrhosts'} = $self->find_value("IgnoreRootRhosts", $self->{'conf'});
	print "<td><b>$self->{'text_hash'}->{'users_rrhosts'}</b></td> <td nowrap>\n";
	printf "<input type=radio name=rrhosts value=1 %s> %s\n",
		lc($self->{'rrhosts'}) eq 'yes' ? "checked" : "", $self->{'text_hash'}->{'yes'};
	printf "<input type=radio name=rrhosts value=0 %s> %s\n",
		lc($self->{'rrhosts'}) eq 'no' ? "checked" : "", $self->{'text_hash'}->{'no'};
	printf "<input type=radio name=rrhosts value=-1 %s> %s</td>\n",
		$self->{'rrhosts'} ? "" : "checked", $self->{'text_hash'}->{'users_rrdef'};
	$self->ecmd();
	}

print "</table></td></tr></table>\n";
print "<input type=submit value='$self->{'text_hash'}->{'save'}'></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

