#!/usr/bin/perl
package status::Filemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Filemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# file-monitor.pl
# Check the status of some file

1;
		return $self;
}

sub get_file_status
{
	my $self = shift;

local @st = stat($_[0]->{'file'});
local $size;
if ($_[0]->{'test'} >= 2) {
	$size = -d $_[0]->{'file'} ? $self->disk_usage_kb($_[0]->{'file'})*1024
				   : $st[7];
	}
if ($_[0]->{'test'} == 0) {
	$self->{'up'} = @st ? 1 : 0;
	}
elsif ($_[0]->{'test'} == 1) {
	$self->{'up'} = @st ? 0 : 1;
	}
elsif ($_[0]->{'test'} == 2) {
	$self->{'up'} = $size > $_[0]->{'greater'} ? 1 : 0;
	}
elsif ($_[0]->{'test'} == 3) {
	$self->{'up'} = $size < $_[0]->{'lesser'} ? 1 : 0;
	}
return { 'up' => $self->{'up'} };
}

sub show_file_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'file_file'},
	$self->ui_textbox("file", $_[0]->{'file'}, 50), 3);

print $self->ui_table_row($self->{'text_hash'}->{'file_test'},
	$self->ui_radio("test", int($_[0]->{'test'}),
		[ [ 0, $self->{'text_hash'}->{'file_test_0'}."<br>" ],
		  [ 1, $self->{'text_hash'}->{'file_test_1'}."<br>" ],
		  [ 2, $self->{'text_hash'}->{'file_test_2'}.
		       $self->ui_textbox("greater", $_[0]->{'greater'}, 10)." ".
		       $self->{'text_hash'}->{'file_bytes'}."<br>" ],
		  [ 2, $self->{'text_hash'}->{'file_test_3'}.
		       $self->ui_textbox("lesser", $_[0]->{'lesser'}, 10)." ".
		       $self->{'text_hash'}->{'file_bytes'}."<br>" ] ]), 3);
}

sub parse_file_dialog
{
	my $self = shift;

$self->{'in_hash'}->{'file'} || $self->error($self->{'text_hash'}->{'file_efile'});
$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
$_[0]->{'test'} = $self->{'in_hash'}->{'test'};
$self->{'in_hash'}->{'greater'} =~ /^\d*$/ && $self->{'in_hash'}->{'lesser'} =~ /^\d*$/ ||
	$self->error($self->{'text_hash'}->{'file_esize'});
$_[0]->{'greater'} = $self->{'in_hash'}->{'greater'};
$_[0]->{'lesser'} = $self->{'in_hash'}->{'lesser'};
}


1;

