#!/usr/bin/perl
package status::Ifacemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Ifacemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# iface-monitor.pl
# Check if a network interface is up or down

1;
		return $self;
}

sub get_iface_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("net"));
$self->foreign_require("net", "net-lib.pl");
local @act = $main::net_object->active_interfaces();
local $a;
foreach $a (@act) {
	if ($a->{'fullname'} eq $_[0]->{'iface'} &&
	    $a->{'up'}) {
		return { 'up' => 1 };
		}
	}
return { 'up' => 0 };
}

sub show_iface_dialog
{
	my $self = shift;

$self->foreign_require("net", "net-lib.pl");
local %done;
local @ifaces = grep { !$done{$_->{'fullname'}}++ }
		  sort { $a->{'fullname'} cmp $b->{'fullname'} }
		     ($main::net_object->boot_interfaces(), $main::net_object->active_interfaces());
print $self->ui_table_row($self->{'text_hash'}->{'iface_iface'},
	$self->ui_select("iface", $_[0]->{'iface'},
	   [ map { [ $_->{'fullname'},
		     $_->{'fullname'}.
		     " (".$main::net_object->iface_type($_->{'fullname'}).")" ] } @ifaces]));
}

sub parse_iface_dialog
{
	my $self = shift;

$self->depends_check($_[0], "net");
$_[0]->{'iface'} = $self->{'in_hash'}->{'iface'};
}


1;

