#!/usr/bin/perl
package status::Inetdmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Inetdmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# inetd-monitor.pl
# Monitor inetd on this host

1;

1;
		return $self;
}

sub get_inetd_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("proc"));
$self->foreign_require("proc", "proc-lib.pl");
local %iconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $iconfig{'inetd_conf_file'});
return { 'up' => $self->find_named_process('inetd$') ? 1 : 0 };
}

sub parse_inetd_dialog
{
	my $self = shift;

$self->depends_check($_[0], "inetd", "proc");
}


1;

