#!/usr/bin/perl
package status::Memorymonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Memorymonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# memory-monitor.pl
# Check the free memory

1;
		return $self;
}

sub get_memory_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check("proc"));
$self->foreign_require("proc", "proc-lib.pl");
local @mem;
eval "\@mem = $main::proc_object->get_memory_info()";
if ($@) {
	return { 'up' => -1 };
	}
elsif ($mem[1] < $_[0]->{'min'}) {
	return { 'up' => 0 };
	}
else {
	return { 'up' => 1,
		 'desc' => $self->text('memory_free2', $self->nice_size($mem[1]*1024)) };
	}
}

sub show_memory_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'memory_min2'},
	$self->ui_bytesbox("min", $_[0]->{'min'}*1024));
}

sub parse_memory_dialog
{
	my $self = shift;

$self->depends_check($_[0], "proc");
$self->foreign_require("proc", "proc-lib.pl");
$main::proc_object->UNIVERSAL::can("get_memory_info") || $self->error($self->{'text_hash'}->{'memory_eproc'});
$self->{'in_hash'}->{'min'} =~ /^[0-9\.]+$/ || $self->error($self->{'text_hash'}->{'memory_emin'});
$_[0]->{'min'} = $self->{'in_hash'}->{'min'}*$self->{'in_hash'}->{'min_units'}/1024;
}


1;

