#!/usr/bin/perl
package status::Monmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Monmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# mon-monitor.pl
# Monitor the mon daemon on this host

1;

1;
		return $self;
}

# Check the PID file to see if mon is running
sub get_mon_status
{
	my $self = shift;

local %mconfig = $self->foreign_config($_[1]);
-d $mconfig{'cfbasedir'} || return { 'up' => -1 };
local $pid;
if (open(PID, $mconfig{'pid_file'}) && chop($pid = <PID>) && kill(0, $pid)) {
	return { 'up' => 1 };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_mon_dialog
{
	my $self = shift;

$self->depends_check($_[0], "mon");
}


1;

