#!/usr/bin/perl
package status::Oldfilemonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Oldfilemonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# oldfile-monitor.pl
# Check if some file has not been changed lately

1;
		return $self;
}

sub get_oldfile_status
{
	my $self = shift;

local %change;
local @st = stat($_[0]->{'file'});
if (!@st) {
	# File doesn't exist!
	return { 'up' => -1 };
	}
elsif ($st[9] < time()-$_[0]->{'diff'}) {
	# File hasn't been changed lately
	return { 'up' => 0 };
	}
else {
	# File has been changed lately
	return { 'up' => 1 };
	}
}

sub show_oldfile_dialog
{
	my $self = shift;

print $self->ui_table_row($self->{'text_hash'}->{'oldfile_file'},
	$self->ui_textbox("file", $_[0]->{'file'}, 50)." ".
	$self->file_chooser_button("file", 0), 3);

print $self->ui_table_row($self->{'text_hash'}->{'oldfile_diff'},
	$self->ui_textbox("diff", $_[0]->{'diff'}, 10)." ".$self->{'text_hash'}->{'oldfile_secs'});
}

sub parse_oldfile_dialog
{
	my $self = shift;

$_[0]->{'file'} = $self->{'in_hash'}->{'file'};
$_[0]->{'diff'} = $self->{'in_hash'}->{'diff'};
}


1;

