#!/usr/bin/perl
package status::Postgresqlmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Postgresqlmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# postgresql-monitor.pl
# Monitor the PostgreSQL server on this host

1;
		return $self;
}

# Check if postgresql is running
sub get_postgresql_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "postgresql-lib.pl");
local %pconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-x $pconfig{'psql'});
local $r = $self->foreign_call($_[1], "is_postgresql_running");
return { 'up' => $r ? 1 : 0 };
}

sub parse_postgresql_dialog
{
	my $self = shift;

$self->depends_check($_[0], "postgresql");
}


1;

