#!/usr/bin/perl
package status::Sambamonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Sambamonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# samba-monitor.pl
# Monitor the samba servers on this host

1;

1;
		return $self;
}

# Check if samba is running
sub get_samba_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "samba-lib.pl");
local %sconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-x $sconfig{'samba_server'});
local $r = $self->foreign_call($_[1], "is_samba_running");
return { 'up' => $r ? 1 : 0 };
}

sub parse_samba_dialog
{
	my $self = shift;

$self->depends_check($_[0], "samba");
}


1;

