#!/usr/bin/perl
package status::Sshdmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Sshdmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# sshd-monitor.pl
# Monitor the SSH server on this host

1;

1;
		return $self;
}

# Check the PID file to see if sshd is running
sub get_sshd_status
{
	my $self = shift;

return { 'up' => -1 } if (!$self->foreign_check($_[1]));
$self->foreign_require($_[1], "sshd-lib.pl");
return { 'up' => -1 } if (!$self->foreign_check($_[1]));
local %sconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $sconfig{'sshd_config'});
local $conf = $self->foreign_call($_[1], "get_sshd_config");
local $pidfile = $self->foreign_call($_[1], "find_value", "PidFile", $conf);
$pidfile ||= $sconfig{'pid_file'};
if (open(PID, $pidfile) && <PID> =~ /(\d+)/ && kill(0, $1)) {
	close(PID);
	local @st = stat($pidfile);
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_sshd_dialog
{
	my $self = shift;

$self->depends_check($_[0], "sshd");
}


1;

