#!/usr/bin/perl
package status::Xinetdmonitor;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'status::Xinetdmonitor');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# xinetd-monitor.pl
# Monitor xinetd on this host

1;

1;
		return $self;
}

sub get_xinetd_status
{
	my $self = shift;

local %xconfig = $self->foreign_config($_[1]);
return { 'up' => -1 } if (!-r $xconfig{'xinetd_conf'});
if (open(PID, $xconfig{'pid_file'}) && <PID> =~ /(\d+)/ && kill(0, $1)) {
	close(PID);
	local @st = stat($xconfig{'pid_file'});
	return { 'up' => 1,
		 'desc' => $self->text('up_since', scalar(localtime($st[9]))) };
	}
return { 'up' => 0 };
}

sub parse_xinetd_dialog
{
	my $self = shift;

$self->depends_check($_[0], "xinetd");
}


1;

