#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete several SSL tunnels

&ModuleLoader::preload_module('stunnel_class', "stunnel::StunnelLib");
$self = new stunnel::StunnelLib:: 'stunnel_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'delete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'delete_enone'});

# Do the deletions
@{$self->{'stunnels_array'}} = $self->list_stunnels();
foreach $d (sort { $b <=> $a } @d) {
	$self->{'st'} = $self->{'stunnels_array'}->[$d];
	$self->lock_file($self->{'st'}->{'file'});
	if ($self->get_stunnel_version(\$self->{'dummy'}) >= 4) {
		if ($self->{'st'}->{'args'} =~ /^(\S+)\s+(\S+)/) {
			$self->{'cfile'} = $2;
			if ($self->{'cfile'} =~ /^\Q$self->{'module_config_directory'}\E\//) {
				$self->lock_file($self->{'cfile'});
				unlink($self->{'cfile'});
				}
			}
		}
	$self->delete_stunnel($self->{'st'});
	}

$self->unlock_all_files();
$self->webmin_log("delete", "stunnels", scalar(@d));
$self->redirect("");

1;
		
}


1;

