#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi

&ModuleLoader::preload_module('swup_class', "swup::SwupLib");
$self = new swup::SwupLib:: 'swup_class',%$self;


$self->ReadParse();

# check if swup is installed
$self->check_swup_path();

# check if rpm is installed
$self->check_rpm_path();

$| = 1;
$self->{'pkg'} = $self->{'in_hash'}->{pkg};
if ($self->{'in_hash'}->{'do_uninstall'} && $self->{'pkg'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'uninstall_pkg_title'}, "", "intro", 1, 1, 0, undef, undef, undef);
	print "<table width=100% border>";
	print "<tr><td><h3>" . $self->text('uninstall_pkg_uninstalling', uc($self->{'pkg'})) . "</h3></td></tr>\n";
	$self->uninstall_package($self->{'in_hash'}->{pkg});
	#print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{info_status}</b></td></tr>";
	#print "<tr $tc><td>" . $self->text($code ? 'info_uninstall_failure' : 'info_uninstall_done', uc($self->{'pkg'})) . "</td></tr>";
	#print "<tr><td>&nbsp;</td></tr>\n";
	#print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{info_message}</b></td></tr>\n";
	#print "<tr $tc><td><pre>$out</pre></td></tr>\n";
	print "</table>";
	print "<hr>\n";
	$self->ui_print_footer('', $self->{'text_hash'}->{index_return});
	exit 0;
}
elsif ($self->{'in_hash'}->{'do_upgrade'} && $self->{'pkg'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'upgrade_pkg_title'}, "", "intro", 1, 1, 0, undef, undef, undef);
	print "<table width=100% border>";
	print "<tr><td><h3>" . $self->text('upgrade_pkg_upgrading', uc($self->{'pkg'})) . "</h3></td></tr>\n";
	$self->upgrade_package($self->{'in_hash'}->{pkg});
	#print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{info_status}</b></td></tr>";
	#print "<tr $tc><td>" . $self->text($code ? 'info_upgrade_failure' : 'info_upgrade_done', uc($self->{'pkg'})) . "</td></tr>";
	#print "<tr><td>&nbsp;</td></tr>\n";
	#print "<tr $self->{'tb'}><td><b>$self->{'text_hash'}->{info_message}</b></td></tr>\n";
	#print "<tr $tc><td><pre>$out</pre></td></tr>\n";
	print "</table>";
	print "<hr>\n";
	$self->ui_print_footer('', $self->{'text_hash'}->{index_return});
	exit 0;
}

$self->ui_print_header(undef, $self->{'text_hash'}->{'info_title'}, "", "intro", 1, 1, 0, undef, undef, undef);

local ($info, $out) = $self->get_package_desc($self->{'in_hash'}->{pkg});

$self->{'pkg'} = $self->html_escape($self->{'in_hash'}->{pkg});
print
"<form action='package_info.cgi' method=post>
<input type=hidden value='$self->{'pkg'}' name=pkg>
<table border width=100%>
<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{'info_summary'}</b></td></tr>
<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{info_name}</b></td><td align=left>$info->{name}</td></tr>
<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{info_version}</b></td><td align=left>$info->{version}</td></tr>
<tr $self->{'cb'}><td><b>$self->{'text_hash'}->{info_installed_on}</b></td align=left><td>$info->{installtime}</td></tr>
<tr><td colspan=2>&nbsp;</td></tr>
<tr $self->{'tb'}><td colspan=2><b>$self->{'text_hash'}->{info_description}</b></td></tr>
<tr $self->{'cb'}><td colspan=2><pre>$out</pre></td></tr>
<tr>
<td colspan=2><input type=submit name=do_uninstall value='$self->{'text_hash'}->{info_uninstall}'>&nbsp;
<input type=submit name=do_upgrade value='$self->{'text_hash'}->{info_upgrade}'></td>
</tr>
</table>
</form>
";

print "<hr>";
$self->ui_print_footer("", $self->{'text_hash'}->{index_return});
1;
		
}


1;

