#!/usr/bin/perl
package syslog::Log_parser;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'syslog::Log_parser');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;
# log_parser.pl
# Functions for parsing this module's logs

&ModuleLoader::preload_module(ref($self), "syslog::SyslogLib");
$self = new syslog::SyslogLib:: ref($self), %$self; 

1;
		return $self;
}

# parse_webmin_log(user, script, action, type, object, &params)
# Converts logged information from this module into human-readable form
sub parse_webmin_log
{
	my $self = shift;

local ($user, $script, $action, $type, $object, $p) = @_;
$object = $self->html_escape($object);
if ($action eq 'modify') {
	return $self->text('log_modify', "<tt>$object</tt>");
	}
elsif ($action eq 'create') {
	return $self->text('log_create', "<tt>$object</tt>");
	}
elsif ($action eq 'delete') {
	return $self->text('log_delete', "<tt>$object</tt>");
	}
elsif ($action eq 'apply') {
	return $self->{'text_hash'}->{'log_apply'};
	}
elsif ($action eq 'start') {
	return $self->{'text_hash'}->{'log_start'};
	}
else {
	return undef;
	}
}


1;

