#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_log.cgi
# Display a form for editing or creating a new log destination

&ModuleLoader::preload_module('syslog_class', "syslog::SyslogLib");
$self = new syslog::SyslogLib:: 'syslog_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'noedit'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'access_hash'}->{'syslog'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
$self->{'conf'} = $self->get_config();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'create_title'}, "");
	$self->{'log'} = { 'active' => '1',
		 'sync' => 1,
		 'file' => -d '/var/log' ? '/var/log/' :
			   -d '/var/adm' ? '/var/adm/' : undef };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title'}, "");
	$self->{'log'} = $self->{'conf'}->[$self->{'in_hash'}->{'idx'}];
	$self->can_edit_log($self->{'log'}) || $self->error($self->{'text_hash'}->{'edit_ecannot2'});
	}

# Log destination section
print "<form action=save_log.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_logto'}</b></td>\n";
printf "<td><input type=radio name=mode value=0 %s> %s</td>\n",
	$self->{'log'}->{'file'} ? 'checked' : '', $self->{'text_hash'}->{'edit_file'};
printf "<td><input name=file size=40 value='%s'> %s\n",
	$self->{'log'}->{'file'}, $self->file_chooser_button("file");
if ($self->{'config_hash'}->{'sync'}) {
	printf "<input type=checkbox name=sync value=1 %s> %s\n",
		$self->{'log'}->{'sync'} ? 'checked' : '', $self->{'text_hash'}->{'edit_sync'};
	}
print "</td> </tr>\n";

if ($self->{'config_hash'}->{'pipe'} == 1) {
	print "<tr> <td></td>\n";
	printf "<td><input type=radio name=mode value=1 %s> %s</td>\n",
		$self->{'log'}->{'pipe'} ? 'checked' : '', $self->{'text_hash'}->{'edit_pipe'};
	printf "<td><input name=pipe size=40 value='%s'> %s</td> </tr>\n",
		$self->{'log'}->{'pipe'}, $self->file_chooser_button("pipe");
	}
elsif ($self->{'config_hash'}->{'pipe'} == 2) {
	print "<tr> <td></td>\n";
	printf "<td><input type=radio name=mode value=1 %s> %s</td>\n",
		$self->{'log'}->{'pipe'} ? 'checked' : '', $self->{'text_hash'}->{'edit_pipe2'};
	printf "<td><input name=pipe size=40 value='%s'></td> </tr>\n",
		$self->{'log'}->{'pipe'};
	}

if ($self->{'config_hash'}->{'socket'}) {
	print "<tr> <td></td>\n";
	printf "<td><input type=radio name=mode value=5 %s> %s</td>\n",
		$self->{'log'}->{'socket'} ? 'checked' : '', $self->{'text_hash'}->{'edit_socket'};
	printf "<td><input name=socket size=40 value='%s'> %s</td> </tr>\n",
		$self->{'log'}->{'socket'}, $self->file_chooser_button("socket");
	}

print "<tr> <td></td>\n";
printf "<td><input type=radio name=mode value=2 %s> %s</td>\n",
	$self->{'log'}->{'host'} ? 'checked' : '', $self->{'text_hash'}->{'edit_host'};
printf "<td><input name=host size=20 value='%s'></td> </tr>\n",
	$self->{'log'}->{'host'};

print "<tr> <td></td>\n";
printf "<td><input type=radio name=mode value=3 %s> %s</td>\n",
	$self->{'log'}->{'users'} ? 'checked' : '', $self->{'text_hash'}->{'edit_users'};
printf "<td><input name=users size=40 value='%s'> %s</td> </tr>\n",
	join(" ", @{$self->{'log'}->{'users'}}), $self->user_chooser_button("users", 1);

print "<tr> <td></td>\n";
printf "<td colspan=2><input type=radio name=mode value=4 %s> %s</td> </tr>\n",
	$self->{'log'}->{'all'} ? 'checked' : '', $self->{'text_hash'}->{'edit_allusers'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_active'}</b></td> <td colspan=2>\n";
printf "<input type=radio name=active value=1 %s> %s\n",
	$self->{'log'}->{'active'} ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=active value=0 %s> %s</td> </tr>\n",
	$self->{'log'}->{'active'} ? '' : 'checked', $self->{'text_hash'}->{'no'};

if ($self->{'config_hash'}->{'tags'}) {
	print "<tr> <td><b>$self->{'text_hash'}->{'edit_tag'}</b></td> <td colspan=2>\n";
	print "<select name=tag>\n";
	foreach $t (grep { $_->{'tag'} } @{$self->{'conf'}}) {
		printf "<option %s value=%s>%s\n",
			$self->{'log'}->{'section'} eq $t ? 'selected' : '',
			$t->{'index'},
			$t->{'tag'} eq '*' ? $self->{'text_hash'}->{'all'} : $t->{'tag'};
		}
	print "</select></td> </tr>\n";
	}

print "</table></td></tr></table><p>\n";

# Log selection section
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

@{$self->{'facil_array'}} = split(/\s+/, $self->{'config_hash'}->{'facilities'});
print "<tr> <td><b>$self->{'text_hash'}->{'edit_facil'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'edit_pri'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $s (@{$self->{'log'}->{'sel'}}, ".none") {
	($self->{'f'}, $self->{'p'}) = split(/\./, $s);
	$self->{'p'} =~ s/warn$/warning/;
	$self->{'p'} =~ s/panic$/emerg/;
	$self->{'p'} =~ s/error$/err/;

	print "<tr> <td>\n";
	printf "<input type=radio name=fmode_$self->{'i'} value=0 %s>\n",
		$self->{'f'} =~ /,/ ? '' : 'checked';
	print "<select name=facil_$self->{'i'}>\n";
#	printf "<option %s>\n", $self->{'f'} ? '' : 'selected';
	printf "<option value='*' %s>%s\n",
		$self->{'f'} eq '*' ? 'selected' : '', $self->{'text_hash'}->{'edit_all'};
	local $ffound = ($self->{'f'} eq '*');
	foreach $fc (@{$self->{'facil_array'}}) {
		printf "<option %s>%s\n",
			$fc eq $self->{'f'} ? 'selected' : '', $fc;
		$ffound++ if ($fc eq $self->{'f'});
		}
	print "<option selected>$self->{'f'}\n" if (!$ffound && $self->{'f'} !~ /,/);
	print "</select>&nbsp;\n";
	printf "<input type=radio name=fmode_$self->{'i'} value=1 %s> %s\n",
		$self->{'f'} =~ /,/ ? 'checked' : '', $self->{'text_hash'}->{'edit_many'};
	printf "<input name=facils_$self->{'i'} size=25 value='%s'></td>\n",
		$self->{'f'} =~ /,/ ? join(" ", split(/,/, $self->{'f'})) : '';

	print "<td>\n";
	printf "<input type=radio name=pmode_$self->{'i'} value=0 %s> %s&nbsp;\n",
		$self->{'p'} eq 'none' ? 'checked' : '', $self->{'text_hash'}->{'edit_none'};
	if ($self->{'config_hash'}->{'pri_all'}) {
		printf "<input type=radio name=pmode_$self->{'i'} value=1 %s> %s&nbsp;\n",
			$self->{'p'} eq '*' ? 'checked' : '', $self->{'text_hash'}->{'edit_all'};
		}
	printf "<input type=radio name=pmode_$self->{'i'} value=2 %s>\n",
		$self->{'p'} eq 'none' || $self->{'p'} eq '*' ? '' : 'checked';

	if ($self->{'config_hash'}->{'pri_dir'} == 1) {
		print "<select name=pdir_$self->{'i'}>\n";
		printf "<option value='' selected>\n"
			if ($self->{'p'} eq '*' || $self->{'p'} eq 'none');
		printf "<option value='' %s>%s\n",
			$self->{'p'} =~ /\!|=/ ? '' : 'selected', $self->{'text_hash'}->{'edit_pdir0'};
		printf "<option value='=' %s>%s\n",
			$self->{'p'} =~ /^=/ ? 'selected' : '', $self->{'text_hash'}->{'edit_pdir1'};
		printf "<option value='!' %s>%s\n",
			$self->{'p'} =~ /^![^=]/ ? 'selected' : '', $self->{'text_hash'}->{'edit_pdir2'};
		printf "<option value='!=' %s>%s\n",
			$self->{'p'} =~ /^!=/ ? 'selected' : '', $self->{'text_hash'}->{'edit_pdir3'};
		print "</select>\n";
		$self->{'p'} =~ s/^[!=]*//;
		}
	elsif ($self->{'config_hash'}->{'pri_dir'} == 2) {
		print "<select name=pdir_$self->{'i'}>\n";
		printf "<option value='' selected>\n"
			if ($self->{'p'} eq '*' || $self->{'p'} eq 'none');
		local $pfx = $self->{'p'} =~ /^([<=>]+)/ ? $1 : undef;
		printf "<option value='' %s>&gt;=\n",
			$pfx eq '>=' || $pfx eq '=>' || !$pfx ? 'selected' : '';
		printf "<option value='>' %s>&gt;\n",
			$pfx eq '>' ? 'selected' : '';
		printf "<option value='<=' %s>&lt;=\n",
			$pfx eq '<=' || $pfx eq '=<' ? 'selected' : '';
		printf "<option value='<' %s>&lt;\n",
			$pfx eq '<' ? 'selected' : '';
		printf "<option value='<>' %s>&lt;&gt;\n",
			$pfx eq '<>' || $pfx eq '><' ? 'selected' : '';
		print "</select>\n";
		$self->{'p'} =~ s/^[<=>]*//;
		}
	else {
		print $self->{'text_hash'}->{'edit_pdir0'};
		}

	local $pfound = ($self->{'p'} eq '*' || $self->{'p'} eq 'none');
	print "<select name=pri_$self->{'i'}>\n";
	print "<option selected>\n" if ($self->{'p'} eq '*' || $self->{'p'} eq 'none');
	foreach $pr ($self->list_priorities()) {
		printf "<option %s>%s\n",
			$self->{'p'} =~ /$pr/ ? 'selected' : '', $pr;
		$pfound++ if ($self->{'p'} =~ /$pr/);
		}
	print "<option selected>$self->{'p'}\n" if (!$pfound);
	print "</select></td></tr>\n";
	$self->{'i'}++;
	}
print "</table></td></tr></table>\n";

print "<table width=100%><tr>\n";
print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
if (!$self->{'in_hash'}->{'new'}) {
	if ($self->{'log'}->{'file'} && -f $self->{'log'}->{'file'}) {
		print "<td align=center><input type=submit name=view ",
		      "value='$self->{'text_hash'}->{'edit_view'}'></td>\n";
		}
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

