#!/usr/bin/perl

&MAIN();

 sub MAIN {
# m4.cgi
# Pass the syslog config file though m4

&ModuleLoader::preload_module('syslog_class', "syslog::SyslogLib");
$self = new syslog::SyslogLib:: 'syslog_class',%$self;

use Socket;

# is this loghost? Find out by sending a UDP packet to it
socket(UDP, PF_INET, SOCK_DGRAM, getprotobyname("udp"));
setsockopt(UDP, SOL_SOCKET, SO_BROADCAST, pack("l", 1));
$self->{'port'} = 45678;
while(!bind(UDP, pack_sockaddr_in($self->{'port'}, INADDR_ANY))) {
	$self->{'port'}++;
	}
send(UDP, "foo", 0, pack_sockaddr_in($self->{'port'}, inet_aton("loghost")));
vec($self->{'rin'}, fileno(UDP), 1) = 1;
if (select($self->{'rin'}, undef, undef, 1)) {
	$self->{'args'} .= " -DLOGHOST";
	}
close(UDP);

# Run m4
$self->{'oldslash'} = $/;
$/ = undef;
open(CONF, "$self->{'config_hash'}->{'m4_path'} $self->{'args'} $self->{'config_hash'}->{'syslog_conf'} |");
$self->{'conf'} = <CONF>;
close(CONF);
$self->open_tempfile(CONF, ">$self->{'config_hash'}->{'syslog_conf'}");
$self->print_tempfile(CONF, $self->{'conf'});
$self->close_tempfile(CONF);
$/ = $self->{'oldslash'};
$self->redirect("");

1;
		
}


1;

