#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple destinations

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ddelete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'ddelete_enone'});
foreach my $d (@d) {
          $self->check_dependencies('destination', $d) &&
	      $self->error($self->text('ddelete_eused', $d));
	  }

$self->lock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->{'conf'} = $self->get_config();
@{$self->{'dests_array'}} = $self->find("destination", $self->{'conf'});
foreach my $d (@d) {
	($self->{'dest'}) = grep { $_->{'value'} eq $d } @{$self->{'dests_array'}};
	$self->{'dest'} || $self->error($self->{'text_hash'}->{'destination_egone'});
	$self->save_directive($self->{'conf'}, undef, $self->{'dest'}, undef, 0);
	}

$self->unlock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->webmin_log('delete', 'destinations', scalar(@d));
$self->redirect("list_destinations.cgi");
1;
		
}


1;

