#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Delete multiple logs

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'ddelete_err'});
@d = split(/\0/, $self->{'in_hash'}->{'d'});
@d || $self->error($self->{'text_hash'}->{'ddelete_enone'});

$self->lock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->{'conf'} = $self->get_config();
@{$self->{'dests_array'}} = $self->find("log", $self->{'conf'});
foreach my $d (@d) {
	($self->{'dest'}) = grep { $_->{'index'} == $d } @{$self->{'dests_array'}};
	$self->{'dest'} || $self->error($self->{'text_hash'}->{'log_egone'});
	$self->save_directive($self->{'conf'}, undef, $self->{'dest'}, undef, 0);
	}

$self->unlock_file($self->{'config_hash'}->{'syslogng_conf'});
$self->webmin_log('delete', 'logs', scalar(@d));
$self->redirect("list_logs.cgi");
1;
		
}


1;

