#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a form for editing or creating a log target

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ReadParse();

# Show title and get the log
$self->{'conf'} = $self->get_config();
@{$self->{'allsources_array'}} = map { $_->{'value'} } $self->find("source", $self->{'conf'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'log_title1'}, "");
	$self->{'log'} = { 'type' => 1,
	         'members' => [ { 'type' => 0,
				  'name' => 'source',
			          'value' => $self->{'allsources_array'}->[0]->{'value'},
			          'values' => $self->{'allsources_array'}->[0]->{'values'},
				} ] };
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'log_title2'}, "");
	@{$self->{'logs_array'}} = $self->find("log", $self->{'conf'});
	($self->{'log'}) = grep { $_->{'index'} == $self->{'in_hash'}->{'idx'} } @{$self->{'logs_array'}};
	$self->{'log'} || $self->error($self->{'text_hash'}->{'log_egone'});
	}

# Form header
print $self->ui_form_start("save_log.cgi", "post");
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("idx", $self->{'in_hash'}->{'idx'}),"\n";
print $self->ui_table_start($self->{'text_hash'}->{'log_header'}, undef, 4);

# Show sources
@{$self->{'gotsources_array'}} = map { $_->{'value'} } $self->find("source", $self->{'log'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'log_source'},
    $self->ui_select("source", \@{$self->{'gotsources_array'}},
	       [ map { [ $_ ] } @{$self->{'allsources_array'}} ], 5, 1));

# Show flags
$self->{'fdir'} = $self->find("flags", $self->{'log'}->{'members'});
if ($self->{'fdir'}) {
	%{$self->{'flags_hash'}} = map { $_, 1 } @{$self->{'fdir'}->{'values'}};
	}
$self->{'flags'} = "";
foreach $f (@{$self->{'log_flags_array'}}) {
	$self->{'flags'} .= $self->ui_checkbox($f, 1, $self->{'text_hash'}->{'log_'.$f}, $self->{'flags_hash'}->{$f})."<br>\n";
	}
print $self->ui_table_row($self->{'text_hash'}->{'log_flags'}, $self->{'flags'});

# Show filters
@{$self->{'allfilters_array'}} = map { [ $_->{'value'} ] } $self->find("filter", $self->{'conf'});
@{$self->{'gotfilters_array'}} = map { $_->{'value'} } $self->find("filter", $self->{'log'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'log_filter'},
    $self->ui_select("filter", \@{$self->{'gotfilters_array'}}, \@{$self->{'allfilters_array'}}, 10, 1));

# Show destinations
@{$self->{'alldestinations_array'}} = map { [ $_->{'value'}, $_->{'value'}." (".$self->nice_destination_file($_).")" ] } $self->find("destination", $self->{'conf'});
@{$self->{'gotdestinations_array'}} = map { $_->{'value'} } $self->find("destination",$self->{'log'}->{'members'});
print $self->ui_table_row($self->{'text_hash'}->{'log_destination'},
    $self->ui_select("destination", \@{$self->{'gotdestinations_array'}}, \@{$self->{'alldestinations_array'}}, 10, 1));

# Form footer and buttons
print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'create'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "save", $self->{'text_hash'}->{'save'} ],
			     [ "delete", $self->{'text_hash'}->{'delete'} ] ]);
	}
$self->ui_print_footer("list_logs.cgi", $self->{'text_hash'}->{'logs_return'});

1;
		
}


1;

