#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of log files

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'filters_title'}, "", "filters");

$self->{'conf'} = $self->get_config();
@{$self->{'filters_array'}} = $self->find("filter", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_filter.cgi?new=1'>$self->{'text_hash'}->{'filters_add'}</a>" );
if (@{$self->{'filters_array'}}) {
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_form_start("delete_filters.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'filters_name'},
				  $self->{'text_hash'}->{'filters_desc'},
				  ], undef, 0, \@{$self->{'tds_array'}});
	foreach $f (@{$self->{'filters_array'}}) {
		$self->{'desc'} = $self->nice_filter_desc($f);
		if ($self->{'desc'} =~ /^(.*?)([a-z])(.*)/) {
			  $self->{'desc'} = $1.ucfirst($2).$3;
			  }
		print $self->ui_checked_columns_row([
			"<a href='edit_filter.cgi?name=".
			  $self->urlize($f->{'value'})."'>$f->{'value'}</a>",
			$self->{'desc'},
			], \@{$self->{'tds_array'}}, "d", $f->{'value'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'filters_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'filters_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

