#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of log targets

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'logs_title'}, "", "logs");

$self->{'conf'} = $self->get_config();
@{$self->{'logs_array'}} = $self->find("log", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_log.cgi?new=1'>$self->{'text_hash'}->{'logs_add'}</a>" );
if (@{$self->{'logs_array'}}) {
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_form_start("delete_logs.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'logs_source'},
				  $self->{'text_hash'}->{'logs_filter'},
				  $self->{'text_hash'}->{'logs_destination'},
				  ], undef, 0, \@{$self->{'tds_array'}});
	foreach $f (@{$self->{'logs_array'}}) {
		$self->{'source'} = join(", ", $self->find_value("source", $f->{'members'}));
		$self->{'filter'} = join(", ", $self->find_value("filter", $f->{'members'}));
		$self->{'dest'} = join(", ", $self->find_value("destination", $f->{'members'}));
		print $self->ui_checked_columns_row([
			"<a href='edit_log.cgi?idx=$f->{'index'}'>$self->{'source'}</a>",
			$self->{'filter'} || "<i>$self->{'text_hash'}->{'logs_none'}</i>",
			$self->{'dest'} || "<i>$self->{'text_hash'}->{'logs_none'}</i>",
			], \@{$self->{'tds_array'}}, "d", $f->{'index'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'logs_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'logs_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

