#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show a list of log sources

&ModuleLoader::preload_module('syslog_ng_class', "syslog_ng::SyslogngLib");
$self = new syslog_ng::SyslogngLib:: 'syslog_ng_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'sources_title'}, "", "sources");

$self->{'conf'} = $self->get_config();
@{$self->{'sources_array'}} = $self->find("source", $self->{'conf'});
@{$self->{'links_array'}} = ( $self->select_all_link("d"),
	   $self->select_invert_link("d"),
	   "<a href='edit_source.cgi?new=1'>$self->{'text_hash'}->{'sources_add'}</a>" );
if (@{$self->{'sources_array'}}) {
	@{$self->{'tds_array'}} = ( "width=5" );
	print $self->ui_form_start("delete_sources.cgi", "post");
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_columns_start([ "",
				  $self->{'text_hash'}->{'sources_source'},
				  $self->{'text_hash'}->{'sources_desc'},
				  ], undef, 0, \@{$self->{'tds_array'}});
	foreach $f (@{$self->{'sources_array'}}) {
		$self->{'desc'} = $self->nice_source_desc($f);
		print $self->ui_checked_columns_row([
			"<a href='edit_source.cgi?name=$f->{'value'}'>$f->{'value'}</a>",
			$self->{'desc'} || "<i>$self->{'text_hash'}->{'sources_none2'}</i>",
			], \@{$self->{'tds_array'}}, "d", $f->{'value'});
		}
	print $self->ui_columns_end();
	print $self->ui_links_row(\@{$self->{'links_array'}});
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'sources_delete'} ] ]);
	}
else {
	print "<b>$self->{'text_hash'}->{'sources_none'}</b><p>\n";
	print $self->ui_links_row([ $self->{'links_array'}->[2] ]);
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

