#!/usr/bin/perl

&MAIN();

 sub MAIN {
# cancel.cgi
# Cancel one or more downloads

&ModuleLoader::preload_module('updown_class', "updown::UpdownLib");
$self = new updown::UpdownLib:: 'updown_class',%$self;

$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'cancel_err'});

@{$self->{'ids_array'}} = split(/\0/, $self->{'in_hash'}->{'cancel'});
@{$self->{'ids_array'}} || $self->error($self->{'text_hash'}->{'cancel_enone'});

# Delete each one, and its At jobs, and kill its PID
if ($self->{'can_schedule'}) {
	$self->foreign_require("at", "at-lib.pl");
	@{$self->{'ats_array'}} = $main::at_object->list_atjobs();
	}
foreach $i (@{$self->{'ids_array'}}) {
	$self->{'down'} = $self->get_download($i);
	$self->can_as_user($self->{'down'}->{'user'}) ||
		$self->error($self->text('cancel_ecannot', $self->{'down'}->{'user'}));
	next if (!$self->{'down'});
	$self->delete_download($self->{'down'});

	foreach $a (@{$self->{'ats_array'}}) {
		if ($a->{'realcmd'} =~ /\Q$self->{'atjob_cmd'}\E\s+\Q$i\E/) {
			# Found the job to cancel
			$main::at_object->delete_atjob($a->{'id'});
			}
		}

	if ($self->{'down'}->{'pid'}) {
		$self->kill_logged('TERM', $self->{'down'}->{'pid'});
		}
	}
$self->webmin_log("cancel", undef, undef, { 'ids' => \@{$self->{'ids_array'}} });
$self->redirect("");

1;
		
}


1;

