#!/usr/bin/perl
package useradmin::Acl_security;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'useradmin::Acl_security');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "useradmin::UserLib");
$self = new useradmin::UserLib:: ref($self), %$self; 

1;
		return $self;
}

# acl_security_form(&options)
# Output HTML for editing security options for the useradmin module
sub acl_security_form
{
	my $self = shift;

local $o = $_[0];

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_uedit'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=uedit_mode value=0 %s> $self->{'text_hash'}->{'acl_uedit_all'}&nbsp;&nbsp;\n",
	$o->{'uedit_mode'} == 0 ? "checked" : "";
printf "<input type=radio name=uedit_mode value=1 %s> $self->{'text_hash'}->{'acl_uedit_none'}&nbsp;\n",
	$o->{'uedit_mode'} == 1 ? "checked" : "";
printf "<input type=radio name=uedit_mode value=6 %s> $self->{'text_hash'}->{'acl_uedit_this'}<br>\n",
	$o->{'uedit_mode'} == 6 ? "checked" : "";
printf "<input type=radio name=uedit_mode value=2 %s> $self->{'text_hash'}->{'acl_uedit_only'}\n",
	$o->{'uedit_mode'} == 2 ? "checked" : "";
printf "<input name=uedit_can size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 2 ? $o->{'uedit'} : "",
	$self->user_chooser_button("uedit_can", 1);
printf "<input type=radio name=uedit_mode value=3 %s> $self->{'text_hash'}->{'acl_uedit_except'}\n",
	$o->{'uedit_mode'} == 3 ? "checked" : "";
printf "<input name=uedit_cannot size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 3 ? $o->{'uedit'} : "",
	$self->user_chooser_button("uedit_cannot", 1);
printf "<input type=radio name=uedit_mode value=4 %s> $self->{'text_hash'}->{'acl_uedit_uid'}\n",
	$o->{'uedit_mode'} == 4 ? "checked" : "";
printf "<input name=uedit_uid size=6 value='%s'> - \n",
	$o->{'uedit_mode'} == 4 ? $o->{'uedit'} : "";
printf "<input name=uedit_uid2 size=6 value='%s'><br>\n",
	$o->{'uedit_mode'} == 4 ? $o->{'uedit2'} : "";
printf "<input type=radio name=uedit_mode value=5 %s> $self->{'text_hash'}->{'acl_uedit_group'}\n",
	$o->{'uedit_mode'} == 5 ? "checked" : "";
printf "<input name=uedit_group size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 5 ?
	 join(" ", map { "".$self->my_getgrgid($_) } split(/\s+/, $o->{'uedit'})) :"",
	$self->group_chooser_button("uedit_group", 1);
printf "%s <input type=checkbox name=uedit_sec value=1 %s> %s<br>\n",
	"&nbsp;" x 5, $o->{'uedit_sec'} ? 'checked' : '',$self->{'text_hash'}->{'acl_uedit_sec'};
printf "<input type=radio name=uedit_mode value=7 %s> $self->{'text_hash'}->{'acl_uedit_re'}\n",
	$o->{'uedit_mode'} == 7 ? "checked" : "";
printf "<input name=uedit_re size=40 value='%s'> %s<br>\n",
	$o->{'uedit_mode'} == 7 ? $o->{'uedit_re'} : "";
print "</td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_ucreate'}</b></td> <td>\n";
printf "<input type=radio name=ucreate value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'ucreate'} ? "checked" : "";
printf "<input type=radio name=ucreate value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'ucreate'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_batch'}</b></td> <td>\n";
printf "<input type=radio name=batch value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'batch'} ? "checked" : "";
printf "<input type=radio name=batch value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'batch'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_export'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=export value=2 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'export'} == 2 ? "checked" : "";
printf "<input type=radio name=export value=1 %s> $self->{'text_hash'}->{'acl_export1'}\n",
	$o->{'export'} == 1 ? "checked" : "";
printf "<input type=radio name=export value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'export'} == 0 ? "checked" : "";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_uid'}</b></td>\n";
print "<td colspan=3><input name=lowuid size=6 value='$o->{'lowuid'}'> -\n";
print "<input name=hiuid size=6 value='$o->{'hiuid'}'><br>\n";
printf "<input type=checkbox name=autouid value=1 %s> %s<br>\n",
	$o->{'autouid'} ? "checked" : "", $self->{'text_hash'}->{'acl_autouid'};
printf "<input type=checkbox name=calcuid value=1 %s> %s<br>\n",
	$o->{'calcuid'} ? "checked" : "", $self->{'text_hash'}->{'acl_calcuid'};
printf "<input type=checkbox name=useruid value=1 %s> %s<br>\n",
	$o->{'useruid'} ? "checked" : "", $self->{'text_hash'}->{'acl_useruid'};
printf "<input type=checkbox name=umultiple value=1 %s> %s<br>\n",
	$o->{'umultiple'} ? "checked" : "", $self->{'text_hash'}->{'acl_umultiple'};
printf "<input type=checkbox name=uuid value=1 %s> %s</td> </tr>\n",
	$o->{'uuid'} ? "checked" : "", $self->{'text_hash'}->{'acl_uuid'};

local $uedit_gmode = defined($o->{'uedit_gmode'}) ? $o->{'uedit_gmode'} :
		     $o->{'ugroups'} eq '*' ? 0 : 2;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_ugroups'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=uedit_gmode value=0 %s> $self->{'text_hash'}->{'acl_gedit_all'}<br>\n",
	$uedit_gmode == 0 ? "checked" : "";
printf "<input type=radio name=uedit_gmode value=2 %s> $self->{'text_hash'}->{'acl_gedit_only'}\n",
	$uedit_gmode == 2 ? "checked" : "";
printf "<input name=uedit_gcan size=40 value='%s'> %s<br>\n",
	$uedit_gmode == 2 ? $o->{'ugroups'} : "",
	$self->group_chooser_button("uedit_gcan", 1);
printf "<input type=radio name=uedit_gmode value=3 %s> $self->{'text_hash'}->{'acl_gedit_except'}\n",
	$uedit_gmode == 3 ? "checked" : "";
printf "<input name=uedit_gcannot size=40 value='%s'> %s<br>\n",
	$uedit_gmode == 3 ? $o->{'ugroups'} : "",
	$self->group_chooser_button("uedit_gcannot", 1);
printf "<input type=radio name=uedit_gmode value=4 %s> $self->{'text_hash'}->{'acl_gedit_gid'}\n",
	$uedit_gmode == 4 ? "checked" : "";
printf "<input name=uedit_gid size=6 value='%s'> -\n",
	$uedit_gmode == 4 ? $o->{'ugroups'} : "";
printf "<input name=uedit_gid2 size=6 value='%s'></td> </tr>\n",
	$uedit_gmode == 4 ? $o->{'ugroups2'} : "";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_shells'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=shells_def value=1 %s> $self->{'text_hash'}->{'acl_any'}\n",
	$o->{'shells'} eq "*" ? "checked" : "";
printf "<input type=radio name=shells_def value=0 %s> $self->{'text_hash'}->{'acl_listed'}<br>\n",
	$o->{'shells'} eq "*" ? "" : "checked";
print "<textarea name=shells rows=3 cols=40>",
	$o->{'shells'} eq "*" ? "" : join("\n", split(/\s+/, $o->{'shells'})),
	"</textarea></td> </tr>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_epeopt'}</b></td> <td>\n";
printf "<input type=radio name=peopt value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'peopt'} ? "checked" : "";
printf "<input type=radio name=peopt value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'peopt'} ? "" : "checked";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_home'}</b></td>\n";
printf "<td colspan=3><input name=home size=40 value='%s'> %s<br>\n",
	$o->{'home'}, $self->file_chooser_button("home", 1);
printf "<input type=checkbox name=autohome value=1 %s> %s</td> </tr>\n",
	$o->{'autohome'} ? "checked" : "",
	$self->{'text_hash'}->{'acl_autohome'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_udelete'}</b></td> <td>\n";
printf "<input type=radio name=udelete value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'udelete'} ? "checked" : "";
printf "<input type=radio name=udelete value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'udelete'} ? "" : "checked";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_urename'}</b></td> <td>\n";
printf "<input type=radio name=urename value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'urename'} ? "checked" : "";
printf "<input type=radio name=urename value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'urename'} ? "" : "checked";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_delhome'}</b></td>\n";
print "<td colspan=3>",$self->ui_radio("delhome", $o->{'delhome'},
			  [ [ 2, $self->{'text_hash'}->{'acl_option'} ],
			    [ 1, $self->{'text_hash'}->{'acl_always'} ],
			    [ 0, $self->{'text_hash'}->{'acl_never'} ] ]),"</td> </tr>\n";

# 0 = always on, 1 = can edit, 2 = always off
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_saveopts'}</b></td> ",
      "<td colspan=3><table>\n";
foreach $opt ('chuid', 'chgid', 'movehome', 'mothers',
	      'makehome', 'copy', 'cothers', 'dothers') {
	print "<tr> <td>",$self->{'text_hash'}->{"uedit_$opt"},"</td>\n";
	printf "<td><input type=radio name=$opt value=1 %s> %s\n",
		$o->{$opt} == 1 ? "checked" : "", $self->{'text_hash'}->{'acl_canedit'};
	printf "<input type=radio name=$opt value=0 %s> %s\n",
		$o->{$opt} == 0 ? "checked" : "", $self->{'text_hash'}->{'acl_on'};
	printf "<input type=radio name=$opt value=2 %s> %s</td> </tr>\n",
		$o->{$opt} == 2 ? "checked" : "", $self->{'text_hash'}->{'acl_off'};
	}
print "</table></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_gedit'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=gedit_mode value=0 %s> $self->{'text_hash'}->{'acl_gedit_all'}&nbsp;&nbsp;\n",
	$o->{'gedit_mode'} == 0 ? "checked" : "";
printf "<input type=radio name=gedit_mode value=1 %s> $self->{'text_hash'}->{'acl_gedit_none'}<br>\n",
	$o->{'gedit_mode'} == 1 ? "checked" : "";
printf "<input type=radio name=gedit_mode value=2 %s> $self->{'text_hash'}->{'acl_gedit_only'}\n",
	$o->{'gedit_mode'} == 2 ? "checked" : "";
printf "<input name=gedit_can size=40 value='%s'> %s<br>\n",
	$o->{'gedit_mode'} == 2 ? $o->{'gedit'} : "",
	$self->group_chooser_button("gedit_can", 1);
printf "<input type=radio name=gedit_mode value=3 %s> $self->{'text_hash'}->{'acl_gedit_except'}\n",
	$o->{'gedit_mode'} == 3 ? "checked" : "";
printf "<input name=gedit_cannot size=40 value='%s'> %s<br>\n",
	$o->{'gedit_mode'} == 3 ? $o->{'gedit'} : "",
	$self->group_chooser_button("gedit_cannot", 1);
printf "<input type=radio name=gedit_mode value=4 %s> $self->{'text_hash'}->{'acl_gedit_gid'}\n",
	$o->{'gedit_mode'} == 4 ? "checked" : "";
printf "<input name=gedit_gid size=6 value='%s'> -\n",
	$o->{'gedit_mode'} == 4 ? $o->{'gedit'} : "";
printf "<input name=gedit_gid2 size=6 value='%s'></td> </tr>\n",
	$o->{'gedit_mode'} == 4 ? $o->{'gedit2'} : "";

print "<tr> <td><b>$self->{'text_hash'}->{'acl_gcreate'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=gcreate value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'gcreate'}==1 ? "checked" : "";
printf "<input type=radio name=gcreate value=2 %s> $self->{'text_hash'}->{'acl_gnew'}\n",
	$o->{'gcreate'}==2 ? "checked" : "";
printf "<input type=radio name=gcreate value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'gcreate'}==0 ? "checked" : "";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'acl_gid'}</b></td>\n";
print "<td colspan=3><input name=lowgid size=6 value='$o->{'lowgid'}'> -\n";
print "<input name=higid size=6 value='$o->{'higid'}'><br>\n";
printf "<input type=checkbox name=autogid value=1 %s> %s<br>\n",
	$o->{'autogid'} ? "checked" : "", $self->{'text_hash'}->{'acl_autogid'};
printf "<input type=checkbox name=calcgid value=1 %s> %s<br>\n",
	$o->{'calcgid'} ? "checked" : "", $self->{'text_hash'}->{'acl_calcgid'};
printf "<input type=checkbox name=usergid value=1 %s> %s<br>\n",
	$o->{'usergid'} ? "checked" : "", $self->{'text_hash'}->{'acl_usergid'};
printf "<input type=checkbox name=gmultiple value=1 %s> %s<br>\n",
	$o->{'gmultiple'} ? "checked" : "", $self->{'text_hash'}->{'acl_gmultiple'};
printf "<input type=checkbox name=ggid value=1 %s> %s</td> </tr>\n",
	$o->{'ggid'} ? "checked" : "", $self->{'text_hash'}->{'acl_ggid'};

print "<tr> <td><b>$self->{'text_hash'}->{'acl_gdelete'}</b></td> <td>\n";
printf "<input type=radio name=gdelete value=1 %s> $self->{'text_hash'}->{'yes'}\n",
	$o->{'gdelete'} ? "checked" : "";
printf "<input type=radio name=gdelete value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
	$o->{'gdelete'} ? "" : "checked";

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr><td valign=top><b>$self->{'text_hash'}->{'acl_logins'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=logins_mode value=0 %s> $self->{'text_hash'}->{'acl_lnone'}<br>\n",
	$o->{'logins'} ? "" : "checked";
printf "<input type=radio name=logins_mode value=1 %s> $self->{'text_hash'}->{'acl_lall'}<br>\n",
	$o->{'logins'} eq "*" ? "checked" : "";
printf "<input type=radio name=logins_mode value=2 %s>\n",
	$o->{'logins'} =~ /[^\*]/ ? "checked" : "";
printf "<input name=logins size=40 value='%s'> %s</td> </tr>\n",
	$o->{'logins'} =~ /[^\*]/ ? $o->{'logins'} : "",
	$self->user_chooser_button("logins", 1);
}

# acl_security_save(&options)
# Parse the form for security options for the useradmin module
sub acl_security_save
{
	my $self = shift;

$_[0]->{'lowuid'} = $self->{'in_hash'}->{'lowuid'};
$_[0]->{'hiuid'} = $self->{'in_hash'}->{'hiuid'};
$_[0]->{'autouid'} = $self->{'in_hash'}->{'autouid'};
$_[0]->{'autogid'} = $self->{'in_hash'}->{'autogid'};
$_[0]->{'calcuid'} = $self->{'in_hash'}->{'calcuid'};
$_[0]->{'calcgid'} = $self->{'in_hash'}->{'calcgid'};
$_[0]->{'useruid'} = $self->{'in_hash'}->{'useruid'};
$_[0]->{'usergid'} = $self->{'in_hash'}->{'usergid'};
$_[0]->{'lowgid'} = $self->{'in_hash'}->{'lowgid'};
$_[0]->{'higid'} = $self->{'in_hash'}->{'higid'};
$_[0]->{'uedit_mode'} = $self->{'in_hash'}->{'uedit_mode'};
$_[0]->{'uedit'} = $self->{'in_hash'}->{'uedit_mode'} == 2 ? $self->{'in_hash'}->{'uedit_can'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 3 ? $self->{'in_hash'}->{'uedit_cannot'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 4 ? $self->{'in_hash'}->{'uedit_uid'} :
		   $self->{'in_hash'}->{'uedit_mode'} == 5 ?
			join(" ", map { "".$self->my_getgrnam($_) }
			     split(/\s+/, $self->{'in_hash'}->{'uedit_group'})) : "";
$_[0]->{'uedit2'} = $self->{'in_hash'}->{'uedit_mode'} == 4 ? $self->{'in_hash'}->{'uedit_uid2'} : undef;
$_[0]->{'uedit_sec'} = $self->{'in_hash'}->{'uedit_mode'} == 5 ? $self->{'in_hash'}->{'uedit_sec'} : undef;
$_[0]->{'uedit_re'} = $self->{'in_hash'}->{'uedit_mode'} == 7 ? $self->{'in_hash'}->{'uedit_re'} : undef;
$_[0]->{'gedit_mode'} = $self->{'in_hash'}->{'gedit_mode'};
$_[0]->{'gedit'} = $self->{'in_hash'}->{'gedit_mode'} == 2 ? $self->{'in_hash'}->{'gedit_can'} :
		   $self->{'in_hash'}->{'gedit_mode'} == 3 ? $self->{'in_hash'}->{'gedit_cannot'} :
		   $self->{'in_hash'}->{'gedit_mode'} == 4 ? $self->{'in_hash'}->{'gedit_gid'} : "";
$_[0]->{'gedit2'} = $self->{'in_hash'}->{'gedit_mode'} == 4 ? $self->{'in_hash'}->{'gedit_gid2'} : undef;
$_[0]->{'ucreate'} = $self->{'in_hash'}->{'ucreate'};
$_[0]->{'gcreate'} = $self->{'in_hash'}->{'gcreate'};
if ($self->{'in_hash'}->{'uedit_gmode'} == 0) {
	delete($_[0]->{'uedit_gmode'});
	$_[0]->{'ugroups'} = "*";
	}
elsif ($self->{'in_hash'}->{'uedit_gmode'} == 2) {
	delete($_[0]->{'uedit_gmode'});
	$_[0]->{'ugroups'} = $self->{'in_hash'}->{'uedit_gcan'};
	}
else {
	$_[0]->{'uedit_gmode'} = $self->{'in_hash'}->{'uedit_gmode'};
	$_[0]->{'ugroups'} = $self->{'in_hash'}->{'uedit_gmode'} == 3 ? $self->{'in_hash'}->{'uedit_gcannot'} :
			     $self->{'in_hash'}->{'uedit_gmode'} == 4 ? $self->{'in_hash'}->{'uedit_gid'} : "";
	}
$_[0]->{'ugroups2'} = $self->{'in_hash'}->{'uedit_gmode'} == 4 ? $self->{'in_hash'}->{'uedit_gid2'} : undef;

$_[0]->{'logins'} = $self->{'in_hash'}->{'logins_mode'} == 0 ? "" :
		    $self->{'in_hash'}->{'logins_mode'} == 1 ? "*" : $self->{'in_hash'}->{'logins'};
$_[0]->{'shells'} = $self->{'in_hash'}->{'shells_def'} ? "*"
				      : join(" ", split(/\s+/, $self->{'in_hash'}->{'shells'}));
$_[0]->{'peopt'} = $self->{'in_hash'}->{'peopt'};
$_[0]->{'batch'} = $self->{'in_hash'}->{'batch'};
$_[0]->{'export'} = $self->{'in_hash'}->{'export'};
$_[0]->{'home'} = $self->{'in_hash'}->{'home'};
$_[0]->{'delhome'} = $self->{'in_hash'}->{'delhome'};
$_[0]->{'autohome'} = $self->{'in_hash'}->{'autohome'};
$_[0]->{'umultiple'} = $self->{'in_hash'}->{'umultiple'};
$_[0]->{'uuid'} = $self->{'in_hash'}->{'uuid'};
$_[0]->{'gmultiple'} = $self->{'in_hash'}->{'gmultiple'};
$_[0]->{'ggid'} = $self->{'in_hash'}->{'ggid'};
foreach $o ('chuid', 'chgid', 'movehome', 'mothers',
	    'makehome', 'copy', 'cothers', 'dothers') {
	$_[0]->{$o} = $self->{'in_hash'}->{$o};
	}
$_[0]->{'udelete'} = $self->{'in_hash'}->{'udelete'};
$_[0]->{'urename'} = $self->{'in_hash'}->{'urename'};
$_[0]->{'gdelete'} = $self->{'in_hash'}->{'gdelete'};
}


1;

