#!/usr/bin/perl

&MAIN();

 sub MAIN {
# batch_form.cgi
# Display a form for doing batch creation, updates or deletion from a text file

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

%{$self->{'access_hash'}} = $self->get_module_acl();
$self->{'access_hash'}->{'batch'} || $self->error($self->{'text_hash'}->{'batch_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'batch_title'}, "");

print "$self->{'text_hash'}->{'batch_desc'}\n";
$self->{'pft'} = $self->passfiles_type();
print "<p><tt>",$self->{'text_hash'}->{'batch_desc'.$self->{'pft'}},"</tt><p>\n";
print "$self->{'text_hash'}->{'batch_descafter'}<br>\n";
print "$self->{'text_hash'}->{'batch_descafter2'}\n";

print "<form action=batch_exec.cgi method=post enctype=multipart/form-data>\n";
print "<table>\n";

print "<tr $self->{'tb'}> <td colspan=3><b>$self->{'text_hash'}->{'batch_title'}</b></td> </tr> ";
print "<tr $self->{'cb'}> <td valign=top><b>$self->{'text_hash'}->{'batch_source'}</b></td> <td>\n";
print "<input type=radio name=source value=0 checked> ",
      "$self->{'text_hash'}->{'batch_source0'} <input type=file name=file><br>\n";
print "<input type=radio name=source value=1> ",
      "$self->{'text_hash'}->{'batch_source1'} <input name=local size=30> ",
      $self->file_chooser_button("local"),"<br>\n";
print "<input type=radio name=source value=2> ",
      "$self->{'text_hash'}->{'batch_source2'}<br><textarea name=text rows=5 cols=50></textarea>",
      "</td> </tr>\n";

if ($self->{'access_hash'}->{'cothers'} == 1 || $self->{'access_hash'}->{'mothers'} == 1 ||
    $self->{'access_hash'}->{'dothers'} == 1) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_others'}</b></td>\n";
	printf "<td><input name=others type=radio value=1 %s> $self->{'text_hash'}->{'yes'}\n",
		$self->{'config_hash'}->{'default_other'} ? "checked" : "";
	printf "<input name=others type=radio value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
		$self->{'config_hash'}->{'default_other'} ? "" : "checked";
	}

print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_batch'}</b></td>\n";
print "<td><input name=batch type=radio value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input name=batch type=radio value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";

if ($self->{'access_hash'}->{'makehome'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_makehome'}</b></td>\n";
	print "<td><input name=makehome type=radio value=1 checked> $self->{'text_hash'}->{'yes'}\n";
	print "<input name=makehome type=radio value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'copy'} && $self->{'config_hash'}->{'user_files'} =~ /\S/) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_copy'}</b></td>\n";
	print "<td><input name=copy type=radio value=1 checked> $self->{'text_hash'}->{'yes'}\n";
	print "<input name=copy type=radio value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'movehome'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_movehome'}</b></td>\n";
	print "<td><input name=movehome type=radio value=1 checked> $self->{'text_hash'}->{'yes'}\n";
	print "<input name=movehome type=radio value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
	}

if ($self->{'access_hash'}->{'chuid'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_chuid'}</b></td>\n";
	print "<td><input type=radio name=chuid value=0> $self->{'text_hash'}->{'no'}\n";
	print "<input type=radio name=chuid value=1 checked> $self->{'text_hash'}->{'home'}\n";
	print "<input type=radio name=chuid value=2> ",
	      "$self->{'text_hash'}->{'uedit_allfiles'}</td></tr>\n";
	}

if ($self->{'access_hash'}->{'chgid'}) {
	print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_chgid'}</b></td>\n";
	print "<td><input type=radio name=chgid value=0> $self->{'text_hash'}->{'no'}\n";
	print "<input type=radio name=chgid value=1 checked> $self->{'text_hash'}->{'home'}\n";
	print "<input type=radio name=chgid value=2> ",
	      "$self->{'text_hash'}->{'uedit_allfiles'}</td></tr>\n";
	}

print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_delhome'}</b></td>\n";
print "<td><input name=delhome type=radio value=1 checked> $self->{'text_hash'}->{'yes'}\n";
print "<input name=delhome type=radio value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";

print "<tr $self->{'cb'}> <td><b>$self->{'text_hash'}->{'batch_crypt'}</b></td>\n";
print "<td><input name=crypt type=radio value=1> $self->{'text_hash'}->{'yes'}\n";
print "<input name=crypt type=radio value=0 checked> $self->{'text_hash'}->{'no'}</td> </tr>\n";
print "<tr $self->{'cb'}> <td><input type=submit value=\"$self->{'text_hash'}->{'batch_upload'}\"></td></tr>\n";
print "</table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

