#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_group.cgi
# Display a form for editing or creating a group

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

$self->ReadParse();
$self->{'n'} = $self->{'in_hash'}->{'num'};
%{$self->{'access_hash'}} = $self->get_module_acl();
if ($self->{'n'} eq "") {
	$self->{'access_hash'}->{'gcreate'}==1 || $self->error($self->{'text_hash'}->{'gedit_ecreate'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title2'}, "", "create_group");
	}
else {
	@{$self->{'glist_array'}} = $self->list_groups();
	%{$self->{'group_hash'}} = %{$self->{'glist_array'}->[$self->{'n'}]};
	$self->can_edit_group(\%{$self->{'access_hash'}}, \%{$self->{'group_hash'}}) ||
		$self->error($self->{'text_hash'}->{'gedit_eedit'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'gedit_title'}, "", "edit_group");
	}

$self->build_group_used(\%{$self->{'gused_hash'}});

print "<form action=\"save_group.cgi\" method=post>\n";
if ($self->{'n'} ne "") {
	print "<input type=hidden name=num value=\"$self->{'n'}\">\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'gedit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'gedit_group'}</b>","ggroup"),
      "</td>\n";
if ($self->{'n'} eq "") {
	print "<td valign=top><input name=group size=10></td>\n";
	}
else {
	print "<td valign=top><tt>$self->{'group_hash'}->{'group'}</tt></td>\n";
	}

print "<td valign=middle>",$self->hlink("<b>$self->{'text_hash'}->{'gedit_gid'}</b>","ggid"),"</td>\n";
if ($self->{'n'} eq "") {
    print "<td>\n";
    $self->{'defgid'} = $self->allocate_gid(\%{$self->{'gused_hash'}});

    if ( $self->{'access_hash'}->{'calcgid'} && $self->{'access_hash'}->{'autogid'} && $self->{'access_hash'}->{'usergid'} ) {
        # Show options for calculated, auto-incremented and user entered GID
        printf "<input type=radio name=gid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_def'};
        printf "<input type=radio name=gid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_calc'};
        printf "<input type=radio name=gid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '0' ? "checked" : "",
	    "<input name=gid size=10 value='$self->{'defgid'}'>";
    }

    if ( $self->{'access_hash'}->{'calcgid'} && $self->{'access_hash'}->{'autogid'} && !$self->{'access_hash'}->{'usergid'} ) {
        # Show options for calculated and auto-incremented GID
        printf "<input type=radio name=gid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_def'};
        printf "<input type=radio name=gid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_calc'};
    }

    if ( $self->{'access_hash'}->{'calcgid'} && !$self->{'access_hash'}->{'autogid'} && $self->{'access_hash'}->{'usergid'} ) {
        # Show options for calculated and user entered GID
        printf "<input type=radio name=gid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_calc'};
        printf "<input type=radio name=gid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '0' ? "checked" : "",
	    "<input name=gid size=10 value='$self->{'defgid'}'>";
    }

    if ( !$self->{'access_hash'}->{'calcgid'} && $self->{'access_hash'}->{'autogid'} && $self->{'access_hash'}->{'usergid'} ) {
        # Show options for auto-incremented and user entered GID
        printf "<input type=radio name=gid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'gedit_gid_def'};
        printf "<input type=radio name=gid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'gid_mode'} eq '0' ? "checked" : "",
	    "<input name=gid size=10 value='$self->{'defgid'}'>";
    }

    if ( $self->{'access_hash'}->{'calcgid'} && !$self->{'access_hash'}->{'autogid'} && !$self->{'access_hash'}->{'usergid'} ) {
        # Hidden field  for calculated GID
	print "<input type=hidden name=gid_def value=2>";
	print "$self->{'text_hash'}->{'gedit_gid_calc'} from Berkeley style cksum\n";
    }

    if ( !$self->{'access_hash'}->{'calcgid'} && $self->{'access_hash'}->{'autogid'} && !$self->{'access_hash'}->{'usergid'} ) {
        # Hidden field for auto-incremented GID
	print "<input type=hidden name=gid_def value=1>";
	print "$self->{'text_hash'}->{'gedit_gid_calc'}\n";
    }

    if ( !$self->{'access_hash'}->{'calcgid'} && !$self->{'access_hash'}->{'autogid'} && $self->{'access_hash'}->{'usergid'} ) {
        # Show field for user entered GID
	print "<input type=hidden name=gid_def value=0>";
	print "GID: <input name=gid size=10 value='$self->{'defgid'}'>\n";
    }

    if ( !$self->{'access_hash'}->{'calcgid'} && !$self->{'access_hash'}->{'autogid'} && !$self->{'access_hash'}->{'usergid'} ) {
        if ( $self->{'config_hash'}->{'gid_mode'} eq '0' ) {
          print "<input type=hidden name=gid_def value=0>";
          print "GID: <input name=gid size=10 value='$self->{'defgid'}'>\n";
        } else {
          print "<input type=hidden name=gid_def value=$self->{'config_hash'}->{'gid_mode'}>";
          print "$self->{'text_hash'}->{'gedit_gid_def'}\n" if ( $self->{'config_hash'}->{'gid_mode'} eq '1' );
          print "$self->{'text_hash'}->{'gedit_gid_calc'}\n" if ( $self->{'config_hash'}->{'gid_mode'} eq '2' );
        }
    }
    print "</td></tr>\n";
	}
else {
	print "<td valign=top><input name=gid size=10 ",
	      "value=\"$self->{'group_hash'}->{'gid'}\"></td>\n";
	}
print "</tr>\n";

print "<tr> <td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'pass'}</b>","gpasswd"),"</td>\n";
printf "<td valign=top><input type=radio name=passmode value=0 %s> $self->{'text_hash'}->{'none2'}<br>\n",
	$self->{'group_hash'}->{'pass'} eq "" ? "checked" : "";
printf "<input type=radio name=passmode value=1 %s> $self->{'text_hash'}->{'encrypted'}\n",
	$self->{'group_hash'}->{'pass'} eq "" ? "" : "checked";
print "<input name=encpass size=13 value=\"$self->{'group_hash'}->{'pass'}\"><br>\n";
print "<input type=radio name=passmode value=2 %s> $self->{'text_hash'}->{'clear'}\n";
print "<input name=pass size=15></td>\n";

# Member chooser
local $w = 500;
local $h = 200;
if ($self->{'gconfig_hash'}->{'db_sizeusers'}) {
	($w, $h) = split(/x/, $self->{'gconfig_hash'}->{'db_sizeusers'});
	}
print "<td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'gedit_members'}</b>","gmembers"),
      "</td>\n";
print "<td><table><tr><td><textarea wrap=auto name=members rows=5 cols=10>",
	join("\n", split(/,/ , $self->{'group_hash'}->{'members'})),"</textarea></td>\n";
print "<td valign=top><input type=button onClick='ifield = document.forms[0].members; chooser = window.open(\"my_user_chooser.cgi?multi=1&user=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=$w,height=$h\"); chooser.ifield = ifield; window.ifield = ifield' value=\"...\"></td></tr></table></td> </tr>\n";
print "</table></td></tr></table><p>\n";

if ($self->{'n'} ne "") {
	if ($self->{'access_hash'}->{'chgid'} == 1 || $self->{'access_hash'}->{'mothers'} == 1) {
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'onsave'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table>\n";

		if ($self->{'access_hash'}->{'chgid'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'chgid'},"gchgid"),"</td>\n";
			print "<td><input type=radio name=chgid value=0 checked> $self->{'text_hash'}->{'no'}</td>\n";
			print "<td><input type=radio name=chgid value=1> $self->{'text_hash'}->{'gedit_homedirs'}</td>\n";
			print "<td><input type=radio name=chgid value=2> $self->{'text_hash'}->{'gedit_allfiles'}</td> </tr>\n";
			}

		if ($self->{'access_hash'}->{'mothers'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'gedit_mothers'},"others"),"</td>\n";
			printf "<td><input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}</td>\n",
				$self->{'config_hash'}->{'default_other'} ? "checked" : "";
			printf "<td><input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
				$self->{'config_hash'}->{'default_other'} ? "" : "checked";
			}

		print "</table></td> </tr></table><p>\n";
		}
	}
else {
	if ($self->{'access_hash'}->{'cothers'} == 1) {
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_oncreate'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table>\n";

		if ($self->{'access_hash'}->{'cothers'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'gedit_cothers'},"others"),"</td>\n";
			printf "<td><input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}</td>\n",
				$self->{'config_hash'}->{'default_other'} ? "checked" : "";
				
			printf "<td><input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
				$self->{'config_hash'}->{'default_other'} ? "" : "checked";
			}

		print "</table></td> </tr></table><p>\n";
		}
	}

if ($self->{'n'} ne "") {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";

	if ($self->{'access_hash'}->{'gdelete'}) {
		print "</form><form action=\"delete_group.cgi\">\n";
		print "<input type=hidden name=num value=\"$self->{'n'}\">\n";
		print "<td align=right><input type=submit value=\"$self->{'text_hash'}->{'delete'}\"></td> </tr>\n";
		}
	print "</form></table><p>\n";
	}
else {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

