#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_user.cgi
# Display a form for editing a user, or creating a new user

&ModuleLoader::preload_module('useradmin_class', "useradmin::UserLib");
$self = new useradmin::UserLib:: 'useradmin_class',%$self;

require 'timelocal.pl';
$self->ReadParse();
$self->{'n'} = $self->{'in_hash'}->{'num'};
%{$self->{'access_hash'}} = $self->get_module_acl();
if ($self->{'n'} eq "") {
	$self->{'access_hash'}->{'ucreate'} || $self->error($self->{'text_hash'}->{'uedit_ecreate'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'uedit_title2'}, "", "create_user");
	}
else {
	@{$self->{'ulist_array'}} = $self->list_users();
	%{$self->{'uinfo_hash'}} = %{$self->{'ulist_array'}->[$self->{'n'}]};
	$self->can_edit_user(\%{$self->{'access_hash'}}, \%{$self->{'uinfo_hash'}}) || $self->error($self->{'text_hash'}->{'uedit_eedit'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'uedit_title'}, "", "edit_user");
	}

# build list of used shells
%{$self->{'shells_hash'}} = map { $_, 1 } split(/,/, $self->{'config_hash'}->{'shells'});
@{$self->{'shlist_array'}} = ($self->{'config_hash'}->{'default_shell'} ? ( $self->{'config_hash'}->{'default_shell'} ) : ( ));
push(@{$self->{'shlist_array'}}, "/bin/sh", "/bin/csh", "/bin/false") if ($self->{'shells_hash'}->{'fixed'});
$self->build_user_used(\%{$self->{'used_hash'}}, $self->{'shells_hash'}->{'passwd'} ? \@{$self->{'shlist_array'}} : undef);
if ($self->{'shells_hash'}->{'shells'}) {
	open(SHELLS, "/etc/shells");
	while(<SHELLS>) {
		s/\r|\n//g;
		s/#.*$//;
		push(@{$self->{'shlist_array'}}, $_) if (/\S/);
		}
	close(SHELLS);
	}
if (%{$self->{'uinfo_hash'}}) {
	push(@{$self->{'shlist_array'}}, $self->{'uinfo_hash'}->{'shell'});
	}

print "<form action=save_user.cgi method=post>\n";
if ($self->{'n'} ne "") {
	print "<input type=hidden name=num value=\"$self->{'n'}\">\n";
	}
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_details'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'user'}</b>","user"),"</td>\n";
if ($self->{'n'} eq "" && $self->{'config_hash'}->{'new_user_group'} && $self->{'access_hash'}->{'gcreate'}) {
	$self->{'onch'} = "newgid.value = user.value";
	}
if ($self->{'access_hash'}->{'urename'} || $self->{'n'} eq "") {
	print "<td><input name=user size=20 value=\"$self->{'uinfo_hash'}->{'user'}\" onChange='$self->{'onch'}'></td>\n";
	}
else {
	print "<td><tt>$self->{'uinfo_hash'}->{'user'}</tt></td>\n";
	print $self->ui_hidden("user", $self->{'uinfo_hash'}->{'user'}),"\n";
	}

print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'uid'}</b>","uid"),"</td>\n";
if ($self->{'n'} eq "") {
    $self->{'defuid'} = $self->allocate_uid(\%{$self->{'used_hash'}});
    print "<td>\n";

    if ( $self->{'access_hash'}->{'calcuid'} && $self->{'access_hash'}->{'autouid'} && $self->{'access_hash'}->{'useruid'} ) {
        # Show options for calculated, auto-incremented and user entered UID
        printf "<input type=radio name=uid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_def'};
        printf "<input type=radio name=uid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_calc'};
        printf "<input type=radio name=uid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '0' ? "checked" : "",
	    "<input name=uid size=10 value='$self->{'defuid'}'>";
    }

    if ( $self->{'access_hash'}->{'calcuid'} && $self->{'access_hash'}->{'autouid'} && !$self->{'access_hash'}->{'useruid'} ) {
	# Show options for calculated and auto-incremented UID
        printf "<input type=radio name=uid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_def'};
        printf "<input type=radio name=uid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_calc'};
    }

    if ( $self->{'access_hash'}->{'calcuid'} && !$self->{'access_hash'}->{'autouid'} && $self->{'access_hash'}->{'useruid'} ) {
	# Show options for calculated and user entered UID
        printf "<input type=radio name=uid_def value=2 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '2' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_calc'};
        printf "<input type=radio name=uid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '0' ? "checked" : "",
	    "<input name=uid size=10 value='$self->{'defuid'}'>";
    }

    if ( !$self->{'access_hash'}->{'calcuid'} && $self->{'access_hash'}->{'autouid'} && $self->{'access_hash'}->{'useruid'} ) {
        # Show options for auto-incremented and user entered UID
        printf "<input type=radio name=uid_def value=1 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '1' ? "checked" : "",
            $self->{'text_hash'}->{'uedit_uid_def'};
        printf "<input type=radio name=uid_def value=0 %s> %s\n",
            $self->{'config_hash'}->{'uid_mode'} eq '0' ? "checked" : "",
	    "<input name=uid size=10 value='$self->{'defuid'}'>";
    }

    if ( $self->{'access_hash'}->{'calcuid'} && !$self->{'access_hash'}->{'autouid'} && !$self->{'access_hash'}->{'useruid'} ) {
        # Hidden field  for calculated UID
	print "<input type=hidden name=uid_def value=2>";
	print "$self->{'text_hash'}->{'uedit_uid_calc'}\n";
    }

    if ( !$self->{'access_hash'}->{'calcuid'} && $self->{'access_hash'}->{'autouid'} && !$self->{'access_hash'}->{'useruid'} ) {
        # Hidden field for auto-incremented UID
	print "<input type=hidden name=uid_def value=1>";
	print "$self->{'text_hash'}->{'uedit_uid_calc'}\n";
    }

    if ( !$self->{'access_hash'}->{'calcuid'} && !$self->{'access_hash'}->{'autouid'} && $self->{'access_hash'}->{'useruid'} ) {
        # Show field for user entered UID
	print "<input type=hidden name=uid_def value=0>";
	print "UID: <input name=uid size=10 value='$self->{'defuid'}'>\n";
    }

    if ( !$self->{'access_hash'}->{'calcuid'} && !$self->{'access_hash'}->{'autouid'} && !$self->{'access_hash'}->{'useruid'} ) {
        if ( $self->{'config_hash'}->{'uid_mode'} eq '0' ) {
          print "<input type=hidden name=uid_def value=0>";
          print "UID: <input name=uid size=10 value='$self->{'defuid'}'>\n";
        } else {
          print "<input type=hidden name=uid_def value=$self->{'config_hash'}->{'uid_mode'}>";
          print "$self->{'text_hash'}->{'uedit_uid_def'}\n" if ( $self->{'config_hash'}->{'uid_mode'} eq '1' );
          print "$self->{'text_hash'}->{'uedit_uid_calc'}\n" if ( $self->{'config_hash'}->{'uid_mode'} eq '2' );
        }
    }
    print "</td></tr>\n";
    }
else {
	print "<td><input name=uid size=10 value='$self->{'uinfo_hash'}->{'uid'}'></td> </tr>\n";
	}

if ($self->{'config_hash'}->{'extra_real'}) {
	local @real = split(/,/, $self->{'uinfo_hash'}->{'real'}, 5);
	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'real'}</b>","real"),"</td>\n";
	print "<td><input name=real size=20 value=\"$real[0]\"></td>\n";

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'office'}</b>","office"),"</td>\n";
	print "<td><input name=office size=20 value=\"$real[1]\"></td> </tr>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'workph'}</b>","workph"),"</td>\n";
	print "<td><input name=workph size=20 value=\"$real[2]\"></td>\n";

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'homeph'}</b>","homeph"),"</td>\n";
	print "<td><input name=homeph size=20 value=\"$real[3]\"></td> </tr>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'extra'}</b>","extra"),"</td>\n";
	print "<td><input name=extra size=20 value=\"$real[4]\"></td>\n";
	}
else {
	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'real'}</b>","real"),"</td>\n";
	print "<td><input name=real size=20 value=\"$self->{'uinfo_hash'}->{'real'}\"></td>\n";
	}

# Show input for home directory
print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'home'}</b>","home"),"</td>\n";
if ($self->{'access_hash'}->{'autohome'}) {
	print "<td>$self->{'text_hash'}->{'uedit_auto'} ",
	      $self->{'n'} eq "" ? "" : "( <tt>$self->{'uinfo_hash'}->{'home'}</tt> )",
	      "</td>\n";
	}
else {
	print "<td>\n";
	if ($self->{'config_hash'}->{'home_base'}) {
		local $grp = $self->my_getgrgid($self->{'uinfo_hash'}->{'gid'});
		local $hb = $self->{'n'} eq "" || $self->auto_home_dir($self->{'config_hash'}->{'home_base'},
			    $self->{'uinfo_hash'}->{'user'}, $grp) eq $self->{'uinfo_hash'}->{'home'};
		printf "<input type=radio name=home_base value=1 %s> %s\n",
			$hb ? "checked" : "", $self->{'text_hash'}->{'uedit_auto'};
		printf "<input type=radio name=home_base value=0 %s>\n",
			$hb ? "" : "checked";
		printf "<input name=home size=25 value=\"%s\"> %s\n",
			$hb ? "" : $self->{'uinfo_hash'}->{'home'},
			$self->file_chooser_button("home", 1);
		}
	else {
		print "<input name=home size=25 value=\"$self->{'uinfo_hash'}->{'home'}\">\n",
		      $self->file_chooser_button("home", 1);
		}
	}
print "</td> </tr>\n";

# Show shell drop-down
print "<tr> <td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'shell'}</b>","shell"),"</td>\n";
print "<td valign=top><select name=shell>\n";
if ($self->{'access_hash'}->{'shells'} ne "*") {
	@{$self->{'shlist_array'}} = %{$self->{'uinfo_hash'}} ? ($self->{'uinfo_hash'}->{'shell'}) : ();
	push(@{$self->{'shlist_array'}}, split(/\s+/, $self->{'access_hash'}->{'shells'}));
	$self->{'shells'} = 1;
	}
$self->{'shells'} = 1 if ($self->{'access_hash'}->{'noother'});
@{$self->{'shlist_array'}} = $self->unique(@{$self->{'shlist_array'}});
foreach $s (@{$self->{'shlist_array'}}) {
	printf "<option value='%s' %s>%s\n", $s,
		$s eq $self->{'uinfo_hash'}->{'shell'} ? "selected" : "",
		$s eq "" ? "&lt;None&gt;" : $s;
	}
print "<option value=*>$self->{'text_hash'}->{'uedit_other'}\n" if (!$self->{'shells'});
print "</select></td>\n";

# Show password field
$self->{'pass'} = %{$self->{'uinfo_hash'}} ? $self->{'uinfo_hash'}->{'pass'} : $self->{'config_hash'}->{'lock_string'};
if (!%{$self->{'uinfo_hash'}} && $self->{'config_hash'}->{'random_password'}) {
	$self->seed_random();
	foreach (1 .. 15) {
		$self->{'random_password'} .= $self->{'random_password_chars_array'}->[
					rand(scalar(@{$self->{'random_password_chars_array'}}))];
		}
	}
if (%{$self->{'uinfo_hash'}} && $self->{'pass'} ne $self->{'config_hash'}->{'lock_string'} && $self->{'pass'} ne "") {
	# Can disable if not already locked, or if a new account
	$self->{'can_disable'} = 1;
	if ($self->{'pass'} =~ /^\Q$self->{'disable_string'}\E/) {
		$self->{'disabled'} = 1;
		$self->{'pass'} =~ s/^\Q$self->{'disable_string'}\E//;
		}
	}
elsif (!%{$self->{'uinfo_hash'}}) {
	$self->{'can_disable'} = 1;
	}
print "<td valign=top rowspan=4>",$self->hlink("<b>$self->{'text_hash'}->{'pass'}</b>","pass"),
      "</td> <td rowspan=4 valign=top>\n";
printf"<input type=radio name=passmode value=0 %s> %s<br>\n",
	$self->{'pass'} eq "" && $self->{'random_password'} eq "" ? "checked" : "",
	$self->{'config_hash'}->{'empty_mode'} ? $self->{'text_hash'}->{'none1'} : $self->{'text_hash'}->{'none2'};
printf"<input type=radio name=passmode value=1 %s> $self->{'text_hash'}->{'nologin'}<br>\n",
	$self->{'pass'} eq $self->{'config_hash'}->{'lock_string'} && $self->{'random_password'} eq "" ? "checked" : "";
printf "<input type=radio name=passmode value=3 %s> $self->{'text_hash'}->{'clear'}\n",
	$self->{'random_password'} ne "" ? "checked" : "";
printf "<input %s name=pass size=15 value='%s'><br>\n",
	$self->{'config_hash'}->{'passwd_stars'} ? "type=password" : "",
	$self->{'config_hash'}->{'random_password'} && $self->{'n'} eq "" ? $self->{'random_password'} : "";
if ($self->{'access_hash'}->{'nocrypt'}) {
	printf
	  "<input type=radio name=passmode value=2 %s> $self->{'text_hash'}->{'nochange'}\n",
	  $self->{'pass'} && $self->{'pass'} ne $self->{'config_hash'}->{'lock_string'} && $self->{'random_password'} eq "" ? "checked" : "";
	print "<input type=hidden name=encpass size=13 value=\"$self->{'pass'}\">\n";
	}
else {
	printf
	  "<input type=radio name=passmode value=2 %s> $self->{'text_hash'}->{'encrypted'}\n",
	  $self->{'pass'} && $self->{'pass'} ne $self->{'config_hash'}->{'lock_string'} ? "checked" : "";
	printf "<input name=encpass size=13 value=\"%s\">\n",
		$self->{'pass'} && $self->{'pass'} ne $self->{'config_hash'}->{'lock_string'} ? $self->{'pass'} : "";
	}

# Show password lock checkbox
if ($self->{'can_disable'}) {
	printf "<br>&nbsp;&nbsp;&nbsp;".
	       "<input type=checkbox name=disable value=1 %s> %s\n",
		$self->{'disabled'} ? "checked" : "", $self->{'text_hash'}->{'uedit_disabled'};
	}
print "</td> </tr>\n";

# Show other-shell option
if (!$self->{'shells'}) {
	print "<tr> <td valign=top rowspan=3>$self->{'text_hash'}->{'uedit_other'}</td>\n";
	print "<td valign=top rowspan=3><input size=25 name=othersh>\n";
	print $self->file_chooser_button("othersh", 0),"</td> </tr>\n";
	print "<tr> <td colspan=2 rowspan=2><br></td> </tr>\n";
	}

print "</table></td></tr></table><p>\n";

$self->{'pft'} = $self->passfiles_type();
if (($self->{'pft'} == 1 || $self->{'pft'} == 6) && $self->{'access_hash'}->{'peopt'}) {
	# This is a BSD system.. a few extra password options are supported
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_passopts'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'change2'}</b>",
				 "change2"),"</td>\n";
	if ($self->{'uinfo_hash'}->{'change'}) {
		@{$self->{'tm_array'}} = localtime($self->{'uinfo_hash'}->{'change'});
		$self->{'cday'} = $self->{'tm_array'}->[3];
		$self->{'cmon'} = $self->{'tm_array'}->[4]+1;
		$self->{'cyear'} = $self->{'tm_array'}->[5]+1900;
		$self->{'chour'} = sprintf "%2.2d", $self->{'tm_array'}->[2];
		$self->{'cmin'} = sprintf "%2.2d", $self->{'tm_array'}->[1];
		}
	print "<td>";
	$self->date_input($self->{'cday'}, $self->{'cmon'}, $self->{'cyear'}, 'change');
	print " &nbsp; <input name=changeh size=3 value=\"$self->{'chour'}\">";
	print ":<input name=changemi size=3 value=\"$self->{'cmin'}\"></td>\n";

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'expire2'}</b>","expire2"),"</td>\n";
	if ($self->{'n'} eq "") {
		if ($self->{'config_hash'}->{'default_expire'} =~
		    /^(\d+)\/(\d+)\/(\d+)$/) {
			$self->{'eday'} = $1;
			$self->{'emon'} = $2;
			$self->{'eyear'} = $3;
			$self->{'ehour'} = "00";
			$self->{'emin'} = "00";
			}
		}
	elsif ($self->{'uinfo_hash'}->{'expire'}) {
		@{$self->{'tm_array'}} = localtime($self->{'uinfo_hash'}->{'expire'});
		$self->{'eday'} = $self->{'tm_array'}->[3];
		$self->{'emon'} = $self->{'tm_array'}->[4]+1;
		$self->{'eyear'} = $self->{'tm_array'}->[5]+1900;
		$self->{'ehour'} = sprintf "%2.2d", $self->{'tm_array'}->[2];
		$self->{'emin'} = sprintf "%2.2d", $self->{'tm_array'}->[1];
		}
	print "<td>";
	$self->date_input($self->{'eday'}, $self->{'emon'}, $self->{'eyear'}, 'expire');
	print " &nbsp; <input name=expireh size=3 value=\"$self->{'ehour'}\">";
	print ":<input name=expiremi size=3 value=\"$self->{'emin'}\"></td> </tr>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'class'}</b>","class"),"</td>\n";
	print "<td><input name=class size=10 value=\"$self->{'uinfo_hash'}->{'class'}\"></td>\n";
	print "</tr>\n";
	print "</table></td></tr></table><p>\n";
	}
elsif (($self->{'pft'} == 2 || $self->{'pft'} == 5) && $self->{'access_hash'}->{'peopt'}) {
	# System has a shadow password file as well.. which means it supports
	# password expiry and so on
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_passopts'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";
	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'change'}</b>","change"),"</td>\n";
	print "<td>";
	if ($self->{'uinfo_hash'}->{'change'}) {
		@{$self->{'tm_array'}} = localtime(timelocal(gmtime($self->{'uinfo_hash'}->{'change'} * 60*60*24)));
		printf "%s/%s/%s\n",
			$self->{'tm_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'tm_array'}->[4]+1)}, $self->{'tm_array'}->[5]+1900;
		}
	elsif ($self->{'n'} eq "") { print "$self->{'text_hash'}->{'uedit_never'}\n"; }
	else { print "$self->{'text_hash'}->{'uedit_unknown'}\n"; }
	if ($self->{'uinfo_hash'}->{'max'} && $self->{'pft'} == 2) {
		print "<input type=checkbox name=forcechange value=1> ",
		      "$self->{'text_hash'}->{'uedit_forcechange'}\n";
		}
	print "</td>\n";

	if ($self->{'pft'} == 2) {
		print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'expire'}</b>","expire"),
		      "</td>\n";
		if ($self->{'n'} eq "") {
			if ($self->{'config_hash'}->{'default_expire'} =~
			    /^(\d+)\/(\d+)\/(\d+)$/) {
				$self->{'eday'} = $1;
				$self->{'emon'} = $2;
				$self->{'eyear'} = $3;
				}
			}
		elsif ($self->{'uinfo_hash'}->{'expire'}) {
			@{$self->{'tm_array'}} = localtime(timelocal(gmtime($self->{'uinfo_hash'}->{'expire'} * 60*60*24)));
			$self->{'eday'} = $self->{'tm_array'}->[3];
			$self->{'emon'} = $self->{'tm_array'}->[4]+1;
			$self->{'eyear'} = $self->{'tm_array'}->[5]+1900;
			}
		print "<td>";
		$self->date_input($self->{'eday'}, $self->{'emon'}, $self->{'eyear'}, 'expire');
		print "</td>\n";
		}
	else {
		print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'ask'}</b>","ask"),"</td>\n";
		printf "<td><input type=radio name=ask value=1 %s> %s\n",
			$self->{'uinfo_hash'}->{'change'} eq '0' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
		printf "<input type=radio name=ask value=0 %s> %s</td>\n",
			$self->{'uinfo_hash'}->{'change'} eq '0' ? '' : 'checked', $self->{'text_hash'}->{'no'};
		}
	print "</tr>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'min'}</b>","min"),"</td>\n";
	printf "<td><input size=5 name=min value=\"%s\"></td>\n",
		$self->{'n'} eq "" ? $self->{'config_hash'}->{'default_min'} : $self->{'uinfo_hash'}->{'min'};

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'max'}</b>","max"),"</td>\n";
	printf "<td><input size=5 name=max value=\"%s\"></td></tr>\n",
		$self->{'n'} eq "" ? $self->{'config_hash'}->{'default_max'} : $self->{'uinfo_hash'}->{'max'};

	if ($self->{'pft'} == 2) {
		# SCO does not have these password file options
		print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'warn'}</b>","warn"),"</td>\n";
		printf "<td><input size=5 name=warn value=\"%s\"></td>\n",
			$self->{'n'} eq "" ? $self->{'config_hash'}->{'default_warn'} : $self->{'uinfo_hash'}->{'warn'};

		print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'inactive'}</b>","inactive"),"</td>\n";
		printf "<td><input size=5 name=inactive value=\"%s\"></td></tr>\n",
			$self->{'n'} eq "" ? $self->{'config_hash'}->{'default_inactive'} : $self->{'uinfo_hash'}->{'inactive'};
		}

	print "</table></td></tr></table><p>\n";
	}
elsif ($self->{'pft'} == 4 && $self->{'access_hash'}->{'peopt'}) {
	# System has extra AIX password information
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_passopts'}</b></td> </tr>\n";
	print "<tr $self->{'cb'}> <td><table width=100%>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'change'}</b>","change"),
	      "</td>\n";
	if ($self->{'uinfo_hash'}->{'change'}) {
		@{$self->{'tm_array'}} = localtime($self->{'uinfo_hash'}->{'change'});
		printf "<td>%s/%s/%s %2.2d:%2.2d:%2.2d</td>\n",
			$self->{'tm_array'}->[3], $self->{'text_hash'}->{"smonth_".($self->{'tm_array'}->[4]+1)}, $self->{'tm_array'}->[5]+1900,
			$self->{'tm_array'}->[2], $self->{'tm_array'}->[1], $self->{'tm_array'}->[0];
		}
	elsif ($self->{'n'} eq "") { print "<td>$self->{'text_hash'}->{'uedit_never'}</td>\n"; }
	else { print "<td>$self->{'text_hash'}->{'uedit_unknown'}</td>\n"; }

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'expire'}</b>","expire"),"</td>\n";
	if ($self->{'uinfo_hash'}->{'expire'}) {
		$self->{'uinfo_hash'}->{'expire'} =~ /^(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/;
		$self->{'emon'} = $1;
		$self->{'eday'} = $2;
		$self->{'ehour'} = $3;
		$self->{'emin'} = $4;
		$self->{'eyear'} = $5;
		if ($self->{'eyear'} > 38) {
			$self->{'eyear'} += 1900;
			}
		else {
			$self->{'eyear'} += 2000;
			}
		}
	$self->{'emon'} =~ s/0(\d)/$1/;	# strip leading 0 
	print "<td>";
	$self->date_input($self->{'eday'}, $self->{'emon'}, $self->{'eyear'}, 'expire');
	print " &nbsp; <input name=expireh size=3 value=\"$self->{'ehour'}\">";
	print "<b>:</b><input name=expiremi size=3 value=\"$self->{'emin'}\"></td> </tr>\n";

	print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'min_weeks'}</b>","min_weeks"),"</td>\n";
	print "<td><input size=5 name=min value=\"$self->{'uinfo_hash'}->{'min'}\"></td>\n";

	print "<td>",$self->hlink("<b>$self->{'text_hash'}->{'max_weeks'}</b>","max_weeks"),"</td>\n";
	print "<td><input size=5 name=max value=\"$self->{'uinfo_hash'}->{'max'}\"></td></tr>\n";

	print "<tr> <td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'warn'}</b>","warn"),"</td>\n";
	print "<td valign=top><input size=5 name=warn value=\"$self->{'uinfo_hash'}->{'warn'}\"></td>\n";

	print "<td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'flags'}</b>","flags"),
	      "</td> <td>\n";
	printf "<input type=checkbox name=flags value=admin %s> %s<br>\n",
		$self->{'uinfo_hash'}->{'admin'} ? 'checked' : '', $self->{'text_hash'}->{'uedit_admin'};
	printf "<input type=checkbox name=flags value=admchg %s> %s<br>\n",
		$self->{'uinfo_hash'}->{'admchg'} ? 'checked' : '', $self->{'text_hash'}->{'uedit_admchg'};
	printf "<input type=checkbox name=flags value=nocheck %s> %s\n",
		$self->{'uinfo_hash'}->{'nocheck'} ? 'checked' : '', $self->{'text_hash'}->{'uedit_nocheck'};
	print "</td> </tr>\n";

	print "</table></td></tr></table><p>\n";
	}

# Output group memberships
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_gmem'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
print "<tr> <td valign=top>",$self->hlink("<b>$self->{'text_hash'}->{'group'}</b>","group"),
      "</td> <td valign=top>\n";
if ($self->{'n'} eq "" && $self->{'access_hash'}->{'gcreate'}) {
	printf "<input type=radio name=gidmode value=2 %s> %s<br>\n",
		$self->{'config_hash'}->{'new_user_group'} ? 'checked' : '', $self->{'text_hash'}->{'uedit_samg'};
	printf "<input type=radio name=gidmode value=1> %s\n",
		$self->{'text_hash'}->{'uedit_newg'};
	print "<input name=newgid size=8><br>\n";
	printf "<input type=radio name=gidmode value=0 %s> %s\n",
		$self->{'config_hash'}->{'new_user_group'} ? '' : 'checked', $self->{'text_hash'}->{'uedit_oldg'};
	}
if ($self->{'access_hash'}->{'ugroups'} eq "*" || $self->{'access_hash'}->{'uedit_gmode'} >= 3) {
	local $w = 300;
	local $h = 200;
	if ($self->{'gconfig_hash'}->{'db_sizeuser'}) {
		($w, $h) = split(/x/, $self->{'gconfig_hash'}->{'db_sizeuser'});
		}
	printf "<input name=gid size=8 value=\"%s\">\n",
		$self->{'n'} eq "" ? $self->{'config_hash'}->{'default_group'}
			 : scalar($self->my_getgrgid($self->{'uinfo_hash'}->{'gid'}));
	print "<input type=button onClick='ifield = document.forms[0].gid; chooser = window.open(\"my_group_chooser.cgi?multi=0&group=\"+escape(ifield.value), \"chooser\", \"toolbar=no,menubar=no,scrollbars=yes,width=$w,height=$h\"); chooser.ifield = ifield; window.ifield = ifield' value=\"...\"></td>\n";
	}
else {
	print "<select name=gid>\n";
	local $cg = %{$self->{'uinfo_hash'}} ? $self->my_getgrgid($self->{'uinfo_hash'}->{'gid'}) : undef;
	@{$self->{'gl_array'}} = $self->unique($cg ? ($cg) : (), split(/\s+/, $self->{'access_hash'}->{'ugroups'}));
	foreach $g (@{$self->{'gl_array'}}) {
		printf "<option %s>%s\n",
			$cg eq $g ? "selected" : "", $g;
		}
	print "</select></td>\n";
	}

if ($self->{'config_hash'}->{'secmode'} != 1) {
	# Work out which secondary groups the user is in
	@{$self->{'defsecs_array'}} = $self->split_quoted_string($self->{'config_hash'}->{'default_secs'});
	@{$self->{'glist_array'}} = $self->list_groups();
	@{$self->{'glist_array'}} = sort { $a->{'group'} cmp $b->{'group'} } @{$self->{'glist_array'}}
		if ($self->{'config_hash'}->{'sort_mode'});
	%{$self->{'ingroups_hash'}} = ( );
	foreach $g (@{$self->{'glist_array'}}) {
		@{$self->{'mems_array'}} = split(/,/ , $g->{'members'});
		$self->{'ismem'} = $self->indexof($self->{'uinfo_hash'}->{'user'}, @{$self->{'mems_array'}}) >= 0;
		if ($self->{'n'} eq "") {
			$self->{'ismem'} = 1 if ($self->indexof($g->{'group'}, @{$self->{'defsecs_array'}}) >= 0);
			}
		$self->{'ingroups_hash'}->{$g->{'group'}} = $self->{'ismem'};
		}
	print "<td valign=top>",
	      $self->hlink("<b>$self->{'text_hash'}->{'uedit_2nd'}</b>","2nd"),"</td>\n";
	}

if ($self->{'config_hash'}->{'secmode'} == 0) {
	# Show secondary groups with select menu
	print "<td><select name=sgid multiple size=5>\n";
	foreach $g (@{$self->{'glist_array'}}) {
		next if (!$self->can_use_group(\%{$self->{'access_hash'}}, $g->{'group'}) &&
			 !$self->{'ingroups_hash'}->{$g->{'group'}});
		printf "<option value=\"%s\" %s>%s (%s)\n",
		    $g->{'group'}, $self->{'ingroups_hash'}->{$g->{'group'}} ? "selected" : "",
		    $g->{'group'}, $g->{'gid'};
		}
	print "</select></td>\n";
	}
elsif ($self->{'config_hash'}->{'secmode'} == 2) {
	# Show a text box
	@{$self->{'insecs_array'}} = ( );
	foreach $g (@{$self->{'glist_array'}}) {
		if ($self->{'ingroups_hash'}->{$g->{'group'}}) {
			push(@{$self->{'insecs_array'}}, $g->{'group'});
			}
		}
	print "<td>",$self->ui_textarea("sgid", join("\n", @{$self->{'insecs_array'}}), 5, 20),"</td>\n";
	}
else {
	# Don't show
	print "<td colspan=2 width=50%></td>\n";
	}
print "</tr>\n";

print "</table></td></tr></table><p>\n";

if ($self->{'n'} ne "") {
	# Editing a user - show options for moving home directory, changing IDs
	# and updating in other modules
	if ($self->{'access_hash'}->{'movehome'} == 1 || $self->{'access_hash'}->{'chuid'} == 1 ||
	    $self->{'access_hash'}->{'chgid'} == 1 || $self->{'access_hash'}->{'mothers'} == 1) {
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'onsave'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table>\n";

		if ($self->{'access_hash'}->{'movehome'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_movehome'}, "movehome"),"</td>\n";
			print "<td><input type=radio name=movehome value=1 checked> $self->{'text_hash'}->{'yes'}</td>\n";
			print "<td><input type=radio name=movehome value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
			}

		if ($self->{'access_hash'}->{'chuid'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_chuid'},"chuid"),"</td>\n";
			print "<td><input type=radio name=chuid value=0> $self->{'text_hash'}->{'no'}</td>\n";
			print "<td><input type=radio name=chuid value=1 checked> ",
			      "$self->{'text_hash'}->{'home'}</td>\n";
			print "<td><input type=radio name=chuid value=2> ",
			      "$self->{'text_hash'}->{'uedit_allfiles'}</td></tr>\n";
			}

		if ($self->{'access_hash'}->{'chgid'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'chgid'},"chgid"),"</td>\n";
			print "<td><input type=radio name=chgid value=0> $self->{'text_hash'}->{'no'}</td>\n";
			print "<td><input type=radio name=chgid value=1 checked> ".
			      "$self->{'text_hash'}->{'home'}</td>\n";
			print "<td><input type=radio name=chgid value=2> ",
			      "$self->{'text_hash'}->{'uedit_allfiles'}</td></tr>\n";
			}

		if ($self->{'access_hash'}->{'mothers'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_mothers'},"others"),"</td>\n";
			printf "<td><input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}</td>\n",
				$self->{'config_hash'}->{'default_other'} ? "checked" : "";
			printf "<td><input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
				$self->{'config_hash'}->{'default_other'} ? "" : "checked";
			}

		print "</table></td> </tr></table><p>\n";
		}
	}
else {
	# Creating a user - show options for creating home directory, copying
	# skel files and creating in other modules
	if ($self->{'access_hash'}->{'makehome'} == 1 || $self->{'access_hash'}->{'copy'} == 1 ||
	    $self->{'access_hash'}->{'cothers'} == 1) {
		print "<table border width=100%>\n";
		print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'uedit_oncreate'}</b></td> </tr>\n";
		print "<tr $self->{'cb'}> <td><table>\n";

		if ($self->{'access_hash'}->{'makehome'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_makehome'},"makehome"),"</td>\n";
			print "<td><input type=radio name=makehome value=1 checked> $self->{'text_hash'}->{'yes'}</td>\n";
			print "<td><input type=radio name=makehome value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
			}

		if ($self->{'config_hash'}->{'user_files'} =~ /\S/ && $self->{'access_hash'}->{'copy'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_copy'},
						 "copy_files"),"</td>\n";
			print "<td><input type=radio name=copy_files ",
			      "value=1 checked> $self->{'text_hash'}->{'yes'}</td>\n";
			print "<td><input type=radio name=copy_files ",
			      "value=0> $self->{'text_hash'}->{'no'}</td> </tr>\n";
			}

		if ($self->{'access_hash'}->{'cothers'} == 1) {
			print "<tr> <td>",$self->hlink($self->{'text_hash'}->{'uedit_cothers'},"others"),"</td>\n";
			printf "<td><input type=radio name=others value=1 %s> $self->{'text_hash'}->{'yes'}</td>\n",
				$self->{'config_hash'}->{'default_other'} ? "checked" : "";
			printf "<td><input type=radio name=others value=0 %s> $self->{'text_hash'}->{'no'}</td> </tr>\n",
				$self->{'config_hash'}->{'default_other'} ? "" : "checked";
			}

		print "</table></td> </tr></table><p>\n";
		}
	}
if ($self->{'n'} ne "") {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=\"$self->{'text_hash'}->{'save'}\"></td>\n";

	print "</form><form action=\"list_logins.cgi\">\n";
	print "<input type=hidden name=username value=\"$self->{'uinfo_hash'}->{'user'}\">\n";
	print "<td align=center>\n";
	print "<input type=submit value=\"$self->{'text_hash'}->{'uedit_logins'}\"></td>\n";

	if ($self->foreign_available("mailboxes") &&
	    $self->foreign_installed("mailboxes", 1)) {
		# Link to the mailboxes module, if installed
		print "</form><form action=../mailboxes/list_mail.cgi>\n";
		print "<input type=hidden name=user value='$self->{'uinfo_hash'}->{'user'}'>\n";
		print "<td align=center>\n";
		print "<input type=submit value='$self->{'text_hash'}->{'uedit_mail'}'></td>\n";
		}

	if ($self->foreign_available("usermin") &&
	    $self->foreign_installed("usermin", 1) &&
	    (%{$self->{'uacl_hash'}} = $self->get_module_acl("usermin") &&
	    $self->{'uacl_hash'}->{'sessions'})) {
		# Link to Usermin module for switching to some user
		$self->foreign_require("usermin", "usermin-lib.pl");
		local %uminiserv;
		&usermin::get_usermin_miniserv_config(\%uminiserv);
		if ($uminiserv{'session'}) {
			print "</form><form action=../usermin/switch.cgi ",
			      "target=_new>\n";
			print "<input type=hidden name=user ",
			      "value='$self->{'uinfo_hash'}->{'user'}'>\n";
			print "<td align=center>\n";
			print "<input type=submit value='$self->{'text_hash'}->{'uedit_swit'}'>",
			      "</td>\n";
			}
		}

	if ($self->{'access_hash'}->{'udelete'}) {
		print "</form><form action=\"delete_user.cgi\">\n";
		print "<input type=hidden name=num value=\"$self->{'n'}\">\n";
		print "<input type=hidden name=user value=\"$self->{'uinfo_hash'}->{'user'}\">\n";
		print "<td align=right><input type=submit value=\"$self->{'text_hash'}->{'delete'}\"></td> </tr>\n";
		}
	print "</form></table><p>\n";
	}
else {
	print "<input type=submit value=\"$self->{'text_hash'}->{'create'}\"></form><p>\n";
	}

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

