#!/usr/bin/perl
package virtual_server::Config_info;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'virtual_server::Config_info');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: ref($self), %$self; 

1;
		return $self;
}

sub show_dns_view {
	my $self = shift;

#	&init_config();
#	&foreign_require('bind8', 'bind-lib.pl');
	$self->require_bind();
	local $conf = $main::bind8_object->get_config();
	local @views = $main::bind8_object->find('view', $conf);
	local $rv = "<select name='dns_view'>\n";
	$rv .= sprintf "<option value='' %s>%s\n", $_[0] eq '' ? 'selected' : '', $self->{'text_hash'}->{newdns_noview};
	foreach my $v (@views) {
		$rv .= sprintf "<option value='%s' %s>%s\n", $v->{'values'}->[0], $_[0] eq $v->{'values'}->[0] ? 'selected' : '', $v->{'values'}->[0];
	}
	$rv .= "</select>";
	return $rv;
}

sub parse_dns_view {
	my $self = shift;

	return $self->{'in_hash'}->{'dns_view'};
}


1;

