#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_alias.cgi
# Display a form for editing or adding a mail alias

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'alias_create'}, "");
	}
else {
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'alias_edit'}, "");
	@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
	($self->{'virt'}) = grep { $_->{'from'} eq $self->{'in_hash'}->{'alias'} } @{$self->{'aliases_array'}};
	}

print $self->check_clicks_function();
print "<form action=save_alias.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=dom value='$self->{'in_hash'}->{'dom'}'>\n";
print "<input type=hidden name=old value='$self->{'in_hash'}->{'alias'}'>\n";

print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'alias_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table>\n";

$self->{'name'} = $self->{'virt'}->{'from'};
$self->{'name'} =~ s/\@\S+$//;
print "<tr> <td>",$self->hlink("<b>$self->{'text_hash'}->{'alias_name'}</b>", "aliasname"),"</td>\n";
printf "<td><input type=radio name=name_def value=1 %s> %s\n",
	$self->{'name'} eq "" && !$self->{'in_hash'}->{'new'} ? "checked" : "", $self->{'text_hash'}->{'alias_catchall'};
printf "<input type=radio name=name_def value=0 %s> %s\n",
	$self->{'name'} eq "" && !$self->{'in_hash'}->{'new'} ? "" : "checked", $self->{'text_hash'}->{'alias_mailbox'};
print "<input name=name size=20 value='$self->{'name'}'></td> </tr>\n";

$self->alias_form($self->{'virt'}->{'to'}, $self->hlink("<b>$self->{'text_hash'}->{'alias_dests'}</b>", "aliasdest"),
	    $self->{'d'}, "alias", $self->{'in_hash'}->{'alias'});

print "</table></td></tr></table>\n";

print "<table><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}' onClick='check_clicks(form)'></td>\n";
	}
print "</table></form>\n";

if ($self->{'single_domain_mode'}) {
	$self->ui_print_footer("list_aliases.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'aliases_return'},
		"", $self->{'text_hash'}->{'index_return2'});
	}
else {
	$self->ui_print_footer("list_aliases.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'aliases_return'},
		"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

