#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one DB

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});

if (! $self->{'in_hash'}->{'new'})
{
local @db_list= $self->domain_databases($self->{'d'});

    foreach (@db_list){
	if($_->{'name'} eq $self->{'in_hash'}->{'name'}  && $_->{'type'} eq $self->{'in_hash'}->{'type'}){ $self->{'can_edit'} = true;}
    }

    $self->{'can_edit'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
}

$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title1'}, "");
	}
else {
	$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'database_title2'}, "");
	}

print $self->ui_form_start("save_database.cgi", "post");
print $self->ui_hidden("dom", $self->{'in_hash'}->{'dom'}),"\n";
if (!$self->{'in_hash'}->{'new'}) {
	print $self->ui_hidden("name", $self->{'in_hash'}->{'name'}),"\n";
	print $self->ui_hidden("type", $self->{'in_hash'}->{'type'}),"\n";
	}
else {
	print $self->ui_hidden("new", 1),"\n";
	}
print $self->ui_table_start($self->{'text_hash'}->{'database_header'},"width=100%", 2);

print $self->ui_table_row($self->{'text_hash'}->{'database_name'},
    $self->{'in_hash'}->{'new'} ? $self->ui_textbox("name", undef, 30) : "<tt>$self->{'in_hash'}->{'name'}</tt>");

@{$self->{'types_array'}} = ( );
push(@{$self->{'types_array'}}, [ "mysql", $self->{'text_hash'}->{'databases_mysql'} ]) if ($self->{'d'}->{'mysql'});
push(@{$self->{'types_array'}}, [ "postgres", $self->{'text_hash'}->{'databases_postgres'} ]) if ($self->{'d'}->{'postgres'});
foreach $p (@{$self->{'database_plugins_array'}}) {
        push(@{$self->{'types_array'}}, [ $p, $self->plugin_call($p, "database_name") ]) if ($self->{'d'}->{$p});
        }
print $self->ui_table_row($self->{'text_hash'}->{'database_type'},
    $self->{'in_hash'}->{'new'} ? $self->ui_select("type", $self->{'types_array'}->[0]->[0], \@{$self->{'types_array'}}) :
    $self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'database_plugins_array'}}) >= 0 ?
        $self->plugin_call($self->{'in_hash'}->{'type'}, "database_name") :
               $self->{'text_hash'}->{'databases_'.$self->{'in_hash'}->{'type'}});

if (!$self->{'in_hash'}->{'new'}) {
        if ($self->indexof($self->{'in_hash'}->{'type'}, @{$self->{'database_plugins_array'}}) >= 0) {
                ($self->{'size'}, $self->{'tables'}) = $self->plugin_call($self->{'in_hash'}->{'type'}, "database_size",
                                                $self->{'d'}, $self->{'in_hash'}->{'name'});
                }
        else {
                $self->{'szfunc'} = $self->{'in_hash'}->{'type'}."_size";
                ($self->{'size'}, $self->{'tables'}) = do { my $fn = $self->{'szfunc'}; $self->$fn($self->{'d'}, $self->{'in_hash'}->{'name'})};
                }
	if ($self->{'size'} ne "") {
		print $self->ui_table_row($self->{'text_hash'}->{'database_size'}, $self->nice_size($self->{'size'}));
		}
	if ($self->{'tables'} ne "") {
		print $self->ui_table_row($self->{'text_hash'}->{'database_tables'}, $self->{'tables'});
		}
	}

print $self->ui_table_end();
if ($self->{'in_hash'}->{'new'}) {
	print $self->ui_form_end([ [ "create", $self->{'text_hash'}->{'databases_add'} ] ]);
	}
else {
	print $self->ui_form_end([ [ "delete", $self->{'text_hash'}->{'database_delete'} ],
		     $self->master_admin() ? ( [ "disc", $self->{'text_hash'}->{'database_disc'} ] )
				     : ( ) ]);
	}

#local $website = &cpplus_get_text(\%apps, 'text_website:$web', 'text_domain:$dns');

$self->ui_print_footer("", $self->text('index_return', $self->{'t_website'}), "edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}",
		 $self->text('edit_return', $self->{'t_website'}), "list_databases.cgi?dom=$self->{'in_hash'}->{'dom'}",
		  $self->text('databases_return', $self->{'t_website'}));

#$self->ui_print_footer("list_databases.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'databases_return'},
		 #"edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
		 #"", $self->{'text_hash'}->{'index_return'});
1;
		
}


1;

