#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display all virtual server templates

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newtmpl_ecannot'});
$self->ui_print_header(undef, $self->{'text_hash'}->{'newtmpl_title'}, "");

# Show list of templates
@{$self->{'tmpls_array'}} = $self->list_templates();
print "<a href='edit_tmpl.cgi?new=1'>$self->{'text_hash'}->{'newtmpl_add'}</a>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'newtmpl_name'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_skel'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_web'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_dns'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_ftp'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_frame'}</b></td>\n",
      "<td><b>$self->{'text_hash'}->{'newtmpl_mail'}</b></td>\n",
      "</tr>\n";
foreach $t (@{$self->{'tmpls_array'}}) {
	next if ($t->{'deleted'});
	print "<tr $self->{'cb'}>\n";
	print "<td><a href='edit_tmpl.cgi?id=$t->{'id'}'>$t->{'name'}</a></td>\n";
	print "<td>",$t->{'skel'} eq "none" ? $self->{'text_hash'}->{'newtmpl_none'} :
		     $t->{'skel'} eq "" ? $self->{'text_hash'}->{'default'} :
					  "<tt>$t->{'skel'}</tt>","</td>\n";
	foreach $w ('web', 'dns', 'ftp', 'frame', 'mail_on') {
		print "<td>",$t->{$w} eq "none" ? $self->{'text_hash'}->{'newtmpl_none'} :
			     $t->{$w} eq "" ? $self->{'text_hash'}->{'default'} :
				      "<i>$self->{'text_hash'}->{'newtmpl_cust'}</i>","</td>\n";
		}
	print "</tr>\n";
	}
print "</table>\n";
print "<a href='edit_tmpl.cgi?new=1'>$self->{'text_hash'}->{'newtmpl_add'}</a><p>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, 'index_config.cgi', $self->{'text_hash'}->{'config_title'});
1;
		
}


1;

