#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Display a form for editing the configuration of a plugin

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

&ModuleLoader::preload_module('virtual_server_class', "ConfigLib");
$self = new ConfigLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newplugin_ecannot'});
$self->ReadParse();
$self->{'m'} = $self->{'in_hash'}->{'mod'};
%{$self->{'module_info_hash'}} = $self->get_module_info($self->{'m'});
$self->ui_print_header($self->text('plugconfig_dir', $self->{'module_info_hash'}->{'desc'}),
		 $self->{'text_hash'}->{'plugconfig_title'}, "");

print "<form action=\"save_plugconfig.cgi\" method=post>\n";
print "<input type=hidden name=module value=\"$self->{'m'}\">\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>",$self->text('config_header', $self->{'module_info_hash'}->{'desc'}),
      "</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";
$self->read_file("$self->{'config_directory'}/$self->{'m'}/config", \%{$self->{'pconfig_hash'}});

$self->{'mdir'} = $self->UNIVERSAL::can('module_root_directory') ? $self->module_root_directory($self->{'m'})
					: "$self->{'root_directory'}/$self->{'m'}";
if (-r "$self->{'mdir'}/config_info.pl") {
	# Module has a custom config editor
	$self->foreign_require($self->{'m'}, "config_info.pl");
	local $fn = "$self->{'m'}::config_form";
	if (defined(&$fn)) {
		$self->{'func'}++;
		$self->foreign_call($self->{'m'}, "config_form", \%{$self->{'pconfig_hash'}});
		}
	}
if (!$self->{'func'}) {
	# Use config.info to create config inputs
	$self->generate_config(\%{$self->{'pconfig_hash'}}, "$self->{'mdir'}/config.info", $self->{'m'});
	}
print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

