#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_rfile.cgi
# Display the contents of an autoreply file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'rfile_ecannot'});

$self->ui_print_header(undef, $self->{'text_hash'}->{'rfile_title'}, "");

$self->switch_to_domain_user($self->{'d'});
if (-e $self->{'in_hash'}->{'file'}) {
	open(FILE, $self->{'in_hash'}->{'file'}) ||
		$self->error($self->text('rfile_eread', $self->{'in_hash'}->{'file'}, $self->{'d'}->{'user'}, $!));
	while(<FILE>) {
		if (/^Reply-Tracking:\s*(.*)/) {
			$self->{'replies'} = $1;
			}
		elsif (/^Reply-Period:\s*(.*)/) {
			$self->{'period'} = $1;
			}
		else {
			push(@{$self->{'lines_array'}}, $_);
			}
		}
	close(FILE);
	}

print $self->text('rfile_desc', "<tt>$self->{'in_hash'}->{'file'}</tt>"),"<p>\n";
print "$self->{'text_hash'}->{'rfile_desc2'}<p>\n";

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
print "<form action=save_rfile.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=file value=\"$self->{'in_hash'}->{'file'}\">\n";
print "<input type=hidden name=dom value=\"$self->{'in_hash'}->{'dom'}\">\n";
print "<input type=hidden name=$self->{'what'} value=\"",$self->{'in_hash'}->{$self->{'what'}},"\">\n";
print "<textarea name=text rows=20 cols=80>",
	join("", @{$self->{'lines_array'}}),"</textarea><p>\n";

print $self->{'text_hash'}->{'rfile_replies'},"\n";
printf "<input type=radio name=replies_def value=1 %s> %s\n",
	$self->{'replies'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_none'};
printf "<input type=radio name=replies_def value=0 %s> %s\n",
	$self->{'replies'} eq '' ? "" :"checked", $self->{'text_hash'}->{'rfile_file'};
printf "<input name=replies size=30 value='%s'> %s<br>\n",
	$self->{'replies'}, $self->file_chooser_button("replies");
print "&nbsp;" x 3;
print $self->{'text_hash'}->{'rfile_period'},"\n";
printf "<input type=radio name=period_def value=1 %s> %s\n",
	$self->{'period'} eq '' ? "checked" : "", $self->{'text_hash'}->{'rfile_default'};
printf "<input type=radio name=period_def value=0 %s>\n",
	$self->{'period'} eq '' ? "" :"checked";
printf "<input name=period size=5 value='%s'> %s<p>\n",
	$self->{'period'}, $self->{'text_hash'}->{'rfile_secs'};

print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"> ",
      "<input type=reset value=\"$self->{'text_hash'}->{'rfile_undo'}\">\n";
print "</form>\n";

$self->ui_print_footer("edit_$self->{'what'}.cgi?dom=$self->{'in_hash'}->{'dom'}&$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}",
	$self->{'text_hash'}->{$self->{'what'}.'_return'});
1;
		
}


1;

