#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Show one template for editing

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newtmpl_ecannot'});
$self->ReadParse();

$self->{'tmpl_title'} = "tmpl_title_$self->{'in_hash'}->{'tmpl_mode'}" if ($self->{'in_hash'}->{'tmpl_mode'});

if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'tmpl_title1'}, "");
	}
else {
	if ($self->{'in_hash'}->{'tmpl_mode'}) {
    		$self->ui_print_header(undef, $self->{'text_hash'}->{$self->{'tmpl_title'}}, "");
	} else {
    		$self->ui_print_header(undef, $self->{'text_hash'}->{'tmpl_title2'}, "");
		}
	@{$self->{'tmpls_array'}} = $self->list_templates();
	($self->{'tmpl'}) = grep { $_->{'id'} == $self->{'in_hash'}->{'id'} } @{$self->{'tmpls_array'}};
	$self->{'tmpl'} || $self->error("Failed to find template with ID $self->{'in_hash'}->{'id'}");
	}

# Show description including template variables
print "$self->{'text_hash'}->{'tmpl_desc'}<br>\n";
$self->print_subs_table("DOM", "PREFIX", "USER", "IP", "HOME");

print $self->ui_form_start("save_tmpl.cgi", "post");
print $self->ui_hidden("id", $self->{'in_hash'}->{'id'}),"\n";
print $self->ui_hidden("new", $self->{'in_hash'}->{'new'}),"\n";
print $self->ui_hidden("tmpl_mode", $self->{'in_hash'}->{'tmpl_mode'}),"\n";
if (!$self->{'in_hash'}->{'tmpl_mode'}) {
    print $self->ui_table_start($self->{'text_hash'}->{'tmpl_header'}, "100%", 2);
    } else {
	print $self->ui_table_start($self->{'text_hash'}->{$self->{'tmpl_title'}}, "100%", 2);
	}

if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 1) {
# Name of this template - only editable for custom templates
#print "<tr><td><b>$self->{'text_hash'}->{'tmpl_name'}</b></td> <td>\n";
#if ($self->{'tmpl'}->{'standard'}) {
#	print "$self->{'tmpl'}->{'name'}\n";
#	}
#else {
#	printf "<input name=name size=40 value='%s'>\n", $self->{'tmpl'}->{'name'};
#	}
#print "</td> </tr>\n";

# The skeleton files directory
print "<tr> <td><b>$self->{'text_hash'}->{'tmpl_skel'}</b></td> <td>\n";
print &none_def_input("skel", $self->{'tmpl'}->{'skel'}, $self->{'text_hash'}->{'tmpl_skeldir'}, 0,
		$self->{'tmpl'}->{'standard'} ? 1 : 0);
printf "<input name=skel size=40 value='%s'></td> </tr>\n",
	$self->{'tmpl'}->{'skel'} eq "none" ? undef : $self->{'tmpl'}->{'skel'};

# Who this template is suitable for
#print "<tr> <td><b>$self->{'text_hash'}->{'tmpl_for'}</b></td> <td>\n";
#foreach $f ("parent", "sub", "alias", "users") {
#	if ($self->{'tmpl'}->{'standard'}) {
#		if ($self->{'tmpl'}->{"for_".$f}) {
#			print ",\n" if ($done_one_for++);
#			print $self->{'text_hash'}->{'tmpl_for_'.$f},"\n";
#			}
#		}
#	else {
#		printf "<input type=checkbox name=for_%s value=1 %s> %s\n",
#			$f, $self->{'tmpl'}->{"for_".$f} ? "checked" : "",
#			$self->{'text_hash'}->{'tmpl_for_'.$f};
#		}
#	}
#print "</td> </tr>\n";

#print $self->ui_table_hr();

# Global ACL on or off
if (!$self->{'tmpl'}->{'default'}) {
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_gacl'}</b></td> <td>\n";
	print $self->ui_radio("gacl", int($self->{'tmpl'}->{'gacl'}),
			   [ [ 0, $self->{'text_hash'}->{'default'} ],
			     [ 1, $self->{'text_hash'}->{'tmpl_gaclbelow'} ] ]),"</td>\n";
	}

# Global ACL users
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_gaclu'}</b></td> <td>\n";
printf "<input type=radio name=gacl_umode value=0 %s> %s\n",
	$self->{'tmpl'}->{'gacl_umode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'tmpl_gacl0'};
printf "<input name=gacl_uusers size=40 value='%s'><br>\n",
	$self->{'tmpl'}->{'gacl_umode'} == 0 ? $self->{'tmpl'}->{'gacl_uusers'} : "";
printf "<input type=radio name=gacl_umode value=1 %s> %s\n",
	$self->{'tmpl'}->{'gacl_umode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'tmpl_gacl1'};
printf "<input name=gacl_ugroups size=40 value='%s'></td> </tr>\n",
	$self->{'tmpl'}->{'gacl_umode'} == 1 ? $self->{'tmpl'}->{'gacl_ugroups'} : "";

# Global ACL groups
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_gaclg'}</b></td> <td>\n";
printf "<input name=gacl_groups size=40 value='%s'></td> </tr>\n",
	$self->{'tmpl'}->{'gacl_groups'};

# Global ACL root
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_gaclr'}</b></td> <td>\n";
printf "<input name=gacl_root size=40 value='%s'></td> </tr>\n",
	$self->{'tmpl'}->{'gacl_root'};

#print $self->ui_table_hr();
}

if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 2) {
# Defaults for new domain form
#print $self->ui_table_row($self->{'text_hash'}->{'tmpl_ugroup'},
#    &none_def_input("ugroup", $self->{'tmpl'}->{'ugroup'}, $self->{'text_hash'}->{'tmpl_ugroupsel'})."\n".
#    $self->ui_textbox("ugroup", $self->{'tmpl'}->{'ugroup'} eq "none" ?
#				"" : $self->{'tmpl'}->{'ugroup'}, 13)."\n".
#    $self->group_chooser_button("ugroup"));

#print $self->ui_table_row($self->{'text_hash'}->{'tmpl_quota'},
#    &none_def_input("quota", $self->{'tmpl'}->{'quota'}, $self->{'text_hash'}->{'tmpl_quotasel'})."\n".	#, 1
#    $self->ui_textbox("quota", $self->{'tmpl'}->{'quota'} eq "none" ?
#				"" : $self->{'tmpl'}->{'quota'}, 13));

#print $self->ui_table_row($self->{'text_hash'}->{'tmpl_uquota'},
#    &none_def_input("uquota", $self->{'tmpl'}->{'uquota'}, $self->{'text_hash'}->{'tmpl_quotasel'})."\n".		#,1
#    $self->ui_textbox("uquota", $self->{'tmpl'}->{'uquota'} eq "none" ?
#				"" : $self->{'tmpl'}->{'uquota'}, 13));

#foreach $l ("mailbox", "dbs", "doms", "bw") {
#	print $self->ui_table_row($self->{'text_hash'}->{'tmpl_'.$l.'limit'},
#	    &none_def_input($l.'limit', $self->{'tmpl'}->{$l.'limit'},
#			    $self->{'text_hash'}->{'tmpl_atmost'}, undef, undef,
#			    $self->{'text_hash'}->{'form_unlimit'})."\n".
#	    $self->ui_textbox($l.'limit', $self->{'tmpl'}->{$l.'limit'} eq "none" ?
#					"" : $self->{'tmpl'}->{$l.'limit'}, 10));
#	}
}

if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 3) {
if ($self->{'config_hash'}->{'web'}) {
	# Apache directives and other settings
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_web'}</b></td> <td>\n";
	print &none_def_input("web", $self->{'tmpl'}->{'web'}, $self->{'text_hash'}->{'tmpl_webbelow'}, 1);
	print "<textarea name=web rows=10 cols=60>";
	if ($self->{'tmpl'}->{'web'} ne "none") {
		print join("\n", split(/\t/, $self->{'tmpl'}->{'web'}));
		}
	print "</textarea>\n";

	print "</td></tr>\n";

print $self->ui_table_row($self->{'text_hash'}->{'tmpl_ugroup'},
    &none_def_input("ugroup", $self->{'tmpl'}->{'ugroup'}, $self->{'text_hash'}->{'tmpl_ugroupsel'})."\n".
    $self->ui_textbox("ugroup", $self->{'tmpl'}->{'ugroup'} eq "none" ?
				"" : $self->{'tmpl'}->{'ugroup'}, 13)."\n".
    $self->group_chooser_button("ugroup"));

	# Input for adding suexec directives
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_suexec'}</b></td>\n";
	print "<td>",$self->ui_radio("suexec", $self->{'tmpl'}->{'web_suexec'} ? 1 : 0,
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

	# Input for logging via program
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_writelogs'}</b></td>\n";
	print "<td>",$self->ui_radio("writelogs", $self->{'tmpl'}->{'web_writelogs'} ? 1 : 0,
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

	# Input for Apache user to add to domain's group
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_user'}</b></td>\n";
	print "<td>",$self->ui_opt_textbox("user", $self->{'tmpl'}->{'web_user'}, 13,
				     $self->{'text_hash'}->{'no'}, $self->{'text_hash'}->{'newweb_useryes'}),"\n",
		     $self->user_chooser_button("user"),"</td> </tr>\n";

	# HTML sub-directory input
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newweb_htmldir'}</b></td>\n";
	printf "<td nowrap><input type=radio name=html_dir_def value=1 %s> %s (%s)\n",
		$self->{'tmpl'}->{'web_html_dir'} ? "" : "checked", $self->{'text_hash'}->{'default'},
		"<tt>public_html</tt>";
	printf "<br><input type=radio name=html_dir_def value=0 %s> %s\n",
		$self->{'tmpl'}->{'web_html_dir'} ? "checked" : "", $self->{'text_hash'}->{'newweb_htmldir0'};
	printf "<input name=html_dir size=20 value='%s'><br>%s</td> </tr>\n",
		$self->{'tmpl'}->{'web_html_dir'}, ("&nbsp;" x 3).$self->{'text_hash'}->{'newweb_htmldir0suf'};
	$self->{'hdir'} = $self->{'tmpl'}->{'web_html_dir'} || "public_html";

	# HTML directory permissions
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_htmlperms'}</b></td>\n";
	print "<td>",$self->ui_textbox("html_perms", $self->{'tmpl'}->{'web_html_perms'}, 4),
	      "</td> </tr>\n";

	# Webalizer stats sub-directory input
	$self->{'smode'} = $self->{'tmpl'}->{'web_stats_hdir'} ? 2 :
		 $self->{'tmpl'}->{'web_stats_dir'} ? 1 : 0;
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newweb_statsdir'}</b></td>\n";
	printf "<td nowrap><input type=radio name=stats_mode value=0 %s> %s (%s)\n",
		$self->{'smode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'default'},
		"<tt>$self->{'hdir'}/stats</tt>";
	printf "<br><input type=radio name=stats_mode value=1 %s> %s\n",
		$self->{'smode'} == 1 ? "checked" : "",
		$self->text('newweb_statsdir0', "<tt>$self->{'hdir'}</tt>");
	printf "<input name=stats_dir size=20 value='%s'>\n",
		$self->{'tmpl'}->{'web_stats_dir'};
	printf "<br><input type=radio name=stats_mode value=2 %s> %s\n",
		$self->{'smode'} == 2 ? "checked" : "",
		$self->text('newweb_statsdir2', "<tt>$self->{'hdir'}</tt>");
	printf "<input name=stats_hdir size=20 value='%s'>\n",
		$self->{'tmpl'}->{'web_stats_hdir'};
	print "</td> </tr>\n";

	# Password-protect webalizer dir
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newweb_statspass'}</b></td>\n";
	print "<td>",$self->ui_radio("statspass", $self->{'tmpl'}->{'web_stats_pass'} ? 1 : 0,
	       [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

	# Alias mode
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_alias'}</b></td> <td>\n";
	printf "<input type=radio name=alias_mode value=0 %s> %s<br>\n",
		$self->{'tmpl'}->{'web_alias'} == 0 ? "checked" : "", $self->{'text_hash'}->{'tmpl_alias0'};
	printf "<input type=radio name=alias_mode value=2 %s> %s<br>\n",
		$self->{'tmpl'}->{'web_alias'} == 2 ? "checked" : "", $self->{'text_hash'}->{'tmpl_alias2'};
	printf "<input type=radio name=alias_mode value=1 %s> %s<br>\n",
		$self->{'tmpl'}->{'web_alias'} == 1 ? "checked" : "", $self->{'text_hash'}->{'tmpl_alias1'};
	print "</td> </tr>\n";

	# Port for normal webserver
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_port'}</b></td>\n";
	printf "<td><input name=web_port size=6 value='%s'></td> </tr>\n",
		$self->{'tmpl'}->{'web_port'};

	# Port for SSL webserver
	print "<tr> <td><b>$self->{'text_hash'}->{'newweb_sslport'}</b></td>\n";
	printf "<td><input name=web_sslport size=6 value='%s'></td> </tr>\n",
		$self->{'tmpl'}->{'web_sslport'};

	if ($self->get_webmin_version() >= 1.201) {
		# Setup matching Webmin/Usermin SSL cert
		print "<tr> <td valign=top><b>",
		      "$self->{'text_hash'}->{'newweb_webmin'}</b></td>\n";
		print "<td>",$self->ui_radio("web_webmin_ssl",
		   $self->{'tmpl'}->{'web_webmin_ssl'} ? 1 : 0,
		   [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

		print "<tr> <td valign=top><b>",
		      "$self->{'text_hash'}->{'newweb_usermin'}</b></td>\n";
		print "<td>",$self->ui_radio("web_usermin_ssl",
		   $self->{'tmpl'}->{'web_usermin_ssl'} ? 1 : 0,
		   [ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ] ]),"</td> </tr>\n";

		}
#	print "</table></td> </tr>\n";

	# Webalizer template
	print $self->ui_table_row($self->{'text_hash'}->{'tmpl_webalizer'},
	    &none_def_input("webalizer", $self->{'tmpl'}->{'webalizer'},
			    $self->{'text_hash'}->{'tmpl_webalizersel'}, 0, 0,
			    $self->{'text_hash'}->{'tmpl_webalizernone'})."\n".
	    $self->ui_textbox("webalizer", $self->{'tmpl'}->{'webalizer'} eq "none" ?
					"" : $self->{'tmpl'}->{'webalizer'}, 40));
	}
}
if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 4) {
if ($self->{'config_hash'}->{'dns'}) {
	# DNS directives
	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_dns'}</b></td> <td>\n";
	print &none_def_input("dns", $self->{'tmpl'}->{'dns'}, $self->{'text_hash'}->{'tmpl_dnsbelow'}, 1);
	print "<textarea name=dns rows=10 cols=60>";
	if ($self->{'tmpl'}->{'dns'} ne "none") {
		print join("\n", split(/\t/, $self->{'tmpl'}->{'dns'}));
		}
	print "</textarea>\n";

	print "</td></tr>\n";

	print "<tr> <td><b>$self->{'text_hash'}->{'tmpl_replace'}</b></td> <td>\n";
	printf "<input type=radio name=bind_replace value=0 %s> %s\n",
		$self->{'tmpl'}->{'dns_replace'} ? "" : "checked", $self->{'text_hash'}->{'tmpl_replace0'};
	printf "<input type=radio name=bind_replace value=1 %s> %s</td> </tr>\n",
		$self->{'tmpl'}->{'dns_replace'} ? "checked" : "", $self->{'text_hash'}->{'tmpl_replace1'};

	$self->require_bind();
	$self->{'conf'} = $main::bind8_object->get_config();
	@{$self->{'views_array'}} = $main::bind8_object->find("view", $self->{'conf'});
	if (@{$self->{'views_array'}}) {
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newdns_view'}</b></td>\n";
		print "<td><select name=view>\n";
		printf "<option value='' %s>%s\n",
			$self->{'config_hash'}->{'dns_view'} eq "" ? "selected" : "",
			$self->{'text_hash'}->{'newdns_noview'};
		foreach $v (@{$self->{'views_array'}}) {
			printf "<option value=%s %s>%s\n",
				$v->{'values'}->[0],
				$self->{'config_hash'}->{'dns_view'} eq $v->{'values'}->[0] ? "selected" : "",
				$v->{'values'}->[0];
			}
		print "</select></td> </tr>\n";
		}

#	print "</td> </tr>\n";
	}
}
if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 5 || $self->{'in_hash'}->{'tmpl_mode'} == 9) {
# FTP directives
if ($self->{'config_hash'}->{'ftp'}) {
	if ($self->{'config_hash'}->{'ftp_system'} == 2) {
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_ftp'}</b></td> <td>\n";
		print &none_def_input("ftp_vsftpd", $self->{'tmpl'}->{'ftp_vsftpd'}, $self->{'text_hash'}->{'tmpl_ftpbelow'}, 1);
		print "<textarea name=ftp_vsftpd rows=10 cols=60>";
		if ($self->{'tmpl'}->{'ftp'} ne "none") {
			print join("\n", split(/\t/, $self->{'tmpl'}->{'ftp_vsftpd'}));
			}
		print "</textarea>\n";
		print "</td> </tr>\n";
		# Directory for anonymous FTP
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newftp_dir'}</b></td>\n";
		printf "<td nowrap><input type=radio name=ftp_dir_def value=1 %s> %s (%s)\n",
			$self->{'tmpl'}->{'ftp_dir'} ? "" : "checked", $self->{'text_hash'}->{'default'},
			"<tt>ftp</tt>";
		printf "<br><input type=radio name=ftp_dir_def value=0 %s> %s\n",
			$self->{'tmpl'}->{'ftp_dir'} ? "checked" : "", $self->{'text_hash'}->{'newftp_dir0'};
		printf "<input name=ftp_dir size=20 value='%s'></td> </tr>\n",
			$self->{'tmpl'}->{'ftp_dir'};
		print "</td> </tr>\n";
		}
	else {
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_ftp'}</b></td> <td>\n";
		print &none_def_input("ftp", $self->{'tmpl'}->{'ftp'}, $self->{'text_hash'}->{'tmpl_ftpbelow'}, 1);
		print "<textarea name=ftp rows=10 cols=60>";
		if ($self->{'tmpl'}->{'ftp'} ne "none") {
			print join("\n", split(/\t/, $self->{'tmpl'}->{'ftp'}));
			}
		print "</textarea>\n";

		print "</td></tr>\n";

		# Directory for anonymous FTP
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'newftp_dir'}</b></td>\n";
		printf "<td nowrap><input type=radio name=ftp_dir_def value=1 %s> %s (%s)\n",
			$self->{'tmpl'}->{'ftp_dir'} ? "" : "checked", $self->{'text_hash'}->{'default'},
			"<tt>ftp</tt>";
		printf "<br><input type=radio name=ftp_dir_def value=0 %s> %s\n",
			$self->{'tmpl'}->{'ftp_dir'} ? "checked" : "", $self->{'text_hash'}->{'newftp_dir0'};
		printf "<input name=ftp_dir size=20 value='%s'><br>%s</td> </tr>\n",
			$self->{'tmpl'}->{'ftp_dir'}, ("&nbsp;" x 3).$self->{'text_hash'}->{'newftp_dir0suf'};

		print "</td> </tr>\n";
		}
	}
}
if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 6) {
if ($self->{'config_hash'}->{'proxy_pass'} == 2) {
	# Frame-forwarding HTML (if enabled)
	print $self->ui_table_hr();

	print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_frame'}</b></td> <td>\n";
	print &none_def_input("frame", $self->{'tmpl'}->{'frame'}, $self->{'text_hash'}->{'tmpl_framebelow'}, 1);
	print "<textarea name=frame rows=10 cols=60>";
	if ($self->{'tmpl'}->{'frame'} ne "none") {
		print join("\n", split(/\t/, $self->{'tmpl'}->{'frame'}));
		}
	print "</textarea></td> </tr>\n";
	}
}

if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 7) {
# Email message for server creation
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mail'}</b></td> <td>\n";
print &none_def_input("mail", $self->{'tmpl'}->{'mail_on'}, $self->{'text_hash'}->{'tmpl_mailbelow'});
print "<br><textarea name=mail rows=10 cols=60>";
if ($self->{'tmpl'}->{'mail'} ne "none") {
	print join("\n", split(/\t/, $self->{'tmpl'}->{'mail'}));
	}
print "</textarea>\n";
print $self->email_template_input(undef, $self->{'tmpl'}->{'mail_subject'}, $self->{'tmpl'}->{'mail_cc'});
print "</td> </tr>\n";
}

if (!$self->{'in_hash'}->{'tmpl_mode'} || $self->{'in_hash'}->{'tmpl_mode'} == 8) {
# MySQL-related settings
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mysql'}</b></td> <td>\n";
print &none_def_input("mysql", $self->{'tmpl'}->{'mysql'}, $self->{'text_hash'}->{'tmpl_mysqlpat'}, 1);
print $self->ui_textbox("mysql", $self->{'tmpl'}->{'mysql'}, 20);
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mysql_wild'}</b></td> <td>\n";
print &none_def_input("mysql_wild", $self->{'tmpl'}->{'mysql_wild'}, $self->{'text_hash'}->{'tmpl_mysqlpat'}, 1);
print $self->ui_textbox("mysql_wild", $self->{'tmpl'}->{'mysql_wild'}, 20);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mysql_hosts'}</b></td> <td>\n";
print &none_def_input("mysql_hosts", $self->{'tmpl'}->{'mysql_hosts'}, $self->{'text_hash'}->{'tmpl_mysqlh'});
print $self->ui_textbox("mysql_hosts", $self->{'tmpl'}->{'mysql_hosts'} eq "none" ? "" : $self->{'tmpl'}->{'mysql_hosts'}, 40);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mysql_mkdb'}</b></td> <td>\n";
print $self->ui_radio("mysql_mkdb", $self->{'tmpl'}->{'mysql_mkdb'},
		[ [ 1, $self->{'text_hash'}->{'yes'} ], [ 0, $self->{'text_hash'}->{'no'} ],
		  ($self->{'tmpl'}->{'default'} ? ( ) : ( [ "", $self->{'text_hash'}->{'default'} ] ) ) ]);

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'tmpl_mysql_nopass'}</b></td> <td>\n";
print $self->ui_radio("mysql_nopass", $self->{'tmpl'}->{'mysql_nopass'},
		[ [ 0, $self->{'text_hash'}->{'yes'} ], [ 1, $self->{'text_hash'}->{'no'} ],
		  ($self->{'tmpl'}->{'default'} ? ( ) : ( [ "", $self->{'text_hash'}->{'default'} ] ) ) ]);
print "</td> </tr>\n";
}
print $self->ui_table_end();

# Buttons to save, create or delete
print $self->ui_form_end([
	[ "save", $self->{'in_hash'}->{'new'} ? $self->{'text_hash'}->{'create'} : $self->{'text_hash'}->{'save'} ],
	!$self->{'in_hash'}->{'new'} && !$self->{'tmpl'}->{'standard'} ?
		( [ "delete", $self->{'text_hash'}->{'delete'} ] ) : ( )
	]);

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'}, 'index_config.cgi', $self->{'text_hash'}->{'config_title'});

1;
		
}

# none_def_input(name, value, final-option, no-none, no-default, none-text)
sub none_def_input
{
	shift if ($self == $_[0]);

local $rv;
local $mode = $_[1] eq "none" ? 0 :
	      $_[1] eq "" ? 1 : 2;
local @opts;
push(@opts, 0) if (!$_[3]);
push(@opts, 1) if (!$self->{'tmpl'}->{'default'} && !$_[4]);
push(@opts, 2);
if (@opts > 1) {
	local $m;
	foreach $m (@opts) {
		$rv .= $self->ui_oneradio("$_[0]_mode", $m,
			$m == 0 ? ($_[5] || $self->{'text_hash'}->{'newtmpl_none'}) :
			$m == 1 ? $self->{'text_hash'}->{'default'} : $_[2], $mode == $m)."\n";
		}
	}
else {
	$rv .= $self->ui_hidden("$_[0]_mode", $opts[0])."\n";
	}
return $rv;
}


1;

