#!/usr/bin/perl

&MAIN();

 sub MAIN {
# index.cgi
# Display a list of domains managed by this module

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;


$self->ui_print_header(undef, $self->text('index_title', $self->{'t_websites'}), "", undef, undef, 1);

$self->ztl_check_quotas();

# Display domains
@{$self->{'doms_array'}} = grep { $self->can_edit_domain($_) } $self->list_domains();
if (@{$self->{'doms_array'}}) {
	# Show domains in a table
	print "<p>$self->{'text_hash'}->{'website_list_descr'}</p>";
	$self->domains_table(\@{$self->{'doms_array'}});
	}
else {
	print "<b>$self->{'text_hash'}->{'index_none'}</b><p>\n";
	}
print "<p>\n";

$self->ui_print_footer($self->{'text_hash'}->{'index_mainpage_url'}, $self->{'text_hash'}->{'index_mainpage'});

1;
		
}


1;

