#!/usr/bin/perl

&MAIN();

 sub MAIN {
# list_aliases.cgi
# Display users and aliases in a domain

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
@{$self->{'aliases_array'}} = $self->list_domain_aliases($self->{'d'});
$self->ui_print_header($self->domain_in($self->{'d'}), $self->{'text_hash'}->{'aliases_title'}, "");

if (@{$self->{'aliases_array'}}) {
	print "<a href='edit_alias.cgi?new=1&dom=$self->{'in_hash'}->{'dom'}'>",
	      "$self->{'text_hash'}->{'aliases_add'}</a><br>\n";
	print "<table border width=100%>\n";
	print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'aliases_name'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'aliases_domain'}</b></td> ",
	      "<td><b>$self->{'text_hash'}->{'aliases_dests'}</b></td> </tr>\n";
	foreach $a (@{$self->{'aliases_array'}}) {
		$self->{'name'} = $a->{'from'};
		$self->{'name'} =~ s/\@\S+$//;
		$self->{'name'} = "<i>$self->{'text_hash'}->{'alias_catchall'}</i>" if ($self->{'name'} eq "");
		print "<tr $self->{'cb'}>\n";
		print "<td valign=top><a href='edit_alias.cgi?dom=$self->{'in_hash'}->{'dom'}&",
		      "alias=$a->{'from'}'>$self->{'name'}</a></td>\n";
		print "<td valign=top>",$self->{'d'}->{'dom'},"</td>\n";
		print "<td>\n";
		foreach $v (@{$a->{'to'}}) {
			($self->{'anum'}, $self->{'astr'}) = $self->alias_type($v);
			print $self->text("aliases_type$self->{'anum'}",
			    "<tt>".$self->html_escape($self->{'astr'})."</tt>"),"<br>\n";
			}
		if (!@{$a->{'to'}}) { print "<i>$self->{'text_hash'}->{'aliases_dnone'}</i>\n"; }
		print "</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<b>$self->{'text_hash'}->{'aliases_none'}</b><p>\n";
	}
print "<a href='edit_alias.cgi?new=1&dom=$self->{'in_hash'}->{'dom'}'>",
      "$self->{'text_hash'}->{'aliases_add'}</a><p>\n";

if ($self->{'single_domain_mode'}) {
	$self->ui_print_footer("", $self->{'text_hash'}->{'index_return2'});
	}
else {
	$self->ui_print_footer("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}", $self->{'text_hash'}->{'edit_return'},
		"", $self->{'text_hash'}->{'index_return'});
	}

1;
		
}


1;

