#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save frame-forwarding HTML

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParseMime();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->{'access_hash'}->{'edit'} && $self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});

$self->{'ff'} = $self->framefwd_file($self->{'d'});
$self->switch_to_domain_user($self->{'d'});
$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->{'in_hash'}->{'text'} =~ s/\n*$/\n/;
$self->open_lock_tempfile(FILE, ">$self->{'ff'}", 1) ||
	$self->error($self->text('expframe_ewrite', $self->{'ff'}, $self->{'d'}->{'user'}, $!));
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);

$self->webmin_log("frame", "domain", $self->{'d'}->{'dom'}, $self->{'d'});
$self->redirect("edit_domain.cgi?dom=$self->{'in_hash'}->{'dom'}");
1;
		
}


1;

