#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_ffile.cgi
# Save a filter file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParseMime();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'ffile_ecannot'});
$self->error_setup($self->{'text_hash'}->{'ffile_err'});

for($i=0; defined($self->{'in_hash'}->{"field_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"field_$i"});
	$self->{'in_hash'}->{"match_$i"} || $self->error($self->{'text_hash'}->{'ffile_ematch'});
	$self->{'in_hash'}->{"action_$i"} || $self->error($self->{'text_hash'}->{'ffile_eaction'});
	push(@{$self->{'filter_array'}}, $self->{'in_hash'}->{"what_$i"}." ".$self->{'in_hash'}->{"action_$i"}." ".
		      $self->{'in_hash'}->{"field_$i"}." ".$self->{'in_hash'}->{"match_$i"}."\n");
	}
push(@{$self->{'filter_array'}}, "2 ".$self->{'in_hash'}->{'other'}."\n") if ($self->{'in_hash'}->{'other'});

$self->switch_to_domain_user($self->{'d'});
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}", 1) ||
	$self->error($self->text('ffile_ewrite', $self->{'in_hash'}->{'file'}, $self->{'d'}->{'user'}, $!));
$self->print_tempfile(FILE, @{$self->{'filter_array'}});
$self->close_tempfile(FILE);
$self->webmin_log("save", "ffile", $self->{'in_hash'}->{'file'});

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
$self->redirect("edit_$self->{'what'}.cgi?$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}&dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

