#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update all custom fields for domains

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newfields_ecannot'});
$self->ReadParse();
$self->error_setup($self->{'text_hash'}->{'newfields_err'});

for($i=0; defined($self->{'in_hash'}->{"name_$i"}); $i++) {
	next if (!$self->{'in_hash'}->{"name_$i"});
	$self->{'in_hash'}->{"desc_$i"} || $self->error($self->text('newfields_edesc', $i+1));
	push(@{$self->{'rv_array'}}, { 'name' => $self->{'in_hash'}->{"name_$i"},
		    'desc' => $self->{'in_hash'}->{"desc_$i"},
		    'type' => $self->{'in_hash'}->{"type_$i"},
		    'opts' => $self->{'in_hash'}->{"opts_$i"} });
	}
$self->save_custom_fields(\@{$self->{'rv_array'}});
$self->redirect("");

1;
		
}


1;

