#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Update plugin modules

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->master_admin() || $self->error($self->{'text_hash'}->{'newplugin_ecannot'});
$self->ReadParse();

# Validate plugins
@{$self->{'newplugins_array'}} = split(/\0/, $self->{'in_hash'}->{'mods'});
foreach $p (@{$self->{'newplugins_array'}}) {
	$self->foreign_require($p, "virtual_feature.pl");
	$self->{'err'} = $self->plugin_call($p, "feature_check");
	$self->{'name'} = $self->plugin_call($p, "feature_name");
	if ($self->{'err'}) {
		$self->error($self->text('newplugin_emod', $self->{'name'}, $self->{'err'}));
		}
	}

# Save module config
$self->lock_file($self->{'module_config_file'});
$self->{'config_hash'}->{'plugins'} = join(" ", @{$self->{'newplugins_array'}});
if ($self->{'config_hash'}->{'last_check'} < time()) {
	$self->{'config_hash'}->{'last_check'} = time()+1;
	}
$self->save_module_config();
$self->unlock_file($self->{'module_config_file'});

$self->webmin_log("plugins");
$self->redirect("");

1;
		
}


1;

