#!/usr/bin/perl

&MAIN();

 sub MAIN {
# Save inputs from config.cgi

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

&ModuleLoader::preload_module('virtual_server_class', "ConfigLib");
$self = new ConfigLib:: 'virtual_server_class',%$self;

$self->ReadParse();
$self->{'m'} = $self->{'in_hash'}->{'module'};
$self->error_setup($self->{'text_hash'}->{'config_err'});

mkdir("$self->{'config_directory'}/$self->{'m'}", 0700);
$self->lock_file("$self->{'config_directory'}/$self->{'m'}/config");
$self->read_file("$self->{'config_directory'}/$self->{'m'}/config", \%{$self->{'pconfig_hash'}});

$self->{'mdir'} = $self->UNIVERSAL::can('module_root_directory') ? $self->module_root_directory($self->{'m'})
					: "$self->{'root_directory'}/$self->{'m'}";
if (-r "$self->{'mdir'}/config_info.pl") {
	# Module has a custom config editor
	$self->foreign_require($self->{'m'}, "config_info.pl");
	local $fn = "$self->{'m'}::config_form";
	if (defined(&$fn)) {
		local $pkg = $self->{'m'};
		$pkg =~ s/[^A-Za-z0-9]/_/g;
		eval "\%${pkg}::in = \%{$self->{'in_hash'}}";
		$self->{'func'}++;
		$self->foreign_call($self->{'m'}, "config_save", \%{$self->{'pconfig_hash'}});
		}
	}
if (!$self->{'func'}) {
	# Use config.info to parse config inputs
	$self->parse_config(\%{$self->{'pconfig_hash'}}, "$self->{'mdir'}/config.info", $self->{'m'});
	}
$self->write_file("$self->{'config_directory'}/$self->{'m'}/config", \%{$self->{'pconfig_hash'}});
$self->unlock_file("$self->{'config_directory'}/$self->{'m'}/config");
$self->webmin_log("_config_", undef, undef, \%{$self->{'in_hash'}}, $self->{'m'});
$self->redirect("");

1;
		
}


1;

