#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_rfile.cgi
# Save an autoreply file

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->ReadParseMime();
$self->{'d'} = $self->get_domain($self->{'in_hash'}->{'dom'});
$self->can_edit_domain($self->{'d'}) || $self->error($self->{'text_hash'}->{'aliases_ecannot'});
$self->{'config_hash'}->{'edit_afiles'} || $self->master_admin() ||
	$self->error($self->{'text_hash'}->{'rfile_ecannot'});

$self->{'in_hash'}->{'replies_def'} || $self->{'in_hash'}->{'replies'} =~ /^\/\S+/ ||
	$self->error($self->{'text_hash'}->{'rfile_ereplies'});
$self->{'in_hash'}->{'period_def'} || $self->{'in_hash'}->{'period'} =~ /^\d+$/ ||
	$self->error($self->{'text_hash'}->{'rfile_eperiod'});

$self->switch_to_domain_user($self->{'d'});
$self->{'in_hash'}->{'text'} =~ s/\r//g;
$self->open_lock_tempfile(FILE, ">$self->{'in_hash'}->{'file'}", 1) ||
	$self->error($self->text('rfile_ewrite', $self->{'in_hash'}->{'file'}, $self->{'dom'}->{'user'}, $!));
if (!$self->{'in_hash'}->{'replies_def'}) {
	$self->print_tempfile(FILE, "Reply-Tracking: $self->{'in_hash'}->{'replies'}\n");
	}
if (!$self->{'in_hash'}->{'period_def'}) {
	$self->print_tempfile(FILE, "Reply-Period: $self->{'in_hash'}->{'period'}\n");
	}
$self->print_tempfile(FILE, $self->{'in_hash'}->{'text'});
$self->close_tempfile(FILE);
$self->webmin_log("save", "rfile", $self->{'in_hash'}->{'file'});

$self->{'what'} = $self->{'in_hash'}->{'alias'} ? 'alias' : 'user';
$self->redirect("edit_$self->{'what'}.cgi?$self->{'what'}=$self->{'in_hash'}->{$self->{'what'}}&dom=$self->{'in_hash'}->{'dom'}");

1;
		
}


1;

