#!/usr/bin/perl

&MAIN();

 sub MAIN {
# stop_bind.cgi
# Stop bind 8

&ModuleLoader::preload_module('virtual_server_class', "virtual_server::VirtualserverLib");
$self = new virtual_server::VirtualserverLib:: 'virtual_server_class',%$self;

$self->{'access_hash'}->{'stop'} || $self->error($self->{'text_hash'}->{'stop_ecannot'});
$self->require_bind();
$self->error_setup($self->{'text_hash'}->{'bstop_err'});
if ($self->{'bconfig_hash'}->{'stop_cmd'}) {
	# Just use a command
	$self->{'out'} = $self->backquote_logged("( $self->{'bconfig_hash'}->{'stop_cmd'} ) 2>&1");
	if ($?) {
		$self->error("<pre>$self->{'out'}</pre>");
		}
	}
else {
	# Kill the process
	$self->{'pid'} = $self->get_bind_pid();
	if (!$self->{'pid'} || !$self->kill_logged('TERM', $self->{'pid'})) {
		$self->error($self->{'text_hash'}->{'bstop_epid'});
		}
	}
$self->webmin_log("stop", "dns");
$self->redirect("");

1;
		
}


1;

