#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_options.cgi
# save vsftpd options form

# main part
&ModuleLoader::preload_module('vsftpd_class', "vsftpd::VsftpdLib");
$self = new vsftpd::VsftpdLib:: 'vsftpd_class',%$self;

$self->ReadParse();

# ACL error
$self->error($self->{'text_hash'}->{'section_ecannot'}) if ($self->{'access_hash'}->{$self->{'in_hash'}->{'section'}.'_dis'});

# get virtual server configuration
local ($file,$name,$conf) = $self->get_server_conf($self->{'in_hash'}->{'idx'});
$self->error($self->text('virt_ecannot',$self->{'in_hash'}->{'idx'})) unless ($file);

# get options list for section & installed version
local $options = $self->get_option_list($self->{'in_hash'}->{'section'});

# save options
foreach (@{$options})
{
 unless ($self->{'access_hash'}->{$_->[0].'_dis'})
 {
  if ($self->{'in_hash'}->{"$_->[0]_def"})
  {
   if ($_->[2] && !$self->{'in_hash'}->{"$_->[0]"}) 
   { 
    # delete option
    $self->del_config_value($_->[0],$conf); 
   }
   else 
   { 
    # change option value
    $self->set_config_value($_->[0],$self->{'in_hash'}->{$_->[0]},$conf); 
   }
  }
  else
  {
   # delete option
   $self->del_config_value($_->[0],$conf); 
  }
 }
}
# save options
$self->save_new_options($conf,"$self->{'config_hash'}->{'vsftpd_dir'}/$file");

if ($self->{'config_hash'}->{'save_apply'} && $self->status_vsftpd())
{
 # restart vsftpd
 $self->restart_vsftpd();
}
# redirect to virt.cgi
$self->redirect("virt.cgi?idx=$self->{'in_hash'}->{'idx'}");
1;
		
}


1;

