#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_global.cgi
# Display options from a webalizer.conf file

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->ReadParse();
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'file'}) {
	$self->can_edit_log($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title2'}, "");
	print "<center>",$self->text('global_for', "<tt>$self->{'in_hash'}->{'file'}</tt>"),
	      "</center>\n";
	}
else {
	$self->{'access_hash'}->{'global'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'global_title'}, "");
	}
$self->{'conf'} = $self->get_config($self->{'in_hash'}->{'file'});

$self->{'cfile'} = $self->config_file_name($self->{'in_hash'}->{'file'}) if ($self->{'in_hash'}->{'file'});

print "<form action=save_global.cgi method=post>\n";
print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
print "<input type=hidden name=type value='$self->{'in_hash'}->{'type'}'>\n";
print "<input type=hidden name=custom value='$self->{'in_hash'}->{'custom'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'global_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'report'} = $self->find_value("ReportTitle", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_report'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=report_def value=1 %s> %s\n",
	$self->{'report'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=report_def value=0 %s>\n",
	$self->{'report'} ? "checked" : "";
printf "<input name=report size=40 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'report'});

if ($self->{'in_hash'}->{'file'}) {
	$self->{'host'} = $self->find_value("HostName", $self->{'conf'});
	print "<tr> <td><b>$self->{'text_hash'}->{'global_host'}</b></td> <td colspan=3>\n";
	printf "<input type=radio name=host_def value=1 %s> %s\n",
		$self->{'host'} ? "" : "checked", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=host_def value=0 %s>\n",
		$self->{'host'} ? "checked" : "";
	print "<input name=host size=30 value='$self->{'host'}'></td> </tr>\n";
	}

@{$self->{'page_array'}} = $self->find_value("PageType", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_page'}</b></td> <td colspan=3>\n";
printf "<input name=page size=50 value='%s'></td> </tr>\n",
	join(" ", @{$self->{'page_array'}});

@{$self->{'index_array'}} = $self->find_value("IndexAlias", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_index'}</b></td> <td colspan=3>\n";
printf "<input name=index size=50 value='%s'></td> </tr>\n",
	join(" ", @{$self->{'index_array'}});

$self->{'gmt'} = $self->find_value("GMTTime", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_gmt'}</b></td>\n";
printf "<td><input type=radio name=gmt value=1 %s> %s\n",
	$self->{'gmt'} =~ /^y/i ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=gmt value=0 %s> %s</td>\n",
	$self->{'gmt'} =~ /^y/i ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'fold'} = $self->find_value("FoldSeqErr", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_fold'}</b></td>\n";
printf "<td><input type=radio name=fold value=1 %s> %s\n",
	$self->{'fold'} =~ /^y/i ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=fold value=0 %s> %s</td> </tr>\n",
	$self->{'fold'} =~ /^y/i ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'visit'} = $self->find_value("VisitTimeout", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_visit'}</b></td>\n";
printf "<td><input type=radio name=visit_def value=1 %s> %s\n",
	$self->{'visit'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=visit_def value=0 %s>\n",
	$self->{'visit'} ? "checked" : "";
printf "<input name=visit size=6 value='%s'> %s</td>\n",
	$self->{'visit'}, $self->{'text_hash'}->{'global_secs'};

$self->{'dns'} = $self->find_value("DNSChildren", $self->{'conf'});
print "<td><b>$self->{'text_hash'}->{'global_dns'}</b></td>\n";
printf "<td><input type=radio name=dns_def value=1 %s> %s\n",
	$self->{'dns'} ? "" : "checked", $self->{'text_hash'}->{'global_none'};
printf "<input type=radio name=dns_def value=0 %s>\n",
	$self->{'dns'} ? "checked" : "";
printf "<input name=dns size=6 value='%s'></td> </tr>\n", $self->{'dns'};

print "<tr> <td colspan=4><hr></td> </tr>\n";

$self->{'history'} = $self->find_value("HistoryName", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_history'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=history_def value=1 %s> %s\n",
	$self->{'history'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=history_def value=0 %s>\n",
	$self->{'history'} ? "checked" : "";
printf "<input name=history size=40 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'history'});

$self->{'current'} = $self->find_value("IncrementalName", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_current'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=current_def value=1 %s> %s\n",
	$self->{'current'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=current_def value=0 %s>\n",
	$self->{'current'} ? "checked" : "";
printf "<input name=current size=40 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'current'});

$self->{'cache'} = $self->find_value("DNSCache", $self->{'conf'});
print "<tr> <td><b>$self->{'text_hash'}->{'global_cache'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=cache_def value=1 %s> %s\n",
	$self->{'cache'} ? "" : "checked", $self->{'text_hash'}->{'default'};
printf "<input type=radio name=cache_def value=0 %s>\n",
	$self->{'cache'} ? "checked" : "";
printf "<input name=cache size=40 value='%s'></td> </tr>\n",
	$self->html_escape($self->{'cache'});

print "<tr> <td colspan=4><hr></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'global_display'}</b></td>\n";
print "<td colspan=3><table>\n";
$self->{'i'} = 0;
foreach $g ('DailyGraph', 'DailyStats', 'HourlyGraph',
	    'HourlyStats', 'CountryGraph', 'GraphLegend') {
	$self->{'v'} = $self->find_value($g, $self->{'conf'});
	print "<tr>\n" if ($self->{'i'}%2 == 0);
	printf "<td><input type=checkbox name=%s value=1 %s>%s</td>\n",
		$g, $self->{'v'} =~ /^n/i ? "" : "checked", $self->{'text_hash'}->{"global_$g"};
	print "</tr>\n" if ($self->{'i'}++%2 == 1);
	}
print "</table></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'global_tables'}</b></td>\n";
print "<td colspan=3><table width=100%>\n";
$self->{'i'} = 0;
foreach $t ('TopSites', 'TopKSites', 'TopURLs', 'TopKURLs', 'TopReferrers',
	    'TopAgents', 'TopCountries', 'TopEntry', 'TopExit',
	    'TopSearch', 'TopUsers') {
	$self->{'v'} = $self->find_value($t, $self->{'conf'});
	print "<tr>\n" if ($self->{'i'}%2 == 0);
	printf "<td><b>%s</b></td>", $self->{'text_hash'}->{"global_$t"};
	printf "<td nowrap><input type=radio name=%s_def value=1 %s> %s\n",
		$t, $self->{'v'} eq "" ? "checked" : "", $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=%s_def value=2 %s> %s\n",
		$t, $self->{'v'} eq "0" ? "checked" : "", $self->{'text_hash'}->{'global_none'};
	printf "<input type=radio name=%s_def value=0 %s>\n",
		$t, $self->{'v'} ? "checked" : "";
	printf "<input name=%s size=4 value='%s'></td>\n",
		$t, $self->{'v'} ? $self->{'v'} : "";
	print "</tr>\n" if ($self->{'i'}++%2 == 1);
	}
print "</table></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'global_all'}</b></td>\n";
print "<td colspan=3><table>\n";
$self->{'i'} = 0;
foreach $a ('AllSites', 'AllURLs', 'AllReferrers', 'AllAgents',
	    'AllSearchStr', 'AllUsers') {
	$self->{'v'} = $self->find_value($a, $self->{'conf'});
	print "<tr>\n" if ($self->{'i'}%3 == 0);
	printf "<td><input type=checkbox name=%s value=1 %s>%s</td>\n",
		$a, $self->{'v'} =~ /^y/i ? "checked" : "", $self->{'text_hash'}->{"global_$a"};
	print "</tr>\n" if ($self->{'i'}++%3 == 2);
	}
print "</table></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";

foreach $hid ("HideURL", "HideSite", "HideReferrer",
	      "HideUser", "HideAgent") {
	@{$self->{'hidv_array'}} = $self->find_value($hid, $self->{'conf'});
	print "<tr> <td><b>",$self->{'text_hash'}->{'global_'.lc($hid)},"</b></td> <td colspan=3>\n";
	printf "<input name=%s size=60 value='%s'></td> </tr>\n",
		lc($hid), join(" ", @{$self->{'hidv_array'}});
	}

print "<tr> <td colspan=4><hr></td> </tr>\n";

foreach $ign ("IgnoreURL", "IgnoreSite", "IgnoreReferrer",
	      "IgnoreUser", "IgnoreAgent") {
	@{$self->{'ignv_array'}} = $self->find_value($ign, $self->{'conf'});
	print "<tr> <td><b>",$self->{'text_hash'}->{'global_'.lc($ign)},"</b></td> <td colspan=3>\n";
	printf "<input name=%s size=60 value='%s'></td> </tr>\n",
		lc($ign), join(" ", @{$self->{'ignv_array'}});
	}

print "<tr> <td colspan=4><hr></td> </tr>\n";

foreach $inc ("IncludeURL", "IncludeSite", "IncludeReferrer",
	      "IncludeUser", "IncludeAgent") {
	@{$self->{'incv_array'}} = $self->find_value($inc, $self->{'conf'});
	print "<tr> <td><b>",$self->{'text_hash'}->{'global_'.lc($inc)},"</b></td> <td colspan=3>\n";
	printf "<input name=%s size=60 value='%s'></td> </tr>\n",
		lc($inc), join(" ", @{$self->{'incv_array'}});
	}

print "</table></td></tr></table>\n";
push(@{$self->{'b_array'}}, "<input type=submit value='$self->{'text_hash'}->{'save'}'>");
push(@{$self->{'b_array'}}, "<input type=submit name=delete value='$self->{'text_hash'}->{'global_delete'}'>")
	if ($self->{'in_hash'}->{'file'} && -r $self->{'cfile'});
$self->spaced_buttons(@{$self->{'b_array'}});
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

