#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_log.cgi
# Display a form for adding a new logfile or editing an existing one.
# Allows you to set the schedule on which the log is analysed

&ModuleLoader::preload_module('webalizer_class', "webalizer::WebalizerLib");
$self = new webalizer::WebalizerLib:: 'webalizer_class',%$self;

$self->foreign_require("cron", "cron-lib.pl");
$self->ReadParse();
$self->{'access_hash'}->{'view'} && $self->error($self->{'text_hash'}->{'edit_ecannot'});
if ($self->{'in_hash'}->{'new'}) {
	$self->{'access_hash'}->{'add'} || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title1'}, "");
	}
else {
	$self->can_edit_log($self->{'in_hash'}->{'file'}) || $self->error($self->{'text_hash'}->{'edit_ecannot'});
	$self->ui_print_header(undef, $self->{'text_hash'}->{'edit_title2'}, "");
	$self->{'lconf'} = $self->get_log_config($self->{'in_hash'}->{'file'});
	}

print "<form action=save_log.cgi>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=oldfile value='$self->{'in_hash'}->{'file'}'>\n";

print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'edit_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_file'}</b></td> <td colspan=3>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<input name=file size=50> ",$self->file_chooser_button("file");
	}
else {
	print "<input type=hidden name=file value='$self->{'in_hash'}->{'file'}'>\n";
	print "<tt>$self->{'in_hash'}->{'file'}</tt>";
	}
print "</td> </tr>\n";

if (!$self->{'in_hash'}->{'new'}) {
	@{$self->{'all_array'}} = $self->all_log_files($self->{'in_hash'}->{'file'});
	if (@{$self->{'all_array'}} > 1) {
		print "<tr> <td valign=top><b>$self->{'text_hash'}->{'edit_files'}</b></td> ",
		      "<td colspan=3><font size=-1>\n";
		foreach $a (@{$self->{'all_array'}}) {
			print "$a<br>\n";
			}
		print "</font></td> </tr>\n";
		}
	}

print "<tr> <td><b>$self->{'text_hash'}->{'edit_type'}</b></td> <td>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<select name=type>\n";
	for($i=1; defined($self->{'t'} = $self->{'text_hash'}->{'index_type'.$i}); $i++) {
		print "<option value=$i>$self->{'t'}\n";
		}
	print "</select>\n";
	}
else {
	print "<input type=hidden name=type value='$self->{'in_hash'}->{'type'}'>\n";
	print $self->{'text_hash'}->{'index_type'.$self->{'in_hash'}->{'type'}};
	}
print "</td>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'edit_dir'}</b></td> <td colspan=3>\n";
printf "<input name=dir size=50 value='%s'> %s</td> </tr>\n",
	$self->{'lconf'}->{'dir'}, $self->file_chooser_button("dir", 1);

print "<tr> <td><b>$self->{'text_hash'}->{'edit_user'}</b></td>\n";
if ($self->{'access_hash'}->{'user'} eq '*') {
	# User that webalizer runs as can be chosen
	printf "<td><input name=user size=13 value='%s'> %s</td> </tr>\n",
		$self->{'lconf'}->{'user'} || "root";
	}
else {
	# User is fixed
	printf "<td><tt>%s</tt></td> </tr>\n",
		!$self->{'in_hash'}->{'new'} && $self->{'lconf'}->{'dir'} ? $self->{'lconf'}->{'user'} || "root" :
		$self->{'access_hash'}->{'user'} eq "" ? $self->{'remote_user'} : $self->{'access_hash'}->{'user'};
	}

print "<tr> <td><b>$self->{'text_hash'}->{'edit_over'}</b></td>\n";
printf "<td><input type=radio name=over value=1 %s> %s\n",
	$self->{'lconf'}->{'over'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=over value=0 %s> %s</td> </tr>\n",
	$self->{'lconf'}->{'over'} ? "" : "checked", $self->{'text_hash'}->{'no'};

$self->{'cfile'} = $self->config_file_name($self->{'in_hash'}->{'file'});
$self->{'cmode'} = -l $self->{'cfile'} ? 2 : -r $self->{'cfile'} ? 1 : 0;
print "<tr> <td><b>$self->{'text_hash'}->{'edit_conf'}</b></td> <td nowrap>\n";
printf "<input type=radio name=cmode value=0 %s> %s\n",
	$self->{'cmode'} == 0 ? "checked" : "", $self->{'text_hash'}->{'edit_cmode0'};
printf "<input type=radio name=cmode value=1 %s> %s\n",
	$self->{'cmode'} == 1 ? "checked" : "", $self->{'text_hash'}->{'edit_cmode1'};
printf "<input type=radio name=cmode value=2 %s> %s\n",
	$self->{'cmode'} == 2 ? "checked" : "", $self->{'text_hash'}->{'edit_cmode2'};
printf "<input name=cfile size=20 value='%s'> %s</td> </tr>\n",
	$self->{'cmode'} == 2 ? readlink($self->{'cfile'}) : "", $self->file_chooser_button("cfile");

print "<tr> <td><b>$self->{'text_hash'}->{'edit_sched'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=sched value=0 %s> %s\n",
	$self->{'lconf'}->{'sched'} ? "" : "checked", $self->{'text_hash'}->{'edit_sched0'};
printf "<input type=radio name=sched value=1 %s> %s</td> </tr>\n",
	$self->{'lconf'}->{'sched'} ? "checked" : "", $self->{'text_hash'}->{'edit_sched1'};

print "<tr> <td><b>$self->{'text_hash'}->{'edit_clear'}</b></td>\n";
printf "<td><input type=radio name=clear value=1 %s> %s\n",
	$self->{'lconf'}->{'clear'} ? "checked" : "", $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=clear value=0 %s> %s</td> </tr>\n",
	$self->{'lconf'}->{'clear'} ? "" : "checked", $self->{'text_hash'}->{'no'};

print "</table>\n";

print "<table border width=100%>\n";
if ($self->{'lconf'}->{'mins'} eq '') {
	$self->{'lconf'}->{'mins'} = $self->{'lconf'}->{'hours'} = 0;
	$self->{'lconf'}->{'days'} = $self->{'lconf'}->{'months'} = $self->{'lconf'}->{'weekdays'} = '*';
	}
$self->foreign_call("cron", "show_times_input", $self->{'lconf'});

print "</table>\n";
print "</td></tr></table>\n";

if ($self->{'in_hash'}->{'new'}) {
	push(@{$self->{'b_array'}}, "<input type=submit value='$self->{'text_hash'}->{'create'}'>");
	}
else {
	push(@{$self->{'b_array'}}, "<input type=submit value='$self->{'text_hash'}->{'save'}'>");
	push(@{$self->{'b_array'}}, "<input type=submit name=global value='$self->{'text_hash'}->{'edit_global'}'>")
		if ($self->{'cmode'});
	if ($self->{'lconf'}->{'dir'}) {
		push(@{$self->{'b_array'}}, "<input type=submit name=run value='$self->{'text_hash'}->{'edit_run'}'>");
		}
	if ($self->{'lconf'}->{'dir'} && -r "$self->{'lconf'}->{'dir'}/index.html") {
		push(@{$self->{'b_array'}}, "<input type=submit name=view value='$self->{'text_hash'}->{'edit_view'}'>");
		}
	if ($self->{'in_hash'}->{'custom'}) {
		push(@{$self->{'b_array'}}, "<input type=submit name=delete value='$self->{'text_hash'}->{'delete'}'>");
		}
	}
$self->spaced_buttons(@{$self->{'b_array'}});
print "</form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

