#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_class.cgi
# Display a list of user classes for editing

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'class_title'}, "", "class");
$self->{'conf'} = $self->get_ftpaccess();

print "<form action=save_class.cgi>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'class_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

@{$self->{'class_array'}} = ( $self->find_value("class", $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'class_class'}</b></td>\n";
print "<td colspan=3><table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'class_name'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'class_types'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'class_addrs'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $c (@{$self->{'class_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=class_$self->{'i'} size=10 value='$c->[0]'></td>\n";
	local %types;
	map { $types{$_}++ } split(/,/, $c->[1]);
	printf "<td><input type=checkbox name=types_$self->{'i'} value=real %s> %s\n",
		$types{'real'} ? 'checked' : '', $self->{'text_hash'}->{'class_real'};
	printf "<input type=checkbox name=types_$self->{'i'} value=anonymous %s> %s\n",
		$types{'anonymous'} ? 'checked' : '', $self->{'text_hash'}->{'class_anonymous'};
	printf "<input type=checkbox name=types_$self->{'i'} value=guest %s> %s</td>\n",
		$types{'guest'} ? 'checked' : '', $self->{'text_hash'}->{'class_guest'};
	printf "<td><input name=addrs_$self->{'i'} size=30 value='%s'></td>\n",
		join(" ", @$c[2..@$c-1]);
	print "</tr>\n";
	$self->{'i'}++;
	}
print "</table></td> </tr>\n";

print "<tr> <td colspan=4><hr></td> </tr>\n";
foreach $g ('guestuser', 'guestgroup', 'realuser', 'realgroup') {
	print "<tr> <td><b>",$self->{'text_hash'}->{"class_$g"},"</b></td> <td colspan=3>\n";
	printf "<input name=%s size=50 value='%s'> %s</td> </tr>\n",
		$g, &join_all($g, $self->{'conf'}),
		$g =~ /user$/ ? $self->user_chooser_button($g, 1)
			      : $self->group_chooser_button($g, 1);
	}

print "<tr> <td colspan=4><hr></td> </tr>\n";
print "<tr> <td><b>",$self->text('class_ftpusers', "<tt>$self->{'config_hash'}->{'ftpusers'}</tt>"),
      "</b></td> <td colspan=3>\n";
open(FTPUSERS, $self->{'config_hash'}->{'ftpusers'});
while(<FTPUSERS>) {
	s/\r|\n//g;
	s/#.*$//;
	push(@{$self->{'ftpusers_array'}}, $_) if (/\S/);
	}
close(FTPUSERS);
printf "<input name=ftpusers size=40 value='%s'> %s</td> </tr>\n",
	join(" ", @{$self->{'ftpusers_array'}}), $self->user_chooser_button('ftpusers', 1);
foreach $g ('deny-uid', 'deny-gid', 'allow-uid', 'allow-gid') {
	($self->{'fg'} = $g) =~ s/-/_/g;
	print "<tr> <td><b>",$self->{'text_hash'}->{"class_$self->{'fg'}"},"</b></td> <td colspan=3>\n";
	printf "<input name=%s size=40 value='%s'> %s</td> </tr>\n",
		$self->{'fg'}, &join_all($g, $self->{'conf'}),
		$g =~ /uid$/ ? $self->user_chooser_button($self->{'fg'}, 1)
			     : $self->group_chooser_button($self->{'fg'}, 1);
	}

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}

# join_all(name, &config)
sub join_all
{
	shift if ($self == $_[0]);

local (@rv, $v);
foreach $v ($self->find_value($_[0], $_[1])) {
	push(@rv, @$v);
	}
return join(" ", @rv);
}


1;

