#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_log.cgi
# Display logging options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'log_title'}, "", "log");

$self->{'conf'} = $self->get_ftpaccess();
foreach $l ($self->find_value('log', $self->{'conf'})) {
	$self->{'log_hash'}->{$l->[0]} = $l;
	}

print "<form action=save_log.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'log_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display log commands option
map { $self->{'commands_hash'}->{$_}++ } split(/,/, $self->{'log_hash'}->{'commands'}->[1]);
print "<tr> <td><b>$self->{'text_hash'}->{'log_commands'}</b></td> <td>\n";
foreach $c ('anonymous', 'guest', 'real') {
	printf "<input type=checkbox name=commands value=$c %s> %s\n",
		$self->{'commands_hash'}->{$c} ? 'checked' : '', $self->{'text_hash'}->{"log_$c"};
	}
print "</td> </tr>\n";

# Display log transfers option
map { $self->{'transfers_hash'}->{$_}++ } split(/,/, $self->{'log_hash'}->{'transfers'}->[1]);
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'log_trans'}</b></td> <td>\n";
foreach $c ('anonymous', 'guest', 'real') {
	printf "<input type=checkbox name=transfers value=$c %s> %s\n",
		$self->{'transfers_hash'}->{$c} ? 'checked' : '', $self->{'text_hash'}->{"log_$c"};
	}
print "</td> </tr> <tr> <td></td> <td>\n";
print "<b>$self->{'text_hash'}->{'log_dir'}</b>\n";
$self->{'d'} = $self->{'log_hash'}->{'transfers'}->[2];
printf "<input type=radio name=direction value=inbound %s> %s\n",
	$self->{'d'} eq 'inbound' ? 'checked' : '', $self->{'text_hash'}->{'log_inbound'};
printf "<input type=radio name=direction value=outbound %s> %s\n",
	$self->{'d'} eq 'outbound' ? 'checked' : '', $self->{'text_hash'}->{'log_outbound'};
printf "<input type=radio name=direction value=inbound,outbound %s> %s\n",
	$self->{'d'} =~ /inbound/ && $self->{'d'} =~ /outbound/ ? 'checked' : '', $self->{'text_hash'}->{'log_both'};
print "</td> </tr>\n";

# Display log syslog option
print "<tr> <td><b>$self->{'text_hash'}->{'log_to'}</b></td> <td>\n";
printf "<input type=radio name=syslog value=1 %s> %s\n",
	$self->{'log_hash'}->{'syslog'} ? 'checked' : '', $self->{'text_hash'}->{'log_syslog'};
printf "<input type=radio name=syslog value=0 %s> %s\n",
	$self->{'log_hash'}->{'syslog'} || $self->{'log_hash'}->{'syslog+xferlog'} ? '' : 'checked',
	$self->{'text_hash'}->{'log_xferlog'};
printf "<input type=radio name=syslog value=2 %s> %s</td> </tr>\n",
	$self->{'log_hash'}->{'syslog+xferlog'} ? 'checked' : '', $self->{'text_hash'}->{'log_sysxfer'};

# Display log security option
map { $self->{'security_hash'}->{$_}++ } split(/,/, $self->{'log_hash'}->{'security'}->[1]);
print "<tr> <td><b>$self->{'text_hash'}->{'log_security'}</b></td> <td>\n";
foreach $c ('anonymous', 'guest', 'real') {
	printf "<input type=checkbox name=security value=$c %s> %s\n",
		$self->{'security_hash'}->{$c} ? 'checked' : '', $self->{'text_hash'}->{"log_$c"};
	}
print "</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

