#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_misc.cgi
# Display miscellaneous options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->ui_print_header(undef, $self->{'text_hash'}->{'misc_title'}, "", "misc");

$self->{'conf'} = $self->get_ftpaccess();
@{$self->{'class_array'}} = $self->find_value("class", $self->{'conf'});

print "<form action=save_misc.cgi>\n";
print "<table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_header'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

# Display ls* options
foreach $l ('lslong', 'lsshort', 'lsplain') {
	$self->{'v'} = $self->find_value($l, $self->{'conf'});
	print "<tr> <td><b>",$self->{'text_hash'}->{"misc_$l"},"</b></td> <td colspan=3>\n";
	printf "<input type=radio name=%s_def value=1 %s> %s\n",
		$l, $self->{'v'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
	printf "<input type=radio name=%s_def value=0 %s>\n",
		$l, $self->{'v'} ? 'checked' : '';
	printf "<input name=%s size=30 value='%s'></td> </tr>\n",
		$l, join(" ", @{$self->{'v'}});
	}

# Display shutdown option
$self->{'s'} = $self->find_value('shutdown', $self->{'conf'});
printf "<tr> <td><b>$self->{'text_hash'}->{'misc_shutdown'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=shutdown_def value=1 %s> %s\n",
	$self->{'s'} ? '' : 'checked', $self->{'text_hash'}->{'misc_none'};
printf "<input type=radio name=shutdown_def value=0 %s>\n",
	$self->{'s'} ? 'checked' : '';
printf "<input name=shutdown size=30 value='%s'> %s</td> </tr>\n",
	$self->{'s'}->[0], $self->file_chooser_button('shutdown', 0);
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display nice option
@{$self->{'nice_array'}} = ( $self->find_value('nice', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'misc_nice'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_ndelta'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'misc_class'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $n (@{$self->{'nice_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=ndelta_$self->{'i'} size=5 value='$n->[0]'></td>\n";
	print "<td><select name=nclass_$self->{'i'}>\n";
	printf "<option value='' %s>%s\n",
		$n->[1] ? '' : 'checked', $self->{'text_hash'}->{'misc_all'};
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$n->[1] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td>\n";
print "<tr> <td colspan=4><hr></td> </tr>\n";

# Display defumask option
@{$self->{'umask_array'}} = ( $self->find_value('defumask', $self->{'conf'}), [ ] );
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'misc_defumask'}</b></td>\n";
print "<td colspan=3><table border>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'misc_umask'}</b></td> ",
      "<td><b>$self->{'text_hash'}->{'misc_class'}</b></td> </tr>\n";
$self->{'i'} = 0;
foreach $u (@{$self->{'umask_array'}}) {
	print "<tr $self->{'cb'}>\n";
	print "<td><input name=umask_$self->{'i'} size=5 value='$u->[0]'></td>\n";
	print "<td><select name=uclass_$self->{'i'}>\n";
	printf "<option value='' %s>%s\n",
		$u->[1] ? '' : 'checked', $self->{'text_hash'}->{'misc_all'};
	foreach $c (@{$self->{'class_array'}}) {
		printf "<option %s>%s\n",
			$u->[1] eq $c->[0] ? 'selected' : '', $c->[0];
		}
	print "</select></td> </tr>\n";
	$self->{'i'}++;
	}
print "</table></td>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value=\"$self->{'text_hash'}->{'save'}\"></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

