#!/usr/bin/perl

&MAIN();

 sub MAIN {
# save_log.cgi
# Save logging options

&ModuleLoader::preload_module('wuftpd_class', "wuftpd::WuftpdLib");
$self = new wuftpd::WuftpdLib:: 'wuftpd_class',%$self;

$self->error_setup($self->{'text_hash'}->{'log_err'});
$self->ReadParse();

$self->lock_file($self->{'config_hash'}->{'ftpaccess'});
$self->{'conf'} = $self->get_ftpaccess();

$self->{'in_hash'}->{'commands'} =~ s/\0/,/g;
if ($self->{'in_hash'}->{'commands'}) {
	push(@{$self->{'log_array'}}, { 'name' => 'log',
		     'values' => [ 'commands', $self->{'in_hash'}->{'commands'} ] } );
	}

$self->{'in_hash'}->{'transfers'} =~ s/\0/,/g;
if ($self->{'in_hash'}->{'transfers'}) {
	push(@{$self->{'log_array'}}, { 'name' => 'log',
		     'values' => [ 'transfers', $self->{'in_hash'}->{'transfers'},
				   $self->{'in_hash'}->{'direction'} ] } );
	}

$self->{'in_hash'}->{'security'} =~ s/\0/,/g;
if ($self->{'in_hash'}->{'security'}) {
	push(@{$self->{'log_array'}}, { 'name' => 'log',
		     'values' => [ 'security', $self->{'in_hash'}->{'security'} ] } );
	}

if ($self->{'in_hash'}->{'syslog'} == 1) {
	push(@{$self->{'log_array'}}, { 'name' => 'log',
		     'values' => [ 'syslog' ] } );
	}
elsif ($self->{'in_hash'}->{'syslog'} == 2) {
	push(@{$self->{'log_array'}}, { 'name' => 'log',
		     'values' => [ 'syslog+xferlog' ] } );
	}

$self->save_directive($self->{'conf'}, 'log', \@{$self->{'log_array'}});
$self->flush_file_lines();
$self->unlock_file($self->{'config_hash'}->{'ftpaccess'});
$self->webmin_log("log", undef, undef, \%{$self->{'in_hash'}});
$self->redirect("");
1;
		
}


1;

