#!/usr/bin/perl
package xinetd::Config_info;

 sub new {
 	my $invocant = shift;
 	my $class = ref($invocant) || $invocant;

	my $module_class = shift;
	my $self = { @_ };
	
	eval "push(\@$module_class\:\:ISA, 'xinetd::Config_info');";
	
	foreach (@ISA) {
	    &ModuleLoader::preload_module($module_class, "$_");
	    eval "\$self = new $_\:\: '$module_class', \%\$self;";
	}

	bless $self, $module_class;
	    

 	# common part;

&ModuleLoader::preload_module(ref($self), "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: ref($self), %$self; 

1;
		return $self;
}

sub show_add_dir
{
	my $self = shift;

local $rv;
$rv .= sprintf "<input type=radio name=add_dir_def value=1 %s> %s\n",
	$_[0] ? "" : "checked", $self->{'text_hash'}->{'config_dirdef'};
$rv .= sprintf "<input type=radio name=add_dir_def value=0 %s> %s\n",
	$_[0] ? "checked" : "", $self->{'text_hash'}->{'config_dirto'};
$rv .= sprintf "<input name=add_dir size=30 value='%s'>\n", $_[0];
return $rv;
}

sub parse_add_dir
{
	my $self = shift;

return $self->{'in_hash'}->{'add_dir_def'} ? undef : $self->{'in_hash'}->{'add_dir'};
}


1;

