#!/usr/bin/perl

&MAIN();

 sub MAIN {
# edit_serv.cgi
# Display a form for editing or creating an internet service

&ModuleLoader::preload_module('xinetd_class', "xinetd::XinetdLib");
$self = new xinetd::XinetdLib:: 'xinetd_class',%$self;

$self->ReadParse();
if ($self->{'in_hash'}->{'new'}) {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'serv_create'}, "");
	}
else {
	$self->ui_print_header(undef, $self->{'text_hash'}->{'serv_edit'}, "");
	@{$self->{'conf_array'}} = $self->get_xinetd_config();
	$self->{'xinet'} = $self->{'conf_array'}->[$self->{'in_hash'}->{'idx'}];
	$self->{'q'} = $self->{'xinet'}->{'quick'};
	($self->{'defs'}) = grep { $_->{'name'} eq 'defaults' } @{$self->{'conf_array'}};
	foreach $m (@{$self->{'defs'}->{'members'}}) {
		$self->{'ddisable_hash'}->{$m->{'value'}}++ if ($m->{'name'} eq 'disabled');
		}
	}

print "<form action=save_serv.cgi method=post>\n";
print "<input type=hidden name=new value='$self->{'in_hash'}->{'new'}'>\n";
print "<input type=hidden name=idx value='$self->{'in_hash'}->{'idx'}'>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'serv_header1'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td><b>$self->{'text_hash'}->{'serv_id'}</b></td>\n";
printf "<td><input name=id size=10 value='%s'></td>\n",
	$self->{'xinet'}->{'value'};

$self->{'id'} = $self->{'q'}->{'id'}->[0] || $self->{'xinet'}->{'value'};
$self->{'dis'} = $self->{'q'}->{'disable'}->[0] eq 'yes' || $self->{'ddisable_hash'}->{$self->{'id'}};
print "<td><b>$self->{'text_hash'}->{'serv_enabled'}</b></td>\n";
printf "<td><input type=radio name=disable value=0 %s> %s\n",
	$self->{'dis'} ? '' : 'checked', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=disable value=1 %s> %s</td> </tr>\n",
	$self->{'dis'} ? 'checked' : '', $self->{'text_hash'}->{'no'};

print "<td><b>$self->{'text_hash'}->{'serv_bind'}</b></td>\n";
printf "<td><input type=radio name=bind_def value=1 %s> %s\n",
	$self->{'q'}->{'bind'} ? '' : 'checked', $self->{'text_hash'}->{'serv_bind_def'};
printf "<input type=radio name=bind_def value=0 %s>\n",
	$self->{'q'}->{'bind'} ? 'checked' : '';
printf "<input name=bind size=20 value='%s'></td>\n",
	$self->{'q'}->{'bind'}->[0];

print "<td><b>$self->{'text_hash'}->{'serv_port'}</b></td>\n";
printf "<td><input type=radio name=port_def value=1 %s> %s\n",
	$self->{'q'}->{'port'} ? '' : 'checked', $self->{'text_hash'}->{'serv_port_def'};
printf "<input type=radio name=port_def value=0 %s>\n",
	$self->{'q'}->{'port'} ? 'checked' : '';
printf "<input name=port size=8 value='%s'></td> </tr>\n",
	$self->{'q'}->{'port'}->[0];

print "<tr> <td><b>$self->{'text_hash'}->{'serv_sock'}</b></td>\n";
print "<td><select name=sock>\n";
foreach $s ('stream', 'dgram', 'raw', 'seqpacket') {
	printf "<option value=%s %s>%s\n",
		$s, $self->{'q'}->{'socket_type'}->[0] eq $s ? 'selected' : '',
		$self->{'text_hash'}->{"sock_$s"};
	}
print "</select></td>\n";

print "<td><b>$self->{'text_hash'}->{'serv_proto'}</b></td>\n";
print "<td><select name=proto>\n";
foreach $p ('', $self->list_protocols()) {
	printf "<option value='%s' %s>%s\n",
		$p, $self->{'q'}->{'protocol'}->[0] eq $p ? 'selected' : '',
		$self->{'text_hash'}->{"proto_$p"} ? $self->{'text_hash'}->{"proto_$p"} : uc($p);
	}
print "</select></td> </tr>\n";

print "</table></td></tr></table><p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'serv_header2'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

$self->{'prog'} = $self->indexof('INTERNAL', @{$self->{'q'}->{'type'}}) >= 0 ? 0 :
	$self->{'q'}->{'redirect'} ? 2 : 1;
print "<tr> <td valign=top><b>$self->{'text_hash'}->{'serv_prog'}</b></td> <td colspan=3>\n";
printf "<input type=radio name=prog value=0 %s> %s<br>\n",
	$self->{'prog'} == 0 ? 'checked' : '', $self->{'text_hash'}->{'serv_internal'};
printf "<input type=radio name=prog value=1 %s> %s\n",
	$self->{'prog'} == 1 ? 'checked' : '', $self->{'text_hash'}->{'serv_server'};
printf "<input name=server size=50 value='%s'><br>\n",
	join(" ", $self->{'q'}->{'server'}->[0], @{$self->{'q'}->{'server_args'}});
printf "<input type=radio name=prog value=2 %s> %s\n",
	$self->{'prog'} == 2 ? 'checked' : '', $self->{'text_hash'}->{'serv_redirect'};
printf "<input name=rhost size=20 value='%s'> %s\n",
	$self->{'prog'} == 2 ? $self->{'q'}->{'redirect'}->[0] : "", $self->{'text_hash'}->{'serv_rport'};
printf "<input name=rport size=6 value='%s'></td> </tr>\n",
	$self->{'prog'} == 2 ? $self->{'q'}->{'redirect'}->[1] : "";

print "<tr> <td><b>$self->{'text_hash'}->{'serv_user'}</b></td>\n";
printf "<td><input name=user size=10 value='%s'> %s</td>\n",
	$self->{'q'}->{'user'}->[0], $self->user_chooser_button('user');

print "<td><b>$self->{'text_hash'}->{'serv_group'}</b></td>\n";
printf "<td><input type=radio name=group_def value=1 %s> %s\n",
	$self->{'q'}->{'group'} ? '' : 'checked', $self->{'text_hash'}->{'serv_group_def'};
printf "<input type=radio name=group_def value=0 %s>\n",
	$self->{'q'}->{'group'} ? 'checked' : '';
printf "<input name=group size=10 value='%s'> %s</td> </tr>\n",
	$self->{'q'}->{'group'}->[0], $self->group_chooser_button('group');

print "<tr> <td><b>$self->{'text_hash'}->{'serv_wait'}</b></td>\n";
printf "<td><input type=radio name=wait value=1 %s> %s\n",
	$self->{'q'}->{'wait'}->[0] eq 'yes' ? 'checked' : '', $self->{'text_hash'}->{'yes'};
printf "<input type=radio name=wait value=0 %s> %s</td>\n",
	$self->{'q'}->{'wait'}->[0] eq 'yes' ? '' : 'checked', $self->{'text_hash'}->{'no'};

$self->{'inst'} = uc($self->{'q'}->{'instances'}->[0]) eq 'UNLIMITED' ? '' : $self->{'q'}->{'instances'}->[0];
print "<td><b>$self->{'text_hash'}->{'serv_inst'}</b></td>\n";
printf "<td><input type=radio name=inst_def value=1 %s> %s\n",
	$self->{'inst'} ? '' : 'checked', $self->{'text_hash'}->{'serv_inst_def'};
printf "<input type=radio name=inst_def value=0 %s>\n",
	$self->{'inst'} ? 'checked' : '';
printf "<input name=inst size=5 value='%s'></td> </tr>\n",
	$self->{'inst'};

print "<tr> <td><b>$self->{'text_hash'}->{'serv_nice'}</b></td>\n";
printf "<td><input type=radio name=nice_def value=1 %s> %s\n",
	$self->{'q'}->{'nice'} ? '' : 'checked', $self->{'text_hash'}->{'default'};
printf "<input type=radio name=nice_def value=0 %s>\n",
	$self->{'q'}->{'nice'} ? 'checked' : '';
printf "<input name=nice size=5 value='%s'></td>\n",
	$self->{'q'}->{'nice'}->[0];

$self->{'cps'} = uc($self->{'q'}->{'cps'}->[0]) eq 'UNLIMITED' ? '' : $self->{'q'}->{'cps'}->[0];
print "<td><b>$self->{'text_hash'}->{'serv_cps0'}</b></td>\n";
printf "<td><input type=radio name=cps_def value=1 %s> %s\n",
	$self->{'cps'} ? '' : 'checked', $self->{'text_hash'}->{'serv_cps_def'};
printf "<input type=radio name=cps_def value=0 %s>\n",
	$self->{'cps'} ? 'checked' : '';
printf "<input name=cps0 size=5 value='%s'> %s</td> </tr>\n",
	$self->{'cps'};

print "<tr> <td colspan=2></td>\n";
print "<td><b>$self->{'text_hash'}->{'serv_cps1'}</b></td>\n";
printf "<td><input name=cps1 size=5 value='%s'> $self->{'text_hash'}->{'serv_sec'}</td> </tr>\n",
	$self->{'q'}->{'cps'}->[1];

print "</table></td></tr></table><p>\n";
print "<table border width=100%>\n";
print "<tr $self->{'tb'}> <td><b>$self->{'text_hash'}->{'serv_header3'}</b></td> </tr>\n";
print "<tr $self->{'cb'}> <td><table width=100%>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'serv_from'}</b></td>\n";
printf "<td><input type=radio name=from_def value=1 %s> %s\n",
	$self->{'q'}->{'only_from'} ? '' : 'checked', $self->{'text_hash'}->{'serv_from_def'};
printf "<input type=radio name=from_def value=0 %s> %s<br>\n",
	$self->{'q'}->{'only_from'} ? 'checked' : '', $self->{'text_hash'}->{'serv_from_sel'};
print "<textarea name=from rows=4 cols=20>",
	join("\n", @{$self->{'q'}->{'only_from'}}),"</textarea></td>\n";

print "<td valign=top><b>$self->{'text_hash'}->{'serv_access'}</b></td>\n";
printf "<td><input type=radio name=access_def value=1 %s> %s\n",
	$self->{'q'}->{'no_access'} ? '' : 'checked', $self->{'text_hash'}->{'serv_access_def'};
printf "<input type=radio name=access_def value=0 %s> %s<br>\n",
	$self->{'q'}->{'no_access'} ? 'checked' : '', $self->{'text_hash'}->{'serv_access_sel'};
print "<textarea name=access rows=4 cols=20>",
	join("\n", @{$self->{'q'}->{'no_access'}}),"</textarea></td> </tr>\n";

print "<tr> <td valign=top><b>$self->{'text_hash'}->{'serv_times'}</b></td>\n";
printf "<td colspan=3><input type=radio name=times_def value=1 %s> %s\n",
	$self->{'q'}->{'access_times'} ? '' : 'checked', $self->{'text_hash'}->{'serv_times_def'};
printf "<input type=radio name=times_def value=0 %s>\n",
	$self->{'q'}->{'access_times'} ? 'checked' : '';
printf "<input name=times size=40 value='%s'></td> </tr>\n",
	join(" ", @{$self->{'q'}->{'access_times'}});

print "</table></td></tr></table>\n";
print "<table width=100%><tr>\n";
if ($self->{'in_hash'}->{'new'}) {
	print "<td><input type=submit value='$self->{'text_hash'}->{'create'}'></td>\n";
	}
else {
	print "<td><input type=submit value='$self->{'text_hash'}->{'save'}'></td>\n";
	print "<td align=right><input type=submit name=delete ",
	      "value='$self->{'text_hash'}->{'delete'}'></td>\n";
	}
print "</tr></table></form>\n";

$self->ui_print_footer("", $self->{'text_hash'}->{'index_return'});

1;
		
}


1;

